-- MySQL dump 10.16  Distrib 10.1.26-MariaDB, for Linux (x86_64)
--
-- Host: 127.0.0.1    Database: test-aonsolutions-org
-- ------------------------------------------------------
-- Server version	10.1.24-MariaDB-1~jessie

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `absence`
--

DROP TABLE IF EXISTS `absence`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `absence` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL DEFAULT '1' COMMENT 'Identificador del Dominio',
  `course_alumn` int(4) NOT NULL COMMENT 'Identificador del CursoAlumno',
  `absence_date` date DEFAULT NULL COMMENT 'Fecha de la Ausencia',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios de la Ausencia',
  `evaluation` tinyint(2) DEFAULT NULL COMMENT 'Numero de Evaluacion en que se produjo la Ausencia',
  PRIMARY KEY (`id`),
  KEY `IDX_ABSENCE_COURSE_ALUMN` (`course_alumn`),
  KEY `IDX_ABSENCE_DOMAIN` (`domain`),
  CONSTRAINT `FK_ABSENCE_COURSE_ALUMN` FOREIGN KEY (`course_alumn`) REFERENCES `course_alumn` (`id`),
  CONSTRAINT `FK_ABSENCE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Ausencias';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `absence`
--

LOCK TABLES `absence` WRITE;
/*!40000 ALTER TABLE `absence` DISABLE KEYS */;
/*!40000 ALTER TABLE `absence` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `academic_skill`
--

DROP TABLE IF EXISTS `academic_skill`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `academic_skill` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la Aptitud Academica',
  `domain` int(4) NOT NULL DEFAULT '1' COMMENT 'Identificador del Dominio',
  `code` char(5) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Codigo de la Aptitud Academica',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion de la Aptitud Academica',
  PRIMARY KEY (`id`),
  KEY `IDX_ACADEMIC_SKILL_DOMAIN` (`domain`),
  CONSTRAINT `FK_ACADEMIC_SKILL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Aptitudes Academicas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `academic_skill`
--

LOCK TABLES `academic_skill` WRITE;
/*!40000 ALTER TABLE `academic_skill` DISABLE KEYS */;
/*!40000 ALTER TABLE `academic_skill` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `academic_year`
--

DROP TABLE IF EXISTS `academic_year`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `academic_year` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Año Academico',
  `domain` int(4) NOT NULL DEFAULT '1' COMMENT 'Identificador del Dominio',
  `description` varchar(9) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion del Año Academico',
  PRIMARY KEY (`id`),
  KEY `IDX_ACADEMIC_YEAR_DOMAIN` (`domain`),
  CONSTRAINT `FK_ACADEMIC_YEAR_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Año Academico';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `academic_year`
--

LOCK TABLES `academic_year` WRITE;
/*!40000 ALTER TABLE `academic_year` DISABLE KEYS */;
/*!40000 ALTER TABLE `academic_year` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `account`
--

DROP TABLE IF EXISTS `account`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `account` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `code` char(12) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Codigo Cuenta Contable',
  `description` varchar(128) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion de la Cuenta',
  `alias` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Alias de la Cuenta',
  `entryEnabled` tinyint(2) DEFAULT '0' COMMENT 'Indica si la Cuenta permite o no Apuntes',
  `level` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Nivel de la Cuenta',
  `active` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'Indica si la Cuenta esta activo o no',
  `cost_center` char(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Centro de Costo',
  PRIMARY KEY (`id`),
  UNIQUE KEY `IDX_UNQ_ACCOUNT_DOMAIN_CODE` (`domain`,`code`),
  KEY `IDX_ACCOUNT_DOMAIN` (`domain`),
  CONSTRAINT `FK_ACCOUNT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=22013749 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Cuentas Contables';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `account`
--

LOCK TABLES `account` WRITE;
/*!40000 ALTER TABLE `account` DISABLE KEYS */;
INSERT INTO `account` VALUES (22011707,8776,'1','FINANCIACIÓN BÁSICA',NULL,0,1,1,NULL),(22011708,8776,'10','CAPITAL.',NULL,0,2,1,NULL),(22011709,8776,'100','Capital social.',NULL,0,3,1,NULL),(22011710,8776,'1000','Capital social.',NULL,0,4,1,NULL),(22011711,8776,'101','Fondo social.',NULL,0,3,1,NULL),(22011712,8776,'1010','Fondo social.',NULL,0,4,1,NULL),(22011713,8776,'102','Capital.',NULL,0,3,1,NULL),(22011714,8776,'1020','Capital.',NULL,0,4,1,NULL),(22011715,8776,'103','Socios por desembolsos no exigidos..',NULL,0,3,1,NULL),(22011716,8776,'1030','Socios por desembolsos no exigidos, capital social.',NULL,0,4,1,NULL),(22011717,8776,'1034','Socios por desembolsos no exigidos, capital pendiente de inscripción.',NULL,0,4,1,NULL),(22011718,8776,'104','Socios por aportaciones no dinerarias pendientes..',NULL,0,3,1,NULL),(22011719,8776,'1040','Socios por aportaciones no dinerarias pendientes, capital social.',NULL,0,4,1,NULL),(22011720,8776,'1044','Socios por aportaciones no dinerarias pendientes, capital pendiente de inscripción.',NULL,0,4,1,NULL),(22011721,8776,'108','Acciones o participaciones propias en situaciones especiales.',NULL,0,3,1,NULL),(22011722,8776,'1080','Acciones o participaciones propias en situaciones especiales.',NULL,0,4,1,NULL),(22011723,8776,'109','Acciones o participaciones propias para reducción de capital.',NULL,0,3,1,NULL),(22011724,8776,'1090','Acciones o participaciones propias para reducción de capital.',NULL,0,4,1,NULL),(22011725,8776,'11','RESERVAS.',NULL,0,2,1,NULL),(22011726,8776,'110','Prima de emisión o asunción.',NULL,0,3,1,NULL),(22011727,8776,'1100','Prima de emisión o asunción.',NULL,0,4,1,NULL),(22011728,8776,'111','Patrimonio neto por emisión de instrumentos financieros compuestos.',NULL,0,3,1,NULL),(22011729,8776,'1110','Patrimonio neto por emisión de instrumentos financieros compuestos.',NULL,0,4,1,NULL),(22011730,8776,'1111','Resto de instrumentos de patrimonio neto.',NULL,0,4,1,NULL),(22011731,8776,'112','Reserva legal.',NULL,0,3,1,NULL),(22011732,8776,'1120','Reserva legal.',NULL,0,4,1,NULL),(22011733,8776,'113','Reservas voluntarias.',NULL,0,3,1,NULL),(22011734,8776,'1130','Reservas voluntarias.',NULL,0,4,1,NULL),(22011735,8776,'114','Reservas especiales.',NULL,0,3,1,NULL),(22011736,8776,'1140','Reservas para acciones o participaciones de la sociedad dominante.',NULL,0,4,1,NULL),(22011737,8776,'1141','Reservas estatutarias.',NULL,0,4,1,NULL),(22011738,8776,'1142','Reserva por capital amortizado.',NULL,0,4,1,NULL),(22011739,8776,'1143','Reserva por fondo de comercio.',NULL,0,4,1,NULL),(22011740,8776,'1144','Reservas por acciones propias aceptadas en garantía.',NULL,0,4,1,NULL),(22011741,8776,'115','Reservas por pérdidas y ganancias actuariales y otros ajustes.',NULL,0,3,1,NULL),(22011742,8776,'1150','Reservas por pérdidas y ganancias actuariales y otros ajustes.',NULL,0,4,1,NULL),(22011743,8776,'118','Aportaciones de socios o propietarios.',NULL,0,3,1,NULL),(22011744,8776,'1180','Aportaciones de socios o propietarios.',NULL,0,4,1,NULL),(22011745,8776,'119','Diferencias por ajuste del capital a euros.',NULL,0,3,1,NULL),(22011746,8776,'1190','Diferencias por ajuste del capital a euros.',NULL,0,4,1,NULL),(22011747,8776,'12','RESULTADOS PENDIENTES DE APLICACIÓN.',NULL,0,2,1,NULL),(22011748,8776,'120','Remanente.',NULL,0,3,1,NULL),(22011749,8776,'1200','Remanente.',NULL,0,4,1,NULL),(22011750,8776,'121','Resultados negativos de ejercicios anteriores.',NULL,0,3,1,NULL),(22011751,8776,'1210','Resultados negativos de ejercicios anteriores.',NULL,0,4,1,NULL),(22011752,8776,'129','Resultados del ejercicio.',NULL,0,3,1,NULL),(22011753,8776,'1290','Resultados del ejercicio.',NULL,0,4,1,NULL),(22011754,8776,'129000000','Resultados del ejercicio.',NULL,1,5,1,NULL),(22011755,8776,'13','SUBVENCIONES, DONACIONES Y AJUSTES POR CAMBIOS DE VALOR.',NULL,0,2,1,NULL),(22011756,8776,'130','Subvenciones oficiales de capital.',NULL,0,3,1,NULL),(22011757,8776,'1300','Subvenciones oficiales de capital.',NULL,0,4,1,NULL),(22011758,8776,'131','Donaciones y legados de capital.',NULL,0,3,1,NULL),(22011759,8776,'1310','Donaciones y legados de capital.',NULL,0,4,1,NULL),(22011760,8776,'132','Otras subvenciones, donaciones y legados.',NULL,0,3,1,NULL),(22011761,8776,'1320','Otras subvenciones, donaciones y legados.',NULL,0,4,1,NULL),(22011762,8776,'133','Ajustes por valoración en instrumentos financieros.',NULL,0,3,1,NULL),(22011763,8776,'1330','Ajustes por valoración en instrumentos financieros.',NULL,0,4,1,NULL),(22011764,8776,'134','Operaciones de cobertura.',NULL,0,3,1,NULL),(22011765,8776,'1340','Cobertura de flujos de efectivo.',NULL,0,4,1,NULL),(22011766,8776,'1341','Cobertura de una inversión neta en un negocio en el extranjero.',NULL,0,4,1,NULL),(22011767,8776,'135','Diferencias de conversión.',NULL,0,3,1,NULL),(22011768,8776,'1350','Diferencias de conversión.',NULL,0,4,1,NULL),(22011769,8776,'136','Ajustes por valoración en activos no corrientes y grupos enajenables de elementos mantenidos para la venta.',NULL,0,3,1,NULL),(22011770,8776,'1360','Ajustes por valoración en activos no corrientes y grupos enajenables de elementos mantenidos para la venta.',NULL,0,4,1,NULL),(22011771,8776,'137','Ingresos fiscales a distribuir en varios ejercicios.',NULL,0,3,1,NULL),(22011772,8776,'1370','Ingresos fiscales por diferencias permanentes a distribuir en varios ejercicios.',NULL,0,4,1,NULL),(22011773,8776,'1371','Ingresos fiscales por deducciones y bonificaciones a distribuir en varios ejercicios.',NULL,0,4,1,NULL),(22011774,8776,'14','PROVISIONES.',NULL,0,2,1,NULL),(22011775,8776,'140','Provisión para retribuciones y otras prestaciones al personal.',NULL,0,3,1,NULL),(22011776,8776,'1400','Provisión para retribuciones y otras prestaciones al personal.',NULL,0,4,1,NULL),(22011777,8776,'141','Provisión para impuestos.',NULL,0,3,1,NULL),(22011778,8776,'1410','Provisión para impuestos.',NULL,0,4,1,NULL),(22011779,8776,'142','Provisión para otras responsabilidades.',NULL,0,3,1,NULL),(22011780,8776,'1420','Provisión para otras responsabilidades.',NULL,0,4,1,NULL),(22011781,8776,'143','Provisión por desmantelamiento, retiro o rehabilitación del inmovilizado.',NULL,0,3,1,NULL),(22011782,8776,'1430','Provisión por desmantelamiento, retiro o rehabilitación del inmovilizado.',NULL,0,4,1,NULL),(22011783,8776,'145','Provisión para actuaciones medioambientales.',NULL,0,3,1,NULL),(22011784,8776,'1450','Provisión para actuaciones medioambientales.',NULL,0,4,1,NULL),(22011785,8776,'146','Provisión para reestructuraciones.',NULL,0,3,1,NULL),(22011786,8776,'1460','Provisión para reestructuraciones.',NULL,0,4,1,NULL),(22011787,8776,'147','Provisiones por transacciones con pagos basados en instrumentos de patrimonio.',NULL,0,3,1,NULL),(22011788,8776,'1470','Provisiones por transacciones con pagos basados en instrumentos de patrimonio.',NULL,0,4,1,NULL),(22011789,8776,'15','DEUDAS A LARGO PLAZO CON CARACTERÍSTICAS ESPECIALES.',NULL,0,2,1,NULL),(22011790,8776,'150','Acciones o participaciones a largo plazo contabilizadas como pasivo.',NULL,0,3,1,NULL),(22011791,8776,'1500','Acciones o participaciones a largo plazo contabilizadas como pasivo.',NULL,0,4,1,NULL),(22011792,8776,'153','Desembolsos no exigidos por acciones o participaciones contabilizadas como pasivo.',NULL,0,3,1,NULL),(22011793,8776,'1530','Desembolsos no exigidos por acciones o participaciones contabilizadas como pasivo.',NULL,0,4,1,NULL),(22011794,8776,'154','Aportaciones no dinerarias pendientes por acciones o participaciones contabilizadas como pasivo.',NULL,0,3,1,NULL),(22011795,8776,'1540','Aportaciones no dinerarias pendientes por acciones o participaciones contabilizadas como pasivo.',NULL,0,4,1,NULL),(22011796,8776,'16','DEUDAS A LARGO PLAZO CON PARTES VINCULADAS.',NULL,0,2,1,NULL),(22011797,8776,'160','Deudas a largo plazo con entidades de crédito vinculadas.',NULL,0,3,1,NULL),(22011798,8776,'1600','Deudas a largo plazo con entidades de crédito vinculadas.',NULL,0,4,1,NULL),(22011799,8776,'161','Proveedores de inmovilizado a largo plazo, partes vinculadas.',NULL,0,3,1,NULL),(22011800,8776,'1610','Proveedores de inmovilizado a largo plazo, partes vinculadas.',NULL,0,4,1,NULL),(22011801,8776,'162','Otras deudas a largo plazo con partes vinculadas.',NULL,0,3,1,NULL),(22011802,8776,'1620','Otras deudas a largo plazo con partes vinculadas.',NULL,0,4,1,NULL),(22011803,8776,'163','Otras deudas a largo plazo con partes vinculadas.',NULL,0,3,1,NULL),(22011804,8776,'1633','Otras deudas a largo plazo empresas del grupo.',NULL,0,4,1,NULL),(22011805,8776,'1634','Otras deudas a largo plazo empresas asociadas.',NULL,0,4,1,NULL),(22011806,8776,'1635','Otras deudas a largo plazo con otras partes vinculadas.',NULL,0,4,1,NULL),(22011807,8776,'17','DEUDAS A LARGO PLAZO POR PRÉSTAMOS RECIBIDOS Y OTROS CONCEPTOS.',NULL,0,2,1,NULL),(22011808,8776,'170','Deudas a largo plazo con entidades de crédito.',NULL,0,3,1,NULL),(22011809,8776,'1700','Deudas a largo plazo con entidades de crédito.',NULL,0,4,1,NULL),(22011810,8776,'171','Deudas a largo plazo.',NULL,0,3,1,NULL),(22011811,8776,'1710','Deudas a largo plazo.',NULL,0,4,1,NULL),(22011812,8776,'172','Deudas a largo plazo transformables en subvenciones, donaciones y legados.',NULL,0,3,1,NULL),(22011813,8776,'1720','Deudas a largo plazo transformables en subvenciones, donaciones y legados.',NULL,0,4,1,NULL),(22011814,8776,'173','Proveedores de inmovilizado a largo plazo.',NULL,0,3,1,NULL),(22011815,8776,'1730','Proveedores de inmovilizado a largo plazo.',NULL,0,4,1,NULL),(22011816,8776,'174','Acreedores de arrendamiento financiero a largo plazo.',NULL,0,3,1,NULL),(22011817,8776,'1740','Acreedores de arrendamiento financiero a largo plazo.',NULL,0,4,1,NULL),(22011818,8776,'175','Efectos a pagar a largo plazo.',NULL,0,3,1,NULL),(22011819,8776,'1750','Efectos a pagar a largo plazo.',NULL,0,4,1,NULL),(22011820,8776,'176','Pasivos por derivados financieros a largo plazo.',NULL,0,3,1,NULL),(22011821,8776,'1765','Pasivos por derivados financieros a largo plazo, cartera de negociación.',NULL,0,4,1,NULL),(22011822,8776,'1768','Pasivos por derivados financieros a largo plazo, instrumentos de cobertura.',NULL,0,4,1,NULL),(22011823,8776,'177','Obligaciones y bonos.',NULL,0,3,1,NULL),(22011824,8776,'1770','Obligaciones y bonos.',NULL,0,4,1,NULL),(22011825,8776,'178','Obligaciones y bonos convertibles.',NULL,0,3,1,NULL),(22011826,8776,'1780','Obligaciones y bonos convertibles.',NULL,0,4,1,NULL),(22011827,8776,'179','Deudas representadas en otros valores negociables.',NULL,0,3,1,NULL),(22011828,8776,'1790','Deudas representadas en otros valores negociables.',NULL,0,4,1,NULL),(22011829,8776,'18','PASIVOS POR FIANZAS Y GARANTÍAS Y OTROS CONCEPTOS A LARGO PLAZO.',NULL,0,2,1,NULL),(22011830,8776,'180','Fianzas recibidas a largo plazo.',NULL,0,3,1,NULL),(22011831,8776,'1800','Fianzas recibidas a largo plazo.',NULL,0,4,1,NULL),(22011832,8776,'181','Anticipos recibidos por ventas o prestaciones de servicios a largo plazo.',NULL,0,3,1,NULL),(22011833,8776,'1810','Anticipos recibidos por ventas o prestaciones de servicios a largo plazo.',NULL,0,4,1,NULL),(22011834,8776,'185','Depósitos recibidos a largo plazo.',NULL,0,3,1,NULL),(22011835,8776,'1850','Depósitos recibidos a largo plazo.',NULL,0,4,1,NULL),(22011836,8776,'189','Garantías financieras a largo plazo.',NULL,0,3,1,NULL),(22011837,8776,'1890','Garantías financieras a largo plazo.',NULL,0,4,1,NULL),(22011838,8776,'19','SITUACIONES TRANSITORIAS DE FINANCIACIÓN.',NULL,0,2,1,NULL),(22011839,8776,'190','Acciones o participaciones emitidas.',NULL,0,3,1,NULL),(22011840,8776,'1900','Acciones o participaciones emitidas.',NULL,0,4,1,NULL),(22011841,8776,'192','Suscriptores de acciones.',NULL,0,3,1,NULL),(22011842,8776,'1920','Suscriptores de acciones.',NULL,0,4,1,NULL),(22011843,8776,'194','Capital emitido pendiente de inscripción.',NULL,0,3,1,NULL),(22011844,8776,'1940','Capital emitido pendiente de inscripción.',NULL,0,4,1,NULL),(22011845,8776,'195','Acciones o participaciones emitidas consideradas como pasivos financieros.',NULL,0,3,1,NULL),(22011846,8776,'1950','Acciones o participaciones emitidas consideradas como pasivos financieros.',NULL,0,4,1,NULL),(22011847,8776,'197','Suscriptores de acciones consideradas como pasivos financieros.',NULL,0,3,1,NULL),(22011848,8776,'1970','Suscriptores de acciones consideradas como pasivos financieros.',NULL,0,4,1,NULL),(22011849,8776,'199','Acciones o participaciones emitidas consideradas como pasivos financieros pendientes de inscripción.',NULL,0,3,1,NULL),(22011850,8776,'1990','Acciones o participaciones emitidas consideradas como pasivos financieros pendientes de inscripción.',NULL,0,4,1,NULL),(22011851,8776,'2','ACTIVO NO CORRIENTE',NULL,0,1,1,NULL),(22011852,8776,'20','INMOVILIZACIONES INTANGIBLES.',NULL,0,2,1,NULL),(22011853,8776,'200','Gastos de investigación.',NULL,0,3,1,NULL),(22011854,8776,'2000','Gastos de investigación.',NULL,0,4,1,NULL),(22011855,8776,'201','Desarrollo.',NULL,0,3,1,NULL),(22011856,8776,'2010','Desarrollo.',NULL,0,4,1,NULL),(22011857,8776,'202','Concesiones administrativas.',NULL,0,3,1,NULL),(22011858,8776,'2020','Concesiones administrativas.',NULL,0,4,1,NULL),(22011859,8776,'203','Propiedad industrial.',NULL,0,3,1,NULL),(22011860,8776,'2030','Propiedad industrial.',NULL,0,4,1,NULL),(22011861,8776,'204','Fondo de comercio.',NULL,0,3,1,NULL),(22011862,8776,'2040','Fondo de comercio.',NULL,0,4,1,NULL),(22011863,8776,'205','Derechos de traspaso.',NULL,0,3,1,NULL),(22011864,8776,'2050','Derechos de traspaso.',NULL,0,4,1,NULL),(22011865,8776,'206','Aplicaciones informáticas.',NULL,0,3,1,NULL),(22011866,8776,'2060','Aplicaciones informáticas.',NULL,0,4,1,NULL),(22011867,8776,'209','Anticipos para inmovilizaciones intangibles.',NULL,0,3,1,NULL),(22011868,8776,'2090','Anticipos para inmovilizaciones intangibles.',NULL,0,4,1,NULL),(22011869,8776,'21','INMOVILIZACIONES MATERIALES.',NULL,0,2,1,NULL),(22011870,8776,'210','Terrenos y bienes naturales.',NULL,0,3,1,NULL),(22011871,8776,'2100','Terrenos y bienes naturales.',NULL,0,4,1,NULL),(22011872,8776,'211','Construcciones .',NULL,0,3,1,NULL),(22011873,8776,'2110','Construcciones .',NULL,0,4,1,NULL),(22011874,8776,'212','Instalaciones técnicas.',NULL,0,3,1,NULL),(22011875,8776,'2120','Instalaciones técnicas.',NULL,0,4,1,NULL),(22011876,8776,'213','Maquinaria.',NULL,0,3,1,NULL),(22011877,8776,'2130','Maquinaria.',NULL,0,4,1,NULL),(22011878,8776,'214','Utillaje.',NULL,0,3,1,NULL),(22011879,8776,'2140','Utillaje.',NULL,0,4,1,NULL),(22011880,8776,'215','Otras instalaciones.',NULL,0,3,1,NULL),(22011881,8776,'2150','Otras instalaciones.',NULL,0,4,1,NULL),(22011882,8776,'216','Mobiliario.',NULL,0,3,1,NULL),(22011883,8776,'2160','Mobiliario.',NULL,0,4,1,NULL),(22011884,8776,'217','Equipos para procesos de información.',NULL,0,3,1,NULL),(22011885,8776,'2170','Equipos para procesos de información.',NULL,0,4,1,NULL),(22011886,8776,'218','Elementos de transporte.',NULL,0,3,1,NULL),(22011887,8776,'2180','Elementos de transporte.',NULL,0,4,1,NULL),(22011888,8776,'219','Otro inmovilizado material.',NULL,0,3,1,NULL),(22011889,8776,'2190','Otro inmovilizado material.',NULL,0,4,1,NULL),(22011890,8776,'22','INVERSIONES INMOBILIARIAS.',NULL,0,2,1,NULL),(22011891,8776,'220','Inversiones en terrenos y bienes naturales.',NULL,0,3,1,NULL),(22011892,8776,'2200','Inversiones en terrenos y bienes naturales.',NULL,0,4,1,NULL),(22011893,8776,'221','Inversiones en construcciones.',NULL,0,3,1,NULL),(22011894,8776,'2210','Inversiones en construcciones.',NULL,0,4,1,NULL),(22011895,8776,'23','INMOVILIZACIONES MATERIALES EN CURSO.',NULL,0,2,1,NULL),(22011896,8776,'230','Adaptación de terrenos y bienes naturales.',NULL,0,3,1,NULL),(22011897,8776,'2300','Adaptación de terrenos y bienes naturales.',NULL,0,4,1,NULL),(22011898,8776,'231','Construcciones en curso.',NULL,0,3,1,NULL),(22011899,8776,'2310','Construcciones en curso.',NULL,0,4,1,NULL),(22011900,8776,'232','Instalaciones técnicas en montaje.',NULL,0,3,1,NULL),(22011901,8776,'2320','Instalaciones técnicas en montaje.',NULL,0,4,1,NULL),(22011902,8776,'233','Maquinaria en montaje.',NULL,0,3,1,NULL),(22011903,8776,'2330','Maquinaria en montaje.',NULL,0,4,1,NULL),(22011904,8776,'237','Equipos para procesos de información en montaje.',NULL,0,3,1,NULL),(22011905,8776,'2370','Equipos para procesos de información en montaje.',NULL,0,4,1,NULL),(22011906,8776,'239','Anticipos para inmovilizaciones materiales.',NULL,0,3,1,NULL),(22011907,8776,'2390','Anticipos para inmovilizaciones materiales.',NULL,0,4,1,NULL),(22011908,8776,'24','INVERSIONES FINANCIERAS A LARGO PLAZO EN PARTES VINCULADAS.',NULL,0,2,1,NULL),(22011909,8776,'240','Participaciones a largo plazo en partes vinculadas.',NULL,0,3,1,NULL),(22011910,8776,'2400','Participaciones a largo plazo en partes vinculadas.',NULL,0,4,1,NULL),(22011911,8776,'241','Valores representativos de deuda a largo plazo de partes vinculadas.',NULL,0,3,1,NULL),(22011912,8776,'2410','Valores representativos de deuda a largo plazo de partes vinculadas.',NULL,0,4,1,NULL),(22011913,8776,'242','Créditos a largo plazo a partes vinculadas.',NULL,0,3,1,NULL),(22011914,8776,'2420','Créditos a largo plazo a partes vinculadas.',NULL,0,4,1,NULL),(22011915,8776,'249','Desembolsos pendientes sobre participaciones a largo plazo en partes vinculadas.',NULL,0,3,1,NULL),(22011916,8776,'2490','Desembolsos pendientes sobre participaciones a largo plazo en partes vinculadas.',NULL,0,4,1,NULL),(22011917,8776,'25','OTRAS INVERSIONES FINANCIERAS A LARGO PLAZO.',NULL,0,2,1,NULL),(22011918,8776,'250','Inversiones financieras a largo plazo en instrumentos de patrimonio.',NULL,0,3,1,NULL),(22011919,8776,'2500','Inversiones financieras a largo plazo en instrumentos de patrimonio.',NULL,0,4,1,NULL),(22011920,8776,'251','Valores representativos de deuda a largo plazo.',NULL,0,3,1,NULL),(22011921,8776,'2510','Valores representativos de deuda a largo plazo.',NULL,0,4,1,NULL),(22011922,8776,'252','Créditos a largo plazo.',NULL,0,3,1,NULL),(22011923,8776,'2520','Créditos a largo plazo.',NULL,0,4,1,NULL),(22011924,8776,'253','Créditos a largo plazo por enajenación de inmovilizado.',NULL,0,3,1,NULL),(22011925,8776,'2530','Créditos a largo plazo por enajenación de inmovilizado.',NULL,0,4,1,NULL),(22011926,8776,'254','Créditos a largo plazo al personal.',NULL,0,3,1,NULL),(22011927,8776,'2540','Créditos a largo plazo al personal.',NULL,0,4,1,NULL),(22011928,8776,'255','Activos por derivados financieros a largo plazo.',NULL,0,3,1,NULL),(22011929,8776,'2550','Activos por derivados financieros a largo plazo.',NULL,0,4,1,NULL),(22011930,8776,'257','Activos por retribuciones a largo plazo de prestación definida.',NULL,0,3,1,NULL),(22011931,8776,'2570','Activos por retribuciones a largo plazo de prestación definida.',NULL,0,4,1,NULL),(22011932,8776,'258','Imposiciones a largo plazo.',NULL,0,3,1,NULL),(22011933,8776,'2580','Imposiciones a largo plazo.',NULL,0,4,1,NULL),(22011934,8776,'259','Desembolsos pendientes sobre participaciones en el patrimonio neto a largo plazo.',NULL,0,3,1,NULL),(22011935,8776,'2590','Desembolsos pendientes sobre participaciones en el patrimonio neto a largo plazo.',NULL,0,4,1,NULL),(22011936,8776,'26','FIANZAS Y DEPÓSITOS CONSTITUIDOS A LARGO PLAZO.',NULL,0,2,1,NULL),(22011937,8776,'260','Fianzas constituidas a largo plazo.',NULL,0,3,1,NULL),(22011938,8776,'2600','Fianzas constituidas a largo plazo.',NULL,0,4,1,NULL),(22011939,8776,'265','Depósitos constituidos a largo plazo.',NULL,0,3,1,NULL),(22011940,8776,'2650','Depósitos constituidos a largo plazo.',NULL,0,4,1,NULL),(22011941,8776,'28','AMORTIZACIÓN ACUMULADA DEL INMOVILIZADO.',NULL,0,2,1,NULL),(22011942,8776,'280','Amortización acumulada del inmovilizado intangible.',NULL,0,3,1,NULL),(22011943,8776,'2800','Amortización acumulada del inmovilizado intangible.',NULL,0,4,1,NULL),(22011944,8776,'2801','Amortización acumulada de investigación',NULL,0,4,1,NULL),(22011945,8776,'2802','Amortización acumulada de desarrollo',NULL,0,4,1,NULL),(22011946,8776,'2803','Amortización acumulada de concesiones administrativas',NULL,0,4,1,NULL),(22011947,8776,'2804','Amortización acumulada de propiedad industrial',NULL,0,4,1,NULL),(22011948,8776,'2805','Amortización acumulada de derechos de traspaso',NULL,0,4,1,NULL),(22011949,8776,'2806','Amortización acumulada de aplicaciones informáticas',NULL,0,4,1,NULL),(22011950,8776,'281','Amortización acumulada del inmovilizado material.',NULL,0,3,1,NULL),(22011951,8776,'2810','Amortización acumulada del inmovilizado material.',NULL,0,4,1,NULL),(22011952,8776,'2811','Amortización acumulada de construcciones',NULL,0,4,1,NULL),(22011953,8776,'2812','Amortización acumulada de instalaciones técnicas',NULL,0,4,1,NULL),(22011954,8776,'2813','Amortización acumulada de maquinaria',NULL,0,4,1,NULL),(22011955,8776,'2814','Amortización acumulada de utillaje',NULL,0,4,1,NULL),(22011956,8776,'2815','Amortización acumulada de otras instalaciones',NULL,0,4,1,NULL),(22011957,8776,'2816','Amortización acumulada de mobiliario',NULL,0,4,1,NULL),(22011958,8776,'2817','Amortización acumulada de equipos para el proceso de información',NULL,0,4,1,NULL),(22011959,8776,'2818','Amortización acumulada de elementos de transporte',NULL,0,4,1,NULL),(22011960,8776,'2819','Amortización acumulada de otro inmovilizado material',NULL,0,4,1,NULL),(22011961,8776,'282','Amortización acumulada de las inversiones inmobiliarias.',NULL,0,3,1,NULL),(22011962,8776,'2820','Amortización acumulada de las inversiones inmobiliarias.',NULL,0,4,1,NULL),(22011963,8776,'29','DETERIORO DE VALOR DE ACTIVOS NO CORRIENTES.',NULL,0,2,1,NULL),(22011964,8776,'290','Deterioro de valor del inmovilizado intangible.',NULL,0,3,1,NULL),(22011965,8776,'2900','Deterioro de valor del inmovilizado intangible.',NULL,0,4,1,NULL),(22011966,8776,'291','Deterioro de valor del inmovilizado material.',NULL,0,3,1,NULL),(22011967,8776,'2910','Deterioro de valor del inmovilizado material.',NULL,0,4,1,NULL),(22011968,8776,'292','Deterioro de valor de las inversiones inmobiliarias.',NULL,0,3,1,NULL),(22011969,8776,'2920','Deterioro de valor de las inversiones inmobiliarias.',NULL,0,4,1,NULL),(22011970,8776,'293','Deterioro de valor de participaciones a largo plazo en partes vinculadas.',NULL,0,3,1,NULL),(22011971,8776,'2930','Deterioro de valor de participaciones a largo plazo en partes vinculadas.',NULL,0,4,1,NULL),(22011972,8776,'294','Deterioro de valor de valores representativos de deuda a largo plazo de partes vinculadas.',NULL,0,3,1,NULL),(22011973,8776,'2940','Deterioro de valor de valores representativos de deuda a largo plazo de partes vinculadas.',NULL,0,4,1,NULL),(22011974,8776,'295','Deterioro de valor de créditos a largo plazo a partes vinculadas.',NULL,0,3,1,NULL),(22011975,8776,'2950','Deterioro de valor de créditos a largo plazo a partes vinculadas.',NULL,0,4,1,NULL),(22011976,8776,'297','Deterioro de valor de valores representativos de deuda a largo plazo.',NULL,0,3,1,NULL),(22011977,8776,'2970','Deterioro de valor de valores representativos de deuda a largo plazo.',NULL,0,4,1,NULL),(22011978,8776,'298','Deterioro de valor de créditos a largo plazo.',NULL,0,3,1,NULL),(22011979,8776,'2980','Deterioro de valor de créditos a largo plazo.',NULL,0,4,1,NULL),(22011980,8776,'3','EXISTENCIAS',NULL,0,1,1,NULL),(22011981,8776,'30','COMERCIALES.',NULL,0,2,1,NULL),(22011982,8776,'300','Mercaderías A.',NULL,0,3,1,NULL),(22011983,8776,'3000','Mercaderías A.',NULL,0,4,1,NULL),(22011984,8776,'301','Mercaderías B.',NULL,0,3,1,NULL),(22011985,8776,'3010','Mercaderías B.',NULL,0,4,1,NULL),(22011986,8776,'31','MATERIAS PRIMAS.',NULL,0,2,1,NULL),(22011987,8776,'310','Materias primas A.',NULL,0,3,1,NULL),(22011988,8776,'3100','Materias primas A.',NULL,0,4,1,NULL),(22011989,8776,'311','Materias primas B.',NULL,0,3,1,NULL),(22011990,8776,'3110','Materias primas B.',NULL,0,4,1,NULL),(22011991,8776,'32','OTROS APROVISIONAMIENTOS.',NULL,0,2,1,NULL),(22011992,8776,'320','Elementos conjuntos incorporables.',NULL,0,3,1,NULL),(22011993,8776,'3200','Elementos conjuntos incorporables.',NULL,0,4,1,NULL),(22011994,8776,'321','Combustibles.',NULL,0,3,1,NULL),(22011995,8776,'3210','Combustibles.',NULL,0,4,1,NULL),(22011996,8776,'322','Repuestos.',NULL,0,3,1,NULL),(22011997,8776,'3220','Repuestos.',NULL,0,4,1,NULL),(22011998,8776,'325','Materiales diversos.',NULL,0,3,1,NULL),(22011999,8776,'3250','Materiales diversos.',NULL,0,4,1,NULL),(22012000,8776,'326','Embalajes.',NULL,0,3,1,NULL),(22012001,8776,'3260','Embalajes.',NULL,0,4,1,NULL),(22012002,8776,'327','Envases.',NULL,0,3,1,NULL),(22012003,8776,'3270','Envases.',NULL,0,4,1,NULL),(22012004,8776,'328','Material de oficina.',NULL,0,3,1,NULL),(22012005,8776,'3280','Material de oficina.',NULL,0,4,1,NULL),(22012006,8776,'33','PRODUCTOS EN CURSO.',NULL,0,2,1,NULL),(22012007,8776,'330','Productos en curso A.',NULL,0,3,1,NULL),(22012008,8776,'3300','Productos en curso A.',NULL,0,4,1,NULL),(22012009,8776,'331','Productos en curso B.',NULL,0,3,1,NULL),(22012010,8776,'3310','Productos en curso B.',NULL,0,4,1,NULL),(22012011,8776,'34','PRODUCTOS SEMITERMINADOS.',NULL,0,2,1,NULL),(22012012,8776,'340','Productos semiterminados A.',NULL,0,3,1,NULL),(22012013,8776,'3400','Productos semiterminados A.',NULL,0,4,1,NULL),(22012014,8776,'341','Productos semiterminados B.',NULL,0,3,1,NULL),(22012015,8776,'3410','Productos semiterminados B.',NULL,0,4,1,NULL),(22012016,8776,'35','PRODUCTOS TERMINADOS.',NULL,0,2,1,NULL),(22012017,8776,'350','Productos terminados A.',NULL,0,3,1,NULL),(22012018,8776,'3500','Productos terminados A.',NULL,0,4,1,NULL),(22012019,8776,'351','Productos terminados B.',NULL,0,3,1,NULL),(22012020,8776,'3510','Productos terminados B.',NULL,0,4,1,NULL),(22012021,8776,'36','SUBPRODUCTOS, RESIDUOS Y MATERIALES RECUPERADOS.',NULL,0,2,1,NULL),(22012022,8776,'360','Subproductos A.',NULL,0,3,1,NULL),(22012023,8776,'3600','Subproductos A.',NULL,0,4,1,NULL),(22012024,8776,'361','Subproductos B.',NULL,0,3,1,NULL),(22012025,8776,'3610','Subproductos B.',NULL,0,4,1,NULL),(22012026,8776,'365','Residuos A.',NULL,0,3,1,NULL),(22012027,8776,'3650','Residuos A.',NULL,0,4,1,NULL),(22012028,8776,'366','Residuos B.',NULL,0,3,1,NULL),(22012029,8776,'3660','Residuos B.',NULL,0,4,1,NULL),(22012030,8776,'368','Materiales recuperados A.',NULL,0,3,1,NULL),(22012031,8776,'3680','Materiales recuperados A.',NULL,0,4,1,NULL),(22012032,8776,'369','Materiales recuperados B.',NULL,0,3,1,NULL),(22012033,8776,'3690','Materiales recuperados B.',NULL,0,4,1,NULL),(22012034,8776,'39','DETERIORO DE VALOR DE LAS EXISTENCIAS.',NULL,0,2,1,NULL),(22012035,8776,'390','Deterioro de valor de las mercaderías.',NULL,0,3,1,NULL),(22012036,8776,'3900','Deterioro de valor de las mercaderías.',NULL,0,4,1,NULL),(22012037,8776,'391','Deterioro de valor de las materias primas.',NULL,0,3,1,NULL),(22012038,8776,'3910','Deterioro de valor de las materias primas.',NULL,0,4,1,NULL),(22012039,8776,'392','Deterioro de valor de otros aprovisionamientos.',NULL,0,3,1,NULL),(22012040,8776,'3920','Deterioro de valor de otros aprovisionamientos.',NULL,0,4,1,NULL),(22012041,8776,'393','Deterioro de valor de los productos en curso.',NULL,0,3,1,NULL),(22012042,8776,'3930','Deterioro de valor de los productos en curso.',NULL,0,4,1,NULL),(22012043,8776,'394','Deterioro de valor de los productos semiterminados.',NULL,0,3,1,NULL),(22012044,8776,'3940','Deterioro de valor de los productos semiterminados.',NULL,0,4,1,NULL),(22012045,8776,'395','Deterioro de valor de los productos terminados.',NULL,0,3,1,NULL),(22012046,8776,'3950','Deterioro de valor de los productos terminados.',NULL,0,4,1,NULL),(22012047,8776,'396','Deterioro de valor de los subproductos, residuos y materiales recuperados.',NULL,0,3,1,NULL),(22012048,8776,'3960','Deterioro de valor de los subproductos, residuos y materiales recuperados.',NULL,0,4,1,NULL),(22012049,8776,'4','ACREEDORES Y DEUDORES POR OPERACIONES COMERCIALES',NULL,0,1,1,NULL),(22012050,8776,'40','PROVEEDORES.',NULL,0,2,1,NULL),(22012051,8776,'400','Proveedores.',NULL,0,3,1,NULL),(22012052,8776,'4000','Proveedores.',NULL,0,4,1,NULL),(22012053,8776,'401','Proveedores, efectos comerciales a pagar.',NULL,0,3,1,NULL),(22012054,8776,'4010','Proveedores, efectos comerciales a pagar.',NULL,0,4,1,NULL),(22012055,8776,'403','Proveedores, empresas del grupo.',NULL,0,3,1,NULL),(22012056,8776,'4030','Proveedores, empresas del grupo.',NULL,0,4,1,NULL),(22012057,8776,'404','Proveedores, empresas asociadas.',NULL,0,3,1,NULL),(22012058,8776,'4040','Proveedores, empresas asociadas.',NULL,0,4,1,NULL),(22012059,8776,'405','Proveedores, otras partes vinculadas.',NULL,0,3,1,NULL),(22012060,8776,'4050','Proveedores, otras partes vinculadas.',NULL,0,4,1,NULL),(22012061,8776,'406','Envases y embalajes a devolver a proveedores.',NULL,0,3,1,NULL),(22012062,8776,'4060','Envases y embalajes a devolver a proveedores.',NULL,0,4,1,NULL),(22012063,8776,'407','Anticipos a proveedores.',NULL,0,3,1,NULL),(22012064,8776,'4070','Anticipos a proveedores.',NULL,0,4,1,NULL),(22012065,8776,'41','ACREEDORES VARIOS.',NULL,0,2,1,NULL),(22012066,8776,'410','Acreedores por prestaciones de servicios.',NULL,0,3,1,NULL),(22012067,8776,'4100','Acreedores por prestaciones de servicios.',NULL,0,4,1,NULL),(22012068,8776,'411','Acreedores, efectos comerciales a pagar.',NULL,0,3,1,NULL),(22012069,8776,'4110','Acreedores, efectos comerciales a pagar.',NULL,0,4,1,NULL),(22012070,8776,'419','Acreedores por operaciones en común.',NULL,0,3,1,NULL),(22012071,8776,'4190','Acreedores por operaciones en común.',NULL,0,4,1,NULL),(22012072,8776,'43','CLIENTES.',NULL,0,2,1,NULL),(22012073,8776,'430','Clientes.',NULL,0,3,1,NULL),(22012074,8776,'4300','Clientes.',NULL,0,4,1,NULL),(22012075,8776,'431','Clientes, efectos comerciales a cobrar.',NULL,0,3,1,NULL),(22012076,8776,'4310','Clientes, efectos comerciales a cobrar.',NULL,0,4,1,NULL),(22012077,8776,'432','Clientes operaciones de factoring.',NULL,0,3,1,NULL),(22012078,8776,'4320','Clientes operaciones de factoring.',NULL,0,4,1,NULL),(22012079,8776,'433','Clientes, empresas del grupo.',NULL,0,3,1,NULL),(22012080,8776,'4330','Clientes, empresas del grupo.',NULL,0,4,1,NULL),(22012081,8776,'434','Clientes, empresas asociadas.',NULL,0,3,1,NULL),(22012082,8776,'4340','Clientes, empresas asociadas.',NULL,0,4,1,NULL),(22012083,8776,'435','Clientes, otras partes vinculadas.',NULL,0,3,1,NULL),(22012084,8776,'4350','Clientes, otras partes vinculadas.',NULL,0,4,1,NULL),(22012085,8776,'436','Clientes de dudoso cobro.',NULL,0,3,1,NULL),(22012086,8776,'4360','Clientes de dudoso cobro.',NULL,0,4,1,NULL),(22012087,8776,'437','Envases y embalajes a devolver por clientes.',NULL,0,3,1,NULL),(22012088,8776,'4370','Envases y embalajes a devolver por clientes.',NULL,0,4,1,NULL),(22012089,8776,'438','Anticipos de clientes.',NULL,0,3,1,NULL),(22012090,8776,'4380','Anticipos de clientes.',NULL,0,4,1,NULL),(22012091,8776,'44','DEUDORES VARIOS.',NULL,0,2,1,NULL),(22012092,8776,'440','Deudores.',NULL,0,3,1,NULL),(22012093,8776,'4400','Deudores.',NULL,0,4,1,NULL),(22012094,8776,'441','Deudores, efectos comerciales a cobrar.',NULL,0,3,1,NULL),(22012095,8776,'4410','Deudores, efectos comerciales a cobrar.',NULL,0,4,1,NULL),(22012096,8776,'446','Deudores de dudoso cobro.',NULL,0,3,1,NULL),(22012097,8776,'4460','Deudores de dudoso cobro.',NULL,0,4,1,NULL),(22012098,8776,'449','Deudores por operaciones en común.',NULL,0,3,1,NULL),(22012099,8776,'4490','Deudores por operaciones en común.',NULL,0,4,1,NULL),(22012100,8776,'46','PERSONAL.',NULL,0,2,1,NULL),(22012101,8776,'460','Anticipos de remuneraciones.',NULL,0,3,1,NULL),(22012102,8776,'4600','Anticipos de remuneraciones.',NULL,0,4,1,NULL),(22012103,8776,'465','Remuneraciones pendientes de pago.',NULL,0,3,1,NULL),(22012104,8776,'4650','Remuneraciones pendientes de pago.',NULL,0,4,1,NULL),(22012105,8776,'465000000','Remuneraciones pendientes de pago.',NULL,1,5,1,NULL),(22012106,8776,'466','Remuneraciones mediante sistemas de aportación definida pendientes de pago.',NULL,0,3,1,NULL),(22012107,8776,'4660','Remuneraciones mediante sistemas de aportación definida pendientes de pago.',NULL,0,4,1,NULL),(22012108,8776,'47','ADMINISTRACIONES PÚBLICAS.',NULL,0,2,1,NULL),(22012109,8776,'470','Hacienda Pública deudora por diversos conceptos.',NULL,0,3,1,NULL),(22012110,8776,'4700','Hacienda Pública, deudora por IVA.',NULL,0,4,1,NULL),(22012111,8776,'4708','Hacienda Pública, deudora por subvenciones concedidas.',NULL,0,4,1,NULL),(22012112,8776,'4709','Hacienda Pública, deudora por devolución de impuestos.',NULL,0,4,1,NULL),(22012113,8776,'471','Organismos de la Seguridad Social, deudores.',NULL,0,3,1,NULL),(22012114,8776,'4710','Organismos de la Seguridad Social, deudores.',NULL,0,4,1,NULL),(22012115,8776,'472','Hacienda Pública, IVA soportado.',NULL,0,3,1,NULL),(22012116,8776,'4720','Hacienda Pública, IVA soportado.',NULL,0,4,1,NULL),(22012117,8776,'472000000','Hacienda Pública, IVA soportado.',NULL,1,5,1,NULL),(22012118,8776,'473','Hacienda Pública, retenciones y pagos a cuenta.',NULL,0,3,1,NULL),(22012119,8776,'4730','Hacienda Pública, retenciones y pagos a cuenta.',NULL,0,4,1,NULL),(22012120,8776,'473000000','Hacienda Pública, retenciones y pagos a cuenta.',NULL,1,5,1,NULL),(22012121,8776,'474','Activos por impuesto diferido.',NULL,0,3,1,NULL),(22012122,8776,'4740','Activos por diferencias temporarias deducibles.',NULL,0,4,1,NULL),(22012123,8776,'4742','Derechos por deducciones y bonificaciones pendientes de aplicar.',NULL,0,4,1,NULL),(22012124,8776,'4745','Crédito por pérdidas a compensar del ejercicio.',NULL,0,4,1,NULL),(22012125,8776,'475','Hacienda Pública acreedora por conceptos fiscales.',NULL,0,3,1,NULL),(22012126,8776,'4750','Hacienda Pública, acreedora por IVA.',NULL,0,4,1,NULL),(22012127,8776,'4751','Hacienda Pública, acreedora por retenciones practicadas.',NULL,0,4,1,NULL),(22012128,8776,'475100000','Hacienda Pública, acreedora por retenciones practicadas.',NULL,1,5,1,NULL),(22012129,8776,'4752','Hacienda Pública, acreedora por impuesto sobre sociedades.',NULL,0,4,1,NULL),(22012130,8776,'4758','Hacienda Pública, acreedora por subvenciones a reintegrar.',NULL,0,4,1,NULL),(22012131,8776,'476','Organismos de la Seguridad Social, acreedores.',NULL,0,3,1,NULL),(22012132,8776,'4760','Organismos de la Seguridad Social, acreedores.',NULL,0,4,1,NULL),(22012133,8776,'476000000','Organismos de la Seguridad Social, acreedores.',NULL,1,5,1,NULL),(22012134,8776,'477','Hacienda Pública, IVA repercutido.',NULL,0,3,1,NULL),(22012135,8776,'4770','Hacienda Pública, IVA repercutido.',NULL,0,4,1,NULL),(22012136,8776,'477000000','Hacienda Pública, IVA repercutido.',NULL,1,5,1,NULL),(22012137,8776,'479','Pasivos por diferencias temporarias imponibles.',NULL,0,3,1,NULL),(22012138,8776,'4790','Pasivos por diferencias temporarias imponibles.',NULL,0,4,1,NULL),(22012139,8776,'48','AJUSTES POR PERIODIFICACIÓN.',NULL,0,2,1,NULL),(22012140,8776,'480','Gastos anticipados.',NULL,0,3,1,NULL),(22012141,8776,'4800','Gastos anticipados.',NULL,0,4,1,NULL),(22012142,8776,'485','Ingresos anticipados.',NULL,0,3,1,NULL),(22012143,8776,'4850','Ingresos anticipados.',NULL,0,4,1,NULL),(22012144,8776,'49','DETERIORO DE VALOR DE CRÉDITOS COMERCIALES Y PROVISIONES A CORTO PLAZO.',NULL,0,2,1,NULL),(22012145,8776,'490','Deterioro de valor de créditos por operaciones comerciales.',NULL,0,3,1,NULL),(22012146,8776,'4900','Deterioro de valor de créditos por operaciones comerciales.',NULL,0,4,1,NULL),(22012147,8776,'493','Deterioro de valor de créditos por operaciones comerciales con partes vinculadas.',NULL,0,3,1,NULL),(22012148,8776,'4930','Deterioro de valor de créditos por operaciones comerciales con partes vinculadas.',NULL,0,4,1,NULL),(22012149,8776,'499','Provisiones por operaciones comerciales.',NULL,0,3,1,NULL),(22012150,8776,'4994','Provisión para contratos onerosos.',NULL,0,4,1,NULL),(22012151,8776,'4999','Provisión para otras operaciones comerciales.',NULL,0,4,1,NULL),(22012152,8776,'5','CUENTAS FINANCIERAS',NULL,0,1,1,NULL),(22012153,8776,'50','EMPRÉSTITOS, DEUDAS CON CARACTERÍSTICAS ESPECIALES Y OTRAS EMISIONES ANÁLOGAS A CORTO PLAZO.',NULL,0,2,1,NULL),(22012154,8776,'500','Obligaciones y bonos a corto plazo.',NULL,0,3,1,NULL),(22012155,8776,'5000','Obligaciones y bonos a corto plazo.',NULL,0,4,1,NULL),(22012156,8776,'501','Obligaciones y bonos convertibles a corto plazo.',NULL,0,3,1,NULL),(22012157,8776,'5010','Obligaciones y bonos convertibles a corto plazo.',NULL,0,4,1,NULL),(22012158,8776,'502','Acciones o participaciones a corto plazo contabilizadas como pasivo.',NULL,0,3,1,NULL),(22012159,8776,'5020','Acciones o participaciones a corto plazo contabilizadas como pasivo.',NULL,0,4,1,NULL),(22012160,8776,'505','Deudas representadas en otros valores negociables a corto plazo.',NULL,0,3,1,NULL),(22012161,8776,'5050','Deudas representadas en otros valores negociables a corto plazo.',NULL,0,4,1,NULL),(22012162,8776,'506','Intereses de empréstitos y otras emisiones análogas.',NULL,0,3,1,NULL),(22012163,8776,'5060','Intereses de empréstitos y otras emisiones análogas.',NULL,0,4,1,NULL),(22012164,8776,'507','Dividendos de emisiones contabilizadas como pasivo.',NULL,0,3,1,NULL),(22012165,8776,'5070','Dividendos de emisiones contabilizadas como pasivo.',NULL,0,4,1,NULL),(22012166,8776,'509','Valores negociables amortizados.',NULL,0,3,1,NULL),(22012167,8776,'5090','Valores negociables amortizados.',NULL,0,4,1,NULL),(22012168,8776,'51','DEUDAS A CORTO PLAZO CON PARTES VINCULADAS.',NULL,0,2,1,NULL),(22012169,8776,'510','Deudas a corto plazo con entidades de crédito vinculadas.',NULL,0,3,1,NULL),(22012170,8776,'5100','Deudas a corto plazo con entidades de crédito vinculadas.',NULL,0,4,1,NULL),(22012171,8776,'511','Proveedores de inmovilizado a corto plazo, partes vinculadas.',NULL,0,3,1,NULL),(22012172,8776,'5110','Proveedores de inmovilizado a corto plazo, partes vinculadas.',NULL,0,4,1,NULL),(22012173,8776,'512','Acreedores por arrendamiento financiero a corto plazo, partes vinculadas.',NULL,0,3,1,NULL),(22012174,8776,'5120','Acreedores por arrendamiento financiero a corto plazo, partes vinculadas.',NULL,0,4,1,NULL),(22012175,8776,'513','Otras deudas a corto plazo con partes vinculadas.',NULL,0,3,1,NULL),(22012176,8776,'5130','Otras deudas a corto plazo con partes vinculadas.',NULL,0,4,1,NULL),(22012177,8776,'514','Intereses a corto plazo de deudas con partes vinculadas.',NULL,0,3,1,NULL),(22012178,8776,'5140','Intereses a corto plazo de deudas con partes vinculadas.',NULL,0,4,1,NULL),(22012179,8776,'52','DEUDAS A CORTO PLAZO POR PRÉSTAMOS RECIBIDOS Y OTROS CONCEPTOS.',NULL,0,2,1,NULL),(22012180,8776,'520','Deudas a corto plazo con entidades de crédito.',NULL,0,3,1,NULL),(22012181,8776,'5200','Préstamos a corto plazo de entidades de crédito.',NULL,0,4,1,NULL),(22012182,8776,'5201','Deudas a corto plazo por crédito dispuesto.',NULL,0,4,1,NULL),(22012183,8776,'5208','Deudas por efectos descontados.',NULL,0,4,1,NULL),(22012184,8776,'5209','Deudas por operaciones de factoring.',NULL,0,4,1,NULL),(22012185,8776,'521','Deudas a corto plazo.',NULL,0,3,1,NULL),(22012186,8776,'5210','Deudas a corto plazo.',NULL,0,4,1,NULL),(22012187,8776,'522','Deudas a corto plazo transformables en subvenciones, donaciones y legados.',NULL,0,3,1,NULL),(22012188,8776,'5220','Deudas a corto plazo transformables en subvenciones, donaciones y legados.',NULL,0,4,1,NULL),(22012189,8776,'523','Proveedores de inmovilizado a corto plazo.',NULL,0,3,1,NULL),(22012190,8776,'5230','Proveedores de inmovilizado a corto plazo.',NULL,0,4,1,NULL),(22012191,8776,'525','Efectos a pagar a corto plazo.',NULL,0,3,1,NULL),(22012192,8776,'5250','Efectos a pagar a corto plazo.',NULL,0,4,1,NULL),(22012193,8776,'526','Dividendo activo a pagar.',NULL,0,3,1,NULL),(22012194,8776,'5260','Dividendo activo a pagar.',NULL,0,4,1,NULL),(22012195,8776,'527','Intereses a corto plazo de deudas con entidades de crédito.',NULL,0,3,1,NULL),(22012196,8776,'5270','Intereses a corto plazo de deudas con entidades de crédito.',NULL,0,4,1,NULL),(22012197,8776,'528','Intereses a corto plazo de deudas.',NULL,0,3,1,NULL),(22012198,8776,'5280','Intereses a corto plazo de deudas.',NULL,0,4,1,NULL),(22012199,8776,'529','Provisiones a corto plazo.',NULL,0,3,1,NULL),(22012200,8776,'5290','Provisiones a corto plazo.',NULL,0,4,1,NULL),(22012201,8776,'53','INVERSIONES FINANCIERAS A CORTO PLAZO EN PARTES VINCULADAS.',NULL,0,2,1,NULL),(22012202,8776,'530','Participaciones a corto plazo en partes vinculadas.',NULL,0,3,1,NULL),(22012203,8776,'5303','Participaciones a corto plazo en empresas del grupo.',NULL,0,4,1,NULL),(22012204,8776,'5304','Participaciones a corto plazo en empresas del asociadas.',NULL,0,4,1,NULL),(22012205,8776,'5305','Participaciones a corto plazo, en otras partes vinculadas.',NULL,0,4,1,NULL),(22012206,8776,'531','Valores representativos de deuda a corto plazo de partes vinculadas.',NULL,0,3,1,NULL),(22012207,8776,'5310','Valores representativos de deuda a corto plazo de partes vinculadas.',NULL,0,4,1,NULL),(22012208,8776,'532','Créditos a corto plazo a partes vinculadas.',NULL,0,3,1,NULL),(22012209,8776,'5320','Créditos a corto plazo a partes vinculadas.',NULL,0,4,1,NULL),(22012210,8776,'533','Intereses a corto plazo de inversiones financieras en partes vinculadas.',NULL,0,3,1,NULL),(22012211,8776,'5330','Intereses a corto plazo de inversiones financieras en partes vinculadas.',NULL,0,4,1,NULL),(22012212,8776,'534','Intereses a corto plazo de créditos a partes vinculadas.',NULL,0,3,1,NULL),(22012213,8776,'5340','Intereses a corto plazo de créditos a partes vinculadas.',NULL,0,4,1,NULL),(22012214,8776,'535','Dividendo a cobrar de inversiones financieras en partes vinculadas.',NULL,0,3,1,NULL),(22012215,8776,'5350','Dividendo a cobrar de inversiones financieras en partes vinculadas.',NULL,0,4,1,NULL),(22012216,8776,'539','Desembolsos pendientes sobre participaciones a corto plazo de partes vinculadas.',NULL,0,3,1,NULL),(22012217,8776,'5390','Desembolsos pendientes sobre participaciones a corto plazo de partes vinculadas.',NULL,0,4,1,NULL),(22012218,8776,'54','OTRAS INVERSIONES FINANCIERAS A CORTO PLAZO.',NULL,0,2,1,NULL),(22012219,8776,'540','Inversiones financieras temporales en instrumentos de patrimonio.',NULL,0,3,1,NULL),(22012220,8776,'5400','Inversiones financieras temporales en instrumentos de patrimonio.',NULL,0,4,1,NULL),(22012221,8776,'541','Valores representativos de deuda a corto plazo.',NULL,0,3,1,NULL),(22012222,8776,'5410','Valores representativos de deuda a corto plazo.',NULL,0,4,1,NULL),(22012223,8776,'542','Créditos a corto plazo.',NULL,0,3,1,NULL),(22012224,8776,'5420','Créditos a corto plazo.',NULL,0,4,1,NULL),(22012225,8776,'543','Créditos a corto plazo por enajenación de inmovilizado.',NULL,0,3,1,NULL),(22012226,8776,'5430','Créditos a corto plazo por enajenación de inmovilizado.',NULL,0,4,1,NULL),(22012227,8776,'544','Créditos a corto plazo al personal.',NULL,0,3,1,NULL),(22012228,8776,'5440','Créditos a corto plazo al personal.',NULL,0,4,1,NULL),(22012229,8776,'545','Dividendo a cobrar.',NULL,0,3,1,NULL),(22012230,8776,'5450','Dividendo a cobrar.',NULL,0,4,1,NULL),(22012231,8776,'546','Intereses a corto plazo de valores representativos de deuda.',NULL,0,3,1,NULL),(22012232,8776,'5460','Intereses a corto plazo de valores representativos de deuda.',NULL,0,4,1,NULL),(22012233,8776,'547','Intereses a corto plazo de créditos.',NULL,0,3,1,NULL),(22012234,8776,'5470','Intereses a corto plazo de créditos.',NULL,0,4,1,NULL),(22012235,8776,'548','Imposiciones a corto plazo.',NULL,0,3,1,NULL),(22012236,8776,'5480','Imposiciones a corto plazo.',NULL,0,4,1,NULL),(22012237,8776,'549','Desembolsos pendientes sobre instrumentos de patrimonio a corto plazo.',NULL,0,3,1,NULL),(22012238,8776,'5490','Desembolsos pendientes sobre instrumentos de patrimonio a corto plazo.',NULL,0,4,1,NULL),(22012239,8776,'55','OTRAS CUENTAS NO BANCARIAS.',NULL,0,2,1,NULL),(22012240,8776,'550','Titular de la explotación.',NULL,0,3,1,NULL),(22012241,8776,'5500','Titular de la explotación.',NULL,0,4,1,NULL),(22012242,8776,'551','Cuenta corriente con socios administradores.',NULL,0,3,1,NULL),(22012243,8776,'5510','Cuenta corriente con socios administradores.',NULL,0,4,1,NULL),(22012244,8776,'552','Cuenta corriente con otras personas y entidades vinculadas.',NULL,0,3,1,NULL),(22012245,8776,'5520','Cuenta corriente con otras personas y entidades vinculadas.',NULL,0,4,1,NULL),(22012246,8776,'553','Cuentas corrientes en fusiones y escisiones.',NULL,0,3,1,NULL),(22012247,8776,'5530','Socios de sociedad disuelta.',NULL,0,4,1,NULL),(22012248,8776,'5531','Socios, cuenta de fusión.',NULL,0,4,1,NULL),(22012249,8776,'5532','Socios de sociedad escindida.',NULL,0,4,1,NULL),(22012250,8776,'5533','Socios, cuenta de escisión.',NULL,0,4,1,NULL),(22012251,8776,'554','Cuenta corriente con uniones temporales de empresas y comunidades de bienes.',NULL,0,3,1,NULL),(22012252,8776,'5540','Cuenta corriente con uniones temporales de empresas y comunidades de bienes.',NULL,0,4,1,NULL),(22012253,8776,'555','Partidas pendientes de aplicación.',NULL,0,3,1,NULL),(22012254,8776,'5550','Partidas pendientes de aplicación.',NULL,0,4,1,NULL),(22012255,8776,'5559','Suplidos y pagos a cuenta.',NULL,0,4,1,NULL),(22012256,8776,'555900000','Suplidos y pagos a cuenta.',NULL,1,5,1,NULL),(22012257,8776,'556','Desembolsos exigidos sobre participaciones en el patrimonio neto.',NULL,0,3,1,NULL),(22012258,8776,'5560','Desembolsos exigidos sobre participaciones en el patrimonio neto.',NULL,0,4,1,NULL),(22012259,8776,'557','Dividendo activo a cuenta.',NULL,0,3,1,NULL),(22012260,8776,'5570','Dividendo activo a cuenta.',NULL,0,4,1,NULL),(22012261,8776,'558','Socios por desembolsos exigidos.',NULL,0,3,1,NULL),(22012262,8776,'5580','Socios por desembolsos exigidos sobre acciones o participaciones ordinarias.',NULL,0,4,1,NULL),(22012263,8776,'5585','Socios por desembolsos exigidos sobre acciones o participaciones consideradas como pasivos financieros.',NULL,0,4,1,NULL),(22012264,8776,'559','Derivados financieros a corto plazo.',NULL,0,3,1,NULL),(22012265,8776,'5590','Activos por derivados financieros a corto plazo, cartera de negociación.',NULL,0,4,1,NULL),(22012266,8776,'5593','Activos de derivados financieros a corto plazo, instrumentos de cobertura.',NULL,0,4,1,NULL),(22012267,8776,'5595','Pasivos por derivados financieros a corto plazo, cartera de negociación.',NULL,0,4,1,NULL),(22012268,8776,'5598','Pasivos por derivados financieros a corto plazo, instrumentos de cobertura.',NULL,0,4,1,NULL),(22012269,8776,'56','FIANZAS Y DEPÓSITOS RECIBIDOS Y CONSTITUIDOS A CORTO PLAZO Y AJUSTES POR PERIODIFICACIÓN.',NULL,0,2,1,NULL),(22012270,8776,'560','Fianzas recibidas a corto plazo.',NULL,0,3,1,NULL),(22012271,8776,'5600','Fianzas recibidas a corto plazo.',NULL,0,4,1,NULL),(22012272,8776,'561','Depósitos recibidos a corto plazo.',NULL,0,3,1,NULL),(22012273,8776,'5610','Depósitos recibidos a corto plazo.',NULL,0,4,1,NULL),(22012274,8776,'565','Fianzas constituidas a corto plazo.',NULL,0,3,1,NULL),(22012275,8776,'5650','Fianzas constituidas a corto plazo.',NULL,0,4,1,NULL),(22012276,8776,'566','Depósitos constituidos a corto plazo.',NULL,0,3,1,NULL),(22012277,8776,'5660','Depósitos constituidos a corto plazo.',NULL,0,4,1,NULL),(22012278,8776,'567','Intereses pagados por anticipado.',NULL,0,3,1,NULL),(22012279,8776,'5670','Intereses pagados por anticipado.',NULL,0,4,1,NULL),(22012280,8776,'568','Intereses cobrados por anticipado.',NULL,0,3,1,NULL),(22012281,8776,'5680','Intereses cobrados por anticipado.',NULL,0,4,1,NULL),(22012282,8776,'569','Garantías financieras a corto plazo.',NULL,0,3,1,NULL),(22012283,8776,'5690','Garantías financieras a corto plazo.',NULL,0,4,1,NULL),(22012284,8776,'57','TESORERÍA.',NULL,0,2,1,NULL),(22012285,8776,'570','Caja, euros.',NULL,0,3,1,NULL),(22012286,8776,'5700','Caja, euros.',NULL,0,4,1,NULL),(22012287,8776,'570000000','Caja, euros.',NULL,1,5,1,NULL),(22012288,8776,'571','Caja, moneda extranjera.',NULL,0,3,1,NULL),(22012289,8776,'5710','Caja, moneda extranjera.',NULL,0,4,1,NULL),(22012290,8776,'572','Bancos e instituciones de crédito c/c vista, euros.',NULL,0,3,1,NULL),(22012291,8776,'5720','Bancos e instituciones de crédito c/c vista, euros.',NULL,0,4,1,NULL),(22012292,8776,'573','Bancos e instituciones de crédito c/c vista, moneda extranjera.',NULL,0,3,1,NULL),(22012293,8776,'5730','Bancos e instituciones de crédito c/c vista, moneda extranjera.',NULL,0,4,1,NULL),(22012294,8776,'574','Bancos e instituciones de crédito, cuentas de ahorro, euros.',NULL,0,3,1,NULL),(22012295,8776,'5740','Bancos e instituciones de crédito, cuentas de ahorro, euros.',NULL,0,4,1,NULL),(22012296,8776,'575','Bancos e instituciones de crédito, cuentas de ahorro, moneda extranjera.',NULL,0,3,1,NULL),(22012297,8776,'5750','Bancos e instituciones de crédito, cuentas de ahorro, moneda extranjera.',NULL,0,4,1,NULL),(22012298,8776,'576','Inversiones a corto plazo de gran liquidez.',NULL,0,3,1,NULL),(22012299,8776,'5760','Inversiones a corto plazo de gran liquidez.',NULL,0,4,1,NULL),(22012300,8776,'58','ACTIVOS NO CORRIENTES MANTENIDOS PARA LA VENTA Y ACTIVOS Y PASIVOS ASOCIADOS.',NULL,0,2,1,NULL),(22012301,8776,'580','Inmovilizado.',NULL,0,3,1,NULL),(22012302,8776,'5800','Inmovilizado.',NULL,0,4,1,NULL),(22012303,8776,'581','Inversiones con personas y entidades vinculadas.',NULL,0,3,1,NULL),(22012304,8776,'5810','Inversiones con personas y entidades vinculadas.',NULL,0,4,1,NULL),(22012305,8776,'582','Inversiones financieras.',NULL,0,3,1,NULL),(22012306,8776,'5820','Inversiones financieras.',NULL,0,4,1,NULL),(22012307,8776,'583','Existencias, deudores comerciales y otras cuentas a cobrar.',NULL,0,3,1,NULL),(22012308,8776,'5830','Existencias, deudores comerciales y otras cuentas a cobrar.',NULL,0,4,1,NULL),(22012309,8776,'584','Otros activos.',NULL,0,3,1,NULL),(22012310,8776,'5840','Otros activos.',NULL,0,4,1,NULL),(22012311,8776,'585','Provisiones.',NULL,0,3,1,NULL),(22012312,8776,'5850','Provisiones.',NULL,0,4,1,NULL),(22012313,8776,'586','Deudas con características especiales.',NULL,0,3,1,NULL),(22012314,8776,'5860','Deudas con características especiales.',NULL,0,4,1,NULL),(22012315,8776,'587','Deudas con personas y entidades vinculadas.',NULL,0,3,1,NULL),(22012316,8776,'5870','Deudas con personas y entidades vinculadas.',NULL,0,4,1,NULL),(22012317,8776,'588','Acreedores comerciales y otras cuentas a pagar.',NULL,0,3,1,NULL),(22012318,8776,'5880','Acreedores comerciales y otras cuentas a pagar.',NULL,0,4,1,NULL),(22012319,8776,'589','Otros pasivos.',NULL,0,3,1,NULL),(22012320,8776,'5890','Otros pasivos.',NULL,0,4,1,NULL),(22012321,8776,'59','DETERIORO DEL VALOR DE INVERSIONES FINANCIERAS A CORTO PLAZO Y DE ACTIVOS NO CORRIENTES MANTENIDOS PARA LA VENTA.',NULL,0,2,1,NULL),(22012322,8776,'593','Deterioro de valor de participaciones a corto plazo en partes vinculadas.',NULL,0,3,1,NULL),(22012323,8776,'5930','Deterioro de valor de participaciones a corto plazo en partes vinculadas.',NULL,0,4,1,NULL),(22012324,8776,'594','Deterioro del valor de valores representativos de deuda a corto plazo de partes vinculadas.',NULL,0,3,1,NULL),(22012325,8776,'5940','Deterioro del valor de valores representativos de deuda a corto plazo de partes vinculadas.',NULL,0,4,1,NULL),(22012326,8776,'595','Deterioro del valor de créditos a corto plazo a partes vinculadas.',NULL,0,3,1,NULL),(22012327,8776,'5950','Deterioro del valor de créditos a corto plazo a partes vinculadas.',NULL,0,4,1,NULL),(22012328,8776,'597','Deterioro de valor de valores representativos de deuda a corto plazo.',NULL,0,3,1,NULL),(22012329,8776,'5970','Deterioro de valor de valores representativos de deuda a corto plazo.',NULL,0,4,1,NULL),(22012330,8776,'598','Deterioro de valor de créditos a corto plazo.',NULL,0,3,1,NULL),(22012331,8776,'5980','Deterioro de valor de créditos a corto plazo.',NULL,0,4,1,NULL),(22012332,8776,'599','Deterioro de valor de activos no corrientes mantenidos para la venta.',NULL,0,3,1,NULL),(22012333,8776,'5990','Deterioro de valor de activos no corrientes mantenidos para la venta.',NULL,0,4,1,NULL),(22012334,8776,'6','COMPRAS Y GASTOS',NULL,0,1,1,NULL),(22012335,8776,'60','COMPRAS.',NULL,0,2,1,NULL),(22012336,8776,'600','Compras de mercaderías.',NULL,0,3,1,NULL),(22012337,8776,'6000','Compras de mercaderías.',NULL,0,4,1,NULL),(22012338,8776,'600000000','Compras de mercaderías.',NULL,1,5,1,NULL),(22012339,8776,'601','Compras de materias primas.',NULL,0,3,1,NULL),(22012340,8776,'6010','Compras de materias primas.',NULL,0,4,1,NULL),(22012341,8776,'602','Compras de otros aprovisionamientos.',NULL,0,3,1,NULL),(22012342,8776,'6020','Compras de otros aprovisionamientos.',NULL,0,4,1,NULL),(22012343,8776,'606','Descuentos sobre compras por pronto pago.',NULL,0,3,1,NULL),(22012344,8776,'6060','Descuentos sobre compras por pronto pago.',NULL,0,4,1,NULL),(22012345,8776,'607','Trabajos realizados por otras empresas.',NULL,0,3,1,NULL),(22012346,8776,'6070','Trabajos realizados por otras empresas.',NULL,0,4,1,NULL),(22012347,8776,'608','Devoluciones de compras y operaciones similares.',NULL,0,3,1,NULL),(22012348,8776,'6080','Devoluciones de compras y operaciones similares.',NULL,0,4,1,NULL),(22012349,8776,'609','Rappels por compras.',NULL,0,3,1,NULL),(22012350,8776,'6090','Rappels por compras.',NULL,0,4,1,NULL),(22012351,8776,'61','VARIACIÓN DE EXISTENCIAS.',NULL,0,2,1,NULL),(22012352,8776,'610','Variación de existencias de mercaderías.',NULL,0,3,1,NULL),(22012353,8776,'6100','Variación de existencias de mercaderías.',NULL,0,4,1,NULL),(22012354,8776,'611','Variación de existencias de materias primas.',NULL,0,3,1,NULL),(22012355,8776,'6110','Variación de existencias de materias primas.',NULL,0,4,1,NULL),(22012356,8776,'612','Variación de existencias de otros aprovisionamientos.',NULL,0,3,1,NULL),(22012357,8776,'6120','Variación de existencias de otros aprovisionamientos.',NULL,0,4,1,NULL),(22012358,8776,'62','SERVICIOS EXTERIORES.',NULL,0,2,1,NULL),(22012359,8776,'620','Gastos en investigación y desarrollo del ejercicio.',NULL,0,3,1,NULL),(22012360,8776,'6200','Gastos en investigación y desarrollo del ejercicio.',NULL,0,4,1,NULL),(22012361,8776,'621','Arrendamientos y cánones.',NULL,0,3,1,NULL),(22012362,8776,'6210','Arrendamientos y cánones.',NULL,0,4,1,NULL),(22012363,8776,'622','Reparaciones y conservación.',NULL,0,3,1,NULL),(22012364,8776,'6220','Reparaciones y conservación.',NULL,0,4,1,NULL),(22012365,8776,'623','Servicios de profesionales independientes.',NULL,0,3,1,NULL),(22012366,8776,'6230','Servicios de profesionales independientes.',NULL,0,4,1,NULL),(22012367,8776,'624','Transportes.',NULL,0,3,1,NULL),(22012368,8776,'6240','Transportes.',NULL,0,4,1,NULL),(22012369,8776,'625','Primas de seguros.',NULL,0,3,1,NULL),(22012370,8776,'6250','Primas de seguros.',NULL,0,4,1,NULL),(22012371,8776,'626','Servicios bancarios y similares.',NULL,0,3,1,NULL),(22012372,8776,'6260','Servicios bancarios y similares.',NULL,0,4,1,NULL),(22012373,8776,'627','Publicidad, propaganda y relaciones públicas.',NULL,0,3,1,NULL),(22012374,8776,'6270','Publicidad, propaganda y relaciones públicas.',NULL,0,4,1,NULL),(22012375,8776,'628','Suministros.',NULL,0,3,1,NULL),(22012376,8776,'6280','Suministros.',NULL,0,4,1,NULL),(22012377,8776,'629','Otros servicios.',NULL,0,3,1,NULL),(22012378,8776,'6290','Otros servicios.',NULL,0,4,1,NULL),(22012379,8776,'63','TRIBUTOS.',NULL,0,2,1,NULL),(22012380,8776,'630','Impuesto sobre beneficios.',NULL,0,3,1,NULL),(22012381,8776,'6300','Impuesto corriente.',NULL,0,4,1,NULL),(22012382,8776,'6301','Impuesto diferido.',NULL,0,4,1,NULL),(22012383,8776,'631','Otros tributos.',NULL,0,3,1,NULL),(22012384,8776,'6310','Otros tributos.',NULL,0,4,1,NULL),(22012385,8776,'633','Ajustes negativos en la imposición sobre beneficios.',NULL,0,3,1,NULL),(22012386,8776,'6330','Ajustes negativos en la imposición sobre beneficios.',NULL,0,4,1,NULL),(22012387,8776,'634','Ajustes negativos en la imposición indirecta.',NULL,0,3,1,NULL),(22012388,8776,'6340','Ajustes negativos en la imposición indirecta.',NULL,0,4,1,NULL),(22012389,8776,'6341','Ajustes negativos en IVA de activo corriente.',NULL,0,4,1,NULL),(22012390,8776,'634100001','Ajustes negativos en IVA de activo corriente.',NULL,1,5,1,NULL),(22012391,8776,'6342','Ajustes negativos en IVA de inversiones.',NULL,0,4,1,NULL),(22012392,8776,'636','Devolución de impuestos.',NULL,0,3,1,NULL),(22012393,8776,'6360','Devolución de impuestos.',NULL,0,4,1,NULL),(22012394,8776,'638','Ajustes positivos en la imposición sobre beneficios.',NULL,0,3,1,NULL),(22012395,8776,'6380','Ajustes positivos en la imposición sobre beneficios.',NULL,0,4,1,NULL),(22012396,8776,'639','Ajustes positivos en la imposición indirecta.',NULL,0,3,1,NULL),(22012397,8776,'6390','Ajustes positivos en la imposición indirecta.',NULL,0,4,1,NULL),(22012398,8776,'64','GASTOS DE PERSONAL.',NULL,0,2,1,NULL),(22012399,8776,'640','Sueldos y salarios.',NULL,0,3,1,NULL),(22012400,8776,'6400','Sueldos y salarios.',NULL,0,4,1,NULL),(22012401,8776,'640000000','Sueldos y salarios.',NULL,1,5,1,NULL),(22012402,8776,'641','Indemnizaciones.',NULL,0,3,1,NULL),(22012403,8776,'6410','Indemnizaciones.',NULL,0,4,1,NULL),(22012404,8776,'641000000','Indemnizaciones.',NULL,1,5,1,NULL),(22012405,8776,'642','Seguridad Social a cargo de la empresa.',NULL,0,3,1,NULL),(22012406,8776,'6420','Seguridad Social a cargo de la empresa.',NULL,0,4,1,NULL),(22012407,8776,'642000000','Seguridad Social a cargo de la empresa.',NULL,1,5,1,NULL),(22012408,8776,'643','Retribuciones a largo plazo mediante sistemas de aportación definida.',NULL,0,3,1,NULL),(22012409,8776,'6430','Retribuciones a largo plazo mediante sistemas de aportación definida.',NULL,0,4,1,NULL),(22012410,8776,'644','Retribuciones a largo plazo mediante sistemas de prestación definida.',NULL,0,3,1,NULL),(22012411,8776,'6440','Contribuciones anuales.',NULL,0,4,1,NULL),(22012412,8776,'6442','Otros costes.',NULL,0,4,1,NULL),(22012413,8776,'645','Retribuciones al personal mediante instrumentos de patrimonio.',NULL,0,3,1,NULL),(22012414,8776,'6450','Retribuciones al personal mediante instrumentos de patrimonio.',NULL,0,4,1,NULL),(22012415,8776,'649','Otros gastos sociales.',NULL,0,3,1,NULL),(22012416,8776,'6490','Otros gastos sociales.',NULL,0,4,1,NULL),(22012417,8776,'65','OTROS GASTOS DE GESTIÓN.',NULL,0,2,1,NULL),(22012418,8776,'650','Pérdidas de créditos comerciales incobrables.',NULL,0,3,1,NULL),(22012419,8776,'6500','Pérdidas de créditos comerciales incobrables.',NULL,0,4,1,NULL),(22012420,8776,'651','Resultados de operaciones en común.',NULL,0,3,1,NULL),(22012421,8776,'6510','Beneficio transferido (gestor).',NULL,0,4,1,NULL),(22012422,8776,'6511','Pérdida soportada (partícipe o asociado no gestor).',NULL,0,4,1,NULL),(22012423,8776,'659','Otras pérdidas en gestión corriente.',NULL,0,3,1,NULL),(22012424,8776,'6590','Otras pérdidas en gestión corriente.',NULL,0,4,1,NULL),(22012425,8776,'66','GASTOS FINANCIEROS.',NULL,0,2,1,NULL),(22012426,8776,'660','Gastos financieros por actualización de provisiones.',NULL,0,3,1,NULL),(22012427,8776,'6600','Gastos financieros por actualización de provisiones.',NULL,0,4,1,NULL),(22012428,8776,'661','Intereses de obligaciones y bonos.',NULL,0,3,1,NULL),(22012429,8776,'6610','Intereses de obligaciones y bonos.',NULL,0,4,1,NULL),(22012430,8776,'662','Intereses de deudas.',NULL,0,3,1,NULL),(22012431,8776,'6620','Intereses de deudas.',NULL,0,4,1,NULL),(22012432,8776,'662000000','Intereses de deudas.',NULL,1,5,1,NULL),(22012433,8776,'663','Pérdidas por valoración de instrumentos financieros por su valor razonable.',NULL,0,3,1,NULL),(22012434,8776,'6630','Pérdidas de cartera de negociación.',NULL,0,4,1,NULL),(22012435,8776,'6631','Pérdidas de designados por la empresa.',NULL,0,4,1,NULL),(22012436,8776,'6632','Pérdidas de disponibles para la venta.',NULL,0,4,1,NULL),(22012437,8776,'6633','Pérdidas de instrumentos de cobertura.',NULL,0,4,1,NULL),(22012438,8776,'664','Dividendos de acciones o participaciones contabilizadas como pasivo.',NULL,0,3,1,NULL),(22012439,8776,'6640','Dividendos de acciones o participaciones contabilizadas como pasivo.',NULL,0,4,1,NULL),(22012440,8776,'665','Intereses por descuento de efectos y operaciones de factoring.',NULL,0,3,1,NULL),(22012441,8776,'6650','Intereses por descuento de efectos y operaciones de factoring.',NULL,0,4,1,NULL),(22012442,8776,'666','Pérdidas en participaciones y valores representativos de deuda.',NULL,0,3,1,NULL),(22012443,8776,'6660','Pérdidas en participaciones y valores representativos de deuda.',NULL,0,4,1,NULL),(22012444,8776,'667','Pérdidas de créditos no comerciales.',NULL,0,3,1,NULL),(22012445,8776,'6670','Pérdidas de créditos no comerciales.',NULL,0,4,1,NULL),(22012446,8776,'668','Diferencias negativas de cambio.',NULL,0,3,1,NULL),(22012447,8776,'6680','Diferencias negativas de cambio.',NULL,0,4,1,NULL),(22012448,8776,'669','Otros gastos financieros.',NULL,0,3,1,NULL),(22012449,8776,'6690','Otros gastos financieros.',NULL,0,4,1,NULL),(22012450,8776,'669000000','Otros gastos financieros.',NULL,1,5,1,NULL),(22012451,8776,'67','PÉRDIDAS PROCEDENTES DE ACTIVOS NO CORRIENTES Y GASTOS EXCEPCIONALES.',NULL,0,2,1,NULL),(22012452,8776,'670','Pérdidas procedentes del inmovilizado intangible.',NULL,0,3,1,NULL),(22012453,8776,'6700','Pérdidas procedentes del inmovilizado intangible.',NULL,0,4,1,NULL),(22012454,8776,'671','Pérdidas procedentes del inmovilizado material.',NULL,0,3,1,NULL),(22012455,8776,'6710','Pérdidas procedentes del inmovilizado material.',NULL,0,4,1,NULL),(22012456,8776,'672','Pérdidas procedentes de las inversiones inmobiliarias.',NULL,0,3,1,NULL),(22012457,8776,'6720','Pérdidas procedentes de las inversiones inmobiliarias.',NULL,0,4,1,NULL),(22012458,8776,'673','Pérdidas procedentes de participaciones a largo plazo en partes vinculadas.',NULL,0,3,1,NULL),(22012459,8776,'6730','Pérdidas procedentes de participaciones a largo plazo en partes vinculadas.',NULL,0,4,1,NULL),(22012460,8776,'675','Pérdidas por operaciones con obligaciones propias.',NULL,0,3,1,NULL),(22012461,8776,'6750','Pérdidas por operaciones con obligaciones propias.',NULL,0,4,1,NULL),(22012462,8776,'678','Gastos excepcionales.',NULL,0,3,1,NULL),(22012463,8776,'6780','Gastos excepcionales.',NULL,0,4,1,NULL),(22012464,8776,'68','DOTACIONES PARA AMORTIZACIONES.',NULL,0,2,1,NULL),(22012465,8776,'680','Amortización del inmovilizado intangible.',NULL,0,3,1,NULL),(22012466,8776,'6800','Amortización del inmovilizado intangible.',NULL,0,4,1,NULL),(22012467,8776,'6801','Amortización de investigación',NULL,0,4,1,NULL),(22012468,8776,'6802','Amortización de desarrollo',NULL,0,4,1,NULL),(22012469,8776,'6803','Amortización de concesiones administrativas',NULL,0,4,1,NULL),(22012470,8776,'6804','Amortización de propiedad industrial',NULL,0,4,1,NULL),(22012471,8776,'6805','Amortización de derechos de traspaso',NULL,0,4,1,NULL),(22012472,8776,'6806','Amortización de aplicaciones informáticas',NULL,0,4,1,NULL),(22012473,8776,'681','Amortización del inmovilizado material.',NULL,0,3,1,NULL),(22012474,8776,'6810','Amortización del inmovilizado material.',NULL,0,4,1,NULL),(22012475,8776,'6811','Amortización de construcciones',NULL,0,4,1,NULL),(22012476,8776,'6812','Amortización de instalaciones técnicas',NULL,0,4,1,NULL),(22012477,8776,'6813','Amortización de maquinaria',NULL,0,4,1,NULL),(22012478,8776,'6814','Amortización de utillaje',NULL,0,4,1,NULL),(22012479,8776,'6815','Amortización de otras instalaciones',NULL,0,4,1,NULL),(22012480,8776,'6816','Amortización de mobiliario',NULL,0,4,1,NULL),(22012481,8776,'6817','Amortización de equipos para el proceso de información',NULL,0,4,1,NULL),(22012482,8776,'6818','Amortización de elementos de transporte',NULL,0,4,1,NULL),(22012483,8776,'6819','Amortización de otro inmovilizado material',NULL,0,4,1,NULL),(22012484,8776,'682','Amortización de las inversiones inmobiliarias.',NULL,0,3,1,NULL),(22012485,8776,'6820','Amortización de las inversiones inmobiliarias.',NULL,0,4,1,NULL),(22012486,8776,'69','PÉRDIDAS POR DETERIORO Y OTRAS DOTACIONES.',NULL,0,2,1,NULL),(22012487,8776,'690','Pérdidas por deterioro del inmovilizado intangible.',NULL,0,3,1,NULL),(22012488,8776,'6900','Pérdidas por deterioro del inmovilizado intangible.',NULL,0,4,1,NULL),(22012489,8776,'691','Pérdidas por deterioro del inmovilizado material.',NULL,0,3,1,NULL),(22012490,8776,'6910','Pérdidas por deterioro del inmovilizado material.',NULL,0,4,1,NULL),(22012491,8776,'692','Pérdidas por deterioro de las inversiones inmobiliarias.',NULL,0,3,1,NULL),(22012492,8776,'6920','Pérdidas por deterioro de las inversiones inmobiliarias.',NULL,0,4,1,NULL),(22012493,8776,'693','Pérdidas por deterioro de existencias.',NULL,0,3,1,NULL),(22012494,8776,'6930','Pérdidas por deterioro de existencias.',NULL,0,4,1,NULL),(22012495,8776,'694','Pérdidas por deterioro de créditos comerciales.',NULL,0,3,1,NULL),(22012496,8776,'6940','Pérdidas por deterioro de créditos comerciales.',NULL,0,4,1,NULL),(22012497,8776,'695','Dotación a la provisión por operaciones comerciales.',NULL,0,3,1,NULL),(22012498,8776,'6954','Dotación a la provisión por contratos onerosos.',NULL,0,4,1,NULL),(22012499,8776,'6959','Dotación a la provisión para otras operaciones comerciales.',NULL,0,4,1,NULL),(22012500,8776,'696','Pérdidas por deterioro de participaciones y valores representativos de deuda a largo plazo.',NULL,0,3,1,NULL),(22012501,8776,'6960','Pérdidas por deterioro de participaciones y valores representativos de deuda a largo plazo.',NULL,0,4,1,NULL),(22012502,8776,'697','Pérdidas por deterioro de créditos a largo plazo.',NULL,0,3,1,NULL),(22012503,8776,'6970','Pérdidas por deterioro de créditos a largo plazo.',NULL,0,4,1,NULL),(22012504,8776,'698','Pérdidas por deterioro de participaciones y valores representativos de deuda a corto plazo.',NULL,0,3,1,NULL),(22012505,8776,'6980','Pérdidas por deterioro de participaciones y valores representativos de deuda a corto plazo.',NULL,0,4,1,NULL),(22012506,8776,'699','Pérdidas por deterioro de créditos a corto plazo.',NULL,0,3,1,NULL),(22012507,8776,'6990','Pérdidas por deterioro de créditos a corto plazo.',NULL,0,4,1,NULL),(22012508,8776,'7','VENTAS E INGRESOS',NULL,0,1,1,NULL),(22012509,8776,'70','VENTAS DE MERCADERÍAS, DE PRODUCCIÓN PROPIA, DE SERVICIOS, ETC.',NULL,0,2,1,NULL),(22012510,8776,'700','Ventas de mercaderías.',NULL,0,3,1,NULL),(22012511,8776,'7000','Ventas de mercaderías.',NULL,0,4,1,NULL),(22012512,8776,'700000000','Ventas de mercaderías.',NULL,1,5,1,NULL),(22012513,8776,'701','Ventas de productos terminados.',NULL,0,3,1,NULL),(22012514,8776,'7010','Ventas de productos terminados.',NULL,0,4,1,NULL),(22012515,8776,'702','Ventas de productos semiterminados.',NULL,0,3,1,NULL),(22012516,8776,'7020','Ventas de productos semiterminados.',NULL,0,4,1,NULL),(22012517,8776,'703','Ventas de subproductos y residuos.',NULL,0,3,1,NULL),(22012518,8776,'7030','Ventas de subproductos y residuos.',NULL,0,4,1,NULL),(22012519,8776,'704','Ventas de envases y embalajes.',NULL,0,3,1,NULL),(22012520,8776,'7040','Ventas de envases y embalajes.',NULL,0,4,1,NULL),(22012521,8776,'705','Prestación de servicios.',NULL,0,3,1,NULL),(22012522,8776,'7050','Prestación de servicios.',NULL,0,4,1,NULL),(22012523,8776,'706','Descuentos sobre ventas por pronto pago.',NULL,0,3,1,NULL),(22012524,8776,'7060','Descuentos sobre ventas por pronto pago.',NULL,0,4,1,NULL),(22012525,8776,'708','Devoluciones de ventas y operaciones similares.',NULL,0,3,1,NULL),(22012526,8776,'7080','Devoluciones de ventas y operaciones similares.',NULL,0,4,1,NULL),(22012527,8776,'709','Rappels sobre ventas.',NULL,0,3,1,NULL),(22012528,8776,'7090','Rappels sobre ventas.',NULL,0,4,1,NULL),(22012529,8776,'71','VARIACIÓN DE EXISTENCIAS.',NULL,0,2,1,NULL),(22012530,8776,'710','Variación de existencias de productos en curso.',NULL,0,3,1,NULL),(22012531,8776,'7100','Variación de existencias de productos en curso.',NULL,0,4,1,NULL),(22012532,8776,'711','Variación de existencias de productos semiterminados.',NULL,0,3,1,NULL),(22012533,8776,'7110','Variación de existencias de productos semiterminados.',NULL,0,4,1,NULL),(22012534,8776,'712','Variación de existencias de productos terminados.',NULL,0,3,1,NULL),(22012535,8776,'7120','Variación de existencias de productos terminados.',NULL,0,4,1,NULL),(22012536,8776,'713','Variación de existencias de subproductos, residuos y materiales recuperados.',NULL,0,3,1,NULL),(22012537,8776,'7130','Variación de existencias de subproductos, residuos y materiales recuperados.',NULL,0,4,1,NULL),(22012538,8776,'73','TRABAJOS REALIZADOS PARA LA EMPRESA.',NULL,0,2,1,NULL),(22012539,8776,'730','Trabajos realizados para el inmovilizado intangible.',NULL,0,3,1,NULL),(22012540,8776,'7300','Trabajos realizados para el inmovilizado intangible.',NULL,0,4,1,NULL),(22012541,8776,'731','Trabajos realizados para el inmovilizado material.',NULL,0,3,1,NULL),(22012542,8776,'7310','Trabajos realizados para el inmovilizado material.',NULL,0,4,1,NULL),(22012543,8776,'732','Trabajos realizados en inversiones inmobiliarias.',NULL,0,3,1,NULL),(22012544,8776,'7320','Trabajos realizados en inversiones inmobiliarias.',NULL,0,4,1,NULL),(22012545,8776,'733','Trabajos realizados para el inmovilizado en curso.',NULL,0,3,1,NULL),(22012546,8776,'7330','Trabajos realizados para el inmovilizado en curso.',NULL,0,4,1,NULL),(22012547,8776,'74','SUBVENCIONES, DONACIONES Y LEGADOS.',NULL,0,2,1,NULL),(22012548,8776,'740','Subvenciones, donaciones y legados a la explotación.',NULL,0,3,1,NULL),(22012549,8776,'7400','Subvenciones, donaciones y legados a la explotación.',NULL,0,4,1,NULL),(22012550,8776,'746','Subvenciones, donaciones y legados de capital transferidos al resultado del ejercicio.',NULL,0,3,1,NULL),(22012551,8776,'7460','Subvenciones, donaciones y legados de capital transferidos al resultado del ejercicio.',NULL,0,4,1,NULL),(22012552,8776,'747','Otras subvenciones, donaciones y legados transferidos al resultado del ejercicio.',NULL,0,3,1,NULL),(22012553,8776,'7470','Otras subvenciones, donaciones y legados transferidos al resultado del ejercicio.',NULL,0,4,1,NULL),(22012554,8776,'75','OTROS INGRESOS DE GESTIÓN.',NULL,0,2,1,NULL),(22012555,8776,'751','Resultados de operaciones en común.',NULL,0,3,1,NULL),(22012556,8776,'7510','Pérdida transferida (gestor).',NULL,0,4,1,NULL),(22012557,8776,'7511','Beneficio atribuido (partícipe o asociado no gestor).',NULL,0,4,1,NULL),(22012558,8776,'752','Ingresos por arrendamientos.',NULL,0,3,1,NULL),(22012559,8776,'7520','Ingresos por arrendamientos.',NULL,0,4,1,NULL),(22012560,8776,'753','Ingresos de propiedad industrial cedida en explotación.',NULL,0,3,1,NULL),(22012561,8776,'7530','Ingresos de propiedad industrial cedida en explotación.',NULL,0,4,1,NULL),(22012562,8776,'754','Ingresos por comisiones.',NULL,0,3,1,NULL),(22012563,8776,'7540','Ingresos por comisiones.',NULL,0,4,1,NULL),(22012564,8776,'755','Ingresos por servicios al personal.',NULL,0,3,1,NULL),(22012565,8776,'7550','Ingresos por servicios al personal.',NULL,0,4,1,NULL),(22012566,8776,'759','Ingresos por servicios diversos.',NULL,0,3,1,NULL),(22012567,8776,'7590','Ingresos por servicios diversos.',NULL,0,4,1,NULL),(22012568,8776,'76','INGRESOS FINANCIEROS.',NULL,0,2,1,NULL),(22012569,8776,'760','Ingresos de participaciones en instrumentos de patrimonio.',NULL,0,3,1,NULL),(22012570,8776,'7600','Ingresos de participaciones en instrumentos de patrimonio.',NULL,0,4,1,NULL),(22012571,8776,'761','Ingresos de valores representativos de deuda.',NULL,0,3,1,NULL),(22012572,8776,'7610','Ingresos de valores representativos de deuda.',NULL,0,4,1,NULL),(22012573,8776,'762','Ingresos de créditos.',NULL,0,3,1,NULL),(22012574,8776,'7620','Ingresos de créditos.',NULL,0,4,1,NULL),(22012575,8776,'763','Beneficios por valoración de instrumentos financieros por su valor razonable.',NULL,0,3,1,NULL),(22012576,8776,'7630','Beneficios de cartera de negociación.',NULL,0,4,1,NULL),(22012577,8776,'7631','Beneficios de designados por la empresa.',NULL,0,4,1,NULL),(22012578,8776,'7632','Beneficios de disponibles para la venta.',NULL,0,4,1,NULL),(22012579,8776,'7633','Beneficios de instrumentos de cobertura.',NULL,0,4,1,NULL),(22012580,8776,'766','Beneficios en participaciones y valores representativos de deuda.',NULL,0,3,1,NULL),(22012581,8776,'7660','Beneficios en participaciones y valores representativos de deuda.',NULL,0,4,1,NULL),(22012582,8776,'767','Ingresos de activos afectos y de derechos de reembolso relativos a retribuciones a largo plazo.',NULL,0,3,1,NULL),(22012583,8776,'7670','Ingresos de activos afectos y de derechos de reembolso relativos a retribuciones a largo plazo.',NULL,0,4,1,NULL),(22012584,8776,'768','Diferencias positivas de cambio.',NULL,0,3,1,NULL),(22012585,8776,'7680','Diferencias positivas de cambio.',NULL,0,4,1,NULL),(22012586,8776,'769','Otros ingresos financieros.',NULL,0,3,1,NULL),(22012587,8776,'7690','Otros ingresos financieros.',NULL,0,4,1,NULL),(22012588,8776,'77','BENEFICIOS PROCEDENTES DE ACTIVOS NO CORRIENTES E INGRESOS EXCEPCIONALES.',NULL,0,2,1,NULL),(22012589,8776,'770','Beneficios procedentes del inmovilizado intangible.',NULL,0,3,1,NULL),(22012590,8776,'7700','Beneficios procedentes del inmovilizado intangible.',NULL,0,4,1,NULL),(22012591,8776,'771','Beneficios procedentes del inmovilizado material.',NULL,0,3,1,NULL),(22012592,8776,'7710','Beneficios procedentes del inmovilizado material.',NULL,0,4,1,NULL),(22012593,8776,'772','Beneficios procedentes de las inversiones inmobiliarias.',NULL,0,3,1,NULL),(22012594,8776,'7720','Beneficios procedentes de las inversiones inmobiliarias.',NULL,0,4,1,NULL),(22012595,8776,'773','Beneficios procedentes de participaciones..',NULL,0,3,1,NULL),(22012596,8776,'7730','Beneficios procedentes de participaciones..',NULL,0,4,1,NULL),(22012597,8776,'774','Diferencia negativa en combinaciones de negocios.',NULL,0,3,1,NULL),(22012598,8776,'7740','Diferencia negativa en combinaciones de negocios.',NULL,0,4,1,NULL),(22012599,8776,'775','Beneficios por operaciones con obligaciones propias.',NULL,0,3,1,NULL),(22012600,8776,'7750','Beneficios por operaciones con obligaciones propias.',NULL,0,4,1,NULL),(22012601,8776,'778','Ingresos excepcionales.',NULL,0,3,1,NULL),(22012602,8776,'7780','Ingresos excepcionales.',NULL,0,4,1,NULL),(22012603,8776,'79','EXCESOS Y APLICACIONES DE PROVISIONES Y DE PÉRDIDAS POR DETERIORO.',NULL,0,2,1,NULL),(22012604,8776,'790','Reversión del deterioro del inmovilizado intangible.',NULL,0,3,1,NULL),(22012605,8776,'7900','Reversión del deterioro del inmovilizado intangible.',NULL,0,4,1,NULL),(22012606,8776,'791','Reversión del deterioro del inmovilizado material.',NULL,0,3,1,NULL),(22012607,8776,'7910','Reversión del deterioro del inmovilizado material.',NULL,0,4,1,NULL),(22012608,8776,'792','Reversión del deterioro de las inversiones inmobiliarias.',NULL,0,3,1,NULL),(22012609,8776,'7920','Reversión del deterioro de las inversiones inmobiliarias.',NULL,0,4,1,NULL),(22012610,8776,'793','Reversión del deterioro de existencias.',NULL,0,3,1,NULL),(22012611,8776,'7930','Reversión del deterioro de existencias.',NULL,0,4,1,NULL),(22012612,8776,'794','Reversión del deterioro de créditos por operaciones comerciales.',NULL,0,3,1,NULL),(22012613,8776,'7940','Reversión del deterioro de créditos por operaciones comerciales.',NULL,0,4,1,NULL),(22012614,8776,'795','Exceso de provisiones.',NULL,0,3,1,NULL),(22012615,8776,'7950','Exceso de provisiones.',NULL,0,4,1,NULL),(22012616,8776,'796','Reversión del deterioro de participaciones y valores representativos de deuda a largo plazo.',NULL,0,3,1,NULL),(22012617,8776,'7960','Reversión del deterioro de participaciones y valores representativos de deuda a largo plazo.',NULL,0,4,1,NULL),(22012618,8776,'797','Reversión del deterioro de créditos a largo plazo.',NULL,0,3,1,NULL),(22012619,8776,'7970','Reversión del deterioro de créditos a largo plazo.',NULL,0,4,1,NULL),(22012620,8776,'798','Reversión del deterioro de participaciones y valores representativos de deuda a corto plazo.',NULL,0,3,1,NULL),(22012621,8776,'7980','Reversión del deterioro de participaciones y valores representativos de deuda a corto plazo.',NULL,0,4,1,NULL),(22012622,8776,'799','Reversión del deterioro de créditos a corto plazo.',NULL,0,3,1,NULL),(22012623,8776,'7990','Reversión del deterioro de créditos a corto plazo.',NULL,0,4,1,NULL),(22012624,8776,'8','GASTOS IMPUTADOS AL PATRIMONIO NETO',NULL,0,1,1,NULL),(22012625,8776,'80','GASTOS FINANCIEROS POR VALORACIÓN DE ACTIVOS FINANCIEROS.',NULL,0,2,1,NULL),(22012626,8776,'800','Pérdidas en activos financieros disponibles para la venta.',NULL,0,3,1,NULL),(22012627,8776,'8000','Pérdidas en activos financieros disponibles para la venta.',NULL,0,4,1,NULL),(22012628,8776,'802','Transferencia de beneficios en activos financieros disponibles para la venta.',NULL,0,3,1,NULL),(22012629,8776,'8020','Transferencia de beneficios en activos financieros disponibles para la venta.',NULL,0,4,1,NULL),(22012630,8776,'81','GASTOS EN OPERACIONES DE COBERTURA.',NULL,0,2,1,NULL),(22012631,8776,'810','Pérdidas por coberturas de flujos de efectivo.',NULL,0,3,1,NULL),(22012632,8776,'8100','Pérdidas por coberturas de flujos de efectivo.',NULL,0,4,1,NULL),(22012633,8776,'811','Pérdidas por coberturas de inversiones netas en un negocio en el extranjero.',NULL,0,3,1,NULL),(22012634,8776,'8110','Pérdidas por coberturas de inversiones netas en un negocio en el extranjero.',NULL,0,4,1,NULL),(22012635,8776,'812','Transferencia de beneficios por coberturas de flujos de efectivo.',NULL,0,3,1,NULL),(22012636,8776,'8120','Transferencia de beneficios por coberturas de flujos de efectivo.',NULL,0,4,1,NULL),(22012637,8776,'813','Transferencia de beneficios por coberturas de inversiones netas en un negocio en el extranjero.',NULL,0,3,1,NULL),(22012638,8776,'8130','Transferencia de beneficios por coberturas de inversiones netas en un negocio en el extranjero.',NULL,0,4,1,NULL),(22012639,8776,'82','GASTOS POR DIFERENCIAS EN CONVERSIÓN.',NULL,0,2,1,NULL),(22012640,8776,'820','Diferencias de conversión negativas.',NULL,0,3,1,NULL),(22012641,8776,'8200','Diferencias de conversión negativas.',NULL,0,4,1,NULL),(22012642,8776,'821','Transferencia de diferencias de conversión positivas.',NULL,0,3,1,NULL),(22012643,8776,'8210','Transferencia de diferencias de conversión positivas.',NULL,0,4,1,NULL),(22012644,8776,'83','IMPUESTOS SOBRE BENEFICIOS.',NULL,0,2,1,NULL),(22012645,8776,'830','Impuestos sobre beneficios.',NULL,0,3,1,NULL),(22012646,8776,'8300','Impuesto corriente.',NULL,0,4,1,NULL),(22012647,8776,'8301','Impuesto diferido.',NULL,0,4,1,NULL),(22012648,8776,'833','Ajustes negativos en la imposición sobre beneficios.',NULL,0,3,1,NULL),(22012649,8776,'8330','Ajustes negativos en la imposición sobre beneficios.',NULL,0,4,1,NULL),(22012650,8776,'834','Ingresos fiscales por diferencias permanentes.',NULL,0,3,1,NULL),(22012651,8776,'8340','Ingresos fiscales por diferencias permanentes.',NULL,0,4,1,NULL),(22012652,8776,'835','Ingresos fiscales por deducciones y bonificaciones.',NULL,0,3,1,NULL),(22012653,8776,'8350','Ingresos fiscales por deducciones y bonificaciones.',NULL,0,4,1,NULL),(22012654,8776,'836','Transferencia de diferencias permanentes.',NULL,0,3,1,NULL),(22012655,8776,'8360','Transferencia de diferencias permanentes.',NULL,0,4,1,NULL),(22012656,8776,'837','Transferencia de deducciones y bonificaciones.',NULL,0,3,1,NULL),(22012657,8776,'8370','Transferencia de deducciones y bonificaciones.',NULL,0,4,1,NULL),(22012658,8776,'838','Ajustes positivos en la imposición sobre beneficios.',NULL,0,3,1,NULL),(22012659,8776,'8380','Ajustes positivos en la imposición sobre beneficios.',NULL,0,4,1,NULL),(22012660,8776,'84','TRANSFERENCIAS DE SUBVENCIONES, DONACIONES Y LEGADOS.',NULL,0,2,1,NULL),(22012661,8776,'840','Transferencia de subvenciones oficiales de capital.',NULL,0,3,1,NULL),(22012662,8776,'8400','Transferencia de subvenciones oficiales de capital.',NULL,0,4,1,NULL),(22012663,8776,'841','Transferencia de donaciones y legados de capital.',NULL,0,3,1,NULL),(22012664,8776,'8410','Transferencia de donaciones y legados de capital.',NULL,0,4,1,NULL),(22012665,8776,'842','Transferencia de otras subvenciones, donaciones y legados.',NULL,0,3,1,NULL),(22012666,8776,'8420','Transferencia de otras subvenciones, donaciones y legados.',NULL,0,4,1,NULL),(22012667,8776,'85','GASTOS POR PÉRDIDAS ACTUARIALES Y AJUSTES EN LOS ACTIVOS POR RETRIBUCIONES A LARGO PLAZO DE PRESTACIÓN DEFINIDA.',NULL,0,2,1,NULL),(22012668,8776,'850','Pérdidas actuariales.',NULL,0,3,1,NULL),(22012669,8776,'8500','Pérdidas actuariales.',NULL,0,4,1,NULL),(22012670,8776,'851','Ajustes negativos en activos por retribuciones a largo plazo de prestación definida.',NULL,0,3,1,NULL),(22012671,8776,'8510','Ajustes negativos en activos por retribuciones a largo plazo de prestación definida.',NULL,0,4,1,NULL),(22012672,8776,'86','GASTOS POR ACTIVOS NO CORRIENTES EN VENTA.',NULL,0,2,1,NULL),(22012673,8776,'860','Pérdidas en activos no corrientes y grupos enajenables de elementos mantenidos para la venta.',NULL,0,3,1,NULL),(22012674,8776,'8600','Pérdidas en activos no corrientes y grupos enajenables de elementos mantenidos para la venta.',NULL,0,4,1,NULL),(22012675,8776,'862','Transferencia de beneficios en activos no corrientes y grupos enajenables de elementos mantenidos para la venta.',NULL,0,3,1,NULL),(22012676,8776,'8620','Transferencia de beneficios en activos no corrientes y grupos enajenables de elementos mantenidos para la venta.',NULL,0,4,1,NULL),(22012677,8776,'89','GASTOS DE PARTICIPACIONES EN EMPRESAS DEL GRUPO O ASOCIADAS CON AJUSTES VALORATIVOS POSITIVOS PREVIOS.',NULL,0,2,1,NULL),(22012678,8776,'891','Deterioro de participaciones en el patrimonio y valores representativos de deuda de empresas del grupo.',NULL,0,3,1,NULL),(22012679,8776,'8910','Deterioro de participaciones en el patrimonio y valores representativos de deuda de empresas del grupo.',NULL,0,4,1,NULL),(22012680,8776,'892','Deterioro de participaciones en el patrimonio y valores representativos de deuda de empresas asociadas.',NULL,0,3,1,NULL),(22012681,8776,'8920','Deterioro de participaciones en el patrimonio y valores representativos de deuda de empresas asociadas.',NULL,0,4,1,NULL),(22012682,8776,'9','INGRESOS IMPUTADOS AL PATRIMONIO NETO',NULL,0,1,1,NULL),(22012683,8776,'90','INGRESOS FINANCIEROS POR VALORACIÓN DE ACTIVOS FINANCIEROS.',NULL,0,2,1,NULL),(22012684,8776,'900','Beneficios en activos financieros disponibles para la venta.',NULL,0,3,1,NULL),(22012685,8776,'9000','Beneficios en activos financieros disponibles para la venta.',NULL,0,4,1,NULL),(22012686,8776,'902','Transferencia de pérdidas de activos financieros disponibles para la venta.',NULL,0,3,1,NULL),(22012687,8776,'9020','Transferencia de pérdidas de activos financieros disponibles para la venta.',NULL,0,4,1,NULL),(22012688,8776,'91','INGRESOS EN OPERACIONES DE COBERTURA.',NULL,0,2,1,NULL),(22012689,8776,'910','Beneficios por coberturas de flujos de efectivo.',NULL,0,3,1,NULL),(22012690,8776,'9100','Beneficios por coberturas de flujos de efectivo.',NULL,0,4,1,NULL),(22012691,8776,'911','Beneficios por coberturas de una inversión neta en un negocio en el extranjero.',NULL,0,3,1,NULL),(22012692,8776,'9110','Beneficios por coberturas de una inversión neta en un negocio en el extranjero.',NULL,0,4,1,NULL),(22012693,8776,'912','Transferencia de pérdidas por coberturas de flujos de efectivo.',NULL,0,3,1,NULL),(22012694,8776,'9120','Transferencia de pérdidas por coberturas de flujos de efectivo.',NULL,0,4,1,NULL),(22012695,8776,'913','Transferencia de pérdidas por coberturas de una inversión neta en un negocio en el extranjero.',NULL,0,3,1,NULL),(22012696,8776,'9130','Transferencia de pérdidas por coberturas de una inversión neta en un negocio en el extranjero.',NULL,0,4,1,NULL),(22012697,8776,'92','INGRESOS POR DIFERENCIAS DE CONVERSIÓN.',NULL,0,2,1,NULL),(22012698,8776,'920','Diferencias de conversión positivas.',NULL,0,3,1,NULL),(22012699,8776,'9200','Diferencias de conversión positivas.',NULL,0,4,1,NULL),(22012700,8776,'921','Transferencia de diferencias de conversión negativas.',NULL,0,3,1,NULL),(22012701,8776,'9210','Transferencia de diferencias de conversión negativas.',NULL,0,4,1,NULL),(22012702,8776,'94','INGRESOS POR SUBVENCIONES, DONACIONES Y LEGADOS.',NULL,0,2,1,NULL),(22012703,8776,'940','Ingresos de subvenciones oficiales de capital.',NULL,0,3,1,NULL),(22012704,8776,'9400','Ingresos de subvenciones oficiales de capital.',NULL,0,4,1,NULL),(22012705,8776,'941','Ingresos de donaciones y legados de capital.',NULL,0,3,1,NULL),(22012706,8776,'9410','Ingresos de donaciones y legados de capital.',NULL,0,4,1,NULL),(22012707,8776,'942','Ingresos de otras subvenciones, donaciones y legados.',NULL,0,3,1,NULL),(22012708,8776,'9420','Ingresos de otras subvenciones, donaciones y legados.',NULL,0,4,1,NULL),(22012709,8776,'95','INGRESOS POR GANANCIAS ACTUARIALES Y AJUSTES EN LOS ACTIVOS POR RETRIBUCIONES A LARGO PLAZO DE PRESTACIÓN DEFINIDA.',NULL,0,2,1,NULL),(22012710,8776,'950','Ganancias actuariales.',NULL,0,3,1,NULL),(22012711,8776,'9500','Ganancias actuariales.',NULL,0,4,1,NULL),(22012712,8776,'951','Ajustes positivos en activos por retribuciones a largo plazo de prestación definida.',NULL,0,3,1,NULL),(22012713,8776,'9510','Ajustes positivos en activos por retribuciones a largo plazo de prestación definida.',NULL,0,4,1,NULL),(22012714,8776,'96','INGRESOS POR ACTIVOS NO CORRIENTES EN VENTA.',NULL,0,2,1,NULL),(22012715,8776,'960','Beneficios en activos no corrientes y grupos enajenables de elementos mantenidos para la venta.',NULL,0,3,1,NULL),(22012716,8776,'9600','Beneficios en activos no corrientes y grupos enajenables de elementos mantenidos para la venta.',NULL,0,4,1,NULL),(22012717,8776,'962','Transferencia de pérdidas en activos no corrientes y grupos enajenables de elementos mantenidos para la venta.',NULL,0,3,1,NULL),(22012718,8776,'9620','Transferencia de pérdidas en activos no corrientes y grupos enajenables de elementos mantenidos para la venta.',NULL,0,4,1,NULL),(22012719,8776,'99','INGRESOS DE PARTICIPACIONES EN EL PATRIMONIO DE EMPRESAS DEL GRUPO O ASOCIADAS CON AJUSTES VALORATIVOS NEGATIVOS PREVIOS.',NULL,0,2,1,NULL),(22012720,8776,'991','Recuperación de ajustes valorativos negativos previos, empresas del grupo.',NULL,0,3,1,NULL),(22012721,8776,'9910','Recuperación de ajustes valorativos negativos previos, empresas del grupo.',NULL,0,4,1,NULL),(22012722,8776,'992','Recuperación de ajustes valorativos negativos previos, empresas asociadas.',NULL,0,3,1,NULL),(22012723,8776,'9920','Recuperación de ajustes valorativos negativos previos, empresas asociadas.',NULL,0,4,1,NULL),(22012724,8776,'993','Transferencia por deterioro de ajustes valorativos negativos previos, empresas del grupo.',NULL,0,3,1,NULL),(22012725,8776,'9930','Transferencia por deterioro de ajustes valorativos negativos previos, empresas del grupo.',NULL,0,4,1,NULL),(22012726,8776,'994','Transferencia por deterioro de ajustes valorativos negativos previos, empresas asociadas.',NULL,0,3,1,NULL),(22012727,8776,'9940','Transferencia por deterioro de ajustes valorativos negativos previos, empresas asociadas.',NULL,0,4,1,NULL),(22012728,8779,'1','FINANCIACIÓN BÁSICA',NULL,0,1,1,NULL),(22012729,8779,'10','CAPITAL.',NULL,0,2,1,NULL),(22012730,8779,'100','Capital social.',NULL,0,3,1,NULL),(22012731,8779,'1000','Capital social.',NULL,0,4,1,NULL),(22012732,8779,'101','Fondo social.',NULL,0,3,1,NULL),(22012733,8779,'1010','Fondo social.',NULL,0,4,1,NULL),(22012734,8779,'102','Capital.',NULL,0,3,1,NULL),(22012735,8779,'1020','Capital.',NULL,0,4,1,NULL),(22012736,8779,'103','Socios por desembolsos no exigidos..',NULL,0,3,1,NULL),(22012737,8779,'1030','Socios por desembolsos no exigidos, capital social.',NULL,0,4,1,NULL),(22012738,8779,'1034','Socios por desembolsos no exigidos, capital pendiente de inscripción.',NULL,0,4,1,NULL),(22012739,8779,'104','Socios por aportaciones no dinerarias pendientes..',NULL,0,3,1,NULL),(22012740,8779,'1040','Socios por aportaciones no dinerarias pendientes, capital social.',NULL,0,4,1,NULL),(22012741,8779,'1044','Socios por aportaciones no dinerarias pendientes, capital pendiente de inscripción.',NULL,0,4,1,NULL),(22012742,8779,'108','Acciones o participaciones propias en situaciones especiales.',NULL,0,3,1,NULL),(22012743,8779,'1080','Acciones o participaciones propias en situaciones especiales.',NULL,0,4,1,NULL),(22012744,8779,'109','Acciones o participaciones propias para reducción de capital.',NULL,0,3,1,NULL),(22012745,8779,'1090','Acciones o participaciones propias para reducción de capital.',NULL,0,4,1,NULL),(22012746,8779,'11','RESERVAS.',NULL,0,2,1,NULL),(22012747,8779,'110','Prima de emisión o asunción.',NULL,0,3,1,NULL),(22012748,8779,'1100','Prima de emisión o asunción.',NULL,0,4,1,NULL),(22012749,8779,'111','Patrimonio neto por emisión de instrumentos financieros compuestos.',NULL,0,3,1,NULL),(22012750,8779,'1110','Patrimonio neto por emisión de instrumentos financieros compuestos.',NULL,0,4,1,NULL),(22012751,8779,'1111','Resto de instrumentos de patrimonio neto.',NULL,0,4,1,NULL),(22012752,8779,'112','Reserva legal.',NULL,0,3,1,NULL),(22012753,8779,'1120','Reserva legal.',NULL,0,4,1,NULL),(22012754,8779,'113','Reservas voluntarias.',NULL,0,3,1,NULL),(22012755,8779,'1130','Reservas voluntarias.',NULL,0,4,1,NULL),(22012756,8779,'114','Reservas especiales.',NULL,0,3,1,NULL),(22012757,8779,'1140','Reservas para acciones o participaciones de la sociedad dominante.',NULL,0,4,1,NULL),(22012758,8779,'1141','Reservas estatutarias.',NULL,0,4,1,NULL),(22012759,8779,'1142','Reserva por capital amortizado.',NULL,0,4,1,NULL),(22012760,8779,'1143','Reserva por fondo de comercio.',NULL,0,4,1,NULL),(22012761,8779,'1144','Reservas por acciones propias aceptadas en garantía.',NULL,0,4,1,NULL),(22012762,8779,'115','Reservas por pérdidas y ganancias actuariales y otros ajustes.',NULL,0,3,1,NULL),(22012763,8779,'1150','Reservas por pérdidas y ganancias actuariales y otros ajustes.',NULL,0,4,1,NULL),(22012764,8779,'118','Aportaciones de socios o propietarios.',NULL,0,3,1,NULL),(22012765,8779,'1180','Aportaciones de socios o propietarios.',NULL,0,4,1,NULL),(22012766,8779,'119','Diferencias por ajuste del capital a euros.',NULL,0,3,1,NULL),(22012767,8779,'1190','Diferencias por ajuste del capital a euros.',NULL,0,4,1,NULL),(22012768,8779,'12','RESULTADOS PENDIENTES DE APLICACIÓN.',NULL,0,2,1,NULL),(22012769,8779,'120','Remanente.',NULL,0,3,1,NULL),(22012770,8779,'1200','Remanente.',NULL,0,4,1,NULL),(22012771,8779,'121','Resultados negativos de ejercicios anteriores.',NULL,0,3,1,NULL),(22012772,8779,'1210','Resultados negativos de ejercicios anteriores.',NULL,0,4,1,NULL),(22012773,8779,'129','Resultados del ejercicio.',NULL,0,3,1,NULL),(22012774,8779,'1290','Resultados del ejercicio.',NULL,0,4,1,NULL),(22012775,8779,'129000000','Resultados del ejercicio.',NULL,1,5,1,NULL),(22012776,8779,'13','SUBVENCIONES, DONACIONES Y AJUSTES POR CAMBIOS DE VALOR.',NULL,0,2,1,NULL),(22012777,8779,'130','Subvenciones oficiales de capital.',NULL,0,3,1,NULL),(22012778,8779,'1300','Subvenciones oficiales de capital.',NULL,0,4,1,NULL),(22012779,8779,'131','Donaciones y legados de capital.',NULL,0,3,1,NULL),(22012780,8779,'1310','Donaciones y legados de capital.',NULL,0,4,1,NULL),(22012781,8779,'132','Otras subvenciones, donaciones y legados.',NULL,0,3,1,NULL),(22012782,8779,'1320','Otras subvenciones, donaciones y legados.',NULL,0,4,1,NULL),(22012783,8779,'133','Ajustes por valoración en instrumentos financieros.',NULL,0,3,1,NULL),(22012784,8779,'1330','Ajustes por valoración en instrumentos financieros.',NULL,0,4,1,NULL),(22012785,8779,'134','Operaciones de cobertura.',NULL,0,3,1,NULL),(22012786,8779,'1340','Cobertura de flujos de efectivo.',NULL,0,4,1,NULL),(22012787,8779,'1341','Cobertura de una inversión neta en un negocio en el extranjero.',NULL,0,4,1,NULL),(22012788,8779,'135','Diferencias de conversión.',NULL,0,3,1,NULL),(22012789,8779,'1350','Diferencias de conversión.',NULL,0,4,1,NULL),(22012790,8779,'136','Ajustes por valoración en activos no corrientes y grupos enajenables de elementos mantenidos para la venta.',NULL,0,3,1,NULL),(22012791,8779,'1360','Ajustes por valoración en activos no corrientes y grupos enajenables de elementos mantenidos para la venta.',NULL,0,4,1,NULL),(22012792,8779,'137','Ingresos fiscales a distribuir en varios ejercicios.',NULL,0,3,1,NULL),(22012793,8779,'1370','Ingresos fiscales por diferencias permanentes a distribuir en varios ejercicios.',NULL,0,4,1,NULL),(22012794,8779,'1371','Ingresos fiscales por deducciones y bonificaciones a distribuir en varios ejercicios.',NULL,0,4,1,NULL),(22012795,8779,'14','PROVISIONES.',NULL,0,2,1,NULL),(22012796,8779,'140','Provisión para retribuciones y otras prestaciones al personal.',NULL,0,3,1,NULL),(22012797,8779,'1400','Provisión para retribuciones y otras prestaciones al personal.',NULL,0,4,1,NULL),(22012798,8779,'141','Provisión para impuestos.',NULL,0,3,1,NULL),(22012799,8779,'1410','Provisión para impuestos.',NULL,0,4,1,NULL),(22012800,8779,'142','Provisión para otras responsabilidades.',NULL,0,3,1,NULL),(22012801,8779,'1420','Provisión para otras responsabilidades.',NULL,0,4,1,NULL),(22012802,8779,'143','Provisión por desmantelamiento, retiro o rehabilitación del inmovilizado.',NULL,0,3,1,NULL),(22012803,8779,'1430','Provisión por desmantelamiento, retiro o rehabilitación del inmovilizado.',NULL,0,4,1,NULL),(22012804,8779,'145','Provisión para actuaciones medioambientales.',NULL,0,3,1,NULL),(22012805,8779,'1450','Provisión para actuaciones medioambientales.',NULL,0,4,1,NULL),(22012806,8779,'146','Provisión para reestructuraciones.',NULL,0,3,1,NULL),(22012807,8779,'1460','Provisión para reestructuraciones.',NULL,0,4,1,NULL),(22012808,8779,'147','Provisiones por transacciones con pagos basados en instrumentos de patrimonio.',NULL,0,3,1,NULL),(22012809,8779,'1470','Provisiones por transacciones con pagos basados en instrumentos de patrimonio.',NULL,0,4,1,NULL),(22012810,8779,'15','DEUDAS A LARGO PLAZO CON CARACTERÍSTICAS ESPECIALES.',NULL,0,2,1,NULL),(22012811,8779,'150','Acciones o participaciones a largo plazo contabilizadas como pasivo.',NULL,0,3,1,NULL),(22012812,8779,'1500','Acciones o participaciones a largo plazo contabilizadas como pasivo.',NULL,0,4,1,NULL),(22012813,8779,'153','Desembolsos no exigidos por acciones o participaciones contabilizadas como pasivo.',NULL,0,3,1,NULL),(22012814,8779,'1530','Desembolsos no exigidos por acciones o participaciones contabilizadas como pasivo.',NULL,0,4,1,NULL),(22012815,8779,'154','Aportaciones no dinerarias pendientes por acciones o participaciones contabilizadas como pasivo.',NULL,0,3,1,NULL),(22012816,8779,'1540','Aportaciones no dinerarias pendientes por acciones o participaciones contabilizadas como pasivo.',NULL,0,4,1,NULL),(22012817,8779,'16','DEUDAS A LARGO PLAZO CON PARTES VINCULADAS.',NULL,0,2,1,NULL),(22012818,8779,'160','Deudas a largo plazo con entidades de crédito vinculadas.',NULL,0,3,1,NULL),(22012819,8779,'1600','Deudas a largo plazo con entidades de crédito vinculadas.',NULL,0,4,1,NULL),(22012820,8779,'161','Proveedores de inmovilizado a largo plazo, partes vinculadas.',NULL,0,3,1,NULL),(22012821,8779,'1610','Proveedores de inmovilizado a largo plazo, partes vinculadas.',NULL,0,4,1,NULL),(22012822,8779,'162','Otras deudas a largo plazo con partes vinculadas.',NULL,0,3,1,NULL),(22012823,8779,'1620','Otras deudas a largo plazo con partes vinculadas.',NULL,0,4,1,NULL),(22012824,8779,'163','Otras deudas a largo plazo con partes vinculadas.',NULL,0,3,1,NULL),(22012825,8779,'1633','Otras deudas a largo plazo empresas del grupo.',NULL,0,4,1,NULL),(22012826,8779,'1634','Otras deudas a largo plazo empresas asociadas.',NULL,0,4,1,NULL),(22012827,8779,'1635','Otras deudas a largo plazo con otras partes vinculadas.',NULL,0,4,1,NULL),(22012828,8779,'17','DEUDAS A LARGO PLAZO POR PRÉSTAMOS RECIBIDOS Y OTROS CONCEPTOS.',NULL,0,2,1,NULL),(22012829,8779,'170','Deudas a largo plazo con entidades de crédito.',NULL,0,3,1,NULL),(22012830,8779,'1700','Deudas a largo plazo con entidades de crédito.',NULL,0,4,1,NULL),(22012831,8779,'171','Deudas a largo plazo.',NULL,0,3,1,NULL),(22012832,8779,'1710','Deudas a largo plazo.',NULL,0,4,1,NULL),(22012833,8779,'172','Deudas a largo plazo transformables en subvenciones, donaciones y legados.',NULL,0,3,1,NULL),(22012834,8779,'1720','Deudas a largo plazo transformables en subvenciones, donaciones y legados.',NULL,0,4,1,NULL),(22012835,8779,'173','Proveedores de inmovilizado a largo plazo.',NULL,0,3,1,NULL),(22012836,8779,'1730','Proveedores de inmovilizado a largo plazo.',NULL,0,4,1,NULL),(22012837,8779,'174','Acreedores de arrendamiento financiero a largo plazo.',NULL,0,3,1,NULL),(22012838,8779,'1740','Acreedores de arrendamiento financiero a largo plazo.',NULL,0,4,1,NULL),(22012839,8779,'175','Efectos a pagar a largo plazo.',NULL,0,3,1,NULL),(22012840,8779,'1750','Efectos a pagar a largo plazo.',NULL,0,4,1,NULL),(22012841,8779,'176','Pasivos por derivados financieros a largo plazo.',NULL,0,3,1,NULL),(22012842,8779,'1765','Pasivos por derivados financieros a largo plazo, cartera de negociación.',NULL,0,4,1,NULL),(22012843,8779,'1768','Pasivos por derivados financieros a largo plazo, instrumentos de cobertura.',NULL,0,4,1,NULL),(22012844,8779,'177','Obligaciones y bonos.',NULL,0,3,1,NULL),(22012845,8779,'1770','Obligaciones y bonos.',NULL,0,4,1,NULL),(22012846,8779,'178','Obligaciones y bonos convertibles.',NULL,0,3,1,NULL),(22012847,8779,'1780','Obligaciones y bonos convertibles.',NULL,0,4,1,NULL),(22012848,8779,'179','Deudas representadas en otros valores negociables.',NULL,0,3,1,NULL),(22012849,8779,'1790','Deudas representadas en otros valores negociables.',NULL,0,4,1,NULL),(22012850,8779,'18','PASIVOS POR FIANZAS Y GARANTÍAS Y OTROS CONCEPTOS A LARGO PLAZO.',NULL,0,2,1,NULL),(22012851,8779,'180','Fianzas recibidas a largo plazo.',NULL,0,3,1,NULL),(22012852,8779,'1800','Fianzas recibidas a largo plazo.',NULL,0,4,1,NULL),(22012853,8779,'181','Anticipos recibidos por ventas o prestaciones de servicios a largo plazo.',NULL,0,3,1,NULL),(22012854,8779,'1810','Anticipos recibidos por ventas o prestaciones de servicios a largo plazo.',NULL,0,4,1,NULL),(22012855,8779,'185','Depósitos recibidos a largo plazo.',NULL,0,3,1,NULL),(22012856,8779,'1850','Depósitos recibidos a largo plazo.',NULL,0,4,1,NULL),(22012857,8779,'189','Garantías financieras a largo plazo.',NULL,0,3,1,NULL),(22012858,8779,'1890','Garantías financieras a largo plazo.',NULL,0,4,1,NULL),(22012859,8779,'19','SITUACIONES TRANSITORIAS DE FINANCIACIÓN.',NULL,0,2,1,NULL),(22012860,8779,'190','Acciones o participaciones emitidas.',NULL,0,3,1,NULL),(22012861,8779,'1900','Acciones o participaciones emitidas.',NULL,0,4,1,NULL),(22012862,8779,'192','Suscriptores de acciones.',NULL,0,3,1,NULL),(22012863,8779,'1920','Suscriptores de acciones.',NULL,0,4,1,NULL),(22012864,8779,'194','Capital emitido pendiente de inscripción.',NULL,0,3,1,NULL),(22012865,8779,'1940','Capital emitido pendiente de inscripción.',NULL,0,4,1,NULL),(22012866,8779,'195','Acciones o participaciones emitidas consideradas como pasivos financieros.',NULL,0,3,1,NULL),(22012867,8779,'1950','Acciones o participaciones emitidas consideradas como pasivos financieros.',NULL,0,4,1,NULL),(22012868,8779,'197','Suscriptores de acciones consideradas como pasivos financieros.',NULL,0,3,1,NULL),(22012869,8779,'1970','Suscriptores de acciones consideradas como pasivos financieros.',NULL,0,4,1,NULL),(22012870,8779,'199','Acciones o participaciones emitidas consideradas como pasivos financieros pendientes de inscripción.',NULL,0,3,1,NULL),(22012871,8779,'1990','Acciones o participaciones emitidas consideradas como pasivos financieros pendientes de inscripción.',NULL,0,4,1,NULL),(22012872,8779,'2','ACTIVO NO CORRIENTE',NULL,0,1,1,NULL),(22012873,8779,'20','INMOVILIZACIONES INTANGIBLES.',NULL,0,2,1,NULL),(22012874,8779,'200','Gastos de investigación.',NULL,0,3,1,NULL),(22012875,8779,'2000','Gastos de investigación.',NULL,0,4,1,NULL),(22012876,8779,'201','Desarrollo.',NULL,0,3,1,NULL),(22012877,8779,'2010','Desarrollo.',NULL,0,4,1,NULL),(22012878,8779,'202','Concesiones administrativas.',NULL,0,3,1,NULL),(22012879,8779,'2020','Concesiones administrativas.',NULL,0,4,1,NULL),(22012880,8779,'203','Propiedad industrial.',NULL,0,3,1,NULL),(22012881,8779,'2030','Propiedad industrial.',NULL,0,4,1,NULL),(22012882,8779,'204','Fondo de comercio.',NULL,0,3,1,NULL),(22012883,8779,'2040','Fondo de comercio.',NULL,0,4,1,NULL),(22012884,8779,'205','Derechos de traspaso.',NULL,0,3,1,NULL),(22012885,8779,'2050','Derechos de traspaso.',NULL,0,4,1,NULL),(22012886,8779,'206','Aplicaciones informáticas.',NULL,0,3,1,NULL),(22012887,8779,'2060','Aplicaciones informáticas.',NULL,0,4,1,NULL),(22012888,8779,'209','Anticipos para inmovilizaciones intangibles.',NULL,0,3,1,NULL),(22012889,8779,'2090','Anticipos para inmovilizaciones intangibles.',NULL,0,4,1,NULL),(22012890,8779,'21','INMOVILIZACIONES MATERIALES.',NULL,0,2,1,NULL),(22012891,8779,'210','Terrenos y bienes naturales.',NULL,0,3,1,NULL),(22012892,8779,'2100','Terrenos y bienes naturales.',NULL,0,4,1,NULL),(22012893,8779,'211','Construcciones .',NULL,0,3,1,NULL),(22012894,8779,'2110','Construcciones .',NULL,0,4,1,NULL),(22012895,8779,'212','Instalaciones técnicas.',NULL,0,3,1,NULL),(22012896,8779,'2120','Instalaciones técnicas.',NULL,0,4,1,NULL),(22012897,8779,'213','Maquinaria.',NULL,0,3,1,NULL),(22012898,8779,'2130','Maquinaria.',NULL,0,4,1,NULL),(22012899,8779,'214','Utillaje.',NULL,0,3,1,NULL),(22012900,8779,'2140','Utillaje.',NULL,0,4,1,NULL),(22012901,8779,'215','Otras instalaciones.',NULL,0,3,1,NULL),(22012902,8779,'2150','Otras instalaciones.',NULL,0,4,1,NULL),(22012903,8779,'216','Mobiliario.',NULL,0,3,1,NULL),(22012904,8779,'2160','Mobiliario.',NULL,0,4,1,NULL),(22012905,8779,'217','Equipos para procesos de información.',NULL,0,3,1,NULL),(22012906,8779,'2170','Equipos para procesos de información.',NULL,0,4,1,NULL),(22012907,8779,'218','Elementos de transporte.',NULL,0,3,1,NULL),(22012908,8779,'2180','Elementos de transporte.',NULL,0,4,1,NULL),(22012909,8779,'219','Otro inmovilizado material.',NULL,0,3,1,NULL),(22012910,8779,'2190','Otro inmovilizado material.',NULL,0,4,1,NULL),(22012911,8779,'22','INVERSIONES INMOBILIARIAS.',NULL,0,2,1,NULL),(22012912,8779,'220','Inversiones en terrenos y bienes naturales.',NULL,0,3,1,NULL),(22012913,8779,'2200','Inversiones en terrenos y bienes naturales.',NULL,0,4,1,NULL),(22012914,8779,'221','Inversiones en construcciones.',NULL,0,3,1,NULL),(22012915,8779,'2210','Inversiones en construcciones.',NULL,0,4,1,NULL),(22012916,8779,'23','INMOVILIZACIONES MATERIALES EN CURSO.',NULL,0,2,1,NULL),(22012917,8779,'230','Adaptación de terrenos y bienes naturales.',NULL,0,3,1,NULL),(22012918,8779,'2300','Adaptación de terrenos y bienes naturales.',NULL,0,4,1,NULL),(22012919,8779,'231','Construcciones en curso.',NULL,0,3,1,NULL),(22012920,8779,'2310','Construcciones en curso.',NULL,0,4,1,NULL),(22012921,8779,'232','Instalaciones técnicas en montaje.',NULL,0,3,1,NULL),(22012922,8779,'2320','Instalaciones técnicas en montaje.',NULL,0,4,1,NULL),(22012923,8779,'233','Maquinaria en montaje.',NULL,0,3,1,NULL),(22012924,8779,'2330','Maquinaria en montaje.',NULL,0,4,1,NULL),(22012925,8779,'237','Equipos para procesos de información en montaje.',NULL,0,3,1,NULL),(22012926,8779,'2370','Equipos para procesos de información en montaje.',NULL,0,4,1,NULL),(22012927,8779,'239','Anticipos para inmovilizaciones materiales.',NULL,0,3,1,NULL),(22012928,8779,'2390','Anticipos para inmovilizaciones materiales.',NULL,0,4,1,NULL),(22012929,8779,'24','INVERSIONES FINANCIERAS A LARGO PLAZO EN PARTES VINCULADAS.',NULL,0,2,1,NULL),(22012930,8779,'240','Participaciones a largo plazo en partes vinculadas.',NULL,0,3,1,NULL),(22012931,8779,'2400','Participaciones a largo plazo en partes vinculadas.',NULL,0,4,1,NULL),(22012932,8779,'241','Valores representativos de deuda a largo plazo de partes vinculadas.',NULL,0,3,1,NULL),(22012933,8779,'2410','Valores representativos de deuda a largo plazo de partes vinculadas.',NULL,0,4,1,NULL),(22012934,8779,'242','Créditos a largo plazo a partes vinculadas.',NULL,0,3,1,NULL),(22012935,8779,'2420','Créditos a largo plazo a partes vinculadas.',NULL,0,4,1,NULL),(22012936,8779,'249','Desembolsos pendientes sobre participaciones a largo plazo en partes vinculadas.',NULL,0,3,1,NULL),(22012937,8779,'2490','Desembolsos pendientes sobre participaciones a largo plazo en partes vinculadas.',NULL,0,4,1,NULL),(22012938,8779,'25','OTRAS INVERSIONES FINANCIERAS A LARGO PLAZO.',NULL,0,2,1,NULL),(22012939,8779,'250','Inversiones financieras a largo plazo en instrumentos de patrimonio.',NULL,0,3,1,NULL),(22012940,8779,'2500','Inversiones financieras a largo plazo en instrumentos de patrimonio.',NULL,0,4,1,NULL),(22012941,8779,'251','Valores representativos de deuda a largo plazo.',NULL,0,3,1,NULL),(22012942,8779,'2510','Valores representativos de deuda a largo plazo.',NULL,0,4,1,NULL),(22012943,8779,'252','Créditos a largo plazo.',NULL,0,3,1,NULL),(22012944,8779,'2520','Créditos a largo plazo.',NULL,0,4,1,NULL),(22012945,8779,'253','Créditos a largo plazo por enajenación de inmovilizado.',NULL,0,3,1,NULL),(22012946,8779,'2530','Créditos a largo plazo por enajenación de inmovilizado.',NULL,0,4,1,NULL),(22012947,8779,'254','Créditos a largo plazo al personal.',NULL,0,3,1,NULL),(22012948,8779,'2540','Créditos a largo plazo al personal.',NULL,0,4,1,NULL),(22012949,8779,'255','Activos por derivados financieros a largo plazo.',NULL,0,3,1,NULL),(22012950,8779,'2550','Activos por derivados financieros a largo plazo.',NULL,0,4,1,NULL),(22012951,8779,'257','Activos por retribuciones a largo plazo de prestación definida.',NULL,0,3,1,NULL),(22012952,8779,'2570','Activos por retribuciones a largo plazo de prestación definida.',NULL,0,4,1,NULL),(22012953,8779,'258','Imposiciones a largo plazo.',NULL,0,3,1,NULL),(22012954,8779,'2580','Imposiciones a largo plazo.',NULL,0,4,1,NULL),(22012955,8779,'259','Desembolsos pendientes sobre participaciones en el patrimonio neto a largo plazo.',NULL,0,3,1,NULL),(22012956,8779,'2590','Desembolsos pendientes sobre participaciones en el patrimonio neto a largo plazo.',NULL,0,4,1,NULL),(22012957,8779,'26','FIANZAS Y DEPÓSITOS CONSTITUIDOS A LARGO PLAZO.',NULL,0,2,1,NULL),(22012958,8779,'260','Fianzas constituidas a largo plazo.',NULL,0,3,1,NULL),(22012959,8779,'2600','Fianzas constituidas a largo plazo.',NULL,0,4,1,NULL),(22012960,8779,'265','Depósitos constituidos a largo plazo.',NULL,0,3,1,NULL),(22012961,8779,'2650','Depósitos constituidos a largo plazo.',NULL,0,4,1,NULL),(22012962,8779,'28','AMORTIZACIÓN ACUMULADA DEL INMOVILIZADO.',NULL,0,2,1,NULL),(22012963,8779,'280','Amortización acumulada del inmovilizado intangible.',NULL,0,3,1,NULL),(22012964,8779,'2800','Amortización acumulada del inmovilizado intangible.',NULL,0,4,1,NULL),(22012965,8779,'2801','Amortización acumulada de investigación',NULL,0,4,1,NULL),(22012966,8779,'2802','Amortización acumulada de desarrollo',NULL,0,4,1,NULL),(22012967,8779,'2803','Amortización acumulada de concesiones administrativas',NULL,0,4,1,NULL),(22012968,8779,'2804','Amortización acumulada de propiedad industrial',NULL,0,4,1,NULL),(22012969,8779,'2805','Amortización acumulada de derechos de traspaso',NULL,0,4,1,NULL),(22012970,8779,'2806','Amortización acumulada de aplicaciones informáticas',NULL,0,4,1,NULL),(22012971,8779,'281','Amortización acumulada del inmovilizado material.',NULL,0,3,1,NULL),(22012972,8779,'2810','Amortización acumulada del inmovilizado material.',NULL,0,4,1,NULL),(22012973,8779,'2811','Amortización acumulada de construcciones',NULL,0,4,1,NULL),(22012974,8779,'2812','Amortización acumulada de instalaciones técnicas',NULL,0,4,1,NULL),(22012975,8779,'2813','Amortización acumulada de maquinaria',NULL,0,4,1,NULL),(22012976,8779,'2814','Amortización acumulada de utillaje',NULL,0,4,1,NULL),(22012977,8779,'2815','Amortización acumulada de otras instalaciones',NULL,0,4,1,NULL),(22012978,8779,'2816','Amortización acumulada de mobiliario',NULL,0,4,1,NULL),(22012979,8779,'2817','Amortización acumulada de equipos para el proceso de información',NULL,0,4,1,NULL),(22012980,8779,'2818','Amortización acumulada de elementos de transporte',NULL,0,4,1,NULL),(22012981,8779,'2819','Amortización acumulada de otro inmovilizado material',NULL,0,4,1,NULL),(22012982,8779,'282','Amortización acumulada de las inversiones inmobiliarias.',NULL,0,3,1,NULL),(22012983,8779,'2820','Amortización acumulada de las inversiones inmobiliarias.',NULL,0,4,1,NULL),(22012984,8779,'29','DETERIORO DE VALOR DE ACTIVOS NO CORRIENTES.',NULL,0,2,1,NULL),(22012985,8779,'290','Deterioro de valor del inmovilizado intangible.',NULL,0,3,1,NULL),(22012986,8779,'2900','Deterioro de valor del inmovilizado intangible.',NULL,0,4,1,NULL),(22012987,8779,'291','Deterioro de valor del inmovilizado material.',NULL,0,3,1,NULL),(22012988,8779,'2910','Deterioro de valor del inmovilizado material.',NULL,0,4,1,NULL),(22012989,8779,'292','Deterioro de valor de las inversiones inmobiliarias.',NULL,0,3,1,NULL),(22012990,8779,'2920','Deterioro de valor de las inversiones inmobiliarias.',NULL,0,4,1,NULL),(22012991,8779,'293','Deterioro de valor de participaciones a largo plazo en partes vinculadas.',NULL,0,3,1,NULL),(22012992,8779,'2930','Deterioro de valor de participaciones a largo plazo en partes vinculadas.',NULL,0,4,1,NULL),(22012993,8779,'294','Deterioro de valor de valores representativos de deuda a largo plazo de partes vinculadas.',NULL,0,3,1,NULL),(22012994,8779,'2940','Deterioro de valor de valores representativos de deuda a largo plazo de partes vinculadas.',NULL,0,4,1,NULL),(22012995,8779,'295','Deterioro de valor de créditos a largo plazo a partes vinculadas.',NULL,0,3,1,NULL),(22012996,8779,'2950','Deterioro de valor de créditos a largo plazo a partes vinculadas.',NULL,0,4,1,NULL),(22012997,8779,'297','Deterioro de valor de valores representativos de deuda a largo plazo.',NULL,0,3,1,NULL),(22012998,8779,'2970','Deterioro de valor de valores representativos de deuda a largo plazo.',NULL,0,4,1,NULL),(22012999,8779,'298','Deterioro de valor de créditos a largo plazo.',NULL,0,3,1,NULL),(22013000,8779,'2980','Deterioro de valor de créditos a largo plazo.',NULL,0,4,1,NULL),(22013001,8779,'3','EXISTENCIAS',NULL,0,1,1,NULL),(22013002,8779,'30','COMERCIALES.',NULL,0,2,1,NULL),(22013003,8779,'300','Mercaderías A.',NULL,0,3,1,NULL),(22013004,8779,'3000','Mercaderías A.',NULL,0,4,1,NULL),(22013005,8779,'301','Mercaderías B.',NULL,0,3,1,NULL),(22013006,8779,'3010','Mercaderías B.',NULL,0,4,1,NULL),(22013007,8779,'31','MATERIAS PRIMAS.',NULL,0,2,1,NULL),(22013008,8779,'310','Materias primas A.',NULL,0,3,1,NULL),(22013009,8779,'3100','Materias primas A.',NULL,0,4,1,NULL),(22013010,8779,'311','Materias primas B.',NULL,0,3,1,NULL),(22013011,8779,'3110','Materias primas B.',NULL,0,4,1,NULL),(22013012,8779,'32','OTROS APROVISIONAMIENTOS.',NULL,0,2,1,NULL),(22013013,8779,'320','Elementos conjuntos incorporables.',NULL,0,3,1,NULL),(22013014,8779,'3200','Elementos conjuntos incorporables.',NULL,0,4,1,NULL),(22013015,8779,'321','Combustibles.',NULL,0,3,1,NULL),(22013016,8779,'3210','Combustibles.',NULL,0,4,1,NULL),(22013017,8779,'322','Repuestos.',NULL,0,3,1,NULL),(22013018,8779,'3220','Repuestos.',NULL,0,4,1,NULL),(22013019,8779,'325','Materiales diversos.',NULL,0,3,1,NULL),(22013020,8779,'3250','Materiales diversos.',NULL,0,4,1,NULL),(22013021,8779,'326','Embalajes.',NULL,0,3,1,NULL),(22013022,8779,'3260','Embalajes.',NULL,0,4,1,NULL),(22013023,8779,'327','Envases.',NULL,0,3,1,NULL),(22013024,8779,'3270','Envases.',NULL,0,4,1,NULL),(22013025,8779,'328','Material de oficina.',NULL,0,3,1,NULL),(22013026,8779,'3280','Material de oficina.',NULL,0,4,1,NULL),(22013027,8779,'33','PRODUCTOS EN CURSO.',NULL,0,2,1,NULL),(22013028,8779,'330','Productos en curso A.',NULL,0,3,1,NULL),(22013029,8779,'3300','Productos en curso A.',NULL,0,4,1,NULL),(22013030,8779,'331','Productos en curso B.',NULL,0,3,1,NULL),(22013031,8779,'3310','Productos en curso B.',NULL,0,4,1,NULL),(22013032,8779,'34','PRODUCTOS SEMITERMINADOS.',NULL,0,2,1,NULL),(22013033,8779,'340','Productos semiterminados A.',NULL,0,3,1,NULL),(22013034,8779,'3400','Productos semiterminados A.',NULL,0,4,1,NULL),(22013035,8779,'341','Productos semiterminados B.',NULL,0,3,1,NULL),(22013036,8779,'3410','Productos semiterminados B.',NULL,0,4,1,NULL),(22013037,8779,'35','PRODUCTOS TERMINADOS.',NULL,0,2,1,NULL),(22013038,8779,'350','Productos terminados A.',NULL,0,3,1,NULL),(22013039,8779,'3500','Productos terminados A.',NULL,0,4,1,NULL),(22013040,8779,'351','Productos terminados B.',NULL,0,3,1,NULL),(22013041,8779,'3510','Productos terminados B.',NULL,0,4,1,NULL),(22013042,8779,'36','SUBPRODUCTOS, RESIDUOS Y MATERIALES RECUPERADOS.',NULL,0,2,1,NULL),(22013043,8779,'360','Subproductos A.',NULL,0,3,1,NULL),(22013044,8779,'3600','Subproductos A.',NULL,0,4,1,NULL),(22013045,8779,'361','Subproductos B.',NULL,0,3,1,NULL),(22013046,8779,'3610','Subproductos B.',NULL,0,4,1,NULL),(22013047,8779,'365','Residuos A.',NULL,0,3,1,NULL),(22013048,8779,'3650','Residuos A.',NULL,0,4,1,NULL),(22013049,8779,'366','Residuos B.',NULL,0,3,1,NULL),(22013050,8779,'3660','Residuos B.',NULL,0,4,1,NULL),(22013051,8779,'368','Materiales recuperados A.',NULL,0,3,1,NULL),(22013052,8779,'3680','Materiales recuperados A.',NULL,0,4,1,NULL),(22013053,8779,'369','Materiales recuperados B.',NULL,0,3,1,NULL),(22013054,8779,'3690','Materiales recuperados B.',NULL,0,4,1,NULL),(22013055,8779,'39','DETERIORO DE VALOR DE LAS EXISTENCIAS.',NULL,0,2,1,NULL),(22013056,8779,'390','Deterioro de valor de las mercaderías.',NULL,0,3,1,NULL),(22013057,8779,'3900','Deterioro de valor de las mercaderías.',NULL,0,4,1,NULL),(22013058,8779,'391','Deterioro de valor de las materias primas.',NULL,0,3,1,NULL),(22013059,8779,'3910','Deterioro de valor de las materias primas.',NULL,0,4,1,NULL),(22013060,8779,'392','Deterioro de valor de otros aprovisionamientos.',NULL,0,3,1,NULL),(22013061,8779,'3920','Deterioro de valor de otros aprovisionamientos.',NULL,0,4,1,NULL),(22013062,8779,'393','Deterioro de valor de los productos en curso.',NULL,0,3,1,NULL),(22013063,8779,'3930','Deterioro de valor de los productos en curso.',NULL,0,4,1,NULL),(22013064,8779,'394','Deterioro de valor de los productos semiterminados.',NULL,0,3,1,NULL),(22013065,8779,'3940','Deterioro de valor de los productos semiterminados.',NULL,0,4,1,NULL),(22013066,8779,'395','Deterioro de valor de los productos terminados.',NULL,0,3,1,NULL),(22013067,8779,'3950','Deterioro de valor de los productos terminados.',NULL,0,4,1,NULL),(22013068,8779,'396','Deterioro de valor de los subproductos, residuos y materiales recuperados.',NULL,0,3,1,NULL),(22013069,8779,'3960','Deterioro de valor de los subproductos, residuos y materiales recuperados.',NULL,0,4,1,NULL),(22013070,8779,'4','ACREEDORES Y DEUDORES POR OPERACIONES COMERCIALES',NULL,0,1,1,NULL),(22013071,8779,'40','PROVEEDORES.',NULL,0,2,1,NULL),(22013072,8779,'400','Proveedores.',NULL,0,3,1,NULL),(22013073,8779,'4000','Proveedores.',NULL,0,4,1,NULL),(22013074,8779,'401','Proveedores, efectos comerciales a pagar.',NULL,0,3,1,NULL),(22013075,8779,'4010','Proveedores, efectos comerciales a pagar.',NULL,0,4,1,NULL),(22013076,8779,'403','Proveedores, empresas del grupo.',NULL,0,3,1,NULL),(22013077,8779,'4030','Proveedores, empresas del grupo.',NULL,0,4,1,NULL),(22013078,8779,'404','Proveedores, empresas asociadas.',NULL,0,3,1,NULL),(22013079,8779,'4040','Proveedores, empresas asociadas.',NULL,0,4,1,NULL),(22013080,8779,'405','Proveedores, otras partes vinculadas.',NULL,0,3,1,NULL),(22013081,8779,'4050','Proveedores, otras partes vinculadas.',NULL,0,4,1,NULL),(22013082,8779,'406','Envases y embalajes a devolver a proveedores.',NULL,0,3,1,NULL),(22013083,8779,'4060','Envases y embalajes a devolver a proveedores.',NULL,0,4,1,NULL),(22013084,8779,'407','Anticipos a proveedores.',NULL,0,3,1,NULL),(22013085,8779,'4070','Anticipos a proveedores.',NULL,0,4,1,NULL),(22013086,8779,'41','ACREEDORES VARIOS.',NULL,0,2,1,NULL),(22013087,8779,'410','Acreedores por prestaciones de servicios.',NULL,0,3,1,NULL),(22013088,8779,'4100','Acreedores por prestaciones de servicios.',NULL,0,4,1,NULL),(22013089,8779,'411','Acreedores, efectos comerciales a pagar.',NULL,0,3,1,NULL),(22013090,8779,'4110','Acreedores, efectos comerciales a pagar.',NULL,0,4,1,NULL),(22013091,8779,'419','Acreedores por operaciones en común.',NULL,0,3,1,NULL),(22013092,8779,'4190','Acreedores por operaciones en común.',NULL,0,4,1,NULL),(22013093,8779,'43','CLIENTES.',NULL,0,2,1,NULL),(22013094,8779,'430','Clientes.',NULL,0,3,1,NULL),(22013095,8779,'4300','Clientes.',NULL,0,4,1,NULL),(22013096,8779,'431','Clientes, efectos comerciales a cobrar.',NULL,0,3,1,NULL),(22013097,8779,'4310','Clientes, efectos comerciales a cobrar.',NULL,0,4,1,NULL),(22013098,8779,'432','Clientes operaciones de factoring.',NULL,0,3,1,NULL),(22013099,8779,'4320','Clientes operaciones de factoring.',NULL,0,4,1,NULL),(22013100,8779,'433','Clientes, empresas del grupo.',NULL,0,3,1,NULL),(22013101,8779,'4330','Clientes, empresas del grupo.',NULL,0,4,1,NULL),(22013102,8779,'434','Clientes, empresas asociadas.',NULL,0,3,1,NULL),(22013103,8779,'4340','Clientes, empresas asociadas.',NULL,0,4,1,NULL),(22013104,8779,'435','Clientes, otras partes vinculadas.',NULL,0,3,1,NULL),(22013105,8779,'4350','Clientes, otras partes vinculadas.',NULL,0,4,1,NULL),(22013106,8779,'436','Clientes de dudoso cobro.',NULL,0,3,1,NULL),(22013107,8779,'4360','Clientes de dudoso cobro.',NULL,0,4,1,NULL),(22013108,8779,'437','Envases y embalajes a devolver por clientes.',NULL,0,3,1,NULL),(22013109,8779,'4370','Envases y embalajes a devolver por clientes.',NULL,0,4,1,NULL),(22013110,8779,'438','Anticipos de clientes.',NULL,0,3,1,NULL),(22013111,8779,'4380','Anticipos de clientes.',NULL,0,4,1,NULL),(22013112,8779,'44','DEUDORES VARIOS.',NULL,0,2,1,NULL),(22013113,8779,'440','Deudores.',NULL,0,3,1,NULL),(22013114,8779,'4400','Deudores.',NULL,0,4,1,NULL),(22013115,8779,'441','Deudores, efectos comerciales a cobrar.',NULL,0,3,1,NULL),(22013116,8779,'4410','Deudores, efectos comerciales a cobrar.',NULL,0,4,1,NULL),(22013117,8779,'446','Deudores de dudoso cobro.',NULL,0,3,1,NULL),(22013118,8779,'4460','Deudores de dudoso cobro.',NULL,0,4,1,NULL),(22013119,8779,'449','Deudores por operaciones en común.',NULL,0,3,1,NULL),(22013120,8779,'4490','Deudores por operaciones en común.',NULL,0,4,1,NULL),(22013121,8779,'46','PERSONAL.',NULL,0,2,1,NULL),(22013122,8779,'460','Anticipos de remuneraciones.',NULL,0,3,1,NULL),(22013123,8779,'4600','Anticipos de remuneraciones.',NULL,0,4,1,NULL),(22013124,8779,'465','Remuneraciones pendientes de pago.',NULL,0,3,1,NULL),(22013125,8779,'4650','Remuneraciones pendientes de pago.',NULL,0,4,1,NULL),(22013126,8779,'465000000','Remuneraciones pendientes de pago.',NULL,1,5,1,NULL),(22013127,8779,'466','Remuneraciones mediante sistemas de aportación definida pendientes de pago.',NULL,0,3,1,NULL),(22013128,8779,'4660','Remuneraciones mediante sistemas de aportación definida pendientes de pago.',NULL,0,4,1,NULL),(22013129,8779,'47','ADMINISTRACIONES PÚBLICAS.',NULL,0,2,1,NULL),(22013130,8779,'470','Hacienda Pública deudora por diversos conceptos.',NULL,0,3,1,NULL),(22013131,8779,'4700','Hacienda Pública, deudora por IVA.',NULL,0,4,1,NULL),(22013132,8779,'4708','Hacienda Pública, deudora por subvenciones concedidas.',NULL,0,4,1,NULL),(22013133,8779,'4709','Hacienda Pública, deudora por devolución de impuestos.',NULL,0,4,1,NULL),(22013134,8779,'471','Organismos de la Seguridad Social, deudores.',NULL,0,3,1,NULL),(22013135,8779,'4710','Organismos de la Seguridad Social, deudores.',NULL,0,4,1,NULL),(22013136,8779,'472','Hacienda Pública, IVA soportado.',NULL,0,3,1,NULL),(22013137,8779,'4720','Hacienda Pública, IVA soportado.',NULL,0,4,1,NULL),(22013138,8779,'472000000','Hacienda Pública, IVA soportado.',NULL,1,5,1,NULL),(22013139,8779,'473','Hacienda Pública, retenciones y pagos a cuenta.',NULL,0,3,1,NULL),(22013140,8779,'4730','Hacienda Pública, retenciones y pagos a cuenta.',NULL,0,4,1,NULL),(22013141,8779,'473000000','Hacienda Pública, retenciones y pagos a cuenta.',NULL,1,5,1,NULL),(22013142,8779,'474','Activos por impuesto diferido.',NULL,0,3,1,NULL),(22013143,8779,'4740','Activos por diferencias temporarias deducibles.',NULL,0,4,1,NULL),(22013144,8779,'4742','Derechos por deducciones y bonificaciones pendientes de aplicar.',NULL,0,4,1,NULL),(22013145,8779,'4745','Crédito por pérdidas a compensar del ejercicio.',NULL,0,4,1,NULL),(22013146,8779,'475','Hacienda Pública acreedora por conceptos fiscales.',NULL,0,3,1,NULL),(22013147,8779,'4750','Hacienda Pública, acreedora por IVA.',NULL,0,4,1,NULL),(22013148,8779,'4751','Hacienda Pública, acreedora por retenciones practicadas.',NULL,0,4,1,NULL),(22013149,8779,'475100000','Hacienda Pública, acreedora por retenciones practicadas.',NULL,1,5,1,NULL),(22013150,8779,'4752','Hacienda Pública, acreedora por impuesto sobre sociedades.',NULL,0,4,1,NULL),(22013151,8779,'4758','Hacienda Pública, acreedora por subvenciones a reintegrar.',NULL,0,4,1,NULL),(22013152,8779,'476','Organismos de la Seguridad Social, acreedores.',NULL,0,3,1,NULL),(22013153,8779,'4760','Organismos de la Seguridad Social, acreedores.',NULL,0,4,1,NULL),(22013154,8779,'476000000','Organismos de la Seguridad Social, acreedores.',NULL,1,5,1,NULL),(22013155,8779,'477','Hacienda Pública, IVA repercutido.',NULL,0,3,1,NULL),(22013156,8779,'4770','Hacienda Pública, IVA repercutido.',NULL,0,4,1,NULL),(22013157,8779,'477000000','Hacienda Pública, IVA repercutido.',NULL,1,5,1,NULL),(22013158,8779,'479','Pasivos por diferencias temporarias imponibles.',NULL,0,3,1,NULL),(22013159,8779,'4790','Pasivos por diferencias temporarias imponibles.',NULL,0,4,1,NULL),(22013160,8779,'48','AJUSTES POR PERIODIFICACIÓN.',NULL,0,2,1,NULL),(22013161,8779,'480','Gastos anticipados.',NULL,0,3,1,NULL),(22013162,8779,'4800','Gastos anticipados.',NULL,0,4,1,NULL),(22013163,8779,'485','Ingresos anticipados.',NULL,0,3,1,NULL),(22013164,8779,'4850','Ingresos anticipados.',NULL,0,4,1,NULL),(22013165,8779,'49','DETERIORO DE VALOR DE CRÉDITOS COMERCIALES Y PROVISIONES A CORTO PLAZO.',NULL,0,2,1,NULL),(22013166,8779,'490','Deterioro de valor de créditos por operaciones comerciales.',NULL,0,3,1,NULL),(22013167,8779,'4900','Deterioro de valor de créditos por operaciones comerciales.',NULL,0,4,1,NULL),(22013168,8779,'493','Deterioro de valor de créditos por operaciones comerciales con partes vinculadas.',NULL,0,3,1,NULL),(22013169,8779,'4930','Deterioro de valor de créditos por operaciones comerciales con partes vinculadas.',NULL,0,4,1,NULL),(22013170,8779,'499','Provisiones por operaciones comerciales.',NULL,0,3,1,NULL),(22013171,8779,'4994','Provisión para contratos onerosos.',NULL,0,4,1,NULL),(22013172,8779,'4999','Provisión para otras operaciones comerciales.',NULL,0,4,1,NULL),(22013173,8779,'5','CUENTAS FINANCIERAS',NULL,0,1,1,NULL),(22013174,8779,'50','EMPRÉSTITOS, DEUDAS CON CARACTERÍSTICAS ESPECIALES Y OTRAS EMISIONES ANÁLOGAS A CORTO PLAZO.',NULL,0,2,1,NULL),(22013175,8779,'500','Obligaciones y bonos a corto plazo.',NULL,0,3,1,NULL),(22013176,8779,'5000','Obligaciones y bonos a corto plazo.',NULL,0,4,1,NULL),(22013177,8779,'501','Obligaciones y bonos convertibles a corto plazo.',NULL,0,3,1,NULL),(22013178,8779,'5010','Obligaciones y bonos convertibles a corto plazo.',NULL,0,4,1,NULL),(22013179,8779,'502','Acciones o participaciones a corto plazo contabilizadas como pasivo.',NULL,0,3,1,NULL),(22013180,8779,'5020','Acciones o participaciones a corto plazo contabilizadas como pasivo.',NULL,0,4,1,NULL),(22013181,8779,'505','Deudas representadas en otros valores negociables a corto plazo.',NULL,0,3,1,NULL),(22013182,8779,'5050','Deudas representadas en otros valores negociables a corto plazo.',NULL,0,4,1,NULL),(22013183,8779,'506','Intereses de empréstitos y otras emisiones análogas.',NULL,0,3,1,NULL),(22013184,8779,'5060','Intereses de empréstitos y otras emisiones análogas.',NULL,0,4,1,NULL),(22013185,8779,'507','Dividendos de emisiones contabilizadas como pasivo.',NULL,0,3,1,NULL),(22013186,8779,'5070','Dividendos de emisiones contabilizadas como pasivo.',NULL,0,4,1,NULL),(22013187,8779,'509','Valores negociables amortizados.',NULL,0,3,1,NULL),(22013188,8779,'5090','Valores negociables amortizados.',NULL,0,4,1,NULL),(22013189,8779,'51','DEUDAS A CORTO PLAZO CON PARTES VINCULADAS.',NULL,0,2,1,NULL),(22013190,8779,'510','Deudas a corto plazo con entidades de crédito vinculadas.',NULL,0,3,1,NULL),(22013191,8779,'5100','Deudas a corto plazo con entidades de crédito vinculadas.',NULL,0,4,1,NULL),(22013192,8779,'511','Proveedores de inmovilizado a corto plazo, partes vinculadas.',NULL,0,3,1,NULL),(22013193,8779,'5110','Proveedores de inmovilizado a corto plazo, partes vinculadas.',NULL,0,4,1,NULL),(22013194,8779,'512','Acreedores por arrendamiento financiero a corto plazo, partes vinculadas.',NULL,0,3,1,NULL),(22013195,8779,'5120','Acreedores por arrendamiento financiero a corto plazo, partes vinculadas.',NULL,0,4,1,NULL),(22013196,8779,'513','Otras deudas a corto plazo con partes vinculadas.',NULL,0,3,1,NULL),(22013197,8779,'5130','Otras deudas a corto plazo con partes vinculadas.',NULL,0,4,1,NULL),(22013198,8779,'514','Intereses a corto plazo de deudas con partes vinculadas.',NULL,0,3,1,NULL),(22013199,8779,'5140','Intereses a corto plazo de deudas con partes vinculadas.',NULL,0,4,1,NULL),(22013200,8779,'52','DEUDAS A CORTO PLAZO POR PRÉSTAMOS RECIBIDOS Y OTROS CONCEPTOS.',NULL,0,2,1,NULL),(22013201,8779,'520','Deudas a corto plazo con entidades de crédito.',NULL,0,3,1,NULL),(22013202,8779,'5200','Préstamos a corto plazo de entidades de crédito.',NULL,0,4,1,NULL),(22013203,8779,'5201','Deudas a corto plazo por crédito dispuesto.',NULL,0,4,1,NULL),(22013204,8779,'5208','Deudas por efectos descontados.',NULL,0,4,1,NULL),(22013205,8779,'5209','Deudas por operaciones de factoring.',NULL,0,4,1,NULL),(22013206,8779,'521','Deudas a corto plazo.',NULL,0,3,1,NULL),(22013207,8779,'5210','Deudas a corto plazo.',NULL,0,4,1,NULL),(22013208,8779,'522','Deudas a corto plazo transformables en subvenciones, donaciones y legados.',NULL,0,3,1,NULL),(22013209,8779,'5220','Deudas a corto plazo transformables en subvenciones, donaciones y legados.',NULL,0,4,1,NULL),(22013210,8779,'523','Proveedores de inmovilizado a corto plazo.',NULL,0,3,1,NULL),(22013211,8779,'5230','Proveedores de inmovilizado a corto plazo.',NULL,0,4,1,NULL),(22013212,8779,'525','Efectos a pagar a corto plazo.',NULL,0,3,1,NULL),(22013213,8779,'5250','Efectos a pagar a corto plazo.',NULL,0,4,1,NULL),(22013214,8779,'526','Dividendo activo a pagar.',NULL,0,3,1,NULL),(22013215,8779,'5260','Dividendo activo a pagar.',NULL,0,4,1,NULL),(22013216,8779,'527','Intereses a corto plazo de deudas con entidades de crédito.',NULL,0,3,1,NULL),(22013217,8779,'5270','Intereses a corto plazo de deudas con entidades de crédito.',NULL,0,4,1,NULL),(22013218,8779,'528','Intereses a corto plazo de deudas.',NULL,0,3,1,NULL),(22013219,8779,'5280','Intereses a corto plazo de deudas.',NULL,0,4,1,NULL),(22013220,8779,'529','Provisiones a corto plazo.',NULL,0,3,1,NULL),(22013221,8779,'5290','Provisiones a corto plazo.',NULL,0,4,1,NULL),(22013222,8779,'53','INVERSIONES FINANCIERAS A CORTO PLAZO EN PARTES VINCULADAS.',NULL,0,2,1,NULL),(22013223,8779,'530','Participaciones a corto plazo en partes vinculadas.',NULL,0,3,1,NULL),(22013224,8779,'5303','Participaciones a corto plazo en empresas del grupo.',NULL,0,4,1,NULL),(22013225,8779,'5304','Participaciones a corto plazo en empresas del asociadas.',NULL,0,4,1,NULL),(22013226,8779,'5305','Participaciones a corto plazo, en otras partes vinculadas.',NULL,0,4,1,NULL),(22013227,8779,'531','Valores representativos de deuda a corto plazo de partes vinculadas.',NULL,0,3,1,NULL),(22013228,8779,'5310','Valores representativos de deuda a corto plazo de partes vinculadas.',NULL,0,4,1,NULL),(22013229,8779,'532','Créditos a corto plazo a partes vinculadas.',NULL,0,3,1,NULL),(22013230,8779,'5320','Créditos a corto plazo a partes vinculadas.',NULL,0,4,1,NULL),(22013231,8779,'533','Intereses a corto plazo de inversiones financieras en partes vinculadas.',NULL,0,3,1,NULL),(22013232,8779,'5330','Intereses a corto plazo de inversiones financieras en partes vinculadas.',NULL,0,4,1,NULL),(22013233,8779,'534','Intereses a corto plazo de créditos a partes vinculadas.',NULL,0,3,1,NULL),(22013234,8779,'5340','Intereses a corto plazo de créditos a partes vinculadas.',NULL,0,4,1,NULL),(22013235,8779,'535','Dividendo a cobrar de inversiones financieras en partes vinculadas.',NULL,0,3,1,NULL),(22013236,8779,'5350','Dividendo a cobrar de inversiones financieras en partes vinculadas.',NULL,0,4,1,NULL),(22013237,8779,'539','Desembolsos pendientes sobre participaciones a corto plazo de partes vinculadas.',NULL,0,3,1,NULL),(22013238,8779,'5390','Desembolsos pendientes sobre participaciones a corto plazo de partes vinculadas.',NULL,0,4,1,NULL),(22013239,8779,'54','OTRAS INVERSIONES FINANCIERAS A CORTO PLAZO.',NULL,0,2,1,NULL),(22013240,8779,'540','Inversiones financieras temporales en instrumentos de patrimonio.',NULL,0,3,1,NULL),(22013241,8779,'5400','Inversiones financieras temporales en instrumentos de patrimonio.',NULL,0,4,1,NULL),(22013242,8779,'541','Valores representativos de deuda a corto plazo.',NULL,0,3,1,NULL),(22013243,8779,'5410','Valores representativos de deuda a corto plazo.',NULL,0,4,1,NULL),(22013244,8779,'542','Créditos a corto plazo.',NULL,0,3,1,NULL),(22013245,8779,'5420','Créditos a corto plazo.',NULL,0,4,1,NULL),(22013246,8779,'543','Créditos a corto plazo por enajenación de inmovilizado.',NULL,0,3,1,NULL),(22013247,8779,'5430','Créditos a corto plazo por enajenación de inmovilizado.',NULL,0,4,1,NULL),(22013248,8779,'544','Créditos a corto plazo al personal.',NULL,0,3,1,NULL),(22013249,8779,'5440','Créditos a corto plazo al personal.',NULL,0,4,1,NULL),(22013250,8779,'545','Dividendo a cobrar.',NULL,0,3,1,NULL),(22013251,8779,'5450','Dividendo a cobrar.',NULL,0,4,1,NULL),(22013252,8779,'546','Intereses a corto plazo de valores representativos de deuda.',NULL,0,3,1,NULL),(22013253,8779,'5460','Intereses a corto plazo de valores representativos de deuda.',NULL,0,4,1,NULL),(22013254,8779,'547','Intereses a corto plazo de créditos.',NULL,0,3,1,NULL),(22013255,8779,'5470','Intereses a corto plazo de créditos.',NULL,0,4,1,NULL),(22013256,8779,'548','Imposiciones a corto plazo.',NULL,0,3,1,NULL),(22013257,8779,'5480','Imposiciones a corto plazo.',NULL,0,4,1,NULL),(22013258,8779,'549','Desembolsos pendientes sobre instrumentos de patrimonio a corto plazo.',NULL,0,3,1,NULL),(22013259,8779,'5490','Desembolsos pendientes sobre instrumentos de patrimonio a corto plazo.',NULL,0,4,1,NULL),(22013260,8779,'55','OTRAS CUENTAS NO BANCARIAS.',NULL,0,2,1,NULL),(22013261,8779,'550','Titular de la explotación.',NULL,0,3,1,NULL),(22013262,8779,'5500','Titular de la explotación.',NULL,0,4,1,NULL),(22013263,8779,'551','Cuenta corriente con socios administradores.',NULL,0,3,1,NULL),(22013264,8779,'5510','Cuenta corriente con socios administradores.',NULL,0,4,1,NULL),(22013265,8779,'552','Cuenta corriente con otras personas y entidades vinculadas.',NULL,0,3,1,NULL),(22013266,8779,'5520','Cuenta corriente con otras personas y entidades vinculadas.',NULL,0,4,1,NULL),(22013267,8779,'553','Cuentas corrientes en fusiones y escisiones.',NULL,0,3,1,NULL),(22013268,8779,'5530','Socios de sociedad disuelta.',NULL,0,4,1,NULL),(22013269,8779,'5531','Socios, cuenta de fusión.',NULL,0,4,1,NULL),(22013270,8779,'5532','Socios de sociedad escindida.',NULL,0,4,1,NULL),(22013271,8779,'5533','Socios, cuenta de escisión.',NULL,0,4,1,NULL),(22013272,8779,'554','Cuenta corriente con uniones temporales de empresas y comunidades de bienes.',NULL,0,3,1,NULL),(22013273,8779,'5540','Cuenta corriente con uniones temporales de empresas y comunidades de bienes.',NULL,0,4,1,NULL),(22013274,8779,'555','Partidas pendientes de aplicación.',NULL,0,3,1,NULL),(22013275,8779,'5550','Partidas pendientes de aplicación.',NULL,0,4,1,NULL),(22013276,8779,'5559','Suplidos y pagos a cuenta.',NULL,0,4,1,NULL),(22013277,8779,'555900000','Suplidos y pagos a cuenta.',NULL,1,5,1,NULL),(22013278,8779,'556','Desembolsos exigidos sobre participaciones en el patrimonio neto.',NULL,0,3,1,NULL),(22013279,8779,'5560','Desembolsos exigidos sobre participaciones en el patrimonio neto.',NULL,0,4,1,NULL),(22013280,8779,'557','Dividendo activo a cuenta.',NULL,0,3,1,NULL),(22013281,8779,'5570','Dividendo activo a cuenta.',NULL,0,4,1,NULL),(22013282,8779,'558','Socios por desembolsos exigidos.',NULL,0,3,1,NULL),(22013283,8779,'5580','Socios por desembolsos exigidos sobre acciones o participaciones ordinarias.',NULL,0,4,1,NULL),(22013284,8779,'5585','Socios por desembolsos exigidos sobre acciones o participaciones consideradas como pasivos financieros.',NULL,0,4,1,NULL),(22013285,8779,'559','Derivados financieros a corto plazo.',NULL,0,3,1,NULL),(22013286,8779,'5590','Activos por derivados financieros a corto plazo, cartera de negociación.',NULL,0,4,1,NULL),(22013287,8779,'5593','Activos de derivados financieros a corto plazo, instrumentos de cobertura.',NULL,0,4,1,NULL),(22013288,8779,'5595','Pasivos por derivados financieros a corto plazo, cartera de negociación.',NULL,0,4,1,NULL),(22013289,8779,'5598','Pasivos por derivados financieros a corto plazo, instrumentos de cobertura.',NULL,0,4,1,NULL),(22013290,8779,'56','FIANZAS Y DEPÓSITOS RECIBIDOS Y CONSTITUIDOS A CORTO PLAZO Y AJUSTES POR PERIODIFICACIÓN.',NULL,0,2,1,NULL),(22013291,8779,'560','Fianzas recibidas a corto plazo.',NULL,0,3,1,NULL),(22013292,8779,'5600','Fianzas recibidas a corto plazo.',NULL,0,4,1,NULL),(22013293,8779,'561','Depósitos recibidos a corto plazo.',NULL,0,3,1,NULL),(22013294,8779,'5610','Depósitos recibidos a corto plazo.',NULL,0,4,1,NULL),(22013295,8779,'565','Fianzas constituidas a corto plazo.',NULL,0,3,1,NULL),(22013296,8779,'5650','Fianzas constituidas a corto plazo.',NULL,0,4,1,NULL),(22013297,8779,'566','Depósitos constituidos a corto plazo.',NULL,0,3,1,NULL),(22013298,8779,'5660','Depósitos constituidos a corto plazo.',NULL,0,4,1,NULL),(22013299,8779,'567','Intereses pagados por anticipado.',NULL,0,3,1,NULL),(22013300,8779,'5670','Intereses pagados por anticipado.',NULL,0,4,1,NULL),(22013301,8779,'568','Intereses cobrados por anticipado.',NULL,0,3,1,NULL),(22013302,8779,'5680','Intereses cobrados por anticipado.',NULL,0,4,1,NULL),(22013303,8779,'569','Garantías financieras a corto plazo.',NULL,0,3,1,NULL),(22013304,8779,'5690','Garantías financieras a corto plazo.',NULL,0,4,1,NULL),(22013305,8779,'57','TESORERÍA.',NULL,0,2,1,NULL),(22013306,8779,'570','Caja, euros.',NULL,0,3,1,NULL),(22013307,8779,'5700','Caja, euros.',NULL,0,4,1,NULL),(22013308,8779,'570000000','Caja, euros.',NULL,1,5,1,NULL),(22013309,8779,'571','Caja, moneda extranjera.',NULL,0,3,1,NULL),(22013310,8779,'5710','Caja, moneda extranjera.',NULL,0,4,1,NULL),(22013311,8779,'572','Bancos e instituciones de crédito c/c vista, euros.',NULL,0,3,1,NULL),(22013312,8779,'5720','Bancos e instituciones de crédito c/c vista, euros.',NULL,0,4,1,NULL),(22013313,8779,'573','Bancos e instituciones de crédito c/c vista, moneda extranjera.',NULL,0,3,1,NULL),(22013314,8779,'5730','Bancos e instituciones de crédito c/c vista, moneda extranjera.',NULL,0,4,1,NULL),(22013315,8779,'574','Bancos e instituciones de crédito, cuentas de ahorro, euros.',NULL,0,3,1,NULL),(22013316,8779,'5740','Bancos e instituciones de crédito, cuentas de ahorro, euros.',NULL,0,4,1,NULL),(22013317,8779,'575','Bancos e instituciones de crédito, cuentas de ahorro, moneda extranjera.',NULL,0,3,1,NULL),(22013318,8779,'5750','Bancos e instituciones de crédito, cuentas de ahorro, moneda extranjera.',NULL,0,4,1,NULL),(22013319,8779,'576','Inversiones a corto plazo de gran liquidez.',NULL,0,3,1,NULL),(22013320,8779,'5760','Inversiones a corto plazo de gran liquidez.',NULL,0,4,1,NULL),(22013321,8779,'58','ACTIVOS NO CORRIENTES MANTENIDOS PARA LA VENTA Y ACTIVOS Y PASIVOS ASOCIADOS.',NULL,0,2,1,NULL),(22013322,8779,'580','Inmovilizado.',NULL,0,3,1,NULL),(22013323,8779,'5800','Inmovilizado.',NULL,0,4,1,NULL),(22013324,8779,'581','Inversiones con personas y entidades vinculadas.',NULL,0,3,1,NULL),(22013325,8779,'5810','Inversiones con personas y entidades vinculadas.',NULL,0,4,1,NULL),(22013326,8779,'582','Inversiones financieras.',NULL,0,3,1,NULL),(22013327,8779,'5820','Inversiones financieras.',NULL,0,4,1,NULL),(22013328,8779,'583','Existencias, deudores comerciales y otras cuentas a cobrar.',NULL,0,3,1,NULL),(22013329,8779,'5830','Existencias, deudores comerciales y otras cuentas a cobrar.',NULL,0,4,1,NULL),(22013330,8779,'584','Otros activos.',NULL,0,3,1,NULL),(22013331,8779,'5840','Otros activos.',NULL,0,4,1,NULL),(22013332,8779,'585','Provisiones.',NULL,0,3,1,NULL),(22013333,8779,'5850','Provisiones.',NULL,0,4,1,NULL),(22013334,8779,'586','Deudas con características especiales.',NULL,0,3,1,NULL),(22013335,8779,'5860','Deudas con características especiales.',NULL,0,4,1,NULL),(22013336,8779,'587','Deudas con personas y entidades vinculadas.',NULL,0,3,1,NULL),(22013337,8779,'5870','Deudas con personas y entidades vinculadas.',NULL,0,4,1,NULL),(22013338,8779,'588','Acreedores comerciales y otras cuentas a pagar.',NULL,0,3,1,NULL),(22013339,8779,'5880','Acreedores comerciales y otras cuentas a pagar.',NULL,0,4,1,NULL),(22013340,8779,'589','Otros pasivos.',NULL,0,3,1,NULL),(22013341,8779,'5890','Otros pasivos.',NULL,0,4,1,NULL),(22013342,8779,'59','DETERIORO DEL VALOR DE INVERSIONES FINANCIERAS A CORTO PLAZO Y DE ACTIVOS NO CORRIENTES MANTENIDOS PARA LA VENTA.',NULL,0,2,1,NULL),(22013343,8779,'593','Deterioro de valor de participaciones a corto plazo en partes vinculadas.',NULL,0,3,1,NULL),(22013344,8779,'5930','Deterioro de valor de participaciones a corto plazo en partes vinculadas.',NULL,0,4,1,NULL),(22013345,8779,'594','Deterioro del valor de valores representativos de deuda a corto plazo de partes vinculadas.',NULL,0,3,1,NULL),(22013346,8779,'5940','Deterioro del valor de valores representativos de deuda a corto plazo de partes vinculadas.',NULL,0,4,1,NULL),(22013347,8779,'595','Deterioro del valor de créditos a corto plazo a partes vinculadas.',NULL,0,3,1,NULL),(22013348,8779,'5950','Deterioro del valor de créditos a corto plazo a partes vinculadas.',NULL,0,4,1,NULL),(22013349,8779,'597','Deterioro de valor de valores representativos de deuda a corto plazo.',NULL,0,3,1,NULL),(22013350,8779,'5970','Deterioro de valor de valores representativos de deuda a corto plazo.',NULL,0,4,1,NULL),(22013351,8779,'598','Deterioro de valor de créditos a corto plazo.',NULL,0,3,1,NULL),(22013352,8779,'5980','Deterioro de valor de créditos a corto plazo.',NULL,0,4,1,NULL),(22013353,8779,'599','Deterioro de valor de activos no corrientes mantenidos para la venta.',NULL,0,3,1,NULL),(22013354,8779,'5990','Deterioro de valor de activos no corrientes mantenidos para la venta.',NULL,0,4,1,NULL),(22013355,8779,'6','COMPRAS Y GASTOS',NULL,0,1,1,NULL),(22013356,8779,'60','COMPRAS.',NULL,0,2,1,NULL),(22013357,8779,'600','Compras de mercaderías.',NULL,0,3,1,NULL),(22013358,8779,'6000','Compras de mercaderías.',NULL,0,4,1,NULL),(22013359,8779,'600000000','Compras de mercaderías.',NULL,1,5,1,NULL),(22013360,8779,'601','Compras de materias primas.',NULL,0,3,1,NULL),(22013361,8779,'6010','Compras de materias primas.',NULL,0,4,1,NULL),(22013362,8779,'602','Compras de otros aprovisionamientos.',NULL,0,3,1,NULL),(22013363,8779,'6020','Compras de otros aprovisionamientos.',NULL,0,4,1,NULL),(22013364,8779,'606','Descuentos sobre compras por pronto pago.',NULL,0,3,1,NULL),(22013365,8779,'6060','Descuentos sobre compras por pronto pago.',NULL,0,4,1,NULL),(22013366,8779,'607','Trabajos realizados por otras empresas.',NULL,0,3,1,NULL),(22013367,8779,'6070','Trabajos realizados por otras empresas.',NULL,0,4,1,NULL),(22013368,8779,'608','Devoluciones de compras y operaciones similares.',NULL,0,3,1,NULL),(22013369,8779,'6080','Devoluciones de compras y operaciones similares.',NULL,0,4,1,NULL),(22013370,8779,'609','Rappels por compras.',NULL,0,3,1,NULL),(22013371,8779,'6090','Rappels por compras.',NULL,0,4,1,NULL),(22013372,8779,'61','VARIACIÓN DE EXISTENCIAS.',NULL,0,2,1,NULL),(22013373,8779,'610','Variación de existencias de mercaderías.',NULL,0,3,1,NULL),(22013374,8779,'6100','Variación de existencias de mercaderías.',NULL,0,4,1,NULL),(22013375,8779,'611','Variación de existencias de materias primas.',NULL,0,3,1,NULL),(22013376,8779,'6110','Variación de existencias de materias primas.',NULL,0,4,1,NULL),(22013377,8779,'612','Variación de existencias de otros aprovisionamientos.',NULL,0,3,1,NULL),(22013378,8779,'6120','Variación de existencias de otros aprovisionamientos.',NULL,0,4,1,NULL),(22013379,8779,'62','SERVICIOS EXTERIORES.',NULL,0,2,1,NULL),(22013380,8779,'620','Gastos en investigación y desarrollo del ejercicio.',NULL,0,3,1,NULL),(22013381,8779,'6200','Gastos en investigación y desarrollo del ejercicio.',NULL,0,4,1,NULL),(22013382,8779,'621','Arrendamientos y cánones.',NULL,0,3,1,NULL),(22013383,8779,'6210','Arrendamientos y cánones.',NULL,0,4,1,NULL),(22013384,8779,'622','Reparaciones y conservación.',NULL,0,3,1,NULL),(22013385,8779,'6220','Reparaciones y conservación.',NULL,0,4,1,NULL),(22013386,8779,'623','Servicios de profesionales independientes.',NULL,0,3,1,NULL),(22013387,8779,'6230','Servicios de profesionales independientes.',NULL,0,4,1,NULL),(22013388,8779,'624','Transportes.',NULL,0,3,1,NULL),(22013389,8779,'6240','Transportes.',NULL,0,4,1,NULL),(22013390,8779,'625','Primas de seguros.',NULL,0,3,1,NULL),(22013391,8779,'6250','Primas de seguros.',NULL,0,4,1,NULL),(22013392,8779,'626','Servicios bancarios y similares.',NULL,0,3,1,NULL),(22013393,8779,'6260','Servicios bancarios y similares.',NULL,0,4,1,NULL),(22013394,8779,'627','Publicidad, propaganda y relaciones públicas.',NULL,0,3,1,NULL),(22013395,8779,'6270','Publicidad, propaganda y relaciones públicas.',NULL,0,4,1,NULL),(22013396,8779,'628','Suministros.',NULL,0,3,1,NULL),(22013397,8779,'6280','Suministros.',NULL,0,4,1,NULL),(22013398,8779,'629','Otros servicios.',NULL,0,3,1,NULL),(22013399,8779,'6290','Otros servicios.',NULL,0,4,1,NULL),(22013400,8779,'63','TRIBUTOS.',NULL,0,2,1,NULL),(22013401,8779,'630','Impuesto sobre beneficios.',NULL,0,3,1,NULL),(22013402,8779,'6300','Impuesto corriente.',NULL,0,4,1,NULL),(22013403,8779,'6301','Impuesto diferido.',NULL,0,4,1,NULL),(22013404,8779,'631','Otros tributos.',NULL,0,3,1,NULL),(22013405,8779,'6310','Otros tributos.',NULL,0,4,1,NULL),(22013406,8779,'633','Ajustes negativos en la imposición sobre beneficios.',NULL,0,3,1,NULL),(22013407,8779,'6330','Ajustes negativos en la imposición sobre beneficios.',NULL,0,4,1,NULL),(22013408,8779,'634','Ajustes negativos en la imposición indirecta.',NULL,0,3,1,NULL),(22013409,8779,'6340','Ajustes negativos en la imposición indirecta.',NULL,0,4,1,NULL),(22013410,8779,'6341','Ajustes negativos en IVA de activo corriente.',NULL,0,4,1,NULL),(22013411,8779,'634100001','Ajustes negativos en IVA de activo corriente.',NULL,1,5,1,NULL),(22013412,8779,'6342','Ajustes negativos en IVA de inversiones.',NULL,0,4,1,NULL),(22013413,8779,'636','Devolución de impuestos.',NULL,0,3,1,NULL),(22013414,8779,'6360','Devolución de impuestos.',NULL,0,4,1,NULL),(22013415,8779,'638','Ajustes positivos en la imposición sobre beneficios.',NULL,0,3,1,NULL),(22013416,8779,'6380','Ajustes positivos en la imposición sobre beneficios.',NULL,0,4,1,NULL),(22013417,8779,'639','Ajustes positivos en la imposición indirecta.',NULL,0,3,1,NULL),(22013418,8779,'6390','Ajustes positivos en la imposición indirecta.',NULL,0,4,1,NULL),(22013419,8779,'64','GASTOS DE PERSONAL.',NULL,0,2,1,NULL),(22013420,8779,'640','Sueldos y salarios.',NULL,0,3,1,NULL),(22013421,8779,'6400','Sueldos y salarios.',NULL,0,4,1,NULL),(22013422,8779,'640000000','Sueldos y salarios.',NULL,1,5,1,NULL),(22013423,8779,'641','Indemnizaciones.',NULL,0,3,1,NULL),(22013424,8779,'6410','Indemnizaciones.',NULL,0,4,1,NULL),(22013425,8779,'641000000','Indemnizaciones.',NULL,1,5,1,NULL),(22013426,8779,'642','Seguridad Social a cargo de la empresa.',NULL,0,3,1,NULL),(22013427,8779,'6420','Seguridad Social a cargo de la empresa.',NULL,0,4,1,NULL),(22013428,8779,'642000000','Seguridad Social a cargo de la empresa.',NULL,1,5,1,NULL),(22013429,8779,'643','Retribuciones a largo plazo mediante sistemas de aportación definida.',NULL,0,3,1,NULL),(22013430,8779,'6430','Retribuciones a largo plazo mediante sistemas de aportación definida.',NULL,0,4,1,NULL),(22013431,8779,'644','Retribuciones a largo plazo mediante sistemas de prestación definida.',NULL,0,3,1,NULL),(22013432,8779,'6440','Contribuciones anuales.',NULL,0,4,1,NULL),(22013433,8779,'6442','Otros costes.',NULL,0,4,1,NULL),(22013434,8779,'645','Retribuciones al personal mediante instrumentos de patrimonio.',NULL,0,3,1,NULL),(22013435,8779,'6450','Retribuciones al personal mediante instrumentos de patrimonio.',NULL,0,4,1,NULL),(22013436,8779,'649','Otros gastos sociales.',NULL,0,3,1,NULL),(22013437,8779,'6490','Otros gastos sociales.',NULL,0,4,1,NULL),(22013438,8779,'65','OTROS GASTOS DE GESTIÓN.',NULL,0,2,1,NULL),(22013439,8779,'650','Pérdidas de créditos comerciales incobrables.',NULL,0,3,1,NULL),(22013440,8779,'6500','Pérdidas de créditos comerciales incobrables.',NULL,0,4,1,NULL),(22013441,8779,'651','Resultados de operaciones en común.',NULL,0,3,1,NULL),(22013442,8779,'6510','Beneficio transferido (gestor).',NULL,0,4,1,NULL),(22013443,8779,'6511','Pérdida soportada (partícipe o asociado no gestor).',NULL,0,4,1,NULL),(22013444,8779,'659','Otras pérdidas en gestión corriente.',NULL,0,3,1,NULL),(22013445,8779,'6590','Otras pérdidas en gestión corriente.',NULL,0,4,1,NULL),(22013446,8779,'66','GASTOS FINANCIEROS.',NULL,0,2,1,NULL),(22013447,8779,'660','Gastos financieros por actualización de provisiones.',NULL,0,3,1,NULL),(22013448,8779,'6600','Gastos financieros por actualización de provisiones.',NULL,0,4,1,NULL),(22013449,8779,'661','Intereses de obligaciones y bonos.',NULL,0,3,1,NULL),(22013450,8779,'6610','Intereses de obligaciones y bonos.',NULL,0,4,1,NULL),(22013451,8779,'662','Intereses de deudas.',NULL,0,3,1,NULL),(22013452,8779,'6620','Intereses de deudas.',NULL,0,4,1,NULL),(22013453,8779,'662000000','Intereses de deudas.',NULL,1,5,1,NULL),(22013454,8779,'663','Pérdidas por valoración de instrumentos financieros por su valor razonable.',NULL,0,3,1,NULL),(22013455,8779,'6630','Pérdidas de cartera de negociación.',NULL,0,4,1,NULL),(22013456,8779,'6631','Pérdidas de designados por la empresa.',NULL,0,4,1,NULL),(22013457,8779,'6632','Pérdidas de disponibles para la venta.',NULL,0,4,1,NULL),(22013458,8779,'6633','Pérdidas de instrumentos de cobertura.',NULL,0,4,1,NULL),(22013459,8779,'664','Dividendos de acciones o participaciones contabilizadas como pasivo.',NULL,0,3,1,NULL),(22013460,8779,'6640','Dividendos de acciones o participaciones contabilizadas como pasivo.',NULL,0,4,1,NULL),(22013461,8779,'665','Intereses por descuento de efectos y operaciones de factoring.',NULL,0,3,1,NULL),(22013462,8779,'6650','Intereses por descuento de efectos y operaciones de factoring.',NULL,0,4,1,NULL),(22013463,8779,'666','Pérdidas en participaciones y valores representativos de deuda.',NULL,0,3,1,NULL),(22013464,8779,'6660','Pérdidas en participaciones y valores representativos de deuda.',NULL,0,4,1,NULL),(22013465,8779,'667','Pérdidas de créditos no comerciales.',NULL,0,3,1,NULL),(22013466,8779,'6670','Pérdidas de créditos no comerciales.',NULL,0,4,1,NULL),(22013467,8779,'668','Diferencias negativas de cambio.',NULL,0,3,1,NULL),(22013468,8779,'6680','Diferencias negativas de cambio.',NULL,0,4,1,NULL),(22013469,8779,'669','Otros gastos financieros.',NULL,0,3,1,NULL),(22013470,8779,'6690','Otros gastos financieros.',NULL,0,4,1,NULL),(22013471,8779,'669000000','Otros gastos financieros.',NULL,1,5,1,NULL),(22013472,8779,'67','PÉRDIDAS PROCEDENTES DE ACTIVOS NO CORRIENTES Y GASTOS EXCEPCIONALES.',NULL,0,2,1,NULL),(22013473,8779,'670','Pérdidas procedentes del inmovilizado intangible.',NULL,0,3,1,NULL),(22013474,8779,'6700','Pérdidas procedentes del inmovilizado intangible.',NULL,0,4,1,NULL),(22013475,8779,'671','Pérdidas procedentes del inmovilizado material.',NULL,0,3,1,NULL),(22013476,8779,'6710','Pérdidas procedentes del inmovilizado material.',NULL,0,4,1,NULL),(22013477,8779,'672','Pérdidas procedentes de las inversiones inmobiliarias.',NULL,0,3,1,NULL),(22013478,8779,'6720','Pérdidas procedentes de las inversiones inmobiliarias.',NULL,0,4,1,NULL),(22013479,8779,'673','Pérdidas procedentes de participaciones a largo plazo en partes vinculadas.',NULL,0,3,1,NULL),(22013480,8779,'6730','Pérdidas procedentes de participaciones a largo plazo en partes vinculadas.',NULL,0,4,1,NULL),(22013481,8779,'675','Pérdidas por operaciones con obligaciones propias.',NULL,0,3,1,NULL),(22013482,8779,'6750','Pérdidas por operaciones con obligaciones propias.',NULL,0,4,1,NULL),(22013483,8779,'678','Gastos excepcionales.',NULL,0,3,1,NULL),(22013484,8779,'6780','Gastos excepcionales.',NULL,0,4,1,NULL),(22013485,8779,'68','DOTACIONES PARA AMORTIZACIONES.',NULL,0,2,1,NULL),(22013486,8779,'680','Amortización del inmovilizado intangible.',NULL,0,3,1,NULL),(22013487,8779,'6800','Amortización del inmovilizado intangible.',NULL,0,4,1,NULL),(22013488,8779,'6801','Amortización de investigación',NULL,0,4,1,NULL),(22013489,8779,'6802','Amortización de desarrollo',NULL,0,4,1,NULL),(22013490,8779,'6803','Amortización de concesiones administrativas',NULL,0,4,1,NULL),(22013491,8779,'6804','Amortización de propiedad industrial',NULL,0,4,1,NULL),(22013492,8779,'6805','Amortización de derechos de traspaso',NULL,0,4,1,NULL),(22013493,8779,'6806','Amortización de aplicaciones informáticas',NULL,0,4,1,NULL),(22013494,8779,'681','Amortización del inmovilizado material.',NULL,0,3,1,NULL),(22013495,8779,'6810','Amortización del inmovilizado material.',NULL,0,4,1,NULL),(22013496,8779,'6811','Amortización de construcciones',NULL,0,4,1,NULL),(22013497,8779,'6812','Amortización de instalaciones técnicas',NULL,0,4,1,NULL),(22013498,8779,'6813','Amortización de maquinaria',NULL,0,4,1,NULL),(22013499,8779,'6814','Amortización de utillaje',NULL,0,4,1,NULL),(22013500,8779,'6815','Amortización de otras instalaciones',NULL,0,4,1,NULL),(22013501,8779,'6816','Amortización de mobiliario',NULL,0,4,1,NULL),(22013502,8779,'6817','Amortización de equipos para el proceso de información',NULL,0,4,1,NULL),(22013503,8779,'6818','Amortización de elementos de transporte',NULL,0,4,1,NULL),(22013504,8779,'6819','Amortización de otro inmovilizado material',NULL,0,4,1,NULL),(22013505,8779,'682','Amortización de las inversiones inmobiliarias.',NULL,0,3,1,NULL),(22013506,8779,'6820','Amortización de las inversiones inmobiliarias.',NULL,0,4,1,NULL),(22013507,8779,'69','PÉRDIDAS POR DETERIORO Y OTRAS DOTACIONES.',NULL,0,2,1,NULL),(22013508,8779,'690','Pérdidas por deterioro del inmovilizado intangible.',NULL,0,3,1,NULL),(22013509,8779,'6900','Pérdidas por deterioro del inmovilizado intangible.',NULL,0,4,1,NULL),(22013510,8779,'691','Pérdidas por deterioro del inmovilizado material.',NULL,0,3,1,NULL),(22013511,8779,'6910','Pérdidas por deterioro del inmovilizado material.',NULL,0,4,1,NULL),(22013512,8779,'692','Pérdidas por deterioro de las inversiones inmobiliarias.',NULL,0,3,1,NULL),(22013513,8779,'6920','Pérdidas por deterioro de las inversiones inmobiliarias.',NULL,0,4,1,NULL),(22013514,8779,'693','Pérdidas por deterioro de existencias.',NULL,0,3,1,NULL),(22013515,8779,'6930','Pérdidas por deterioro de existencias.',NULL,0,4,1,NULL),(22013516,8779,'694','Pérdidas por deterioro de créditos comerciales.',NULL,0,3,1,NULL),(22013517,8779,'6940','Pérdidas por deterioro de créditos comerciales.',NULL,0,4,1,NULL),(22013518,8779,'695','Dotación a la provisión por operaciones comerciales.',NULL,0,3,1,NULL),(22013519,8779,'6954','Dotación a la provisión por contratos onerosos.',NULL,0,4,1,NULL),(22013520,8779,'6959','Dotación a la provisión para otras operaciones comerciales.',NULL,0,4,1,NULL),(22013521,8779,'696','Pérdidas por deterioro de participaciones y valores representativos de deuda a largo plazo.',NULL,0,3,1,NULL),(22013522,8779,'6960','Pérdidas por deterioro de participaciones y valores representativos de deuda a largo plazo.',NULL,0,4,1,NULL),(22013523,8779,'697','Pérdidas por deterioro de créditos a largo plazo.',NULL,0,3,1,NULL),(22013524,8779,'6970','Pérdidas por deterioro de créditos a largo plazo.',NULL,0,4,1,NULL),(22013525,8779,'698','Pérdidas por deterioro de participaciones y valores representativos de deuda a corto plazo.',NULL,0,3,1,NULL),(22013526,8779,'6980','Pérdidas por deterioro de participaciones y valores representativos de deuda a corto plazo.',NULL,0,4,1,NULL),(22013527,8779,'699','Pérdidas por deterioro de créditos a corto plazo.',NULL,0,3,1,NULL),(22013528,8779,'6990','Pérdidas por deterioro de créditos a corto plazo.',NULL,0,4,1,NULL),(22013529,8779,'7','VENTAS E INGRESOS',NULL,0,1,1,NULL),(22013530,8779,'70','VENTAS DE MERCADERÍAS, DE PRODUCCIÓN PROPIA, DE SERVICIOS, ETC.',NULL,0,2,1,NULL),(22013531,8779,'700','Ventas de mercaderías.',NULL,0,3,1,NULL),(22013532,8779,'7000','Ventas de mercaderías.',NULL,0,4,1,NULL),(22013533,8779,'700000000','Ventas de mercaderías.',NULL,1,5,1,NULL),(22013534,8779,'701','Ventas de productos terminados.',NULL,0,3,1,NULL),(22013535,8779,'7010','Ventas de productos terminados.',NULL,0,4,1,NULL),(22013536,8779,'702','Ventas de productos semiterminados.',NULL,0,3,1,NULL),(22013537,8779,'7020','Ventas de productos semiterminados.',NULL,0,4,1,NULL),(22013538,8779,'703','Ventas de subproductos y residuos.',NULL,0,3,1,NULL),(22013539,8779,'7030','Ventas de subproductos y residuos.',NULL,0,4,1,NULL),(22013540,8779,'704','Ventas de envases y embalajes.',NULL,0,3,1,NULL),(22013541,8779,'7040','Ventas de envases y embalajes.',NULL,0,4,1,NULL),(22013542,8779,'705','Prestación de servicios.',NULL,0,3,1,NULL),(22013543,8779,'7050','Prestación de servicios.',NULL,0,4,1,NULL),(22013544,8779,'706','Descuentos sobre ventas por pronto pago.',NULL,0,3,1,NULL),(22013545,8779,'7060','Descuentos sobre ventas por pronto pago.',NULL,0,4,1,NULL),(22013546,8779,'708','Devoluciones de ventas y operaciones similares.',NULL,0,3,1,NULL),(22013547,8779,'7080','Devoluciones de ventas y operaciones similares.',NULL,0,4,1,NULL),(22013548,8779,'709','Rappels sobre ventas.',NULL,0,3,1,NULL),(22013549,8779,'7090','Rappels sobre ventas.',NULL,0,4,1,NULL),(22013550,8779,'71','VARIACIÓN DE EXISTENCIAS.',NULL,0,2,1,NULL),(22013551,8779,'710','Variación de existencias de productos en curso.',NULL,0,3,1,NULL),(22013552,8779,'7100','Variación de existencias de productos en curso.',NULL,0,4,1,NULL),(22013553,8779,'711','Variación de existencias de productos semiterminados.',NULL,0,3,1,NULL),(22013554,8779,'7110','Variación de existencias de productos semiterminados.',NULL,0,4,1,NULL),(22013555,8779,'712','Variación de existencias de productos terminados.',NULL,0,3,1,NULL),(22013556,8779,'7120','Variación de existencias de productos terminados.',NULL,0,4,1,NULL),(22013557,8779,'713','Variación de existencias de subproductos, residuos y materiales recuperados.',NULL,0,3,1,NULL),(22013558,8779,'7130','Variación de existencias de subproductos, residuos y materiales recuperados.',NULL,0,4,1,NULL),(22013559,8779,'73','TRABAJOS REALIZADOS PARA LA EMPRESA.',NULL,0,2,1,NULL),(22013560,8779,'730','Trabajos realizados para el inmovilizado intangible.',NULL,0,3,1,NULL),(22013561,8779,'7300','Trabajos realizados para el inmovilizado intangible.',NULL,0,4,1,NULL),(22013562,8779,'731','Trabajos realizados para el inmovilizado material.',NULL,0,3,1,NULL),(22013563,8779,'7310','Trabajos realizados para el inmovilizado material.',NULL,0,4,1,NULL),(22013564,8779,'732','Trabajos realizados en inversiones inmobiliarias.',NULL,0,3,1,NULL),(22013565,8779,'7320','Trabajos realizados en inversiones inmobiliarias.',NULL,0,4,1,NULL),(22013566,8779,'733','Trabajos realizados para el inmovilizado en curso.',NULL,0,3,1,NULL),(22013567,8779,'7330','Trabajos realizados para el inmovilizado en curso.',NULL,0,4,1,NULL),(22013568,8779,'74','SUBVENCIONES, DONACIONES Y LEGADOS.',NULL,0,2,1,NULL),(22013569,8779,'740','Subvenciones, donaciones y legados a la explotación.',NULL,0,3,1,NULL),(22013570,8779,'7400','Subvenciones, donaciones y legados a la explotación.',NULL,0,4,1,NULL),(22013571,8779,'746','Subvenciones, donaciones y legados de capital transferidos al resultado del ejercicio.',NULL,0,3,1,NULL),(22013572,8779,'7460','Subvenciones, donaciones y legados de capital transferidos al resultado del ejercicio.',NULL,0,4,1,NULL),(22013573,8779,'747','Otras subvenciones, donaciones y legados transferidos al resultado del ejercicio.',NULL,0,3,1,NULL),(22013574,8779,'7470','Otras subvenciones, donaciones y legados transferidos al resultado del ejercicio.',NULL,0,4,1,NULL),(22013575,8779,'75','OTROS INGRESOS DE GESTIÓN.',NULL,0,2,1,NULL),(22013576,8779,'751','Resultados de operaciones en común.',NULL,0,3,1,NULL),(22013577,8779,'7510','Pérdida transferida (gestor).',NULL,0,4,1,NULL),(22013578,8779,'7511','Beneficio atribuido (partícipe o asociado no gestor).',NULL,0,4,1,NULL),(22013579,8779,'752','Ingresos por arrendamientos.',NULL,0,3,1,NULL),(22013580,8779,'7520','Ingresos por arrendamientos.',NULL,0,4,1,NULL),(22013581,8779,'753','Ingresos de propiedad industrial cedida en explotación.',NULL,0,3,1,NULL),(22013582,8779,'7530','Ingresos de propiedad industrial cedida en explotación.',NULL,0,4,1,NULL),(22013583,8779,'754','Ingresos por comisiones.',NULL,0,3,1,NULL),(22013584,8779,'7540','Ingresos por comisiones.',NULL,0,4,1,NULL),(22013585,8779,'755','Ingresos por servicios al personal.',NULL,0,3,1,NULL),(22013586,8779,'7550','Ingresos por servicios al personal.',NULL,0,4,1,NULL),(22013587,8779,'759','Ingresos por servicios diversos.',NULL,0,3,1,NULL),(22013588,8779,'7590','Ingresos por servicios diversos.',NULL,0,4,1,NULL),(22013589,8779,'76','INGRESOS FINANCIEROS.',NULL,0,2,1,NULL),(22013590,8779,'760','Ingresos de participaciones en instrumentos de patrimonio.',NULL,0,3,1,NULL),(22013591,8779,'7600','Ingresos de participaciones en instrumentos de patrimonio.',NULL,0,4,1,NULL),(22013592,8779,'761','Ingresos de valores representativos de deuda.',NULL,0,3,1,NULL),(22013593,8779,'7610','Ingresos de valores representativos de deuda.',NULL,0,4,1,NULL),(22013594,8779,'762','Ingresos de créditos.',NULL,0,3,1,NULL),(22013595,8779,'7620','Ingresos de créditos.',NULL,0,4,1,NULL),(22013596,8779,'763','Beneficios por valoración de instrumentos financieros por su valor razonable.',NULL,0,3,1,NULL),(22013597,8779,'7630','Beneficios de cartera de negociación.',NULL,0,4,1,NULL),(22013598,8779,'7631','Beneficios de designados por la empresa.',NULL,0,4,1,NULL),(22013599,8779,'7632','Beneficios de disponibles para la venta.',NULL,0,4,1,NULL),(22013600,8779,'7633','Beneficios de instrumentos de cobertura.',NULL,0,4,1,NULL),(22013601,8779,'766','Beneficios en participaciones y valores representativos de deuda.',NULL,0,3,1,NULL),(22013602,8779,'7660','Beneficios en participaciones y valores representativos de deuda.',NULL,0,4,1,NULL),(22013603,8779,'767','Ingresos de activos afectos y de derechos de reembolso relativos a retribuciones a largo plazo.',NULL,0,3,1,NULL),(22013604,8779,'7670','Ingresos de activos afectos y de derechos de reembolso relativos a retribuciones a largo plazo.',NULL,0,4,1,NULL),(22013605,8779,'768','Diferencias positivas de cambio.',NULL,0,3,1,NULL),(22013606,8779,'7680','Diferencias positivas de cambio.',NULL,0,4,1,NULL),(22013607,8779,'769','Otros ingresos financieros.',NULL,0,3,1,NULL),(22013608,8779,'7690','Otros ingresos financieros.',NULL,0,4,1,NULL),(22013609,8779,'77','BENEFICIOS PROCEDENTES DE ACTIVOS NO CORRIENTES E INGRESOS EXCEPCIONALES.',NULL,0,2,1,NULL),(22013610,8779,'770','Beneficios procedentes del inmovilizado intangible.',NULL,0,3,1,NULL),(22013611,8779,'7700','Beneficios procedentes del inmovilizado intangible.',NULL,0,4,1,NULL),(22013612,8779,'771','Beneficios procedentes del inmovilizado material.',NULL,0,3,1,NULL),(22013613,8779,'7710','Beneficios procedentes del inmovilizado material.',NULL,0,4,1,NULL),(22013614,8779,'772','Beneficios procedentes de las inversiones inmobiliarias.',NULL,0,3,1,NULL),(22013615,8779,'7720','Beneficios procedentes de las inversiones inmobiliarias.',NULL,0,4,1,NULL),(22013616,8779,'773','Beneficios procedentes de participaciones..',NULL,0,3,1,NULL),(22013617,8779,'7730','Beneficios procedentes de participaciones..',NULL,0,4,1,NULL),(22013618,8779,'774','Diferencia negativa en combinaciones de negocios.',NULL,0,3,1,NULL),(22013619,8779,'7740','Diferencia negativa en combinaciones de negocios.',NULL,0,4,1,NULL),(22013620,8779,'775','Beneficios por operaciones con obligaciones propias.',NULL,0,3,1,NULL),(22013621,8779,'7750','Beneficios por operaciones con obligaciones propias.',NULL,0,4,1,NULL),(22013622,8779,'778','Ingresos excepcionales.',NULL,0,3,1,NULL),(22013623,8779,'7780','Ingresos excepcionales.',NULL,0,4,1,NULL),(22013624,8779,'79','EXCESOS Y APLICACIONES DE PROVISIONES Y DE PÉRDIDAS POR DETERIORO.',NULL,0,2,1,NULL),(22013625,8779,'790','Reversión del deterioro del inmovilizado intangible.',NULL,0,3,1,NULL),(22013626,8779,'7900','Reversión del deterioro del inmovilizado intangible.',NULL,0,4,1,NULL),(22013627,8779,'791','Reversión del deterioro del inmovilizado material.',NULL,0,3,1,NULL),(22013628,8779,'7910','Reversión del deterioro del inmovilizado material.',NULL,0,4,1,NULL),(22013629,8779,'792','Reversión del deterioro de las inversiones inmobiliarias.',NULL,0,3,1,NULL),(22013630,8779,'7920','Reversión del deterioro de las inversiones inmobiliarias.',NULL,0,4,1,NULL),(22013631,8779,'793','Reversión del deterioro de existencias.',NULL,0,3,1,NULL),(22013632,8779,'7930','Reversión del deterioro de existencias.',NULL,0,4,1,NULL),(22013633,8779,'794','Reversión del deterioro de créditos por operaciones comerciales.',NULL,0,3,1,NULL),(22013634,8779,'7940','Reversión del deterioro de créditos por operaciones comerciales.',NULL,0,4,1,NULL),(22013635,8779,'795','Exceso de provisiones.',NULL,0,3,1,NULL),(22013636,8779,'7950','Exceso de provisiones.',NULL,0,4,1,NULL),(22013637,8779,'796','Reversión del deterioro de participaciones y valores representativos de deuda a largo plazo.',NULL,0,3,1,NULL),(22013638,8779,'7960','Reversión del deterioro de participaciones y valores representativos de deuda a largo plazo.',NULL,0,4,1,NULL),(22013639,8779,'797','Reversión del deterioro de créditos a largo plazo.',NULL,0,3,1,NULL),(22013640,8779,'7970','Reversión del deterioro de créditos a largo plazo.',NULL,0,4,1,NULL),(22013641,8779,'798','Reversión del deterioro de participaciones y valores representativos de deuda a corto plazo.',NULL,0,3,1,NULL),(22013642,8779,'7980','Reversión del deterioro de participaciones y valores representativos de deuda a corto plazo.',NULL,0,4,1,NULL),(22013643,8779,'799','Reversión del deterioro de créditos a corto plazo.',NULL,0,3,1,NULL),(22013644,8779,'7990','Reversión del deterioro de créditos a corto plazo.',NULL,0,4,1,NULL),(22013645,8779,'8','GASTOS IMPUTADOS AL PATRIMONIO NETO',NULL,0,1,1,NULL),(22013646,8779,'80','GASTOS FINANCIEROS POR VALORACIÓN DE ACTIVOS FINANCIEROS.',NULL,0,2,1,NULL),(22013647,8779,'800','Pérdidas en activos financieros disponibles para la venta.',NULL,0,3,1,NULL),(22013648,8779,'8000','Pérdidas en activos financieros disponibles para la venta.',NULL,0,4,1,NULL),(22013649,8779,'802','Transferencia de beneficios en activos financieros disponibles para la venta.',NULL,0,3,1,NULL),(22013650,8779,'8020','Transferencia de beneficios en activos financieros disponibles para la venta.',NULL,0,4,1,NULL),(22013651,8779,'81','GASTOS EN OPERACIONES DE COBERTURA.',NULL,0,2,1,NULL),(22013652,8779,'810','Pérdidas por coberturas de flujos de efectivo.',NULL,0,3,1,NULL),(22013653,8779,'8100','Pérdidas por coberturas de flujos de efectivo.',NULL,0,4,1,NULL),(22013654,8779,'811','Pérdidas por coberturas de inversiones netas en un negocio en el extranjero.',NULL,0,3,1,NULL),(22013655,8779,'8110','Pérdidas por coberturas de inversiones netas en un negocio en el extranjero.',NULL,0,4,1,NULL),(22013656,8779,'812','Transferencia de beneficios por coberturas de flujos de efectivo.',NULL,0,3,1,NULL),(22013657,8779,'8120','Transferencia de beneficios por coberturas de flujos de efectivo.',NULL,0,4,1,NULL),(22013658,8779,'813','Transferencia de beneficios por coberturas de inversiones netas en un negocio en el extranjero.',NULL,0,3,1,NULL),(22013659,8779,'8130','Transferencia de beneficios por coberturas de inversiones netas en un negocio en el extranjero.',NULL,0,4,1,NULL),(22013660,8779,'82','GASTOS POR DIFERENCIAS EN CONVERSIÓN.',NULL,0,2,1,NULL),(22013661,8779,'820','Diferencias de conversión negativas.',NULL,0,3,1,NULL),(22013662,8779,'8200','Diferencias de conversión negativas.',NULL,0,4,1,NULL),(22013663,8779,'821','Transferencia de diferencias de conversión positivas.',NULL,0,3,1,NULL),(22013664,8779,'8210','Transferencia de diferencias de conversión positivas.',NULL,0,4,1,NULL),(22013665,8779,'83','IMPUESTOS SOBRE BENEFICIOS.',NULL,0,2,1,NULL),(22013666,8779,'830','Impuestos sobre beneficios.',NULL,0,3,1,NULL),(22013667,8779,'8300','Impuesto corriente.',NULL,0,4,1,NULL),(22013668,8779,'8301','Impuesto diferido.',NULL,0,4,1,NULL),(22013669,8779,'833','Ajustes negativos en la imposición sobre beneficios.',NULL,0,3,1,NULL),(22013670,8779,'8330','Ajustes negativos en la imposición sobre beneficios.',NULL,0,4,1,NULL),(22013671,8779,'834','Ingresos fiscales por diferencias permanentes.',NULL,0,3,1,NULL),(22013672,8779,'8340','Ingresos fiscales por diferencias permanentes.',NULL,0,4,1,NULL),(22013673,8779,'835','Ingresos fiscales por deducciones y bonificaciones.',NULL,0,3,1,NULL),(22013674,8779,'8350','Ingresos fiscales por deducciones y bonificaciones.',NULL,0,4,1,NULL),(22013675,8779,'836','Transferencia de diferencias permanentes.',NULL,0,3,1,NULL),(22013676,8779,'8360','Transferencia de diferencias permanentes.',NULL,0,4,1,NULL),(22013677,8779,'837','Transferencia de deducciones y bonificaciones.',NULL,0,3,1,NULL),(22013678,8779,'8370','Transferencia de deducciones y bonificaciones.',NULL,0,4,1,NULL),(22013679,8779,'838','Ajustes positivos en la imposición sobre beneficios.',NULL,0,3,1,NULL),(22013680,8779,'8380','Ajustes positivos en la imposición sobre beneficios.',NULL,0,4,1,NULL),(22013681,8779,'84','TRANSFERENCIAS DE SUBVENCIONES, DONACIONES Y LEGADOS.',NULL,0,2,1,NULL),(22013682,8779,'840','Transferencia de subvenciones oficiales de capital.',NULL,0,3,1,NULL),(22013683,8779,'8400','Transferencia de subvenciones oficiales de capital.',NULL,0,4,1,NULL),(22013684,8779,'841','Transferencia de donaciones y legados de capital.',NULL,0,3,1,NULL),(22013685,8779,'8410','Transferencia de donaciones y legados de capital.',NULL,0,4,1,NULL),(22013686,8779,'842','Transferencia de otras subvenciones, donaciones y legados.',NULL,0,3,1,NULL),(22013687,8779,'8420','Transferencia de otras subvenciones, donaciones y legados.',NULL,0,4,1,NULL),(22013688,8779,'85','GASTOS POR PÉRDIDAS ACTUARIALES Y AJUSTES EN LOS ACTIVOS POR RETRIBUCIONES A LARGO PLAZO DE PRESTACIÓN DEFINIDA.',NULL,0,2,1,NULL),(22013689,8779,'850','Pérdidas actuariales.',NULL,0,3,1,NULL),(22013690,8779,'8500','Pérdidas actuariales.',NULL,0,4,1,NULL),(22013691,8779,'851','Ajustes negativos en activos por retribuciones a largo plazo de prestación definida.',NULL,0,3,1,NULL),(22013692,8779,'8510','Ajustes negativos en activos por retribuciones a largo plazo de prestación definida.',NULL,0,4,1,NULL),(22013693,8779,'86','GASTOS POR ACTIVOS NO CORRIENTES EN VENTA.',NULL,0,2,1,NULL),(22013694,8779,'860','Pérdidas en activos no corrientes y grupos enajenables de elementos mantenidos para la venta.',NULL,0,3,1,NULL),(22013695,8779,'8600','Pérdidas en activos no corrientes y grupos enajenables de elementos mantenidos para la venta.',NULL,0,4,1,NULL),(22013696,8779,'862','Transferencia de beneficios en activos no corrientes y grupos enajenables de elementos mantenidos para la venta.',NULL,0,3,1,NULL),(22013697,8779,'8620','Transferencia de beneficios en activos no corrientes y grupos enajenables de elementos mantenidos para la venta.',NULL,0,4,1,NULL),(22013698,8779,'89','GASTOS DE PARTICIPACIONES EN EMPRESAS DEL GRUPO O ASOCIADAS CON AJUSTES VALORATIVOS POSITIVOS PREVIOS.',NULL,0,2,1,NULL),(22013699,8779,'891','Deterioro de participaciones en el patrimonio y valores representativos de deuda de empresas del grupo.',NULL,0,3,1,NULL),(22013700,8779,'8910','Deterioro de participaciones en el patrimonio y valores representativos de deuda de empresas del grupo.',NULL,0,4,1,NULL),(22013701,8779,'892','Deterioro de participaciones en el patrimonio y valores representativos de deuda de empresas asociadas.',NULL,0,3,1,NULL),(22013702,8779,'8920','Deterioro de participaciones en el patrimonio y valores representativos de deuda de empresas asociadas.',NULL,0,4,1,NULL),(22013703,8779,'9','INGRESOS IMPUTADOS AL PATRIMONIO NETO',NULL,0,1,1,NULL),(22013704,8779,'90','INGRESOS FINANCIEROS POR VALORACIÓN DE ACTIVOS FINANCIEROS.',NULL,0,2,1,NULL),(22013705,8779,'900','Beneficios en activos financieros disponibles para la venta.',NULL,0,3,1,NULL),(22013706,8779,'9000','Beneficios en activos financieros disponibles para la venta.',NULL,0,4,1,NULL),(22013707,8779,'902','Transferencia de pérdidas de activos financieros disponibles para la venta.',NULL,0,3,1,NULL),(22013708,8779,'9020','Transferencia de pérdidas de activos financieros disponibles para la venta.',NULL,0,4,1,NULL),(22013709,8779,'91','INGRESOS EN OPERACIONES DE COBERTURA.',NULL,0,2,1,NULL),(22013710,8779,'910','Beneficios por coberturas de flujos de efectivo.',NULL,0,3,1,NULL),(22013711,8779,'9100','Beneficios por coberturas de flujos de efectivo.',NULL,0,4,1,NULL),(22013712,8779,'911','Beneficios por coberturas de una inversión neta en un negocio en el extranjero.',NULL,0,3,1,NULL),(22013713,8779,'9110','Beneficios por coberturas de una inversión neta en un negocio en el extranjero.',NULL,0,4,1,NULL),(22013714,8779,'912','Transferencia de pérdidas por coberturas de flujos de efectivo.',NULL,0,3,1,NULL),(22013715,8779,'9120','Transferencia de pérdidas por coberturas de flujos de efectivo.',NULL,0,4,1,NULL),(22013716,8779,'913','Transferencia de pérdidas por coberturas de una inversión neta en un negocio en el extranjero.',NULL,0,3,1,NULL),(22013717,8779,'9130','Transferencia de pérdidas por coberturas de una inversión neta en un negocio en el extranjero.',NULL,0,4,1,NULL),(22013718,8779,'92','INGRESOS POR DIFERENCIAS DE CONVERSIÓN.',NULL,0,2,1,NULL),(22013719,8779,'920','Diferencias de conversión positivas.',NULL,0,3,1,NULL),(22013720,8779,'9200','Diferencias de conversión positivas.',NULL,0,4,1,NULL),(22013721,8779,'921','Transferencia de diferencias de conversión negativas.',NULL,0,3,1,NULL),(22013722,8779,'9210','Transferencia de diferencias de conversión negativas.',NULL,0,4,1,NULL),(22013723,8779,'94','INGRESOS POR SUBVENCIONES, DONACIONES Y LEGADOS.',NULL,0,2,1,NULL),(22013724,8779,'940','Ingresos de subvenciones oficiales de capital.',NULL,0,3,1,NULL),(22013725,8779,'9400','Ingresos de subvenciones oficiales de capital.',NULL,0,4,1,NULL),(22013726,8779,'941','Ingresos de donaciones y legados de capital.',NULL,0,3,1,NULL),(22013727,8779,'9410','Ingresos de donaciones y legados de capital.',NULL,0,4,1,NULL),(22013728,8779,'942','Ingresos de otras subvenciones, donaciones y legados.',NULL,0,3,1,NULL),(22013729,8779,'9420','Ingresos de otras subvenciones, donaciones y legados.',NULL,0,4,1,NULL),(22013730,8779,'95','INGRESOS POR GANANCIAS ACTUARIALES Y AJUSTES EN LOS ACTIVOS POR RETRIBUCIONES A LARGO PLAZO DE PRESTACIÓN DEFINIDA.',NULL,0,2,1,NULL),(22013731,8779,'950','Ganancias actuariales.',NULL,0,3,1,NULL),(22013732,8779,'9500','Ganancias actuariales.',NULL,0,4,1,NULL),(22013733,8779,'951','Ajustes positivos en activos por retribuciones a largo plazo de prestación definida.',NULL,0,3,1,NULL),(22013734,8779,'9510','Ajustes positivos en activos por retribuciones a largo plazo de prestación definida.',NULL,0,4,1,NULL),(22013735,8779,'96','INGRESOS POR ACTIVOS NO CORRIENTES EN VENTA.',NULL,0,2,1,NULL),(22013736,8779,'960','Beneficios en activos no corrientes y grupos enajenables de elementos mantenidos para la venta.',NULL,0,3,1,NULL),(22013737,8779,'9600','Beneficios en activos no corrientes y grupos enajenables de elementos mantenidos para la venta.',NULL,0,4,1,NULL),(22013738,8779,'962','Transferencia de pérdidas en activos no corrientes y grupos enajenables de elementos mantenidos para la venta.',NULL,0,3,1,NULL),(22013739,8779,'9620','Transferencia de pérdidas en activos no corrientes y grupos enajenables de elementos mantenidos para la venta.',NULL,0,4,1,NULL),(22013740,8779,'99','INGRESOS DE PARTICIPACIONES EN EL PATRIMONIO DE EMPRESAS DEL GRUPO O ASOCIADAS CON AJUSTES VALORATIVOS NEGATIVOS PREVIOS.',NULL,0,2,1,NULL),(22013741,8779,'991','Recuperación de ajustes valorativos negativos previos, empresas del grupo.',NULL,0,3,1,NULL),(22013742,8779,'9910','Recuperación de ajustes valorativos negativos previos, empresas del grupo.',NULL,0,4,1,NULL),(22013743,8779,'992','Recuperación de ajustes valorativos negativos previos, empresas asociadas.',NULL,0,3,1,NULL),(22013744,8779,'9920','Recuperación de ajustes valorativos negativos previos, empresas asociadas.',NULL,0,4,1,NULL),(22013745,8779,'993','Transferencia por deterioro de ajustes valorativos negativos previos, empresas del grupo.',NULL,0,3,1,NULL),(22013746,8779,'9930','Transferencia por deterioro de ajustes valorativos negativos previos, empresas del grupo.',NULL,0,4,1,NULL),(22013747,8779,'994','Transferencia por deterioro de ajustes valorativos negativos previos, empresas asociadas.',NULL,0,3,1,NULL),(22013748,8779,'9940','Transferencia por deterioro de ajustes valorativos negativos previos, empresas asociadas.',NULL,0,4,1,NULL);
/*!40000 ALTER TABLE `account` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `account_entry`
--

DROP TABLE IF EXISTS `account_entry`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `account_entry` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Asiento',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `account_period` int(4) NOT NULL COMMENT 'Ejercicio Contable del Asiento',
  `activity` int(4) DEFAULT NULL COMMENT 'Identificador de la Actividad',
  `entry_date` date DEFAULT NULL COMMENT 'Fecha del Asiento',
  `entry_type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de Asiento',
  `journal` int(4) DEFAULT NULL COMMENT 'Numero de diario del Asiento',
  `security_level` tinyint(2) DEFAULT '0' COMMENT 'Nivel de seguridad del Asiento',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios del Asiento',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_ACCOUNT_ENTRY_ACCOUNT_PERIOD` (`account_period`),
  KEY `IDX_ACCOUNT_ENTRY_DOMAIN` (`domain`),
  KEY `IDX_ACCOUNT_ENTRY_ACTIVITY` (`activity`),
  CONSTRAINT `FK_ACCOUNT_ENTRY_ACCOUNT_PERIOD` FOREIGN KEY (`account_period`) REFERENCES `account_period` (`id`),
  CONSTRAINT `FK_ACCOUNT_ENTRY_ACTIVITY` FOREIGN KEY (`activity`) REFERENCES `enterprise_activity` (`id`),
  CONSTRAINT `FK_ACCOUNT_ENTRY_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Asientos Contables';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `account_entry`
--

LOCK TABLES `account_entry` WRITE;
/*!40000 ALTER TABLE `account_entry` DISABLE KEYS */;
/*!40000 ALTER TABLE `account_entry` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `account_entry_bank_statement`
--

DROP TABLE IF EXISTS `account_entry_bank_statement`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `account_entry_bank_statement` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `account_entry` int(4) NOT NULL COMMENT 'Identificador de Asiento',
  `bank_statement` int(4) NOT NULL COMMENT 'Identificador de Extracto bancario',
  PRIMARY KEY (`id`),
  KEY `IDX_ACC_ENTRY_BANK_STATEMENT_ACC_ENTRY` (`account_entry`),
  KEY `IDX_ACC_ENTRY_BANK_STATEMENT_BANK_STATEMENT` (`bank_statement`),
  KEY `IDX_ACCOUNT_ENTRY_BANK_STATEMENT_DOMAIN` (`domain`),
  CONSTRAINT `FK_ACCOUNT_ENTRY_BANK_STATEMENT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_ACC_ENTRY_BANK_STATEMENT_ACC_ENTRY` FOREIGN KEY (`account_entry`) REFERENCES `account_entry` (`id`),
  CONSTRAINT `FK_ACC_ENTRY_BANK_STATEMENT_BANK_STATEMENT` FOREIGN KEY (`bank_statement`) REFERENCES `bank_statement` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Relacion entre Asientos Contables y Extractos bancarios';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `account_entry_bank_statement`
--

LOCK TABLES `account_entry_bank_statement` WRITE;
/*!40000 ALTER TABLE `account_entry_bank_statement` DISABLE KEYS */;
/*!40000 ALTER TABLE `account_entry_bank_statement` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `account_entry_detail`
--

DROP TABLE IF EXISTS `account_entry_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `account_entry_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Apunte',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `account_entry` int(4) NOT NULL COMMENT 'Identificador del Asiento',
  `line` int(4) unsigned NOT NULL COMMENT 'Numero de linea del Apunte dentro del Asiento',
  `account` int(4) NOT NULL COMMENT 'Cuenta Contable del Apunte',
  `concept` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Concepto del Apunte',
  `balancing_account` int(4) DEFAULT NULL COMMENT 'Contrapartida del Apunte',
  `debit` double DEFAULT '0' COMMENT 'Debe del Apunte',
  `credit` double DEFAULT '0' COMMENT 'Haber del Apunte',
  `document_number` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de documento asociado',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_ACCOUNT_ENTRY_DETAIL_ACCOUNT` (`account`),
  KEY `IDX_ACCOUNT_ENTRY_DETAIL_ACCOUNT_ENTRY` (`account_entry`),
  KEY `IDX_ACCOUNT_ENTRY_DETAIL_BALANCING_ACCOUNT` (`balancing_account`),
  KEY `IDX_ACCOUNT_ENTRY_DETAIL_DOMAIN` (`domain`),
  CONSTRAINT `FK_ACCOUNT_ENTRY_DETAIL_ACCOUNT` FOREIGN KEY (`account`) REFERENCES `account` (`id`),
  CONSTRAINT `FK_ACCOUNT_ENTRY_DETAIL_ACCOUNT_ENTRY` FOREIGN KEY (`account_entry`) REFERENCES `account_entry` (`id`),
  CONSTRAINT `FK_ACCOUNT_ENTRY_DETAIL_BALANCING_ACCOUNT` FOREIGN KEY (`balancing_account`) REFERENCES `account` (`id`),
  CONSTRAINT `FK_ACCOUNT_ENTRY_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Apuntes Contables';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `account_entry_detail`
--

LOCK TABLES `account_entry_detail` WRITE;
/*!40000 ALTER TABLE `account_entry_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `account_entry_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `account_entry_fbatch`
--

DROP TABLE IF EXISTS `account_entry_fbatch`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `account_entry_fbatch` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `account_entry` int(4) NOT NULL COMMENT 'Identificador de Asiento Contable',
  `fbatch` int(4) NOT NULL COMMENT 'Identificador de Remesa',
  PRIMARY KEY (`id`),
  KEY `IDX_ACCOUNT_ENTRY_FBATCH_ACCOUNT_ENTRY` (`account_entry`),
  KEY `IDX_ACCOUNT_ENTRY_FBATCH_FBATCH` (`fbatch`),
  KEY `IDX_ACCOUNT_ENTRY_FBATCH_DOMAIN` (`domain`),
  CONSTRAINT `FK_ACCOUNT_ENTRY_FBATCH_ACCOUNT_ENTRY` FOREIGN KEY (`account_entry`) REFERENCES `account_entry` (`id`),
  CONSTRAINT `FK_ACCOUNT_ENTRY_FBATCH_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_ACCOUNT_ENTRY_FBATCH_FBATCH` FOREIGN KEY (`fbatch`) REFERENCES `fbatch` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Relacion entre Asientos Contables y Remesas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `account_entry_fbatch`
--

LOCK TABLES `account_entry_fbatch` WRITE;
/*!40000 ALTER TABLE `account_entry_fbatch` DISABLE KEYS */;
/*!40000 ALTER TABLE `account_entry_fbatch` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `account_entry_finance_tracking`
--

DROP TABLE IF EXISTS `account_entry_finance_tracking`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `account_entry_finance_tracking` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `account_entry` int(4) NOT NULL COMMENT 'Identificador de Asiento Contable',
  `finance_tracking` int(4) NOT NULL COMMENT 'Identificador de Seguimiento de Vencimientos',
  PRIMARY KEY (`id`),
  KEY `IDX_ACCOUNT_ENTRY_FINANCE_TRACKING_ACCOUNT_ENTRY` (`account_entry`),
  KEY `IDX_ACCOUNT_ENTRY_FINANCE_TRACKING_FINANCE_TRACKING` (`finance_tracking`),
  KEY `IDX_ACCOUNT_ENTRY_FINANCE_TRACKING_DOMAIN` (`domain`),
  CONSTRAINT `FK_ACCOUNT_ENTRY_FINANCE_TRACKING_ACCOUNT_ENTRY` FOREIGN KEY (`account_entry`) REFERENCES `account_entry` (`id`),
  CONSTRAINT `FK_ACCOUNT_ENTRY_FINANCE_TRACKING_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_ACCOUNT_ENTRY_FINANCE_TRACKING_FINANCE_TRACKING` FOREIGN KEY (`finance_tracking`) REFERENCES `finance_tracking` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Relacion entre Seguimiento de Vencimientos y Asientos Contab';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `account_entry_finance_tracking`
--

LOCK TABLES `account_entry_finance_tracking` WRITE;
/*!40000 ALTER TABLE `account_entry_finance_tracking` DISABLE KEYS */;
/*!40000 ALTER TABLE `account_entry_finance_tracking` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `account_entry_invoice`
--

DROP TABLE IF EXISTS `account_entry_invoice`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `account_entry_invoice` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de Relacion',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `account_entry` int(4) NOT NULL COMMENT 'Identificador de Asiento',
  `invoice` int(4) NOT NULL COMMENT 'Identificador de Factura',
  PRIMARY KEY (`id`),
  KEY `IDX_ACCOUNT_ENTRY_INVOICE_ACCOUNT_ENTRY` (`account_entry`),
  KEY `IDX_ACCOUNT_ENTRY_INVOICE_INVOICE` (`invoice`),
  KEY `IDX_ACCOUNT_ENTRY_INVOICE_DOMAIN` (`domain`),
  CONSTRAINT `FK_ACCOUNT_ENTRY_INVOICE_ACCOUNT_ENTRY` FOREIGN KEY (`account_entry`) REFERENCES `account_entry` (`id`),
  CONSTRAINT `FK_ACCOUNT_ENTRY_INVOICE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_ACCOUNT_ENTRY_INVOICE_INVOICE` FOREIGN KEY (`invoice`) REFERENCES `invoice` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Relacion entre Asientos Contables y Facturas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `account_entry_invoice`
--

LOCK TABLES `account_entry_invoice` WRITE;
/*!40000 ALTER TABLE `account_entry_invoice` DISABLE KEYS */;
/*!40000 ALTER TABLE `account_entry_invoice` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `account_helper`
--

DROP TABLE IF EXISTS `account_helper`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `account_helper` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `counter` int(4) NOT NULL DEFAULT '0' COMMENT 'Contador, veces que se ha usado',
  `account` int(4) NOT NULL COMMENT 'Cuenta Contable',
  `balancing_account` int(4) NOT NULL COMMENT 'Contrapartida',
  PRIMARY KEY (`id`),
  KEY `IDX_ACCOUNT_HELPER_ACCOUNT` (`account`),
  KEY `IDX_ACCOUNT_HELPER_BAL_ACCOUNT` (`balancing_account`),
  KEY `IDX_ACCOUNT_HELPER_DOMAIN` (`domain`),
  CONSTRAINT `FK_ACCOUNT_HELPER_ACCOUNT` FOREIGN KEY (`account`) REFERENCES `account` (`id`),
  CONSTRAINT `FK_ACCOUNT_HELPER_BAL_ACCOUNT` FOREIGN KEY (`balancing_account`) REFERENCES `account` (`id`),
  CONSTRAINT `FK_ACCOUNT_HELPER_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Ayuda a la introduccion de apuntes';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `account_helper`
--

LOCK TABLES `account_helper` WRITE;
/*!40000 ALTER TABLE `account_helper` DISABLE KEYS */;
/*!40000 ALTER TABLE `account_helper` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `account_period`
--

DROP TABLE IF EXISTS `account_period`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `account_period` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` char(16) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre del periodo',
  `initiation_date` date NOT NULL COMMENT 'Fecha de inicio del Ejercicio',
  `deadline` date NOT NULL COMMENT 'Fecha final del Ejercicio',
  `status` tinyint(2) DEFAULT '0' COMMENT 'Estado del Ejercicio',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  UNIQUE KEY `IDX_UNQ_ACCOUNT_PERIOD_DOMAIN_NAME` (`domain`,`name`),
  KEY `IDX_ACCOUNT_PERIOD_DOMAIN` (`domain`),
  CONSTRAINT `FK_ACCOUNT_PERIOD_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Ejercicios Contables';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `account_period`
--

LOCK TABLES `account_period` WRITE;
/*!40000 ALTER TABLE `account_period` DISABLE KEYS */;
/*!40000 ALTER TABLE `account_period` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `action`
--

DROP TABLE IF EXISTS `action`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `action` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `menu` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indica si la Accion esta o no dentro del menu',
  `name` varchar(64) COLLATE latin1_spanish_ci NOT NULL DEFAULT '' COMMENT 'Nombre de la Accion',
  `application` int(4) NOT NULL COMMENT 'Aplicacion a la que pertenece la Accion',
  PRIMARY KEY (`id`),
  UNIQUE KEY `IDX_UNQ_ACTION_NAME_APPLICATION` (`name`,`application`),
  KEY `IDX_ACTION_NAME` (`name`),
  KEY `IDX_ACTION_APPLICATION` (`application`),
  CONSTRAINT `FK_ACTION_APPLICATION` FOREIGN KEY (`application`) REFERENCES `application` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=7459 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Acciones de una Applicacion';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `action`
--

LOCK TABLES `action` WRITE;
/*!40000 ALTER TABLE `action` DISABLE KEYS */;
INSERT INTO `action` VALUES (1,0,'home',8),(2,0,'menu_config',8),(3,1,'company',8),(4,0,'resetAction',8),(5,0,'newSaveAction',8),(6,0,'saveAction',8),(7,0,'backAction',8),(8,0,'menu_finance',2),(9,0,'menu_configuration',2),(10,0,'menu_reports',2),(11,1,'account_statement_search',2),(12,0,'menu_pred_entries',2),(13,0,'menu_masters',2),(14,0,'menu_budget',2),(15,1,'tax_list',8),(17,0,'tax_form',8),(18,1,'series',8),(19,0,'cancelNewAction',8),(20,1,'relationship_form',8),(21,1,'dbDumper_form',8),(23,1,'item_search',8),(24,0,'item_list',8),(25,0,'menu_sales',8),(26,1,'productCategory',8),(27,1,'segment_form',8),(28,1,'geotreeParent_list',8),(29,0,'item_form',8),(30,0,'product_stats',8),(31,1,'invoicingGroup_list',8),(32,0,'invoicingGroup_search',8),(33,0,'menu_task',8),(34,1,'customer_search',8),(35,0,'customer_list',8),(36,0,'menu_fixed_assets',2),(37,0,'menu_balance',2),(38,1,'journal_search',2),(39,0,'journal_list',2),(40,0,'customer_form',8),(41,0,'cancelEditAction',8),(42,1,'customer_search',2),(43,0,'customer_list',2),(44,0,'customer_form',2),(45,1,'account_list',2),(46,0,'account_search',2),(47,0,'account_form',2),(48,0,'searchAction',8),(49,0,'customer_consultant_search',8),(50,1,'dossierType_list',8),(51,0,'dossierType_search',8),(52,0,'dossierType_form',8),(53,0,'customer_consultant_list',8),(54,0,'customer_consultant_form',8),(55,1,'activity_type_standalone',8),(56,0,'removeAction',8),(57,1,'feePreInvoicing',8),(58,1,'feePrint_search',8),(59,0,'feePrint_list',8),(62,1,'saleInvoice_search',8),(63,0,'saleInvoice_list',8),(64,1,'feeInvoicing',8),(65,0,'saleInvoice_form',8),(66,0,'cancelAction',8),(67,1,'task_list',8),(68,0,'task_form',8),(69,0,'process_wizard_step0',8),(70,1,'job_type',8),(71,1,'process_list',8),(72,0,'process_form',8),(73,0,'process_wizard_step1',8),(74,0,'process_wizard_step2',8),(75,0,'process_wizard_step3',8),(76,1,'campaign_search',8),(77,0,'campaign_list',8),(78,1,'daily_tracking_report',8),(79,0,'actionFavorite',8),(80,0,'registry_stats',8),(81,1,'dailyTracking_form',8),(83,0,'dailyTracking_list',8),(84,0,'dailyTracking_search',8),(85,1,'finance_search-Charge',8),(86,1,'invoiceRemover_search',8),(87,0,'invoiceRemover_list',8),(88,0,'invoicingGroup_form',8),(89,0,'finance_list',8),(90,0,'menu_treasury',8),(91,1,'fbatch_search',8),(92,0,'fbatch_list',8),(93,0,'fbatch_form',8),(94,1,'finance_search',8),(95,0,'finance_form',8),(96,1,'saleInvoiceRecorder_search',8),(97,0,'saleInvoiceRecorder_list',8),(98,0,'confirmAction',8),(99,0,'task_search',8),(100,0,'finance_fraction',8),(101,1,'util_checking',8),(102,1,'invoicePrint_search',8),(103,0,'invoicePrint_list',8),(104,0,'company_form',8),(105,1,'defaultParams',2),(106,1,'customerAccountChecker_search',2),(107,0,'customerAccountChecker_list',2),(108,1,'bank_search',2),(109,1,'accountChange_form',2),(110,1,'accPeriod',2),(111,0,'cancelEditAction',2),(112,1,'company',2),(113,1,'series',2),(114,1,'tax_list',2),(115,1,'actionDenied',2),(116,1,'account_importer',2),(117,1,'regenerateAccount',2),(118,1,'finance_search-charge',2),(119,0,'finance_list',2),(120,1,'financialStatement_search',2),(121,1,'accountBudget_search',2),(122,0,'accountBudget_form',2),(123,1,'sqlScript_form',8),(124,0,'1',8),(125,0,'2',8),(126,0,'113',8),(127,0,'38',8),(128,1,'abc_stats_search',8),(129,0,'abc_customer_stats',8),(130,0,'invoice_list',8),(131,1,'sales_accumulate_search',8),(132,0,'sales_stats_year',8),(133,0,'customer_stat_list_year',8),(134,0,'47',8),(135,0,'8',8),(136,0,'3',8),(137,0,'4',8),(138,0,'53',8),(139,0,'159',8),(140,1,'abc_stats_searchProduct',8),(141,0,'abc_product_stats',8),(142,1,'category_stats_search',8),(143,0,'category_stats_year',8),(144,1,'noFeeCustomer_list',8),(145,0,'5',8),(146,1,'actionDenied',8),(147,0,'16',8),(148,0,'64',8),(149,0,'menu_purchase',8),(150,1,'fbatch_search-Charge',8),(151,0,'109',8),(152,0,'menu_expenses',8),(153,1,'sales_accumulate_search-sales',8),(154,1,'abc_stats_searchCategory-sales',8),(155,0,'abc_category_stats',8),(156,0,'abccategory_product_stats',8),(157,1,'finance_search-sales',8),(158,1,'fbatch_search-Payment',8),(159,0,'44',8),(160,0,'9',8),(161,1,'item_search-sales',8),(162,0,'11',8),(163,0,'15',8),(164,0,'165',8),(165,1,'category_stats_search-sales',8),(166,0,'category_product_stats',8),(167,0,'category_customer_list',8),(168,1,'summary_stats_search-sales',8),(169,0,'summary_stats_year',8),(170,0,'summary_stats_search',8),(171,1,'abc_stats_searchProduct-sales',8),(172,0,'106',8),(173,0,'13',8),(174,0,'6',8),(175,0,'121',8),(176,0,'122',8),(177,1,'cashFlowForecast_search',8),(178,0,'cashFlowForecast_list',8),(179,1,'cashFlowForecastReport_search',8),(180,0,'cashFlowForecastReport_list',8),(181,0,'sales_stats_month',8),(182,0,'sales_stats_day',8),(183,0,'rowSelectorAction',8),(184,1,'process_transition_type',8),(185,1,'invoiceSigner_search',8),(186,0,'invoiceSigner_list',8),(187,1,'defaultParams',8),(188,0,'webMap',8),(189,0,'actionMoreUsed',8),(190,0,'18',8),(191,1,'bankStatement_search',8),(192,0,'bankStatement_list',8),(193,1,'bank-sales',8),(194,0,'bank_search',8),(195,0,'bank',8),(196,0,'61',8),(197,1,'accPeriod',8),(198,0,'customer_stat_list_day',8),(199,0,'87',8),(200,0,'89',8),(201,0,'12',8),(202,0,'project_search',8),(203,0,'menu_groupware',8),(204,0,'lookupAction',8),(205,0,'account_form',8),(206,0,'cancelAction',2),(207,0,'menu_treasury',2),(208,0,'0',8),(209,0,'36',8),(210,0,'108',8),(211,0,'107',8),(212,1,'gantt_form',8),(213,0,'project_list',8),(214,0,'10',8),(215,1,'taskHolder_search',8),(216,0,'taskHolder_list',8),(217,0,'taskHolder_form',8),(218,1,'account_finance_tracking_entry',8),(219,0,'accountEntry_search',8),(220,0,'accountEntry_list',8),(221,0,'menu_entries',2),(222,1,'accountEntry_search',2),(223,1,'account_finance_entry',2),(224,1,'fbatch_search-Charge',2),(225,0,'fbatch_list',2),(226,0,'fbatch_form',2),(227,0,'finance_search',2),(228,1,'account_finance_tracking_entry',2),(229,1,'saleInvoiceRecorder_search',2),(230,0,'saleInvoiceRecorder_list',2),(231,0,'menu_config',2),(232,0,'rowSelectorAction',2),(233,0,'menu_utilities',28),(236,0,'domainApplication_form',28),(237,0,'appUser_form',28),(238,0,'resetAction',28),(239,0,'newSaveAction',28),(240,0,'menu_management',28),(242,0,'menu_groupware',28),(244,0,'project_list',28),(246,0,'saleInvoice_list',28),(247,0,'menu_fiscal',28),(249,0,'vatTax_list',28),(250,0,'menu_treasury',28),(252,0,'fbatch_list',28),(254,0,'sales_stats_year',28),(255,0,'sales_accumulate_search',28),(256,0,'saleInvoice_form',28),(257,0,'menu_accounting',28),(259,0,'accountEntry_form',28),(260,0,'account_statement_list',28),(261,0,'project_form',28),(263,0,'task_form',28),(264,0,'menu_document',28),(265,0,'customer_list',28),(266,0,'changePassword_form',28),(269,0,'notice_form',28),(270,0,'customer_form',28),(271,0,'lookupAction',28),(274,0,'1',28),(275,0,'saveAction',28),(276,0,'fbatch_form',28),(278,0,'invoicePrint_list',28),(279,0,'79',28),(280,0,'registry_stats',28),(281,0,'company_form',28),(282,0,'62',28),(283,0,'rowSelectorAction',28),(284,0,'cancelEditAction',28),(289,0,'77',28),(290,0,'10',28),(291,0,'advancedMode',28),(292,0,'home',28),(293,0,'alarm_list',28),(296,0,'domainUser_form',28),(298,0,'corporateIdentity_fax',28),(299,0,'corporateIdentity_letter',28),(304,0,'favorite_list',28),(306,0,'favorite_form',28),(308,0,'taskHolder_list',28),(310,0,'customer_stat_list_year',28),(311,0,'invoice_list',28),(312,0,'0',28),(313,0,'2',28),(315,0,'feePrint_list',28),(317,0,'item_list',28),(320,0,'invoiceRemover_list',28),(321,0,'note_list',28),(322,0,'actionFavorite',28),(323,0,'webMap',28),(324,0,'cancelAction',28),(325,0,'removeAction',28),(327,0,'3',28),(328,0,'backAction',28),(330,0,'finance_list',28),(331,0,'finance_form',28),(332,0,'finance_search',28),(333,0,'searchAction',28),(343,0,'menu_configuration',28),(347,0,'mailAccount_form',28),(351,0,'4',28),(353,0,'confirmAction',28),(355,0,'47',28),(359,0,'account_form',28),(363,0,'account_search',28),(367,0,'invoicingGroup_form',28),(369,0,'invoicingGroup_list',28),(375,0,'contact_search',28),(377,0,'contact_form',28),(381,0,'signature_form',28),(385,0,'alarm_form',28),(387,0,'finance_fraction',28),(389,0,'49',28),(393,0,'invoiceSigner_list',28),(399,0,'account_statement_account_list',28),(403,0,'journal_list',28),(411,0,'catalogue_list',28),(415,0,'vat_report_list',28),(419,0,'ledger_list',28),(421,0,'15',28),(423,0,'28',28),(427,0,'customerAccountChecker_list',28),(433,0,'saleInvoiceRecorder_list',28),(439,0,'30',28),(443,0,'category_stats_year',28),(445,0,'category_product_stats',28),(447,0,'category_customer_list',28),(449,0,'item_form',28),(453,0,'abc_product_stats',28),(455,0,'sales_stats_month',28),(457,0,'sales_stats_day',28),(459,0,'customer_stat_list_day',28),(465,0,'8',28),(473,0,'product_stats',28),(477,0,'abc_customer_stats',28),(479,0,'abc_stats_searchProduct',28),(483,0,'journal_search',28),(485,0,'11',28),(487,0,'5',28),(495,0,'category_stats_search',28),(502,1,'company-enterprise',28),(506,1,'newDomain_form-enterprise',28),(512,0,'tax_form',28),(516,0,'tariff_form',28),(518,0,'tariff_list',28),(520,0,'catalogue_form',28),(522,0,'9',28),(524,0,'fbatch_search',28),(530,1,'integral',28),(532,0,'23',28),(542,1,'balance_importer',28),(548,1,'renting_search',28),(550,1,'amortization_exporter',28),(560,1,'amortization_importer',28),(564,1,'account_exporter',28),(575,1,'removeDomain_form-enterprise',28),(587,1,'balance_exporter',28),(600,1,'model340_search',28),(601,1,'account_importer',28),(615,1,'offer_search-garage',28),(616,0,'25',28),(617,0,'29',28),(618,0,'menu_marketing',28),(619,0,'menu_commercial',28),(620,0,'supplier_form',28),(621,0,'cancelNewAction',28),(622,0,'supplier_list',28),(623,0,'note_form',28),(624,0,'commercialTracking_form',28),(627,0,'projectType_form',28),(628,0,'menu_warehouse',28),(630,0,'taskHolder_form',28),(634,0,'process_form',28),(635,0,'null_list',28),(638,0,'dailyTracking_list',28),(640,0,'seller_form',28),(641,0,'seller_list',28),(643,0,'project_stats',28),(644,0,'target_list',28),(645,0,'target_form',28),(647,0,'projectCommercial_form',28),(650,0,'campaign_list',28),(651,0,'process_wizard_step0',28),(652,0,'task_search',28),(653,0,'7',28),(654,0,'16',28),(657,1,'daily_tracking_report',28),(662,0,'geotreeParent_form',28),(663,0,'projectCommercial_list',28),(665,0,'commercialTracking_list',28),(666,0,'offer_list',28),(669,0,'commercial_seller_view',28),(670,0,'commercial_seller_stat',28),(671,0,'commercial_search_view',28),(672,0,'offer_form',28),(674,1,'target_search',28),(676,0,'marketingTemplate_form',28),(678,0,'marketingCampaign_form',28),(679,0,'campaignAction_form',28),(680,0,'campaignActionTarget_search',28),(681,0,'campaignActionTarget_list',28),(684,0,'question_form',28),(685,0,'start',28),(686,0,'domainApplicationProfile_form',28),(687,0,'171',28),(688,0,'creditor_form',28),(689,0,'creditor_list',28),(691,0,'cashFlowForecast_form',28),(692,0,'cashFlowForecast_list',28),(694,0,'cashFlowForecastReport_list',28),(695,0,'customer_stat_list_month',28),(696,0,'vatTax_form',28),(697,0,'saleInvoiceRecorder_search',28),(698,0,'purchaseInvoice_form',28),(699,0,'creditor_search',28),(700,0,'expenseInvoice_form',28),(701,0,'expenseInvoice_list',28),(702,0,'89',28),(708,0,'abc_stats_search',28),(710,1,'projectTas_search',28),(711,0,'closeButtonAction',28),(712,0,'sendAction',28),(713,0,'invoiceSigner_form',28),(714,0,'balance_form',28),(718,0,'sales_form',28),(719,0,'sales_search',28),(720,0,'sales_list',28),(721,0,'menu_enterprise',28),(722,0,'17',28),(726,0,'commissionType_form',28),(727,0,'applicationProfile_list',28),(728,1,'duplicateGroup_search',28),(729,1,'segment_form-academy',28),(730,1,'academicSkillToGroup_search',28),(731,1,'taskHolder_search-academy',28),(732,1,'relationship_form-academy',28),(733,1,'qualitySkill_form',28),(734,1,'qualification_form',28),(735,1,'courseLevel_form',28),(736,1,'alumnReclassification_search',28),(737,1,'academicYear_form',28),(738,1,'observation_form',28),(739,1,'courseSubject_form',28),(740,1,'closeGroup_search',28),(741,1,'feeToGroup_search',28),(742,1,'mark_search',28),(743,1,'academicSkill_form',28),(744,1,'alumnLoan_search',28),(746,0,'_form',28),(747,0,'purchaseInvoice_list',28),(748,0,'101',28),(750,0,'userOverload_form',28),(752,0,'summary_stats_year',28),(754,0,'abc_category_stats',28),(755,0,'purchase_list',28),(760,0,'undeductibleInvoice_list',28),(761,0,'bankStatement_list',28),(762,0,'abc_stats_searchCategory',28),(789,0,'111',28),(790,0,'27',28),(791,0,'domainUser_search',28),(792,0,'notice_search',28),(793,0,'commission_form',28),(794,0,'26',28),(795,0,'43',28),(796,0,'accountManager_form',28),(797,0,'accountManager_search',28),(798,0,'process_search',28),(799,0,'dailyTracking_search',28),(800,0,'process_wizard_step1',28),(801,0,'process_wizard_step2',28),(802,0,'process_wizard_step3',28),(803,0,'campaign_form',28),(804,0,'marketingTemplate_search',28),(805,1,'publishParameter',28),(807,0,'menu_garage',28),(808,1,'make_form',28),(809,1,'model_form',28),(810,1,'tasItem_search',28),(811,1,'taskHolder_search-garage',28),(812,0,'projectTas_form',28),(813,0,'projectTas_list',28),(814,1,'tasStat_search',28),(815,0,'tasStat_list',28),(816,0,'tasStat_tasItem_form',28),(817,0,'income_list',28),(818,0,'purchase_form',28),(819,0,'income_form',28),(820,0,'customer_search',28),(821,0,'trialBalance_list',28),(822,0,'trialBalance_search',28),(823,0,'undeductibleInvoice_form',28),(824,0,'invoiceIntegrity_preview',28),(825,0,'accountEntry_list',28),(828,0,'stock_list',28),(829,0,'check_list',28),(830,0,'officialTrialBalance_list',28),(831,0,'balance_sheet_list',28),(832,0,'expenseInvoiceRecorder_list',28),(834,0,'tax_list',28),(835,0,'account_finance_tracking_entry',28),(836,0,'expenseInvoiceRecorder_search',28),(837,0,'6',28),(838,0,'delivery_list',28),(839,0,'profit_and_loss_list',28),(840,0,'balance_sheet_search',28),(841,0,'mod347_search',28),(843,0,'supplierAccountChecker_list',28),(844,0,'creditorAccountChecker_list',28),(846,0,'stock_form',28),(848,0,'inventory_list',28),(850,0,'supplier_search',28),(851,0,'86',28),(852,0,'mod347_form',28),(853,0,'85',28),(854,0,'18',28),(855,0,'summary_stats_search',28),(856,0,'purchaseInvoiceRecorder_list',28),(857,0,'42',28),(858,0,'delivery_form',28),(859,0,'bank_search',28),(860,0,'bank',28),(861,0,'127',28),(862,0,'134',28),(863,0,'retention_report_list',28),(864,0,'32',28),(867,0,'187',28),(868,0,'loan_list',28),(869,0,'loan_form',28),(870,0,'13',28),(871,0,'12',28),(872,0,'tasItem_form',28),(873,0,'167',28),(874,0,'campaignAction_list',28),(875,0,'invoicingGroup_search',28),(876,0,'notice_list',28),(877,1,'commercialTerm-garage',28),(878,0,'undeductibleInvoiceRecorder_list',28),(879,0,'purchaseInvoiceRecorder_search',28),(880,0,'170',28),(881,0,'inventory_form',28),(882,0,'abccategory_product_stats',28),(883,0,'customer_stat_list',28),(884,0,'19',28),(885,0,'tasItem_list',28),(886,1,'audabridgeParams',28),(887,1,'seller_search',28),(888,0,'commercial_category_stats_year',28),(889,0,'offers_list',28),(892,0,'survey_form',28),(893,0,'surveyResponse_search',28),(894,0,'marketingCampaign_search',28),(895,0,'communicationCenter_email',28),(896,0,'offerDetailCommission_list',28),(897,0,'commission_list',28),(898,0,'note_search',28),(904,0,'203',28),(905,0,'vat_report_detail',28),(906,0,'corporateIdentityAttach_search',28),(907,0,'batchDocument_search',28),(909,0,'warehouseTransfer_list',28),(911,0,'116',28),(912,0,'34',28),(913,0,'favorite_category',28),(914,0,'commercial_product_stats',28),(923,0,'moveMessagesAction',28),(929,0,'46',28),(935,0,'fiscalBatch_list',28),(942,0,'accountStatement_account_list',28),(949,0,'accountStatement_list',28),(950,0,'expenseInvoice_search',28),(958,0,'undeductibleInvoiceRecorder_search',28),(959,0,'35',28),(962,0,'31',28),(963,0,'logout',28),(964,0,'22',28),(966,0,'74',28),(1187,0,'mod123_list',28),(1195,0,'amortizationType_form',28),(1199,0,'geotreeParent_list',28),(1201,0,'156',28),(1203,0,'24',28),(1204,0,'50',28),(1209,0,'amortization_form',28),(1210,0,'periodAmortization_list',28),(1211,0,'33',28),(1212,0,'amortizationType_search',28),(1213,0,'amortization_search',28),(1214,0,'20',28),(1215,0,'invoiceIntegrity_list',28),(1219,0,'balance_list',28),(1220,0,'balance_search',28),(1221,0,'178',28),(1222,0,'financeTrackingEntry_form',28),(1225,0,'14',28),(1229,0,'vatTaxDeclaration_form',28),(1230,0,'vatTaxDeclaration_list',28),(1233,0,'retention_report_detail',28),(1236,0,'feeAssignment_list',28),(1242,0,'39',28),(1243,0,'70',28),(1371,0,'mod111_list',28),(1372,0,'mod111_form',28),(1373,0,'247',28),(1374,0,'56',28),(1375,0,'53',28),(1381,0,'40',28),(1382,0,'87',28),(1384,0,'mod349_form',28),(1386,0,'mod131_form',28),(1388,0,'fiscalActivity_form',28),(1389,0,'mod131_list',28),(1390,0,'mod115_form',28),(1391,0,'mod115_list',28),(1392,0,'mod130_form',28),(1393,0,'mod130_list',28),(1394,0,'mod310_form',28),(1413,0,'61',28),(1414,0,'mod310_list',28),(1415,0,'menu_pos',28),(1418,0,'pos_list',28),(1419,1,'pos_search',28),(1421,0,'pos_form',28),(1425,0,'174',28),(1426,0,'161',28),(1427,0,'warehouseTransfer_form',28),(1428,0,'21',28),(1429,0,'feePrint_form',28),(1432,0,'product_form',28),(1433,0,'product_list',28),(1435,0,'menu_payroll',28),(1438,0,'328',28),(1439,0,'invoiceExporter_list',28),(1440,0,'mod111_search',28),(1441,0,'commercial_target_stats_year',28),(1451,0,'batchDocument_list',28),(1452,0,'purchasePrint_list',28),(1453,0,'112',28),(1454,0,'334',28),(1457,0,'36',28),(1458,0,'143',28),(1459,0,'138',28),(1488,0,'invoiceExporter_form',28),(1491,0,'contract_form',28),(1492,0,'enterprise_form',28),(1496,0,'person_form',28),(1497,0,'person_list',28),(1512,0,'newsletter_form',28),(1514,0,'prepayment_list',28),(1515,0,'136',28),(1550,0,'prepayment_form',28),(1823,0,'145',28),(1825,0,'72',28),(1829,0,'mod349_search',28),(1839,0,'favorite_search',28),(1895,0,'139',28),(1899,1,'alumn_search',28),(1903,0,'auditSession_list',28),(1904,0,'auditSession_moreUsed',28),(1913,0,'fPaymentPrint_list',28),(1933,1,'mailAccount_list-enterprise',28),(1940,1,'signature_list-enterprise',28),(1944,0,'adminDomain_form',28),(1945,0,'portalAccess_form',28),(1947,0,'item_search',28),(1948,0,'domainUser_list',28),(1949,0,'userOverload_list',28),(1950,0,'domainApplicationProfile_list',28),(2413,0,'auditSession_search',28),(2605,0,'contract_list',28),(2607,0,'systemPayment_list',28),(2608,0,'systemPayment_form',28),(2610,0,'systemDeduction_list',28),(2611,0,'menu_contrata',28),(2612,0,'documentGlobal_list',28),(2614,0,'contractBatch_list',28),(2617,0,'channel_form',28),(2618,0,'66',28),(2619,0,'41',28),(2620,0,'54',28),(2621,0,'314',28),(2622,0,'fiscalActivity_search',28),(2623,0,'67',28),(2624,0,'159',28),(2625,0,'88',28),(2628,0,'exporter_form',28),(2629,0,'invoiceExporter_search',28),(2630,0,'auditSession_form',28),(2631,0,'tariff_search',28),(2632,0,'person_search',28),(2633,0,'paymentConcept_list',28),(2634,0,'paymentConcept_form',28),(2635,0,'campaign_project_history',28),(2636,0,'processTask_form',28),(2637,0,'fiscalBatch_form',28),(2639,0,'calendar_form',28),(2640,0,'contrataBatch_list',28),(2641,0,'contrataBatch_form',28),(2646,0,'deductionConcept_list',28),(2648,0,'bonusConcept_list',28),(2649,0,'holiday_form',28),(2650,0,'holiday_list',28),(2652,0,'contractBatch_form',28),(2653,0,'contractLeave_form',28),(2655,0,'sepeCodes_list',28),(2656,0,'irpfData_list',28),(2657,0,'irpfData_form',28),(2659,0,'geozoneIrpf_list',28),(2660,0,'geozoneIrpf_search',28),(2661,0,'geozoneIrpf_form',28),(2662,0,'contractLeave_list',28),(2670,0,'calendar_list',28),(2675,0,'retention_report_detail_grouped',28),(2682,0,'bonusConcept_form',28),(2692,0,'contrataBatch_search',28),(2704,0,'trainingCenter_search',28),(2713,0,'certifica2Batch_list',28),(2714,0,'certifica2Batch_form',28),(2717,0,'mod311_list',28),(2719,0,'mod311_form',28),(2725,0,'certifica2Batch_search',28),(2727,0,'fanBatch_list',28),(2729,0,'contractLeave_search',28),(2731,0,'fanBatch_form',28),(2732,0,'fanBatch_search',28),(2733,0,'246',28),(2734,0,'gwt_enterprise_site',28),(2845,0,'financeExporter_search',28),(2846,0,'38',28),(2847,0,'45',28),(2862,0,'news_form',28),(2863,0,'news_list',28),(2866,0,'htmlTemplate_form',28),(2873,1,'globalConfig_form',28),(2899,0,'financeExporter_list',28),(2980,0,'190',28),(2986,0,'accountingFinanceChecker_list',28),(2987,0,'accountingFinanceChecker_stripped',28),(3045,0,'407',28),(3181,0,'82',28),(3182,0,'contractPdfEdition_form',28),(3196,0,'55',28),(3199,0,'119',28),(3220,0,'question_search',28),(3224,0,'157',28),(3232,0,'165',28),(3234,0,'action',28),(3236,0,'105',28),(3238,0,'craBatch_form',28),(3252,0,'_list',28),(3270,0,'mod303_form',28),(3272,0,'mod303_list',28),(3274,0,'craBatch_list',28),(3275,0,'152',28),(3277,0,'irpfData_search',28),(3281,0,'payrollCodes_list',28),(3282,0,'payrollCodeTables_list',28),(3283,0,'mod123_form',28),(3284,0,'57',28),(3286,0,'60',28),(3287,0,'132',28),(3288,0,'communicationCenter_response',28),(3289,0,'surveyResponse_action_form',28),(3290,0,'surveyResponse_form',28),(3291,0,'leaveBatch_list',28),(3292,0,'leaveBatch_search',28),(3293,0,'leaveBatch_form',28),(3294,0,'posShift_list',28),(3295,0,'posShift_form',28),(3296,0,'posFinance_list',28),(3297,0,'423',28),(3298,0,'craBatch_search',28),(3324,0,'operationReport_list',28),(3348,0,'120',28),(3349,0,'69',28),(3350,0,'48',28),(3351,1,'companyImages',28),(3352,0,'44',28),(3353,0,'37',28),(3354,0,'commercial_geozone_stats_year',28),(3355,0,'htmlTemplate_search',28),(3356,0,'news_search',28),(3357,0,'100',28),(3358,0,'company',28),(3359,0,'95',28),(3361,0,'80',28),(3362,0,'73',28),(3363,0,'65',28),(3364,0,'51',28),(3365,0,'catalogue_search',28),(3458,0,'103',28),(3459,0,'115',28),(3462,0,'121',28),(3465,0,'trainingCenter_form',28),(3466,0,'trainingCenter_list',28),(3471,0,'commercial_activity_view',28),(3472,0,'commercial_activity_list',28),(3474,0,'71',28),(3476,0,'adminDomain_history',28),(3480,0,'113',28),(3481,0,'salaryPrint_search',28),(3482,0,'salaryPrint_list',28),(3484,0,'channel_search',28),(3486,0,'129',28),(3487,0,'91',28),(3488,0,'133',28),(3489,0,'162',28),(3490,0,'orderServer_list',28),(3491,0,'orderServer_form',28),(3492,0,'companyCustomize',28),(3494,0,'172',28),(3495,0,'207',28),(3496,0,'81',28),(3498,0,'153',28),(3499,0,'226',28),(3500,0,'commercial_seller_stats_year',28),(3501,0,'menu_academy',28),(3502,0,'alumn_list',28),(3503,1,'course_search',28),(3504,0,'course_list',28),(3505,1,'posShift_search',28),(3511,0,'targetDeduplication_list',28),(3512,0,'targetDeduplication_form',28),(3513,0,'147',28),(3514,0,'160',28),(3515,0,'144',28),(3516,0,'180',28),(3526,0,'249',28),(3527,0,'276',28),(3528,0,'256',28),(3529,0,'307',28),(3530,0,'281',28),(3531,0,'259',28),(3532,0,'146',28),(3533,0,'targetDeduplication_search',28),(3534,0,'survey_search',28),(3536,0,'118',28),(3537,0,'299',28),(3538,0,'alumn_form',28),(3539,0,'course_form',28),(3540,0,'185',28),(3541,0,'newsletter_search',28),(3542,0,'58',28),(3543,0,'154',28),(3547,0,'130',28),(3570,0,'131',28),(3648,0,'salaryPrint_form',28),(3664,0,'126',28),(3674,0,'97',28),(3676,0,'63',28),(3678,0,'183',28),(3685,0,'carrier_form',28),(3686,0,'carrier_list',28),(4103,1,'contract_search',28),(4160,1,'contractBatch_search',28),(4920,0,'64',28),(4951,0,'mark_list',28),(4952,0,'alumnLoan_list',28),(4953,0,'alumnLoan_form',28),(4954,0,'feeToGroup_list',28),(4956,0,'courseAlumnObservation_form',28),(4957,0,'courseAlumnAbsence_form',28),(4958,0,'alumnReclassification_list',28),(4959,0,'closeGroup_list',28),(4960,0,'duplicateGroup_list',28),(4961,0,'academicSkillToGroup_list',28),(4986,0,'163',28),(4987,0,'purchaseOrder_form',28),(4988,0,'proposal_list',28),(4991,0,'405',28),(4992,1,'sepeAppParams_form-contrata',28),(4993,1,'agreement_search',28),(4994,0,'agreement_list',28),(4996,0,'668',28),(4999,0,'adminGoogle_form',28),(5001,0,'218',28),(5002,0,'222',28),(5004,0,'progressBarStartAction',28),(5005,0,'progressBarCloseAction',28),(5007,0,'financeExporter_form',28),(5792,0,'75',28),(6057,0,'adminGoogle_formSA',28),(6059,0,'offerDetailCommission_form',28),(6063,1,'gwt_employee_tree',28),(6064,1,'contract_search-payroll',28),(6065,1,'mod111_search-payroll',28),(6066,1,'irpfData_search-payroll',28),(6067,1,'finance_search-Payroll',28),(6068,1,'gwt_main_agreement',28),(6069,1,'corporateIdentityAttach_list',28),(6070,1,'salaryPrint_search-payroll',28),(6071,1,'contractOption_list-payroll',28),(6072,1,'certifica2Batch_search-payroll',28),(6073,1,'fbatch_search-Payroll',28),(6074,1,'gwt_mod190-payroll',28),(6078,1,'contractLeave_search-payroll',28),(6079,1,'contrataBatch_search-payroll',28),(6081,0,'52',28),(6082,1,'payrollCodeTables_list-payroll',28),(6084,1,'craBatch_search-payroll',28),(6085,1,'gwt_main_system',28),(6090,1,'contractBatch_search-payroll',28),(6093,1,'expenseInvoice_search-payroll',28),(6094,1,'trainingCenter_list-payroll',28),(6096,0,'376',28),(6097,0,'338',28),(6098,1,'fanBatch_search-payroll',28),(6099,0,'184',28),(6101,0,'84',28),(6111,0,'137',28),(6113,0,'173',28),(6115,0,'123',28),(6116,1,'contractOption_list-contrata',28),(6117,0,'adminDomain_displayModules',28),(6124,0,'fbatchExporter_search',28),(6125,0,'fbatchExporter_list',28),(6126,0,'menu_aonOne',28),(6127,1,'globalConfig_form-aonOne',28),(6580,1,'leaveBatch_search-payroll',28),(6581,1,'person-payroll',28),(6593,1,'supplier_search-aonOne',28),(6596,1,'expenseItem-aonOne',28),(6597,0,'122',28),(6599,1,'cashFlowForecast_search-aonOne',28),(6601,1,'series-aonOne',28),(6602,1,'tax_list-aonOne',28),(6603,1,'bankStatement_search-aonOne',28),(6606,1,'invoiceSigner_search-aonOne',28),(6607,1,'invoicePrint_search-aonOne',28),(6614,0,'233',28),(6619,0,'domainApplication_list',28),(6620,1,'catalogue_search-aonOne',28),(6621,1,'purchaseInvoice_search-aonOne',28),(6878,0,'communicationCenter_mail',28),(6901,1,'mod111_search-fiscal',28),(6902,1,'mod130_search',28),(6903,1,'mod349_list',28),(6907,1,'gwt_mod190',28),(6908,1,'accountingBook_search',28),(6909,1,'fiscalMatrix_list',28),(6910,1,'vatTax_search',28),(6911,1,'reportAttach_form',28),(6912,1,'mod303_search',28),(6913,1,'fiscalActivity_list',28),(6914,1,'reports_launcher',28),(6915,1,'gwt_mod180',28),(6917,1,'mod115_search',28),(6918,1,'undeductibleInvoice_search-aonOne',28),(6921,1,'gwt_mod390',28),(6922,1,'mod347_list',28),(6933,1,'mod131_search',28),(6935,1,'mod123_search',28),(6937,0,'729',28),(6939,1,'vat_report_search-aonOne',28),(6943,1,'tariff_list-aonOne',28),(6947,0,'sddMandate_list',28),(6949,0,'140',28),(6950,0,'135',28),(6953,1,'mod340_search',28),(6973,1,'offer_search',28),(6974,1,'projectCommercial_search',28),(6980,1,'sales_search-commercial',28),(6982,0,'333',28),(6983,0,'238',28),(6985,0,'381',28),(6987,1,'commercial_search_view-target',28),(6989,1,'question_list-commercial',28),(6990,1,'commercial_seller_stat_search',28),(6991,1,'surveyResponse_list-commercial',28),(6992,1,'commissionType_list',28),(6993,1,'commissionCalculation',28),(6994,1,'commercial_search_view-product',28),(6995,1,'commercial_search_view-category',28),(6996,1,'commission_search',28),(6997,1,'commercial_search_view-seller',28),(6998,1,'survey_list-commercial',28),(6999,1,'offerDetailCommission_search',28),(7000,1,'commercialActivity',28),(7002,1,'commercialTerm',28),(7034,1,'marketingTemplate_list-commercial',28),(7037,0,'114',28),(7038,1,'commercial_target_stat_search',28),(7051,1,'commercial_category_stat_search',28),(7052,1,'commercial_product_stat_search',28),(7054,1,'commercial_geozone_stat_search',28),(7056,1,'payMethod-aonOne',28),(7059,1,'customer_search-aonOne',28),(7060,1,'saleInvoice_search-aonOne',28),(7061,1,'expenseInvoice_search-aonOne',28),(7062,1,'finance_search-charge-aonOne',28),(7063,1,'fbatch_search-charge-aonOne',28),(7064,1,'creditor_search-aonOne',28),(7065,1,'cashFlowForecastReport_search-aonOne',28),(7066,1,'finance_search-payment-aonOne',28),(7067,1,'offer_search-aonOne',28),(7068,1,'product_search-aonOne',28),(7069,1,'fbatch_search-payment-aonOne',28),(7073,1,'targetDeduplication_search-commercial',28),(7103,1,'expenseInvoice_search-management',28),(7104,1,'accountEntry_search',28),(7105,1,'expenseEntry_form',28),(7106,1,'task_list',28),(7107,1,'target_search-configuration',28),(7108,1,'finance_search-Charge',28),(7109,1,'saleInvoice_search',28),(7110,1,'finance_search-Payment',28),(7111,1,'accountStatement_search',28),(7112,1,'target_search-commercial',28),(7113,1,'invoicePrint_search',28),(7114,1,'purchaseInvoice_search',28),(7115,1,'amortization_list',28),(7116,1,'undeductibleInvoice_search',28),(7117,1,'supplier_search-management',28),(7118,1,'fbatch_search-Charge',28),(7119,1,'account_list',28),(7120,1,'customer_search-management',28),(7121,1,'product_search-management',28),(7122,1,'feePreInvoicing',28),(7123,1,'invoiceEntry_form',28),(7124,1,'bankStatement_search',28),(7125,1,'customer_search-configuration',28),(7126,1,'dailyTracking_form',28),(7127,1,'project_search',28),(7128,1,'backup_form',28),(7129,1,'endPeriodEntries_form',28),(7130,1,'sales_search-management',28),(7131,1,'financeEntry_form',28),(7132,1,'projectType_list',28),(7133,1,'job_type',28),(7134,1,'vat_report_search',28),(7135,1,'accPeriod-accounting',28),(7136,1,'balance_list-accounting',28),(7137,1,'autConcept',28),(7138,1,'accountingDefaultParams-accounting',28),(7139,1,'mailAccount_list',28),(7140,1,'purchaseInvoiceRecorder_search-accounting',28),(7143,1,'commercialTracking_search',28),(7144,1,'purchase_search',28),(7145,1,'series-configuration',28),(7146,1,'tax_list-configuration',28),(7147,1,'income_search',28),(7148,1,'corporateIdentity_label',28),(7149,1,'delivery_search',28),(7150,1,'saleInvoiceRecorder_search-accounting',28),(7151,1,'creditor_search-management',28),(7152,1,'profit_and_loss_search',28),(7153,1,'geotreeParent_list-configuration',28),(7154,1,'amortizationType_list',28),(7155,1,'journal_search-Report',28),(7156,1,'trialBalance_search-Report',28),(7157,1,'deliveryInvoicing',28),(7158,1,'financeTrackingEntry_form-accounting',28),(7159,1,'posInvoice_form',28),(7160,1,'ledger_search',28),(7161,1,'balance_sheet_search-operating',28),(7162,1,'salaryEntry_form',28),(7163,1,'target_search-marketing',28),(7164,1,'process_list',28),(7165,1,'operationReport_search',28),(7166,1,'expenseItem-management',28),(7167,1,'periodAmortization_search',28),(7173,1,'loanFeeEntry_form',28),(7174,1,'abc_stats_search-sales',28),(7175,1,'sales_accumulate_search-sales',28),(7176,1,'mod310_search-OLD',28),(7177,1,'invoiceReport_search',28),(7178,1,'abc_stats_searchCategory-sales',28),(7179,1,'htmlTemplate_list',28),(7180,1,'product_search',28),(7181,1,'aonLoader_form',28),(7182,1,'feeAssignment_search',28),(7183,1,'cashFlowForecastReport_search',28),(7184,1,'mod349_list-accounting',28),(7185,1,'journal_search-Balance',28),(7186,1,'check_form',28),(7187,1,'balance_sheet_search-closing',28),(7188,1,'feeInvoicing',28),(7189,1,'mod340_search-accounting',28),(7190,1,'retention_report_search',28),(7191,1,'invoiceRemover_search',28),(7192,1,'activityTypeStandalone_grid',28),(7193,1,'domainUser_profile',28),(7194,1,'product_search-configuration',28),(7195,1,'paymethodTypeDetail-configuration',28),(7196,1,'segment_form-configuration',28),(7197,1,'gantt_form',28),(7198,1,'contact_list',28),(7199,1,'relationship_form',28),(7200,1,'catalogue_search-configuration',28),(7201,0,'255',28),(7202,1,'taskHolder_search',28),(7203,1,'survey_list',28),(7205,1,'invoicingGroup_list-management',28),(7206,1,'increaseItem-management',28),(7207,1,'news_list-messages',28),(7208,1,'orderServer_search',28),(7209,1,'orderProposal_search',28),(7210,1,'signature_list',28),(7211,1,'targetDeduplication_search-marketing',28),(7212,1,'newsletter_list',28),(7213,1,'news_list-news',28),(7214,1,'marketingCampaign_list',28),(7215,1,'channel_list',28),(7216,1,'marketingTemplate_list',28),(7217,1,'communicationCenter',28),(7218,1,'brand-configuration',28),(7219,1,'seller_search-commercial',28),(7220,1,'expenseItem-configuration',28),(7221,1,'campaign_search',28),(7222,1,'payMethod-configuration',28),(7223,1,'bankConcept',28),(7224,1,'costProfile_list',28),(7225,1,'socialInsuranceEntry_form',28),(7226,1,'mod347_list-accounting',28),(7227,1,'officialTrialBalance_search',28),(7228,1,'retention_report_search-aonOne',28),(7229,1,'accountChange_form',28),(7230,1,'rss_form',28),(7231,1,'invoicingGroup_list-configuration',28),(7232,1,'prepayment_search',28),(7233,1,'corporateIdentity_receipt',28),(7234,1,'question_list',28),(7235,1,'warehouse',28),(7236,1,'purchasePrint_search',28),(7237,1,'loan_search',28),(7238,1,'loanEntry_form',28),(7239,1,'invoiceIntegrity_search',28),(7240,1,'abc_stats_searchProduct-sales',28),(7241,1,'category_stats_search-sales',28),(7242,0,'236',28),(7243,1,'feePrint_search-anual',28),(7244,1,'feePrint_search',28),(7245,1,'supplier_search-configuration',28),(7246,1,'accountingFinanceChecker_search',28),(7247,1,'supplierAccountChecker_search',28),(7248,1,'fbatch_search-Payment',28),(7249,1,'regenerateAccount',28),(7250,1,'aonLoader_form-aonOne',28),(7251,1,'pos_search-tpv',28),(7252,1,'posOpening_form-tpv',28),(7253,1,'costCenter',28),(7254,1,'abc_stats_searchCategory-expenses',28),(7255,0,'domainBooking_list',28),(7256,0,'83',28),(7257,1,'summary_stats_search-purchase',28),(7258,1,'summary_stats_search-sales',28),(7259,1,'tariff_list-configuration',28),(7260,1,'sddMandate_search',28),(7261,1,'gwt_mod193',28),(7262,1,'productCategory-configuration',28),(7263,1,'sales_accumulate_search-purchase',28),(7264,1,'sales_accumulate_search-expenses',28),(7265,1,'creditor_search-configuration',28),(7266,1,'cashFlowForecast_search',28),(7267,1,'financePrint_checking',28),(7268,0,'sddMandate_form',28),(7269,1,'category_stats_search-expenses',28),(7270,1,'amortizationType_list-parent',28),(7271,1,'workgroup_list',28),(7272,1,'autConcept-parent',28),(7273,1,'noFeeCustomer_list',28),(7274,1,'financeChecking_form',28),(7275,1,'paymentCardSettle_search',28),(7276,1,'posFinance_search',28),(7277,1,'fPaymentPrint_search',28),(7278,1,'inventory_search',28),(7279,1,'warehouseTransfer_search',28),(7280,1,'inventory_close',28),(7281,1,'carrier_search',28),(7282,1,'stock_search',28),(7283,1,'productTag_form',28),(7284,1,'creditorAccountChecker_search',28),(7285,1,'posFinance_search-tpv',28),(7286,1,'process_transition_type',28),(7287,1,'regenerateVat',28),(7288,1,'rss_preview',28),(7289,1,'abc_stats_search-purchase',28),(7290,1,'abc_stats_searchProduct-purchase',28),(7291,1,'balance_sheet_search-custom',28),(7292,1,'productCategory-pos',28),(7293,1,'posClosing_form-tpv',28),(7294,1,'posShift_search-tpv',28),(7295,1,'account_list-parent',28),(7296,1,'stock_report_search-item',28),(7297,1,'stock_report_search-warehouse',28),(7298,0,'google_drive_list',28),(7299,0,'google_drive_form',28),(7300,1,'gwt_main_trash',28),(7301,1,'consumptionControl_search',28),(7302,1,'stock_report_search-itemValued',28),(7303,1,'dsi_import_form',28),(7304,0,'205',28),(7305,1,'customerAccountChecker_search',28),(7306,1,'invoiceSigner_search',28),(7307,1,'productTag_form-pos',28),(7308,1,'balance_list-parent',28),(7309,1,'salesImporter_form-amazonSales',28),(7310,1,'salesImporter_form-amazonSalesShipment',28),(7311,1,'purchaseOrder_grid',28),(7312,1,'proposal_search',28),(7313,1,'noShowInvoice_search',28),(7314,1,'salesImporter_form-amazonSalesReturn',28),(7315,1,'advanceInvoice_search',28),(7316,1,'balance_sheet_search-patrimony',28),(7317,0,'96',28),(7318,0,'514',28),(7319,1,'gwt_templates',28),(7320,1,'category_stats_search-purchase',28),(7321,1,'stock_report_search-warehouseValued',28),(7322,0,'280',28),(7323,1,'abc_stats_searchCategory-purchase',28),(7324,1,'department_grid',28),(7325,1,'hotel_list',28),(7326,1,'summary_stats_search-expenses',28),(7327,1,'abc_stats_searchProduct-expenses',28),(7328,1,'invoiceExporter',28),(7330,1,'abc_stats_search-expenses',28),(7331,1,'campaign_type',28),(7333,1,'fbatchExporter',28),(7334,1,'groupware_process_launcher',28),(7335,1,'financeExporter',28),(7337,1,'seller_search-configuration',28),(7338,1,'applicationParameter_list',28),(7339,0,'493',28),(7340,1,'geotreeParent_list-aonOne',28),(7341,1,'segment_form-aonOne',28),(7342,1,'financeExporter-aonOne',28),(7343,1,'invoiceExporter-aonOne',28),(7344,1,'commercialTerm-aonOne',28),(7345,1,'productTag_form-aonOne',28),(7346,1,'fbatchExporter-aonOne',28),(7347,1,'productCategory-aonOne',28),(7348,1,'bankConcept-aonOne',28),(7349,0,'285',28),(7350,1,'gwt_mod184',28),(7351,0,'59',28),(7352,0,'117',28),(7353,0,'108',28),(7354,0,'76',28),(7355,1,'gwt_invoiceReport',28),(7356,1,'gwt_mod140',28),(7357,0,'companyImages_form',28),(7358,1,'images-marketing',28),(7359,1,'images-commercial',28),(7360,0,'254',28),(7361,0,'companyImages_list',28),(7362,1,'reportPrint_search-payroll',28),(7364,1,'itemTagPrint_search-tpv',28),(7365,0,'itemTagPrint_list',28),(7366,0,'itemTagPrint_search',28),(7367,0,'102',28),(7368,0,'128',28),(7369,0,'339',28),(7370,0,'383',28),(7371,0,'150',28),(7372,1,'invoiceRecorder_search-accounting',28),(7373,0,'invoiceRecorder_list',28),(7375,0,'179',28),(7376,1,'mod311_search',28),(7377,0,'invoiceRecorder_search',28),(7378,1,'salaryAccounting_form-accounting',28),(7379,0,'374',28),(7380,0,'gwt_documents',28),(7381,1,'account_list-configuration',28),(7382,1,'itemTagPrint_search-warehouse',28),(7383,0,'181',28),(7384,1,'gwt_fiscalPanel-mod200',28),(7385,1,'gwt_fiscalPanel-mod202',28),(7386,0,'surveyResponse_list',28),(7387,1,'boe_import_form',28),(7388,0,'gwt_mod200',28),(7389,0,'purchaseForm',28),(7390,0,'107',28),(7391,1,'consumptionControl_search-countError',28),(7392,1,'mailProcess_form',28),(7394,0,'companyImages_search',28),(7395,1,'gwt_fiscalPanel-deposit',28),(7396,0,'296',28),(7397,0,'268',28),(7398,0,'corporateIdentityAttach_form',28),(7399,0,'442',28),(7400,0,'195',28),(7401,0,'196',28),(7402,0,'313',28),(7403,0,'499',28),(7404,0,'90',28),(7405,0,'1874',28),(7406,0,'1100',28),(7407,1,'gwt_consumption_error_templates',28),(7408,1,'manufacturingOrder_search',28),(7409,1,'cancellationInvoice_search',28),(7410,1,'gwt_consumption_templates',28),(7411,0,'613',28),(7412,0,'199',28),(7413,0,'124',28),(7414,0,'232',28),(7415,0,'478',28),(7416,0,'481',28),(7417,1,'gwt_main_creta',28),(7418,0,'manufacturingOrder_form',28),(7419,0,'748',28),(7420,0,'316',28),(7421,0,'244',28),(7422,0,'721',28),(7423,0,'585',28),(7424,1,'gwt_salaryAccounting-payroll',28),(7425,0,'166',28),(7426,0,'manufacturingOrder_list',28),(7427,0,'264',28),(7428,1,'account_list-aonOne',28),(7429,0,'accountingFinanceChecker_finances',28),(7430,0,'505',28),(7431,0,'509',28),(7432,0,'salesForm',28),(7433,1,'gwt_accountEntry-deposit',28),(7434,1,'gwt_invoiceStats',28),(7435,0,'statement_list',28),(7436,0,'155',28),(7437,1,'aonZipLoader_form',28),(7438,0,'978',28),(7439,0,'1637',28),(7440,1,'investAsset_search',28),(7441,0,'investAsset_form',28),(7442,0,'investAsset_list',28),(7443,0,'258',28),(7444,1,'gwt_invoiceSeriesBreakdown',28),(7445,0,'309',28),(7446,0,'304',28),(7447,0,'194',28),(7448,0,'324',28),(7449,0,'275',28),(7450,1,'gwt_main_calculator',28),(7451,1,'feeInvoicing-aonOne',28),(7452,1,'feeAssignment_search-aonOne',28),(7453,1,'feePreInvoicing-aonOne',28),(7454,0,'643',28),(7455,0,'630',28),(7456,0,'1044',28),(7457,0,'645',28),(7458,0,'253',28);
/*!40000 ALTER TABLE `action` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `action_denied`
--

DROP TABLE IF EXISTS `action_denied`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `action_denied` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `action_id` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador de la Accion',
  `user_id` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador del Usuario',
  PRIMARY KEY (`id`),
  KEY `IDX_ACTION_DENIED_ACTION` (`action_id`),
  KEY `IDX_ACTION_DENIED_USER` (`user_id`),
  KEY `IDX_ACTION_DENIED_DOMAIN` (`domain`),
  CONSTRAINT `FK_ACTION_DENIED_ACTION` FOREIGN KEY (`action_id`) REFERENCES `action` (`id`),
  CONSTRAINT `FK_ACTION_DENIED_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_ACTION_DENIED_USER` FOREIGN KEY (`user_id`) REFERENCES `user` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Accion no permitida para el Usuario';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `action_denied`
--

LOCK TABLES `action_denied` WRITE;
/*!40000 ALTER TABLE `action_denied` DISABLE KEYS */;
/*!40000 ALTER TABLE `action_denied` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `action_entry`
--

DROP TABLE IF EXISTS `action_entry`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `action_entry` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `executionDate` datetime NOT NULL COMMENT 'Fecha de ejecucion',
  `action_id` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador de la Accion',
  `session_id` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador de la Sesion',
  PRIMARY KEY (`id`),
  KEY `IDX_ACTION_ENTRY_ACTION` (`action_id`),
  KEY `IDX_ACTION_ENTRY_SESSION` (`session_id`),
  KEY `IDX_ACTION_ENTRY_DOMAIN` (`domain`),
  CONSTRAINT `FK_ACTION_ENTRY_ACTION` FOREIGN KEY (`action_id`) REFERENCES `action` (`id`),
  CONSTRAINT `FK_ACTION_ENTRY_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_ACTION_ENTRY_SESSION` FOREIGN KEY (`session_id`) REFERENCES `session` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Entrada de la ejecucion de una Accion';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `action_entry`
--

LOCK TABLES `action_entry` WRITE;
/*!40000 ALTER TABLE `action_entry` DISABLE KEYS */;
/*!40000 ALTER TABLE `action_entry` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `action_favorite`
--

DROP TABLE IF EXISTS `action_favorite`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `action_favorite` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `position` int(4) NOT NULL COMMENT 'Posicion dentro de las Acciones Favoritas',
  `action_id` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador de la Accion',
  `user_id` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador del Usuario',
  PRIMARY KEY (`id`),
  KEY `IDX_ACTION_FAVORITE_ACTION` (`action_id`),
  KEY `IDX_ACTION_FAVORITE_USER` (`user_id`),
  KEY `IDX_ACTION_FAVORITE_DOMAIN` (`domain`),
  CONSTRAINT `FK_ACTION_FAVORITE_ACTION` FOREIGN KEY (`action_id`) REFERENCES `action` (`id`),
  CONSTRAINT `FK_ACTION_FAVORITE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_ACTION_FAVORITE_USER` FOREIGN KEY (`user_id`) REFERENCES `user` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Accion Favorita del Usuario';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `action_favorite`
--

LOCK TABLES `action_favorite` WRITE;
/*!40000 ALTER TABLE `action_favorite` DISABLE KEYS */;
/*!40000 ALTER TABLE `action_favorite` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `activity_type`
--

DROP TABLE IF EXISTS `activity_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `activity_type` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Tipo de Actividad',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `description` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion del Tipo de Actividad',
  `project_type` int(4) DEFAULT NULL COMMENT 'Tipo de Proyecto',
  `active` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'Activo si o no',
  PRIMARY KEY (`id`),
  KEY `IDX_ACTIVITY_TYPE_PROJECT_TYPE` (`project_type`),
  KEY `IDX_ACTIVITY_TYPE_DOMAIN` (`domain`),
  CONSTRAINT `FK_ACTIVITY_TYPE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_ACTIVITY_TYPE_PROJECT_TYPE` FOREIGN KEY (`project_type`) REFERENCES `project_type` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Tipos de Actividades';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `activity_type`
--

LOCK TABLES `activity_type` WRITE;
/*!40000 ALTER TABLE `activity_type` DISABLE KEYS */;
/*!40000 ALTER TABLE `activity_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `agreement`
--

DROP TABLE IF EXISTS `agreement`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `agreement` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `calendar` int(4) DEFAULT NULL COMMENT 'Calendario',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion',
  PRIMARY KEY (`id`),
  KEY `IDX_AGREEMENT_CALENDAR` (`calendar`),
  KEY `IDX_AGREEMENT_DOMAIN` (`domain`),
  CONSTRAINT `FK_AGREEMENT_CALENDAR` FOREIGN KEY (`calendar`) REFERENCES `calendar` (`id`),
  CONSTRAINT `FK_AGREEMENT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1194 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Convenios';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `agreement`
--

LOCK TABLES `agreement` WRITE;
/*!40000 ALTER TABLE `agreement` DISABLE KEYS */;
INSERT INTO `agreement` VALUES (-1164,8776,NULL,'BORRAR ( PAPELERA ) Y RESTAURAR'),(1156,8776,NULL,'CONVENIO COLECTIVO DE OFICINAS Y DESPACHOS PARA MADRID'),(1157,8776,NULL,'MENSAJES DE AYUDA, EJEMPLOS'),(1158,8776,NULL,'PAGAS EXTRAS, BONOS Y BENEFICIOS'),(1159,8776,NULL,'CONVENIO COLECTIVO DE OFICINAS Y DESPACHOS PARA BIZKAIA'),(1160,8776,NULL,'PAGAS EXTRAS CON GARANTIZADO'),(1161,8784,NULL,'HOSTELERÍA DE LA COMUNIDAD AUTÓNOMA DE BALEARES'),(1162,8776,NULL,'ATRASOS'),(1163,8783,NULL,'CONVENIO DE EMPRESA'),(1164,0,NULL,'ESTATUTO DE LOS TRABAJADORES'),(1165,0,NULL,'CONVENIO COLECTIVO PARA EL COMERCIO DEL METAL MADRID'),(1192,8776,NULL,'STAR WARS AGREEMENT'),(1193,8776,NULL,'PAGAS EXTRAS ANULAES, SEMESTRALES Y TRIMESTREALES');
/*!40000 ALTER TABLE `agreement` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `agreement_data`
--

DROP TABLE IF EXISTS `agreement_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `agreement_data` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre',
  `agreement` int(4) NOT NULL COMMENT 'Convenio',
  `expression` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Expresion',
  `start_date` date NOT NULL COMMENT 'Fecha de inicio ',
  `end_date` date DEFAULT NULL COMMENT 'Fecha de finalizacion',
  PRIMARY KEY (`id`),
  KEY `IDX_AGREEMENT_DATA_AGREEMENT` (`agreement`),
  KEY `IDX_AGREEMENT_DATA_DOMAIN` (`domain`),
  CONSTRAINT `FK_AGREEMENT_DATA_AGREEMENT` FOREIGN KEY (`agreement`) REFERENCES `agreement` (`id`),
  CONSTRAINT `FK_AGREEMENT_DATA_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2153 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Contexto del convenio';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `agreement_data`
--

LOCK TABLES `agreement_data` WRITE;
/*!40000 ALTER TABLE `agreement_data` DISABLE KEYS */;
INSERT INTO `agreement_data` VALUES (2124,8776,'PAGAS',1156,'14','2010-06-01',NULL),(2125,8776,'JORNADA_LABORAL',1156,'1765','2010-06-01',NULL),(2126,8776,'AÑOS_ANTIGUEDAD',1156,'AÑO(INICIO_NOMINA) - AÑO(INICIO_ANTIGUEDAD)','2010-06-01',NULL),(2127,8777,'DIETA',1156,'62.22','2010-06-01',NULL),(2128,8777,'IMPORTE_KM',1156,'0.28','2010-06-01',NULL),(2129,8777,'PLUS_EXTRA_SALARIAL',1156,'0.00','2010-06-01',NULL),(2130,8776,'PAGAS',1159,'15','2009-01-01',NULL),(2131,8776,'IMPORTE_KM',1159,'0.37','2009-01-01','2011-12-31'),(2132,8776,'IMPORTE_KM',1159,'0.39','2012-01-01',NULL),(2134,8776,'AÑOS_ANTIGUEDAD',1159,'AÑO(INICIO_NOMINA)-AÑO(INICIO_ANTIGUEDAD)','2009-01-01',NULL),(2136,8776,'PAGAS',1162,'14','2015-01-01',NULL),(2139,8776,'AUMENTO',1162,'0.10 * SMI * PAGAS','2015-01-01',NULL),(2140,0,'SALARIO_MENSUAL',1164,'SMI','2014-01-01',NULL),(2142,0,'INCREMENTO',1165,'1.00','2015-04-01','2016-03-31'),(2144,0,'INCREMENTO',1165,'1.012','2016-04-01','2017-03-31'),(2145,0,'INCREMENTO',1165,'1.042','2017-04-01',NULL),(2146,0,'PLUS_TRANSPORTE_URBANO',1165,'ROUND( 90.77 * INCREMENTO,2)','2015-04-01',NULL),(2147,0,'MEDIA_DIETA',1165,'ROUND(10.44 * INCREMENTO,2)','2015-04-01',NULL),(2148,0,'DIETA_COMPLETA',1165,'ROUND(43.33 * INCREMENTO,2)','2015-04-01',NULL),(2150,0,'IMPORTE_HORA_EXTRA',1165,'ROUND(SALARIO_MENSUAL * 14 /1778 * 1.75,2) ','2015-04-01',NULL),(2151,8776,'PAGAS',1193,'14','2017-01-01',NULL),(2152,8776,'PLUS_SALARIAL',1193,'69','2017-01-01',NULL);
/*!40000 ALTER TABLE `agreement_data` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `agreement_extra`
--

DROP TABLE IF EXISTS `agreement_extra`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `agreement_extra` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `agreement` int(4) NOT NULL COMMENT 'Convenio',
  `agreement_payment` int(4) DEFAULT NULL COMMENT 'Concepto',
  `start_date` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Fecha de inicio dd mm [year offset]',
  `end_date` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Fecha de finalizacion dd mm [year offset]',
  `issue_date` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Fecha de emision dd mm',
  PRIMARY KEY (`id`),
  KEY `IDX_AGREEMENT_EXTRA_AGREEMENT` (`agreement`),
  KEY `IDX_AGREEMENT_EXTRA_AGREEMENT_PAYMENT` (`agreement_payment`),
  KEY `IDX_AGREEMENT_EXTRA_DOMAIN` (`domain`),
  CONSTRAINT `FK_AGREEMENT_EXTRA_AGREEMENT` FOREIGN KEY (`agreement`) REFERENCES `agreement` (`id`),
  CONSTRAINT `FK_AGREEMENT_EXTRA_AGREEMENT_PAYMENT` FOREIGN KEY (`agreement_payment`) REFERENCES `agreement_payment` (`id`),
  CONSTRAINT `FK_AGREEMENT_EXTRA_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1104 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Pagas extras';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `agreement_extra`
--

LOCK TABLES `agreement_extra` WRITE;
/*!40000 ALTER TABLE `agreement_extra` DISABLE KEYS */;
INSERT INTO `agreement_extra` VALUES (1044,8776,1156,3,'1/7','31/12','15/12'),(1045,8776,1156,4,'1/1','30/6','15/7'),(1046,8776,1158,24,'1/1','31/12','15/1 1'),(1047,8776,1158,23,'1/7','31/12','15/12'),(1048,8776,1158,22,'1/1','30/6','15/7'),(1049,8776,1159,28,'1/3 -1','28/2','15/3'),(1050,8776,1159,29,'1/1','31/12','15/12'),(1051,8776,1159,30,'1/7 -1','30/6','15/7'),(1052,8776,1160,37,'1/1','30/6','15/7'),(1053,8776,1160,36,'1/7','31/12','15/12'),(1054,8784,1161,42,'1/1 2','31/12 2','21/12 2'),(1055,8784,1161,41,'1/8 1','31/7 2','31/7 2'),(1056,8776,1160,46,'1/1','31/12','15/3 1'),(1057,8776,1162,NULL,'1/1 1','31/12 1','15/12 1'),(1058,8776,1162,48,'1/7','30/6 1','15/7 1'),(1059,8783,1163,52,'1/1','31/12','15/12'),(1060,8783,1163,53,'1/7 -1','30/6','15/7'),(1061,0,1164,56,'1/1','30/6','15/7'),(1062,0,1164,55,'1/7','31/12','15/12'),(1063,0,1165,60,'1/1','30/6','15/7'),(1064,0,1165,58,'1/7','31/12','15/12'),(1096,8776,1192,97,'1/1','31/12','15/12'),(1097,8776,1193,110,'1/1','30/6','15/7'),(1098,8776,1193,104,'1/1','31/12','15/1 1'),(1099,8776,1193,109,'1/1','31/3','15/4'),(1100,8776,1193,107,'1/7','31/12','15/12'),(1101,8776,1193,102,'1/4','30/6','1/7'),(1102,8776,1193,106,'1/7','30/9','15/10'),(1103,8776,1193,108,'1/10','31/12','1/1 1');
/*!40000 ALTER TABLE `agreement_extra` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `agreement_level`
--

DROP TABLE IF EXISTS `agreement_level`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `agreement_level` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `agreement` int(4) NOT NULL COMMENT 'Convenio',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion',
  PRIMARY KEY (`id`),
  KEY `IDX_AGREEMENT_LEVEL_AGREEMENT` (`agreement`),
  KEY `IDX_AGREEMENT_LEVEL_DOMAIN` (`domain`),
  CONSTRAINT `FK_AGREEMENT_LEVEL_AGREEMENT` FOREIGN KEY (`agreement`) REFERENCES `agreement` (`id`),
  CONSTRAINT `FK_AGREEMENT_LEVEL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=6090 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Niveles retributivos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `agreement_level`
--

LOCK TABLES `agreement_level` WRITE;
/*!40000 ALTER TABLE `agreement_level` DISABLE KEYS */;
INSERT INTO `agreement_level` VALUES (-5948,8776,-1164,'I'),(-5947,8776,-1164,'VIII'),(-5946,8776,-1164,'VII'),(-5945,8776,-1164,'VI'),(-5944,8776,-1164,'V'),(-5943,8776,-1164,'IV'),(-5942,8776,-1164,'III'),(-5941,8776,-1164,'II'),(-5940,8776,-1164,'I'),(5901,8776,1156,'1'),(5902,8776,1156,'2'),(5903,8776,1156,'3'),(5904,8776,1156,'4'),(5905,8776,1156,'5'),(5906,8776,1156,'6'),(5907,8776,1156,'7'),(5908,8776,1156,'8'),(5909,8776,1156,'9'),(5911,8776,1156,'X'),(5912,8778,1156,'XI'),(5913,8776,1158,'I'),(5914,8776,1159,'I'),(5915,8776,1159,'II'),(5916,8776,1159,'III'),(5917,8776,1159,'IV'),(5918,8776,1159,'V'),(5919,8776,1159,'VI'),(5920,8776,1159,'VII'),(5921,8776,1159,'VIII'),(5922,8776,1159,'IX'),(5923,8776,1159,'XI'),(5924,8776,1159,'XII'),(5925,8776,1159,'X'),(5926,8776,1160,'I'),(5927,8784,1161,'I.A'),(5928,8784,1161,'II.A'),(5929,8784,1161,'III.A'),(5930,8784,1161,'IV.A'),(5931,8784,1161,'V.A'),(5932,8784,1161,'VI.A'),(5933,8776,1162,'I'),(5934,8776,1162,'II'),(5935,8776,1162,'III'),(5936,8776,1162,'IV'),(5937,8776,1162,'v'),(5938,8783,1163,'I'),(5939,8783,1163,'II'),(5940,0,1164,'I'),(5941,0,1165,'3.1'),(5942,0,1165,'3.2'),(5943,0,1165,'4.1'),(5944,0,1165,'1'),(5945,0,1165,'4.2'),(5946,0,1165,'2.1'),(5947,0,1165,'5.1'),(5948,0,1165,'2.2'),(5949,0,1165,'5.2'),(5950,0,1165,'2.3'),(5951,0,1165,'6.1'),(5952,0,1165,'6.2'),(5953,0,1165,'7.1'),(5954,0,1165,'7.2'),(5955,0,1165,'8'),(6082,8776,1192,'I'),(6083,8776,1192,'II'),(6084,8776,1192,'III'),(6085,8776,1192,'IV'),(6086,8776,1192,'V'),(6087,8776,1193,'I'),(6088,8776,1193,'II'),(6089,8776,1193,'III');
/*!40000 ALTER TABLE `agreement_level` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `agreement_level_category`
--

DROP TABLE IF EXISTS `agreement_level_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `agreement_level_category` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `agreement_level` int(4) NOT NULL COMMENT 'Nivel retributivo',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion',
  PRIMARY KEY (`id`),
  KEY `IDX_AGREEMENT_LEVEL_CATEGORY_AGREEMENT_LEVEL` (`agreement_level`),
  KEY `IDX_AGREEMENT_LEVEL_CATEGORY_DOMAIN` (`domain`),
  CONSTRAINT `FK_AGREEMENT_LEVEL_CATEGORY_AGREEMENT_LEVEL` FOREIGN KEY (`agreement_level`) REFERENCES `agreement_level` (`id`),
  CONSTRAINT `FK_AGREEMENT_LEVEL_CATEGORY_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=8580 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Categorias profesionales';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `agreement_level_category`
--

LOCK TABLES `agreement_level_category` WRITE;
/*!40000 ALTER TABLE `agreement_level_category` DISABLE KEYS */;
INSERT INTO `agreement_level_category` VALUES (-8210,8776,-5943,'CATEGORIA 4'),(-8209,8776,-5942,'CATEGORIA 3'),(-8208,8776,-5941,'CATEGORIA 2'),(-8207,8776,-5940,'CATEGORIA 1'),(-8206,8776,-5947,'CATEGORIA 8'),(-8205,8776,-5946,'CATEGORIA 7'),(-8204,8776,-5945,'CATEGORIA 6'),(-8203,8776,-5944,'CATEGORIA 5'),(8096,8776,5901,'PERSONAL TITULADO DE GRADO SUPERIOR'),(8097,8776,5902,'PERSONAL TITULADO DE GRADO MEDIO'),(8098,8776,5904,'JEFE DE SEGUNDA'),(8099,8776,5902,'JEFE SUPERIOR'),(8100,8776,5903,'ANALISTA'),(8101,8776,5903,'JEFE DE PRIMERA'),(8102,8776,5903,'JEFE DE INFORMÁTICA'),(8103,8776,5903,'PROGRAMADOR'),(8104,8776,5904,'JEFE DE EXPLOTACIÓN'),(8105,8776,5904,'JEFE DE DELINEACIÓN'),(8106,8776,5905,'OPERADOR DE PRIMERA'),(8107,8776,5905,'DELINEANTE PROYECTISTA'),(8108,8776,5905,'OCIFIAL DE PRIMERA'),(8109,8776,5906,'DELINEANTE'),(8110,8776,5906,'OCIFIAL DE SEGUNDA'),(8111,8776,5906,'OPERADOR DE SEGUNDA'),(8112,8776,5906,'ENCARGADO'),(8113,8776,5907,'ENTREVISTADOR-ENCUESTADOR'),(8114,8776,5907,'DIBUJANTE'),(8115,8776,5908,'GRABADOR-RECUPERADOR DE DATOS'),(8116,8776,5908,'CALCADOR'),(8117,8776,5909,'ORDENANZA'),(8118,8776,5909,'LIMPIADOR'),(8119,8776,5909,'AUXILIAR'),(8120,8776,5909,'VIGILANTE DIURNO Y NOCTURNO'),(8121,8776,5909,'CONSERJE'),(8122,8776,5909,'MOZO Y PEÓN'),(8123,8776,5911,'BOTONES'),(8124,8778,5912,'BECARIOS'),(8125,8776,5913,'I'),(8126,8776,5914,'Titulado/a grado superior'),(8127,8776,5914,'Analista'),(8128,8776,5915,'Titulado/a grado medio'),(8129,8776,5915,'Jefe/a superior'),(8130,8776,5916,'Programador/a de ordenador'),(8131,8776,5916,'Cajero/a con firma'),(8132,8776,5916,'Analista programador/a'),(8133,8776,5916,'Jefe/a de 1'),(8134,8776,5916,'Técnico cálculo en diseño'),(8136,8776,5917,'Delineante Proyectista'),(8137,8776,5917,'Jefe/a de 2'),(8138,8776,5917,'Cajero/a sin firma'),(8139,8776,5917,'Programador/a de máquinario auxiliar'),(8140,8776,5919,'Delineante'),(8141,8776,5919,'Operador/a de ordenador'),(8142,8776,5919,'Programador de 2ª'),(8143,8776,5919,'Viajante'),(8144,8776,5919,'Oficial/a 1ª administrativo/a'),(8145,8776,5920,'Perforista-grabador/a de 1'),(8146,8776,5920,'Conserje'),(8147,8776,5920,'Dibujante'),(8148,8776,5920,'Oficial/a 2ª administrativo/a'),(8149,8776,5920,'Operador/a de 2ª'),(8150,8776,5918,'Delineante Proyectista 2ª'),(8151,8776,5921,'Telefonista recepcionista'),(8152,8776,5921,'Vigilante'),(8153,8776,5921,'Dibujante de 2'),(8154,8776,5921,'Delineante de 2ª'),(8155,8776,5921,'Oficial de 1ª - oficicios varios'),(8156,8776,5921,'Cobrador/a'),(8157,8776,5922,'Oficial de 2ª - oficios varios'),(8158,8776,5922,'Personal de limpieza'),(8159,8776,5922,'Calcador/a'),(8160,8776,5922,'Perforista-grabador de 2ª'),(8161,8776,5922,'Auxiliar administrativo/a'),(8162,8776,5922,'Telefonista ordenanza'),(8163,8776,5923,'Auxiliar técnico'),(8164,8776,5924,'Aspirante y botone (men de 18 años)'),(8165,8776,5925,'Ayudantes de oficios varios'),(8166,8776,5926,'I'),(8167,8784,5927,'Primer/a conserje'),(8168,8784,5927,'Jefe/a de cocina'),(8169,8784,5927,'Jefe/a de recepción'),(8170,8784,5927,'Contable general'),(8171,8784,5927,'Jefe/a de comedor'),(8172,8784,5928,'Jefe/a de bar'),(8173,8784,5928,'Segundo/a jefe/a de comedor'),(8174,8784,5928,'Jefe/a de reposteria'),(8175,8784,5928,'Segundo/a jefe/a de sala'),(8176,8784,5928,'Segundo/a jefe/a de cocina'),(8177,8784,5929,'Jefe/a de partida'),(8178,8784,5929,'Jefe/a de sector'),(8179,8784,5929,'Segundo/a jefe/a de bar'),(8180,8784,5929,'Dependiente/a de primera'),(8181,8784,5930,'Oficial/a repostero/a'),(8182,8784,5930,'Cafetero/a'),(8183,8784,5930,'Cocinero/a'),(8184,8784,5930,'Planchista'),(8185,8784,5930,'Dependiente/a 2ª'),(8186,8784,5931,'Ayudante/a de cocina'),(8187,8784,5931,'Ayudante/a de reposteria'),(8188,8784,5931,'Facturista'),(8189,8784,5931,'Telefonista'),(8190,8784,5931,'Ayudante/a de planchista'),(8191,8784,5932,'Portero/a recibidor/a de sala de fiestas'),(8192,8784,5932,'Peón'),(8193,8784,5932,'Guardarropa'),(8194,8784,5932,'Portero/a de coches'),(8196,8776,5934,'CATEGORIA II'),(8197,8776,5935,'CATEGORIA III'),(8198,8776,5936,'CATEGORIA IV'),(8199,8776,5937,'CATEGORIA V'),(8200,8776,5933,'CATEGORIA I'),(8201,8783,5938,'CATEGORIA I'),(8202,8783,5939,'CATEGORIA II'),(8203,0,5940,'I'),(8205,0,5944,'Analista de Sistemas'),(8206,0,5944,'Licenciados'),(8207,0,5944,'Jefe de Personal'),(8208,0,5944,'Jefe de Compras'),(8209,0,5944,'Grado Universitario'),(8210,0,5944,'Jefe de Ventas'),(8211,0,5944,'Ingenieros'),(8212,0,5944,'Encargado General'),(8214,0,5948,'Jefe de Almacén'),(8215,0,5948,'Jefe de Sucursal'),(8216,0,5948,'Dibujante'),(8217,0,5948,'Analista de Aplicaciones'),(8218,0,5948,'Ayudantes Técnicos'),(8219,0,5948,'Proyectista'),(8220,0,5948,'Programador de Sistemas'),(8221,0,5950,'Delineante'),(8222,0,5950,'Escaparatista'),(8223,0,5950,'Rotulista'),(8224,0,5941,'Jefe de Grupo'),(8225,0,5941,'Jefe de Sección Admvo'),(8226,0,5941,'Programador de Aplicaciones'),(8227,0,5941,'Jefe de Taller'),(8228,0,5942,'Visitador'),(8229,0,5943,'Dependiente Mayor'),(8230,0,5943,'Viajante'),(8231,0,5943,'Oficial de 1ª Admvo'),(8232,0,5943,'Contable'),(8233,0,5943,'Cajero'),(8234,0,5943,'Operador de Ordenador'),(8235,0,5943,'Jefe de Sección'),(8236,0,5943,'Practicante / ATS'),(8237,0,5945,'Corredor de Plaza'),(8238,0,5945,'Dependiente (22 años)'),(8239,0,5945,'Conductor \"E'),(8240,0,5945,'Oficial de 2ª Admvo'),(8241,0,5945,'Conductor \"D'),(8242,0,5945,'Engarcado de Establecimiento'),(8243,0,5947,'Cobrador de Ventas C?edito'),(8244,0,5947,'Ofical 1'),(8245,0,5947,'Conductor \"C'),(8246,0,5949,'Capataz'),(8247,0,5949,'Conserje'),(8248,0,5949,'Cobrador'),(8249,0,5949,'Mozo Especializado'),(8250,0,5949,'Auxiliares'),(8251,0,5949,'Conductor \"A1'),(8252,0,5949,'Oficial 2'),(8253,0,5949,'Personal de Limpieza a Tiemplo Completo'),(8254,0,5949,'Telefonista'),(8255,0,5949,'Conductor \"B'),(8256,0,5949,'Oficial 3'),(8257,0,5952,'Contrato para la Formación Segundo Año'),(8258,0,5953,'Aspirante hasta 18 años'),(8259,0,5954,'Aspirante de 16 y 17 años'),(8260,0,5955,'Personal de Limpieza Tiempo Parcial'),(8261,0,5951,'Contrato para la Formación Primer Año'),(8263,0,5946,'Jefe 1ª Administrativo'),(8564,8776,6082,'Jedi'),(8565,8776,6082,'Sith'),(8566,8776,6083,'General'),(8567,8776,6084,'X-Wing Pilot'),(8568,8776,6084,'Emperor\'s Royal Guard'),(8569,8776,6085,'Stormtrooper'),(8570,8776,6085,'Wookiee'),(8571,8776,6085,'Sand Trooper'),(8572,8776,6085,'Scout Trooper'),(8573,8776,6085,'Snow Trooper'),(8574,8776,6086,'Clone Trooper'),(8575,8776,6086,'Ewok'),(8576,8776,6087,'I'),(8578,8776,6089,'III'),(8579,8776,6088,'II');
/*!40000 ALTER TABLE `agreement_level_category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `agreement_level_data`
--

DROP TABLE IF EXISTS `agreement_level_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `agreement_level_data` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre',
  `agreement_level` int(4) NOT NULL COMMENT 'Nivel retributivo',
  `expression` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Expresion',
  `start_date` date NOT NULL COMMENT 'Fecha de inicio ',
  `end_date` date DEFAULT NULL COMMENT 'Fecha de finalizacion',
  PRIMARY KEY (`id`),
  KEY `IDX_AGREEMENT_LEVEL_DATA_AGREEMENT_LEVEL` (`agreement_level`),
  KEY `IDX_AGREEMENT_LEVEL_DATA_DOMAIN` (`domain`),
  CONSTRAINT `FK_AGREEMENT_LEVEL_DATA_AGREEMENT_LEVEL` FOREIGN KEY (`agreement_level`) REFERENCES `agreement_level` (`id`),
  CONSTRAINT `FK_AGREEMENT_LEVEL_DATA_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=15892 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Contexto del convenio';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `agreement_level_data`
--

LOCK TABLES `agreement_level_data` WRITE;
/*!40000 ALTER TABLE `agreement_level_data` DISABLE KEYS */;
INSERT INTO `agreement_level_data` VALUES (-15731,8776,'SALARIO_MENSUAL',-5943,'SMI * 5','2016-06-01',NULL),(-15730,8776,'SALARIO_MENSUAL',-5942,'SMI * 6','2016-06-01',NULL),(-15729,8776,'SALARIO_MENSUAL',-5941,'SMI * 7','2016-06-01',NULL),(-15728,8776,'SALARIO_MENSUAL',-5940,'SMI * 8','2016-06-01',NULL),(-15727,8776,'SALARIO_MENSUAL',-5947,'SMI','2016-06-01',NULL),(-15726,8776,'SALARIO_MENSUAL',-5946,'SMI * 2','2016-06-01',NULL),(-15725,8776,'SALARIO_MENSUAL',-5945,'SMI * 3','2016-06-01',NULL),(-15724,8776,'SALARIO_MENSUAL',-5944,'SMI * 4','2016-06-01',NULL),(15638,8776,'SALARIO_ANUAL',5904,'13829.55','2010-06-01',NULL),(15639,8776,'SALARIO_ANUAL',5901,'15454.46','2010-06-01',NULL),(15640,8776,'SALARIO_ANUAL',5902,'14944.11','2010-06-01',NULL),(15641,8776,'SALARIO_ANUAL',5903,'14387.05','2010-06-01',NULL),(15642,8776,'SALARIO_ANUAL',5905,'12808.91','2010-06-01',NULL),(15643,8776,'SALARIO_ANUAL',5906,'12298.66','2010-06-01',NULL),(15644,8776,'SALARIO_ANUAL',5907,'11695.78','2010-06-01',NULL),(15645,8776,'SALARIO_ANUAL',5908,'11185.10','2010-06-01',NULL),(15646,8776,'SALARIO_ANUAL',5909,'10488.16','2010-06-01',NULL),(15647,8776,'SALARIO_ANUAL',5911,'8866.20','2010-06-01',NULL),(15649,8778,'SALARIO_ANUAL',5912,'SMI*14','2010-06-01',NULL),(15650,8776,'SALARIO_MENSUAL',5913,'1067.40','2016-05-01',NULL),(15651,8776,'SALARIO_ANUAL',5920,'17063.42','2009-01-01','2009-12-31'),(15652,8776,'SALARIO_ANUAL',5921,'16263.88','2009-01-01','2009-12-31'),(15653,8776,'SALARIO_ANUAL',5922,'15463.41','2009-01-01','2009-12-31'),(15654,8776,'SALARIO_ANUAL',5923,'13016.85','2009-01-01','2009-12-31'),(15655,8776,'SALARIO_ANUAL',5924,'9115.55','2009-01-01','2009-12-31'),(15656,8776,'SALARIO_ANUAL',5925,'13863.92','2009-01-01','2009-12-31'),(15657,8776,'SALARIO_ANUAL',5914,'26661.53','2009-01-01','2009-12-31'),(15658,8776,'SALARIO_ANUAL',5915,'23903.45','2009-01-01','2009-12-31'),(15659,8776,'SALARIO_ANUAL',5916,'22662.48','2009-01-01','2009-12-31'),(15660,8776,'SALARIO_ANUAL',5917,'21328.85','2009-01-01','2009-12-31'),(15661,8776,'SALARIO_ANUAL',5918,'20528.91','2009-01-01','2009-12-31'),(15662,8776,'SALARIO_ANUAL',5919,'19728.83','2009-01-01','2009-12-31'),(15663,8776,'SALARIO_ANUAL',5920,'17792.74','2010-01-01','2010-12-31'),(15664,8776,'SALARIO_ANUAL',5921,'16959.81','2010-01-01','2010-12-31'),(15665,8776,'SALARIO_ANUAL',5922,'16125.40','2010-01-01','2010-12-31'),(15666,8776,'SALARIO_ANUAL',5923,'13573.86','2010-01-01','2010-12-31'),(15667,8776,'SALARIO_ANUAL',5924,'9505.51','2010-01-01','2010-12-31'),(15668,8776,'SALARIO_ANUAL',5925,'14457.10','2010-01-01','2010-12-31'),(15669,8776,'SALARIO_ANUAL',5914,'27802.37','2010-01-01','2010-12-31'),(15670,8776,'SALARIO_ANUAL',5915,'24926.61','2010-01-01','2010-12-31'),(15671,8776,'SALARIO_ANUAL',5916,'23632.18','2010-01-01','2010-12-31'),(15672,8776,'SALARIO_ANUAL',5917,'22241.84','2010-01-01','2010-12-31'),(15673,8776,'SALARIO_ANUAL',5918,'21407.29','2010-01-01','2010-12-31'),(15674,8776,'SALARIO_ANUAL',5919,'20573.14','2010-01-01','2010-12-31'),(15675,8776,'SALARIO_ANUAL',5920,'18433.28','2011-01-01','2011-12-31'),(15676,8776,'SALARIO_ANUAL',5921,'17507.37','2011-01-01','2011-12-31'),(15677,8776,'SALARIO_ANUAL',5922,'16705.91','2011-01-01','2011-12-31'),(15678,8776,'SALARIO_ANUAL',5923,'14062.52','2011-01-01','2011-12-31'),(15679,8776,'SALARIO_ANUAL',5924,'9847.71','2011-01-01','2011-12-31'),(15680,8776,'SALARIO_ANUAL',5925,'14977.56','2011-01-01','2011-12-31'),(15681,8776,'SALARIO_ANUAL',5914,'28803.26','2011-01-01','2011-12-31'),(15682,8776,'SALARIO_ANUAL',5915,'25823.97','2011-01-01','2011-12-31'),(15683,8776,'SALARIO_ANUAL',5916,'24482.97','2011-01-01','2011-12-31'),(15684,8776,'SALARIO_ANUAL',5917,'23042.55','2011-01-01','2011-12-31'),(15685,8776,'SALARIO_ANUAL',5918,'22177.95','2011-01-01','2011-12-31'),(15686,8776,'SALARIO_ANUAL',5919,'21313.78','2011-01-01','2011-12-31'),(15687,8776,'SALARIO_ANUAL',5920,'18444.74','2012-01-01',NULL),(15688,8776,'SALARIO_ANUAL',5921,'17580.48','2012-01-01',NULL),(15689,8776,'SALARIO_ANUAL',5922,'16715.20','2012-01-01',NULL),(15690,8776,'SALARIO_ANUAL',5923,'14070.59','2012-01-01',NULL),(15691,8776,'SALARIO_ANUAL',5924,'9853.47','2012-01-01',NULL),(15692,8776,'SALARIO_ANUAL',5925,'14986.24','2012-01-01',NULL),(15693,8776,'SALARIO_ANUAL',5914,'28819.83','2012-01-01',NULL),(15694,8776,'SALARIO_ANUAL',5915,'25838.49','2012-01-01',NULL),(15695,8776,'SALARIO_ANUAL',5916,'24497.06','2012-01-01',NULL),(15696,8776,'SALARIO_ANUAL',5917,'23055.46','2012-01-01',NULL),(15697,8776,'SALARIO_ANUAL',5918,'22190.75','2012-01-01',NULL),(15698,8776,'SALARIO_ANUAL',5919,'21325.92','2012-01-01',NULL),(15699,8776,'SALARIO_MENSUAL',5926,'1200.00','2016-01-01',NULL),(15700,8784,'SALARIO_MENSUAL',5927,'1596.63','2014-01-01','2014-12-31'),(15701,8784,'SALARIO_MENSUAL',5928,'1480.35','2014-01-01','2014-12-31'),(15702,8784,'SALARIO_MENSUAL',5929,'1378.40','2014-01-01','2014-12-31'),(15703,8784,'SALARIO_MENSUAL',5930,'1280.52','2014-01-01','2014-12-31'),(15704,8784,'SALARIO_MENSUAL',5931,'1186.57','2014-01-01','2014-12-31'),(15705,8784,'SALARIO_MENSUAL',5932,'1115.41','2014-01-01','2014-12-31'),(15706,8784,'SALARIO_MENSUAL',5927,'1614.59','2015-01-01',NULL),(15707,8784,'SALARIO_MENSUAL',5928,'1497.00','2015-01-01',NULL),(15708,8784,'SALARIO_MENSUAL',5929,'1393.91','2015-01-01',NULL),(15709,8784,'SALARIO_MENSUAL',5930,'1294.92','2015-01-01',NULL),(15710,8784,'SALARIO_MENSUAL',5931,'1199.92','2015-01-01',NULL),(15711,8784,'SALARIO_MENSUAL',5932,'1127.96','2015-01-01',NULL),(15717,8776,'SALARIO_ANUAL',5936,'SMI*PAGAS*2','2015-01-01',NULL),(15718,8776,'SALARIO_ANUAL',5937,'SMI*PAGAS','2015-01-01',NULL),(15719,8776,'SALARIO_ANUAL',5933,'SMI*PAGAS*5','2015-01-01',NULL),(15720,8776,'SALARIO_ANUAL',5934,'SMI*PAGAS*4','2015-01-01',NULL),(15721,8776,'SALARIO_ANUAL',5935,'SMI*PAGAS*3','2015-01-01',NULL),(15722,8783,'SALARIO_MENSUAL',5938,'SMI*2','2016-01-01',NULL),(15723,8783,'SALARIO_MENSUAL',5939,'SMI','2016-01-01',NULL),(15724,0,'SALARIO_MENSUAL',5941,'ROUND(1272.57 * INCREMENTO, 2)','2015-04-01',NULL),(15725,0,'SALARIO_MENSUAL',5942,'ROUND(1216.34 * INCREMENTO, 2)','2015-04-01',NULL),(15726,0,'SALARIO_MENSUAL',5943,'ROUND(1144.94 * INCREMENTO, 2)','2015-04-01',NULL),(15728,0,'SALARIO_MENSUAL',5945,'ROUND(1066.63 * INCREMENTO, 2)','2015-04-01',NULL),(15729,0,'SALARIO_MENSUAL',5946,'ROUND(1565.06 * INCREMENTO, 2)','2015-04-01',NULL),(15730,0,'SALARIO_MENSUAL',5947,'ROUND(992.89 * INCREMENTO, 2)','2015-04-01',NULL),(15731,0,'SALARIO_MENSUAL',5948,'ROUND(1449.00 * INCREMENTO, 2)','2015-04-01',NULL),(15732,0,'SALARIO_MENSUAL',5949,'ROUND(918.28 * INCREMENTO, 2)','2015-04-01',NULL),(15733,0,'SALARIO_MENSUAL',5950,'ROUND(1336.63 * INCREMENTO, 2)','2015-04-01',NULL),(15734,0,'SALARIO_MENSUAL',5951,'ROUND(611.54 * INCREMENTO, 2)','2015-04-01',NULL),(15735,0,'SALARIO_MENSUAL',5952,'ROUND(648.54 * INCREMENTO, 2)','2015-04-01',NULL),(15736,0,'SALARIO_MENSUAL',5953,'ROUND(704.55 * INCREMENTO, 2)','2015-04-01',NULL),(15737,0,'SALARIO_MENSUAL',5954,'ROUND(593.46 * INCREMENTO, 2)','2015-04-01',NULL),(15738,0,'SALARIO_HORA',5955,'ROUND(6.46 * INCREMENTO, 2)','2015-04-01',NULL),(15754,0,'SALARIO_MENSUAL',5944,'ROUND(1740.65 * INCREMENTO, 2)','2015-04-01',NULL),(15755,0,'VALOR_CUATRIENIO_MENSUAL',5952,'ROUND(0.00 * INCREMENTO, 2)','2015-04-01',NULL),(15756,0,'VALOR_CUATRIENIO_MENSUAL',5953,'ROUND(0.00 * INCREMENTO, 2)','2015-04-01',NULL),(15757,0,'VALOR_CUATRIENIO_MENSUAL',5954,'ROUND(0.00 * INCREMENTO, 2)','2015-04-01',NULL),(15758,0,'VALOR_CUATRIENIO_MENSUAL',5955,'ROUND(0.00 * INCREMENTO, 2)','2015-04-01',NULL),(15769,0,'VALOR_CUATRIENIO_MENSUAL',5951,'ROUND(0.00 * INCREMENTO, 2)','2015-04-01',NULL),(15770,0,'VALOR_CUATRIENIO_MENSUAL',5941,'ROUND(59.13 * INCREMENTO, 2)','2015-04-01',NULL),(15771,0,'VALOR_CUATRIENIO_MENSUAL',5942,'ROUND(59.13 * INCREMENTO, 2)','2015-04-01',NULL),(15772,0,'VALOR_CUATRIENIO_MENSUAL',5943,'ROUND(51.68 * INCREMENTO, 2)','2015-04-01',NULL),(15773,0,'VALOR_CUATRIENIO_MENSUAL',5944,'ROUND(81.66 * INCREMENTO, 2)','2015-04-01',NULL),(15774,0,'VALOR_CUATRIENIO_MENSUAL',5945,'ROUND(51.68 * INCREMENTO, 2)','2015-04-01',NULL),(15775,0,'VALOR_CUATRIENIO_MENSUAL',5946,'ROUND(67.35 * INCREMENTO, 2)','2015-04-01',NULL),(15776,0,'VALOR_CUATRIENIO_MENSUAL',5947,'ROUND(43.46 * INCREMENTO, 2)','2015-04-01',NULL),(15777,0,'VALOR_CUATRIENIO_MENSUAL',5948,'ROUND(67.35 * INCREMENTO, 2)','2015-04-01',NULL),(15778,0,'VALOR_CUATRIENIO_MENSUAL',5949,'ROUND(43.46 * INCREMENTO, 2)','2015-04-01',NULL),(15779,0,'VALOR_CUATRIENIO_MENSUAL',5950,'ROUND(67.35 * INCREMENTO, 2)','2015-04-01',NULL),(15783,0,'PLUS_TRANSPORTE_URBANO',5955,'ROUND( 0.00 * INCREMENTO,2)','2015-04-01',NULL),(15785,0,'PLUS_TRANSPORTE_URBANO',5952,'ROUND( 55.71 * INCREMENTO,2)','2015-04-01',NULL),(15786,0,'PLUS_TRANSPORTE_URBANO',5953,'ROUND( 55.71 * INCREMENTO,2)','2015-04-01',NULL),(15787,0,'PLUS_TRANSPORTE_URBANO',5954,'ROUND( 55.71 * INCREMENTO,2)','2015-04-01',NULL),(15788,0,'PLUS_TRANSPORTE_URBANO',5951,'ROUND( 55.71 * INCREMENTO,2)','2015-04-01',NULL),(15884,8776,'SALARIO_MENSUAL',6082,'SMI * 3.0','2017-01-01',NULL),(15885,8776,'SALARIO_MENSUAL',6083,'SMI * 2.0','2017-01-01',NULL),(15886,8776,'SALARIO_MENSUAL',6084,'SMI * 1.5','2017-01-01',NULL),(15887,8776,'SALARIO_MENSUAL',6085,'SMI * 1.2','2017-01-01',NULL),(15888,8776,'SALARIO_MENSUAL',6086,'SMI * 1.0','2017-01-01',NULL),(15889,8776,'SALARIO_ANUAL',6088,'ROUND(SMI * 2,2)','2017-01-01',NULL),(15890,8776,'SALARIO_ANUAL',6089,'ROUND(SMI * 3,2)','2017-01-01',NULL),(15891,8776,'SALARIO_ANUAL',6087,'SMI','2017-01-01',NULL);
/*!40000 ALTER TABLE `agreement_level_data` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `agreement_payment`
--

DROP TABLE IF EXISTS `agreement_payment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `agreement_payment` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `agreement` int(4) NOT NULL COMMENT 'Convenio',
  `payment_concept` int(4) DEFAULT NULL COMMENT 'Identificador unico del concepto',
  `type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de complemento Salarial',
  `expression` varchar(1024) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Importe',
  `description` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion',
  `start_date` date NOT NULL COMMENT 'Fecha de inicio',
  `end_date` date DEFAULT NULL COMMENT 'Fecha de finalizacion',
  `month` tinyint(2) DEFAULT NULL COMMENT 'Mes de la percepcion',
  `salary_type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de Nomina/Recibo',
  `description_decorable` tinyint(2) NOT NULL DEFAULT '0',
  `irpf_expression` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Importe tributable',
  `quote_expression` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Importe cotizable',
  PRIMARY KEY (`id`),
  KEY `IDX_AGREEMENT_PAYMENT_PAYMENT_CONCEPT` (`payment_concept`),
  KEY `IDX_AGREEMENT_PAYMENT_AGREEMENT` (`agreement`),
  KEY `IDX_AGREEMENT_PAYMENT_DOMAIN` (`domain`),
  CONSTRAINT `FK_AGREEMENT_PAYMENT_AGREEMENT` FOREIGN KEY (`agreement`) REFERENCES `agreement` (`id`),
  CONSTRAINT `FK_AGREEMENT_PAYMENT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_AGREEMENT_PAYMENT_PAYMENT_CONCEPT` FOREIGN KEY (`payment_concept`) REFERENCES `payment_concept` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=111 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Percepciones';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `agreement_payment`
--

LOCK TABLES `agreement_payment` WRITE;
/*!40000 ALTER TABLE `agreement_payment` DISABLE KEYS */;
INSERT INTO `agreement_payment` VALUES (-55,8776,-1164,6266,1,'/*user*/ SALARIO_BASE * 0.10 /**/ * DIAS_TRABAJADOS / DIAS_MES','PLUS SALARIAL','2016-06-01',NULL,NULL,0,0,'_P','_P'),(-54,8776,-1164,6179,1,'/*user*/SALARIO_MENSUAL/**/ * DIAS_TRABAJADOS / DIAS_MES ','SALARIO BASE ','2016-06-01',NULL,NULL,0,0,'_P','_P'),(1,8776,1156,6178,1,'/*user*/SALARIO_ANUAL/**/ / PAGAS * DIAS_TRABAJADOS / DIAS_MES ','[1]SALARIO BASE','2010-06-01',NULL,NULL,0,0,'_P','_P'),(2,8776,1156,6182,1,'COCIENTE(AÑO(INICIO_NOMINA)-MAX(1996, AÑO(INICIO_ANTIGUEDAD)),4) * SALARIO_BASE * 4 / 100','[2]COMPLEMENTO DE ANTIGÜEDAD ( > 1996 )','2010-06-01',NULL,NULL,0,0,'_P','_P'),(3,8776,1156,6194,4,'/*user*/(SALARIO_BASE + ANTIGUEDAD) *  ( 1 + MAX(0,DIAS(INICIO_CONTRATO,INICIO_NOMINA))  / DIAS_TRABAJADOS) /6/**/','[4]PAGA EXTRAORDINARIA DICIEMBRE','2010-06-01',NULL,11,1,0,'_P','_P/2'),(4,8776,1156,6194,4,'(SALARIO_BASE + ANTIGUEDAD) *  ( 1 + MAX(0,DIAS(INICIO_CONTRATO,INICIO_NOMINA))  / DIAS_TRABAJADOS) /6','[3]PAGA EXTRAORDINARIA JULIO','2010-06-01',NULL,6,1,0,'_P','_P/2'),(5,8776,1156,6266,1,'/*user*/SALARIO_ANUAL / JORNADA_LABORAL * HORAS_NOCHE *  20 /100/**/ * DIAS_TRABAJADOS / DIAS_MES','[5]PLUS NOCTURNIDAD','2010-06-01',NULL,NULL,0,0,'_P','_P'),(6,8776,1156,6182,1,'AÑO(INICIO_ANTIGUEDAD) <= 1993?SALARIO_BASE * 4 /100: REMOVE()','[2]COMPLEMENTO DE ANTIGÜEDAD ( 1993-1996 )','2010-06-01',NULL,NULL,0,0,'_P','_P'),(7,8776,1156,6182,1,'AÑO(INICIO_ANTIGUEDAD) <= 1989?(1992- AÑO(INICIO_ANTIGUEDAD))/3 * SALARIO_BASE * 5 /100: REMOVE()','[2]COMPLEMENTO DE ANTIGÜEDAD ( < 1993 )','2010-06-01',NULL,NULL,0,0,'_P','_P'),(9,8778,1156,-2,NULL,NULL,NULL,'2010-06-01',NULL,NULL,0,0,NULL,NULL),(10,8776,1156,6186,50,'/*read-only*/IMPORTE_KM * KMS/**/','[6] KILOMETRAJE (@{IMPORTE_KM} € x @{KMS} KMS)','2010-06-01',NULL,NULL,0,0,'EXCESO(0.19 * KMS)','EXCESO(0.19 * KMS)'),(12,8776,1156,-3,NULL,NULL,NULL,'2010-06-01',NULL,NULL,0,0,NULL,NULL),(13,8777,1156,6183,1,'PLUS_EXTRA_SALARIAL','PLUS REGIMEN GENERAL ( VARIABLE == DEVENGO )','2010-06-01',NULL,NULL,0,0,'_P','_P'),(14,8780,1156,6266,1,'/*user*/ 0.00 /**/ * DIAS_TRABAJADOS / DIAS_MES','[8] PLUS REGIMÉN ESPECIAL AGRARIO','2010-06-01',NULL,NULL,0,0,'_P','_P'),(15,8780,1156,6266,1,'/*user*/SALARIO_ANUAL / JORNADA_LABORAL * HORAS_NOCHE *  20 /100/**/ * DIAS_TRABAJADOS / DIAS_MES','[5] PLUS NOCTURNIDAD','2010-06-01',NULL,NULL,0,0,'_P','_P'),(16,8776,1157,6194,4,'INPUT(\"/*user*//**/\",PAGA_EXTRA_HELP)','PAGA EXTRAORDINARIA','2016-05-01',NULL,NULL,0,0,'_P','_P'),(17,8776,1157,6182,1,'INPUT(\"/*user*//**/\",ANTIGUEDAD_HELP)','COMPLEMENTO PERSONAL DE ANTIGÜEDAD','2016-05-01',NULL,NULL,0,0,'_P','_P'),(22,8776,1158,6194,4,'INPUT(\"/*user*/SALARIO_BASE/**/\",PAGA_EXTRA_HELP)','PAGA EXTRAORDINARIA DE VERANO','2016-01-01',NULL,6,1,0,'_P','_P/12'),(23,8776,1158,6194,4,'INPUT(\"/*user*/SALARIO_BASE/**/\",PAGA_EXTRA_HELP)','PAGA EXTRAORDINARIA DE NAVIDAD','2016-01-01',NULL,11,1,0,'_P','_P/12'),(24,8776,1158,6194,4,'INPUT(\"/*user*/BENEFICIOS/**/\",PAGA_EXTRA_HELP)','PAGA EXTRAORDINARIA DE BENIFICIOS','2016-01-01',NULL,0,1,0,'_P','_P/12'),(25,8776,1158,6179,1,'/*user*/SALARIO_MENSUAL/**/ * DIAS_TRABAJADOS / DIAS_MES ','SALARIO BASE MENSUAL','2016-01-01',NULL,NULL,0,0,'_P','_P'),(26,8776,1159,6178,1,'/*user*/SALARIO_ANUAL/**/ / PAGAS * DIAS_TRABAJADOS / DIAS_MES ',' SALARIO BASE','2009-01-01',NULL,NULL,0,0,'_P','_P'),(27,8776,1159,6182,1,'INPUT(\"/*user*/ANTIGÜEDAD(SALARIO_BASE * 0.05, TRIENIO)/**/\",ANTIGUEDAD_HELP)','COMPLEMENTO PERSONAL DE ANTIGÜEDAD','2009-01-01',NULL,NULL,0,0,'_P','_P'),(28,8776,1159,6194,4,'INPUT(\"/*user*/SALARIO_BASE + ANTIGUEDAD/**/\",PAGA_EXTRA_HELP)','PAGA EXTRAORDINARIA DE MARZO','2009-01-01',NULL,2,1,0,'_P','_P/12'),(29,8776,1159,6194,4,'INPUT(\"/*user*/SALARIO_BASE + ANTIGUEDAD/**/\",PAGA_EXTRA_HELP)','PAGA EXTRAORDINARIA DE JULIO','2009-01-01',NULL,11,1,0,'_P','_P/12'),(30,8776,1159,6194,4,'INPUT(\"/*user*/SALARIO_BASE + ANTIGUEDAD/**/\",PAGA_EXTRA_HELP)','PAGA EXTRAORDINARIA DE DICEMBRE','2009-01-01',NULL,6,1,0,'_P','_P/12'),(31,8776,1159,6186,50,'/*read-only*/IMPORTE_KM * KMS/**/','KILOMETRAJE COCHE DEL EMPLEADO ( @{IMPORTE_KM} € X @{KMS} KMS )','2009-01-01',NULL,NULL,0,0,'EXCESO(0.19 * KMS)','EXCESO(0.19 * KMS)'),(32,8776,1159,6254,55,'isdef DIAS_ENFERMEDAD_PROFESIONAL ?/*user*/GTZDO(SALARIO_BASE+ANTIGUEDAD,1)/**/: REMOVE()','MEJORAS PREST.SS.ENFERMEDAD PROFESIONAL','2009-01-01',NULL,NULL,0,0,'_P',NULL),(33,8776,1159,6253,55,'isdef DIAS_ENFERMEDAD_COMUN ?/*user*/GTZDO(SALARIO_BASE+ANTIGUEDAD,16)/**/: REMOVE()','MEJORAS PREST.SS.ENFERMEDAD COMÚN','2009-01-01',NULL,NULL,0,0,'_P',NULL),(34,8776,1159,6253,55,'isdef DIAS_ENFERMEDAD_COMUN ?/*user*/GTZDO((SALARIO_BASE+ANTIGUEDAD)*(3+12*0.40+1.25*0.60),16,16)/**/: REMOVE()','MEJORAS PREST.SS.ENFERMEDAD COMÚN ( 15 DÍAS INICIALES)','2009-01-01',NULL,NULL,0,0,'_P',NULL),(35,8776,1160,6179,1,'/*user*/SALARIO_MENSUAL/**/ * DIAS_TRABAJADOS / DIAS_MES ','SALARIO BASE MENSUAL','2016-01-01',NULL,NULL,0,0,'_P','_P'),(36,8776,1160,6194,4,'INPUT(\"/*user*/ SALARIO_BASE + GARANTIZADO/**/\",PAGA_EXTRA_HELP)','PAGA EXTRAORDINARIA DICIEMBRE SEMESTRAL','2016-01-01',NULL,11,1,0,'_P','SALARIO_BASE/12'),(37,8776,1160,6194,4,'INPUT(\"/*user*/SALARIO_BASE + GARANTIZADO/**/\",PAGA_EXTRA_HELP)','PAGA EXTRAORDINARIA JULIO SEMESTRAL','2016-01-01',NULL,6,1,0,'_P','SALARIO_BASE/12'),(38,8776,1160,6250,55,'GTZDO(SALARIO_BASE)','MEJORAS PREST.SS.INCAPACIDAD TEMPORAL (GARANTIZADO)','2016-01-01',NULL,NULL,0,0,'_P',NULL),(39,8784,1161,6179,1,'/*user*/SALARIO_MENSUAL/**/ * DIAS_TRABAJADOS / DIAS_MES ','SALARIO BASE MENSUAL','2014-01-01',NULL,NULL,0,0,'_P','_P'),(41,8784,1161,6194,4,'INPUT(\"/*user*/SALARIO_BASE + ANTIGUEDAD + GARANTIZADO/**/\",PAGA_EXTRA_HELP)','PAGA EXTRAORDINARIA JULIO','2014-01-01',NULL,6,1,0,'_P','(SALARIO_BASE + ANTIGUEDAD)/12'),(42,8784,1161,6194,4,'INPUT(\"/*user*/SALARIO_BASE + ANTIGUEDAD + GARANTIZADO/**/\",PAGA_EXTRA_HELP)','PAGA EXTRAORDINARIA DICIEMBRE','2014-01-01',NULL,11,1,0,'_P','(SALARIO_BASE + ANTIGUEDAD)/12'),(43,8784,1161,6182,1,'INPUT(\"/*user*/AD_PERSONAM/**/\",ANTIGUEDAD_HELP)','COMPLEMENTO POR ANTIGÜEDAD AD PERSONAM','2014-01-01',NULL,NULL,0,0,'_P','_P'),(44,8784,1161,6253,55,'isdef DIAS_ENFERMEDAD_COMUN ?/*user*/GTZDO(SALARIO_BASE+ANTIGUEDAD,4)/**/: REMOVE()','MEJORAS PREST.SS.ENFERMEDAD COMÚN','2014-01-01',NULL,NULL,0,0,'_P',NULL),(45,8784,1161,6254,55,'isdef DIAS_ENFERMEDAD_PROFESIONAL ?/*user*/GTZDO(SALARIO_BASE+ANTIGUEDAD)/**/: REMOVE()','MEJORAS PREST.SS.ENFERMEDAD PROFESIONAL','2014-01-01',NULL,NULL,0,0,'_P',NULL),(46,8776,1160,6194,4,'INPUT(\"/*user*/ SALARIO_BASE + GARANTIZADO/**/\",PAGA_EXTRA_HELP)','PAGA EXTRAORDINARIA MARZO ANUAL','2016-01-01',NULL,2,1,0,'_P','SALARIO_BASE/12'),(47,8776,1162,6178,1,'(/*user*/SALARIO_ANUAL + AUMENTO/**/) / PAGAS * DIAS_TRABAJADOS / DIAS_MES ','[1] SALARIO BASE ANUAL','2015-01-01',NULL,NULL,0,0,'_P','_P'),(48,8776,1162,6194,4,'INPUT(\"/*user*/SALARIO_BASE  + ANTIGUEDAD/**/\",PAGA_EXTRA_HELP)','PAGA EXTRAORDINARIA VERANO','2015-01-01',NULL,6,1,0,'_P','_P/12'),(50,8776,1162,6182,1,'INPUT(\"/*user*/ANTIGÜEDAD(SALARIO_BASE * 0.04, TRIENIO)/**/\",ANTIGUEDAD_HELP)','[2] COMPLEMENTO PERSONAL DE ANTIGÜEDAD','2015-01-01',NULL,NULL,0,0,'_P','_P'),(51,8783,1163,6179,1,'/*user*/SALARIO_MENSUAL/**/ * DIAS_TRABAJADOS / DIAS_MES ','SALARIO BASE MENSUAL','2016-01-01',NULL,NULL,0,0,'_P','_P'),(52,8783,1163,6194,4,'INPUT(\"/*user*/SALARIO_BASE/**/\",PAGA_EXTRA_HELP)','PAGA EXTRAORDINARIA DICIEMBRE','2016-01-01',NULL,11,1,0,'_P','_P/12'),(53,8783,1163,6194,4,'INPUT(\"/*user*/SALARIO_BASE/**/\",PAGA_EXTRA_HELP)','PAGA EXTRAORDINARIA VERANO','2016-01-01',NULL,6,1,0,'_P','_P/12'),(54,0,1164,6179,1,'/*user*/SALARIO_MENSUAL/**/ * DIAS_TRABAJADOS / DIAS_MES ','SALARIO BASE MENSUAL','2014-01-01',NULL,NULL,0,0,'_P','_P'),(55,0,1164,6194,4,'INPUT(\"/*user*/SALARIO_BASE/**/\",PAGA_EXTRA_HELP)','PAGA EXTRAORDINARIA NAVIDAD','2014-01-01',NULL,11,1,0,'_P','_P'),(56,0,1164,6194,4,'INPUT(\"/*user*/SALARIO_BASE/**/\",PAGA_EXTRA_HELP)','PAGA EXTRAORDINARIA VERANO','2014-01-01',NULL,6,1,0,'_P','_P'),(57,0,1165,6179,1,'/*user*/SALARIO_MENSUAL/**/ * DIAS_TRABAJADOS / DIAS_MES ','SALARIO BASE MENSUAL','2015-04-01',NULL,NULL,0,0,'_P','_P'),(58,0,1165,6194,56,'INPUT(\"/*user*/SALARIO_BASE + ANTIGUEDAD + PAGA_BENEFICIOS/**/\",PAGA_EXTRA_HELP)','PAGA EXTRAORDINARIA DICIEMBRE','2015-04-01',NULL,11,1,0,'_P','SALARIO_BASE + ANTIGUEDAD)/12'),(60,0,1165,6194,4,'INPUT(\"/*user*/SALARIO_BASE + ANTIGUEDAD + PAGA_BENEFICIOS/**/\",PAGA_EXTRA_HELP)','PAGA EXTRAORDINARIA JULIO','2015-04-01',NULL,6,1,0,'_P','(SALARIO_BASE + ANTIGUEDAD)/12'),(61,0,1165,6182,1,'INPUT(\"/*user*/ANTIGÜEDAD(VALOR_CUATRIENIO_MENSUAL * DIAS_TRABAJADOS / DIAS_MES, CUATRIENIO) /**/\",ANTIGUEDAD_HELP)','AUMENTO PERIÓDICO POR TIEMPO DE SERVICIO','2015-04-01',NULL,NULL,0,0,'_P','_P'),(62,0,1165,6181,1,'( !TIEMPO_COMPLETO  && isdef SALARIO_HORA ) ? /*user*/SALARIO_HORA * HORAS_TRABAJADAS/**/: HIDE()','SALARIO BASE ( @{SALARIO_HORA} € X @{HORAS_TRABAJADAS} HORAS )','2015-04-01',NULL,NULL,0,0,'_P','_P'),(63,0,1165,6183,1,'PLUS_TRANSPORTE_URBANO * DIAS_TRABAJADOS / DIAS_MES','PLUS EXTRA SALARIAL DE TRANSPORTE URBANO','2015-04-01',NULL,NULL,0,0,'_P','_P'),(64,0,1165,6230,43,'DIETA_COMPLETA * DIAS_DIETA_COMPLETA','DIETAS Y VIAJES','2015-04-01',NULL,NULL,0,0,'_P','_P'),(65,0,1165,-4,NULL,NULL,NULL,'2015-04-01',NULL,NULL,0,0,NULL,NULL),(66,0,1165,-5,NULL,NULL,NULL,'2015-04-01',NULL,NULL,0,0,NULL,NULL),(67,0,1165,-6,NULL,NULL,NULL,'2015-04-01',NULL,NULL,0,0,NULL,NULL),(68,0,1165,6193,3,'IMPORTE_HORA_EXTRA * HORAS_EXTRAS','HORAS EXTRAORDINARIAS','2015-04-01',NULL,NULL,0,0,'_P','_P'),(69,0,1165,6193,3,'IMPORTE_HORA_EXTRA * 2 * HORAS_EXTRAS_FESTIVOS','HORAS EXTRAORDINARIAS ( DOMINGOS y FESTIVOS )','2015-04-01',NULL,NULL,0,0,'_P','_P'),(82,8776,1169,6182,1,'INPUT(\"/*user*/ANTIGÜEDAD(SALARIO_BASE * 0.04, CUATRIENIO)/**/\",ANTIGUEDAD_HELP)','COMPLEMENTO PERSONAL DE ANTIGÜEDAD','2017-01-01',NULL,NULL,0,0,'_P','_P'),(83,8776,1169,6250,55,NULL,'MEJORAS PREST.SS.INCAPACIDAD TEMPORAL (GARANTIZADO)','2017-01-01',NULL,NULL,0,0,'_P',NULL),(84,8776,1169,6194,4,'INPUT(\"/*user*/SALARIO_BASE + ANTIGUEDAD/**/\",PAGA_EXTRA_HELP)','PAGA EXTRAORDINARIA NAVIDAD','2017-01-01',NULL,NULL,1,0,'_P','_P/12'),(85,8776,1169,6194,4,'INPUT(\"/*user*/SALARIO_BASE + ANTIGUEDAD/**/\",PAGA_EXTRA_HELP)','PAGA EXTRAORDINARIA VERANO','2017-01-01',NULL,NULL,1,0,'_P','_P/12'),(86,8776,1169,6179,1,'/*user*/SALARIO_MENSUAL/**/ * DIAS_TRABAJADOS / DIAS_MES ','SALARIO BASE MENSUAL','2017-01-01',NULL,NULL,0,0,'_P','_P'),(87,8776,1175,6182,1,'INPUT(\"/*user*/ANTIGÜEDAD(SALARIO_BASE * 0.04, CUATRIENIO)/**/\",ANTIGUEDAD_HELP)','COMPLEMENTO PERSONAL DE ANTIGÜEDAD','2017-01-01',NULL,NULL,0,0,'_P','_P'),(88,8776,1175,6250,55,NULL,'MEJORAS PREST.SS.INCAPACIDAD TEMPORAL (GARANTIZADO)','2017-01-01',NULL,NULL,0,0,'_P',NULL),(89,8776,1175,6194,4,'INPUT(\"/*user*/SALARIO_BASE + ANTIGUEDAD/**/\",PAGA_EXTRA_HELP)','PAGA EXTRAORDINARIA NAVIDAD','2017-01-01',NULL,NULL,1,0,'_P','_P/12'),(90,8776,1175,6194,4,'INPUT(\"/*user*/SALARIO_BASE + ANTIGUEDAD/**/\",PAGA_EXTRA_HELP)','PAGA EXTRAORDINARIA VERANO','2017-01-01',NULL,NULL,1,0,'_P','_P/12'),(91,8776,1175,6179,1,'/*user*/SALARIO_MENSUAL/**/ * DIAS_TRABAJADOS / DIAS_MES ','SALARIO BASE MENSUAL','2017-01-01',NULL,NULL,0,0,'_P','_P'),(92,8776,1192,6182,1,'INPUT(\"/*user*/ANTIGÜEDAD(SALARIO_BASE * 0.04, CUATRIENIO)/**/\",ANTIGUEDAD_HELP)','COMPLEMENTO PERSONAL DE ANTIGÜEDAD','2017-01-01','2017-01-31',NULL,0,0,'_P','_P'),(93,8776,1192,6250,55,NULL,'MEJORAS PREST.SS.INCAPACIDAD TEMPORAL (GARANTIZADO)','2017-01-01','2017-01-31',NULL,0,0,'_P',NULL),(96,8776,1192,6179,1,'/*user*/SALARIO_MENSUAL/**/ * DIAS_TRABAJADOS / DIAS_MES ','SALARIO BASE MENSUAL','2017-01-01','2017-01-31',NULL,0,0,'_P','_P'),(97,8776,1192,6194,4,'INPUT(\"/*user*/SALARIO_BASE + ANTIGUEDAD/**/\",PAGA_EXTRA_HELP)','PAGA EXTRAORDINARIA NAVIDAD','2017-01-01','2017-01-31',11,1,0,'_P','_P'),(98,8776,1192,6179,1,'/*user*/SALARIO_MENSUAL/**/ * DIAS_TRABAJADOS / DIAS_MES ','SALARIO BASE MENSUAL','2017-02-01',NULL,NULL,0,0,'_P','_P'),(99,8776,1192,6194,4,'INPUT(\"/*user*/SALARIO_BASE + ANTIGUEDAD/**/\",PAGA_EXTRA_HELP)','PAGA EXTRAORDINARIA NAVIDAD','2017-02-01',NULL,11,1,0,'_P','_P'),(100,8776,1192,6182,1,'INPUT(\"/*user*/ANTIGÜEDAD(SALARIO_BASE * 0.04, CUATRIENIO)/**/\",ANTIGUEDAD_HELP)','COMPLEMENTO PERSONAL DE ANTIGÜEDAD','2017-02-01',NULL,NULL,0,0,'_P','_P'),(101,8776,1192,6250,55,NULL,'MEJORAS PREST.SS.INCAPACIDAD TEMPORAL (GARANTIZADO)','2017-02-01',NULL,NULL,0,0,'_P',NULL),(102,8776,1193,6194,4,'INPUT(\"/*user*/SALARIO_BASE + PLUS_SALARIAL/**/\",PAGA_EXTRA_HELP)','[7]PAGA EXTRAORDINARIA BENEFICIOS 2º TRIMESTRE.','2017-01-01',NULL,6,1,0,'_P','PRORRATEAR()'),(103,8776,1193,6178,1,'/*user*/SALARIO_ANUAL/**/ / PAGAS * DIAS_TRABAJADOS / DIAS_MES ','[1]SALARIO BASE','2017-01-01',NULL,NULL,0,0,'_P','_P'),(104,8776,1193,6194,4,'INPUT(\"/*user*/SALARIO_BASE  + PLUS_SALARIAL/**/\",PAGA_EXTRA_HELP)','[5]PAGA EXTRAORDINARIA BENECIFICOS ANUAL','2017-01-01',NULL,0,1,0,'_P','PRORRATEAR()'),(105,8776,1193,6266,1,'/*user*/ PLUS_SALARIAL /**/ * DIAS_TRABAJADOS / DIAS_MES','[2]PLUS SALARIAL','2017-01-01',NULL,NULL,0,0,'_P','_P'),(106,8776,1193,6194,4,'INPUT(\"/*user*/SALARIO_BASE + PLUS_SALARIAL/**/\",PAGA_EXTRA_HELP)','[8]PAGA EXTRAORDINARIA BENEFICIOS 3º TRIMESTRE','2017-01-01',NULL,9,1,0,'_P','PRORRATEAR()'),(107,8776,1193,6194,4,'INPUT(\"/*user*/SALARIO_BASE + PLUS_SALARIAL/**/\",PAGA_EXTRA_HELP)','[3]PAGA EXTRAORDINARIA NAVIDAD','2017-01-01',NULL,11,1,0,'_P','PRORRATEAR()'),(108,8776,1193,6194,4,'INPUT(\"/*user*/ SALARIO_BASE +  PLUS_SALARIAL/**/\",PAGA_EXTRA_HELP)','[9]PAGA EXTRAORDINARIA BENEFICIOS 4º TRIMESTRE','2017-01-01',NULL,0,1,0,'_P','PRORRATEAR()'),(109,8776,1193,6194,4,'INPUT(\"/*user*/SALARIO_BASE + PLUS_SALARIAL/**/\",PAGA_EXTRA_HELP)','[6]PAGA EXTRAORDINARIA BENEFICIOS 1º TRIMESTRE','2017-01-01',NULL,3,1,0,'_P','PRORRATEAR()'),(110,8776,1193,6194,4,'INPUT(\"/*user*/SALARIO_BASE + PLUS_SALARIAL/**/\",PAGA_EXTRA_HELP)','[4]PAGA EXTRAORDINARIA VERANO','2017-01-01',NULL,6,1,0,'_P','PRORRATEAR()');
/*!40000 ALTER TABLE `agreement_payment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `alarm`
--

DROP TABLE IF EXISTS `alarm`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `alarm` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la Alarma',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `description` text COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion de la Alarma',
  `alarm_date` datetime NOT NULL COMMENT 'Fecha y hora de ejecucion de la Alarma',
  `status` tinyint(2) DEFAULT NULL COMMENT 'Estado de la Alarma',
  `source` tinyint(2) NOT NULL COMMENT 'Origen de la Alarma',
  `source_id` int(4) DEFAULT NULL COMMENT 'Identificador del origen de la Alarma',
  `user_id` int(4) DEFAULT NULL COMMENT 'Identificador del Usuario asociado a la Alarma',
  `priority` tinyint(2) NOT NULL COMMENT 'Prioridad de la Alarma',
  PRIMARY KEY (`id`),
  KEY `IDX_ALARM_USER` (`user_id`),
  KEY `IDX_ALARM_DOMAIN` (`domain`),
  CONSTRAINT `FK_ALARM_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_ALARM_USER` FOREIGN KEY (`user_id`) REFERENCES `user` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Alarmas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `alarm`
--

LOCK TABLES `alarm` WRITE;
/*!40000 ALTER TABLE `alarm` DISABLE KEYS */;
/*!40000 ALTER TABLE `alarm` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `allotment`
--

DROP TABLE IF EXISTS `allotment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `allotment` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `hotel` int(4) NOT NULL COMMENT 'Identificador del Hotel',
  `rate_code` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo de Cupo',
  `agency` int(4) DEFAULT NULL COMMENT 'Identificador de la agencia de viajes',
  `agency_group` int(4) DEFAULT NULL COMMENT 'Identificador del Grupo de agencias',
  `start_date` date NOT NULL COMMENT 'Fecha de inicio del Cupo',
  `end_date` date NOT NULL COMMENT 'Fecha de fin del Cupo',
  `quantity` int(4) DEFAULT '0' COMMENT 'Cupo de Habitaciones',
  `remarks` text COLLATE latin1_spanish_ci COMMENT 'Comentarios',
  `active` tinyint(1) NOT NULL COMMENT 'Indica si el Cupo esta activo o no',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_ALLOTMENT_DOMAIN` (`domain`),
  KEY `IDX_ALLOTMENT_HOTEL` (`hotel`),
  KEY `IDX_ALLOTMENT_AGENCY` (`agency`),
  KEY `IDX_ALLOTMENT_AGENCY_GROUP` (`agency_group`),
  CONSTRAINT `FK_ALLOTMENT_AGENCY` FOREIGN KEY (`agency`) REFERENCES `customer` (`registry`),
  CONSTRAINT `FK_ALLOTMENT_AGENCY_GROUP` FOREIGN KEY (`agency_group`) REFERENCES `invoicing_group` (`id`),
  CONSTRAINT `FK_ALLOTMENT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_ALLOTMENT_HOTEL` FOREIGN KEY (`hotel`) REFERENCES `hotel` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Cupos de seguridad';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `allotment`
--

LOCK TABLES `allotment` WRITE;
/*!40000 ALTER TABLE `allotment` DISABLE KEYS */;
/*!40000 ALTER TABLE `allotment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `allotment_item`
--

DROP TABLE IF EXISTS `allotment_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `allotment_item` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `allotment` int(4) NOT NULL COMMENT 'Identificador del Cupo de seguridad',
  `item` int(4) NOT NULL COMMENT 'Identificador del Tipo de Habitacion',
  PRIMARY KEY (`id`),
  KEY `IDX_ALLOTMENT_ITEM_DOMAIN` (`domain`),
  KEY `IDX_ALLOTMENT_ITEM_ALLOTMENT` (`allotment`),
  KEY `IDX_ALLOTMENT_ITEM_ITEM` (`item`),
  CONSTRAINT `FK_ALLOTMENT_ITEM_ALLOTMENT` FOREIGN KEY (`allotment`) REFERENCES `allotment` (`id`),
  CONSTRAINT `FK_ALLOTMENT_ITEM_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_ALLOTMENT_ITEM_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Tipos de Habitacion por Cupo';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `allotment_item`
--

LOCK TABLES `allotment_item` WRITE;
/*!40000 ALTER TABLE `allotment_item` DISABLE KEYS */;
/*!40000 ALTER TABLE `allotment_item` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `allotment_tariff`
--

DROP TABLE IF EXISTS `allotment_tariff`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `allotment_tariff` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `allotment` int(4) NOT NULL COMMENT 'Identificador del Cupo de seguridad',
  `tariff` int(4) NOT NULL COMMENT 'Identificador de la Tarifa',
  PRIMARY KEY (`id`),
  KEY `IDX_ALLOTMENT_TARIFF_DOMAIN` (`domain`),
  KEY `IDX_ALLOTMENT_TARIFF_ALLOTMENT` (`allotment`),
  KEY `IDX_ALLOTMENT_TARIFF_TARIFF` (`tariff`),
  CONSTRAINT `FK_ALLOTMENT_TARIFF_ALLOTMENT` FOREIGN KEY (`allotment`) REFERENCES `allotment` (`id`),
  CONSTRAINT `FK_ALLOTMENT_TARIFF_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_ALLOTMENT_TARIFF_TARIFF` FOREIGN KEY (`tariff`) REFERENCES `tariff` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Tarifas por Cupo';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `allotment_tariff`
--

LOCK TABLES `allotment_tariff` WRITE;
/*!40000 ALTER TABLE `allotment_tariff` DISABLE KEYS */;
/*!40000 ALTER TABLE `allotment_tariff` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `alumn_loan`
--

DROP TABLE IF EXISTS `alumn_loan`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `alumn_loan` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Prestamo',
  `domain` int(4) NOT NULL DEFAULT '1' COMMENT 'Identificador del Dominio',
  `customer` int(4) NOT NULL COMMENT 'Alumno al que se le realizo el Prestamo',
  `material` varchar(16) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Material prestado',
  `loan_date` date NOT NULL COMMENT 'Fecha del Prestamo',
  `end_date` date DEFAULT NULL COMMENT 'Fecha devolucion del material',
  `comments` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Observaciones',
  PRIMARY KEY (`id`),
  KEY `IDX_ALUMN_LOAN_CUSTOMER` (`customer`),
  KEY `IDX_ALUMN_LOAN_DOMAIN` (`domain`),
  CONSTRAINT `FK_ALUMN_LOAN_CUSTOMER` FOREIGN KEY (`customer`) REFERENCES `customer` (`registry`),
  CONSTRAINT `FK_ALUMN_LOAN_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Prestamos a Alumnos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `alumn_loan`
--

LOCK TABLES `alumn_loan` WRITE;
/*!40000 ALTER TABLE `alumn_loan` DISABLE KEYS */;
/*!40000 ALTER TABLE `alumn_loan` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `amortization`
--

DROP TABLE IF EXISTS `amortization`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `amortization` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `description` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion del inmovilizado',
  `initial_date` date NOT NULL COMMENT 'Fecha de inicio de la Amortizacion',
  `deadline` date DEFAULT NULL COMMENT 'Fecha de baja de la Amortizacion',
  `amount` double NOT NULL DEFAULT '0' COMMENT 'Importe a amortizar.',
  `fee_period` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Periodo de las cuotas de Amortizacion',
  `sale_amount` double DEFAULT NULL COMMENT 'Importe de la venta',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios',
  `invest_asset` int(4) DEFAULT NULL COMMENT 'Identificador del Bien afecto',
  `fixed_asset_account` int(4) NOT NULL COMMENT 'Cuenta de inmovilizado',
  `accumulated_account` int(4) NOT NULL COMMENT 'Cuenta de Amortizacion acumulada',
  `allocation_account` int(4) NOT NULL COMMENT 'Cuenta para la dotacion de la Amortizacion',
  `percentage` double DEFAULT '0' COMMENT 'Porcentaje de Amortizacion',
  `security_level` tinyint(2) DEFAULT '0' COMMENT 'Nivel de seguridad',
  PRIMARY KEY (`id`),
  KEY `IDX_AMORTIZATION_FIXED_ASSET_ACCOUNT` (`fixed_asset_account`),
  KEY `IDX_AMORTIZATION_ACCUMULATED_ACCOUNT` (`accumulated_account`),
  KEY `IDX_AMORTIZATION_ALLOCATION_ACCOUNT` (`allocation_account`),
  KEY `IDX_AMORTIZATION_DOMAIN` (`domain`),
  KEY `IDX_AMORTIZATION_INVEST_ASSET` (`invest_asset`),
  CONSTRAINT `FK_AMORTIZATION_ACCUMULATED_ACCOUNT` FOREIGN KEY (`accumulated_account`) REFERENCES `account` (`id`),
  CONSTRAINT `FK_AMORTIZATION_ALLOCATION_ACCOUNT` FOREIGN KEY (`allocation_account`) REFERENCES `account` (`id`),
  CONSTRAINT `FK_AMORTIZATION_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_AMORTIZATION_FIXED_ASSET_ACCOUNT` FOREIGN KEY (`fixed_asset_account`) REFERENCES `account` (`id`),
  CONSTRAINT `FK_AMORTIZATION_INVEST_ASSET` FOREIGN KEY (`invest_asset`) REFERENCES `invest_asset` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Fichas de Amortizacion Contables';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `amortization`
--

LOCK TABLES `amortization` WRITE;
/*!40000 ALTER TABLE `amortization` DISABLE KEYS */;
/*!40000 ALTER TABLE `amortization` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `amortization_detail`
--

DROP TABLE IF EXISTS `amortization_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `amortization_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `amortization` int(4) NOT NULL COMMENT 'Ficha de Amortizacion',
  `from_date` date NOT NULL COMMENT 'Desde fecha',
  `to_date` date NOT NULL COMMENT 'Hasta fecha',
  `coefficient` double(15,3) NOT NULL COMMENT 'Coeficiente de Amortizacion',
  `allocation` double(15,3) NOT NULL COMMENT 'Dotacion de la Amortizacion',
  `status` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Estatus del Detalle de Amortizacion',
  `account_entry` int(4) DEFAULT NULL COMMENT 'Posicion del Apunte Contable',
  `fiscal_allocation` double(15,3) DEFAULT '0.000' COMMENT 'Dotacion fiscal',
  PRIMARY KEY (`id`),
  KEY `IDX_AMORTIZATION_DETAIL_AMORTIZATION` (`amortization`),
  KEY `IDX_AMORTIZATION_DETAIL_ACCOUNT_ENTRY` (`account_entry`),
  KEY `IDX_AMORTIZATION_DETAIL_DOMAIN` (`domain`),
  CONSTRAINT `FK_AMORTIZATION_DETAIL_ACCOUNT_ENTRY` FOREIGN KEY (`account_entry`) REFERENCES `account_entry` (`id`),
  CONSTRAINT `FK_AMORTIZATION_DETAIL_AMORTIZATION` FOREIGN KEY (`amortization`) REFERENCES `amortization` (`id`),
  CONSTRAINT `FK_AMORTIZATION_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalles de la Ficha de Amortizacion Contable';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `amortization_detail`
--

LOCK TABLES `amortization_detail` WRITE;
/*!40000 ALTER TABLE `amortization_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `amortization_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `amortization_invoice`
--

DROP TABLE IF EXISTS `amortization_invoice`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `amortization_invoice` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `amortization` int(4) NOT NULL COMMENT 'Identificador de la Ficha de Amortizacion',
  `invoice` int(4) NOT NULL COMMENT 'Identificador de la Factura',
  `sales` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indica si es venta de inmovilizado o no',
  PRIMARY KEY (`id`),
  KEY `IDX_AMORTIZATION_INVOICE_DOMAIN` (`domain`),
  KEY `IDX_AMORTIZATION_INVOICE_AMORTIZATION` (`amortization`),
  KEY `IDX_AMORTIZATION_INVOICE_INVOICE` (`invoice`),
  CONSTRAINT `FK_AMORTIZATION_INVOICE_AMORTIZATION` FOREIGN KEY (`amortization`) REFERENCES `amortization` (`id`),
  CONSTRAINT `FK_AMORTIZATION_INVOICE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_AMORTIZATION_INVOICE_INVOICE` FOREIGN KEY (`invoice`) REFERENCES `invoice` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Vinculo entr la Ficha de Amortizacion y la factura.';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `amortization_invoice`
--

LOCK TABLES `amortization_invoice` WRITE;
/*!40000 ALTER TABLE `amortization_invoice` DISABLE KEYS */;
/*!40000 ALTER TABLE `amortization_invoice` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `amortization_type`
--

DROP TABLE IF EXISTS `amortization_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `amortization_type` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `fixed_asset_account` varchar(4) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Cuenta de inmovilizado',
  `accumulated_account` varchar(4) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Cuenta de amortizacion acumulada',
  `allocation_account` varchar(4) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Cuenta para la dotacion de la amortizacion',
  `percentage` double DEFAULT '0' COMMENT 'Porcentaje de amortizacion',
  `description` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion del Tipo de Amortizacion',
  PRIMARY KEY (`id`),
  KEY `IDX_AMORTIZATION_TYPE_DOMAIN` (`domain`),
  CONSTRAINT `FK_AMORTIZATION_TYPE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Tipos de Amortizacion';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `amortization_type`
--

LOCK TABLES `amortization_type` WRITE;
/*!40000 ALTER TABLE `amortization_type` DISABLE KEYS */;
/*!40000 ALTER TABLE `amortization_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `app_param`
--

DROP TABLE IF EXISTS `app_param`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `app_param` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre del Parametro',
  `value` varchar(96) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Valor del Parametro',
  PRIMARY KEY (`id`),
  UNIQUE KEY `IDX_APP_PARAM_DOMAIN_NAME` (`domain`,`name`),
  KEY `IDX_APP_PARAM_DOMAIN` (`domain`),
  CONSTRAINT `FK_APP_PARAM_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1760509 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Parametros de la Aplicacion';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `app_param`
--

LOCK TABLES `app_param` WRITE;
/*!40000 ALTER TABLE `app_param` DISABLE KEYS */;
INSERT INTO `app_param` VALUES (87956,0,'APP_PRINT_HEADER_PARAM','false'),(87957,0,'APP_PRINT_RECORD_DATA_PARAM','false'),(87958,0,'APP_PRINT_LOGO_PARAM','false'),(87959,0,'APP_PRINT_S_INVOICE_FOOTER_PARAM','false'),(87960,0,'APP_SMART_CARD_PARAM','false'),(1140576,0,'AON_CUSTOMIZE_OEM','false'),(1149176,0,'APP_PRINT_DISCOUNT_PRICE_APPLIED','false'),(1149177,0,'APP_PRINT_REFERENCE_CODE_PARAM','false'),(1149178,0,'APP_PRINT_PRODUCT_CODE_PARAM','false'),(1760251,0,'APP_PRINT_PROJECT_PARAM','false'),(1760252,0,'AON_HELPDESK_ENABLED','false'),(1760253,8776,'ACC_DEFAULT_CASH_ACC','22012287'),(1760254,8776,'ACC_DEFAULT_CHARGED_RET_ACC','22012128'),(1760255,8776,'ACC_DEFAULT_CHARGED_VAT_ACC','22012136'),(1760256,8776,'ACC_DEFAULT_COMPANY_SOC_INS_ACC','22012407'),(1760257,8776,'ACC_DEFAULT_DEBT_INTEREST_ACC','22012432'),(1760258,8776,'ACC_DEFAULT_FINAN_EXPENSES_ACC','22012450'),(1760259,8776,'ACC_DEFAULT_PAID_RET_ACC','22012120'),(1760260,8776,'ACC_DEFAULT_PAID_VAT_ACC','22012117'),(1760261,8776,'ACC_DEFAULT_PENDING_SALARY_ACC','22012105'),(1760262,8776,'ACC_DEFAULT_PURCHASE_ACC','22012338'),(1760263,8776,'ACC_DEFAULT_SALARY_ACC','22012401'),(1760264,8776,'ACC_DEFAULT_SALES_ACC','22012512'),(1760265,8776,'ACC_DEFAULT_SOCIAL_INSURANCE_ACC','22012133'),(1760266,8776,'ACC_DEFAULT_PREPAYMENT_ACC','22012256'),(1760267,8776,'ACC_VAT_NEGATIVE_ADJUST_ACC','22012390'),(1760268,8776,'APP_PRINT_HEADER_PARAM','false'),(1760269,8776,'APP_PRINT_RECORD_DATA_PARAM','false'),(1760270,8776,'APP_PRINT_DISCOUNT_PRICE_APPLIED','false'),(1760271,8776,'APP_PRINT_LOGO_PARAM','false'),(1760272,8776,'APP_PRINT_REFERENCE_CODE_PARAM','false'),(1760273,8776,'APP_PRINT_PROJECT_PARAM','false'),(1760274,8776,'APP_PRINT_PRODUCT_CODE_PARAM','false'),(1760275,8776,'APP_PRINT_S_INVOICE_FOOTER_PARAM','false'),(1760276,8776,'APP_SMART_CARD_PARAM','false'),(1760277,8776,'AON_HELPDESK_ENABLED','false'),(1760278,8776,'AON_CUSTOMIZE_OEM','false'),(1760279,8776,'AON_PRODUCT_AVERAGE_MONTHS','1'),(1760280,8777,'PAY_REPORT_salary_PAY',NULL),(1760281,8777,'PAY_default_contractCode_PAY',NULL),(1760282,8777,'PAY_afi_test_env_PAY',NULL),(1760283,8777,'PAY_REPORT_salaryDraft_PAY',NULL),(1760284,8777,'PAY_ss_payment_bankAccount_PAY',NULL),(1760285,8777,'PAY_ss_mutual_PAY',NULL),(1760286,8777,'PAY_authorization_key_PAY',NULL),(1760287,8777,'PAY_default_trainingCenter_PAY',NULL),(1760288,8777,'PAY_REPORT_additional_salary_PAY',NULL),(1760289,8777,'PAY_fan_test_env_PAY',NULL),(1760290,8777,'APP_PRINT_HEADER_PARAM','false'),(1760291,8777,'APP_PRINT_RECORD_DATA_PARAM','false'),(1760292,8777,'APP_PRINT_DISCOUNT_PRICE_APPLIED','false'),(1760293,8777,'APP_PRINT_LOGO_PARAM','false'),(1760294,8777,'APP_PRINT_REFERENCE_CODE_PARAM','false'),(1760295,8777,'APP_PRINT_PROJECT_PARAM','false'),(1760296,8777,'APP_PRINT_PRODUCT_CODE_PARAM','false'),(1760297,8777,'APP_PRINT_S_INVOICE_FOOTER_PARAM','false'),(1760298,8777,'APP_SMART_CARD_PARAM','false'),(1760299,8777,'AON_HELPDESK_ENABLED','false'),(1760300,8777,'PAY_contrata_user_PAY',NULL),(1760301,8777,'PAY_contrata_ssl_env_active_PAY',NULL),(1760302,8777,'PAY_certifica2_user_PAY',NULL),(1760303,8777,'PAY_certifica2_ssl_env_PAY',NULL),(1760304,8777,'PAY_dev_mode_PAY',NULL),(1760305,8777,'PAY_contrata_test_env_active_PAY',NULL),(1760306,8777,'PAY_contrata_passwd_PAY',NULL),(1760307,8777,'PAY_certifica2_test_env_PAY',NULL),(1760308,8777,'PAY_certifica2_passwd_PAY',NULL),(1760309,8778,'PAY_REPORT_salary_PAY',NULL),(1760310,8778,'PAY_default_contractCode_PAY',NULL),(1760311,8778,'PAY_afi_test_env_PAY',NULL),(1760312,8778,'PAY_REPORT_salaryDraft_PAY',NULL),(1760313,8778,'PAY_ss_payment_bankAccount_PAY',NULL),(1760314,8778,'PAY_ss_mutual_PAY',NULL),(1760315,8778,'PAY_authorization_key_PAY',NULL),(1760316,8778,'PAY_default_trainingCenter_PAY',NULL),(1760317,8778,'PAY_REPORT_additional_salary_PAY',NULL),(1760318,8778,'PAY_fan_test_env_PAY',NULL),(1760319,8778,'PAY_contrata_user_PAY',NULL),(1760320,8778,'PAY_contrata_ssl_env_active_PAY',NULL),(1760321,8778,'PAY_certifica2_user_PAY',NULL),(1760322,8778,'PAY_certifica2_ssl_env_PAY',NULL),(1760323,8778,'PAY_dev_mode_PAY',NULL),(1760324,8778,'PAY_contrata_test_env_active_PAY',NULL),(1760325,8778,'PAY_contrata_passwd_PAY',NULL),(1760326,8778,'PAY_certifica2_test_env_PAY',NULL),(1760327,8778,'PAY_certifica2_passwd_PAY',NULL),(1760328,8779,'ACC_DEFAULT_CASH_ACC','22013308'),(1760329,8779,'ACC_DEFAULT_CHARGED_RET_ACC','22013149'),(1760330,8779,'ACC_DEFAULT_CHARGED_VAT_ACC','22013157'),(1760331,8779,'ACC_DEFAULT_COMPANY_SOC_INS_ACC','22013428'),(1760332,8779,'ACC_DEFAULT_DEBT_INTEREST_ACC','22013453'),(1760333,8779,'ACC_DEFAULT_FINAN_EXPENSES_ACC','22013471'),(1760334,8779,'ACC_DEFAULT_PAID_RET_ACC','22013141'),(1760335,8779,'ACC_DEFAULT_PAID_VAT_ACC','22013138'),(1760336,8779,'ACC_DEFAULT_PENDING_SALARY_ACC','22013126'),(1760337,8779,'ACC_DEFAULT_PURCHASE_ACC','22013359'),(1760338,8779,'ACC_DEFAULT_SALARY_ACC','22013422'),(1760339,8779,'ACC_DEFAULT_SALES_ACC','22013533'),(1760340,8779,'ACC_DEFAULT_SOCIAL_INSURANCE_ACC','22013154'),(1760341,8779,'ACC_DEFAULT_PREPAYMENT_ACC','22013277'),(1760342,8779,'ACC_VAT_NEGATIVE_ADJUST_ACC','22013411'),(1760343,8779,'APP_PRINT_HEADER_PARAM','false'),(1760344,8779,'APP_PRINT_RECORD_DATA_PARAM','false'),(1760345,8780,'PAY_REPORT_salary_PAY',NULL),(1760346,8780,'PAY_default_contractCode_PAY',NULL),(1760347,8780,'PAY_afi_test_env_PAY',NULL),(1760348,8780,'PAY_REPORT_salaryDraft_PAY',NULL),(1760349,8780,'PAY_ss_payment_bankAccount_PAY',NULL),(1760350,8780,'PAY_ss_mutual_PAY',NULL),(1760351,8780,'PAY_authorization_key_PAY',NULL),(1760352,8780,'PAY_default_trainingCenter_PAY',NULL),(1760353,8780,'PAY_REPORT_additional_salary_PAY',NULL),(1760354,8780,'PAY_fan_test_env_PAY',NULL),(1760355,8780,'PAY_contrata_user_PAY',NULL),(1760356,8780,'PAY_contrata_ssl_env_active_PAY',NULL),(1760357,8780,'PAY_certifica2_user_PAY',NULL),(1760358,8780,'PAY_certifica2_ssl_env_PAY',NULL),(1760359,8780,'PAY_dev_mode_PAY',NULL),(1760360,8780,'PAY_contrata_test_env_active_PAY',NULL),(1760361,8780,'PAY_contrata_passwd_PAY',NULL),(1760362,8780,'PAY_certifica2_test_env_PAY',NULL),(1760363,8780,'PAY_certifica2_passwd_PAY',NULL),(1760364,8778,'APP_PRINT_HEADER_PARAM','false'),(1760365,8778,'APP_PRINT_RECORD_DATA_PARAM','false'),(1760366,8778,'APP_PRINT_DISCOUNT_PRICE_APPLIED','false'),(1760367,8778,'APP_PRINT_LOGO_PARAM','false'),(1760368,8778,'APP_PRINT_REFERENCE_CODE_PARAM','false'),(1760369,8778,'APP_PRINT_PROJECT_PARAM','false'),(1760370,8778,'APP_PRINT_PRODUCT_CODE_PARAM','false'),(1760371,8778,'APP_PRINT_S_INVOICE_FOOTER_PARAM','false'),(1760372,8778,'APP_SMART_CARD_PARAM','false'),(1760373,8778,'AON_HELPDESK_ENABLED','false'),(1760374,8778,'AON_DSI_LOADER_ENABLED','false'),(1760375,8777,'AON_DSI_LOADER_ENABLED','false'),(1760376,8781,'AON_CUSTOMIZE_OEM','false'),(1760377,8781,'AON_PRODUCT_AVERAGE_MONTHS','1'),(1760378,8781,'APP_PRINT_HEADER_PARAM','false'),(1760379,8781,'APP_PRINT_RECORD_DATA_PARAM','false'),(1760380,8781,'APP_PRINT_DISCOUNT_PRICE_APPLIED','false'),(1760381,8781,'APP_PRINT_LOGO_PARAM','false'),(1760382,8781,'APP_PRINT_REFERENCE_CODE_PARAM','false'),(1760383,8781,'APP_PRINT_PROJECT_PARAM','false'),(1760384,8781,'APP_PRINT_PRODUCT_CODE_PARAM','false'),(1760385,8781,'APP_PRINT_S_INVOICE_FOOTER_PARAM','false'),(1760386,8781,'APP_SMART_CARD_PARAM','false'),(1760387,8781,'AON_HELPDESK_ENABLED','false'),(1760388,8781,'AON_DSI_LOADER_ENABLED','false'),(1760389,8781,'PAY_REPORT_salary_PAY',NULL),(1760390,8781,'PAY_default_contractCode_PAY',NULL),(1760391,8781,'PAY_afi_test_env_PAY',NULL),(1760392,8781,'PAY_REPORT_salaryDraft_PAY',NULL),(1760393,8781,'PAY_ss_payment_bankAccount_PAY',NULL),(1760394,8781,'PAY_ss_mutual_PAY',NULL),(1760395,8781,'PAY_authorization_key_PAY',NULL),(1760396,8781,'PAY_default_trainingCenter_PAY',NULL),(1760397,8781,'PAY_REPORT_additional_salary_PAY',NULL),(1760398,8781,'PAY_fan_test_env_PAY',NULL),(1760399,8781,'PAY_contrata_user_PAY',NULL),(1760400,8781,'PAY_contrata_ssl_env_active_PAY',NULL),(1760401,8781,'PAY_certifica2_user_PAY',NULL),(1760402,8781,'PAY_certifica2_ssl_env_PAY',NULL),(1760403,8781,'PAY_dev_mode_PAY',NULL),(1760404,8781,'PAY_contrata_test_env_active_PAY',NULL),(1760405,8781,'PAY_contrata_passwd_PAY',NULL),(1760406,8781,'PAY_certifica2_test_env_PAY',NULL),(1760407,8781,'PAY_certifica2_passwd_PAY',NULL),(1760408,8783,'PAY_REPORT_salary_PAY',NULL),(1760409,8783,'PAY_default_contractCode_PAY',NULL),(1760410,8783,'PAY_afi_test_env_PAY',NULL),(1760411,8783,'PAY_REPORT_salaryDraft_PAY',NULL),(1760412,8783,'PAY_ss_payment_bankAccount_PAY',NULL),(1760413,8783,'PAY_ss_mutual_PAY',NULL),(1760414,8783,'PAY_authorization_key_PAY',NULL),(1760415,8783,'PAY_default_trainingCenter_PAY',NULL),(1760416,8783,'PAY_REPORT_additional_salary_PAY',NULL),(1760417,8783,'PAY_fan_test_env_PAY',NULL),(1760418,8783,'PAY_contrata_user_PAY',NULL),(1760419,8783,'PAY_contrata_ssl_env_active_PAY',NULL),(1760420,8783,'PAY_certifica2_user_PAY',NULL),(1760421,8783,'PAY_certifica2_ssl_env_PAY',NULL),(1760422,8783,'PAY_dev_mode_PAY',NULL),(1760423,8783,'PAY_contrata_test_env_active_PAY',NULL),(1760424,8783,'PAY_contrata_passwd_PAY',NULL),(1760425,8783,'PAY_certifica2_test_env_PAY',NULL),(1760426,8783,'PAY_certifica2_passwd_PAY',NULL),(1760427,8784,'PAY_REPORT_salary_PAY',NULL),(1760428,8784,'PAY_default_contractCode_PAY',NULL),(1760429,8784,'PAY_afi_test_env_PAY',NULL),(1760430,8784,'PAY_REPORT_salaryDraft_PAY',NULL),(1760431,8784,'PAY_ss_payment_bankAccount_PAY',NULL),(1760432,8784,'PAY_ss_mutual_PAY',NULL),(1760433,8784,'PAY_authorization_key_PAY',NULL),(1760434,8784,'PAY_default_trainingCenter_PAY',NULL),(1760435,8784,'PAY_REPORT_additional_salary_PAY',NULL),(1760436,8784,'PAY_fan_test_env_PAY',NULL),(1760437,8784,'PAY_contrata_user_PAY',NULL),(1760438,8784,'PAY_contrata_ssl_env_active_PAY',NULL),(1760439,8784,'PAY_certifica2_user_PAY',NULL),(1760440,8784,'PAY_certifica2_ssl_env_PAY',NULL),(1760441,8784,'PAY_dev_mode_PAY',NULL),(1760442,8784,'PAY_contrata_test_env_active_PAY',NULL),(1760443,8784,'PAY_contrata_passwd_PAY',NULL),(1760444,8784,'PAY_certifica2_test_env_PAY',NULL),(1760445,8784,'PAY_certifica2_passwd_PAY',NULL),(1760446,8783,'APP_PRINT_HEADER_PARAM','false'),(1760447,8783,'APP_PRINT_RECORD_DATA_PARAM','false'),(1760448,8783,'APP_PRINT_DISCOUNT_PRICE_APPLIED','false'),(1760449,8783,'APP_PRINT_LOGO_PARAM','false'),(1760450,8783,'APP_PRINT_REFERENCE_CODE_PARAM','false'),(1760451,8783,'APP_PRINT_PROJECT_PARAM','false'),(1760452,8783,'APP_PRINT_PRODUCT_CODE_PARAM','false'),(1760453,8783,'APP_PRINT_S_INVOICE_FOOTER_PARAM','false'),(1760454,8783,'APP_SMART_CARD_PARAM','false'),(1760455,8783,'AON_HELPDESK_ENABLED','false'),(1760456,8783,'AON_DSI_LOADER_ENABLED','false'),(1760457,0,'AON_PRODUCT_AVERAGE_MONTHS','1'),(1760458,8776,'PAY_SYSTEM_AGREEMENT','1164'),(1760459,8787,'PAY_REPORT_salary_PAY',NULL),(1760460,8787,'PAY_default_contractCode_PAY',NULL),(1760461,8787,'PAY_afi_test_env_PAY',NULL),(1760462,8787,'PAY_REPORT_salaryDraft_PAY',NULL),(1760463,8787,'PAY_ss_payment_bankAccount_PAY',NULL),(1760464,8787,'PAY_ss_mutual_PAY',NULL),(1760465,8787,'PAY_authorization_key_PAY',NULL),(1760466,8787,'PAY_default_trainingCenter_PAY',NULL),(1760467,8787,'PAY_REPORT_additional_salary_PAY',NULL),(1760468,8787,'PAY_fan_test_env_PAY',NULL),(1760469,8787,'PAY_contrata_user_PAY',NULL),(1760470,8787,'PAY_contrata_ssl_env_active_PAY',NULL),(1760471,8787,'PAY_certifica2_user_PAY',NULL),(1760472,8787,'PAY_certifica2_ssl_env_PAY',NULL),(1760473,8787,'PAY_dev_mode_PAY',NULL),(1760474,8787,'PAY_contrata_test_env_active_PAY',NULL),(1760475,8787,'PAY_contrata_passwd_PAY',NULL),(1760476,8787,'PAY_certifica2_test_env_PAY',NULL),(1760477,8787,'PAY_certifica2_passwd_PAY',NULL),(1760478,8788,'PAY_REPORT_salary_PAY',NULL),(1760479,8788,'PAY_default_contractCode_PAY',NULL),(1760480,8788,'PAY_afi_test_env_PAY',NULL),(1760481,8788,'PAY_REPORT_salaryDraft_PAY',NULL),(1760482,8788,'PAY_ss_payment_bankAccount_PAY',NULL),(1760483,8788,'PAY_ss_mutual_PAY',NULL),(1760484,8788,'PAY_authorization_key_PAY',NULL),(1760485,8788,'PAY_default_trainingCenter_PAY',NULL),(1760486,8788,'PAY_REPORT_additional_salary_PAY',NULL),(1760487,8788,'PAY_fan_test_env_PAY',NULL),(1760488,8788,'APP_PRINT_HEADER_PARAM','false'),(1760489,8788,'APP_PRINT_RECORD_DATA_PARAM','false'),(1760490,8788,'APP_PRINT_DISCOUNT_PRICE_APPLIED','false'),(1760491,8788,'APP_PRINT_LOGO_PARAM','false'),(1760492,8788,'APP_PRINT_REFERENCE_CODE_PARAM','false'),(1760493,8788,'APP_PRINT_PROJECT_PARAM','false'),(1760494,8788,'APP_PRINT_PRODUCT_CODE_PARAM','false'),(1760495,8788,'APP_PRINT_PRODUCT_VAT_PARAM','false'),(1760496,8788,'APP_PRINT_S_INVOICE_FOOTER_PARAM','false'),(1760497,8788,'APP_SMART_CARD_PARAM','false'),(1760498,8788,'AON_HELPDESK_ENABLED','false'),(1760499,8788,'AON_DSI_LOADER_ENABLED','false'),(1760500,8788,'PAY_contrata_user_PAY',NULL),(1760501,8788,'PAY_contrata_ssl_env_active_PAY',NULL),(1760502,8788,'PAY_certifica2_user_PAY',NULL),(1760503,8788,'PAY_certifica2_ssl_env_PAY',NULL),(1760504,8788,'PAY_dev_mode_PAY',NULL),(1760505,8788,'PAY_contrata_test_env_active_PAY',NULL),(1760506,8788,'PAY_contrata_passwd_PAY',NULL),(1760507,8788,'PAY_certifica2_test_env_PAY',NULL),(1760508,8788,'PAY_certifica2_passwd_PAY',NULL);
/*!40000 ALTER TABLE `app_param` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `application`
--

DROP TABLE IF EXISTS `application`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `application` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `name` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre de la Aplicacion',
  `description` varchar(128) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion de la Aplicacion',
  `contratable` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indica si la Aplicacion es contratable o no',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=29 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Aplicaciones';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `application`
--

LOCK TABLES `application` WRITE;
/*!40000 ALTER TABLE `application` DISABLE KEYS */;
INSERT INTO `application` VALUES (1,'aon-academy','ACADEMY',1),(2,'aon-account','ACCOUNT',1),(3,'aon-asset','RECURSOS',1),(4,'aon-audit','AUDIT',1),(5,'aon-cms','CMS',1),(6,'aon-commercial','COMMERCIAL',1),(7,'aon-communicator','COMMUNICATOR',1),(8,'aon-consultant','CONSULTANT',1),(9,'aon-document','DOCUMENT',1),(10,'aon-desktop','DESKTOP',1),(11,'aon-ebackoffice','EBACKOFFICE',1),(12,'aon-ecm','ECM',1),(13,'aon-ecommerce','ECOMMERCE',1),(14,'aon-employee','EMPLOYEE',1),(15,'aon-enterprise','ENTERPRISE',1),(16,'aon-finance','FINANCE',1),(17,'aon-fiscal','FISCAL',1),(18,'aon-gt','GT',1),(19,'aon-manager','MANAGER',1),(20,'aon-payroll','PAYROLL',1),(21,'aon-pms','PMS',1),(22,'aon-project','PROJECT',1),(23,'aon-publisher','PUBLISHER',1),(24,'aon-smb','SMB',1),(25,'aon-task','TASK',1),(26,'aon-webinfo','INFOWEB',1),(27,'aon-webmail','WEBMAIL',0),(28,'aon-aio','AIO',1);
/*!40000 ALTER TABLE `application` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `application_role`
--

DROP TABLE IF EXISTS `application_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `application_role` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `application` int(4) NOT NULL COMMENT 'Identificador de la Aplicacion',
  `role` int(4) NOT NULL COMMENT 'Identificador del Role',
  PRIMARY KEY (`id`),
  KEY `IDX_APPLICATION_ROLE_APPLICATION` (`application`),
  KEY `IDX_APPLICATION_ROLE_ROLE` (`role`),
  CONSTRAINT `FK_APPLICATION_ROLE_APPLICATION` FOREIGN KEY (`application`) REFERENCES `application` (`id`),
  CONSTRAINT `FK_APPLICATION_ROLE_ROLE` FOREIGN KEY (`role`) REFERENCES `role` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=239 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Roles de la Aplicacion';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `application_role`
--

LOCK TABLES `application_role` WRITE;
/*!40000 ALTER TABLE `application_role` DISABLE KEYS */;
INSERT INTO `application_role` VALUES (1,1,1001),(2,1,1002),(3,1,1003),(4,1,1004),(5,1,1005),(6,1,1006),(7,1,1007),(8,1,1008),(9,1,1009),(10,1,1010),(11,1,1011),(12,1,1012),(13,1,1013),(14,1,1014),(15,1,1015),(16,1,1016),(17,1,1017),(18,1,1018),(19,1,1019),(20,1,1020),(21,1,1021),(22,1,1022),(23,1,1023),(24,1,1024),(25,1,1025),(26,1,1026),(27,1,1027),(28,1,1028),(29,1,1029),(30,1,1030),(31,1,1031),(32,1,1032),(33,1,1033),(34,1,1034),(35,1,1035),(36,1,1036),(37,1,1037),(38,1,1038),(39,1,1039),(40,1,1040),(41,1,1041),(42,1,1042),(43,1,1043),(44,1,1044),(45,1,1045),(46,1,1046),(47,1,1047),(48,1,1048),(49,1,1049),(50,1,1050),(51,1,1051),(52,1,1052),(53,1,1053),(54,1,1054),(55,1,1055),(56,1,1056),(57,1,1057),(58,1,1058),(60,2,2),(61,2,3),(62,2,5),(63,2,6),(64,2,12),(65,2,13),(66,3,101),(67,3,102),(68,4,102),(69,4,103),(70,5,104),(71,5,105),(72,5,106),(73,5,107),(75,6,2),(76,6,3),(77,6,5),(78,6,6),(79,6,14),(80,7,102),(81,7,103),(83,8,2),(84,8,3),(85,8,4),(86,8,5),(87,8,6),(88,8,7),(89,8,12),(90,8,13),(91,8,14),(92,8,15),(93,8,16),(95,9,2),(96,9,3),(98,10,2),(99,10,3),(100,10,6),(101,10,108),(102,10,109),(103,10,110),(104,10,111),(105,10,112),(107,11,2),(108,11,3),(109,12,103),(110,12,113),(111,12,114),(112,12,115),(113,12,116),(115,13,2),(116,13,3),(118,14,2),(119,14,3),(121,15,2),(122,15,3),(123,15,4),(124,15,5),(125,15,6),(126,15,7),(127,15,8),(128,15,9),(129,15,10),(130,15,11),(131,15,12),(132,15,13),(133,15,14),(134,15,16),(136,16,2),(137,16,3),(138,16,4),(139,16,5),(140,16,6),(141,16,7),(142,16,12),(143,16,13),(145,17,2),(146,17,3),(147,17,4),(148,17,5),(149,17,6),(150,17,7),(151,17,12),(152,17,13),(154,18,2),(155,18,3),(156,18,4),(157,18,5),(158,18,6),(159,18,7),(160,18,8),(161,18,9),(162,18,10),(163,18,11),(164,18,12),(165,18,13),(166,18,14),(167,18,16),(169,19,2),(170,19,3),(172,20,2),(173,20,3),(174,20,17),(176,21,2),(177,21,3),(178,21,4),(179,21,5),(180,21,6),(181,21,7),(182,21,8),(183,21,12),(184,21,13),(185,21,14),(186,21,16),(188,22,2),(189,22,3),(190,22,6),(191,22,15),(193,23,2),(194,23,3),(196,24,2),(197,24,3),(198,24,4),(199,24,5),(200,24,6),(201,24,7),(202,24,8),(203,24,12),(204,24,13),(205,24,14),(206,24,16),(208,25,2),(209,25,3),(210,25,6),(211,25,15),(213,26,103),(215,27,2),(216,27,3),(218,28,2),(219,28,3),(220,28,4),(221,28,5),(222,28,6),(223,28,7),(224,28,8),(225,28,9),(226,28,10),(227,28,11),(228,28,12),(229,28,13),(230,28,14),(231,28,15),(232,28,16),(233,28,19),(234,28,20),(235,28,21),(236,28,22),(237,28,23),(238,28,24);
/*!40000 ALTER TABLE `application_role` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `application_user`
--

DROP TABLE IF EXISTS `application_user`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `application_user` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `user_id` int(4) NOT NULL COMMENT 'Identificador del Usuario',
  `domain_application` int(4) NOT NULL COMMENT 'Identificador de la Aplicacion del Dominio',
  `active` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'Indica si la Aplicacion del Dominio esta activo o no',
  PRIMARY KEY (`id`),
  KEY `IDX_APPLICATION_USER_USER` (`user_id`),
  KEY `IDX_APPLICATION_USER_DOMAIN_APPLICATION` (`domain_application`),
  KEY `IDX_APPLICATION_USER_DOMAIN` (`domain`),
  CONSTRAINT `FK_APPLICATION_USER_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_APPLICATION_USER_DOMAIN_APPLICATION` FOREIGN KEY (`domain_application`) REFERENCES `domain_application` (`id`),
  CONSTRAINT `FK_APPLICATION_USER_USER` FOREIGN KEY (`user_id`) REFERENCES `user` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=8476 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Usuarios de las Aplicaciones del Dominio';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `application_user`
--

LOCK TABLES `application_user` WRITE;
/*!40000 ALTER TABLE `application_user` DISABLE KEYS */;
INSERT INTO `application_user` VALUES (3618,0,2862,3055,1),(8475,8776,10248,10038,1);
/*!40000 ALTER TABLE `application_user` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `application_user_profile`
--

DROP TABLE IF EXISTS `application_user_profile`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `application_user_profile` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `application_user` int(4) NOT NULL COMMENT 'Identificador del Usuario de la Aplicacion',
  `profile` int(4) NOT NULL COMMENT 'Identificador del Perfil',
  PRIMARY KEY (`id`),
  KEY `IDX_APPLICATION_USER_PROFILE_PROFILE` (`profile`),
  KEY `IDX_APPLICATION_USER_PROFILE_APPLICATION_USER` (`application_user`),
  KEY `IDX_APPLICATION_USER_PROFILE_DOMAIN` (`domain`),
  CONSTRAINT `FK_APPLICATION_USER_PROFILE_APPLICATION_USER` FOREIGN KEY (`application_user`) REFERENCES `application_user` (`id`),
  CONSTRAINT `FK_APPLICATION_USER_PROFILE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_APPLICATION_USER_PROFILE_PROFILE` FOREIGN KEY (`profile`) REFERENCES `profile` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=7891 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Perfiles del Usuario para la Aplicacion';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `application_user_profile`
--

LOCK TABLES `application_user_profile` WRITE;
/*!40000 ALTER TABLE `application_user_profile` DISABLE KEYS */;
INSERT INTO `application_user_profile` VALUES (2663,0,3618,71),(7890,8776,8475,71);
/*!40000 ALTER TABLE `application_user_profile` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `asset`
--

DROP TABLE IF EXISTS `asset`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `asset` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion del Activo',
  `name` varchar(10) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre corto del Activo',
  PRIMARY KEY (`id`),
  KEY `IDX_ASSET_DOMAIN` (`domain`),
  CONSTRAINT `FK_ASSET_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Activos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `asset`
--

LOCK TABLES `asset` WRITE;
/*!40000 ALTER TABLE `asset` DISABLE KEYS */;
/*!40000 ALTER TABLE `asset` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `asset_activity`
--

DROP TABLE IF EXISTS `asset_activity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `asset_activity` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `asset` int(4) NOT NULL COMMENT 'Identificador del Activo',
  `date` date NOT NULL COMMENT 'Fecha de la Actividad',
  `from_time` datetime NOT NULL COMMENT 'Hora de inicio de la Actividad',
  `to_time` datetime NOT NULL COMMENT 'Hora final de la Actividad',
  `who` varchar(20) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Quien solicita el Activo',
  `why` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Motivo de solicitud del Activo',
  `status` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Estado de la Solicitud',
  PRIMARY KEY (`id`),
  KEY `IDX_ASSET_ACTIVITY_ASSET` (`asset`),
  KEY `IDX_ASSET_ACTIVITY_DOMAIN` (`domain`),
  KEY `IDX_ASSET_ACTIVITY_DATE` (`date`),
  CONSTRAINT `FK_ASSET_ACTIVITY_ASSET` FOREIGN KEY (`asset`) REFERENCES `asset` (`id`),
  CONSTRAINT `FK_ASSET_ACTIVITY_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Actividades sobre el Activo';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `asset_activity`
--

LOCK TABLES `asset_activity` WRITE;
/*!40000 ALTER TABLE `asset_activity` DISABLE KEYS */;
/*!40000 ALTER TABLE `asset_activity` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `asset_feature`
--

DROP TABLE IF EXISTS `asset_feature`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `asset_feature` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `asset` int(4) NOT NULL COMMENT 'Identificador del Activo',
  `feature` int(4) NOT NULL COMMENT 'Identificador de la Caracteristica',
  PRIMARY KEY (`id`),
  KEY `IDX_ASSET_FEATURE_ASSET` (`asset`),
  KEY `IDX_ASSET_FEATURE_FEATURE` (`feature`),
  KEY `IDX_ASSET_FEATURE_DOMAIN` (`domain`),
  CONSTRAINT `FK_ASSET_FEATURE_ASSET` FOREIGN KEY (`asset`) REFERENCES `asset` (`id`),
  CONSTRAINT `FK_ASSET_FEATURE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_ASSET_FEATURE_FEATURE` FOREIGN KEY (`feature`) REFERENCES `feature` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Caracteristicas por Activo';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `asset_feature`
--

LOCK TABLES `asset_feature` WRITE;
/*!40000 ALTER TABLE `asset_feature` DISABLE KEYS */;
/*!40000 ALTER TABLE `asset_feature` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `auto_concept`
--

DROP TABLE IF EXISTS `auto_concept`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `auto_concept` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Concepto Automatico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `description` char(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion del Concepto Automatico',
  PRIMARY KEY (`id`),
  KEY `IDX_AUTO_CONCEPT_DOMAIN` (`domain`),
  CONSTRAINT `FK_AUTO_CONCEPT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Conceptos Automaticos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `auto_concept`
--

LOCK TABLES `auto_concept` WRITE;
/*!40000 ALTER TABLE `auto_concept` DISABLE KEYS */;
/*!40000 ALTER TABLE `auto_concept` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `balance`
--

DROP TABLE IF EXISTS `balance`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `balance` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(64) COLLATE latin1_spanish_ci NOT NULL DEFAULT '' COMMENT 'Nombre del Balance',
  `removable` tinyint(1) DEFAULT '0' COMMENT 'Indica se puede ser borrado por el usuario',
  `type` tinyint(2) DEFAULT '0' COMMENT 'Tipo de Balance',
  PRIMARY KEY (`id`),
  KEY `IDX_BALANCE_DOMAIN` (`domain`),
  CONSTRAINT `FK_BALANCE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=12618 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Balances';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `balance`
--

LOCK TABLES `balance` WRITE;
/*!40000 ALTER TABLE `balance` DISABLE KEYS */;
INSERT INTO `balance` VALUES (12608,8776,'BALANCE DE SITUACIÓN',0,0),(12609,8776,'CUENTA DE EXPLOTACIÓN',0,1),(12610,8776,'BALANCE DE SITUACIÓN (ABREVIADO)',0,0),(12611,8776,'CUENTA DE EXPLOTACIÓN (ABREVIADA)',0,1),(12612,8776,'ESTADO DE CAMBIOS EN EL PATRIMONIO NETO (ABREVIADO)',0,2),(12613,8779,'BALANCE DE SITUACIÓN',0,0),(12614,8779,'CUENTA DE EXPLOTACIÓN',0,1),(12615,8779,'BALANCE DE SITUACIÓN (ABREVIADO)',0,0),(12616,8779,'CUENTA DE EXPLOTACIÓN (ABREVIADA)',0,1),(12617,8779,'ESTADO DE CAMBIOS EN EL PATRIMONIO NETO (ABREVIADO)',0,2);
/*!40000 ALTER TABLE `balance` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `balance_detail`
--

DROP TABLE IF EXISTS `balance_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `balance_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `balance` int(4) NOT NULL COMMENT 'Identificador del Balance',
  `code` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo del Detalle en el Balance',
  `description` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripción del detalle de balance',
  `accounts` text COLLATE latin1_spanish_ci COMMENT 'Cuentas separadas por comas, que forman el acumulado.',
  `sortKey` int(4) DEFAULT '0' COMMENT 'Orden el que aparecera en el listado.',
  `notes` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Notas en el Balance',
  `title` tinyint(1) NOT NULL DEFAULT '0',
  `internal_calculation` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indica si es un calculo interno, es decir si el contenido de accounts son referencias a la columna -code- de esta tabla',
  `visible` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'Si aparece o no en la impresion.',
  `zeroFlag` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Flag que se activa cuando la cuenta o cuentas tienen valor 0.',
  `creditNature` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Si es verdadero se hace una haber menos debe de las cuentas indicadas',
  PRIMARY KEY (`id`),
  KEY `IDX_BALANCE_DETAIL_BALANCE` (`balance`),
  KEY `IDX_BALANCE_DETAIL_DOMAIN` (`domain`),
  CONSTRAINT `FK_BALANCE_DETAIL_BALANCE` FOREIGN KEY (`balance`) REFERENCES `balance` (`id`),
  CONSTRAINT `FK_BALANCE_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=906783 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalles del Balace';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `balance_detail`
--

LOCK TABLES `balance_detail` WRITE;
/*!40000 ALTER TABLE `balance_detail` DISABLE KEYS */;
INSERT INTO `balance_detail` VALUES (906155,8776,12608,'A0','ACTIVO','',0,NULL,1,0,1,0,0),(906156,8776,12608,'A','A) ACTIVO NO CORRIENTE','A.I,A.II,A.III,A.IV,A.V,A.VI',1,NULL,1,1,1,0,0),(906157,8776,12608,'A.I','I. Inmovilizado intangible.','A.I.1,A.I.2,A.I.3,A.I.4,A.I.5,A.I.6',2,NULL,1,1,1,0,0),(906158,8776,12608,'A.I.1','1. Desarrollo.','201,(2801),(2901)',3,NULL,0,0,1,0,0),(906159,8776,12608,'A.I.2','2. Concesiones.','202,(2802),(2902)',4,NULL,0,0,1,0,0),(906160,8776,12608,'A.I.3','3. Patentes, licencias, marcas y similares.','203,(2803),(2903)',5,NULL,0,0,1,0,0),(906161,8776,12608,'A.I.4','4. Fondo de comercio.','204',6,NULL,0,0,1,0,0),(906162,8776,12608,'A.I.5','5. Aplicaciones informáticas.','206,(2806),(2906)',7,NULL,0,0,1,0,0),(906163,8776,12608,'A.I.6','6. Otro inmovilizado intangible.','205,209,(2805),(2905)',8,NULL,0,0,1,0,0),(906164,8776,12608,'A.II','II. Inmovilizado material.','A.II.1,A.II.2,A.II.3',9,NULL,1,1,1,0,0),(906165,8776,12608,'A.II.1','1. Terrenos y construcciones.','210,211,(2811),(2910),(2911)',10,NULL,0,0,1,0,0),(906166,8776,12608,'A.II.2','2. Instalaciones técnicas, y otro inmovilizado material.','212,213,214,215,216,217,218,219,(2812),(2813),(2814),(2815),(2816),(2817),(2818),(2819),(2912),(2913),(2914),(2915),(2916),(2917),(2918),(2919)',11,NULL,0,0,1,0,0),(906167,8776,12608,'A.II.3','3. Inmovilizado en curso y anticipos.','23',12,NULL,0,0,1,0,0),(906168,8776,12608,'A.III','III. Inversiones inmobiliarias.','A.III.1,A.III.2',13,NULL,1,1,1,0,0),(906169,8776,12608,'A.III.1','1. Terrenos.','220,(2920)',14,NULL,0,0,1,0,0),(906170,8776,12608,'A.III.2','2. Construcciones.','221,(282),(2921)',15,NULL,0,0,1,0,0),(906171,8776,12608,'A.IV','IV. Inversiones en empresas del grupo y asociadas a largo plazo.','A.IV.1,A.IV.2,A.IV.3,A.IV.4,A.IV.5',16,NULL,1,1,1,0,0),(906172,8776,12608,'A.IV.1','1. Instrumentos de patrimonio.','2403,2404,(2493),(2494),(293)',17,NULL,0,0,1,0,0),(906173,8776,12608,'A.IV.2','2. Créditos a empresas.','2423,2424,(2953),(2954)',18,NULL,0,0,1,0,0),(906174,8776,12608,'A.IV.3','3. Valores representativos de deuda.','2413,2414,(2943),(2944)',19,NULL,0,0,1,0,0),(906175,8776,12608,'A.IV.4','4. Derivados.','',20,NULL,0,0,1,0,0),(906176,8776,12608,'A.IV.5','5. Otros activos financieros.','',21,NULL,0,0,1,0,0),(906177,8776,12608,'A.V','V. Inversiones financieras a largo plazo.','A.V.1,A.V.2,A.V.3,A.V.4,A.V.5',22,NULL,1,1,1,0,0),(906178,8776,12608,'A.V.1','1. Instrumentos de patrimonio.','2405,(2495),250,(259)',23,NULL,0,0,1,0,0),(906179,8776,12608,'A.V.2','2. Créditos a terceros','2425,252,253,254,(2955),(298)',24,NULL,0,0,1,0,0),(906180,8776,12608,'A.V.3','3. Valores representativos de deuda','2415,251,(2945),(297)',25,NULL,0,0,1,0,0),(906181,8776,12608,'A.V.4','4. Derivados.','255',26,NULL,0,0,1,0,0),(906182,8776,12608,'A.V.5','5. Otros activos financieros.','258,26',27,NULL,0,0,1,0,0),(906183,8776,12608,'A.VI','VI. Activos por impuesto diferido.','474',28,NULL,1,0,1,0,0),(906184,8776,12608,'','','',29,NULL,0,0,1,0,0),(906185,8776,12608,'B','B) ACTIVO CORRIENTE','B.I,B.II,B.III,B.IV,B.V,B.VI,B.VII',30,NULL,1,1,1,0,0),(906186,8776,12608,'B.I','I. Activos no corrientes mantenidos para la venta.','580,581,582,583,584,(599)',31,NULL,0,0,1,0,0),(906187,8776,12608,'B.II','II. Existencias.','B.II.1,B.II.2,B.II.3,B.II.4,B.II.5,B.II.6',32,NULL,1,1,1,0,0),(906188,8776,12608,'B.II.1','1. Comerciales.','30,(390)',33,NULL,0,0,1,0,0),(906189,8776,12608,'B.II.2','2. Materias primas y otros aprovisionamientos.','31,32,(391),(392)',34,NULL,0,0,1,0,0),(906190,8776,12608,'B.II.3','3. Productos en curso.','33,34,(393),(394)',35,NULL,0,0,1,0,0),(906191,8776,12608,'B.II.4','4. Productos terminados.','35,(395)',36,NULL,0,0,1,0,0),(906192,8776,12608,'B.II.5','5. Subproductos, residuos y materiales recuperados.','36,(396)',37,NULL,0,0,1,0,0),(906193,8776,12608,'B.II.6','6. Anticipos a proveedores','407',38,NULL,0,0,1,0,0),(906194,8776,12608,'B.III','III. Deudores comerciales y otras cuentas a cobrar.','B.III.1,B.III.2,B.III.3,B.III.4,B.III.5,B.III.6,B.III.7',39,NULL,1,1,1,0,0),(906195,8776,12608,'B.III.1','1. Clientes por ventas y prestaciones de servicios.','430,431,432,435,436,(437),(490),(4935)',40,NULL,0,0,1,0,0),(906196,8776,12608,'B.III.2','2. Clientes, empresas del grupo y asociadas.','433,434,(4933),(4934)',41,NULL,0,0,1,0,0),(906197,8776,12608,'B.III.3','3. Deudores varios.','44,5531,5533',42,NULL,0,0,1,0,0),(906198,8776,12608,'B.III.4','4. Personal.','460,544',43,NULL,0,0,1,0,0),(906199,8776,12608,'B.III.5','5. Activos por impuesto corriente.','4709,4703',44,NULL,0,0,1,0,0),(906200,8776,12608,'B.III.6','6. Otros créditos con las Administraciones Públicas.','4700,4708,471,472,473',45,NULL,0,0,1,0,0),(906201,8776,12608,'B.III.7','7. Accionistas (socios) por desembolsos exigidos','5580',46,NULL,0,0,1,0,0),(906202,8776,12608,'B.IV','IV. Inversiones en empresas del grupo y asociadas a corto plazo.','B.IV.1,B.IV.2,B.IV.3,B.IV.4,B.IV.5',47,NULL,1,1,1,0,0),(906203,8776,12608,'B.IV.1','1. Instrumentos de patrimonio.','5303,5304,(5393),(5394),(593)',48,NULL,0,0,1,0,0),(906204,8776,12608,'B.IV.2','2. Créditos a empresas.','5323,5324,5343,5344,(5953),(5954)',49,NULL,0,0,1,0,0),(906205,8776,12608,'B.IV.3','3. Valores representativos de deuda.','5313,5314,5333,5334,(5943),(5944)',50,NULL,0,0,1,0,0),(906206,8776,12608,'B.IV.4','4. Derivados.','',51,NULL,0,0,1,0,0),(906207,8776,12608,'B.IV.5','5. Otros activos financieros.','5353,5354,5523,5524',52,NULL,0,0,1,0,0),(906208,8776,12608,'B.V','V. Inversiones financieras a corto plazo.','B.V.1,B.V.2,B.V.3,B.V.4,B.V.5',53,NULL,1,1,1,0,0),(906209,8776,12608,'B.V.1','1. Instrumentos de patrimonio.','5305,540,(5395),(549)',54,NULL,0,0,1,0,0),(906210,8776,12608,'B.V.2','2. Créditos a empresas','5325,5345,542,543,547,(5955),(598)',55,NULL,0,0,1,0,0),(906211,8776,12608,'B.V.3','3. Valores representativos de deuda.','5315,5335,541,546,(5945),(597)',56,NULL,0,0,1,0,0),(906212,8776,12608,'B.V.4','4. Derivados.','5590,5593',57,NULL,0,0,1,0,0),(906213,8776,12608,'B.V.5','5. Otros activos financieros.','5355,545,548,?551,5525,565,566',58,NULL,0,0,1,0,0),(906214,8776,12608,'B.VI','VI. Periodificaciones a corto plazo.','480,567',59,NULL,1,0,1,0,0),(906215,8776,12608,'B.VII','VII. Efectivo y otros activos líquidos equivalentes.','B.VII.1,B.VII.2',60,NULL,1,1,1,0,0),(906216,8776,12608,'B.VII.1','1. Tesorería.','570,571,572,573,574,575',61,NULL,0,0,1,0,0),(906217,8776,12608,'B.VII.2','2. Otros activos líquidos equivalentes.','576',62,NULL,0,0,1,0,0),(906218,8776,12608,'','','',63,NULL,0,0,1,0,0),(906219,8776,12608,'AB','TOTAL ACTIVO (A + B)','A,B',64,NULL,1,1,1,0,0),(906220,8776,12608,'','','',65,NULL,0,0,1,0,0),(906221,8776,12608,'','','',66,NULL,0,0,1,0,0),(906222,8776,12608,'A0','PATRIMONIO NETO Y PASIVO','',67,NULL,1,0,1,0,0),(906223,8776,12608,'','','',68,NULL,0,0,1,0,1),(906224,8776,12608,'PA','A) PATRIMONIO NETO','PA.A-1,PA.A-2,PA.A-3',69,NULL,1,1,1,0,1),(906225,8776,12608,'PA.A-1','A-1) Fondos propios.','PA.A-1.I,PA.A-1.II,PA.A-1.III,PA.A-1.IV,PA.A-1.V,PA.A-1.VI,PA.A-1.VII,PA.A-1.VIII,PA.A-1.IX',70,NULL,1,1,1,0,1),(906226,8776,12608,'PA.A-1.I','I. Capital.','PA.A-1.I.1,PA.A-1.I.2',71,NULL,1,1,1,0,1),(906227,8776,12608,'PA.A-1.I.1','1. Capital escriturado.','100,101,102',72,NULL,0,0,1,0,1),(906228,8776,12608,'PA.A-1.I.2','2. (Capital no exigido).','(1030),(1040)',73,NULL,0,0,1,0,1),(906229,8776,12608,'PA.A-1.II','II. Prima de emisión.','110',74,NULL,1,0,1,0,1),(906230,8776,12608,'PA.A-1.III','III. Reservas.','PA.A-1.III.1,PA.A-1.III.2',75,NULL,1,1,1,0,1),(906231,8776,12608,'PA.A-1.III.1','1. Legal y estatutarias.','112,1141',76,NULL,0,0,1,0,1),(906232,8776,12608,'PA.A-1.III.2','2. Otras reservas.','113,1140,1142,1143,1144,115,119',77,NULL,0,0,1,0,1),(906233,8776,12608,'PA.A-1.IV','IV. (Acciones y participaciones en patrimonio propias).','(108),(109)',78,NULL,1,0,1,0,1),(906234,8776,12608,'PA.A-1.V','V. Resultados de ejercicios anteriores.','PA.A-1.V.1,PA.A-1.V.2',79,NULL,1,1,1,0,1),(906235,8776,12608,'PA.A-1.V.1','1. Remanente.','120',80,NULL,0,0,1,0,1),(906236,8776,12608,'PA.A-1.V.2','2. (Resultados negativos de ejercicios anteriores).','(121)',81,NULL,0,0,1,0,1),(906237,8776,12608,'PA.A-1.VI','VI. Otras aportaciones de socios.','118',82,NULL,1,0,1,0,1),(906238,8776,12608,'PA.A-1.VII','VII. Resultado del ejercicio.','129,6,7',83,NULL,1,0,1,0,1),(906239,8776,12608,'PA.A-1.VIII','VIII. (Dividendo a cuenta).','(557)',84,NULL,1,0,1,0,1),(906240,8776,12608,'PA.A-1.IX','IX. Otros instrumentos de patrimonio neto.','111',85,NULL,1,0,1,0,1),(906241,8776,12608,'PA.A-2','A-2) Ajustes por cambios de valor.','PA.A-2.I,PA.A-2.II,PA.A-2.III',86,NULL,1,1,1,0,1),(906242,8776,12608,'PA.A-2.I','I. Activos financieros disponibles para la venta.','133',87,NULL,0,0,1,0,1),(906243,8776,12608,'PA.A-2.II','II. Operaciones de cobertura.','1340',88,NULL,0,0,1,0,1),(906244,8776,12608,'PA.A-2.III','III. Otros.','137,139',89,NULL,0,0,1,0,1),(906245,8776,12608,'PA.A-3','A-3) Subvenciones, donaciones y legados recibidos.','130,131,132',90,NULL,1,0,1,0,1),(906246,8776,12608,'','','',91,NULL,0,0,1,0,1),(906247,8776,12608,'PB','B) PASIVO NO CORRIENTE','PB.I,PB.II,PB.III,PB.IV,PB.V',92,NULL,1,1,1,0,1),(906248,8776,12608,'PB.I','I. Provisiones a largo plazo.','PB.I.1,PB.I.2,PB.I.3,PB.I.4',93,NULL,1,1,1,0,1),(906249,8776,12608,'PB.I.1','1. Obligaciones por prestaciones a largo plazo al personal.','140',94,NULL,0,0,1,0,1),(906250,8776,12608,'PB.I.2','2. Actuaciones medioambientales.','145',95,NULL,0,0,1,0,1),(906251,8776,12608,'PB.I.3','3. Provisiones por reestructuración.','146',96,NULL,0,0,1,0,1),(906252,8776,12608,'PB.I.4','4. Otras provisiones.','141,142,143,147',97,NULL,0,0,1,0,1),(906253,8776,12608,'PB.II','II Deudas a largo plazo.','PB.II.1,PB.II.2,PB.II.3,PB.II.4,PB.II.5',98,NULL,1,1,1,0,1),(906254,8776,12608,'PB.II.1','1. Obligaciones y otros valores negociables.','177,178,179',99,NULL,0,0,1,0,1),(906255,8776,12608,'PB.II.2','2. Deudas con entidades de crédito.','1605,170',100,NULL,0,0,1,0,1),(906256,8776,12608,'PB.II.3','3. Acreedores por arrendamiento financiero.','1625,174',101,NULL,0,0,1,0,1),(906257,8776,12608,'PB.II.4','4. Derivados.','176',102,NULL,0,0,1,0,1),(906258,8776,12608,'PB.II.5','5. Otros pasivos financieros.','1615,1635,171,172,173,175,180,185,189',103,NULL,0,0,1,0,1),(906259,8776,12608,'PB.III','III. Deudas con empresas del grupo y asociadas a largo plazo.','1603,1604,1613,1614,1623,1624,1633,1634',104,NULL,1,0,1,0,1),(906260,8776,12608,'PB.IV','IV. Pasivos por impuesto diferido.','479',105,NULL,1,0,1,0,1),(906261,8776,12608,'PB.V','V. Periodificaciones a largo plazo.','181',106,NULL,1,0,1,0,1),(906262,8776,12608,'','','',107,NULL,0,0,1,0,1),(906263,8776,12608,'PC','C) PASIVO CORRIENTE','PC.I,PC.II,PC.III,PC.IV,PC.V,PC.VI',108,NULL,1,1,1,0,1),(906264,8776,12608,'PC.I','I. Pasivos vinculados con activos no corrientes mantenidos para la venta.','585,586,587,588,589',109,NULL,1,0,1,0,1),(906265,8776,12608,'PC.II','II. Provisiones a corto plazo.','499,529',110,NULL,1,0,1,0,1),(906266,8776,12608,'PC.III','III. Deudas a corto plazo.','PC.III.1,PC.III.2,PC.III.3,PC.III.4,PC.III.5',111,NULL,1,1,1,0,1),(906267,8776,12608,'PC.III.1','1. Obligaciones y otros valores negociables.','500,501,505,506',112,NULL,0,0,1,0,1),(906268,8776,12608,'PC.III.2','2. Deudas con entidades de crédito.','5105,520,527',113,NULL,0,0,1,0,1),(906269,8776,12608,'PC.III.3','3. Acreedores por arrendamiento financiero.','5125,524',114,NULL,0,0,1,0,1),(906270,8776,12608,'PC.III.4','4. Derivados.','5595,5598',115,NULL,0,0,1,0,1),(906271,8776,12608,'PC.III.5','5. Otros pasivos financieros.','(1034),(1044),(190),(192),194,509,5115,5135,5145,521,522,523,525,526,528,?551,5525,5530,5532,555,5565,5566,560,561,569',116,NULL,0,0,1,0,1),(906272,8776,12608,'PC.IV','IV. Deudas con empresas del grupo y asociadas a corto plazo.','5103,5104,5113,5114,5123,5124,5133,5134,5143,5144,5523,5524,5563,5564',117,NULL,1,0,1,0,1),(906273,8776,12608,'PC.V','V. Acreedores comerciales y otras cuentas a pagar.','PC.V.1,PC.V.2,PC.V.3,PC.V.4,PC.V.5,PC.V.6,PC.V.7',118,NULL,1,1,1,0,1),(906274,8776,12608,'PC.V.1','1. Proveedores','400,401,405,(406)',119,NULL,0,0,1,0,1),(906275,8776,12608,'PC.V.2','2. Proveedores, empresas del grupo y asociadas.','403,404',120,NULL,0,0,1,0,1),(906276,8776,12608,'PC.V.3','3. Acreedores varios.','41',121,NULL,0,0,1,0,1),(906277,8776,12608,'PC.V.4','4. Personal (remuneraciones pendientes de pago).','465,466',122,NULL,0,0,1,0,1),(906278,8776,12608,'PC.V.5','5. Pasivos por impuesto corriente.','4752',123,NULL,0,0,1,0,1),(906279,8776,12608,'PC.V.6','6. Otras deudas con las Administraciones Públicas.','4750,4751,4758,476,477',124,NULL,0,0,1,0,1),(906280,8776,12608,'PC.V.7','7. Anticipos de clientes.','438',125,NULL,0,0,1,0,1),(906281,8776,12608,'PC.VI','VI. Periodificaciones a corto plazo.','485,568',126,NULL,1,0,1,0,1),(906282,8776,12608,'','','',127,NULL,0,0,1,0,1),(906283,8776,12608,'PABC','TOTAL PATRIMONIO NETO Y PASIVO (A + B + C)','PA,PB,PC',128,NULL,1,1,1,0,1),(906284,8776,12608,'','','',129,NULL,0,0,1,0,1),(906285,8776,12608,'DIF','DIFERENCIA (ACTIVO-PATRIMONIO NETO Y PASIVO)','AB,(PABC)',130,NULL,1,1,1,1,0),(906286,8776,12609,'A','A OPERACIONES CONTINUADAS','A.T4',0,NULL,1,1,1,0,1),(906287,8776,12609,'A.1','1. Importe neto de la cifra de negocios.','A.1.A,A.1.B',1,NULL,1,1,1,0,1),(906288,8776,12609,'A.1.A','a) Ventas.','700,701,702,703,704,(706),(708),(709)',2,NULL,0,0,1,0,1),(906289,8776,12609,'A.1.B','b) Prestaciones de servicios.','705',3,NULL,0,0,1,0,1),(906290,8776,12609,'A.2','2. Variación de existencias de productos terminados y en curso de fabricación.','(6930),71,7930',4,NULL,1,0,1,0,1),(906291,8776,12609,'A.3','3. Trabajos realizados por la empresa para su activo.','73',5,NULL,1,0,1,0,1),(906292,8776,12609,'A.4','4. Aprovisionamientos.','A.4.A,A.4.B,A.4.C,A.4.D',6,NULL,1,1,1,0,1),(906293,8776,12609,'A.4.A','a) Consumo de mercaderías.','(600),6060,6080,6090,610',7,NULL,0,0,1,0,1),(906294,8776,12609,'A.4.B','b) Consumo de materias primas y otras materias consumibles.','(601),(602),6061,6062,6081,6082,6091,6092,611,612',8,NULL,0,0,1,0,1),(906295,8776,12609,'A.4.C','c) Trabajos realizados por otras empresas.','(607)',9,NULL,0,0,1,0,1),(906296,8776,12609,'A.4.D','d) Deterioro de mercaderías, materias primas y otros aprovisionamientos.','(6931),(6932),(6933),7931,7932,7933',10,NULL,0,0,1,0,1),(906297,8776,12609,'A.5','5. Otros ingresos de explotación.','A.5.A,A.5.B',11,NULL,1,1,1,0,1),(906298,8776,12609,'A.5.A','a) Ingresos accesorios y otros de gestión corriente.','75',12,NULL,0,0,1,0,1),(906299,8776,12609,'A.5.B','b) Subvenciones de explotación incorporadas al resultado del ejercicio.','740,747',13,NULL,0,0,1,0,1),(906300,8776,12609,'A.6','6. Gastos de personal.','A.6.A,A.6.B,A.6.C',14,NULL,1,1,1,0,1),(906301,8776,12609,'A.6.A','a) Sueldos, salarios y asimilados.','(640),(641),(6450)',15,NULL,0,0,1,0,1),(906302,8776,12609,'A.6.B','b) Cargas sociales.','(642),(643),(649)',16,NULL,0,0,1,0,1),(906303,8776,12609,'A.6.C','c) Provisiones.','(644),(6457),7950,7957',17,NULL,0,0,1,0,1),(906304,8776,12609,'A.7','7. Otros gastos de explotación.','A.7.A,A.7.B,A.7.C,A.7.D',18,NULL,1,1,1,0,1),(906305,8776,12609,'A.7.A','a) Servicios exteriores.','(62)',19,NULL,0,0,1,0,1),(906306,8776,12609,'A.7.B','b) Tributos.','(631),(634),636,639',20,NULL,0,0,1,0,1),(906307,8776,12609,'A.7.C','c) Pérdidas, deterioro y variación de provisiones por operaciones comerciales.','(650),(694),(695),794,7954',21,NULL,0,0,1,0,1),(906308,8776,12609,'A.7.D','d) Otros gastos de gestión corriente.','(651),(659)',22,NULL,0,0,1,0,1),(906309,8776,12609,'A.8','8. Amortización del inmovilizado.','(68)',23,NULL,1,0,1,0,1),(906310,8776,12609,'A.9','9. Imputación de subvenciones de inmovilizado no financiero y otras.','746',24,NULL,1,0,1,0,1),(906311,8776,12609,'A.10','10. Excesos de provisiones.','7951,7952,7955,7956',25,NULL,1,0,1,0,1),(906312,8776,12609,'A.11','11. Deterioro y resultado por enajenaciones del inmovilizado.','A.11.A,A.11.B',26,NULL,1,1,1,0,1),(906313,8776,12609,'A.11.A','a) Deterioros y pérdidas.','(690),(691),(692),790,791,792',27,NULL,0,0,1,0,1),(906314,8776,12609,'A.11.B','b) Resultados por enajenaciones y otras.','(670),(671),(672),770,771,772',28,NULL,0,0,1,0,1),(906315,8776,12609,'A.X','Otros Resultados.','678,778',29,NULL,1,0,1,0,1),(906316,8776,12609,'','','',30,NULL,0,0,1,0,1),(906317,8776,12609,'A.T1','A.1) RESULTADO DE EXPLOTACIÓN (1+2+3+4+5+6+7+8+9+10+11+12)','A.1,A.2,A.3,A.4,A.5,A.6,A.7,A.8,A.9,A.10,A.11,A.X',31,NULL,1,1,1,0,1),(906318,8776,12609,'','','',32,NULL,0,0,1,0,1),(906319,8776,12609,'A.12','12. Ingresos financieros.','A.12.A,A.12.B',33,NULL,1,1,1,0,1),(906320,8776,12609,'A.12.A','a) De participaciones en instrumentos de patrimonio.','A.12.A.1,A.12.A.2',34,NULL,1,1,1,0,1),(906321,8776,12609,'A.12.A.1','a1) En empresas del grupo y asociadas.','7600,7601',35,NULL,0,0,1,0,1),(906322,8776,12609,'A.12.A.2','a2) En terceros.','7602,7603',36,NULL,0,0,1,0,1),(906323,8776,12609,'A.12.B','b) De valores negociables y otros instrumentos financieros.','A.12.B.1,A.12.B.2',37,NULL,1,1,1,0,1),(906324,8776,12609,'A.12.B.1','b1) De empresas del grupo y asociadas.','7610,7611,76200,76201,76210,76211',38,NULL,0,0,1,0,1),(906325,8776,12609,'A.12.B.2','b2) De terceros.','7612,7613,76202,76203,76212,76213,767,769',39,NULL,0,0,1,0,1),(906326,8776,12609,'A.13','13. Gastos financieros.','A.13.A,A.13.B,A.13.C',40,NULL,1,1,1,0,1),(906327,8776,12609,'A.13.A','a) Por deudas con empresas del grupo y asociadas.','(6610),(6611),(6615),(6616),(6620),(6621),(6640),(6641),(6650),(6651),(6654),(6655)',41,NULL,0,0,1,0,1),(906328,8776,12609,'A.13.B','b) Por deudas con terceros.','(6612),(6613),(6617),(6618),(6622),(6623),(6624),(6642),(6643),(6652),(6653),(6656),(6657),(669)',42,NULL,0,0,1,0,1),(906329,8776,12609,'A.13.C','c) Por actualización de provisiones.','(660)',43,NULL,0,0,1,0,1),(906330,8776,12609,'A.14','14. Variación de valor razonable en instrumentos financieros.','A.14.A,A.14.B',44,NULL,1,1,1,0,1),(906331,8776,12609,'A.14.A','a) Cartera de negociación y otros.','(6630),(6631),(6633),7630,7631,7633',45,NULL,0,0,1,0,1),(906332,8776,12609,'A.14.B','b) Imputación al resultado del ejercicio por activos financieros disponibles para la venta.','(6632),7632',46,NULL,0,0,1,0,1),(906333,8776,12609,'A.15','15. Diferencias de cambio.','(668),768',47,NULL,1,0,1,0,1),(906334,8776,12609,'A.16','16. Deterioro y resultado por enajenaciones de instrumentos financieros.','A.16.A,A.16.B',48,NULL,1,1,1,0,1),(906335,8776,12609,'A.16.A','a) Deterioros y pérdidas.','(696),(697),(698),(699),796,797,798,799',49,NULL,0,0,1,0,1),(906336,8776,12609,'A.16.B','b) Resultados por enajenaciones y otras.','(666),(667),(673),(675),766,773,775',50,NULL,0,0,1,0,1),(906337,8776,12609,'','','',51,NULL,0,0,1,0,1),(906338,8776,12609,'A.T2','A.2) RESULTADO FINANCIERO (12+13+14+15+16)','A.12,A.13,A.14,A.15,A.16',52,NULL,1,1,1,0,1),(906339,8776,12609,'','','',53,NULL,0,0,1,0,1),(906340,8776,12609,'A.T3','A.3) RESULTADO ANTES DE IMPUESTOS (A.1+A.2)','A.T1,A.T2',54,NULL,1,1,1,0,1),(906341,8776,12609,'','','',55,NULL,0,0,1,0,1),(906342,8776,12609,'A.17','17. Impuestos sobre beneficios.','(6300),6301,(633),638',56,NULL,1,0,1,0,1),(906343,8776,12609,'','','',57,NULL,0,0,1,0,1),(906344,8776,12609,'A.T4','A.4) RESULTADO DEL EJ. PROCEDENTE DE OP. CONTINUADAS (A.3+17)','A.T3,A.17',58,NULL,1,1,1,0,1),(906345,8776,12609,'','','',59,NULL,0,0,1,0,1),(906346,8776,12609,'B','B) OPERACIONES INTERRUMPIDAS','B.18',60,NULL,1,1,1,0,1),(906347,8776,12609,'B.18','18. Resultado del ejercicio procedente de operaciones interrumpidas neto de impuestos.','',61,NULL,0,0,1,0,1),(906348,8776,12609,'','','',62,NULL,0,0,1,0,1),(906349,8776,12609,'A.5','A.5) RESULTADO DEL EJERCICIO (A.4+18)','A.T4,B.18',63,NULL,1,1,1,0,1),(906350,8776,12610,'','ACTIVO','',0,NULL,1,0,1,0,0),(906351,8776,12610,'11000','A) ACTIVO NO CORRIENTE','11100,11200,11300,11400,11500,11600',1,NULL,1,1,1,0,0),(906352,8776,12610,'11100','I. Inmovilizado intangible','20,(280),(290)',2,NULL,1,0,1,0,0),(906353,8776,12610,'11200','II. Inmovilizado material','21,(281),(291),23',3,NULL,1,0,1,0,0),(906354,8776,12610,'11300','III. Inversiones inmobiliarias','22,(282),(292)',4,NULL,1,0,1,0,0),(906355,8776,12610,'11400','IV. Inversiones en empresas del grupo y asociadas L/P','2403,2404,2413,2414,2423,2424,2493,2494,293,(2943),(2944),(2953),(2954)',5,NULL,1,0,1,0,0),(906356,8776,12610,'11500','V. Inversiones financieras a largo plazo','2405,2415,2425,(2495),250,251,252,253,254,255,257,258,259,26,2945,2955,297,298',6,NULL,1,0,1,0,0),(906357,8776,12610,'11600','VI. Activos por Impuesto diferido','474',7,NULL,1,0,1,0,0),(906358,8776,12610,'','','',8,NULL,0,0,1,0,0),(906359,8776,12610,'12000','B) ACTIVO CORRIENTE','12100,12200,12300,12400,12500,12600,12700',9,NULL,1,1,1,0,0),(906360,8776,12610,'12100','I. Activos no corrientes mantenidos para la venta','580,581,582,583,584,(599)',10,NULL,1,0,1,0,0),(906361,8776,12610,'12200','II. Existencias','30,31,32,33,34,35,36,(39),407',11,NULL,1,0,1,0,0),(906362,8776,12610,'12300','III. Deudores comerciales y otras cuentas a cobrar','12380,12370,12390',12,NULL,1,1,1,0,0),(906363,8776,12610,'12380','1. Clientes por ventas y prestaciones de servicios','430,431,432,433,434,435,436,(437),(490),(493)',13,NULL,0,0,1,0,0),(906364,8776,12610,'12370','2. Accionistas (socios) por desembolsos exigidos','5580',14,NULL,0,0,1,0,0),(906365,8776,12610,'12390','3. Otros deudores','44,460,470,471,472,473,5531,5533,544',15,NULL,0,0,1,0,0),(906366,8776,12610,'12400','IV. Inversiones en empresas del grupo y asociadas C/P','5303,5304,5313,5314,5323,5324,5333,5334,5343,5344,5353,5354,(5393),(5394),5523,5524,(593),(5943),(5944),(5953),(5954)',16,NULL,1,0,1,0,0),(906367,8776,12610,'12500','V. Inversiones financieras a corto plazo','5305,5315,5325,5335,5345,5355,(5395),540,541,542,543,545,546,547,548,(549),?551,5525,5590,5593,565,566,(5945),(5955),(597),(598)',17,NULL,1,0,1,0,0),(906368,8776,12610,'12600','VI. Periodificaciones a corto plazo','480,567',18,NULL,1,0,1,0,0),(906369,8776,12610,'12700','VII. Efectivo y otros activos líquidos equivalentes','57',19,NULL,1,0,1,0,0),(906370,8776,12610,'','','',20,NULL,0,0,1,0,0),(906371,8776,12610,'10000','TOTAL ACTIVO (A+B)','11000,12000',21,NULL,1,1,1,0,0),(906372,8776,12610,'','','',22,NULL,0,0,1,0,0),(906373,8776,12610,'','PATRIMONIO NETO Y PASIVO','',23,NULL,1,0,1,0,1),(906374,8776,12610,'20000','A) PATRIMONIO NETO','21000,22000,23000',24,NULL,1,1,1,0,1),(906375,8776,12610,'21000','A-1) Fondos propios','21100,21200,21300,21400,21500,21600,21700,21800,21900',25,NULL,1,1,1,0,1),(906376,8776,12610,'21100','I. Capital','21110,21120',26,NULL,1,1,1,0,1),(906377,8776,12610,'21110','1. Capital escriturado','100,101,102',27,NULL,0,0,1,0,1),(906378,8776,12610,'21120','2. (Capital no exigido)','(1030),(1040)',28,NULL,0,0,1,0,1),(906379,8776,12610,'21200','II. Prima de emisión','110',29,NULL,1,0,1,0,1),(906380,8776,12610,'21300','III. Reservas','112,113,114,115,119,108,109',30,NULL,1,0,1,0,1),(906381,8776,12610,'21400','IV. (Acciones y participaciones en patrimonio propias)','(108),(109)',31,NULL,1,0,1,0,1),(906382,8776,12610,'21500','V. Resultado de ejercicios anteriores','120,(121)',32,NULL,1,0,1,0,1),(906383,8776,12610,'21600','VI. Otras aportaciones de socios','118',33,NULL,1,0,1,0,1),(906384,8776,12610,'21700','VII. Resultado del ejercicio','129,6,7',34,NULL,1,0,1,0,1),(906385,8776,12610,'21800','VIII. (Dividendo a cuenta )','(557)',35,NULL,1,0,1,0,1),(906386,8776,12610,'21900','IX. Otros instrumentos de patrimonio neto','111',36,NULL,1,0,1,0,1),(906387,8776,12610,'22000','A-2) Ajustes por cambios de valor','133,1340,137',37,NULL,1,0,1,0,1),(906388,8776,12610,'23000','A-3) Subvenciones, donaciones y legados recibidos','130,131,132',38,NULL,1,0,1,0,1),(906389,8776,12610,'','','',39,NULL,0,0,1,0,1),(906390,8776,12610,'31000','B) PASIVO NO CORRIENTE','31100,31200,31300,31400,31500',40,NULL,1,1,1,0,1),(906391,8776,12610,'31100','I. Provisiones a largo plazo','14',41,NULL,1,0,1,0,1),(906392,8776,12610,'31200','II. Deudas a largo plazo','31220,31230,31290',42,NULL,1,1,1,0,1),(906393,8776,12610,'31220','1. Deudas con entidades de crédito','1605,170',43,NULL,0,0,1,0,1),(906394,8776,12610,'31230','2. Acreedores por arrendamiento financiero','1625,174',44,NULL,0,0,1,0,1),(906395,8776,12610,'31290','3. Otras deudas a largo plazo','1615,1635,171,172,173,175,176,177,178,179,180,185,189',45,NULL,0,0,1,0,1),(906396,8776,12610,'31300','III .Deudas con empresas del grupo y asociadas L/P','1603,1604,1613,1614,1623,1624,1633,1634',46,NULL,1,0,1,0,1),(906397,8776,12610,'31400','IV. Pasivos por impuesto diferido','479',47,NULL,1,0,1,0,1),(906398,8776,12610,'31500','V. Periodificaciones a largo plazo','181',48,NULL,1,0,1,0,1),(906399,8776,12610,'','','',49,NULL,0,0,1,0,1),(906400,8776,12610,'32000','C) PASIVO CORRIENTE','32100,32200,32300,32400,32500,32600',50,NULL,1,1,1,0,1),(906401,8776,12610,'32100','I. Pasivos vinculados con activos no corrientes mantenidos para la venta','585,586,587,588,589',51,NULL,1,0,1,0,1),(906402,8776,12610,'32200','II. Provisiones a corto plazo','499,529',52,NULL,1,0,1,0,1),(906403,8776,12610,'32300','III. Deudas a corto plazo','32320,32330,32390',53,NULL,1,1,1,0,1),(906404,8776,12610,'32320','1. Deudas con entidades de crédito','5105,520,527',54,NULL,0,0,1,0,1),(906405,8776,12610,'32330','2. Acreedores por arrendamiento financiero','5125,524',55,NULL,0,0,1,0,1),(906406,8776,12610,'32390','3. Otras deudas a corto plazo','(1034),(1044),(190),(192),194,500,501,505,509,5115,5135,5145,521,522,523,525,526,528,?551,5525,5530,5532,555,5565,5566,5595,5598,560,561,569',56,NULL,0,0,1,0,1),(906407,8776,12610,'32400','IV. Deudas con empresas del grupo y asociadas C/P','5103,5104,5113,5114,5123,5124,5133,5134,5143,5144,5523,5524,5563,5564',57,NULL,1,0,0,0,1),(906408,8776,12610,'32500','V. Acreedores comerciales y otras cuentas a pagar','32580,32590',58,NULL,1,1,1,0,1),(906409,8776,12610,'32580','1. Proveedores','400,401,403,404,405,(406)',59,NULL,0,0,1,0,1),(906410,8776,12610,'32590','2. Otros acreedores','41,438,465,466,475,476,477',60,NULL,0,0,1,0,1),(906411,8776,12610,'32600','VI. Periodificaciones a corto plazo','485,568',61,NULL,1,0,1,0,1),(906412,8776,12610,'','','',62,NULL,0,0,1,0,1),(906413,8776,12610,'30000','TOTAL PATRIMONIO NETO Y PASIVO (A+B+C)','20000,31000,32000',63,NULL,1,1,1,0,1),(906414,8776,12610,'DIF','DIFERENCIA (ACTIVO-PATRIMONIO NETO Y PASIVO)','10000,(30000)',64,NULL,1,1,1,1,0),(906415,8776,12611,'','','',0,NULL,0,0,1,0,1),(906416,8776,12611,'40100','1. Importe neto de la cifra de negocios','700,701,702,703,704,705,(706),(708),(709)',1,NULL,0,0,1,0,1),(906417,8776,12611,'40200','2. Variación de existencias de productos terminados y en curso de fabricación','(6930),71,7930',2,NULL,0,0,1,0,1),(906418,8776,12611,'40300','3. Trabajos realizados por la empresa para su activo','73',3,NULL,0,0,1,0,1),(906419,8776,12611,'40400','4. Aprovisionamientos','(600),(601),(602),(606),(607),608,609,61,(693),(6932),(6933),7931,7932,7933',4,NULL,0,0,1,0,1),(906420,8776,12611,'40500','5. Otros ingresos de explotación','740,747,75',5,NULL,0,0,1,0,1),(906421,8776,12611,'40600','6. Gastos de personal','(64),7950,7957',6,NULL,0,0,1,0,1),(906422,8776,12611,'40700','7. Otros gastos de explotación','(62),(631),(634),636,639,(65),(694),(695),794,7954',7,NULL,0,0,1,0,1),(906423,8776,12611,'40800','8. Amortización de inmovilizado','(68)',8,NULL,0,0,1,0,1),(906424,8776,12611,'40900','9. Imputación de subvenciones de inmovilizado no financiero y otras','746',9,NULL,0,0,1,0,1),(906425,8776,12611,'41000','10. Excesos de provisiones','7951,7952,7955,7956',10,NULL,0,0,1,0,1),(906426,8776,12611,'41100','11. Deterioro y resultado por enejenaciones del inmovilizado','(670),(671),(672),(690),(691),(692),770,771,772,790,791,792',11,NULL,0,0,1,0,1),(906427,8776,12611,'41200','12. Diferencia negativa de combinaciones de negocio','774',12,NULL,0,0,1,0,1),(906428,8776,12611,'41300','13. Otros Resultados','(678),778',13,NULL,0,0,1,0,1),(906429,8776,12611,'','','',14,NULL,0,0,1,0,1),(906430,8776,12611,'49100','A) RESULTADO DE EXPLOTACIÓN (1+2+3+4+5+6+7+8+9+10+11+12+13)','40100,40200,40300,40400,40500,40600,40700,40800,40900,41000,41100,41200,41300',15,NULL,1,1,1,0,1),(906431,8776,12611,'','','',16,NULL,0,0,1,0,1),(906432,8776,12611,'41400','14. Ingresos financieros','41430,41490',17,NULL,0,1,1,0,0),(906433,8776,12611,'41430','a) Imputación de subvenciones, donaciones y legados de carácter financiero','7460',18,NULL,0,0,1,0,1),(906434,8776,12611,'41490','b) Otros ingresos financieros','760,761,762,767,769',19,NULL,0,0,1,0,1),(906435,8776,12611,'41500','15. Gastos financieros','(660),(661),(662),(664),(665),(669)',20,NULL,0,0,1,0,1),(906436,8776,12611,'41600','16. Variación de valor razonable en instrumentos financieros','(663),763',21,NULL,0,0,1,0,1),(906437,8776,12611,'41700','17. Diferencias de cambio','(668),768',22,NULL,0,0,1,0,1),(906438,8776,12611,'41800','18. Deterioro y resultado por enajenaciones de instrumentos financieros','(666),(667),(673),(675),(696),(697),(698),(699),766,773,775,796,797,798,799',23,NULL,0,0,1,0,1),(906439,8776,12611,'42100','19. Otros ingresos y gastos de carácter financiero','42110,42120,42130',24,NULL,0,1,1,0,0),(906440,8776,12611,'42110','a). Incorporación al activo de gastos financieros','',25,NULL,0,0,1,0,1),(906441,8776,12611,'42120','b). Ingresos financieros derivados de convenios de acreedores','',26,NULL,0,0,1,0,1),(906442,8776,12611,'42130','c). Resto de ingresos y gastos','',27,NULL,0,0,1,0,1),(906443,8776,12611,'','','',28,NULL,0,0,1,0,1),(906444,8776,12611,'49200','B) RESULTADO FINANCIERO (14+15+16+17+18+19)','41400,41500,41600,41700,41800,42100,',29,NULL,1,1,1,0,1),(906445,8776,12611,'','','',30,NULL,0,0,1,0,1),(906446,8776,12611,'49300','C) RESULTADO ANTES DE IMPUESTOS (A+B)','49100,49200',31,NULL,1,1,1,0,1),(906447,8776,12611,'','','',32,NULL,0,0,1,0,1),(906448,8776,12611,'41900','20. Impuestos sobre beneficios','(6300),(6301),(633),638',33,NULL,0,0,1,0,1),(906449,8776,12611,'','','',34,NULL,0,0,0,0,1),(906450,8776,12611,'49500','D) RESULTADO DEL EJERCICIO (C+20)','49300,41900',35,NULL,1,1,1,0,1),(906451,8776,12612,'A','A) Resultado de la cuenta de pérdidas y ganancias','',0,NULL,0,0,1,0,0),(906452,8776,12612,'','','',1,NULL,0,0,1,0,0),(906453,8776,12612,'1','Ingresos y gastos imputados directamente al patrimonio neto','1.I,1.II,1.III,1.IV,1.V',2,NULL,1,0,1,0,0),(906454,8776,12612,'1.I','I. Por valoración de instrumentos financieros','800,89,900,991,992',3,NULL,0,0,1,0,0),(906455,8776,12612,'1.II','II. Por coberturas de flujos de efectivo','810,910',4,NULL,0,0,1,0,0),(906456,8776,12612,'1.III','III. Subvenciones',' donaciones y legados recibidos',13,NULL,0,0,0,1,0),(906457,8776,12612,'1.IV','IV. Por ganancias y pérdidas actuariales y otros ajust','85,95',6,NULL,0,0,1,0,0),(906458,8776,12612,'1.V','V. Efecto impositivo','8300,8301,833,834,835,838',7,NULL,0,0,1,0,0),(906459,8776,12612,'B','B) Total Ingresos y gastos imputados directamente al patrimonio neto (I+II+III+IV+V)','1.I,1.II,1.III,1.IV,1.V',8,NULL,1,1,1,0,0),(906460,8776,12612,'','','',9,NULL,0,0,1,0,0),(906461,8776,12612,'2','Transferencias a la cuenta de P Y G','2.VI,2.VII,2.VIII,2.IX',10,NULL,1,0,1,0,0),(906462,8776,12612,'2.VI','VI. Por valoración de instrumentos financieros','802,902,993,994',11,NULL,0,0,1,0,0),(906463,8776,12612,'2.VII','VII. Por coberturas de flujos de efectivo','812,912',12,NULL,0,0,1,0,0),(906464,8776,12612,'2.VIII','VIII. Subvenciones',' donaciones y legados recibidos',18,NULL,0,0,0,1,0),(906465,8776,12612,'2.IX','IX. Efecto impositivo','8301,836,837',14,NULL,0,0,1,0,0),(906466,8776,12612,'C','C) Total transferencias a la cuentad de P Y G (VI+VII+VIII+IX)','2.VI,2.VII,2.VIII,2.IX',15,NULL,1,1,1,0,0),(906467,8776,12612,'','','',16,NULL,0,0,1,0,0),(906468,8776,12612,'D','TOTAL DE INGRESOS Y GASTOS RECONOCIDOS (A+B+C)','A,B,C',17,NULL,1,1,1,0,0),(906469,8779,12613,'A0','ACTIVO','',0,NULL,1,0,1,0,0),(906470,8779,12613,'A','A) ACTIVO NO CORRIENTE','A.I,A.II,A.III,A.IV,A.V,A.VI',1,NULL,1,1,1,0,0),(906471,8779,12613,'A.I','I. Inmovilizado intangible.','A.I.1,A.I.2,A.I.3,A.I.4,A.I.5,A.I.6',2,NULL,1,1,1,0,0),(906472,8779,12613,'A.I.1','1. Desarrollo.','201,(2801),(2901)',3,NULL,0,0,1,0,0),(906473,8779,12613,'A.I.2','2. Concesiones.','202,(2802),(2902)',4,NULL,0,0,1,0,0),(906474,8779,12613,'A.I.3','3. Patentes, licencias, marcas y similares.','203,(2803),(2903)',5,NULL,0,0,1,0,0),(906475,8779,12613,'A.I.4','4. Fondo de comercio.','204',6,NULL,0,0,1,0,0),(906476,8779,12613,'A.I.5','5. Aplicaciones informáticas.','206,(2806),(2906)',7,NULL,0,0,1,0,0),(906477,8779,12613,'A.I.6','6. Otro inmovilizado intangible.','205,209,(2805),(2905)',8,NULL,0,0,1,0,0),(906478,8779,12613,'A.II','II. Inmovilizado material.','A.II.1,A.II.2,A.II.3',9,NULL,1,1,1,0,0),(906479,8779,12613,'A.II.1','1. Terrenos y construcciones.','210,211,(2811),(2910),(2911)',10,NULL,0,0,1,0,0),(906480,8779,12613,'A.II.2','2. Instalaciones técnicas, y otro inmovilizado material.','212,213,214,215,216,217,218,219,(2812),(2813),(2814),(2815),(2816),(2817),(2818),(2819),(2912),(2913),(2914),(2915),(2916),(2917),(2918),(2919)',11,NULL,0,0,1,0,0),(906481,8779,12613,'A.II.3','3. Inmovilizado en curso y anticipos.','23',12,NULL,0,0,1,0,0),(906482,8779,12613,'A.III','III. Inversiones inmobiliarias.','A.III.1,A.III.2',13,NULL,1,1,1,0,0),(906483,8779,12613,'A.III.1','1. Terrenos.','220,(2920)',14,NULL,0,0,1,0,0),(906484,8779,12613,'A.III.2','2. Construcciones.','221,(282),(2921)',15,NULL,0,0,1,0,0),(906485,8779,12613,'A.IV','IV. Inversiones en empresas del grupo y asociadas a largo plazo.','A.IV.1,A.IV.2,A.IV.3,A.IV.4,A.IV.5',16,NULL,1,1,1,0,0),(906486,8779,12613,'A.IV.1','1. Instrumentos de patrimonio.','2403,2404,(2493),(2494),(293)',17,NULL,0,0,1,0,0),(906487,8779,12613,'A.IV.2','2. Créditos a empresas.','2423,2424,(2953),(2954)',18,NULL,0,0,1,0,0),(906488,8779,12613,'A.IV.3','3. Valores representativos de deuda.','2413,2414,(2943),(2944)',19,NULL,0,0,1,0,0),(906489,8779,12613,'A.IV.4','4. Derivados.','',20,NULL,0,0,1,0,0),(906490,8779,12613,'A.IV.5','5. Otros activos financieros.','',21,NULL,0,0,1,0,0),(906491,8779,12613,'A.V','V. Inversiones financieras a largo plazo.','A.V.1,A.V.2,A.V.3,A.V.4,A.V.5',22,NULL,1,1,1,0,0),(906492,8779,12613,'A.V.1','1. Instrumentos de patrimonio.','2405,(2495),250,(259)',23,NULL,0,0,1,0,0),(906493,8779,12613,'A.V.2','2. Créditos a terceros','2425,252,253,254,(2955),(298)',24,NULL,0,0,1,0,0),(906494,8779,12613,'A.V.3','3. Valores representativos de deuda','2415,251,(2945),(297)',25,NULL,0,0,1,0,0),(906495,8779,12613,'A.V.4','4. Derivados.','255',26,NULL,0,0,1,0,0),(906496,8779,12613,'A.V.5','5. Otros activos financieros.','258,26',27,NULL,0,0,1,0,0),(906497,8779,12613,'A.VI','VI. Activos por impuesto diferido.','474',28,NULL,1,0,1,0,0),(906498,8779,12613,'','','',29,NULL,0,0,1,0,0),(906499,8779,12613,'B','B) ACTIVO CORRIENTE','B.I,B.II,B.III,B.IV,B.V,B.VI,B.VII',30,NULL,1,1,1,0,0),(906500,8779,12613,'B.I','I. Activos no corrientes mantenidos para la venta.','580,581,582,583,584,(599)',31,NULL,0,0,1,0,0),(906501,8779,12613,'B.II','II. Existencias.','B.II.1,B.II.2,B.II.3,B.II.4,B.II.5,B.II.6',32,NULL,1,1,1,0,0),(906502,8779,12613,'B.II.1','1. Comerciales.','30,(390)',33,NULL,0,0,1,0,0),(906503,8779,12613,'B.II.2','2. Materias primas y otros aprovisionamientos.','31,32,(391),(392)',34,NULL,0,0,1,0,0),(906504,8779,12613,'B.II.3','3. Productos en curso.','33,34,(393),(394)',35,NULL,0,0,1,0,0),(906505,8779,12613,'B.II.4','4. Productos terminados.','35,(395)',36,NULL,0,0,1,0,0),(906506,8779,12613,'B.II.5','5. Subproductos, residuos y materiales recuperados.','36,(396)',37,NULL,0,0,1,0,0),(906507,8779,12613,'B.II.6','6. Anticipos a proveedores','407',38,NULL,0,0,1,0,0),(906508,8779,12613,'B.III','III. Deudores comerciales y otras cuentas a cobrar.','B.III.1,B.III.2,B.III.3,B.III.4,B.III.5,B.III.6,B.III.7',39,NULL,1,1,1,0,0),(906509,8779,12613,'B.III.1','1. Clientes por ventas y prestaciones de servicios.','430,431,432,435,436,(437),(490),(4935)',40,NULL,0,0,1,0,0),(906510,8779,12613,'B.III.2','2. Clientes, empresas del grupo y asociadas.','433,434,(4933),(4934)',41,NULL,0,0,1,0,0),(906511,8779,12613,'B.III.3','3. Deudores varios.','44,5531,5533',42,NULL,0,0,1,0,0),(906512,8779,12613,'B.III.4','4. Personal.','460,544',43,NULL,0,0,1,0,0),(906513,8779,12613,'B.III.5','5. Activos por impuesto corriente.','4709,4703',44,NULL,0,0,1,0,0),(906514,8779,12613,'B.III.6','6. Otros créditos con las Administraciones Públicas.','4700,4708,471,472,473',45,NULL,0,0,1,0,0),(906515,8779,12613,'B.III.7','7. Accionistas (socios) por desembolsos exigidos','5580',46,NULL,0,0,1,0,0),(906516,8779,12613,'B.IV','IV. Inversiones en empresas del grupo y asociadas a corto plazo.','B.IV.1,B.IV.2,B.IV.3,B.IV.4,B.IV.5',47,NULL,1,1,1,0,0),(906517,8779,12613,'B.IV.1','1. Instrumentos de patrimonio.','5303,5304,(5393),(5394),(593)',48,NULL,0,0,1,0,0),(906518,8779,12613,'B.IV.2','2. Créditos a empresas.','5323,5324,5343,5344,(5953),(5954)',49,NULL,0,0,1,0,0),(906519,8779,12613,'B.IV.3','3. Valores representativos de deuda.','5313,5314,5333,5334,(5943),(5944)',50,NULL,0,0,1,0,0),(906520,8779,12613,'B.IV.4','4. Derivados.','',51,NULL,0,0,1,0,0),(906521,8779,12613,'B.IV.5','5. Otros activos financieros.','5353,5354,5523,5524',52,NULL,0,0,1,0,0),(906522,8779,12613,'B.V','V. Inversiones financieras a corto plazo.','B.V.1,B.V.2,B.V.3,B.V.4,B.V.5',53,NULL,1,1,1,0,0),(906523,8779,12613,'B.V.1','1. Instrumentos de patrimonio.','5305,540,(5395),(549)',54,NULL,0,0,1,0,0),(906524,8779,12613,'B.V.2','2. Créditos a empresas','5325,5345,542,543,547,(5955),(598)',55,NULL,0,0,1,0,0),(906525,8779,12613,'B.V.3','3. Valores representativos de deuda.','5315,5335,541,546,(5945),(597)',56,NULL,0,0,1,0,0),(906526,8779,12613,'B.V.4','4. Derivados.','5590,5593',57,NULL,0,0,1,0,0),(906527,8779,12613,'B.V.5','5. Otros activos financieros.','5355,545,548,?551,5525,565,566',58,NULL,0,0,1,0,0),(906528,8779,12613,'B.VI','VI. Periodificaciones a corto plazo.','480,567',59,NULL,1,0,1,0,0),(906529,8779,12613,'B.VII','VII. Efectivo y otros activos líquidos equivalentes.','B.VII.1,B.VII.2',60,NULL,1,1,1,0,0),(906530,8779,12613,'B.VII.1','1. Tesorería.','570,571,572,573,574,575',61,NULL,0,0,1,0,0),(906531,8779,12613,'B.VII.2','2. Otros activos líquidos equivalentes.','576',62,NULL,0,0,1,0,0),(906532,8779,12613,'','','',63,NULL,0,0,1,0,0),(906533,8779,12613,'AB','TOTAL ACTIVO (A + B)','A,B',64,NULL,1,1,1,0,0),(906534,8779,12613,'','','',65,NULL,0,0,1,0,0),(906535,8779,12613,'','','',66,NULL,0,0,1,0,0),(906536,8779,12613,'A0','PATRIMONIO NETO Y PASIVO','',67,NULL,1,0,1,0,0),(906537,8779,12613,'','','',68,NULL,0,0,1,0,1),(906538,8779,12613,'PA','A) PATRIMONIO NETO','PA.A-1,PA.A-2,PA.A-3',69,NULL,1,1,1,0,1),(906539,8779,12613,'PA.A-1','A-1) Fondos propios.','PA.A-1.I,PA.A-1.II,PA.A-1.III,PA.A-1.IV,PA.A-1.V,PA.A-1.VI,PA.A-1.VII,PA.A-1.VIII,PA.A-1.IX',70,NULL,1,1,1,0,1),(906540,8779,12613,'PA.A-1.I','I. Capital.','PA.A-1.I.1,PA.A-1.I.2',71,NULL,1,1,1,0,1),(906541,8779,12613,'PA.A-1.I.1','1. Capital escriturado.','100,101,102',72,NULL,0,0,1,0,1),(906542,8779,12613,'PA.A-1.I.2','2. (Capital no exigido).','(1030),(1040)',73,NULL,0,0,1,0,1),(906543,8779,12613,'PA.A-1.II','II. Prima de emisión.','110',74,NULL,1,0,1,0,1),(906544,8779,12613,'PA.A-1.III','III. Reservas.','PA.A-1.III.1,PA.A-1.III.2',75,NULL,1,1,1,0,1),(906545,8779,12613,'PA.A-1.III.1','1. Legal y estatutarias.','112,1141',76,NULL,0,0,1,0,1),(906546,8779,12613,'PA.A-1.III.2','2. Otras reservas.','113,1140,1142,1143,1144,115,119',77,NULL,0,0,1,0,1),(906547,8779,12613,'PA.A-1.IV','IV. (Acciones y participaciones en patrimonio propias).','(108),(109)',78,NULL,1,0,1,0,1),(906548,8779,12613,'PA.A-1.V','V. Resultados de ejercicios anteriores.','PA.A-1.V.1,PA.A-1.V.2',79,NULL,1,1,1,0,1),(906549,8779,12613,'PA.A-1.V.1','1. Remanente.','120',80,NULL,0,0,1,0,1),(906550,8779,12613,'PA.A-1.V.2','2. (Resultados negativos de ejercicios anteriores).','(121)',81,NULL,0,0,1,0,1),(906551,8779,12613,'PA.A-1.VI','VI. Otras aportaciones de socios.','118',82,NULL,1,0,1,0,1),(906552,8779,12613,'PA.A-1.VII','VII. Resultado del ejercicio.','129,6,7',83,NULL,1,0,1,0,1),(906553,8779,12613,'PA.A-1.VIII','VIII. (Dividendo a cuenta).','(557)',84,NULL,1,0,1,0,1),(906554,8779,12613,'PA.A-1.IX','IX. Otros instrumentos de patrimonio neto.','111',85,NULL,1,0,1,0,1),(906555,8779,12613,'PA.A-2','A-2) Ajustes por cambios de valor.','PA.A-2.I,PA.A-2.II,PA.A-2.III',86,NULL,1,1,1,0,1),(906556,8779,12613,'PA.A-2.I','I. Activos financieros disponibles para la venta.','133',87,NULL,0,0,1,0,1),(906557,8779,12613,'PA.A-2.II','II. Operaciones de cobertura.','1340',88,NULL,0,0,1,0,1),(906558,8779,12613,'PA.A-2.III','III. Otros.','137,139',89,NULL,0,0,1,0,1),(906559,8779,12613,'PA.A-3','A-3) Subvenciones, donaciones y legados recibidos.','130,131,132',90,NULL,1,0,1,0,1),(906560,8779,12613,'','','',91,NULL,0,0,1,0,1),(906561,8779,12613,'PB','B) PASIVO NO CORRIENTE','PB.I,PB.II,PB.III,PB.IV,PB.V',92,NULL,1,1,1,0,1),(906562,8779,12613,'PB.I','I. Provisiones a largo plazo.','PB.I.1,PB.I.2,PB.I.3,PB.I.4',93,NULL,1,1,1,0,1),(906563,8779,12613,'PB.I.1','1. Obligaciones por prestaciones a largo plazo al personal.','140',94,NULL,0,0,1,0,1),(906564,8779,12613,'PB.I.2','2. Actuaciones medioambientales.','145',95,NULL,0,0,1,0,1),(906565,8779,12613,'PB.I.3','3. Provisiones por reestructuración.','146',96,NULL,0,0,1,0,1),(906566,8779,12613,'PB.I.4','4. Otras provisiones.','141,142,143,147',97,NULL,0,0,1,0,1),(906567,8779,12613,'PB.II','II Deudas a largo plazo.','PB.II.1,PB.II.2,PB.II.3,PB.II.4,PB.II.5',98,NULL,1,1,1,0,1),(906568,8779,12613,'PB.II.1','1. Obligaciones y otros valores negociables.','177,178,179',99,NULL,0,0,1,0,1),(906569,8779,12613,'PB.II.2','2. Deudas con entidades de crédito.','1605,170',100,NULL,0,0,1,0,1),(906570,8779,12613,'PB.II.3','3. Acreedores por arrendamiento financiero.','1625,174',101,NULL,0,0,1,0,1),(906571,8779,12613,'PB.II.4','4. Derivados.','176',102,NULL,0,0,1,0,1),(906572,8779,12613,'PB.II.5','5. Otros pasivos financieros.','1615,1635,171,172,173,175,180,185,189',103,NULL,0,0,1,0,1),(906573,8779,12613,'PB.III','III. Deudas con empresas del grupo y asociadas a largo plazo.','1603,1604,1613,1614,1623,1624,1633,1634',104,NULL,1,0,1,0,1),(906574,8779,12613,'PB.IV','IV. Pasivos por impuesto diferido.','479',105,NULL,1,0,1,0,1),(906575,8779,12613,'PB.V','V. Periodificaciones a largo plazo.','181',106,NULL,1,0,1,0,1),(906576,8779,12613,'','','',107,NULL,0,0,1,0,1),(906577,8779,12613,'PC','C) PASIVO CORRIENTE','PC.I,PC.II,PC.III,PC.IV,PC.V,PC.VI',108,NULL,1,1,1,0,1),(906578,8779,12613,'PC.I','I. Pasivos vinculados con activos no corrientes mantenidos para la venta.','585,586,587,588,589',109,NULL,1,0,1,0,1),(906579,8779,12613,'PC.II','II. Provisiones a corto plazo.','499,529',110,NULL,1,0,1,0,1),(906580,8779,12613,'PC.III','III. Deudas a corto plazo.','PC.III.1,PC.III.2,PC.III.3,PC.III.4,PC.III.5',111,NULL,1,1,1,0,1),(906581,8779,12613,'PC.III.1','1. Obligaciones y otros valores negociables.','500,501,505,506',112,NULL,0,0,1,0,1),(906582,8779,12613,'PC.III.2','2. Deudas con entidades de crédito.','5105,520,527',113,NULL,0,0,1,0,1),(906583,8779,12613,'PC.III.3','3. Acreedores por arrendamiento financiero.','5125,524',114,NULL,0,0,1,0,1),(906584,8779,12613,'PC.III.4','4. Derivados.','5595,5598',115,NULL,0,0,1,0,1),(906585,8779,12613,'PC.III.5','5. Otros pasivos financieros.','(1034),(1044),(190),(192),194,509,5115,5135,5145,521,522,523,525,526,528,?551,5525,5530,5532,555,5565,5566,560,561,569',116,NULL,0,0,1,0,1),(906586,8779,12613,'PC.IV','IV. Deudas con empresas del grupo y asociadas a corto plazo.','5103,5104,5113,5114,5123,5124,5133,5134,5143,5144,5523,5524,5563,5564',117,NULL,1,0,1,0,1),(906587,8779,12613,'PC.V','V. Acreedores comerciales y otras cuentas a pagar.','PC.V.1,PC.V.2,PC.V.3,PC.V.4,PC.V.5,PC.V.6,PC.V.7',118,NULL,1,1,1,0,1),(906588,8779,12613,'PC.V.1','1. Proveedores','400,401,405,(406)',119,NULL,0,0,1,0,1),(906589,8779,12613,'PC.V.2','2. Proveedores, empresas del grupo y asociadas.','403,404',120,NULL,0,0,1,0,1),(906590,8779,12613,'PC.V.3','3. Acreedores varios.','41',121,NULL,0,0,1,0,1),(906591,8779,12613,'PC.V.4','4. Personal (remuneraciones pendientes de pago).','465,466',122,NULL,0,0,1,0,1),(906592,8779,12613,'PC.V.5','5. Pasivos por impuesto corriente.','4752',123,NULL,0,0,1,0,1),(906593,8779,12613,'PC.V.6','6. Otras deudas con las Administraciones Públicas.','4750,4751,4758,476,477',124,NULL,0,0,1,0,1),(906594,8779,12613,'PC.V.7','7. Anticipos de clientes.','438',125,NULL,0,0,1,0,1),(906595,8779,12613,'PC.VI','VI. Periodificaciones a corto plazo.','485,568',126,NULL,1,0,1,0,1),(906596,8779,12613,'','','',127,NULL,0,0,1,0,1),(906597,8779,12613,'PABC','TOTAL PATRIMONIO NETO Y PASIVO (A + B + C)','PA,PB,PC',128,NULL,1,1,1,0,1),(906598,8779,12613,'','','',129,NULL,0,0,1,0,1),(906599,8779,12613,'DIF','DIFERENCIA (ACTIVO-PATRIMONIO NETO Y PASIVO)','AB,(PABC)',130,NULL,1,1,1,1,0),(906600,8779,12614,'A','A OPERACIONES CONTINUADAS','A.T4',0,NULL,1,1,1,0,1),(906601,8779,12614,'A.1','1. Importe neto de la cifra de negocios.','A.1.A,A.1.B',1,NULL,1,1,1,0,1),(906602,8779,12614,'A.1.A','a) Ventas.','700,701,702,703,704,(706),(708),(709)',2,NULL,0,0,1,0,1),(906603,8779,12614,'A.1.B','b) Prestaciones de servicios.','705',3,NULL,0,0,1,0,1),(906604,8779,12614,'A.2','2. Variación de existencias de productos terminados y en curso de fabricación.','(6930),71,7930',4,NULL,1,0,1,0,1),(906605,8779,12614,'A.3','3. Trabajos realizados por la empresa para su activo.','73',5,NULL,1,0,1,0,1),(906606,8779,12614,'A.4','4. Aprovisionamientos.','A.4.A,A.4.B,A.4.C,A.4.D',6,NULL,1,1,1,0,1),(906607,8779,12614,'A.4.A','a) Consumo de mercaderías.','(600),6060,6080,6090,610',7,NULL,0,0,1,0,1),(906608,8779,12614,'A.4.B','b) Consumo de materias primas y otras materias consumibles.','(601),(602),6061,6062,6081,6082,6091,6092,611,612',8,NULL,0,0,1,0,1),(906609,8779,12614,'A.4.C','c) Trabajos realizados por otras empresas.','(607)',9,NULL,0,0,1,0,1),(906610,8779,12614,'A.4.D','d) Deterioro de mercaderías, materias primas y otros aprovisionamientos.','(6931),(6932),(6933),7931,7932,7933',10,NULL,0,0,1,0,1),(906611,8779,12614,'A.5','5. Otros ingresos de explotación.','A.5.A,A.5.B',11,NULL,1,1,1,0,1),(906612,8779,12614,'A.5.A','a) Ingresos accesorios y otros de gestión corriente.','75',12,NULL,0,0,1,0,1),(906613,8779,12614,'A.5.B','b) Subvenciones de explotación incorporadas al resultado del ejercicio.','740,747',13,NULL,0,0,1,0,1),(906614,8779,12614,'A.6','6. Gastos de personal.','A.6.A,A.6.B,A.6.C',14,NULL,1,1,1,0,1),(906615,8779,12614,'A.6.A','a) Sueldos, salarios y asimilados.','(640),(641),(6450)',15,NULL,0,0,1,0,1),(906616,8779,12614,'A.6.B','b) Cargas sociales.','(642),(643),(649)',16,NULL,0,0,1,0,1),(906617,8779,12614,'A.6.C','c) Provisiones.','(644),(6457),7950,7957',17,NULL,0,0,1,0,1),(906618,8779,12614,'A.7','7. Otros gastos de explotación.','A.7.A,A.7.B,A.7.C,A.7.D',18,NULL,1,1,1,0,1),(906619,8779,12614,'A.7.A','a) Servicios exteriores.','(62)',19,NULL,0,0,1,0,1),(906620,8779,12614,'A.7.B','b) Tributos.','(631),(634),636,639',20,NULL,0,0,1,0,1),(906621,8779,12614,'A.7.C','c) Pérdidas, deterioro y variación de provisiones por operaciones comerciales.','(650),(694),(695),794,7954',21,NULL,0,0,1,0,1),(906622,8779,12614,'A.7.D','d) Otros gastos de gestión corriente.','(651),(659)',22,NULL,0,0,1,0,1),(906623,8779,12614,'A.8','8. Amortización del inmovilizado.','(68)',23,NULL,1,0,1,0,1),(906624,8779,12614,'A.9','9. Imputación de subvenciones de inmovilizado no financiero y otras.','746',24,NULL,1,0,1,0,1),(906625,8779,12614,'A.10','10. Excesos de provisiones.','7951,7952,7955,7956',25,NULL,1,0,1,0,1),(906626,8779,12614,'A.11','11. Deterioro y resultado por enajenaciones del inmovilizado.','A.11.A,A.11.B',26,NULL,1,1,1,0,1),(906627,8779,12614,'A.11.A','a) Deterioros y pérdidas.','(690),(691),(692),790,791,792',27,NULL,0,0,1,0,1),(906628,8779,12614,'A.11.B','b) Resultados por enajenaciones y otras.','(670),(671),(672),770,771,772',28,NULL,0,0,1,0,1),(906629,8779,12614,'A.X','Otros Resultados.','678,778',29,NULL,1,0,1,0,1),(906630,8779,12614,'','','',30,NULL,0,0,1,0,1),(906631,8779,12614,'A.T1','A.1) RESULTADO DE EXPLOTACIÓN (1+2+3+4+5+6+7+8+9+10+11+12)','A.1,A.2,A.3,A.4,A.5,A.6,A.7,A.8,A.9,A.10,A.11,A.X',31,NULL,1,1,1,0,1),(906632,8779,12614,'','','',32,NULL,0,0,1,0,1),(906633,8779,12614,'A.12','12. Ingresos financieros.','A.12.A,A.12.B',33,NULL,1,1,1,0,1),(906634,8779,12614,'A.12.A','a) De participaciones en instrumentos de patrimonio.','A.12.A.1,A.12.A.2',34,NULL,1,1,1,0,1),(906635,8779,12614,'A.12.A.1','a1) En empresas del grupo y asociadas.','7600,7601',35,NULL,0,0,1,0,1),(906636,8779,12614,'A.12.A.2','a2) En terceros.','7602,7603',36,NULL,0,0,1,0,1),(906637,8779,12614,'A.12.B','b) De valores negociables y otros instrumentos financieros.','A.12.B.1,A.12.B.2',37,NULL,1,1,1,0,1),(906638,8779,12614,'A.12.B.1','b1) De empresas del grupo y asociadas.','7610,7611,76200,76201,76210,76211',38,NULL,0,0,1,0,1),(906639,8779,12614,'A.12.B.2','b2) De terceros.','7612,7613,76202,76203,76212,76213,767,769',39,NULL,0,0,1,0,1),(906640,8779,12614,'A.13','13. Gastos financieros.','A.13.A,A.13.B,A.13.C',40,NULL,1,1,1,0,1),(906641,8779,12614,'A.13.A','a) Por deudas con empresas del grupo y asociadas.','(6610),(6611),(6615),(6616),(6620),(6621),(6640),(6641),(6650),(6651),(6654),(6655)',41,NULL,0,0,1,0,1),(906642,8779,12614,'A.13.B','b) Por deudas con terceros.','(6612),(6613),(6617),(6618),(6622),(6623),(6624),(6642),(6643),(6652),(6653),(6656),(6657),(669)',42,NULL,0,0,1,0,1),(906643,8779,12614,'A.13.C','c) Por actualización de provisiones.','(660)',43,NULL,0,0,1,0,1),(906644,8779,12614,'A.14','14. Variación de valor razonable en instrumentos financieros.','A.14.A,A.14.B',44,NULL,1,1,1,0,1),(906645,8779,12614,'A.14.A','a) Cartera de negociación y otros.','(6630),(6631),(6633),7630,7631,7633',45,NULL,0,0,1,0,1),(906646,8779,12614,'A.14.B','b) Imputación al resultado del ejercicio por activos financieros disponibles para la venta.','(6632),7632',46,NULL,0,0,1,0,1),(906647,8779,12614,'A.15','15. Diferencias de cambio.','(668),768',47,NULL,1,0,1,0,1),(906648,8779,12614,'A.16','16. Deterioro y resultado por enajenaciones de instrumentos financieros.','A.16.A,A.16.B',48,NULL,1,1,1,0,1),(906649,8779,12614,'A.16.A','a) Deterioros y pérdidas.','(696),(697),(698),(699),796,797,798,799',49,NULL,0,0,1,0,1),(906650,8779,12614,'A.16.B','b) Resultados por enajenaciones y otras.','(666),(667),(673),(675),766,773,775',50,NULL,0,0,1,0,1),(906651,8779,12614,'','','',51,NULL,0,0,1,0,1),(906652,8779,12614,'A.T2','A.2) RESULTADO FINANCIERO (12+13+14+15+16)','A.12,A.13,A.14,A.15,A.16',52,NULL,1,1,1,0,1),(906653,8779,12614,'','','',53,NULL,0,0,1,0,1),(906654,8779,12614,'A.T3','A.3) RESULTADO ANTES DE IMPUESTOS (A.1+A.2)','A.T1,A.T2',54,NULL,1,1,1,0,1),(906655,8779,12614,'','','',55,NULL,0,0,1,0,1),(906656,8779,12614,'A.17','17. Impuestos sobre beneficios.','(6300),6301,(633),638',56,NULL,1,0,1,0,1),(906657,8779,12614,'','','',57,NULL,0,0,1,0,1),(906658,8779,12614,'A.T4','A.4) RESULTADO DEL EJ. PROCEDENTE DE OP. CONTINUADAS (A.3+17)','A.T3,A.17',58,NULL,1,1,1,0,1),(906659,8779,12614,'','','',59,NULL,0,0,1,0,1),(906660,8779,12614,'B','B) OPERACIONES INTERRUMPIDAS','B.18',60,NULL,1,1,1,0,1),(906661,8779,12614,'B.18','18. Resultado del ejercicio procedente de operaciones interrumpidas neto de impuestos.','',61,NULL,0,0,1,0,1),(906662,8779,12614,'','','',62,NULL,0,0,1,0,1),(906663,8779,12614,'A.5','A.5) RESULTADO DEL EJERCICIO (A.4+18)','A.T4,B.18',63,NULL,1,1,1,0,1),(906664,8779,12615,'','ACTIVO','',0,NULL,1,0,1,0,0),(906665,8779,12615,'11000','A) ACTIVO NO CORRIENTE','11100,11200,11300,11400,11500,11600',1,NULL,1,1,1,0,0),(906666,8779,12615,'11100','I. Inmovilizado intangible','20,(280),(290)',2,NULL,1,0,1,0,0),(906667,8779,12615,'11200','II. Inmovilizado material','21,(281),(291),23',3,NULL,1,0,1,0,0),(906668,8779,12615,'11300','III. Inversiones inmobiliarias','22,(282),(292)',4,NULL,1,0,1,0,0),(906669,8779,12615,'11400','IV. Inversiones en empresas del grupo y asociadas L/P','2403,2404,2413,2414,2423,2424,2493,2494,293,(2943),(2944),(2953),(2954)',5,NULL,1,0,1,0,0),(906670,8779,12615,'11500','V. Inversiones financieras a largo plazo','2405,2415,2425,(2495),250,251,252,253,254,255,257,258,259,26,2945,2955,297,298',6,NULL,1,0,1,0,0),(906671,8779,12615,'11600','VI. Activos por Impuesto diferido','474',7,NULL,1,0,1,0,0),(906672,8779,12615,'','','',8,NULL,0,0,1,0,0),(906673,8779,12615,'12000','B) ACTIVO CORRIENTE','12100,12200,12300,12400,12500,12600,12700',9,NULL,1,1,1,0,0),(906674,8779,12615,'12100','I. Activos no corrientes mantenidos para la venta','580,581,582,583,584,(599)',10,NULL,1,0,1,0,0),(906675,8779,12615,'12200','II. Existencias','30,31,32,33,34,35,36,(39),407',11,NULL,1,0,1,0,0),(906676,8779,12615,'12300','III. Deudores comerciales y otras cuentas a cobrar','12380,12370,12390',12,NULL,1,1,1,0,0),(906677,8779,12615,'12380','1. Clientes por ventas y prestaciones de servicios','430,431,432,433,434,435,436,(437),(490),(493)',13,NULL,0,0,1,0,0),(906678,8779,12615,'12370','2. Accionistas (socios) por desembolsos exigidos','5580',14,NULL,0,0,1,0,0),(906679,8779,12615,'12390','3. Otros deudores','44,460,470,471,472,473,5531,5533,544',15,NULL,0,0,1,0,0),(906680,8779,12615,'12400','IV. Inversiones en empresas del grupo y asociadas C/P','5303,5304,5313,5314,5323,5324,5333,5334,5343,5344,5353,5354,(5393),(5394),5523,5524,(593),(5943),(5944),(5953),(5954)',16,NULL,1,0,1,0,0),(906681,8779,12615,'12500','V. Inversiones financieras a corto plazo','5305,5315,5325,5335,5345,5355,(5395),540,541,542,543,545,546,547,548,(549),?551,5525,5590,5593,565,566,(5945),(5955),(597),(598)',17,NULL,1,0,1,0,0),(906682,8779,12615,'12600','VI. Periodificaciones a corto plazo','480,567',18,NULL,1,0,1,0,0),(906683,8779,12615,'12700','VII. Efectivo y otros activos líquidos equivalentes','57',19,NULL,1,0,1,0,0),(906684,8779,12615,'','','',20,NULL,0,0,1,0,0),(906685,8779,12615,'10000','TOTAL ACTIVO (A+B)','11000,12000',21,NULL,1,1,1,0,0),(906686,8779,12615,'','','',22,NULL,0,0,1,0,0),(906687,8779,12615,'','PATRIMONIO NETO Y PASIVO','',23,NULL,1,0,1,0,1),(906688,8779,12615,'20000','A) PATRIMONIO NETO','21000,22000,23000',24,NULL,1,1,1,0,1),(906689,8779,12615,'21000','A-1) Fondos propios','21100,21200,21300,21400,21500,21600,21700,21800,21900',25,NULL,1,1,1,0,1),(906690,8779,12615,'21100','I. Capital','21110,21120',26,NULL,1,1,1,0,1),(906691,8779,12615,'21110','1. Capital escriturado','100,101,102',27,NULL,0,0,1,0,1),(906692,8779,12615,'21120','2. (Capital no exigido)','(1030),(1040)',28,NULL,0,0,1,0,1),(906693,8779,12615,'21200','II. Prima de emisión','110',29,NULL,1,0,1,0,1),(906694,8779,12615,'21300','III. Reservas','112,113,114,115,119,108,109',30,NULL,1,0,1,0,1),(906695,8779,12615,'21400','IV. (Acciones y participaciones en patrimonio propias)','(108),(109)',31,NULL,1,0,1,0,1),(906696,8779,12615,'21500','V. Resultado de ejercicios anteriores','120,(121)',32,NULL,1,0,1,0,1),(906697,8779,12615,'21600','VI. Otras aportaciones de socios','118',33,NULL,1,0,1,0,1),(906698,8779,12615,'21700','VII. Resultado del ejercicio','129,6,7',34,NULL,1,0,1,0,1),(906699,8779,12615,'21800','VIII. (Dividendo a cuenta )','(557)',35,NULL,1,0,1,0,1),(906700,8779,12615,'21900','IX. Otros instrumentos de patrimonio neto','111',36,NULL,1,0,1,0,1),(906701,8779,12615,'22000','A-2) Ajustes por cambios de valor','133,1340,137',37,NULL,1,0,1,0,1),(906702,8779,12615,'23000','A-3) Subvenciones, donaciones y legados recibidos','130,131,132',38,NULL,1,0,1,0,1),(906703,8779,12615,'','','',39,NULL,0,0,1,0,1),(906704,8779,12615,'31000','B) PASIVO NO CORRIENTE','31100,31200,31300,31400,31500',40,NULL,1,1,1,0,1),(906705,8779,12615,'31100','I. Provisiones a largo plazo','14',41,NULL,1,0,1,0,1),(906706,8779,12615,'31200','II. Deudas a largo plazo','31220,31230,31290',42,NULL,1,1,1,0,1),(906707,8779,12615,'31220','1. Deudas con entidades de crédito','1605,170',43,NULL,0,0,1,0,1),(906708,8779,12615,'31230','2. Acreedores por arrendamiento financiero','1625,174',44,NULL,0,0,1,0,1),(906709,8779,12615,'31290','3. Otras deudas a largo plazo','1615,1635,171,172,173,175,176,177,178,179,180,185,189',45,NULL,0,0,1,0,1),(906710,8779,12615,'31300','III .Deudas con empresas del grupo y asociadas L/P','1603,1604,1613,1614,1623,1624,1633,1634',46,NULL,1,0,1,0,1),(906711,8779,12615,'31400','IV. Pasivos por impuesto diferido','479',47,NULL,1,0,1,0,1),(906712,8779,12615,'31500','V. Periodificaciones a largo plazo','181',48,NULL,1,0,1,0,1),(906713,8779,12615,'','','',49,NULL,0,0,1,0,1),(906714,8779,12615,'32000','C) PASIVO CORRIENTE','32100,32200,32300,32400,32500,32600',50,NULL,1,1,1,0,1),(906715,8779,12615,'32100','I. Pasivos vinculados con activos no corrientes mantenidos para la venta','585,586,587,588,589',51,NULL,1,0,1,0,1),(906716,8779,12615,'32200','II. Provisiones a corto plazo','499,529',52,NULL,1,0,1,0,1),(906717,8779,12615,'32300','III. Deudas a corto plazo','32320,32330,32390',53,NULL,1,1,1,0,1),(906718,8779,12615,'32320','1. Deudas con entidades de crédito','5105,520,527',54,NULL,0,0,1,0,1),(906719,8779,12615,'32330','2. Acreedores por arrendamiento financiero','5125,524',55,NULL,0,0,1,0,1),(906720,8779,12615,'32390','3. Otras deudas a corto plazo','(1034),(1044),(190),(192),194,500,501,505,509,5115,5135,5145,521,522,523,525,526,528,?551,5525,5530,5532,555,5565,5566,5595,5598,560,561,569',56,NULL,0,0,1,0,1),(906721,8779,12615,'32400','IV. Deudas con empresas del grupo y asociadas C/P','5103,5104,5113,5114,5123,5124,5133,5134,5143,5144,5523,5524,5563,5564',57,NULL,1,0,0,0,1),(906722,8779,12615,'32500','V. Acreedores comerciales y otras cuentas a pagar','32580,32590',58,NULL,1,1,1,0,1),(906723,8779,12615,'32580','1. Proveedores','400,401,403,404,405,(406)',59,NULL,0,0,1,0,1),(906724,8779,12615,'32590','2. Otros acreedores','41,438,465,466,475,476,477',60,NULL,0,0,1,0,1),(906725,8779,12615,'32600','VI. Periodificaciones a corto plazo','485,568',61,NULL,1,0,1,0,1),(906726,8779,12615,'','','',62,NULL,0,0,1,0,1),(906727,8779,12615,'30000','TOTAL PATRIMONIO NETO Y PASIVO (A+B+C)','20000,31000,32000',63,NULL,1,1,1,0,1),(906728,8779,12615,'DIF','DIFERENCIA (ACTIVO-PATRIMONIO NETO Y PASIVO)','10000,(30000)',64,NULL,1,1,1,1,0),(906729,8779,12616,'','','',0,NULL,0,0,1,0,1),(906730,8779,12616,'40100','1. Importe neto de la cifra de negocios','700,701,702,703,704,705,(706),(708),(709)',1,NULL,0,0,1,0,1),(906731,8779,12616,'40200','2. Variación de existencias de productos terminados y en curso de fabricación','(6930),71,7930',2,NULL,0,0,1,0,1),(906732,8779,12616,'40300','3. Trabajos realizados por la empresa para su activo','73',3,NULL,0,0,1,0,1),(906733,8779,12616,'40400','4. Aprovisionamientos','(600),(601),(602),(606),(607),608,609,61,(693),(6932),(6933),7931,7932,7933',4,NULL,0,0,1,0,1),(906734,8779,12616,'40500','5. Otros ingresos de explotación','740,747,75',5,NULL,0,0,1,0,1),(906735,8779,12616,'40600','6. Gastos de personal','(64),7950,7957',6,NULL,0,0,1,0,1),(906736,8779,12616,'40700','7. Otros gastos de explotación','(62),(631),(634),636,639,(65),(694),(695),794,7954',7,NULL,0,0,1,0,1),(906737,8779,12616,'40800','8. Amortización de inmovilizado','(68)',8,NULL,0,0,1,0,1),(906738,8779,12616,'40900','9. Imputación de subvenciones de inmovilizado no financiero y otras','746',9,NULL,0,0,1,0,1),(906739,8779,12616,'41000','10. Excesos de provisiones','7951,7952,7955,7956',10,NULL,0,0,1,0,1),(906740,8779,12616,'41100','11. Deterioro y resultado por enejenaciones del inmovilizado','(670),(671),(672),(690),(691),(692),770,771,772,790,791,792',11,NULL,0,0,1,0,1),(906741,8779,12616,'41200','12. Diferencia negativa de combinaciones de negocio','774',12,NULL,0,0,1,0,1),(906742,8779,12616,'41300','13. Otros Resultados','(678),778',13,NULL,0,0,1,0,1),(906743,8779,12616,'','','',14,NULL,0,0,1,0,1),(906744,8779,12616,'49100','A) RESULTADO DE EXPLOTACIÓN (1+2+3+4+5+6+7+8+9+10+11+12+13)','40100,40200,40300,40400,40500,40600,40700,40800,40900,41000,41100,41200,41300',15,NULL,1,1,1,0,1),(906745,8779,12616,'','','',16,NULL,0,0,1,0,1),(906746,8779,12616,'41400','14. Ingresos financieros','41430,41490',17,NULL,0,1,1,0,0),(906747,8779,12616,'41430','a) Imputación de subvenciones, donaciones y legados de carácter financiero','7460',18,NULL,0,0,1,0,1),(906748,8779,12616,'41490','b) Otros ingresos financieros','760,761,762,767,769',19,NULL,0,0,1,0,1),(906749,8779,12616,'41500','15. Gastos financieros','(660),(661),(662),(664),(665),(669)',20,NULL,0,0,1,0,1),(906750,8779,12616,'41600','16. Variación de valor razonable en instrumentos financieros','(663),763',21,NULL,0,0,1,0,1),(906751,8779,12616,'41700','17. Diferencias de cambio','(668),768',22,NULL,0,0,1,0,1),(906752,8779,12616,'41800','18. Deterioro y resultado por enajenaciones de instrumentos financieros','(666),(667),(673),(675),(696),(697),(698),(699),766,773,775,796,797,798,799',23,NULL,0,0,1,0,1),(906753,8779,12616,'42100','19. Otros ingresos y gastos de carácter financiero','42110,42120,42130',24,NULL,0,1,1,0,0),(906754,8779,12616,'42110','a). Incorporación al activo de gastos financieros','',25,NULL,0,0,1,0,1),(906755,8779,12616,'42120','b). Ingresos financieros derivados de convenios de acreedores','',26,NULL,0,0,1,0,1),(906756,8779,12616,'42130','c). Resto de ingresos y gastos','',27,NULL,0,0,1,0,1),(906757,8779,12616,'','','',28,NULL,0,0,1,0,1),(906758,8779,12616,'49200','B) RESULTADO FINANCIERO (14+15+16+17+18+19)','41400,41500,41600,41700,41800,42100,',29,NULL,1,1,1,0,1),(906759,8779,12616,'','','',30,NULL,0,0,1,0,1),(906760,8779,12616,'49300','C) RESULTADO ANTES DE IMPUESTOS (A+B)','49100,49200',31,NULL,1,1,1,0,1),(906761,8779,12616,'','','',32,NULL,0,0,1,0,1),(906762,8779,12616,'41900','20. Impuestos sobre beneficios','(6300),(6301),(633),638',33,NULL,0,0,1,0,1),(906763,8779,12616,'','','',34,NULL,0,0,0,0,1),(906764,8779,12616,'49500','D) RESULTADO DEL EJERCICIO (C+20)','49300,41900',35,NULL,1,1,1,0,1),(906765,8779,12617,'A','A) Resultado de la cuenta de pérdidas y ganancias','',0,NULL,0,0,1,0,0),(906766,8779,12617,'','','',1,NULL,0,0,1,0,0),(906767,8779,12617,'1','Ingresos y gastos imputados directamente al patrimonio neto','1.I,1.II,1.III,1.IV,1.V',2,NULL,1,0,1,0,0),(906768,8779,12617,'1.I','I. Por valoración de instrumentos financieros','800,89,900,991,992',3,NULL,0,0,1,0,0),(906769,8779,12617,'1.II','II. Por coberturas de flujos de efectivo','810,910',4,NULL,0,0,1,0,0),(906770,8779,12617,'1.III','III. Subvenciones',' donaciones y legados recibidos',13,NULL,0,0,0,1,0),(906771,8779,12617,'1.IV','IV. Por ganancias y pérdidas actuariales y otros ajust','85,95',6,NULL,0,0,1,0,0),(906772,8779,12617,'1.V','V. Efecto impositivo','8300,8301,833,834,835,838',7,NULL,0,0,1,0,0),(906773,8779,12617,'B','B) Total Ingresos y gastos imputados directamente al patrimonio neto (I+II+III+IV+V)','1.I,1.II,1.III,1.IV,1.V',8,NULL,1,1,1,0,0),(906774,8779,12617,'','','',9,NULL,0,0,1,0,0),(906775,8779,12617,'2','Transferencias a la cuenta de P Y G','2.VI,2.VII,2.VIII,2.IX',10,NULL,1,0,1,0,0),(906776,8779,12617,'2.VI','VI. Por valoración de instrumentos financieros','802,902,993,994',11,NULL,0,0,1,0,0),(906777,8779,12617,'2.VII','VII. Por coberturas de flujos de efectivo','812,912',12,NULL,0,0,1,0,0),(906778,8779,12617,'2.VIII','VIII. Subvenciones',' donaciones y legados recibidos',18,NULL,0,0,0,1,0),(906779,8779,12617,'2.IX','IX. Efecto impositivo','8301,836,837',14,NULL,0,0,1,0,0),(906780,8779,12617,'C','C) Total transferencias a la cuentad de P Y G (VI+VII+VIII+IX)','2.VI,2.VII,2.VIII,2.IX',15,NULL,1,1,1,0,0),(906781,8779,12617,'','','',16,NULL,0,0,1,0,0),(906782,8779,12617,'D','TOTAL DE INGRESOS Y GASTOS RECONOCIDOS (A+B+C)','A,B,C',17,NULL,1,1,1,0,0);
/*!40000 ALTER TABLE `balance_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bank_concept`
--

DROP TABLE IF EXISTS `bank_concept`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `bank_concept` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre del Concepto',
  `account` int(4) DEFAULT NULL COMMENT 'Identificador de la Cuenta Contable',
  PRIMARY KEY (`id`),
  KEY `IDX_BANK_CONCEPT_DOMAIN` (`domain`),
  KEY `IDX_BANK_CONCEPT_ACCOUNT` (`account`),
  CONSTRAINT `FK_BANK_CONCEPT_ACCOUNT` FOREIGN KEY (`account`) REFERENCES `account` (`id`),
  CONSTRAINT `FK_BANK_CONCEPT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Conceptos bancarios';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `bank_concept`
--

LOCK TABLES `bank_concept` WRITE;
/*!40000 ALTER TABLE `bank_concept` DISABLE KEYS */;
/*!40000 ALTER TABLE `bank_concept` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bank_statement`
--

DROP TABLE IF EXISTS `bank_statement`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `bank_statement` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `rbank` int(4) NOT NULL COMMENT 'Identificador de Banco de la Compañia',
  `lot_number` int(4) NOT NULL DEFAULT '0' COMMENT 'Numero de lote',
  `operation_date` date NOT NULL COMMENT 'Fecha de operacion',
  `common_concept` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Concepto comun',
  `own_concept` varchar(5) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Concepto propio',
  `payment` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indica si es un pago',
  `amount` double(15,2) NOT NULL DEFAULT '0.00' COMMENT 'Importe',
  `document` varchar(10) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de documento',
  `reference1` varchar(12) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Referencia 1',
  `reference2` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Referencia 2',
  `description` varchar(80) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion',
  `reliability` tinyint(2) DEFAULT '0' COMMENT 'Fiabilidad del punteo',
  `security_level` tinyint(2) DEFAULT '0' COMMENT 'Nivel de seguridad',
  `status` tinyint(2) DEFAULT '0' COMMENT 'Estado',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios',
  PRIMARY KEY (`id`),
  KEY `IDX_BANK_STATEMENT_RBANK` (`rbank`),
  KEY `IDX_BANK_STATEMENT_DOMAIN` (`domain`),
  CONSTRAINT `FK_BANK_STATEMENT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_BANK_STATEMENT_RBANK` FOREIGN KEY (`rbank`) REFERENCES `rbank` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Extractos bancarios';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `bank_statement`
--

LOCK TABLES `bank_statement` WRITE;
/*!40000 ALTER TABLE `bank_statement` DISABLE KEYS */;
/*!40000 ALTER TABLE `bank_statement` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bank_statement_link`
--

DROP TABLE IF EXISTS `bank_statement_link`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `bank_statement_link` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `bank_statement` int(4) NOT NULL COMMENT 'Identificador de Extracto bancario',
  `source` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Origen',
  `source_id` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador del origen',
  `source_date` date DEFAULT NULL COMMENT 'Fecha del origen',
  `amount` double(15,2) NOT NULL DEFAULT '0.00' COMMENT 'Importe',
  `status` tinyint(2) DEFAULT '0' COMMENT 'Estado',
  `linked_bank_statement_link` int(4) DEFAULT NULL COMMENT 'Identificador del Enlace de Extracto bancario asociado',
  PRIMARY KEY (`id`),
  KEY `IDX_BANK_STATEMENT_LINK_BANK_STATEMENT` (`bank_statement`),
  KEY `IDX_BANK_STATEMENT_LINK_BANK_STATEMENT_LINK` (`linked_bank_statement_link`),
  KEY `IDX_BANK_STATEMENT_LINK_DOMAIN` (`domain`),
  CONSTRAINT `FK_BANK_STATEMENT_LINK_BANK_STATEMENT` FOREIGN KEY (`bank_statement`) REFERENCES `bank_statement` (`id`),
  CONSTRAINT `FK_BANK_STATEMENT_LINK_BANK_STATEMENT_LINK` FOREIGN KEY (`linked_bank_statement_link`) REFERENCES `bank_statement_link` (`id`),
  CONSTRAINT `FK_BANK_STATEMENT_LINK_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Enlaces del Extracto bancario';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `bank_statement_link`
--

LOCK TABLES `bank_statement_link` WRITE;
/*!40000 ALTER TABLE `bank_statement_link` DISABLE KEYS */;
/*!40000 ALTER TABLE `bank_statement_link` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `bonus_concept`
--

DROP TABLE IF EXISTS `bonus_concept`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `bonus_concept` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `expression` varchar(1024) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Importe',
  `description` varchar(256) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion',
  `type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de Bonificacion Salarial',
  PRIMARY KEY (`id`),
  KEY `IDX_BONUS_CONCEPT_DOMAIN` (`domain`),
  CONSTRAINT `FK_BONUS_CONCEPT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3269 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Conceptos de bonficaciones y/o reducciones';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `bonus_concept`
--

LOCK TABLES `bonus_concept` WRITE;
/*!40000 ALTER TABLE `bonus_concept` DISABLE KEYS */;
INSERT INTO `bonus_concept` VALUES (2,0,'','Bonificaciones - Con derecho a reducción (casilla 601 de TC1)',0),(3,0,'','Bonif.Fom.Empleo Cuantía fija-EXCEPTO R.G.Artistas [0112]',1),(4,0,'','Bonificación Ceuta y Melilla (O. TAS/471/2004)',2),(5,0,'','Bonificación minusvalidos - (Centros Especiales de Empleo)',3),(6,0,'','Bonificación por Ley 19/94 - (Reg. Canario - Rég. del Mar)',4),(7,0,'','Bonificación por formación teórica a distancia',5),(8,0,'','Bonificación por formación teórica presencial',6),(9,0,'','Bonificación por ERE',7),(10,0,'','Bonificación Sector Industrial Incentivado',8),(11,0,'','Bonificación por trabajadores con 60 o más años',9),(12,0,'','Exención de desempleo hijos<30años Autonomos',10),(13,0,'','Reducciones - Con derecho a reducción (casilla 209 de TC1)',11),(14,0,'','Reducción contingencias comunes excepto I.T. (R.D.L. 16/2001)',12),(15,0,'','Reducciones SEA Contingencias comunes - (S.E.Agrario)',13),(16,0,'','Reducciones SEA Desempleo - (Sistema Especial Agrario)',14),(17,0,'MAX(0.00,CGC_E - (( COEFICIENTE_PARCIALIDAD == 1 ? 100 : (COEFICIENTE_PARCIALIDAD >= 0.75 ? 75 : (COEFICIENTE_PARCIALIDAD >= 0.5 ? 50 : 0.00))) / 30 * DIAS_BONIFICACION))','Reducción contingencias comunes - Tarifa Plana (R.D.L. 3/2014)',15),(18,0,'','Bonificacion INEM formacion continua',16),(3262,0,'/*read-only*/ CHECK((C=COEFICIENTE_PARCIALIDAD)>=0.50,\"La jornada debe ser al menos del 50%\");TC2S=\"100,200,300\";CHECK(TC2S.indexOf(TC2)>=0,\"El contrato debe ser %s\", TC2S);FIN_BONIF=DIA(AÑO(INICIO_BONIF,2),-1);CHECK(INICIO_NOMINA <= FIN_BONIF, \"La Tarifa Plana finalizo el %1$td/%1$tm/%1$tY\", FIN_BONIF);TRAMO(FIN_BONIF);N=MAX(0,DIAS(FIN,FIN_BONIF));D = (C < 1.00 ? ( C < 0.75 ? 50.00 : 75.00 ) : 100.00);MAX(0,(CGC_E * ((DIAS_COTIZADOS-N)/DIAS_COTIZADOS)-(D * (DIAS_COTIZADOS-N)/DIAS_MES )))/**/','REDUCCIONES RD-L 3/2014 TARIFA PLANA (PRIMEROS DOS AÑOS)',NULL),(3263,0,'/*read-only*/ CHECK((C=COEFICIENTE_PARCIALIDAD)>=0.50,\"La jornada debe ser al menos del 50%\");T=\"100,200,300\";CHECK(T.indexOf(TC2)>=0,\"El contrato debe ser %s\",T);I=AÑO(INICIO_BONIF,2);CHECK(FIN_NOMINA>=I,\"La Tarifa Plana (3º año) comienza el %1$td/%1$tm/%1$tY\",I);N=MAX(0,DIAS(I,(A=INICIO)));F=DIA(AÑO(INICIO_BONIF,3),-1);CHECK(INICIO_NOMINA<=F,\"La Tarifa Plana (3º año) finalizo el %1$td/%1$tm/%1$tY\",F);TRAMO(F);N+=MAX(0,DIAS(FIN,F));CGC_E * ((DIAS_COTIZADOS-N)/DIAS_COTIZADOS) * 0.50 /**/','REDUCCIONES RD-L 3/2014 TARIFA PLANA (TERCER AÑO)',NULL),(3266,0,'/*read-only*/CHECK(COEFICIENTE_PARCIALIDAD>=0.50,\"La jornada debe ser al menos del 50%\");TC2S=\"100,200,300,150,250,350,130,230,330\";CHECK(TC2S.indexOf(TC2)>=0,\"El contrato debe ser %s\", TC2S);FIN_BONIF=DIA(AÑO(INICIO_BONIF,2),-1);CHECK(INICIO_NOMINA <= FIN_BONIF, \"La Tarifa Reducida finalizo el %1$td/%1$tm/%1$tY\", FIN_BONIF);TRAMO(FIN_BONIF);DIAS_NO_BONIF=MAX(0,DIAS(FIN,FIN_BONIF));500.00  * (DIAS_COTIZADOS - DIAS_NO_BONIF) * COEFICIENTE_PARCIALIDAD / DIAS_MES * PORCENTAJE_CGC_E/100/**/','TARIFA REDUCIDA REDUCCIÓN RD-L 1/2015',NULL),(3268,0,'/*read-only*/CHECK((C=COEFICIENTE_PARCIALIDAD)>=0.50,\"La jornada debe ser al menos del 50%\");T=\"100,200,300,150,250,350,130,230,330\";CHECK(T.indexOf(TC2)>=0,\"El contrato debe ser %s\",T);I=AÑO((O=INICIO_BONIF),2);CHECK(FIN_NOMINA>=I,\"La Tarifa Reducida (3º año) comienza el %1$td/%1$tm/%1$tY\",I);N=MAX(0,DIAS(I,(A=INICIO)));F=DIA(AÑO(O,3),-1);CHECK(A<=F,\"La Tarifa Reducida (3º año) finalizo el %1$td/%1$tm/%1$tY\",F);TRAMO(F);N+=MAX(0,DIAS(FIN,F));250.00*(DIAS_COTIZADOS-N)*C/DIAS_MES*PORCENTAJE_CGC_E/100/**/','TARIFA REDUCIDA.TERCER AÑO .REDUCCIÓN RD-L 1/2015',NULL);
/*!40000 ALTER TABLE `bonus_concept` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `booking`
--

DROP TABLE IF EXISTS `booking`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `booking` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `project_reservation_room` int(4) NOT NULL COMMENT 'Identificador de la Habitacion de la Reserva',
  `hotel` int(4) NOT NULL COMMENT 'Identificador del Hotel',
  `agency` int(4) DEFAULT NULL COMMENT 'Identificador de la Agencia',
  `item` int(4) NOT NULL COMMENT 'Identificador del Producto',
  `tariff` int(4) NOT NULL COMMENT 'Identificador de la Tarifa',
  `stay_date` date NOT NULL COMMENT 'Fecha de estancia',
  `stay_type` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Indica si es una entrada, una salida o una permanencia',
  `guests` int(4) NOT NULL DEFAULT '0' COMMENT 'Numero de Huespedes',
  PRIMARY KEY (`id`),
  UNIQUE KEY `IDX_UNQ_BOOKING_ROOM_DATE` (`project_reservation_room`,`stay_date`,`stay_type`),
  KEY `IDX_BOOKING_DOMAIN` (`domain`),
  KEY `IDX_BOOKING_PROJECT_RESERVATION_ROOM` (`project_reservation_room`),
  KEY `IDX_BOOKING_HOTEL` (`hotel`),
  KEY `IDX_BOOKING_AGENCY` (`agency`),
  KEY `IDX_BOOKING_ITEM` (`item`),
  KEY `IDX_BOOKING_TARIFF` (`tariff`),
  CONSTRAINT `FK_BOOKING_AGENCY` FOREIGN KEY (`agency`) REFERENCES `customer` (`registry`),
  CONSTRAINT `FK_BOOKING_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_BOOKING_HOTEL` FOREIGN KEY (`hotel`) REFERENCES `hotel` (`id`),
  CONSTRAINT `FK_BOOKING_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`),
  CONSTRAINT `FK_BOOKING_PROJECT_RESERVATION_ROOM` FOREIGN KEY (`project_reservation_room`) REFERENCES `project_reservation_room` (`id`),
  CONSTRAINT `FK_BOOKING_TARIFF` FOREIGN KEY (`tariff`) REFERENCES `tariff` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Booking de Hoteles';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `booking`
--

LOCK TABLES `booking` WRITE;
/*!40000 ALTER TABLE `booking` DISABLE KEYS */;
/*!40000 ALTER TABLE `booking` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `brand`
--

DROP TABLE IF EXISTS `brand`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `brand` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la Marca Comercial',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre de la Marca Comercial',
  PRIMARY KEY (`id`),
  KEY `IDX_BRAND_DOMAIN` (`domain`),
  CONSTRAINT `FK_BRAND_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Marcas Comerciales';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `brand`
--

LOCK TABLES `brand` WRITE;
/*!40000 ALTER TABLE `brand` DISABLE KEYS */;
/*!40000 ALTER TABLE `brand` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `calendar`
--

DROP TABLE IF EXISTS `calendar`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `calendar` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `holiday` int(4) DEFAULT NULL COMMENT 'Identificador de Festivos',
  `anual_hours` double DEFAULT '0' COMMENT 'Horas anuales del Calendario',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion del Calendario',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios',
  `monday` tinyint(2) DEFAULT '0' COMMENT 'Tipo de dia',
  `monday_hours` double DEFAULT '0' COMMENT 'Numero de horas laborables',
  `tuesday` tinyint(2) DEFAULT '0' COMMENT 'Tipo de dia',
  `tuesday_hours` double DEFAULT '0' COMMENT 'Numero de horas laborables',
  `wednesday` tinyint(2) DEFAULT '0' COMMENT 'Tipo de dia',
  `wednesday_hours` double DEFAULT '0' COMMENT 'Numero de horas laborables',
  `thursday` tinyint(2) DEFAULT '0' COMMENT 'Tipo de dia',
  `thursday_hours` double DEFAULT '0' COMMENT 'Numero de horas laborables',
  `friday` tinyint(2) DEFAULT '0' COMMENT 'Tipo de dia',
  `friday_hours` double DEFAULT '0' COMMENT 'Numero de horas laborables',
  `saturday` tinyint(2) DEFAULT '1' COMMENT 'Tipo de dia',
  `saturday_hours` double DEFAULT '0' COMMENT 'Numero de horas laborables',
  `sunday` tinyint(2) DEFAULT '1' COMMENT 'Tipo de dia',
  `sunday_hours` double DEFAULT '0' COMMENT 'Numero de horas laborables',
  `generic` tinyint(1) DEFAULT '1' COMMENT 'Indica si es editable o no',
  `calendar` int(4) DEFAULT NULL COMMENT 'Calendario del que se hereda',
  PRIMARY KEY (`id`),
  KEY `IDX_CALENDAR_HOLIDAY` (`holiday`),
  KEY `IDX_CALENDAR_CALENDAR` (`calendar`),
  KEY `IDX_CALENDAR_DOMAIN` (`domain`),
  CONSTRAINT `FK_CALENDAR_CALENDAR` FOREIGN KEY (`calendar`) REFERENCES `calendar` (`id`),
  CONSTRAINT `FK_CALENDAR_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_CALENDAR_HOLIDAY` FOREIGN KEY (`holiday`) REFERENCES `holiday` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Calendarios Laborales';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `calendar`
--

LOCK TABLES `calendar` WRITE;
/*!40000 ALTER TABLE `calendar` DISABLE KEYS */;
INSERT INTO `calendar` VALUES (1,8785,93,0,NULL,NULL,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,NULL),(2,8785,94,0,NULL,NULL,1,0,0,0,0,0,0,0,0,0,0,0,1,0,1,NULL);
/*!40000 ALTER TABLE `calendar` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `calendar_holiday`
--

DROP TABLE IF EXISTS `calendar_holiday`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `calendar_holiday` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `calendar` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador del Calendario',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion del Festivo',
  `date` date DEFAULT NULL COMMENT 'Fecha del festivo',
  `day_type` tinyint(2) DEFAULT '0' COMMENT 'Tipo de dia',
  `hours` double DEFAULT '0' COMMENT 'Numero de horas laborables',
  PRIMARY KEY (`id`),
  KEY `IDX_CALENDAR_HOLIDAY_CALENDAR` (`calendar`),
  KEY `IDX_CALENDAR_HOLIDAY_DOMAIN` (`domain`),
  CONSTRAINT `FK_CALENDAR_HOLIDAY_CALENDAR` FOREIGN KEY (`calendar`) REFERENCES `calendar` (`id`),
  CONSTRAINT `FK_CALENDAR_HOLIDAY_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Festivos de Calendarios';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `calendar_holiday`
--

LOCK TABLES `calendar_holiday` WRITE;
/*!40000 ALTER TABLE `calendar_holiday` DISABLE KEYS */;
/*!40000 ALTER TABLE `calendar_holiday` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `calendar_period`
--

DROP TABLE IF EXISTS `calendar_period`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `calendar_period` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `calendar` int(4) NOT NULL COMMENT 'Identificador del Calendario',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion del Periodo',
  `month` tinyint(2) DEFAULT '0' COMMENT 'Mes del periodo',
  `start_day` tinyint(2) DEFAULT '0' COMMENT 'Dia inicio del periodo',
  `end_day` tinyint(2) DEFAULT '0' COMMENT 'Dia fin del periodo',
  `monday` tinyint(2) DEFAULT '0' COMMENT 'Tipo de dia',
  `monday_hours` double DEFAULT '0' COMMENT 'Numero de horas laborables',
  `tuesday` tinyint(2) DEFAULT '0' COMMENT 'Tipo de dia',
  `tuesday_hours` double DEFAULT '0' COMMENT 'Numero de horas laborables',
  `wednesday` tinyint(2) DEFAULT '0' COMMENT 'Tipo de dia',
  `wednesday_hours` double DEFAULT '0' COMMENT 'Numero de horas laborables',
  `thursday` tinyint(2) DEFAULT '0' COMMENT 'Tipo de dia',
  `thursday_hours` double DEFAULT '0' COMMENT 'Numero de horas laborables',
  `friday` tinyint(2) DEFAULT '0' COMMENT 'Tipo de dia',
  `friday_hours` double DEFAULT '0' COMMENT 'Numero de horas laborables',
  `saturday` tinyint(2) DEFAULT '0' COMMENT 'Tipo de dia',
  `saturday_hours` double DEFAULT '0' COMMENT 'Numero de horas laborables',
  `sunday` tinyint(2) DEFAULT '0' COMMENT 'Tipo de dia',
  `sunday_hours` double DEFAULT '0' COMMENT 'Numero de horas laborables',
  PRIMARY KEY (`id`),
  KEY `IDX_CALENDAR_PERIOD_CALENDAR` (`calendar`),
  KEY `IDX_CALENDAR_PERIOD_DOMAIN` (`domain`),
  CONSTRAINT `FK_CALENDAR_PERIOD_CALENDAR` FOREIGN KEY (`calendar`) REFERENCES `calendar` (`id`),
  CONSTRAINT `FK_CALENDAR_PERIOD_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Periodos de Calendarios';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `calendar_period`
--

LOCK TABLES `calendar_period` WRITE;
/*!40000 ALTER TABLE `calendar_period` DISABLE KEYS */;
/*!40000 ALTER TABLE `calendar_period` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `campaign`
--

DROP TABLE IF EXISTS `campaign`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `campaign` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la Campaña',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `campaign_type` int(4) DEFAULT NULL COMMENT 'Identificador del Tipo de Campaña',
  `description` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion de la Campaña',
  `process` int(4) NOT NULL COMMENT 'Identificador del Proceso',
  `start_date` date NOT NULL COMMENT 'Fecha de inicio de la Campaña',
  `end_date` date NOT NULL COMMENT 'Fecha de finalizacion de la Campaña',
  `workgroup` int(4) NOT NULL COMMENT 'Grupo de Trabajo supervisor de la Campaña',
  `manual` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Tipo de Campaña',
  `status` tinyint(2) DEFAULT NULL COMMENT 'Estado de la Campaña',
  PRIMARY KEY (`id`),
  KEY `IDX_CAMPAIGN_CAMPAIGN_TYPE` (`campaign_type`),
  KEY `IDX_CAMPAIGN_PROCESS` (`process`),
  KEY `IDX_CAMPAIGN_WORKGROUP` (`workgroup`),
  KEY `IDX_CAMPAIGN_DOMAIN` (`domain`),
  CONSTRAINT `FK_CAMPAIGN_CAMPAIGN_TYPE` FOREIGN KEY (`campaign_type`) REFERENCES `campaign_type` (`id`),
  CONSTRAINT `FK_CAMPAIGN_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_CAMPAIGN_PROCESS` FOREIGN KEY (`process`) REFERENCES `process` (`id`),
  CONSTRAINT `FK_CAMPAIGN_WORKGROUP` FOREIGN KEY (`workgroup`) REFERENCES `workgroup` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Campañas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `campaign`
--

LOCK TABLES `campaign` WRITE;
/*!40000 ALTER TABLE `campaign` DISABLE KEYS */;
/*!40000 ALTER TABLE `campaign` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `campaign_project`
--

DROP TABLE IF EXISTS `campaign_project`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `campaign_project` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la Relacion de Campañas y Expedientes',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `campaign` int(4) NOT NULL COMMENT 'Identificador de la Campaña',
  `project` int(4) NOT NULL COMMENT 'Identificador del Expediente',
  PRIMARY KEY (`id`),
  KEY `IDX_CAMPAIGN_PROJECT_CAMPAIGN` (`campaign`),
  KEY `IDX_CAMPAIGN_PROJECT_PROJECT` (`project`),
  KEY `IDX_CAMPAIGN_PROJECT_DOMAIN` (`domain`),
  CONSTRAINT `FK_CAMPAIGN_PROJECT_CAMPAIGN` FOREIGN KEY (`campaign`) REFERENCES `campaign` (`id`),
  CONSTRAINT `FK_CAMPAIGN_PROJECT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_CAMPAIGN_PROJECT_PROJECT` FOREIGN KEY (`project`) REFERENCES `project` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Relacion entre Campañas y Expedientes';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `campaign_project`
--

LOCK TABLES `campaign_project` WRITE;
/*!40000 ALTER TABLE `campaign_project` DISABLE KEYS */;
/*!40000 ALTER TABLE `campaign_project` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `campaign_type`
--

DROP TABLE IF EXISTS `campaign_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `campaign_type` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `description` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion',
  `active` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Activo si o no',
  PRIMARY KEY (`id`),
  KEY `IDX_CAMPAIGN_TYPE_DOMAIN` (`domain`),
  CONSTRAINT `FK_CAMPAIGN_TYPE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Tipos de Campañas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `campaign_type`
--

LOCK TABLES `campaign_type` WRITE;
/*!40000 ALTER TABLE `campaign_type` DISABLE KEYS */;
/*!40000 ALTER TABLE `campaign_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `carrier`
--

DROP TABLE IF EXISTS `carrier`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `carrier` (
  `registry` int(4) NOT NULL COMMENT 'Registro de la Agencia de Transporte',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `scope` int(4) NOT NULL COMMENT 'Identificador del Ambito',
  `status` tinyint(2) DEFAULT NULL COMMENT 'Estado de la Agencia de Transporte',
  PRIMARY KEY (`registry`),
  KEY `IDX_CARRIER_DOMAIN` (`domain`),
  KEY `IDX_CARRIER_SCOPE` (`scope`),
  CONSTRAINT `FK_CARRIER_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_CARRIER_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`),
  CONSTRAINT `FK_CARRIER_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Agencias de Transporte';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `carrier`
--

LOCK TABLES `carrier` WRITE;
/*!40000 ALTER TABLE `carrier` DISABLE KEYS */;
/*!40000 ALTER TABLE `carrier` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `carrier_packing`
--

DROP TABLE IF EXISTS `carrier_packing`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `carrier_packing` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la hoja de ruta',
  `domain` int(4) NOT NULL COMMENT 'Identificador del dominio',
  `series` char(5) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Serie de la hoja de ruta',
  `number` int(4) NOT NULL DEFAULT '0' COMMENT 'Numero de la hoja de ruta',
  `type` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Indica el tipo de la hoja de ruta',
  `status` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Indica el estado de la hoja de ruta',
  `issue_date` datetime DEFAULT NULL COMMENT 'Fecha de emision',
  `carrier` int(4) NOT NULL COMMENT 'Identificador de la agencia de transporte',
  `delivery_date` datetime DEFAULT NULL COMMENT 'Fecha de entrega',
  `carrier_reference` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Referencia de la agencia de transporte',
  `number_plate` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de matricula del vehiculo',
  `driver_name` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre del conductor',
  `driver_document` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de documento del conductor',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Observaciones carrier packing',
  `gross` double DEFAULT NULL COMMENT 'Bruto',
  `tare` double DEFAULT NULL COMMENT 'Tara',
  `additional_tare` double DEFAULT NULL COMMENT 'Tara Adicional',
  `net` double DEFAULT NULL COMMENT 'Neto',
  `reception_start_date` datetime DEFAULT NULL COMMENT 'Fecha entrada transporte, recepcion',
  `reception_end_date` datetime DEFAULT NULL COMMENT 'Fecha salida transporte, recepcion',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_CARRIER_PACKING_DOMAIN` (`domain`),
  KEY `IDX_CARRIER_PACKING_CARRIER` (`carrier`),
  CONSTRAINT `FK_CARRIER_PACKING_CARRIER` FOREIGN KEY (`carrier`) REFERENCES `carrier` (`registry`),
  CONSTRAINT `FK_CARRIER_PACKING_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Hojas de ruta';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `carrier_packing`
--

LOCK TABLES `carrier_packing` WRITE;
/*!40000 ALTER TABLE `carrier_packing` DISABLE KEYS */;
/*!40000 ALTER TABLE `carrier_packing` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cashflow_forecast`
--

DROP TABLE IF EXISTS `cashflow_forecast`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cashflow_forecast` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `payment` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indica si es un pago o un cobro',
  `description` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion',
  `start_date` date NOT NULL COMMENT 'Fecha de inicio de aplicacion',
  `due_date` date DEFAULT NULL COMMENT 'Fecha final de aplicacion',
  `rbank` int(4) DEFAULT NULL COMMENT 'Identificador de Banco de la Compañia',
  `amount` double(15,2) NOT NULL DEFAULT '0.00' COMMENT 'Importe',
  `payment_day` double(15,2) NOT NULL DEFAULT '1.00' COMMENT 'Dia de pago',
  `january` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Aplicable en enero',
  `february` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Aplicable en febrero',
  `march` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Aplicable en marzo',
  `april` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Aplicable en abril',
  `may` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Aplicable en mayo',
  `june` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Aplicable en junio',
  `july` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Aplicable en julio',
  `august` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Aplicable en agosto',
  `september` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Aplicable en septiembre',
  `october` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Aplicable en octubre',
  `november` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Aplicable en noviembre',
  `december` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Aplicable en diciembre',
  PRIMARY KEY (`id`),
  KEY `IDX_CASHFLOW_FORECAST_RBANK` (`rbank`),
  KEY `IDX_CASHFLOW_FORECAST_DOMAIN` (`domain`),
  CONSTRAINT `FK_CASHFLOW_FORECAST_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_CASHFLOW_FORECAST_RBANK` FOREIGN KEY (`rbank`) REFERENCES `rbank` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Prevision de tesoreria';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cashflow_forecast`
--

LOCK TABLES `cashflow_forecast` WRITE;
/*!40000 ALTER TABLE `cashflow_forecast` DISABLE KEYS */;
/*!40000 ALTER TABLE `cashflow_forecast` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalogue`
--

DROP TABLE IF EXISTS `catalogue`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `catalogue` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre del Catalogo',
  `purchase` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indica si se trata de un Catalogo de Compras o Ventas',
  `start_date` date NOT NULL COMMENT 'Fecha de inicio del Catalogo',
  `end_date` date DEFAULT NULL COMMENT 'Fecha de fin del Catalogo',
  PRIMARY KEY (`id`),
  KEY `IDX_CATALOGUE_DOMAIN` (`domain`),
  CONSTRAINT `FK_CATALOGUE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Catalogos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalogue`
--

LOCK TABLES `catalogue` WRITE;
/*!40000 ALTER TABLE `catalogue` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalogue` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalogue_category`
--

DROP TABLE IF EXISTS `catalogue_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `catalogue_category` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `catalogue` int(4) NOT NULL COMMENT 'Identificador del Catalogo',
  `category` int(4) NOT NULL COMMENT 'Identificador de la Categoria',
  `quantity` double DEFAULT '0' COMMENT 'Cantidad a partir de la cual se aplica el descuento',
  `discount` double(6,2) DEFAULT '0.00' COMMENT 'Descuento de la Categoria en el Catalogo',
  PRIMARY KEY (`id`),
  KEY `IDX_CATALOGUE_CATEGORY_CATALOGUE` (`catalogue`),
  KEY `IDX_CATALOGUE_CATEGORY_PCATEGORY` (`category`),
  KEY `IDX_CATALOGUE_CATEGORY_DOMAIN` (`domain`),
  CONSTRAINT `FK_CATALOGUE_CATEGORY_CATALOGUE` FOREIGN KEY (`catalogue`) REFERENCES `catalogue` (`id`),
  CONSTRAINT `FK_CATALOGUE_CATEGORY_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_CATALOGUE_CATEGORY_PCATEGORY` FOREIGN KEY (`category`) REFERENCES `pcategory` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Categorias del Catalogo';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalogue_category`
--

LOCK TABLES `catalogue_category` WRITE;
/*!40000 ALTER TABLE `catalogue_category` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalogue_category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `catalogue_item`
--

DROP TABLE IF EXISTS `catalogue_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `catalogue_item` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `catalogue` int(4) NOT NULL COMMENT 'Identificador del Catalogo',
  `product` int(4) NOT NULL COMMENT 'Identificador del Producto',
  `item` int(4) DEFAULT NULL COMMENT 'Identificador del Articulo',
  `quantity` double DEFAULT '0' COMMENT 'Cantidad a partir de la cual se aplica el precio o descuento',
  `price` double DEFAULT '0' COMMENT 'Precio del Articulo en el Catalogo',
  `discount` double(6,2) DEFAULT '0.00' COMMENT 'Descuento del Articulo en el Catalogo',
  PRIMARY KEY (`id`),
  KEY `IDX_CATALOGUE_ITEM_CATALOGUE` (`catalogue`),
  KEY `IDX_CATALOGUE_ITEM_ITEM` (`item`),
  KEY `IDX_CATALOGUE_ITEM_DOMAIN` (`domain`),
  KEY `IDX_CATALOGUE_ITEM_PRODUCT` (`product`),
  CONSTRAINT `FK_CATALOGUE_ITEM_CATALOGUE` FOREIGN KEY (`catalogue`) REFERENCES `catalogue` (`id`),
  CONSTRAINT `FK_CATALOGUE_ITEM_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_CATALOGUE_ITEM_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`),
  CONSTRAINT `FK_CATALOGUE_ITEM_PRODUCT` FOREIGN KEY (`product`) REFERENCES `product` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Articulos del Catalogo';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `catalogue_item`
--

LOCK TABLES `catalogue_item` WRITE;
/*!40000 ALTER TABLE `catalogue_item` DISABLE KEYS */;
/*!40000 ALTER TABLE `catalogue_item` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `category`
--

DROP TABLE IF EXISTS `category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `category` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la Categoria',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre de la Categoria',
  `type` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Tipo de la Categoria',
  `scope` int(4) DEFAULT NULL COMMENT 'Identificador del Ambito',
  `description` varchar(1024) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion de la Categoria',
  `url` varchar(256) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Url de la Categoria',
  `rattach` int(4) DEFAULT NULL COMMENT 'Identificador del Archivo Adjunto',
  PRIMARY KEY (`id`),
  KEY `IDX_CATEGORY_DOMAIN` (`domain`),
  KEY `IDX_CATEGORY_RATTACH` (`rattach`),
  KEY `IDX_CATEGORY_SCOPE` (`scope`),
  CONSTRAINT `FK_CATEGORY_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_CATEGORY_RATTACH` FOREIGN KEY (`rattach`) REFERENCES `rattach` (`id`),
  CONSTRAINT `FK_CATEGORY_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Categorias';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `category`
--

LOCK TABLES `category` WRITE;
/*!40000 ALTER TABLE `category` DISABLE KEYS */;
INSERT INTO `category` VALUES (-1001,0,'CONVENIOS',0,NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `certifica2_batch`
--

DROP TABLE IF EXISTS `certifica2_batch`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `certifica2_batch` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del certificado de empresa de la remesa',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `enterprise` int(4) NOT NULL COMMENT 'Identificador unico del certificado de empresa de la empresa',
  `date` datetime DEFAULT NULL COMMENT 'Fecha de la remesa',
  `status` int(4) DEFAULT NULL COMMENT 'Estado de la remesa',
  `sign` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Huella digital obtenida de la respuesta',
  `communication_id` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Identificador resultante de la comunicacion',
  `income_file` mediumblob COMMENT 'Archivo respuesta en binario',
  `income_file_date` datetime DEFAULT NULL COMMENT 'Fecha de respuesta',
  `outcome_file` mediumblob COMMENT 'Archivo Adjunto en binario',
  `outcome_file_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  PRIMARY KEY (`id`),
  KEY `IDX_CERTIFICA2_BATCH_ENTERPRISE` (`enterprise`),
  KEY `IDX_CERTIFICA2_BATCH_DOMAIN` (`domain`),
  CONSTRAINT `FK_CERTIFICA2_BATCH_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_CERTIFICA2_BATCH_ENTERPRISE` FOREIGN KEY (`enterprise`) REFERENCES `enterprise` (`registry`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Remesas de certificados de empresa';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `certifica2_batch`
--

LOCK TABLES `certifica2_batch` WRITE;
/*!40000 ALTER TABLE `certifica2_batch` DISABLE KEYS */;
/*!40000 ALTER TABLE `certifica2_batch` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `certifica2_batch_detail`
--

DROP TABLE IF EXISTS `certifica2_batch_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `certifica2_batch_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del certificado de empresa de la remesa',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `certifica2_batch` int(4) NOT NULL COMMENT 'Identificador unico del certificado de empresa',
  `contract` int(4) NOT NULL COMMENT 'Identificador unico del contrato de empleado',
  `suspension_cause_code` varchar(2) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Codigo causa suspension',
  `status` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Estado de la linea de la remesa',
  PRIMARY KEY (`id`),
  KEY `IDX_CERTIFICA2_BATCH_DETAIL_CERTIFICA2_BATCH` (`certifica2_batch`),
  KEY `IDX_CERTIFICA2_BATCH_DETAIL_CONTRACT` (`contract`),
  KEY `IDX_CERTIFICA2_BATCH_DETAIL_DOMAIN` (`domain`),
  CONSTRAINT `FK_CERTIFICA2_BATCH_DETAIL_CERTIFICA2_BATCH` FOREIGN KEY (`certifica2_batch`) REFERENCES `certifica2_batch` (`id`),
  CONSTRAINT `FK_CERTIFICA2_BATCH_DETAIL_CONTRACT` FOREIGN KEY (`contract`) REFERENCES `contract` (`id`),
  CONSTRAINT `FK_CERTIFICA2_BATCH_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalle de las remesas de certificados de empresa';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `certifica2_batch_detail`
--

LOCK TABLES `certifica2_batch_detail` WRITE;
/*!40000 ALTER TABLE `certifica2_batch_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `certifica2_batch_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cnae`
--

DROP TABLE IF EXISTS `cnae`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cnae` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `code` varchar(5) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Codigo del CNAE',
  `title` varchar(255) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Titulo del CNAE',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=9901 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='CNAE';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cnae`
--

LOCK TABLES `cnae` WRITE;
/*!40000 ALTER TABLE `cnae` DISABLE KEYS */;
INSERT INTO `cnae` VALUES (111,'0111','Cultivo de cereales (excepto arroz), leguminosas y semillas oleaginosas'),(112,'0112','Cultivo de arroz'),(113,'0113','Cultivo de hortalizas, raíces y tubérculos'),(114,'0114','Cultivo de cañaa de azúcar'),(115,'0115','Cultivo de tabaco'),(116,'0116','Cultivo de plantas para fibras textiles'),(119,'0119','Otros cultivos no perennes'),(121,'0121','Cultivo de la vid'),(122,'0122','Cultivo de frutos tropicales y subtropicales'),(123,'0123','Cultivo de cítricos'),(124,'0124','Cultivo de frutos con hueso y pepitas'),(125,'0125','Cultivo de otros árboles y arbustos frutales y frutos secos'),(126,'0126','Cultivo de frutos oleaginosos'),(127,'0127','Cultivo de plantas para bebidas'),(128,'0128','Cultivo de especias, plantas aromáticas, medicinales y farmacéuticas'),(129,'0129','Otros cultivos perennes'),(130,'0130','Propagación de plantas'),(141,'0141','Explotación de ganado bovino para la producción de leche'),(142,'0142','Explotación de otro ganado bovino y búfalos'),(143,'0143','Explotación de caballos y otros equinos'),(144,'0144','Explotación de camellos y otros camélidos'),(145,'0145','Explotación de ganado ovino y caprino'),(146,'0146','Explotación de ganado porcino'),(147,'0147','Avicultura'),(149,'0149','Otras explotaciones de ganado'),(150,'0150','Producción agrícola combinada con la producción ganadera'),(161,'0161','Actividades de apoyo a la agricultura'),(162,'0162','Actividades de apoyo a la ganadería'),(163,'0163','Actividades de preparación posterior a la cosecha'),(164,'0164','Tratamiento de semillas para reproducción'),(170,'0170','Caza, captura de animales y servicios relacionados con las mismas'),(210,'0210','Silvicultura y otras actividades forestales'),(220,'0220','Explotación de la madera'),(230,'0230','Recolección de productos silvestres, excepto madera'),(240,'0240','Servicios de apoyo a la silvicultura'),(311,'0311','Pesca marina'),(312,'0312','Pesca en agua dulce'),(321,'0321','Acuicultura marina'),(322,'0322','Acuicultura en agua dulce'),(510,'0510','Extracción de antracita y hulla'),(520,'0520','Extracción de lignito'),(610,'0610','Extracción de crudo de petróleo'),(620,'0620','Extracción de gas natural'),(710,'0710','Extracción de minerales de hierro'),(721,'0721','Extracción de minerales de uranio y torio'),(729,'0729','Extracción de otros minerales metálicos no férreos'),(811,'0811','Extracción de piedra ornamental y para la construcción, piedra caliza, yeso, creta y pizarra'),(812,'0812','Extracción de gravas y arenas'),(891,'0891','Extracción de minerales para productos químicos y fertilizantes'),(892,'0892','Extracción de turba'),(893,'0893','Extracción de sal'),(899,'0899','Otras industrias extractivas n.c.o.p.'),(910,'0910','Actividades de apoyo a la extracción de petróleo y gas natural'),(990,'0990','Actividades de apoyo a otras industrias extractivas'),(1011,'1011','Procesado y conservación de carne'),(1012,'1012','Procesado y conservación de volatería'),(1013,'1013','Elaboración de productos cárnicos y de volatería'),(1021,'1021','Procesado de pescados, crustáceos y moluscos'),(1022,'1022','Fabricación de conservas de pescado'),(1031,'1031','Procesado y conservación de patatas'),(1032,'1032','Elaboración de zumos de frutas y hortalizas'),(1039,'1039','Otro procesado y conservación de frutas y hortalizas'),(1042,'1042','Fabricación de margarina y grasas comestibles similares'),(1043,'1043','Fabricación de aceite de oliva'),(1044,'1044','Fabricación de otros aceites y grasas'),(1052,'1052','Elaboración de helados'),(1053,'1053','Fabricación de quesos'),(1054,'1054','Preparación de leche y otros productos lácteos'),(1061,'1061','Fabricación de productos de molinería'),(1062,'1062','Fabricación de almidones y productos amiláceos'),(1071,'1071','Fabricación de pan y de productos frescos de panadería y pastelería'),(1072,'1072','Fabricación de galletas y productos de panadería y pastelería de larga duración'),(1073,'1073','Fabricación de pastas alimenticias, cuscús y productos similares'),(1081,'1081','Fabricación de azúcar'),(1082,'1082','Fabricación de cacao, chocolate y productos de confitería'),(1083,'1083','Elaboración de café, té e infusiones'),(1084,'1084','Elaboración de especias, salsas y condimentos'),(1085,'1085','Elaboración de platos y comidas preparados'),(1086,'1086','Elaboración de preparados alimenticios homogeneizados y alimentos dietéticos'),(1089,'1089','Elaboración de otros productos alimenticios n.c.o.p.'),(1091,'1091','Fabricación de productos para la alimentación de animales de granja'),(1092,'1092','Fabricación de productos para la alimentación de animales de compañía'),(1101,'1101','Destilación, rectificación y mezcla de bebidas alcohólicas'),(1102,'1102','Elaboración de vinos'),(1103,'1103','Elaboración de sidra y otras bebidas fermentadas a partir de frutas'),(1104,'1104','Elaboración de otras bebidas no destiladas, procedentes de la fermentación'),(1105,'1105','Fabricación de cerveza'),(1106,'1106','Fabricación de malta'),(1107,'1107','Fabricación de bebidas no alcohólicas'),(1200,'1200','Industria del tabaco'),(1310,'1310','Preparación e hilado de fibras textiles'),(1320,'1320','Fabricación de tejidos textiles'),(1330,'1330','Acabado de textiles'),(1391,'1391','Fabricación de tejidos de punto'),(1392,'1392','Fabricación de artículos confeccionados con textiles, excepto prendas de vestir'),(1393,'1393','Fabricación de alfombras y moquetas'),(1394,'1394','Fabricación de cuerdas, cordeles, bramantes y redes'),(1395,'1395','Fabricación de telas no tejidas y artículos confeccionados con ellas, excepto prendas de vestir'),(1396,'1396','Fabricación de otros productos textiles de uso técnico e industrial'),(1399,'1399','Fabricación de otros productos textiles n.c.o.p.'),(1411,'1411','Confección de prendas de vestir de cuero'),(1412,'1412','Confección de ropa de trabajo'),(1413,'1413','Confección de otras prendas de vestir exteriores'),(1414,'1414','Confección de ropa interior'),(1419,'1419','Confección de otras prendas de vestir y accesorios'),(1420,'1420','Fabricación de artículos de peletería'),(1431,'1431','Confección de calcetería'),(1439,'1439','Confección de otras prendas de vestir de punto'),(1511,'1511','Preparación, curtido y acabado del cuero'),(1512,'1512','Fabricación de artículos de marroquinería, viaje y de guarnicionería y talabartería'),(1520,'1520','Fabricación de calzado'),(1610,'1610','Aserrado y cepillado de la madera'),(1621,'1621','Fabricación de chapas y tableros de madera'),(1622,'1622','Fabricación de suelos de madera ensamblados'),(1623,'1623','Fabricación de otras estructuras de madera y piezas de carpintería y ebanistería para la construcción'),(1624,'1624','Fabricación de envases y embalajes de madera'),(1629,'1629','Fabricación de otros productos de madera'),(1711,'1711','Fabricación de pasta papelera'),(1712,'1712','Fabricación de papel y cartón'),(1721,'1721','Fabricación de papel y cartón ondulados'),(1722,'1722','Fabricación de artículos de papel y cartón para uso doméstico, sanitario e higiínico'),(1723,'1723','Fabricación de artículos de papelería'),(1724,'1724','Fabricación de papeles pintados'),(1729,'1729','Fabricación de otros artículos de papel y cartón'),(1811,'1811','Artes gráficas y servicios relacionados con las mismas'),(1812,'1812','Otras actividades de impresión y artes gráficas'),(1813,'1813','Servicios de preimpresión y preparación de soportes'),(1814,'1814','Encuadernación y servicios relacionados con la misma'),(1820,'1820','Reproducción de soportes grabados'),(1910,'1910','Coquerías'),(1920,'1920','Refino de petróleo'),(2011,'2011','Fabricación de gases industriales'),(2012,'2012','Fabricación de colorantes y pigmentos'),(2013,'2013','Fabricación de otros productos básicos de química inorgánica'),(2014,'2014','Fabricación de otros productos básicos de química orgánica'),(2015,'2015','Fabricación de fertilizantes y compuestos nitrogenados'),(2016,'2016','Fabricación de plásticos en formas primarias'),(2017,'2017','Fabricación de caucho sintético en formas primarias'),(2020,'2020','Fabricación de pesticidas y otros productos agroquímicos'),(2030,'2030','Fabricación de pinturas, barnices y revestimientos similares'),(2041,'2041','Fabricación de jabones, detergentes y otros artículos de limpieza y abrillantamiento'),(2042,'2042','Fabricación de perfumes y cosméticos'),(2051,'2051','Fabricación de explosivos'),(2052,'2052','Fabricación de colas'),(2053,'2053','Fabricación de aceites esenciales'),(2059,'2059','Fabricación de otros productos químicos n.c.o.p.'),(2060,'2060','Fabricación de fibras artificiales y sintéticas'),(2110,'2110','Fabricación de productos farmacéuticos de base'),(2120,'2120','Fabricación de especialidades farmacéuticas'),(2211,'2211','Fabricación de neumáticos y cámaras de caucho'),(2219,'2219','Fabricación de otros productos de caucho'),(2221,'2221','Fabricación de placas, hojas, tubos y perfiles de plástico'),(2222,'2222','Fabricación de envases y embalajes de plástico'),(2223,'2223','Fabricación de productos de plástico para la construcción'),(2229,'2229','Fabricación de otros productos de plástico'),(2311,'2311','Fabricación de vidrio plano'),(2312,'2312','Manipulado y transformación de vidrio plano'),(2313,'2313','Fabricación de vidrio hueco'),(2314,'2314','Fabricación de fibra de vidrio'),(2319,'2319','Fabricación y manipulado de otro vidrio, incluido el vidrio técnico'),(2320,'2320','Fabricación de productos cerámicos refractarios'),(2331,'2331','Fabricación de azulejos y baldosas de cerámica'),(2332,'2332','Fabricación de ladrillos, tejas y productos de tierras cocidas para la construcción'),(2341,'2341','Fabricación de artículos cerámicos de uso doméstico y ornamental'),(2342,'2342','Fabricación de aparatos sanitarios cerámicos'),(2343,'2343','Fabricación de aisladores y piezas aislantes de material cerámico'),(2344,'2344','Fabricación de otros productos cerámicos de uso técnico'),(2349,'2349','Fabricación de otros productos cerámicos'),(2351,'2351','Fabricación de cemento'),(2352,'2352','Fabricación de cal y yeso'),(2361,'2361','Fabricación de elementos de hormigón para la construcción'),(2362,'2362','Fabricación de elementos de yeso para la construcción'),(2363,'2363','Fabricación de hormigón fresco'),(2364,'2364','Fabricación de mortero'),(2365,'2365','Fabricación de fibrocemento'),(2369,'2369','Fabricación de otros productos de hormigón, yeso y cemento'),(2370,'2370','Corte, tallado y acabado de la piedra'),(2391,'2391','Fabricación de productos abrasivos'),(2399,'2399','Fabricación de otros productos minerales no metálicos n.c.o.p.'),(2410,'2410','Fabricación de productos básicos de hierro, acero y ferroaleaciones'),(2420,'2420','Fabricación de tubos, tuberías, perfiles huecos y sus accesorios, de acero'),(2431,'2431','Estirado en frío'),(2432,'2432','Laminación en frío'),(2433,'2433','Producción de perfiles en frío por conformación con plegado'),(2434,'2434','Trefilado en frío'),(2441,'2441','Producción de metales preciosos'),(2442,'2442','Producción de aluminio'),(2443,'2443','Producción de plomo, zinc y estaño'),(2444,'2444','Producción de cobre'),(2445,'2445','Producción de otros metales no férreos'),(2446,'2446','Procesamiento de combustibles nucleares'),(2451,'2451','Fundición de hierro'),(2452,'2452','Fundición de acero'),(2453,'2453','Fundición de metales ligeros'),(2454,'2454','Fundición de otros metales no férreos'),(2511,'2511','Fabricación de estructuras metálicas y sus componentes'),(2512,'2512','Fabricación de carpintería metálica'),(2521,'2521','Fabricación de radiadores y calderas para calefacción central'),(2529,'2529','Fabricación de otras cisternas, grandes depósitos y contenedores de metal'),(2530,'2530','Fabricación de generadores de vapor, excepto calderas de calefacción central'),(2540,'2540','Fabricación de armas y municiones'),(2550,'2550','Forja, estampación y embutición de metales'),(2561,'2561','Tratamiento y revestimiento de metales'),(2562,'2562','Ingeniería mecánica por cuenta de terceros'),(2571,'2571','Fabricación de artículos de cuchillería y cubertería'),(2572,'2572','Fabricación de cerraduras y herrajes'),(2573,'2573','Fabricación de herramientas'),(2591,'2591','Fabricación de bidones y toneles de hierro o acero'),(2592,'2592','Fabricación de envases y embalajes metálicos ligeros'),(2593,'2593','Fabricación de productos de alambre, cadenas y muelles'),(2594,'2594','Fabricación de pernos y productos de tornillería'),(2599,'2599','Fabricación de otros productos metálicos n.c.o.p.'),(2611,'2611','Fabricación de componentes electrónicos'),(2612,'2612','Fabricación de circuitos impresos ensamblados'),(2620,'2620','Fabricación de ordenadores y equipos perifíricos'),(2630,'2630','Fabricación de equipos de telecomunicaciones'),(2640,'2640','Fabricación de productos electrónicos de consumo'),(2651,'2651','Fabricación de instrumentos y aparatos de medida, verificación y navegación'),(2652,'2652','Fabricación de relojes'),(2660,'2660','Fabricación de equipos de radiación, electromédicos y electroterapéuticos'),(2670,'2670','Fabricación de instrumentos de óptica y equipo fotográfico'),(2680,'2680','Fabricación de soportes magnéticos y ópticos'),(2711,'2711','Fabricación de motores, generadores y transformadores eléctricos'),(2712,'2712','Fabricación de aparatos de distribución y control eléctrico'),(2720,'2720','Fabricación de pilas y acumuladores eléctricos'),(2731,'2731','Fabricación de cables de fibra óptica'),(2732,'2732','Fabricación de otros hilos y cables electrónicos y eléctricos'),(2733,'2733','Fabricación de dispositivos de cableado'),(2740,'2740','Fabricación de lámparas y aparatos eléctricos de iluminación'),(2751,'2751','Fabricación de electrodomésticos'),(2752,'2752','Fabricación de aparatos domésticos no eléctricos'),(2790,'2790','Fabricación de otro material y equipo eléctrico'),(2811,'2811','Fabricación de motores y turbinas, excepto los destinados a aeronaves, vehículos automóviles y ciclomotores'),(2812,'2812','Fabricación de equipos de transmisión hidráulica y neumática'),(2813,'2813','Fabricación de otras bombas y compresores'),(2814,'2814','Fabricación de otra grifería y válvulas'),(2815,'2815','Fabricación de cojinetes, engranajes y órganos mecánicos de transmisión'),(2821,'2821','Fabricación de hornos y quemadores'),(2822,'2822','Fabricación de maquinaria de elevación y manipulación'),(2823,'2823','Fabricación de máquinas y equipos de oficina, excepto equipos informáticos'),(2824,'2824','Fabricación de herramientas eléctricas manuales'),(2825,'2825','Fabricación de maquinaria de ventilación y refrigeración no doméstica'),(2829,'2829','Fabricación de otra maquinaria de uso general n.c.o.p.'),(2830,'2830','Fabricación de maquinaria agraria y forestal'),(2841,'2841','Fabricación de máquinas herramienta para trabajar el metal'),(2849,'2849','Fabricación de otras máquinas herramienta'),(2891,'2891','Fabricación de maquinaria para la industria metalúrgica'),(2892,'2892','Fabricación de maquinaria para las industrias extractivas y de la construcción'),(2893,'2893','Fabricación de maquinaria para la industria de la alimentación, bebidas y tabaco'),(2894,'2894','Fabricación de maquinaria para las industrias textil, de la confección y del cuero'),(2895,'2895','Fabricación de maquinaria para la industria del papel y del cartón'),(2896,'2896','Fabricación de maquinaria para la industria del plástico y el caucho'),(2899,'2899','Fabricación de otra maquinaria para usos específicos n.c.o.p.'),(2910,'2910','Fabricación de vehículos de motor'),(2920,'2920','Fabricación de carrocerías para vehículos de motor'),(2931,'2931','Fabricación de equipos eléctricos y electrónicos para vehículos de motor'),(2932,'2932','Fabricación de otros componentes, piezas y accesorios para vehículos de motor'),(3011,'3011','Construcción de barcos y estructuras flotantes'),(3012,'3012','Construcción de embarcaciones de recreo y deporte'),(3020,'3020','Fabricación de locomotoras y material ferroviario'),(3030,'3030','Construcción aeronáutica y espacial y su maquinaria'),(3040,'3040','Fabricación de vehículos militares de combate'),(3091,'3091','Fabricación de motocicletas'),(3092,'3092','Fabricación de bicicletas y de vehículos para personas con discapacidad'),(3099,'3099','Fabricación de otro material de transporte n.c.o.p.'),(3101,'3101','Fabricación de muebles de oficina y de establecimientos comerciales'),(3102,'3102','Fabricación de muebles de cocina'),(3103,'3103','Fabricación de colchones'),(3109,'3109','Fabricación de otros muebles'),(3211,'3211','Fabricación de monedas'),(3212,'3212','Fabricación de artículos de joyería y artículos similares'),(3213,'3213','Fabricación de artículos de bisutería y artículos similares'),(3220,'3220','Fabricación de instrumentos musicales'),(3230,'3230','Fabricación de artículos de deporte'),(3240,'3240','Fabricación de juegos y juguetes'),(3250,'3250','Fabricación de instrumentos y suministros médicos y odontológicos'),(3291,'3291','Fabricación de escobas, brochas y cepillos'),(3299,'3299','Otras industrias manufactureras n.c.o.p.'),(3311,'3311','Reparación de productos metálicos'),(3312,'3312','Reparación de maquinaria'),(3313,'3313','Reparación de equipos electrónicos y ópticos'),(3314,'3314','Reparación de equipos eléctricos'),(3315,'3315','Reparación y mantenimiento naval'),(3316,'3316','Reparación y mantenimiento aeronáutico y espacial'),(3317,'3317','Reparación y mantenimiento de otro material de transporte'),(3319,'3319','Reparación de otros equipos'),(3320,'3320','Instalación de máquinas y equipos industriales'),(3512,'3512','Transporte de energía eléctrica'),(3513,'3513','Distribución de energía eléctrica'),(3514,'3514','Comercio de energía eléctrica'),(3515,'3515','Producción de energía hidroeléctrica'),(3516,'3516','Producción de energía eléctrica de origen térmico convencional'),(3517,'3517','Producción de energía eléctrica de origen nuclear'),(3518,'3518','Producción de energía eléctrica de origen eólico'),(3519,'3519','Producción de energía eléctrica de otros tipos'),(3521,'3521','Producción de gas'),(3522,'3522','Distribución por tubería de combustibles gaseosos'),(3523,'3523','Comercio de gas por tubería'),(3530,'3530','Suministro de vapor y aire acondicionado'),(3600,'3600','Captación, depuración y distribución de agua'),(3700,'3700','Recogida y tratamiento de aguas residuales'),(3811,'3811','Recogida de residuos no peligrosos'),(3812,'3812','Recogida de residuos peligrosos'),(3821,'3821','Tratamiento y eliminación de residuos no peligrosos'),(3822,'3822','Tratamiento y eliminación de residuos peligrosos'),(3831,'3831','Separación y clasificación de materiales'),(3832,'3832','Valorización de materiales ya clasificados'),(3900,'3900','Actividades de descontaminación y otros servicios de gestión de residuos'),(4110,'4110','Promoción inmobiliaria'),(4121,'4121','Construcción de edificios residenciales'),(4122,'4122','Construcción de edificios no residenciales'),(4211,'4211','Construcción de carreteras y autopistas'),(4212,'4212','Construcción de vías férreas de superficie y subterráneas'),(4213,'4213','Construcción de puentes y túneles'),(4221,'4221','Construcción de redes para fluidos'),(4222,'4222','Construcción de redes eléctricas y de telecomunicaciones'),(4291,'4291','Obras hidráulicas'),(4299,'4299','Construcción de otros proyectos de ingeniería civil n.c.o.p.'),(4311,'4311','Demolición'),(4312,'4312','Preparación de terrenos'),(4313,'4313','Perforaciones y sondeos'),(4321,'4321','Instalaciones eléctricas'),(4322,'4322','Fontanería, instalaciones de sistemas de calefacción y aire acondicionado'),(4329,'4329','Otras instalaciones en obras de construcción'),(4331,'4331','Revocamiento'),(4332,'4332','Instalación de carpintería'),(4333,'4333','Revestimiento de suelos y paredes'),(4334,'4334','Pintura y acristalamiento'),(4339,'4339','Otro acabado de edificios'),(4391,'4391','Construcción de cubiertas'),(4399,'4399','Otras actividades de construcción especializada n.c.o.p.'),(4511,'4511','Venta de automóviles y vehículos de motor ligeros'),(4519,'4519','Venta de otros vehículos de motor'),(4520,'4520','Mantenimiento y reparación de vehículos de motor'),(4531,'4531','Comercio al por mayor de repuestos y accesorios de vehículos de motor'),(4532,'4532','Comercio al por menor de repuestos y accesorios de vehículos de motor'),(4540,'4540','Venta, mantenimiento y reparación de motocicletas y de sus repuestos y accesorios'),(4611,'4611','Intermediarios del comercio de materias primas agrarias, animales vivos, materias primas textiles y productos semielaborados'),(4612,'4612','Intermediarios del comercio de combustibles, minerales, metales y productos químicos industriales'),(4613,'4613','Intermediarios del comercio de la madera y materiales de construcción'),(4614,'4614','Intermediarios del comercio de maquinaria, equipo industrial, embarcaciones y aeronaves'),(4615,'4615','Intermediarios del comercio de muebles, artículos para el hogar y ferretería'),(4616,'4616','Intermediarios del comercio de textiles, prendas de vestir, peletería, calzado y artículos de cuero'),(4617,'4617','Intermediarios del comercio de productos alimenticios, bebidas y tabaco'),(4618,'4618','Intermediarios del comercio especializados en la venta de otros productos especáficos'),(4619,'4619','Intermediarios del comercio de productos diversos'),(4621,'4621','Comercio al por mayor de cereales, tabaco en rama, simientes y alimentos para animales'),(4622,'4622','Comercio al por mayor de flores y plantas'),(4623,'4623','Comercio al por mayor de animales vivos'),(4624,'4624','Comercio al por mayor de cueros y pieles'),(4631,'4631','Comercio al por mayor de frutas y hortalizas'),(4632,'4632','Comercio al por mayor de carne y productos cárnicos'),(4633,'4633','Comercio al por mayor de productos lácteos, huevos, aceites y grasas comestibles'),(4634,'4634','Comercio al por mayor de bebidas'),(4635,'4635','Comercio al por mayor de productos del tabaco'),(4636,'4636','Comercio al por mayor de azúcar, chocolate y confitería'),(4637,'4637','Comercio al por mayor de café, té, cacao y especias'),(4638,'4638','Comercio al por mayor de pescados y mariscos y otros productos alimenticios'),(4639,'4639','Comercio al por mayor, no especializado, de productos alimenticios, bebidas y tabaco'),(4641,'4641','Comercio al por mayor de textiles'),(4642,'4642','Comercio al por mayor de prendas de vestir y calzado'),(4643,'4643','Comercio al por mayor de aparatos electrodomésticos'),(4644,'4644','Comercio al por mayor de porcelana, cristalería y artículos de limpieza'),(4645,'4645','Comercio al por mayor de productos perfumería y cosmética'),(4646,'4646','Comercio al por mayor de productos farmacéuticos'),(4647,'4647','Comercio al por mayor de muebles, alfombras y aparatos de iluminación'),(4648,'4648','Comercio al por mayor de artículos de relojería y joyería'),(4649,'4649','Comercio al por mayor de otros artículos de uso doméstico'),(4651,'4651','Comercio al por mayor de ordenadores, equipos periféricos y programas informáticos'),(4652,'4652','Comercio al por mayor de equipos electrónicos y de telecomunicaciones y sus componentes'),(4661,'4661','Comercio al por mayor de maquinaria, equipos y suministros agrícolas'),(4662,'4662','Comercio al por mayor de máquinas herramienta'),(4663,'4663','Comercio al por mayor de maquinaria para la minería, la construcción y la ingeniería civil'),(4664,'4664','Comercio al por mayor de maquinaria para la industria textil y de máquinas de coser y tricotar'),(4665,'4665','Comercio al por mayor de muebles de oficina'),(4666,'4666','Comercio al por mayor de otra maquinaria y equipo de oficina'),(4669,'4669','Comercio al por mayor de otra maquinaria y equipo'),(4671,'4671','Comercio al por mayor de combustibles sálidos, líquidos y gaseosos, y productos similares'),(4672,'4672','Comercio al por mayor de metales y minerales metálicos'),(4673,'4673','Comercio al por mayor de madera, materiales de construcción y aparatos sanitarios'),(4674,'4674','Comercio al por mayor de ferretería, fontanería y calefacción'),(4675,'4675','Comercio al por mayor de productos químicos'),(4676,'4676','Comercio al por mayor de otros productos semielaborados'),(4677,'4677','Comercio al por mayor de chatarra y productos de desecho'),(4690,'4690','Comercio al por mayor no especializado'),(4711,'4711','Comercio al por menor en establecimientos no especializados, con predominio en productos alimenticios, bebidas y tabaco'),(4719,'4719','Otro comercio al por menor en establecimientos no especializados'),(4721,'4721','Comercio al por menor de frutas y hortalizas en establecimientos especializados'),(4722,'4722','Comercio al por menor de carne y productos cárnicos en establecimientos especializados'),(4723,'4723','Comercio al por menor de pescados y mariscos en establecimientos especializados'),(4724,'4724','Comercio al por menor de pan y productos de panadería, confitería y pastelería en establecimientos especializados'),(4725,'4725','Comercio al por menor de bebidas en establecimientos especializados'),(4726,'4726','Comercio al por menor de productos de tabaco en establecimientos especializados'),(4729,'4729','Otro comercio al por menor de productos alimenticios en establecimientos especializados'),(4730,'4730','Comercio al por menor de combustible para la automoción en establecimientos especializados'),(4741,'4741','Comercio al por menor de ordenadores, equipos periféricos y programas informáticos en establecimientos especializados'),(4742,'4742','Comercio al por menor de equipos de telecomunicaciones en establecimientos especializados'),(4743,'4743','Comercio al por menor de equipos de audio y vídeo en establecimientos especializados'),(4751,'4751','Comercio al por menor de textiles en establecimientos especializados'),(4752,'4752','Comercio al por menor de ferretería, pintura y vidrio en establecimientos especializados'),(4753,'4753','Comercio al por menor de alfombras, moquetas y revestimientos de paredes y suelos en establecimientos especializados'),(4754,'4754','Comercio al por menor de aparatos electrodomésticos en establecimientos especializados'),(4759,'4759','Comercio al por menor de muebles, aparatos de iluminación y otros artículos de uso doméstico en establecimientos especializados'),(4761,'4761','Comercio al por menor de libros en establecimientos especializados'),(4762,'4762','Comercio al por menor de periódicos y artículos de papelería en establecimientos especializados'),(4763,'4763','Comercio al por menor de grabaciones de música y vídeo en establecimientos especializados'),(4764,'4764','Comercio al por menor de artículos deportivos en establecimientos especializados'),(4765,'4765','Comercio al por menor de juegos y juguetes en establecimientos especializados'),(4771,'4771','Comercio al por menor de prendas de vestir en establecimientos especializados'),(4772,'4772','Comercio al por menor de calzado y artículos de cuero en establecimientos especializados'),(4773,'4773','Comercio al por menor de productos farmacéuticos en establecimientos especializados'),(4774,'4774','Comercio al por menor de artículos médicos y ortopédicos en establecimientos especializados'),(4775,'4775','Comercio al por menor de productos cosméticos e higiénicos en establecimientos especializados'),(4776,'4776','Comercio al por menor de flores, plantas, semillas, fertilizantes, animales de compañía y alimentos para los mismos en establecimientos especializados'),(4777,'4777','Comercio al por menor de artículos de relojería y joyería en establecimientos especializados'),(4778,'4778','Otro comercio al por menor de artículos nuevos en establecimientos especializados'),(4779,'4779','Comercio al por menor de artículos de segunda mano en establecimientos'),(4781,'4781','Comercio al por menor de productos alimenticios, bebidas y tabaco en puestos de venta y en mercadillos'),(4782,'4782','Comercio al por menor de productos textiles, prendas de vestir y calzado en puestos de venta y en mercadillos'),(4789,'4789','Comercio al por menor de otros productos en puestos de venta y en mercadillos'),(4791,'4791','Comercio al por menor por correspondencia o Internet'),(4799,'4799','Otro comercio al por menor no realizado ni en establecimientos, ni en puestos de venta ni en mercadillos'),(4910,'4910','Transporte interurbano de pasajeros por ferrocarril'),(4920,'4920','Transporte de mercancías por ferrocarril'),(4931,'4931','Transporte terrestre urbano y suburbano de pasajeros'),(4932,'4932','Transporte por taxi'),(4939,'4939','tipos de transporte terrestre de pasajeros n.c.o.p.'),(4941,'4941','Transporte de mercancías por carretera'),(4942,'4942','Servicios de mudanza'),(4950,'4950','Transporte por tubería'),(5010,'5010','Transporte marítimo de pasajeros'),(5020,'5020','Transporte marítimo de mercancías'),(5030,'5030','Transporte de pasajeros por vías navegables interiores'),(5040,'5040','Transporte de mercancías por vías navegables interiores'),(5110,'5110','Transporte aéreo de pasajeros'),(5121,'5121','Transporte aéreo de mercancías'),(5122,'5122','Transporte espacial'),(5210,'5210','Depísito y almacenamiento'),(5221,'5221','Actividades anexas al transporte terrestre'),(5222,'5222','Actividades anexas al transporte marítimo y por vías navegables interiores'),(5223,'5223','Actividades anexas al transporte aéreo'),(5224,'5224','Manipulación de mercancías'),(5229,'5229','Otras actividades anexas al transporte'),(5310,'5310','Actividades postales sometidas a la obligación del servicio universal'),(5320,'5320','Otras actividades postales y de correos'),(5510,'5510','Hoteles y alojamientos similares'),(5520,'5520','Alojamientos turísticos y otros alojamientos de corta estancia'),(5530,'5530','Campings y aparcamientos para caravanas'),(5590,'5590','Otros alojamientos'),(5610,'5610','Restaurantes y puestos de comidas'),(5621,'5621','Provisión de comidas preparadas para eventos'),(5629,'5629','Otros servicios de comidas'),(5630,'5630','Establecimientos de bebidas'),(5811,'5811','Edición de libros'),(5812,'5812','Edición de directorios y guías de direcciones postales'),(5813,'5813','Edición de periódicos'),(5814,'5814','Edición de revistas'),(5819,'5819','Otras actividades editoriales'),(5821,'5821','Edición de videojuegos'),(5829,'5829','Edición de otros programas informáticos'),(5912,'5912','Actividades de postproducción cinematográfica, de vídeo y de programas de televisión'),(5914,'5914','Actividades de exhibición cinematográfica'),(5915,'5915','Actividades de producción cinematográfica y de vídeo'),(5916,'5916','Actividades de producciones de programas de televisión'),(5917,'5917','Actividades de distribución cinematográfica y de vídeo'),(5918,'5918','Actividades de distribución de programas de televisión'),(5920,'5920','Actividades de grabación de sonido y edición musical'),(6010,'6010','Actividades de radiodifusión'),(6020,'6020','Actividades de programación y emisión de televisión'),(6110,'6110','Telecomunicaciones por cable'),(6120,'6120','Telecomunicaciones inalámbricas'),(6130,'6130','Telecomunicaciones por satélite'),(6190,'6190','Otras actividades de telecomunicaciones'),(6201,'6201','Actividades de programación informática'),(6202,'6202','Actividades de consultoría informática'),(6203,'6203','Gestión de recursos informáticos'),(6209,'6209','Otros servicios relacionados con las tecnologías de la información y la informática'),(6311,'6311','Proceso de datos, hosting y actividades relacionadas'),(6312,'6312','Portales web'),(6391,'6391','Actividades de las agencias de noticias'),(6399,'6399','Otros servicios de información n.c.o.p.'),(6411,'6411','Banco central'),(6419,'6419','Otra intermediación monetaria'),(6420,'6420','Actividades de las sociedades holding'),(6430,'6430','Inversión colectiva, fondos y entidades financieras similares'),(6491,'6491','Arrendamiento financiero'),(6492,'6492','Otras actividades crediticias'),(6499,'6499','Otros servicios financieros, excepto seguros y fondos de pensiones n.c.o.p.'),(6511,'6511','Seguros de vida'),(6512,'6512','Seguros distintos de los seguros de vida'),(6520,'6520','Reaseguros'),(6530,'6530','Fondos de pensiones'),(6611,'6611','Administración de mercados financieros'),(6612,'6612','Actividades de intermediación en operaciones con valores y otros activos'),(6619,'6619','Otras actividades auxiliares a los servicios financieros, excepto seguros y fondos de pensiones'),(6621,'6621','Evaluación de riesgos y daños'),(6622,'6622','Actividades de agentes y corredores de seguros'),(6629,'6629','Otras actividades auxiliares a seguros y fondos de pensiones'),(6630,'6630','Actividades de gestión de fondos'),(6810,'6810','Compraventa de bienes inmobiliarios por cuenta propia'),(6820,'6820','Alquiler de bienes inmobiliarios por cuenta propia'),(6831,'6831','Agentes de la propiedad inmobiliaria'),(6832,'6832','Gestión y administración de la propiedad inmobiliaria'),(6910,'6910','Actividades jurídicas'),(6920,'6920','Actividades de contabilidad, teneduría de libros, auditoría y asesoría fiscal'),(7010,'7010','Actividades de las sedes centrales'),(7021,'7021','Relaciones públicas y comunicación'),(7022,'7022','Otras actividades de consultoría de gestión empresarial'),(7111,'7111','Servicios técnicos de arquitectura'),(7112,'7112','Servicios técnicos de ingeniería y otras actividades relacionadas con el asesoramiento técnico'),(7120,'7120','Ensayos y análisis técnicos'),(7211,'7211','Investigación y desarrollo experimental en biotecnología'),(7219,'7219','Otra investigación y desarrollo experimental en ciencias naturales y técnicas'),(7220,'7220','Investigación y desarrollo experimental en ciencias sociales y humanidades'),(7311,'7311','Agencias de publicidad'),(7312,'7312','Servicios de representación de medios de comunicación'),(7320,'7320','Estudio de mercado y realización de encuestas de opinión pública'),(7410,'7410','Actividades de diseño especializado'),(7420,'7420','Actividades de fotografía'),(7430,'7430','Actividades de traducción e interpretación'),(7490,'7490','Otras actividades profesionales, científicas y técnicas n.c.o.p.'),(7500,'7500','Actividades veterinarias'),(7711,'7711','Alquiler de automóviles y vehículos de motor ligeros'),(7712,'7712','Alquiler de camiones'),(7721,'7721','Alquiler de artículos de ocio y deportivos'),(7722,'7722','Alquiler de cintas de vídeo y discos'),(7729,'7729','Alquiler de otros efectos personales y artículos de uso doméstico'),(7731,'7731','Alquiler de maquinaria y equipo de uso agrícola'),(7732,'7732','Alquiler de maquinaria y equipo para la construcción e ingeniería civil'),(7733,'7733','Alquiler de maquinaria y equipo de oficina, incluidos ordenadores'),(7734,'7734','Alquiler de medios de navegación'),(7735,'7735','Alquiler de medios de transporte aéreo'),(7739,'7739','Alquiler de otra maquinaria, equipos y bienes tangibles n.c.o.p.'),(7740,'7740','Arrendamiento de la propiedad intelectual y productos similares, excepto trabajos protegidos por los derechos de autor'),(7810,'7810','Actividades de las agencias de colocación'),(7820,'7820','Actividades de las empresas de trabajo temporal'),(7830,'7830','Otra provisión de recursos humanos'),(7911,'7911','Actividades de las agencias de viajes'),(7912,'7912','Actividades de los operadores turísticos'),(7990,'7990','Otros servicios de reservas y actividades relacionadas con los mismos'),(8010,'8010','Actividades de seguridad privada'),(8020,'8020','Servicios de sistemas de seguridad'),(8030,'8030','Actividades de investigación'),(8110,'8110','Servicios integrales a edificios e instalaciones'),(8121,'8121','Limpieza general de edificios'),(8122,'8122','Otras actividades de limpieza industrial y de edificios'),(8129,'8129','Otras actividades de limpieza'),(8130,'8130','Actividades de jardinería'),(8211,'8211','Servicios administrativos combinados'),(8219,'8219','Actividades de fotocopiado, preparación de documentos y otras actividades especializadas de oficina'),(8220,'8220','Actividades de los centros de llamadas'),(8230,'8230','Organización de convenciones y ferias de muestras'),(8291,'8291','Actividades de las agencias de cobros y de información comercial'),(8292,'8292','Actividades de envasado y empaquetado'),(8299,'8299','Otras actividades de apoyo a las empresas n.c.o.p.'),(8411,'8411','Actividades generales de la Administración Pública'),(8412,'8412','Regulación de las actividades sanitarias, educativas y culturales y otros servicios sociales, excepto Seguridad Social'),(8413,'8413','Regulación de la actividad económica y contribución a su mayor eficiencia'),(8421,'8421','Asuntos exteriores'),(8422,'8422','Defensa'),(8423,'8423','Justicia'),(8424,'8424','Orden público y seguridad'),(8425,'8425','Protección civil'),(8430,'8430','Seguridad Social obligatoria'),(8510,'8510','Educación preprimaria'),(8520,'8520','Educación primaria'),(8531,'8531','Educación secundaria general'),(8532,'8532','Educación secundaria técnica y profesional'),(8541,'8541','Educación postsecundaria no terciaria'),(8543,'8543','Educación universitaria'),(8544,'8544','Educación terciaria no universitaria'),(8551,'8551','Educación deportiva y recreativa'),(8552,'8552','Educación cultural'),(8553,'8553','Actividades de las escuelas de conducción y pilotaje'),(8559,'8559','Otra educación n.c.o.p.'),(8560,'8560','Actividades auxiliares a la educación'),(8610,'8610','Actividades hospitalarias'),(8621,'8621','Actividades de medicina general'),(8622,'8622','Actividades de medicina especializada'),(8623,'8623','Actividades odontológicas'),(8690,'8690','Otras actividades sanitarias'),(8710,'8710','Asistencia en establecimientos residenciales con cuidados sanitarios'),(8720,'8720','Asistencia en establecimientos residenciales para personas con discapacidad intelectual, enfermedad mental y drogodependencia'),(8731,'8731','Asistencia en establecimientos residenciales para personas mayores'),(8732,'8732','Asistencia en establecimientos residenciales para personas con discapacidad física'),(8790,'8790','Otras actividades de asistencia en establecimientos residenciales'),(8811,'8811','Actividades de servicios sociales sin alojamiento para personas mayores'),(8812,'8812','Actividades de servicios sociales sin alojamiento para personas con discapacidad'),(8891,'8891','Actividades de cuidado diurno de niños'),(8899,'8899','Otros actividades de servicios sociales sin alojamiento n.c.o.p.'),(9001,'9001','Artes escénicas'),(9002,'9002','Actividades auxiliares a las artes escénicas'),(9003,'9003','Creación artística y literaria'),(9004,'9004','Gestión de salas de espectáculos'),(9102,'9102','Actividades de museos'),(9103,'9103','Gestión de lugares y edificios históricos'),(9104,'9104','Actividades de los jardines botánicos, parques zoológicos y reservas naturales'),(9105,'9105','Actividades de bibliotecas'),(9106,'9106','Actividades de archivos'),(9200,'9200','Actividades de juegos de azar y apuestas'),(9311,'9311','Gestión de instalaciones deportivas'),(9312,'9312','Actividades de los clubes deportivos'),(9313,'9313','Actividades de los gimnasios'),(9319,'9319','Otras actividades deportivas'),(9321,'9321','Actividades de los parques de atracciones y los parques temáticos'),(9329,'9329','Otras actividades recreativas y de entretenimiento'),(9411,'9411','Actividades de organizaciones empresariales y patronales'),(9412,'9412','Actividades de organizaciones profesionales'),(9420,'9420','Actividades sindicales'),(9491,'9491','Actividades de organizaciones religiosas'),(9492,'9492','Actividades de organizaciones políticas'),(9499,'9499','Otras actividades asociativas n.c.o.p.'),(9511,'9511','Reparación de ordenadores y equipos periféricos'),(9512,'9512','Reparación de equipos de comunicación'),(9521,'9521','Reparación de aparatos electrónicos de audio y vídeo de uso doméstico'),(9522,'9522','Reparación de aparatos electrodomésticos y de equipos para el hogar y el jardón'),(9523,'9523','Reparación de calzado y artículos de cuero'),(9524,'9524','Reparación de muebles y artículos de menaje'),(9525,'9525','Reparación de relojes y joyería'),(9529,'9529','Reparación de otros efectos personales y artículos de uso doméstico'),(9601,'9601','Lavado y limpieza de prendas textiles y de piel'),(9602,'9602','Peluquería y otros tratamientos de belleza'),(9603,'9603','Pompas fúnebres y actividades relacionadas'),(9604,'9604','Actividades de mantenimiento físico'),(9609,'9609','Otras servicios personales n.c.o.p.'),(9700,'9700','Actividades de los hogares como empleadores de personal doméstico'),(9810,'9810','Actividades de los hogares como productores de bienes para uso propio'),(9820,'9820','Actividades de los hogares como productores de servicios para uso propio'),(9900,'9900','Actividades de organizaciones y organismos extraterritoriales');
/*!40000 ALTER TABLE `cnae` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cnae2009`
--

DROP TABLE IF EXISTS `cnae2009`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cnae2009` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `code` varchar(4) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Codigo del CNAE',
  `title` varchar(255) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Titulo del CNAE',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=10000991 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='CNAE 2009. Clasificación Nacional de Actividades Económicas ';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cnae2009`
--

LOCK TABLES `cnae2009` WRITE;
/*!40000 ALTER TABLE `cnae2009` DISABLE KEYS */;
INSERT INTO `cnae2009` VALUES (10,'10','Industria de la alimentación'),(11,'11','Fabricación de bebidas'),(12,'12','Industria del tabaco'),(13,'13','Industria textil'),(14,'14','Confección de prendas de vestir'),(15,'15','Industria del cuero y del calzado'),(16,'16','Industria de la madera y del corcho, excepto muebles: cestería y espartería'),(17,'17','Industria del papel'),(18,'18','Artes gráficas y reproducción de soportes grabados'),(19,'19','Coquerías y refino de petróleo'),(20,'20','Industria química'),(21,'21','Fabricación de productos farmacéuticos'),(22,'22','Fabricación de productos de caucho y plásticos'),(23,'23','Fabricación de otros productos minerales no metálicos'),(24,'24','Metalurgia: fabricación de productos de hierro, acero y ferroaleaciones'),(25,'25','Fabricación de productos metálicos, excepto maquinaria y equipo'),(26,'26','Fabricación de productos informáticos, electrónicos y ópticos'),(27,'27','Fabricación de material y equipo eléctrico'),(28,'28','Fabricación de maquinaria y equipo n.c.o.p.'),(29,'29','Fabricación de vehículos de motor, remolques y semirremolques'),(30,'30','Fabricación de otro material de transporte'),(31,'31','Fabricación de muebles'),(32,'32','Otras industrias manufactureras'),(33,'33','Reparación e instalación de maquinaria y equipo'),(35,'35','Suministro de energía eléctrica, gas, vapor y aire acondicionado'),(36,'36','Captación, depuración y distribución de agua'),(37,'37','Recogida y tratamiento de aguas residuales'),(38,'38','Recogida, tratamiento y eliminación de residuos: valorización'),(39,'39','Actividades de descontaminación y otros servicios de gestión de residuos'),(41,'41','Construcción de edificios'),(42,'42','Ingeniería civil'),(43,'43','Actividades de construcción especializada'),(45,'45','Venta y reparación de vehículos de motor y motocicletas'),(46,'46','Comercio al por mayor e intermediarios del comercio, excepto de vehículos de motor y motocicletas'),(47,'47','Comercio al por menor, excepto de vehículos de motor y motocicletas'),(49,'49','Transporte terrestre y por tubería'),(50,'50','Transporte marítimo y por vías navegables interiores'),(51,'51','Transporte aéreo'),(52,'52','Almacenamiento y actividades anexas al transporte'),(53,'53','Actividades postales y de correos'),(55,'55','Servicios de alojamiento'),(56,'56','Servicios de comidas y bebidas'),(58,'58','Edición'),(59,'59','Actividades cinematográficas, de vídeo y de programas de televisión, grabación de sonido y edición musical'),(60,'60','Actividades de programación y emisión de radio y televisión'),(61,'61','Telecomunicaciones'),(62,'62','Programación, consultoría y otras actividades relacionadas con la informática'),(63,'63','Servicios de información'),(64,'64','Servicios financieros, excepto seguros y fondos de pensiones'),(65,'65','Seguros, reaseguros y fondos de pensiones, excepto Seguridad Social obligatoria'),(66,'66','Actividades auxiliares a los servicios financieros y a los seguros'),(68,'68','Actividades inmobiliarias'),(69,'69','Actividades jurídicas y de contabilidad'),(70,'70','Actividades de las sedes centrales: actividades de consultoría de gestión empresarial'),(71,'71','Servicios técnicos de arquitectura e ingeniería: ensayos y análisis técnicos'),(72,'72','Investigación y desarrollo'),(73,'73','Publicidad y estudios de mercado'),(74,'74','Otras actividades profesionales, científicas y técnicas'),(75,'75','Actividades veterinarias'),(77,'77','Actividades de alquiler'),(78,'78','Actividades relacionadas con el empleo'),(79,'79','Actividades de agencias de viajes, operadores turísticos, servicios de reservas y actividades relacionadas con los mismos'),(80,'80','Actividades de seguridad e investigación'),(81,'81','Servicios a edificios y actividades de jardinería'),(82,'82','Actividades administrativas de oficina y otras actividades auxiliares a las empresas'),(84,'84','Administración Pública y defensa: Seguridad Social obligatoria'),(85,'85','Educación'),(86,'86','Actividades sanitarias'),(87,'87','Asistencia en establecimientos residenciales'),(88,'88','Actividades de servicios sociales sin alojamiento'),(90,'90','Actividades de creación, artísticas y espectáculos'),(91,'91','Actividades de bibliotecas, archivos, museos y otras actividades culturales'),(92,'92','Actividades de juegos de azar y apuestas'),(93,'93','Actividades deportivas, recreativas y de entretenimiento'),(94,'94','Actividades asociativas'),(95,'95','Reparación de ordenadores, efectos personales y artículos de uso doméstico'),(96,'96','Otros servicios personales'),(97,'97','Actividades de los hogares como empleadores de personal doméstico'),(98,'98','Actividades de los hogares como productores de bienes y servicios para uso propio'),(99,'99','Actividades de organizaciones y organismos extraterritoriales'),(101,'101','Procesado y conservación de carne y elaboración de productos cárnicos'),(102,'102','Procesado y conservación de pescados, crustáceos y moluscos'),(103,'103','Procesado y conservación de frutas y hortalizas'),(104,'104','Fabricación de aceites y grasas vegetales y animales'),(105,'105','Fabricación de productos lácteos'),(106,'106','Fabricación de productos de molinería, almidones y productos amiláceos'),(107,'107','Fabricación de productos de panadería y pastas alimenticias'),(108,'108','Fabricación de otros productos alimenticios'),(109,'109','Fabricación de productos para la alimentación animal'),(110,'110','Fabricación de bebidas'),(120,'120','Industria del tabaco'),(131,'131','Preparación e hilado de fibras textiles'),(132,'132','Fabricación de tejidos textiles'),(133,'133','Acabado de textiles'),(139,'139','Fabricación de otros productos textiles'),(141,'141','Confección de prendas de vestir, excepto de peletería'),(142,'142','Fabricación de artículos de peletería'),(143,'143','Confección de prendas de vestir de punto'),(151,'151','Preparación, curtido y acabado del cuero: fabricación de artículos de marroquinería, viaje y de guarnicionería y talabartería: preparación y teñido de pieles'),(152,'152','Fabricación de calzado'),(161,'161','Aserrado y cepillado de la madera'),(162,'162','Fabricación de productos de madera, corcho, cestería y espartería'),(171,'171','Fabricación de pasta papelera, papel y cartón'),(172,'172','Fabricación de artículos de papel y de cartón'),(181,'181','Artes gráficas y servicios relacionados con las mismas'),(182,'182','Reproducción de soportes grabados'),(191,'191','Coquerías'),(192,'192','Refino de petróleo'),(201,'201','Fabricación de productos químicos básicos, compuestos nitrogenados, fertilizantes, plásticos y caucho sintético en formas primarias'),(202,'202','Fabricación de pesticidas y otros productos agroquímicos'),(203,'203','Fabricación de pinturas, barnices y revestimientos similares: tintas de imprenta y masillas'),(204,'204','Fabricación de jabones, detergentes y otros artículos de limpieza y abrillantamiento: fabricación de perfumes y cosméticos'),(205,'205','Fabricación de otros productos químicos'),(206,'206','Fabricación de fibras artificiales y sintéticas'),(211,'211','Fabricación de productos farmacéuticos de base'),(212,'212','Fabricación de especialidades farmacéuticas'),(221,'221','Fabricación de productos de caucho'),(222,'222','Fabricación de productos de plástico'),(231,'231','Fabricación de vidrio y productos de vidrio'),(232,'232','Fabricación de productos cerámicos refractarios'),(233,'233','Fabricación de productos cerámicos para la construcción'),(234,'234','Fabricación de otros productos cerámicos'),(235,'235','Fabricación de cemento, cal y yeso'),(236,'236','Fabricación de elementos de hormigón, cemento y yeso'),(237,'237','Corte, tallado y acabado de la piedra'),(239,'239','Fabricación de productos abrasivos y productos minerales no metálicos n.c.o.p.'),(241,'241','Fabricación de productos básicos de hierro, acero y ferroaleaciones'),(242,'242','Fabricación de tubos, tuberías, perfiles huecos y sus accesorios, de acero'),(243,'243','Fabricación de otros productos de primera transformación del acero'),(244,'244','Producción de metales preciosos y de otros metales no férreos'),(245,'245','Fundición de metales'),(251,'251','Fabricación de elementos metálicos para la construcción'),(252,'252','Fabricación de cisternas, grandes depísitos y contenedores de metal'),(253,'253','Fabricación de generadores de vapor, excepto calderas de calefacción central'),(254,'254','Fabricación de armas y municiones'),(255,'255','Forja, estampación y embutición de metales: metalurgia de polvos'),(256,'256','Tratamiento y revestimiento de metales: ingeniería mecánica por cuenta de terceros'),(257,'257','Fabricación de artículos de cuchillería y cubertería, herramientas y ferretería'),(259,'259','Fabricación de otros productos metálicos'),(261,'261','Fabricación de componentes electrónicos y circuitos impresos ensamblados'),(262,'262','Fabricación de ordenadores y equipos periféricos'),(263,'263','Fabricación de equipos de telecomunicaciones'),(264,'264','Fabricación de productos electrónicos de consumo'),(265,'265','Fabricación de instrumentos y aparatos de medida, verificación y navegación: fabricación de relojes'),(266,'266','Fabricación de equipos de radiación, electromédicos y electroterapéuticos'),(267,'267','Fabricación de instrumentos de óptica y equipo fotográfico'),(268,'268','Fabricación de soportes magnéticos y ópticos'),(271,'271','Fabricación de motores, generadores y transformadores eléctricos, y de aparatos de distribución y control eléctrico'),(272,'272','Fabricación de pilas y acumuladores eléctricos'),(273,'273','Fabricación de cables y dispositivos de cableado'),(274,'274','Fabricación de lámparas y aparatos eléctricos de iluminación'),(275,'275','Fabricación de aparatos domésticos'),(279,'279','Fabricación de otro material y equipo eléctrico'),(281,'281','Fabricación de maquinaria de uso general'),(282,'282','Fabricación de otra maquinaria de uso general'),(283,'283','Fabricación de maquinaria agraria y forestal'),(284,'284','Fabricación de máquinas herramienta para trabajar el metal y otras máquinas herramienta'),(289,'289','Fabricación de otra maquinaria para usos específicos'),(291,'291','Fabricación de vehículos de motor'),(292,'292','Fabricación de carrocerías para vehículos de motor: fabricación de remolques y semirremolques'),(293,'293','Fabricación de componentes, piezas y accesorios para vehículos de motor'),(301,'301','Construcción naval'),(302,'302','Fabricación de locomotoras y material ferroviario'),(303,'303','Construcción aeronáutica y espacial y su maquinaria'),(304,'304','Fabricación de vehículos militares de combate'),(309,'309','Fabricación de otro material de transporte n.c.o.p.'),(310,'310','Fabricación de muebles'),(321,'321','Fabricación de artículos de joyería, bisutería y similares'),(322,'322','Fabricación de instrumentos musicales'),(323,'323','Fabricación de artículos de deporte'),(324,'324','Fabricación de juegos y juguetes'),(325,'325','Fabricación de instrumentos y suministros médicos y odontológicos'),(329,'329','Industrias manufactureras n.c.o.p.'),(331,'331','Reparación de productos metálicos, maquinaria y equipo'),(332,'332','Instalación de máquinas y equipos industriales'),(351,'351','Producción, transporte y distribución de energía eléctrica'),(352,'352','Producción de gas: distribución por tubería de combustibles gaseosos'),(353,'353','Suministro de vapor y aire acondicionado'),(360,'360','Captación, depuración y distribución de agua'),(370,'370','Recogida y tratamiento de aguas residuales'),(381,'381','Recogida de residuos'),(382,'382','Tratamiento y eliminación de residuos'),(383,'383','Valorización'),(390,'390','Actividades de descontaminación y otros servicios de gestión de residuos'),(411,'411','Promoción inmobiliaria'),(412,'412','Construcción de edificios'),(421,'421','Construcción de carreteras y vías férreas, puentes y túneles'),(422,'422','Construcción de redes'),(429,'429','Construcción de otros proyectos de ingeniería civil'),(431,'431','Demolición y preparación de terrenos'),(432,'432','Instalaciones eléctricas, de fontanería y otras instalaciones en obras de construcción'),(433,'433','Acabado de edificios'),(439,'439','Otras actividades de construcción especializada'),(451,'451','Venta de vehículos de motor'),(452,'452','Mantenimiento y reparación de vehículos de motor'),(453,'453','Comercio de repuestos y accesorios de vehículos de motor'),(454,'454','Venta, mantenimiento y reparación de motocicletas y de sus repuestos y accesorios'),(461,'461','Intermediarios del comercio'),(462,'462','Comercio al por mayor de materias primas agrarias y de animales vivos'),(463,'463','Comercio al por mayor de productos alimenticios, bebidas y tabaco'),(464,'464','Comercio al por mayor de artículos de uso doméstico'),(465,'465','Comercio al por mayor de equipos para las tecnologías de la información y las comunicaciones'),(466,'466','Comercio al por mayor de otra maquinaria, equipos y suministros'),(467,'467','Otro comercio al por mayor especializado'),(469,'469','Comercio al por mayor no especializado'),(471,'471','Comercio al por menor en establecimientos no especializados'),(472,'472','Comercio al por menor de productos alimenticios, bebidas y tabaco en establecimientos especializados'),(473,'473','Comercio al por menor de combustible para la automoción en establecimientos especializados'),(474,'474','Comercio al por menor de equipos para las tecnologías de la información y las comunicaciones en establecimientos especializados'),(475,'475','Comercio al por menor de otros artículos de uso doméstico en establecimientos especializados'),(476,'476','Comercio al por menor de artículos culturales y recreativos en establecimientos especializados'),(477,'477','Comercio al por menor de otros artículos en establecimientos especializados'),(478,'478','Comercio al por menor en puestos de venta y en mercadillos'),(479,'479','Comercio al por menor no realizado ni en establecimientos, ni en puestos de venta ni en mercadillos'),(491,'491','Transporte interurbano de pasajeros por ferrocarril'),(492,'492','Transporte de mercancías por ferrocarril'),(493,'493','Otro transporte terrestre de pasajeros'),(494,'494','Transporte de mercancías por carretera y servicios de mudanza'),(495,'495','Transporte por tubería'),(501,'501','Transporte marítimo de pasajeros'),(502,'502','Transporte marítimo de mercancías'),(503,'503','Transporte de pasajeros por vías navegables interiores'),(504,'504','Transporte de mercancías por vías navegables interiores'),(511,'511','Transporte aéreo de pasajeros'),(512,'512','Transporte aéreo de mercancías y transporte espacial'),(521,'521','Depísito y almacenamiento'),(522,'522','Actividades anexas al transporte'),(531,'531','Actividades postales sometidas a la obligación del servicio universal'),(532,'532','Otras actividades postales y de correos'),(551,'551','Hoteles y alojamientos similares'),(552,'552','Alojamientos turísticos y otros alojamientos de corta estancia'),(553,'553','Campings y aparcamientos para caravanas'),(559,'559','Otros alojamientos'),(561,'561','Restaurantes y puestos de comidas'),(562,'562','Provisión de comidas preparadas para eventos y otros servicios de comidas'),(563,'563','Establecimientos de bebidas'),(581,'581','Edición de libros, periódicos y otras actividades editoriales'),(582,'582','Edición de programas informáticos'),(591,'591','Actividades cinematográficas, de vídeo y de programas de televisión'),(592,'592','Actividades de grabación de sonido y edición musical'),(601,'601','Actividades de radiodifusión'),(602,'602','Actividades de programación y emisión de televisión'),(611,'611','Telecomunicaciones por cable'),(612,'612','Telecomunicaciones inalámbricas'),(613,'613','Telecomunicaciones por satélite'),(619,'619','Otras actividades de telecomunicaciones'),(620,'620','Programación, consultoría y otras actividades relacionadas con la informática'),(631,'631','Proceso de datos, hosting y actividades relacionadas: portales web'),(639,'639','Otros servicios de información'),(641,'641','Intermediación monetaria'),(642,'642','Actividades de las sociedades holding'),(643,'643','Inversión colectiva, fondos y entidades financieras similares'),(649,'649','Otros servicios financieros, excepto seguros y fondos de pensiones'),(651,'651','Seguros'),(652,'652','Reaseguros'),(653,'653','Fondos de pensiones'),(661,'661','Actividades auxiliares a los servicios financieros, excepto seguros y fondos de pensiones'),(662,'662','Actividades auxiliares a seguros y fondos de pensiones'),(663,'663','Actividades de gestión de fondos'),(681,'681','Compraventa de bienes inmobiliarios por cuenta propia'),(682,'682','Alquiler de bienes inmobiliarios por cuenta propia'),(683,'683','Actividades inmobiliarias por cuenta de terceros'),(691,'691','Actividades jurídicas'),(692,'692','Actividades de contabilidad, teneduría de libros, auditoría y asesoría fiscal'),(701,'701','Actividades de las sedes centrales'),(702,'702','Actividades de consultoría de gestión empresarial'),(711,'711','Servicios técnicos de arquitectura e ingeniería y otras actividades relacionadas con el asesoramiento técnico'),(712,'712','Ensayos y análisis técnicos'),(721,'721','Investigación y desarrollo experimental en ciencias naturales y técnicas'),(722,'722','Investigación y desarrollo experimental en ciencias sociales y humanidades'),(731,'731','Publicidad'),(732,'732','Estudio de mercado y realización de encuestas de opinión pública'),(741,'741','Actividades de diseño especializado'),(742,'742','Actividades de fotografía'),(743,'743','Actividades de traducción e interpretación'),(749,'749','Otras actividades profesionales, científicas y técnicas n.c.o.p.'),(750,'750','Actividades veterinarias'),(771,'771','Alquiler de vehículos de motor'),(772,'772','Alquiler de efectos personales y artículos de uso doméstico'),(773,'773','Alquiler de otra maquinaria, equipos y bienes tangibles'),(774,'774','Arrendamiento de la propiedad intelectual y productos similares, excepto trabajos protegidos por los derechos de autor'),(781,'781','Actividades de las agencias de colocación'),(782,'782','Actividades de las empresas de trabajo temporal'),(783,'783','Otra provisión de recursos humanos'),(791,'791','Actividades de agencias de viajes y operadores turísticos'),(799,'799','Otros servicios de reservas y actividades relacionadas con los mismos'),(801,'801','Actividades de seguridad privada'),(802,'802','Servicios de sistemas de seguridad'),(803,'803','Actividades de investigación'),(811,'811','Servicios integrales a edificios e instalaciones'),(812,'812','Actividades de limpieza'),(813,'813','Actividades de jardinería'),(821,'821','Actividades administrativas y auxiliares de oficina'),(822,'822','Actividades de los centros de llamadas'),(823,'823','Organización de convenciones y ferias de muestras'),(829,'829','Actividades de apoyo a las empresas n.c.o.p.'),(841,'841','Administración Pública y de la política económica y social'),(842,'842','Prestación de servicios a la comunidad en general'),(843,'843','Seguridad Social obligatoria'),(851,'851','Educación preprimaria'),(852,'852','Educación primaria'),(853,'853','Educación secundaria'),(854,'854','Educación postsecundaria'),(855,'855','Otra educación'),(856,'856','Actividades auxiliares a la educación'),(861,'861','Actividades hospitalarias'),(862,'862','Actividades médicas y odontológicas'),(869,'869','Otras actividades sanitarias'),(871,'871','Asistencia en establecimientos residenciales con cuidados sanitarios'),(872,'872','Asistencia en establecimientos residenciales para personas con discapacidad intelectual, enfermedad mental y drogodependencia'),(873,'873','Asistencia en establecimientos residenciales para personas mayores y con discapacidad física'),(879,'879','Otras actividades de asistencia en establecimientos residenciales'),(881,'881','Actividades de servicios sociales sin alojamiento para personas mayores y con discapacidad'),(889,'889','Otros actividades de servicios sociales sin alojamiento'),(900,'900','Actividades de creación, artísticas y espectáculos'),(910,'910','Actividades de bibliotecas, archivos, museos y otras actividades culturales'),(920,'920','Actividades de juegos de azar y apuestas'),(931,'931','Actividades deportivas'),(932,'932','Actividades recreativas y de entretenimiento'),(941,'941','Actividades de organizaciones empresariales, profesionales y patronales'),(942,'942','Actividades sindicales'),(949,'949','Otras actividades asociativas'),(951,'951','Reparación de ordenadores y equipos de comunicación'),(952,'952','Reparación de efectos personales y artículos de uso doméstico'),(960,'960','Otros servicios personales'),(970,'970','Actividades de los hogares como empleadores de personal doméstico'),(981,'981','Actividades de los hogares como productores de bienes para uso propio'),(982,'982','Actividades de los hogares como productores de servicios para uso propio'),(990,'990','Actividades de organizaciones y organismos extraterritoriales'),(1011,'1011','Procesado y conservación de carne'),(1012,'1012','Procesado y conservación de volatería'),(1013,'1013','Elaboración de productos cárnicos y de volatería'),(1021,'1021','Procesado de pescados, crustáceos y moluscos'),(1022,'1022','Fabricación de conservas de pescado'),(1031,'1031','Procesado y conservación de patatas'),(1032,'1032','Elaboración de zumos de frutas y hortalizas'),(1039,'1039','Otro procesado y conservación de frutas y hortalizas'),(1042,'1042','Fabricación de margarina y grasas comestibles similares'),(1043,'1043','Fabricación de aceite de oliva'),(1044,'1044','Fabricación de otros aceites y grasas'),(1052,'1052','Elaboración de helados'),(1053,'1053','Fabricación de quesos'),(1054,'1054','Preparación de leche y otros productos lácteos'),(1061,'1061','Fabricación de productos de molinería'),(1062,'1062','Fabricación de almidones y productos amiláceos'),(1071,'1071','Fabricación de pan y de productos frescos de panadería y pastelería'),(1072,'1072','Fabricación de galletas y productos de panadería y pastelería de larga duración'),(1073,'1073','Fabricación de pastas alimenticias, cuscús y productos similares'),(1081,'1081','Fabricación de azúcar'),(1082,'1082','Fabricación de cacao, chocolate y productos de confitería'),(1083,'1083','Elaboración de café, té e infusiones'),(1084,'1084','Elaboración de especias, salsas y condimentos'),(1085,'1085','Elaboración de platos y comidas preparados'),(1086,'1086','Elaboración de preparados alimenticios homogeneizados y alimentos dietéticos'),(1089,'1089','Elaboración de otros productos alimenticios n.c.o.p.'),(1091,'1091','Fabricación de productos para la alimentación de animales de granja'),(1092,'1092','Fabricación de productos para la alimentación de animales de compañía'),(1101,'1101','Destilación, rectificación y mezcla de bebidas alcohólicas'),(1102,'1102','Elaboración de vinos'),(1103,'1103','Elaboración de sidra y otras bebidas fermentadas a partir de frutas'),(1104,'1104','Elaboración de otras bebidas no destiladas, procedentes de la fermentación'),(1105,'1105','Fabricación de cerveza'),(1106,'1106','Fabricación de malta'),(1107,'1107','Fabricación de bebidas no alcohólicas: producción de aguas minerales y otras aguas embotelladas'),(1200,'1200','Industria del tabaco'),(1310,'1310','Preparación e hilado de fibras textiles'),(1320,'1320','Fabricación de tejidos textiles'),(1330,'1330','Acabado de textiles'),(1391,'1391','Fabricación de tejidos de punto'),(1392,'1392','Fabricación de artículos confeccionados con textiles, excepto prendas de vestir'),(1393,'1393','Fabricación de alfombras y moquetas'),(1394,'1394','Fabricación de cuerdas, cordeles, bramantes y redes'),(1395,'1395','Fabricación de telas no tejidas y artículos confeccionados con ellas, excepto prendas de vestir'),(1396,'1396','Fabricación de otros productos textiles de uso técnico e industrial'),(1399,'1399','Fabricación de otros productos textiles n.c.o.p.'),(1411,'1411','Confección de prendas de vestir de cuero'),(1412,'1412','Confección de ropa de trabajo'),(1413,'1413','Confección de otras prendas de vestir exteriores'),(1414,'1414','Confección de ropa interior'),(1419,'1419','Confección de otras prendas de vestir y accesorios'),(1420,'1420','Fabricación de artículos de peletería'),(1431,'1431','Confección de calcetería'),(1439,'1439','Confección de otras prendas de vestir de punto'),(1511,'1511','Preparación, curtido y acabado del cuero: preparación y teñido de pieles'),(1512,'1512','Fabricación de artículos de marroquinería, viaje y de guarnicionería y talabartería'),(1520,'1520','Fabricación de calzado'),(1610,'1610','Aserrado y cepillado de la madera'),(1621,'1621','Fabricación de chapas y tableros de madera'),(1622,'1622','Fabricación de suelos de madera ensamblados'),(1623,'1623','Fabricación de otras estructuras de madera y piezas de carpintería y ebanistería para la construcción'),(1624,'1624','Fabricación de envases y embalajes de madera'),(1629,'1629','Fabricación de otros productos de madera: artículos de corcho, cestería y espartería'),(1711,'1711','Fabricación de pasta papelera'),(1712,'1712','Fabricación de papel y cartón'),(1721,'1721','Fabricación de papel y cartón ondulados: fabricación de envases y embalajes de papel y cartón'),(1722,'1722','Fabricación de artículos de papel y cartón para uso doméstico, sanitario e higiénico'),(1723,'1723','Fabricación de artículos de papelería'),(1724,'1724','Fabricación de papeles pintados'),(1729,'1729','Fabricación de otros artículos de papel y cartón'),(1811,'1811','Artes gráficas y servicios relacionados con las mismas'),(1812,'1812','Otras actividades de impresión y artes gráficas'),(1813,'1813','Servicios de preimpresión y preparación de soportes'),(1814,'1814','Encuadernación y servicios relacionados con la misma'),(1820,'1820','Reproducción de soportes grabados'),(1910,'1910','Coquerías'),(1920,'1920','Refino de petróleo'),(2011,'2011','Fabricación de gases industriales'),(2012,'2012','Fabricación de colorantes y pigmentos'),(2013,'2013','Fabricación de otros productos básicos de química inorgánica'),(2014,'2014','Fabricación de otros productos básicos de química orgánica'),(2015,'2015','Fabricación de fertilizantes y compuestos nitrogenados'),(2016,'2016','Fabricación de plásticos en formas primarias'),(2017,'2017','Fabricación de caucho sintético en formas primarias'),(2020,'2020','Fabricación de pesticidas y otros productos agroquímicos'),(2030,'2030','Fabricación de pinturas, barnices y revestimientos similares: tintas de imprenta y masillas'),(2041,'2041','Fabricación de jabones, detergentes y otros artículos de limpieza y abrillantamiento'),(2042,'2042','Fabricación de perfumes y cosméticos'),(2051,'2051','Fabricación de explosivos'),(2052,'2052','Fabricación de colas'),(2053,'2053','Fabricación de aceites esenciales'),(2059,'2059','Fabricación de otros productos químicos n.c.o.p.'),(2060,'2060','Fabricación de fibras artificiales y sintéticas'),(2110,'2110','Fabricación de productos farmacéuticos de base'),(2120,'2120','Fabricación de especialidades farmacéuticas'),(2211,'2211','Fabricación de neumáticos y cámaras de caucho: reconstrucción y recauchutado de neumáticos'),(2219,'2219','Fabricación de otros productos de caucho'),(2221,'2221','Fabricación de placas, hojas, tubos y perfiles de plástico'),(2222,'2222','Fabricación de envases y embalajes de plástico'),(2223,'2223','Fabricación de productos de plástico para la construcción'),(2229,'2229','Fabricación de otros productos de plástico'),(2311,'2311','Fabricación de vidrio plano'),(2312,'2312','Manipulado y transformación de vidrio plano'),(2313,'2313','Fabricación de vidrio hueco'),(2314,'2314','Fabricación de fibra de vidrio'),(2319,'2319','Fabricación y manipulado de otro vidrio, incluido el vidrio técnico'),(2320,'2320','Fabricación de productos cerámicos refractarios'),(2331,'2331','Fabricación de azulejos y baldosas de cerámica'),(2332,'2332','Fabricación de ladrillos, tejas y productos de tierras cocidas para la construcción'),(2341,'2341','Fabricación de artículos cerámicos de uso doméstico y ornamental'),(2342,'2342','Fabricación de aparatos sanitarios cerámicos'),(2343,'2343','Fabricación de aisladores y piezas aislantes de material cerámico'),(2344,'2344','Fabricación de otros productos cerámicos de uso técnico'),(2349,'2349','Fabricación de otros productos cerámicos'),(2351,'2351','Fabricación de cemento'),(2352,'2352','Fabricación de cal y yeso'),(2361,'2361','Fabricación de elementos de hormigón para la construcción'),(2362,'2362','Fabricación de elementos de yeso para la construcción'),(2363,'2363','Fabricación de hormigón fresco'),(2364,'2364','Fabricación de mortero'),(2365,'2365','Fabricación de fibrocemento'),(2369,'2369','Fabricación de otros productos de hormigón, yeso y cemento'),(2370,'2370','Corte, tallado y acabado de la piedra'),(2391,'2391','Fabricación de productos abrasivos'),(2399,'2399','Fabricación de otros productos minerales no metálicos n.c.o.p.'),(2410,'2410','Fabricación de productos básicos de hierro, acero y ferroaleaciones'),(2420,'2420','Fabricación de tubos, tuberías, perfiles huecos y sus accesorios, de acero'),(2431,'2431','Estirado en frío'),(2432,'2432','Laminación en frío'),(2433,'2433','Producción de perfiles en frío por conformación con plegado'),(2434,'2434','Trefilado en frío'),(2441,'2441','Producción de metales preciosos'),(2442,'2442','Producción de aluminio'),(2443,'2443','Producción de plomo, zinc y estaño'),(2444,'2444','Producción de cobre'),(2445,'2445','Producción de otros metales no férreos'),(2446,'2446','Procesamiento de combustibles nucleares'),(2451,'2451','Fundición de hierro'),(2452,'2452','Fundición de acero'),(2453,'2453','Fundición de metales ligeros'),(2454,'2454','Fundición de otros metales no férreos'),(2511,'2511','Fabricación de estructuras metálicas y sus componentes'),(2512,'2512','Fabricación de carpintería metálica'),(2521,'2521','Fabricación de radiadores y calderas para calefacción central'),(2529,'2529','Fabricación de otras cisternas, grandes depísitos y contenedores de metal'),(2530,'2530','Fabricación de generadores de vapor, excepto calderas de calefacción central'),(2540,'2540','Fabricación de armas y municiones'),(2550,'2550','Forja, estampación y embutición de metales: metalurgia de polvos'),(2561,'2561','Tratamiento y revestimiento de metales'),(2562,'2562','Ingeniería mecánica por cuenta de terceros'),(2571,'2571','Fabricación de artículos de cuchillería y cubertería'),(2572,'2572','Fabricación de cerraduras y herrajes'),(2573,'2573','Fabricación de herramientas'),(2591,'2591','Fabricación de bidones y toneles de hierro o acero'),(2592,'2592','Fabricación de envases y embalajes metálicos ligeros'),(2593,'2593','Fabricación de productos de alambre, cadenas y muelles'),(2594,'2594','Fabricación de pernos y productos de tornillería'),(2599,'2599','Fabricación de otros productos metálicos n.c.o.p.'),(2611,'2611','Fabricación de componentes electrónicos'),(2612,'2612','Fabricación de circuitos impresos ensamblados'),(2620,'2620','Fabricación de ordenadores y equipos periféricos'),(2630,'2630','Fabricación de equipos de telecomunicaciones'),(2640,'2640','Fabricación de productos electrónicos de consumo'),(2651,'2651','Fabricación de instrumentos y aparatos de medida, verificación y navegación'),(2652,'2652','Fabricación de relojes'),(2660,'2660','Fabricación de equipos de radiación, electromédicos y electroterapéuticos'),(2670,'2670','Fabricación de instrumentos de óptica y equipo fotográfico'),(2680,'2680','Fabricación de soportes magnéticos y ópticos'),(2711,'2711','Fabricación de motores, generadores y transformadores eléctricos'),(2712,'2712','Fabricación de aparatos de distribución y control eléctrico'),(2720,'2720','Fabricación de pilas y acumuladores eléctricos'),(2731,'2731','Fabricación de cables de fibra óptica'),(2732,'2732','Fabricación de otros hilos y cables electrónicos y eléctricos'),(2733,'2733','Fabricación de dispositivos de cableado'),(2740,'2740','Fabricación de lámparas y aparatos eléctricos de iluminación'),(2751,'2751','Fabricación de electrodomésticos'),(2752,'2752','Fabricación de aparatos domésticos no eléctricos'),(2790,'2790','Fabricación de otro material y equipo eléctrico'),(2811,'2811','Fabricación de motores y turbinas, excepto los destinados a aeronaves, vehículos automóviles y ciclomotores'),(2812,'2812','Fabricación de equipos de transmisión hidráulica y neumática'),(2813,'2813','Fabricación de otras bombas y compresores'),(2814,'2814','Fabricación de otra grifería y válvulas'),(2815,'2815','Fabricación de cojinetes, engranajes y órganos mecánicos de transmisión'),(2821,'2821','Fabricación de hornos y quemadores'),(2822,'2822','Fabricación de maquinaria de elevación y manipulación'),(2823,'2823','Fabricación de máquinas y equipos de oficina, excepto equipos informáticos'),(2824,'2824','Fabricación de herramientas eléctricas manuales'),(2825,'2825','Fabricación de maquinaria de ventilación y refrigeración no doméstica'),(2829,'2829','Fabricación de otra maquinaria de uso general n.c.o.p.'),(2830,'2830','Fabricación de maquinaria agraria y forestal'),(2841,'2841','Fabricación de máquinas herramienta para trabajar el metal'),(2849,'2849','Fabricación de otras máquinas herramienta'),(2891,'2891','Fabricación de maquinaria para la industria metalúrgica'),(2892,'2892','Fabricación de maquinaria para las industrias extractivas y de la construcción'),(2893,'2893','Fabricación de maquinaria para la industria de la alimentación, bebidas y tabaco'),(2894,'2894','Fabricación de maquinaria para las industrias textil, de la confección y del cuero'),(2895,'2895','Fabricación de maquinaria para la industria del papel y del cartón'),(2896,'2896','Fabricación de maquinaria para la industria del plástico y el caucho'),(2899,'2899','Fabricación de otra maquinaria para usos específicos n.c.o.p.'),(2910,'2910','Fabricación de vehículos de motor'),(2920,'2920','Fabricación de carrocerías para vehículos de motor: fabricación de remolques y semirremolques'),(2931,'2931','Fabricación de equipos eléctricos y electrónicos para vehículos de motor'),(2932,'2932','Fabricación de otros componentes, piezas y accesorios para vehículos de motor'),(3011,'3011','Construcción de barcos y estructuras flotantes'),(3012,'3012','Construcción de embarcaciones de recreo y deporte'),(3020,'3020','Fabricación de locomotoras y material ferroviario'),(3030,'3030','Construcción aeronáutica y espacial y su maquinaria'),(3040,'3040','Fabricación de vehículos militares de combate'),(3091,'3091','Fabricación de motocicletas'),(3092,'3092','Fabricación de bicicletas y de vehículos para personas con discapacidad'),(3099,'3099','Fabricación de otro material de transporte n.c.o.p.'),(3101,'3101','Fabricación de muebles de oficina y de establecimientos comerciales'),(3102,'3102','Fabricación de muebles de cocina'),(3103,'3103','Fabricación de colchones'),(3109,'3109','Fabricación de otros muebles'),(3211,'3211','Fabricación de monedas'),(3212,'3212','Fabricación de artículos de joyería y artículos similares'),(3213,'3213','Fabricación de artículos de bisutería y artículos similares'),(3220,'3220','Fabricación de instrumentos musicales'),(3230,'3230','Fabricación de artículos de deporte'),(3240,'3240','Fabricación de juegos y juguetes'),(3250,'3250','Fabricación de instrumentos y suministros médicos y odontológicos'),(3291,'3291','Fabricación de escobas, brochas y cepillos'),(3299,'3299','Otras industrias manufactureras n.c.o.p.'),(3311,'3311','Reparación de productos metálicos'),(3312,'3312','Reparación de maquinaria'),(3313,'3313','Reparación de equipos electrónicos y ópticos'),(3314,'3314','Reparación de equipos eléctricos'),(3315,'3315','Reparación y mantenimiento naval'),(3316,'3316','Reparación y mantenimiento aeronáutico y espacial'),(3317,'3317','Reparación y mantenimiento de otro material de transporte'),(3319,'3319','Reparación de otros equipos'),(3320,'3320','Instalación de máquinas y equipos industriales'),(3512,'3512','Transporte de energía eléctrica'),(3513,'3513','Distribución de energía eléctrica'),(3514,'3514','Comercio de energía eléctrica'),(3515,'3515','Producción de energía hidroeléctrica'),(3516,'3516','Producción de energía eléctrica de origen térmico convencional'),(3517,'3517','Producción de energía eléctrica de origen nuclear'),(3518,'3518','Producción de energía eléctrica de origen eólico'),(3519,'3519','Producción de energía eléctrica de otros tipos'),(3521,'3521','Producción de gas'),(3522,'3522','Distribución por tubería de combustibles gaseosos'),(3523,'3523','Comercio de gas por tubería'),(3530,'3530','Suministro de vapor y aire acondicionado'),(3600,'3600','Captación, depuración y distribución de agua'),(3700,'3700','Recogida y tratamiento de aguas residuales'),(3811,'3811','Recogida de residuos no peligrosos'),(3812,'3812','Recogida de residuos peligrosos'),(3821,'3821','Tratamiento y eliminación de residuos no peligrosos'),(3822,'3822','Tratamiento y eliminación de residuos peligrosos'),(3831,'3831','Separación y clasificación de materiales'),(3832,'3832','Valorización de materiales ya clasificados'),(3900,'3900','Actividades de descontaminación y otros servicios de gestión de residuos'),(4110,'4110','Promoción inmobiliaria'),(4121,'4121','Construcción de edificios residenciales'),(4122,'4122','Construcción de edificios no residenciales'),(4211,'4211','Construcción de carreteras y autopistas'),(4212,'4212','Construcción de vías férreas de superficie y subterráneas'),(4213,'4213','Construcción de puentes y túneles'),(4221,'4221','Construcción de redes para fluidos'),(4222,'4222','Construcción de redes eléctricas y de telecomunicaciones'),(4291,'4291','Obras hidráulicas'),(4299,'4299','Construcción de otros proyectos de ingeniería civil n.c.o.p.'),(4311,'4311','Demolición'),(4312,'4312','Preparación de terrenos'),(4313,'4313','Perforaciones y sondeos'),(4321,'4321','Instalaciones eléctricas'),(4322,'4322','Fontanería, instalaciones de sistemas de calefacción y aire acondicionado'),(4329,'4329','Otras instalaciones en obras de construcción'),(4331,'4331','Revocamiento'),(4332,'4332','Instalación de carpintería'),(4333,'4333','Revestimiento de suelos y paredes'),(4334,'4334','Pintura y acristalamiento'),(4339,'4339','Otro acabado de edificios'),(4391,'4391','Construcción de cubiertas'),(4399,'4399','Otras actividades de construcción especializada n.c.o.p.'),(4511,'4511','Venta de automóviles y vehículos de motor ligeros'),(4519,'4519','Venta de otros vehículos de motor'),(4520,'4520','Mantenimiento y reparación de vehículos de motor'),(4531,'4531','Comercio al por mayor de repuestos y accesorios de vehículos de motor'),(4532,'4532','Comercio al por menor de repuestos y accesorios de vehículos de motor'),(4540,'4540','Venta, mantenimiento y reparación de motocicletas y de sus repuestos y accesorios'),(4611,'4611','Intermediarios del comercio de materias primas agrarias, animales vivos, materias primas textiles y productos semielaborados'),(4612,'4612','Intermediarios del comercio de combustibles, minerales, metales y productos químicos industriales'),(4613,'4613','Intermediarios del comercio de la madera y materiales de construcción'),(4614,'4614','Intermediarios del comercio de maquinaria, equipo industrial, embarcaciones y aeronaves'),(4615,'4615','Intermediarios del comercio de muebles, artículos para el hogar y ferretería'),(4616,'4616','Intermediarios del comercio de textiles, prendas de vestir, peletería, calzado y artículos de cuero'),(4617,'4617','Intermediarios del comercio de productos alimenticios, bebidas y tabaco'),(4618,'4618','Intermediarios del comercio especializados en la venta de otros productos específicos'),(4619,'4619','Intermediarios del comercio de productos diversos'),(4621,'4621','Comercio al por mayor de cereales, tabaco en rama, simientes y alimentos para animales'),(4622,'4622','Comercio al por mayor de flores y plantas'),(4623,'4623','Comercio al por mayor de animales vivos'),(4624,'4624','Comercio al por mayor de cueros y pieles'),(4631,'4631','Comercio al por mayor de frutas y hortalizas'),(4632,'4632','Comercio al por mayor de carne y productos cárnicos'),(4633,'4633','Comercio al por mayor de productos lácteos, huevos, aceites y grasas comestibles'),(4634,'4634','Comercio al por mayor de bebidas'),(4635,'4635','Comercio al por mayor de productos del tabaco'),(4636,'4636','Comercio al por mayor de azúcar, chocolate y confitería'),(4637,'4637','Comercio al por mayor de café, té, cacao y especias'),(4638,'4638','Comercio al por mayor de pescados y mariscos y otros productos alimenticios'),(4639,'4639','Comercio al por mayor, no especializado, de productos alimenticios, bebidas y tabaco'),(4641,'4641','Comercio al por mayor de textiles'),(4642,'4642','Comercio al por mayor de prendas de vestir y calzado'),(4643,'4643','Comercio al por mayor de aparatos electrodomésticos'),(4644,'4644','Comercio al por mayor de porcelana, cristalería y artículos de limpieza'),(4645,'4645','Comercio al por mayor de productos perfumería y cosmética'),(4646,'4646','Comercio al por mayor de productos farmacéuticos'),(4647,'4647','Comercio al por mayor de muebles, alfombras y aparatos de iluminación'),(4648,'4648','Comercio al por mayor de artículos de relojería y joyería'),(4649,'4649','Comercio al por mayor de otros artículos de uso doméstico'),(4651,'4651','Comercio al por mayor de ordenadores, equipos periféricos y programas informáticos'),(4652,'4652','Comercio al por mayor de equipos electrónicos y de telecomunicaciones y sus componentes'),(4661,'4661','Comercio al por mayor de maquinaria, equipos y suministros agrícolas'),(4662,'4662','Comercio al por mayor de máquinas herramienta'),(4663,'4663','Comercio al por mayor de maquinaria para la minería, la construcción y la ingeniería civil'),(4664,'4664','Comercio al por mayor de maquinaria para la industria textil y de máquinas de coser y tricotar'),(4665,'4665','Comercio al por mayor de muebles de oficina'),(4666,'4666','Comercio al por mayor de otra maquinaria y equipo de oficina'),(4669,'4669','Comercio al por mayor de otra maquinaria y equipo'),(4671,'4671','Comercio al por mayor de combustibles sálidos, líquidos y gaseosos, y productos similares'),(4672,'4672','Comercio al por mayor de metales y minerales metálicos'),(4673,'4673','Comercio al por mayor de madera, materiales de construcción y aparatos sanitarios'),(4674,'4674','Comercio al por mayor de ferretería, fontanería y calefacción'),(4675,'4675','Comercio al por mayor de productos químicos'),(4676,'4676','Comercio al por mayor de otros productos semielaborados'),(4677,'4677','Comercio al por mayor de chatarra y productos de desecho'),(4690,'4690','Comercio al por mayor no especializado'),(4711,'4711','Comercio al por menor en establecimientos no especializados, con predominio en productos alimenticios, bebidas y tabaco'),(4719,'4719','Otro comercio al por menor en establecimientos no especializados'),(4721,'4721','Comercio al por menor de frutas y hortalizas en establecimientos especializados'),(4722,'4722','Comercio al por menor de carne y productos cárnicos en establecimientos especializados'),(4723,'4723','Comercio al por menor de pescados y mariscos en establecimientos especializados'),(4724,'4724','Comercio al por menor de pan y productos de panadería, confitería y pastelería en establecimientos especializados'),(4725,'4725','Comercio al por menor de bebidas en establecimientos especializados'),(4726,'4726','Comercio al por menor de productos de tabaco en establecimientos especializados'),(4729,'4729','Otro comercio al por menor de productos alimenticios en establecimientos especializados'),(4730,'4730','Comercio al por menor de combustible para la automoción en establecimientos especializados'),(4741,'4741','Comercio al por menor de ordenadores, equipos periféricos y programas informáticos en establecimientos especializados'),(4742,'4742','Comercio al por menor de equipos de telecomunicaciones en establecimientos especializados'),(4743,'4743','Comercio al por menor de equipos de audio y vídeo en establecimientos especializados'),(4751,'4751','Comercio al por menor de textiles en establecimientos especializados'),(4752,'4752','Comercio al por menor de ferretería, pintura y vidrio en establecimientos especializados'),(4753,'4753','Comercio al por menor de alfombras, moquetas y revestimientos de paredes y suelos en establecimientos especializados'),(4754,'4754','Comercio al por menor de aparatos electrodomésticos en establecimientos especializados'),(4759,'4759','Comercio al por menor de muebles, aparatos de iluminación y otros artículos de uso doméstico en establecimientos especializados'),(4761,'4761','Comercio al por menor de libros en establecimientos especializados'),(4762,'4762','Comercio al por menor de periódicos y artículos de papelería en establecimientos especializados'),(4763,'4763','Comercio al por menor de grabaciones de música y vídeo en establecimientos especializados'),(4764,'4764','Comercio al por menor de artículos deportivos en establecimientos especializados'),(4765,'4765','Comercio al por menor de juegos y juguetes en establecimientos especializados'),(4771,'4771','Comercio al por menor de prendas de vestir en establecimientos especializados'),(4772,'4772','Comercio al por menor de calzado y artículos de cuero en establecimientos especializados'),(4773,'4773','Comercio al por menor de productos farmacéuticos en establecimientos especializados'),(4774,'4774','Comercio al por menor de artículos médicos y ortopédicos en establecimientos especializados'),(4775,'4775','Comercio al por menor de productos cosméticos e higiénicos en establecimientos especializados'),(4776,'4776','Comercio al por menor de flores, plantas, semillas, fertilizantes, animales de compañía y alimentos para los mismos en establecimientos especializados'),(4777,'4777','Comercio al por menor de artículos de relojería y joyería en establecimientos especializados'),(4778,'4778','Otro comercio al por menor de artículos nuevos en establecimientos especializados'),(4779,'4779','Comercio al por menor de artículos de segunda mano en establecimientos'),(4781,'4781','Comercio al por menor de productos alimenticios, bebidas y tabaco en puestos de venta y en mercadillos'),(4782,'4782','Comercio al por menor de productos textiles, prendas de vestir y calzado en puestos de venta y en mercadillos'),(4789,'4789','Comercio al por menor de otros productos en puestos de venta y en mercadillos'),(4791,'4791','Comercio al por menor por correspondencia o Internet'),(4799,'4799','Otro comercio al por menor no realizado ni en establecimientos, ni en puestos de venta ni en mercadillos'),(4910,'4910','Transporte interurbano de pasajeros por ferrocarril'),(4920,'4920','Transporte de mercancías por ferrocarril'),(4931,'4931','Transporte terrestre urbano y suburbano de pasajeros'),(4932,'4932','Transporte por taxi'),(4939,'4939','tipos de transporte terrestre de pasajeros n.c.o.p.'),(4941,'4941','Transporte de mercancías por carretera'),(4942,'4942','Servicios de mudanza'),(4950,'4950','Transporte por tubería'),(5010,'5010','Transporte marítimo de pasajeros'),(5020,'5020','Transporte marítimo de mercancías'),(5030,'5030','Transporte de pasajeros por vías navegables interiores'),(5040,'5040','Transporte de mercancías por vías navegables interiores'),(5110,'5110','Transporte aéreo de pasajeros'),(5121,'5121','Transporte aéreo de mercancías'),(5122,'5122','Transporte espacial'),(5210,'5210','Depísito y almacenamiento'),(5221,'5221','Actividades anexas al transporte terrestre'),(5222,'5222','Actividades anexas al transporte marítimo y por vías navegables interiores'),(5223,'5223','Actividades anexas al transporte aéreo'),(5224,'5224','Manipulación de mercancías'),(5229,'5229','Otras actividades anexas al transporte'),(5310,'5310','Actividades postales sometidas a la obligación del servicio universal'),(5320,'5320','Otras actividades postales y de correos'),(5510,'5510','Hoteles y alojamientos similares'),(5520,'5520','Alojamientos turísticos y otros alojamientos de corta estancia'),(5530,'5530','Campings y aparcamientos para caravanas'),(5590,'5590','Otros alojamientos'),(5610,'5610','Restaurantes y puestos de comidas'),(5621,'5621','Provisión de comidas preparadas para eventos'),(5629,'5629','Otros servicios de comidas'),(5630,'5630','Establecimientos de bebidas'),(5811,'5811','Edición de libros'),(5812,'5812','Edición de directorios y guías de direcciones postales'),(5813,'5813','Edición de periódicos'),(5814,'5814','Edición de revistas'),(5819,'5819','Otras actividades editoriales'),(5821,'5821','Edición de videojuegos'),(5829,'5829','Edición de otros programas informáticos'),(5912,'5912','Actividades de postproducción cinematográfica, de vídeo y de programas de televisión'),(5914,'5914','Actividades de exhibición cinematográfica'),(5915,'5915','Actividades de producción cinematográfica y de vídeo'),(5916,'5916','Actividades de producciones de programas de televisión'),(5917,'5917','Actividades de distribución cinematográfica y de vídeo'),(5918,'5918','Actividades de distribución de programas de televisión'),(5920,'5920','Actividades de grabación de sonido y edición musical'),(6010,'6010','Actividades de radiodifusión'),(6020,'6020','Actividades de programación y emisión de televisión'),(6110,'6110','Telecomunicaciones por cable'),(6120,'6120','Telecomunicaciones inalámbricas'),(6130,'6130','Telecomunicaciones por satélite'),(6190,'6190','Otras actividades de telecomunicaciones'),(6201,'6201','Actividades de programación informática'),(6202,'6202','Actividades de consultoría informática'),(6203,'6203','Gestión de recursos informáticos'),(6209,'6209','Otros servicios relacionados con las tecnologías de la información y la informática'),(6311,'6311','Proceso de datos, hosting y actividades relacionadas'),(6312,'6312','Portales web'),(6391,'6391','Actividades de las agencias de noticias'),(6399,'6399','Otros servicios de información n.c.o.p.'),(6411,'6411','Banco central'),(6419,'6419','Otra intermediación monetaria'),(6420,'6420','Actividades de las sociedades holding'),(6430,'6430','Inversión colectiva, fondos y entidades financieras similares'),(6491,'6491','Arrendamiento financiero'),(6492,'6492','Otras actividades crediticias'),(6499,'6499','Otros servicios financieros, excepto seguros y fondos de pensiones n.c.o.p.'),(6511,'6511','Seguros de vida'),(6512,'6512','Seguros distintos de los seguros de vida'),(6520,'6520','Reaseguros'),(6530,'6530','Fondos de pensiones'),(6611,'6611','Administración de mercados financieros'),(6612,'6612','Actividades de intermediación en operaciones con valores y otros activos'),(6619,'6619','Otras actividades auxiliares a los servicios financieros, excepto seguros y fondos de pensiones'),(6621,'6621','Evaluación de riesgos y daños'),(6622,'6622','Actividades de agentes y corredores de seguros'),(6629,'6629','Otras actividades auxiliares a seguros y fondos de pensiones'),(6630,'6630','Actividades de gestión de fondos'),(6810,'6810','Compraventa de bienes inmobiliarios por cuenta propia'),(6820,'6820','Alquiler de bienes inmobiliarios por cuenta propia'),(6831,'6831','Agentes de la propiedad inmobiliaria'),(6832,'6832','Gestión y administración de la propiedad inmobiliaria'),(6910,'6910','Actividades jurídicas'),(6920,'6920','Actividades de contabilidad, teneduría de libros, auditoría y asesoría fiscal'),(7010,'7010','Actividades de las sedes centrales'),(7021,'7021','Relaciones públicas y comunicación'),(7022,'7022','Otras actividades de consultoría de gestión empresarial'),(7111,'7111','Servicios técnicos de arquitectura'),(7112,'7112','Servicios técnicos de ingeniería y otras actividades relacionadas con el asesoramiento técnico'),(7120,'7120','Ensayos y análisis técnicos'),(7211,'7211','Investigación y desarrollo experimental en biotecnología'),(7219,'7219','Otra investigación y desarrollo experimental en ciencias naturales y técnicas'),(7220,'7220','Investigación y desarrollo experimental en ciencias sociales y humanidades'),(7311,'7311','Agencias de publicidad'),(7312,'7312','Servicios de representación de medios de comunicación'),(7320,'7320','Estudio de mercado y realización de encuestas de opinión pública'),(7410,'7410','Actividades de diseño especializado'),(7420,'7420','Actividades de fotografía'),(7430,'7430','Actividades de traducción e interpretación'),(7490,'7490','Otras actividades profesionales, científicas y técnicas n.c.o.p.'),(7500,'7500','Actividades veterinarias'),(7711,'7711','Alquiler de automóviles y vehículos de motor ligeros'),(7712,'7712','Alquiler de camiones'),(7721,'7721','Alquiler de artículos de ocio y deportivos'),(7722,'7722','Alquiler de cintas de vídeo y discos'),(7729,'7729','Alquiler de otros efectos personales y artículos de uso doméstico'),(7731,'7731','Alquiler de maquinaria y equipo de uso agrícola'),(7732,'7732','Alquiler de maquinaria y equipo para la construcción e ingeniería civil'),(7733,'7733','Alquiler de maquinaria y equipo de oficina, incluidos ordenadores'),(7734,'7734','Alquiler de medios de navegación'),(7735,'7735','Alquiler de medios de transporte aéreo'),(7739,'7739','Alquiler de otra maquinaria, equipos y bienes tangibles n.c.o.p.'),(7740,'7740','Arrendamiento de la propiedad intelectual y productos similares, excepto trabajos protegidos por los derechos de autor'),(7810,'7810','Actividades de las agencias de colocación'),(7820,'7820','Actividades de las empresas de trabajo temporal'),(7830,'7830','Otra provisión de recursos humanos'),(7911,'7911','Actividades de las agencias de viajes'),(7912,'7912','Actividades de los operadores turísticos'),(7990,'7990','Otros servicios de reservas y actividades relacionadas con los mismos'),(8010,'8010','Actividades de seguridad privada'),(8020,'8020','Servicios de sistemas de seguridad'),(8030,'8030','Actividades de investigación'),(8110,'8110','Servicios integrales a edificios e instalaciones'),(8121,'8121','Limpieza general de edificios'),(8122,'8122','Otras actividades de limpieza industrial y de edificios'),(8129,'8129','Otras actividades de limpieza'),(8130,'8130','Actividades de jardinería'),(8211,'8211','Servicios administrativos combinados'),(8219,'8219','Actividades de fotocopiado, preparación de documentos y otras actividades especializadas de oficina'),(8220,'8220','Actividades de los centros de llamadas'),(8230,'8230','Organización de convenciones y ferias de muestras'),(8291,'8291','Actividades de las agencias de cobros y de información comercial'),(8292,'8292','Actividades de envasado y empaquetado'),(8299,'8299','Otras actividades de apoyo a las empresas n.c.o.p.'),(8411,'8411','Actividades generales de la Administración Pública'),(8412,'8412','Regulación de las actividades sanitarias, educativas y culturales y otros servicios sociales, excepto Seguridad Social'),(8413,'8413','Regulación de la actividad económica y contribución a su mayor eficiencia'),(8421,'8421','Asuntos exteriores'),(8422,'8422','Defensa'),(8423,'8423','Justicia'),(8424,'8424','Orden público y seguridad'),(8425,'8425','Protección civil'),(8430,'8430','Seguridad Social obligatoria'),(8510,'8510','Educación preprimaria'),(8520,'8520','Educación primaria'),(8531,'8531','Educación secundaria general'),(8532,'8532','Educación secundaria técnica y profesional'),(8541,'8541','Educación postsecundaria no terciaria'),(8543,'8543','Educación universitaria'),(8544,'8544','Educación terciaria no universitaria'),(8551,'8551','Educación deportiva y recreativa'),(8552,'8552','Educación cultural'),(8553,'8553','Actividades de las escuelas de conducción y pilotaje'),(8559,'8559','Otra educación n.c.o.p.'),(8560,'8560','Actividades auxiliares a la educación'),(8610,'8610','Actividades hospitalarias'),(8621,'8621','Actividades de medicina general'),(8622,'8622','Actividades de medicina especializada'),(8623,'8623','Actividades odontológicas'),(8690,'8690','Otras actividades sanitarias'),(8710,'8710','Asistencia en establecimientos residenciales con cuidados sanitarios'),(8720,'8720','Asistencia en establecimientos residenciales para personas con discapacidad intelectual, enfermedad mental y drogodependencia'),(8731,'8731','Asistencia en establecimientos residenciales para personas mayores'),(8732,'8732','Asistencia en establecimientos residenciales para personas con discapacidad física'),(8790,'8790','Otras actividades de asistencia en establecimientos residenciales'),(8811,'8811','Actividades de servicios sociales sin alojamiento para personas mayores'),(8812,'8812','Actividades de servicios sociales sin alojamiento para personas con discapacidad'),(8891,'8891','Actividades de cuidado diurno de niños'),(8899,'8899','Otros actividades de servicios sociales sin alojamiento n.c.o.p.'),(9001,'9001','Artes escénicas'),(9002,'9002','Actividades auxiliares a las artes escénicas'),(9003,'9003','Creación artística y literaria'),(9004,'9004','Gestión de salas de espectáculos'),(9102,'9102','Actividades de museos'),(9103,'9103','Gestión de lugares y edificios históricos'),(9104,'9104','Actividades de los jardines botánicos, parques zoológicos y reservas naturales'),(9105,'9105','Actividades de bibliotecas'),(9106,'9106','Actividades de archivos'),(9200,'9200','Actividades de juegos de azar y apuestas'),(9311,'9311','Gestión de instalaciones deportivas'),(9312,'9312','Actividades de los clubes deportivos'),(9313,'9313','Actividades de los gimnasios'),(9319,'9319','Otras actividades deportivas'),(9321,'9321','Actividades de los parques de atracciones y los parques temáticos'),(9329,'9329','Otras actividades recreativas y de entretenimiento'),(9411,'9411','Actividades de organizaciones empresariales y patronales'),(9412,'9412','Actividades de organizaciones profesionales'),(9420,'9420','Actividades sindicales'),(9491,'9491','Actividades de organizaciones religiosas'),(9492,'9492','Actividades de organizaciones políticas'),(9499,'9499','Otras actividades asociativas n.c.o.p.'),(9511,'9511','Reparación de ordenadores y equipos periféricos'),(9512,'9512','Reparación de equipos de comunicación'),(9521,'9521','Reparación de aparatos electrónicos de audio y vídeo de uso doméstico'),(9522,'9522','Reparación de aparatos electrodomésticos y de equipos para el hogar y el jardón'),(9523,'9523','Reparación de calzado y artículos de cuero'),(9524,'9524','Reparación de muebles y artículos de menaje'),(9525,'9525','Reparación de relojes y joyería'),(9529,'9529','Reparación de otros efectos personales y artículos de uso doméstico'),(9601,'9601','Lavado y limpieza de prendas textiles y de piel'),(9602,'9602','Peluquería y otros tratamientos de belleza'),(9603,'9603','Pompas fúnebres y actividades relacionadas'),(9604,'9604','Actividades de mantenimiento físico'),(9609,'9609','Otras servicios personales n.c.o.p.'),(9700,'9700','Actividades de los hogares como empleadores de personal doméstico'),(9810,'9810','Actividades de los hogares como productores de bienes para uso propio'),(9820,'9820','Actividades de los hogares como productores de servicios para uso propio'),(9900,'9900','Actividades de organizaciones y organismos extraterritoriales'),(100001,'01','Agricultura, ganadería, caza y servicios relacionados con las mismas'),(100002,'02','Silvicultura y explotación forestal'),(100003,'03','Pesca y acuicultura'),(100005,'05','Extracción de antracita, hulla y lignito'),(100006,'06','Extracción de crudo de petróleo y gas natural'),(100007,'07','Extracción de minerales metálicos'),(100008,'08','Otras industrias extractivas'),(100009,'09','Actividades de apoyo a las industrias extractivas'),(1000011,'011','Cultivos no perennes'),(1000012,'012','Cultivos perennes'),(1000013,'013','Propagación de plantas'),(1000014,'014','Producción ganadera'),(1000015,'015','Producción agrícola combinada con la producción ganadera'),(1000016,'016','Actividades de apoyo a la agricultura, a la ganadería y de preparación posterior a la cosecha'),(1000017,'017','Caza, captura de animales y servicios relacionados con las mismas'),(1000021,'021','Silvicultura y otras actividades forestales'),(1000022,'022','Explotación de la madera'),(1000023,'023','Recolección de productos silvestres, excepto madera'),(1000024,'024','Servicios de apoyo a la silvicultura'),(1000031,'031','Pesca'),(1000032,'032','Acuicultura'),(1000051,'051','Extracción de antracita y hulla'),(1000052,'052','Extracción de lignito'),(1000061,'061','Extracción de crudo de petróleo'),(1000062,'062','Extracción de gas natural'),(1000071,'071','Extracción de minerales de hierro'),(1000072,'072','Extracción de minerales metálicos no férreos'),(1000081,'081','Extracción de piedra, arena y arcilla'),(1000089,'089','Industrias extractivas n.c.o.p.'),(1000091,'091','Actividades de apoyo a la extracción de petróleo y gas natural'),(1000099,'099','Actividades de apoyo a otras industrias extractivas'),(10000111,'0111','Cultivo de cereales (excepto arroz),leguminosas y semillas oleaginosas'),(10000112,'0112','Cultivo de arroz'),(10000113,'0113','Cultivo de hortalizas, raíces y tubérculos'),(10000114,'0114','Cultivo de caía de azúcar'),(10000115,'0115','Cultivo de tabaco'),(10000116,'0116','Cultivo de plantas para fibras textiles'),(10000119,'0119','Otros cultivos no perennes'),(10000121,'0121','Cultivo de la vid'),(10000122,'0122','Cultivo de frutos tropicales y subtropicales'),(10000123,'0123','Cultivo de cétricos'),(10000124,'0124','Cultivo de frutos con hueso y pepitas'),(10000125,'0125','Cultivo de otros árboles y arbustos frutales y frutos secos'),(10000126,'0126','Cultivo de frutos oleaginosos'),(10000127,'0127','Cultivo de plantas para bebidas'),(10000128,'0128','Cultivo de especias, plantas aromáticas, medicinales y farmacéuticas'),(10000129,'0129','Otros cultivos perennes'),(10000130,'0130','Propagación de plantas'),(10000141,'0141','Explotación de ganado bovino para la producción de leche'),(10000142,'0142','Explotación de otro ganado bovino y búfalos'),(10000143,'0143','Explotación de caballos y otros equinos'),(10000144,'0144','Explotación de camellos y otros camélidos'),(10000145,'0145','Explotación de ganado ovino y caprino'),(10000146,'0146','Explotación de ganado porcino'),(10000147,'0147','Avicultura'),(10000149,'0149','Otras explotaciones de ganado'),(10000150,'0150','Producción agrícola combinada con la producción ganadera'),(10000161,'0161','Actividades de apoyo a la agricultura'),(10000162,'0162','Actividades de apoyo a la ganadería'),(10000163,'0163','Actividades de preparación posterior a la cosecha'),(10000164,'0164','Tratamiento de semillas para reproducción'),(10000170,'0170','Caza, captura de animales y servicios relacionados con las mismas'),(10000210,'0210','Silvicultura y otras actividades forestales'),(10000220,'0220','Explotación de la madera'),(10000230,'0230','Recolección de productos silvestres, excepto madera'),(10000240,'0240','Servicios de apoyo a la silvicultura'),(10000311,'0311','Pesca marina'),(10000312,'0312','Pesca en agua dulce'),(10000321,'0321','Acuicultura marina'),(10000322,'0322','Acuicultura en agua dulce'),(10000510,'0510','Extracción de antracita y hulla'),(10000520,'0520','Extracción de lignito'),(10000610,'0610','Extracción de crudo de petróleo'),(10000620,'0620','Extracción de gas natural'),(10000710,'0710','Extracción de minerales de hierro'),(10000721,'0721','Extracción de minerales de uranio y torio'),(10000729,'0729','Extracción de otros minerales metálicos no férreos'),(10000811,'0811','Extracción de piedra ornamental y para la construcción, piedra caliza, yeso, creta y pizarra'),(10000812,'0812','Extracción de gravas y arenas: extracción de arcilla y caolón'),(10000891,'0891','Extracción de minerales para productos químicos y fertilizantes'),(10000892,'0892','Extracción de turba'),(10000893,'0893','Extracción de sal'),(10000899,'0899','Otras industrias extractivas n.c.o.p.'),(10000910,'0910','Actividades de apoyo a la extracción de petróleo y gas natural'),(10000990,'0990','Actividades de apoyo a otras industrias extractivas');
/*!40000 ALTER TABLE `cnae2009` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cnae2009_rate`
--

DROP TABLE IF EXISTS `cnae2009_rate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cnae2009_rate` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador único',
  `cnae2009` int(4) NOT NULL COMMENT 'CNAE',
  `start_date` date NOT NULL COMMENT 'Fecha de inicio ',
  `end_date` date DEFAULT NULL COMMENT 'Fecha de finalizacion',
  `it_amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe por Incapacidad Temporal (I.T.)',
  `ims_amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe por Incapacidad Permanente, Muerte y Supervivencia (I.M.S.)',
  PRIMARY KEY (`id`),
  KEY `IDX_CNAE2009_RATE_CNAE2009` (`cnae2009`),
  CONSTRAINT `FK_CNAE2009_RATE_CNAE2009` FOREIGN KEY (`cnae2009`) REFERENCES `cnae2009` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=456 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Tarifas de primas para I.T e I.M.S';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cnae2009_rate`
--

LOCK TABLES `cnae2009_rate` WRITE;
/*!40000 ALTER TABLE `cnae2009_rate` DISABLE KEYS */;
INSERT INTO `cnae2009_rate` VALUES (1,100001,'2010-01-01',NULL,1.500,1.100),(2,10000113,'2010-01-01',NULL,1.150,1.100),(3,10000119,'2010-01-01',NULL,1.150,1.100),(4,10000129,'2010-01-01',NULL,2.250,2.900),(5,10000130,'2010-01-01',NULL,1.150,1.100),(6,1000014,'2010-01-01',NULL,1.800,1.500),(7,10000147,'2010-01-01',NULL,1.200,1.150),(8,1000015,'2010-01-01',NULL,1.600,1.200),(9,1000016,'2010-01-01',NULL,1.600,1.200),(10,10000164,'2010-01-01',NULL,1.150,1.100),(11,1000017,'2010-01-01',NULL,1.800,1.500),(12,100002,'2010-01-01',NULL,2.250,2.900),(13,100003,'2010-01-01',NULL,3.050,3.350),(14,10000322,'2010-01-01',NULL,3.050,3.200),(15,100005,'2010-01-01',NULL,2.300,2.900),(16,100006,'2010-01-01',NULL,2.300,2.900),(17,100007,'2010-01-01',NULL,2.300,2.900),(18,100008,'2010-01-01',NULL,2.300,2.900),(19,10000811,'2010-01-01',NULL,3.450,3.700),(20,100009,'2010-01-01',NULL,2.300,2.900),(21,10,'2010-01-01',NULL,1.600,1.600),(22,101,'2010-01-01',NULL,2.000,1.900),(23,102,'2010-01-01',NULL,1.800,1.500),(24,106,'2010-01-01',NULL,1.700,1.600),(25,107,'2010-01-01',NULL,1.000,0.850),(26,108,'2010-01-01',NULL,1.000,0.850),(27,11,'2010-01-01',NULL,1.600,1.600),(28,12,'2010-01-01',NULL,1.000,0.800),(29,13,'2010-01-01',NULL,1.000,0.850),(30,1391,'2010-01-01',NULL,0.800,0.700),(31,14,'2010-01-01',NULL,0.500,0.400),(32,1411,'2010-01-01',NULL,1.500,1.100),(33,1420,'2010-01-01',NULL,1.500,1.100),(34,143,'2010-01-01',NULL,0.800,0.700),(35,15,'2010-01-01',NULL,1.500,1.100),(36,16,'2010-01-01',NULL,2.250,2.900),(37,1624,'2010-01-01',NULL,2.100,2.000),(38,1629,'2010-01-01',NULL,2.100,2.000),(39,17,'2010-01-01',NULL,1.000,1.050),(40,171,'2010-01-01',NULL,2.000,1.500),(41,18,'2010-01-01',NULL,1.000,1.000),(42,19,'2010-01-01',NULL,1.900,2.550),(43,20,'2010-01-01',NULL,1.600,1.400),(44,204,'2010-01-01',NULL,1.500,1.200),(45,206,'2010-01-01',NULL,1.500,1.200),(46,21,'2010-01-01',NULL,1.300,1.100),(47,22,'2010-01-01',NULL,1.750,1.250),(48,23,'2010-01-01',NULL,2.100,2.000),(49,231,'2010-01-01',NULL,1.600,1.500),(50,232,'2010-01-01',NULL,1.600,1.500),(51,2331,'2010-01-01',NULL,1.600,1.500),(52,234,'2010-01-01',NULL,1.600,1.500),(53,237,'2010-01-01',NULL,2.750,3.350),(54,24,'2010-01-01',NULL,2.000,1.850),(55,25,'2010-01-01',NULL,2.000,1.850),(56,26,'2010-01-01',NULL,1.500,1.100),(57,27,'2010-01-01',NULL,1.600,1.200),(58,28,'2010-01-01',NULL,2.000,1.850),(59,29,'2010-01-01',NULL,1.600,1.200),(60,30,'2010-01-01',NULL,2.000,1.850),(61,3091,'2010-01-01',NULL,1.600,1.200),(62,3092,'2010-01-01',NULL,1.600,1.200),(63,31,'2010-01-01',NULL,2.000,1.850),(64,32,'2010-01-01',NULL,1.600,1.200),(65,321,'2010-01-01',NULL,1.000,0.850),(66,322,'2010-01-01',NULL,1.000,0.850),(67,33,'2010-01-01',NULL,2.000,1.850),(68,3313,'2010-01-01',NULL,1.500,1.100),(69,3314,'2010-01-01',NULL,1.600,1.200),(70,35,'2010-01-01',NULL,1.800,1.500),(71,36,'2010-01-01',NULL,2.100,1.600),(72,37,'2010-01-01',NULL,2.100,1.600),(73,38,'2010-01-01',NULL,2.100,1.600),(74,39,'2010-01-01',NULL,2.100,1.600),(75,41,'2010-01-01',NULL,3.350,3.350),(76,411,'2010-01-01',NULL,0.850,0.800),(77,42,'2010-01-01',NULL,3.350,3.350),(78,43,'2010-01-01',NULL,3.350,3.350),(79,45,'2010-01-01',NULL,1.000,1.000),(80,452,'2010-01-01',NULL,2.450,2.000),(81,454,'2010-01-01',NULL,1.700,1.200),(82,46,'2010-01-01',NULL,1.400,1.200),(83,4623,'2010-01-01',NULL,1.800,1.500),(84,4624,'2010-01-01',NULL,1.800,1.500),(85,4632,'2010-01-01',NULL,1.800,1.500),(86,4638,'2010-01-01',NULL,1.600,1.400),(87,4672,'2010-01-01',NULL,1.800,1.500),(88,4673,'2010-01-01',NULL,1.800,1.500),(89,4674,'2010-01-01',NULL,1.800,1.550),(90,4677,'2010-01-01',NULL,1.800,1.550),(91,4690,'2010-01-01',NULL,1.800,1.550),(92,47,'2010-01-01',NULL,0.950,0.700),(93,473,'2010-01-01',NULL,1.000,0.850),(94,49,'2010-01-01',NULL,1.800,1.500),(95,494,'2010-01-01',NULL,2.000,1.700),(96,50,'2010-01-01',NULL,2.000,1.850),(97,51,'2010-01-01',NULL,1.900,1.700),(98,52,'2010-01-01',NULL,1.800,1.500),(99,5221,'2010-01-01',NULL,1.000,1.100),(100,53,'2010-01-01',NULL,0.950,0.700),(101,55,'2010-01-01',NULL,0.750,0.500),(102,56,'2010-01-01',NULL,0.750,0.500),(103,58,'2010-01-01',NULL,0.650,1.000),(104,59,'2010-01-01',NULL,0.750,0.500),(105,60,'2010-01-01',NULL,0.750,0.500),(106,61,'2010-01-01',NULL,0.700,0.700),(107,62,'2010-01-01',NULL,0.650,1.000),(108,63,'2010-01-01',NULL,0.650,1.000),(109,6391,'2010-01-01',NULL,0.750,0.500),(110,64,'2010-01-01',NULL,0.650,0.350),(111,65,'2010-01-01',NULL,0.650,0.350),(112,66,'2010-01-01',NULL,0.650,0.350),(113,68,'2010-01-01',NULL,0.650,1.000),(114,69,'2010-01-01',NULL,0.650,1.000),(115,70,'2010-01-01',NULL,1.000,0.800),(116,71,'2010-01-01',NULL,0.650,1.000),(117,72,'2010-01-01',NULL,0.650,0.350),(118,73,'2010-01-01',NULL,0.900,0.800),(119,74,'2010-01-01',NULL,0.900,0.850),(120,742,'2010-01-01',NULL,0.500,0.400),(121,75,'2010-01-01',NULL,1.500,1.100),(122,77,'2010-01-01',NULL,1.000,1.000),(123,78,'2010-01-01',NULL,1.550,1.200),(124,781,'2010-01-01',NULL,0.950,1.000),(125,79,'2010-01-01',NULL,0.800,0.700),(126,80,'2010-01-01',NULL,1.400,2.200),(127,81,'2010-01-01',NULL,2.100,1.500),(128,811,'2010-01-01',NULL,1.000,0.850),(129,82,'2010-01-01',NULL,1.000,1.050),(130,8220,'2010-01-01',NULL,0.700,0.700),(131,8292,'2010-01-01',NULL,1.800,1.500),(132,84,'2010-01-01',NULL,0.650,1.000),(133,842,'2010-01-01',NULL,1.400,2.200),(134,85,'2010-01-01',NULL,0.650,0.350),(135,86,'2010-01-01',NULL,0.800,0.700),(136,87,'2010-01-01',NULL,0.800,0.700),(137,88,'2010-01-01',NULL,0.800,0.700),(138,90,'2010-01-01',NULL,0.750,0.500),(139,91,'2010-01-01',NULL,0.750,0.500),(140,9104,'2010-01-01',NULL,1.750,1.200),(141,92,'2010-01-01',NULL,0.750,0.500),(142,93,'2010-01-01',NULL,1.700,1.300),(143,94,'2010-01-01',NULL,0.650,1.000),(144,95,'2010-01-01',NULL,1.500,1.100),(145,9524,'2010-01-01',NULL,2.000,1.850),(146,96,'2010-01-01',NULL,0.800,0.700),(147,9602,'2010-01-01',NULL,0.650,0.450),(148,9603,'2010-01-01',NULL,1.800,1.500),(149,9609,'2010-01-01',NULL,1.500,1.100),(150,97,'2010-01-01',NULL,0.650,0.450),(151,99,'2010-01-01',NULL,1.600,1.500),(304,100001,'2014-01-01',NULL,1.500,1.100),(305,10000113,'2014-01-01',NULL,1.150,1.100),(306,10000119,'2014-01-01',NULL,1.150,1.100),(307,10000129,'2014-01-01',NULL,2.250,2.900),(308,10000130,'2014-01-01',NULL,1.150,1.100),(309,1000014,'2014-01-01',NULL,1.800,1.500),(310,10000147,'2014-01-01',NULL,1.250,1.150),(311,1000015,'2014-01-01',NULL,1.600,1.200),(312,1000016,'2014-01-01',NULL,1.600,1.200),(313,10000164,'2014-01-01',NULL,1.150,1.100),(314,1000017,'2014-01-01',NULL,1.800,1.500),(315,100002,'2014-01-01',NULL,2.250,2.900),(316,100003,'2014-01-01',NULL,3.050,3.350),(317,10000322,'2014-01-01',NULL,3.050,3.200),(318,100005,'2014-01-01',NULL,2.300,2.900),(319,100006,'2014-01-01',NULL,2.300,2.900),(320,100007,'2014-01-01',NULL,2.300,2.900),(321,100008,'2014-01-01',NULL,2.300,2.900),(322,10000811,'2014-01-01',NULL,3.450,3.700),(323,100009,'2014-01-01',NULL,2.300,2.900),(324,10,'2014-01-01',NULL,1.600,1.600),(325,101,'2014-01-01',NULL,2.000,1.900),(326,102,'2014-01-01',NULL,1.800,1.500),(327,106,'2014-01-01',NULL,1.700,1.600),(328,107,'2014-01-01',NULL,1.050,0.900),(329,108,'2014-01-01',NULL,1.050,0.900),(330,11,'2014-01-01',NULL,1.600,1.600),(331,12,'2014-01-01',NULL,1.000,0.800),(332,13,'2014-01-01',NULL,1.000,0.850),(333,1391,'2014-01-01',NULL,0.800,0.700),(334,14,'2014-01-01',NULL,0.500,0.400),(335,1411,'2014-01-01',NULL,1.500,1.100),(336,1420,'2014-01-01',NULL,1.500,1.100),(337,143,'2014-01-01',NULL,0.800,0.700),(338,15,'2014-01-01',NULL,1.500,1.100),(339,16,'2014-01-01',NULL,2.250,2.900),(340,1624,'2014-01-01',NULL,2.100,2.000),(341,1629,'2014-01-01',NULL,2.100,2.000),(342,17,'2014-01-01',NULL,1.000,1.050),(343,171,'2014-01-01',NULL,2.000,1.500),(344,18,'2014-01-01',NULL,1.000,1.000),(345,19,'2014-01-01',NULL,1.450,1.900),(346,20,'2014-01-01',NULL,1.600,1.400),(347,204,'2014-01-01',NULL,1.500,1.200),(348,206,'2014-01-01',NULL,1.500,1.200),(349,21,'2014-01-01',NULL,1.300,1.100),(350,22,'2014-01-01',NULL,1.750,1.250),(351,23,'2014-01-01',NULL,2.100,2.000),(352,231,'2014-01-01',NULL,1.600,1.500),(353,232,'2014-01-01',NULL,1.600,1.500),(354,2331,'2014-01-01',NULL,1.600,1.500),(355,234,'2014-01-01',NULL,1.600,1.500),(356,237,'2014-01-01',NULL,2.750,3.350),(357,24,'2014-01-01',NULL,2.000,1.850),(358,25,'2014-01-01',NULL,2.000,1.850),(359,26,'2014-01-01',NULL,1.500,1.100),(360,27,'2014-01-01',NULL,1.600,1.200),(361,28,'2014-01-01',NULL,2.000,1.850),(362,29,'2014-01-01',NULL,1.600,1.200),(363,30,'2014-01-01',NULL,2.000,1.850),(364,3091,'2014-01-01',NULL,1.600,1.200),(365,3092,'2014-01-01',NULL,1.600,1.200),(366,31,'2014-01-01',NULL,2.000,1.850),(367,32,'2014-01-01',NULL,1.600,1.200),(368,321,'2014-01-01',NULL,1.000,0.850),(369,322,'2014-01-01',NULL,1.000,0.850),(370,33,'2014-01-01',NULL,2.000,1.850),(371,3313,'2014-01-01',NULL,1.500,1.100),(372,3314,'2014-01-01',NULL,1.600,1.200),(373,35,'2014-01-01',NULL,1.800,1.500),(374,36,'2014-01-01',NULL,2.100,1.600),(375,37,'2014-01-01',NULL,2.100,1.600),(376,38,'2014-01-01',NULL,2.100,1.600),(377,39,'2014-01-01',NULL,2.100,1.600),(378,41,'2014-01-01',NULL,3.350,3.350),(379,411,'2014-01-01',NULL,0.850,0.800),(380,42,'2014-01-01',NULL,3.350,3.350),(381,43,'2014-01-01',NULL,3.350,3.350),(382,45,'2014-01-01',NULL,1.000,1.050),(383,452,'2014-01-01',NULL,2.450,2.000),(384,454,'2014-01-01',NULL,1.700,1.200),(385,46,'2014-01-01',NULL,1.400,1.200),(386,4623,'2014-01-01',NULL,1.800,1.500),(387,4624,'2014-01-01',NULL,1.800,1.500),(388,4632,'2014-01-01',NULL,1.800,1.500),(389,4638,'2014-01-01',NULL,1.600,1.400),(390,4672,'2014-01-01',NULL,1.800,1.500),(391,4673,'2014-01-01',NULL,1.800,1.500),(392,4674,'2014-01-01',NULL,1.800,1.550),(393,4677,'2014-01-01',NULL,1.800,1.550),(394,4690,'2014-01-01',NULL,1.800,1.550),(395,47,'2014-01-01',NULL,0.950,0.700),(396,473,'2014-01-01',NULL,1.000,0.850),(397,49,'2014-01-01',NULL,1.800,1.500),(398,494,'2014-01-01',NULL,2.000,1.700),(399,50,'2014-01-01',NULL,2.000,1.850),(400,51,'2014-01-01',NULL,1.900,1.700),(401,52,'2014-01-01',NULL,1.800,1.500),(402,5221,'2014-01-01',NULL,1.000,1.100),(403,53,'2014-01-01',NULL,1.000,0.750),(404,55,'2014-01-01',NULL,0.750,0.500),(405,56,'2014-01-01',NULL,0.750,0.500),(406,58,'2014-01-01',NULL,0.650,1.000),(407,59,'2014-01-01',NULL,0.750,0.500),(408,60,'2014-01-01',NULL,0.750,0.500),(409,61,'2014-01-01',NULL,0.700,0.700),(410,62,'2014-01-01',NULL,0.650,0.700),(411,63,'2014-01-01',NULL,0.650,1.000),(412,6391,'2014-01-01',NULL,0.750,0.500),(413,64,'2014-01-01',NULL,0.650,0.350),(414,65,'2014-01-01',NULL,0.650,0.350),(415,66,'2014-01-01',NULL,0.650,0.350),(416,68,'2014-01-01',NULL,0.650,1.000),(417,69,'2014-01-01',NULL,0.650,0.700),(418,70,'2014-01-01',NULL,0.750,0.600),(419,71,'2014-01-01',NULL,0.650,1.000),(420,72,'2014-01-01',NULL,0.650,0.350),(421,73,'2014-01-01',NULL,0.900,0.800),(422,74,'2014-01-01',NULL,0.900,0.850),(423,742,'2014-01-01',NULL,0.500,0.400),(424,75,'2014-01-01',NULL,1.500,1.100),(425,77,'2014-01-01',NULL,1.000,1.000),(426,78,'2014-01-01',NULL,1.550,1.200),(427,781,'2014-01-01',NULL,0.950,1.000),(428,79,'2014-01-01',NULL,0.800,0.700),(429,80,'2014-01-01',NULL,1.400,2.200),(430,81,'2014-01-01',NULL,2.100,1.500),(431,811,'2014-01-01',NULL,1.000,0.850),(432,82,'2014-01-01',NULL,1.000,1.050),(433,8220,'2014-01-01',NULL,0.700,0.700),(434,8292,'2014-01-01',NULL,1.800,1.500),(435,84,'2014-01-01',NULL,0.650,1.000),(436,842,'2014-01-01',NULL,1.400,2.200),(437,85,'2014-01-01',NULL,0.650,0.350),(438,86,'2014-01-01',NULL,0.800,0.700),(439,87,'2014-01-01',NULL,0.800,0.700),(440,88,'2014-01-01',NULL,0.800,0.700),(441,90,'2014-01-01',NULL,0.750,0.500),(442,91,'2014-01-01',NULL,0.750,0.500),(443,9104,'2014-01-01',NULL,1.750,1.200),(444,92,'2014-01-01',NULL,0.750,0.500),(445,93,'2014-01-01',NULL,1.700,1.300),(446,94,'2014-01-01',NULL,0.650,1.000),(447,95,'2014-01-01',NULL,1.500,1.100),(448,9524,'2014-01-01',NULL,2.000,1.850),(449,96,'2014-01-01',NULL,0.850,0.700),(450,9602,'2014-01-01',NULL,0.650,0.450),(451,9603,'2014-01-01',NULL,1.800,1.500),(452,9609,'2014-01-01',NULL,1.500,1.100),(453,97,'2014-01-01',NULL,0.650,0.450),(454,99,'2014-01-01',NULL,1.200,1.150),(455,869,'2014-01-01',NULL,0.950,0.800);
/*!40000 ALTER TABLE `cnae2009_rate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cno`
--

DROP TABLE IF EXISTS `cno`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cno` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `code` varchar(5) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Codigo del CNO',
  `title` varchar(255) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Titulo del CNO',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=9821 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='CNO';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cno`
--

LOCK TABLES `cno` WRITE;
/*!40000 ALTER TABLE `cno` DISABLE KEYS */;
INSERT INTO `cno` VALUES (11,'0011','Oficiales de las fuerzas armadas'),(12,'0012','Suboficiales de las fuerzas armadas'),(20,'0020','Tropa y marinería de las fuerzas armadas'),(1111,'1111','Miembros del poder ejecutivo (nacional, autonómico y local) y del poder legislativo'),(1112,'1112','Personal directivo de la Administración Pública'),(1113,'1113','Directores de organizaciones de interés social'),(1120,'1120','Directores generales y presidentes ejecutivos'),(1211,'1211','Directores financieros'),(1212,'1212','Directores de recursos humanos'),(1219,'1219','Directores de políticas y planificación y de otros departamentos administrativos no clasificados bajo otros epígrafes'),(1221,'1221','Directores comerciales y de ventas'),(1222,'1222','Directores de publicidad y relaciones públicas'),(1223,'1223','Directores de investigación y desarrollo'),(1311,'1311','Directores de producción de explotaciones agropecuarias y forestales'),(1312,'1312','Directores de producción de explotaciones pesqueras y acuícolas'),(1313,'1313','Directores de industrias manufactureras'),(1314,'1314','Directores de explotaciones mineras'),(1315,'1315','Directores de empresas de abastecimiento, transporte, distribución y afines'),(1316,'1316','Directores de empresas de construcción'),(1321,'1321','Directores de servicios de tecnologías de la información y las comunicaciones (TIC)'),(1322,'1322','Directores de servicios sociales para niños'),(1323,'1323','Directores-gerentes de centros sanitarios'),(1324,'1324','Directores de servicios sociales para personas mayores'),(1325,'1325','Directores de otros servicios sociales'),(1326,'1326','Directores de servicios de educación'),(1327,'1327','Directores de sucursales de bancos, de servicios financieros y de seguros'),(1329,'1329','Directores de otras empresas de servicios profesionales no clasificados bajo otros epígrafes'),(1411,'1411','Directores y gerentes de hoteles'),(1419,'1419','Directores y gerentes de otras empresas de servicios de alojamiento'),(1421,'1421','Directores y gerentes de restaurantes'),(1422,'1422','Directores y gerentes de bares, cafeterías y similares'),(1429,'1429','Directores y gerentes de empresas de catering y otras empresas de restauración'),(1431,'1431','Directores y gerentes de empresas de comercio al por mayor'),(1432,'1432','Directores y gerentes de empresas de comercio al por menor'),(1501,'1501','Directores y gerentes de empresas de actividades recreativas, culturales y deportivas'),(1509,'1509','Directores y gerentes de empresas de gestión de residuos y de otras empresas de servicios no clasificados bajo otros epígrafes'),(2111,'2111','Médicos de familia'),(2112,'2112','Otros médicos especialistas'),(2121,'2121','Enfermeros no especializados'),(2122,'2122','Enfermeros especializados (excepto matronos)'),(2123,'2123','Matronos'),(2130,'2130','Veterinarios'),(2140,'2140','Farmacéuticos'),(2151,'2151','Odontólogos y estomatólogos'),(2152,'2152','Fisioterapeutas'),(2153,'2153','Dietistas y nutricionistas'),(2154,'2154','Logopedas'),(2155,'2155','ópticos-optometristas'),(2156,'2156','Terapeutas ocupacionales'),(2157,'2157','Podólogos'),(2158,'2158','Profesionales de la salud y la higiene laboral y ambiental'),(2159,'2159','Profesionales de la salud no clasificados bajo otros epígrafes'),(2210,'2210','Profesores de universidades y otra enseñanza superior (excepto formación profesional)'),(2220,'2220','Profesores de formación profesional (materias específicas)'),(2230,'2230','Profesores de enseñanza secundaria (excepto materias específicas de formación profesional)'),(2240,'2240','Profesores de enseñanza primaria'),(2251,'2251','Maestros de educación infantil'),(2252,'2252','Técnicos en educación infantil'),(2311,'2311','Profesores de educación especial'),(2312,'2312','Técnicos educadores de educación especial'),(2321,'2321','Especialistas en métodos didácticos y pedagágicos'),(2322,'2322','Profesores de enseñanza no reglada de idiomas'),(2323,'2323','Profesores de enseñanza no reglada de música y danza'),(2324,'2324','Profesores de enseñanza no reglada de artes '),(2325,'2325','Instructores en tecnologías de la información en enseñanza no reglada'),(2326,'2326','Profesionales de la educación ambiental'),(2329,'2329','Profesores y profesionales de la enseñanza no clasificados bajo otros epígrafes'),(2411,'2411','Físicos y astrónomos'),(2412,'2412','Meteorólogos'),(2413,'2413','Químicos'),(2414,'2414','Geólogos y geofísicos'),(2415,'2415','Matemáticos y actuarios'),(2416,'2416','Estadísticos'),(2421,'2421','Biólogos, botánicos, zoólogos y afines'),(2422,'2422','Ingenieros agrónomos'),(2423,'2423','Ingenieros de montes'),(2424,'2424','Ingenieros técnicos agrícolas'),(2425,'2425','Ingenieros técnicos forestales y del medio natural'),(2426,'2426','Profesionales de la protección ambiental'),(2427,'2427','Enólogos'),(2431,'2431','Ingenieros industriales y de producción'),(2432,'2432','Ingenieros en construcción y obra civil'),(2433,'2433','Ingenieros mecánicos'),(2434,'2434','Ingenieros aeronáuticos'),(2435,'2435','Ingenieros químicos'),(2436,'2436','Ingenieros de minas, metalúrgicos y afines'),(2437,'2437','Ingenieros ambientales'),(2439,'2439','Ingenieros no clasificados bajo otros epígrafes'),(2441,'2441','Ingenieros en electricidad'),(2442,'2442','Ingenieros electrónicos'),(2443,'2443','Ingenieros en telecomunicaciones'),(2451,'2451','Arquitectos (excepto arquitectos paisajistas y urbanistas)'),(2452,'2452','Arquitectos paisajistas'),(2453,'2453','Urbanistas e ingenieros de tráfico'),(2454,'2454','Ingenieros geágrafos y cartógrafos'),(2461,'2461','Ingenieros técnicos industriales y de producción'),(2462,'2462','Ingenieros técnicos de obras públicas'),(2463,'2463','Ingenieros técnicos mecánicos'),(2464,'2464','Ingenieros técnicos aeronáuticos'),(2465,'2465','Ingenieros técnicos químicos'),(2466,'2466','Ingenieros técnicos de minas, metalúrgicos y afines'),(2469,'2469','Ingenieros técnicos no clasificados bajo otros epígrafes'),(2471,'2471','Ingenieros técnicos en electricidad'),(2472,'2472','Ingenieros técnicos en electrónica'),(2473,'2473','Ingenieros técnicos en telecomunicaciones'),(2481,'2481','Arquitectos técnicos y técnicos urbanistas'),(2482,'2482','Diseñadores de productos y de prendas'),(2483,'2483','Ingenieros técnicos en topografía'),(2484,'2484','Diseñadores gráficos y multimedia'),(2511,'2511','Abogados'),(2512,'2512','Fiscales'),(2513,'2513','Jueces y magistrados'),(2591,'2591','Notarios y registradores'),(2592,'2592','Procuradores'),(2599,'2599','Profesionales del derecho no clasificados bajo otros epígrafes'),(2611,'2611','Especialistas en contabilidad'),(2612,'2612','Asesores financieros y en inversiones'),(2613,'2613','Analistas financieros'),(2621,'2621','Analistas de gestión y organización'),(2622,'2622','Especialistas en administración de política de empresas'),(2623,'2623','Especialistas de la Administración Pública'),(2624,'2624','Especialistas en políticas y servicios de personal y afines'),(2625,'2625','Especialistas en formación de personal'),(2630,'2630','Técnicos de empresas y actividades turísticas'),(2640,'2640','Profesionales de ventas técnicas y médicas (excepto las TIC)'),(2651,'2651','Profesionales de la publicidad y la comercialización'),(2652,'2652','Profesionales de relaciones públicas'),(2653,'2653','Profesionales de la venta de tecnologías de la información y las comunicaciones'),(2711,'2711','Analistas de sistemas'),(2712,'2712','Analistas y diseñadores de software'),(2713,'2713','Analistas, programadores y diseñadores Web y multimedia'),(2719,'2719','Analistas y diseñadores de software y multimedia no clasificados bajo otros epígrafes'),(2721,'2721','Diseñadores y administradores de bases de datos'),(2722,'2722','Administradores de sistemas y redes'),(2723,'2723','Analistas de redes informáticas'),(2729,'2729','Especialistas en bases de datos y en redes informáticas no clasificados bajo otros epígrafes'),(2810,'2810','Economistas'),(2821,'2821','Sociólogos, geógrafos, antropólogos, arqueólogos y afines'),(2822,'2822','Filósofos, historiadores y profesionales en ciencias políticas'),(2823,'2823','Psicólogos'),(2824,'2824','Profesionales del trabajo y la educación social'),(2825,'2825','Agentes de igualdad de oportunidades entre mujeres y hombres'),(2830,'2830','Sacerdotes de las distintas religiones'),(2911,'2911','Archivistas y conservadores de museos'),(2912,'2912','Bibliotecarios, documentalistas y afines'),(2921,'2921','Escritores'),(2922,'2922','Periodistas'),(2923,'2923','Filólogos, intérpretes y traductores'),(2931,'2931','Artistas de artes plásticas y visuales'),(2932,'2932','Compositores, músicos y cantantes'),(2933,'2933','Coreógrafos y bailarines'),(2934,'2934','Directores de cine, de teatro y afines'),(2935,'2935','Actores'),(2936,'2936','Locutores de radio, televisión y otros presentadores'),(2937,'2937','Profesionales de espectáculos taurinos'),(2939,'2939','Artistas creativos e interpretativos no clasificados bajo otros epígrafes'),(3110,'3110','Delineantes y dibujantes técnicos'),(3121,'3121','Técnicos en ciencias físicas y químicas'),(3122,'3122','Técnicos en construcción'),(3123,'3123','Técnicos en electricidad'),(3124,'3124','Técnicos en electrónica (excepto electro medicina)'),(3125,'3125','Técnicos en electrónica, especialidad en electro medicina'),(3126,'3126','Técnicos en mecánica'),(3127,'3127','Técnicos y analistas de laboratorio en química industrial'),(3128,'3128','Técnicos en metalurgia y minas'),(3129,'3129','Otros técnicos de las ciencias físicas, químicas, medioambientales y de las ingenierías'),(3131,'3131','Técnicos en instalaciones de producción de energía'),(3132,'3132','Técnicos en instalaciones de tratamiento de residuos, de aguas y otros operadores en plantas similares'),(3133,'3133','Técnicos en control de instalaciones de procesamiento de productos químicos'),(3134,'3134','Técnicos de refinerías de petróleo y gas natural'),(3135,'3135','Técnicos en control de procesos de producción de metales'),(3139,'3139','Técnicos en control de procesos no clasificados bajo otros epígrafes'),(3141,'3141','Técnicos en ciencias biológicas (excepto en áreas sanitarias)'),(3142,'3142','Técnicos agropecuarios'),(3143,'3143','Técnicos forestales y del medio natural'),(3151,'3151','Jefes y oficiales de máquinas'),(3152,'3152','Capitanes y oficiales de puente'),(3153,'3153','Pilotos de aviación y profesionales afines'),(3154,'3154','Controladores de tráfico aéreo'),(3155,'3155','Técnicos en seguridad aeronáutica'),(3160,'3160','Técnicos de control de calidad de las ciencias físicas, químicas y de las ingenierías'),(3201,'3201','Supervisores en ingeniería de minas'),(3202,'3202','Supervisores de la construcción'),(3203,'3203','Supervisores de industrias alimenticias y del tabaco'),(3204,'3204','Supervisores de industrias química y farmacéutica'),(3205,'3205','Supervisores de industrias de transformación de plásticos, caucho y resinas naturales'),(3206,'3206','Supervisores de industrias de la madera y pastero papeleras'),(3207,'3207','Supervisores de la producción en industrias de artes gráficas y en la fabricación de productos de papel'),(3209,'3209','Supervisores de otras industrias manufactureras'),(3311,'3311','Técnicos en radioterapia'),(3312,'3312','Técnicos en imagen para el diagnóstico'),(3313,'3313','Técnicos en anatomía patológica y citología'),(3314,'3314','Técnicos en laboratorio de diagnóstico clínico'),(3315,'3315','Técnicos en ortoprótesis'),(3316,'3316','Técnicos en prótesis dentales'),(3317,'3317','Técnicos en audioprótesis'),(3321,'3321','Técnicos superiores en higiene bucodental'),(3322,'3322','Técnicos superiores en documentación sanitaria'),(3323,'3323','Técnicos superiores en dietética'),(3324,'3324','Técnicos en optometría'),(3325,'3325','Ayudantes fisioterapeutas'),(3326,'3326','Técnicos en prevención de riesgos laborales y salud ambiental'),(3327,'3327','Ayudantes de veterinaria'),(3329,'3329','Técnicos de la sanidad no clasificados bajo otros epígrafes'),(3331,'3331','Profesionales de la acupuntura, la naturopatía, la homeopatía, la medicina tradicional china y la ayurveda'),(3339,'3339','Otros profesionales de las terapias alternativas'),(3401,'3401','Profesionales de apoyo e intermediarios de cambio, bolsa y finanzas'),(3402,'3402','Comerciales de préstamos y créditos'),(3403,'3403','Tenedores de libros'),(3404,'3404','Profesionales de apoyo en servicios estadísticos, matemáticos y afines'),(3405,'3405','Tasadores'),(3510,'3510','Agentes y representantes comerciales'),(3521,'3521','Mediadores y agentes de seguros'),(3522,'3522','Agentes de compras'),(3523,'3523','Consignatarios'),(3531,'3531','Representantes de aduanas'),(3532,'3532','Organizadores de conferencias y eventos'),(3533,'3533','Agentes o intermediarios en la contratación de la mano de obra (excepto representantes de espectáculos)'),(3534,'3534','Agentes y administradores de la propiedad inmobiliaria'),(3535,'3535','Portavoces y agentes de relaciones públicas'),(3539,'3539','Representantes artísticos y deportivos y otros agentes de servicios comerciales no clasificados bajo otros epígrafes'),(3611,'3611','Supervisores de secretaría'),(3612,'3612','Asistentes jurídico-legales'),(3613,'3613','Asistentes de dirección y administrativos'),(3614,'3614','Secretarios de centros médicos o clínicas'),(3621,'3621','Profesionales de apoyo de la Administración Pública de tributos'),(3622,'3622','Profesionales de apoyo de la Administración Pública de servicios sociales'),(3623,'3623','Profesionales de apoyo de la Administración Pública de servicios de expedición de licencias'),(3629,'3629','Otros profesionales de apoyo de la Administración Pública para tareas de inspección y control y tareas similares'),(3631,'3631','Técnicos de la policía nacional, autonómica y local'),(3632,'3632','Suboficiales de la guardia civil'),(3711,'3711','Profesionales de apoyo de servicios jurídicos y servicios similares'),(3712,'3712','Detectives privados'),(3713,'3713','Profesionales de apoyo al trabajo y a la educación social'),(3714,'3714','Promotores de igualdad de oportunidades entre mujeres y hombres'),(3715,'3715','Animadores comunitarios'),(3716,'3716','Auxiliares laicos de las religiones'),(3721,'3721','Atletas y deportistas'),(3722,'3722','Entrenadores y árbitros de actividades deportivas'),(3723,'3723','Instructores de actividades deportivas'),(3724,'3724','Monitores de actividades recreativas y de entretenimiento'),(3731,'3731','Fotógrafos'),(3732,'3732','Diseñadores y decoradores de interior'),(3733,'3733','Técnicos en galerías de arte, museos y bibliotecas'),(3734,'3734','Chefs'),(3739,'3739','Otros técnicos y profesionales de apoyo de actividades culturales y artísticas'),(3811,'3811','Técnicos en operaciones de sistemas informáticos'),(3812,'3812','Técnicos en asistencia al usuario de tecnologías de la información'),(3813,'3813','Técnicos en redes'),(3814,'3814','Técnicos de la Web'),(3820,'3820','Programadores informáticos'),(3831,'3831','Técnicos de grabación audiovisual'),(3832,'3832','Técnicos de radiodifusión'),(3833,'3833','Técnicos de ingeniería de las telecomunicaciones'),(4111,'4111','Empleados de contabilidad'),(4112,'4112','Empleados de control de personal y nóminas'),(4113,'4113','Empleados de oficina de servicios estadísticos, financieros y bancarios'),(4121,'4121','Empleados de control de abastecimientos e inventario'),(4122,'4122','Empleados de oficina de servicios de apoyo a la producción'),(4123,'4123','Empleados de logística y transporte de pasajeros y mercancías'),(4210,'4210','Empleados de bibliotecas y archivos'),(4221,'4221','Empleados de servicios de correos (excepto empleados de mostrador)'),(4222,'4222','Codificadores y correctores de imprenta'),(4223,'4223','Empleados de servicio de personal'),(4301,'4301','Grabadores de datos'),(4309,'4309','Empleados administrativos sin tareas de atención al público no clasificados bajo otros epígrafes'),(4411,'4411','Empleados de información al usuario'),(4412,'4412','Recepcionistas (excepto de hoteles)'),(4421,'4421','Empleados de agencias de viajes'),(4422,'4422','Recepcionistas de hoteles'),(4423,'4423','Telefonistas'),(4424,'4424','Teleoperadores'),(4430,'4430','Agentes de encuestas'),(4441,'4441','Cajeros de bancos y afines'),(4442,'4442','Empleados de venta de apuestas'),(4443,'4443','Empleados de sala de juegos y afines'),(4444,'4444','Empleados de casas de empeño y de préstamos'),(4445,'4445','Cobradores de facturas, deudas y empleados afines'),(4446,'4446','Empleados de mostrador de correos'),(4500,'4500','Empleados administrativos con tareas de atención al público no clasificados bajo otros epígrafes'),(5000,'5000','Camareros y cocineros propietarios'),(5110,'5110','Cocineros asalariados'),(5120,'5120','Camareros asalariados'),(5210,'5210','Jefes de sección de tiendas y almacenes'),(5220,'5220','Vendedores en tiendas y almacenes'),(5300,'5300','Comerciantes propietarios de tiendas'),(5411,'5411','Vendedores en quioscos'),(5412,'5412','Vendedores en mercados ocasionales y mercadillos'),(5420,'5420','Operadores de telemarketing'),(5430,'5430','Expendedores de gasolineras'),(5491,'5491','Vendedores a domicilio'),(5492,'5492','Promotores de venta'),(5493,'5493','Modelos de moda, arte y publicidad'),(5499,'5499','Vendedores no clasificados bajo otros epígrafes'),(5500,'5500','Cajeros y taquilleros (excepto bancos)'),(5611,'5611','Auxiliares de enfermería hospitalaria'),(5612,'5612','Auxiliares de enfermería de atención primaria'),(5621,'5621','Técnicos auxiliares de farmacia'),(5622,'5622','Técnicos de emergencias sanitarias'),(5629,'5629','Trabajadores de los cuidados a las personas en servicios de salud no clasificados bajo otros epígrafes'),(5710,'5710','Trabajadores de los cuidados personales a domicilio'),(5721,'5721','Cuidadores de niños en guarderías y centros educativos'),(5722,'5722','Cuidadores de niños en domicilios'),(5811,'5811','Peluqueros'),(5812,'5812','Especialistas en tratamientos de estática, bienestar y afines'),(5821,'5821','Auxiliares de vuelo y camareros de avión, barco y tren'),(5822,'5822','Revisores y cobradores de transporte terrestre'),(5823,'5823','Acompañantes turísticos'),(5824,'5824','Azafatos de tierra'),(5825,'5825','Guías de turismo'),(5831,'5831','Supervisores de mantenimiento y limpieza en oficinas, hoteles y otros establecimientos'),(5832,'5832','Mayordomos del servicio doméstico'),(5833,'5833','Conserjes de edificios'),(5840,'5840','Trabajadores propietarios de pequeños alojamientos'),(5891,'5891','Asistentes personales o personas de compañía'),(5892,'5892','Empleados de pompas fúnebres y embalsamadores'),(5893,'5893','Cuidadores de animales y adiestradores'),(5894,'5894','Instructores de autoescuela'),(5895,'5895','Astrólogos, adivinadores y afines'),(5899,'5899','Trabajadores de servicios personales no clasificados bajo otros epígrafes'),(5910,'5910','Guardias civiles'),(5921,'5921','Policías nacionales'),(5922,'5922','Policías autonómicos'),(5923,'5923','Policías locales'),(5931,'5931','Bomberos (excepto forestales)'),(5932,'5932','Bomberos forestales'),(5941,'5941','Vigilantes de seguridad y similares habilitados para ir armados'),(5942,'5942','Auxiliares de vigilante de seguridad y similares no habilitados para ir armados'),(5991,'5991','Vigilantes de prisiones'),(5992,'5992','Bañistas-socorristas'),(5993,'5993','Agentes forestales y medioambientales'),(5999,'5999','Trabajadores de los servicios de protección y seguridad no clasificados bajo otros epígrafes'),(6110,'6110','Trabajadores cualificados en actividades agrícolas (excepto en huertas, invernaderos, viveros y jardines)'),(6120,'6120','Trabajadores cualificados en huertas, invernaderos, viveros y jardines'),(6201,'6201','Trabajadores cualificados en actividades ganaderas de vacuno'),(6202,'6202','Trabajadores cualificados en actividades ganaderas de ovino y caprino'),(6203,'6203','Trabajadores cualificados en actividades ganaderas de porcino'),(6204,'6204','Trabajadores cualificados en apicultura y sericicultura'),(6205,'6205','Trabajadores cualificados en la avicultura y la cunicultura'),(6209,'6209','Trabajadores cualificados en actividades ganaderas no clasificados bajo otros epígrafes'),(6300,'6300','Trabajadores cualificados en actividades agropecuarias mixtas'),(6410,'6410','Trabajadores cualificados en actividades forestales y del medio natural'),(6421,'6421','Trabajadores cualificados en la acuicultura'),(6422,'6422','Pescadores de aguas costeras y aguas dulces'),(6423,'6423','Pescadores de altura'),(6430,'6430','Trabajadores cualificados en actividades cinegéticas'),(7111,'7111','Encofradores y operarios de puesta en obra de hormigón'),(7112,'7112','Montadores de prefabricados estructurales (sólo hormigón)'),(7121,'7121','Albañiles'),(7122,'7122','Canteros, tronzadores, labrantes y grabadores de piedras'),(7131,'7131','Carpinteros (excepto ebanistas)'),(7132,'7132','Instaladores de cerramientos metálicos y carpinteros metálicos (excepto montadores de estructuras metálicas)'),(7191,'7191','Mantenedores de edificios'),(7192,'7192','Instaladores de fachadas técnicas'),(7193,'7193','Instaladores de sistemas de impermeabilización en edificios'),(7199,'7199','Otros trabajadores de las obras estructurales de construcción no clasificados bajo otros epígrafes'),(7211,'7211','Escayolistas'),(7212,'7212','Aplicadores de revestimientos de pasta y mortero'),(7221,'7221','Fontaneros'),(7222,'7222','Montadores-instaladores de gas en edificios'),(7223,'7223','Instaladores de conductos en obra pública'),(7231,'7231','Pintores y empapeladores'),(7232,'7232','Pintores en las industrias manufactureras'),(7240,'7240','Soladores, colocadores de parquet y afines'),(7250,'7250','Mecánicos-instaladores de refrigeración y climatización'),(7291,'7291','Montadores de cubiertas'),(7292,'7292','Instaladores de material aislante térmico y de insonorización'),(7293,'7293','Cristaleros'),(7294,'7294','Montadores-instaladores de placas de energía solar'),(7295,'7295','Personal de limpieza de fachadas de edificios y chimeneas'),(7311,'7311','Moldeadores y macheros'),(7312,'7312','Soldadores y oxicortadores'),(7313,'7313','Chapistas y caldereros'),(7314,'7314','Montadores de estructuras metálicas'),(7315,'7315','Montadores de estructuras cableadas y empalmadores de cables'),(7321,'7321','Herreros y forjadores'),(7322,'7322','Trabajadores de la fabricación de herramientas, mecánico-ajustadores, modelistas, matriceros y afines'),(7323,'7323','Ajustadores y operadores de máquinas-herramienta'),(7324,'7324','Pulidores de metales y afiladores de herramientas'),(7401,'7401','Mecánicos y ajustadores de vehículos de motor'),(7402,'7402','Mecánicos y ajustadores de motores de avión'),(7403,'7403','Mecánicos y ajustadores de maquinaria agrícola e industrial'),(7404,'7404','Mecánicos y ajustadores de maquinaria naval y ferroviaria'),(7405,'7405','Reparadores de bicicletas y afines'),(7510,'7510','Electricistas de la construcción y afines'),(7521,'7521','Mecánicos y reparadores de equipos eléctricos'),(7522,'7522','Instaladores y reparadores de líneas eléctricas'),(7531,'7531','Mecánicos y reparadores de equipos electrónicos'),(7532,'7532','Instaladores y reparadores en electro medicina'),(7533,'7533','Instaladores y reparadores en tecnologías de la información y las comunicaciones'),(7611,'7611','Relojeros y mecánicos de instrumentos de precisión'),(7612,'7612','Lutieres y similares: afinadores de instrumentos musicales'),(7613,'7613','Joyeros, orfebres y plateros'),(7614,'7614','Trabajadores de la cerámica, alfareros y afines'),(7615,'7615','Sopladores, modeladores, laminadores, cortadores y pulidores de vidrio'),(7616,'7616','Rotulistas, grabadores de vidrio, pintores decorativos de artículos diversos'),(7617,'7617','Artesanos en madera y materiales similares: cesteros, bruceros y trabajadores afines'),(7618,'7618','Artesanos en tejidos, cueros y materiales similares, preparadores de fibra y tejedores con telares artesanos o de tejidos de punto y afines'),(7619,'7619','Artesanos no clasificados bajo otros epígrafes'),(7621,'7621','Trabajadores de procesos de preimpresión'),(7622,'7622','Trabajadores de procesos de impresión'),(7623,'7623','Trabajadores de procesos de encuadernación'),(7701,'7701','Matarifes y trabajadores de las industrias cárnicas'),(7702,'7702','Trabajadores de las industrias del pescado'),(7703,'7703','Panaderos, pasteleros y confiteros'),(7704,'7704','Trabajadores del tratamiento de la leche y elaboración de productos lácteos (incluidos helados)'),(7705,'7705','Trabajadores conserveros de frutas y hortalizas y trabajadores de la elaboración de bebidas no alcohólicas'),(7706,'7706','Trabajadores de la elaboración de bebidas alcohólicas distintas del vino'),(7707,'7707','Trabajadores de la elaboración del vino'),(7708,'7708','Preparadores y elaboradores del tabaco y sus productos'),(7709,'7709','Catadores y clasificadores de alimentos y bebidas'),(7811,'7811','Trabajadores del tratamiento de la madera'),(7812,'7812','Ajustadores y operadores de máquinas para trabajar la madera'),(7820,'7820','Ebanistas y trabajadores afines'),(7831,'7831','Sastres, modistos, peleteros y sombrereros'),(7832,'7832','Patronistas para productos en textil y piel'),(7833,'7833','Cortadores de tejidos, cuero, piel y otros materiales'),(7834,'7834','Costureros a mano, bordadores y afines'),(7835,'7835','Tapiceros, colchoneros y afines'),(7836,'7836','Curtidores y preparadores de pieles'),(7837,'7837','Zapateros y afines'),(7891,'7891','Buceadores'),(7892,'7892','Pegadores'),(7893,'7893','Clasificadores y probadores de productos (excepto alimentos, bebidas y tabaco)'),(7894,'7894','Fumigadores y otros controladores de plagas y malas hierbas'),(7899,'7899','Oficiales, operarios y artesanos de otros oficios no clasificados bajo otros epígrafes'),(8111,'8111','Mineros y otros operadores en instalaciones mineras'),(8112,'8112','Operadores en instalaciones para la preparación de minerales y rocas'),(8113,'8113','Sondistas y trabajadores afines'),(8114,'8114','Operadores de maquinaria para fabricar productos derivados de minerales no metálicos'),(8121,'8121','Operadores en instalaciones para la obtención y transformación de metales'),(8122,'8122','Operadores de máquinas pulidoras, galvanizadoras y recubridoras de metales'),(8131,'8131','Operadores en plantas industriales químicas'),(8132,'8132','Operadores de máquinas para fabricar productos farmacéuticos, cosméticos y afines'),(8133,'8133','Operadores de laboratorios fotográficos y afines'),(8141,'8141','Operadores de máquinas para fabricar productos de caucho y derivados de resinas naturales'),(8142,'8142','Operadores de máquinas para fabricar productos de material plástico'),(8143,'8143','Operadores de máquinas para fabricar productos de papel y cartón'),(8144,'8144','Operadores de serrerías, de máquinas de fabricación de tableros y de instalaciones afines para el tratamiento de la madera y el corcho'),(8145,'8145','Operadores en instalaciones para la preparación de pasta de papel y fabricación de papel'),(8151,'8151','Operadores de máquinas para preparar fibras, hilar y devanar'),(8152,'8152','Operadores de telares y otras máquinas tejedoras'),(8153,'8153','Operadores de máquinas de coser y bordar'),(8154,'8154','Operadores de máquinas de blanquear, teñir, estampar y acabar textiles'),(8155,'8155','Operadores de máquinas para tratar pieles y cuero'),(8156,'8156','Operadores de máquinas para la fabricación del calzado, marroquinería y guantería de piel'),(8159,'8159','Operadores de máquinas para fabricar productos textiles no clasificados bajo otros epígrafes'),(8160,'8160','Operadores de máquinas para elaborar productos alimenticios, bebidas y tabaco'),(8170,'8170','Operadores de máquinas de lavandería y tintorería'),(8191,'8191','Operadores de hornos e instalaciones de vidriería y cerámica'),(8192,'8192','Operadores de calderas y máquinas de vapor'),(8193,'8193','Operadores de máquinas de embalaje, embotellamiento y etiquetado'),(8199,'8199','Operadores de instalaciones y maquinaria fijas no clasificados bajo otros epígrafes'),(8201,'8201','Ensambladores de maquinaria mecánica'),(8202,'8202','Ensambladores de equipos eléctricos y electrónicos'),(8209,'8209','Montadores y ensambladores no clasificados en otros epígrafes'),(8311,'8311','Maquinistas de locomotoras'),(8312,'8312','Agentes de maniobras ferroviarias'),(8321,'8321','Operadores de maquinaria agrícola móvil'),(8322,'8322','Operadores de maquinaria forestal móvil'),(8331,'8331','Operadores de maquinaria de movimientos de tierras y equipos similares'),(8332,'8332','Operadores de grías, montacargas y de maquinaria similar de movimiento de materiales'),(8333,'8333','Operadores de carretillas elevadoras'),(8340,'8340','Marineros de puente, marineros de máquinas y afines'),(8411,'8411','Conductores propietarios de automóviles, taxis y furgonetas'),(8412,'8412','Conductores asalariados de automóviles, taxis y furgonetas'),(8420,'8420','Conductores de autobuses y tranvías'),(8431,'8431','Conductores propietarios de camiones'),(8432,'8432','Conductores asalariados de camiones'),(8440,'8440','Conductores de motocicletas y ciclomotores'),(9100,'9100','Empleados domésticos'),(9210,'9210','Personal de limpieza de oficinas, hoteles y otros establecimientos similares'),(9221,'9221','Limpiadores en seco a mano y afines'),(9222,'9222','Limpiadores de vehículos'),(9223,'9223','Limpiadores de ventanas'),(9229,'9229','Otro personal de limpieza'),(9310,'9310','Ayudantes de cocina'),(9320,'9320','Preparadores de comidas rápidas'),(9410,'9410','Vendedores callejeros'),(9420,'9420','Repartidores de publicidad, limpiabotas y otros trabajadores de oficios callejeros'),(9431,'9431','Ordenanzas'),(9432,'9432','Mozos de equipaje y afines'),(9433,'9433','Repartidores, recadistas y mensajeros a pie'),(9434,'9434','Lectores de contadores y recaudadores de máquinas recreativas y expendedoras'),(9441,'9441','Recogedores de residuos'),(9442,'9442','Clasificadores de desechos, operarios de punto limpio y recogedores de chatarra'),(9443,'9443','Barrenderos y afines'),(9490,'9490','Otras ocupaciones elementales'),(9511,'9511','Peones agrícolas (excepto en huertas, invernaderos, viveros y jardines)'),(9512,'9512','Peones agrícolas en huertas, invernaderos, viveros y jardines'),(9520,'9520','Peones ganaderos'),(9530,'9530','Peones agropecuarios'),(9541,'9541','Peones de la pesca'),(9542,'9542','Peones de la acuicultura'),(9543,'9543','Peones forestales y de la caza'),(9601,'9601','Peones de obras públicas'),(9602,'9602','Peones de la construcción de edificios'),(9603,'9603','Peones de la minería, canteras y otras industrias extractivas'),(9700,'9700','Peones de las industrias manufactureras'),(9811,'9811','Peones del transporte de mercancías y descargadores'),(9812,'9812','Conductores de vehículos de tracción animal para el transporte de personas y similares'),(9820,'9820','Reponedores');
/*!40000 ALTER TABLE `cno` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `commercial_activity`
--

DROP TABLE IF EXISTS `commercial_activity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commercial_activity` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre de la Actividad Comercial',
  `probability` int(4) DEFAULT NULL COMMENT 'Probabilidad de la Actividad',
  `survey` int(4) DEFAULT NULL COMMENT 'Identificador del Cuestionario',
  PRIMARY KEY (`id`),
  KEY `IDX_COMMERCIAL_ACTIVITY_DOMAIN` (`domain`),
  KEY `IDX_COMMERCIAL_ACTIVITY_SURVEY` (`survey`),
  CONSTRAINT `FK_COMMERCIAL_ACTIVITY_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_COMMERCIAL_ACTIVITY_SURVEY` FOREIGN KEY (`survey`) REFERENCES `survey` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Actividades Comerciales';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commercial_activity`
--

LOCK TABLES `commercial_activity` WRITE;
/*!40000 ALTER TABLE `commercial_activity` DISABLE KEYS */;
/*!40000 ALTER TABLE `commercial_activity` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `commercial_term`
--

DROP TABLE IF EXISTS `commercial_term`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commercial_term` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `line` smallint(2) DEFAULT '1' COMMENT 'Numero de linea de Condicion',
  `name` varchar(64) COLLATE latin1_spanish_ci NOT NULL DEFAULT '' COMMENT 'Nombre de la Condicion Comercial',
  `description` text COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion de la Condicion Comercial',
  `term_general` tinyint(1) DEFAULT '0' COMMENT 'Indica si la Condición es particular o general',
  PRIMARY KEY (`id`),
  KEY `IDX_COMMERCIAL_TERM_DOMAIN` (`domain`),
  CONSTRAINT `FK_COMMERCIAL_TERM_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Condiciones Comerciales';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commercial_term`
--

LOCK TABLES `commercial_term` WRITE;
/*!40000 ALTER TABLE `commercial_term` DISABLE KEYS */;
/*!40000 ALTER TABLE `commercial_term` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `commercial_tracking`
--

DROP TABLE IF EXISTS `commercial_tracking`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commercial_tracking` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `date` datetime NOT NULL COMMENT 'Fecha del Seguimiento Comercial',
  `seller` int(4) NOT NULL COMMENT 'Identificador del Comercial',
  `project_commercial` int(4) NOT NULL COMMENT 'Identificador del Proyecto',
  `activity` int(4) NOT NULL COMMENT 'Identificador de la Actividad Comercial',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios del Seguimiento Comercial',
  `status` tinyint(2) NOT NULL COMMENT 'Estado del Seguimiento Comercial',
  `next_commercial_tracking` int(4) DEFAULT NULL COMMENT 'Identificador del siguiente Seguimiento Comercial',
  `end_date` datetime DEFAULT NULL COMMENT 'Fecha de cierre del Seguimiento Comercial',
  `offer` int(4) DEFAULT NULL COMMENT 'Identificador del Presupuesto',
  `allDay` tinyint(1) DEFAULT '0' COMMENT 'Indica si el Seguimiento Comercial dura todo el dia',
  `location` varchar(255) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Ubicacion del Seguimiento Comercial',
  `eventId` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `IDX_COMMERCIAL_TRACKING_SELLER` (`seller`),
  KEY `IDX_COMMERCIAL_TRACKING_ACTIVITY` (`activity`),
  KEY `IDX_COMMERCIAL_TRACKING_OFFER` (`offer`),
  KEY `IDX_COMMERCIAL_TRACKING_NEXT_COMMERCIAL_TRACKING` (`next_commercial_tracking`),
  KEY `IDX_COMMERCIAL_TRACKING_DOMAIN` (`domain`),
  KEY `IDX_COMMERCIAL_TRACKING_PROJECT_COMMERCIAL` (`project_commercial`),
  CONSTRAINT `FK_COMMERCIAL_TRACKING_ACTIVITY` FOREIGN KEY (`activity`) REFERENCES `commercial_activity` (`id`),
  CONSTRAINT `FK_COMMERCIAL_TRACKING_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_COMMERCIAL_TRACKING_NEXT_COMMERCIAL_TRACKING` FOREIGN KEY (`next_commercial_tracking`) REFERENCES `commercial_tracking` (`id`),
  CONSTRAINT `FK_COMMERCIAL_TRACKING_OFFER` FOREIGN KEY (`offer`) REFERENCES `offer` (`id`),
  CONSTRAINT `FK_COMMERCIAL_TRACKING_PROJECT_COMMERCIAL` FOREIGN KEY (`project_commercial`) REFERENCES `project_commercial` (`project`),
  CONSTRAINT `FK_COMMERCIAL_TRACKING_SELLER` FOREIGN KEY (`seller`) REFERENCES `seller` (`registry`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Seguimientos Comerciales';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commercial_tracking`
--

LOCK TABLES `commercial_tracking` WRITE;
/*!40000 ALTER TABLE `commercial_tracking` DISABLE KEYS */;
/*!40000 ALTER TABLE `commercial_tracking` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `commission`
--

DROP TABLE IF EXISTS `commission`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commission` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion de la Comision',
  `start_date` date NOT NULL COMMENT 'Fecha de inicio de la Comision',
  `end_date` date DEFAULT NULL COMMENT 'Fecha de fin de la Comision',
  PRIMARY KEY (`id`),
  KEY `IDX_COMMISSION_DOMAIN` (`domain`),
  CONSTRAINT `FK_COMMISSION_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Comisiones';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commission`
--

LOCK TABLES `commission` WRITE;
/*!40000 ALTER TABLE `commission` DISABLE KEYS */;
/*!40000 ALTER TABLE `commission` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `commission_category`
--

DROP TABLE IF EXISTS `commission_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commission_category` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `commission` int(4) NOT NULL COMMENT 'Identificador de la Comision',
  `category` int(4) NOT NULL COMMENT 'Identificador de la Categoria',
  `quantity` double DEFAULT '0' COMMENT 'Cantidad a partir de la cual se aplica la Comision',
  `rate` double(6,2) DEFAULT '0.00' COMMENT 'Porcentaje de Comision',
  PRIMARY KEY (`id`),
  KEY `IDX_COMMISSION_CATEGORY_COMMISSION` (`commission`),
  KEY `IDX_COMMISSION_CATEGORY_CATEGORY` (`category`),
  KEY `IDX_COMMISSION_CATEGORY_DOMAIN` (`domain`),
  CONSTRAINT `FK_COMMISSION_CATEGORY_CATEGORY` FOREIGN KEY (`category`) REFERENCES `pcategory` (`id`),
  CONSTRAINT `FK_COMMISSION_CATEGORY_COMMISSION` FOREIGN KEY (`commission`) REFERENCES `commission` (`id`),
  CONSTRAINT `FK_COMMISSION_CATEGORY_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Comisiones por Categoria';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commission_category`
--

LOCK TABLES `commission_category` WRITE;
/*!40000 ALTER TABLE `commission_category` DISABLE KEYS */;
/*!40000 ALTER TABLE `commission_category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `commission_item`
--

DROP TABLE IF EXISTS `commission_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commission_item` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `commission` int(4) NOT NULL COMMENT 'Identificador de la Comision',
  `item` int(4) NOT NULL COMMENT 'Identificador del Articulo',
  `quantity` double DEFAULT '0' COMMENT 'Cantidad a partir de la cual se aplica la Comision',
  `amount` double DEFAULT '0' COMMENT 'Importe de la Comision',
  `rate` double(6,2) DEFAULT '0.00' COMMENT 'Porcentaje de Comision',
  PRIMARY KEY (`id`),
  KEY `IDX_COMMISSION_ITEM_COMMISSION` (`commission`),
  KEY `IDX_COMMISSION_ITEM_ITEM` (`item`),
  KEY `IDX_COMMISSION_ITEM_DOMAIN` (`domain`),
  CONSTRAINT `FK_COMMISSION_ITEM_COMMISSION` FOREIGN KEY (`commission`) REFERENCES `commission` (`id`),
  CONSTRAINT `FK_COMMISSION_ITEM_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_COMMISSION_ITEM_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Comisiones por Articulo';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commission_item`
--

LOCK TABLES `commission_item` WRITE;
/*!40000 ALTER TABLE `commission_item` DISABLE KEYS */;
/*!40000 ALTER TABLE `commission_item` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `commission_type`
--

DROP TABLE IF EXISTS `commission_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commission_type` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion del Tipo de Comision',
  `rate` double(6,2) DEFAULT '0.00' COMMENT 'Porcentaje de Comision',
  PRIMARY KEY (`id`),
  KEY `IDX_COMMISSION_TYPE_DOMAIN` (`domain`),
  CONSTRAINT `FK_COMMISSION_TYPE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Tipos de Comisiones';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commission_type`
--

LOCK TABLES `commission_type` WRITE;
/*!40000 ALTER TABLE `commission_type` DISABLE KEYS */;
/*!40000 ALTER TABLE `commission_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `commission_type_commission`
--

DROP TABLE IF EXISTS `commission_type_commission`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `commission_type_commission` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `commission_type` int(4) NOT NULL COMMENT 'Identificador del Tipo de Comision',
  `commission` int(4) NOT NULL COMMENT 'Identificador de la Comision',
  PRIMARY KEY (`id`),
  KEY `IDX_COMMISSION_TYPE_COMMISSION_COMMISSION_TYPE` (`commission_type`),
  KEY `IDX_COMMISSION_TYPE_COMMISSION_COMMISSION` (`commission`),
  KEY `IDX_COMMISSION_TYPE_COMMISSION_DOMAIN` (`domain`),
  CONSTRAINT `FK_COMMISSION_TYPE_COMMISSION_COMMISSION` FOREIGN KEY (`commission`) REFERENCES `commission` (`id`),
  CONSTRAINT `FK_COMMISSION_TYPE_COMMISSION_COMMISSION_TYPE` FOREIGN KEY (`commission_type`) REFERENCES `commission_type` (`id`),
  CONSTRAINT `FK_COMMISSION_TYPE_COMMISSION_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Comisiones por Tipo de Comision';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commission_type_commission`
--

LOCK TABLES `commission_type_commission` WRITE;
/*!40000 ALTER TABLE `commission_type_commission` DISABLE KEYS */;
/*!40000 ALTER TABLE `commission_type_commission` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `company`
--

DROP TABLE IF EXISTS `company`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `company` (
  `registry` int(4) NOT NULL DEFAULT '1' COMMENT 'Registro de la Compañia',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `active` tinyint(1) DEFAULT '0' COMMENT 'Indica si la Compañia es activa o inactiva',
  `surcharge` tinyint(1) DEFAULT '0' COMMENT 'Indica si la Compañia tiene de recargo de equivalencia',
  `withholding` tinyint(1) DEFAULT '0' COMMENT 'Indica si la Compañia aplica retencion de impuestos',
  `vat_accrual_payment` tinyint(1) DEFAULT '0' COMMENT 'Indica si la Compañia esta acogida al Regimen Especial de Criterio de Caja',
  `e_invoice` tinyint(1) DEFAULT '0' COMMENT 'Indica si la Compañia desea emitir Facturas electronicas',
  PRIMARY KEY (`registry`),
  UNIQUE KEY `IDX_UNQ_COMPANY_DOMAIN` (`domain`),
  KEY `IDX_COMPANY_DOMAIN` (`domain`),
  CONSTRAINT `FK_COMPANY_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_COMPANY_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Datos Corporativos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `company`
--

LOCK TABLES `company` WRITE;
/*!40000 ALTER TABLE `company` DISABLE KEYS */;
INSERT INTO `company` VALUES (216081,0,0,0,0,0,0),(8628387,8776,1,0,0,0,0),(8628388,8777,1,0,0,0,0),(8628397,8778,1,0,0,0,0),(8628405,8779,1,0,0,0,0),(8628412,8780,1,0,0,0,0),(8628439,8781,1,0,0,0,0),(8628443,8782,1,0,0,0,0),(8628451,8783,1,0,0,0,0),(8628463,8784,1,0,0,0,0),(8628474,8785,1,0,0,0,0),(8628500,8787,1,0,0,0,0),(8628519,8788,1,0,0,0,0);
/*!40000 ALTER TABLE `company` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `contact`
--

DROP TABLE IF EXISTS `contact`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `contact` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `user_id` int(4) DEFAULT NULL COMMENT 'Identificador del Usuario',
  `displayName` varchar(128) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Mostrar Como',
  `contact_data` int(4) DEFAULT NULL COMMENT 'Identificador de la Informacin del Contacto',
  PRIMARY KEY (`id`),
  KEY `IDX_CONTACT_CONTACT_DATA` (`contact_data`),
  KEY `IDX_CONTACT_USER` (`user_id`),
  KEY `IDX_CONTACT_DOMAIN` (`domain`),
  CONSTRAINT `FK_CONTACT_CONTACT_DATA` FOREIGN KEY (`contact_data`) REFERENCES `contact_data` (`id`),
  CONSTRAINT `FK_CONTACT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_CONTACT_USER` FOREIGN KEY (`user_id`) REFERENCES `user` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Grupo de Contactos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `contact`
--

LOCK TABLES `contact` WRITE;
/*!40000 ALTER TABLE `contact` DISABLE KEYS */;
/*!40000 ALTER TABLE `contact` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `contact_data`
--

DROP TABLE IF EXISTS `contact_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `contact_data` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre',
  `surname` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Apellido',
  `address` varchar(256) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Direccion',
  `postalCode` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo postal',
  `city` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Localidad',
  `contactState` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Estado',
  `country` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Pais',
  `phone` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Telefono',
  `cellularPhone` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Movil',
  `fax` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Fax',
  `email` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Email',
  `note` text COLLATE latin1_spanish_ci COMMENT 'Nota',
  `organization` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Organizacin',
  `title` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Cargo',
  `organizationAddress` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Direccin de la Organizacin',
  `organizationPostalCode` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo postal de la Organizacin',
  `organizationCity` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Localidad de la Organizacin',
  `organizationState` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Estado de la Organizacin',
  `organizationPhone` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Telefono de la Organizacin',
  `organizationFax` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Fax de la Organizacin',
  `web` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Web',
  PRIMARY KEY (`id`),
  KEY `IDX_CONTACT_DATA_DOMAIN` (`domain`),
  CONSTRAINT `FK_CONTACT_DATA_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Contactos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `contact_data`
--

LOCK TABLES `contact_data` WRITE;
/*!40000 ALTER TABLE `contact_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `contact_data` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `contact_detail`
--

DROP TABLE IF EXISTS `contact_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `contact_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `contact_group` int(4) NOT NULL COMMENT 'Identificador del Grupo de Contactos',
  `contact` int(4) NOT NULL COMMENT 'Identificador del Contacto',
  PRIMARY KEY (`id`),
  KEY `IDX_CONTACT_DETAIL_CONTACT` (`contact`),
  KEY `IDX_CONTACT_DETAIL_CONTACT_GROUP` (`contact_group`),
  KEY `IDX_CONTACT_DETAIL_DOMAIN` (`domain`),
  CONSTRAINT `FK_CONTACT_DETAIL_CONTACT` FOREIGN KEY (`contact`) REFERENCES `contact` (`id`),
  CONSTRAINT `FK_CONTACT_DETAIL_CONTACT_GROUP` FOREIGN KEY (`contact_group`) REFERENCES `contact` (`id`),
  CONSTRAINT `FK_CONTACT_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalles del Grupo de Contactos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `contact_detail`
--

LOCK TABLES `contact_detail` WRITE;
/*!40000 ALTER TABLE `contact_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `contact_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `contract`
--

DROP TABLE IF EXISTS `contract`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `contract` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `person` int(4) NOT NULL COMMENT 'Identificador de la Persona',
  `workplace` int(4) NOT NULL COMMENT 'Identificador del Centro de Trabajo',
  `enterprise_ccc` int(4) DEFAULT NULL COMMENT 'CCC',
  `start_date` date NOT NULL COMMENT 'Fecha de inicio del Contrato',
  `end_date` date DEFAULT NULL COMMENT 'Fecha de finalizacion del Contrato',
  `calendar` int(4) DEFAULT NULL COMMENT 'Calendario',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion',
  `sepe_status` tinyint(2) DEFAULT '0' COMMENT 'Estado de notificacion del contrato al SEPE',
  `registration` int(4) DEFAULT NULL COMMENT 'Número libro de matricula',
  `seniority_date` date DEFAULT NULL COMMENT 'Fecha de antiguedad',
  `enterprise_activity` int(4) DEFAULT NULL COMMENT 'Actividad',
  `ss_regime` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Regimen de la Seguridad Social',
  `agreement_level_category` int(4) DEFAULT NULL COMMENT 'Identificador unico de la Categoria Profesional',
  `model` tinyint(2) DEFAULT NULL COMMENT 'Indica el modelo de documento del contrato',
  `category_description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Categoria o grupo profesional',
  `ss_status` tinyint(2) DEFAULT '0' COMMENT 'Estado de notificacion del contrato a la Seguridad Social',
  PRIMARY KEY (`id`),
  KEY `IDX_CONTRACT_PERSON` (`person`),
  KEY `IDX_CONTRACT_WORKPLACE` (`workplace`),
  KEY `IDX_CONTRACT_CALENDAR` (`calendar`),
  KEY `IDX_CONTRACT_ENTERPRISE_CCC` (`enterprise_ccc`),
  KEY `IDX_CONTRACT_AGREEMENT_LEVEL_CATEGORY` (`agreement_level_category`),
  KEY `IDX_CONTRACT_ENTERPRISE_ACTIVITY` (`enterprise_activity`),
  KEY `IDX_CONTRACT_DOMAIN` (`domain`),
  CONSTRAINT `FK_CONTRACT_AGREEMENT_LEVEL_CATEGORY` FOREIGN KEY (`agreement_level_category`) REFERENCES `agreement_level_category` (`id`),
  CONSTRAINT `FK_CONTRACT_CALENDAR` FOREIGN KEY (`calendar`) REFERENCES `calendar` (`id`),
  CONSTRAINT `FK_CONTRACT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_CONTRACT_ENTERPRISE_ACTIVITY` FOREIGN KEY (`enterprise_activity`) REFERENCES `enterprise_activity` (`id`),
  CONSTRAINT `FK_CONTRACT_ENTERPRISE_CCC` FOREIGN KEY (`enterprise_ccc`) REFERENCES `enterprise_ccc` (`id`),
  CONSTRAINT `FK_CONTRACT_PERSON` FOREIGN KEY (`person`) REFERENCES `person` (`registry`),
  CONSTRAINT `FK_CONTRACT_WORKPLACE` FOREIGN KEY (`workplace`) REFERENCES `workplace` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5886 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Contratos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `contract`
--

LOCK TABLES `contract` WRITE;
/*!40000 ALTER TABLE `contract` DISABLE KEYS */;
INSERT INTO `contract` VALUES (-5800,8777,8628434,8352,1162,'2016-04-19',NULL,NULL,NULL,NULL,NULL,'2016-04-19',1447,0,NULL,NULL,'',NULL),(-5799,8777,8628435,8352,1162,'2016-04-15',NULL,NULL,NULL,NULL,NULL,'2016-04-15',1447,0,NULL,NULL,'',NULL),(-5798,8777,8628435,8352,1162,'2016-04-15',NULL,NULL,NULL,NULL,NULL,'2016-04-15',1447,0,8101,NULL,'',NULL),(-5797,8777,8628435,8352,1162,'2016-04-14',NULL,NULL,NULL,NULL,NULL,'2016-04-14',1447,0,NULL,NULL,'',NULL),(-5795,8777,8628434,8352,1162,'2016-04-14',NULL,NULL,NULL,NULL,NULL,'2016-04-14',1447,0,NULL,NULL,'',NULL),(5747,8777,8628389,8352,1162,'2012-08-18',NULL,NULL,NULL,NULL,NULL,'2012-08-18',1447,0,8096,NULL,'',NULL),(5748,8777,8628391,8352,1162,'1993-02-18',NULL,NULL,NULL,NULL,NULL,'1993-02-18',1447,0,8096,NULL,'',NULL),(5749,8777,8628390,8352,1162,'1989-02-18',NULL,NULL,NULL,NULL,NULL,'1989-02-18',1447,0,8096,NULL,'',NULL),(5750,8777,8628393,8352,1162,'2001-02-19',NULL,NULL,NULL,NULL,NULL,'1991-02-19',1447,0,8096,NULL,'',NULL),(5751,8777,8628394,8356,1162,'2016-02-22',NULL,NULL,NULL,NULL,NULL,'2016-02-22',1447,0,8100,NULL,'',NULL),(5752,8777,8628395,8356,1162,'2016-02-22',NULL,NULL,NULL,NULL,NULL,'2016-02-22',1447,0,8100,NULL,'',NULL),(5753,8777,8628396,8357,1162,'2016-02-21',NULL,NULL,NULL,NULL,NULL,'2016-02-21',1447,0,NULL,NULL,'',NULL),(5754,8777,8628398,8357,1162,'2016-02-21',NULL,NULL,NULL,NULL,NULL,'2016-02-21',1447,0,NULL,NULL,'',NULL),(5755,8778,8628399,8358,1163,'2016-02-22',NULL,NULL,NULL,NULL,NULL,'2016-02-22',1448,0,NULL,NULL,'',NULL),(5756,8777,8628400,8359,1162,'2016-02-22',NULL,NULL,NULL,NULL,NULL,'2016-02-22',1447,0,NULL,NULL,'',NULL),(5758,8777,8628401,8355,1162,'2015-02-22',NULL,NULL,NULL,NULL,NULL,'2015-02-22',1447,0,NULL,NULL,'',NULL),(5759,8777,8628479,8360,1164,'2015-02-22',NULL,NULL,NULL,NULL,NULL,'2015-02-22',1447,0,NULL,NULL,'',NULL),(5760,8777,8628480,8361,1165,'2015-02-22',NULL,NULL,NULL,NULL,NULL,'2015-02-22',1447,0,NULL,NULL,'',NULL),(5761,8777,8628401,8362,1166,'2016-02-22',NULL,NULL,NULL,NULL,NULL,'2016-02-22',1447,0,NULL,NULL,'',NULL),(5762,8777,8628404,8359,1162,'2016-02-22',NULL,NULL,NULL,NULL,NULL,'2016-02-22',1447,0,NULL,NULL,'',NULL),(5763,8777,8628402,8355,1162,'2016-02-22',NULL,NULL,NULL,NULL,NULL,'2016-02-22',1447,0,NULL,NULL,'',NULL),(5764,8777,8628402,8360,1164,'2016-02-22',NULL,NULL,NULL,NULL,NULL,'2016-02-22',1447,0,NULL,NULL,'',NULL),(5765,8777,8628402,8361,1165,'2016-02-22',NULL,NULL,NULL,NULL,NULL,'2016-02-22',1447,0,NULL,NULL,'',NULL),(5766,8777,8628406,8364,1162,'2016-01-22','2016-02-22',NULL,NULL,NULL,NULL,'2016-01-22',1447,0,NULL,NULL,'',NULL),(5767,8777,8628407,8364,1162,'2016-02-22',NULL,NULL,NULL,NULL,NULL,'2016-02-22',1447,0,NULL,NULL,'',NULL),(5768,8777,8628409,8364,1162,'2016-02-22','2016-03-01',NULL,NULL,NULL,NULL,'2016-02-22',1447,0,NULL,NULL,'',NULL),(5769,8777,8628408,8364,1162,'2014-02-22','2016-03-02',NULL,NULL,NULL,NULL,'2014-02-22',1447,0,8104,NULL,'',NULL),(5770,8777,8628410,8364,1162,'2016-02-22','2016-02-29',NULL,NULL,NULL,NULL,'2016-02-22',1447,0,NULL,NULL,'',NULL),(5771,8777,8628411,8366,NULL,'2016-02-22',NULL,NULL,NULL,NULL,NULL,'2016-02-22',NULL,3,NULL,NULL,'',NULL),(5772,8777,8628413,8365,1162,'2012-02-29',NULL,NULL,NULL,NULL,NULL,'2012-02-29',1447,0,8197,NULL,'',NULL),(5773,8778,8628414,8358,1167,'2016-03-01',NULL,NULL,NULL,NULL,NULL,'2016-03-01',1448,0,8124,NULL,'',NULL),(5775,8777,8628416,8368,1162,'2016-03-01',NULL,NULL,NULL,NULL,NULL,'2016-03-01',1447,0,8108,NULL,'',NULL),(5776,8777,8628415,8368,1162,'2016-03-01',NULL,NULL,NULL,NULL,NULL,'2016-03-01',1447,0,8114,NULL,'',NULL),(5777,8777,8628417,8354,1162,'2016-03-01',NULL,NULL,NULL,NULL,NULL,'2016-03-01',1447,0,8105,NULL,'',NULL),(5778,8777,8628418,8354,1162,'2016-03-01',NULL,NULL,NULL,NULL,NULL,'2016-03-01',1447,0,8114,NULL,'',NULL),(5779,8777,8628419,8354,1162,'2016-01-10',NULL,NULL,NULL,NULL,NULL,'2016-01-01',1447,0,8113,NULL,'',NULL),(5780,8777,8628420,8354,1162,'2016-03-01',NULL,NULL,NULL,NULL,NULL,'2016-03-01',1447,0,8111,NULL,'',NULL),(5781,8778,8628421,8358,1163,'2016-03-03',NULL,NULL,NULL,NULL,NULL,'2016-03-03',1448,0,NULL,NULL,'',NULL),(5782,8777,8628422,8369,1162,'2016-03-09',NULL,NULL,NULL,NULL,NULL,'2016-03-09',1447,0,8100,NULL,'OBSOLETO',NULL),(5783,8780,8628423,8370,1168,'2016-03-11',NULL,NULL,NULL,NULL,NULL,'2016-03-11',1449,0,NULL,NULL,'',NULL),(5784,8777,8628424,8364,1162,'2016-02-09','2016-03-28',NULL,NULL,NULL,NULL,'2016-02-09',1447,0,8108,NULL,'',NULL),(5785,8777,8628425,8354,1162,'2016-02-03',NULL,NULL,NULL,NULL,NULL,'2016-04-03',1447,0,NULL,NULL,'',NULL),(5786,8777,8628426,8354,1162,'2016-02-03',NULL,NULL,NULL,NULL,NULL,'2016-04-03',1447,0,NULL,NULL,'',NULL),(5787,8777,8628427,8371,1162,'2016-04-03',NULL,NULL,NULL,NULL,NULL,'2016-04-03',1447,0,8100,NULL,'',NULL),(5788,8777,8628428,8369,1162,'2016-04-05',NULL,NULL,NULL,NULL,NULL,'2016-04-05',1447,0,8103,NULL,'',NULL),(5789,8777,8628429,8369,1162,'2016-04-05',NULL,NULL,NULL,NULL,NULL,'2016-04-05',1447,0,8100,NULL,'',NULL),(5790,8777,8628430,8369,1162,'2016-04-05',NULL,NULL,NULL,NULL,NULL,'2016-04-05',1447,0,8109,NULL,'',NULL),(5791,8780,8628431,8367,1168,'2016-04-06',NULL,NULL,NULL,NULL,NULL,'2016-04-06',1449,0,8120,NULL,'',NULL),(5792,8777,8628432,8352,1162,'2016-04-07',NULL,NULL,NULL,NULL,NULL,'2016-04-07',1447,0,NULL,NULL,'',NULL),(5793,8777,8628433,8372,1162,'2016-04-07',NULL,NULL,NULL,NULL,NULL,'2016-04-07',1447,0,NULL,NULL,'',NULL),(5794,8777,8628434,8371,1162,'2016-04-14',NULL,NULL,NULL,NULL,NULL,'2016-04-14',1447,0,NULL,NULL,'',NULL),(5796,8777,8628435,8372,1162,'2016-04-14',NULL,NULL,NULL,NULL,NULL,'2016-04-14',1447,0,NULL,NULL,'',NULL),(5801,8777,8628437,8373,1162,'2016-04-19',NULL,NULL,NULL,NULL,NULL,'2016-04-19',1447,0,NULL,NULL,'',NULL),(5802,8777,8628438,8373,1162,'2016-04-19',NULL,NULL,NULL,NULL,NULL,'2016-04-19',1447,0,NULL,NULL,'',NULL),(5803,8781,8628440,8374,1169,'2016-04-20',NULL,NULL,NULL,NULL,NULL,'2016-04-20',1450,0,NULL,NULL,'',NULL),(5804,8777,8628441,8362,1166,'2016-04-20',NULL,NULL,NULL,NULL,NULL,'2016-04-20',1447,0,NULL,NULL,'',NULL),(5805,8777,8628442,8362,1166,'2016-04-20',NULL,NULL,NULL,NULL,NULL,'2016-04-20',1447,0,NULL,NULL,'',NULL),(5806,8777,8628444,8354,1162,'2016-04-25',NULL,NULL,NULL,NULL,NULL,'2016-04-25',1447,0,NULL,NULL,'',NULL),(5807,8777,8628445,8354,1162,'2016-03-25',NULL,NULL,NULL,NULL,NULL,'2016-04-25',1447,0,NULL,NULL,'',NULL),(5808,8777,8628446,8356,1162,'2016-05-03',NULL,NULL,NULL,NULL,NULL,'2016-05-03',1447,0,8125,NULL,'',NULL),(5809,8777,8628447,8354,1162,'2016-05-04',NULL,NULL,NULL,NULL,NULL,'2016-05-04',1447,0,NULL,NULL,'',NULL),(5810,8777,8628448,8354,1162,'2016-05-04',NULL,NULL,NULL,NULL,NULL,'2016-05-04',1447,0,NULL,NULL,'',NULL),(5811,8777,8628449,8354,1162,'2016-05-04',NULL,NULL,NULL,NULL,NULL,'2016-05-04',1447,0,NULL,NULL,'',NULL),(5812,8777,8628450,8354,1162,'2016-05-05',NULL,NULL,NULL,NULL,NULL,'2016-05-05',1447,0,NULL,NULL,'',NULL),(5813,8783,8628452,8376,1170,'2016-05-06',NULL,NULL,NULL,NULL,NULL,'2016-01-01',1452,0,8126,NULL,'',NULL),(5814,8783,8628453,8376,1170,'2016-05-06',NULL,NULL,NULL,NULL,NULL,'2009-01-01',1452,0,8128,NULL,'',NULL),(5815,8783,8628454,8376,1170,'2016-05-06',NULL,NULL,NULL,NULL,NULL,'2000-01-01',1452,0,8134,NULL,'',NULL),(5816,8783,8628455,8376,1170,'2016-05-06',NULL,NULL,NULL,NULL,NULL,'2016-05-06',1452,0,8137,NULL,'',NULL),(5817,8783,8628456,8376,1170,'2016-05-06',NULL,NULL,NULL,NULL,NULL,'2016-05-06',1452,0,8144,NULL,'',NULL),(5818,8783,8628457,8376,1170,'2016-05-06',NULL,NULL,NULL,NULL,NULL,'2016-05-06',1452,0,8148,NULL,'',NULL),(5819,8777,8628458,8354,1162,'2016-05-09',NULL,NULL,NULL,NULL,NULL,'2016-05-09',1447,0,8125,NULL,'',NULL),(5820,8777,8628459,8354,1162,'2016-05-18',NULL,NULL,NULL,NULL,NULL,'2016-05-18',1447,0,8166,NULL,'',NULL),(5821,8777,8628460,8377,1162,'2016-05-18',NULL,NULL,NULL,NULL,NULL,'2016-05-18',1447,0,NULL,NULL,'',NULL),(5822,8777,8628461,8377,1162,'2016-05-18',NULL,NULL,NULL,NULL,NULL,'2016-05-18',1447,0,NULL,NULL,'',NULL),(5823,8777,8628462,8377,1162,'2016-05-18',NULL,NULL,NULL,NULL,NULL,'2016-05-18',1447,0,8101,NULL,'',NULL),(5824,8784,8628464,8378,1171,'2016-05-18',NULL,NULL,NULL,NULL,NULL,'2016-05-18',1453,0,8169,NULL,'',NULL),(5825,8784,8628465,8378,1171,'2016-05-18',NULL,NULL,NULL,NULL,NULL,'2016-05-18',1453,0,8182,NULL,'',NULL),(5826,8777,8628466,8379,1162,'2016-05-23',NULL,NULL,NULL,NULL,NULL,'2016-05-23',1447,0,NULL,NULL,'',NULL),(5827,8777,8628467,8359,1162,'2016-05-24',NULL,NULL,NULL,NULL,NULL,'2016-05-24',1447,0,NULL,NULL,'',NULL),(5828,8783,8628468,8381,1170,'2016-02-01',NULL,NULL,NULL,NULL,NULL,'2016-02-01',1452,0,8201,NULL,'',NULL),(5829,8783,8628469,8381,1170,'2010-05-27',NULL,NULL,NULL,NULL,NULL,'2010-05-27',1452,0,8202,NULL,'',NULL),(5830,8783,8628470,8381,1170,'2010-05-27','2016-04-10',NULL,NULL,NULL,NULL,'2010-05-27',1452,0,8201,NULL,'',NULL),(5831,8777,8628471,8354,1162,'2016-05-30',NULL,NULL,NULL,NULL,NULL,'2016-05-30',1447,0,8125,NULL,'',NULL),(5832,8777,8628472,8357,1162,'2016-05-31',NULL,NULL,NULL,NULL,NULL,'2016-05-31',1447,0,NULL,NULL,'',NULL),(5833,8777,8628473,8357,1162,'2016-06-01',NULL,NULL,NULL,NULL,NULL,'2016-06-01',1447,0,NULL,NULL,'',NULL),(5834,8777,8628475,8379,1162,'2016-06-06',NULL,NULL,NULL,NULL,NULL,'2016-06-06',1447,0,8098,NULL,'',NULL),(5835,8783,8628476,8384,1170,'2016-06-07',NULL,NULL,NULL,NULL,NULL,'2016-06-07',1452,0,-8207,NULL,'',NULL),(5836,8783,8628477,8384,1170,'2016-06-07',NULL,NULL,NULL,NULL,NULL,'2016-06-07',1452,0,-8203,NULL,'',NULL),(5837,8777,8628478,8364,1162,'2016-06-07','2016-06-27',NULL,NULL,NULL,NULL,'2016-06-07',1447,0,8111,NULL,'',NULL),(5838,8777,8628481,8364,1162,'2016-06-13',NULL,NULL,NULL,NULL,NULL,'2016-06-13',1447,0,NULL,NULL,'',NULL),(5839,8777,8628482,8364,1162,'2016-06-14',NULL,NULL,NULL,NULL,NULL,'2016-06-14',1447,0,NULL,NULL,'',NULL),(5840,8777,8628483,8364,1162,'2016-06-14',NULL,NULL,NULL,NULL,NULL,'2016-06-14',1447,0,NULL,NULL,'',NULL),(5841,8777,8628484,8354,1162,'2016-06-15',NULL,NULL,NULL,NULL,NULL,'2016-06-15',1447,0,8125,NULL,'',NULL),(5842,8777,8628485,8377,1162,'2016-06-20',NULL,NULL,NULL,NULL,NULL,'2016-06-20',1447,0,8098,NULL,'',NULL),(5843,8777,8628486,8357,1162,'2016-07-04',NULL,NULL,NULL,NULL,NULL,'2016-07-04',1447,0,NULL,NULL,'',NULL),(5844,8777,8628487,8372,1162,'2016-07-06',NULL,NULL,NULL,NULL,NULL,'2016-07-06',1447,0,8100,NULL,'',NULL),(5845,8777,8628488,8369,1162,'2016-07-07',NULL,NULL,NULL,NULL,NULL,'2016-07-07',1447,0,8203,NULL,'',NULL),(5846,8777,8628489,8385,1166,'2016-07-21',NULL,NULL,NULL,NULL,NULL,'2016-07-21',1447,0,8102,NULL,'',NULL),(5847,8777,8628490,8385,1166,'2016-07-21',NULL,NULL,NULL,NULL,NULL,'2016-07-21',1447,0,8102,NULL,'',NULL),(5848,8777,8628491,8354,1162,'2016-08-18',NULL,NULL,NULL,NULL,NULL,'2016-08-18',1447,0,NULL,NULL,'',NULL),(5849,8777,8628492,8354,1162,'2016-08-18',NULL,NULL,NULL,NULL,NULL,'2016-08-18',1447,0,8119,NULL,'',NULL),(5850,8777,8628493,8354,1162,'2016-08-19',NULL,NULL,NULL,NULL,NULL,'2016-08-19',1447,0,8103,NULL,'',NULL),(5851,8777,8628494,8387,1162,'2016-08-26',NULL,NULL,NULL,NULL,NULL,'2016-08-26',1447,0,NULL,NULL,'',NULL),(5852,8777,8628495,8387,1162,'2016-08-26',NULL,NULL,NULL,NULL,NULL,'2016-08-26',1447,0,NULL,NULL,'',NULL),(5853,8777,8628496,8387,1162,'2016-08-29',NULL,NULL,NULL,NULL,NULL,'2016-08-29',1447,0,NULL,NULL,'',NULL),(5854,8777,8628497,8385,1166,'2016-09-20',NULL,NULL,NULL,NULL,NULL,'2016-09-20',1447,0,8119,NULL,'',NULL),(5855,8777,8628498,8385,1166,'2016-09-20',NULL,NULL,NULL,NULL,NULL,'2016-09-20',1447,0,8103,NULL,'',NULL),(5856,8787,8628501,8389,1174,'2016-09-29',NULL,NULL,NULL,NULL,NULL,'2016-09-29',1455,0,8205,NULL,'',NULL),(5857,8787,8628502,8389,1174,'2016-09-30',NULL,NULL,NULL,NULL,NULL,'2016-09-30',1455,0,8263,NULL,'',NULL),(5858,8787,8628503,8389,1174,'2016-09-30',NULL,NULL,NULL,NULL,NULL,'2016-09-30',1455,0,8225,NULL,'',NULL),(5859,8787,8628504,8389,1174,'2016-09-30',NULL,NULL,NULL,NULL,NULL,'2016-09-30',1455,0,8234,NULL,'',NULL),(5860,8787,8628505,8389,1174,'2016-09-30',NULL,NULL,NULL,NULL,NULL,'2016-09-30',1455,0,8252,NULL,'',NULL),(5861,8787,8628506,8389,1174,'2016-09-30',NULL,NULL,NULL,NULL,NULL,'2016-09-30',1455,0,8261,NULL,'',NULL),(5862,8787,8628507,8389,1174,'2016-09-30',NULL,NULL,NULL,NULL,NULL,'2016-09-30',1455,0,8257,NULL,'',NULL),(5863,8787,8628508,8389,1174,'2016-09-30',NULL,NULL,NULL,NULL,NULL,'2016-09-30',1455,0,8260,NULL,'',NULL),(5864,8777,8628509,8372,1162,'2012-10-02','2016-09-21',NULL,NULL,NULL,NULL,'2012-10-02',1447,0,8098,NULL,'',NULL),(5865,8777,8628510,8385,1166,'2016-11-10',NULL,NULL,NULL,NULL,NULL,'2016-11-10',1447,0,8098,NULL,'',NULL),(5866,8777,8628511,8385,1166,'2016-11-10',NULL,NULL,NULL,NULL,NULL,'2016-11-10',1447,0,8100,NULL,'',NULL),(5867,8777,8628512,8368,1162,'2016-11-10',NULL,NULL,NULL,NULL,NULL,'2016-11-10',1447,0,8096,NULL,'',NULL),(5868,8777,8628513,8354,1162,'2016-07-16',NULL,NULL,NULL,NULL,NULL,'2016-07-16',1447,0,8106,NULL,'',NULL),(5869,8777,8628514,8354,1162,'2016-09-16',NULL,NULL,NULL,NULL,NULL,'2016-09-16',1447,0,8102,NULL,'',NULL),(5870,8777,8628515,8356,1162,'2016-01-01',NULL,NULL,NULL,NULL,NULL,'2016-01-01',1447,0,8100,NULL,'',NULL),(5871,8777,8628516,8390,1162,'2016-11-25',NULL,NULL,NULL,NULL,NULL,'2016-11-25',1447,0,NULL,NULL,'',NULL),(5872,8777,8628517,8390,1162,'2016-11-25',NULL,NULL,NULL,NULL,NULL,'2016-11-25',1447,0,8101,NULL,'',NULL),(5873,8777,8628518,8390,1162,'2016-12-02',NULL,NULL,NULL,NULL,NULL,'2016-12-02',1447,0,NULL,NULL,'',NULL),(5874,8788,8628521,8391,1175,'2012-11-19',NULL,NULL,NULL,NULL,NULL,'2012-11-19',1456,0,8203,NULL,'ADMINISTRATIVO',NULL),(5875,8788,8628522,8391,1175,'2016-11-02','2016-11-09',NULL,NULL,NULL,NULL,'2016-11-02',1456,0,8203,NULL,'',NULL),(5876,8788,8628522,8391,1175,'2016-11-12','2016-11-16',NULL,NULL,NULL,NULL,'2016-11-12',1456,0,8203,NULL,'',NULL),(5877,8788,8628522,8391,1175,'2016-11-19','2016-11-23',NULL,NULL,NULL,NULL,'2016-11-19',1456,0,8203,NULL,'',NULL),(5878,8788,8628522,8391,1175,'2016-11-26','2016-11-30',NULL,NULL,NULL,NULL,'2016-11-26',1456,0,8203,NULL,'',NULL),(5879,8788,8628523,8391,1175,'2016-01-04',NULL,NULL,NULL,NULL,NULL,'2016-01-04',1456,0,8203,NULL,'OFICIAL Y CABALLERO',NULL),(5880,8788,8628524,8391,1175,'2016-01-04',NULL,NULL,NULL,NULL,NULL,'2016-01-04',1456,0,8203,NULL,'',NULL),(5881,8788,8628525,8391,1175,'2016-01-04',NULL,NULL,NULL,NULL,NULL,'2016-01-04',1456,0,8203,NULL,'',NULL),(5882,8777,8628526,8356,1162,'2016-02-27',NULL,NULL,NULL,NULL,NULL,'2016-02-27',1447,0,8578,NULL,'',NULL),(5883,8777,8628527,8392,1166,'2017-07-18',NULL,NULL,NULL,NULL,NULL,'2017-07-18',1447,0,8103,NULL,'',NULL),(5884,8777,8628528,8392,1166,'2017-07-28',NULL,NULL,NULL,NULL,NULL,'2017-07-28',1447,0,8114,NULL,'',NULL),(5885,8777,8628529,8393,1162,'2017-08-29',NULL,NULL,NULL,NULL,NULL,'2017-08-29',1447,0,8575,NULL,'',NULL);
/*!40000 ALTER TABLE `contract` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `contract_attach`
--

DROP TABLE IF EXISTS `contract_attach`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `contract_attach` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Archivo Adjunto del contrato',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `contract` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador del Registro del contrato',
  `mimeType` tinyint(2) DEFAULT '0' COMMENT 'Mime Type del Archivo Adjunto',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion del Archivo Adjunto',
  `data` mediumblob COMMENT 'Archivo Adjunto en binario',
  `type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de Archivo Adjunto',
  `scope` int(4) DEFAULT NULL COMMENT 'Ambito del Archivo Adjunto',
  `security_level` tinyint(2) DEFAULT '0' COMMENT 'Nivel de seguridad del Archivo Adjunto',
  `attach_date` datetime DEFAULT NULL COMMENT 'Fecha del Archivo Adjunto',
  `driveId` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `IDX_CONTRACT_ATTACH_CONTRACT` (`contract`),
  KEY `IDX_CONTRACT_ATTACH_SCOPE` (`scope`),
  KEY `IDX_CONTRACT_ATTACH_DOMAIN` (`domain`),
  CONSTRAINT `FK_CONTRACT_ATTACH_CONTRACT` FOREIGN KEY (`contract`) REFERENCES `contract` (`id`),
  CONSTRAINT `FK_CONTRACT_ATTACH_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_CONTRACT_ATTACH_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=32 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Archivos Adjuntos de contratos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `contract_attach`
--

LOCK TABLES `contract_attach` WRITE;
/*!40000 ALTER TABLE `contract_attach` DISABLE KEYS */;
INSERT INTO `contract_attach` VALUES (1,8777,5868,5,'CONTRATO - Contrat@',NULL,4,NULL,0,'2016-11-21 09:48:53','0B6O1CXZ1Vg71dFhTOVRWRHFqUmc'),(2,8777,5869,5,'CONTRATO - Contrat@',NULL,4,NULL,0,'2016-11-24 18:14:39','0B6O1CXZ1Vg71b1l5Z3RDVmNIWGs'),(3,8777,5808,5,'CONTRATO - Contrat@',NULL,4,NULL,0,'2016-11-23 10:04:00','0B6O1CXZ1Vg71d2huUmlQa0VkREE'),(4,8777,5779,5,'CONTRATO - Contrat@',NULL,4,NULL,0,'2016-11-24 15:53:28','0B6O1CXZ1Vg71eE1PN3JkWFlMU28'),(5,8777,5831,5,'CONTRATO - Contrat@',NULL,4,NULL,0,'2016-11-24 15:50:55','0B6O1CXZ1Vg71aGpzY0xxZ3ZrSkE'),(6,8777,5780,5,'CONTRATO - Contrat@',NULL,4,NULL,0,'2016-11-24 17:30:16','0B6O1CXZ1Vg71YWtKbWNXSTN4Nms'),(7,8777,5870,5,'CONTRATO - Contrat@',NULL,4,NULL,0,'2016-11-25 11:44:24','0B6O1CXZ1Vg71cXpxNHp0dHRWQzg'),(8,8777,5871,5,'CONTRACT - Contrat@',NULL,4,NULL,0,'2016-12-02 10:37:47','0B6O1CXZ1Vg71R1d0bk5MVDRsUnM'),(9,8777,5872,5,'CONTRACT - Contrat@',NULL,4,NULL,0,'2016-12-02 10:37:33','0B6O1CXZ1Vg71ejdicVpuOFJ3RFE'),(10,8777,5873,5,'CONTRACT - Contrat@','<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n<CONTRATOS>\n    <CONTRATO_200>\n        <DATOS_EMPRESA>\n            <CIF_NIF_EMPRESA>\n                <CIF_NIF></CIF_NIF>\n            </CIF_NIF_EMPRESA>\n            <CODIGO_CUENTA_COTIZACION>011100000000000</CODIGO_CUENTA_COTIZACION>\n        </DATOS_EMPRESA>\n        <DATOS_TRABAJADOR>\n            <NOMBRE_APELLIDOS>\n                <NOMBRE>VACIO</NOMBRE>\n                <PRIMER_APELLIDO>DRAFT</PRIMER_APELLIDO>\n                <SEGUNDO_APELLIDO>PARCIAL</SEGUNDO_APELLIDO>\n            </NOMBRE_APELLIDOS>\n            <NACIONALIDAD>724</NACIONALIDAD>\n            <MUNICIPIO_RESIDENCIA></MUNICIPIO_RESIDENCIA>\n            <PAIS_RESIDENCIA>724</PAIS_RESIDENCIA>\n        </DATOS_TRABAJADOR>\n        <DATOS_GENERALES_CONTRATO>\n            <FECHA_INICIO>20161202</FECHA_INICIO>\n            <NACIONALIDAD_CT>724</NACIONALIDAD_CT>\n            <MUNICIPIO_CT>01059</MUNICIPIO_CT>\n        </DATOS_GENERALES_CONTRATO>\n        <DATOS_CONTRATO_TIEMPO_PARCIAL>\n            <TIPO_JORNADA>S</TIPO_JORNADA>\n            <HORAS_JORNADA>002000</HORAS_JORNADA>\n            <FIJODISCONTINUO_PERIODICO>N</FIJODISCONTINUO_PERIODICO>\n        </DATOS_CONTRATO_TIEMPO_PARCIAL>\n        <DATOS_COMUNICA_COPIA_BASICA>\n            <DOMIC_CENTRO_TRABAJO>CL. </DOMIC_CENTRO_TRABAJO>\n        </DATOS_COMUNICA_COPIA_BASICA>\n    </CONTRATO_200>\n</CONTRATOS>\n',4,NULL,0,'2016-12-02 10:48:17',NULL),(11,8788,5874,5,'CONTRACT - Contrat@','<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n<CONTRATOS>\n    <CONTRATO_100>\n        <DATOS_EMPRESA>\n            <CIF_NIF_EMPRESA>\n                <CIF_NIF></CIF_NIF>\n            </CIF_NIF_EMPRESA>\n            <CODIGO_CUENTA_COTIZACION>011166666666666</CODIGO_CUENTA_COTIZACION>\n        </DATOS_EMPRESA>\n        <DATOS_TRABAJADOR>\n            <IDENTIFICADORPFISICA>D22222222</IDENTIFICADORPFISICA>\n            <NOMBRE_APELLIDOS>\n                <NOMBRE>SIN FRACCIONAR</NOMBRE>\n                <PRIMER_APELLIDO>TIEMPO COMPLETO</PRIMER_APELLIDO>\n                <SEGUNDO_APELLIDO></SEGUNDO_APELLIDO>\n            </NOMBRE_APELLIDOS>\n            <NACIONALIDAD>724</NACIONALIDAD>\n            <MUNICIPIO_RESIDENCIA></MUNICIPIO_RESIDENCIA>\n            <PAIS_RESIDENCIA>724</PAIS_RESIDENCIA>\n            <NUMERO_SEGURIDAD_SOCIAL>222222222222</NUMERO_SEGURIDAD_SOCIAL>\n        </DATOS_TRABAJADOR>\n        <DATOS_GENERALES_CONTRATO>\n            <FECHA_INICIO>20121119</FECHA_INICIO>\n            <NACIONALIDAD_CT>724</NACIONALIDAD_CT>\n            <MUNICIPIO_CT>08019</MUNICIPIO_CT>\n        </DATOS_GENERALES_CONTRATO>\n        <DATOS_COMUNICA_COPIA_BASICA>\n            <DOMIC_CENTRO_TRABAJO>CL. </DOMIC_CENTRO_TRABAJO>\n        </DATOS_COMUNICA_COPIA_BASICA>\n    </CONTRATO_100>\n</CONTRATOS>\n',4,NULL,0,'2016-12-27 12:23:13',NULL),(12,8788,5878,5,'CONTRACT - Contrat@','<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n<CONTRATOS>\n    <CONTRATO_401>\n        <DATOS_EMPRESA>\n            <CIF_NIF_EMPRESA>\n                <CIF_NIF></CIF_NIF>\n            </CIF_NIF_EMPRESA>\n            <CODIGO_CUENTA_COTIZACION>011166666666666</CODIGO_CUENTA_COTIZACION>\n        </DATOS_EMPRESA>\n        <DATOS_TRABAJADOR>\n            <IDENTIFICADORPFISICA>D11111111</IDENTIFICADORPFISICA>\n            <NOMBRE_APELLIDOS>\n                <NOMBRE>ALTAS y BAJAS</NOMBRE>\n                <PRIMER_APELLIDO>MLTIPLES</PRIMER_APELLIDO>\n                <SEGUNDO_APELLIDO></SEGUNDO_APELLIDO>\n            </NOMBRE_APELLIDOS>\n            <NACIONALIDAD>724</NACIONALIDAD>\n            <MUNICIPIO_RESIDENCIA></MUNICIPIO_RESIDENCIA>\n            <PAIS_RESIDENCIA>724</PAIS_RESIDENCIA>\n            <NUMERO_SEGURIDAD_SOCIAL>111111111111</NUMERO_SEGURIDAD_SOCIAL>\n        </DATOS_TRABAJADOR>\n        <DATOS_GENERALES_CONTRATO>\n            <FECHA_INICIO>20161126</FECHA_INICIO>\n            <FECHA_TERMINO>20161130</FECHA_TERMINO>\n            <NACIONALIDAD_CT>724</NACIONALIDAD_CT>\n            <MUNICIPIO_CT>08019</MUNICIPIO_CT>\n            <IND_EMPRESA_AAPP_UNIVERSIDAD>N</IND_EMPRESA_AAPP_UNIVERSIDAD>\n        </DATOS_GENERALES_CONTRATO>\n        <DATOS_COMUNICA_COPIA_BASICA>\n            <DOMIC_CENTRO_TRABAJO>CL. </DOMIC_CENTRO_TRABAJO>\n        </DATOS_COMUNICA_COPIA_BASICA>\n    </CONTRATO_401>\n</CONTRATOS>\n',4,NULL,0,'2016-12-27 12:23:41',NULL),(13,8788,5877,5,'CONTRACT - Contrat@','<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n<CONTRATOS>\n    <CONTRATO_401>\n        <DATOS_EMPRESA>\n            <CIF_NIF_EMPRESA>\n                <CIF_NIF></CIF_NIF>\n            </CIF_NIF_EMPRESA>\n            <CODIGO_CUENTA_COTIZACION>011166666666666</CODIGO_CUENTA_COTIZACION>\n        </DATOS_EMPRESA>\n        <DATOS_TRABAJADOR>\n            <IDENTIFICADORPFISICA>D11111111</IDENTIFICADORPFISICA>\n            <NOMBRE_APELLIDOS>\n                <NOMBRE>ALTAS y BAJAS</NOMBRE>\n                <PRIMER_APELLIDO>MLTIPLES</PRIMER_APELLIDO>\n                <SEGUNDO_APELLIDO></SEGUNDO_APELLIDO>\n            </NOMBRE_APELLIDOS>\n            <NACIONALIDAD>724</NACIONALIDAD>\n            <MUNICIPIO_RESIDENCIA></MUNICIPIO_RESIDENCIA>\n            <PAIS_RESIDENCIA>724</PAIS_RESIDENCIA>\n            <NUMERO_SEGURIDAD_SOCIAL>111111111111</NUMERO_SEGURIDAD_SOCIAL>\n        </DATOS_TRABAJADOR>\n        <DATOS_GENERALES_CONTRATO>\n            <FECHA_INICIO>20161119</FECHA_INICIO>\n            <FECHA_TERMINO>20161123</FECHA_TERMINO>\n            <NACIONALIDAD_CT>724</NACIONALIDAD_CT>\n            <MUNICIPIO_CT>08019</MUNICIPIO_CT>\n            <IND_EMPRESA_AAPP_UNIVERSIDAD>N</IND_EMPRESA_AAPP_UNIVERSIDAD>\n        </DATOS_GENERALES_CONTRATO>\n        <DATOS_COMUNICA_COPIA_BASICA>\n            <DOMIC_CENTRO_TRABAJO>CL. </DOMIC_CENTRO_TRABAJO>\n        </DATOS_COMUNICA_COPIA_BASICA>\n    </CONTRATO_401>\n</CONTRATOS>\n',4,NULL,0,'2016-12-27 12:24:17',NULL),(14,8777,5749,5,'CONTRACT - Contrat@','<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n<CONTRATOS>\n    <CONTRATO_100>\n        <DATOS_EMPRESA>\n            <CIF_NIF_EMPRESA>\n                <CIF_NIF></CIF_NIF>\n            </CIF_NIF_EMPRESA>\n            <CODIGO_CUENTA_COTIZACION>011100000000000</CODIGO_CUENTA_COTIZACION>\n        </DATOS_EMPRESA>\n        <DATOS_TRABAJADOR>\n            <NOMBRE_APELLIDOS>\n                <NOMBRE>INDEFINIDO</NOMBRE>\n                <PRIMER_APELLIDO>1989 TIEMPO COMPLETO</PRIMER_APELLIDO>\n                <SEGUNDO_APELLIDO>ORDINARIO</SEGUNDO_APELLIDO>\n            </NOMBRE_APELLIDOS>\n            <NACIONALIDAD>724</NACIONALIDAD>\n            <MUNICIPIO_RESIDENCIA></MUNICIPIO_RESIDENCIA>\n            <PAIS_RESIDENCIA>724</PAIS_RESIDENCIA>\n        </DATOS_TRABAJADOR>\n        <DATOS_GENERALES_CONTRATO>\n            <FECHA_INICIO>19890218</FECHA_INICIO>\n            <NACIONALIDAD_CT>724</NACIONALIDAD_CT>\n            <MUNICIPIO_CT>01059</MUNICIPIO_CT>\n        </DATOS_GENERALES_CONTRATO>\n        <DATOS_COMUNICA_COPIA_BASICA>\n            <DOMIC_CENTRO_TRABAJO>CL. </DOMIC_CENTRO_TRABAJO>\n        </DATOS_COMUNICA_COPIA_BASICA>\n    </CONTRATO_100>\n</CONTRATOS>\n',4,NULL,0,'2016-12-23 14:37:05',NULL),(15,8777,5761,5,'CONTRACT - Contrat@','<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n<CONTRATOS>\n    <CONTRATO_100>\n        <DATOS_EMPRESA>\n            <CIF_NIF_EMPRESA>\n                <CIF_NIF></CIF_NIF>\n            </CIF_NIF_EMPRESA>\n            <CODIGO_CUENTA_COTIZACION>011100000000000</CODIGO_CUENTA_COTIZACION>\n        </DATOS_EMPRESA>\n        <DATOS_TRABAJADOR>\n            <NOMBRE_APELLIDOS>\n                <NOMBRE>INDEFINIDO</NOMBRE>\n                <PRIMER_APELLIDO>I.R.P.F ARABA TIEMPO</PRIMER_APELLIDO>\n                <SEGUNDO_APELLIDO>ORDINARIO</SEGUNDO_APELLIDO>\n            </NOMBRE_APELLIDOS>\n            <NACIONALIDAD>724</NACIONALIDAD>\n            <MUNICIPIO_RESIDENCIA></MUNICIPIO_RESIDENCIA>\n            <PAIS_RESIDENCIA>724</PAIS_RESIDENCIA>\n        </DATOS_TRABAJADOR>\n        <DATOS_GENERALES_CONTRATO>\n            <FECHA_INICIO>20160222</FECHA_INICIO>\n            <NACIONALIDAD_CT>724</NACIONALIDAD_CT>\n            <MUNICIPIO_CT></MUNICIPIO_CT>\n        </DATOS_GENERALES_CONTRATO>\n        <DATOS_COMUNICA_COPIA_BASICA>\n            <DOMIC_CENTRO_TRABAJO>CL. - -</DOMIC_CENTRO_TRABAJO>\n        </DATOS_COMUNICA_COPIA_BASICA>\n    </CONTRATO_100>\n</CONTRATOS>\n',4,NULL,0,'2016-12-23 15:03:21',NULL),(16,8788,5876,5,'CONTRACT - Contrat@','<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n<CONTRATOS>\n    <CONTRATO_401>\n        <DATOS_EMPRESA>\n            <CIF_NIF_EMPRESA>\n                <CIF_NIF></CIF_NIF>\n            </CIF_NIF_EMPRESA>\n            <CODIGO_CUENTA_COTIZACION>011166666666666</CODIGO_CUENTA_COTIZACION>\n        </DATOS_EMPRESA>\n        <DATOS_TRABAJADOR>\n            <IDENTIFICADORPFISICA>D11111111</IDENTIFICADORPFISICA>\n            <NOMBRE_APELLIDOS>\n                <NOMBRE>ALTAS y BAJAS</NOMBRE>\n                <PRIMER_APELLIDO>MLTIPLES</PRIMER_APELLIDO>\n                <SEGUNDO_APELLIDO></SEGUNDO_APELLIDO>\n            </NOMBRE_APELLIDOS>\n            <NACIONALIDAD>724</NACIONALIDAD>\n            <MUNICIPIO_RESIDENCIA></MUNICIPIO_RESIDENCIA>\n            <PAIS_RESIDENCIA>724</PAIS_RESIDENCIA>\n            <NUMERO_SEGURIDAD_SOCIAL>111111111111</NUMERO_SEGURIDAD_SOCIAL>\n        </DATOS_TRABAJADOR>\n        <DATOS_GENERALES_CONTRATO>\n            <FECHA_INICIO>20161112</FECHA_INICIO>\n            <FECHA_TERMINO>20161116</FECHA_TERMINO>\n            <NACIONALIDAD_CT>724</NACIONALIDAD_CT>\n            <MUNICIPIO_CT>08019</MUNICIPIO_CT>\n            <IND_EMPRESA_AAPP_UNIVERSIDAD>N</IND_EMPRESA_AAPP_UNIVERSIDAD>\n        </DATOS_GENERALES_CONTRATO>\n        <DATOS_COMUNICA_COPIA_BASICA>\n            <DOMIC_CENTRO_TRABAJO>CL. </DOMIC_CENTRO_TRABAJO>\n        </DATOS_COMUNICA_COPIA_BASICA>\n    </CONTRATO_401>\n</CONTRATOS>\n',4,NULL,0,'2016-12-27 12:24:35',NULL),(17,8788,5875,5,'CONTRACT - Contrat@','<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n<CONTRATOS>\n    <CONTRATO_401>\n        <DATOS_EMPRESA>\n            <CIF_NIF_EMPRESA>\n                <CIF_NIF></CIF_NIF>\n            </CIF_NIF_EMPRESA>\n            <CODIGO_CUENTA_COTIZACION>011166666666666</CODIGO_CUENTA_COTIZACION>\n        </DATOS_EMPRESA>\n        <DATOS_TRABAJADOR>\n            <IDENTIFICADORPFISICA>D11111111</IDENTIFICADORPFISICA>\n            <NOMBRE_APELLIDOS>\n                <NOMBRE>ALTAS y BAJAS</NOMBRE>\n                <PRIMER_APELLIDO>MLTIPLES</PRIMER_APELLIDO>\n                <SEGUNDO_APELLIDO></SEGUNDO_APELLIDO>\n            </NOMBRE_APELLIDOS>\n            <NACIONALIDAD>724</NACIONALIDAD>\n            <MUNICIPIO_RESIDENCIA></MUNICIPIO_RESIDENCIA>\n            <PAIS_RESIDENCIA>724</PAIS_RESIDENCIA>\n            <NUMERO_SEGURIDAD_SOCIAL>111111111111</NUMERO_SEGURIDAD_SOCIAL>\n        </DATOS_TRABAJADOR>\n        <DATOS_GENERALES_CONTRATO>\n            <FECHA_INICIO>20161102</FECHA_INICIO>\n            <FECHA_TERMINO>20161109</FECHA_TERMINO>\n            <NACIONALIDAD_CT>724</NACIONALIDAD_CT>\n            <MUNICIPIO_CT>08019</MUNICIPIO_CT>\n            <IND_EMPRESA_AAPP_UNIVERSIDAD>N</IND_EMPRESA_AAPP_UNIVERSIDAD>\n        </DATOS_GENERALES_CONTRATO>\n        <DATOS_COMUNICA_COPIA_BASICA>\n            <DOMIC_CENTRO_TRABAJO>CL. </DOMIC_CENTRO_TRABAJO>\n        </DATOS_COMUNICA_COPIA_BASICA>\n    </CONTRATO_401>\n</CONTRATOS>\n',4,NULL,0,'2016-12-27 12:24:56',NULL),(18,8788,5879,5,'CONTRACT - Contrat@','<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n<CONTRATOS>\n    <CONTRATO_100>\n        <DATOS_EMPRESA>\n            <CIF_NIF_EMPRESA>\n                <CIF_NIF></CIF_NIF>\n            </CIF_NIF_EMPRESA>\n            <CODIGO_CUENTA_COTIZACION>011166666666666</CODIGO_CUENTA_COTIZACION>\n        </DATOS_EMPRESA>\n        <DATOS_TRABAJADOR>\n            <NOMBRE_APELLIDOS>\n                <NOMBRE>15 PRIMEROS DIA</NOMBRE>\n                <PRIMER_APELLIDO>INCAPACIDAD TEMPORAL</PRIMER_APELLIDO>\n                <SEGUNDO_APELLIDO></SEGUNDO_APELLIDO>\n            </NOMBRE_APELLIDOS>\n            <NACIONALIDAD>724</NACIONALIDAD>\n            <MUNICIPIO_RESIDENCIA></MUNICIPIO_RESIDENCIA>\n            <PAIS_RESIDENCIA>724</PAIS_RESIDENCIA>\n        </DATOS_TRABAJADOR>\n        <DATOS_GENERALES_CONTRATO>\n            <FECHA_INICIO>20160104</FECHA_INICIO>\n            <NACIONALIDAD_CT>724</NACIONALIDAD_CT>\n            <MUNICIPIO_CT>08019</MUNICIPIO_CT>\n        </DATOS_GENERALES_CONTRATO>\n        <DATOS_COMUNICA_COPIA_BASICA>\n            <DOMIC_CENTRO_TRABAJO>CL. </DOMIC_CENTRO_TRABAJO>\n        </DATOS_COMUNICA_COPIA_BASICA>\n    </CONTRATO_100>\n</CONTRATOS>\n',4,NULL,0,'2017-01-04 18:29:15',NULL),(19,8788,5881,5,'CONTRACT - Contrat@','<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n<CONTRATOS>\n    <CONTRATO_100>\n        <DATOS_EMPRESA>\n            <CIF_NIF_EMPRESA>\n                <CIF_NIF></CIF_NIF>\n            </CIF_NIF_EMPRESA>\n            <CODIGO_CUENTA_COTIZACION>011166666666666</CODIGO_CUENTA_COTIZACION>\n        </DATOS_EMPRESA>\n        <DATOS_TRABAJADOR>\n            <IDENTIFICADORPFISICA>D55555555</IDENTIFICADORPFISICA>\n            <NOMBRE_APELLIDOS>\n                <NOMBRE>PAGO DELEGADO</NOMBRE>\n                <PRIMER_APELLIDO>INCAPACIDAD TEMPORAL</PRIMER_APELLIDO>\n                <SEGUNDO_APELLIDO>AT y EP</SEGUNDO_APELLIDO>\n            </NOMBRE_APELLIDOS>\n            <NACIONALIDAD>724</NACIONALIDAD>\n            <MUNICIPIO_RESIDENCIA></MUNICIPIO_RESIDENCIA>\n            <PAIS_RESIDENCIA>724</PAIS_RESIDENCIA>\n            <NUMERO_SEGURIDAD_SOCIAL>55555555</NUMERO_SEGURIDAD_SOCIAL>\n        </DATOS_TRABAJADOR>\n        <DATOS_GENERALES_CONTRATO>\n            <FECHA_INICIO>20160104</FECHA_INICIO>\n            <NACIONALIDAD_CT>724</NACIONALIDAD_CT>\n            <MUNICIPIO_CT>08019</MUNICIPIO_CT>\n        </DATOS_GENERALES_CONTRATO>\n        <DATOS_COMUNICA_COPIA_BASICA>\n            <DOMIC_CENTRO_TRABAJO>CL. </DOMIC_CENTRO_TRABAJO>\n        </DATOS_COMUNICA_COPIA_BASICA>\n    </CONTRATO_100>\n</CONTRATOS>\n',4,NULL,0,'2017-01-04 18:30:12',NULL),(20,8788,5880,5,'CONTRACT - Contrat@','<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n<CONTRATOS>\n    <CONTRATO_100>\n        <DATOS_EMPRESA>\n            <CIF_NIF_EMPRESA>\n                <CIF_NIF></CIF_NIF>\n            </CIF_NIF_EMPRESA>\n            <CODIGO_CUENTA_COTIZACION>011166666666666</CODIGO_CUENTA_COTIZACION>\n        </DATOS_EMPRESA>\n        <DATOS_TRABAJADOR>\n            <IDENTIFICADORPFISICA>D44444444</IDENTIFICADORPFISICA>\n            <NOMBRE_APELLIDOS>\n                <NOMBRE>PAGO DELEGADO</NOMBRE>\n                <PRIMER_APELLIDO>INCAPACIDAD TEMPORAL</PRIMER_APELLIDO>\n                <SEGUNDO_APELLIDO></SEGUNDO_APELLIDO>\n            </NOMBRE_APELLIDOS>\n            <NACIONALIDAD>724</NACIONALIDAD>\n            <MUNICIPIO_RESIDENCIA></MUNICIPIO_RESIDENCIA>\n            <PAIS_RESIDENCIA>724</PAIS_RESIDENCIA>\n            <NUMERO_SEGURIDAD_SOCIAL>44444444</NUMERO_SEGURIDAD_SOCIAL>\n        </DATOS_TRABAJADOR>\n        <DATOS_GENERALES_CONTRATO>\n            <FECHA_INICIO>20160104</FECHA_INICIO>\n            <NACIONALIDAD_CT>724</NACIONALIDAD_CT>\n            <MUNICIPIO_CT>08019</MUNICIPIO_CT>\n        </DATOS_GENERALES_CONTRATO>\n        <DATOS_COMUNICA_COPIA_BASICA>\n            <DOMIC_CENTRO_TRABAJO>CL. </DOMIC_CENTRO_TRABAJO>\n        </DATOS_COMUNICA_COPIA_BASICA>\n    </CONTRATO_100>\n</CONTRATOS>\n',4,NULL,0,'2017-01-04 18:30:33',NULL),(21,8777,5882,5,'CONTRACT - Contrat@','<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n<CONTRATOS>\n    <CONTRATO_100>\n        <DATOS_EMPRESA>\n            <CIF_NIF_EMPRESA>\n                <CIF_NIF></CIF_NIF>\n            </CIF_NIF_EMPRESA>\n            <CODIGO_CUENTA_COTIZACION>011100000000000</CODIGO_CUENTA_COTIZACION>\n        </DATOS_EMPRESA>\n        <DATOS_TRABAJADOR>\n            <NOMBRE_APELLIDOS>\n                <NOMBRE>SEMESTRALES Y T</NOMBRE>\n                <PRIMER_APELLIDO>EXTRAS</PRIMER_APELLIDO>\n                <SEGUNDO_APELLIDO>ANULAES</SEGUNDO_APELLIDO>\n            </NOMBRE_APELLIDOS>\n            <NACIONALIDAD>724</NACIONALIDAD>\n            <MUNICIPIO_RESIDENCIA></MUNICIPIO_RESIDENCIA>\n            <PAIS_RESIDENCIA>724</PAIS_RESIDENCIA>\n        </DATOS_TRABAJADOR>\n        <DATOS_GENERALES_CONTRATO>\n            <FECHA_INICIO>20160227</FECHA_INICIO>\n            <NACIONALIDAD_CT>724</NACIONALIDAD_CT>\n            <MUNICIPIO_CT>01059</MUNICIPIO_CT>\n        </DATOS_GENERALES_CONTRATO>\n        <DATOS_COMUNICA_COPIA_BASICA>\n            <DOMIC_CENTRO_TRABAJO>CL. </DOMIC_CENTRO_TRABAJO>\n        </DATOS_COMUNICA_COPIA_BASICA>\n    </CONTRATO_100>\n</CONTRATOS>\n',4,NULL,0,'2017-02-27 18:04:53',NULL),(22,8777,5772,5,'CONTRACT - Contrat@','<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n<CONTRATOS>\n    <CONTRATO_100>\n        <DATOS_EMPRESA>\n            <CIF_NIF_EMPRESA>\n                <CIF_NIF></CIF_NIF>\n            </CIF_NIF_EMPRESA>\n            <CODIGO_CUENTA_COTIZACION>011100000000000</CODIGO_CUENTA_COTIZACION>\n        </DATOS_EMPRESA>\n        <DATOS_TRABAJADOR>\n            <NOMBRE_APELLIDOS>\n                <NOMBRE>INDEFINIDO</NOMBRE>\n                <PRIMER_APELLIDO>ATRASOS TIEMPO COMPL</PRIMER_APELLIDO>\n                <SEGUNDO_APELLIDO>ORDINARIO</SEGUNDO_APELLIDO>\n            </NOMBRE_APELLIDOS>\n            <NACIONALIDAD>724</NACIONALIDAD>\n            <MUNICIPIO_RESIDENCIA></MUNICIPIO_RESIDENCIA>\n            <PAIS_RESIDENCIA>724</PAIS_RESIDENCIA>\n        </DATOS_TRABAJADOR>\n        <DATOS_GENERALES_CONTRATO>\n            <FECHA_INICIO>20120229</FECHA_INICIO>\n            <NACIONALIDAD_CT>724</NACIONALIDAD_CT>\n            <MUNICIPIO_CT>01059</MUNICIPIO_CT>\n        </DATOS_GENERALES_CONTRATO>\n        <DATOS_COMUNICA_COPIA_BASICA>\n            <DOMIC_CENTRO_TRABAJO>CL. </DOMIC_CENTRO_TRABAJO>\n        </DATOS_COMUNICA_COPIA_BASICA>\n    </CONTRATO_100>\n</CONTRATOS>\n',4,NULL,0,'2017-03-06 17:47:12',NULL),(23,8777,5793,5,'CONTRACT - Contrat@','<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n<CONTRATOS>\n    <CONTRATO_100>\n        <DATOS_EMPRESA>\n            <CIF_NIF_EMPRESA>\n                <CIF_NIF></CIF_NIF>\n            </CIF_NIF_EMPRESA>\n            <CODIGO_CUENTA_COTIZACION>011100000000000</CODIGO_CUENTA_COTIZACION>\n        </DATOS_EMPRESA>\n        <DATOS_TRABAJADOR>\n            <NOMBRE_APELLIDOS>\n                <NOMBRE>DESCRIPCIONES</NOMBRE>\n                <PRIMER_APELLIDO>ERROR</PRIMER_APELLIDO>\n                <SEGUNDO_APELLIDO></SEGUNDO_APELLIDO>\n            </NOMBRE_APELLIDOS>\n            <NACIONALIDAD>724</NACIONALIDAD>\n            <MUNICIPIO_RESIDENCIA></MUNICIPIO_RESIDENCIA>\n            <PAIS_RESIDENCIA>724</PAIS_RESIDENCIA>\n        </DATOS_TRABAJADOR>\n        <DATOS_GENERALES_CONTRATO>\n            <FECHA_INICIO>20160407</FECHA_INICIO>\n            <NACIONALIDAD_CT>724</NACIONALIDAD_CT>\n            <MUNICIPIO_CT>01059</MUNICIPIO_CT>\n        </DATOS_GENERALES_CONTRATO>\n        <DATOS_COMUNICA_COPIA_BASICA>\n            <DOMIC_CENTRO_TRABAJO>CL. </DOMIC_CENTRO_TRABAJO>\n        </DATOS_COMUNICA_COPIA_BASICA>\n    </CONTRATO_100>\n</CONTRATOS>\n',4,NULL,0,'2017-03-06 17:47:24',NULL),(24,8777,5851,5,'CONTRACT - Contrat@','<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n<CONTRATOS>\n    <CONTRATO_100>\n        <DATOS_EMPRESA>\n            <CIF_NIF_EMPRESA>\n                <CIF_NIF></CIF_NIF>\n            </CIF_NIF_EMPRESA>\n            <CODIGO_CUENTA_COTIZACION>011100000000000</CODIGO_CUENTA_COTIZACION>\n        </DATOS_EMPRESA>\n        <DATOS_TRABAJADOR>\n            <NOMBRE_APELLIDOS>\n                <NOMBRE>FIJA</NOMBRE>\n                <PRIMER_APELLIDO>CONSTANTE</PRIMER_APELLIDO>\n                <SEGUNDO_APELLIDO></SEGUNDO_APELLIDO>\n            </NOMBRE_APELLIDOS>\n            <NACIONALIDAD>724</NACIONALIDAD>\n            <MUNICIPIO_RESIDENCIA></MUNICIPIO_RESIDENCIA>\n            <PAIS_RESIDENCIA>724</PAIS_RESIDENCIA>\n        </DATOS_TRABAJADOR>\n        <DATOS_GENERALES_CONTRATO>\n            <FECHA_INICIO>20160826</FECHA_INICIO>\n            <NACIONALIDAD_CT>724</NACIONALIDAD_CT>\n            <MUNICIPIO_CT>01059</MUNICIPIO_CT>\n        </DATOS_GENERALES_CONTRATO>\n        <DATOS_COMUNICA_COPIA_BASICA>\n            <DOMIC_CENTRO_TRABAJO>CL. </DOMIC_CENTRO_TRABAJO>\n        </DATOS_COMUNICA_COPIA_BASICA>\n    </CONTRATO_100>\n</CONTRATOS>\n',4,NULL,0,'2017-03-07 08:47:41',NULL),(25,8777,5852,5,'CONTRACT - Contrat@','<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n<CONTRATOS>\n    <CONTRATO_100>\n        <DATOS_EMPRESA>\n            <CIF_NIF_EMPRESA>\n                <CIF_NIF></CIF_NIF>\n            </CIF_NIF_EMPRESA>\n            <CODIGO_CUENTA_COTIZACION>011100000000000</CODIGO_CUENTA_COTIZACION>\n        </DATOS_EMPRESA>\n        <DATOS_TRABAJADOR>\n            <NOMBRE_APELLIDOS>\n                <NOMBRE>BRUTO</NOMBRE>\n                <PRIMER_APELLIDO>CONSTANTE</PRIMER_APELLIDO>\n                <SEGUNDO_APELLIDO></SEGUNDO_APELLIDO>\n            </NOMBRE_APELLIDOS>\n            <NACIONALIDAD>724</NACIONALIDAD>\n            <MUNICIPIO_RESIDENCIA></MUNICIPIO_RESIDENCIA>\n            <PAIS_RESIDENCIA>724</PAIS_RESIDENCIA>\n        </DATOS_TRABAJADOR>\n        <DATOS_GENERALES_CONTRATO>\n            <FECHA_INICIO>20160826</FECHA_INICIO>\n            <NACIONALIDAD_CT>724</NACIONALIDAD_CT>\n            <MUNICIPIO_CT>01059</MUNICIPIO_CT>\n        </DATOS_GENERALES_CONTRATO>\n        <DATOS_COMUNICA_COPIA_BASICA>\n            <DOMIC_CENTRO_TRABAJO>CL. </DOMIC_CENTRO_TRABAJO>\n        </DATOS_COMUNICA_COPIA_BASICA>\n    </CONTRATO_100>\n</CONTRATOS>\n',4,NULL,0,'2017-03-07 08:51:09',NULL),(26,8777,5847,5,'CONTRACT - Contrat@','<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n<CONTRATOS>\n    <CONTRATO_200>\n        <DATOS_EMPRESA>\n            <CIF_NIF_EMPRESA>\n                <CIF_NIF></CIF_NIF>\n            </CIF_NIF_EMPRESA>\n            <CODIGO_CUENTA_COTIZACION>011100000000000</CODIGO_CUENTA_COTIZACION>\n        </DATOS_EMPRESA>\n        <DATOS_TRABAJADOR>\n            <NOMBRE_APELLIDOS>\n                <NOMBRE>( M M J V S D )</NOMBRE>\n                <PRIMER_APELLIDO>INDEFINIDO</PRIMER_APELLIDO>\n                <SEGUNDO_APELLIDO>TIEMPO PARCIAL ORDIN</SEGUNDO_APELLIDO>\n            </NOMBRE_APELLIDOS>\n            <NACIONALIDAD>724</NACIONALIDAD>\n            <MUNICIPIO_RESIDENCIA></MUNICIPIO_RESIDENCIA>\n            <PAIS_RESIDENCIA>724</PAIS_RESIDENCIA>\n        </DATOS_TRABAJADOR>\n        <DATOS_GENERALES_CONTRATO>\n            <FECHA_INICIO>20160721</FECHA_INICIO>\n            <NACIONALIDAD_CT>724</NACIONALIDAD_CT>\n            <MUNICIPIO_CT></MUNICIPIO_CT>\n        </DATOS_GENERALES_CONTRATO>\n        <DATOS_CONTRATO_TIEMPO_PARCIAL>\n            <TIPO_JORNADA>S</TIPO_JORNADA>\n            <HORAS_JORNADA>002000</HORAS_JORNADA>\n            <FIJODISCONTINUO_PERIODICO>N</FIJODISCONTINUO_PERIODICO>\n        </DATOS_CONTRATO_TIEMPO_PARCIAL>\n        <DATOS_COMUNICA_COPIA_BASICA>\n            <DOMIC_CENTRO_TRABAJO>CL. - -</DOMIC_CENTRO_TRABAJO>\n        </DATOS_COMUNICA_COPIA_BASICA>\n    </CONTRATO_200>\n</CONTRATOS>\n',4,NULL,0,'2017-03-14 17:59:20',NULL),(27,8777,5826,5,'CONTRACT - Contrat@','<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n<CONTRATOS>\n    <CONTRATO_100>\n        <DATOS_EMPRESA>\n            <CIF_NIF_EMPRESA>\n                <CIF_NIF></CIF_NIF>\n            </CIF_NIF_EMPRESA>\n            <CODIGO_CUENTA_COTIZACION>011100000000000</CODIGO_CUENTA_COTIZACION>\n        </DATOS_EMPRESA>\n        <DATOS_TRABAJADOR>\n            <NOMBRE_APELLIDOS>\n                <NOMBRE>EMBARGABLE</NOMBRE>\n                <PRIMER_APELLIDO>MAX</PRIMER_APELLIDO>\n                <SEGUNDO_APELLIDO></SEGUNDO_APELLIDO>\n            </NOMBRE_APELLIDOS>\n            <NACIONALIDAD>724</NACIONALIDAD>\n            <MUNICIPIO_RESIDENCIA></MUNICIPIO_RESIDENCIA>\n            <PAIS_RESIDENCIA>724</PAIS_RESIDENCIA>\n        </DATOS_TRABAJADOR>\n        <DATOS_GENERALES_CONTRATO>\n            <FECHA_INICIO>20160523</FECHA_INICIO>\n            <NACIONALIDAD_CT>724</NACIONALIDAD_CT>\n            <MUNICIPIO_CT>01059</MUNICIPIO_CT>\n        </DATOS_GENERALES_CONTRATO>\n        <DATOS_COMUNICA_COPIA_BASICA>\n            <DOMIC_CENTRO_TRABAJO>CL. </DOMIC_CENTRO_TRABAJO>\n        </DATOS_COMUNICA_COPIA_BASICA>\n    </CONTRATO_100>\n</CONTRATOS>\n',4,NULL,0,'2017-03-15 16:29:48',NULL),(28,8777,5883,5,'CONTRACT - Contrat@','<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n<CONTRATOS>\n    <CONTRATO_100>\n        <DATOS_EMPRESA>\n            <CIF_NIF_EMPRESA>\n                <CIF_NIF></CIF_NIF>\n            </CIF_NIF_EMPRESA>\n            <CODIGO_CUENTA_COTIZACION>011100000000000</CODIGO_CUENTA_COTIZACION>\n        </DATOS_EMPRESA>\n        <DATOS_TRABAJADOR>\n            <NOMBRE_APELLIDOS>\n                <NOMBRE>INCIDENCIA</NOMBRE>\n                <PRIMER_APELLIDO>COMPLEMENTO_I</PRIMER_APELLIDO>\n                <SEGUNDO_APELLIDO></SEGUNDO_APELLIDO>\n            </NOMBRE_APELLIDOS>\n            <NACIONALIDAD>724</NACIONALIDAD>\n            <MUNICIPIO_RESIDENCIA></MUNICIPIO_RESIDENCIA>\n            <PAIS_RESIDENCIA>724</PAIS_RESIDENCIA>\n        </DATOS_TRABAJADOR>\n        <DATOS_GENERALES_CONTRATO>\n            <FECHA_INICIO>20170718</FECHA_INICIO>\n            <NACIONALIDAD_CT>724</NACIONALIDAD_CT>\n            <MUNICIPIO_CT></MUNICIPIO_CT>\n        </DATOS_GENERALES_CONTRATO>\n        <DATOS_COMUNICA_COPIA_BASICA>\n            <DOMIC_CENTRO_TRABAJO>CL. - -</DOMIC_CENTRO_TRABAJO>\n        </DATOS_COMUNICA_COPIA_BASICA>\n    </CONTRATO_100>\n</CONTRATOS>\n',4,NULL,0,'2017-07-21 11:49:51',NULL),(29,8777,5884,5,'CONTRACT - Contrat@','<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n<CONTRATOS>\n    <CONTRATO_520>\n        <DATOS_EMPRESA>\n            <CIF_NIF_EMPRESA>\n                <CIF_NIF></CIF_NIF>\n            </CIF_NIF_EMPRESA>\n            <CODIGO_CUENTA_COTIZACION>011100000000000</CODIGO_CUENTA_COTIZACION>\n        </DATOS_EMPRESA>\n        <DATOS_TRABAJADOR>\n            <NOMBRE_APELLIDOS>\n                <NOMBRE>COMPLEMENTO</NOMBRE>\n                <PRIMER_APELLIDO>TIEMPO_PARCIAL</PRIMER_APELLIDO>\n                <SEGUNDO_APELLIDO></SEGUNDO_APELLIDO>\n            </NOMBRE_APELLIDOS>\n            <NACIONALIDAD>724</NACIONALIDAD>\n            <MUNICIPIO_RESIDENCIA></MUNICIPIO_RESIDENCIA>\n            <PAIS_RESIDENCIA>724</PAIS_RESIDENCIA>\n        </DATOS_TRABAJADOR>\n        <DATOS_GENERALES_CONTRATO>\n            <FECHA_INICIO>20170728</FECHA_INICIO>\n            <NACIONALIDAD_CT>724</NACIONALIDAD_CT>\n            <MUNICIPIO_CT></MUNICIPIO_CT>\n        </DATOS_GENERALES_CONTRATO>\n        <DATOSCONTRATOPRACTICAS/>\n        <DATOS_CONTRATO_TIEMPO_PARCIAL>\n            <TIPO_JORNADA>S</TIPO_JORNADA>\n            <HORAS_JORNADA>003000</HORAS_JORNADA>\n        </DATOS_CONTRATO_TIEMPO_PARCIAL>\n        <DATOS_COMUNICA_COPIA_BASICA>\n            <DOMIC_CENTRO_TRABAJO>CL. - -</DOMIC_CENTRO_TRABAJO>\n        </DATOS_COMUNICA_COPIA_BASICA>\n    </CONTRATO_520>\n</CONTRATOS>\n',4,NULL,0,'2017-07-28 09:25:27',NULL),(30,8777,5846,5,'CONTRACT - Contrat@','<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n<CONTRATOS>\n    <CONTRATO_200>\n        <DATOS_EMPRESA>\n            <CIF_NIF_EMPRESA>\n                <CIF_NIF></CIF_NIF>\n            </CIF_NIF_EMPRESA>\n            <CODIGO_CUENTA_COTIZACION>011100000000000</CODIGO_CUENTA_COTIZACION>\n        </DATOS_EMPRESA>\n        <DATOS_TRABAJADOR>\n            <NOMBRE_APELLIDOS>\n                <NOMBRE>(L M M J V ) 50</NOMBRE>\n                <PRIMER_APELLIDO>INDEFINIDO</PRIMER_APELLIDO>\n                <SEGUNDO_APELLIDO>TIMEPO PARCIAL ORDIN</SEGUNDO_APELLIDO>\n            </NOMBRE_APELLIDOS>\n            <NACIONALIDAD>724</NACIONALIDAD>\n            <MUNICIPIO_RESIDENCIA></MUNICIPIO_RESIDENCIA>\n            <PAIS_RESIDENCIA>724</PAIS_RESIDENCIA>\n        </DATOS_TRABAJADOR>\n        <DATOS_GENERALES_CONTRATO>\n            <FECHA_INICIO>20160721</FECHA_INICIO>\n            <NACIONALIDAD_CT>724</NACIONALIDAD_CT>\n            <MUNICIPIO_CT></MUNICIPIO_CT>\n        </DATOS_GENERALES_CONTRATO>\n        <DATOS_CONTRATO_TIEMPO_PARCIAL>\n            <TIPO_JORNADA>S</TIPO_JORNADA>\n            <HORAS_JORNADA>002000</HORAS_JORNADA>\n            <FIJODISCONTINUO_PERIODICO>N</FIJODISCONTINUO_PERIODICO>\n        </DATOS_CONTRATO_TIEMPO_PARCIAL>\n        <DATOS_COMUNICA_COPIA_BASICA>\n            <DOMIC_CENTRO_TRABAJO>CL. - -</DOMIC_CENTRO_TRABAJO>\n        </DATOS_COMUNICA_COPIA_BASICA>\n    </CONTRATO_200>\n</CONTRATOS>\n',4,NULL,0,'2017-08-29 09:34:12',NULL),(31,8777,5885,5,'CONTRACT - Contrat@','<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"yes\"?>\n<CONTRATOS>\n    <CONTRATO_200>\n        <DATOS_EMPRESA>\n            <CIF_NIF_EMPRESA>\n                <CIF_NIF></CIF_NIF>\n            </CIF_NIF_EMPRESA>\n            <CODIGO_CUENTA_COTIZACION>011100000000000</CODIGO_CUENTA_COTIZACION>\n        </DATOS_EMPRESA>\n        <DATOS_TRABAJADOR>\n            <NOMBRE_APELLIDOS>\n                <NOMBRE>CALENDARIO</NOMBRE>\n                <PRIMER_APELLIDO>TESTING</PRIMER_APELLIDO>\n                <SEGUNDO_APELLIDO></SEGUNDO_APELLIDO>\n            </NOMBRE_APELLIDOS>\n            <NACIONALIDAD>724</NACIONALIDAD>\n            <MUNICIPIO_RESIDENCIA></MUNICIPIO_RESIDENCIA>\n            <PAIS_RESIDENCIA>724</PAIS_RESIDENCIA>\n        </DATOS_TRABAJADOR>\n        <DATOS_GENERALES_CONTRATO>\n            <FECHA_INICIO>20170829</FECHA_INICIO>\n            <NACIONALIDAD_CT>724</NACIONALIDAD_CT>\n            <MUNICIPIO_CT>01059</MUNICIPIO_CT>\n        </DATOS_GENERALES_CONTRATO>\n        <DATOS_CONTRATO_TIEMPO_PARCIAL>\n            <TIPO_JORNADA>S</TIPO_JORNADA>\n            <HORAS_JORNADA>002800</HORAS_JORNADA>\n            <FIJODISCONTINUO_PERIODICO>N</FIJODISCONTINUO_PERIODICO>\n        </DATOS_CONTRATO_TIEMPO_PARCIAL>\n        <DATOS_COMUNICA_COPIA_BASICA>\n            <DOMIC_CENTRO_TRABAJO>CL. </DOMIC_CENTRO_TRABAJO>\n        </DATOS_COMUNICA_COPIA_BASICA>\n    </CONTRATO_200>\n</CONTRATOS>\n',4,NULL,0,'2017-09-11 11:41:27',NULL);
/*!40000 ALTER TABLE `contract_attach` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `contract_batch`
--

DROP TABLE IF EXISTS `contract_batch`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `contract_batch` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la remesa de contratos',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `outcome_file_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `communication_id` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Identificador resultante de la comunicacion',
  `income_file_date` datetime DEFAULT NULL COMMENT 'Fecha de respuesta',
  `red_response_id` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Identificador de la respuesta',
  `status` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Indica el estado de la remesa',
  `outcome_file` mediumblob COMMENT 'Archivo Adjunto en binario',
  `income_file` mediumblob COMMENT 'Archivo respuesta en binario',
  PRIMARY KEY (`id`),
  KEY `IDX_CONTRACT_BATCH_DOMAIN` (`domain`),
  CONSTRAINT `FK_CONTRACT_BATCH_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Remesas de contratos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `contract_batch`
--

LOCK TABLES `contract_batch` WRITE;
/*!40000 ALTER TABLE `contract_batch` DISABLE KEYS */;
/*!40000 ALTER TABLE `contract_batch` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `contract_batch_detail`
--

DROP TABLE IF EXISTS `contract_batch_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `contract_batch_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del detalle de la remesa',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `contract_batch` int(4) NOT NULL COMMENT 'Identificador unico de la remesa de contratos',
  `contract` int(4) NOT NULL COMMENT 'Identificador unico del contrato',
  `status` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Estado de la linea de la remesa',
  `action_type` varchar(2) COLLATE latin1_spanish_ci NOT NULL DEFAULT '' COMMENT 'Tipo de accion a realizar',
  `leave_type` varchar(2) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Tipo de baja',
  PRIMARY KEY (`id`),
  KEY `IDX_CONTRACT_BATCH_DETAIL_CONTRACT_BATCH` (`contract_batch`),
  KEY `IDX_CONTRACT_BATCH_DETAIL_CONTRACT` (`contract`),
  KEY `IDX_CONTRACT_BATCH_DETAIL_DOMAIN` (`domain`),
  CONSTRAINT `FK_CONTRACT_BATCH_DETAIL_CONTRACT` FOREIGN KEY (`contract`) REFERENCES `contract` (`id`),
  CONSTRAINT `FK_CONTRACT_BATCH_DETAIL_CONTRACT_BATCH` FOREIGN KEY (`contract_batch`) REFERENCES `contract_batch` (`id`),
  CONSTRAINT `FK_CONTRACT_BATCH_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalle de las remesas de contratos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `contract_batch_detail`
--

LOCK TABLES `contract_batch_detail` WRITE;
/*!40000 ALTER TABLE `contract_batch_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `contract_batch_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `contract_bonus`
--

DROP TABLE IF EXISTS `contract_bonus`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `contract_bonus` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `contract` int(4) NOT NULL COMMENT 'Contrato',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion',
  `expression` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Fórmula',
  `start_date` date NOT NULL COMMENT 'Fecha de inicio ',
  `end_date` date DEFAULT NULL COMMENT 'Fecha de finalizacion',
  `bonus_concept` int(4) DEFAULT NULL COMMENT 'Concepto de bonificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_CONTRACT_BONUS_CONTRACT` (`contract`),
  KEY `IDX_CONTRACT_BONUS_BONUS_CONCEPT` (`bonus_concept`),
  KEY `IDX_CONTRACT_BONUS_DOMAIN` (`domain`),
  CONSTRAINT `FK_CONTRACT_BONUS_BONUS_CONCEPT` FOREIGN KEY (`bonus_concept`) REFERENCES `bonus_concept` (`id`),
  CONSTRAINT `FK_CONTRACT_BONUS_CONTRACT` FOREIGN KEY (`contract`) REFERENCES `contract` (`id`),
  CONSTRAINT `FK_CONTRACT_BONUS_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1121 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Bonificaciones';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `contract_bonus`
--

LOCK TABLES `contract_bonus` WRITE;
/*!40000 ALTER TABLE `contract_bonus` DISABLE KEYS */;
INSERT INTO `contract_bonus` VALUES (1114,8777,5776,'','','2016-03-01',NULL,3262),(1116,8777,5776,'','','2016-03-01',NULL,3263),(1117,8777,5775,'','','2016-03-01',NULL,3266),(1118,8777,5775,'','','2016-03-01',NULL,3268),(1119,8777,5867,'REDUCCIONES RD-L 3/2014 TARIFA PLANA (PRIMEROS DOS AÑOS)',NULL,'2016-11-01',NULL,3262),(1120,8777,5867,'REDUCCIONES RD-L 3/2014 TARIFA PLANA (TERCER AÑO)',NULL,'2016-11-01',NULL,3263);
/*!40000 ALTER TABLE `contract_bonus` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `contract_calendar_event`
--

DROP TABLE IF EXISTS `contract_calendar_event`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `contract_calendar_event` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `contract` int(4) NOT NULL COMMENT 'Identificador del Contrato',
  `date` date NOT NULL COMMENT 'Fecha de la incidencia',
  `type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de incidencia',
  `duration` double DEFAULT NULL COMMENT 'Duracion de la incidencia',
  PRIMARY KEY (`id`),
  KEY `IDX_CONTRACT_CALENDAR_EVENT_CONTRACT` (`contract`),
  KEY `IDX_CONTRACT_CALENDAR_EVENT_DOMAIN` (`domain`),
  CONSTRAINT `FK_CONTRACT_CALENDAR_EVENT_CONTRACT` FOREIGN KEY (`contract`) REFERENCES `contract` (`id`),
  CONSTRAINT `FK_CONTRACT_CALENDAR_EVENT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Incidencias de calendario en Contratos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `contract_calendar_event`
--

LOCK TABLES `contract_calendar_event` WRITE;
/*!40000 ALTER TABLE `contract_calendar_event` DISABLE KEYS */;
/*!40000 ALTER TABLE `contract_calendar_event` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `contract_clause`
--

DROP TABLE IF EXISTS `contract_clause`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `contract_clause` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `contract` int(4) DEFAULT NULL COMMENT 'Identificador del Contrato',
  `line` smallint(2) DEFAULT '1' COMMENT 'Numero de linea de la Clausula del Contrato',
  `name` varchar(64) COLLATE latin1_spanish_ci NOT NULL DEFAULT '' COMMENT 'Titulo de la Clausula de Contrato',
  `description` text COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion de la Clausula de Contrato',
  `general` tinyint(1) DEFAULT '0' COMMENT 'Indica si la Clausula es particular o general',
  PRIMARY KEY (`id`),
  KEY `IDX_CONTRACT_CLAUSE_CONTRACT` (`contract`),
  KEY `IDX_CONTRACT_CLAUSE_DOMAIN` (`domain`),
  CONSTRAINT `FK_CONTRACT_CLAUSE_CONTRACT` FOREIGN KEY (`contract`) REFERENCES `contract` (`id`),
  CONSTRAINT `FK_CONTRACT_CLAUSE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Clausulas de contrato';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `contract_clause`
--

LOCK TABLES `contract_clause` WRITE;
/*!40000 ALTER TABLE `contract_clause` DISABLE KEYS */;
/*!40000 ALTER TABLE `contract_clause` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `contract_data`
--

DROP TABLE IF EXISTS `contract_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `contract_data` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre',
  `contract` int(4) NOT NULL COMMENT 'Contrato',
  `expression` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Expresion',
  `start_date` date NOT NULL COMMENT 'Fecha de inicio ',
  `end_date` date DEFAULT NULL COMMENT 'Fecha de finalizacion',
  PRIMARY KEY (`id`),
  KEY `IDX_CONTRACT_DATA_CONTRACT` (`contract`),
  KEY `IDX_CONTRACT_DATA_DOMAIN` (`domain`),
  CONSTRAINT `FK_CONTRACT_DATA_CONTRACT` FOREIGN KEY (`contract`) REFERENCES `contract` (`id`),
  CONSTRAINT `FK_CONTRACT_DATA_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=55647 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Contexto del contrato';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `contract_data`
--

LOCK TABLES `contract_data` WRITE;
/*!40000 ALTER TABLE `contract_data` DISABLE KEYS */;
INSERT INTO `contract_data` VALUES (-55155,8777,'TC2',-5800,'\"401\"','2016-04-19',NULL),(-55154,8777,'TC2',-5799,'\"100\"','2016-04-15',NULL),(-55153,8777,'GRUPO_COTIZACION',-5799,'\"01\"','2016-04-15',NULL),(-55152,8777,'TC2',-5798,'\"100\"','2016-04-15',NULL),(-55151,8777,'GRUPO_COTIZACION',-5798,'\"02\"','2016-04-15',NULL),(-55150,8777,'TC2',-5797,'\"100\"','2016-04-14',NULL),(-55149,8777,'GRUPO_COTIZACION',-5797,'\"01\"','2016-04-14',NULL),(-55146,8777,'TC2',-5795,'\"100\"','2016-04-14',NULL),(-55145,8777,'GRUPO_COTIZACION',-5795,'\"01\"','2016-04-14',NULL),(54986,8777,'GRUPO_COTIZACION',5747,'\"03\"','2012-08-18',NULL),(54987,8777,'TC2',5747,'\"100\"','2012-08-18',NULL),(54988,8777,'GRUPO_COTIZACION',5748,'\"03\"','1993-02-18',NULL),(54989,8777,'TC2',5748,'\"100\"','1993-02-18',NULL),(54990,8777,'TC2',5749,'\"100\"','1989-02-18',NULL),(54991,8777,'GRUPO_COTIZACION',5749,'\"03\"','1989-02-18',NULL),(54992,8777,'GRUPO_COTIZACION',5750,'\"03\"','2001-02-19',NULL),(54993,8777,'TC2',5750,'\"100\"','2001-02-19',NULL),(54994,8777,'GRUPO_COTIZACION',5751,'\"03\"','2016-02-22',NULL),(54995,8777,'TC2',5751,'\"100\"','2016-02-22',NULL),(54996,8777,'GRUPO_COTIZACION',5752,'\"05\"','2016-02-22',NULL),(54997,8777,'TC2',5752,'\"100\"','2016-02-22',NULL),(54998,8777,'TC2',5753,'\"100\"','2016-02-21',NULL),(54999,8777,'GRUPO_COTIZACION',5753,'\"01\"','2016-02-21',NULL),(55000,8777,'SALARIO_MENSUAL',5753,'10000','2016-02-01',NULL),(55001,8777,'GRUPO_COTIZACION',5754,'\"01\"','2016-02-21',NULL),(55002,8777,'TC2',5754,'\"100\"','2016-02-21',NULL),(55003,8777,'SALARIO_MENSUAL',5754,'10','2016-02-01',NULL),(55004,8778,'TC2',5755,'\"421\"','2016-02-22',NULL),(55005,8778,'SALARIO_MENSUAL',5755,'600','2016-02-01',NULL),(55006,8777,'GRUPO_COTIZACION',5756,'\"04\"','2016-02-22',NULL),(55007,8777,'TC2',5756,'\"100\"','2016-02-22',NULL),(55010,8777,'GRUPO_COTIZACION',5758,'\"01\"','2015-02-22',NULL),(55011,8777,'TC2',5758,'\"100\"','2015-02-22',NULL),(55012,8777,'TC2',5759,'\"100\"','2015-02-22',NULL),(55013,8777,'TC2',5760,'\"100\"','2015-02-22',NULL),(55014,8777,'GRUPO_COTIZACION',5761,'\"01\"','2016-02-22',NULL),(55015,8777,'TC2',5761,'\"100\"','2016-02-22',NULL),(55016,8777,'GRUPO_COTIZACION',5759,'\"01\"','2015-02-22',NULL),(55017,8777,'GRUPO_COTIZACION',5760,'\"05\"','2015-02-22',NULL),(55018,8777,'GRUPO_COTIZACION',5762,'\"05\"','2016-02-22',NULL),(55019,8777,'TC2',5762,'\"100\"','2016-02-22',NULL),(55020,8777,'GRUPO_COTIZACION',5763,'\"09\"','2016-02-22',NULL),(55021,8777,'TC2',5763,'\"100\"','2016-02-22',NULL),(55022,8777,'GRUPO_COTIZACION',5764,'\"03\"','2016-02-22',NULL),(55023,8777,'TC2',5764,'\"100\"','2016-02-22',NULL),(55024,8777,'GRUPO_COTIZACION',5765,'\"07\"','2016-02-22',NULL),(55025,8777,'TC2',5765,'\"100\"','2016-02-22',NULL),(55026,8777,'GRUPO_COTIZACION',5766,'\"10\"','2016-01-22','2016-02-22'),(55027,8777,'TC2',5766,'\"100\"','2016-01-22','2016-02-22'),(55028,8777,'GRUPO_COTIZACION',5767,'\"08\"','2016-02-22',NULL),(55029,8777,'TC2',5767,'\"100\"','2016-02-22',NULL),(55030,8777,'GRUPO_COTIZACION',5768,'\"06\"','2016-02-22','2016-03-01'),(55031,8777,'TC2',5768,'\"100\"','2016-02-22','2016-03-01'),(55032,8777,'GRUPO_COTIZACION',5769,'\"09\"','2014-02-22','2016-03-02'),(55033,8777,'TC2',5769,'\"401\"','2014-02-22','2016-03-02'),(55034,8777,'GRUPO_COTIZACION',5770,'\"02\"','2016-02-22','2016-02-29'),(55035,8777,'TC2',5770,'\"100\"','2016-02-22','2016-02-29'),(55036,8777,'SALARIO_ANUAL',5770,'30000','2016-02-01',NULL),(55038,8777,'TIEMPO_COMPLETO',5771,'true','2016-02-22',NULL),(55039,8777,'SALARIO_MENSUAL',5771,'1750.35','2016-02-01',NULL),(55043,8777,'CAUSA_INDEMNIZACION',5766,'IMPROCEDENTE','2016-02-22','2016-03-07'),(55044,8777,'SALARIO_ANUAL',5766,'22000','2016-02-01',NULL),(55045,8777,'PAGAS',5766,'12','2016-02-01',NULL),(55046,8777,'GRUPO_COTIZACION',5772,'\"03\"','2012-02-29',NULL),(55047,8777,'TC2',5772,'\"100\"','2012-02-29',NULL),(55048,8777,'CAUSA_INDEMNIZACION',5770,'CAMBIO_CONDICIONES','2016-02-22','2016-03-02'),(55049,8777,'DIAS_VACACIONES_NO_DISFRUTADOS',5770,'1.5','2016-03-01','2016-03-02'),(55050,8777,'PAGAS',5770,'12','2016-02-01',NULL),(55051,8778,'TC2',5773,'\"000\"','2016-03-01',NULL),(55052,8778,'HORAS_LUNES',5773,'4','2016-03-01',NULL),(55053,8778,'HORAS_MARTES',5773,'4','2016-03-01',NULL),(55054,8778,'HORAS_MIERCOLES',5773,'4','2016-03-01',NULL),(55055,8778,'HORAS_JUEVES',5773,'4','2016-03-01',NULL),(55056,8778,'HORAS_VIERNES',5773,'4','2016-03-01',NULL),(55057,8778,'HORAS_SABADO',5773,'0.0','2016-03-01',NULL),(55058,8778,'HORAS_DOMINGO',5773,'0.0','2016-03-01',NULL),(55059,8778,'SALARIO_MENSUAL',5773,'SMI','2016-03-01',NULL),(55060,8778,'GRUPO_COTIZACION',5773,'\"05\"','2016-03-01',NULL),(55063,8777,'GRUPO_COTIZACION',5775,'\"08\"','2016-03-01',NULL),(55064,8777,'TC2',5775,'\"200\"','2016-03-01',NULL),(55065,8777,'HORAS_LUNES',5775,'4.0','2016-03-01',NULL),(55066,8777,'HORAS_MARTES',5775,'4.0','2016-03-01',NULL),(55067,8777,'HORAS_MIERCOLES',5775,'4.0','2016-03-01',NULL),(55068,8777,'HORAS_JUEVES',5775,'2.0','2016-03-01',NULL),(55069,8777,'HORAS_VIERNES',5775,'2.0','2016-03-01',NULL),(55070,8777,'GRUPO_COTIZACION',5776,'\"09\"','2016-03-01',NULL),(55071,8777,'TC2',5776,'\"100\"','2016-03-01',NULL),(55072,8777,'GRUPO_COTIZACION',5777,'\"05\"','2016-03-01',NULL),(55073,8777,'TC2',5777,'\"100\"','2016-03-01',NULL),(55074,8777,'GRUPO_COTIZACION',5778,'\"09\"','2016-03-01',NULL),(55075,8777,'TC2',5778,'\"100\"','2016-03-01',NULL),(55076,8777,'GRUPO_COTIZACION',5779,'\"09\"','2016-01-10',NULL),(55077,8777,'TC2',5779,'\"100\"','2016-01-10',NULL),(55078,8777,'GRUPO_COTIZACION',5780,'\"08\"','2016-03-01',NULL),(55079,8777,'TC2',5780,'\"200\"','2016-03-01',NULL),(55080,8777,'HORAS_LUNES',5780,'2.5','2016-03-01',NULL),(55081,8777,'HORAS_MARTES',5780,'2.5','2016-03-01',NULL),(55082,8777,'HORAS_MIERCOLES',5780,'5.5','2016-03-01',NULL),(55083,8777,'HORAS_JUEVES',5780,'5.5','2016-03-01',NULL),(55084,8777,'HORAS_VIERNES',5780,'4.0','2016-03-01',NULL),(55085,8778,'TC2',5781,'\"421\"','2016-03-03',NULL),(55086,8778,'SALARIO_MENSUALSMI',5781,'SMI','2016-03-01',NULL),(55087,8778,'SALARIO_MENSUAL',5781,'SMI','2016-03-01',NULL),(55088,8777,'CAUSA_INDEMNIZACION',5769,'FIN_OBRA','2016-02-22','2016-03-31'),(55089,8777,'GRUPO_COTIZACION',5782,'\"06\"','2016-03-09',NULL),(55090,8777,'TC2',5782,'\"100\"','2016-03-09',NULL),(55091,8780,'TC2',5783,'\"100\"','2016-03-11',NULL),(55095,8780,'GRUPO_COTIZACION',5783,'\"04\"','2016-03-01',NULL),(55096,8780,'SALARIO_MENSUAL',5783,'SMI*2','2016-03-01',NULL),(55097,8777,'GRUPO_COTIZACION',5784,'\"04\"','2016-02-09','2016-03-28'),(55098,8777,'TC2',5784,'\"100\"','2016-02-09','2016-03-28'),(55115,8777,'SALARIO_VARIABLE_DIA',5784,'SISTEMA(\'SALARIO_VARIABLE_DIA\')','2016-02-09','2016-04-05'),(55116,8777,'GRUPO_COTIZACION',5785,'\"05\"','2016-02-03',NULL),(55117,8777,'TC2',5785,'\"100\"','2016-02-03',NULL),(55118,8777,'GRUPO_COTIZACION',5786,'\"09\"','2016-02-03',NULL),(55119,8777,'TC2',5786,'\"100\"','2016-02-03',NULL),(55120,8777,'SALARIO_MENSUAL',5786,'SMI','2016-04-03',NULL),(55121,8777,'SSSALARIO_MENSUAL',5785,'SMI','2016-04-03',NULL),(55122,8777,'SALARIO_MENSUAL',5785,'SMI','2016-04-01',NULL),(55123,8777,'GRUPO_COTIZACION',5787,'\"02\"','2016-04-03',NULL),(55124,8777,'TC2',5787,'\"100\"','2016-04-03',NULL),(55125,8777,'TC2',5788,'\"100\"','2016-04-05',NULL),(55126,8777,'GRUPO_COTIZACION',5789,'\"02\"','2016-04-05',NULL),(55127,8777,'TC2',5789,'\"200\"','2016-04-05',NULL),(55128,8777,'HORAS_LUNES',5789,'4.0','2016-04-05',NULL),(55129,8777,'HORAS_MARTES',5789,'4.0','2016-04-05',NULL),(55130,8777,'HORAS_MIERCOLES',5789,'2.0','2016-04-05',NULL),(55131,8777,'HORAS_JUEVES',5789,'6.0','2016-04-05',NULL),(55132,8777,'HORAS_VIERNES',5789,'4.0','2016-04-05',NULL),(55133,8777,'GRUPO_COTIZACION',5788,'\"02\"','2016-04-05',NULL),(55134,8777,'SALARIO_ANUAL',5789,'14387.05*(1.10)','2016-04-01',NULL),(55135,8777,'GRUPO_COTIZACION',5790,'\"07\"','2016-04-05',NULL),(55136,8777,'TC2',5790,'\"100\"','2016-04-05',NULL),(55137,8780,'TC2',5791,'\"100\"','2016-04-06',NULL),(55138,8777,'GRUPO_COTIZACION',5792,'\"05\"','2016-04-07',NULL),(55139,8777,'TC2',5792,'\"100\"','2016-04-07',NULL),(55140,8777,'SALARIO_MENSUAL',5792,'SMI*14/12','2016-04-07',NULL),(55141,8777,'GRUPO_COTIZACION',5793,'\"04\"','2016-04-07',NULL),(55142,8777,'TC2',5793,'\"100\"','2016-04-07',NULL),(55143,8777,'GRUPO_COTIZACION',5794,'\"06\"','2016-04-14',NULL),(55144,8777,'TC2',5794,'\"100\"','2016-04-14',NULL),(55147,8777,'GRUPO_COTIZACION',5796,'\"04\"','2016-04-14',NULL),(55148,8777,'TC2',5796,'\"100\"','2016-04-14',NULL),(55156,8777,'GRUPO_COTIZACION',5801,'\"06\"','2016-04-19',NULL),(55157,8777,'TC2',5801,'\"100\"','2016-04-19',NULL),(55158,8777,'GRUPO_COTIZACION',5802,'\"02\"','2016-04-19',NULL),(55159,8777,'TC2',5802,'\"300\"','2016-04-19',NULL),(55160,8777,'HORAS_LUNES',5802,'4.0','2016-04-19',NULL),(55161,8777,'HORAS_MARTES',5802,'4.0','2016-04-19',NULL),(55162,8777,'HORAS_MIERCOLES',5802,'4.0','2016-04-19',NULL),(55163,8777,'HORAS_JUEVES',5802,'8.0','2016-04-19',NULL),(55164,8777,'SALARIO_MENSUAL',5802,'SMI','2016-04-19',NULL),(55165,8777,'SALARIO_MENSUAL',5801,'SMI*1.25','2016-04-19',NULL),(55166,8781,'GRUPO_COTIZACION',5803,'\"10\"','2016-04-20',NULL),(55167,8781,'TC2',5803,'\"100\"','2016-04-20',NULL),(55168,8777,'GRUPO_COTIZACION',5804,'\"04\"','2016-04-20',NULL),(55169,8777,'TC2',5804,'\"100\"','2016-04-20',NULL),(55170,8777,'SALARIO',5794,'100','2016-04-14','2016-04-30'),(55171,8777,'GRUPO_COTIZACION',5805,'\"05\"','2016-04-20',NULL),(55172,8777,'TC2',5805,'\"100\"','2016-04-20',NULL),(55173,8777,'PORCENTAJE_IRPF',5805,'0','2016-04-20',NULL),(55174,8777,'GRUPO_COTIZACION',5806,'\"01\"','2016-04-25',NULL),(55175,8777,'TC2',5806,'\"100\"','2016-04-25',NULL),(55177,8777,'SALARIO_MENSUAL',5806,'1067.4','2016-04-25',NULL),(55178,8777,'GRUPO_COTIZACION',5807,'\"01\"','2016-03-25',NULL),(55179,8777,'TC2',5807,'\"100\"','2016-03-25',NULL),(55181,8777,'TC2',5808,'\"100\"','2016-05-03',NULL),(55182,8777,'GRUPO_COTIZACION',5808,'\"01\"','2016-05-03',NULL),(55183,8777,'SALARIO_MENSUAL',5807,'1067.40','2016-03-25',NULL),(55184,8777,'GRUPO_COTIZACION',5809,'\"09\"','2016-05-04',NULL),(55185,8777,'TC2',5809,'\"100\"','2016-05-04',NULL),(55186,8777,'SALARIO_MENSUAL',5809,'SMI * 14 /12','2016-05-04',NULL),(55187,8777,'GRUPO_COTIZACION',5810,'\"11\"','2016-05-04',NULL),(55188,8777,'TC2',5810,'\"100\"','2016-05-04',NULL),(55189,8777,'SALARIO_MENSUAL',5810,'SMI * 14 /12','2016-05-04',NULL),(55190,8777,'GRUPO_COTIZACION',5811,'\"06\"','2016-05-04',NULL),(55191,8777,'TC2',5811,'\"100\"','2016-05-04',NULL),(55192,8777,'SALARIO_ANUAL',5811,'SMI * 14','2016-05-04',NULL),(55195,8777,'PAGAS',5811,'12','2016-05-04','2016-05-31'),(55196,8777,'PAGAS',5811,'12','2016-06-01',NULL),(55197,8777,'GRUPO_COTIZACION',5812,'\"05\"','2016-05-05',NULL),(55198,8777,'TC2',5812,'\"100\"','2016-05-05',NULL),(55199,8777,'SALARIO_MENSUAL',5812,'1000.00','2016-05-05',NULL),(55200,8783,'GRUPO_COTIZACION',5813,'\"01\"','2016-05-06',NULL),(55201,8783,'TC2',5813,'\"100\"','2016-05-06',NULL),(55202,8783,'TC2',5814,'\"100\"','2016-05-06',NULL),(55203,8783,'GRUPO_COTIZACION',5814,'\"01\"','2016-05-06',NULL),(55204,8783,'GRUPO_COTIZACION',5815,'\"02\"','2016-05-06',NULL),(55205,8783,'TC2',5815,'\"100\"','2016-05-06',NULL),(55206,8783,'GRUPO_COTIZACION',5816,'\"04\"','2016-05-06',NULL),(55207,8783,'TC2',5816,'\"100\"','2016-05-06',NULL),(55208,8783,'GRUPO_COTIZACION',5817,'\"08\"','2016-05-06',NULL),(55209,8783,'TC2',5817,'\"100\"','2016-05-06',NULL),(55210,8783,'GRUPO_COTIZACION',5818,'\"08\"','2016-05-06',NULL),(55211,8783,'TC2',5818,'\"100\"','2016-05-06',NULL),(55212,8777,'GRUPO_COTIZACION',5819,'\"02\"','2016-05-09',NULL),(55213,8777,'TC2',5819,'\"100\"','2016-05-09',NULL),(55214,8777,'GRUPO_COTIZACION',5820,'\"01\"','2016-05-18',NULL),(55215,8777,'TC2',5820,'\"100\"','2016-05-18',NULL),(55217,8777,'SALARIO_MENSUAL',5820,'1200.00','2016-05-18',NULL),(55218,8777,'GRUPO_COTIZACION',5821,'\"05\"','2016-05-18',NULL),(55219,8777,'TC2',5821,'\"100\"','2016-05-18',NULL),(55220,8777,'SALARIO_ANUAL',5821,'SMI*14','2016-05-18',NULL),(55221,8777,'PAGAS',5821,'12','2016-05-18',NULL),(55222,8777,'GRUPO_COTIZACION',5822,'\"09\"','2016-05-18',NULL),(55223,8777,'TC2',5822,'\"100\"','2016-05-18',NULL),(55224,8777,'PAGAS',5822,'14','2016-05-18',NULL),(55225,8777,'SALARIO_ANUAL',5822,'SMI*14','2016-05-18',NULL),(55226,8777,'TC2',5823,'\"100\"','2016-05-18',NULL),(55227,8777,'GRUPO_COTIZACION',5823,'\"03\"','2016-05-18',NULL),(55228,8784,'GRUPO_COTIZACION',5824,'\"03\"','2016-05-18',NULL),(55229,8784,'TC2',5824,'\"401\"','2016-05-18',NULL),(55230,8784,'GRUPO_COTIZACION',5825,'\"08\"','2016-05-18',NULL),(55231,8784,'TC2',5825,'\"100\"','2016-05-18',NULL),(55232,8777,'GRUPO_COTIZACION',5826,'\"04\"','2016-05-23',NULL),(55233,8777,'TC2',5826,'\"100\"','2016-05-23',NULL),(55242,8777,'SALARIO_MENSUAL',5826,'SMI*3*12/14','2016-05-23',NULL),(55243,8777,'GRUPO_COTIZACION',5827,'\"01\"','2016-05-24',NULL),(55244,8777,'TC2',5827,'\"100\"','2016-05-24',NULL),(55249,8777,'SALARIO_MENSUAL',5805,'SMI*4','2016-05-01',NULL),(55250,8783,'GRUPO_COTIZACION',5828,'\"05\"','2016-02-01',NULL),(55251,8783,'TC2',5828,'\"100\"','2016-02-01',NULL),(55252,8783,'GRUPO_COTIZACION',5829,'\"04\"','2010-05-27',NULL),(55253,8783,'TC2',5829,'\"100\"','2010-05-27',NULL),(55254,8783,'GRUPO_COTIZACION',5830,'\"04\"','2010-05-27',NULL),(55255,8783,'TC2',5830,'\"100\"','2010-05-27',NULL),(55256,8777,'GRUPO_COTIZACION',5831,'\"01\"','2016-05-30',NULL),(55257,8777,'TC2',5831,'\"100\"','2016-05-30',NULL),(55258,8777,'GRUPO_COTIZACION',5832,'\"01\"','2016-05-31',NULL),(55259,8777,'TC2',5832,'\"100\"','2016-05-31',NULL),(55260,8777,'SALARIO_MENSUAL',5832,'SMI','2016-05-01',NULL),(55261,8777,'TC2',5833,'\"200\"','2016-06-01',NULL),(55262,8777,'HORAS_LUNES',5833,'2','2016-06-01',NULL),(55263,8777,'HORAS_MARTES',5833,'4','2016-06-01',NULL),(55264,8777,'HORAS_MIERCOLES',5833,'2','2016-06-01',NULL),(55265,8777,'HORAS_JUEVES',5833,'4','2016-06-01',NULL),(55266,8777,'HORAS_VIERNES',5833,'2','2016-06-01',NULL),(55267,8777,'HORAS_SABADO',5833,'0.0','2016-06-01',NULL),(55268,8777,'HORAS_DOMINGO',5833,'0.0','2016-06-01',NULL),(55269,8777,'SALARIO_MENSUAL',5833,'SMI','2016-06-01',NULL),(55270,8777,'GRUPO_COTIZACION',5833,'\"07\"','2016-06-01',NULL),(55271,8777,'GRUPO_COTIZACION',5834,'\"04\"','2016-06-06',NULL),(55272,8777,'TC2',5834,'\"100\"','2016-06-06',NULL),(55273,8783,'GRUPO_COTIZACION',5835,'\"01\"','2016-06-07',NULL),(55274,8783,'TC2',5835,'\"100\"','2016-06-07',NULL),(55275,8783,'GRUPO_COTIZACION',5836,'\"05\"','2016-06-07',NULL),(55276,8783,'TC2',5836,'\"100\"','2016-06-07',NULL),(55277,8777,'GRUPO_COTIZACION',5837,'\"06\"','2016-06-07',NULL),(55278,8777,'TC2',5837,'\"401\"','2016-06-07',NULL),(55279,8777,'DIAS_VACACIONES_NO_DISFRUTADOS',5837,'3.0','2016-06-28','2016-06-30'),(55280,8777,'DIAS_VACACIONES_NO_DISFRUTADOS',5837,'27.0','2016-07-01','2016-07-27'),(55281,8777,'CAUSA_INDEMNIZACION',5837,'FIN_TEMPORAL','2016-06-07','2016-07-27'),(55282,8777,'FECHA_PREAVISO',5767,'\"01/06/2016\"','2016-02-22','2016-06-19'),(55283,8777,'DIAS_PREAVISO',5767,'0.00','2016-02-22','2016-06-19'),(55284,8777,'GRUPO_COTIZACION',5838,'\"04\"','2016-06-13',NULL),(55285,8777,'TC2',5838,'\"100\"','2016-06-13',NULL),(55286,8777,'GRUPO_COTIZACION',5839,'\"01\"','2016-06-14',NULL),(55287,8777,'TC2',5839,'\"100\"','2016-06-14',NULL),(55288,8777,'GRUPO_COTIZACION',5840,'\"04\"','2016-06-14',NULL),(55289,8777,'TC2',5840,'\"100\"','2016-06-14',NULL),(55290,8777,'DIAS_VACACIONES_NO_DISFRUTADOS',5840,'4.0','2016-06-15','2016-06-18'),(55291,8777,'FECHA_PREAVISO',5840,'\"16/05/2016\"','2016-06-14','2016-06-18'),(55293,8777,'SALARIO_MENSUAL',5840,'3000','2016-06-01',NULL),(55294,8777,'SALARIO_DIA',5840,'100.00','2016-06-01','2016-06-13'),(55295,8777,'SALARIO_DIA',5840,'SISTEMA(\'SALARIO_DIA\')','2016-06-14',NULL),(55296,8777,'DIAS_PREAVISO',5840,'10','2016-06-14',NULL),(55297,8777,'GRUPO_COTIZACION',5841,'\"04\"','2016-06-15',NULL),(55298,8777,'TC2',5841,'\"100\"','2016-06-15',NULL),(55302,8777,'PORCENTAJE_IRPF',5841,'SISTEMA(\'PORCENTAJE_IRPF\')','2016-06-01','2016-07-31'),(55305,8777,'PORCENTAJE_IRPF',5841,'12','2016-08-01',NULL),(55306,8777,'GRUPO_COTIZACION',5842,'\"04\"','2016-06-20',NULL),(55307,8777,'TC2',5842,'\"401\"','2016-06-20',NULL),(55308,8777,'IMPORTE_HORA_EXTRA_FZA',5842,'100.00','2016-09-01','2016-09-30'),(55310,8777,'HORAS_EXTRAS_FZA',5842,'10.00','2016-09-01','2016-09-30'),(55311,8777,'GRUPO_COTIZACION',5843,'\"05\"','2016-07-04',NULL),(55312,8777,'TC2',5843,'\"100\"','2016-07-04',NULL),(55314,8777,'SALARIO_MENSUAL',5794,'100','2016-07-01','2016-07-31'),(55315,8777,'SALARIO_MENSUAL',5843,'1000','2016-07-01',NULL),(55316,8777,'GRUPO_COTIZACION',5844,'\"03\"','2016-07-06',NULL),(55317,8777,'TC2',5844,'\"100\"','2016-07-06',NULL),(55318,8777,'SALARIO_ANUAL',5844,'14387.05+100','2016-07-06',NULL),(55319,8777,'PORCENTAJE_CGC',5844,'4.71','2016-07-06',NULL),(55320,8777,'PORCENTAJE_FOGASA',5844,'0.21','2016-07-06',NULL),(55321,8777,'GRUPO_COTIZACION',5845,'\"09\"','2016-07-07',NULL),(55322,8777,'TC2',5845,'\"100\"','2016-07-07',NULL),(55323,8777,'GRUPO_COTIZACION',5846,'\"03\"','2016-07-21',NULL),(55324,8777,'TC2',5846,'\"200\"','2016-07-21',NULL),(55325,8777,'HORAS_LUNES',5846,'4.0','2016-07-21',NULL),(55326,8777,'HORAS_MARTES',5846,'4.0','2016-07-21',NULL),(55327,8777,'HORAS_MIERCOLES',5846,'4.0','2016-07-21',NULL),(55328,8777,'HORAS_JUEVES',5846,'4.0','2016-07-21',NULL),(55329,8777,'HORAS_VIERNES',5846,'4.0','2016-07-21',NULL),(55330,8777,'HORAS_SABADO',5846,'0.0','2016-07-21',NULL),(55331,8777,'HORAS_DOMINGO',5846,'0.0','2016-07-21',NULL),(55332,8777,'GRUPO_COTIZACION',5847,'\"03\"','2016-07-21',NULL),(55333,8777,'TC2',5847,'\"200\"','2016-07-21',NULL),(55334,8777,'HORAS_LUNES',5847,'0.0','2016-07-21',NULL),(55335,8777,'HORAS_MARTES',5847,'0.0','2016-07-21',NULL),(55336,8777,'HORAS_MIERCOLES',5847,'4.0','2016-07-21',NULL),(55337,8777,'HORAS_JUEVES',5847,'4.0','2016-07-21',NULL),(55338,8777,'HORAS_VIERNES',5847,'4.0','2016-07-21',NULL),(55339,8777,'HORAS_SABADO',5847,'4.0','2016-07-21',NULL),(55340,8777,'HORAS_DOMINGO',5847,'4.0','2016-07-21',NULL),(55341,8777,'GRUPO_COTIZACION',5848,'\"03\"','2016-08-18',NULL),(55342,8777,'TC2',5848,'\"100\"','2016-08-18',NULL),(55343,8777,'GRUPO_COTIZACION',5849,'\"07\"','2016-08-18',NULL),(55344,8777,'TC2',5849,'\"100\"','2016-08-18',NULL),(55345,8777,'GRUPO_COTIZACION',5850,'\"02\"','2016-08-19',NULL),(55346,8777,'TC2',5850,'\"100\"','2016-08-19',NULL),(55347,8777,'GRUPO_COTIZACION',5851,'\"04\"','2016-08-26',NULL),(55348,8777,'TC2',5851,'\"100\"','2016-08-26',NULL),(55349,8777,'GRUPO_COTIZACION',5852,'\"05\"','2016-08-26',NULL),(55350,8777,'TC2',5852,'\"100\"','2016-08-26',NULL),(55351,8777,'GRUPO_COTIZACION',5853,'\"09\"','2016-08-29',NULL),(55352,8777,'TC2',5853,'\"100\"','2016-08-29',NULL),(55355,8777,'KMS',5844,'66','2016-07-01',NULL),(55356,8777,'GRUPO_COTIZACION',5854,'\"10\"','2016-09-20',NULL),(55357,8777,'TC2',5854,'\"200\"','2016-09-20',NULL),(55361,8777,'HORAS_JUEVES',5854,'2','2016-09-20',NULL),(55364,8777,'HORAS_DOMINGO',5854,'2','2016-09-20',NULL),(55365,8777,'HORAS_LUNES',5854,'NO_LABORABLE','2016-09-01',NULL),(55366,8777,'HORAS_MARTES',5854,'NO_LABORABLE','2016-09-01',NULL),(55370,8777,'HORAS_MIERCOLES',5854,'2','2016-09-01',NULL),(55371,8777,'HORAS_VIERNES',5854,'2','2016-09-01',NULL),(55372,8777,'HORAS_SABADO',5854,'2','2016-09-01',NULL),(55373,8777,'GRUPO_COTIZACION',5855,'\"07\"','2016-09-20',NULL),(55374,8777,'TC2',5855,'\"200\"','2016-09-20',NULL),(55375,8787,'GRUPO_COTIZACION',5856,'\"01\"','2016-09-29',NULL),(55376,8787,'TC2',5856,'\"100\"','2016-09-29',NULL),(55377,8787,'GRUPO_COTIZACION',5857,'\"02\"','2016-09-30',NULL),(55378,8787,'TC2',5857,'\"100\"','2016-09-30',NULL),(55379,8787,'GRUPO_COTIZACION',5858,'\"03\"','2016-09-30',NULL),(55380,8787,'TC2',5858,'\"100\"','2016-09-30',NULL),(55381,8787,'GRUPO_COTIZACION',5859,'\"04\"','2016-09-30',NULL),(55382,8787,'TC2',5859,'\"100\"','2016-09-30',NULL),(55383,8787,'GRUPO_COTIZACION',5860,'\"05\"','2016-09-30',NULL),(55384,8787,'TC2',5860,'\"100\"','2016-09-30',NULL),(55385,8787,'GRUPO_COTIZACION',5861,'\"06\"','2016-09-30',NULL),(55386,8787,'TC2',5861,'\"421\"','2016-09-30',NULL),(55387,8787,'GRUPO_COTIZACION',5862,'\"06\"','2016-09-30',NULL),(55388,8787,'TC2',5862,'\"421\"','2016-09-30',NULL),(55389,8787,'GRUPO_COTIZACION',5863,'\"10\"','2016-09-30',NULL),(55390,8787,'TC2',5863,'\"200\"','2016-09-30',NULL),(55391,8787,'HORAS_LUNES',5863,'2.0','2016-09-30',NULL),(55392,8787,'HORAS_MARTES',5863,'2.0','2016-09-30',NULL),(55393,8787,'HORAS_MIERCOLES',5863,'2.0','2016-09-30',NULL),(55394,8787,'HORAS_JUEVES',5863,'2.0','2016-09-30',NULL),(55395,8787,'HORAS_VIERNES',5863,'2.0','2016-09-30',NULL),(55396,8777,'GRUPO_COTIZACION',5864,'\"04\"','2012-10-02',NULL),(55397,8777,'TC2',5864,'\"100\"','2012-10-02',NULL),(55398,8777,'GRUPO_COTIZACION',5865,'\"04\"','2016-11-10',NULL),(55399,8777,'TC2',5865,'\"100\"','2016-11-10',NULL),(55402,8777,'TIEMPO_COMPLETO',5865,'false','2016-11-01',NULL),(55404,8777,'GRUPO_COTIZACION',5866,'\"03\"','2016-11-10',NULL),(55405,8777,'TC2',5866,'\"100\"','2016-11-10',NULL),(55410,8777,'HORAS_JUEVES',5866,'4','2016-11-01',NULL),(55412,8777,'HORAS_DOMINGO',5866,'NO_LABORABLE','2016-11-01',NULL),(55413,8777,'HORAS_VIERNES',5866,'4','2016-11-01',NULL),(55414,8777,'COEFICIENTE_PARCIALIDAD',5865,'0.50','2016-11-01','2017-12-09'),(55415,8777,'COEFICIENTE_PARCIALIDAD',5865,'0.75','2016-12-10',NULL),(55419,8777,'TIEMPO_COMPLETO',5866,'false','2016-11-01',NULL),(55421,8777,'HORAS_LUNES',5866,'4','2016-11-01','2016-12-09'),(55422,8777,'HORAS_LUNES',5866,'8','2016-12-10',NULL),(55423,8777,'HORAS_MARTES',5866,'4','2016-11-01','2016-12-09'),(55424,8777,'HORAS_MARTES',5866,'8','2016-12-10',NULL),(55425,8777,'HORAS_MIERCOLES',5866,'4','2016-11-01','2016-12-09'),(55426,8777,'HORAS_MIERCOLES',5866,'6','2016-12-10',NULL),(55427,8777,'GRUPO_COTIZACION',5867,'\"01\"','2016-11-10',NULL),(55428,8777,'TC2',5867,'\"100\"','2016-11-10',NULL),(55429,8777,'INICIO_BONIF',5867,'FECHA(2015,11,10)','2016-11-01',NULL),(55430,8777,'GRUPO_COTIZACION',5868,'\"05\"','2016-07-16',NULL),(55431,8777,'TC2',5868,'\"100\"','2016-07-16',NULL),(55432,8777,'GRUPO_COTIZACION',5869,'\"03\"','2016-09-16',NULL),(55433,8777,'TC2',5869,'\"100\"','2016-09-16',NULL),(55436,8777,'COEFICIENTE_MATERNIDAD',5868,'0.50','2016-12-01',NULL),(55438,8777,'COEFICIENTE_PATERNIDAD',5869,'2/8','2016-12-01',NULL),(55440,8777,'DIAS_MES',5779,'30','2016-01-01',NULL),(55441,8777,'GRUPO_COTIZACION',5870,'\"03\"','2016-01-01',NULL),(55442,8777,'TC2',5870,'\"100\"','2016-01-01',NULL),(55443,8777,'GRUPO_COTIZACION',5871,'\"04\"','2016-11-25',NULL),(55444,8777,'TC2',5871,'\"100\"','2016-11-25',NULL),(55445,8777,'GRUPO_COTIZACION',5872,'\"03\"','2016-11-25',NULL),(55446,8777,'TC2',5872,'\"100\"','2016-11-25',NULL),(55447,8777,'GRUPO_COTIZACION',5873,'\"04\"','2016-12-02',NULL),(55448,8777,'TC2',5873,'\"200\"','2016-12-02',NULL),(55449,8777,'HORAS_LUNES',5873,'4.0','2016-12-02',NULL),(55450,8777,'HORAS_MARTES',5873,'4.0','2016-12-02',NULL),(55451,8777,'HORAS_MIERCOLES',5873,'4.0','2016-12-02',NULL),(55452,8777,'HORAS_JUEVES',5873,'4.0','2016-12-02',NULL),(55453,8777,'HORAS_VIERNES',5873,'4.0','2016-12-02',NULL),(55454,8788,'GRUPO_COTIZACION',5874,'\"05\"','2012-11-19',NULL),(55455,8788,'TC2',5874,'\"100\"','2012-11-19',NULL),(55456,8788,'SALARIO_MENSUAL',5874,'SMI*1.75','2016-12-01',NULL),(55457,8788,'GRUPO_COTIZACION',5875,'\"04\"','2016-11-02',NULL),(55458,8788,'TC2',5875,'\"401\"','2016-11-02',NULL),(55459,8788,'GRUPO_COTIZACION',5876,'\"04\"','2016-11-12',NULL),(55460,8788,'TC2',5876,'\"401\"','2016-11-12',NULL),(55461,8788,'GRUPO_COTIZACION',5877,'\"07\"','2016-11-19',NULL),(55462,8788,'TC2',5877,'\"401\"','2016-11-19',NULL),(55463,8788,'GRUPO_COTIZACION',5878,'\"07\"','2016-11-26',NULL),(55464,8788,'TC2',5878,'\"401\"','2016-11-26',NULL),(55465,8788,'GRUPO_COTIZACION',5879,'\"05\"','2016-01-04',NULL),(55466,8788,'TC2',5879,'\"100\"','2016-01-04',NULL),(55467,8788,'GRUPO_COTIZACION',5880,'\"04\"','2016-01-04',NULL),(55468,8788,'TC2',5880,'\"100\"','2016-01-04',NULL),(55469,8788,'GRUPO_COTIZACION',5881,'\"03\"','2016-01-04',NULL),(55470,8788,'TC2',5881,'\"100\"','2016-01-04',NULL),(55471,8777,'TIEMPO_COMPLETO',5872,'false','2017-12-01',NULL),(55472,8777,'HORAS_LUNES',5872,'4.00','2017-12-01',NULL),(55473,8777,'HORAS_MARTES',5872,'4','2017-12-01',NULL),(55474,8777,'HORAS_MIERCOLES',5872,'2','2017-12-01',NULL),(55475,8777,'HORAS_JUEVES',5872,'40/5','2017-12-01',NULL),(55476,8777,'HORAS_VIERNES',5872,'40/5','2017-12-01',NULL),(55478,8777,'GRUPO_COTIZACION',5882,'\"05\"','2016-02-27',NULL),(55479,8777,'TC2',5882,'\"100\"','2016-02-27',NULL),(55481,8777,'PLUS_EXTRA_SALARIAL',5872,'66666.00 / 100.00','2018-01-01',NULL),(55482,8777,'PLUS_EXTRA_SALARIAL',5872,'CONVENIO(\'PLUS_EXTRA_SALARIAL\')','2017-12-01','2017-12-31'),(55483,8777,'GRUPO_COTIZACION',5883,'\"03\"','2017-07-18',NULL),(55484,8777,'TC2',5883,'\"100\"','2017-07-18',NULL),(55491,8777,'COMPLEMENTO_I',5883,'3','2017-07-01','2017-07-31'),(55498,8777,'COMPLEMENTO_I',5883,'3','2017-07-18','2017-07-31'),(55499,8777,'COMPLEMENTO_I',5883,'4','2017-08-01','2017-08-31'),(55500,8777,'DIAS_TRABAJADOS',5883,'14','2017-07-18','2017-07-31'),(55501,8777,'DIAS_TRABAJADOS',5883,'30','2017-08-01','2017-08-31'),(55502,8777,'DIAS_TRABAJADOS',5883,'30','2017-09-01','2017-09-30'),(55503,8777,'DIAS_TRABAJADOS',5883,'30','2017-10-01','2017-10-31'),(55504,8777,'DIAS_TRABAJADOS',5883,'30','2017-11-01','2017-11-30'),(55505,8777,'DIAS_TRABAJADOS',5883,'30','2017-12-01','2017-12-31'),(55506,8777,'COMPLEMENTO_I',5883,'3','2017-07-18','2017-07-31'),(55507,8777,'COMPLEMENTO_I',5883,'2','2017-01-01','2017-01-31'),(55508,8777,'COMPLEMENTO_I',5883,'2','2017-02-01','2017-02-28'),(55509,8777,'COMPLEMENTO_I',5883,'2','2017-03-01','2017-03-31'),(55510,8777,'COMPLEMENTO_I',5883,'2','2017-04-01','2017-04-30'),(55511,8777,'COMPLEMENTO_I',5883,'2','2017-05-01','2017-05-31'),(55512,8777,'COMPLEMENTO_I',5883,'2','2017-06-01','2017-06-30'),(55513,8777,'COMPLEMENTO_I',5883,'2','2017-07-01','2017-07-31'),(55514,8777,'COMPLEMENTO_I',5883,'2','2017-08-01','2017-08-31'),(55515,8777,'COMPLEMENTO_I',5883,'2','2017-09-01','2017-09-30'),(55516,8777,'COMPLEMENTO_I',5883,'2','2017-10-01','2017-10-31'),(55517,8777,'COMPLEMENTO_I',5883,'2','2017-11-01','2017-11-30'),(55518,8777,'COMPLEMENTO_I',5883,'2','2017-12-01','2017-12-31'),(55519,8777,'GRUPO_COTIZACION',5884,'\"03\"','2017-07-28',NULL),(55520,8777,'OCUPACION',5884,'\"a\"','2017-07-28',NULL),(55521,8777,'TC2',5884,'\"520\"','2017-07-28',NULL),(55529,8777,'HORAS_LUNES',5884,'6','2017-07-28',NULL),(55530,8777,'HORAS_MARTES',5884,'6','2017-07-28',NULL),(55531,8777,'HORAS_MIERCOLES',5884,'6','2017-07-28',NULL),(55532,8777,'HORAS_JUEVES',5884,'6','2017-07-28',NULL),(55533,8777,'HORAS_VIERNES',5884,'6','2017-07-28',NULL),(55534,8777,'HORAS_SABADO',5884,'0.0','2017-07-28',NULL),(55535,8777,'HORAS_DOMINGO',5884,'0.0','2017-07-28',NULL),(55587,8777,'KMS',5884,'50','2017-07-28','2017-07-31'),(55588,8777,'KMS',5884,'100','2017-08-01','2017-08-31'),(55589,8777,'KMS',5884,'30','2017-09-01','2017-09-30'),(55590,8777,'DIAS_TRABAJADOS',5884,'4','2017-07-28','2017-07-31'),(55591,8777,'DIAS_TRABAJADOS',5884,'30','2017-08-01','2017-08-31'),(55592,8777,'DIAS_TRABAJADOS',5884,'30','2017-09-01','2017-09-30'),(55593,8777,'DIAS_TRABAJADOS',5884,'30','2017-10-01','2017-10-31'),(55594,8777,'DIAS_TRABAJADOS',5884,'30','2017-11-01','2017-11-30'),(55595,8777,'DIAS_TRABAJADOS',5884,'30','2017-12-01','2017-12-31'),(55596,8777,'GRUPO_COTIZACION',5885,'\"10\"','2017-08-29',NULL),(55597,8777,'OCUPACION',5885,'\"g\"','2017-08-29',NULL),(55598,8777,'TC2',5885,'\"200\"','2017-08-29',NULL),(55640,8777,'HORAS_MARTES',5885,'6.0','2017-08-29',NULL),(55641,8777,'HORAS_MIERCOLES',5885,'6.0','2017-08-30',NULL),(55642,8777,'HORAS_JUEVES',5885,'6.0','2017-08-31',NULL),(55643,8777,'HORAS_VIERNES',5885,'6.0','2017-09-01',NULL),(55644,8777,'HORAS_SABADO',5885,'-1.0','2017-09-02',NULL),(55645,8777,'HORAS_DOMINGO',5885,'-1.0','2017-09-03',NULL),(55646,8777,'HORAS_LUNES',5885,'6.0','2017-09-04',NULL);
/*!40000 ALTER TABLE `contract_data` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `contract_deduction`
--

DROP TABLE IF EXISTS `contract_deduction`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `contract_deduction` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de Deducción',
  `deduction_concept` int(4) DEFAULT NULL COMMENT 'Identificador unico del concepto',
  `contract` int(4) NOT NULL COMMENT 'Contrato',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion',
  `description_decorable` tinyint(2) NOT NULL DEFAULT '0',
  `expression` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Fórmula',
  `start_date` date NOT NULL COMMENT 'Fecha de inicio ',
  `end_date` date DEFAULT NULL COMMENT 'Fecha de finalizacion',
  `month` tinyint(2) DEFAULT NULL COMMENT 'Mes de la percepcion',
  PRIMARY KEY (`id`),
  KEY `IDX_CONTRACT_DEDUCTION_DEDUCTION_CONCEPT` (`deduction_concept`),
  KEY `IDX_CONTRACT_DEDUCTION_CONTRACT` (`contract`),
  KEY `IDX_CONTRACT_DEDUCTION_DOMAIN` (`domain`),
  CONSTRAINT `FK_CONTRACT_DEDUCTION_CONTRACT` FOREIGN KEY (`contract`) REFERENCES `contract` (`id`),
  CONSTRAINT `FK_CONTRACT_DEDUCTION_DEDUCTION_CONCEPT` FOREIGN KEY (`deduction_concept`) REFERENCES `deduction_concept` (`id`),
  CONSTRAINT `FK_CONTRACT_DEDUCTION_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1863 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Deducciones';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `contract_deduction`
--

LOCK TABLES `contract_deduction` WRITE;
/*!40000 ALTER TABLE `contract_deduction` DISABLE KEYS */;
INSERT INTO `contract_deduction` VALUES (1806,8777,9,NULL,5753,'TEST BASE COTIZACIÓN MÁXIMA 2016',0,'(NOMINA)?(/*user*/CHECK(BASE_CGC==(X=3642*DIAS_TRABAJADOS/DIAS_MES), \"BASE ERRÓNEA SE ESPERABA \" +X+ \"€\")/**/):REMOVE()','2016-02-01',NULL,NULL),(1807,8777,9,NULL,5754,'TEST BASE MÍNIMA COTIZACIÓN 2016',0,'(NOMINA)?(/*user*/CHECK(BASE_CGC==(X=1067.40*DIAS_TRABAJADOS/DIAS_MES), \"BASE ERRÓNEA SE ESPERABA \" +X+ \"€\")/**/):REMOVE()','2016-02-01',NULL,NULL),(1808,8777,9,NULL,5756,'TEST BRUTO',0,'(NOMINA)?(/*user*/CHECK(TOTAL_DEVENGADO==(X=1500*DIAS_TRABAJADOS/DIAS_MES), \"BRUTO ERRÓNEO SE ESPERABA \"+X+\" €\")/**/):REMOVE()','2016-02-01',NULL,NULL),(1809,8777,9,NULL,5758,'TEST I.R.P.F ',0,'(NOMINA)?(/*user*/CHECK(PORCENTAJE_IRPF==2,\"I.R.P.F ERRÓNEO SE ESPERABA 2.00%\")/**/):REMOVE()','2016-01-01',NULL,NULL),(1810,8777,9,NULL,5759,'TEST I.R.P.F',0,'(NOMINA)?(/*user*/CHECK(PORCENTAJE_IRPF==39, \"I.R.P.F ERRÓNEO SE ESPERABA 39.00%\")/**/):REMOVE()','2016-01-01',NULL,NULL),(1811,8777,9,NULL,5760,'TEST I.R.P.F',0,'(NOMINA)?(/*user*/CHECK(PORCENTAJE_IRPF==0.00, \"I.R.P.F ERRÓNEO SE ESPERABA 0.00%\")/**/):REMOVE()','2016-01-01',NULL,NULL),(1813,8777,9,NULL,5762,'TEST NETO',0,'(NOMINA)?(/*user*/CHECK(TOTAL_DEVENGADO*(1-((6.35+15)/100.00))-2125 < 0.0005, \"NETO ERRÓNEO SE ESPERABA 2125 €\" )/**/):REMOVE()','2016-02-01',NULL,NULL),(1814,8777,9,NULL,5751,'TEST PRORRATA PAGAS, MES COMPLETO',0,'(NOMINA)?(/*user*/CHECK(BASE_PAGA_EXTRA==(X=(SALARIO_ANUAL/(PAGAS*6))),\"PRORRATA ERRÓNEA SE ESPERABA \"+X+\" €\");/**/):REMOVE()','2016-02-01',NULL,NULL),(1815,8777,9,NULL,5752,'TEST PRORRATA DE PAGAS (BASE_CGC)',0,'(NOMINA)?(/*user*/CHECK(BASE_PAGA_EXTRA==(X=(SALARIO_ANUAL/(PAGAS*6))),\"PRORRATA ERRÓNEA SE ESPERABA \"+X+\" €\");/**/):REMOVE()','2016-01-01','2016-01-31',NULL),(1816,8777,9,NULL,5752,'TEST PRORRATA DE PAGAS (BASE_PAGA_EXTRA)',0,'(NOMINA)?(/*user*/CHECK(BASE_PAGA_EXTRA==(X=(SALARIO_ANUAL/(PAGAS*6))),\"PRORRATA ERRÓNEA SE ESPERABA \"+X+\" €\");/**/):REMOVE()','2016-02-01',NULL,NULL),(1817,8777,9,NULL,5752,'TEST PRORRATA DE PAGAS (BASE_PAGA_EXTRA)',0,'(NOMINA)?(/*user*/CHECK(BASE_CGC==(X=(SALARIO_ANUAL/PAGAS*(1+1/6))),\"BASE ERRÓNEA SE ESPERABA \"+X+\" €\");/**/):REMOVE()','2016-01-01','2016-01-31',NULL),(1819,8777,9,NULL,5752,'TEST PRORRATA DE PAGAS (BASE_CGC)',0,'(NOMINA)?(/*user*/CHECK(BASE_CGC==(X=(SALARIO_ANUAL/14*(DIAS_TRABAJADOS/DIAS_MES+1/6))),\"ERROR SE ESPERABA \"+X);/**/):REMOVE()','2016-02-01',NULL,NULL),(1820,8777,9,NULL,5751,'TEST PAGA EXTRA',0,'(EXTRA)?(/*user*/CHECK(TOTAL_DEVENGADO==(X=SALARIO_ANUAL/PAGAS), \"PAGA ERRÓNEA SE ESPERABA \" + X + \" €\" );/**/):REMOVE()','2016-07-01','2016-12-31',NULL),(1821,8777,6,NULL,5801,NULL,0,'(NOMINA)?(/*user*/BASE_IRPF * 0.00/100/**/):REMOVE()','2016-04-19',NULL,NULL),(1822,8777,7,NULL,5804,NULL,0,'(NOMINA)?(/*user*/ANTICIPO/**/):REMOVE()','2016-04-20',NULL,NULL),(1840,8777,9,NULL,5806,'TEST GARANTIZADO',0,'(NOMINA)?(/*user*/CHECK(TOTAL_DEVENGADO == (X=(SALARIO_MENSUAL)), \"GTZDO ERRÓNEO \" + X)/**/):REMOVE()','2016-05-01',NULL,NULL),(1841,8777,9,NULL,5806,'TEST GARANTIZADO',0,'(NOMINA)?(/*user*/CHECK(TOTAL_DEVENGADO == (X=(SALARIO_MENSUAL*6/30)), \"GTZDO ERRÓNEO \" + X)/**/):REMOVE()','2016-04-25','2016-04-30',NULL),(1842,8777,9,NULL,5807,'TEST GARANTIZADO',0,'(NOMINA)?(/*user*/CHECK(TOTAL_DEVENGADO == (X=(SALARIO_MENSUAL)), \"GTZDO ERRÓNEO \" + X)/**/):REMOVE()','2016-04-25',NULL,NULL),(1843,8777,9,NULL,5810,'TEST GARANTIZADO',0,'(NOMINA)?(/*user*/CHECK(TOTAL_DEVENGADO == (X=(SALARIO_MENSUAL)), \"GTZDO ERRÓNEO \" + X)/**/):REMOVE()','2016-06-01','2016-06-30',NULL),(1844,8777,9,NULL,5811,'TEST GARANTIZADO',0,'(NOMINA)?(/*user*/CHECK(TOTAL_DEVENGADO == (X=(SALARIO_ANUAL/12)), \"GTZDO ERRÓNEO \" + X)/**/):REMOVE()','2016-05-04',NULL,NULL),(1845,8777,9,NULL,5812,'TEST GARANTIZADO',0,'(NOMINA)?(/*user*/CHECK((TOTAL_DEVENGADO-(X=(SALARIO_MENSUAL*(1-1/30))))<0.01 , \"GTZDO ERRÓNEO \" + X)/**/):REMOVE()','2016-06-01','2016-06-30',NULL),(1847,8777,9,NULL,5819,'TEST GARANTIZADO',0,'(NOMINA)?(/*user*/CHECK(TOTAL_DEVENGADO == (X=(SALARIO_MENSUAL*(1+1/6))), \"GTZDO ERRÓNEO \" + X)/**/):REMOVE()','2016-08-01',NULL,NULL),(1848,8777,9,NULL,5820,'TEST GARANTIZADO',0,'(NOMINA)?(/*user*/CHECK(TOTAL_DEVENGADO == (X=(SALARIO_MENSUAL))	, \"GTZDO ERRÓNEO \" + X)/**/):REMOVE()','2016-05-18',NULL,NULL),(1849,8783,9,NULL,5828,'TEST EXTRA',0,'(EXTRA)?(/*user*/CHECK(TOTAL_DEVENGADO==(SALARIO_MENSUAL), \"EXTRA ERRONEA\")/**/):REMOVE()','2016-05-24',NULL,NULL),(1850,8777,9,NULL,5833,'TEST BASE MÍNIMA',0,'(NOMINA)?(/*user*/CHECK(BASE_CGC==HORAS_NOMINA * 4.60, \"BASE COTIZACIÖN ERRÓNEA\")/**/):REMOVE()','2016-06-01',NULL,NULL),(1851,8777,7,NULL,5842,'ANTICIPO',0,'(NOMINA)?(/*user*/100.00/**/):REMOVE()','2016-07-01','2016-07-31',NULL),(1854,8777,9,NULL,5843,'BASE_CGC',0,'if(NOMINA){BASE_CGC=REDEFINE(\'BASE_CGC\',/*user*/666.66/**/);BUILDER.setCgcBase(BASE_CGC);}REMOVE();','2016-07-01',NULL,NULL),(1855,8777,9,NULL,5843,'BASE_CGP',0,'if(NOMINA){BASE_CGP=REDEFINE(\'BASE_CGP\',/*user*/999.99/**/);BUILDER.setCgpBase(BASE_CGP);}REMOVE();','2016-07-01',NULL,NULL),(1857,8777,9,NULL,5846,'TEST',0,'(NOMINA)?(/*user*/CHECK((T=DIAS_TRABAJADOS)==(D=DIAS(FIN,INICIO+1))/2, \'PARCIALIDAD \'+T/D+\'  ERRÓNEA\')	/**/):REMOVE()','2016-07-01',NULL,NULL),(1859,8777,9,NULL,5846,'TEST',0,'(NOMINA)?(/*user*/CHECK(DIAS_TRABAJADOS==(MIN(30,(DIAS(FIN,INICIO)+1))/2.00),\'PARCIALIDAD ERRÓNEA \')/**/):REMOVE()','2016-07-01',NULL,NULL),(1860,8777,9,NULL,5847,'TEST',0,'(NOMINA)?(/*user*/CHECK(DIAS_TRABAJADOS==(MIN(30,(DIAS(FIN,INICIO)+1))/2.00),\'PARCIALIDAD ERRÓNEA \')/**/):REMOVE()','2016-07-01',NULL,NULL),(1861,8777,9,NULL,5868,'TEST',0,'(NOMINA)?(/*user*/CHECK( BASE_CGC == BASE_REGULADORA * 30 ,\"COTIZ. ERRÓNEA DEBERIAS SER \" + (BASE_REGULADORA*30))/**/):REMOVE()','2016-12-01',NULL,NULL),(1862,8777,9,NULL,5868,'X',0,'(NOMINA)?(/*user*/DIAS_COTIZADOS * COEFICIENTE_MATERNIDAD * BASE_REGULADORA/**/):REMOVE()','2016-11-01','2016-11-30',NULL);
/*!40000 ALTER TABLE `contract_deduction` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `contract_embargo`
--

DROP TABLE IF EXISTS `contract_embargo`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `contract_embargo` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `contract` int(4) NOT NULL COMMENT 'Contrato',
  `start_date` date NOT NULL COMMENT 'Fecha de inicio ',
  `end_date` date DEFAULT NULL COMMENT 'Fecha de finalizacion',
  `amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe',
  `expression` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Formula',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion',
  PRIMARY KEY (`id`),
  KEY `IDX_CONTRACT_EMBARGO_CONTRACT` (`contract`),
  KEY `IDX_CONTRACT_EMBARGO_DOMAIN` (`domain`),
  CONSTRAINT `FK_CONTRACT_EMBARGO_CONTRACT` FOREIGN KEY (`contract`) REFERENCES `contract` (`id`),
  CONSTRAINT `FK_CONTRACT_EMBARGO_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Embargos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `contract_embargo`
--

LOCK TABLES `contract_embargo` WRITE;
/*!40000 ALTER TABLE `contract_embargo` DISABLE KEYS */;
INSERT INTO `contract_embargo` VALUES (3,8777,5826,'2016-05-23',NULL,0.000,'(NOMINA)?(/*user*/REMOVE()/**/):REMOVE()','TEST EMBARGO'),(4,8777,5826,'2016-05-23',NULL,0.000,'(NOMINA)?(/*user*/EMBARGAR(500.00)/**/):REMOVE()','EMBARGO 500 €'),(5,8777,5834,'2016-06-01',NULL,0.000,'(NOMINA)?(/*user*/555.89/**/):REMOVE()','IMPAGO PENSIÓN ALIMENTICIA');
/*!40000 ALTER TABLE `contract_embargo` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `contract_info`
--

DROP TABLE IF EXISTS `contract_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `contract_info` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `contract` int(4) DEFAULT NULL COMMENT 'Identificador del Contrato',
  `name` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre',
  `expression` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Expresion',
  `start_date` date NOT NULL COMMENT 'Fecha de inicio ',
  `end_date` date DEFAULT NULL COMMENT 'Fecha de finalizacion',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_CONTRACT_INFO_CONTRACT` (`contract`),
  KEY `IDX_CONTRACT_INFO_DOMAIN` (`domain`),
  CONSTRAINT `FK_CONTRACT_INFO_CONTRACT` FOREIGN KEY (`contract`) REFERENCES `contract` (`id`),
  CONSTRAINT `FK_CONTRACT_INFO_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=47829 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Informacion temporal del Contrato';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `contract_info`
--

LOCK TABLES `contract_info` WRITE;
/*!40000 ALTER TABLE `contract_info` DISABLE KEYS */;
INSERT INTO `contract_info` VALUES (-47551,8777,-5800,'SS_ALTA','PENDING','2016-04-19',NULL,'admin','2016-04-19 18:37:16',NULL,NULL),(-47550,8777,-5800,'SEPE_CONTRATO','PENDING','2016-04-19',NULL,'admin','2016-04-19 18:37:16',NULL,NULL),(-47549,8777,-5800,'OPCION_CONTRATO','\"TEMPORARY_OPT1\"','2016-04-19',NULL,'admin','2016-04-19 18:37:16',NULL,NULL),(-47548,8777,-5799,'SS_ALTA','PENDING','2016-04-15',NULL,'admin','2016-04-15 10:36:40',NULL,NULL),(-47547,8777,-5799,'SEPE_CONTRATO','PENDING','2016-04-15',NULL,'admin','2016-04-15 10:36:40',NULL,NULL),(-47546,8777,-5799,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-04-15',NULL,'admin','2016-04-15 10:36:40',NULL,NULL),(-47545,8777,-5798,'SS_ALTA','PENDING','2016-04-15',NULL,'admin','2016-04-15 10:21:04',NULL,NULL),(-47544,8777,-5798,'SEPE_CONTRATO','PENDING','2016-04-15',NULL,'admin','2016-04-15 10:21:04',NULL,NULL),(-47543,8777,-5798,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-04-15',NULL,'admin','2016-04-15 10:21:04',NULL,NULL),(-47542,8777,-5797,'SS_ALTA','PENDING','2016-04-14',NULL,'admin','2016-04-14 18:45:26',NULL,NULL),(-47541,8777,-5797,'SEPE_CONTRATO','PENDING','2016-04-14',NULL,'admin','2016-04-14 18:45:26',NULL,NULL),(-47540,8777,-5797,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-04-14',NULL,'admin','2016-04-14 18:45:26',NULL,NULL),(-47536,8777,-5795,'SS_ALTA','PENDING','2016-04-14',NULL,'admin','2016-04-19 18:32:16',NULL,NULL),(-47535,8777,-5795,'SEPE_CONTRATO','PENDING','2016-04-14',NULL,'admin','2016-04-19 18:32:16',NULL,NULL),(-47534,8777,-5795,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-04-14',NULL,'admin','2016-04-19 18:32:16',NULL,NULL),(47419,8777,5747,'SEPE_CONTRATO','PENDING','2010-08-18',NULL,'admin','2016-02-18 19:19:53',NULL,NULL),(47420,8777,5747,'SS_ALTA','PENDING','2010-08-18',NULL,'admin','2016-02-18 19:19:53',NULL,NULL),(47421,8777,5748,'SEPE_CONTRATO','PENDING','2016-02-18',NULL,'admin','2016-06-08 09:43:58',NULL,NULL),(47422,8777,5748,'SS_ALTA','PENDING','2016-02-18',NULL,'admin','2016-06-08 09:43:58',NULL,NULL),(47423,8777,5749,'SEPE_CONTRATO','PENDING','1975-02-18',NULL,'admin','2016-02-19 10:29:54',NULL,NULL),(47424,8777,5749,'SS_ALTA','PENDING','1975-02-18',NULL,'admin','2016-02-19 10:29:54',NULL,NULL),(47425,8777,5747,'SS_ALTA','PENDING','2012-08-18',NULL,'admin','2016-06-08 09:44:09',NULL,NULL),(47426,8777,5747,'SEPE_CONTRATO','PENDING','2012-08-18',NULL,'admin','2016-06-08 09:44:09',NULL,NULL),(47427,8777,5749,'SS_ALTA','PENDING','1989-02-18',NULL,'admin','2016-02-19 10:30:42',NULL,NULL),(47428,8777,5749,'SEPE_CONTRATO','PENDING','1989-02-18',NULL,'admin','2016-02-19 10:30:42',NULL,NULL),(47429,8777,5750,'SEPE_CONTRATO','PENDING','2016-02-19',NULL,'admin','2016-02-19 12:07:08',NULL,NULL),(47430,8777,5750,'SS_ALTA','PENDING','2016-02-19',NULL,'admin','2016-02-19 12:07:08',NULL,NULL),(47431,8777,5751,'SEPE_CONTRATO','PENDING','2016-02-21',NULL,'admin','2016-02-22 12:29:17',NULL,NULL),(47432,8777,5751,'SS_ALTA','PENDING','2016-02-21',NULL,'admin','2016-02-22 12:29:17',NULL,NULL),(47433,8777,5752,'SEPE_CONTRATO','PENDING','2016-01-01',NULL,'admin','2016-02-22 12:40:11',NULL,NULL),(47434,8777,5752,'SS_ALTA','PENDING','2016-01-01',NULL,'admin','2016-02-22 12:40:11',NULL,NULL),(47435,8777,5753,'SEPE_CONTRATO','PENDING','2016-02-21',NULL,'admin','2016-05-31 18:18:38',NULL,NULL),(47436,8777,5753,'SS_ALTA','PENDING','2016-02-21',NULL,'admin','2016-05-31 18:18:38',NULL,NULL),(47437,8777,5754,'SEPE_CONTRATO','PENDING','2016-02-21',NULL,'admin','2016-05-31 18:18:22',NULL,NULL),(47438,8777,5754,'SS_ALTA','PENDING','2016-02-21',NULL,'admin','2016-05-31 18:18:22',NULL,NULL),(47439,8778,5755,'SEPE_CONTRATO','PENDING','2016-02-22',NULL,'admin','2016-02-22 09:10:48',NULL,NULL),(47440,8778,5755,'SS_ALTA','PENDING','2016-02-22',NULL,'admin','2016-02-22 09:10:48',NULL,NULL),(47441,8777,5756,'SEPE_CONTRATO','PENDING','2016-02-22',NULL,'admin','2016-02-22 09:52:17',NULL,NULL),(47442,8777,5756,'SS_ALTA','PENDING','2016-02-22',NULL,'admin','2016-02-22 09:52:17',NULL,NULL),(47445,8777,5758,'SEPE_CONTRATO','PENDING','2016-02-22',NULL,'admin','2016-02-22 10:33:23',NULL,NULL),(47446,8777,5758,'SS_ALTA','PENDING','2016-02-22',NULL,'admin','2016-02-22 10:33:23',NULL,NULL),(47447,8777,5759,'SEPE_CONTRATO','PENDING','2016-02-22',NULL,'admin','2016-02-22 10:56:50',NULL,NULL),(47448,8777,5759,'SS_ALTA','PENDING','2016-02-22',NULL,'admin','2016-02-22 10:56:50',NULL,NULL),(47449,8777,5760,'SEPE_CONTRATO','PENDING','2016-02-22',NULL,'admin','2016-02-22 11:02:09',NULL,NULL),(47450,8777,5760,'SS_ALTA','PENDING','2016-02-22',NULL,'admin','2016-02-22 11:02:09',NULL,NULL),(47451,8777,5761,'SEPE_CONTRATO','PENDING','2016-02-22',NULL,'admin','2016-02-22 10:12:03',NULL,NULL),(47452,8777,5761,'SS_ALTA','PENDING','2016-02-22',NULL,'admin','2016-02-22 10:12:03',NULL,NULL),(47453,8777,5762,'SEPE_CONTRATO','PENDING','2016-02-22',NULL,'admin','2016-02-22 11:06:34',NULL,NULL),(47454,8777,5762,'SS_ALTA','PENDING','2016-02-22',NULL,'admin','2016-02-22 11:06:34',NULL,NULL),(47455,8777,5763,'SEPE_CONTRATO','PENDING','2016-02-22',NULL,'admin','2016-02-22 12:20:24',NULL,NULL),(47456,8777,5763,'SS_ALTA','PENDING','2016-02-22',NULL,'admin','2016-02-22 12:20:24',NULL,NULL),(47457,8777,5764,'SEPE_CONTRATO','PENDING','2016-02-22',NULL,'admin','2016-02-22 12:20:48',NULL,NULL),(47458,8777,5764,'SS_ALTA','PENDING','2016-02-22',NULL,'admin','2016-02-22 12:20:48',NULL,NULL),(47459,8777,5765,'SEPE_CONTRATO','PENDING','2016-02-22',NULL,'admin','2016-02-22 12:21:16',NULL,NULL),(47460,8777,5765,'SS_ALTA','PENDING','2016-02-22',NULL,'admin','2016-02-22 12:21:16',NULL,NULL),(47461,8777,5766,'SEPE_CONTRATO','PENDING','2016-02-22',NULL,'admin','2016-02-23 17:31:20',NULL,NULL),(47462,8777,5766,'SS_ALTA','PENDING','2016-02-22',NULL,'admin','2016-02-23 17:31:20',NULL,NULL),(47463,8777,5767,'SEPE_CONTRATO','PENDING','2016-02-22',NULL,'admin','2016-04-07 09:16:33',NULL,NULL),(47464,8777,5767,'SS_ALTA','PENDING','2016-02-22',NULL,'admin','2016-04-07 09:16:33',NULL,NULL),(47465,8777,5768,'SEPE_CONTRATO','PENDING','2016-02-22',NULL,'admin','2016-03-01 09:05:59',NULL,NULL),(47466,8777,5768,'SS_ALTA','PENDING','2016-02-22',NULL,'admin','2016-03-01 09:05:59',NULL,NULL),(47467,8777,5769,'SEPE_CONTRATO','PENDING','2016-02-22',NULL,'admin','2016-03-02 18:40:15',NULL,NULL),(47468,8777,5769,'SS_ALTA','PENDING','2016-02-22',NULL,'admin','2016-03-02 18:40:15',NULL,NULL),(47469,8777,5770,'SEPE_CONTRATO','PENDING','2016-02-22',NULL,'admin','2016-02-29 14:59:58',NULL,NULL),(47470,8777,5770,'SS_ALTA','PENDING','2016-02-22',NULL,'admin','2016-02-29 14:59:58',NULL,NULL),(47471,8777,5771,'RETA','true','2016-02-22',NULL,'admin','2016-02-22 18:27:44',NULL,NULL),(47472,8777,5771,NULL,'true','2016-02-22',NULL,'admin','2016-02-22 18:27:44',NULL,NULL),(47473,8777,5771,'SS_ALTA','PENDING','2016-02-22',NULL,'admin','2016-02-22 18:28:21',NULL,NULL),(47474,8777,5771,'SEPE_CONTRATO','PENDING','2016-02-22',NULL,'admin','2016-02-22 18:28:21',NULL,NULL),(47475,8777,5772,'SEPE_CONTRATO','PENDING','2016-02-29',NULL,'admin','2016-05-24 07:38:25',NULL,NULL),(47476,8777,5772,'SS_ALTA','PENDING','2016-02-29',NULL,'admin','2016-05-24 07:38:25',NULL,NULL),(47477,8778,5773,'SEPE_CONTRATO','PENDING','2016-03-01',NULL,'admin','2016-06-13 19:30:05',NULL,NULL),(47478,8778,5773,'SS_ALTA','PENDING','2016-03-01',NULL,'admin','2016-06-13 19:30:05',NULL,NULL),(47482,8777,5775,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-03-01',NULL,'admin','2016-03-01 11:45:59',NULL,NULL),(47483,8777,5775,'SEPE_CONTRATO','PENDING','2016-03-01',NULL,'admin','2016-03-01 11:45:59',NULL,NULL),(47484,8777,5775,'SS_ALTA','PENDING','2016-03-01',NULL,'admin','2016-03-01 11:45:59',NULL,NULL),(47485,8777,5776,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-03-01',NULL,'admin','2016-03-01 11:50:38',NULL,NULL),(47486,8777,5776,'SEPE_CONTRATO','PENDING','2016-03-01',NULL,'admin','2016-03-01 11:50:38',NULL,NULL),(47487,8777,5776,'SS_ALTA','PENDING','2016-03-01',NULL,'admin','2016-03-01 11:50:38',NULL,NULL),(47488,8777,5777,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-03-01',NULL,'admin','2016-06-08 17:46:57',NULL,NULL),(47489,8777,5777,'SEPE_CONTRATO','PENDING','2016-03-01',NULL,'admin','2016-06-08 17:46:57',NULL,NULL),(47490,8777,5777,'SS_ALTA','PENDING','2016-03-01',NULL,'admin','2016-06-08 17:46:57',NULL,NULL),(47491,8777,5778,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-03-01',NULL,'admin','2016-03-01 17:21:32',NULL,NULL),(47492,8777,5778,'SEPE_CONTRATO','PENDING','2016-03-01',NULL,'admin','2016-03-01 17:21:32',NULL,NULL),(47493,8777,5778,'SS_ALTA','PENDING','2016-03-01',NULL,'admin','2016-03-01 17:21:32',NULL,NULL),(47494,8777,5779,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-01-10',NULL,'admin','2016-11-24 15:53:28',NULL,NULL),(47495,8777,5779,'SEPE_CONTRATO','PENDING','2016-03-01',NULL,'admin','2016-11-24 15:53:28',NULL,NULL),(47496,8777,5779,'SS_ALTA','PENDING','2016-03-01',NULL,'admin','2016-11-24 15:53:28',NULL,NULL),(47497,8777,5780,'SEPE_CONTRATO','PENDING','2016-03-01',NULL,'admin','2016-11-24 17:30:16',NULL,NULL),(47498,8777,5780,'SS_ALTA','PENDING','2016-03-01',NULL,'admin','2016-11-24 17:30:16',NULL,NULL),(47499,8778,5781,'OPCION_CONTRATO','\"LEARNING_OPT1\"','2016-03-03',NULL,'admin','2016-06-13 18:20:16',NULL,NULL),(47500,8778,5781,'SEPE_CONTRATO','PENDING','2016-03-02',NULL,'admin','2016-03-03 11:10:13',NULL,NULL),(47501,8778,5781,'SS_ALTA','PENDING','2016-03-02',NULL,'admin','2016-03-03 11:10:13',NULL,NULL),(47502,8777,5769,'OPCION_CONTRATO','\"TEMPORARY_OPT1\"','2014-02-22','2016-03-02','admin','2016-03-02 18:40:15',NULL,NULL),(47503,8777,5782,'SEPE_CONTRATO','PENDING','2016-03-09',NULL,'admin','2016-03-09 15:58:51',NULL,NULL),(47504,8777,5782,'SS_ALTA','PENDING','2016-03-09',NULL,'admin','2016-03-09 15:58:51',NULL,NULL),(47505,8780,5783,'SEPE_CONTRATO','PENDING','2016-03-11',NULL,'admin','2016-03-11 12:00:27',NULL,NULL),(47506,8780,5783,'SS_ALTA','PENDING','2016-03-11',NULL,'admin','2016-03-11 12:00:27',NULL,NULL),(47507,8777,5784,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-02-09','2016-03-28','admin','2016-03-18 14:09:31',NULL,NULL),(47508,8777,5784,'SEPE_CONTRATO','PENDING','2016-03-18',NULL,'admin','2016-03-18 14:09:31',NULL,NULL),(47509,8777,5784,'SS_ALTA','PENDING','2016-03-18',NULL,'admin','2016-03-18 14:09:31',NULL,NULL),(47510,8777,5785,'SEPE_CONTRATO','PENDING','2016-04-03',NULL,'admin','2016-04-03 23:31:40',NULL,NULL),(47511,8777,5785,'SS_ALTA','PENDING','2016-04-03',NULL,'admin','2016-04-03 23:31:40',NULL,NULL),(47512,8777,5786,'SEPE_CONTRATO','PENDING','2016-04-03',NULL,'admin','2016-04-03 23:31:19',NULL,NULL),(47513,8777,5786,'SS_ALTA','PENDING','2016-04-03',NULL,'admin','2016-04-03 23:31:19',NULL,NULL),(47514,8777,5787,'SEPE_CONTRATO','PENDING','2016-04-03',NULL,'admin','2016-04-03 23:42:35',NULL,NULL),(47515,8777,5787,'SS_ALTA','PENDING','2016-04-03',NULL,'admin','2016-04-03 23:42:35',NULL,NULL),(47516,8777,5788,'SEPE_CONTRATO','PENDING','2016-04-05',NULL,'admin','2016-04-05 16:18:56',NULL,NULL),(47517,8777,5788,'SS_ALTA','PENDING','2016-04-05',NULL,'admin','2016-04-05 16:18:56',NULL,NULL),(47518,8777,5789,'SEPE_CONTRATO','PENDING','2016-04-05',NULL,'admin','2016-04-05 16:17:16',NULL,NULL),(47519,8777,5789,'SS_ALTA','PENDING','2016-04-05',NULL,'admin','2016-04-05 16:17:16',NULL,NULL),(47520,8777,5790,'SEPE_CONTRATO','PENDING','2016-04-05',NULL,'admin','2016-04-05 17:56:48',NULL,NULL),(47521,8777,5790,'SS_ALTA','PENDING','2016-04-05',NULL,'admin','2016-04-05 17:56:48',NULL,NULL),(47522,8780,5791,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-04-06',NULL,'admin','2016-04-06 18:37:18',NULL,NULL),(47523,8780,5791,'SEPE_CONTRATO','PENDING','2016-04-06',NULL,'admin','2016-04-06 18:37:18',NULL,NULL),(47524,8780,5791,'SS_ALTA','PENDING','2016-04-06',NULL,'admin','2016-04-06 18:37:18',NULL,NULL),(47525,8777,5792,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-04-07',NULL,'admin','2016-04-14 11:04:20',NULL,NULL),(47526,8777,5792,'SEPE_CONTRATO','PENDING','2016-04-07',NULL,'admin','2016-04-14 11:04:20',NULL,NULL),(47527,8777,5792,'SS_ALTA','PENDING','2016-04-07',NULL,'admin','2016-04-14 11:04:20',NULL,NULL),(47528,8777,5793,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-04-07',NULL,'admin','2016-04-07 16:50:48',NULL,NULL),(47529,8777,5793,'SEPE_CONTRATO','PENDING','2016-04-07',NULL,'admin','2016-04-07 16:50:48',NULL,NULL),(47530,8777,5793,'SS_ALTA','PENDING','2016-04-07',NULL,'admin','2016-04-07 16:50:48',NULL,NULL),(47531,8777,5794,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-04-14',NULL,'admin','2016-04-19 18:33:43',NULL,NULL),(47532,8777,5794,'SEPE_CONTRATO','PENDING','2016-04-14',NULL,'admin','2016-04-19 18:33:43',NULL,NULL),(47533,8777,5794,'SS_ALTA','PENDING','2016-04-14',NULL,'admin','2016-04-19 18:33:43',NULL,NULL),(47537,8777,5796,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-04-14',NULL,'admin','2016-04-14 18:38:32',NULL,NULL),(47538,8777,5796,'SEPE_CONTRATO','PENDING','2016-04-14',NULL,'admin','2016-04-14 18:38:32',NULL,NULL),(47539,8777,5796,'SS_ALTA','PENDING','2016-04-14',NULL,'admin','2016-04-14 18:38:32',NULL,NULL),(47552,8777,5801,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-04-19',NULL,'admin','2016-04-19 18:40:50',NULL,NULL),(47553,8777,5801,'SEPE_CONTRATO','PENDING','2016-04-19',NULL,'admin','2016-04-19 18:40:50',NULL,NULL),(47554,8777,5801,'SS_ALTA','PENDING','2016-04-19',NULL,'admin','2016-04-19 18:40:50',NULL,NULL),(47555,8777,5802,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-04-19',NULL,'admin','2016-04-19 18:43:38',NULL,NULL),(47556,8777,5802,'SEPE_CONTRATO','PENDING','2016-04-19',NULL,'admin','2016-04-19 18:43:38',NULL,NULL),(47557,8777,5802,'SS_ALTA','PENDING','2016-04-19',NULL,'admin','2016-04-19 18:43:38',NULL,NULL),(47558,8781,5803,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-04-20',NULL,'admin','2016-04-20 15:38:30',NULL,NULL),(47559,8781,5803,'SEPE_CONTRATO','PENDING','2016-04-20',NULL,'admin','2016-04-20 15:38:30',NULL,NULL),(47560,8781,5803,'SS_ALTA','PENDING','2016-04-20',NULL,'admin','2016-04-20 15:38:30',NULL,NULL),(47561,8777,5804,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-04-20',NULL,'admin','2016-04-20 16:43:46',NULL,NULL),(47562,8777,5804,'SEPE_CONTRATO','PENDING','2016-04-20',NULL,'admin','2016-04-20 16:43:46',NULL,NULL),(47563,8777,5804,'SS_ALTA','PENDING','2016-04-20',NULL,'admin','2016-04-20 16:43:46',NULL,NULL),(47564,8777,5805,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-04-20',NULL,'admin','2016-04-20 18:24:11',NULL,NULL),(47565,8777,5805,'SEPE_CONTRATO','PENDING','2016-04-20',NULL,'admin','2016-04-20 18:24:11',NULL,NULL),(47566,8777,5805,'SS_ALTA','PENDING','2016-04-20',NULL,'admin','2016-04-20 18:24:11',NULL,NULL),(47567,8777,5806,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-04-25',NULL,'admin','2016-04-25 18:22:11',NULL,NULL),(47568,8777,5806,'SEPE_CONTRATO','PENDING','2016-04-25',NULL,'admin','2016-04-25 18:22:11',NULL,NULL),(47569,8777,5806,'SS_ALTA','PENDING','2016-04-25',NULL,'admin','2016-04-25 18:22:11',NULL,NULL),(47570,8777,5807,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-03-25',NULL,'admin','2016-05-04 17:48:47',NULL,NULL),(47571,8777,5807,'SEPE_CONTRATO','PENDING','2016-04-25',NULL,'admin','2016-05-04 17:48:47',NULL,NULL),(47572,8777,5807,'SS_ALTA','PENDING','2016-04-25',NULL,'admin','2016-05-04 17:48:47',NULL,NULL),(47573,8777,5808,'SEPE_CONTRATO','PENDING','2016-05-03',NULL,'admin','2016-05-03 17:58:15',NULL,NULL),(47574,8777,5808,'SS_ALTA','PENDING','2016-05-03',NULL,'admin','2016-05-03 17:58:15',NULL,NULL),(47575,8777,5808,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-05-03',NULL,'admin','2016-05-03 17:58:15',NULL,NULL),(47576,8777,5809,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-05-04',NULL,'admin','2016-05-04 17:56:31',NULL,NULL),(47577,8777,5809,'SEPE_CONTRATO','PENDING','2016-05-04',NULL,'admin','2016-05-04 17:56:31',NULL,NULL),(47578,8777,5809,'SS_ALTA','PENDING','2016-05-04',NULL,'admin','2016-05-04 17:56:31',NULL,NULL),(47579,8777,5810,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-05-04',NULL,'admin','2016-06-08 18:54:51',NULL,NULL),(47580,8777,5810,'SEPE_CONTRATO','PENDING','2016-05-04',NULL,'admin','2016-06-08 18:54:51',NULL,NULL),(47581,8777,5810,'SS_ALTA','PENDING','2016-05-04',NULL,'admin','2016-06-08 18:54:51',NULL,NULL),(47582,8777,5811,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-05-04',NULL,'admin','2016-05-04 18:20:43',NULL,NULL),(47583,8777,5811,'SEPE_CONTRATO','PENDING','2016-05-04',NULL,'admin','2016-05-04 18:20:43',NULL,NULL),(47584,8777,5811,'SS_ALTA','PENDING','2016-05-04',NULL,'admin','2016-05-04 18:20:43',NULL,NULL),(47585,8777,5812,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-05-05',NULL,'admin','2016-05-05 15:40:07',NULL,NULL),(47586,8777,5812,'SEPE_CONTRATO','PENDING','2016-05-05',NULL,'admin','2016-05-05 15:40:07',NULL,NULL),(47587,8777,5812,'SS_ALTA','PENDING','2016-05-05',NULL,'admin','2016-05-05 15:40:07',NULL,NULL),(47588,8783,5813,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-05-06',NULL,'admin','2016-05-06 10:38:48',NULL,NULL),(47589,8783,5813,'SEPE_CONTRATO','PENDING','2016-05-06',NULL,'admin','2016-05-06 10:38:48',NULL,NULL),(47590,8783,5813,'SS_ALTA','PENDING','2016-05-06',NULL,'admin','2016-05-06 10:38:48',NULL,NULL),(47591,8783,5814,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-05-06',NULL,'admin','2016-05-06 11:14:24',NULL,NULL),(47592,8783,5814,'SEPE_CONTRATO','PENDING','2016-05-06',NULL,'admin','2016-05-06 11:14:24',NULL,NULL),(47593,8783,5814,'SS_ALTA','PENDING','2016-05-06',NULL,'admin','2016-05-06 11:14:24',NULL,NULL),(47594,8783,5815,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-05-06',NULL,'admin','2016-05-06 11:31:32',NULL,NULL),(47595,8783,5815,'SEPE_CONTRATO','PENDING','2016-05-06',NULL,'admin','2016-05-06 11:31:32',NULL,NULL),(47596,8783,5815,'SS_ALTA','PENDING','2016-05-06',NULL,'admin','2016-05-06 11:31:32',NULL,NULL),(47597,8783,5816,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-05-06',NULL,'admin','2016-05-06 11:38:08',NULL,NULL),(47598,8783,5816,'SEPE_CONTRATO','PENDING','2016-05-06',NULL,'admin','2016-05-06 11:38:08',NULL,NULL),(47599,8783,5816,'SS_ALTA','PENDING','2016-05-06',NULL,'admin','2016-05-06 11:38:08',NULL,NULL),(47600,8783,5817,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-05-06',NULL,'admin','2016-05-06 12:53:15',NULL,NULL),(47601,8783,5817,'SEPE_CONTRATO','PENDING','2016-05-06',NULL,'admin','2016-05-06 12:53:15',NULL,NULL),(47602,8783,5817,'SS_ALTA','PENDING','2016-05-06',NULL,'admin','2016-05-06 12:53:15',NULL,NULL),(47603,8783,5818,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-05-06',NULL,'admin','2016-05-06 12:58:02',NULL,NULL),(47604,8783,5818,'SEPE_CONTRATO','PENDING','2016-05-06',NULL,'admin','2016-05-06 12:58:02',NULL,NULL),(47605,8783,5818,'SS_ALTA','PENDING','2016-05-06',NULL,'admin','2016-05-06 12:58:02',NULL,NULL),(47606,8777,5819,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-05-09',NULL,'admin','2016-05-09 18:41:59',NULL,NULL),(47607,8777,5819,'SEPE_CONTRATO','PENDING','2016-05-09',NULL,'admin','2016-05-09 18:41:59',NULL,NULL),(47608,8777,5819,'SS_ALTA','PENDING','2016-05-09',NULL,'admin','2016-05-09 18:41:59',NULL,NULL),(47609,8777,5820,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-05-18',NULL,'admin','2016-05-20 10:05:33',NULL,NULL),(47610,8777,5820,'SEPE_CONTRATO','PENDING','2016-05-18',NULL,'admin','2016-05-20 10:05:33',NULL,NULL),(47611,8777,5820,'SS_ALTA','PENDING','2016-05-18',NULL,'admin','2016-05-20 10:05:33',NULL,NULL),(47612,8777,5821,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-05-18',NULL,'admin','2016-05-18 10:38:00',NULL,NULL),(47613,8777,5821,'SEPE_CONTRATO','PENDING','2016-05-18',NULL,'admin','2016-05-18 10:38:00',NULL,NULL),(47614,8777,5821,'SS_ALTA','PENDING','2016-05-18',NULL,'admin','2016-05-18 10:38:00',NULL,NULL),(47615,8777,5822,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-05-18',NULL,'admin','2016-05-18 10:40:23',NULL,NULL),(47616,8777,5822,'SEPE_CONTRATO','PENDING','2016-05-18',NULL,'admin','2016-05-18 10:40:23',NULL,NULL),(47617,8777,5822,'SS_ALTA','PENDING','2016-05-18',NULL,'admin','2016-05-18 10:40:23',NULL,NULL),(47618,8777,5823,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-05-18',NULL,'admin','2016-05-18 10:44:31',NULL,NULL),(47619,8777,5823,'SEPE_CONTRATO','PENDING','2016-05-18',NULL,'admin','2016-05-18 10:44:31',NULL,NULL),(47620,8777,5823,'SS_ALTA','PENDING','2016-05-18',NULL,'admin','2016-05-18 10:44:31',NULL,NULL),(47621,8784,5824,'OPCION_CONTRATO','\"TEMPORARY_OPT1\"','2016-05-18',NULL,'admin','2016-05-18 16:08:34',NULL,NULL),(47622,8784,5824,'SEPE_CONTRATO','PENDING','2016-05-18',NULL,'admin','2016-05-18 16:08:34',NULL,NULL),(47623,8784,5824,'SS_ALTA','PENDING','2016-05-18',NULL,'admin','2016-05-18 16:08:34',NULL,NULL),(47624,8784,5825,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-05-18',NULL,'admin','2016-05-18 16:14:30',NULL,NULL),(47625,8784,5825,'SEPE_CONTRATO','PENDING','2016-05-18',NULL,'admin','2016-05-18 16:14:30',NULL,NULL),(47626,8784,5825,'SS_ALTA','PENDING','2016-05-18',NULL,'admin','2016-05-18 16:14:30',NULL,NULL),(47627,8777,5826,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-05-23',NULL,'admin','2016-05-23 09:14:37',NULL,NULL),(47628,8777,5826,'SEPE_CONTRATO','PENDING','2016-05-23',NULL,'admin','2016-05-23 09:14:37',NULL,NULL),(47629,8777,5826,'SS_ALTA','PENDING','2016-05-23',NULL,'admin','2016-05-23 09:14:37',NULL,NULL),(47630,8777,5827,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-05-24',NULL,'admin','2016-05-27 13:59:40',NULL,NULL),(47631,8777,5827,'SEPE_CONTRATO','PENDING','2016-05-24',NULL,'admin','2016-05-27 13:59:40',NULL,NULL),(47632,8777,5827,'SS_ALTA','PENDING','2016-05-24',NULL,'admin','2016-05-27 13:59:40',NULL,NULL),(47633,8783,5828,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-02-01',NULL,'admin','2016-05-26 09:08:03',NULL,NULL),(47634,8783,5828,'SEPE_CONTRATO','PENDING','2016-05-24',NULL,'admin','2016-05-26 09:08:03',NULL,NULL),(47635,8783,5828,'SS_ALTA','PENDING','2016-05-24',NULL,'admin','2016-05-26 09:08:03',NULL,NULL),(47636,8783,5829,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2010-05-27',NULL,'admin','2016-05-27 09:29:50',NULL,NULL),(47637,8783,5829,'SEPE_CONTRATO','PENDING','2010-05-27',NULL,'admin','2016-05-27 09:29:50',NULL,NULL),(47638,8783,5829,'SS_ALTA','PENDING','2010-05-27',NULL,'admin','2016-05-27 09:29:50',NULL,NULL),(47639,8783,5830,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2010-05-27','2016-04-10','admin','2016-05-27 10:44:11',NULL,NULL),(47640,8783,5830,'SEPE_CONTRATO','PENDING','2016-05-27',NULL,'admin','2016-05-27 10:44:11',NULL,NULL),(47641,8783,5830,'SS_ALTA','PENDING','2016-05-27',NULL,'admin','2016-05-27 10:44:11',NULL,NULL),(47642,8777,5831,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-05-30',NULL,'admin','2016-05-30 15:49:44',NULL,NULL),(47643,8777,5831,'SEPE_CONTRATO','PENDING','2016-05-30',NULL,'admin','2016-05-30 15:49:44',NULL,NULL),(47644,8777,5831,'SS_ALTA','PENDING','2016-05-30',NULL,'admin','2016-05-30 15:49:44',NULL,NULL),(47645,8777,5832,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-05-31',NULL,'admin','2016-05-31 18:29:21',NULL,NULL),(47646,8777,5832,'SEPE_CONTRATO','PENDING','2016-05-31',NULL,'admin','2016-05-31 18:29:21',NULL,NULL),(47647,8777,5832,'SS_ALTA','PENDING','2016-05-31',NULL,'admin','2016-05-31 18:29:21',NULL,NULL),(47648,8777,5833,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-06-01',NULL,'admin','2016-06-08 11:50:05',NULL,NULL),(47649,8777,5833,'SEPE_CONTRATO','PENDING','2016-06-01',NULL,'admin','2016-06-08 11:50:05',NULL,NULL),(47650,8777,5833,'SS_ALTA','PENDING','2016-06-01',NULL,'admin','2016-06-08 11:50:05',NULL,NULL),(47651,8777,5834,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-06-06',NULL,'admin','2016-06-06 18:34:28',NULL,NULL),(47652,8777,5834,'SEPE_CONTRATO','PENDING','2016-06-06',NULL,'admin','2016-06-06 18:34:28',NULL,NULL),(47653,8777,5834,'SS_ALTA','PENDING','2016-06-06',NULL,'admin','2016-06-06 18:34:28',NULL,NULL),(47654,8783,5835,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-06-07',NULL,'admin','2016-06-07 09:57:06',NULL,NULL),(47655,8783,5835,'SEPE_CONTRATO','PENDING','2016-06-07',NULL,'admin','2016-06-07 09:57:06',NULL,NULL),(47656,8783,5835,'SS_ALTA','PENDING','2016-06-07',NULL,'admin','2016-06-07 09:57:06',NULL,NULL),(47657,8783,5836,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-06-07',NULL,'admin','2016-06-07 09:57:58',NULL,NULL),(47658,8783,5836,'SEPE_CONTRATO','PENDING','2016-06-07',NULL,'admin','2016-06-07 09:57:58',NULL,NULL),(47659,8783,5836,'SS_ALTA','PENDING','2016-06-07',NULL,'admin','2016-06-07 09:57:58',NULL,NULL),(47660,8777,5837,'OPCION_CONTRATO','\"TEMPORARY_OPT1\"','2016-06-07','2016-06-27','admin','2016-06-07 11:20:56',NULL,NULL),(47661,8777,5837,'SEPE_CONTRATO','PENDING','2016-06-07',NULL,'admin','2016-06-07 11:20:56',NULL,NULL),(47662,8777,5837,'SS_ALTA','PENDING','2016-06-07',NULL,'admin','2016-06-07 11:20:56',NULL,NULL),(47663,8778,5781,'SS_ALTA','PENDING','2016-03-03',NULL,'admin','2016-06-13 18:20:16',NULL,NULL),(47664,8778,5781,'SEPE_CONTRATO','PENDING','2016-03-03',NULL,'admin','2016-06-13 18:20:16',NULL,NULL),(47665,8777,5838,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-06-13',NULL,'admin','2016-06-13 19:55:11',NULL,NULL),(47666,8777,5838,'SEPE_CONTRATO','PENDING','2016-06-13',NULL,'admin','2016-06-13 19:55:11',NULL,NULL),(47667,8777,5838,'SS_ALTA','PENDING','2016-06-13',NULL,'admin','2016-06-13 19:55:11',NULL,NULL),(47668,8777,5839,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-06-14',NULL,'admin','2016-06-14 08:48:15',NULL,NULL),(47669,8777,5839,'SEPE_CONTRATO','PENDING','2016-06-14',NULL,'admin','2016-06-14 08:48:15',NULL,NULL),(47670,8777,5839,'SS_ALTA','PENDING','2016-06-14',NULL,'admin','2016-06-14 08:48:15',NULL,NULL),(47671,8777,5840,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-06-14',NULL,'admin','2016-06-14 09:18:10',NULL,NULL),(47672,8777,5840,'SEPE_CONTRATO','PENDING','2016-06-14',NULL,'admin','2016-06-14 09:18:10',NULL,NULL),(47673,8777,5840,'SS_ALTA','PENDING','2016-06-14',NULL,'admin','2016-06-14 09:18:10',NULL,NULL),(47674,8777,5841,'SEPE_CONTRATO','PENDING','2016-06-15',NULL,'admin','2016-06-17 11:02:22',NULL,NULL),(47675,8777,5841,'SS_ALTA','PENDING','2016-06-15',NULL,'admin','2016-06-17 11:02:22',NULL,NULL),(47676,8777,5842,'OPCION_CONTRATO','\"TEMPORARY_OPT1\"','2016-06-20',NULL,'admin','2016-06-20 17:30:47',NULL,NULL),(47677,8777,5842,'SEPE_CONTRATO','PENDING','2016-06-20',NULL,'admin','2016-06-20 17:30:47',NULL,NULL),(47678,8777,5842,'SS_ALTA','PENDING','2016-06-20',NULL,'admin','2016-06-20 17:30:47',NULL,NULL),(47679,8777,5843,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-07-04',NULL,'admin','2016-07-04 13:11:05',NULL,NULL),(47680,8777,5843,'SEPE_CONTRATO','PENDING','2016-07-04',NULL,'admin','2016-07-04 13:11:05',NULL,NULL),(47681,8777,5843,'SS_ALTA','PENDING','2016-07-04',NULL,'admin','2016-07-04 13:11:05',NULL,NULL),(47682,8777,5844,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-07-06',NULL,'admin','2016-07-06 11:53:12',NULL,NULL),(47683,8777,5844,'SEPE_CONTRATO','PENDING','2016-07-06',NULL,'admin','2016-07-06 11:53:12',NULL,NULL),(47684,8777,5844,'SS_ALTA','PENDING','2016-07-06',NULL,'admin','2016-07-06 11:53:12',NULL,NULL),(47685,8777,5845,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-07-07',NULL,'admin','2016-07-07 13:29:51',NULL,NULL),(47686,8777,5845,'SEPE_CONTRATO','PENDING','2016-07-07',NULL,'admin','2016-07-07 13:29:51',NULL,NULL),(47687,8777,5845,'SS_ALTA','PENDING','2016-07-07',NULL,'admin','2016-07-07 13:29:51',NULL,NULL),(47688,8777,5846,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-07-21',NULL,'admin','2016-07-21 19:56:45',NULL,NULL),(47689,8777,5846,'SEPE_CONTRATO','PENDING','2016-07-21',NULL,'admin','2016-07-21 19:56:45',NULL,NULL),(47690,8777,5846,'SS_ALTA','PENDING','2016-07-21',NULL,'admin','2016-07-21 19:56:45',NULL,NULL),(47691,8777,5847,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-07-21',NULL,'admin','2016-07-21 20:19:02',NULL,NULL),(47692,8777,5847,'SEPE_CONTRATO','PENDING','2016-07-21',NULL,'admin','2016-07-21 20:19:02',NULL,NULL),(47693,8777,5847,'SS_ALTA','PENDING','2016-07-21',NULL,'admin','2016-07-21 20:19:02',NULL,NULL),(47694,8777,5848,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-08-18',NULL,'admin','2016-08-18 14:06:21',NULL,NULL),(47695,8777,5848,'SEPE_CONTRATO','PENDING','2016-08-18',NULL,'admin','2016-08-18 14:06:21',NULL,NULL),(47696,8777,5848,'SS_ALTA','PENDING','2016-08-18',NULL,'admin','2016-08-18 14:06:21',NULL,NULL),(47697,8777,5849,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-08-18',NULL,'admin','2016-08-18 14:56:27',NULL,NULL),(47698,8777,5849,'SEPE_CONTRATO','PENDING','2016-08-18',NULL,'admin','2016-08-18 14:56:27',NULL,NULL),(47699,8777,5849,'SS_ALTA','PENDING','2016-08-18',NULL,'admin','2016-08-18 14:56:27',NULL,NULL),(47700,8777,5850,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-08-19',NULL,'admin','2016-08-19 01:04:03',NULL,NULL),(47701,8777,5850,'SEPE_CONTRATO','PENDING','2016-08-19',NULL,'admin','2016-08-19 01:04:03',NULL,NULL),(47702,8777,5850,'SS_ALTA','PENDING','2016-08-19',NULL,'admin','2016-08-19 01:04:03',NULL,NULL),(47703,8777,5851,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-08-26',NULL,'admin','2016-08-26 12:33:05',NULL,NULL),(47704,8777,5851,'SEPE_CONTRATO','PENDING','2016-08-26',NULL,'admin','2016-08-26 12:33:05',NULL,NULL),(47705,8777,5851,'SS_ALTA','PENDING','2016-08-26',NULL,'admin','2016-08-26 12:33:05',NULL,NULL),(47706,8777,5852,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-08-26',NULL,'admin','2016-08-26 12:46:48',NULL,NULL),(47707,8777,5852,'SEPE_CONTRATO','PENDING','2016-08-26',NULL,'admin','2016-08-26 12:46:48',NULL,NULL),(47708,8777,5852,'SS_ALTA','PENDING','2016-08-26',NULL,'admin','2016-08-26 12:46:48',NULL,NULL),(47709,8777,5853,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-08-29',NULL,'admin','2016-08-29 09:54:41',NULL,NULL),(47710,8777,5853,'SEPE_CONTRATO','PENDING','2016-08-29',NULL,'admin','2016-08-29 09:54:41',NULL,NULL),(47711,8777,5853,'SS_ALTA','PENDING','2016-08-29',NULL,'admin','2016-08-29 09:54:41',NULL,NULL),(47712,8777,5854,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-09-20',NULL,'admin','2016-09-20 12:13:33',NULL,NULL),(47713,8777,5854,'SEPE_CONTRATO','PENDING','2016-09-20',NULL,'admin','2016-09-20 12:13:33',NULL,NULL),(47714,8777,5854,'SS_ALTA','PENDING','2016-09-20',NULL,'admin','2016-09-20 12:13:33',NULL,NULL),(47715,8777,5855,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-09-20',NULL,'admin','2016-09-20 17:24:29',NULL,NULL),(47716,8777,5855,'SEPE_CONTRATO','PENDING','2016-09-20',NULL,'admin','2016-09-20 17:24:29',NULL,NULL),(47717,8777,5855,'SS_ALTA','PENDING','2016-09-20',NULL,'admin','2016-09-20 17:24:29',NULL,NULL),(47718,8787,5856,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-09-29',NULL,'admin','2016-09-29 18:51:24',NULL,NULL),(47719,8787,5856,'SEPE_CONTRATO','PENDING','2016-09-29',NULL,'admin','2016-09-29 18:51:24',NULL,NULL),(47720,8787,5856,'SS_ALTA','PENDING','2016-09-29',NULL,'admin','2016-09-29 18:51:24',NULL,NULL),(47721,8787,5857,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-09-30',NULL,'admin','2016-09-30 11:16:31',NULL,NULL),(47722,8787,5857,'SEPE_CONTRATO','PENDING','2016-09-30',NULL,'admin','2016-09-30 11:16:31',NULL,NULL),(47723,8787,5857,'SS_ALTA','PENDING','2016-09-30',NULL,'admin','2016-09-30 11:16:31',NULL,NULL),(47724,8787,5858,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-09-30',NULL,'admin','2016-09-30 11:20:30',NULL,NULL),(47725,8787,5858,'SEPE_CONTRATO','PENDING','2016-09-30',NULL,'admin','2016-09-30 11:20:30',NULL,NULL),(47726,8787,5858,'SS_ALTA','PENDING','2016-09-30',NULL,'admin','2016-09-30 11:20:30',NULL,NULL),(47727,8787,5859,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-09-30',NULL,'admin','2016-09-30 11:21:50',NULL,NULL),(47728,8787,5859,'SEPE_CONTRATO','PENDING','2016-09-30',NULL,'admin','2016-09-30 11:21:50',NULL,NULL),(47729,8787,5859,'SS_ALTA','PENDING','2016-09-30',NULL,'admin','2016-09-30 11:21:50',NULL,NULL),(47730,8787,5860,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-09-30',NULL,'admin','2016-09-30 11:23:02',NULL,NULL),(47731,8787,5860,'SEPE_CONTRATO','PENDING','2016-09-30',NULL,'admin','2016-09-30 11:23:02',NULL,NULL),(47732,8787,5860,'SS_ALTA','PENDING','2016-09-30',NULL,'admin','2016-09-30 11:23:02',NULL,NULL),(47733,8787,5861,'OPCION_CONTRATO','\"LEARNING_OPT1\"','2016-09-30',NULL,'admin','2016-09-30 11:26:17',NULL,NULL),(47734,8787,5861,'SEPE_CONTRATO','PENDING','2016-09-30',NULL,'admin','2016-09-30 11:26:17',NULL,NULL),(47735,8787,5861,'SS_ALTA','PENDING','2016-09-30',NULL,'admin','2016-09-30 11:26:17',NULL,NULL),(47736,8787,5862,'OPCION_CONTRATO','\"LEARNING_OPT1\"','2016-09-30',NULL,'admin','2016-09-30 11:28:41',NULL,NULL),(47737,8787,5862,'SEPE_CONTRATO','PENDING','2016-09-30',NULL,'admin','2016-09-30 11:28:41',NULL,NULL),(47738,8787,5862,'SS_ALTA','PENDING','2016-09-30',NULL,'admin','2016-09-30 11:28:41',NULL,NULL),(47739,8787,5863,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-09-30',NULL,'admin','2016-09-30 11:43:06',NULL,NULL),(47740,8787,5863,'SEPE_CONTRATO','PENDING','2016-09-30',NULL,'admin','2016-09-30 11:43:06',NULL,NULL),(47741,8787,5863,'SS_ALTA','PENDING','2016-09-30',NULL,'admin','2016-09-30 11:43:06',NULL,NULL),(47742,8777,5864,'SEPE_CONTRATO','PENDING','2012-10-02','2016-09-21','admin','2016-10-31 09:14:52',NULL,NULL),(47743,8777,5864,'SS_ALTA','PENDING','2012-10-02','2016-09-21','admin','2016-10-31 09:14:52',NULL,NULL),(47744,8777,5865,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-11-10',NULL,'admin','2016-11-10 17:49:08',NULL,NULL),(47745,8777,5865,'SEPE_CONTRATO','PENDING','2016-11-10',NULL,'admin','2016-11-10 17:49:08',NULL,NULL),(47746,8777,5865,'SS_ALTA','PENDING','2016-11-10',NULL,'admin','2016-11-10 17:49:08',NULL,NULL),(47747,8777,5866,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-11-10',NULL,'admin','2016-11-10 17:54:27',NULL,NULL),(47748,8777,5866,'SEPE_CONTRATO','PENDING','2016-11-10',NULL,'admin','2016-11-10 17:54:27',NULL,NULL),(47749,8777,5866,'SS_ALTA','PENDING','2016-11-10',NULL,'admin','2016-11-10 17:54:27',NULL,NULL),(47750,8777,5867,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-11-10',NULL,'admin','2016-11-10 18:10:34',NULL,NULL),(47751,8777,5867,'SEPE_CONTRATO','PENDING','2016-11-10',NULL,'admin','2016-11-10 18:10:35',NULL,NULL),(47752,8777,5867,'SS_ALTA','PENDING','2016-11-10',NULL,'admin','2016-11-10 18:10:35',NULL,NULL),(47753,8777,5868,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-07-16',NULL,'admin','2016-11-21 09:48:53',NULL,NULL),(47754,8777,5868,'SEPE_CONTRATO','PENDING','2016-11-16',NULL,'admin','2016-11-21 09:48:53',NULL,NULL),(47755,8777,5868,'SS_ALTA','PENDING','2016-11-16',NULL,'admin','2016-11-21 09:48:53',NULL,NULL),(47756,8777,5869,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-09-16',NULL,'admin','2016-11-24 18:14:39',NULL,NULL),(47757,8777,5869,'SEPE_CONTRATO','PENDING','2016-11-16',NULL,'admin','2016-11-24 18:14:39',NULL,NULL),(47758,8777,5869,'SS_ALTA','PENDING','2016-11-16',NULL,'admin','2016-11-24 18:14:39',NULL,NULL),(47759,8777,5870,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-01-01',NULL,'admin','2016-11-25 11:43:50',NULL,NULL),(47760,8777,5870,'SEPE_CONTRATO','PENDING','2016-01-01',NULL,'admin','2016-11-25 11:43:51',NULL,NULL),(47761,8777,5870,'SS_ALTA','PENDING','2016-01-01',NULL,'admin','2016-11-25 11:43:51',NULL,NULL),(47762,8777,5871,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-11-25',NULL,'admin','2016-12-02 10:37:47',NULL,NULL),(47763,8777,5871,'SEPE_CONTRATO','PENDING','2016-11-25',NULL,'admin','2016-12-02 10:37:47',NULL,NULL),(47764,8777,5871,'SS_ALTA','PENDING','2016-11-25',NULL,'admin','2016-12-02 10:37:47',NULL,NULL),(47765,8777,5872,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-11-25',NULL,'admin','2016-12-02 10:37:33',NULL,NULL),(47766,8777,5872,'SEPE_CONTRATO','PENDING','2016-11-25',NULL,'admin','2016-12-02 10:37:33',NULL,NULL),(47767,8777,5872,'SS_ALTA','PENDING','2016-11-25',NULL,'admin','2016-12-02 10:37:33',NULL,NULL),(47768,8777,5872,'SEPE_CONTRATO','PENDING','2016-11-25',NULL,'admin','2016-12-02 10:37:19',NULL,NULL),(47769,8777,5873,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-12-02',NULL,'admin','2016-12-02 10:48:18',NULL,NULL),(47770,8777,5873,'SEPE_CONTRATO','PENDING','2016-12-02',NULL,'admin','2016-12-02 10:47:15',NULL,NULL),(47771,8777,5873,'SS_ALTA','PENDING','2016-12-02',NULL,'admin','2016-12-02 10:48:18',NULL,NULL),(47772,8777,5873,'SEPE_CONTRATO','PENDING','2016-12-02',NULL,'admin','2016-12-02 10:48:18',NULL,NULL),(47773,8788,5874,'SEPE_CONTRATO','PENDING','2012-12-19',NULL,'admin','2016-12-19 11:31:39',NULL,NULL),(47774,8788,5874,'SS_ALTA','PENDING','2012-12-19',NULL,'admin','2016-12-27 12:23:13',NULL,NULL),(47775,8788,5874,'SEPE_CONTRATO','PENDING','2012-12-19',NULL,'admin','2016-12-27 12:23:13',NULL,NULL),(47776,8788,5875,'OPCION_CONTRATO','\"TEMPORARY_OPT1\"','2016-11-02','2016-11-09','admin','2016-12-27 12:24:56',NULL,NULL),(47777,8788,5875,'SEPE_CONTRATO','PENDING','2016-12-02','2016-12-09','admin','2016-12-27 12:24:57',NULL,NULL),(47778,8788,5875,'SS_ALTA','PENDING','2016-12-02','2016-12-09','admin','2016-12-27 12:24:56',NULL,NULL),(47779,8788,5876,'OPCION_CONTRATO','\"TEMPORARY_OPT1\"','2016-11-12','2016-11-16','admin','2016-12-27 12:24:35',NULL,NULL),(47780,8788,5876,'SEPE_CONTRATO','PENDING','2016-12-12','2016-12-16','admin','2016-12-19 16:10:41',NULL,NULL),(47781,8788,5876,'SS_ALTA','PENDING','2016-12-12','2016-12-16','admin','2016-12-27 12:24:35',NULL,NULL),(47782,8788,5877,'OPCION_CONTRATO','\"TEMPORARY_OPT1\"','2016-11-19','2016-11-23','admin','2016-12-27 12:24:17',NULL,NULL),(47783,8788,5877,'SEPE_CONTRATO','PENDING','2016-12-19','2016-12-23','admin','2016-12-19 16:11:42',NULL,NULL),(47784,8788,5877,'SS_ALTA','PENDING','2016-12-19','2016-12-23','admin','2016-12-27 12:24:18',NULL,NULL),(47785,8788,5878,'OPCION_CONTRATO','\"TEMPORARY_OPT1\"','2016-11-26','2016-11-30','admin','2016-12-27 12:23:41',NULL,NULL),(47786,8788,5878,'SEPE_CONTRATO','PENDING','2016-12-26','2016-12-31','admin','2016-12-20 17:36:48',NULL,NULL),(47787,8788,5878,'SS_ALTA','PENDING','2016-12-26','2016-12-31','admin','2016-12-27 12:23:41',NULL,NULL),(47788,8788,5878,'SEPE_CONTRATO','PENDING','2016-12-26','2016-12-31','admin','2016-12-27 12:23:41',NULL,NULL),(47789,8788,5877,'SEPE_CONTRATO','PENDING','2016-12-19','2016-12-23','admin','2016-12-27 12:24:18',NULL,NULL),(47790,8777,5749,'SEPE_CONTRATO','PENDING','1989-02-18',NULL,'admin','2016-12-23 14:37:05',NULL,NULL),(47791,8777,5761,'SEPE_CONTRATO','PENDING','2016-02-22',NULL,'admin','2016-12-23 15:03:21',NULL,NULL),(47792,8788,5876,'SEPE_CONTRATO','PENDING','2016-12-12','2016-12-16','admin','2016-12-27 12:24:35',NULL,NULL),(47793,8788,5875,'SEPE_CONTRATO','PENDING','2016-12-02','2016-12-09','admin','2016-12-27 12:24:38',NULL,NULL),(47794,8788,5879,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-01-04',NULL,'admin','2017-01-04 18:29:15',NULL,NULL),(47795,8788,5879,'SEPE_CONTRATO','PENDING','2016-01-04',NULL,'admin','2017-01-04 18:16:09',NULL,NULL),(47796,8788,5879,'SS_ALTA','PENDING','2016-01-04',NULL,'admin','2017-01-04 18:29:15',NULL,NULL),(47797,8788,5879,'SEPE_CONTRATO','PENDING','2016-01-04',NULL,'admin','2017-01-04 18:29:15',NULL,NULL),(47798,8788,5880,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-01-04',NULL,'admin','2017-01-04 18:30:33',NULL,NULL),(47799,8788,5880,'SEPE_CONTRATO','PENDING','2016-01-04',NULL,'admin','2017-01-04 18:29:25',NULL,NULL),(47800,8788,5880,'SS_ALTA','PENDING','2016-01-04',NULL,'admin','2017-01-04 18:30:33',NULL,NULL),(47801,8788,5881,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-01-04',NULL,'admin','2017-01-04 18:30:12',NULL,NULL),(47802,8788,5881,'SEPE_CONTRATO','PENDING','2016-01-04',NULL,'admin','2017-01-04 18:25:44',NULL,NULL),(47803,8788,5881,'SS_ALTA','PENDING','2016-01-04',NULL,'admin','2017-01-04 18:30:12',NULL,NULL),(47804,8788,5881,'SEPE_CONTRATO','PENDING','2016-01-04',NULL,'admin','2017-01-04 18:30:12',NULL,NULL),(47805,8788,5880,'SEPE_CONTRATO','PENDING','2016-01-04',NULL,'admin','2017-01-04 18:30:33',NULL,NULL),(47806,8777,5882,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2016-02-27',NULL,'admin','2017-02-27 18:04:53',NULL,NULL),(47807,8777,5882,'SEPE_CONTRATO','PENDING','2016-02-27',NULL,'admin','2017-02-27 17:04:52',NULL,NULL),(47808,8777,5882,'SS_ALTA','PENDING','2016-02-27',NULL,'admin','2017-02-27 18:04:54',NULL,NULL),(47809,8777,5882,'SEPE_CONTRATO','PENDING','2016-02-27',NULL,'admin','2017-02-27 18:04:54',NULL,NULL),(47810,8777,5772,'SEPE_CONTRATO','PENDING','2012-02-29',NULL,'admin','2017-03-06 17:47:12',NULL,NULL),(47811,8777,5793,'SEPE_CONTRATO','PENDING','2016-04-07',NULL,'admin','2017-03-06 17:47:24',NULL,NULL),(47812,8777,5851,'SEPE_CONTRATO','PENDING','2016-08-26',NULL,'admin','2017-03-07 08:47:41',NULL,NULL),(47813,8777,5852,'SEPE_CONTRATO','PENDING','2016-08-26',NULL,'admin','2017-03-07 08:51:09',NULL,NULL),(47814,8777,5847,'SEPE_CONTRATO','PENDING','2016-07-21',NULL,'admin','2017-03-14 17:59:20',NULL,NULL),(47815,8777,5826,'SEPE_CONTRATO','PENDING','2016-05-23',NULL,'admin','2017-03-15 16:29:48',NULL,NULL),(47816,8777,5883,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2017-07-18',NULL,'admin','2017-07-18 12:42:46',NULL,NULL),(47817,8777,5883,'SEPE_CONTRATO','PENDING','2017-07-18',NULL,'admin','2017-07-18 12:42:46',NULL,NULL),(47818,8777,5883,'SS_ALTA','PENDING','2017-07-18',NULL,'admin','2017-07-18 12:42:46',NULL,NULL),(47819,8777,5883,'SEPE_CONTRATO','PENDING','2017-07-18',NULL,'admin','2017-07-21 11:49:51',NULL,NULL),(47820,8777,5884,'OPCION_CONTRATO','\"PRACTICE_OPT1\"','2017-07-28',NULL,'admin','2017-07-28 09:25:27',NULL,NULL),(47821,8777,5884,'SEPE_CONTRATO','PENDING','2017-07-28',NULL,'admin','2017-07-28 09:25:27',NULL,NULL),(47822,8777,5884,'SS_ALTA','PENDING','2017-07-28',NULL,'admin','2017-07-28 09:25:27',NULL,NULL),(47823,8777,5884,'SEPE_CONTRATO','PENDING','2017-07-28',NULL,'admin','2017-07-28 09:24:42',NULL,NULL),(47824,8777,5846,'SEPE_CONTRATO','PENDING','2016-07-21',NULL,'admin','2017-08-29 09:16:36',NULL,NULL),(47825,8777,5885,'OPCION_CONTRATO','\"INDEFINITE_OPT1\"','2017-08-29',NULL,'admin','2017-08-29 09:34:12',NULL,NULL),(47826,8777,5885,'SEPE_CONTRATO','PENDING','2017-08-29',NULL,'admin','2017-08-29 09:34:12',NULL,NULL),(47827,8777,5885,'SS_ALTA','PENDING','2017-08-29',NULL,'admin','2017-08-29 09:34:12',NULL,NULL),(47828,8777,5885,'SEPE_CONTRATO','PENDING','2017-08-29',NULL,'admin','2017-09-11 11:41:27',NULL,NULL);
/*!40000 ALTER TABLE `contract_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `contract_leave`
--

DROP TABLE IF EXISTS `contract_leave`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `contract_leave` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de Baja',
  `contract` int(4) NOT NULL COMMENT 'Contrato',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion',
  `start_date` date NOT NULL COMMENT 'Fecha de inicio ',
  `end_date` date DEFAULT NULL COMMENT 'Fecha de finalizacion',
  `daily_cgc_base` double(15,3) DEFAULT NULL COMMENT 'Base de cotizacion por contingencias comunes',
  `daily_cgp_base` double(15,3) DEFAULT NULL COMMENT 'Base de cotizacion por contingencias profesionales',
  `parent` int(4) DEFAULT NULL COMMENT 'Baja origen, si es recaida',
  `daily_reg_base` double(15,3) DEFAULT NULL COMMENT 'Base reguladora',
  `discharge_cause` tinyint(2) DEFAULT NULL COMMENT 'Causa del alta',
  PRIMARY KEY (`id`),
  KEY `IDX_CONTRACT_LEAVE_CONTRACT_LEAVE` (`parent`),
  KEY `IDX_CONTRACT_LEAVE_CONTRACT` (`contract`),
  KEY `IDX_CONTRACT_LEAVE_DOMAIN` (`domain`),
  CONSTRAINT `FK_CONTRACT_LEAVE_CONTRACT` FOREIGN KEY (`contract`) REFERENCES `contract` (`id`),
  CONSTRAINT `FK_CONTRACT_LEAVE_CONTRACT_LEAVE` FOREIGN KEY (`parent`) REFERENCES `contract_leave` (`id`),
  CONSTRAINT `FK_CONTRACT_LEAVE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=886 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Bajas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `contract_leave`
--

LOCK TABLES `contract_leave` WRITE;
/*!40000 ALTER TABLE `contract_leave` DISABLE KEYS */;
INSERT INTO `contract_leave` VALUES (849,8777,0,5777,NULL,'2016-03-09','2016-03-22',NULL,NULL,NULL,NULL,0),(850,8780,0,5783,NULL,'2016-04-14','2016-04-21',NULL,NULL,NULL,NULL,0),(851,8777,0,5786,NULL,'2016-05-12','2016-05-19',NULL,NULL,NULL,NULL,0),(852,8777,0,5785,NULL,'2016-05-12','2016-05-13',NULL,NULL,NULL,NULL,0),(853,8777,0,5806,NULL,'2016-04-27','2016-05-10',NULL,NULL,NULL,NULL,0),(854,8777,1,5807,NULL,'2016-05-18',NULL,NULL,NULL,NULL,NULL,NULL),(855,8777,0,5806,NULL,'2016-05-20',NULL,NULL,NULL,NULL,NULL,NULL),(860,8777,0,5810,NULL,'2016-06-06','2016-06-15',NULL,NULL,NULL,NULL,0),(861,8777,1,5810,NULL,'2016-06-20','2016-06-27',NULL,NULL,NULL,NULL,0),(862,8777,0,5811,NULL,'2016-06-10',NULL,NULL,NULL,NULL,NULL,NULL),(863,8777,1,5812,NULL,'2016-06-20',NULL,NULL,NULL,NULL,NULL,NULL),(864,8783,0,5816,NULL,'2016-07-18',NULL,NULL,NULL,NULL,NULL,NULL),(865,8783,1,5817,NULL,'2016-07-13',NULL,NULL,NULL,NULL,NULL,NULL),(866,8783,2,5818,NULL,'2016-07-13',NULL,NULL,NULL,NULL,NULL,NULL),(867,8777,0,5819,NULL,'2016-07-14',NULL,NULL,NULL,NULL,NULL,NULL),(868,8777,0,5820,NULL,'2016-07-12',NULL,NULL,NULL,NULL,NULL,NULL),(869,8777,0,5827,NULL,'2016-06-15','2016-06-22',NULL,NULL,NULL,NULL,0),(870,8777,0,5827,NULL,'2016-07-13',NULL,NULL,NULL,NULL,NULL,NULL),(871,8777,0,5831,NULL,'2016-07-05','2016-08-10',NULL,NULL,NULL,NULL,0),(872,8783,0,5828,NULL,'2016-08-14',NULL,NULL,NULL,NULL,NULL,NULL),(873,8777,0,5832,NULL,'2016-07-14','2016-07-27',NULL,NULL,NULL,NULL,0),(874,8777,0,5831,NULL,'2016-08-25',NULL,NULL,NULL,NULL,NULL,NULL),(875,8777,0,5841,NULL,'2016-08-15','2016-08-25',NULL,NULL,NULL,NULL,0),(876,8777,0,5848,NULL,'2016-08-25',NULL,NULL,NULL,NULL,NULL,NULL),(877,8777,0,5849,NULL,'2016-08-22','2016-09-14',NULL,NULL,NULL,NULL,0),(878,8777,0,5850,NULL,'2016-08-22','2016-08-26',NULL,NULL,NULL,NULL,0),(879,8777,2,5868,NULL,'2016-12-14',NULL,NULL,NULL,NULL,NULL,NULL),(880,8777,3,5869,NULL,'2016-12-04',NULL,NULL,NULL,NULL,NULL,NULL),(881,8777,2,5779,NULL,'2016-04-06',NULL,NULL,NULL,NULL,NULL,NULL),(882,8777,3,5780,NULL,'2016-06-13',NULL,NULL,NULL,NULL,NULL,NULL),(883,8788,0,5879,NULL,'2016-11-21',NULL,NULL,NULL,NULL,NULL,NULL),(884,8788,0,5880,NULL,'2016-06-15',NULL,NULL,NULL,NULL,NULL,NULL),(885,8788,1,5881,NULL,'2016-08-10',NULL,NULL,NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `contract_leave` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `contract_leave_detail`
--

DROP TABLE IF EXISTS `contract_leave_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `contract_leave_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `type` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Tipo de parte',
  `contract_leave` int(4) NOT NULL COMMENT 'Contrato',
  `college_number` varchar(8) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de colegiado',
  `confirm_order` tinyint(2) DEFAULT NULL COMMENT 'Numero de orden del parte de confirmacion',
  `cias` varchar(11) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'codigo identificacion area sanitaria',
  `date` date NOT NULL COMMENT 'Fecha del parte',
  `status` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Indica el estado',
  PRIMARY KEY (`id`),
  KEY `IDX_CONTRACT_LEAVE_DETAIL_CONTRACT_LEAVE` (`contract_leave`),
  KEY `IDX_CONTRACT_LEAVE_DETAIL_DOMAIN` (`domain`),
  CONSTRAINT `FK_CONTRACT_LEAVE_DETAIL_CONTRACT_LEAVE` FOREIGN KEY (`contract_leave`) REFERENCES `contract_leave` (`id`),
  CONSTRAINT `FK_CONTRACT_LEAVE_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalle de las bajas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `contract_leave_detail`
--

LOCK TABLES `contract_leave_detail` WRITE;
/*!40000 ALTER TABLE `contract_leave_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `contract_leave_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `contract_payment`
--

DROP TABLE IF EXISTS `contract_payment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `contract_payment` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de Percepción Salarial',
  `contract` int(4) NOT NULL COMMENT 'Contrato',
  `payment_concept` int(4) DEFAULT NULL COMMENT 'Identificador unico del concepto',
  `description` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion',
  `description_decorable` tinyint(2) NOT NULL DEFAULT '0',
  `expression` varchar(1024) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Importe',
  `irpf_expression` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Importe tributable',
  `quote_expression` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Importe cotizable',
  `start_date` date NOT NULL COMMENT 'Fecha de inicio ',
  `month` tinyint(2) DEFAULT NULL COMMENT 'Mes de la percepcion',
  `end_date` date DEFAULT NULL COMMENT 'Fecha de finalizacion',
  `salary_type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de Nomina/Recibo',
  PRIMARY KEY (`id`),
  KEY `IDX_CONTRACT_PAYMENT_PAYMENT_CONCEPT` (`payment_concept`),
  KEY `IDX_CONTRACT_PAYMENT_CONTRACT` (`contract`),
  KEY `IDX_CONTRACT_PAYMENT_DOMAIN` (`domain`),
  CONSTRAINT `FK_CONTRACT_PAYMENT_CONTRACT` FOREIGN KEY (`contract`) REFERENCES `contract` (`id`),
  CONSTRAINT `FK_CONTRACT_PAYMENT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_CONTRACT_PAYMENT_PAYMENT_CONCEPT` FOREIGN KEY (`payment_concept`) REFERENCES `payment_concept` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=28784 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Percepciones Salariales';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `contract_payment`
--

LOCK TABLES `contract_payment` WRITE;
/*!40000 ALTER TABLE `contract_payment` DISABLE KEYS */;
INSERT INTO `contract_payment` VALUES (28616,8777,1,5747,NULL,'TEST COMPLEMENTO DE ANTIGÜEDAD (2012-2017)',0,'(AÑO(INICIO_NOMINA)==2017 )? CHECK(FALSO(),\"COMPLEMENTO PERSONAL DE ANTIGÜEDAD NO CHEQUEADO\"):0.00','_P','_P','2017-01-01',NULL,NULL,0),(28620,8777,1,5747,NULL,'TEST COMPLEMENTO DE ANTIGÜEDAD (2012-2016)',0,'AÑO(INICIO_NOMINA) ==2016? CHECK(ANTIGUEDAD==(X=SALARIO_ANUAL/PAGAS*4/100),\"ANTIGÜEDAD ERRÓNEA SE ESPERABA \" + X + \" €\"):0.00','_P','_P','2016-01-01',NULL,NULL,0),(28622,8777,1,5748,NULL,'TEST COMPLEMENTO ANTIGUEDAD (2016)',0,'AÑO(INICIO_NOMINA) ==2016? CHECK(ANTIGUEDAD==(X=SALARIO_ANUAL/PAGAS*24/100),\"ANTIGÜEDAD ERRÓNEA SE ESPERABA \" + X + \" €\"):0.00','_P','_P','2016-01-01',NULL,NULL,0),(28623,8777,1,5749,NULL,'TEST COMPLEMENTO ANTIGUEDAD (2016)',0,'AÑO(INICIO_NOMINA) ==2016? CHECK(ANTIGUEDAD==(X=SALARIO_ANUAL/PAGAS*29/100),\"ANTIGÜEDAD ERRÓNEA SE ESPERABA \" + X + \" €\"):0.00','_P','_P','2016-01-01',NULL,NULL,0),(28625,8777,1,5750,NULL,'TEST COMPLEMENTO ANTIGUEDAD (2016)',0,'AÑO(INICIO_NOMINA) ==2016? CHECK(ANTIGUEDAD==(X=SALARIO_ANUAL/PAGAS*24/100),\"ANTIGÜEDAD ERRÓNEA SE ESPERABA \" + X + \" €\") :0.00','_P','_P','2016-01-01',NULL,NULL,0),(28628,8777,NULL,5753,6179,'SALARIO BASE',0,NULL,NULL,NULL,'2016-02-01',NULL,NULL,0),(28629,8777,NULL,5754,6179,'SALARIO BASE ',0,NULL,NULL,NULL,'2016-02-01',NULL,NULL,0),(28630,8778,1,5755,NULL,'SALARIO BASE',0,'SALARIO_MENSUAL * DIAS_TRABAJADOS / DIAS_MES','_P','_P','2016-02-01',NULL,NULL,0),(28632,8777,1,5756,NULL,'SALARIO BASE',0,'BRUTO(1500 * DIAS_TRABAJADOS / DIAS_MES)','_P','_P','2016-02-01',NULL,NULL,0),(28633,8777,NULL,5756,6238,NULL,0,'100 * DIAS_TRABAJADOS/DIAS_MES',NULL,NULL,'2016-02-01',NULL,NULL,0),(28634,8777,NULL,5756,NULL,'PREST. POR ENFERMEDAD COMÃ?N PAGO DIRECTO',0,'DIAS_ENFERMEDAD_COMUN_366 * 0.00',NULL,'DIAS_COTIZADOS * BASE_REGULADORA','2016-02-01',NULL,NULL,0),(28635,8777,NULL,5756,NULL,'PREST. POR A.T Y/O E.P PAGO DIRECTO',0,'DIAS_ENFERMEDAD_PROFESIONAL_366 * 0.00',NULL,'DIAS_COTIZADOS * BASE_REGULADORA','2016-02-01',NULL,NULL,0),(28637,8777,1,5759,NULL,'SALARIO BASE',0,'BRUTO(203570.00/12)','_P','_P','2016-01-01',NULL,NULL,0),(28638,8777,1,5760,NULL,'SALARIO BASE',0,'BRUTO(11690.00/12)','_P','_P','2016-01-01',NULL,NULL,0),(28639,8777,NULL,5762,6194,NULL,0,'/*user*/150/**/ * DIAS_TRABAJADOS / DIAS_PAGA ',NULL,NULL,'2016-02-01',NULL,NULL,0),(28640,8777,NULL,5762,6183,NULL,0,'33',NULL,NULL,'2016-02-01',NULL,NULL,0),(28641,8777,1,5762,NULL,'SALARIO BASE',0,'NETO(2125 * DIAS_TRABAJADOS/DIAS_MES)','_P','_P','2016-02-01',NULL,NULL,0),(28642,8777,NULL,5770,6178,' SALARIO BASE',0,NULL,NULL,NULL,'2016-02-01',NULL,NULL,0),(28643,8777,NULL,5752,6194,'[3]PAGA EXTRAORDINARIA JULIO',0,'/*user*/(SALARIO_BASE + ANTIGUEDAD)/12/**/ * DIAS_TRABAJADOS / DIAS_PAGA ',NULL,NULL,'2016-01-01',NULL,'2016-01-31',0),(28644,8777,NULL,5752,6194,'[3]PAGA EXTRAORDINARIA JULIO',0,'(SALARIO_BASE + ANTIGUEDAD)/12 * DIAS_PAGA / DIAS_TRABAJADOS',NULL,NULL,'2016-02-01',NULL,NULL,0),(28645,8777,NULL,5752,6194,'[4]PAGA EXTRAORDINARIA DICIEMBRE',0,'/*user*/(SALARIO_BASE + ANTIGUEDAD)/12/**/ * DIAS_TRABAJADOS / DIAS_PAGA ',NULL,NULL,'2016-01-01',NULL,'2016-01-31',0),(28646,8777,NULL,5752,6194,'[4]PAGA EXTRAORDINARIA DICIEMBRE',0,'(SALARIO_BASE + ANTIGUEDAD)/12 * DIAS_PAGA / DIAS_TRABAJADOS	',NULL,NULL,'2016-02-01',NULL,NULL,0),(28647,8777,NULL,5771,6179,'SALARIO BASE',0,NULL,NULL,NULL,'2016-02-01',NULL,NULL,0),(28648,8777,NULL,5766,6178,' SALARIO BASE',0,NULL,NULL,NULL,'2016-02-01',NULL,NULL,0),(28651,8777,1,5766,NULL,'TEST SALARIO DIARIO',0,'CHECK(SALARIO_DIA == (X=SALARIO_ANUAL / 365.00), \"SALARIO DIARIO \" + SALARIO_DIA + \" ERRÓNEO SE ESPERABA \" + X + \" €\"  )','_P','_P','2016-01-22',NULL,NULL,2),(28652,8777,1,5770,NULL,'TEST SALARIO DIARIO',0,'CHECK(SALARIO_DIA==(X=SALARIO_ANUAL/365),\"SALARIO DIARIO ERRÓNEO SE ESPERABA \"+ X + \"€\")','_P','_P','2016-02-22',NULL,'2016-03-02',2),(28653,8778,NULL,5773,6179,'SALARIO BASE',0,NULL,NULL,NULL,'2016-03-01',NULL,NULL,0),(28655,8777,1,5769,NULL,'TEST DIAS INDEMNIZACIÓN',0,'CHECK(12 == 11, \'DIAS INDEMNIZACION ERRÓNEOS SE ESPERABA 11\')','_P','_P','2016-02-22',NULL,'2016-03-31',2),(28656,8778,NULL,5781,6179,'[1]SALARIO BASE',0,NULL,NULL,NULL,'2016-03-01',NULL,NULL,0),(28657,8778,1,5781,NULL,'[2]PAGA  EXTRAORDINARIA JULIO ',0,'SALARIO_BASE/12','_P','_P','2016-03-01',NULL,NULL,0),(28658,8778,NULL,5781,6194,'[2]PAGA EXTRAORDINARIA DICIEMBRE',0,'SALARIO_BASE/12',NULL,NULL,'2016-03-01',NULL,NULL,0),(28659,8780,NULL,5783,6179,'SALARIO BASE',0,NULL,NULL,NULL,'2016-03-01',NULL,NULL,0),(28660,8777,NULL,5786,6179,'SALARIO BASE',0,NULL,NULL,NULL,'2016-04-03',NULL,NULL,0),(28662,8777,NULL,5785,6179,'SALARIO BASE',0,NULL,NULL,NULL,'2016-04-01',NULL,NULL,0),(28664,8777,1,5788,NULL,'[6] PLUS REGIMÉN GENERAL ( REDEFINIDO )',0,'33.33','_P','_P','2016-04-05',NULL,NULL,0),(28665,8777,NULL,5788,6178,'[1]SALARIO BASE ( REDEFINIDO )',0,'/*user*/SALARIO_ANUAL*(1.10)/**/ / PAGAS * DIAS_TRABAJADOS / DIAS_MES ',NULL,NULL,'2016-04-05',NULL,NULL,0),(28668,8777,NULL,5792,6179,'[1]SALARIO BASE',0,NULL,NULL,NULL,'2016-04-07',NULL,NULL,0),(28669,8777,NULL,5792,6182,NULL,0,'ANTIGÜEDAD(SALARIO_BASE*0.10, TRIENIO)',NULL,NULL,'2016-04-07',NULL,NULL,0),(28670,8777,1,5793,NULL,'SALARIO BASE (@{S4L4R10_B4S3})',0,'100','_P','_P','2016-04-07',NULL,NULL,0),(28672,8777,NULL,5793,6266,'PLUS SALARIAL @{PLUS',0,'/*user*/50/**/ * DIAS_TRABAJADOS / DIAS_MES',NULL,NULL,'2016-04-07',NULL,NULL,0),(28673,8777,1,5796,NULL,NULL,0,'INPUT(\"\",\"INTRODUZCA EL \'IMPORTE\' DE LA PAGA, BONO :<UL><LI>SALARIO_BASE + ANTIGUEDAD</LI></UL>\")','_P','_P','2016-04-14',NULL,NULL,0),(28674,8777,NULL,5801,6182,NULL,0,NULL,NULL,NULL,'2016-04-19',NULL,NULL,0),(28675,8777,NULL,5802,6179,NULL,0,NULL,NULL,NULL,'2016-04-19',NULL,NULL,0),(28676,8777,NULL,5802,6194,NULL,0,NULL,NULL,NULL,'2016-04-19',NULL,NULL,0),(28677,8777,NULL,5801,6179,NULL,0,NULL,NULL,NULL,'2016-04-19',NULL,NULL,0),(28682,8777,1,5758,NULL,'SALARIO BASE',0,'BRUTO(12160.01/12)','_P','_P','2016-01-01',NULL,'2016-03-31',0),(28683,8777,1,5758,NULL,'SALARIO BASE',0,'BRUTO(12160.01/12)','_P','_P','2016-04-01',NULL,NULL,0),(28695,8777,NULL,5804,6179,'SALARIO BASE MENSUAL',0,NULL,NULL,NULL,'2016-04-20',NULL,NULL,0),(28697,8777,NULL,5806,NULL,'PREST. POR ENFERMEDAD COMÃ?N PAGO DIRECTO',0,'DIAS_ENFERMEDAD_COMUN_366 * 0.00',NULL,'DIAS_COTIZADOS * BASE_REGULADORA','2016-04-25',NULL,NULL,0),(28698,8777,NULL,5806,NULL,'PREST. POR A.T Y/O E.P PAGO DIRECTO',0,'DIAS_ENFERMEDAD_PROFESIONAL_366 * 0.00',NULL,'DIAS_COTIZADOS * BASE_REGULADORA','2016-04-25',NULL,NULL,0),(28701,8777,NULL,5806,6253,'MEJORAS PREST.SS.ENFERMEDAD COMÚM',0,'isdef DIAS_ENFERMEDAD_COMUN ?/*user*/GTZDO(SALARIO_BASE,1)/**/: REMOVE()',NULL,NULL,'2016-04-25',NULL,NULL,0),(28703,8777,NULL,5807,NULL,'PREST. POR ENFERMEDAD COMÃ?N PAGO DIRECTO',0,'DIAS_ENFERMEDAD_COMUN_366 * 0.00',NULL,'DIAS_COTIZADOS * BASE_REGULADORA','2016-04-25',NULL,NULL,0),(28704,8777,NULL,5807,NULL,'PREST. POR A.T Y/O E.P PAGO DIRECTO',0,'DIAS_ENFERMEDAD_PROFESIONAL_366 * 0.00',NULL,'DIAS_COTIZADOS * BASE_REGULADORA','2016-04-25',NULL,NULL,0),(28705,8777,NULL,5807,6254,'MEJORAS PREST.SS.ENFERMEDAD PROFESIONAL',0,'isdef DIAS_ENFERMEDAD_PROFESIONAL ?/*user*/GTZDO(SALARIO_BASE,1)/**/: REMOVE()',NULL,NULL,'2016-04-25',NULL,NULL,0),(28706,8777,NULL,5806,6179,'SALARIO BASE MENSUAL',0,NULL,NULL,NULL,'2016-04-25',NULL,'2016-04-30',0),(28708,8777,NULL,5806,6179,'SALARIO BASE MENSUAL',0,NULL,NULL,NULL,'2016-05-01',NULL,NULL,0),(28709,8777,NULL,5807,6179,'SALARIO BASE MENSUAL',0,NULL,NULL,NULL,'2016-04-01',NULL,NULL,0),(28710,8777,NULL,5809,6179,'SALARIO BASE MENSUAL',0,NULL,NULL,NULL,'2016-05-04',NULL,NULL,0),(28711,8777,NULL,5809,6253,'MEJORAS PREST.SS.ENFERMEDAD COMÚM',0,NULL,NULL,NULL,'2016-05-04',NULL,NULL,0),(28712,8777,NULL,5809,NULL,'PREST. POR ENFERMEDAD COMÃ?N PAGO DIRECTO',0,'DIAS_ENFERMEDAD_COMUN_366 * 0.00',NULL,'DIAS_COTIZADOS * BASE_REGULADORA','2016-05-04',NULL,NULL,0),(28713,8777,NULL,5809,NULL,'PREST. POR A.T Y/O E.P PAGO DIRECTO',0,'DIAS_ENFERMEDAD_PROFESIONAL_366 * 0.00',NULL,'DIAS_COTIZADOS * BASE_REGULADORA','2016-05-04',NULL,NULL,0),(28714,8777,NULL,5809,6254,'MEJORAS PREST.SS.ENFERMEDAD PROFESIONAL',0,NULL,NULL,NULL,'2016-05-04',NULL,NULL,0),(28715,8777,NULL,5810,6179,'SALARIO BASE MENSUAL',0,NULL,NULL,NULL,'2016-05-04',NULL,NULL,0),(28716,8777,NULL,5810,NULL,'PREST. POR ENFERMEDAD COMÃ?N PAGO DIRECTO',0,'DIAS_ENFERMEDAD_COMUN_366 * 0.00',NULL,'DIAS_COTIZADOS * BASE_REGULADORA','2016-05-04',NULL,NULL,0),(28717,8777,NULL,5810,NULL,'PREST. POR A.T Y/O E.P PAGO DIRECTO',0,'DIAS_ENFERMEDAD_PROFESIONAL_366 * 0.00',NULL,'DIAS_COTIZADOS * BASE_REGULADORA','2016-05-04',NULL,NULL,0),(28718,8777,NULL,5810,6250,'MEJORAS PREST.SS.INCAPACIDAD TEMPORAL',0,'GTZDO(SALARIO_BASE,1)',NULL,NULL,'2016-05-04',NULL,NULL,0),(28719,8777,NULL,5809,6250,'MEJORAS PREST.SS.INCAPACIDAD TEMPORAL',0,'GTZDO(SALARIO_BASE,1,3)',NULL,NULL,'2016-05-04',NULL,NULL,0),(28720,8777,NULL,5811,6178,' SALARIO BASE ANUAL',0,NULL,NULL,NULL,'2016-05-04',NULL,NULL,0),(28721,8777,NULL,5811,6253,'MEJORAS PREST.SS.ENFERMEDAD COMÚM',0,NULL,NULL,NULL,'2016-05-04',NULL,NULL,0),(28722,8777,NULL,5811,NULL,'PREST. POR ENFERMEDAD COMÃ?N PAGO DIRECTO',0,'DIAS_ENFERMEDAD_COMUN_366 * 0.00',NULL,'DIAS_COTIZADOS * BASE_REGULADORA','2016-05-04',NULL,NULL,0),(28723,8777,NULL,5811,NULL,'PREST. POR A.T Y/O E.P PAGO DIRECTO',0,'DIAS_ENFERMEDAD_PROFESIONAL_366 * 0.00',NULL,'DIAS_COTIZADOS * BASE_REGULADORA','2016-05-04',NULL,NULL,0),(28724,8777,NULL,5811,6253,'MEJORAS PREST.SS.ENFERMEDAD COMÚM',0,'isdef DIAS_ENFERMEDAD_COMUN ?/*user*/GTZDO(SALARIO_BASE,4)/**/: REMOVE()',NULL,NULL,'2016-05-04',NULL,NULL,0),(28726,8777,NULL,5812,6179,'SALARIO BASE MENSUAL',0,NULL,NULL,NULL,'2016-05-05',NULL,NULL,0),(28727,8777,NULL,5812,NULL,'PREST. POR ENFERMEDAD COMÃ?N PAGO DIRECTO',0,'DIAS_ENFERMEDAD_COMUN_366 * 0.00',NULL,'DIAS_COTIZADOS * BASE_REGULADORA','2016-05-05',NULL,NULL,0),(28728,8777,NULL,5812,NULL,'PREST. POR A.T Y/O E.P PAGO DIRECTO',0,'DIAS_ENFERMEDAD_PROFESIONAL_366 * 0.00',NULL,'DIAS_COTIZADOS * BASE_REGULADORA','2016-05-05',NULL,NULL,0),(28730,8777,NULL,5812,6254,'MEJORAS PREST.SS.ENFERMEDAD PROFESIONAL',0,'isdef DIAS_ENFERMEDAD_PROFESIONAL ?/*user*/GTZDO(SALARIO_BASE,11)/**/: REMOVE()',NULL,NULL,'2016-05-05',NULL,NULL,0),(28731,8777,NULL,5812,6254,'MEJORAS PREST.SS.ENFERMEDAD PROFESIONAL',0,'isdef DIAS_ENFERMEDAD_PROFESIONAL ?/*user*/GTZDO(SALARIO_BASE * 0.90,1,10)/**/: REMOVE()',NULL,NULL,'2016-05-05',NULL,NULL,0),(28732,8777,NULL,5819,NULL,'PREST. POR ENFERMEDAD COMÃ?N PAGO DIRECTO',0,'DIAS_ENFERMEDAD_COMUN_366 * 0.00',NULL,'DIAS_COTIZADOS * BASE_REGULADORA','2016-05-09',NULL,NULL,0),(28733,8777,NULL,5819,NULL,'PREST. POR A.T Y/O E.P PAGO DIRECTO',0,'DIAS_ENFERMEDAD_PROFESIONAL_366 * 0.00',NULL,'DIAS_COTIZADOS * BASE_REGULADORA','2016-05-09',NULL,NULL,0),(28735,8777,NULL,5819,6253,'MEJORAS PREST.SS.ENFERMEDAD COMÚN',0,'isdef DIAS_ENFERMEDAD_COMUN ?/*user*/GTZDO(TODO)/**/: REMOVE()',NULL,NULL,'2016-05-09',NULL,NULL,0),(28738,8777,NULL,5820,NULL,'PREST. POR ENFERMEDAD COMÃ?N PAGO DIRECTO',0,'DIAS_ENFERMEDAD_COMUN_366 * 0.00',NULL,'DIAS_COTIZADOS * BASE_REGULADORA','2016-05-18',NULL,NULL,0),(28739,8777,NULL,5820,NULL,'PREST. POR A.T Y/O E.P PAGO DIRECTO',0,'DIAS_ENFERMEDAD_PROFESIONAL_366 * 0.00',NULL,'DIAS_COTIZADOS * BASE_REGULADORA','2016-05-18',NULL,NULL,0),(28742,8777,NULL,5821,6178,' SALARIO BASE ANUAL',0,NULL,NULL,NULL,'2016-05-18',NULL,NULL,0),(28743,8777,NULL,5822,6178,' SALARIO BASE ANUAL',0,NULL,NULL,NULL,'2016-05-18',NULL,NULL,0),(28744,8777,NULL,5822,6194,'PAGA EXTRAORDINARIA JUNIO',0,'INPUT(\"/*user*/SALARIO_BASE/12/**/\",PAGA_EXTRA_HELP)',NULL,NULL,'2016-05-18',NULL,NULL,0),(28745,8777,NULL,5822,6194,'PAGA EXTRAORDINARIA NAVIDAD',0,'INPUT(\"/*user*/SALARIO_BASE/12/**/\",PAGA_EXTRA_HELP)',NULL,NULL,'2016-05-18',NULL,NULL,0),(28747,8777,NULL,5826,6179,'SALARIO BASE MENSUAL',0,NULL,NULL,NULL,'2016-05-23',NULL,NULL,0),(28748,8777,NULL,5826,6194,'PAGA EXTRAORDINARIA',0,'INPUT(\"/*user*/SALARIO_BASE/14/**/\",PAGA_EXTRA_HELP)',NULL,NULL,'2016-05-23',NULL,NULL,0),(28749,8777,NULL,5826,6194,'PAGA EXTRAORDINARIA',0,'INPUT(\"/*user*/SALARIO_BASE/14/**/\",PAGA_EXTRA_HELP)',NULL,NULL,'2016-05-23',NULL,NULL,0),(28751,8777,NULL,5805,6179,'SALARIO BASE MENSUAL',0,NULL,NULL,NULL,'2016-05-01',NULL,NULL,0),(28753,8777,NULL,5827,6179,'SALARIO BASE MENSUAL',0,'BRUTO(1000.00 * DIAS_TRABAJADOS/DIAS_MES)',NULL,NULL,'2016-05-01',NULL,NULL,0),(28754,8777,NULL,5832,6179,'SALARIO BASE MENSUAL',0,NULL,NULL,NULL,'2016-05-01',NULL,NULL,0),(28755,8777,NULL,5833,6179,'SALARIO BASE MENSUAL',0,NULL,NULL,NULL,'2016-06-01',NULL,NULL,0),(28756,8777,NULL,5833,6183,'PLUS EXTRA SALARIAL',0,'15',NULL,NULL,'2016-06-01',NULL,NULL,0),(28757,8777,1,5838,NULL,'CERO',0,'0.00','_P','_P','2016-06-13',NULL,'2016-06-25',2),(28758,8777,1,5839,NULL,'MÁX',0,'666000','_P','_P','2016-06-14',NULL,'2016-06-25',2),(28762,8777,NULL,5840,6179,'SALARIO BASE MENSUAL',0,NULL,NULL,NULL,'2016-06-01',NULL,NULL,0),(28763,8777,NULL,5840,6274,'DIAS PREAVISO (REDEFINIDO)',0,'100',NULL,NULL,'2016-06-14',NULL,NULL,2),(28764,8777,NULL,5840,6213,'VACACIONES NO DISFRUTADAS (REDEFINIDO)',0,'200',NULL,NULL,'2016-06-14',NULL,NULL,2),(28765,8777,1,5842,NULL,'SUPLEMENTO BRUTO',0,'BRUTO(1000.00 * DIAS_TRABAJADOS/DIAS_MES)','_P','_P','2016-06-01',NULL,'2016-06-30',0),(28766,8777,1,5842,NULL,'IRPF',0,'0.00','100.00','_P','2016-08-01',NULL,'2016-08-31',0),(28767,8777,NULL,5842,6193,'HORAS EXTR. ESTRUCTURALES O FUERZA MAYOR',0,NULL,NULL,NULL,'2016-09-01',NULL,'2016-09-30',0),(28768,8777,NULL,5843,6179,'SALARIO BASE MENSUAL',0,NULL,NULL,NULL,'2016-07-01',NULL,NULL,0),(28770,8777,NULL,5794,NULL,'PREST. POR ENFERMEDAD COMÃ?N PAGO DIRECTO',0,'DIAS_ENFERMEDAD_COMUN_366 * 0.00',NULL,'DIAS_COTIZADOS * BASE_REGULADORA','2016-07-01',NULL,'2016-07-31',0),(28771,8777,NULL,5794,NULL,'PREST. POR A.T Y/O E.P PAGO DIRECTO',0,'DIAS_ENFERMEDAD_PROFESIONAL_366 * 0.00',NULL,'DIAS_COTIZADOS * BASE_REGULADORA','2016-07-01',NULL,'2016-07-31',0),(28772,8777,1,5848,NULL,'SALARIO BASE ( ERRÓNEO )',0,'666.00','_P','_P','2016-08-01',NULL,NULL,0),(28773,8777,NULL,5849,6192,'HORAS EXTRAORDINARIAS NO ESTRUCTURALES',0,'100.00',NULL,NULL,'2016-08-01',NULL,'2016-08-31',0),(28774,8777,NULL,5850,6193,'HORAS EXTR. ESTRUCTURALES O FUERZA MAYOR',0,'100.00',NULL,NULL,'2016-08-01',NULL,'2016-08-31',0),(28775,8777,1,5851,NULL,'SALARIO MENSUAL',0,'2000.00','_P','_P','2016-08-01',NULL,NULL,0),(28776,8777,1,5852,NULL,'SALARIO MENSUAL, ',0,'BRUTO(2500)','_P','_P','2016-08-01',NULL,NULL,0),(28777,8777,1,5853,NULL,'SALARIO NETO',0,'NETO(2000.00)','_P','_P','2016-08-01',NULL,NULL,0),(28781,8777,NULL,5870,6194,'[3]PAGA EXTRAORDINARIA JULIO (REDEFINIDA)',0,'(SALARIO_BASE + ANTIGUEDAD) *  ( 1 + MAX(0,DIAS(INICIO_CONTRATO,INICIO_NOMINA))  / DIAS_TRABAJADOS) /6',NULL,'_P/2','2016-01-01',6,NULL,1),(28782,8777,NULL,5870,6194,'[4]PAGA EXTRAORDINARIA DICIEMBRE (REDEFINIDA)',0,'/*user*/(SALARIO_BASE + ANTIGUEDAD) *  ( 1 + MAX(0,DIAS(INICIO_CONTRATO,INICIO_NOMINA))  / DIAS_TRABAJADOS) /6/**/',NULL,'_P/2','2016-01-01',11,NULL,1),(28783,8777,1,5883,NULL,'INCIDENCIA_COMPLEMENTO_I',0,'COMPLEMENTO_I','_P','_P','2017-07-01',NULL,NULL,0);
/*!40000 ALTER TABLE `contract_payment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `contrata_batch`
--

DROP TABLE IF EXISTS `contrata_batch`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `contrata_batch` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `date` datetime DEFAULT NULL COMMENT 'Fecha de la Remesa',
  `status` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Indica el estado de la Remesa',
  `type` tinyint(2) DEFAULT '0' COMMENT 'Tipo de remesa a comunicar al SEPE',
  `communication_id` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Identificador resultante de la comunicacion',
  `outcome_file` mediumblob COMMENT 'Archivo Adjunto en binario',
  `outcome_file_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `income_file` mediumblob COMMENT 'Archivo respuesta en binario',
  `income_file_date` datetime DEFAULT NULL COMMENT 'Fecha de respuesta',
  PRIMARY KEY (`id`),
  KEY `IDX_CONTRATA_BATCH_DOMAIN` (`domain`),
  CONSTRAINT `FK_CONTRATA_BATCH_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Remesas de altas de Contratos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `contrata_batch`
--

LOCK TABLES `contrata_batch` WRITE;
/*!40000 ALTER TABLE `contrata_batch` DISABLE KEYS */;
/*!40000 ALTER TABLE `contrata_batch` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `contrata_batch_detail`
--

DROP TABLE IF EXISTS `contrata_batch_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `contrata_batch_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `contrata_batch` int(4) NOT NULL COMMENT 'Identificador de la Remesa',
  `contract` int(4) NOT NULL COMMENT 'Identificador del Contrato',
  `status` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Estado de la linea de la remesa',
  PRIMARY KEY (`id`),
  KEY `IDX_CONTRATA_BATCH_DETAIL_DOMAIN` (`domain`),
  KEY `IDX_CONTRATA_BATCH_DETAIL_CONTRACT` (`contract`),
  KEY `IDX_CONTRATA_BATCH_DETAIL_CONTRATA_BATCH` (`contrata_batch`),
  CONSTRAINT `FK_CONTRATA_BATCH_DETAIL_CONTRACT` FOREIGN KEY (`contract`) REFERENCES `contract` (`id`),
  CONSTRAINT `FK_CONTRATA_BATCH_DETAIL_CONTRATA_BATCH` FOREIGN KEY (`contrata_batch`) REFERENCES `contrata_batch` (`id`),
  CONSTRAINT `FK_CONTRATA_BATCH_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalle de Remesas de altas de Contratos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `contrata_batch_detail`
--

LOCK TABLES `contrata_batch_detail` WRITE;
/*!40000 ALTER TABLE `contrata_batch_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `contrata_batch_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cost_profile`
--

DROP TABLE IF EXISTS `cost_profile`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cost_profile` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `description` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion',
  `cost` double NOT NULL DEFAULT '0' COMMENT 'Costo por hora',
  PRIMARY KEY (`id`),
  KEY `IDX_COST_PROFILE_DOMAIN` (`domain`),
  CONSTRAINT `FK_COST_PROFILE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Perfiles de Costos para Usuarios';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cost_profile`
--

LOCK TABLES `cost_profile` WRITE;
/*!40000 ALTER TABLE `cost_profile` DISABLE KEYS */;
/*!40000 ALTER TABLE `cost_profile` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `course`
--

DROP TABLE IF EXISTS `course`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `course` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Curso',
  `domain` int(4) NOT NULL DEFAULT '1' COMMENT 'Identificador del Dominio',
  `code` varchar(5) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Alias del Curso',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion del Curso',
  `start_date` date NOT NULL COMMENT 'Fecha inicio del Curso',
  `end_date` date NOT NULL COMMENT 'Fecha fin del Curso',
  `academic_year` int(4) NOT NULL COMMENT 'Año Academico del Curso',
  `subject` int(4) NOT NULL COMMENT 'Materia del Curso',
  `level` int(4) NOT NULL COMMENT 'Nivel del Curso',
  `workplace` int(4) NOT NULL COMMENT 'Identificador del Centro de Trabajo',
  `alumn_limit` smallint(2) DEFAULT NULL COMMENT 'Limite de Alumnos del Curso',
  `status` tinyint(2) DEFAULT NULL COMMENT 'Estado del Curso',
  `comments` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Comentarios sobre el Curso',
  PRIMARY KEY (`id`),
  KEY `IDX_COURSE_ACADEMIC_YEAR` (`academic_year`),
  KEY `IDX_COURSE_LEVEL` (`level`),
  KEY `IDX_COURSE_SUBJECT` (`subject`),
  KEY `IDX_COURSE_WORKPLACE` (`workplace`),
  KEY `IDX_COURSE_DOMAIN` (`domain`),
  CONSTRAINT `FK_COURSE_ACADEMIC_YEAR` FOREIGN KEY (`academic_year`) REFERENCES `academic_year` (`id`),
  CONSTRAINT `FK_COURSE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_COURSE_LEVEL` FOREIGN KEY (`level`) REFERENCES `course_level` (`id`),
  CONSTRAINT `FK_COURSE_SUBJECT` FOREIGN KEY (`subject`) REFERENCES `course_subject` (`id`),
  CONSTRAINT `FK_COURSE_WORKPLACE` FOREIGN KEY (`workplace`) REFERENCES `workplace` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Cursos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `course`
--

LOCK TABLES `course` WRITE;
/*!40000 ALTER TABLE `course` DISABLE KEYS */;
/*!40000 ALTER TABLE `course` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `course_academicskill`
--

DROP TABLE IF EXISTS `course_academicskill`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `course_academicskill` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador Unico',
  `domain` int(4) NOT NULL DEFAULT '1' COMMENT 'Identificador del Dominio',
  `course` int(4) NOT NULL COMMENT 'Curso',
  `academic_skill` int(4) NOT NULL COMMENT 'Aptitud Academica',
  `weight` int(4) NOT NULL DEFAULT '1' COMMENT 'Peso de la Aptitud para calcular la Nota media',
  PRIMARY KEY (`id`),
  KEY `IDX_COURSE_ACADEMIC_SKILL_COURSE` (`course`),
  KEY `IDX_COURSE_ACADEMIC_SKILL_ACADEMIC_SKILL` (`academic_skill`),
  KEY `IDX_COURSE_ACADEMIC_SKILL_DOMAIN` (`domain`),
  CONSTRAINT `FK_COURSE_ACADEMIC_SKILL_ACADEMIC_SKILL` FOREIGN KEY (`academic_skill`) REFERENCES `academic_skill` (`id`),
  CONSTRAINT `FK_COURSE_ACADEMIC_SKILL_COURSE` FOREIGN KEY (`course`) REFERENCES `course` (`id`),
  CONSTRAINT `FK_COURSE_ACADEMIC_SKILL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Aptitudes Academicas por Curso';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `course_academicskill`
--

LOCK TABLES `course_academicskill` WRITE;
/*!40000 ALTER TABLE `course_academicskill` DISABLE KEYS */;
/*!40000 ALTER TABLE `course_academicskill` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `course_alumn`
--

DROP TABLE IF EXISTS `course_alumn`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `course_alumn` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL DEFAULT '1' COMMENT 'Identificador del Dominio',
  `course` int(4) NOT NULL COMMENT 'Identificador del Curso',
  `customer` int(4) NOT NULL COMMENT 'Identificador del Alumno',
  `status` tinyint(2) DEFAULT NULL COMMENT 'Estado del alumno en el curso',
  PRIMARY KEY (`id`),
  KEY `IDX_COURSE_ALUMN_COURSE` (`course`),
  KEY `IDX_COURSE_ALUMN_CUSTOMER` (`customer`),
  KEY `IDX_COURSE_ALUMN_DOMAIN` (`domain`),
  CONSTRAINT `FK_COURSE_ALUMN_COURSE` FOREIGN KEY (`course`) REFERENCES `course` (`id`),
  CONSTRAINT `FK_COURSE_ALUMN_CUSTOMER` FOREIGN KEY (`customer`) REFERENCES `customer` (`registry`),
  CONSTRAINT `FK_COURSE_ALUMN_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Alumnos por Curso';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `course_alumn`
--

LOCK TABLES `course_alumn` WRITE;
/*!40000 ALTER TABLE `course_alumn` DISABLE KEYS */;
/*!40000 ALTER TABLE `course_alumn` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `course_evaluation`
--

DROP TABLE IF EXISTS `course_evaluation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `course_evaluation` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL DEFAULT '1' COMMENT 'Identificador del Dominio',
  `course` int(4) NOT NULL COMMENT 'Identificador de Curso',
  `quality_skill` int(4) NOT NULL COMMENT 'Identificador de Aptitudes Calidad',
  `evaluation` double(15,3) DEFAULT '0.000' COMMENT 'Evaluaciones',
  `quantity` int(4) DEFAULT '0' COMMENT 'Cantidad',
  PRIMARY KEY (`id`),
  KEY `IDX_COURSE_EVALUATION_COURSE` (`course`),
  KEY `IDX_COURSE_EVALUATION_QUALITY_SKILL` (`quality_skill`),
  KEY `IDX_COURSE_EVALUATION_DOMAIN` (`domain`),
  CONSTRAINT `FK_COURSE_EVALUATION_COURSE` FOREIGN KEY (`course`) REFERENCES `course` (`id`),
  CONSTRAINT `FK_COURSE_EVALUATION_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_COURSE_EVALUATION_QUALITY_SKILL` FOREIGN KEY (`quality_skill`) REFERENCES `quality_skill` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Evaluaciones por Curso';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `course_evaluation`
--

LOCK TABLES `course_evaluation` WRITE;
/*!40000 ALTER TABLE `course_evaluation` DISABLE KEYS */;
/*!40000 ALTER TABLE `course_evaluation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `course_instructor`
--

DROP TABLE IF EXISTS `course_instructor`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `course_instructor` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL DEFAULT '1' COMMENT 'Identificador del Dominio',
  `course` int(4) NOT NULL COMMENT 'Identificador del Curso',
  `task_holder` int(4) NOT NULL COMMENT 'Identificador del Profesor',
  `type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de Profesor',
  PRIMARY KEY (`id`),
  KEY `IDX_COURSE_INSTRUCTOR_COURSE` (`course`),
  KEY `IDX_COURSE_INSTRUCTOR_DOMAIN` (`domain`),
  KEY `IDX_COURSE_INSTRUCTOR_TASK_HOLDER` (`task_holder`),
  CONSTRAINT `FK_COURSE_INSTRUCTOR_COURSE` FOREIGN KEY (`course`) REFERENCES `course` (`id`),
  CONSTRAINT `FK_COURSE_INSTRUCTOR_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_COURSE_INSTRUCTOR_TASK_HOLDER` FOREIGN KEY (`task_holder`) REFERENCES `task_holder` (`registry`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Profesores por Curso';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `course_instructor`
--

LOCK TABLES `course_instructor` WRITE;
/*!40000 ALTER TABLE `course_instructor` DISABLE KEYS */;
/*!40000 ALTER TABLE `course_instructor` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `course_level`
--

DROP TABLE IF EXISTS `course_level`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `course_level` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Nivel',
  `domain` int(4) NOT NULL DEFAULT '1' COMMENT 'Identificador del Dominio',
  `description` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion del Nivel',
  PRIMARY KEY (`id`),
  KEY `IDX_COURSE_LEVEL_DOMAIN` (`domain`),
  CONSTRAINT `FK_COURSE_LEVEL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Niveles de Cursos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `course_level`
--

LOCK TABLES `course_level` WRITE;
/*!40000 ALTER TABLE `course_level` DISABLE KEYS */;
/*!40000 ALTER TABLE `course_level` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `course_observation`
--

DROP TABLE IF EXISTS `course_observation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `course_observation` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL DEFAULT '1' COMMENT 'Identificador del Dominio',
  `course` int(4) NOT NULL COMMENT 'Identificador de Curso',
  `observation` varchar(64) CHARACTER SET latin1 COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Observaciones',
  PRIMARY KEY (`id`),
  KEY `IDX_COURSE_OBSERVATION_COURSE` (`course`),
  KEY `IDX_COURSE_OBSERVATION_DOMAIN` (`domain`),
  CONSTRAINT `FK_COURSE_OBSERVATION_COURSE` FOREIGN KEY (`course`) REFERENCES `course` (`id`),
  CONSTRAINT `FK_COURSE_OBSERVATION_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Observaciones por Curso';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `course_observation`
--

LOCK TABLES `course_observation` WRITE;
/*!40000 ALTER TABLE `course_observation` DISABLE KEYS */;
/*!40000 ALTER TABLE `course_observation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `course_schedule`
--

DROP TABLE IF EXISTS `course_schedule`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `course_schedule` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Horario',
  `domain` int(4) NOT NULL DEFAULT '1' COMMENT 'Identificador del Dominio',
  `course` int(4) NOT NULL COMMENT 'Identificador del Curso',
  `day_of_week` tinyint(2) NOT NULL COMMENT 'Dia de la semana',
  `start_time` time NOT NULL COMMENT 'Hora de comienzo',
  `end_time` time NOT NULL COMMENT 'Hora de fin',
  PRIMARY KEY (`id`),
  KEY `IDX_COURSE_SCHEDULE_COURSE` (`course`),
  KEY `IDX_COURSE_SCHEDULE_DOMAIN` (`domain`),
  CONSTRAINT `FK_COURSE_SCHEDULE_COURSE` FOREIGN KEY (`course`) REFERENCES `course` (`id`),
  CONSTRAINT `FK_COURSE_SCHEDULE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Horarios de Cursos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `course_schedule`
--

LOCK TABLES `course_schedule` WRITE;
/*!40000 ALTER TABLE `course_schedule` DISABLE KEYS */;
/*!40000 ALTER TABLE `course_schedule` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `course_subject`
--

DROP TABLE IF EXISTS `course_subject`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `course_subject` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la Materia',
  `domain` int(4) NOT NULL DEFAULT '1' COMMENT 'Identificador del Dominio',
  `description` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion de la Materia',
  PRIMARY KEY (`id`),
  KEY `IDX_COURSE_SUBJECT_DOMAIN` (`domain`),
  CONSTRAINT `FK_COURSE_SUBJECT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Materias de Cursos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `course_subject`
--

LOCK TABLES `course_subject` WRITE;
/*!40000 ALTER TABLE `course_subject` DISABLE KEYS */;
/*!40000 ALTER TABLE `course_subject` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cra_batch`
--

DROP TABLE IF EXISTS `cra_batch`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cra_batch` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `status` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Indica el estado de la Remesa',
  `communication_id` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Identificador resultante de la comunicacion',
  `income_file` mediumblob COMMENT 'Archivo respuesta en binario',
  `income_file_date` datetime DEFAULT NULL COMMENT 'Fecha de respuesta',
  `outcome_file` mediumblob COMMENT 'Archivo Adjunto en binario',
  `outcome_file_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  PRIMARY KEY (`id`),
  KEY `IDX_CRA_BATCH_DOMAIN` (`domain`),
  CONSTRAINT `FK_CRA_BATCH_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Remesas del fichero cra';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cra_batch`
--

LOCK TABLES `cra_batch` WRITE;
/*!40000 ALTER TABLE `cra_batch` DISABLE KEYS */;
/*!40000 ALTER TABLE `cra_batch` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cra_batch_detail`
--

DROP TABLE IF EXISTS `cra_batch_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `cra_batch_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `cra_batch` int(4) NOT NULL COMMENT 'Identificador unico de la Remesa',
  `enterprise_ccc` int(4) NOT NULL COMMENT 'Identificador unico del ccc',
  PRIMARY KEY (`id`),
  KEY `IDX_CRA_BATCH_DETAIL_DOMAIN` (`domain`),
  KEY `IDX_CRA_BATCH_DETAIL_CRA_BATCH` (`cra_batch`),
  KEY `IDX_CRA_BATCH_DETAIL_ENTERPRISE_CCC` (`enterprise_ccc`),
  CONSTRAINT `FK_CRA_BATCH_DETAIL_CRA_BATCH` FOREIGN KEY (`cra_batch`) REFERENCES `cra_batch` (`id`),
  CONSTRAINT `FK_CRA_BATCH_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_CRA_BATCH_DETAIL_ENTERPRISE_CCC` FOREIGN KEY (`enterprise_ccc`) REFERENCES `enterprise_ccc` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalle de las Remesas del fichero cra';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cra_batch_detail`
--

LOCK TABLES `cra_batch_detail` WRITE;
/*!40000 ALTER TABLE `cra_batch_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `cra_batch_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `creditor`
--

DROP TABLE IF EXISTS `creditor`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `creditor` (
  `registry` int(4) NOT NULL DEFAULT '0' COMMENT 'Registro del Acreedor',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `withholding` tinyint(1) DEFAULT '0' COMMENT 'Indica si el Acreedor aplica retencion de impuestos',
  `vat_accrual_payment` tinyint(1) DEFAULT '0' COMMENT 'Indica si el Acreedor esta acogido al Regimen Especial de Criterio de Caja',
  `transaction` tinyint(2) DEFAULT '0' COMMENT 'Tipo de transacciones del Acreedor',
  `status` tinyint(2) DEFAULT NULL COMMENT 'Estado del Acreedor',
  `scope` int(4) NOT NULL COMMENT 'Identificador del Ambito',
  `account` int(4) DEFAULT NULL COMMENT 'Identificador de la Cuenta Contable',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`registry`),
  KEY `IDX_CREDITOR_SCOPE` (`scope`),
  KEY `IDX_CREDITOR_DOMAIN` (`domain`),
  KEY `IDX_CREDITOR_ACCOUNT` (`account`),
  CONSTRAINT `FK_CREDITOR_ACCOUNT` FOREIGN KEY (`account`) REFERENCES `account` (`id`),
  CONSTRAINT `FK_CREDITOR_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_CREDITOR_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`),
  CONSTRAINT `FK_CREDITOR_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Acreedores';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `creditor`
--

LOCK TABLES `creditor` WRITE;
/*!40000 ALTER TABLE `creditor` DISABLE KEYS */;
/*!40000 ALTER TABLE `creditor` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customer`
--

DROP TABLE IF EXISTS `customer`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `customer` (
  `registry` int(4) NOT NULL DEFAULT '0' COMMENT 'Registro del Cliente',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `tariff` int(4) DEFAULT NULL COMMENT 'Tarifa asociada al Cliente',
  `surcharge` tinyint(1) DEFAULT '0' COMMENT 'Indica si el Cliente tiene recargo de equivalencia',
  `withholding` tinyint(1) DEFAULT '0' COMMENT 'Indica si el Cliente aplica retencion de impuestos',
  `transaction` tinyint(2) DEFAULT '0' COMMENT 'Tipo de transacciones del Cliente',
  `status` tinyint(2) DEFAULT NULL COMMENT 'Estado del Cliente',
  `scope` int(4) NOT NULL COMMENT 'Identificador del Ambito',
  `e_invoice` tinyint(1) DEFAULT '0' COMMENT 'Indica si el Cliente desea recibir Facturas electronicas',
  `invoicing_group` int(4) DEFAULT NULL COMMENT 'Identificador de Grupo de Facturacion',
  `project_grouped` tinyint(1) DEFAULT '1' COMMENT 'Indica si el Cliente desea agrupar Proyectos en una sola Factura',
  `delivery_grouped` tinyint(1) DEFAULT '1' COMMENT 'Indica si el Cliente desea agrupar Albaranes en una sola Factura',
  `delivery_valuated` tinyint(1) DEFAULT '1' COMMENT 'Indica si el Cliente desea imprimir el Albaran valorado',
  `account` int(4) DEFAULT NULL COMMENT 'Identificador de la Cuenta Contable',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`registry`),
  KEY `IDX_CUSTOMER_TARIFF` (`tariff`),
  KEY `IDX_CUSTOMER_SCOPE` (`scope`),
  KEY `IDX_CUSTOMER_DOMAIN` (`domain`),
  KEY `IDX_CUSTOMER_ACCOUNT` (`account`),
  KEY `IDX_CUSTOMER_INVOICING_GROUP` (`invoicing_group`),
  CONSTRAINT `FK_CUSTOMER_ACCOUNT` FOREIGN KEY (`account`) REFERENCES `account` (`id`),
  CONSTRAINT `FK_CUSTOMER_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_CUSTOMER_INVOICING_GROUP` FOREIGN KEY (`invoicing_group`) REFERENCES `invoicing_group` (`id`),
  CONSTRAINT `FK_CUSTOMER_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`),
  CONSTRAINT `FK_CUSTOMER_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`),
  CONSTRAINT `FK_CUSTOMER_TARIFF` FOREIGN KEY (`tariff`) REFERENCES `tariff` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Clientes';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customer`
--

LOCK TABLES `customer` WRITE;
/*!40000 ALTER TABLE `customer` DISABLE KEYS */;
/*!40000 ALTER TABLE `customer` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customer_fee`
--

DROP TABLE IF EXISTS `customer_fee`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `customer_fee` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la Cuota del Cliente',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `project` int(4) DEFAULT NULL COMMENT 'Identificador del Proyecto',
  `customer` int(4) DEFAULT NULL COMMENT 'Identificador del Cliente',
  `line` smallint(2) DEFAULT '1' COMMENT 'Numero de linea de Cuota',
  `item` int(4) NOT NULL COMMENT 'Identificador del Articulo',
  `description` varchar(1024) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion de la Cuota',
  `quantity` double(15,3) DEFAULT '0.000' COMMENT 'Cantidad de la Cuota',
  `price` double DEFAULT '0' COMMENT 'Precio de la Cuota',
  `discount_expr` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descuentos de la Cuota',
  `initial_date` date DEFAULT NULL COMMENT 'Fecha de inicio de la Cuota',
  `final_date` date DEFAULT NULL COMMENT 'Fecha de finalizacion de la Cuota',
  `billing_date` date DEFAULT NULL COMMENT 'Proxima fecha de facturación de la Cuota',
  `period` smallint(2) DEFAULT '1' COMMENT 'Periodo de facturacion en meses de la Cuota',
  `security_level` tinyint(2) DEFAULT '0' COMMENT 'Nivel de seguridad de la Cuota',
  `invoicing_group` int(4) DEFAULT NULL COMMENT 'Identificador de Grupo de Facturacion',
  `seller` int(4) DEFAULT NULL COMMENT 'Identificador de Agente Comercial',
  `workplace` int(4) NOT NULL COMMENT 'Identificador del Centro de Trabajo',
  PRIMARY KEY (`id`),
  KEY `IDX_CUSTOMER_FEE_CUSTOMER` (`customer`),
  KEY `IDX_CUSTOMER_FEE_ITEM` (`item`),
  KEY `IDX_CUSTOMER_FEE_WORKPLACE` (`workplace`),
  KEY `IDX_CUSTOMER_FEE_DOMAIN` (`domain`),
  KEY `IDX_CUSTOMER_FEE_INVOICING_GROUP` (`invoicing_group`),
  KEY `IDX_CUSTOMER_FEE_PROJECT` (`project`),
  KEY `IDX_CUSTOMER_FEE_SELLER` (`seller`),
  CONSTRAINT `FK_CUSTOMER_FEE_CUSTOMER` FOREIGN KEY (`customer`) REFERENCES `customer` (`registry`),
  CONSTRAINT `FK_CUSTOMER_FEE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_CUSTOMER_FEE_INVOICING_GROUP` FOREIGN KEY (`invoicing_group`) REFERENCES `invoicing_group` (`id`),
  CONSTRAINT `FK_CUSTOMER_FEE_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`),
  CONSTRAINT `FK_CUSTOMER_FEE_PROJECT` FOREIGN KEY (`project`) REFERENCES `project` (`id`),
  CONSTRAINT `FK_CUSTOMER_FEE_SELLER` FOREIGN KEY (`seller`) REFERENCES `seller` (`registry`),
  CONSTRAINT `FK_CUSTOMER_FEE_WORKPLACE` FOREIGN KEY (`workplace`) REFERENCES `workplace` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Cuotas de Clientes';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customer_fee`
--

LOCK TABLES `customer_fee` WRITE;
/*!40000 ALTER TABLE `customer_fee` DISABLE KEYS */;
/*!40000 ALTER TABLE `customer_fee` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `daily_tracking`
--

DROP TABLE IF EXISTS `daily_tracking`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `daily_tracking` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Parte',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `task_holder` int(4) NOT NULL COMMENT 'Identificador del Usuario que realiza el Parte',
  `tracking_date` date NOT NULL COMMENT 'Fecha del Parte',
  `tracking_duration` double NOT NULL DEFAULT '0' COMMENT 'Tiempo invertido en el Parte',
  `job_type` int(4) NOT NULL COMMENT 'Tipo de Trabajo realizado en el Parte',
  `registry` int(4) DEFAULT NULL COMMENT 'Identificador del Cliente asociado al Parte',
  `project` int(4) DEFAULT NULL COMMENT 'Identificador del Expediente asociado al Parte',
  `activity_type` int(4) DEFAULT NULL COMMENT 'Identificador de la Actividad asociada al Parte',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios del Parte',
  `task` int(4) DEFAULT NULL COMMENT 'Identificador de la Tarea que provoca el Parte',
  `cost` double DEFAULT '0' COMMENT 'Costo',
  PRIMARY KEY (`id`),
  KEY `IDX_DAILY_TRACKING_ACTIVITY_TYPE` (`activity_type`),
  KEY `IDX_DAILY_TRACKING_JOB_TYPE` (`job_type`),
  KEY `IDX_DAILY_TRACKING_PROJECT` (`project`),
  KEY `IDX_DAILY_TRACKING_REGISTRY` (`registry`),
  KEY `IDX_DAILY_TRACKING_TASK` (`task`),
  KEY `IDX_DAILY_TRACKING_TASK_HOLDER` (`task_holder`),
  KEY `IDX_DAILY_TRACKING_DOMAIN` (`domain`),
  CONSTRAINT `FK_DAILY_TRACKING_ACTIVITY_TYPE` FOREIGN KEY (`activity_type`) REFERENCES `activity_type` (`id`),
  CONSTRAINT `FK_DAILY_TRACKING_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_DAILY_TRACKING_JOB_TYPE` FOREIGN KEY (`job_type`) REFERENCES `job_type` (`id`),
  CONSTRAINT `FK_DAILY_TRACKING_PROJECT` FOREIGN KEY (`project`) REFERENCES `project` (`id`),
  CONSTRAINT `FK_DAILY_TRACKING_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`),
  CONSTRAINT `FK_DAILY_TRACKING_TASK` FOREIGN KEY (`task`) REFERENCES `task` (`id`),
  CONSTRAINT `FK_DAILY_TRACKING_TASK_HOLDER` FOREIGN KEY (`task_holder`) REFERENCES `task_holder` (`registry`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Parte Diario de Trabajo';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `daily_tracking`
--

LOCK TABLES `daily_tracking` WRITE;
/*!40000 ALTER TABLE `daily_tracking` DISABLE KEYS */;
/*!40000 ALTER TABLE `daily_tracking` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `data_attach`
--

DROP TABLE IF EXISTS `data_attach`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `data_attach` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `source` tinyint(2) NOT NULL COMMENT 'Origen',
  `source_id` int(4) DEFAULT NULL COMMENT 'Identificador del origen',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion',
  `data` mediumblob COMMENT 'Archivo Adjunto en binario',
  `type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de Archivo Adjunto',
  `mimeType` tinyint(2) DEFAULT '0' COMMENT 'Mime Type del Archivo Adjunto',
  `drive_id` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Identificador de Google Drive',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_DATA_ATTACH_DOMAIN` (`domain`),
  KEY `IDX_DATA_ATTACH_SOURCE` (`source_id`,`source`),
  CONSTRAINT `FK_DATA_ATTACH_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='DATA ATTACH';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `data_attach`
--

LOCK TABLES `data_attach` WRITE;
/*!40000 ALTER TABLE `data_attach` DISABLE KEYS */;
/*!40000 ALTER TABLE `data_attach` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `data_response`
--

DROP TABLE IF EXISTS `data_response`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `data_response` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `code` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Codigo de referencia',
  `response_date` date DEFAULT NULL COMMENT 'Fecha',
  `source` tinyint(2) NOT NULL COMMENT 'Origen',
  `source_id` int(4) DEFAULT NULL COMMENT 'Identificador del Origen',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_DATA_RESPONSE_DOMAIN` (`domain`),
  CONSTRAINT `FK_DATA_RESPONSE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='DATA RESPONSE';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `data_response`
--

LOCK TABLES `data_response` WRITE;
/*!40000 ALTER TABLE `data_response` DISABLE KEYS */;
/*!40000 ALTER TABLE `data_response` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `data_response_detail`
--

DROP TABLE IF EXISTS `data_response_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `data_response_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `data_response` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador de data_response',
  `data_variable` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Codigo de la variable',
  `data_value` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Valor de la variable',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_DATA_RESPONSE_DETAIL_DOMAIN` (`domain`),
  KEY `IDX_DATA_RESPONSE_DETAIL_DATA_RESPONSE` (`data_response`),
  CONSTRAINT `FK_DATA_RESPONSE_DETAIL_DATA_RESPONSE` FOREIGN KEY (`data_response`) REFERENCES `data_response` (`id`),
  CONSTRAINT `FK_DATA_RESPONSE_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='DATA RESPONSE DETAIL';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `data_response_detail`
--

LOCK TABLES `data_response_detail` WRITE;
/*!40000 ALTER TABLE `data_response_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `data_response_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `db_version`
--

DROP TABLE IF EXISTS `db_version`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `db_version` (
  `version_number` varchar(10) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Numero de Version de la Base de Datos',
  PRIMARY KEY (`version_number`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Version de la Base de Datos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `db_version`
--

LOCK TABLES `db_version` WRITE;
/*!40000 ALTER TABLE `db_version` DISABLE KEYS */;
INSERT INTO `db_version` VALUES ('9.04.0');
/*!40000 ALTER TABLE `db_version` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `deduction_concept`
--

DROP TABLE IF EXISTS `deduction_concept`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `deduction_concept` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `code` varchar(25) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion',
  `type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de Deduccion Salarial',
  `description_decorable` tinyint(2) DEFAULT '0',
  `expression` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Importe',
  PRIMARY KEY (`id`),
  KEY `IDX_DEDUCTION_CONCEPT_DOMAIN` (`domain`),
  CONSTRAINT `FK_DEDUCTION_CONCEPT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=6306 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Conceptos de deducciones';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `deduction_concept`
--

LOCK TABLES `deduction_concept` WRITE;
/*!40000 ALTER TABLE `deduction_concept` DISABLE KEYS */;
INSERT INTO `deduction_concept` VALUES (6296,0,NULL,'EMBARGO',-1,0,NULL),(6297,0,NULL,'ANTICIPO',7,0,NULL),(6298,0,NULL,'VALOR DE PRODUCTOS EN ESPECIE',8,0,NULL),(6299,0,'CGC','Contingencias Comunes',0,0,NULL),(6300,0,'ATEP','Accidentes de Trabajo y Enfermedades Profesionales',1,0,NULL),(6301,0,'DESMPL','Desempleo',2,0,NULL),(6302,0,'FP','Formación Profesional',3,0,NULL),(6303,0,'ESTR','Horas extraordinarias fuerza mayor',4,0,NULL),(6304,0,'NESTR','Resto horas extraordinarias',5,0,NULL),(6305,0,'IRPF','IRPF',6,0,NULL);
/*!40000 ALTER TABLE `deduction_concept` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `delivery`
--

DROP TABLE IF EXISTS `delivery`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `delivery` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Albaran de Venta',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `project` int(4) DEFAULT NULL COMMENT 'Identificador del Proyecto',
  `series` char(5) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Serie del Albaran',
  `number` int(4) NOT NULL DEFAULT '0' COMMENT 'Numero del Albaran',
  `customer` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador del Cliente',
  `address` int(4) DEFAULT NULL COMMENT 'Identificador de la Direccion de envio del Albaran',
  `issue_time` datetime DEFAULT NULL COMMENT 'Fecha de emision del Albaran',
  `pay_method` int(4) DEFAULT NULL COMMENT 'Identificador de la Forma de Pago',
  `security_level` tinyint(2) DEFAULT '0' COMMENT 'Nivel de seguridad del Albaran',
  `status` tinyint(2) DEFAULT '0' COMMENT 'Estado del Albaran',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios del Albaran',
  `remarks` text COLLATE latin1_spanish_ci COMMENT 'Observaciones del Albaran',
  `workplace` int(4) DEFAULT NULL COMMENT 'Identificador del Centro de Trabajo',
  `scope` int(4) NOT NULL DEFAULT '1' COMMENT 'Ambito del Albaran',
  `number_of_pymnts` smallint(2) DEFAULT '0' COMMENT 'Numero de Vencimientos',
  `days_to_first_pymnt` smallint(2) DEFAULT '0' COMMENT 'Dias al primer Vencimiento',
  `days_between_pymnts` smallint(2) DEFAULT '0' COMMENT 'Dias entre Vencimientos',
  `pymnt_days` varchar(8) COLLATE latin1_spanish_ci DEFAULT '0' COMMENT 'Dias de pago',
  `bank_account` varchar(34) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'IBAN - Numero de Cuenta Bancaria Internacional',
  `bank_alias` varchar(25) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Alias del Banco',
  `bic` varchar(11) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'BIC - Codigo Identificador del Banco',
  `carrier` int(4) DEFAULT NULL COMMENT 'Identificador de la agencia de transporte',
  `carrier_packing` int(4) DEFAULT NULL COMMENT 'Identificador de la Hoja de ruta',
  `number_plate` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de matricula',
  `driver` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre del conductor',
  `driver_document` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de Documento del conductor',
  `total_packages` double(15,3) DEFAULT '0.000' COMMENT 'Numero total de bultos',
  `total_weight` double(15,3) DEFAULT '0.000' COMMENT 'Peso total',
  `shipping_alternative_address` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Primera parte de la Direccion de entrega',
  `shipping_alternative_address2` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Segunda parte de la Direccion de entrega',
  `shipping_alternative_zip` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo Postal de entrega',
  `shipping_alternative_city` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Localidad de entrega',
  `shipping_alternative_phone` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Telefono de contacto de la entrega',
  `shipping_alternative_recipient` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Destinatario de la entrega',
  `shipping_contact` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre del contacto para la entrega',
  `shipping_period` tinyint(2) DEFAULT '0' COMMENT 'Tipo de periodo de entrega',
  `tracking_number` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de expedicion',
  `shipping_status` tinyint(2) DEFAULT '0' COMMENT 'Estado de la entrega',
  `status_modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion del estado',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  UNIQUE KEY `IDX_UNQ_DELIVERY_DOMAIN_SERIES_NUMBER` (`domain`,`series`,`number`),
  KEY `IDX_DELIVERY_WORKPLACE` (`workplace`),
  KEY `IDX_DELIVERY_SCOPE` (`scope`),
  KEY `IDX_DELIVERY_PROJECT` (`project`),
  KEY `IDX_DELIVERY_ISSUE_TIME` (`issue_time`),
  KEY `IDX_DELIVERY_CUSTOMER` (`customer`),
  KEY `IDX_DELIVERY_RADDRESS` (`address`),
  KEY `IDX_DELIVERY_PAY_METHOD` (`pay_method`),
  KEY `IDX_DELIVERY_DOMAIN` (`domain`),
  KEY `IDX_DELIVERY_CARRIER` (`carrier`),
  CONSTRAINT `FK_DELIVERY_CARRIER` FOREIGN KEY (`carrier`) REFERENCES `carrier` (`registry`),
  CONSTRAINT `FK_DELIVERY_CUSTOMER` FOREIGN KEY (`customer`) REFERENCES `customer` (`registry`),
  CONSTRAINT `FK_DELIVERY_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_DELIVERY_PAY_METHOD` FOREIGN KEY (`pay_method`) REFERENCES `pay_method` (`id`),
  CONSTRAINT `FK_DELIVERY_PROJECT` FOREIGN KEY (`project`) REFERENCES `project` (`id`),
  CONSTRAINT `FK_DELIVERY_RADDRESS` FOREIGN KEY (`address`) REFERENCES `raddress` (`id`),
  CONSTRAINT `FK_DELIVERY_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`),
  CONSTRAINT `FK_DELIVERY_WORKPLACE` FOREIGN KEY (`workplace`) REFERENCES `workplace` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Albaranes de Venta';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `delivery`
--

LOCK TABLES `delivery` WRITE;
/*!40000 ALTER TABLE `delivery` DISABLE KEYS */;
/*!40000 ALTER TABLE `delivery` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `delivery_detail`
--

DROP TABLE IF EXISTS `delivery_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `delivery_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Detalle del Albaran de Venta',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `delivery` int(4) NOT NULL COMMENT 'Identificador del Albaran de Venta',
  `line` smallint(2) DEFAULT '1' COMMENT 'Numero de linea del Detalle dentro del Albaran',
  `item` int(4) NOT NULL COMMENT 'Identificador del Articulo del Detalle de Albaran',
  `description` varchar(1024) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion del Detalle de Albaran',
  `warehouse` int(4) NOT NULL COMMENT 'Identificador del Almacen',
  `quantity` double(15,3) DEFAULT NULL COMMENT 'Cantidad del Detalle de Albaran',
  `price` double DEFAULT '0' COMMENT 'Precio del Detalle de Albaran',
  `discount_expr` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descuentos del Detalle de Albaran',
  `sales_detail` int(4) DEFAULT NULL COMMENT 'Identificador del Detalle del Pedido de Venta asociado',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_DELIVERY_DETAIL_DELIVERY` (`delivery`),
  KEY `IDX_DELIVERY_DETAIL_WAREHOUSE` (`warehouse`),
  KEY `IDX_DELIVERY_DETAIL_ITEM` (`item`),
  KEY `IDX_DELIVERY_DETAIL_SALES_DETAIL` (`sales_detail`),
  KEY `IDX_DELIVERY_DETAIL_DOMAIN` (`domain`),
  CONSTRAINT `FK_DELIVERY_DETAIL_DELIVERY` FOREIGN KEY (`delivery`) REFERENCES `delivery` (`id`),
  CONSTRAINT `FK_DELIVERY_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_DELIVERY_DETAIL_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`),
  CONSTRAINT `FK_DELIVERY_DETAIL_SALES_DETAIL` FOREIGN KEY (`sales_detail`) REFERENCES `sales_detail` (`id`),
  CONSTRAINT `FK_DELIVERY_DETAIL_WAREHOUSE` FOREIGN KEY (`warehouse`) REFERENCES `warehouse` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalles del Albaran de Venta';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `delivery_detail`
--

LOCK TABLES `delivery_detail` WRITE;
/*!40000 ALTER TABLE `delivery_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `delivery_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `department`
--

DROP TABLE IF EXISTS `department`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `department` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre del Departamento',
  PRIMARY KEY (`id`),
  KEY `IDX_DEPARTMENT_DOMAIN` (`domain`),
  CONSTRAINT `FK_DEPARTMENT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Departamentos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `department`
--

LOCK TABLES `department` WRITE;
/*!40000 ALTER TABLE `department` DISABLE KEYS */;
/*!40000 ALTER TABLE `department` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `domain`
--

DROP TABLE IF EXISTS `domain`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `domain` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `name` varchar(253) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre del Dominio',
  `description` varchar(128) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion del Dominio',
  `parent` int(4) DEFAULT NULL COMMENT 'Identificador del Dominio padre',
  `type` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Tipo de Dominio',
  `scope` int(4) DEFAULT NULL COMMENT 'Identificador del Ambito',
  `subDomainSuffix` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Sufijo de los Dominio Hijo',
  `enableHeredity` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indica si el Dominio tiene deshabilitado la herencia de registros o no',
  `domainManagement` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indica si el Dominio tiene capacidad de MultiDominio o no',
  `disableDomainManagement` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indica si el Dominio tiene deshabilitado el mantenimiento de Dominios o no',
  `maxDocumentSize` int(4) DEFAULT NULL COMMENT 'Tamao Maximo de los Documentos',
  `maxTotalDocumentSize` int(4) DEFAULT NULL COMMENT 'Almacenamiento Documental Contratado',
  `maxDefinedUsers` int(4) DEFAULT NULL COMMENT 'Numero Maximo de Usuarios',
  `active` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'Indica si el Dominio esta activo o no',
  `owner` varchar(256) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Emails del creador del Dominio',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  `expirationDate` date DEFAULT NULL COMMENT 'Fecha de Expiracion del Dominio',
  `lastAccess_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de ultimo acceso',
  `lastAccess_date` datetime DEFAULT NULL COMMENT 'Fecha de ultimo acceso',
  PRIMARY KEY (`id`),
  UNIQUE KEY `IDX_UNQ_DOMAIN_NAME` (`name`),
  KEY `IDX_DOMAIN_PARENT` (`parent`),
  KEY `IDX_DOMAIN_SCOPE` (`scope`),
  CONSTRAINT `FK_DOMAIN_PARENT` FOREIGN KEY (`parent`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_DOMAIN_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=8789 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Dominios';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `domain`
--

LOCK TABLES `domain` WRITE;
/*!40000 ALTER TABLE `domain` DISABLE KEYS */;
INSERT INTO `domain` VALUES (0,'admin-test.aonsolutions.org','Consola de ADMINISTRACION (BBDD:PRODUCCION)',NULL,5,NULL,NULL,0,0,0,1,100,5,1,'admin@aonsolutions.org',NULL,'2016-02-18 08:44:47',NULL,NULL,NULL,'admin','2016-11-24 08:27:31'),(8776,'payroll-test.aonsolutions.org','PAYROLL TEST',NULL,1,NULL,'payroll-test.aonsolutions.org',0,1,0,1,100,1,1,'payroll@aonsolutions.org','admin','2016-02-18 10:42:31','admin','2016-02-18 10:47:09',NULL,'admin','2017-09-11 09:59:50'),(8777,'general-payroll-test.aonsolutions.org','RÉGIMEN GENERAL ',8776,0,3535,NULL,1,0,0,1,100,0,1,'payroll@aonsolutions.org','admin','2016-02-18 10:56:49',NULL,NULL,NULL,'admin','2017-09-11 11:16:13'),(8778,'trainning-payroll-test.aonsolutions.org','FORMACIÓN Y APRENDIZAJE',8776,0,NULL,NULL,1,0,0,1,100,0,1,'payroll@aonsolutions.org','admin','2016-02-21 23:49:19',NULL,NULL,NULL,'admin','2017-03-10 10:31:45'),(8779,'doc-test.aonsolutions.org','DOCUMENTAL TEST',NULL,1,NULL,'doc-test.aonsolutions.org',0,1,0,1,100,0,1,'doc@aonsolutions.org','admin','2016-02-22 11:29:06',NULL,NULL,NULL,NULL,NULL),(8780,'agrarian-payroll-test.aonsolutions.org','RÉGIMEN ESPECIAL AGRARIO',8776,0,NULL,NULL,1,0,0,1,100,0,1,'agrarian@aonsolutions.org','admin','2016-02-23 11:32:44',NULL,NULL,NULL,'admin','2017-08-03 11:15:07'),(8781,'inactiva-payroll-test.aonsolutions.org','INACTIVA',8776,0,3535,NULL,1,0,0,1,100,0,0,'info@aonolsutions.org','admin','2016-04-20 15:26:58',NULL,NULL,NULL,'admin','2016-04-20 16:16:22'),(8782,'artistas-payroll-test.aonsolutions.org','ARTISTAS',8776,0,3535,NULL,1,0,0,1,100,0,1,'info@aonsolutions.org','admin','2016-04-21 10:38:45',NULL,NULL,NULL,'admin','2016-04-21 10:40:05'),(8783,'convenios-payroll-test.aonsolutions.org','CONVENIOS COLECTIVOS',8776,0,NULL,NULL,1,0,0,1,100,0,1,'info@aonsolutions.org','admin','2016-05-06 10:19:48',NULL,NULL,NULL,'admin','2016-06-07 11:07:43'),(8784,'hosteleria-baleares-payroll-test.aonsolutions.org','HOSTELERÍA ISLAS BALEARES',8776,0,3535,NULL,1,0,0,1,100,0,1,'info@aonsolutions.org','admin','2016-05-18 15:06:04',NULL,NULL,NULL,'admin','2016-05-18 15:06:13'),(8785,'calendar-payroll-test.aonsolutions.org','CALENDARIOS DE EMPRESA',8776,0,3535,NULL,1,0,0,1,100,0,1,'info@aonsolutions.org','admin','2016-06-06 17:41:19',NULL,NULL,NULL,'admin','2016-06-21 16:28:23'),(8787,'metal-payroll-test.aonsolutions.org','COMERCIO DEL METAL MADRID',8776,0,3535,NULL,1,0,0,1,100,0,1,'info@aonsolutions.org','admin','2016-09-29 18:41:07',NULL,NULL,NULL,'admin','2016-10-27 16:08:55'),(8788,'creta-payroll-test.aonsolutions.org','SISTEMA DE LIQUIDACIÓN DIRECTA (CRET@)',8776,0,3535,NULL,1,0,0,1,100,0,1,'info@test.aonsolutions.org','admin','2016-12-19 11:11:09',NULL,NULL,NULL,'admin','2017-02-17 14:38:06');
/*!40000 ALTER TABLE `domain` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `domain_application`
--

DROP TABLE IF EXISTS `domain_application`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `domain_application` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `application` int(4) NOT NULL COMMENT 'Identificador de la Aplicacion',
  `active` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'Indica si la Aplicacion del Dominio esta activa o no',
  `audit_level` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Nivel de auditoria',
  PRIMARY KEY (`id`),
  UNIQUE KEY `IDX_UNQ_DOMAIN_APPLICATION` (`domain`,`application`),
  KEY `IDX_APPLICATION_DOMAIN` (`domain`),
  KEY `IDX_DOMAIN_APPLICATION_APPLICATION` (`application`),
  CONSTRAINT `FK_APPLICATION_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_DOMAIN_APPLICATION_APPLICATION` FOREIGN KEY (`application`) REFERENCES `application` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=10051 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Aplicacion web';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `domain_application`
--

LOCK TABLES `domain_application` WRITE;
/*!40000 ALTER TABLE `domain_application` DISABLE KEYS */;
INSERT INTO `domain_application` VALUES (3055,0,28,1,0),(10038,8776,28,1,0),(10039,8777,28,1,0),(10040,8778,28,1,0),(10041,8779,28,1,0),(10042,8780,28,1,0),(10043,8781,28,1,0),(10044,8782,28,1,0),(10045,8783,28,1,0),(10046,8784,28,1,0),(10047,8785,28,1,0),(10049,8787,28,1,0),(10050,8788,28,1,0);
/*!40000 ALTER TABLE `domain_application` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `domain_application_module`
--

DROP TABLE IF EXISTS `domain_application_module`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `domain_application_module` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `domain_application` int(4) NOT NULL COMMENT 'Identificador de la Aplicacion del Dominio',
  `module` tinyint(2) NOT NULL COMMENT 'Modulo de la Aplicacion del Dominio',
  PRIMARY KEY (`id`),
  KEY `IDX_DOMAIN_APPLICATION_MODULE_DOMAIN_APPLICATION` (`domain_application`),
  KEY `IDX_DOMAIN_APPLICATION_MODULE_DOMAIN` (`domain`),
  CONSTRAINT `FK_DOMAIN_APPLICATION_MODULE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_DOMAIN_APPLICATION_MODULE_DOMAIN_APPLICATION` FOREIGN KEY (`domain_application`) REFERENCES `domain_application` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=32072 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Modulos de las Aplicaciones del Dominio';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `domain_application_module`
--

LOCK TABLES `domain_application_module` WRITE;
/*!40000 ALTER TABLE `domain_application_module` DISABLE KEYS */;
INSERT INTO `domain_application_module` VALUES (17747,0,6628,19),(17749,0,6631,19),(17770,0,6646,19),(32056,8776,10038,8),(32057,8777,10039,19),(32058,8778,10040,19),(32059,8780,10042,19),(32060,8781,10043,19),(32061,8782,10044,19),(32062,8783,10045,19),(32063,8784,10046,19),(32064,8785,10047,19),(32067,0,3055,8),(32068,0,3055,9),(32070,8787,10049,19),(32071,8788,10050,19);
/*!40000 ALTER TABLE `domain_application_module` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `domain_gserviceaccount`
--

DROP TABLE IF EXISTS `domain_gserviceaccount`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `domain_gserviceaccount` (
  `client_id` varchar(100) COLLATE latin1_spanish_ci NOT NULL,
  `email_address` varchar(100) COLLATE latin1_spanish_ci DEFAULT NULL,
  `public_key` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL,
  `private_key` mediumblob,
  `client_secret` mediumblob,
  `domain` int(4) DEFAULT NULL,
  `size` double DEFAULT '0',
  `limit` double DEFAULT '0',
  `google_account` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL,
  PRIMARY KEY (`client_id`),
  KEY `FK_DOMAIN_GSERVICEACCOUNT_DOMAIN_IDX` (`domain`),
  CONSTRAINT `FK_DOMAIN_GSERVICEACCOUNT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `domain_gserviceaccount`
--

LOCK TABLES `domain_gserviceaccount` WRITE;
/*!40000 ALTER TABLE `domain_gserviceaccount` DISABLE KEYS */;
INSERT INTO `domain_gserviceaccount` VALUES ('822373337462-mjs4n8jn7nj6eimdm2bfd9hrkhakdutb.apps.googleusercontent.com','822373337462-mjs4n8jn7nj6eimdm2bfd9hrkhakdutb@developer.gserviceaccount.com','3c86e9029ecbecf28917e4df66373ac0cdddd56c','00z	*H\rkg0c0(	*H\r00\r*H\r\n00(\n*H\r0\Z~/ߟDlYP%-S\0\\r2φk<	K~u|et?5PGQLE:_,LEX>C]K\rxHiRl֩SMt~B5&yHnEtW.V$N˩sRDe$M\ZTQwF%q^JNf\Z	>r2!Rݸ%T+*\"F9V\n$A1 ̓Da[)R68.\Zo B=ȟaj/rwO\rF\0lmjN6AnHKSV\"]?c\r&F)DXnʔп~֝ؽ|\Z9Y_5fBp}VC=3-$BFR_fb\ZHTa ö12Z@/7K2|\rUQ}\ZjXtAl0L/OV?q=!ƒOf\"Q-D_RIP|T1O$?TzL,#ՏK|jxO\Zxb(BË9\"\ZRR&yY]j459ğԀluݰ+I``HqD\nU+M.Dph)HK7\01H0#	*H\r	1\0p\0r\0i\0v\0a\0t\0e\0k\0e\0y0!	*H\r	1Time 141267611991003	*H\r$0 \00	*H\r0(\n*H\r0\Z\'y[es3\0Ɛ-w⡿F\"$;oc㘐IBtSJˣ捦-&7X5:ǒCQ6l:҅B덞.v1U\\L40b\nּ&u6U6-\0UsOP]h7&~ ,IGr09k!tjDįŪ)f0ZaC60fTfCAo5>+d/ɧ|20\\`=3JIi>$v\nV:dM:]Y$OBG׈BXiuM@-lҊc/}~cٗKoO\'-IYկb9BnQNb=hJğeBO\\%\0pjkCGިGe^:=0E+\r濵Div\\󄕵f:\Z/l±qPplO:P0B5\r}efO]Op$f1G|Dv.n\'&B-V3_> =:KQ{~;NGqua#w#(J\Z{.Z\r[b	i,\rf%eXY)\'8@EP!UA2k&eV;שE>fgKSڈsZ3Žuo@\nkKlh_>ul\\>S)_Pv	9HĪ7̺[0=0!0	+\Z\0Bkhq\\ofRtW@UVDۛ\"-\"x\0',NULL,0,0,0,'aio@aonsolutions.net');
/*!40000 ALTER TABLE `domain_gserviceaccount` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `elaboration`
--

DROP TABLE IF EXISTS `elaboration`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `elaboration` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la elaboracion',
  `domain` int(4) NOT NULL COMMENT 'Identificador del dominio',
  `series` char(5) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Serie de la elaboracion',
  `number` int(4) NOT NULL DEFAULT '0' COMMENT 'Numero de la elaboracion',
  `date` datetime DEFAULT NULL COMMENT 'Fecha de elaboracion',
  `item` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador del articulo base a elaborar',
  `description` varchar(1024) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion',
  `warehouse` int(4) DEFAULT NULL COMMENT 'Identificador del almacen',
  `quantity` double(15,3) DEFAULT '0.000' COMMENT 'Cantidad a elaborar',
  `status` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Indica el estado de la elaboracion',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios',
  `remarks` text COLLATE latin1_spanish_ci COMMENT 'Observaciones',
  `source` tinyint(2) DEFAULT '0' COMMENT 'Origen',
  `source_id` int(4) DEFAULT '0' COMMENT 'Identificador del origen',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_ELABORATION_DOMAIN` (`domain`),
  KEY `IDX_ELABORATION_ITEM` (`item`),
  KEY `IDX_ELABORATION_WAREHOUSE` (`warehouse`),
  CONSTRAINT `FK_ELABORATION_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_ELABORATION_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`),
  CONSTRAINT `FK_ELABORATION_WAREHOUSE` FOREIGN KEY (`warehouse`) REFERENCES `warehouse` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Ordenes de elaboracion';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `elaboration`
--

LOCK TABLES `elaboration` WRITE;
/*!40000 ALTER TABLE `elaboration` DISABLE KEYS */;
/*!40000 ALTER TABLE `elaboration` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `elaboration_detail`
--

DROP TABLE IF EXISTS `elaboration_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `elaboration_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del detalle',
  `domain` int(4) NOT NULL COMMENT 'Identificador del dominio',
  `elaboration` int(4) NOT NULL COMMENT 'Identificador de la elaboracion',
  `date` datetime DEFAULT NULL COMMENT 'Fecha de elaboracion',
  `item` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador del articulo no base elaborado',
  `quantity` double(15,3) DEFAULT '0.000' COMMENT 'Cantidad elaborado',
  `warehouse` int(4) DEFAULT NULL COMMENT 'Identificador del almacen',
  `add_info` text COLLATE latin1_spanish_ci COMMENT 'Informacion de uso interno',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_ELABORATION_DETAIL_DOMAIN` (`domain`),
  KEY `IDX_ELABORATION_DETAIL_ELABORATION` (`elaboration`),
  KEY `IDX_ELABORATION_DETAIL_ITEM` (`item`),
  KEY `IDX_ELABORATION_DETAIL_WAREHOUSE` (`warehouse`),
  CONSTRAINT `FK_ELABORATION_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_ELABORATION_DETAIL_ELABORATION` FOREIGN KEY (`elaboration`) REFERENCES `elaboration` (`id`),
  CONSTRAINT `FK_ELABORATION_DETAIL_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`),
  CONSTRAINT `FK_ELABORATION_DETAIL_WAREHOUSE` FOREIGN KEY (`warehouse`) REFERENCES `warehouse` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalle de ordenes de elaboracion';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `elaboration_detail`
--

LOCK TABLES `elaboration_detail` WRITE;
/*!40000 ALTER TABLE `elaboration_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `elaboration_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `elaboration_detail_composition`
--

DROP TABLE IF EXISTS `elaboration_detail_composition`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `elaboration_detail_composition` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la composicion',
  `domain` int(4) NOT NULL COMMENT 'Identificador del dominio',
  `elaboration_detail` int(4) NOT NULL COMMENT 'Identificador del lote elaborado',
  `item` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador del articulo no base utilizado',
  `quantity` double(15,3) DEFAULT '0.000' COMMENT 'Cantidad utilizada',
  `warehouse` int(4) DEFAULT NULL COMMENT 'Identificador del almacen',
  `add_info` text COLLATE latin1_spanish_ci COMMENT 'Informacion de uso interno',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_ELABORATION_DETAIL_COMPOSITION_DOMAIN` (`domain`),
  KEY `IDX_ELABORATION_DETAIL_COMPOSITION_ELABORATION_DETAIL` (`elaboration_detail`),
  KEY `IDX_ELABORATION_DETAIL_COMPOSITION_ITEM` (`item`),
  KEY `IDX_ELABORATION_DETAIL_COMPOSITION_WAREHOUSE` (`warehouse`),
  CONSTRAINT `FK_ELABORATION_DETAIL_COMPOSITION_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_ELABORATION_DETAIL_COMPOSITION_ELABORATION_DETAIL` FOREIGN KEY (`elaboration_detail`) REFERENCES `elaboration_detail` (`id`),
  CONSTRAINT `FK_ELABORATION_DETAIL_COMPOSITION_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`),
  CONSTRAINT `FK_ELABORATION_DETAIL_COMPOSITION_WAREHOUSE` FOREIGN KEY (`warehouse`) REFERENCES `warehouse` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Composicion de ordenes de elaboracion';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `elaboration_detail_composition`
--

LOCK TABLES `elaboration_detail_composition` WRITE;
/*!40000 ALTER TABLE `elaboration_detail_composition` DISABLE KEYS */;
/*!40000 ALTER TABLE `elaboration_detail_composition` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `enterprise`
--

DROP TABLE IF EXISTS `enterprise`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `enterprise` (
  `registry` int(4) NOT NULL DEFAULT '1' COMMENT 'Registro de la Empresa',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `scope` int(4) NOT NULL COMMENT 'Identificador del Ambito',
  `calendar` int(4) DEFAULT NULL COMMENT 'Calendario',
  PRIMARY KEY (`registry`),
  KEY `IDX_ENTERPRISE_SCOPE` (`scope`),
  KEY `IDX_ENTERPRISE_CALENDAR` (`calendar`),
  KEY `IDX_ENTERPRISE_DOMAIN` (`domain`),
  CONSTRAINT `FK_ENTERPRISE_CALENDAR` FOREIGN KEY (`calendar`) REFERENCES `calendar` (`id`),
  CONSTRAINT `FK_ENTERPRISE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_ENTERPRISE_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`),
  CONSTRAINT `FK_ENTERPRISE_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Empresa';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `enterprise`
--

LOCK TABLES `enterprise` WRITE;
/*!40000 ALTER TABLE `enterprise` DISABLE KEYS */;
INSERT INTO `enterprise` VALUES (8628387,8776,3535,NULL),(8628388,8777,3535,NULL),(8628397,8778,3535,NULL),(8628405,8779,3538,NULL),(8628412,8780,3535,NULL),(8628439,8781,3535,NULL),(8628443,8782,3535,NULL),(8628451,8783,3535,NULL),(8628463,8784,3535,NULL),(8628474,8785,3535,NULL),(8628500,8787,3535,NULL),(8628519,8788,3535,NULL);
/*!40000 ALTER TABLE `enterprise` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `enterprise_activity`
--

DROP TABLE IF EXISTS `enterprise_activity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `enterprise_activity` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `description` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion de la Actividad de la Empresa',
  `enterprise` int(4) NOT NULL COMMENT 'Identificador de la Empresa',
  `iae` int(4) DEFAULT NULL COMMENT 'Epigrafe IAE',
  `cnae` int(4) DEFAULT NULL COMMENT 'Identificador del CNAE',
  `type` tinyint(2) NOT NULL COMMENT 'Tipo de Actividad de la Empresa',
  `cnae2009` int(4) DEFAULT NULL COMMENT 'Identificador del CNAE 2009',
  `surcharge` tinyint(1) DEFAULT '0' COMMENT 'Indica si la Actividad tiene de recargo de equivalencia',
  `vat_tax` int(4) DEFAULT NULL COMMENT 'Identificador del IVA por defecto',
  `retention_tax` int(4) DEFAULT NULL COMMENT 'Identificador del IRPF por defecto',
  `vat_regime` tinyint(2) DEFAULT NULL COMMENT 'Regimen de IVA',
  `retention_regime` tinyint(2) DEFAULT NULL COMMENT 'Regimen de IRPF',
  `start_date` date DEFAULT NULL COMMENT 'Fecha de inicio',
  `end_date` date DEFAULT NULL COMMENT 'Fecha de fin',
  `prorata` double(5,2) DEFAULT '100.00' COMMENT 'Porcentaje de prorrata',
  `prorata_type` tinyint(1) DEFAULT '0' COMMENT 'Indica el tipo de prorrata',
  `principal` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indica si es la Actividad principal',
  PRIMARY KEY (`id`),
  KEY `IDX_ENTERPRISE_ACTIVITY_ENTERPRISE` (`enterprise`),
  KEY `IDX_ENTERPRISE_ACTIVITY_CNAE` (`cnae`),
  KEY `IDX_ENTERPRISE_ACTIVITY_CNAE2009` (`cnae2009`),
  KEY `IDX_ENTERPRISE_ACTIVITY_DOMAIN` (`domain`),
  KEY `IDX_ENTERPRISE_ACTIVITY_IAE` (`iae`),
  KEY `IDX_ENTERPRISE_ACTIVITY_TAX_VAT` (`vat_tax`),
  KEY `IDX_ENTERPRISE_ACTIVITY_TAX_RETENTION` (`retention_tax`),
  CONSTRAINT `FK_ENTERPRISE_ACTIVITY_CNAE` FOREIGN KEY (`cnae`) REFERENCES `cnae` (`id`),
  CONSTRAINT `FK_ENTERPRISE_ACTIVITY_CNAE2009` FOREIGN KEY (`cnae2009`) REFERENCES `cnae2009` (`id`),
  CONSTRAINT `FK_ENTERPRISE_ACTIVITY_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_ENTERPRISE_ACTIVITY_ENTERPRISE` FOREIGN KEY (`enterprise`) REFERENCES `enterprise` (`registry`),
  CONSTRAINT `FK_ENTERPRISE_ACTIVITY_IAE` FOREIGN KEY (`iae`) REFERENCES `iae` (`id`),
  CONSTRAINT `FK_ENTERPRISE_ACTIVITY_TAX_RETENTION` FOREIGN KEY (`retention_tax`) REFERENCES `tax` (`id`),
  CONSTRAINT `FK_ENTERPRISE_ACTIVITY_TAX_VAT` FOREIGN KEY (`vat_tax`) REFERENCES `tax` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1457 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Actividades de Empresas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `enterprise_activity`
--

LOCK TABLES `enterprise_activity` WRITE;
/*!40000 ALTER TABLE `enterprise_activity` DISABLE KEYS */;
INSERT INTO `enterprise_activity` VALUES (1447,8777,'OFICINAS Y DESPACHOS',8628388,NULL,NULL,0,6201,0,NULL,NULL,0,0,NULL,NULL,0.00,0,1),(1448,8778,'FORMACIÓN Y APRENDIZAJE',8628397,991,NULL,0,6201,0,NULL,NULL,0,0,NULL,NULL,0.00,0,1),(1449,8780,'RÉGIMEN ESPECIAL AGRARIO',8628412,816,NULL,0,100001,0,NULL,NULL,0,0,NULL,NULL,0.00,0,1),(1450,8781,'PROGRAMACIÓN',8628439,991,NULL,0,6201,0,NULL,NULL,0,0,NULL,NULL,0.00,0,1),(1451,8782,'TREATRO, CIRCO, MÚSICA',8628443,1047,NULL,0,9001,0,NULL,NULL,0,0,NULL,NULL,0.00,0,1),(1452,8783,'OFICINAS Y DESPACHOS',8628451,771,NULL,0,82,0,NULL,NULL,0,0,NULL,NULL,0.00,0,1),(1453,8784,'HOSTELERIA',8628463,656,NULL,0,551,0,NULL,NULL,0,0,NULL,NULL,0.00,0,0),(1454,8785,'AREONÁUTICA',8628474,946,NULL,0,3030,0,NULL,NULL,0,0,NULL,NULL,0.00,0,1),(1455,8787,'COMERCIO DEL METAL',8628500,167,NULL,0,4672,0,NULL,NULL,0,0,NULL,NULL,0.00,0,1),(1456,8788,'MOTOS y BICICLETAS',8628519,273,NULL,0,4540,0,NULL,NULL,0,0,'2016-01-01',NULL,0.00,0,1);
/*!40000 ALTER TABLE `enterprise_activity` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `enterprise_ccc`
--

DROP TABLE IF EXISTS `enterprise_ccc`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `enterprise_ccc` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `ccc` char(11) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Valor del Codigo Cuenta Cotizacion',
  `type` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Tipo de Cuenta Cotizacion',
  `enterprise_activity` int(4) NOT NULL COMMENT 'Identificador de la Actividad de Empresa',
  `geozone` int(4) DEFAULT NULL COMMENT 'Identificador de la Zona Geografica',
  PRIMARY KEY (`id`),
  KEY `IDX_ENTERPRISE_CCC_ENTERPRISE_ACTIVITY` (`enterprise_activity`),
  KEY `IDX_ENTERPRISE_CCC_GEOZONE` (`geozone`),
  KEY `IDX_ENTERPRISE_CCC_DOMAIN` (`domain`),
  CONSTRAINT `FK_ENTERPRISE_CCC_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_ENTERPRISE_CCC_ENTERPRISE_ACTIVITY` FOREIGN KEY (`enterprise_activity`) REFERENCES `enterprise_activity` (`id`),
  CONSTRAINT `FK_ENTERPRISE_CCC_GEOZONE` FOREIGN KEY (`geozone`) REFERENCES `geozone` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1176 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Codigo Cuenta Cotizacion';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `enterprise_ccc`
--

LOCK TABLES `enterprise_ccc` WRITE;
/*!40000 ALTER TABLE `enterprise_ccc` DISABLE KEYS */;
INSERT INTO `enterprise_ccc` VALUES (1162,8777,'00000000000',0,1447,133890),(1163,8778,'00000000000',1,1448,133890),(1164,8777,'00000000000',0,1447,133937),(1165,8777,'00000000000',0,1447,133909),(1166,8777,'00000000000',0,1447,133917),(1167,8778,'00000000000',5,1448,133890),(1168,8780,'00000000000',7,1449,133890),(1169,8781,'00000000000',0,1450,133917),(1170,8783,'00000000000',0,1452,133937),(1171,8784,'00000000000',0,1453,133896),(1172,8785,'00000000000',0,1454,133890),(1173,8787,'00000000000',0,1455,133904),(1174,8787,'00000000000',0,1455,133917),(1175,8788,'66666666666',0,1456,133897);
/*!40000 ALTER TABLE `enterprise_ccc` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `enterprise_data`
--

DROP TABLE IF EXISTS `enterprise_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `enterprise_data` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `enterprise` int(4) NOT NULL COMMENT 'Identificador de Empresa',
  `name` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre',
  `expression` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Expresion',
  `start_date` date DEFAULT NULL COMMENT 'Fecha de inicio',
  `end_date` date DEFAULT NULL COMMENT 'Fecha de finalizacion',
  PRIMARY KEY (`id`),
  KEY `IDX_ENTERPRISE_DATA_ENTERPRISE` (`enterprise`),
  KEY `IDX_ENTERPRISE_DATA_DOMAIN` (`domain`),
  CONSTRAINT `FK_ENTERPRISE_DATA_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_ENTERPRISE_DATA_ENTERPRISE` FOREIGN KEY (`enterprise`) REFERENCES `enterprise` (`registry`)
) ENGINE=InnoDB AUTO_INCREMENT=15 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Contexto de la Empresa';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `enterprise_data`
--

LOCK TABLES `enterprise_data` WRITE;
/*!40000 ALTER TABLE `enterprise_data` DISABLE KEYS */;
INSERT INTO `enterprise_data` VALUES (1,8777,8628388,'PAY_REPORT_additional_salary_PAY',NULL,NULL,NULL),(2,8777,8628388,'PAY_REPORT_enterpriseSalary_PAY','salaryExpense',NULL,NULL),(3,8777,8628388,'PAY_REPORT_salaryDraft_PAY','salaryDraft_invoiceSimple',NULL,NULL),(4,8777,8628388,'PAY_REPORT_salary_PAY','salary_invoiceSimple',NULL,NULL),(5,8777,8628388,'PAY_salarySendingMethod_PAY','EMAIL',NULL,NULL),(6,8777,8628388,'PAY_salarySending_email_PAY','',NULL,NULL),(7,8783,8628451,'PAY_REPORT_additional_salary_PAY',NULL,NULL,NULL),(8,8783,8628451,'PAY_REPORT_enterpriseSalary_PAY','salaryExpense',NULL,NULL),(9,8783,8628451,'PAY_REPORT_salaryDraft_PAY','salaryDraft',NULL,NULL),(10,8783,8628451,'PAY_REPORT_salary_PAY','salary',NULL,NULL),(11,8783,8628451,'PAY_salarySendingMethod_PAY','EMAIL',NULL,NULL),(12,8783,8628451,'PAY_salarySending_email_PAY','',NULL,NULL),(14,8783,8628451,'agreement','-1164',NULL,NULL);
/*!40000 ALTER TABLE `enterprise_data` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `evaluation_observation`
--

DROP TABLE IF EXISTS `evaluation_observation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `evaluation_observation` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL DEFAULT '1' COMMENT 'Identificador del Dominio',
  `alumn` int(4) NOT NULL COMMENT 'Identificador de Alumno',
  `evaluation` tinyint(2) NOT NULL COMMENT 'Numero de Evaluacion',
  `comments` text CHARACTER SET latin1 COLLATE latin1_spanish_ci COMMENT 'Comentarios',
  PRIMARY KEY (`id`),
  KEY `IDX_EVALUATION_OBSERVATION_ALUMN` (`alumn`),
  KEY `IDX_EVALUATION_OBSERVATION_DOMAIN` (`domain`),
  CONSTRAINT `FK_EVALUATION_OBSERVATION_ALUMN` FOREIGN KEY (`alumn`) REFERENCES `course_alumn` (`id`),
  CONSTRAINT `FK_EVALUATION_OBSERVATION_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Observaciones por Evaluacion';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `evaluation_observation`
--

LOCK TABLES `evaluation_observation` WRITE;
/*!40000 ALTER TABLE `evaluation_observation` DISABLE KEYS */;
/*!40000 ALTER TABLE `evaluation_observation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fan_batch`
--

DROP TABLE IF EXISTS `fan_batch`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fan_batch` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la remesa',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `status` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Indica el estado de la remesa',
  `liquidation_type` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Indica el tipo de liquidacion',
  `communication_id` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Identificador resultante de la comunicacion',
  `income_file` mediumblob COMMENT 'Archivo respuesta en binario',
  `income_file_date` datetime DEFAULT NULL COMMENT 'Fecha de respuesta',
  `outcome_file` mediumblob COMMENT 'Archivo Adjunto en binario',
  `outcome_file_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  PRIMARY KEY (`id`),
  KEY `IDX_FAN_BATCH_DOMAIN` (`domain`),
  CONSTRAINT `FK_FAN_BATCH_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Remesas del fichero fan';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fan_batch`
--

LOCK TABLES `fan_batch` WRITE;
/*!40000 ALTER TABLE `fan_batch` DISABLE KEYS */;
/*!40000 ALTER TABLE `fan_batch` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fan_batch_detail`
--

DROP TABLE IF EXISTS `fan_batch_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fan_batch_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del detalle',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `fan_batch` int(4) NOT NULL COMMENT 'Identificador unico de la remesa',
  `enterprise_ccc` int(4) NOT NULL COMMENT 'Identificador unico del ccc',
  PRIMARY KEY (`id`),
  KEY `IDX_FAN_BATCH_DETAIL_FAN_BATCH` (`fan_batch`),
  KEY `IDX_FAN_BATCH_DETAIL_ENTERPRISE_CCC` (`enterprise_ccc`),
  KEY `IDX_FAN_BATCH_DETAIL_DOMAIN` (`domain`),
  CONSTRAINT `FK_FAN_BATCH_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_FAN_BATCH_DETAIL_ENTERPRISE_CCC` FOREIGN KEY (`enterprise_ccc`) REFERENCES `enterprise_ccc` (`id`),
  CONSTRAINT `FK_FAN_BATCH_DETAIL_FAN_BATCH` FOREIGN KEY (`fan_batch`) REFERENCES `fan_batch` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalle de las remesas del fichero fan';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fan_batch_detail`
--

LOCK TABLES `fan_batch_detail` WRITE;
/*!40000 ALTER TABLE `fan_batch_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `fan_batch_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `favorite`
--

DROP TABLE IF EXISTS `favorite`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `favorite` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de Favorito',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `favorite_category` int(4) NOT NULL COMMENT 'Categoria a la que pertenece el Favorito',
  `description` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion del Favorito',
  `url` varchar(128) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Url del Favorito',
  `user_id` int(4) NOT NULL COMMENT 'Usuario al que pertenece el Favorito',
  PRIMARY KEY (`id`),
  KEY `IDX_FAVORITE_FAVORITE_CATEGORY` (`favorite_category`),
  KEY `IDX_FAVORITE_USER` (`user_id`),
  KEY `IDX_FAVORITE_DOMAIN` (`domain`),
  CONSTRAINT `FK_FAVORITE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_FAVORITE_FAVORITE_CATEGORY` FOREIGN KEY (`favorite_category`) REFERENCES `favorite_category` (`id`),
  CONSTRAINT `FK_FAVORITE_USER` FOREIGN KEY (`user_id`) REFERENCES `user` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Favoritos de Usuario';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `favorite`
--

LOCK TABLES `favorite` WRITE;
/*!40000 ALTER TABLE `favorite` DISABLE KEYS */;
/*!40000 ALTER TABLE `favorite` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `favorite_category`
--

DROP TABLE IF EXISTS `favorite_category`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `favorite_category` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `description` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion de la Categoria',
  `user_id` int(4) NOT NULL COMMENT 'Usuario al que pertenece la Categoria',
  PRIMARY KEY (`id`),
  KEY `IDX_FAVORITE_CATEGORY_USER` (`user_id`),
  KEY `IDX_FAVORITE_CATEGORY_DOMAIN` (`domain`),
  CONSTRAINT `FK_FAVORITE_CATEGORY_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_FAVORITE_CATEGORY_USER` FOREIGN KEY (`user_id`) REFERENCES `user` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Categorias de Favoritos de Usuario';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `favorite_category`
--

LOCK TABLES `favorite_category` WRITE;
/*!40000 ALTER TABLE `favorite_category` DISABLE KEYS */;
/*!40000 ALTER TABLE `favorite_category` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fbatch`
--

DROP TABLE IF EXISTS `fbatch`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fbatch` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la Remesa',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `description` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion de la Remesa',
  `issue_date` date DEFAULT NULL COMMENT 'Fecha de emision de la Remesa',
  `type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de Remesa',
  `status` tinyint(2) DEFAULT NULL COMMENT 'Estado de la Remesa',
  `rbank` int(4) DEFAULT NULL COMMENT 'Banco de la Compañia utilizado en la Remesa',
  `bank_statement_link` int(4) DEFAULT NULL COMMENT 'Identificador de la Linea del Extracto bancario',
  `payment` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indica si es un pago o un cobro',
  `security_level` tinyint(2) DEFAULT '0' COMMENT 'Nivel de seguridad',
  `rattach` int(4) DEFAULT NULL COMMENT 'Identificador del Archivo Adjunto',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_FBATCH_BANK_STATEMENT_LINK` (`bank_statement_link`),
  KEY `IDX_FBATCH_RBANK` (`rbank`),
  KEY `IDX_FBATCH_DOMAIN` (`domain`),
  CONSTRAINT `FK_FBATCH_BANK_STATEMENT_LINK` FOREIGN KEY (`bank_statement_link`) REFERENCES `bank_statement_link` (`id`),
  CONSTRAINT `FK_FBATCH_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_FBATCH_RBANK` FOREIGN KEY (`rbank`) REFERENCES `rbank` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Remesas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fbatch`
--

LOCK TABLES `fbatch` WRITE;
/*!40000 ALTER TABLE `fbatch` DISABLE KEYS */;
/*!40000 ALTER TABLE `fbatch` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fbatch_detail`
--

DROP TABLE IF EXISTS `fbatch_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fbatch_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Detalle de la Remesa',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `fbatch` int(4) NOT NULL COMMENT 'Identificador de la Remesa',
  `finance` int(4) NOT NULL COMMENT 'Identificador del Vencimiento',
  `amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe del Detalle de la Remesa',
  `status` tinyint(2) DEFAULT NULL COMMENT 'Estado del Detalle de la Remesa',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_FBATCH_DETAIL_FINANCE` (`finance`),
  KEY `IDX_FBATCH_DETAIL_FBATCH` (`fbatch`),
  KEY `IDX_FBATCH_DETAIL_DOMAIN` (`domain`),
  CONSTRAINT `FK_FBATCH_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_FBATCH_DETAIL_FBATCH` FOREIGN KEY (`fbatch`) REFERENCES `fbatch` (`id`),
  CONSTRAINT `FK_FBATCH_DETAIL_FINANCE` FOREIGN KEY (`finance`) REFERENCES `finance` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalles de la Remesa';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fbatch_detail`
--

LOCK TABLES `fbatch_detail` WRITE;
/*!40000 ALTER TABLE `fbatch_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `fbatch_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `feature`
--

DROP TABLE IF EXISTS `feature`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `feature` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre de la Caracteristica',
  PRIMARY KEY (`id`),
  KEY `IDX_FEATURE_DOMAIN` (`domain`),
  CONSTRAINT `FK_FEATURE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Caracteristicas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `feature`
--

LOCK TABLES `feature` WRITE;
/*!40000 ALTER TABLE `feature` DISABLE KEYS */;
/*!40000 ALTER TABLE `feature` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `finance`
--

DROP TABLE IF EXISTS `finance`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `finance` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Vencimiento',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `payment` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indica si es un pago o un cobro',
  `registry` int(4) DEFAULT NULL COMMENT 'Identificador del Cliente o Proveedor',
  `rdocument` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de Documento del Cliente o Proveedor',
  `rdocument_type` tinyint(2) DEFAULT '0' COMMENT 'Tipo de documento (NIF, CIF...)',
  `rdocument_country` varchar(2) COLLATE latin1_spanish_ci DEFAULT 'ES' COMMENT 'Pais del documento',
  `rname` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre completo del Cliente o Proveedor',
  `amount` double DEFAULT '0' COMMENT 'Importe del Vencimiento',
  `expenses` double(15,3) DEFAULT '0.000' COMMENT 'Gastos asociados al Vencimiento',
  `concept` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Concepto del Vencimiento',
  `invoice` int(4) DEFAULT NULL COMMENT 'Identificador de la Factura',
  `due_date` date DEFAULT NULL COMMENT 'Fecha de Vencimiento',
  `pay_method` int(4) DEFAULT NULL COMMENT 'Identificador de la Forma de Pago',
  `bank_account` varchar(34) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'IBAN - Numero de Cuenta Bancaria Internacional',
  `bank_alias` varchar(25) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Alias del Banco',
  `bic` varchar(11) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'BIC - Codigo Identificador del Banco',
  `cheque_number` varchar(24) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de cheque',
  `status` tinyint(2) DEFAULT '0' COMMENT 'Estado del Vencimiento',
  `security_level` tinyint(2) DEFAULT '0' COMMENT 'Nivel de seguridad del Vencimiento',
  `remarks` text COLLATE latin1_spanish_ci COMMENT 'Observaciones del Vencimiento',
  `scope` int(4) NOT NULL DEFAULT '1' COMMENT 'Ambito del Vencimiento',
  `manual` tinyint(1) DEFAULT '0' COMMENT 'Indica si el Vencimiento es manual',
  `advance` tinyint(1) DEFAULT '0' COMMENT 'Indica si el Vencimiento es un anticipo',
  `payroll` tinyint(1) DEFAULT '0' COMMENT 'Indica si el Vencimiento es de Nominas',
  `prepayment` tinyint(1) DEFAULT '0' COMMENT 'Indica si el Vencimiento es un Suplido',
  `source_id` int(4) DEFAULT NULL COMMENT 'Identificador del Origen del Vencimiento',
  `finance_group` int(4) DEFAULT NULL COMMENT 'Identificador unico del Vencimiento agrupador',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_FINANCE_SCOPE` (`scope`),
  KEY `IDX_FINANCE_DUE_DATE` (`due_date`),
  KEY `IDX_FINANCE_REGISTRY` (`registry`),
  KEY `IDX_FINANCE_PAY_METHOD` (`pay_method`),
  KEY `IDX_FINANCE_INVOICE` (`invoice`),
  KEY `IDX_FINANCE_DOMAIN` (`domain`),
  KEY `IDX_FINANCE_FINANCE` (`finance_group`),
  CONSTRAINT `FK_FINANCE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_FINANCE_FINANCE` FOREIGN KEY (`finance_group`) REFERENCES `finance` (`id`),
  CONSTRAINT `FK_FINANCE_INVOICE` FOREIGN KEY (`invoice`) REFERENCES `invoice` (`id`),
  CONSTRAINT `FK_FINANCE_PAY_METHOD` FOREIGN KEY (`pay_method`) REFERENCES `pay_method` (`id`),
  CONSTRAINT `FK_FINANCE_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`),
  CONSTRAINT `FK_FINANCE_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Vencimientos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `finance`
--

LOCK TABLES `finance` WRITE;
/*!40000 ALTER TABLE `finance` DISABLE KEYS */;
/*!40000 ALTER TABLE `finance` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `finance_pos`
--

DROP TABLE IF EXISTS `finance_pos`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `finance_pos` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `finance` int(4) NOT NULL COMMENT 'Identificador de Vencimiento',
  `pos` int(4) NOT NULL COMMENT 'Identificador del TPV',
  `code` char(16) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Codigo de autorizacion',
  `xml_response` text COLLATE latin1_spanish_ci COMMENT 'XML de respuesta',
  PRIMARY KEY (`id`),
  KEY `IDX_FINANCE_POS_DOMAIN` (`domain`),
  KEY `IDX_FINANCE_POS_FINANCE` (`finance`),
  KEY `IDX_FINANCE_POS_POS` (`pos`),
  CONSTRAINT `FK_FINANCE_POS_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_FINANCE_POS_FINANCE` FOREIGN KEY (`finance`) REFERENCES `finance` (`id`),
  CONSTRAINT `FK_FINANCE_POS_POS` FOREIGN KEY (`pos`) REFERENCES `pos` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Vencimientos de TPV';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `finance_pos`
--

LOCK TABLES `finance_pos` WRITE;
/*!40000 ALTER TABLE `finance_pos` DISABLE KEYS */;
/*!40000 ALTER TABLE `finance_pos` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `finance_tracking`
--

DROP TABLE IF EXISTS `finance_tracking`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `finance_tracking` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `finance` int(4) NOT NULL COMMENT 'Identificador de Vencimiento',
  `tracking_date` date NOT NULL COMMENT 'Fecha de Seguimiento',
  `type` tinyint(4) NOT NULL COMMENT 'Tipo de Seguimiento',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion del Seguimiento',
  `pm_type_detail` int(4) DEFAULT NULL COMMENT 'Identificador del Detalle por Tipo de Forma de Pago',
  `rbank` int(4) DEFAULT NULL COMMENT 'Identificador de la Cuenta Bancaria de la Compañia',
  `bank_statement_link` int(4) DEFAULT NULL COMMENT 'Identificador de la Linea del Extracto bancario',
  `amount` double(15,3) DEFAULT NULL COMMENT 'Importe del Seguimiento',
  `recorded` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indica si esta contabilizado o no',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_FINANCE_TRACKING_RBANK` (`rbank`),
  KEY `IDX_FINANCE_TRACKING_PM_TYPE_DETAIL` (`pm_type_detail`),
  KEY `IDX_FINANCE_TRACKING_BANK_STATEMENT_LINK` (`bank_statement_link`),
  KEY `IDX_FINANCE_TRACKING_FINANCE` (`finance`),
  KEY `IDX_FINANCE_TRACKING_DOMAIN` (`domain`),
  CONSTRAINT `FK_FINANCE_TRACKING_BANK_STATEMENT_LINK` FOREIGN KEY (`bank_statement_link`) REFERENCES `bank_statement_link` (`id`),
  CONSTRAINT `FK_FINANCE_TRACKING_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_FINANCE_TRACKING_FINANCE` FOREIGN KEY (`finance`) REFERENCES `finance` (`id`),
  CONSTRAINT `FK_FINANCE_TRACKING_PM_TYPE_DETAIL` FOREIGN KEY (`pm_type_detail`) REFERENCES `pm_type_detail` (`id`),
  CONSTRAINT `FK_FINANCE_TRACKING_RBANK` FOREIGN KEY (`rbank`) REFERENCES `rbank` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Seguimiento de Vencimientos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `finance_tracking`
--

LOCK TABLES `finance_tracking` WRITE;
/*!40000 ALTER TABLE `finance_tracking` DISABLE KEYS */;
/*!40000 ALTER TABLE `finance_tracking` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fs_activity`
--

DROP TABLE IF EXISTS `fs_activity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fs_activity` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `year` int(4) NOT NULL COMMENT 'Ejercicio del Lote',
  `activity` int(4) DEFAULT NULL COMMENT 'Identificador de la Actividad',
  `epigraph` varchar(7) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Epigrafe IAE',
  `description` varchar(128) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion del epigrafe',
  `farmer` tinyint(1) DEFAULT '0' COMMENT 'Actividad agricola',
  `max_person` double(15,3) DEFAULT '0.000' COMMENT 'Valor maximo de personas',
  `max_import` double(15,3) DEFAULT '0.000' COMMENT 'Valor maximo de importe',
  `vat_percent` double(15,3) DEFAULT '0.000' COMMENT 'IVA - porcentaje aplicable',
  PRIMARY KEY (`id`),
  KEY `IDX_FS_ACTIVITY_DOMAIN` (`domain`),
  KEY `IDX_FS_ACTIVITY_ACTIVITY` (`activity`),
  CONSTRAINT `FK_FS_ACTIVITY_ACTIVITY` FOREIGN KEY (`activity`) REFERENCES `enterprise_activity` (`id`),
  CONSTRAINT `FK_FS_ACTIVITY_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Fiscal. Datos previos de Modulos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fs_activity`
--

LOCK TABLES `fs_activity` WRITE;
/*!40000 ALTER TABLE `fs_activity` DISABLE KEYS */;
/*!40000 ALTER TABLE `fs_activity` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fs_activity_info`
--

DROP TABLE IF EXISTS `fs_activity_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fs_activity_info` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `fs_activity` int(4) NOT NULL COMMENT 'Actividad fiscal',
  `info_key` varchar(5) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Clave de informacion',
  `line` int(4) NOT NULL COMMENT 'Numero de linea',
  `type` tinyint(2) NOT NULL COMMENT 'Tipo de linea',
  `value` varchar(25) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Valor de la informacion',
  `factor` double(15,3) DEFAULT '0.000' COMMENT 'Factor',
  `base` double(15,3) DEFAULT '0.000' COMMENT 'Rendimiento neto',
  `unit` varchar(25) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Unidades',
  `min_value` double(15,3) DEFAULT '0.000' COMMENT 'Valor minimo',
  `max_value` double(15,3) DEFAULT '0.000' COMMENT 'Valor maximo',
  PRIMARY KEY (`id`),
  KEY `IDX_FS_ACTIVITY_INFO_DOMAIN` (`domain`),
  KEY `IDX_FS_ACTIVITY_INFO_FS_ACTIVITY` (`fs_activity`),
  CONSTRAINT `FK_FS_ACTIVITY_INFO_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_FS_ACTIVITY_INFO_FS_ACTIVITY` FOREIGN KEY (`fs_activity`) REFERENCES `fs_activity` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Fiscal. Informacion de los Datos previos de Modulos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fs_activity_info`
--

LOCK TABLES `fs_activity_info` WRITE;
/*!40000 ALTER TABLE `fs_activity_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `fs_activity_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fs_mod347`
--

DROP TABLE IF EXISTS `fs_mod347`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fs_mod347` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `year` int(4) NOT NULL COMMENT 'Ejercicio de la Declaracion',
  `administration` tinyint(2) DEFAULT '0' COMMENT 'Administracion',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios de la Declaracion',
  `status` tinyint(2) DEFAULT '0' COMMENT 'Estado de la Declaracion',
  `security_level` tinyint(2) DEFAULT '0' COMMENT 'Nivel de seguridad',
  `complementary` tinyint(1) DEFAULT '0' COMMENT 'Declaracion complementaria',
  `replacement` tinyint(1) DEFAULT '0' COMMENT 'Declaracion sustitutiva',
  `number` int(4) DEFAULT '0' COMMENT 'Numero de Decl.',
  `replaced_number` int(4) DEFAULT '0' COMMENT 'Numero de Decl. complementada o sustituida',
  PRIMARY KEY (`id`),
  KEY `IDX_FS_MOD347_DOMAIN` (`domain`),
  CONSTRAINT `FK_FS_MOD347_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Declaracion de Model 347';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fs_mod347`
--

LOCK TABLES `fs_mod347` WRITE;
/*!40000 ALTER TABLE `fs_mod347` DISABLE KEYS */;
/*!40000 ALTER TABLE `fs_mod347` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fs_mod347_detail`
--

DROP TABLE IF EXISTS `fs_mod347_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fs_mod347_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `fs_mod347` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador de la Declaracion',
  `sheet` varchar(1) COLLATE latin1_spanish_ci NOT NULL DEFAULT 'D' COMMENT 'Tipo de hoja (Declarado o Inmueble)',
  `type` varchar(1) COLLATE latin1_spanish_ci DEFAULT '0' COMMENT 'Clave de operacion',
  `document` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'NIF del declarado',
  `registry` int(4) DEFAULT '0' COMMENT 'Identificador del Declarado',
  `name` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Apellidos  y Nombre del declarado',
  `province` int(4) DEFAULT '0' COMMENT 'Provincia del declarado',
  `country` varchar(2) COLLATE latin1_spanish_ci DEFAULT '0' COMMENT 'Pais del declarado',
  `amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe de las operaciones',
  `first_quarter_amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe de las operaciones primer trimestre',
  `second_quarter_amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe de las operaciones segundo trimestre',
  `third_quarter_amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe de las operaciones tercer trimestre',
  `fourth_quarter_amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe de las operaciones cuarto trimestre',
  `asset_amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe de las operaciones de inmuebles',
  `asset_first_quarter_amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe de las operaciones de inmuebles del primer trimestre',
  `asset_second_quarter_amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe de las operaciones de inmuebles del segundo trimestre',
  `asset_third_quarter_amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe de las operaciones de inmuebles del tercer trimestre',
  `asset_fourth_quarter_amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe de las operaciones de inmuebles del cuarto trimestre',
  `cash_amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe de las operaciones en metalico',
  `cash_year` int(11) DEFAULT NULL COMMENT 'Ejercicio en el que se hubieran declarado las operaciones en metalico.',
  `insurance_operation` tinyint(1) DEFAULT '0' COMMENT 'Las Entidades Aseguradoras maracaran este campo para identificar las operaciones de seguros',
  `business_premise_rental` tinyint(1) DEFAULT '0' COMMENT 'Se marcara este campo para operaciones de arrendamiento de locales de negocio,',
  `asset_location` varchar(1) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Situacion del inmueble',
  `cadasdral_reference` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Refercia catastral',
  `asset_street_type` varchar(5) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Tipo de via',
  `asset_street` varchar(50) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre de la via',
  `asset_street_number_type` varchar(3) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Tipo de numero de via',
  `asset_street_number` varchar(5) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de via',
  `asset_street_number_suffix` varchar(3) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Calificador del numero de via',
  `asset_street_block` varchar(3) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Direccion. Bloque.',
  `asset_street_hall` varchar(3) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Direccion. Portal.',
  `asset_street_stair` varchar(3) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Direccion. Escalera.',
  `asset_street_floor` varchar(3) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Direccion. Planta.',
  `asset_street_door` varchar(3) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Direccion. Puerta.',
  `asset_street_complement` varchar(40) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Direccion. Complemento.',
  `asset_street_city` varchar(30) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Direccion. Complemento.',
  `asset_street_town` varchar(30) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Direccion. Complemento.',
  `asset_street_town_code` varchar(5) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Direccion. Complemento.',
  `asset_street_province` varchar(2) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Direccion. Complemento.',
  `asset_street_zip` varchar(5) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Direccion. Complemento.',
  `operator_nif` varchar(17) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'NIF del operador intracomunitario',
  `vat_accrual` tinyint(1) DEFAULT '0' COMMENT 'Regimen de critrio de caja',
  `isp` tinyint(1) DEFAULT '0' COMMENT 'Inversion de sujeto pasivo',
  `deposit_regime` tinyint(1) DEFAULT '0' COMMENT 'Regimen de deposito',
  `vat_accrual_amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe de las operaciones en reg, caja',
  PRIMARY KEY (`id`),
  KEY `IDX_FS_MOD347_DETAIL_FS_MOD347` (`fs_mod347`),
  KEY `IDX_FS_MOD347_DETAIL_DOMAIN` (`domain`),
  CONSTRAINT `FK_FS_MOD347_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_FS_MOD347_DETAIL_FS_MOD347` FOREIGN KEY (`fs_mod347`) REFERENCES `fs_mod347` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalle de la Declaracion 347';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fs_mod347_detail`
--

LOCK TABLES `fs_mod347_detail` WRITE;
/*!40000 ALTER TABLE `fs_mod347_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `fs_mod347_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fs_mod349`
--

DROP TABLE IF EXISTS `fs_mod349`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fs_mod349` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `year` int(4) NOT NULL COMMENT 'Ejercicio de la Declaracion',
  `period` tinyint(2) DEFAULT '0' COMMENT 'Periodo de la Declaracion',
  `administration` tinyint(2) DEFAULT '0' COMMENT 'Administracion',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios de la Declaracion',
  `status` tinyint(2) DEFAULT '0' COMMENT 'Estado de la Declaracion',
  `security_level` tinyint(2) DEFAULT '0' COMMENT 'Nivel de seguridad',
  `complementary` tinyint(1) DEFAULT '0' COMMENT 'Declaracion complementaria',
  `replacement` tinyint(1) DEFAULT '0' COMMENT 'Declaracion sustitutiva',
  `number` int(4) DEFAULT '0' COMMENT 'Numero de Declaracion',
  `replaced_number` int(4) DEFAULT '0' COMMENT 'Numero de Declaracion complementada o sustituida',
  PRIMARY KEY (`id`),
  KEY `IDX_FS_MOD349_DOMAIN` (`domain`),
  CONSTRAINT `FK_FS_MOD349_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Declaracion de Modelo 349';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fs_mod349`
--

LOCK TABLES `fs_mod349` WRITE;
/*!40000 ALTER TABLE `fs_mod349` DISABLE KEYS */;
/*!40000 ALTER TABLE `fs_mod349` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fs_mod349_detail`
--

DROP TABLE IF EXISTS `fs_mod349_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fs_mod349_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `fs_mod349` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador de la Declaracion',
  `rectification` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Rectificacion',
  `type` varchar(1) COLLATE latin1_spanish_ci DEFAULT '0' COMMENT 'Clave de operacion',
  `document` varchar(15) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Documento del operador',
  `registry` int(4) DEFAULT '0' COMMENT 'Identificador del Declarado',
  `name` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Apellidos y Nombre del Declarado',
  `country` varchar(2) COLLATE latin1_spanish_ci DEFAULT '0' COMMENT 'Pais del Declarado',
  `accumulated` double(15,3) DEFAULT '0.000' COMMENT 'Importe acumulado de las operaciones',
  `declared` double(15,3) DEFAULT '0.000' COMMENT 'Importe declarado de las operaciones',
  `amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe de las operaciones',
  `rectified_year` int(4) DEFAULT NULL COMMENT 'Ejercicio de la Declaracion del importe rectificado',
  `rectified_period` tinyint(2) DEFAULT NULL COMMENT 'Periodo de la Declaracion del importe rectificado',
  `rectified_amount` varchar(45) COLLATE latin1_spanish_ci DEFAULT '0.000' COMMENT 'Importe rectificado',
  PRIMARY KEY (`id`),
  KEY `IDX_FS_MOD349_DETAIL_DOMAIN` (`domain`),
  KEY `IDX_FS_MOD349_DETAIL_FS_MOD349` (`fs_mod349`),
  CONSTRAINT `FK_FS_MOD349_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_FS_MOD349_DETAIL_FS_MOD349` FOREIGN KEY (`fs_mod349`) REFERENCES `fs_mod349` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalle de la Declaracion 349';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fs_mod349_detail`
--

LOCK TABLES `fs_mod349_detail` WRITE;
/*!40000 ALTER TABLE `fs_mod349_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `fs_mod349_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fs_model`
--

DROP TABLE IF EXISTS `fs_model`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fs_model` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `year` int(4) NOT NULL COMMENT 'Ejercicio de la Declaracion',
  `period` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Periodo de la Declaracion',
  `administration` tinyint(2) NOT NULL COMMENT 'Administracion',
  `status` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Estado de la Declaracion',
  `security_level` tinyint(2) DEFAULT '0' COMMENT 'Nivel de seguridad',
  `complementary` tinyint(1) DEFAULT '0' COMMENT 'Declaracion complementaria',
  `replacement` tinyint(1) DEFAULT '0' COMMENT 'Declaracion sustitutiva',
  `withoutActivity` tinyint(1) DEFAULT '0' COMMENT 'Sin Actividad',
  `model` varchar(3) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Tipo de modelo',
  `number` varchar(13) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de Declaracion',
  `replaced_number` varchar(13) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de Declaracion complementada o sustituida',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios de la Declaracion',
  `finance` int(4) DEFAULT NULL COMMENT 'Identificador de Vencimiento',
  `document` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'NIF',
  `surname` varchar(30) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Apellidos',
  `name` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre',
  `street_initial` varchar(2) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Sigla via',
  `street_name` varchar(17) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre de la via publica',
  `street_number` varchar(4) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de la via publica',
  `street_stair` varchar(2) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Escalera',
  `street_floor` varchar(2) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Piso',
  `street_door` varchar(2) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Puerta',
  `phone` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Telefono',
  `town` varchar(20) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Municipio',
  `province` varchar(15) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Provincia',
  `zip` varchar(5) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo Postal',
  `admon_aeat` varchar(5) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo de Administracion AEAT',
  `contact_person` varchar(100) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Persona de Contacto',
  `contact_phone` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Telf. Fijo',
  `contact_cellular` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Telf. Movil',
  `contact_email` varchar(100) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Email',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_FS_MODEL_DOMAIN` (`domain`),
  KEY `IDX_FS_MODEL_FINANCE` (`finance`),
  CONSTRAINT `FK_FS_MODEL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_FS_MODEL_FINANCE` FOREIGN KEY (`finance`) REFERENCES `finance` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Declaraciones Fiscales';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fs_model`
--

LOCK TABLES `fs_model` WRITE;
/*!40000 ALTER TABLE `fs_model` DISABLE KEYS */;
/*!40000 ALTER TABLE `fs_model` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fs_model180`
--

DROP TABLE IF EXISTS `fs_model180`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fs_model180` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `enterprise` int(4) NOT NULL COMMENT 'Identificador de la Empresa',
  `year` int(4) NOT NULL COMMENT 'Ejercicio de la Declaracion',
  `administration` tinyint(2) NOT NULL COMMENT 'Administracion',
  `status` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Estado de la Declaracion',
  `security_level` tinyint(2) DEFAULT '0' COMMENT 'Nivel de seguridad',
  `document` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'NIF',
  `name` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre',
  `contact_person` varchar(100) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Persona de Contacto',
  `contact_phone` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Telf. Fijo de Contacto',
  `complementary` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Declaracion complementaria',
  `replacement` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Declaracion sustitutiva',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios de la Declaracion',
  `receipt` varchar(13) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de Declaracion',
  `replaced_receipt` varchar(13) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de declaracion sustituida',
  `receiver_count_total` int(4) NOT NULL DEFAULT '0' COMMENT 'Numero total de perceptores',
  `receipt_total` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Importe declarado',
  `retention_total` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Importe declarado',
  PRIMARY KEY (`id`),
  KEY `IDX_FS_MODEL180_DOMAIN` (`domain`),
  KEY `IDX_FS_MODEL180_ENTERPRISE` (`enterprise`),
  CONSTRAINT `FK_FS_MODEL180_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_FS_MODEL180_ENTERPRISE` FOREIGN KEY (`enterprise`) REFERENCES `enterprise` (`registry`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Declaraciones 180';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fs_model180`
--

LOCK TABLES `fs_model180` WRITE;
/*!40000 ALTER TABLE `fs_model180` DISABLE KEYS */;
/*!40000 ALTER TABLE `fs_model180` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fs_model180_detail`
--

DROP TABLE IF EXISTS `fs_model180_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fs_model180_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `fs_model180` int(4) NOT NULL COMMENT 'Identificador del modelo 180',
  `document` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'NIF Perceptor',
  `name` varchar(40) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre',
  `representative_document` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'NIF Representante',
  `province` int(4) NOT NULL DEFAULT '0' COMMENT 'Provincia',
  `inKind` tinyint(1) NOT NULL COMMENT 'Percepcion en especie',
  `perception` double(15,3) NOT NULL DEFAULT '0.000',
  `percentage` double(15,3) DEFAULT '0.000' COMMENT 'Porcentaje de retencion',
  `retention` double(15,3) NOT NULL DEFAULT '0.000',
  `accrual_year` int(4) NOT NULL DEFAULT '0',
  `location` varchar(1) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Situacion del inmueble',
  `cadasdral_reference` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Refercia catastral',
  `street_type` varchar(5) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Tipo de via',
  `street_name` varchar(50) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre de la via',
  `number_type` varchar(3) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Tipo de numero de via',
  `number` varchar(5) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de via',
  `number_suffix` varchar(3) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Calificador del numero de via',
  `block` varchar(3) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Direccion. Bloque.',
  `hall` varchar(3) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Direccion. Portal.',
  `stair` varchar(3) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Direccion. Escalera.',
  `floor` varchar(3) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Direccion. Planta.',
  `door` varchar(3) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Direccion. Puerta.',
  `complement` varchar(40) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Direccion. Complemento.',
  `city` varchar(30) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Localidad o poblacion.',
  `town` varchar(30) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Municipio.',
  `town_code` varchar(5) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo de municipio..',
  `province_code` varchar(2) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo de provincia.',
  `zip` varchar(5) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo postal.',
  PRIMARY KEY (`id`),
  KEY `IDX_FS_MODEL180_DETAIL_DOMAIN` (`domain`),
  KEY `IDX_FS_MODEL180_DETAIL_FS_MODEL180` (`fs_model180`),
  CONSTRAINT `FK_FS_MODEL180_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_FS_MODEL180_DETAIL_FS_MODEL180` FOREIGN KEY (`fs_model180`) REFERENCES `fs_model180` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalles de Declaraciones 180';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fs_model180_detail`
--

LOCK TABLES `fs_model180_detail` WRITE;
/*!40000 ALTER TABLE `fs_model180_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `fs_model180_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fs_model184`
--

DROP TABLE IF EXISTS `fs_model184`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fs_model184` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `enterprise` int(4) NOT NULL COMMENT 'Identificador de la Empresa',
  `year` int(4) NOT NULL COMMENT 'Ejercicio de la Declaracion',
  `administration` tinyint(2) NOT NULL COMMENT 'Administracion',
  `status` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Estado de la Declaracion',
  `security_level` tinyint(2) DEFAULT '0' COMMENT 'Nivel de seguridad',
  `document` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'NIF',
  `name` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre',
  `contact_person` varchar(100) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Persona de Contacto',
  `contact_phone` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Telf. Fijo de Contacto',
  `complementary` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Declaracion complementaria',
  `replacement` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Declaracion sustitutiva',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios de la Declaracion',
  `receipt` varchar(13) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de Declaracion',
  `replaced_receipt` varchar(13) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de declaracion sustituida',
  `entity_type` varchar(1) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Tipo de entidad nacional',
  `main_activity` varchar(1) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Actividad principal',
  `foreign_entity_type` varchar(1) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Tipo de entidad extranjera',
  `foreign_object` varchar(1) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Objeto',
  `country` varchar(2) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Pais',
  `resident_percent` double(15,3) DEFAULT '0.000' COMMENT 'Porcentaje de renta atrib. a miembros residentes',
  `tax_is` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Tributacion en regimen del Impuesto sobre Sociedades',
  `net_sales_amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe neto cifra de negocios',
  `lrdocument` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'NIF Representante',
  `lrname` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre Representante',
  PRIMARY KEY (`id`),
  KEY `IDX_FS_MODEL184_DOMAIN` (`domain`),
  KEY `IDX_FS_MODEL184_ENTERPRISE` (`enterprise`),
  CONSTRAINT `FK_FS_MODEL184_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_FS_MODEL184_ENTERPRISE` FOREIGN KEY (`enterprise`) REFERENCES `enterprise` (`registry`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Declaraciones 184';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fs_model184`
--

LOCK TABLES `fs_model184` WRITE;
/*!40000 ALTER TABLE `fs_model184` DISABLE KEYS */;
/*!40000 ALTER TABLE `fs_model184` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fs_model184_detail`
--

DROP TABLE IF EXISTS `fs_model184_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fs_model184_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `fs_model184` int(4) NOT NULL COMMENT 'Identificador del modelo 184',
  `type` varchar(1) COLLATE latin1_spanish_ci NOT NULL DEFAULT 'I' COMMENT 'Tipo de detalle',
  `document` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'NIF Perceptor',
  `name` varchar(40) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre',
  `representative_document` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'NIF Representante',
  `key` varchar(1) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Clave Percepcion',
  `subkey` varchar(2) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Subclave Percepcion',
  `province` int(4) NOT NULL DEFAULT '0' COMMENT 'Provincia',
  `country` varchar(2) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Pais',
  `regime` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Regimen de determinacion de rendimientos',
  `activity_type` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Tipo de actividad',
  `epigraph` int(4) DEFAULT '0' COMMENT 'Epigrafe',
  `grantee_document` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'NIF persona o entidad cesionaria',
  `grantee_name` varchar(40) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre persona o entidad cesionaria',
  `adq_date` date DEFAULT NULL COMMENT 'Fecha adquisicion accion/participacion',
  `increase` double(15,3) DEFAULT NULL COMMENT 'Ajustes: Aumentos',
  `decrease` double(15,3) DEFAULT NULL COMMENT 'Ajustes: Disminuciones',
  `accounting_result` double(15,3) DEFAULT NULL COMMENT 'Resultado contable',
  `expenses` double(15,3) DEFAULT NULL COMMENT 'Gastos',
  `net_yield` double(15,3) DEFAULT NULL COMMENT 'Renta atribuible / Rend. Neto atribuible',
  `reduction_percent` double(15,3) DEFAULT NULL COMMENT 'Porc. Reduccion',
  `deduction_right_rent` double(15,3) DEFAULT NULL COMMENT 'Renta atrib. con drcho. deduccion',
  `result` double(15,3) DEFAULT NULL COMMENT 'Ganancias / Perdidas',
  `deduction_base` double(15,3) DEFAULT NULL COMMENT 'Base de la deduccion / Importe',
  `retention` double(15,3) DEFAULT NULL COMMENT 'Retenciones e ingresos a cuenta',
  `part_type` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Clave tipo de participe',
  `member_end_of_year` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Miembro a 31 diciembre',
  `member_days` int(4) DEFAULT '0' COMMENT 'Numero dias miembro',
  `part_percent` double(15,3) DEFAULT NULL COMMENT 'Porcentaje de participacion',
  `amount` double(15,3) DEFAULT NULL COMMENT 'Importe (rendimiento / retencion / deduccion)',
  `reduction` double(15,3) DEFAULT NULL COMMENT 'Reduccion',
  `address` varchar(60) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Direccion',
  `location` varchar(1) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Situacion del inmueble',
  `cadasdral_reference` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Referencia catastral',
  `staff_expenses` double(15,3) DEFAULT '0.000' COMMENT 'Gastos de personal',
  `asset_acquisition` double(15,3) DEFAULT '0.000' COMMENT 'Adquisicion a terceros de bienes y servicios',
  `tax_deduction` double(15,3) DEFAULT '0.000' COMMENT 'Tributos fiscalmente deducibles y gastos financieros',
  `other_tax_deduction` double(15,3) DEFAULT '0.000' COMMENT 'Otros gastos fiscalmente deducibles',
  `vat_accrual_payment` tinyint(1) DEFAULT '0' COMMENT 'Regimen Especial de Criterio de Caja',
  `declared_key` varchar(1) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Clave del declarado',
  `nature` varchar(1) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Naturaleza del inmueble',
  `asset_percent` double(15,3) DEFAULT '0.000' COMMENT 'Porc. titularidad inmueble',
  PRIMARY KEY (`id`),
  KEY `IDX_FS_MODEL184_DETAIL_DOMAIN` (`domain`),
  KEY `IDX_FS_MODEL184_DETAIL_FS_MODEL184` (`fs_model184`),
  CONSTRAINT `FK_FS_MODEL184_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_FS_MODEL184_DETAIL_FS_MODEL184` FOREIGN KEY (`fs_model184`) REFERENCES `fs_model184` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalles de Declaraciones 184';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fs_model184_detail`
--

LOCK TABLES `fs_model184_detail` WRITE;
/*!40000 ALTER TABLE `fs_model184_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `fs_model184_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fs_model190`
--

DROP TABLE IF EXISTS `fs_model190`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fs_model190` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `enterprise` int(4) NOT NULL COMMENT 'Identificador de la Empresa',
  `year` int(4) NOT NULL COMMENT 'Ejercicio de la Declaracion',
  `administration` tinyint(2) NOT NULL COMMENT 'Administracion',
  `status` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Estado de la Declaracion',
  `security_level` tinyint(2) DEFAULT '0' COMMENT 'Nivel de seguridad',
  `document` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'NIF',
  `name` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre',
  `contact_person` varchar(100) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Persona de Contacto',
  `contact_phone` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Telf. Fijo de Contacto',
  `complementary` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Declaracion complementaria',
  `replacement` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Declaracion sustitutiva',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios de la Declaracion',
  `receipt` varchar(13) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de Declaracion',
  `replaced_receipt` varchar(13) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de declaracion sustituida',
  `receiver_count_total` int(4) NOT NULL DEFAULT '0' COMMENT 'Numero total de perceptores',
  `receipt_total` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Importe declarado',
  `retention_total` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Importe declarado',
  PRIMARY KEY (`id`),
  KEY `IDX_FS_MODEL190_DOMAIN` (`domain`),
  KEY `IDX_FS_MODEL190_ENTERPRISE` (`enterprise`),
  CONSTRAINT `FK_FS_MODEL190_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_FS_MODEL190_ENTERPRISE` FOREIGN KEY (`enterprise`) REFERENCES `enterprise` (`registry`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Declaraciones 190';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fs_model190`
--

LOCK TABLES `fs_model190` WRITE;
/*!40000 ALTER TABLE `fs_model190` DISABLE KEYS */;
/*!40000 ALTER TABLE `fs_model190` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fs_model190_detail`
--

DROP TABLE IF EXISTS `fs_model190_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fs_model190_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `fs_model190` int(4) NOT NULL COMMENT 'Identificador del modelo 190',
  `document` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'NIF Perceptor',
  `name` varchar(40) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre',
  `representative_document` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'NIF Representante',
  `province` int(4) NOT NULL DEFAULT '0' COMMENT 'Provincia',
  `key` varchar(1) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Clave Percepcion',
  `subkey` varchar(2) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Subclave Percepcion',
  `perception` double(15,3) NOT NULL DEFAULT '0.000',
  `retention` double(15,3) NOT NULL DEFAULT '0.000',
  `in_kind_perception` double(15,3) NOT NULL DEFAULT '0.000',
  `in_kind_deposit` double(15,3) NOT NULL DEFAULT '0.000',
  `in_kind_output_deposit` double(15,3) NOT NULL DEFAULT '0.000',
  `accrual_year` int(4) NOT NULL DEFAULT '0',
  `ceuta_melilla` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Los datos anteriores corresponden a rendimientos obtenidos en Ceuta o Melilla',
  `birth_year` int(4) NOT NULL DEFAULT '0',
  `family_situation` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Situacion familiar',
  `spouse_document` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de Documento del conyuge',
  `disability` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Grado de discapacidad',
  `contract` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Contrato o relacion',
  `labour_prolongation` tinyint(1) DEFAULT '0' COMMENT 'Prolongacion de la actividad laboral',
  `geographic_mobility` tinyint(1) DEFAULT '0' COMMENT 'Movilidad geografica',
  `applicable_reduction` double(15,3) DEFAULT NULL COMMENT 'Reducciones aplicables',
  `deducible_expenses` double(15,3) DEFAULT NULL COMMENT 'Gastos deducibles ',
  `spousal_support` double(15,3) DEFAULT NULL COMMENT 'Pension compensatoria a favor del cónyuge.',
  `food_annuity` double(15,3) DEFAULT NULL COMMENT 'Anualidades por alimentos en favor de los hijos.',
  `less_than_3_descendent` tinyint(1) DEFAULT '0',
  `less_than_3_descendent_ratio` tinyint(1) DEFAULT '0',
  `other_descendent` tinyint(1) DEFAULT '0',
  `other_descendent_ratio` tinyint(1) DEFAULT '0',
  `disability_descendent_33` tinyint(1) DEFAULT '0',
  `disability_descendent_33_ratio` tinyint(1) DEFAULT '0',
  `disability_descendent_dependence` tinyint(1) DEFAULT '0',
  `disability_descendent_dependence_ratio` tinyint(1) DEFAULT '0',
  `disability_descendent_65` tinyint(1) DEFAULT '0',
  `disability_descendent_65_ratio` tinyint(1) DEFAULT '0',
  `less_than_75_ascendant` tinyint(1) DEFAULT '0',
  `less_than_75_ascendant_ratio` tinyint(1) DEFAULT '0',
  `ascendant` tinyint(1) DEFAULT '0',
  `ascendant_ratio` tinyint(1) DEFAULT '0',
  `disability_ascendant_33` tinyint(1) DEFAULT '0',
  `disability_ascendant_33_ratio` tinyint(1) DEFAULT '0',
  `disability_ascendant_dependence` tinyint(1) DEFAULT '0',
  `disability_ascendant_dependence_ratio` tinyint(1) DEFAULT '0',
  `disability_ascendant_65` tinyint(1) DEFAULT '0',
  `disability_ascendant_65_Ratio` tinyint(1) DEFAULT '0',
  `first_child_calculation` tinyint(1) DEFAULT '0',
  `second_child_calculation` tinyint(1) DEFAULT '0',
  `third_child_calculation` tinyint(1) DEFAULT '0',
  `home_loan_communnication` tinyint(1) DEFAULT '0',
  `perception_il` double(15,3) DEFAULT '0.000' COMMENT 'Percepcin Integra/valoracion derivada de incapacidad laboral',
  `retention_il` double(15,3) DEFAULT '0.000' COMMENT 'Retenciones practicadas/ingresos a cuenta efectuados derivadas de incapacidad laboral',
  `output_retention_il` double(15,3) DEFAULT '0.000' COMMENT 'Ingresos a cuenta repercutidos derivados de incapacidad laboral',
  PRIMARY KEY (`id`),
  KEY `IDX_FS_MODEL190_DETAIL_DOMAIN` (`domain`),
  KEY `IDX_FS_MODEL190_DETAIL_FS_MODEL190` (`fs_model190`),
  CONSTRAINT `FK_FS_MODEL190_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_FS_MODEL190_DETAIL_FS_MODEL190` FOREIGN KEY (`fs_model190`) REFERENCES `fs_model190` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalles de Declaraciones 190';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fs_model190_detail`
--

LOCK TABLES `fs_model190_detail` WRITE;
/*!40000 ALTER TABLE `fs_model190_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `fs_model190_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fs_model193`
--

DROP TABLE IF EXISTS `fs_model193`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fs_model193` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `enterprise` int(4) NOT NULL COMMENT 'Identificador de la Empresa',
  `year` int(4) NOT NULL COMMENT 'Ejercicio de la Declaracion',
  `administration` tinyint(2) NOT NULL COMMENT 'Administracion',
  `status` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Estado de la Declaracion',
  `security_level` tinyint(2) DEFAULT '0' COMMENT 'Nivel de seguridad',
  `document` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'NIF',
  `name` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre',
  `contact_person` varchar(100) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Persona de Contacto',
  `contact_phone` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Telf. Fijo de Contacto',
  `complementary` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Declaracion complementaria',
  `replacement` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Declaracion sustitutiva',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios de la Declaracion',
  `receipt` varchar(13) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de Declaracion',
  `replaced_receipt` varchar(13) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de declaracion sustituida',
  `receiver_count_total` int(4) NOT NULL DEFAULT '0' COMMENT 'Numero total de perceptores',
  `retention_base_total` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Base de retenciones e ingresos a cuenta',
  `retention_total` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Retenciones e ingresos a cuenta',
  `deposit_retention_total` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Retenciones e ingresos a cuenta ingresados',
  `expenses_total` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Gastos',
  `nature` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Naturaleza del declarante',
  PRIMARY KEY (`id`),
  KEY `IDX_FS_MODEL193_DOMAIN` (`domain`),
  KEY `IDX_FS_MODEL193_ENTERPRISE` (`enterprise`),
  CONSTRAINT `FK_FS_MODEL193_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_FS_MODEL193_ENTERPRISE` FOREIGN KEY (`enterprise`) REFERENCES `enterprise` (`registry`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Declaraciones 193';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fs_model193`
--

LOCK TABLES `fs_model193` WRITE;
/*!40000 ALTER TABLE `fs_model193` DISABLE KEYS */;
/*!40000 ALTER TABLE `fs_model193` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fs_model193_detail`
--

DROP TABLE IF EXISTS `fs_model193_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fs_model193_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `fs_model193` int(4) NOT NULL COMMENT 'Identificador del modelo 193',
  `type` varchar(1) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Tipo de Registro P (perceptor) o G (Gastos), ',
  `document` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'NIF Perceptor',
  `name` varchar(40) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre',
  `representative_document` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'NIF Representante',
  `intermediary_payment` tinyint(1) DEFAULT NULL COMMENT 'Pago a un Mediador',
  `province` int(4) NOT NULL DEFAULT '0' COMMENT 'Provincia',
  `key_code` tinyint(1) DEFAULT NULL COMMENT 'Clave Codigo',
  `issuing_code` varchar(12) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo emisor',
  `key` varchar(1) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Clave de percepcion',
  `nature` varchar(2) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Naturaleza de la percepcion',
  `payment` tinyint(1) DEFAULT NULL COMMENT 'Pago',
  `code_type` varchar(1) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Tipo Codigo',
  `lender_amount` double(15,3) NOT NULL DEFAULT '0.000',
  `account_code` varchar(20) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo de cuenta,Numero id. prestamo',
  `pending` tinyint(1) DEFAULT NULL COMMENT 'Pendiente',
  `accrual_year` int(4) NOT NULL DEFAULT '0',
  `in_kind` tinyint(1) DEFAULT NULL COMMENT 'Percepcion en especie',
  `perception` double(15,3) NOT NULL DEFAULT '0.000',
  `reduction` double(15,3) NOT NULL DEFAULT '0.000',
  `retention_base` double(15,3) NOT NULL DEFAULT '0.000',
  `percent` double(5,3) NOT NULL DEFAULT '0.000',
  `retention` double(15,3) NOT NULL DEFAULT '0.000',
  `deponent_nature` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Naturaleza del declarante',
  `loan_start_date` date DEFAULT NULL COMMENT 'Fecha de inicio del prestamo',
  `loan_due_date` date DEFAULT NULL COMMENT 'Fecha de vencimiento del prestamo',
  `compensation` double(15,3) NOT NULL DEFAULT '0.000',
  `guarantee` double(15,3) NOT NULL DEFAULT '0.000',
  `expenses` double(15,3) NOT NULL DEFAULT '0.000',
  `penalization` double(15,3) DEFAULT '0.000' COMMENT 'Penalizaciones',
  `declarant_nature` tinyint(1) DEFAULT '0' COMMENT 'Naturaleza del declarante',
  PRIMARY KEY (`id`),
  KEY `IDX_FS_MODEL193_DETAIL_DOMAIN` (`domain`),
  KEY `IDX_FS_MODEL193_DETAIL_FS_MODEL193` (`fs_model193`),
  CONSTRAINT `FK_FS_MODEL193_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_FS_MODEL193_DETAIL_FS_MODEL193` FOREIGN KEY (`fs_model193`) REFERENCES `fs_model193` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalles de Declaraciones 193';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fs_model193_detail`
--

LOCK TABLES `fs_model193_detail` WRITE;
/*!40000 ALTER TABLE `fs_model193_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `fs_model193_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fs_model200`
--

DROP TABLE IF EXISTS `fs_model200`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fs_model200` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `enterprise` int(4) NOT NULL COMMENT 'Identificador de la Empresa',
  `year` int(4) NOT NULL COMMENT 'Ejercicio de la Declaracion',
  `administration` tinyint(2) NOT NULL COMMENT 'Administracion',
  `status` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Estado de la Declaracion',
  `document` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'NIF',
  `name` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre',
  `phone1` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Telefono 1',
  `phone2` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Telefono 2',
  `complementary` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Declaracion complementaria',
  `receipt` varchar(13) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de Declaracion',
  `complementary_receipt` varchar(13) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de Declaracion sustituida',
  `cnae` varchar(5) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo CNAE',
  `period_type` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Tipo de periodo',
  `period_start` date NOT NULL COMMENT 'Inicio periodo',
  `period_end` date NOT NULL COMMENT 'Fin periodo',
  `fiscal_group` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de grupo fiscal',
  `dominant_document` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'NIF de la entidad dominante',
  `secretary_document` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'NIF del secretario',
  `secretary_name` varchar(25) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'NIF del secretario',
  `irnr` date DEFAULT NULL COMMENT 'Fecha IRNR',
  `result_type` varchar(1) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT '(D) Devolucion, (I) Ingreso, (C) Cuota cero',
  `dev_type` varchar(1) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT '(R) Renuncia, (T) Transferencia',
  `pay_type` varchar(1) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT '(E) Efectivo, (A) Adeudo',
  `amount` double(15,3) DEFAULT NULL COMMENT 'Importe',
  `iban` varchar(34) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'IBAN',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios de la Declaracion',
  `nrs_anexoIII` varchar(30) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'NRS anexo III',
  `just_canarias` varchar(30) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de justificante Canarias',
  `nrs_anexoIV` varchar(30) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'NRS anexo IV',
  `nrs_anexoV` varchar(30) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'NRS anexo V',
  `bic` char(11) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'BIC - Codigo Identificador del Banco',
  `just_activos` varchar(30) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de justificante activos',
  PRIMARY KEY (`id`),
  KEY `IDX_FS_MODEL200_DOMAIN` (`domain`),
  KEY `IDX_FS_MODEL200_ENTERPRISE` (`enterprise`),
  CONSTRAINT `FK_FS_MODEL200_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_FS_MODEL200_ENTERPRISE` FOREIGN KEY (`enterprise`) REFERENCES `enterprise` (`registry`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Impuesto sobre sociedades';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fs_model200`
--

LOCK TABLES `fs_model200` WRITE;
/*!40000 ALTER TABLE `fs_model200` DISABLE KEYS */;
/*!40000 ALTER TABLE `fs_model200` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fs_model200_detail`
--

DROP TABLE IF EXISTS `fs_model200_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fs_model200_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `fs_model200` int(4) NOT NULL COMMENT 'Identificador del modelo 200',
  `key` varchar(7) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Clave Casilla',
  `value` double(15,3) DEFAULT NULL COMMENT 'Valor de la casilla',
  PRIMARY KEY (`id`),
  KEY `IDX_FS_MODEL200_DETAIL_DOMAIN` (`domain`),
  KEY `IDX_FS_MODEL200_DETAIL_FS_MODEL200` (`fs_model200`),
  CONSTRAINT `FK_FS_MODEL200_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_FS_MODEL200_DETAIL_FS_MODEL200` FOREIGN KEY (`fs_model200`) REFERENCES `fs_model200` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalles Impuesto sobre sociedades';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fs_model200_detail`
--

LOCK TABLES `fs_model200_detail` WRITE;
/*!40000 ALTER TABLE `fs_model200_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `fs_model200_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fs_model200_registry`
--

DROP TABLE IF EXISTS `fs_model200_registry`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fs_model200_registry` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `fs_model200` int(4) NOT NULL COMMENT 'Identificador del modelo 200',
  `document` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'NIF',
  `name` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre',
  `province` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Provincia',
  `country` varchar(2) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Pais',
  `residence` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Residencia',
  `representative` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Representante',
  `type` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Tipo. Administrador/participacion ',
  `percent` double(15,3) DEFAULT NULL COMMENT 'Porcentaje',
  `nominal_value` double(15,3) DEFAULT NULL COMMENT 'Valor Nominal',
  `book_value` double(15,3) DEFAULT NULL COMMENT 'Valor en libros',
  `incomes` double(15,3) DEFAULT NULL COMMENT 'Ingresos por dividendos',
  `a_value` double(15,3) DEFAULT NULL COMMENT 'Correccion de valor',
  `b_value` double(15,3) DEFAULT NULL COMMENT 'Reversion por perdidas',
  `c_value` double(15,3) DEFAULT NULL COMMENT 'Efecto de la correccion',
  `d_value` double(15,3) DEFAULT NULL COMMENT 'Saldo de correcciones',
  `capital` double(15,3) DEFAULT NULL COMMENT 'Capital',
  `reserve` double(15,3) DEFAULT NULL COMMENT 'Reservas',
  `other_amounts` double(15,3) DEFAULT NULL COMMENT 'Otras partidas',
  `result` double(15,3) DEFAULT NULL COMMENT 'Resultado del ultimo ejercicio',
  `notary` varchar(20) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Notaria',
  `notary_date` date DEFAULT NULL COMMENT 'Fecha Notaria',
  `cc_value` double(15,3) DEFAULT NULL COMMENT 'Eliminacion del deterioro contable',
  PRIMARY KEY (`id`),
  KEY `IDX_FS_MODEL200_REGISTRY_DOMAIN` (`domain`),
  KEY `IDX_FS_MODEL200_REGISTRY_FS_MODEL200` (`fs_model200`),
  CONSTRAINT `FK_FS_MODEL200_REGISTRY_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_FS_MODEL200_REGISTRY_FS_MODEL200` FOREIGN KEY (`fs_model200`) REFERENCES `fs_model200` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Adminitradores/participaciones del Impuesto sobre sociedades';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fs_model200_registry`
--

LOCK TABLES `fs_model200_registry` WRITE;
/*!40000 ALTER TABLE `fs_model200_registry` DISABLE KEYS */;
/*!40000 ALTER TABLE `fs_model200_registry` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fs_model390`
--

DROP TABLE IF EXISTS `fs_model390`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fs_model390` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `enterprise` int(4) NOT NULL COMMENT 'Identificador de la Empresa',
  `year` int(4) NOT NULL COMMENT 'Ejercicio de la Declaracion',
  `administration` tinyint(2) NOT NULL COMMENT 'Administracion',
  `status` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Estado de la Declaracion',
  `security_level` tinyint(2) DEFAULT '0' COMMENT 'Nivel de seguridad',
  `document` varchar(9) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'NIF',
  `name` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre',
  `complementary` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Declaracion complementaria',
  `replacement` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Declaracion sustitutiva',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios de la Declaracion',
  `receipt` varchar(13) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de Declaracion',
  `replaced_receipt` varchar(13) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de Declaracion sustituida',
  `model` text COLLATE latin1_spanish_ci COMMENT 'Modelo XML de la Declaracion',
  `response` varchar(30) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Respuesta AEAT',
  PRIMARY KEY (`id`),
  KEY `IDX_FS_MODEL390_DOMAIN` (`domain`),
  KEY `IDX_FS_MODEL390_ENTERPRISE` (`enterprise`),
  CONSTRAINT `FK_FS_MODEL390_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_FS_MODEL390_ENTERPRISE` FOREIGN KEY (`enterprise`) REFERENCES `enterprise` (`registry`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Declaraciones 390';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fs_model390`
--

LOCK TABLES `fs_model390` WRITE;
/*!40000 ALTER TABLE `fs_model390` DISABLE KEYS */;
/*!40000 ALTER TABLE `fs_model390` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fs_model_detail`
--

DROP TABLE IF EXISTS `fs_model_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fs_model_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `fs_model` int(4) NOT NULL COMMENT 'Identificador de la Declaracion',
  `type` varchar(10) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Clave de la Declaracion',
  `description` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion',
  `acu_amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe acumulado',
  `dec_amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe declarado',
  `res_amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe resultado',
  `adj_amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe ajustado',
  `amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe',
  PRIMARY KEY (`id`),
  KEY `IDX_FS_MODEL_DETAIL_DOMAIN` (`domain`),
  KEY `IDX_FS_MODEL_DETAIL_FS_MODEL` (`fs_model`),
  CONSTRAINT `FK_FS_MODEL_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_FS_MODEL_DETAIL_FS_MODEL` FOREIGN KEY (`fs_model`) REFERENCES `fs_model` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalle de Declaraciones Fiscales';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fs_model_detail`
--

LOCK TABLES `fs_model_detail` WRITE;
/*!40000 ALTER TABLE `fs_model_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `fs_model_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fs_vat`
--

DROP TABLE IF EXISTS `fs_vat`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fs_vat` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `year` int(4) NOT NULL COMMENT 'Ejercicio de la Declaracion',
  `period` tinyint(2) DEFAULT '0' COMMENT 'Periodo de la Declaracion',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios de la Declaracion',
  `status` tinyint(2) DEFAULT '0' COMMENT 'Estado de la Declaracion',
  `security_level` tinyint(2) DEFAULT '0' COMMENT 'Nivel de seguridad',
  `complementary` tinyint(1) DEFAULT '0' COMMENT 'Declaracion complementaria',
  `replacement` tinyint(1) DEFAULT '0' COMMENT 'Declaracion sustitutiva',
  `tax_refund_registry` tinyint(1) DEFAULT '0' COMMENT 'Inscrito en registro de devolucion',
  `number` int(4) DEFAULT '0' COMMENT 'Numero de Decl. complementaria o sustitutiva',
  `prorata` double(5,2) DEFAULT '100.00' COMMENT 'Porcentaje de prorrata',
  `replaced_number` varchar(13) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de Declaracion complementada o sustituida',
  PRIMARY KEY (`id`),
  KEY `IDX_FS_VAT_DOMAIN` (`domain`),
  CONSTRAINT `FK_FS_VAT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Declaracion de Iva';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fs_vat`
--

LOCK TABLES `fs_vat` WRITE;
/*!40000 ALTER TABLE `fs_vat` DISABLE KEYS */;
/*!40000 ALTER TABLE `fs_vat` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fs_vat_declaration`
--

DROP TABLE IF EXISTS `fs_vat_declaration`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fs_vat_declaration` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `fs_vat` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador de la Declaracion',
  `without_activity` tinyint(1) DEFAULT '0' COMMENT 'Sin actividad',
  `administration` tinyint(2) DEFAULT '0' COMMENT 'Administracion',
  `percent` double DEFAULT '0' COMMENT 'Porcentaje atribuible',
  `operations_volume` double(15,3) DEFAULT '0.000' COMMENT 'Volumen de operaciones',
  `quota` double(15,3) DEFAULT '0.000' COMMENT 'Cuota atribuible',
  `prev_year_compensate_quota` double(15,3) DEFAULT '0.000' COMMENT 'Cuota a compensar de ejerc. anteriores',
  `done_deposits` double(15,3) DEFAULT '0.000' COMMENT 'Ingresos efectuados',
  `done_refunds` double(15,3) DEFAULT '0.000' COMMENT 'Devoluciones practicadas',
  `extra_charge` double(15,3) DEFAULT '0.000' COMMENT 'Recargo',
  `delay_interest` double(15,3) DEFAULT '0.000' COMMENT 'Intereses de demora',
  `compensate` double(15,3) DEFAULT '0.000' COMMENT 'A compensar',
  `pay_back` double(15,3) DEFAULT '0.000' COMMENT 'A devolver',
  `deposit` double(15,3) DEFAULT '0.000' COMMENT 'A ingresar',
  `prev_deposit` double(15,3) DEFAULT '0.000' COMMENT 'Ingresado anteriormente',
  `prev_pay_back` double(15,3) DEFAULT '0.000' COMMENT 'Devuelto anteriormente',
  `total_tax_debt` double(15,3) DEFAULT '0.000' COMMENT 'Total deuda tributaria',
  `rbank` int(4) DEFAULT NULL COMMENT 'Banco de la Compañia',
  `compensable` tinyint(1) DEFAULT '0' COMMENT 'Compensar o devolver',
  `status` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Estado de la Declaracion',
  PRIMARY KEY (`id`),
  KEY `IDX_FS_VAT_DECLARATION_FS_VAT` (`fs_vat`),
  KEY `IDX_FS_VAT_DECLARATION_RBANK` (`rbank`),
  KEY `IDX_FS_VAT_DECLARATION_DOMAIN` (`domain`),
  CONSTRAINT `FK_FS_VAT_DECLARATION_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_FS_VAT_DECLARATION_FS_VAT` FOREIGN KEY (`fs_vat`) REFERENCES `fs_vat` (`id`),
  CONSTRAINT `FK_FS_VAT_DECLARATION_RBANK` FOREIGN KEY (`rbank`) REFERENCES `rbank` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Resultado de la Declaracion de Iva';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fs_vat_declaration`
--

LOCK TABLES `fs_vat_declaration` WRITE;
/*!40000 ALTER TABLE `fs_vat_declaration` DISABLE KEYS */;
/*!40000 ALTER TABLE `fs_vat_declaration` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `fs_vat_detail`
--

DROP TABLE IF EXISTS `fs_vat_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `fs_vat_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `fs_vat` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador de la Declaracion',
  `vat_key` varchar(3) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Clave de la Declaracion',
  `percent` double DEFAULT '0' COMMENT 'Porcentaje de Iva',
  `taxable_base` double(15,3) DEFAULT '0.000' COMMENT 'Base imponible',
  `quota` double(15,3) DEFAULT '0.000' COMMENT 'Cuota',
  `deductible_quota` double(15,3) DEFAULT '0.000' COMMENT 'Cuota deducible',
  `adj_taxable_base` double(15,3) DEFAULT '0.000' COMMENT 'Base imponible ajustada',
  `adj_quota` double(15,3) DEFAULT '0.000' COMMENT 'Cuota ajustada',
  `adj_deductible_quota` double(15,3) DEFAULT '0.000' COMMENT 'Cuota deducible ajustada',
  `acu_taxable_base` double(15,3) DEFAULT '0.000' COMMENT 'Base imponible acumulada',
  `acu_quota` double(15,3) DEFAULT '0.000' COMMENT 'Cuota acumulada',
  `acu_deductible_quota` double(15,3) DEFAULT '0.000' COMMENT 'Cuota deducible acumulada',
  `dec_taxable_base` double(15,3) DEFAULT '0.000' COMMENT 'Base imponible declarado',
  `dec_quota` double(15,3) DEFAULT '0.000' COMMENT 'Cuota declarado',
  `dec_deductible_quota` double(15,3) DEFAULT '0.000' COMMENT 'Cuota deducible declarado',
  `res_taxable_base` double(15,3) DEFAULT '0.000' COMMENT 'Base imponible resultado',
  `res_quota` double(15,3) DEFAULT '0.000' COMMENT 'Cuota resultado',
  `res_deductible_quota` double(15,3) DEFAULT '0.000' COMMENT 'Cuota deducible resultado',
  PRIMARY KEY (`id`),
  KEY `IDX_FS_VAT_DETAIL_FS_VAT` (`fs_vat`),
  KEY `IDX_FS_VAT_DETAIL_DOMAIN` (`domain`),
  CONSTRAINT `FK_FS_VAT_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_FS_VAT_DETAIL_FS_VAT` FOREIGN KEY (`fs_vat`) REFERENCES `fs_vat` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalle de Declaracion de Iva';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `fs_vat_detail`
--

LOCK TABLES `fs_vat_detail` WRITE;
/*!40000 ALTER TABLE `fs_vat_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `fs_vat_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `geotree`
--

DROP TABLE IF EXISTS `geotree`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `geotree` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `parent` int(4) DEFAULT NULL COMMENT 'Identificador de la Zona Geografica Padre',
  `child` int(4) NOT NULL COMMENT 'Identificador de la Zona Geografica Hijo',
  PRIMARY KEY (`id`),
  KEY `IDX_GEOTREE_PARENT_GEOZONE` (`parent`),
  KEY `IDX_GEOTREE_CHILD_GEOZONE` (`child`),
  KEY `IDX_GEOTREE_DOMAIN` (`domain`),
  CONSTRAINT `FK_GEOTREE_CHILD_GEOZONE` FOREIGN KEY (`child`) REFERENCES `geozone` (`id`),
  CONSTRAINT `FK_GEOTREE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_GEOTREE_PARENT_GEOZONE` FOREIGN KEY (`parent`) REFERENCES `geozone` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=133143 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Jerarquia de Zonas Geograficas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `geotree`
--

LOCK TABLES `geotree` WRITE;
/*!40000 ALTER TABLE `geotree` DISABLE KEYS */;
INSERT INTO `geotree` VALUES (51892,0,52217,52216),(51895,0,NULL,52217),(133037,8776,NULL,133942),(133038,8776,133942,133890),(133039,8776,133942,133891),(133040,8776,133942,133892),(133041,8776,133942,133893),(133042,8776,133942,133894),(133043,8776,133942,133895),(133044,8776,133942,133896),(133045,8776,133942,133897),(133046,8776,133942,133898),(133047,8776,133942,133899),(133048,8776,133942,133900),(133049,8776,133942,133901),(133050,8776,133942,133902),(133051,8776,133942,133903),(133052,8776,133942,133904),(133053,8776,133942,133905),(133054,8776,133942,133906),(133055,8776,133942,133907),(133056,8776,133942,133908),(133057,8776,133942,133909),(133058,8776,133942,133910),(133059,8776,133942,133911),(133060,8776,133942,133912),(133061,8776,133942,133913),(133062,8776,133942,133914),(133063,8776,133942,133915),(133064,8776,133942,133916),(133065,8776,133942,133917),(133066,8776,133942,133918),(133067,8776,133942,133919),(133068,8776,133942,133920),(133069,8776,133942,133921),(133070,8776,133942,133922),(133071,8776,133942,133923),(133072,8776,133942,133924),(133073,8776,133942,133925),(133074,8776,133942,133926),(133075,8776,133942,133927),(133076,8776,133942,133928),(133077,8776,133942,133929),(133078,8776,133942,133930),(133079,8776,133942,133931),(133080,8776,133942,133932),(133081,8776,133942,133933),(133082,8776,133942,133934),(133083,8776,133942,133935),(133084,8776,133942,133936),(133085,8776,133942,133937),(133086,8776,133942,133938),(133087,8776,133942,133939),(133088,8776,133942,133940),(133089,8776,133942,133941),(133090,8779,NULL,133995),(133091,8779,133995,133943),(133092,8779,133995,133944),(133093,8779,133995,133945),(133094,8779,133995,133946),(133095,8779,133995,133947),(133096,8779,133995,133948),(133097,8779,133995,133949),(133098,8779,133995,133950),(133099,8779,133995,133951),(133100,8779,133995,133952),(133101,8779,133995,133953),(133102,8779,133995,133954),(133103,8779,133995,133955),(133104,8779,133995,133956),(133105,8779,133995,133957),(133106,8779,133995,133958),(133107,8779,133995,133959),(133108,8779,133995,133960),(133109,8779,133995,133961),(133110,8779,133995,133962),(133111,8779,133995,133963),(133112,8779,133995,133964),(133113,8779,133995,133965),(133114,8779,133995,133966),(133115,8779,133995,133967),(133116,8779,133995,133968),(133117,8779,133995,133969),(133118,8779,133995,133970),(133119,8779,133995,133971),(133120,8779,133995,133972),(133121,8779,133995,133973),(133122,8779,133995,133974),(133123,8779,133995,133975),(133124,8779,133995,133976),(133125,8779,133995,133977),(133126,8779,133995,133978),(133127,8779,133995,133979),(133128,8779,133995,133980),(133129,8779,133995,133981),(133130,8779,133995,133982),(133131,8779,133995,133983),(133132,8779,133995,133984),(133133,8779,133995,133985),(133134,8779,133995,133986),(133135,8779,133995,133987),(133136,8779,133995,133988),(133137,8779,133995,133989),(133138,8779,133995,133990),(133139,8779,133995,133991),(133140,8779,133995,133992),(133141,8779,133995,133993),(133142,8779,133995,133994);
/*!40000 ALTER TABLE `geotree` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `geozone`
--

DROP TABLE IF EXISTS `geozone`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `geozone` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la Zona Geografica',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre de la Zona Geografica',
  `code` varchar(3) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo de la Zona Geografica',
  `system` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indica si es una Zona Geografica del sistema',
  PRIMARY KEY (`id`),
  KEY `IDX_GEOZONE_DOMAIN` (`domain`),
  CONSTRAINT `FK_GEOZONE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=133996 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Zonas Geograficas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `geozone`
--

LOCK TABLES `geozone` WRITE;
/*!40000 ALTER TABLE `geozone` DISABLE KEYS */;
INSERT INTO `geozone` VALUES (52216,0,'ARABA/ALAVA','01',1),(52217,0,'ESPAÑA','ES',1),(133890,8776,'ARABA/ALAVA','01',1),(133891,8776,'ALBACETE','02',1),(133892,8776,'ALICANTE','03',1),(133893,8776,'ALMERIA','04',1),(133894,8776,'AVILA','05',1),(133895,8776,'BADAJOZ','06',1),(133896,8776,'ILLES BALEARS','07',1),(133897,8776,'BARCELONA','08',1),(133898,8776,'BURGOS','09',1),(133899,8776,'CACERES','10',1),(133900,8776,'CADIZ','11',1),(133901,8776,'CASTELLON','12',1),(133902,8776,'CIUDAD REAL','13',1),(133903,8776,'CORDOBA','14',1),(133904,8776,'A CORUÑA','15',1),(133905,8776,'CUENCA','16',1),(133906,8776,'GIRONA','17',1),(133907,8776,'GRANADA','18',1),(133908,8776,'GUADALAJARA','19',1),(133909,8776,'GIPUZKOA','20',1),(133910,8776,'HUELVA','21',1),(133911,8776,'HUESCA','22',1),(133912,8776,'JAEN','23',1),(133913,8776,'LEON','24',1),(133914,8776,'LLEIDA','25',1),(133915,8776,'LA RIOJA','26',1),(133916,8776,'LUGO','27',1),(133917,8776,'MADRID','28',1),(133918,8776,'MALAGA','29',1),(133919,8776,'MURCIA','30',1),(133920,8776,'NAVARRA','31',1),(133921,8776,'OURENSE','32',1),(133922,8776,'ASTURIAS','33',1),(133923,8776,'PALENCIA','34',1),(133924,8776,'LAS PALMAS','35',1),(133925,8776,'PONTEVEDRA','36',1),(133926,8776,'SALAMANCA','37',1),(133927,8776,'TENERIFE','38',1),(133928,8776,'CANTABRIA','39',1),(133929,8776,'SEGOVIA','40',1),(133930,8776,'SEVILLA','41',1),(133931,8776,'SORIA','42',1),(133932,8776,'TARRAGONA','43',1),(133933,8776,'TERUEL','44',1),(133934,8776,'TOLEDO','45',1),(133935,8776,'VALENCIA','46',1),(133936,8776,'VALLADOLID','47',1),(133937,8776,'BIZKAIA','48',1),(133938,8776,'ZAMORA','49',1),(133939,8776,'ZARAGOZA','50',1),(133940,8776,'CEUTA','51',1),(133941,8776,'MELILLA','52',1),(133942,8776,'ESPAÑA','ES',1),(133943,8779,'ARABA/ALAVA','01',1),(133944,8779,'ALBACETE','02',1),(133945,8779,'ALICANTE','03',1),(133946,8779,'ALMERIA','04',1),(133947,8779,'AVILA','05',1),(133948,8779,'BADAJOZ','06',1),(133949,8779,'ILLES BALEARS','07',1),(133950,8779,'BARCELONA','08',1),(133951,8779,'BURGOS','09',1),(133952,8779,'CACERES','10',1),(133953,8779,'CADIZ','11',1),(133954,8779,'CASTELLON','12',1),(133955,8779,'CIUDAD REAL','13',1),(133956,8779,'CORDOBA','14',1),(133957,8779,'A CORUÑA','15',1),(133958,8779,'CUENCA','16',1),(133959,8779,'GIRONA','17',1),(133960,8779,'GRANADA','18',1),(133961,8779,'GUADALAJARA','19',1),(133962,8779,'GIPUZKOA','20',1),(133963,8779,'HUELVA','21',1),(133964,8779,'HUESCA','22',1),(133965,8779,'JAEN','23',1),(133966,8779,'LEON','24',1),(133967,8779,'LLEIDA','25',1),(133968,8779,'LA RIOJA','26',1),(133969,8779,'LUGO','27',1),(133970,8779,'MADRID','28',1),(133971,8779,'MALAGA','29',1),(133972,8779,'MURCIA','30',1),(133973,8779,'NAVARRA','31',1),(133974,8779,'OURENSE','32',1),(133975,8779,'ASTURIAS','33',1),(133976,8779,'PALENCIA','34',1),(133977,8779,'LAS PALMAS','35',1),(133978,8779,'PONTEVEDRA','36',1),(133979,8779,'SALAMANCA','37',1),(133980,8779,'TENERIFE','38',1),(133981,8779,'CANTABRIA','39',1),(133982,8779,'SEGOVIA','40',1),(133983,8779,'SEVILLA','41',1),(133984,8779,'SORIA','42',1),(133985,8779,'TARRAGONA','43',1),(133986,8779,'TERUEL','44',1),(133987,8779,'TOLEDO','45',1),(133988,8779,'VALENCIA','46',1),(133989,8779,'VALLADOLID','47',1),(133990,8779,'BIZKAIA','48',1),(133991,8779,'ZAMORA','49',1),(133992,8779,'ZARAGOZA','50',1),(133993,8779,'CEUTA','51',1),(133994,8779,'MELILLA','52',1),(133995,8779,'ESPAÑA','ES',1);
/*!40000 ALTER TABLE `geozone` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `geozone_irpf`
--

DROP TABLE IF EXISTS `geozone_irpf`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `geozone_irpf` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `geozone_code` varchar(3) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Codigo de la Zona Geografica',
  `start_date` date NOT NULL COMMENT 'Fecha de inicio ',
  `end_date` date DEFAULT NULL COMMENT 'Fecha de finalizacion',
  `amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe rendimiento anual',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=730 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Tabla de tramos del IRPF';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `geozone_irpf`
--

LOCK TABLES `geozone_irpf` WRITE;
/*!40000 ALTER TABLE `geozone_irpf` DISABLE KEYS */;
INSERT INTO `geozone_irpf` VALUES (440,'01','2013-01-01','2013-12-31',0.010),(441,'01','2013-01-01','2013-12-31',11640.010),(442,'01','2013-01-01','2013-12-31',12110.010),(443,'01','2013-01-01','2013-12-31',12610.010),(444,'01','2013-01-01','2013-12-31',13160.010),(445,'01','2013-01-01','2013-12-31',13760.010),(446,'01','2013-01-01','2013-12-31',14420.010),(447,'01','2013-01-01','2013-12-31',15140.010),(448,'01','2013-01-01','2013-12-31',15930.010),(449,'01','2013-01-01','2013-12-31',17110.010),(450,'01','2013-01-01','2013-12-31',18510.010),(451,'01','2013-01-01','2013-12-31',19850.010),(452,'01','2013-01-01','2013-12-31',21350.010),(453,'01','2013-01-01','2013-12-31',22830.010),(454,'01','2013-01-01','2013-12-31',24220.010),(455,'01','2013-01-01','2013-12-31',26460.010),(456,'01','2013-01-01','2013-12-31',28960.010),(457,'01','2013-01-01','2013-12-31',31970.010),(458,'01','2013-01-01','2013-12-31',35660.010),(459,'01','2013-01-01','2013-12-31',38960.010),(460,'01','2013-01-01','2013-12-31',41850.010),(461,'01','2013-01-01','2013-12-31',44830.010),(462,'01','2013-01-01','2013-12-31',48280.010),(463,'01','2013-01-01','2013-12-31',52170.010),(464,'01','2013-01-01','2013-12-31',55540.010),(465,'01','2013-01-01','2013-12-31',59220.010),(466,'01','2013-01-01','2013-12-31',63450.010),(467,'01','2013-01-01','2013-12-31',68290.010),(468,'01','2013-01-01','2013-12-31',73500.010),(469,'01','2013-01-01','2013-12-31',78090.010),(470,'01','2013-01-01','2013-12-31',83270.010),(471,'01','2013-01-01','2013-12-31',89200.010),(472,'01','2013-01-01','2013-12-31',96040.010),(473,'01','2013-01-01','2013-12-31',104010.010),(474,'01','2013-01-01','2013-12-31',113060.010),(475,'01','2013-01-01','2013-12-31',124210.010),(476,'01','2013-01-01','2013-12-31',137810.010),(477,'01','2013-01-01','2013-12-31',154600.010),(478,'01','2013-01-01','2013-12-31',175220.010),(479,'01','2013-01-01','2013-12-31',202170.010),(480,'01','2013-01-01','2013-12-31',238930.010),(481,'48','2013-01-01','2013-12-31',0.010),(482,'48','2013-01-01','2013-12-31',11640.010),(483,'48','2013-01-01','2013-12-31',12110.010),(484,'48','2013-01-01','2013-12-31',12610.010),(485,'48','2013-01-01','2013-12-31',13160.010),(486,'48','2013-01-01','2013-12-31',13760.010),(487,'48','2013-01-01','2013-12-31',14420.010),(488,'48','2013-01-01','2013-12-31',15140.010),(489,'48','2013-01-01','2013-12-31',15930.010),(490,'48','2013-01-01','2013-12-31',17110.010),(491,'48','2013-01-01','2013-12-31',18510.010),(492,'48','2013-01-01','2013-12-31',19850.010),(493,'48','2013-01-01','2013-12-31',21350.010),(494,'48','2013-01-01','2013-12-31',22830.010),(495,'48','2013-01-01','2013-12-31',24220.010),(496,'48','2013-01-01','2013-12-31',26460.010),(497,'48','2013-01-01','2013-12-31',28960.010),(498,'48','2013-01-01','2013-12-31',31970.010),(499,'48','2013-01-01','2013-12-31',35660.010),(500,'48','2013-01-01','2013-12-31',38960.010),(501,'48','2013-01-01','2013-12-31',41850.010),(502,'48','2013-01-01','2013-12-31',44830.010),(503,'48','2013-01-01','2013-12-31',48280.010),(504,'48','2013-01-01','2013-12-31',52170.010),(505,'48','2013-01-01','2013-12-31',55540.010),(506,'48','2013-01-01','2013-12-31',59220.010),(507,'48','2013-01-01','2013-12-31',63450.010),(508,'48','2013-01-01','2013-12-31',68290.010),(509,'48','2013-01-01','2013-12-31',73500.010),(510,'48','2013-01-01','2013-12-31',78090.010),(511,'48','2013-01-01','2013-12-31',83270.010),(512,'48','2013-01-01','2013-12-31',89200.010),(513,'48','2013-01-01','2013-12-31',96040.010),(514,'48','2013-01-01','2013-12-31',104010.010),(515,'48','2013-01-01','2013-12-31',113060.010),(516,'48','2013-01-01','2013-12-31',124210.010),(517,'48','2013-01-01','2013-12-31',137810.010),(518,'48','2013-01-01','2013-12-31',154600.010),(519,'48','2013-01-01','2013-12-31',175220.010),(520,'48','2013-01-01','2013-12-31',202170.010),(521,'48','2013-01-01','2013-12-31',238930.010),(522,'20','2013-01-01','2013-12-31',0.000),(523,'20','2013-01-01','2013-12-31',11640.010),(524,'20','2013-01-01','2013-12-31',12110.010),(525,'20','2013-01-01','2013-12-31',12610.010),(526,'20','2013-01-01','2013-12-31',13160.010),(527,'20','2013-01-01','2013-12-31',13760.010),(528,'20','2013-01-01','2013-12-31',14420.010),(529,'20','2013-01-01','2013-12-31',15140.010),(530,'20','2013-01-01','2013-12-31',15930.010),(531,'20','2013-01-01','2013-12-31',17110.010),(532,'20','2013-01-01','2013-12-31',18510.010),(533,'20','2013-01-01','2013-12-31',19850.010),(534,'20','2013-01-01','2013-12-31',21350.010),(535,'20','2013-01-01','2013-12-31',22830.010),(536,'20','2013-01-01','2013-12-31',24220.010),(537,'20','2013-01-01','2013-12-31',26460.010),(538,'20','2013-01-01','2013-12-31',28960.010),(539,'20','2013-01-01','2013-12-31',31970.010),(540,'20','2013-01-01','2013-12-31',35660.010),(541,'20','2013-01-01','2013-12-31',38960.010),(542,'20','2013-01-01','2013-12-31',41850.010),(543,'20','2013-01-01','2013-12-31',44830.010),(544,'20','2013-01-01','2013-12-31',48280.010),(545,'20','2013-01-01','2013-12-31',52170.010),(546,'20','2013-01-01','2013-12-31',55540.010),(547,'20','2013-01-01','2013-12-31',59220.010),(548,'20','2013-01-01','2013-12-31',63450.010),(549,'20','2013-01-01','2013-12-31',68290.010),(550,'20','2013-01-01','2013-12-31',73500.010),(551,'20','2013-01-01','2013-12-31',78090.010),(552,'20','2013-01-01','2013-12-31',83270.010),(553,'20','2013-01-01','2013-12-31',89200.010),(554,'20','2013-01-01','2013-12-31',96040.010),(555,'20','2013-01-01','2013-12-31',104010.010),(556,'20','2013-01-01','2013-12-31',113060.010),(557,'20','2013-01-01','2013-12-31',124210.010),(558,'20','2013-01-01','2013-12-31',137810.010),(559,'20','2013-01-01','2013-12-31',154600.010),(560,'20','2013-01-01','2013-12-31',175220.010),(561,'20','2013-01-01','2013-12-31',202170.010),(562,'20','2013-01-01','2013-12-31',238930.010),(563,'31','2013-01-01','2013-12-31',11250.010),(564,'31','2013-01-01','2013-12-31',12750.010),(565,'31','2013-01-01','2013-12-31',14250.010),(566,'31','2013-01-01','2013-12-31',16750.010),(567,'31','2013-01-01','2013-12-31',19750.010),(568,'31','2013-01-01','2013-12-31',23250.010),(569,'31','2013-01-01','2013-12-31',25750.010),(570,'31','2013-01-01','2013-12-31',28250.010),(571,'31','2013-01-01','2013-12-31',32250.010),(572,'31','2013-01-01','2013-12-31',35750.010),(573,'31','2013-01-01','2013-12-31',41250.010),(574,'31','2013-01-01','2013-12-31',48000.010),(575,'31','2013-01-01','2013-12-31',55000.010),(576,'31','2013-01-01','2013-12-31',62000.010),(577,'31','2013-01-01','2013-12-31',69250.010),(578,'31','2013-01-01','2013-12-31',75250.010),(579,'31','2013-01-01','2013-12-31',82250.010),(580,'31','2013-01-01','2013-12-31',94750.010),(581,'31','2013-01-01','2013-12-31',107250.010),(582,'31','2013-01-01','2013-12-31',120000.010),(583,'31','2013-01-01','2013-12-31',132750.010),(584,'31','2013-01-01','2013-12-31',146000.010),(585,'48','2014-01-01','2017-12-31',0.010),(586,'48','2014-01-01','2017-12-31',11690.010),(587,'48','2014-01-01','2017-12-31',12160.010),(588,'48','2014-01-01','2017-12-31',12670.010),(589,'48','2014-01-01','2017-12-31',13220.010),(590,'48','2014-01-01','2017-12-31',13820.010),(591,'48','2014-01-01','2017-12-31',14480.010),(592,'48','2014-01-01','2017-12-31',15210.010),(593,'48','2014-01-01','2017-12-31',16010.010),(594,'48','2014-01-01','2017-12-31',17210.010),(595,'48','2014-01-01','2017-12-31',18620.010),(596,'48','2014-01-01','2017-12-31',19960.010),(597,'48','2014-01-01','2017-12-31',21470.010),(598,'48','2014-01-01','2017-12-31',22960.010),(599,'48','2014-01-01','2017-12-31',24350.010),(600,'48','2014-01-01','2017-12-31',26650.010),(601,'48','2014-01-01','2017-12-31',29160.010),(602,'48','2014-01-01','2017-12-31',32190.010),(603,'48','2014-01-01','2017-12-31',36300.010),(604,'48','2014-01-01','2017-12-31',39270.010),(605,'48','2014-01-01','2017-12-31',42310.010),(606,'48','2014-01-01','2017-12-31',45450.010),(607,'48','2014-01-01','2017-12-31',48950.010),(608,'48','2014-01-01','2017-12-31',52900.010),(609,'48','2014-01-01','2017-12-31',56270.010),(610,'48','2014-01-01','2017-12-31',60000.010),(611,'48','2014-01-01','2017-12-31',64280.010),(612,'48','2014-01-01','2017-12-31',69190.010),(613,'48','2014-01-01','2017-12-31',74420.010),(614,'48','2014-01-01','2017-12-31',79070.010),(615,'48','2014-01-01','2017-12-31',84310.010),(616,'48','2014-01-01','2017-12-31',90320.010),(617,'48','2014-01-01','2017-12-31',97240.010),(618,'48','2014-01-01','2017-12-31',104860.010),(619,'48','2014-01-01','2017-12-31',113250.010),(620,'48','2014-01-01','2017-12-31',123460.010),(621,'48','2014-01-01','2017-12-31',135230.010),(622,'48','2014-01-01','2017-12-31',148600.010),(623,'48','2014-01-01','2017-12-31',164240.010),(624,'48','2014-01-01','2017-12-31',183560.010),(625,'48','2014-01-01','2017-12-31',203570.010),(626,'20','2014-01-01','2017-12-31',0.000),(627,'20','2014-01-01','2017-12-31',11690.010),(628,'20','2014-01-01','2017-12-31',12160.010),(629,'20','2014-01-01','2017-12-31',12670.010),(630,'20','2014-01-01','2017-12-31',13220.010),(631,'20','2014-01-01','2017-12-31',13820.010),(632,'20','2014-01-01','2017-12-31',14480.010),(633,'20','2014-01-01','2017-12-31',15210.010),(634,'20','2014-01-01','2017-12-31',16010.010),(635,'20','2014-01-01','2017-12-31',17210.010),(636,'20','2014-01-01','2017-12-31',18620.010),(637,'20','2014-01-01','2017-12-31',19960.010),(638,'20','2014-01-01','2017-12-31',21470.010),(639,'20','2014-01-01','2017-12-31',22960.010),(640,'20','2014-01-01','2017-12-31',24350.010),(641,'20','2014-01-01','2017-12-31',26650.010),(642,'20','2014-01-01','2017-12-31',29160.010),(643,'20','2014-01-01','2017-12-31',32190.010),(644,'20','2014-01-01','2017-12-31',36300.010),(645,'20','2014-01-01','2017-12-31',39270.010),(646,'20','2014-01-01','2017-12-31',42310.010),(647,'20','2014-01-01','2017-12-31',45450.010),(648,'20','2014-01-01','2017-12-31',48950.010),(649,'20','2014-01-01','2017-12-31',52900.010),(650,'20','2014-01-01','2017-12-31',56270.010),(651,'20','2014-01-01','2017-12-31',60000.010),(652,'20','2014-01-01','2017-12-31',64280.010),(653,'20','2014-01-01','2017-12-31',69190.010),(654,'20','2014-01-01','2017-12-31',74420.010),(655,'20','2014-01-01','2017-12-31',79070.010),(656,'20','2014-01-01','2017-12-31',84310.010),(657,'20','2014-01-01','2017-12-31',90320.010),(658,'20','2014-01-01','2017-12-31',97240.010),(659,'20','2014-01-01','2017-12-31',104860.010),(660,'20','2014-01-01','2017-12-31',113250.010),(661,'20','2014-01-01','2017-12-31',123460.010),(662,'20','2014-01-01','2017-12-31',135230.010),(663,'20','2014-01-01','2017-12-31',148600.010),(664,'20','2014-01-01','2017-12-31',164240.010),(665,'20','2014-01-01','2017-12-31',183560.010),(666,'20','2014-01-01','2017-12-31',203570.010),(667,'01','2014-01-01','2017-12-31',0.000),(668,'01','2014-01-01','2017-12-31',11690.010),(669,'01','2014-01-01','2017-12-31',12160.010),(670,'01','2014-01-01','2017-12-31',12670.010),(671,'01','2014-01-01','2017-12-31',13220.010),(672,'01','2014-01-01','2017-12-31',13820.010),(673,'01','2014-01-01','2017-12-31',14480.010),(674,'01','2014-01-01','2017-12-31',15210.010),(675,'01','2014-01-01','2017-12-31',16010.010),(676,'01','2014-01-01','2017-12-31',17210.010),(677,'01','2014-01-01','2017-12-31',18620.010),(678,'01','2014-01-01','2017-12-31',19960.010),(679,'01','2014-01-01','2017-12-31',21470.010),(680,'01','2014-01-01','2017-12-31',22960.010),(681,'01','2014-01-01','2017-12-31',24350.010),(682,'01','2014-01-01','2017-12-31',26650.010),(683,'01','2014-01-01','2017-12-31',29160.010),(684,'01','2014-01-01','2017-12-31',32190.010),(685,'01','2014-01-01','2017-12-31',36300.010),(686,'01','2014-01-01','2017-12-31',39270.010),(687,'01','2014-01-01','2017-12-31',42310.010),(688,'01','2014-01-01','2017-12-31',45450.010),(689,'01','2014-01-01','2017-12-31',48950.010),(690,'01','2014-01-01','2017-12-31',52900.010),(691,'01','2014-01-01','2017-12-31',56270.010),(692,'01','2014-01-01','2017-12-31',60000.010),(693,'01','2014-01-01','2017-12-31',64280.010),(694,'01','2014-01-01','2017-12-31',69190.010),(695,'01','2014-01-01','2017-12-31',74420.010),(696,'01','2014-01-01','2017-12-31',79070.010),(697,'01','2014-01-01','2017-12-31',84310.010),(698,'01','2014-01-01','2017-12-31',90320.010),(699,'01','2014-01-01','2017-12-31',97240.010),(700,'01','2014-01-01','2017-12-31',104860.010),(701,'01','2014-01-01','2017-12-31',113250.010),(702,'01','2014-01-01','2017-12-31',123460.010),(703,'01','2014-01-01','2017-12-31',135230.010),(704,'01','2014-01-01','2017-12-31',148600.010),(705,'01','2014-01-01','2017-12-31',164240.010),(706,'01','2014-01-01','2017-12-31',183560.010),(707,'01','2014-01-01','2017-12-31',203570.010),(708,'31','2014-01-01','2017-12-31',11250.010),(709,'31','2014-01-01','2017-12-31',12750.010),(710,'31','2014-01-01','2017-12-31',14250.010),(711,'31','2014-01-01','2017-12-31',16750.010),(712,'31','2014-01-01','2017-12-31',19750.010),(713,'31','2014-01-01','2017-12-31',23250.010),(714,'31','2014-01-01','2017-12-31',25750.010),(715,'31','2014-01-01','2017-12-31',28250.010),(716,'31','2014-01-01','2017-12-31',32250.010),(717,'31','2014-01-01','2017-12-31',35750.010),(718,'31','2014-01-01','2017-12-31',41250.010),(719,'31','2014-01-01','2017-12-31',48000.010),(720,'31','2014-01-01','2017-12-31',55000.010),(721,'31','2014-01-01','2017-12-31',62000.010),(722,'31','2014-01-01','2017-12-31',69250.010),(723,'31','2014-01-01','2017-12-31',75250.010),(724,'31','2014-01-01','2017-12-31',82250.010),(725,'31','2014-01-01','2017-12-31',94750.010),(726,'31','2014-01-01','2017-12-31',107250.010),(727,'31','2014-01-01','2017-12-31',120000.010),(728,'31','2014-01-01','2017-12-31',132750.010),(729,'31','2014-01-01','2017-12-31',146000.010);
/*!40000 ALTER TABLE `geozone_irpf` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `geozone_irpf_descendant`
--

DROP TABLE IF EXISTS `geozone_irpf_descendant`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `geozone_irpf_descendant` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `geozone_irpf` int(4) DEFAULT NULL COMMENT 'Identificador del tramo de IRPF',
  `descendant` tinyint(2) DEFAULT '0' COMMENT 'Descendientes',
  `percent` double(15,2) DEFAULT '0.00' COMMENT 'Porcentaje',
  PRIMARY KEY (`id`),
  KEY `IDX_GEOZONE_IRPF_DESCENDANT_GEOZONE_IRPF` (`geozone_irpf`),
  CONSTRAINT `FK_GEOZONE_IRPF_DESCENDANT_GEOZONE_IRPF` FOREIGN KEY (`geozone_irpf`) REFERENCES `geozone_irpf` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5474 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Tabla de porcentajes IRPF segun descendientes';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `geozone_irpf_descendant`
--

LOCK TABLES `geozone_irpf_descendant` WRITE;
/*!40000 ALTER TABLE `geozone_irpf_descendant` DISABLE KEYS */;
INSERT INTO `geozone_irpf_descendant` VALUES (3290,440,0,0.00),(3291,441,0,1.00),(3292,442,0,2.00),(3293,443,0,3.00),(3294,444,0,4.00),(3295,445,0,5.00),(3296,446,0,6.00),(3297,447,0,7.00),(3298,448,0,8.00),(3299,449,0,9.00),(3300,450,0,10.00),(3301,451,0,11.00),(3302,452,0,12.00),(3303,453,0,13.00),(3304,454,0,14.00),(3305,455,0,15.00),(3306,456,0,16.00),(3307,457,0,17.00),(3308,458,0,18.00),(3309,459,0,19.00),(3310,460,0,20.00),(3311,461,0,21.00),(3312,462,0,22.00),(3313,463,0,23.00),(3314,464,0,24.00),(3315,465,0,25.00),(3316,466,0,26.00),(3317,467,0,27.00),(3318,468,0,28.00),(3319,469,0,29.00),(3320,470,0,30.00),(3321,471,0,31.00),(3322,472,0,32.00),(3323,473,0,33.00),(3324,474,0,34.00),(3325,475,0,35.00),(3326,476,0,36.00),(3327,477,0,37.00),(3328,478,0,38.00),(3329,479,0,39.00),(3330,480,0,40.00),(3331,481,0,0.00),(3332,482,0,1.00),(3333,483,0,2.00),(3334,484,0,3.00),(3335,485,0,4.00),(3336,486,0,5.00),(3337,487,0,6.00),(3338,488,0,7.00),(3339,489,0,8.00),(3340,490,0,9.00),(3341,491,0,10.00),(3342,492,0,11.00),(3343,493,0,12.00),(3344,494,0,13.00),(3345,495,0,14.00),(3346,496,0,15.00),(3347,497,0,16.00),(3348,498,0,17.00),(3349,499,0,18.00),(3350,500,0,19.00),(3351,501,0,20.00),(3352,502,0,21.00),(3353,503,0,22.00),(3354,504,0,23.00),(3355,505,0,24.00),(3356,506,0,25.00),(3357,507,0,26.00),(3358,508,0,27.00),(3359,509,0,28.00),(3360,510,0,29.00),(3361,511,0,30.00),(3362,512,0,31.00),(3363,513,0,32.00),(3364,514,0,33.00),(3365,515,0,34.00),(3366,516,0,35.00),(3367,517,0,36.00),(3368,518,0,37.00),(3369,519,0,38.00),(3370,520,0,39.00),(3371,521,0,40.00),(3372,NULL,0,0.00),(3373,523,0,1.00),(3374,524,0,2.00),(3375,525,0,3.00),(3376,526,0,4.00),(3377,527,0,5.00),(3378,528,0,6.00),(3379,529,0,7.00),(3380,530,0,8.00),(3381,531,0,9.00),(3382,532,0,10.00),(3383,533,0,11.00),(3384,534,0,12.00),(3385,535,0,13.00),(3386,536,0,14.00),(3387,537,0,15.00),(3388,538,0,16.00),(3389,539,0,17.00),(3390,540,0,18.00),(3391,541,0,19.00),(3392,542,0,20.00),(3393,543,0,21.00),(3394,544,0,22.00),(3395,545,0,23.00),(3396,546,0,24.00),(3397,547,0,25.00),(3398,548,0,26.00),(3399,549,0,27.00),(3400,550,0,28.00),(3401,551,0,29.00),(3402,552,0,30.00),(3403,553,0,31.00),(3404,554,0,32.00),(3405,555,0,33.00),(3406,556,0,34.00),(3407,557,0,35.00),(3408,558,0,36.00),(3409,559,0,37.00),(3410,560,0,38.00),(3411,561,0,39.00),(3412,562,0,40.00),(3413,563,0,4.10),(3414,564,0,6.20),(3415,565,0,8.20),(3416,566,0,10.20),(3417,567,0,12.30),(3418,568,0,13.80),(3419,569,0,14.90),(3420,570,0,16.00),(3421,571,0,17.10),(3422,572,0,18.20),(3423,573,0,19.40),(3424,574,0,21.50),(3425,575,0,24.10),(3426,576,0,26.10),(3427,577,0,28.30),(3428,578,0,29.40),(3429,579,0,30.50),(3430,580,0,31.70),(3431,581,0,33.90),(3432,582,0,35.10),(3433,583,0,35.80),(3434,584,0,36.40),(3435,440,1,0.00),(3436,441,1,0.00),(3437,442,1,0.00),(3438,443,1,1.00),(3439,444,1,2.00),(3440,445,1,3.00),(3441,446,1,4.00),(3442,447,1,5.00),(3443,448,1,6.00),(3444,449,1,7.00),(3445,450,1,9.00),(3446,451,1,10.00),(3447,452,1,11.00),(3448,453,1,12.00),(3449,454,1,13.00),(3450,455,1,14.00),(3451,456,1,15.00),(3452,457,1,16.00),(3453,458,1,17.00),(3454,459,1,18.00),(3455,460,1,19.00),(3456,461,1,20.00),(3457,462,1,21.00),(3458,463,1,22.00),(3459,464,1,23.00),(3460,465,1,25.00),(3461,466,1,26.00),(3462,467,1,27.00),(3463,468,1,28.00),(3464,469,1,29.00),(3465,470,1,30.00),(3466,471,1,31.00),(3467,472,1,32.00),(3468,473,1,33.00),(3469,474,1,34.00),(3470,475,1,35.00),(3471,476,1,36.00),(3472,477,1,37.00),(3473,478,1,38.00),(3474,479,1,39.00),(3475,480,1,40.00),(3476,481,1,0.00),(3477,482,1,0.00),(3478,483,1,0.00),(3479,484,1,1.00),(3480,485,1,2.00),(3481,486,1,3.00),(3482,487,1,4.00),(3483,488,1,5.00),(3484,489,1,6.00),(3485,490,1,7.00),(3486,491,1,9.00),(3487,492,1,10.00),(3488,493,1,11.00),(3489,494,1,12.00),(3490,495,1,13.00),(3491,496,1,14.00),(3492,497,1,15.00),(3493,498,1,16.00),(3494,499,1,17.00),(3495,500,1,18.00),(3496,501,1,19.00),(3497,502,1,20.00),(3498,503,1,21.00),(3499,504,1,22.00),(3500,505,1,23.00),(3501,506,1,25.00),(3502,507,1,26.00),(3503,508,1,27.00),(3504,509,1,28.00),(3505,510,1,29.00),(3506,511,1,30.00),(3507,512,1,31.00),(3508,513,1,32.00),(3509,514,1,33.00),(3510,515,1,34.00),(3511,516,1,35.00),(3512,517,1,36.00),(3513,518,1,37.00),(3514,519,1,38.00),(3515,520,1,39.00),(3516,521,1,40.00),(3517,NULL,1,0.00),(3518,523,1,0.00),(3519,524,1,0.00),(3520,525,1,1.00),(3521,526,1,2.00),(3522,527,1,3.00),(3523,528,1,4.00),(3524,529,1,5.00),(3525,530,1,6.00),(3526,531,1,7.00),(3527,532,1,9.00),(3528,533,1,10.00),(3529,534,1,11.00),(3530,535,1,12.00),(3531,536,1,13.00),(3532,537,1,14.00),(3533,538,1,15.00),(3534,539,1,16.00),(3535,540,1,17.00),(3536,541,1,18.00),(3537,542,1,19.00),(3538,543,1,20.00),(3539,544,1,21.00),(3540,545,1,22.00),(3541,546,1,23.00),(3542,547,1,25.00),(3543,548,1,26.00),(3544,549,1,27.00),(3545,550,1,28.00),(3546,551,1,29.00),(3547,552,1,30.00),(3548,553,1,31.00),(3549,554,1,32.00),(3550,555,1,33.00),(3551,556,1,34.00),(3552,557,1,35.00),(3553,558,1,36.00),(3554,559,1,37.00),(3555,560,1,38.00),(3556,561,1,39.00),(3557,562,1,40.00),(3558,563,1,2.00),(3559,564,1,4.10),(3560,565,1,6.20),(3561,566,1,8.20),(3562,567,1,11.30),(3563,568,1,12.30),(3564,569,1,13.40),(3565,570,1,14.50),(3566,571,1,15.60),(3567,572,1,17.20),(3568,573,1,18.30),(3569,574,1,21.50),(3570,575,1,23.50),(3571,576,1,25.50),(3572,577,1,27.70),(3573,578,1,29.40),(3574,579,1,30.50),(3575,580,1,31.70),(3576,581,1,33.90),(3577,582,1,35.10),(3578,583,1,35.70),(3579,584,1,36.40),(3580,440,2,0.00),(3581,441,2,0.00),(3582,442,2,0.00),(3583,443,2,0.00),(3584,444,2,0.00),(3585,445,2,0.00),(3586,446,2,2.00),(3587,447,2,3.00),(3588,448,2,4.00),(3589,449,2,5.00),(3590,450,2,7.00),(3591,451,2,8.00),(3592,452,2,9.00),(3593,453,2,10.00),(3594,454,2,11.00),(3595,455,2,13.00),(3596,456,2,14.00),(3597,457,2,15.00),(3598,458,2,16.00),(3599,459,2,17.00),(3600,460,2,18.00),(3601,461,2,20.00),(3602,462,2,21.00),(3603,463,2,22.00),(3604,464,2,23.00),(3605,465,2,24.00),(3606,466,2,25.00),(3607,467,2,26.00),(3608,468,2,27.00),(3609,469,2,28.00),(3610,470,2,29.00),(3611,471,2,30.00),(3612,472,2,31.00),(3613,473,2,32.00),(3614,474,2,33.00),(3615,475,2,35.00),(3616,476,2,36.00),(3617,477,2,37.00),(3618,478,2,38.00),(3619,479,2,39.00),(3620,480,2,40.00),(3621,481,2,0.00),(3622,482,2,0.00),(3623,483,2,0.00),(3624,484,2,0.00),(3625,485,2,0.00),(3626,486,2,0.00),(3627,487,2,2.00),(3628,488,2,3.00),(3629,489,2,4.00),(3630,490,2,5.00),(3631,491,2,7.00),(3632,492,2,8.00),(3633,493,2,9.00),(3634,494,2,10.00),(3635,495,2,11.00),(3636,496,2,13.00),(3637,497,2,14.00),(3638,498,2,15.00),(3639,499,2,16.00),(3640,500,2,17.00),(3641,501,2,18.00),(3642,502,2,20.00),(3643,503,2,21.00),(3644,504,2,22.00),(3645,505,2,23.00),(3646,506,2,24.00),(3647,507,2,25.00),(3648,508,2,26.00),(3649,509,2,27.00),(3650,510,2,28.00),(3651,511,2,29.00),(3652,512,2,30.00),(3653,513,2,31.00),(3654,514,2,32.00),(3655,515,2,33.00),(3656,516,2,35.00),(3657,517,2,36.00),(3658,518,2,37.00),(3659,519,2,38.00),(3660,520,2,39.00),(3661,521,2,40.00),(3662,NULL,2,0.00),(3663,523,2,0.00),(3664,524,2,0.00),(3665,525,2,0.00),(3666,526,2,0.00),(3667,527,2,0.00),(3668,528,2,2.00),(3669,529,2,3.00),(3670,530,2,4.00),(3671,531,2,5.00),(3672,532,2,7.00),(3673,533,2,8.00),(3674,534,2,9.00),(3675,535,2,10.00),(3676,536,2,11.00),(3677,537,2,13.00),(3678,538,2,14.00),(3679,539,2,15.00),(3680,540,2,16.00),(3681,541,2,17.00),(3682,542,2,18.00),(3683,543,2,20.00),(3684,544,2,21.00),(3685,545,2,22.00),(3686,546,2,23.00),(3687,547,2,24.00),(3688,548,2,25.00),(3689,549,2,26.00),(3690,550,2,27.00),(3691,551,2,28.00),(3692,552,2,29.00),(3693,553,2,30.00),(3694,554,2,31.00),(3695,555,2,32.00),(3696,556,2,33.00),(3697,557,2,35.00),(3698,558,2,36.00),(3699,559,2,37.00),(3700,560,2,38.00),(3701,561,2,39.00),(3702,562,2,40.00),(3703,563,2,0.00),(3704,564,2,2.10),(3705,565,2,4.10),(3706,566,2,6.20),(3707,567,2,9.70),(3708,568,2,11.80),(3709,569,2,12.80),(3710,570,2,13.90),(3711,571,2,15.10),(3712,572,2,17.10),(3713,573,2,18.30),(3714,574,2,20.90),(3715,575,2,23.00),(3716,576,2,24.50),(3717,577,2,27.20),(3718,578,2,28.30),(3719,579,2,30.50),(3720,580,2,31.70),(3721,581,2,33.90),(3722,582,2,34.60),(3723,583,2,35.20),(3724,584,2,36.40),(3725,440,3,0.00),(3726,441,3,0.00),(3727,442,3,0.00),(3728,443,3,0.00),(3729,444,3,0.00),(3730,445,3,0.00),(3731,446,3,0.00),(3732,447,3,0.00),(3733,448,3,1.00),(3734,449,3,2.00),(3735,450,3,4.00),(3736,451,3,5.00),(3737,452,3,6.00),(3738,453,3,8.00),(3739,454,3,9.00),(3740,455,3,10.00),(3741,456,3,12.00),(3742,457,3,13.00),(3743,458,3,15.00),(3744,459,3,16.00),(3745,460,3,17.00),(3746,461,3,18.00),(3747,462,3,19.00),(3748,463,3,21.00),(3749,464,3,22.00),(3750,465,3,23.00),(3751,466,3,24.00),(3752,467,3,25.00),(3753,468,3,26.00),(3754,469,3,27.00),(3755,470,3,29.00),(3756,471,3,30.00),(3757,472,3,31.00),(3758,473,3,32.00),(3759,474,3,33.00),(3760,475,3,34.00),(3761,476,3,35.00),(3762,477,3,36.00),(3763,478,3,37.00),(3764,479,3,38.00),(3765,480,3,40.00),(3766,481,3,0.00),(3767,482,3,0.00),(3768,483,3,0.00),(3769,484,3,0.00),(3770,485,3,0.00),(3771,486,3,0.00),(3772,487,3,0.00),(3773,488,3,0.00),(3774,489,3,1.00),(3775,490,3,2.00),(3776,491,3,4.00),(3777,492,3,5.00),(3778,493,3,6.00),(3779,494,3,8.00),(3780,495,3,9.00),(3781,496,3,10.00),(3782,497,3,12.00),(3783,498,3,13.00),(3784,499,3,15.00),(3785,500,3,16.00),(3786,501,3,17.00),(3787,502,3,18.00),(3788,503,3,19.00),(3789,504,3,21.00),(3790,505,3,22.00),(3791,506,3,23.00),(3792,507,3,24.00),(3793,508,3,25.00),(3794,509,3,26.00),(3795,510,3,27.00),(3796,511,3,29.00),(3797,512,3,30.00),(3798,513,3,31.00),(3799,514,3,32.00),(3800,515,3,33.00),(3801,516,3,34.00),(3802,517,3,35.00),(3803,518,3,36.00),(3804,519,3,37.00),(3805,520,3,38.00),(3806,521,3,39.00),(3807,NULL,3,0.00),(3808,523,3,0.00),(3809,524,3,0.00),(3810,525,3,0.00),(3811,526,3,0.00),(3812,527,3,0.00),(3813,528,3,0.00),(3814,529,3,0.00),(3815,530,3,1.00),(3816,531,3,2.00),(3817,532,3,4.00),(3818,533,3,5.00),(3819,534,3,6.00),(3820,535,3,8.00),(3821,536,3,9.00),(3822,537,3,10.00),(3823,538,3,12.00),(3824,539,3,13.00),(3825,540,3,15.00),(3826,541,3,16.00),(3827,542,3,17.00),(3828,543,3,18.00),(3829,544,3,19.00),(3830,545,3,21.00),(3831,546,3,22.00),(3832,547,3,23.00),(3833,548,3,24.00),(3834,549,3,25.00),(3835,550,3,26.00),(3836,551,3,27.00),(3837,552,3,29.00),(3838,553,3,30.00),(3839,554,3,31.00),(3840,555,3,32.00),(3841,556,3,33.00),(3842,557,3,34.00),(3843,558,3,35.00),(3844,559,3,36.00),(3845,560,3,37.00),(3846,561,3,38.00),(3847,562,3,39.00),(3848,563,3,0.00),(3849,564,3,0.10),(3850,565,3,2.10),(3851,566,3,4.20),(3852,567,3,8.20),(3853,568,3,9.20),(3854,569,3,10.30),(3855,570,3,12.40),(3856,571,3,13.50),(3857,572,3,14.60),(3858,573,3,16.70),(3859,574,3,18.90),(3860,575,3,21.50),(3861,576,3,24.50),(3862,577,3,26.60),(3863,578,3,27.30),(3864,579,3,29.40),(3865,580,3,30.60),(3866,581,3,32.90),(3867,582,3,34.00),(3868,583,3,34.70),(3869,584,3,35.80),(3870,440,4,0.00),(3871,441,4,0.00),(3872,442,4,0.00),(3873,443,4,0.00),(3874,444,4,0.00),(3875,445,4,0.00),(3876,446,4,0.00),(3877,447,4,0.00),(3878,448,4,0.00),(3879,449,4,0.00),(3880,450,4,0.00),(3881,451,4,2.00),(3882,452,4,3.00),(3883,453,4,4.00),(3884,454,4,6.00),(3885,455,4,8.00),(3886,456,4,10.00),(3887,457,4,11.00),(3888,458,4,13.00),(3889,459,4,14.00),(3890,460,4,15.00),(3891,461,4,17.00),(3892,462,4,18.00),(3893,463,4,19.00),(3894,464,4,21.00),(3895,465,4,22.00),(3896,466,4,23.00),(3897,467,4,24.00),(3898,468,4,25.00),(3899,469,4,27.00),(3900,470,4,28.00),(3901,471,4,29.00),(3902,472,4,30.00),(3903,473,4,31.00),(3904,474,4,32.00),(3905,475,4,33.00),(3906,476,4,35.00),(3907,477,4,36.00),(3908,478,4,37.00),(3909,479,4,38.00),(3910,480,4,39.00),(3911,481,4,0.00),(3912,482,4,0.00),(3913,483,4,0.00),(3914,484,4,0.00),(3915,485,4,0.00),(3916,486,4,0.00),(3917,487,4,0.00),(3918,488,4,0.00),(3919,489,4,0.00),(3920,490,4,0.00),(3921,491,4,0.00),(3922,492,4,2.00),(3923,493,4,3.00),(3924,494,4,4.00),(3925,495,4,6.00),(3926,496,4,8.00),(3927,497,4,10.00),(3928,498,4,11.00),(3929,499,4,13.00),(3930,500,4,14.00),(3931,501,4,15.00),(3932,502,4,17.00),(3933,503,4,18.00),(3934,504,4,19.00),(3935,505,4,21.00),(3936,506,4,22.00),(3937,507,4,23.00),(3938,508,4,24.00),(3939,509,4,25.00),(3940,510,4,27.00),(3941,511,4,28.00),(3942,512,4,29.00),(3943,513,4,30.00),(3944,514,4,31.00),(3945,515,4,32.00),(3946,516,4,33.00),(3947,517,4,35.00),(3948,518,4,36.00),(3949,519,4,37.00),(3950,520,4,38.00),(3951,521,4,39.00),(3952,NULL,4,0.00),(3953,523,4,0.00),(3954,524,4,0.00),(3955,525,4,0.00),(3956,526,4,0.00),(3957,527,4,0.00),(3958,528,4,0.00),(3959,529,4,0.00),(3960,530,4,0.00),(3961,531,4,0.00),(3962,532,4,0.00),(3963,533,4,2.00),(3964,534,4,3.00),(3965,535,4,4.00),(3966,536,4,6.00),(3967,537,4,8.00),(3968,538,4,10.00),(3969,539,4,11.00),(3970,540,4,13.00),(3971,541,4,14.00),(3972,542,4,15.00),(3973,543,4,17.00),(3974,544,4,18.00),(3975,545,4,19.00),(3976,546,4,21.00),(3977,547,4,22.00),(3978,548,4,23.00),(3979,549,4,24.00),(3980,550,4,25.00),(3981,551,4,27.00),(3982,552,4,28.00),(3983,553,4,29.00),(3984,554,4,30.00),(3985,555,4,31.00),(3986,556,4,32.00),(3987,557,4,33.00),(3988,558,4,35.00),(3989,559,4,36.00),(3990,560,4,37.00),(3991,561,4,38.00),(3992,562,4,39.00),(3993,563,4,0.00),(3994,564,4,0.00),(3995,565,4,0.00),(3996,566,4,1.10),(3997,567,4,6.20),(3998,568,4,8.20),(3999,569,4,9.70),(4000,570,4,10.80),(4001,571,4,12.90),(4002,572,4,14.00),(4003,573,4,16.10),(4004,574,4,18.30),(4005,575,4,21.50),(4006,576,4,23.50),(4007,577,4,25.10),(4008,578,4,27.20),(4009,579,4,29.40),(4010,580,4,30.60),(4011,581,4,32.30),(4012,582,4,33.50),(4013,583,4,34.10),(4014,584,4,35.30),(4015,440,5,0.00),(4016,441,5,0.00),(4017,442,5,0.00),(4018,443,5,0.00),(4019,444,5,0.00),(4020,445,5,0.00),(4021,446,5,0.00),(4022,447,5,0.00),(4023,448,5,0.00),(4024,449,5,0.00),(4025,450,5,0.00),(4026,451,5,0.00),(4027,452,5,0.00),(4028,453,5,1.00),(4029,454,5,3.00),(4030,455,5,5.00),(4031,456,5,6.00),(4032,457,5,8.00),(4033,458,5,10.00),(4034,459,5,12.00),(4035,460,5,13.00),(4036,461,5,15.00),(4037,462,5,16.00),(4038,463,5,18.00),(4039,464,5,19.00),(4040,465,5,20.00),(4041,466,5,22.00),(4042,467,5,23.00),(4043,468,5,24.00),(4044,469,5,25.00),(4045,470,5,27.00),(4046,471,5,28.00),(4047,472,5,29.00),(4048,473,5,30.00),(4049,474,5,32.00),(4050,475,5,33.00),(4051,476,5,34.00),(4052,477,5,35.00),(4053,478,5,36.00),(4054,479,5,38.00),(4055,480,5,39.00),(4056,481,5,0.00),(4057,482,5,0.00),(4058,483,5,0.00),(4059,484,5,0.00),(4060,485,5,0.00),(4061,486,5,0.00),(4062,487,5,0.00),(4063,488,5,0.00),(4064,489,5,0.00),(4065,490,5,0.00),(4066,491,5,0.00),(4067,492,5,0.00),(4068,493,5,0.00),(4069,494,5,1.00),(4070,495,5,3.00),(4071,496,5,5.00),(4072,497,5,6.00),(4073,498,5,8.00),(4074,499,5,10.00),(4075,500,5,12.00),(4076,501,5,13.00),(4077,502,5,15.00),(4078,503,5,16.00),(4079,504,5,18.00),(4080,505,5,19.00),(4081,506,5,20.00),(4082,507,5,22.00),(4083,508,5,23.00),(4084,509,5,24.00),(4085,510,5,25.00),(4086,511,5,27.00),(4087,512,5,28.00),(4088,513,5,29.00),(4089,514,5,30.00),(4090,515,5,32.00),(4091,516,5,33.00),(4092,517,5,34.00),(4093,518,5,35.00),(4094,519,5,36.00),(4095,520,5,38.00),(4096,521,5,39.00),(4097,NULL,5,0.00),(4098,523,5,0.00),(4099,524,5,0.00),(4100,525,5,0.00),(4101,526,5,0.00),(4102,527,5,0.00),(4103,528,5,0.00),(4104,529,5,0.00),(4105,530,5,0.00),(4106,531,5,0.00),(4107,532,5,0.00),(4108,533,5,0.00),(4109,534,5,0.00),(4110,535,5,1.00),(4111,536,5,3.00),(4112,537,5,5.00),(4113,538,5,6.00),(4114,539,5,8.00),(4115,540,5,10.00),(4116,541,5,12.00),(4117,542,5,13.00),(4118,543,5,15.00),(4119,544,5,16.00),(4120,545,5,18.00),(4121,546,5,19.00),(4122,547,5,20.00),(4123,548,5,22.00),(4124,549,5,23.00),(4125,550,5,24.00),(4126,551,5,25.00),(4127,552,5,27.00),(4128,553,5,28.00),(4129,554,5,29.00),(4130,555,5,30.00),(4131,556,5,32.00),(4132,557,5,33.00),(4133,558,5,34.00),(4134,559,5,35.00),(4135,560,5,36.00),(4136,561,5,38.00),(4137,562,5,39.00),(4138,563,5,0.00),(4139,564,5,0.00),(4140,565,5,0.00),(4141,566,5,0.10),(4142,567,5,4.10),(4143,568,5,6.20),(4144,569,5,8.20),(4145,570,5,9.20),(4146,571,5,11.30),(4147,572,5,13.40),(4148,573,5,15.60),(4149,574,5,17.70),(4150,575,5,20.90),(4151,576,5,22.90),(4152,577,5,25.00),(4153,578,5,26.20),(4154,579,5,28.30),(4155,580,5,30.50),(4156,581,5,31.70),(4157,582,5,32.90),(4158,583,5,33.60),(4159,584,5,34.70),(4160,440,6,0.00),(4161,441,6,0.00),(4162,442,6,0.00),(4163,443,6,0.00),(4164,444,6,0.00),(4165,445,6,0.00),(4166,446,6,0.00),(4167,447,6,0.00),(4168,448,6,0.00),(4169,449,6,0.00),(4170,450,6,0.00),(4171,451,6,0.00),(4172,452,6,0.00),(4173,453,6,0.00),(4174,454,6,0.00),(4175,455,6,0.00),(4176,456,6,0.00),(4177,457,6,0.00),(4178,458,6,3.00),(4179,459,6,5.00),(4180,460,6,7.00),(4181,461,6,9.00),(4182,462,6,11.00),(4183,463,6,12.00),(4184,464,6,14.00),(4185,465,6,16.00),(4186,466,6,17.00),(4187,467,6,19.00),(4188,468,6,20.00),(4189,469,6,22.00),(4190,470,6,23.00),(4191,471,6,25.00),(4192,472,6,26.00),(4193,473,6,28.00),(4194,474,6,29.00),(4195,475,6,31.00),(4196,476,6,32.00),(4197,477,6,34.00),(4198,478,6,35.00),(4199,479,6,36.00),(4200,480,6,38.00),(4201,481,6,0.00),(4202,482,6,0.00),(4203,483,6,0.00),(4204,484,6,0.00),(4205,485,6,0.00),(4206,486,6,0.00),(4207,487,6,0.00),(4208,488,6,0.00),(4209,489,6,0.00),(4210,490,6,0.00),(4211,491,6,0.00),(4212,492,6,0.00),(4213,493,6,0.00),(4214,494,6,0.00),(4215,495,6,0.00),(4216,496,6,0.00),(4217,497,6,0.00),(4218,498,6,0.00),(4219,499,6,3.00),(4220,500,6,5.00),(4221,501,6,7.00),(4222,502,6,9.00),(4223,503,6,11.00),(4224,504,6,12.00),(4225,505,6,14.00),(4226,506,6,16.00),(4227,507,6,17.00),(4228,508,6,19.00),(4229,509,6,20.00),(4230,510,6,22.00),(4231,511,6,23.00),(4232,512,6,25.00),(4233,513,6,26.00),(4234,514,6,28.00),(4235,515,6,29.00),(4236,516,6,31.00),(4237,517,6,32.00),(4238,518,6,34.00),(4239,519,6,35.00),(4240,520,6,36.00),(4241,521,6,38.00),(4242,NULL,6,0.00),(4243,523,6,0.00),(4244,524,6,0.00),(4245,525,6,0.00),(4246,526,6,0.00),(4247,527,6,0.00),(4248,528,6,0.00),(4249,529,6,0.00),(4250,530,6,0.00),(4251,531,6,0.00),(4252,532,6,0.00),(4253,533,6,0.00),(4254,534,6,0.00),(4255,535,6,0.00),(4256,536,6,0.00),(4257,537,6,0.00),(4258,538,6,0.00),(4259,539,6,0.00),(4260,540,6,3.00),(4261,541,6,5.00),(4262,542,6,7.00),(4263,543,6,9.00),(4264,544,6,11.00),(4265,545,6,12.00),(4266,546,6,14.00),(4267,547,6,16.00),(4268,548,6,17.00),(4269,549,6,19.00),(4270,550,6,20.00),(4271,551,6,22.00),(4272,552,6,23.00),(4273,553,6,25.00),(4274,554,6,26.00),(4275,555,6,28.00),(4276,556,6,29.00),(4277,557,6,31.00),(4278,558,6,32.00),(4279,559,6,34.00),(4280,560,6,35.00),(4281,561,6,36.00),(4282,562,6,38.00),(4283,563,6,0.00),(4284,564,6,0.00),(4285,565,6,0.00),(4286,566,6,0.00),(4287,567,6,0.10),(4288,568,6,4.10),(4289,569,6,6.20),(4290,570,6,8.20),(4291,571,6,10.20),(4292,572,6,12.30),(4293,573,6,13.50),(4294,574,6,16.60),(4295,575,6,19.80),(4296,576,6,21.90),(4297,577,6,24.40),(4298,578,6,26.10),(4299,579,6,27.70),(4300,580,6,29.50),(4301,581,6,31.20),(4302,582,6,32.40),(4303,583,6,33.00),(4304,584,6,34.20),(4305,563,7,0.00),(4306,564,7,0.00),(4307,565,7,0.00),(4308,566,7,0.00),(4309,567,7,0.00),(4310,568,7,0.10),(4311,569,7,4.10),(4312,570,7,6.10),(4313,571,7,8.20),(4314,572,7,10.30),(4315,573,7,12.40),(4316,574,7,15.60),(4317,575,7,18.70),(4318,576,7,21.40),(4319,577,7,22.90),(4320,578,7,24.50),(4321,579,7,26.60),(4322,580,7,28.90),(4323,581,7,30.10),(4324,582,7,31.30),(4325,583,7,32.50),(4326,584,7,33.60),(4327,563,8,0.00),(4328,564,8,0.00),(4329,565,8,0.00),(4330,566,8,0.00),(4331,567,8,0.00),(4332,568,8,0.00),(4333,569,8,1.10),(4334,570,8,4.10),(4335,571,8,7.20),(4336,572,8,9.20),(4337,573,8,11.30),(4338,574,8,14.50),(4339,575,8,17.70),(4340,576,8,19.80),(4341,577,8,21.80),(4342,578,8,23.40),(4343,579,8,25.60),(4344,580,8,27.80),(4345,581,8,29.50),(4346,582,8,30.70),(4347,583,8,31.90),(4348,584,8,33.10),(4349,563,9,0.00),(4350,564,9,0.00),(4351,565,9,0.00),(4352,566,9,0.00),(4353,567,9,0.00),(4354,568,9,0.00),(4355,569,9,0.00),(4356,570,9,1.10),(4357,571,9,5.10),(4358,572,9,7.20),(4359,573,9,10.20),(4360,574,9,13.40),(4361,575,9,16.60),(4362,576,9,18.70),(4363,577,9,20.30),(4364,578,9,22.30),(4365,579,9,24.50),(4366,580,9,26.80),(4367,581,9,28.50),(4368,582,9,29.70),(4369,583,9,30.80),(4370,584,9,32.50),(4371,563,10,0.00),(4372,564,10,0.00),(4373,565,10,0.00),(4374,566,10,0.00),(4375,567,10,0.00),(4376,568,10,0.00),(4377,569,10,0.00),(4378,570,10,0.00),(4379,571,10,2.10),(4380,572,10,6.10),(4381,573,10,9.20),(4382,574,10,12.30),(4383,575,10,15.00),(4384,576,10,17.20),(4385,577,10,19.30),(4386,578,10,21.30),(4387,579,10,23.90),(4388,580,10,25.70),(4389,581,10,27.40),(4390,582,10,29.10),(4391,583,10,30.30),(4392,584,10,31.90),(4393,585,0,0.00),(4394,585,1,0.00),(4395,585,2,0.00),(4396,585,3,0.00),(4397,585,4,0.00),(4398,585,5,0.00),(4399,585,6,0.00),(4400,586,0,1.00),(4401,586,1,0.00),(4402,586,2,0.00),(4403,586,3,0.00),(4404,586,4,0.00),(4405,586,5,0.00),(4406,586,6,0.00),(4407,587,0,2.00),(4408,587,1,0.00),(4409,587,2,0.00),(4410,587,3,0.00),(4411,587,4,0.00),(4412,587,5,0.00),(4413,587,6,0.00),(4414,588,0,3.00),(4415,588,1,1.00),(4416,588,2,0.00),(4417,588,3,0.00),(4418,588,4,0.00),(4419,588,5,0.00),(4420,588,6,0.00),(4421,589,0,4.00),(4422,589,1,2.00),(4423,589,2,0.00),(4424,589,3,0.00),(4425,589,4,0.00),(4426,589,5,0.00),(4427,589,6,0.00),(4428,590,0,5.00),(4429,590,1,3.00),(4430,590,2,0.00),(4431,590,3,0.00),(4432,590,4,0.00),(4433,590,5,0.00),(4434,590,6,0.00),(4435,591,0,6.00),(4436,591,1,4.00),(4437,591,2,2.00),(4438,591,3,0.00),(4439,591,4,0.00),(4440,591,5,0.00),(4441,591,6,0.00),(4442,592,0,7.00),(4443,592,1,5.00),(4444,592,2,3.00),(4445,592,3,0.00),(4446,592,4,0.00),(4447,592,5,0.00),(4448,592,6,0.00),(4449,593,0,8.00),(4450,593,1,6.00),(4451,593,2,4.00),(4452,593,3,0.00),(4453,593,4,0.00),(4454,593,5,0.00),(4455,593,6,0.00),(4456,594,0,9.00),(4457,594,1,7.00),(4458,594,2,5.00),(4459,594,3,2.00),(4460,594,4,0.00),(4461,594,5,0.00),(4462,594,6,0.00),(4463,595,0,10.00),(4464,595,1,9.00),(4465,595,2,7.00),(4466,595,3,4.00),(4467,595,4,0.00),(4468,595,5,0.00),(4469,595,6,0.00),(4470,596,0,11.00),(4471,596,1,10.00),(4472,596,2,8.00),(4473,596,3,5.00),(4474,596,4,1.00),(4475,596,5,0.00),(4476,596,6,0.00),(4477,597,0,12.00),(4478,597,1,11.00),(4479,597,2,9.00),(4480,597,3,6.00),(4481,597,4,3.00),(4482,597,5,0.00),(4483,597,6,0.00),(4484,598,0,13.00),(4485,598,1,12.00),(4486,598,2,10.00),(4487,598,3,8.00),(4488,598,4,4.00),(4489,598,5,1.00),(4490,598,6,0.00),(4491,599,0,14.00),(4492,599,1,13.00),(4493,599,2,11.00),(4494,599,3,9.00),(4495,599,4,6.00),(4496,599,5,3.00),(4497,599,6,0.00),(4498,600,0,15.00),(4499,600,1,14.00),(4500,600,2,13.00),(4501,600,3,10.00),(4502,600,4,8.00),(4503,600,5,4.00),(4504,600,6,0.00),(4505,601,0,16.00),(4506,601,1,15.00),(4507,601,2,14.00),(4508,601,3,12.00),(4509,601,4,10.00),(4510,601,5,6.00),(4511,601,6,0.00),(4512,602,0,17.00),(4513,602,1,16.00),(4514,602,2,15.00),(4515,602,3,13.00),(4516,602,4,11.00),(4517,602,5,8.00),(4518,602,6,0.00),(4519,603,0,18.00),(4520,603,1,17.00),(4521,603,2,16.00),(4522,603,3,15.00),(4523,603,4,13.00),(4524,603,5,10.00),(4525,603,6,3.00),(4526,604,0,19.00),(4527,604,1,18.00),(4528,604,2,17.00),(4529,604,3,16.00),(4530,604,4,14.00),(4531,604,5,12.00),(4532,604,6,5.00),(4533,605,0,20.00),(4534,605,1,19.00),(4535,605,2,18.00),(4536,605,3,17.00),(4537,605,4,15.00),(4538,605,5,13.00),(4539,605,6,7.00),(4540,606,0,21.00),(4541,606,1,20.00),(4542,606,2,20.00),(4543,606,3,18.00),(4544,606,4,17.00),(4545,606,5,15.00),(4546,606,6,9.00),(4547,607,0,22.00),(4548,607,1,21.00),(4549,607,2,21.00),(4550,607,3,19.00),(4551,607,4,18.00),(4552,607,5,16.00),(4553,607,6,11.00),(4554,608,0,23.00),(4555,608,1,22.00),(4556,608,2,22.00),(4557,608,3,21.00),(4558,608,4,19.00),(4559,608,5,18.00),(4560,608,6,12.00),(4561,609,0,24.00),(4562,609,1,23.00),(4563,609,2,23.00),(4564,609,3,22.00),(4565,609,4,21.00),(4566,609,5,19.00),(4567,609,6,14.00),(4568,610,0,25.00),(4569,610,1,25.00),(4570,610,2,24.00),(4571,610,3,23.00),(4572,610,4,22.00),(4573,610,5,20.00),(4574,610,6,16.00),(4575,611,0,26.00),(4576,611,1,26.00),(4577,611,2,25.00),(4578,611,3,24.00),(4579,611,4,23.00),(4580,611,5,22.00),(4581,611,6,17.00),(4582,612,0,27.00),(4583,612,1,27.00),(4584,612,2,26.00),(4585,612,3,25.00),(4586,612,4,24.00),(4587,612,5,23.00),(4588,612,6,19.00),(4589,613,0,28.00),(4590,613,1,28.00),(4591,613,2,27.00),(4592,613,3,26.00),(4593,613,4,25.00),(4594,613,5,24.00),(4595,613,6,20.00),(4596,614,0,29.00),(4597,614,1,29.00),(4598,614,2,28.00),(4599,614,3,27.00),(4600,614,4,27.00),(4601,614,5,25.00),(4602,614,6,22.00),(4603,615,0,30.00),(4604,615,1,30.00),(4605,615,2,29.00),(4606,615,3,29.00),(4607,615,4,28.00),(4608,615,5,27.00),(4609,615,6,23.00),(4610,616,0,31.00),(4611,616,1,31.00),(4612,616,2,30.00),(4613,616,3,30.00),(4614,616,4,29.00),(4615,616,5,28.00),(4616,616,6,25.00),(4617,617,0,32.00),(4618,617,1,32.00),(4619,617,2,31.00),(4620,617,3,31.00),(4621,617,4,30.00),(4622,617,5,29.00),(4623,617,6,26.00),(4624,618,0,33.00),(4625,618,1,33.00),(4626,618,2,32.00),(4627,618,3,32.00),(4628,618,4,31.00),(4629,618,5,30.00),(4630,618,6,28.00),(4631,619,0,34.00),(4632,619,1,34.00),(4633,619,2,33.00),(4634,619,3,33.00),(4635,619,4,32.00),(4636,619,5,32.00),(4637,619,6,29.00),(4638,620,0,35.00),(4639,620,1,35.00),(4640,620,2,35.00),(4641,620,3,34.00),(4642,620,4,33.00),(4643,620,5,33.00),(4644,620,6,31.00),(4645,621,0,36.00),(4646,621,1,36.00),(4647,621,2,36.00),(4648,621,3,35.00),(4649,621,4,35.00),(4650,621,5,34.00),(4651,621,6,32.00),(4652,622,0,37.00),(4653,622,1,37.00),(4654,622,2,37.00),(4655,622,3,36.00),(4656,622,4,36.00),(4657,622,5,35.00),(4658,622,6,34.00),(4659,623,0,38.00),(4660,623,1,38.00),(4661,623,2,38.00),(4662,623,3,37.00),(4663,623,4,37.00),(4664,623,5,36.00),(4665,623,6,35.00),(4666,624,0,39.00),(4667,624,1,39.00),(4668,624,2,39.00),(4669,624,3,38.00),(4670,624,4,38.00),(4671,624,5,38.00),(4672,624,6,36.00),(4673,625,0,40.00),(4674,625,1,40.00),(4675,625,2,40.00),(4676,625,3,39.00),(4677,625,4,39.00),(4678,625,5,39.00),(4679,625,6,38.00),(4680,626,0,0.00),(4681,626,1,0.00),(4682,626,2,0.00),(4683,626,3,0.00),(4684,626,4,0.00),(4685,626,5,0.00),(4686,626,6,0.00),(4687,627,0,1.00),(4688,627,1,0.00),(4689,627,2,0.00),(4690,627,3,0.00),(4691,627,4,0.00),(4692,627,5,0.00),(4693,627,6,0.00),(4694,628,0,2.00),(4695,628,1,0.00),(4696,628,2,0.00),(4697,628,3,0.00),(4698,628,4,0.00),(4699,628,5,0.00),(4700,628,6,0.00),(4701,629,0,3.00),(4702,629,1,1.00),(4703,629,2,0.00),(4704,629,3,0.00),(4705,629,4,0.00),(4706,629,5,0.00),(4707,629,6,0.00),(4708,630,0,4.00),(4709,630,1,2.00),(4710,630,2,0.00),(4711,630,3,0.00),(4712,630,4,0.00),(4713,630,5,0.00),(4714,630,6,0.00),(4715,631,0,5.00),(4716,631,1,3.00),(4717,631,2,0.00),(4718,631,3,0.00),(4719,631,4,0.00),(4720,631,5,0.00),(4721,631,6,0.00),(4722,632,0,6.00),(4723,632,1,4.00),(4724,632,2,2.00),(4725,632,3,0.00),(4726,632,4,0.00),(4727,632,5,0.00),(4728,632,6,0.00),(4729,633,0,7.00),(4730,633,1,5.00),(4731,633,2,3.00),(4732,633,3,0.00),(4733,633,4,0.00),(4734,633,5,0.00),(4735,633,6,0.00),(4736,634,0,8.00),(4737,634,1,6.00),(4738,634,2,4.00),(4739,634,3,0.00),(4740,634,4,0.00),(4741,634,5,0.00),(4742,634,6,0.00),(4743,635,0,9.00),(4744,635,1,7.00),(4745,635,2,5.00),(4746,635,3,2.00),(4747,635,4,0.00),(4748,635,5,0.00),(4749,635,6,0.00),(4750,636,0,10.00),(4751,636,1,9.00),(4752,636,2,7.00),(4753,636,3,4.00),(4754,636,4,0.00),(4755,636,5,0.00),(4756,636,6,0.00),(4757,637,0,11.00),(4758,637,1,10.00),(4759,637,2,8.00),(4760,637,3,5.00),(4761,637,4,1.00),(4762,637,5,0.00),(4763,637,6,0.00),(4764,638,0,12.00),(4765,638,1,11.00),(4766,638,2,9.00),(4767,638,3,6.00),(4768,638,4,3.00),(4769,638,5,0.00),(4770,638,6,0.00),(4771,639,0,13.00),(4772,639,1,12.00),(4773,639,2,10.00),(4774,639,3,8.00),(4775,639,4,4.00),(4776,639,5,1.00),(4777,639,6,0.00),(4778,640,0,14.00),(4779,640,1,13.00),(4780,640,2,11.00),(4781,640,3,9.00),(4782,640,4,6.00),(4783,640,5,3.00),(4784,640,6,0.00),(4785,641,0,15.00),(4786,641,1,14.00),(4787,641,2,13.00),(4788,641,3,10.00),(4789,641,4,8.00),(4790,641,5,4.00),(4791,641,6,0.00),(4792,642,0,16.00),(4793,642,1,15.00),(4794,642,2,14.00),(4795,642,3,12.00),(4796,642,4,10.00),(4797,642,5,6.00),(4798,642,6,0.00),(4799,643,0,17.00),(4800,643,1,16.00),(4801,643,2,15.00),(4802,643,3,13.00),(4803,643,4,11.00),(4804,643,5,8.00),(4805,643,6,0.00),(4806,644,0,18.00),(4807,644,1,17.00),(4808,644,2,16.00),(4809,644,3,15.00),(4810,644,4,13.00),(4811,644,5,10.00),(4812,644,6,3.00),(4813,645,0,19.00),(4814,645,1,18.00),(4815,645,2,17.00),(4816,645,3,16.00),(4817,645,4,14.00),(4818,645,5,12.00),(4819,645,6,5.00),(4820,646,0,20.00),(4821,646,1,19.00),(4822,646,2,18.00),(4823,646,3,17.00),(4824,646,4,15.00),(4825,646,5,13.00),(4826,646,6,7.00),(4827,647,0,21.00),(4828,647,1,20.00),(4829,647,2,20.00),(4830,647,3,18.00),(4831,647,4,17.00),(4832,647,5,15.00),(4833,647,6,9.00),(4834,648,0,22.00),(4835,648,1,21.00),(4836,648,2,21.00),(4837,648,3,19.00),(4838,648,4,18.00),(4839,648,5,16.00),(4840,648,6,11.00),(4841,649,0,23.00),(4842,649,1,22.00),(4843,649,2,22.00),(4844,649,3,21.00),(4845,649,4,19.00),(4846,649,5,18.00),(4847,649,6,12.00),(4848,650,0,24.00),(4849,650,1,23.00),(4850,650,2,23.00),(4851,650,3,22.00),(4852,650,4,21.00),(4853,650,5,19.00),(4854,650,6,14.00),(4855,651,0,25.00),(4856,651,1,25.00),(4857,651,2,24.00),(4858,651,3,23.00),(4859,651,4,22.00),(4860,651,5,20.00),(4861,651,6,16.00),(4862,652,0,26.00),(4863,652,1,26.00),(4864,652,2,25.00),(4865,652,3,24.00),(4866,652,4,23.00),(4867,652,5,22.00),(4868,652,6,17.00),(4869,653,0,27.00),(4870,653,1,27.00),(4871,653,2,26.00),(4872,653,3,25.00),(4873,653,4,24.00),(4874,653,5,23.00),(4875,653,6,19.00),(4876,654,0,28.00),(4877,654,1,28.00),(4878,654,2,27.00),(4879,654,3,26.00),(4880,654,4,25.00),(4881,654,5,24.00),(4882,654,6,20.00),(4883,655,0,29.00),(4884,655,1,29.00),(4885,655,2,28.00),(4886,655,3,27.00),(4887,655,4,27.00),(4888,655,5,25.00),(4889,655,6,22.00),(4890,656,0,30.00),(4891,656,1,30.00),(4892,656,2,29.00),(4893,656,3,29.00),(4894,656,4,28.00),(4895,656,5,27.00),(4896,656,6,23.00),(4897,657,0,31.00),(4898,657,1,31.00),(4899,657,2,30.00),(4900,657,3,30.00),(4901,657,4,29.00),(4902,657,5,28.00),(4903,657,6,25.00),(4904,658,0,32.00),(4905,658,1,32.00),(4906,658,2,31.00),(4907,658,3,31.00),(4908,658,4,30.00),(4909,658,5,29.00),(4910,658,6,26.00),(4911,659,0,33.00),(4912,659,1,33.00),(4913,659,2,32.00),(4914,659,3,32.00),(4915,659,4,31.00),(4916,659,5,30.00),(4917,659,6,28.00),(4918,660,0,34.00),(4919,660,1,34.00),(4920,660,2,33.00),(4921,660,3,33.00),(4922,660,4,32.00),(4923,660,5,32.00),(4924,660,6,29.00),(4925,661,0,35.00),(4926,661,1,35.00),(4927,661,2,35.00),(4928,661,3,34.00),(4929,661,4,33.00),(4930,661,5,33.00),(4931,661,6,31.00),(4932,662,0,36.00),(4933,662,1,36.00),(4934,662,2,36.00),(4935,662,3,35.00),(4936,662,4,35.00),(4937,662,5,34.00),(4938,662,6,32.00),(4939,663,0,37.00),(4940,663,1,37.00),(4941,663,2,37.00),(4942,663,3,36.00),(4943,663,4,36.00),(4944,663,5,35.00),(4945,663,6,34.00),(4946,664,0,38.00),(4947,664,1,38.00),(4948,664,2,38.00),(4949,664,3,37.00),(4950,664,4,37.00),(4951,664,5,36.00),(4952,664,6,35.00),(4953,665,0,39.00),(4954,665,1,39.00),(4955,665,2,39.00),(4956,665,3,38.00),(4957,665,4,38.00),(4958,665,5,38.00),(4959,665,6,36.00),(4960,666,0,40.00),(4961,666,1,40.00),(4962,666,2,40.00),(4963,666,3,39.00),(4964,666,4,39.00),(4965,666,5,39.00),(4966,666,6,38.00),(4967,667,0,0.00),(4968,667,1,0.00),(4969,667,2,0.00),(4970,667,3,0.00),(4971,667,4,0.00),(4972,667,5,0.00),(4973,667,6,0.00),(4974,668,0,1.00),(4975,668,1,0.00),(4976,668,2,0.00),(4977,668,3,0.00),(4978,668,4,0.00),(4979,668,5,0.00),(4980,668,6,0.00),(4981,669,0,2.00),(4982,669,1,0.00),(4983,669,2,0.00),(4984,669,3,0.00),(4985,669,4,0.00),(4986,669,5,0.00),(4987,669,6,0.00),(4988,670,0,3.00),(4989,670,1,1.00),(4990,670,2,0.00),(4991,670,3,0.00),(4992,670,4,0.00),(4993,670,5,0.00),(4994,670,6,0.00),(4995,671,0,4.00),(4996,671,1,2.00),(4997,671,2,0.00),(4998,671,3,0.00),(4999,671,4,0.00),(5000,671,5,0.00),(5001,671,6,0.00),(5002,672,0,5.00),(5003,672,1,3.00),(5004,672,2,0.00),(5005,672,3,0.00),(5006,672,4,0.00),(5007,672,5,0.00),(5008,672,6,0.00),(5009,673,0,6.00),(5010,673,1,4.00),(5011,673,2,2.00),(5012,673,3,0.00),(5013,673,4,0.00),(5014,673,5,0.00),(5015,673,6,0.00),(5016,674,0,7.00),(5017,674,1,5.00),(5018,674,2,3.00),(5019,674,3,0.00),(5020,674,4,0.00),(5021,674,5,0.00),(5022,674,6,0.00),(5023,675,0,8.00),(5024,675,1,6.00),(5025,675,2,4.00),(5026,675,3,0.00),(5027,675,4,0.00),(5028,675,5,0.00),(5029,675,6,0.00),(5030,676,0,9.00),(5031,676,1,7.00),(5032,676,2,5.00),(5033,676,3,2.00),(5034,676,4,0.00),(5035,676,5,0.00),(5036,676,6,0.00),(5037,677,0,10.00),(5038,677,1,9.00),(5039,677,2,7.00),(5040,677,3,4.00),(5041,677,4,0.00),(5042,677,5,0.00),(5043,677,6,0.00),(5044,678,0,11.00),(5045,678,1,10.00),(5046,678,2,8.00),(5047,678,3,5.00),(5048,678,4,1.00),(5049,678,5,0.00),(5050,678,6,0.00),(5051,679,0,12.00),(5052,679,1,11.00),(5053,679,2,9.00),(5054,679,3,6.00),(5055,679,4,3.00),(5056,679,5,0.00),(5057,679,6,0.00),(5058,680,0,13.00),(5059,680,1,12.00),(5060,680,2,10.00),(5061,680,3,8.00),(5062,680,4,4.00),(5063,680,5,1.00),(5064,680,6,0.00),(5065,681,0,14.00),(5066,681,1,13.00),(5067,681,2,11.00),(5068,681,3,9.00),(5069,681,4,6.00),(5070,681,5,3.00),(5071,681,6,0.00),(5072,682,0,15.00),(5073,682,1,14.00),(5074,682,2,13.00),(5075,682,3,10.00),(5076,682,4,8.00),(5077,682,5,4.00),(5078,682,6,0.00),(5079,683,0,16.00),(5080,683,1,15.00),(5081,683,2,14.00),(5082,683,3,12.00),(5083,683,4,10.00),(5084,683,5,6.00),(5085,683,6,0.00),(5086,684,0,17.00),(5087,684,1,16.00),(5088,684,2,15.00),(5089,684,3,13.00),(5090,684,4,11.00),(5091,684,5,8.00),(5092,684,6,0.00),(5093,685,0,18.00),(5094,685,1,17.00),(5095,685,2,16.00),(5096,685,3,15.00),(5097,685,4,13.00),(5098,685,5,10.00),(5099,685,6,3.00),(5100,686,0,19.00),(5101,686,1,18.00),(5102,686,2,17.00),(5103,686,3,16.00),(5104,686,4,14.00),(5105,686,5,12.00),(5106,686,6,5.00),(5107,687,0,20.00),(5108,687,1,19.00),(5109,687,2,18.00),(5110,687,3,17.00),(5111,687,4,15.00),(5112,687,5,13.00),(5113,687,6,7.00),(5114,688,0,21.00),(5115,688,1,20.00),(5116,688,2,20.00),(5117,688,3,18.00),(5118,688,4,17.00),(5119,688,5,15.00),(5120,688,6,9.00),(5121,689,0,22.00),(5122,689,1,21.00),(5123,689,2,21.00),(5124,689,3,19.00),(5125,689,4,18.00),(5126,689,5,16.00),(5127,689,6,11.00),(5128,690,0,23.00),(5129,690,1,22.00),(5130,690,2,22.00),(5131,690,3,21.00),(5132,690,4,19.00),(5133,690,5,18.00),(5134,690,6,12.00),(5135,691,0,24.00),(5136,691,1,23.00),(5137,691,2,23.00),(5138,691,3,22.00),(5139,691,4,21.00),(5140,691,5,19.00),(5141,691,6,14.00),(5142,692,0,25.00),(5143,692,1,25.00),(5144,692,2,24.00),(5145,692,3,23.00),(5146,692,4,22.00),(5147,692,5,20.00),(5148,692,6,16.00),(5149,693,0,26.00),(5150,693,1,26.00),(5151,693,2,25.00),(5152,693,3,24.00),(5153,693,4,23.00),(5154,693,5,22.00),(5155,693,6,17.00),(5156,694,0,27.00),(5157,694,1,27.00),(5158,694,2,26.00),(5159,694,3,25.00),(5160,694,4,24.00),(5161,694,5,23.00),(5162,694,6,19.00),(5163,695,0,28.00),(5164,695,1,28.00),(5165,695,2,27.00),(5166,695,3,26.00),(5167,695,4,25.00),(5168,695,5,24.00),(5169,695,6,20.00),(5170,696,0,29.00),(5171,696,1,29.00),(5172,696,2,28.00),(5173,696,3,27.00),(5174,696,4,27.00),(5175,696,5,25.00),(5176,696,6,22.00),(5177,697,0,30.00),(5178,697,1,30.00),(5179,697,2,29.00),(5180,697,3,29.00),(5181,697,4,28.00),(5182,697,5,27.00),(5183,697,6,23.00),(5184,698,0,31.00),(5185,698,1,31.00),(5186,698,2,30.00),(5187,698,3,30.00),(5188,698,4,29.00),(5189,698,5,28.00),(5190,698,6,25.00),(5191,699,0,32.00),(5192,699,1,32.00),(5193,699,2,31.00),(5194,699,3,31.00),(5195,699,4,30.00),(5196,699,5,29.00),(5197,699,6,26.00),(5198,700,0,33.00),(5199,700,1,33.00),(5200,700,2,32.00),(5201,700,3,32.00),(5202,700,4,31.00),(5203,700,5,30.00),(5204,700,6,28.00),(5205,701,0,34.00),(5206,701,1,34.00),(5207,701,2,33.00),(5208,701,3,33.00),(5209,701,4,32.00),(5210,701,5,32.00),(5211,701,6,29.00),(5212,702,0,35.00),(5213,702,1,35.00),(5214,702,2,35.00),(5215,702,3,34.00),(5216,702,4,33.00),(5217,702,5,33.00),(5218,702,6,31.00),(5219,703,0,36.00),(5220,703,1,36.00),(5221,703,2,36.00),(5222,703,3,35.00),(5223,703,4,35.00),(5224,703,5,34.00),(5225,703,6,32.00),(5226,704,0,37.00),(5227,704,1,37.00),(5228,704,2,37.00),(5229,704,3,36.00),(5230,704,4,36.00),(5231,704,5,35.00),(5232,704,6,34.00),(5233,705,0,38.00),(5234,705,1,38.00),(5235,705,2,38.00),(5236,705,3,37.00),(5237,705,4,37.00),(5238,705,5,36.00),(5239,705,6,35.00),(5240,706,0,39.00),(5241,706,1,39.00),(5242,706,2,39.00),(5243,706,3,38.00),(5244,706,4,38.00),(5245,706,5,38.00),(5246,706,6,36.00),(5247,707,0,40.00),(5248,707,1,40.00),(5249,707,2,40.00),(5250,707,3,39.00),(5251,707,4,39.00),(5252,707,5,39.00),(5253,707,6,38.00),(5254,708,0,2.00),(5255,708,1,0.00),(5256,708,2,0.00),(5257,708,3,0.00),(5258,708,4,0.00),(5259,708,5,0.00),(5260,708,6,0.00),(5261,708,7,0.00),(5262,708,8,0.00),(5263,708,9,0.00),(5264,709,0,4.10),(5265,709,1,2.10),(5266,709,2,0.10),(5267,709,3,0.00),(5268,709,4,0.00),(5269,709,5,0.00),(5270,709,6,0.00),(5271,709,7,0.00),(5272,709,8,0.00),(5273,709,9,0.00),(5274,710,0,6.20),(5275,710,1,4.10),(5276,710,2,2.10),(5277,710,3,0.00),(5278,710,4,0.00),(5279,710,5,0.00),(5280,710,6,0.00),(5281,710,7,0.00),(5282,710,8,0.00),(5283,710,9,0.00),(5284,711,0,8.20),(5285,711,1,6.20),(5286,711,2,4.20),(5287,711,3,1.10),(5288,711,4,0.10),(5289,711,5,0.00),(5290,711,6,0.00),(5291,711,7,0.00),(5292,711,8,0.00),(5293,711,9,0.00),(5294,712,0,11.30),(5295,712,1,9.70),(5296,712,2,8.20),(5297,712,3,6.20),(5298,712,4,4.10),(5299,712,5,0.10),(5300,712,6,0.00),(5301,712,7,0.00),(5302,712,8,0.00),(5303,712,9,0.00),(5304,713,0,12.30),(5305,713,1,11.80),(5306,713,2,9.20),(5307,713,3,8.20),(5308,713,4,6.20),(5309,713,5,4.10),(5310,713,6,0.10),(5311,713,7,0.00),(5312,713,8,0.00),(5313,713,9,0.00),(5314,714,0,13.40),(5315,714,1,12.80),(5316,714,2,10.30),(5317,714,3,9.70),(5318,714,4,8.20),(5319,714,5,6.20),(5320,714,6,4.10),(5321,714,7,1.10),(5322,714,8,0.00),(5323,714,9,0.00),(5324,715,0,14.50),(5325,715,1,13.90),(5326,715,2,12.40),(5327,715,3,10.80),(5328,715,4,9.20),(5329,715,5,8.20),(5330,715,6,6.10),(5331,715,7,4.10),(5332,715,8,1.10),(5333,715,9,0.00),(5334,716,0,15.60),(5335,716,1,15.10),(5336,716,2,13.50),(5337,716,3,12.90),(5338,716,4,11.30),(5339,716,5,10.20),(5340,716,6,8.20),(5341,716,7,7.20),(5342,716,8,5.10),(5343,716,9,2.10),(5344,717,0,17.20),(5345,717,1,17.10),(5346,717,2,14.60),(5347,717,3,14.00),(5348,717,4,13.40),(5349,717,5,12.30),(5350,717,6,10.30),(5351,717,7,9.20),(5352,717,8,7.20),(5353,717,9,6.10),(5354,718,0,18.30),(5355,718,1,18.30),(5356,718,2,16.70),(5357,718,3,16.10),(5358,718,4,15.60),(5359,718,5,13.50),(5360,718,6,12.40),(5361,718,7,11.30),(5362,718,8,10.20),(5363,718,9,9.20),(5364,719,0,21.50),(5365,719,1,20.90),(5366,719,2,18.90),(5367,719,3,18.30),(5368,719,4,17.70),(5369,719,5,16.60),(5370,719,6,15.60),(5371,719,7,14.50),(5372,719,8,13.40),(5373,719,9,12.30),(5374,720,0,23.50),(5375,720,1,23.00),(5376,720,2,21.50),(5377,720,3,21.50),(5378,720,4,20.90),(5379,720,5,19.80),(5380,720,6,18.70),(5381,720,7,17.70),(5382,720,8,16.60),(5383,720,9,15.00),(5384,721,0,25.50),(5385,721,1,24.50),(5386,721,2,24.50),(5387,721,3,23.50),(5388,721,4,22.90),(5389,721,5,21.90),(5390,721,6,21.40),(5391,721,7,19.80),(5392,721,8,18.70),(5393,721,9,17.20),(5394,722,0,27.70),(5395,722,1,27.20),(5396,722,2,26.60),(5397,722,3,25.10),(5398,722,4,25.00),(5399,722,5,24.40),(5400,722,6,22.90),(5401,722,7,21.80),(5402,722,8,20.30),(5403,722,9,19.30),(5404,723,0,29.40),(5405,723,1,28.30),(5406,723,2,27.30),(5407,723,3,27.20),(5408,723,4,26.20),(5409,723,5,26.10),(5410,723,6,24.50),(5411,723,7,23.40),(5412,723,8,22.30),(5413,723,9,21.30),(5414,724,0,30.50),(5415,724,1,30.50),(5416,724,2,29.40),(5417,724,3,29.40),(5418,724,4,28.30),(5419,724,5,27.70),(5420,724,6,26.60),(5421,724,7,25.60),(5422,724,8,24.50),(5423,724,9,23.90),(5424,725,0,31.70),(5425,725,1,31.70),(5426,725,2,30.60),(5427,725,3,30.60),(5428,725,4,30.50),(5429,725,5,29.50),(5430,725,6,28.90),(5431,725,7,27.80),(5432,725,8,26.80),(5433,725,9,25.70),(5434,726,0,33.90),(5435,726,1,33.90),(5436,726,2,32.90),(5437,726,3,32.30),(5438,726,4,31.70),(5439,726,5,31.20),(5440,726,6,30.10),(5441,726,7,29.50),(5442,726,8,28.50),(5443,726,9,27.40),(5444,727,0,35.10),(5445,727,1,34.60),(5446,727,2,34.00),(5447,727,3,33.50),(5448,727,4,32.90),(5449,727,5,32.40),(5450,727,6,31.30),(5451,727,7,30.70),(5452,727,8,29.70),(5453,727,9,29.10),(5454,728,0,35.70),(5455,728,1,35.20),(5456,728,2,34.70),(5457,728,3,34.10),(5458,728,4,33.60),(5459,728,5,33.00),(5460,728,6,32.50),(5461,728,7,31.90),(5462,728,8,30.80),(5463,728,9,30.30),(5464,729,0,36.40),(5465,729,1,36.40),(5466,729,2,35.80),(5467,729,3,35.30),(5468,729,4,34.70),(5469,729,5,34.20),(5470,729,6,33.60),(5471,729,7,33.10),(5472,729,8,32.50),(5473,729,9,31.90);
/*!40000 ALTER TABLE `geozone_irpf_descendant` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `geozone_irpf_handicap`
--

DROP TABLE IF EXISTS `geozone_irpf_handicap`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `geozone_irpf_handicap` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `geozone_irpf` int(4) DEFAULT NULL COMMENT 'Identificador del tramo de IRPF',
  `handicap` tinyint(2) DEFAULT '0' COMMENT 'Grado Minusvalia',
  `percent` double(15,2) DEFAULT '0.00' COMMENT 'Porcentaje',
  PRIMARY KEY (`id`),
  KEY `IDX_GEOZONE_IRPF_HANDICAP_GEOZONE_IRPF` (`geozone_irpf`),
  CONSTRAINT `FK_GEOZONE_IRPF_HANDICAP_GEOZONE_IRPF` FOREIGN KEY (`geozone_irpf`) REFERENCES `geozone_irpf` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=406 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Tabla de  ';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `geozone_irpf_handicap`
--

LOCK TABLES `geozone_irpf_handicap` WRITE;
/*!40000 ALTER TABLE `geozone_irpf_handicap` DISABLE KEYS */;
INSERT INTO `geozone_irpf_handicap` VALUES (238,440,0,9.00),(239,453,0,7.00),(240,456,0,6.00),(241,460,0,5.00),(242,462,0,4.00),(243,467,0,3.00),(244,473,0,2.00),(245,478,0,1.00),(246,481,0,9.00),(247,494,0,7.00),(248,497,0,6.00),(249,501,0,5.00),(250,503,0,4.00),(251,508,0,3.00),(252,514,0,2.00),(253,519,0,1.00),(254,NULL,0,9.00),(255,535,0,7.00),(256,538,0,6.00),(257,542,0,5.00),(258,544,0,4.00),(259,549,0,3.00),(260,555,0,2.00),(261,560,0,1.00),(262,563,0,5.00),(263,568,0,3.00),(264,573,0,2.00),(265,580,0,2.00),(266,440,1,12.00),(267,453,1,12.00),(268,456,1,10.00),(269,460,1,10.00),(270,462,1,8.00),(271,467,1,6.00),(272,473,1,5.00),(273,478,1,3.00),(274,481,1,12.00),(275,494,1,12.00),(276,497,1,10.00),(277,501,1,10.00),(278,503,1,8.00),(279,508,1,6.00),(280,514,1,5.00),(281,519,1,3.00),(282,NULL,1,12.00),(283,535,1,12.00),(284,538,1,10.00),(285,542,1,10.00),(286,544,1,8.00),(287,549,1,6.00),(288,555,1,5.00),(289,560,1,3.00),(290,563,1,15.00),(291,568,1,15.00),(292,573,1,8.00),(293,580,1,5.00),(294,440,2,12.00),(295,453,2,12.00),(296,456,2,10.00),(297,460,2,10.00),(298,462,2,8.00),(299,467,2,6.00),(300,473,2,5.00),(301,478,2,3.00),(302,481,2,12.00),(303,494,2,12.00),(304,497,2,10.00),(305,501,2,10.00),(306,503,2,8.00),(307,508,2,6.00),(308,514,2,5.00),(309,519,2,3.00),(310,NULL,2,12.00),(311,535,2,12.00),(312,538,2,10.00),(313,542,2,10.00),(314,544,2,8.00),(315,549,2,6.00),(316,555,2,5.00),(317,560,2,3.00),(318,563,2,15.00),(319,568,2,15.00),(320,573,2,8.00),(321,580,2,5.00),(322,585,0,9.00),(323,585,1,12.00),(324,585,2,12.00),(325,598,0,7.00),(326,598,1,12.00),(327,598,2,12.00),(328,601,0,6.00),(329,601,1,10.00),(330,601,2,10.00),(331,605,0,5.00),(332,605,1,10.00),(333,605,2,10.00),(334,607,0,4.00),(335,607,1,8.00),(336,607,2,8.00),(337,612,0,3.00),(338,612,1,6.00),(339,612,2,6.00),(340,618,0,2.00),(341,618,1,5.00),(342,618,2,5.00),(343,623,0,1.00),(344,623,1,3.00),(345,623,2,3.00),(346,NULL,0,9.00),(347,NULL,1,12.00),(348,NULL,2,12.00),(349,639,0,7.00),(350,639,1,12.00),(351,639,2,12.00),(352,642,0,6.00),(353,642,1,10.00),(354,642,2,10.00),(355,646,0,5.00),(356,646,1,10.00),(357,646,2,10.00),(358,648,0,4.00),(359,648,1,8.00),(360,648,2,8.00),(361,653,0,3.00),(362,653,1,6.00),(363,653,2,6.00),(364,659,0,2.00),(365,659,1,5.00),(366,659,2,5.00),(367,664,0,1.00),(368,664,1,3.00),(369,664,2,3.00),(370,NULL,0,9.00),(371,NULL,1,12.00),(372,NULL,2,12.00),(373,680,0,7.00),(374,680,1,12.00),(375,680,2,12.00),(376,683,0,6.00),(377,683,1,10.00),(378,683,2,10.00),(379,687,0,5.00),(380,687,1,10.00),(381,687,2,10.00),(382,689,0,4.00),(383,689,1,8.00),(384,689,2,8.00),(385,694,0,3.00),(386,694,1,6.00),(387,694,2,6.00),(388,700,0,2.00),(389,700,1,5.00),(390,700,2,5.00),(391,705,0,1.00),(392,705,1,3.00),(393,705,2,3.00),(394,708,0,5.00),(395,708,1,15.00),(396,708,2,15.00),(397,713,0,3.00),(398,713,1,15.00),(399,713,2,15.00),(400,718,0,2.00),(401,718,1,8.00),(402,718,2,8.00),(403,725,0,2.00),(404,725,1,5.00),(405,725,2,5.00);
/*!40000 ALTER TABLE `geozone_irpf_handicap` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `holiday`
--

DROP TABLE IF EXISTS `holiday`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `holiday` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion de la Festividad',
  `holiday` int(4) DEFAULT NULL COMMENT 'Identificador de Festividad',
  `editable` tinyint(1) DEFAULT '0' COMMENT 'Indica si es editable o no',
  PRIMARY KEY (`id`),
  KEY `IDX_HOLIDAY_HOLIDAY` (`holiday`),
  KEY `IDX_HOLIDAY_DOMAIN` (`domain`),
  CONSTRAINT `FK_HOLIDAY_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_HOLIDAY_HOLIDAY` FOREIGN KEY (`holiday`) REFERENCES `holiday` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=95 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Festividades';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `holiday`
--

LOCK TABLES `holiday` WRITE;
/*!40000 ALTER TABLE `holiday` DISABLE KEYS */;
INSERT INTO `holiday` VALUES (21,0,'Fiestas ESTATALES',NULL,0),(22,0,'Festivos ANDALUCIA',21,0),(23,0,'Festivos PAÍS VASCO',21,0),(24,0,'Festivos ARAGÓN',21,0),(25,0,'Festivos ASTURIAS',21,0),(26,0,'Festivos VITORIA-GASTEIZ',23,0),(27,0,'Festivos BALEARES',21,0),(28,0,'Festivos CANARIAS',21,0),(29,0,'Festivos CANTABRIA',21,0),(30,0,'Festivos CASTILLA - LA MANCHA',21,0),(31,0,'Festivos CASTILLA Y LEÓN',21,0),(32,0,'Festivos CATALUÑA',21,0),(33,0,'Festivos COMUNIDAD VALENCIANA',21,0),(34,0,'Festivos EXTREMADURA',21,0),(35,0,'Festivos GALICIA',21,0),(36,0,'Festivos COMUNIDAD DE MADRID',21,0),(37,0,'Festivos REGIÓN DE MURCIA',21,0),(38,0,'Festivos NAVARRA',21,0),(39,0,'Festivos LA RIOJA',21,0),(40,0,'Festivos CIUDAD DE CEUTA',21,0),(41,0,'Festivos CIUDAD DE MELILLA',21,0),(42,0,'Festivos A CORUÑA',35,0),(43,0,'Festivos ALBACETE',30,0),(44,0,'Festivos ALICANTE',33,0),(45,0,'Festivos ALMERÍA',22,0),(46,0,'Festivos ÁVILA',31,0),(47,0,'Festivos BADAJOZ',34,0),(48,0,'Festivos BARCELONA',32,0),(49,0,'Festivos BILBAO',23,0),(50,0,'Festivos BURGOS',31,0),(51,0,'Festivos CÁCERES',34,0),(52,0,'Festivos CÁDIZ',22,0),(53,0,'Festivos CASTELLÓN',33,0),(54,0,'Festivos CEUTA',40,0),(55,0,'Festivos CIUDAD REAL',30,0),(56,0,'Festivos CÓRDOBA',22,0),(57,0,'Festivos CUENCA',30,0),(58,0,'Festivos GIRONA',32,0),(59,0,'Festivos GRANADA',22,0),(60,0,'Festivos GUADALAJARA',30,0),(61,0,'Festivos HUELVA',22,0),(62,0,'Festivos HUESCA',24,0),(63,0,'Festivos JAÉN',22,0),(64,0,'Festivos LAS PALMAS',28,0),(65,0,'Festivos LEÓN',31,0),(66,0,'Festivos LLEIDA',32,0),(67,0,'Festivos LOGROÑO',39,0),(68,0,'Festivos LUGO',35,0),(69,0,'Festivos MADRID',36,0),(70,0,'Festivos MÁLAGA',22,0),(71,0,'Festivos MELILLA',41,0),(72,0,'Festivos MURCIA',37,0),(73,0,'Festivos OURENSE',35,0),(74,0,'Festivos OVIEDO',25,0),(75,0,'Festivos PALENCIA',31,0),(76,0,'Festivos PALMA DE MALLORCA',27,0),(77,0,'Festivos PAMPLONA',38,0),(78,0,'Festivos PONTEVEDRA',35,0),(79,0,'Festivos SALAMANCA',31,0),(80,0,'Festivos SAN SEBASTIÁN',23,0),(81,0,'Festivos SANTA CRUZ DE TENERIFE',28,0),(82,0,'Festivos SANTANDER',29,0),(83,0,'Festivos SEGOVIA',31,0),(84,0,'Festivos SEVILLA',22,0),(85,0,'Festivos SORIA',31,0),(86,0,'Festivos TARRAGONA',32,0),(87,0,'Festivos TERUEL',24,0),(88,0,'Festivos TOLEDO',36,0),(89,0,'Festivos VALENCIA',33,0),(90,0,'Festivos VALLADOLID',31,0),(91,0,'Festivos ZAMORA',31,0),(92,0,'Festivos ZARAGOZA',24,0),(93,8785,'Festivos Propios',26,0),(94,8785,'Festivos Propios',NULL,0);
/*!40000 ALTER TABLE `holiday` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `holiday_detail`
--

DROP TABLE IF EXISTS `holiday_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `holiday_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `holiday` int(4) NOT NULL COMMENT 'Identificador de Festividad',
  `date` date NOT NULL COMMENT 'Fecha Festiva',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion de Festividad',
  PRIMARY KEY (`id`),
  KEY `IDX_HOLIDAY_DETAIL_HOLIDAY` (`holiday`),
  KEY `IDX_HOLIDAY_DETAIL_DOMAIN` (`domain`),
  CONSTRAINT `FK_HOLIDAY_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_HOLIDAY_DETAIL_HOLIDAY` FOREIGN KEY (`holiday`) REFERENCES `holiday` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=869 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalle de Festividades';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `holiday_detail`
--

LOCK TABLES `holiday_detail` WRITE;
/*!40000 ALTER TABLE `holiday_detail` DISABLE KEYS */;
INSERT INTO `holiday_detail` VALUES (72,0,21,'2014-01-01','Año Nuevo'),(73,0,21,'2014-04-18','Viernes Santo'),(74,0,21,'2014-05-01','Fiesta del Trabajo'),(75,0,21,'2014-08-15','Asunción de la Virgen'),(76,0,21,'2014-11-01','Todos lo Santos'),(77,0,21,'2014-12-06','Día de la Constitución Española'),(78,0,21,'2014-12-25','Natividad deñ Señor'),(79,0,21,'2014-12-08','La Inmaculada Concepción'),(80,0,22,'2014-01-06','Epifanía del Señor'),(81,0,22,'2014-02-28','Día de Andalucía'),(82,0,22,'2014-04-17','Jueves Santo'),(83,0,22,'2014-10-13','Lunes siguiente a la Fiesta Nacional de España'),(84,0,23,'2014-01-06','Epifanía del Señor'),(85,0,23,'2014-04-17','Jueves Santo'),(86,0,23,'2014-04-21','Lunes de Pascua'),(87,0,23,'2014-07-25','Santiago Apostol'),(88,0,24,'2014-01-06','Epifanía del Señor'),(89,0,24,'2014-04-17','Jueves Santo'),(90,0,24,'2014-04-23','San Jorge'),(91,0,24,'2014-10-13','Lunes siguiente a la Fiesta Nacional de España'),(92,0,25,'2014-01-06','Epifanía del Señor'),(93,0,25,'2014-04-17','Jueves Santo'),(94,0,25,'2014-09-08','Día de Asturias'),(95,0,25,'2014-10-13','Lunes siguiente a la Fiesta Nacional de España'),(96,0,26,'2014-04-28','San Prudencio'),(97,0,26,'2014-08-05','Ntra. Sra. De la Virgen Blanca'),(98,0,27,'2014-01-06','Epifanía del Señor'),(99,0,27,'2014-03-01','Día de las Illes Balears'),(100,0,27,'2014-04-17','Jueves Santo'),(101,0,27,'2014-12-26','San Esteban - Segunda Fiesta de Navidad'),(102,0,28,'2014-01-06','Epifanía del Señor'),(103,0,28,'2014-04-17','Jueves Santo'),(104,0,28,'2014-05-30','Día de Canarias'),(105,0,29,'2014-01-06','Epifanía del Señor'),(106,0,29,'2014-04-17','Jueves Santo'),(107,0,29,'2014-07-25','Santiago Apostol'),(108,0,29,'2014-09-15','Festividad de la Bien Aparecida'),(109,0,30,'2014-01-06','Epifanía del Señor'),(110,0,30,'2014-04-17','Jueves Santo'),(111,0,30,'2014-04-21','Lunes de Pascua'),(112,0,30,'2014-06-19','Corpus Christi'),(113,0,31,'2014-01-06','Epifanía del Señor'),(114,0,31,'2014-04-17','Jueves Santo'),(115,0,31,'2014-04-23','Fiesta de la Comunidad Autónoma'),(116,0,31,'2014-10-13','Lunes siguiente a la Fiesta Nacional de España'),(117,0,32,'2014-01-06','Epifanía del Señor'),(118,0,32,'2014-04-21','Lunes de Pascua'),(119,0,32,'2014-06-24','San Juan'),(120,0,32,'2014-09-11','Fiesta Nacional de Cataluña'),(121,0,32,'2014-12-26','San Esteban - Segunda Fiesta de Navidad'),(122,0,33,'2014-01-06','Epifanía del Señor'),(123,0,33,'2014-03-19','San José'),(124,0,33,'2014-04-21','Lunes de Pascua'),(125,0,33,'2014-10-09','Día de la Comunidad Valenciana'),(126,0,34,'2014-01-06','Epifanía del Señor'),(127,0,34,'2014-04-17','Jueves Santo'),(128,0,34,'2014-09-08','Día de Extremadura'),(129,0,34,'2014-10-13','Lunes siguiente a la Fiesta Nacional de España'),(130,0,35,'2014-01-06','Epifanía del Señor'),(131,0,35,'2014-04-17','Jueves Santo'),(132,0,35,'2014-05-17','Día de las Letras Gallegas'),(133,0,35,'2014-07-25','Día Nacional de Galicia'),(134,0,36,'2014-01-06','Epifanía del Señor'),(135,0,36,'2014-04-17','Jueves Santo'),(136,0,36,'2014-05-02','Fiesta de la Comunidad de Madrid'),(137,0,36,'2014-06-19','Corpus Christi'),(138,0,37,'2014-01-06','Epifanía del Señor'),(139,0,37,'2014-03-19','San José'),(140,0,37,'2014-04-17','Jueves Santo'),(141,0,37,'2014-06-09','Día de la Región de Murcia'),(142,0,38,'2014-01-06','Epifanía del Señor'),(143,0,38,'2014-03-19','San José'),(144,0,38,'2014-04-17','Jueves Santo'),(145,0,38,'2014-04-21','Lunes de Pascua'),(146,0,39,'2014-01-06','Epifanía del Señor'),(147,0,39,'2014-04-17','Jueves Santo'),(148,0,39,'2014-04-21','Lunes de Pascua'),(149,0,39,'2014-06-09','Día de La Rioja'),(150,0,40,'2014-01-06','Epifanía del Señor'),(151,0,40,'2014-04-17','Jueves Santo'),(152,0,40,'2014-10-06','Festividad de la Pascua del Sacrificio (DUL - HIY - YA)'),(153,0,40,'2014-10-13','Lunes siguiente a la Fiesta Nacional de España'),(154,0,41,'2014-01-06','Epifanía del Señor'),(155,0,41,'2014-03-19','San José'),(156,0,41,'2014-04-17','Jueves Santo'),(157,0,41,'2014-10-04','Fiesta del Sacrificio (Aid El Kebir)'),(158,0,42,'2014-03-04','Martes de Carnaval'),(159,0,42,'2014-06-24','San Juan'),(160,0,43,'2014-06-24','San Juan'),(161,0,43,'2014-09-08','Virgen de los Llanos'),(162,0,44,'2014-06-23','Lunes de Hogueras'),(163,0,44,'2014-06-24','San Juan'),(164,0,45,'2014-06-24','San Juan'),(165,0,45,'2014-08-30','Virgen del Mar'),(166,0,46,'2014-05-02','San Segundo'),(167,0,46,'2014-10-15','Santa Teresa de Jesús'),(168,0,47,'2014-03-04','Martes de Carnaval'),(169,0,47,'2014-06-24','San Juan'),(170,0,48,'2014-06-09','Pascua Granada'),(171,0,48,'2014-09-24','Día de La Merced'),(172,0,49,'2014-07-31','San Ignacio'),(173,0,49,'2014-08-22','Viernes de la Semana Grande'),(174,0,50,'2014-06-20','Curpillos'),(175,0,50,'2014-06-30','San Pedro y San Pablo'),(176,0,51,'2014-04-23','San Jorge'),(177,0,51,'2014-05-30','San Fernando'),(178,0,52,'2014-03-03','Lunes de Carnaval'),(179,0,52,'2014-10-07','Virgen del Rosario'),(180,0,53,'2014-03-24','Lunes de Magdalena'),(181,0,53,'2014-03-28','Viernes de Magdalena'),(182,0,54,'2014-06-13','San Antonio'),(183,0,54,'2014-08-05','Virgen de África'),(184,0,55,'2014-06-09','Virgen de Alarcos'),(185,0,55,'2014-08-22','La Octava'),(186,0,56,'2014-09-08','Virgen de la Fuensanta'),(187,0,56,'2014-10-24','San Rafael'),(188,0,57,'2014-01-28','San Julián'),(189,0,57,'2014-06-02','Virgen de la Luz'),(190,0,58,'2014-07-25','San Jaime'),(191,0,58,'2014-10-29','San Narcís'),(192,0,59,'2014-01-02','Día de la Toma'),(193,0,59,'2014-06-19','Corpus Christi'),(194,0,60,'2014-09-08','Virgen de la Antigua'),(195,0,60,'2014-09-12','Viernes de la Semana de Feria'),(196,0,61,'2014-08-04','Fiestas Colombianas'),(197,0,61,'2014-09-08','Virgen de la Cinta'),(198,0,62,'2014-01-22','San Vicente'),(199,0,62,'2014-08-11','San Lorenzo'),(200,0,63,'2014-06-11','Virgen de la Capilla'),(201,0,63,'2014-10-18','San Lucas'),(202,0,64,'2014-03-04','Martes de Carnaval'),(203,0,64,'2014-06-24','San Juan Bautista'),(204,0,65,'2014-06-24','San Juan'),(205,0,65,'2014-10-06','Lunes siguiente a San Froilán'),(206,0,66,'2014-05-12','San Anastasio'),(207,0,66,'2014-09-29','San Miguel'),(208,0,67,'2014-06-11','San Bernabé'),(209,0,67,'2014-09-22','San Mateo'),(210,0,68,'2014-03-04','Martes de Carnaval'),(211,0,68,'2014-10-06','Lunes siguiente a San Froilán'),(212,0,69,'2014-05-15','San Isidro'),(213,0,69,'2014-11-10','Lunes siguiente a Nuestra Señora de la Almudena'),(214,0,70,'2014-08-19','Reconquista de Málaga para la Corona de Castilla'),(215,0,70,'2014-09-08','Virgen de la Victoria'),(216,0,71,'2014-09-08','Virgen de la Victoria'),(217,0,71,'2014-09-17','Día de Melilla'),(218,0,72,'2014-04-22','Bando de la Huerta'),(219,0,72,'2014-09-16','Fiesta de la Romería'),(220,0,73,'2014-03-04','Martes de Carnaval'),(221,0,73,'2014-11-11','San Martiño'),(222,0,74,'2014-06-10','Martes de Campo'),(223,0,74,'2014-09-22','San Mateo'),(224,0,75,'2014-02-03','Lunes siguiente a Las Candelas'),(225,0,75,'2014-09-02','San Antolín'),(226,0,76,'2014-01-20','San Sebastián'),(227,0,76,'2014-04-21','Segunda Fiesta de Pascua'),(228,0,77,'2014-11-20','San Saturnino'),(229,0,77,'2014-12-03','San Francisco Javier'),(230,0,78,'2014-03-05','Miércoles de Ceniza'),(231,0,78,'2014-07-11','San Benito de Lerez'),(232,0,79,'2014-06-12','San Juan de Sahagún'),(233,0,79,'2014-09-08','Virgen de La Vega'),(234,0,80,'2014-01-20','Día de San Sebastián'),(235,0,80,'2014-07-31','San Ignacio'),(236,0,81,'2014-03-04','Martes de Carnaval'),(237,0,81,'2014-05-03','Día de Santa Cruz'),(238,0,82,'2014-06-09','Virgen del Mar'),(239,0,82,'2014-08-30','Santos Mártires'),(240,0,83,'2014-06-24','San Juan'),(241,0,83,'2014-10-24','San Frutos'),(242,0,84,'2014-05-30','San Fernando'),(243,0,84,'2014-06-19','Corpus Christi'),(244,0,85,'2014-06-26','Jueves de La Saca'),(245,0,85,'2014-10-02','San Saturio'),(246,0,86,'2014-08-19','Sant Magí'),(247,0,86,'2014-09-23','Santa Tecla'),(248,0,87,'2014-04-22','Sermón de las Tortillas'),(249,0,87,'2014-07-14','Lunes de Vaquillas'),(250,0,88,'2014-01-23','San Idelfonso'),(251,0,88,'2014-04-07','Fallecimiento de El Greco'),(252,0,89,'2014-01-22','San Vicente Mártir'),(253,0,89,'2014-04-28','San Vicente Ferrer'),(254,0,90,'2014-05-13','San Predro Regalado'),(255,0,90,'2014-09-08','Nuestra Sra. de San Lorenzo'),(256,0,91,'2014-06-08','La Hiniesta'),(257,0,91,'2014-09-08','Virgen de la Concha'),(258,0,92,'2014-01-29','San Valero'),(259,0,92,'2014-03-05','Cincomarzada'),(466,0,21,'2015-01-01','Fiesta de Año Nuevo'),(467,0,21,'2015-12-25','Natividad del Señor'),(468,0,21,'2015-12-08','Día de la Inmaculada Concepción'),(469,0,21,'2015-10-12','Día de la Hispanidad'),(470,0,21,'2015-08-15','Asunción de la Virgen'),(471,0,21,'2015-05-01','Fiesta del Trabajo'),(472,0,21,'2015-04-03','Viernes Santo'),(473,0,21,'2015-01-06','Epifanía del Señor'),(474,0,22,'2015-12-07','Lunes siguiente al día de la Constitución Española'),(475,0,22,'2015-11-02','Lunes siguiente a Todos los Santos'),(476,0,22,'2015-04-02','Jueves Santo'),(477,0,22,'2015-02-28','Día de Andalucía'),(478,0,23,'2015-04-02','Jueves Santo'),(479,0,23,'2015-04-06','Lunes de Pascua'),(480,0,23,'2015-07-25','Santiago Apostol'),(481,0,23,'2015-03-19','San José'),(482,0,24,'2015-11-02','Lunes siguiente a Todos los Santos'),(483,0,24,'2015-12-07','Lunes siguiente al Día de la Constitución Española'),(484,0,24,'2015-04-23','San Jorge, Día de Aragón'),(485,0,24,'2015-04-02','Jueves Santo'),(486,0,25,'2015-12-07','Lunes siguiente al Día de la Constitución Española'),(487,0,25,'2015-11-02','Lunes siguiente a Todos los Santos'),(488,0,25,'2015-09-08','Día de Asturias'),(489,0,25,'2015-04-02','Jueves Santo'),(490,0,26,'2015-04-28','San Prudencio'),(491,0,26,'2015-08-05','Nuestra Señora de la Virgen Blanca'),(492,0,27,'2015-04-06','Lunes de Pascua'),(493,0,27,'2015-04-02','Jueves Santo'),(494,0,27,'2015-12-07','Lunes siguiente al Día de la Constitución Española'),(495,0,27,'2015-11-02','Lunes siguiente a Todos los Santos'),(496,0,28,'2015-04-02','Jueves Santo'),(497,0,28,'2015-11-02','Lunes siguiente a Todos los Santos'),(498,0,28,'2015-05-30','Día de Canarias'),(499,0,29,'2015-04-02','Jueves Santo'),(500,0,29,'2015-04-06','Lunes de Pascua'),(501,0,29,'2015-09-15','Fiesta de la Bien Aparecida'),(502,0,29,'2015-11-02','Lunes siguiente a Todos los Santos'),(503,0,30,'2015-12-07','Lunes siguiente al Día de la Constitución Española'),(504,0,30,'2015-04-06','Lunes de Pascua'),(505,0,30,'2015-04-02','Jueves Santo'),(506,0,30,'2015-06-04','Fiesta del Corpus Christi'),(507,0,31,'2015-12-07','Lunes siguiente al Día de la Constitución Española'),(508,0,31,'2015-04-02','Jueves Santo'),(509,0,31,'2015-04-23','Día de la Comunidad Autónoma'),(510,0,31,'2015-11-02','Lunes siguiente a Todos los Santos'),(511,0,32,'2015-06-24','San Juan'),(512,0,32,'2015-04-06','Lunes de Pascua'),(513,0,32,'2015-12-26','San Esteban'),(514,0,32,'2015-09-11','Fiesta Nacional de Cataluña'),(515,0,33,'2015-12-07','Lunes siguiente al Día de la Constitución Española'),(516,0,33,'2015-03-19','San José'),(517,0,33,'2015-10-09','Día de la Comunidad Valenciana'),(518,0,33,'2015-04-06','Lunes de Pascua'),(519,0,34,'2015-11-02','Lunes siguiente a Todos los Santos'),(520,0,34,'2015-09-08','Día de Extremadura'),(521,0,34,'2015-04-02','Jueves Santo'),(522,0,34,'2015-12-07','Lunes siguiente al Día de la Constitución Española'),(523,0,35,'2015-07-25','Día Nacional de Galicia'),(524,0,35,'2015-11-02','Lunes siguiente a Todos los Santos'),(525,0,35,'2015-04-02','Jueves Santo'),(526,0,35,'2015-03-20','Día siguiente a San José'),(527,0,36,'2015-05-02','Fiesta de la Comunidad de Madrid'),(528,0,36,'2015-06-04','Fiesta del Corpus Christi'),(529,0,36,'2015-04-02','Jueves Santo'),(530,0,36,'2015-03-19','San José'),(531,0,37,'2015-12-07','Día siguiente al Día de la Constitución Española'),(532,0,37,'2015-06-09','Día de la Región de Murcia'),(533,0,37,'2015-03-19','San José'),(534,0,37,'2015-04-02','Jueves Santo'),(535,0,38,'2015-04-02','Jueves Santo'),(536,0,38,'2015-03-19','San José'),(537,0,38,'2015-04-06','Lunes de Pascua'),(538,0,38,'2015-07-25','Santiago Apostol'),(539,0,39,'2015-12-07','Lunes siguiente al Día de la Constitución Española'),(540,0,39,'2015-04-02','Jueves Santo'),(541,0,39,'2015-04-06','Lunes de Pascua'),(542,0,39,'2015-06-09','Día de La Rioja'),(543,0,40,'2015-08-05','Virgen de Africa'),(544,0,40,'2015-11-02','Lunes siguiente a Todos los Santos'),(545,0,40,'2015-04-02','Jueves Santo'),(546,0,40,'2015-12-07','Lunes siguiente al Día de la Constitución Española'),(547,0,40,'2015-06-13','San Antonio'),(548,0,40,'2015-09-25','Festividad de la Pascua del Sacrificio'),(549,0,41,'2015-09-25','Fiesta del Sacrificio'),(550,0,41,'2015-12-07','Lunes siguiente al Día de la Constitución Española'),(551,0,41,'2015-09-08','Virgen de la Victoria'),(552,0,41,'2015-09-17','Día de Melilla'),(553,0,41,'2015-04-02','Jueves Santo'),(554,0,41,'2015-03-19','San José'),(555,0,42,'2015-02-17','Martes de Carnaval'),(556,0,42,'2015-06-24','San Juan'),(557,0,43,'2015-09-08','Virgen de los Llanos'),(558,0,43,'2015-06-24','San Juan'),(559,0,44,'2015-04-16','Santa Faz'),(560,0,44,'2015-06-24','San Juan'),(561,0,45,'2015-06-24','Festividad de San Juan'),(562,0,45,'2015-08-29','Día de la Virgen del Mar'),(563,0,46,'2015-10-15','Santa Teresa de Jesús'),(564,0,46,'2015-05-02','San Segundo'),(565,0,47,'2015-06-24','San Juan'),(566,0,47,'2015-02-17','Martes de Carnaval'),(567,0,48,'2015-06-01','Pascua Granada'),(568,0,48,'2015-09-24','Día de la Merced'),(569,0,49,'2015-08-28','Viernes de la Semana Grande'),(570,0,49,'2015-07-31','San Ignacio'),(571,0,50,'2015-06-12','Curpillos'),(572,0,50,'2015-06-29','San Pedro y San Pablo'),(573,0,51,'2015-05-29','San Fernando'),(574,0,51,'2015-04-23','San Jorge'),(575,0,52,'2015-02-16','Lunes de Carnaval'),(576,0,52,'2015-10-07','Virgen del Rosario'),(577,0,53,'2015-06-29','San Pedro y San Pablo'),(578,0,53,'2015-03-09','Lunes de Magdalena'),(579,0,55,'2015-06-01','Virgen de los Alarcos'),(580,0,55,'2015-08-22','La Octava'),(581,0,56,'2015-09-08','Virgen de la Fuensanta'),(582,0,56,'2015-10-24','San Rafael'),(583,0,57,'2015-06-01','Virgen de la Luz'),(584,0,57,'2015-01-28','San Julián'),(585,0,58,'2015-10-29','San Narcís'),(586,0,58,'2015-07-25','San Jaime'),(587,0,59,'2015-06-04','Corpus Christi'),(588,0,59,'2015-01-02','Día de la Toma'),(589,0,60,'2015-09-11','Viernes de la Semana de Feria'),(590,0,60,'2015-09-08','Virgen de la Antigua'),(591,0,61,'2015-08-03','Fiestas Colombinas'),(592,0,61,'2015-09-08','Virgen de la Cinta'),(593,0,62,'2015-08-10','San Lorenzo'),(594,0,62,'2015-01-22','San Vicente'),(595,0,63,'2015-06-11','Virgen de la Capilla'),(596,0,63,'2015-11-25','Santa Catalina de Alejandría'),(597,0,64,'2015-02-17','Martes de Carnaval'),(598,0,64,'2015-06-24','San Juan Bautista'),(599,0,65,'2015-10-05','San Froilán'),(600,0,65,'2015-06-24','San Juan'),(601,0,66,'2015-09-29','San Miquel'),(602,0,66,'2015-05-11','San Anastasio'),(603,0,67,'2015-09-21','San Mateo'),(604,0,67,'2015-06-11','San Bernabé'),(605,0,68,'2015-10-05','San Froilán'),(606,0,68,'2015-02-17','Martes de Carnaval'),(607,0,69,'2015-05-15','San Isidro'),(608,0,69,'2015-11-09','Nuestra Señora de la Almudena'),(609,0,70,'2015-09-08','Día de la Victoria'),(610,0,70,'2015-08-19','Reconquista de Malaga para la Corona de Castilla'),(611,0,72,'2015-09-15','Fiesta de la Romería'),(612,0,72,'2015-04-07','Bando de la Huerta'),(613,0,73,'2015-02-17','Martes de Carnaval'),(614,0,73,'2015-11-11','San Martiño'),(615,0,74,'2015-05-26','Martes del Campo'),(616,0,74,'2015-09-21','San Mateo'),(617,0,75,'2015-09-02','San Antolín'),(618,0,75,'2015-02-02','Las Candelas'),(619,0,76,'2015-01-20','San Sebastián'),(620,0,76,'2015-12-26','Segunda Navidad'),(621,0,77,'2015-11-30','Lunes siguiente a San Saturnino'),(622,0,77,'2015-12-03','San Francisco Javier'),(623,0,78,'2015-07-11','San Benito'),(624,0,78,'2015-02-18','Miércoles de Ceniza'),(625,0,79,'2015-09-08','Virgen de La Vega'),(626,0,79,'2015-06-12','San Juan de Sahagún'),(627,0,80,'2015-07-31','San Ignacio'),(628,0,80,'2015-01-20','Día de San Sebastián'),(629,0,81,'2015-05-04','Lunes siguiente al Día de Santa Cruz'),(630,0,81,'2015-02-17','Martes de Carnaval'),(631,0,82,'2015-07-25','Santiago Apostol'),(632,0,82,'2015-05-25','Virgen del Mar'),(633,0,83,'2015-10-26','Lunes siguiente a San Frutos'),(634,0,83,'2015-06-29','San Pedro'),(635,0,84,'2015-06-04','Corpus Christi'),(636,0,84,'2015-04-22','Miércoles de Feria'),(637,0,85,'2015-06-25','Jueves de la Saca'),(638,0,85,'2015-10-02','San Saturio'),(639,0,86,'2015-08-19','Sant Magí'),(640,0,86,'2015-09-23','Santa Tecla'),(641,0,87,'2015-04-07','Sermón de las Tortilas'),(642,0,87,'2015-07-13','Lunes de Vaquillas'),(643,0,88,'2015-03-19','San José'),(644,0,88,'2015-01-23','San Ildefonso'),(645,0,89,'2015-04-13','San Vicente Ferrer'),(646,0,89,'2015-01-22','San Vicente Mártir'),(647,0,90,'2015-09-08','Nuestra Señora de San Lorenzo'),(648,0,90,'2015-05-13','San Pedro Regalado'),(649,0,91,'2015-06-29','San Pedro'),(650,0,91,'2015-05-25','La Hiniesta'),(651,0,92,'2015-03-05','Cincomarzada'),(652,0,92,'2015-01-29','San Valero'),(682,0,21,'2016-01-01','Año Nuevo'),(683,0,21,'2016-01-06','Epifanía del Señor'),(684,0,21,'2016-03-25','Viernes Santo'),(685,0,21,'2016-08-15','Asunción de la Virgen'),(686,0,21,'2016-10-12','Fiesta Nacional de España'),(687,0,21,'2016-11-01','Todos los Santos'),(688,0,21,'2016-12-06','Día de la Constitución Española'),(689,0,21,'2016-12-08','La Inmaculada Concepción'),(690,0,22,'2016-02-29','Día de Andalucía'),(691,0,22,'2016-03-24','Jueves Santo'),(692,0,22,'2016-05-02','Lunes siguiente a la Fiesta del Trabajo'),(693,0,22,'2016-12-26','Lunes siguiente a la Natividad del Señor San Esteban'),(694,0,24,'2016-03-24','Jueves Santo'),(695,0,24,'2016-04-23','San Jorge, Día de Aragón'),(696,0,24,'2016-05-02','Lunes siguiente a la Fiesta del Trabajo'),(697,0,24,'2016-12-26','Lunes siguiente a la Natividad del Señor San Esteban'),(698,0,25,'2016-03-24','Jueves Santo'),(699,0,25,'2016-05-02','Lunes siguiente a la Fiesta del Trabajo'),(700,0,25,'2016-09-08','Día de Asturias'),(701,0,25,'2016-12-26','Lunes siguiente a la Natividad del Señor San Esteban'),(702,0,27,'2016-03-01','Día de las Islas Baleares'),(703,0,27,'2016-03-24','Jueves Santo'),(704,0,27,'2016-03-28','Lunes de Pascua'),(705,0,27,'2016-12-26','Lunes siguiente a la Natividad del Señor San Esteban'),(706,0,28,'2016-03-24','Jueves Santo'),(707,0,28,'2016-05-02','Lunes siguiente a la Fiesta del Trabajo'),(708,0,28,'2016-05-30','Día de Canarias'),(709,0,29,'2016-03-24','Jueves Santo'),(710,0,29,'2016-07-28','Día de las Instituciones de Cantabria'),(711,0,29,'2016-09-15','Festividad de la Bien Aparecida'),(712,0,29,'2016-12-26','Lunes siguiente a la Natividad del Señor San Esteban'),(713,0,30,'2016-03-24','Jueves Santo'),(714,0,30,'2016-05-26','Corpus Christi'),(715,0,30,'2016-05-31','Día de la Región de Castilla- La Mancha'),(716,0,30,'2016-12-26','Lunes siguiente a la Natividad del Señor San Esteban'),(717,0,31,'2016-03-24','Jueves Santo'),(718,0,31,'2016-04-23','Fiesta de la Comunidad Autónoma'),(719,0,31,'2016-05-02','Lunes siguiente a la Fiesta del Trabajo'),(720,0,31,'2016-12-26','Lunes siguiente a la Natividad del Señor San Esteban'),(721,0,32,'2016-03-28','Lunes de Pascua'),(722,0,32,'2016-05-16','Lunes de Pascua Granada'),(723,0,32,'2016-06-24','San Juan'),(724,0,32,'2016-12-26','Lunes siguiente a la Natividad del Señor  San Esteban'),(725,0,33,'2016-03-19','San José'),(726,0,33,'2016-03-24','Jueves Santo'),(727,0,33,'2016-03-28','Lunes de Pascua'),(728,0,33,'2016-12-26','Lunes siguiente a la Natividad del Señor  San Esteban'),(729,0,34,'2016-03-24','Jueves Santo'),(730,0,34,'2016-05-02','Lunes siguiente a la Fiesta del Trabajo'),(731,0,34,'2016-09-08','Día de Extremadura'),(732,0,34,'2016-12-26','Lunes siguiente a la Natividad del Señor  San Esteban'),(733,0,35,'2016-03-24','Jueves Santo'),(734,0,35,'2016-05-17','Día de las Letras Gallegas'),(735,0,35,'2016-06-24','San Juan'),(736,0,35,'2016-07-25','Día Nacional de Galicia'),(737,0,36,'2016-03-24','Jueves Santo'),(738,0,36,'2016-05-02','Lunes siguiente a la Fiesta del Trabajo'),(739,0,36,'2016-07-25','Santiago Apóstol'),(740,0,36,'2016-12-26','Lunes siguiente a la Natividad del Señor  San Esteban'),(741,0,37,'2016-03-19','San José'),(742,0,37,'2016-03-24','Jueves Santo'),(743,0,37,'2016-06-09','Día de la Región de Murcia'),(744,0,37,'2016-12-26','Lunes siguiente a la Natividad del Señor  San Esteban'),(745,0,38,'2016-03-24','Jueves Santo'),(746,0,38,'2016-03-28','Lunes de Pascua'),(747,0,38,'2016-07-25','Santiago Apóstol'),(748,0,38,'2016-12-26','Lunes siguiente a la Natividad del Señor  San Esteban'),(749,0,23,'2016-03-24','Jueves Santo'),(750,0,23,'2016-03-28','Lunes de Pascua'),(751,0,23,'2016-07-25','Santiago Apóstol'),(752,0,23,'2016-10-07','80º Aniversario del primer Gobierno Vasco'),(753,0,39,'2016-03-24','Jueves Santo'),(754,0,39,'2016-03-28','Lunes de Pascua'),(755,0,39,'2016-06-09','Día de La Rioja'),(756,0,39,'2016-07-25','Santiago Apóstol'),(757,0,40,'2016-03-24','Jueves Santo'),(758,0,40,'2016-09-02','Día de la Ciudad Autónoma de Ceuta'),(759,0,40,'2016-09-12','Festividad de la Pascua del Sacrificio(EidulAdha)'),(760,0,40,'2016-12-26','Lunes siguiente a la Natividad del Señor  San Esteban'),(761,0,41,'2016-03-19','San José'),(762,0,41,'2016-03-24','Jueves Santo'),(763,0,41,'2016-09-12','Fiesta del Sacrificio (Aid El Kebir)'),(764,0,41,'2016-12-26','Lunes siguiente a la Natividad del Señor  San Esteban'),(765,0,42,'2016-02-09','Martes de Carnaval'),(766,0,42,'2016-10-07','Virgen del Rosario'),(767,0,43,'2016-06-24','San Juan'),(768,0,43,'2016-09-08','Virgen de los Llanos'),(769,0,44,'2016-04-07','Santa Faz'),(770,0,44,'2016-06-24','San Juan'),(771,0,45,'2016-06-24','San Juan'),(772,0,45,'2016-08-27','Virgen del Mar'),(773,0,46,'2016-05-03','Día después deSan Segundo'),(774,0,46,'2016-10-15','Santa Teresa de Jesús'),(775,0,47,'2016-02-09','Martes de Carnaval'),(776,0,47,'2016-06-24','San Juan'),(777,0,48,'2016-02-12','Santa Eulàlia'),(778,0,48,'2016-09-24','Día de la Merced'),(779,0,49,'2016-07-04','San Valentín de Berriotxoa'),(780,0,49,'2016-08-26','Viernes de la Semana Grande'),(781,0,50,'2016-06-03','Curpillos'),(782,0,50,'2016-06-29','San Pedro y San Pablo'),(783,0,51,'2016-04-23','San Jorge'),(784,0,51,'2016-05-27','San Fernando'),(785,0,52,'2016-02-08','Lunes de Carnaval'),(786,0,52,'2016-10-07','Virgen del Rosario'),(787,0,53,'2016-02-29','Lunes de Magdalena'),(788,0,53,'2016-06-29','San Pedro y San Pablo'),(789,0,54,'2016-06-13','San Antonio'),(790,0,54,'2016-08-05','Virgen de África'),(791,0,55,'2016-05-16','Virgen de Alarcos'),(792,0,55,'2016-08-22','La Octava'),(793,0,56,'2016-09-08','Virgen de laFuensanta'),(794,0,56,'2016-10-24','San Rafael'),(795,0,57,'2016-01-28','San Julián'),(796,0,57,'2016-06-01','Virgen de la Luz'),(797,0,58,'2016-07-25','San Jaime'),(798,0,58,'2016-10-29','San Narcís'),(799,0,59,'2016-01-02','Día de la Toma'),(800,0,59,'2016-05-26','Corpus Christi'),(801,0,60,'2016-09-08','Virgen de la Antigua'),(802,0,60,'2016-09-16','Viernes de la Semana de Feria'),(803,0,61,'2016-08-03','Fiestas Colombinas'),(804,0,61,'2016-09-08','Virgen de la Cinta'),(805,0,62,'2016-01-22','San Vicente'),(806,0,62,'2016-08-10','San Lorenzo'),(807,0,63,'2016-10-18','San Lucas'),(808,0,63,'2016-11-25','Santa Catalina de Alejandría'),(809,0,64,'2016-02-09','Martes de Carnaval'),(810,0,64,'2016-06-24','San Juan Bautista'),(811,0,65,'2016-06-24','San Juan'),(812,0,65,'2016-10-05','San Froilán'),(813,0,66,'2016-05-11','San Anastasio'),(814,0,66,'2016-09-29','San Miquel'),(815,0,67,'2016-06-11','San Bernabé'),(816,0,67,'2016-09-21','San Mateo'),(817,0,68,'2016-02-09','Martes de Carnaval'),(818,0,68,'2016-10-05','San Froilán'),(819,0,69,'2016-05-16','Lunes siguiente a San Isidro'),(820,0,69,'2016-11-09','Nuestra Señora de la Almudena'),(821,0,70,'2016-08-19','Reconquista de Málaga para la Corona de Castilla'),(822,0,70,'2016-09-08','Virgen de la Victoria'),(823,0,71,'2016-09-08','Virgen de la Victoria'),(824,0,71,'2016-09-17','Día de Melilla'),(825,0,72,'2016-03-29','Bando de la Huerta'),(826,0,72,'2016-09-13','Fiesta de la Romería'),(827,0,73,'2016-02-09','Martes de Carnaval'),(828,0,73,'2016-11-11','San Martiño'),(829,0,74,'2016-05-17','Martes de Campo'),(830,0,74,'2016-09-21','San Mateo'),(831,0,75,'2016-02-02','Las Candelas'),(832,0,75,'2016-09-02','San Antolín'),(833,0,76,'2016-01-20','San Sebastián'),(834,0,76,'2016-06-24','San Juan'),(835,0,77,'2016-11-29','San Saturnino'),(836,0,77,'2016-12-03','San Francisco Javier'),(837,0,78,'2016-02-10','Miércoles de Ceniza'),(838,0,78,'2016-07-11','San Benito de Lerez'),(839,0,79,'2016-06-13','Lunes siguiente a San Juan de Sahagún'),(840,0,79,'2016-09-08','Virgen de la Vega'),(841,0,80,'2016-01-20','Día de San Sebastián'),(842,0,80,'2016-09-09','Virgen de Arantzazu'),(843,0,81,'2016-02-09','Martes de Carnaval'),(844,0,81,'2016-05-03','Día de la Santa Cruz'),(845,0,82,'2016-07-25','Santiago Apóstol'),(846,0,82,'2016-08-30','Santos Mártires'),(847,0,83,'2016-06-29','San Pedro'),(848,0,83,'2016-10-25','San Frutos'),(849,0,84,'2016-04-13','Miércoles de Feria'),(850,0,84,'2016-05-26','Corpus Christi'),(851,0,85,'2016-06-30','Jueves de La Saca'),(852,0,85,'2016-10-03','Lunes siguiente a San Saturio'),(853,0,86,'2016-08-19','Sant Magí'),(854,0,86,'2016-09-23','Santa Tecla'),(855,0,87,'2016-03-29','Sermón de las Tortillas'),(856,0,87,'2016-07-11','Lunes de Vaquillas'),(857,0,88,'2016-01-23','San Ildefonso'),(858,0,88,'2016-03-28','Lunes de Pascua'),(859,0,89,'2016-01-22','San Vicente Mártir'),(860,0,89,'2016-04-04','San Vicente Ferrer'),(861,0,90,'2016-05-13','San Pedro Regalado'),(862,0,90,'2016-09-08','Nuestra Sra. de San Lorenzo'),(863,0,26,'2016-04-28','San Prudencio'),(864,0,26,'2016-08-05','Ntra. Sra. De la Virgen Blanca'),(865,0,91,'2016-05-26','La Hiniesta'),(866,0,91,'2016-06-29','San Pedro'),(867,0,92,'2016-01-29','San Valero'),(868,0,92,'2016-03-05','Cincomarzada');
/*!40000 ALTER TABLE `holiday_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hotel`
--

DROP TABLE IF EXISTS `hotel`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `hotel` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `code` varchar(16) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Codigo del Hotel',
  `scope` int(4) NOT NULL COMMENT 'Identificador del Ambito',
  `workplace` int(4) NOT NULL COMMENT 'Identificador del Centro de Trabajo',
  `phone` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Telefono del Hotel',
  `fax` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Fax del Hotel',
  `email` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Email del Hotel',
  `web` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Web del Hotel',
  `service_catalogue` int(4) DEFAULT NULL COMMENT 'Identificador del Catalogo de Servicios',
  `sheet_changing` tinyint(2) DEFAULT NULL COMMENT 'Dias entre cambio de sabanas',
  `police_code` varchar(10) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo del Hotel para la policia',
  `police_counter` int(4) DEFAULT '0' COMMENT 'Contador para envio de ficheros a la policia',
  `tourist_tax` tinyint(1) DEFAULT '0' COMMENT 'Indica si el Hotel aplica Tasa turistica o no',
  `active` tinyint(1) DEFAULT '1' COMMENT 'Indica si el Hotel esta activo o no',
  PRIMARY KEY (`id`),
  UNIQUE KEY `IDX_UNQ_HOTEL_CODE` (`code`),
  KEY `IDX_HOTEL_SCOPE` (`scope`),
  KEY `IDX_HOTEL_WORKPLACE` (`workplace`),
  KEY `IDX_HOTEL_DOMAIN` (`domain`),
  KEY `IDX_HOTEL_SERVICE_CATALOGUE` (`service_catalogue`),
  CONSTRAINT `FK_HOTEL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_HOTEL_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`),
  CONSTRAINT `FK_HOTEL_SERVICE_CATALOGUE` FOREIGN KEY (`service_catalogue`) REFERENCES `catalogue` (`id`),
  CONSTRAINT `FK_HOTEL_WORKPLACE` FOREIGN KEY (`workplace`) REFERENCES `workplace` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Hoteles';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `hotel`
--

LOCK TABLES `hotel` WRITE;
/*!40000 ALTER TABLE `hotel` DISABLE KEYS */;
/*!40000 ALTER TABLE `hotel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `iae`
--

DROP TABLE IF EXISTS `iae`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `iae` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `section` varchar(1) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Seccion',
  `epigraph` varchar(8) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Epigrafe',
  `title` varchar(255) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Titulo',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1070 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='IAE';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `iae`
--

LOCK TABLES `iae` WRITE;
/*!40000 ALTER TABLE `iae` DISABLE KEYS */;
INSERT INTO `iae` VALUES (1,'1','011','EXPLOTACION EXTENSIVA DE GANADO BOVINO'),(2,'1','012','EXPLOTACION INTENSIVA DE GANADO BOVINO DE LECHE'),(3,'1','013','EXPLOTACION INTENSIVA DE GANADO BOVINO DE CEBO'),(4,'1','021','EXPLOTACION EXTENSIVA DE GANADO OVINO'),(5,'1','022','EXPLOTACION INTENSIVA DE GANADO OVINO DE CRIA'),(6,'1','023','EXPLOTACION INTENSIVA DE GANADO OVINO DE CEBO'),(7,'1','024','EXPLOTACION DE GANADO CAPRINO'),(8,'1','031','EXPLOTACION EXTENSIVA DE GANADO PORCINO'),(9,'1','032','EXPLOTACION INTENSIVA DE GANADO PORCINO CRIA'),(10,'1','033','EXPLOTACION INTENSIVA DE GANADO PORCINO CEBO'),(11,'1','041.1','REPRODUCTORAS DE PUESTA'),(12,'1','041.2','PONEDORAS HUEVOS A PARTIR CUATRO MESES'),(13,'1','042.1','REPRODUCTORAS DE CARNE'),(14,'1','042.2','POLLOS Y PATOS PARA CARNE'),(15,'1','042.3','PAVOS, FAISANES Y PALMIPEDAS REPRODUCTORAS'),(16,'1','042.4','PAVOS, FAISANES Y PALMIPEDAS PARA CARNE'),(17,'1','042.5','CODORNICES PARA CARNE'),(18,'1','051','CUNICULTURA'),(19,'1','061','EXPLOTACION DE GANADO CABALLAR, MULAR Y ASNAL'),(20,'1','062','APICULTURA'),(21,'1','069','OTRAS EXPLOTACIONES GANADERAS'),(22,'1','071','EXPLOTACIONES MIXTAS'),(23,'1','111.1','EXTRACCION Y PREPARACION DE HULLA'),(24,'1','111.2','EXTRACCION Y PREPARACION DE HULLA SUBBITUMINOSA'),(25,'1','111.3','PREPARACION DE HULLA FACTORIA INDEPENDIENTE'),(26,'1','111.4','AGLOMERACION DE HULLA'),(27,'1','112.1','EXTRACCION Y PREPARACION DE ANTRACITA'),(28,'1','112.2','PREPARACION DE ANTRACITA FACTORIA INDEPEND.'),(29,'1','113.1','EXTRACCION Y PREPARACION DE LIGNITO PARDO'),(30,'1','113.2','PREPARACION DE LIGNITO PARDO EN FACTORIA INDEPEN.'),(31,'1','114','FABRICACION DE COQUE'),(32,'1','121.1','TRABAJOS DE TESTIFICACION EN SONDEOS'),(33,'1','121.2','DESVIACION SONDEOS Y CIMENTACION POZOS'),(34,'1','121.3','TOMAS MEDIDA PRESION FONDO DE POZOS'),(35,'1','121.9','OTRAS ACTIV. DE PROSPECCION'),(36,'1','122.1','EXTRACCION DE CRUDOS DE PETROLEO'),(37,'1','122.2','DISTRIBUCION DE CRUDOS DE PETROLEO'),(38,'1','123.1','EXTRACCION Y DEPURACION DE GAS NATURAL'),(39,'1','123.2','DISTRIBUCION DE GAS NATURAL'),(40,'1','124','EXTRACCION DE PIZARRAS BITUMINOSAS'),(41,'1','130','REFINO DE PETROLEO'),(42,'1','141','EXTRACCION Y PREPARACION DE MINERALES RADIACTIVOS'),(43,'1','142','PREPARACION DE MINERALES RADIACTIVOS EN FACTORIA INDEPENDIENTE'),(44,'1','143.1','TRANSFORMACION DE MINERALES RADIOACTIVOS'),(45,'1','143.2','TRATAMIENTO DE RESIDUOS RADIOACTIVOS'),(46,'1','143.3','ALMACENAMIENTO DE RESIDUOS RADIOACTIVOS'),(47,'1','151.1','PRODUCCION DE ENERGIA HIDROELECTRICA'),(48,'1','151.2','PRODUCCION DE ENERGIA TERMOELECTRICA'),(49,'1','151.3','PRODUCCION DE ENERGIA ELECTRONUCLEAR'),(50,'1','151.4','OTRAS PRODUCCIONES DE ENERGIA'),(51,'1','151.5','TTE. Y DISTRIBUCION DE ELECTRICIDAD'),(52,'1','152','FABRICACION Y DISTRIBUCION DE GAS'),(53,'1','153','PRODUCCION Y DISTRIBUCION DE VAPOR Y AGUA CALIENTE'),(54,'1','161.1','CAPTACION, TRATAMIENTO Y DISTRIB. DE AGUA'),(55,'1','161.2','CAPTACION DE AGUA PARA SU SUMINISTRO'),(56,'1','161.3','TRATAMIENTO DEL AGUA PARA SU SUMINISTRO'),(57,'1','161.4','DISTRIBUCION DE AGUA EN NUCLEOS URBANOS'),(58,'1','162','FABRICACION DE HIELO PARA LA VENTA'),(59,'1','211.1','EXTRACCION Y PREPARACION DE MINERALES FERREOS'),(60,'1','211.2','PREPARACION DE MINERALES FERREOS EN FACTORIA INDEPENDIENTE'),(61,'1','212.1','EXTRACCION Y PREPARACION DE MINERALES METALICOS NO FERREOS'),(62,'1','212.2','PREPARACION DE MINERALES METALICOS NO FERREOS EN FACTORIA INDEPENDIENTE'),(63,'1','221.1','PRODUCTOS SIDERURGICOS PRIMARIOS O DE CABECERA (S.I.)'),(64,'1','221.2','ACERO BRUTO (S.I.)'),(65,'1','221.3','SEMIPRODUCTOS (S.I.)'),(66,'1','221.4','PRODUCTOS LAMINADOS EN CALIENTE (S.I.)'),(67,'1','221.5','PRODUCTOS LAMINADOS EN FRIO (S.I.)'),(68,'1','221.6','PRODUCTOS DERIVADOS DE LOS ANTERIORES (S.I.)'),(69,'1','221.7','OTROS PRODUCTOS Y SUBPRODUCTOS (S.I.)'),(70,'1','222.1','ACERO BRUTO (S.N.I.)'),(71,'1','222.2','SEMIPRODUCTOS (S.N.I.)'),(72,'1','222.3','PRODUCTOS LAMINADOS EN CALIENTE (S.N.I.)'),(73,'1','222.4','PRODUCTOS LAMINADOS EN FRIO (S.N.I.)'),(74,'1','222.5','PRODUCTOS DERIVADOS DE LOS ANTERIORES (S.N.I.)'),(75,'1','222.6','OTROS PRODUCTOS Y SUBPRODUCTOS (S.N.I.)'),(76,'1','223.1','PRODUCTOS TUBULARES (TUBOS Y PERFILES HUECOS) DE ACERO SIN SOLDADURA'),(77,'1','223.2','PRODUCTOS TUBULARES DE ACERO SOLDADOS LONGITUDINALMENTE'),(78,'1','223.3','PRODUCTOS TUBULARES DE ACERO SOLDADOS HELICOIDALMENTE'),(79,'1','223.4','ACCESORIOS PARA TUBERIAS (EXCEPTO FUNDICION)'),(80,'1','224.1','ALAMBRE DE ACERO'),(81,'1','224.2','PRODUCTOS CALIBRADOS POR ESTIRADO'),(82,'1','224.3','PRODUCTOS CALIBRADOS POR DESCORTEZADO (TORNEADO)'),(83,'1','224.4','PRODUCTOS CALIBRADOS POR RECTIFICADO'),(84,'1','224.5','PERFILES CONFORMADOS EN FRIO'),(85,'1','224.6','FLEJE LAMINADO EN FRIO'),(86,'1','224.7','FLEJE MAGNETICO LAMINADO EN FRIO'),(87,'1','224.8','FLEJE RECUBIERTO'),(88,'1','225.1','PRODUCCION Y PRIMERA TRANSFORMACION DEL ALUMINIO'),(89,'1','225.2','PRODUCCION Y PRIMERA TRANSFORMACION DEL COBRE'),(90,'1','225.9','PRODUCCION Y PRIMERA TRANSFORMACION DE OTROS METALES NO FERREOS N.C.O.P'),(91,'1','231.1','EXTRACCION DE SUSTANCIAS ARCILLOSAS'),(92,'1','231.2','EXTRACCION DE ROCAS Y PIZARRAS PARA LA CONSTRUCCION'),(93,'1','231.3','EXTRACCION DE ARENAS Y GRAVAS PARA LA CONSTRUCCION'),(94,'1','231.4','EXTRACCION DE YESO'),(95,'1','231.9','EXTRACCION DE OTROS MATERIALES DE CONSTRUCCION N.C.O.P'),(96,'1','232.1','EXTRACCION DE SALES POTASICAS'),(97,'1','232.2','EXTRACCION DE FOSFATOS Y NITRATOS'),(98,'1','233.1','EXTRACCION DE SAL MARINA'),(99,'1','233.2','EXTRACCION DE SAL MANANTIAL Y SAL GEMA'),(100,'1','234.1','EXTRACCION DE PIRITAS DE HIERRO SIN TOSTAR'),(101,'1','234.2','EXTRACCION DE AZUFRE NATURAL'),(102,'1','239.1','EXTRACCION DE FLUORITA'),(103,'1','239.2','EXTRACCION DE TURBA'),(104,'1','239.9','EXTRACCION DE OTROS MINERALES NO METALICOS NI ENERGETICOS, N.C.O.P'),(105,'1','241.1','LADRILLOS, BLOQUES Y PIEZAS ESPECIALES PARA FORJADOS'),(106,'1','241.2','TEJAS, BALDOSAS Y OTROS MATERIALES DE TIERRAS COCIDAS PARA LA CONSTRUCCION'),(107,'1','242.1','FABRICACION DE CEMENTOS ARTIFICIALES'),(108,'1','242.2','FABRICACION DE CEMENTOS NATURALES'),(109,'1','242.3','FABRICACION DE CALES Y YESOS'),(110,'1','243.1','FABRICACION DE HORMIGONES PREPARADOS'),(111,'1','243.2','FABRICACION DE PRODUCTOS EN FIBROCEMENTO'),(112,'1','243.3','FABRICACION DE OTROS ARTICULOS DERIVADOS DEL CEMENTO, EXCEPTO PAVIMENTOS'),(113,'1','243.4','FABRICACION DE PAVIMENTOS DERIVADOS DEL CEMENTO'),(114,'1','243.5','FABRICACION DE ARTICULOS DERIVADOS DEL YESO Y ESCAYOLA'),(115,'1','244.1','INDUSTRIAS DE LA PIEDRA NATURAL TRITURADA Y CLASIFICADA'),(116,'1','244.2','INDUSTRIAS DE LA PIEDRA NATURAL SIMPLEMENTE TALLADA Y ASERRADA'),(117,'1','244.3','INDUSTRIAS DE LA PIEDRA ELABORADA'),(118,'1','245.1','MUELAS Y ARTICULOS SIMILARES PARA MAQUINAS Y PIEDRAS PARA AFILAR O PULIR A MANO'),(119,'1','245.2','FABRICACION DE OTROS ABRASIVOS'),(120,'1','246.1','FABRICACION DEL VIDRIO PLANO'),(121,'1','246.2','FABRICACION DE VIDRIO HUECO'),(122,'1','246.3','FABRICACION DE VIDRIO TECNICO'),(123,'1','246.4','FABRICACION DE FIBRA DE VIDRIO'),(124,'1','246.5','MANIPLADO DE VIDRIO'),(125,'1','246.6','FABRICACION DE FIBRAS Y ESMALTES CERAMICOS'),(126,'1','247.1','FABRICACION DE ARTICULOS REFRACTARIOS'),(127,'1','247.2','FAB. DE BALDOSAS PARA PAVIMENTACION O REVESTIMIENTO SIN BARNIZAR NI ESMALTAR'),(128,'1','247.3','FAB. DE BALDOSAS PARA PAVIMENTACION O REVESTIMIENTO BARNIZADAS O ESMALTADAS'),(129,'1','247.4','FAB. DE VAJILLAS, ARTICULOS DEL HOGAR Y OBJETOS DE ADORNO, DE MATERIAL CERAMICO'),(130,'1','247.5','FAB. DE APARATOS SANITARIOS DE LOZA, PORCELANA Y GRES'),(131,'1','247.6','FAB. DE AISLADORES Y PIEZAS AISLANTES DE MATERIAL CERAMICO PARA INSTALACIONES ELECTRICAS'),(132,'1','247.9','FAB. DE OTROS ARTICULOS CERAMICOS N.C.O.P'),(133,'1','249.1','FAB. DE PRODUCTOS ASFALTICOS'),(134,'1','249.2','FAB. DE PRODUCTOS A BASE DE AMIANTO'),(135,'1','249.9','FAB. DE PRODUCTOS A BASE DE OTROS MINERALES NO METALICOS'),(136,'1','251.1','FAB. DE PRODUCTOS QUIMICOS ORGANICOS DE ORIGEN PETROQUIMICO'),(137,'1','251.2','FAB. DE OTROS PRODUCTOS QUIMICOS ORGANICOS'),(138,'1','251.3','FAB. DE PRODUCTOS QUIMICOS INORGANICOS (EXCEPTO GASES COMPRIMIDOS)'),(139,'1','251.4','FAB. DE PRIMERAS MATERIAS PLASTICAS'),(140,'1','251.5','FAB. DE CAUCHOS Y LATEX SINTETICOS'),(141,'1','251.6','PRODUCCION DE FIBRAS ARTIFICIALES Y SINTETICAS'),(142,'1','251.7','FAB. DE ACIDO Y ANHIDRIDO FTALICO Y MALEICO'),(143,'1','252.1','FAB. DE ABONOS'),(144,'1','252.2','FAB. DE PLAGUICIDAS'),(145,'1','253.1','FAB. DE GASES COMPRIMIDOS'),(146,'1','253.2','FAB. DE COLORANTES Y PIGMENTOS'),(147,'1','253.3','FAB. DE PINTURAS, BARNICES Y LACAS'),(148,'1','253.4','FAB. DE TINTAS DE IMPRENTA'),(149,'1','253.5','TRATAMIENTO DE ACEITES Y GRASA PARA USOS INDUSTRIALES'),(150,'1','253.6','FAB. DE ACEITES ESENCIALES Y DE SUSTANTICAS AROMATICAS, NATURALES Y SINTETICAS'),(151,'1','253.7','FAB. DE COLAS Y GELATINAS Y DE PRODUCTOS AUXILIARES PARA LAINDUSTRIA TEXTIL, DEL CUERO Y DEL CAUCHO'),(152,'1','253.8','FAB. DE EXPLOSIVOS'),(153,'1','253.9','FAB. DE OTROS PRODUCTOS QUIMICOS DE USO INDUSTRIAL, N.C.O.P.'),(154,'1','254.1','FAB. DE PRODUCTOS FARMACEUTICOS DE BASE'),(155,'1','254.2','FAB. DE ESPECIALIDADES Y OTROS PRODUCTOS FARMACEUTICOS'),(156,'1','255.1','FAB. DE JABONES COMUNES, DETERGENTES Y LEJIAS'),(157,'1','255.2','FAB. DE JABONES DE TOCADOR, Y OTROS PRODUCTOS DE PERFUMERIA Y COSMETICA'),(158,'1','255.3','FAB. DE DERIVADOS DE CERAS Y PARAFINAS'),(159,'1','255.4','FAB. DE MATERIAL FOTOGRAFICO SENSIBLE'),(160,'1','255.5','FAB. DE ARTICULOS PIROTECNICOS, CERILLAS Y FOSFOROS.'),(161,'1','255.9','FAB. DE OTROS PRODUCTOS QUIMICOS DESTINADOS PRINCIPALMENTE AL CONSUMO FINAL N.C.O.P.'),(162,'1','311.1','FUNDICION PIEZAS DE HIERRO Y ACERO'),(163,'1','311.2','FUNDICION PIEZAS METALES NO FERREOS'),(164,'1','312.1','PIEZAS FORJADAS'),(165,'1','312.2','PIEZAS ESTAMPADAS O TROQUELADAS'),(166,'1','312.3','PIEZAS EMBUTIDAS, CORTADAS'),(167,'1','313.1','TRATAMIENTO DE METALES'),(168,'1','313.2','RECUBRIMIENTOS METALICOS'),(169,'1','313.9','TRAT. PROTECCION DE METALES'),(170,'1','314.1','FAB. ART. CARPINTERIA METALICA'),(171,'1','314.2','FAB. ESTRUCTURAS METALICAS'),(172,'1','315.1','GRANDES CALDERAS'),(173,'1','315.2','GRANDES DEPOSITOS METALICOS'),(174,'1','316.1','FAB. HERRAMIENTAS MANUALES'),(175,'1','316.2','FAB. ARTICULOS DE FERRETERIA/CERRAJERIA'),(176,'1','316.3','TORNILLERIA Y ART. DERIVADOS ALAMBRE'),(177,'1','316.4','FAB. ART. MENAJE'),(178,'1','316.5','FAB. COCINAS, CALENTADORES, CALEFACCION'),(179,'1','316.6','FAB. MOBILIARIO METALICO'),(180,'1','316.7','FAB. RECIPIENTES Y ENVASES METALICOS'),(181,'1','316.8','FAB. ARMAS LIGERAS Y SUS MUNICIONES'),(182,'1','316.9','OTROS ART. ACABADOS EN METALES NCOP'),(183,'1','319.1','TALLERES DE MECANICA EN GENERAL'),(184,'1','319.9','TALLERES MECANICOS NCOP'),(185,'1','321.1','CONSTRUCC. MAQ. AGRICOLAS'),(186,'1','321.2','CONSTRUCC. TRACTORES AGRICOLAS'),(187,'1','322.1','CONS. MAQUINAS PARA TRABAJAR METALES'),(188,'1','322.2','CONST. MAQUINAS TRABAJAR MADERA/CORCHO'),(189,'1','322.3','FAB. UTILES PARA MAQUINAS HERRAMIENTAS'),(190,'1','323.1','CONST. MAQUINAS TEXTILES Y ACCESORIOS'),(191,'1','323.2','CONST. MAQUINAS INDUST. CUERO Y CALZADO'),(192,'1','323.3','FAB. MAQUINAS DE COSER'),(193,'1','324.1','MAQUINAS IND. ALIMENT.,BEBIDAS Y TAB.'),(194,'1','324.2','CONST. MAQUINAS PARA INDUSTRIA QUIMICA'),(195,'1','324.3','CONST. MAQ. IND._DEL CAUCHO Y PLASTICOS'),(196,'1','325.1','CONST. MAQ. MINERIA Y CONSTRUCCION'),(197,'1','325.2','CONST. MAQUINAS IND. MINERALES NO METAL'),(198,'1','325.3','CONST. MAQ. PARA SIDERURGIA Y FUNDICION'),(199,'1','325.4','CONST. MAQ. ELEVACION Y MANIPULACION'),(200,'1','326.1','FAB. ENGRANAJES, CADENAS DE TRANSMISION'),(201,'1','326.2','FAB. DE RODAMIENTOS'),(202,'1','329.1','CONST. MAQ. IND. PAPEL, CARTON Y AA.GG.'),(203,'1','329.2','CONST. MAQ. DE LAVADO Y LIMPIEZA EN SECO'),(204,'1','329.3','CONST. MOTORES Y TURBINAS (EXC.TRANSPOR)'),(205,'1','329.4','CONST. MAQ. MANIPULACION DE FLUIDOS'),(206,'1','329.9','CONST. OTRAS MAQ. Y EQUIPOS NCOP'),(207,'1','330.1','CONS. MAQ. DE OFICINA Y ORDENADORES'),(208,'1','330.2','INSTALAC. MAQ. OFICINA Y ORDENADORES'),(209,'1','341.1','FAB. HILOS Y CABLES AISLADOS COMUNICAC.'),(210,'1','341.2','FAB. HILOS Y CABLES PARA ELECTRICIDAD'),(211,'1','341.3','FAB. HILOS Y CABLES PARA BOBINAS'),(212,'1','341.4','FAB. CORDONES FLEXIBLES E HILOS AISLADOS'),(213,'1','341.5','FAB. HILOS Y CABLES PARA CONSTRUCCION'),(214,'1','341.9','FAB. OTROS HILOS Y CABLES AISLADOS'),(215,'1','342.1','MAQUINAS TRASFORMACION ELECTRICIDAD'),(216,'1','342.2','OTRO MATERIAL ELECTRICO'),(217,'1','343.1','FAB. PILAS ELECTRICAS'),(218,'1','343.2','FAB. ACUMULADORES ELECTRICOS'),(219,'1','343.3','FAB. ACCESORIOS DE PILAS Y ACUMULADORES'),(220,'1','344','FAB. DE CONTADORES Y APARATOS DE MEDIDA, CONTROL Y VERIFICACIONELECTRICOS'),(221,'1','345.1','FAB. COCINAS, HORNOS, PLACAS, Y DEMAS'),(222,'1','345.2','FAB. REFRIGERADORES Y CONGELADORES'),(223,'1','345.3','FAB. LAVAVAJILLAS, LAVADORAS Y SECADORAS'),(224,'1','345.4','FAB. CALENTADORES Y CALEFACC. ELECTRICA'),(225,'1','345.5','FAB. VENTILADORES Y ACONDICIONADORES'),(226,'1','345.6','FAB. APARATOS ELEC. AUXILIARES COCINA'),(227,'1','345.7','FAB. APAR. ELECTRICOS PARA EL HOGAR'),(228,'1','345.8','FAB. OTROS APARATOS ELECTRICOS'),(229,'1','345.9','FAB. ACCESORIOS DE APAR. ELECTRODOMEST.'),(230,'1','346.1','FAB. LAMPARAS ELECTRICAS'),(231,'1','346.2','FAB. LUMINARIAS DE ALTA INTENSIDAD'),(232,'1','346.3','FAB. ART. CARBON Y GRAFITO USO ELECTRIC.'),(233,'1','346.4','FAB. OTRO MATERIAL DE ALUMBRADO'),(234,'1','346.5','FAB. ACCESORIOS MATERIAL ALUMBRADO'),(235,'1','351.1','FAB. APARATOS TELEFONICOS Y TELEGRAFICOS'),(236,'1','351.2','FAB. APARATOS TELECOMUNICACION RADIODIF.'),(237,'1','352','FAB. DE APARATOS Y EQUIPO ELECTROMEDICO Y DE USO PROFESIONAL Y CIENTIFICO'),(238,'1','353','FAB. DE APARATOS Y EQUIPO ELECTRONICO DE SE?ALIZACION, CONTROL Y PROGRAMACION'),(239,'1','354.1','FAB. VALVULAS Y TUBOS ELECTRONICOS'),(240,'1','354.2','FAB. OTROS COMPONENTES ELECTRONICOS'),(241,'1','354.3','FAB. COMPONENTES ELECTRONICOS PASIVOS'),(242,'1','354.4','ACCESORIOS DE COMPONENTES ELECTRONICOS'),(243,'1','355.1','FAB. RECEPTORES RADIO, TV, Y SONIDO'),(244,'1','355.2','EDICION SOPORTES AUDIO, VIDEO, INFORMATICA'),(245,'1','361.1','AUTOMOVILES DE TURISMO'),(246,'1','361.2','AUTOBUSES Y AUTOCARES'),(247,'1','361.3','CAMIONES'),(248,'1','361.4','OTROS VEHICULOS AUTOMOVILES'),(249,'1','361.5','MOTORES PARA VEHICULOS AUTOMOVILES'),(250,'1','361.6','CHASIS CON MOTOR PARA AUTOMOVILES'),(251,'1','361.7','COMPONENTES PARA VEHICULOS AUTOMOVILES'),(252,'1','362.1','CARROCERIAS AUTOMOVILES Y REMOLQUES'),(253,'1','362.2','REMOLQUES Y VOLQUETES'),(254,'1','363.1','REPUESTOS Y ACCESORIOS MOTORES AUTOS'),(255,'1','363.2','ACCESORIOS Y REPUESTOS CARROCERIAS AUTO'),(256,'1','363.9','OTROS ACCESORIOS Y REPUESTOS AUTOMOVILES'),(257,'1','371.1','BUQUES DE CASCO DE ACERO'),(258,'1','371.2','BUQUES DE CASCO DE MADERA'),(259,'1','371.3','BUQUES DE CASCO DE PLASTICO'),(260,'1','371.4','ARTEFACTOS FLOTANTES'),(261,'1','371.5','MOTORES, Y TURBINAS PARA EMBARCACIONES'),(262,'1','371.6','ACCESORIOS Y REPUESTOS EMBARCACIONES'),(263,'1','372.1','SERV. REPARACION Y MANTENIM. BUQUES'),(264,'1','372.2','SERV. DESGUACE DE EMBARCACIONES'),(265,'1','381.1','MATERIAL FERROVIARIO'),(266,'1','381.2','SERV. REPARACION MATERIAL FERROVIARIO'),(267,'1','382.1','AERONAVES E INGENIOS ESPACIALES'),(268,'1','382.2','SERV. REPARACION Y MANTENIMIENTO AVIONES'),(269,'1','383.1','MOTOCICLETAS, Y CICLOMOTORES'),(270,'1','383.2','BICICLETAS, TRICICLOS Y MONOCICLOS'),(271,'1','383.3','VEHICULOS ESPECIALES CON MEC. PROPULSION'),(272,'1','383.4','MOTORES PARA MOTOS, CICLIMOTORES'),(273,'1','383.5','ACCESORIOS PARA MOTOS Y BICICLETAS'),(274,'1','389.1','REMOLQUES AGRICOLAS'),(275,'1','389.2','VEHICULOS ACCIONADOS A MANO'),(276,'1','389.9','ACCESORIOS PARA OTRO MATERIAL TTE. NCOP'),(277,'1','391.1','CONTADORES NO ELECTRICOS'),(278,'1','391.2','INSTRUMENTOS PARA LA NAVEGACION'),(279,'1','391.3','INSTRUMENTOS TOPOGRAFIA, METEREOLOGIA,...'),(280,'1','391.4','INSTRUM. MEDIDA DENSIDAD, TEMPERATURA...'),(281,'1','391.5','INSTRUM. ENSAYOS MECANICOS DE MATERIALES'),(282,'1','391.6','BALANZAS DE PRECISION'),(283,'1','391.7','OTROS INSTRUM. PRECISION'),(284,'1','391.8','ACCESORIOS INSTRUM. APARAT. PRECISION'),(285,'1','392.1','FAB. MATERIAL MEDICO-QUIRURGICO'),(286,'1','392.2','FAB. APARATOS PROTESIS Y ORTOPEDIA'),(287,'1','393.1','FAB. INSTRUM. OPTICOS Y MAT. FOTOGRAFICO'),(288,'1','393.2','FAB. MONTURAS PARA GAFAS (PLASTICO NO)'),(289,'1','399.1','RELOJES Y CRONOGRAFOS PULSERA Y BOLSILLO'),(290,'1','399.2','RELOJES DESPERTADORES'),(291,'1','399.3','RELOJES DE PARED Y SOBREMESA'),(292,'1','399.4','RELOJES PARA VEHICULOS'),(293,'1','399.5','RELOJES DE TORRE, ESTACION,...'),(294,'1','399.6','APARATOS CON MECANISMOS DE RELOJERIA'),(295,'1','399.7','MAQUINAS DE RELOJ MONTADAS'),(296,'1','399.8','CAJAS DE RELOJES'),(297,'1','399.9','ACCESORIOS DE RELOJES Y OTROS INSTRUM.'),(298,'1','411.1','FAB. Y ENVASADO DE ACEITE DE OLIVA'),(299,'1','411.2','FAB. ACEITE DE OLIVA'),(300,'1','411.3','ENVASADO DE ACEITE DE OLIVA'),(301,'1','412.1','EXTRACC. Y ENVASADO ACEITES SEMILLAS'),(302,'1','412.2','OBTENC. Y ENVASADO GRASAS ANIMALES MAR'),(303,'1','412.3','REFINADO Y OTROS TRATAMIENTOS GRASAS'),(304,'1','412.4','OBTENCION Y ENVASADO MARGARINA'),(305,'1','413.1','SACRIFICIO Y DESPIECE DE GANADO'),(306,'1','413.2','FAB. PTOS. CARNICOS DE TODAS CLASES'),(307,'1','413.3','SALAS DESPIECE AUTONOMAS'),(308,'1','413.4','INCUBACION Y VENTA DE POLLUELOS'),(309,'1','414.1','PREPARACION DE LECHE'),(310,'1','414.2','PREPARACION LECHE EN CONSERVA'),(311,'1','414.3','FAB. QUESO Y MANTEQUILLA'),(312,'1','414.4','ELABORACION DE HELADOS Y SIMILARES'),(313,'1','415.1','CONSERVAS VEGETALES'),(314,'1','415.2','EXTRACTOS, ZUMOS Y OTROS PREPARADOS'),(315,'1','415.3','LIMPIEZA, CLASIFIC.Y ENVASE FRUTAS'),(316,'1','416.1','CONSERVAS DE PESCADO'),(317,'1','416.2','PTOS. RESIDUALES CONSERVACION PESCADO'),(318,'1','417.1','FAB. HARINAS Y SEMOLAS'),(319,'1','417.2','FAB. OTROS PTOS. MOLINERIA'),(320,'1','418.1','FAB. PASTAS ALIMENTICIAS'),(321,'1','418.2','FAB. PTOS. AMILACEOS'),(322,'1','419.1','INDUSTRIA DEL PAN Y BOLLERIA'),(323,'1','419.2','INDUST. BOLLERIA Y PASTELERIA'),(324,'1','419.3','INDUST. ELABORACION MASAS FRITAS'),(325,'1','420.1','AZUCAR Y JARABES DE AZUCAR'),(326,'1','420.2','PTOS. RESIDUALES DE LA INDUSTRIA AZUCAR'),(327,'1','421.1','INDUSTRIA CACAO Y CHOCOLATE'),(328,'1','421.2','ELABORACION PTOS. CONFITERIA'),(329,'1','422.1','FORRAJES DESHIDRATADOS ALIMENTAC. ANIMAL'),(330,'1','422.2','HARINAS PESCADO Y OTROS PTOS. PIENSOS'),(331,'1','422.3','ELAB. PIENSOS COMP. CUALQ. CLASE(EXC.4224)'),(332,'1','422.4','ELAB. PIENSOS COMP. ANIMALES DOMESTICOS'),(333,'1','423.1','ELAB. CAFE, TE, Y SUCEDANEOS'),(334,'1','423.2','ELAB. SOPAS PREPARADAS Y CONDIMENTOS'),(335,'1','423.3','ELAB. PTOS. DIETETICOS Y DE REGIMEN'),(336,'1','423.9','ELAB. OTROS PTOS. ALIMENTICIOS NCOP'),(337,'1','424.1','DESTILACION Y RECTIFICACION ALCOHOLES'),(338,'1','424.2','OBTENCION AGUARDIENTES NATURALES'),(339,'1','424.3','OBTENC. AGUARDIENTES COMPUESTOS'),(340,'1','425.1','ELABORACION Y CRIANZA DE VINOS'),(341,'1','425.2','ELABORACION DE VINOS ESPUMOSOS'),(342,'1','425.3','ELABORACION OTROS VINOS ESPECIALES'),(343,'1','425.9','OTRAS INDUSTRIAS VINICOLAS NCOP'),(344,'1','426.1','SIDRA Y OTRAS BEBIDAS FERMENTADAS'),(345,'1','426.2','PTOS. RESIDUALES DE SIDRERIAS'),(346,'1','427.1','CERVEZA Y MALTA DE CERVEZA'),(347,'1','427.2','SUBPRODUCTOS RESIDUALES DE CERVEZA'),(348,'1','428.1','PREP. Y ENVASADO DE AGUAS MINERALES'),(349,'1','428.2','FAB. AGUAS GASEOSAS Y OTRAS BEBIDAS SIN'),(350,'1','429.1','ELAB. CIGARROS, CIGARRILLOS DE TABACO'),(351,'1','429.2','PRIMERA TRANSFORMACION TABACO'),(352,'1','431.1','PREP. FIBRAS DE ALGODON'),(353,'1','431.2','HILADO Y RETORCIDO DEL ALGODON'),(354,'1','431.3','TEJIDO ALGODON Y SUS MEZCLAS'),(355,'1','432.1','PREP. FIBRAS LANA'),(356,'1','432.2','HILADO Y RETORCIDO LANA'),(357,'1','432.3','TEJIDO DE LANA'),(358,'1','433.1','PTOS. IND. SEDA NATURAL Y SUS MEZCLAS'),(359,'1','433.2','PREP. HILADO Y TEJIDO DE FIBRAS SINTETIC'),(360,'1','434.1','FIBRAS DURAS PREPARADAS PARA HILADO'),(361,'1','434.2','SUBPRODUCTOS DE LA PREP. FIBRAS DURAS'),(362,'1','434.3','HILADOS Y RETORCIDOS DE FIBRAS DURAS'),(363,'1','434.4','TEJIDOS DE FIBRAS DURAS Y SUS MEZCLAS'),(364,'1','435.1','FAB. GENEROS DE PUNTO EN PIEZA'),(365,'1','435.2','FAB. CALCETERIA'),(366,'1','435.3','FAB. PRENDAS INTERIORES PUNTO'),(367,'1','435.4','FAB. PRENDAS EXTERIORES DE PUNTO'),(368,'1','436.1','TEXTILES BLANQUEADOS'),(369,'1','436.2','TEXTILES TE?IDOS'),(370,'1','436.3','TEXTILES ESTAMPADOS'),(371,'1','436.9','TEXTILES APRESTADOS Y MERCERIZADOS'),(372,'1','437.1','FAB. ALFOMBRAS Y TAPICES'),(373,'1','437.2','FAB. TEJIDOS IMPREGNADOS'),(374,'1','439.1','CORDELERIA'),(375,'1','439.2','FAB. FIELTROS, TULES, ENCAJES, ETC.'),(376,'1','439.3','FAB. TEXTILES CON FIBRAS RECUPERACION'),(377,'1','439.9','OTRAS INDUSTRIAS TEXTILES NCOP'),(378,'1','441.1','CUEROS Y PIELES NO ACABADAS'),(379,'1','441.2','CUEROS Y PIELES ACABADAS'),(380,'1','441.3','CUEROS Y PIELES REGENERADAS, SUBPRODUCT.'),(381,'1','442.1','FAB. ART. MARROQUINERIA Y VIAJE'),(382,'1','442.2','FAB. GUANTES DE PIEL'),(383,'1','442.9','FAB. OTROS ARTICULOS DE CUERO NCOP'),(384,'1','451.1','PTOS. INTERMEDIOS DE FAB. CALZADO'),(385,'1','451.2','CALZADO DE CALLE FAB. EN SERIE'),(386,'1','451.3','ZAPATILLAS DE CASA, CALZADOS ESPECIALES'),(387,'1','451.4','RECORTES Y DESPERDICIOS DE CUERO'),(388,'1','452.1','CALZADO ARTESANIA Y MEDIDA'),(389,'1','452.2','CALZADO ORTOPEDICO'),(390,'1','453','CONFECCION EN SERIE DE TODA CLASE DE PRENDAS DE VESTIR Y SUS COMPLEMENTOS'),(391,'1','454.1','PRENDAS VESTIR HECHAS A MEDIDA'),(392,'1','454.2','SOMBREROS Y ACCESORIOS PARA EL VESTIDO'),(393,'1','455.1','CONFECC. ART. TEXTILES HOGAR/TAPICERIA'),(394,'1','455.9','CONFECC. OTROS ART. TEXTILES NCOP'),(395,'1','456.1','PELETERIA NATURAL'),(396,'1','456.2','PELETERIA ARTIFICIAL'),(397,'1','461.1','PTOS. ASERRADO Y PREP. IND. MADERA'),(398,'1','461.2','PTOS. RESIDUALES IND. MADERA'),(399,'1','462.1','CHAPAS DE MADERA'),(400,'1','462.2','MADERAS CHAPADAS, CONTRACHAPADAS, ETC'),(401,'1','462.3','TABLEROS, PANELES DE FIBRAS Y DE PART.'),(402,'1','462.4','MADERAS MEJORADAS'),(403,'1','463.1','PUERTAS Y VENTANAS DE MADERA'),(404,'1','463.2','PARQUET, ENTARIMADO Y ADOQUINES MADERA'),(405,'1','463.3','OTRAS PIEZAS CARPINTERIA PARA CONSTRUCC.'),(406,'1','463.4','ELEM. ESTRUCTURALES Y PREFABRIC. MADERA'),(407,'1','464.1','ENVASES Y EMBALAJES INDUSTRIALES MADERA'),(408,'1','464.2','TONELERIA'),(409,'1','464.3','ESTUCHES, BAULES, MALETAS DE MADERA'),(410,'1','465.1','OBJETOS MADERA DE USO DOMESTICO'),(411,'1','465.2','HERRAMIENTAS, MANGOS, MONTURAS DE MADERA'),(412,'1','465.3','ART. MADERA PARA FAB. CALZADO'),(413,'1','465.4','ART. MADERA PARA IND. TEXTIL'),(414,'1','465.5','CALZADO DE MADERA'),(415,'1','465.6','HARINA Y LANA DE MADERA'),(416,'1','465.9','OTROS OBJETOS MADERA NCOP'),(417,'1','466.1','PRODUCTOS DE CORCHO'),(418,'1','466.2','PTOS. RESIDUALES FAB. CORCHO'),(419,'1','467.1','ARTICULOS DE MATERIAS TRENZABLES'),(420,'1','467.2','CEPILLOS, BROCHAS, ESCOBAS Y SIMILARES'),(421,'1','468.1','FAB. MOBILIARIO DE MADERA PARA EL HOGAR'),(422,'1','468.2','FAB. MOBILIARIO MADERA ESCOLAR Y OFICINA'),(423,'1','468.3','FAB. MUEBLES DIV. MADERA, JUNCO, MIMBRE'),(424,'1','468.4','FAB. ATAUDES'),(425,'1','468.5','ACTIV. ANEXAS IND. MUEBLE'),(426,'1','471.1','PASTA PAPELERA'),(427,'1','471.2','SUBPRODUCTOS PASTA PAPELERA'),(428,'1','472.1','PAPEL Y CARTON'),(429,'1','472.2','PTOS. RESIDUALES FAB. PAPEL Y CARTON'),(430,'1','473.1','FAB. CARTON ONDULADO Y SUS ARTICULOS'),(431,'1','473.2','FAB. OTROS ART. Y ENVASES PAPEL Y CARTON'),(432,'1','473.3','FAB. ART. OFICINA, ESCRITORIO, EN PAPEL'),(433,'1','473.4','FAB. ART. DECORACION EN PAPEL Y CARTON'),(434,'1','473.9','FAB. OTROS MANIPULADOS PAPEL Y CARTON'),(435,'1','474.1','IMPRESION TEXTOS E IMAGENES'),(436,'1','474.2','IMPRESION DE PRENSA DIARIA'),(437,'1','474.3','REPRODUCCION TEXTOS E IMAGENES'),(438,'1','475.1','ESTEREOTIPIA, GOMAS CAUCHO, RODILLOS...'),(439,'1','475.2','COMPOSICION TEXTOS'),(440,'1','475.3','REPRODUCCION TEXTOS'),(441,'1','475.4','ENCUADERNACION'),(442,'1','476.1','EDICION DE LIBROS'),(443,'1','476.2','EDICION DE PERIODICOS Y REVISTAS'),(444,'1','476.9','OTRAS EDICIONES NCOP'),(445,'1','481.1','FAB. CUBIERTAS Y CAMARAS'),(446,'1','481.2','RECAUCHUTADO Y RECONSTRUCCION CUBIERTAS'),(447,'1','481.9','FAB. OTROS ART. CAUCHO NCOP'),(448,'1','482.1','FAB. PTOS. SEMIELABORADOS PLASTICO'),(449,'1','482.2','FAB. ART. ACABADOS MATERIAS PLASTICAS'),(450,'1','491.1','JOYERIA'),(451,'1','491.2','BISUTERIA'),(452,'1','492.1','INSTRUMENTOS DE CUERDA DE TECLADO'),(453,'1','492.2','INSTRUMENTOS DE VIENTO DE TECLADO'),(454,'1','492.3','INSTRUMENTOS DE CUERDA'),(455,'1','492.4','INSTRUMENTOS VIENTO'),(456,'1','492.5','INSTRUMENTOS PERCUSION'),(457,'1','492.6','INSTRUMENTOS MUSICALES ELECTRONICOS'),(458,'1','492.7','OTROS INSTRUMENTOS MUSICALES'),(459,'1','492.8','PARTES, PIEZAS SUELTAS INSTRUM. MUSICALES'),(460,'1','493.1','PELICULAS Y COPIAS CINE REVELADAS'),(461,'1','493.2','PLACAS, PELICULAS, NAGATIVAS Y DIAPOSIT.'),(462,'1','493.3','COPIAS FOTOGRAFICAS Y AMPLIACIONES'),(463,'1','494.1','FAB. JUEGOS, JUGUETES Y ART. PUERICULT.'),(464,'1','494.2','FAB. ART. DEPORTE'),(465,'1','495.1','FAB. ART. ESCRITORIO'),(466,'1','495.9','FAB. OTROS ART. NCOP'),(467,'1','501.1','CONSTRUCCION COMPLETA, REPAR. Y CONSERV.'),(468,'1','501.2','CONSTRUCC. COMPLETA OBRAS CIVILES'),(469,'1','501.3','ALBA?ILERIA Y PEQ. TRABAJOS CONSTRUCCION'),(470,'1','502.1','DEMOLICIONES Y DERRIBOS EN GENERAL'),(471,'1','502.2','CONSOLIDACION Y PREPARACION DE TERRENOS'),(472,'1','502.3','CONSOLID. Y PREP. TERRENOS OBRAS CIVILES'),(473,'1','502.4','CIMENTACIONES Y PAVIMENTACIONES'),(474,'1','502.5','CIMENTACIONES Y PAVIMENTAC.OBRAS CIVILES'),(475,'1','502.6','PERFORACIONES ALUMBRAMIENTO DE AGUAS'),(476,'1','503.1','PREP. MONTAJE ESTRUCTURAS Y CUBIERTAS'),(477,'1','503.2','PREP. ESTRUC. CUBIERTAS EN OBRAS CIVILES'),(478,'1','503.3','MONTAJE ESTRUC. METALICAS TTE. Y OBRAS'),(479,'1','503.4','OBRAS SIN MAQUINAS Y SIN MAS 4 OBREROS'),(480,'1','504.1','INSTALACIONES ELECTRICAS EN GENERAL'),(481,'1','504.2','INSTALACIONES FONTANERIA'),(482,'1','504.3','INSTALACIONES FRIO Y CALOR'),(483,'1','504.4','INSTALACIONES PARARRAYOS'),(484,'1','504.5','INSTALACION COCINAS'),(485,'1','504.6','INSTALACION APARATOS ELEVADORES'),(486,'1','504.7','INSTALACIONES TELEFONICAS'),(487,'1','504.8','MONTAJES METALICOS E INSTALAC. INDUSTR.'),(488,'1','505.1','REVESTIMIENTOS EXTERIORES E INTERIORES'),(489,'1','505.2','SOLADOS Y PAVIMENTOS'),(490,'1','505.3','SOLADOS Y PAVIMENTOS DE MADERA'),(491,'1','505.4','COLOCACION DE AISLAMIENTOS EN EDIFICIOS'),(492,'1','505.5','CARPINTERIA Y CERRAJERIA'),(493,'1','505.6','PINTURA Y REVESTIMIENTO CON PAPEL, TEJIDO'),(494,'1','505.7','YESO, ESCAYOLA Y DECORACION'),(495,'1','506.0','INSTALACION DE ANDAMIOS, CIMBRAS, ETC.'),(496,'1','507','CONSTRUCCION, REPARACION Y CONSERVACION DE TODA CLASE DE OBRAS'),(497,'1','508','AGRUPACIONES Y UNIONES TEMPORALES DE EMPRESAS'),(498,'1','611','COMERCIO AL POR MAYOR DE TODA CLASE DE MERCANCIAS'),(499,'1','612.1','COM. MAY. PTOS. ALIMENTIC. BEBIDAS Y TABACOS'),(500,'1','612.2','COM. MAY. CEREALES, PLANTAS, ABONOS, ANIMALES'),(501,'1','612.3','COM. MAY. FRUTAS Y VERDURAS'),(502,'1','612.4','COM. MAY. CARNES, HUEVOS, AVES Y CAZA'),(503,'1','612.5','COM. MAY. LECHE, PTOS. LACTEOS, MIEL, ACEITE'),(504,'1','612.6','COM. MAY. BEBIDAS Y TABACO'),(505,'1','612.7','COM. MAY. VINOS Y VINAGRES DEL PAIS'),(506,'1','612.8','COM. MAY. PESCADOS'),(507,'1','612.9','COM. MAY. OTROS PTOS. ALIMENT., HELADOS ETC'),(508,'1','613.1','COM. MAY. PTOS. TEXTILES, CONFECC, Y CALZADO'),(509,'1','613.2','COM. MAY. TEJIDOS POR METROS, ALFOMBRAS'),(510,'1','613.3','COM. MAY. PRENDAS EXTERIORES VESTIR'),(511,'1','613.4','COM. MAY. CALZADO, PELETERIA, MARROQUINERIA'),(512,'1','613.5','COM. MAY. CAMISERIA, LENCERIA, MERCERIA,...'),(513,'1','613.9','COM. MAY. ACCESORIOS VESTIDO NCOP'),(514,'1','614.1','COM. MAY. PTOS. FARMACEUTICOS Y MEDICAMENTO'),(515,'1','614.2','COM. MAY. PTOS. PERFUMERIA, DROGUERIA'),(516,'1','614.3','COM. MAY. PTOS. MANTENIMIENTO HOGAR'),(517,'1','614.4','COM. MAY. PRODUCTOS ZOOSANITARIOS'),(518,'1','615.1','COM. MAY. VEHICULOS Y SUS ACCESORIOS'),(519,'1','615.2','COM. MAY. DE MUEBLES'),(520,'1','615.3','COM. MAY. APARATOS ELECTRODOMESTICOS'),(521,'1','615.4','COM.MAY. APAR.Y MAT. ELECTRONICO'),(522,'1','615.5','COMERCIO AL POR MAYOR DE OBRAS DE ARTE'),(523,'1','615.6','GALERIAS DE ARTE'),(524,'1','615.9','COM. MAY. OTROS ART. CONSUMO DURADERO NCOP'),(525,'1','616.1','COM. MAY. CARBON'),(526,'1','616.2','COM. MAY. HIERRO Y ACERO'),(527,'1','616.3','COM. MAY. MINERALES'),(528,'1','616.4','COM. MAY. METALES NO FERREOS'),(529,'1','616.5','COM. MAY. PETROLEO Y LUBRICANTES'),(530,'1','616.6','COM. MAY. PTOS. QUIMICOS INDUSTRIALES'),(531,'1','616.9','COM. MAY. PTOS. INTERINDUSTRIALES Y QUIMIC.'),(532,'1','617.1','COM. MAY. FIBRAS TEXTILES BRUTAS'),(533,'1','617.2','COM. MAY. CUEROS Y PIELES EN BRUTO'),(534,'1','617.3','COM. MAY. MADERA Y CORCHO'),(535,'1','617.4','COM. MAY. MATERIALES CONSTRUCCION'),(536,'1','617.5','COM. MAY. MAQUINARIA PARA MADERA Y METAL'),(537,'1','617.6','COM. MAY. MAQUINARIA AGRICOLA'),(538,'1','617.7','COM. MAY. MAQUINARIA TEXTIL'),(539,'1','617.8','COM. MAY. MAQUINAS Y MATERIAL OFICINA'),(540,'1','617.9','COM. MAY. INTERINDUSTRIAL EXCEP. QUIMICA'),(541,'1','618.1','EXPORTACION TODA CLASE MERCANCIAS'),(542,'1','618.2','COM. MAY. MERCANCIAS EN ZONAS FRANCAS'),(543,'1','619.1','COM. MAY. JUGUETES Y ARTICULOS DEPORTE'),(544,'1','619.2','COM. MAY. INSTRUM. MEDICOS Y ORTOPEDICOS'),(545,'1','619.3','COM. MAY. METALES PRECIOSOS, Y JOYERIA'),(546,'1','619.4','COM. MAY. PTOS. DE PAPEL Y CARTON'),(547,'1','619.5','COM. MAY. ART. PAPELERIA Y ESCRITORIO'),(548,'1','619.6','COM. MAY. LIBROS, PERIODICOS Y REVISTAS'),(549,'1','619.7','COM. MAY. INSTRUM. PRECISION Y MEDIDA'),(550,'1','619.8','COMPRA-VENTA DE GANADO'),(551,'1','619.9','COM. MAY. OTROS PRODUCTOS NCOP'),(552,'1','621','COMERCIO AL POR MAYOR DE CHATARRA Y METALES DE DESECHO FERREOS Y NO FERREOS'),(553,'1','622','COMERCIO AL POR MAYOR DE OTROS PRODUCTOS DE RECUPERACION'),(554,'1','623','RECUPERACION Y COMERCIO DE RESIDUOS FUERA DE ESTABLECIMIENTO PERMANENTE'),(555,'1','631','INTERMEDIARIOS DEL COMERCIO'),(556,'1','641','COMERCIO AL POR MENOR DE FRUTAS, VERDURAS, HORTALIZAS Y TUBERCULOS'),(557,'1','642.1','COM. MEN. CARNES, HUEVOS, CAZA Y GRANJA'),(558,'1','642.2','COM. MEN. CARNICERIAS-CHARCUTERIAS'),(559,'1','642.3','COM. MEN. CARNICERIAS-SALCHICHERIAS'),(560,'1','642.4','COM. MEN. CARNICERIAS'),(561,'1','642.5','COM. MEN. HUEVOS, AVES, GRANJA Y CAZA'),(562,'1','642.6','COM. MEN. CASQUERIAS'),(563,'1','643.1','COM. MEN. PESCADOS'),(564,'1','643.2','COM. MEN. BACALAO Y SALAZONES'),(565,'1','644.1','COM. MEN. PAN, PASTELES, CONFITERIA, LACTEOS'),(566,'1','644.2','DESPACHOS PAN, PAN ESPECIAL, Y BOLLERIA'),(567,'1','644.3','COM. MEN. PTOS.PASTELERIA,BOLLERIA'),(568,'1','644.4','COM. MEN. HELADOS'),(569,'1','644.5','COM. MEN. BOMBONES Y CARAMELOS'),(570,'1','644.6','COM. MEN. MASAS FRITAS'),(571,'1','645','COMERCIO AL POR MENOR DE VINOS Y BEBIDAS DE TODAS CLASES'),(572,'1','646.1','COM. MEN. TABACOS EN EXPENDIDURIA'),(573,'1','646.2','COM. MEN. TABACO EXTENSIONES TRANSITORIAS'),(574,'1','646.3','COM. MEN. TABACO EXPENDIDURIAS COMPLEMENT.'),(575,'1','646.4','COM. MEN. TABACO CON VENTA POR RECARGO'),(576,'1','646.5','COM. MEN. TABACO MAQUINAS AUTOMATICAS'),(577,'1','646.6','COM. MEN. TABACOS VENTA NO ESTANCADA'),(578,'1','646.7','COM. MEN. ARTICULOS FUMADORES POR MINUSV.'),(579,'1','646.8','COM. MEN. ARTICULOS PARA FUMADORES'),(580,'1','647.1','COM. MEN. PTOS. ALIMENTICIOS Y BEBIDAS'),(581,'1','647.2','COM. MEN. PTOS. ALIMENTICIOS MENOS 120 M2'),(582,'1','647.3','COM. MEN- PTOS. ALIMENTICIOS 120 - 399 M2'),(583,'1','647.4','COM. MEN. PTOS. ALIMENTICIOS SUP.400 M2'),(584,'1','647.5','PTOS. ALIMENTICIOS Y BEB. MAQUINAS'),(585,'1','651.1','COM. MEN. PTOS. TEXTILES PARA EL HOGAR'),(586,'1','651.2','COM. MEN. PRENDAS DE VESTIR Y TOCADO'),(587,'1','651.3','COM. MEN. LENCERIA Y CORSETERIA'),(588,'1','651.4','COM. MEN. MERCERIA Y PAQUETERIA'),(589,'1','651.5','COM. MEN. PRENDAS ESPECIALES'),(590,'1','651.6','COM. MEN. CALZADO Y COMPLEMENTOS PIEL'),(591,'1','651.7','COM. MEN. CONFECCIONES DE PELETERIA'),(592,'1','652.1','FARMACIAS'),(593,'1','652.2','COM. MEN. PTOS. DROGUERIA, PERFUMERIA'),(594,'1','652.3','COM. MEN. PTOS. PERFUMERIA Y COSMETICA'),(595,'1','652.4','COM. MEN. PLANTAS Y HIERBAS, HERBORARIOS'),(596,'1','653.1','COM. MEN. MUEBLES (EXCEPTO OFICINA)'),(597,'1','653.2','COM. MEN. APARATOS DE USO DOMESTICO'),(598,'1','653.3','COM. MEN. ART. MENAJE, FERRETERIA, ADORNO'),(599,'1','653.4','COM. MEN. MATERIALES DE CONSTRUCCION'),(600,'1','653.5','COM. MEN. PUERTAS, VENTANAS Y PERSIANAS'),(601,'1','653.6','COM. MEN. ARTICULOS DE \"BRICOLAGE\"'),(602,'1','653.9','COM. MEN. ART.HOGAR NCOP'),(603,'1','654.1','COM. MEN. VEHICULOS TERRESTRES'),(604,'1','654.2','COM. MEN. ACCESORIOS Y RECAMBIOS VEHICULOS'),(605,'1','654.3','COM. MEN. VEHICULOS AEREOS'),(606,'1','654.4','COM. MEN. VEHICULOS FLUVIALES Y MARITIMOS'),(607,'1','654.5','COM. MEN. DE TODA CLASE DE MAQUINARIA'),(608,'1','654.6','COM. MEN. CUBIERTAS, BANDAS Y CAMARAS AIRE'),(609,'1','655.1','COM. MEN. COMBUSTIBLES TODAS CLASES'),(610,'1','655.2','COM. MEN. GASES COMBUSTIBLES'),(611,'1','655.3','COM. MEN. CARBURANTES Y ACEITES VEHICULOS'),(612,'1','656','COMERCIO AL POR MENOR DE BIENES USADOS (MUEBLES, PRENDAS Y ENSERES ORDINARIOS DE USO DOMESTICO)'),(613,'1','657','COMERCIO AL POR MENOR DE INSTRUMENTOS MUSICALES EN GENERAL, ASI COMO DE SUS ACCESORIOS'),(614,'1','659.1','COM. MEN. SELLOS, MONEDAS, MEDALLAS, COLECC.'),(615,'1','659.2','COM. MEN. MUEBLES Y MAQUINAS DE OFICINA'),(616,'1','659.3','COM. MEN. APARATOS MEDICOS, ORTOPEDICOS'),(617,'1','659.4','COM. MEN. LIBROS, PERIODICOS, REVISTAS.'),(618,'1','659.5','COM. MEN. ART. JOYERIA, RELOJERIA, BISUTERIA'),(619,'1','659.6','COM. MEN. JUGUETES, ART. DEPORTE, ARMAS...'),(620,'1','659.7','COM. MEN. SEMILLAS, ABONOS, FLORES, PLANTAS'),(621,'1','659.8','COM. MEN. \"SEX-SHOP\"'),(622,'1','659.9','COM. MEN. OTROS PTOS. NCOP'),(623,'1','661.1','COM. MEN. GRANDES ALMACENES'),(624,'1','661.2','COM. MEN. EN HIPERMERCADOS'),(625,'1','661.3','COM. MEN. ALMACENES POPULARES'),(626,'1','662.1','COM. MEN. EN ECONOMATOS Y COOP. DE CONSUMO'),(627,'1','662.2','COM. MEN. TODA CLASE ART. EN OTROS LOCALES'),(628,'1','663.1','COM. MEN. PTOS. ALIMENTICIOS SIN ESTABLEC.'),(629,'1','663.2','COM. MEN. TEXTILES Y CONFECC. SIN ESTABLEC.'),(630,'1','663.3','COM. MEN. CALZADO SIN ESTABLECIMIENTO'),(631,'1','663.4','COM. MEN. DROGUERIA SIN ESTABLECIMIENTO'),(632,'1','663.9','COM. MEN. OTRAS MERCANCIAS SIN ESTABLECIM.'),(633,'1','664.1','VENTA ARTICULOS DIVERSOS EN EXPOSITORES'),(634,'1','664.2','VENTA CARRETES FOTOS EN EXPOSITORES'),(635,'1','664.9','COM. MEN. ART. DIVERSOS EN MAQUINAS'),(636,'1','665','COMERCIO AL POR MENOR POR CORREO O POR CATALOGO DE PRODUCTOS DIVERSOS'),(637,'1','671.1','RESTAURANTES CINCO TENEDORES'),(638,'1','671.2','RESTAURANTES CUATRO TENEDORES'),(639,'1','671.3','RESTAURANTES DE TRES TENEDORES'),(640,'1','671.4','RESTAURANTES DE DOS TENEDORES'),(641,'1','671.5','RESTAURANTES DE UN TENEDOR'),(642,'1','672.1','CAFETERIAS TRES TAZAS'),(643,'1','672.2','CAFETERIAS DOS TAZAS'),(644,'1','672.3','CAFETERIAS DE UNA TAZA'),(645,'1','673.1','BARES CATEGORIA ESPECIAL'),(646,'1','673.2','OTROS CAFES Y BARES'),(647,'1','674.1','CAFE-BAR EN VEHICULO'),(648,'1','674.2','CAFE-BAR EN FERROCARRILES'),(649,'1','674.3','CABE-BAR EN BARCOS'),(650,'1','674.4','CAFE-BAR AERONAVES'),(651,'1','674.5','CAFE-BAR SOCIEDADES, CASINOS, CLUBES...'),(652,'1','674.6','CAFE-BAR TEATROS Y CINES'),(653,'1','674.7','SERVICIOS EN PARQUES O RECINTOS FERIALES'),(654,'1','675','SERVICIOS EN QUIOSCOS, CAJONES, BARRACAS U OTROS LOCALES ANALOGOS'),(655,'1','676','SERVICIOS DE CHOCOLATERIAS, HELADERIAS Y HORCHATERIAS'),(656,'1','677.1','HOSTELERIA Y RESTAURACION SIN ESTABLEC.'),(657,'1','677.9','OTROS SERV. ALIMENTACION - RESTAURACION'),(658,'1','681','SERVICIO DE HOSPEDAJE EN HOTELES Y MOTELES'),(659,'1','682','SERVICIO DE HOSPEDAJE EN HOSTALES Y PENSIONES'),(660,'1','683','SERVICIO DE HOSPEDAJE EN FONDAS Y CASAS DE HUESPEDES'),(661,'1','684','SERVICIO DE HOSPEDAJE EN HOTELES-APARTAMENTOS'),(662,'1','685','ALOJAMIENTOS TURISTICOS EXTRAHOTELEROS'),(663,'1','686','EXPLOTACION DE APARTAMENTOS PRIVADOS A TRAVES DE AGENCIA O EMPRESA ORGANIZADA'),(664,'1','687.1','CAMPAMENTOS DE LUJO'),(665,'1','687.2','CAMPAMENTOS DE PRIMERA CLASE'),(666,'1','687.3','CAMPAMENTOS DE SEGUNDA CLASE'),(667,'1','687.4','CAMPAMENTOS DE TERCERA CLASE'),(668,'1','691.1','REPARACI?N DE ART?CULOS EL?CTRICOS PARA EL HOGAR'),(669,'1','691.2','REPARACI?N DE VEH?CULOS AUTOM?VILES, BICICLETAS Y OTROS VEH?CULOS'),(670,'1','691.9','REPARACI?N DE OTROS BIENES DE CONSUMO N.C.O.P.'),(671,'1','692','REPARACI?N DE MAQUINARIA INDUSTRIAL'),(672,'1','699','OTRAS REPARACIONES N.C.O.P.'),(673,'1','711.1','TTE. FERROVIARIO DE VIAJEROS VIA NORMAL'),(674,'1','711.2','TTE. FERROVIARIO MERCACIAS VIA NORMAL'),(675,'1','712.1','TTE. FERROVIARIO VIAJEROS VIA ESTRECHA'),(676,'1','712.2','TTE. FERROVIARIO MERCANCIAS VIA ESTRECHA'),(677,'1','721.1','TTE. URBANO COLECTIVO'),(678,'1','721.2','TTE. POR AUTOTAXIS'),(679,'1','721.3','TTE. VIAJEROS POR CARRETERA'),(680,'1','721.4','TRANSPORTE SANITARIO EN AMBULANCIAS'),(681,'1','722','TRANSPORTE DE MERCANCIAS POR CARRETERA'),(682,'1','729.1','TTE. FERROCARRIL DE CREMALLERA'),(683,'1','729.2','TTE. TELEFERICOS Y FUNICULARES'),(684,'1','729.3','OTROS SERVICIOS DE TTE. TERRESTRE'),(685,'1','731.1','TTE. MARITIMO INTERNACIONAL PASAJEROS'),(686,'1','731.2','TTE. MARITIMO INTERNACIONAL MERCANCIAS'),(687,'1','732.1','TTE. MARITIMO INTERNACIONAL PTOS PETROL.'),(688,'1','732.2','TTE. CABOTAJE PTOS. PETROLIFEROS Y GAS'),(689,'1','732.3','TTE. VIAS NAVEGABLES INTERIOR PETROLEO Y GAS'),(690,'1','733.1','TTE. CABOTAJE Y VIAS INTERIOR VIAJEROS'),(691,'1','733.2','TTE. CABOTAJE Y VIAS INTERIOR MERCANCIAS'),(692,'1','733.3','TRANSBORDADORES, FERRY BOATS Y SIMIL'),(693,'1','733.4','TTE. MARITIMO PASAJEROS EN JET-FOIL'),(694,'1','741.1','TTE. AEREO NACIONAL DE VIAJEROS'),(695,'1','741.2','TTE. AEREO NACIONAL MERCANCIAS'),(696,'1','741.3','TTE. AEREO INTERNACIONAL DE VIAJEROS'),(697,'1','741.4','TTE. AEREO INTERNACIONAL MERCANCIAS'),(698,'1','742.1','TTE. AEREO NACIONAL VIAJEROS'),(699,'1','742.2','TTE. AEREO NACIONAL DE MERCANCIAS'),(700,'1','742.3','TTE. AEREO INTERNAC. VIAJEROS CHARTER'),(701,'1','742.4','TTE. AEREO INTERNAC. MERCANCIAS CHARTER'),(702,'1','751.1','GUARDIA Y CUSTODIA VEHICULOS EN GARAJES'),(703,'1','751.2','GUARDIA Y CUSTODIA VEHICULOS \"PARKING\"'),(704,'1','751.3','GUARDIA Y CUSTODIA VEHICULOS EN SOLARES'),(705,'1','751.4','EXPLOTACION AUTOPISTAS Y TUNELES PEAJE'),(706,'1','751.5','ENGRASE Y LAVADO DE VEHICULOS'),(707,'1','751.6','SERVICIOS DE CARGA Y DESCARGA MERCANCIAS'),(708,'1','752.1','SERVICIOS PILOTAJE Y PRACTICOS PUERTOS'),(709,'1','752.2','SERVICIOS TRANSBORDO DE BARCOS'),(710,'1','752.3','SERVICIOS DE REMOLQUE DE NAVIOS'),(711,'1','752.4','SERVICIOS LIMPIEZA Y DESINFECCION BARCOS'),(712,'1','752.5','SERV. SALVAMENTO Y RECUPERACION BARCOS'),(713,'1','752.6','SERVICIOS CARGA Y DESCARGA DE BUQUES'),(714,'1','752.7','EXPLOTACION DE PUERTOS, CANALES Y DIQUES'),(715,'1','752.8','SERV. SE?ALES MARITIMAS Y COSTERAS'),(716,'1','753.1','TERMINALES LINEAS TTE. AEREO AEROPUERTOS'),(717,'1','753.2','SERVICIO DE CONTROL DE NAVEGACION AEREA'),(718,'1','753.3','SERV. HANGARES Y ESTACIONAMIENTO AVIONES'),(719,'1','753.4','SERV. REMOLQUE, Y MANTENIMIENTO AVIONES'),(720,'1','753.5','EXPLOTACION INTEGRAL DE AEROPUERTOS'),(721,'1','753.9','OTROS SERV. ANEXOS AL TTE. AEREO NCOP'),(722,'1','754.1','DEPOSITOS Y ALMACENES GENERALES'),(723,'1','754.2','DEPOSITOS Y ALMACENES DE VEHICULOS'),(724,'1','754.3','SILOS Y OTROS ALMACENES DE GRANOS'),(725,'1','754.4','ALMACENES FRIGORIFICOS'),(726,'1','754.5','ALMACENES Y DEPOSITOS DE LIQUIDOS'),(727,'1','754.6','GUARDAMUEBLES'),(728,'1','754.9','OTROS DEPOSITOS ESPECIALES NCOP'),(729,'1','755.1','SERVICIOS A OTRAS AGENCIAS DE VIAJES'),(730,'1','755.2','SERV. AL PUBLICO DE AGENCIAS DE VIAJES'),(731,'1','756.1','AGENCIAS DE TTE., TRANSITARIOS'),(732,'1','756.2','CONSIGNATARIOS DE BUQUES'),(733,'1','756.9','OTROS SERVICIOS DE MEDIACION DEL TTE.'),(734,'1','757','SERVICIOS DE MUDANZAS'),(735,'1','761.1','SERV. TELEFONIA FIJA'),(736,'1','761.2','SERV. TELEFONIA MOVIL'),(737,'1','761.3','SERV. TELEFONICOS USOS ESPECIALES'),(738,'1','769.1','TELECOMUNICACION MOVIL'),(739,'1','769.2','TELETRANSMISION DE DATOS'),(740,'1','769.3','TELECOMUNICACION VIA SATELITE'),(741,'1','769.9','OTROS SERV. PRIVADOS TELECOMUNICACION'),(742,'1','811','BANCA'),(743,'1','812','CAJAS DE AHORRO'),(744,'1','819.1','INSTITUCIONES DE CREDITO'),(745,'1','819.2','ESTABLECIMIENTOS FINANCIEROS DE CREDITO'),(746,'1','819.3','ESTABLECIMIENTOS DE PRESTAMO Y CREDITO'),(747,'1','819.4','ESTAB. FINANCIEROS DE \"FACTORING\"'),(748,'1','819.5','ARRENDAMIENTO FINANCIERO'),(749,'1','819.6','ENTIDADES DE CAMBIO DE MONEDA'),(750,'1','819.9','OTRAS ENTIDADES FINANCIERAS NCOP'),(751,'1','821.1','SEGUROS DE VIDA'),(752,'1','821.2','SEGUROS DE CAPITALIZACION'),(753,'1','821.3','SEGUROS MIXTOS DE VIDA Y CAPITALIZACION'),(754,'1','822.1','SEGUROS DE ASISTENCIA SANITARIA'),(755,'1','822.2','SEGUROS DE ENTIERRO'),(756,'1','822.3','SEGUROS DE DA?OS MATERIALES'),(757,'1','822.4','SEGUROS DE TRANSPORTES'),(758,'1','822.9','OTROS SEGUROS'),(759,'1','823','OTRAS ENTIDADES ASEGURADORAS (MONTEPIOS, CAJAS DE PENSIONES, ...)'),(760,'1','831.1','SERV.COMPRA-VTA. DE VALORES MOBILIARIOS'),(761,'1','831.2','SER. FINANC. CONTRATACION PRODUCTOS'),(762,'1','831.3','SERV. DE COMPENSACION BANCARIA'),(763,'1','831.9','OTROS SERVICIOS FINANCIEROS NCOP'),(764,'1','832.1','AGENCIAS DE SEGUROS Y CORREDURIAS'),(765,'1','832.2','SERV. TASACION Y TARIFICACION SEGUROS'),(766,'1','832.9','OTROS SERV. AUXILIARES DE SEGUROS'),(767,'1','833.1','PROMOCION INMOBILIARIA DE TERRENOS'),(768,'1','833.2','PROMOCION INMOBILIARIA DE EDIFICACIONES'),(769,'1','834','SERVICIOS RELATIVOS A LA PROPIEDAD INMOBILIARIA Y A LA PROPIEDAD INDUSTRIAL'),(770,'1','841','SERVICIOS JURIDICOS'),(771,'1','842','SERVICIOS FINANCIEROS Y CONTABLES'),(772,'1','843.1','SERVICIOS TECNICOS DE INGENIERIA'),(773,'1','843.2','SERV. TEC. DE ARQUITECTURA'),(774,'1','843.3','SERV. TEC. PROSPECCIONES Y GEOLOGIA'),(775,'1','843.4','SERV. TECNICOS DE TOPOGRAFIA'),(776,'1','843.5','SERV. TECNICOS DE DELINEACION'),(777,'1','843.6','INSPECCION TECNICA DE VEHICULOS'),(778,'1','843.9','OTROS SERVICIOS TECNICOS NCOP'),(779,'1','844','SERVICIOS DE PUBLICIDAD, RELACIONES P?BLICAS Y SIMILARES'),(780,'1','845','EXPLOTACION ELECTRONICA POR CUENTA DE TERCEROS'),(781,'1','846','EMPRESAS DE ESTUDIOS DE MERCADO'),(782,'1','847','SERVICIOS INTEGRALES DE CORREOS Y TELECOMUNICACIONES'),(783,'1','849.1','COBROS DE DEUDAS Y CONFECCION FACTURAS'),(784,'1','849.2','SERV. MECANOGRAFICOS, TAQUIGRAFICOS, ETC'),(785,'1','849.3','SERV. TRADUCCION Y SIMILARES'),(786,'1','849.4','SERV. CUSTODIA, SEGURIDAD Y PROTECCION'),(787,'1','849.5','SERVICIOS RECAD., REPARTO Y MANIP. CORRES'),(788,'1','849.6','SERV. COLOCACION Y SUMINISTRO DE PERSONAL'),(789,'1','849.7','SERV. GESTION ADMINISTRATIVA'),(790,'1','849.8','MULTISERVIOS INTENSIVOS EN PERSONAL'),(791,'1','849.9','OTROS SERVICIOS INDEPENDIENTES NCOP'),(792,'1','851','ALQUILER DE MAQUINARIA Y EQUIPO AGRICOLA'),(793,'1','852','ALQUILER DE MAQUINARIA Y EQUIPO PARA LA CONSTRUCCION'),(794,'1','853','ALQUILER DE MAQUINARIA Y EQUIPO CONTABLE, DE OFICINA Y C?LCULO ELECTR?NICO'),(795,'1','854.1','ALQUILER DE AUTOMOVILES SIN CONDUCTOR'),(796,'1','854.2','ALQUILER DE AUTOMOVILES EN \"RENTING\"'),(797,'1','855.1','ALQUILER DE AERONAVES DE TODAS CLASES'),(798,'1','855.2','ALQUILER DE EMBARCACIONES'),(799,'1','855.3','ALQUILER DE BICICLETAS'),(800,'1','855.9','ALQUILER OTROS MEDIOS TRANSP. N.C.O.P.'),(801,'1','856.1','ALQUILER DE BIENES DE CONSUMO'),(802,'1','856.2','ALQUILER DE PELICULAS DE VIDEO'),(803,'1','857.1','ALQUILER DE APARATOS DE MEDIDA'),(804,'1','857.2','SERV. DE PESA A MEDIDA SIN ALQUILER'),(805,'1','857.3','ALQUILER CONTADORES PARA AUTOMOVILES'),(806,'1','857.4','ALQUILER, LEC., CONS., CONTADORES DE LUZ'),(807,'1','857.5','LECTURA Y CONS. CONTAD. LUZ TANTO ALZADO'),(808,'1','857.6','ALQUILER, LEC. Y CONS. CONTADORES GAS'),(809,'1','857.7','LECTURA Y CONS. DE CONTADORES DE GAS'),(810,'1','857.8','ALQUILER, LEC. Y CONS. CONTADORES AGUA'),(811,'1','857.9','LECTURA Y CONS. DE CONTADORES DE AGUA'),(812,'1','859','ALQUILER DE OTROS BIENES N.C.O.P. (SIN PERSONAL PERMANENTE)'),(813,'1','861.1','ALQUILER DE VIVIENDAS'),(814,'1','861.2','ALQUILER LOCALES INDUSTRIALES'),(815,'1','862','ALQUILER DE BIENES INMUEBLES DE NATURALEZA RUSTICA'),(816,'1','911','SERVICIOS AGRICOLAS Y GANADEROS'),(817,'1','912','SERVICIOS FORESTALES'),(818,'1','913','SERVICIOS RELACIONADOS CON LA PESCA Y LA ACUICULTURA'),(819,'1','921.1','SERV. LIMPIEZA VIARIA Y JARDINES'),(820,'1','921.2','SERV. RECOGIDA DE BASURAS Y DESECHOS'),(821,'1','921.3','EXTERMINIO ANIMALES DA?INOS Y DESIFECC.'),(822,'1','921.4','SERV. ALCANTARILLADO, EVACUACION AGUAS'),(823,'1','921.5','SERVICIOS INCINERACION, ELIM. BASURAS'),(824,'1','921.6','SERV. PROTECCION Y ACONDIC. AMBIENTAL'),(825,'1','921.7','SERV. PROTECCION CONTRA INCENDIOS'),(826,'1','921.8','SERV. ADMON. CEMENTERIOS'),(827,'1','921.9','OTROS SERVICIOS DE SANEAMIENTO N.C.O.P.'),(828,'1','922.1','SERV. LIMPIEZA INTERIORES'),(829,'1','922.2','SERV. ESPECIALIZADOS DE LIMPIEZA'),(830,'1','931.1','GUARDERIA Y ENSE?ANZA INFANTIL, EXCLUSIV.'),(831,'1','931.2','ENSE?ANZA EDUCACION GENERAL BASICA'),(832,'1','931.3','ENSE?ANZA BACHILLERATO, F.P., Y C.O.U.'),(833,'1','931.4','ENSE?ANZA REGLADA (PREESC, EGB, BUP, FP, COU)'),(834,'1','931.5','ENSE?ANZA DE EDUCACION SUPERIOR'),(835,'1','932.1','ENSE?ANZA FORMACION PROF. NO SUPERIOR'),(836,'1','932.2','ENSE?ANZA FORM. PROFESIONAL SUPERIOR'),(837,'1','933.1','ENSE?. CONDUCCION VEHICULOS'),(838,'1','933.2','PROMOCION CURSOS, ESTUDIOS EN EL EXTRANJ.'),(839,'1','933.9','OTROS ACTIV. ENSE?ANZA'),(840,'1','934','ENSE?ANZA FUERA DE ESTABLECIMIENTO PERMANENTE'),(841,'1','935.1','COLEGIOS MAYORES'),(842,'1','935.2','RESIDENCIAS DE ESTUDIANTES'),(843,'1','936.1','INVESTIGACION CC. EXACTAS Y NATURALES'),(844,'1','936.2','INVESTIGACION CC. MEDICAS'),(845,'1','936.3','INVESTIGACIONES AGRARIAS'),(846,'1','936.4','INVEST. CC. SOCIALES, HUMANIDADES'),(847,'1','936.5','INVESTIGACION TECNICA INDUSTRIAL'),(848,'1','936.9','OTRAS INVESTIGACIONES CIENTIFICAS N.C.O.P.'),(849,'1','941.1','HOSPITALES GENERALES'),(850,'1','941.2','HOSPITALES ESPECIALIZADOS'),(851,'1','942.1','CONSULTORIOS MEDICOS, SANITARIOS...'),(852,'1','942.2','BALNEARIOS Y BA?OS'),(853,'1','942.9','OTROS SERV. SANITARIOS'),(854,'1','943','CONSULTAS Y CLINICAS DE ESTOMATOLOGIA Y ODONTOLOGIA'),(855,'1','944','SERVICIOS DE NATUROPATIA, ACUPUNTURA Y OTROS SERVICIOS PARASANITARIOS'),(856,'1','945','CONSULTAS Y CLINICAS VETERINARIAS'),(857,'1','951','ASISTENCIA Y SERVICIOS SOCIALES PARA NI?OS, JOVENES, ANCIANOS, ... (CENTROS RESIDENCIALES)'),(858,'1','952','ASISTENCIA Y SERVICIOS SOCIALES PARA NI?OS, JOVENES, ANCIANOS, ... (CENTROS NO RESIDENCIALES)'),(859,'1','961.1','PRODUCCION PELICULAS CINEMATOGRAFICAS'),(860,'1','961.2','DOBLAJE, MONTAJE DE PELICULAS'),(861,'1','961.3','DECORACIONES ESCENICAS PELICULAS'),(862,'1','962.1','DISTRIBUCION Y VENTA DE PELICULAS'),(863,'1','962.2','DISTRIBUCION Y VENTA MAYOR DE PELICULAS'),(864,'1','963.1','EXHIBICION DE PELICULAS DE CINE Y VIDEO'),(865,'1','963.2','EXHIBICION PELICULAS AIRE LIBRE'),(866,'1','963.3','EXHIBICION PELICULAS SIN ESTABLECIMIENTO'),(867,'1','963.4','EXHIBICION PELICULAS ESTABLEC. DISTINTOS'),(868,'1','964.1','SERVICIOS DE RADIODIFUSION'),(869,'1','964.2','SERVICIOS DE TELEVISION'),(870,'1','964.3','SERV. TRANSMISION Y ENLACE SE?ALES TV'),(871,'1','965.1','ESPECTACULOS EN SALAS Y LOCALES'),(872,'1','965.2','ESPECTACULOS AL AIRE LIBRE'),(873,'1','965.3','ESPECTACULOS FUERA ESTABLECIMIENTO'),(874,'1','965.4','EMPRESAS DE ESPECTACULOS'),(875,'1','965.5','ESPECTACULOS TAURINOS'),(876,'1','966.1','BIBLIOTECAS Y MUSEOS'),(877,'1','966.2','ZOOLOGICOS, BOTANICOS Y SIMILARES'),(878,'1','966.9','OTROS SERVICIOS CULTURALES NCOP'),(879,'1','967.1','INSTALACIONES DEPORTIVAS'),(880,'1','967.2','ESCUELAS Y SERV. PERFECC. DEL DEPORTE'),(881,'1','967.3','ALQUILER ARTICULOS DEPORTE EN INST. DEP.'),(882,'1','968.1','INSTALAC. CELEB. ESPECTACULOS DEPORTIVOS'),(883,'1','968.2','ORGANIZACION ESPECTACULOS DEPORTIVOS'),(884,'1','968.3','ORGANIZ. ESPECT. DEPORT. FEDERAC. Y CLUBES'),(885,'1','969.1','SALAS DE BAILE Y DISCOTECAS'),(886,'1','969.2','CASINOS DE JUEGO'),(887,'1','969.3','JUEGOS DE BINGO'),(888,'1','969.4','MAQUINAS RECREATIVAS Y DE AZAR'),(889,'1','969.5','JUEGOS BILLAR, PING-PONG, BOLOS Y OTROS'),(890,'1','969.6','SALONES RECREATIVOS Y DE JUEGO'),(891,'1','969.7','OTRAS MAQUINAS AUTOMATICAS'),(892,'1','971.1','TINTE, LIMP. SECO, LAVADO Y PLANCHADO'),(893,'1','971.2','LIMPIEZA Y TE?IDO DEL CALZADO'),(894,'1','971.3','ZURCIDO Y REPARACION DE ROPAS'),(895,'1','972.1','SERV. PELUQUERIA SE?ORAS Y CABALLEROS'),(896,'1','972.2','SALONES E INSTITUTOS DE BELLEZA'),(897,'1','973.1','SERVICIOS FOTOGRAFICOS'),(898,'1','973.2','MAQUINAS AUTOMAT. FOTOGRAFIAS Y FOTOCOP.'),(899,'1','973.3','SERV. COPIAS DOCUMENTOS MAQ. FOTOCOPIA'),(900,'1','974','AGENCIAS DE PRESTACION DE SERVICIOS DOMESTICOS'),(901,'1','975','SERVICIOS DE ENMARCACION'),(902,'1','979.1','SERV. POMPAS FUNEBRES'),(903,'1','979.2','ADORNO DE TEMPLOS Y OTROS LOCALES'),(904,'1','979.3','AGENCIAS MATRIMONIALES Y OTROS SERVICIOS'),(905,'1','979.4','ADIESTRAMIENTO Y CUIDADOS DE ANIMALES'),(906,'1','979.9','OTROS SERVICIOS PERSONALES NCOP'),(907,'1','981.1','CURIOSIDADES EN PARQUES, GRUTAS, ...'),(908,'1','981.2','JARDINES DE RECREO'),(909,'1','981.3','PARQUES DE ATRACCIONES (TAMB. ACUATICOS)'),(910,'1','982.1','TOMBOLAS Y RIFAS AUTORIZADAS ESTABLECIM.'),(911,'1','982.2','TOMBOLAS Y RIFAS AUTOR. SIN ESTABLECIM.'),(912,'1','982.3','EXPOSICION FIGURAS DE CERA ESTABLECIM.'),(913,'1','982.4','OTRAS ATRACC., SERVICIOS, FUERA ESTABLEC.'),(914,'1','982.5','ORGANIZ. Y CELEB. APUESTAS DEPORT. LOTER'),(915,'1','983','AGENCIAS DE COLOCACION DE ARTISTAS'),(916,'1','989.1','EXPEDICION BILLETES ESPECTACULOS'),(917,'1','989.2','SERV. ORGANIZ. CONGRESOS, ASAMBLEAS, ...'),(918,'1','989.3','PARQUES O RECINTOS FERIALES'),(919,'1','991','PRESTACION DE SERVICIOS POR SOCIEDADES DE DESARROLLO INDUSTRIAL REGIONAL'),(920,'1','999','OTROS SERVICIOS N.C.O.P.'),(921,'2','011','DOCTORES Y LICENCIADOS EN BIOLOGIA'),(922,'2','012','INGENIEROS AGRONOMOS Y DE MONTES'),(923,'2','013','VETERINARIOS'),(924,'2','021','TECNICOS BIOLOGIA, AGRONOMIA Y SILVICULT'),(925,'2','022','INGENIEROS TEC. AGRICOLAS Y FORESTALES'),(926,'2','023','INGENIEROS TECNICOS TOPOGRAFOS'),(927,'2','024','AUXILIARES Y AYUDANTES VETERINARIA'),(928,'2','099','OTRO PROFESIONALES AGRICULTURA... NCOP'),(929,'2','111','DRES.Y LICENCIADOS FISICAS Y GEOLOGICAS'),(930,'2','112','INGENIEROS DE MINAS'),(931,'2','121','DRES. Y LICENCIADOS EN QUIMICAS'),(932,'2','131','INGENIEROS TEC. MINAS FACULT. Y PERITOS'),(933,'2','199','OTROS PROF. RELAC. ENERGIA,MINERIA,QUIM.'),(934,'2','211','INGENIEROS AERONAUTICOS'),(935,'2','212','INGENIEROS NAVALES'),(936,'2','213','INGENIEROS TELECOMUNICACION'),(937,'2','214','INGENIEROS ARMAMENTO'),(938,'2','221','INGENIEROS TEC. AERONAUTICOS'),(939,'2','222','INGENIEROS TEC. TELECOMUNICACIONES'),(940,'2','223','AYUDANTES INGENIEROS Y TECNICOS ICAI'),(941,'2','224','DIBUJANTES TECNICOS'),(942,'2','225','TECNICOS EN TELECOMUNICACION'),(943,'2','226','TECNICOS EN SONIDO'),(944,'2','227','TECNICOS EN ILUMINACION'),(945,'2','228','INGENIEROS TECN. NAVALES,AYTES Y PERITOS'),(946,'2','299','OTROS PROF.RELACION AERONAUTICA,COMUNIC.'),(947,'2','311','INGENIEROS INDUSTRIALES Y TEXTILES'),(948,'2','321','INGENIEROS TEC. INDUSTRIALES Y TEXTILES'),(949,'2','322','TECNICOS EN ARTES GRAFICAS'),(950,'2','399','OTROS PROFESIONALES INDUSTRIAS MANUFAC.'),(951,'2','411','ARQUITECTOS'),(952,'2','412','INGENIEROS CAMINOS, CANALES Y PUERTOS'),(953,'2','421','ARQUITECTOS TECNICOS Y APAREJADORES'),(954,'2','422','INGENIEROS TEC. OBRAS PUBLICAS'),(955,'2','431','DELINEANTES'),(956,'2','432','DECORADORES-DISE?ADORES DE INTERIORES'),(957,'2','441','TEC. SUPERIORES URBANISTICOS Y TOPOGRAFI'),(958,'2','451','INGENIEROS EN GEODESIA Y CARTOGRAFIA'),(959,'2','499','OTROS PROFES. RELACIONADOS CONSTRUCCION'),(960,'2','511','AGENTES COMERCIALES'),(961,'2','521','TECNICOS EN HOSTELERIA'),(962,'2','599','OTROS PROF. RELAC. COMERCIO Y HOSTELERIA'),(963,'2','611','AGENTES DE FERROCARRILES'),(964,'2','612','CONDUCTORES DE VEHICULOS TERRESTRES'),(965,'2','699','OTROS PROFESIONALES RELAC. TRANSPORTE'),(966,'2','711','ACTUARIOS DE SEGUROS'),(967,'2','712','AGENTES Y CORREDORES DE SEGUROS'),(968,'2','721','AGENTES COLEGIADOS PROPIEDAD IND.E INMOB'),(969,'2','722','GESTORES ADMINISTRATIVOS'),(970,'2','723','ADMINISTRADORES DE FINCAS'),(971,'2','724','INTERMEDIARIOS PROMOCION EDIFICACIONES'),(972,'2','725','HABILITADOS DE CLASES PASIVAS'),(973,'2','726','GRADUADOS SOCIALES'),(974,'2','727','AGENTES O INTERMEDIARIOS PRESTAMOS'),(975,'2','728','AGENTES DE ADUANAS'),(976,'2','731','ABOGADOS'),(977,'2','732','PROCURADORES'),(978,'2','733','NOTARIOS'),(979,'2','734','REGISTRADORES'),(980,'2','741','ECONOMISTAS'),(981,'2','742','INTENDENTES Y PROFESORES MERCANTILES'),(982,'2','743','PERITOS MERCANTILES'),(983,'2','744','DIPLOMADOS EN CIENCIAS EMPRESARIALES'),(984,'2','746','CORREDORES DE COMERCIO LIBRES'),(985,'2','747','AUDITORES DE CUENTAS Y CENSORES JURADOS'),(986,'2','748','ADMINISTRADORES DE CARTERAS DE VALORES'),(987,'2','749','CORREDORES INTERPRETES Y MARITIMOS'),(988,'2','751','PROFESIONALES PUBLICIDAD, RELAC.PUBLICAS'),(989,'2','761','DOCTORES Y LICENCIADOS EXACTAS Y ESTAD.'),(990,'2','762','DOCTORES,LICENCIADOS,INGENIEROS INFORMAT'),(991,'2','763','PROGRAMADORES Y ANALISTAS INFORMATICA'),(992,'2','764','DIPLOMADOS EN INFORMATICA'),(993,'2','765','GRABADORES, Y OTROS PROF. INFORMATICA'),(994,'2','771','AGENTES COBRADORES'),(995,'2','772','ESTENOTIPISTAS, TAQUIMECANOGRAFOS,...'),(996,'2','773','DETECTIVES PRIVADOS, VIGILANCIA, PROTECC'),(997,'2','774','TRADUCTORES E INTERPRETES'),(998,'2','775','DOCTORES Y LICENCIADOS EN FILOSOFIA'),(999,'2','776','DRES.LICENC.POLITICAS,SOCIALES,LETRAS'),(1000,'2','777','ESPECIALISTAS ORIENTACION Y ANALISIS PER'),(1001,'2','778','DIPL. EN BIBLIOTECOMANIA Y DOCUMENTACION'),(1002,'2','799','OTROS PROF. ACTIV. FINANC. JURID. SEGUR.'),(1003,'2','811','PROFESIONALES LIMPIEZA'),(1004,'2','821','PERSONAL DOCENTE ENSE?ANZA SUPERIOR'),(1005,'2','822','PERSONAL DOCENTE ENSE?ANZA MEDIA'),(1006,'2','823','DOCENTES ENSE?ANZA GRAL. BASICA'),(1007,'2','824','PROFESORES FORMACION PROFESIONAL'),(1008,'2','825','PROFESORES CONDUCCION VEHICULOS'),(1009,'2','826','PERSONAL DOCENTE ENSE?ANZAS DIVERSAS'),(1010,'2','831','MEDICOS MEDICINA GENERAL'),(1011,'2','832','MEDICOS ESPECIALISTAS'),(1012,'2','833','ESTOMATOLOGOS'),(1013,'2','834','ODONTOLOGOS'),(1014,'2','835','FARMACEUTICOS'),(1015,'2','836','AYUD. TECN. SANITARIOS Y FISIOTERAPEUTAS'),(1016,'2','837','PROTESICOS E HIGIENISTAS DENTALES'),(1017,'2','838','OPTICOS-OPTOMETRISTAS Y PODOLOGOS'),(1018,'2','839','MASAJISTAS, DIETISTAS, Y AUX.ENFERMERIA'),(1019,'2','841','ACUPUNTORES, NATUROPATAS Y OTROS'),(1020,'2','851','REPRESENTANTES TECNICOS DEL ESPECTACULO'),(1021,'2','852','APODERADOS Y REPRESENTANTES TAURINOS'),(1022,'2','853','AGENTES COLOCADORES ARTISTAS'),(1023,'2','854','EXPERTOS ORGANIZACION CONGRESOS'),(1024,'2','855','AGENTES Y CORREDORES APUESTAS'),(1025,'2','861','PINTORES,ESCULTORES,CERAMISTAS,ARTESANOS'),(1026,'2','862','RESTAURADORES OBRAS DE ARTE'),(1027,'2','871','EXPENDEDORES OFICIALES LOTERIAS'),(1028,'2','872','EXPENDEDORES OFICIALES APUESTAS'),(1029,'2','873','EXPENDEDORES NO OFICIALES APUESTAS'),(1030,'2','881','ASTROLOGOS Y SIMILARES'),(1031,'2','882','GUIAS DE TURISMO'),(1032,'2','883','GUIAS INTERPRETES DE TURISMO'),(1033,'2','884','PERITOS TASADORES:SEGUROS,ALHAJAS,...'),(1034,'2','885','LIQUIDADORES Y COMISARIOS DE AVERIAS'),(1035,'2','886','CRONOMETRADORES'),(1036,'2','887','MAQUILLADORES Y ESTETICISTAS'),(1037,'2','888','GRAFOLOGOS'),(1038,'2','899','OTROS PROF. RELACIONADOS CON SERVICIOS'),(1039,'3','011','DIRECTORES DE CINE Y TEATRO'),(1040,'3','012','AYUDANTES DE DIRECCION'),(1041,'3','013','ACTORES DE CINE Y TEATRO'),(1042,'3','014','EXTRAS ESPECIALISTAS, DOBLES, COMPARSAS'),(1043,'3','015','OPERADORES CAMARA:CINE,TV.,VIDEO'),(1044,'3','016','HUMORISTAS,CARICATOS,EXCENTRICOS'),(1045,'3','017','APUNTADORES Y REGIDORES'),(1046,'3','018','ARTISTAS CIRCENSES'),(1047,'3','019','ACTIVIDADES CINE,TEATRO, Y CIRCO NCOP'),(1048,'3','021','DIRECTORES COREOGRAFICOS'),(1049,'3','022','BAILARINES'),(1050,'3','029','OTRAS ACTIV. DEL BAILE NCOP'),(1051,'3','031','MAESTROS Y DIRECTORES DE MUSICA'),(1052,'3','032','INTERPRETES DE INSTRUMENTOS MUSICALES'),(1053,'3','033','CANTANTES'),(1054,'3','039','OTRAS ACTIV. RELAC. MUSICA NCOP'),(1055,'3','041','JUGADORES Y ENTRENADORES DE FUTBOL'),(1056,'3','042','JUGADORES,ENTRENADORES, DE TENIS Y GOLF'),(1057,'3','043','PILOTOS,ENTRENADORES MOTO Y AUTOCICLISMO'),(1058,'3','044','BOXEADORES,ENTRENADORES DE BOXEO'),(1059,'3','045','JUGADORES,ENTRENADORES DE BALONCESTO'),(1060,'3','046','CORREDORES,ENTRENADORES DE CICLISMO'),(1061,'3','047','BALONMANO,VOLEIBOL,PELOTA,HIPICA,LUCHA'),(1062,'3','048','ARBITROS DE ESPECTACULOS DEPORTIVOS'),(1063,'3','049','OTRAS ACTIV. RELACIONADAS DEPORTE NCOP'),(1064,'3','051','MATADORES DE TOROS'),(1065,'3','052','REJONEADORES'),(1066,'3','053','SUBALTERNOS'),(1067,'3','054','JEFES DE CUADRILLAS COMICAS Y SIMILARES'),(1068,'3','055','OTRO PERSONAL CUADRILLAS COMICAS Y SIMIL'),(1069,'3','059','OTRAS ACTIV. ESPEC.TAURINOS NCOP');
/*!40000 ALTER TABLE `iae` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `iattach`
--

DROP TABLE IF EXISTS `iattach`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `iattach` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Archivo Adjunto del Articulo',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `item` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador de Articulo',
  `mimeType` tinyint(2) DEFAULT NULL COMMENT 'Mime Type del Archivo Adjunto',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion del Archivo Adjunto',
  `data` mediumblob COMMENT 'Archivo Adjunto en binario',
  `type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de Archivo Adjunto',
  `driveId` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `IDX_IATTACH_ITEM` (`item`),
  KEY `IDX_IATTACH_DOMAIN` (`domain`),
  CONSTRAINT `FK_IATTACH_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_IATTACH_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Archivos Adjuntos de Articulos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `iattach`
--

LOCK TABLES `iattach` WRITE;
/*!40000 ALTER TABLE `iattach` DISABLE KEYS */;
/*!40000 ALTER TABLE `iattach` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `income`
--

DROP TABLE IF EXISTS `income`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `income` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Albaran de Compra',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `project` int(4) DEFAULT NULL COMMENT 'Identificador del Proyecto',
  `reference_code` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Codigo de referencia del Albaran',
  `supplier` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador del Proveedor',
  `address` int(4) DEFAULT NULL COMMENT 'Identificador de la Direccion del Proveedor',
  `issue_time` date DEFAULT NULL COMMENT 'Fecha de emision del Albaran',
  `pay_method` int(4) DEFAULT NULL COMMENT 'Identificador de la Forma de Pago',
  `security_level` tinyint(2) DEFAULT '0' COMMENT 'Nivel de seguridad del Albaran',
  `status` tinyint(2) DEFAULT '0' COMMENT 'Estado del Albaran',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios del Albaran',
  `remarks` text COLLATE latin1_spanish_ci COMMENT 'Observaciones del Albaran',
  `workplace` int(4) DEFAULT NULL COMMENT 'Identificador del Centro de Trabajo',
  `scope` int(4) NOT NULL DEFAULT '1' COMMENT 'Ambito del Albaran',
  `number_of_pymnts` smallint(2) DEFAULT '0' COMMENT 'Numero de Vencimientos',
  `days_to_first_pymnt` smallint(2) DEFAULT '0' COMMENT 'Dias al primer Vencimiento',
  `days_between_pymnts` smallint(2) DEFAULT '0' COMMENT 'Dias entre Vencimientos',
  `pymnt_days` varchar(8) COLLATE latin1_spanish_ci DEFAULT '0' COMMENT 'Dias de pago',
  `bank_account` varchar(34) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'IBAN - Numero de Cuenta Bancaria Internacional',
  `bank_alias` varchar(25) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Alias del Banco',
  `bic` varchar(11) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'BIC - Codigo Identificador del Banco',
  `carrier_packing` int(4) DEFAULT NULL COMMENT 'Identificador de la Hoja de ruta',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  UNIQUE KEY `IDX_UNQ_INCOME_DOMAIN_SUPPLIER_REFERENCE_CODE` (`domain`,`supplier`,`reference_code`),
  KEY `IDX_INCOME_WORKPLACE` (`workplace`),
  KEY `IDX_INCOME_SCOPE` (`scope`),
  KEY `IDX_INCOME_PROJECT` (`project`),
  KEY `IDX_INCOME_SUPPLIER` (`supplier`),
  KEY `IDX_INCOME_RADDRESS` (`address`),
  KEY `IDX_INCOME_PAY_METHOD` (`pay_method`),
  KEY `IDX_INCOME_DOMAIN` (`domain`),
  CONSTRAINT `FK_INCOME_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_INCOME_PAY_METHOD` FOREIGN KEY (`pay_method`) REFERENCES `pay_method` (`id`),
  CONSTRAINT `FK_INCOME_PROJECT` FOREIGN KEY (`project`) REFERENCES `project` (`id`),
  CONSTRAINT `FK_INCOME_RADDRESS` FOREIGN KEY (`address`) REFERENCES `raddress` (`id`),
  CONSTRAINT `FK_INCOME_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`),
  CONSTRAINT `FK_INCOME_SUPPLIER` FOREIGN KEY (`supplier`) REFERENCES `supplier` (`registry`),
  CONSTRAINT `FK_INCOME_WORKPLACE` FOREIGN KEY (`workplace`) REFERENCES `workplace` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Albaranes de Compra';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `income`
--

LOCK TABLES `income` WRITE;
/*!40000 ALTER TABLE `income` DISABLE KEYS */;
/*!40000 ALTER TABLE `income` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `income_detail`
--

DROP TABLE IF EXISTS `income_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `income_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Detalle del Albaran de Compra',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `income` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador del Albaran de Compra',
  `project` int(4) DEFAULT NULL COMMENT 'Identificador del Proyecto',
  `line` smallint(2) DEFAULT '1' COMMENT 'Numero de linea del Detalle dentro del Albaran',
  `item` int(4) NOT NULL COMMENT 'Identificador del Articulo del Detalle de Albaran',
  `description` varchar(1024) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion del Detalle de Albaran',
  `warehouse` int(4) NOT NULL COMMENT 'Identificador del Almacen',
  `quantity` double(15,3) DEFAULT NULL COMMENT 'Cantidad del Detalle de Albaran',
  `price` double DEFAULT '0' COMMENT 'Precio del Detalle de Albaran',
  `discount_expr` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descuentos del Detalle de Albaran',
  `purchase_detail` int(4) DEFAULT NULL COMMENT 'Identificador del Detalle del Pedido de Compra asociado',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_INCOME_DETAIL_PROJECT` (`project`),
  KEY `IDX_INCOME_DETAIL_ITEM` (`item`),
  KEY `IDX_INCOME_DETAIL_WAREHOUSE` (`warehouse`),
  KEY `IDX_INCOME_DETAIL_PURCHASE_DETAIL` (`purchase_detail`),
  KEY `IDX_INCOME_DETAIL_INCOME` (`income`),
  KEY `IDX_INCOME_DETAIL_DOMAIN` (`domain`),
  CONSTRAINT `FK_INCOME_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_INCOME_DETAIL_INCOME` FOREIGN KEY (`income`) REFERENCES `income` (`id`),
  CONSTRAINT `FK_INCOME_DETAIL_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`),
  CONSTRAINT `FK_INCOME_DETAIL_PROJECT` FOREIGN KEY (`project`) REFERENCES `project` (`id`),
  CONSTRAINT `FK_INCOME_DETAIL_PURCHASE_DETAIL` FOREIGN KEY (`purchase_detail`) REFERENCES `purchase_detail` (`id`),
  CONSTRAINT `FK_INCOME_DETAIL_WAREHOUSE` FOREIGN KEY (`warehouse`) REFERENCES `warehouse` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalles del Albaran de Compra';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `income_detail`
--

LOCK TABLES `income_detail` WRITE;
/*!40000 ALTER TABLE `income_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `income_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `inventory`
--

DROP TABLE IF EXISTS `inventory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `inventory` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Inventario',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `inventory_date` date NOT NULL DEFAULT '0000-00-00' COMMENT 'Fecha de Inventario',
  `warehouse` int(4) NOT NULL DEFAULT '0' COMMENT 'Almacen Inventariado',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion del Inventario',
  `status` tinyint(2) DEFAULT '0' COMMENT 'Estado del Inventario',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_INVENTORY_DOMAIN` (`domain`),
  CONSTRAINT `FK_INVENTORY_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Inventarios de Almacenes';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `inventory`
--

LOCK TABLES `inventory` WRITE;
/*!40000 ALTER TABLE `inventory` DISABLE KEYS */;
/*!40000 ALTER TABLE `inventory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `inventory_detail`
--

DROP TABLE IF EXISTS `inventory_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `inventory_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Detalle del Inventario',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `inventory` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador de Inventario',
  `item` int(4) NOT NULL DEFAULT '0' COMMENT 'Articulo Inventariado',
  `actual_quantity` double(15,3) DEFAULT '0.000' COMMENT 'Cantidad actual del Articulo Inventariado',
  `real_quantity` double(15,3) DEFAULT '0.000' COMMENT 'Cantidad real del Articulo Inventariado',
  `cost` double(15,3) DEFAULT '0.000' COMMENT 'Coste del Articulo Inventariado',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_INVENTORY_DETAIL_INVENTORY` (`inventory`),
  KEY `IDX_INVENTORY_DETAIL_ITEM` (`item`),
  KEY `IDX_INVENTORY_DETAIL_DOMAIN` (`domain`),
  CONSTRAINT `FK_INVENTORY_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_INVENTORY_DETAIL_INVENTORY` FOREIGN KEY (`inventory`) REFERENCES `inventory` (`id`),
  CONSTRAINT `FK_INVENTORY_DETAIL_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalles de Inventarios de Almacenes';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `inventory_detail`
--

LOCK TABLES `inventory_detail` WRITE;
/*!40000 ALTER TABLE `inventory_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `inventory_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invest_asset`
--

DROP TABLE IF EXISTS `invest_asset`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invest_asset` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `activity` int(4) DEFAULT NULL COMMENT 'Identificador de la Actividad',
  `description` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion del Bien',
  `type` tinyint(2) NOT NULL COMMENT 'Tipo de Bien',
  `regime` tinyint(2) NOT NULL COMMENT 'Regimen',
  `start_date` date DEFAULT NULL COMMENT 'Fecha de alta',
  `end_date` date DEFAULT NULL COMMENT 'Fecha de baja',
  `vat_percent` double DEFAULT '0' COMMENT 'Porcentaje de afectacion de IVA',
  `retention_percent` double DEFAULT '0' COMMENT 'Porcentaje de afectacion de imposicion directa',
  PRIMARY KEY (`id`),
  KEY `IDX_INVEST_ASSET_DOMAIN` (`domain`),
  KEY `IDX_INVEST_ASSET_ACTIVITY` (`activity`),
  CONSTRAINT `FK_INVEST_ASSET_ACTIVITY` FOREIGN KEY (`activity`) REFERENCES `enterprise_activity` (`id`),
  CONSTRAINT `FK_INVEST_ASSET_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Bienes afectos o de inversion';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invest_asset`
--

LOCK TABLES `invest_asset` WRITE;
/*!40000 ALTER TABLE `invest_asset` DISABLE KEYS */;
/*!40000 ALTER TABLE `invest_asset` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invoice`
--

DROP TABLE IF EXISTS `invoice`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invoice` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la Factura',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `activity` int(4) DEFAULT NULL COMMENT 'Identificador de la Actividad',
  `invest_asset` int(4) DEFAULT NULL COMMENT 'Identificador del Bien afecto',
  `project` int(4) DEFAULT NULL COMMENT 'Identificador del Proyecto',
  `series` char(5) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Serie de la Factura',
  `number` int(4) NOT NULL DEFAULT '0' COMMENT 'Numero de la Factura',
  `reference_code` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo de referencia de la Factura',
  `registry` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador del Cliente o Proveedor',
  `rdocument` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de Documento del Cliente o Proveedor',
  `rdocument_type` tinyint(2) DEFAULT '0' COMMENT 'Tipo de documento (NIF, CIF...)',
  `rdocument_country` varchar(2) COLLATE latin1_spanish_ci DEFAULT 'ES' COMMENT 'Pais del documento',
  `rname` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre completo del Cliente o Proveedor',
  `raddress` int(4) DEFAULT NULL COMMENT 'Identificador de la Direccion de envio de la Factura',
  `issue_date` date DEFAULT NULL COMMENT 'Fecha de emision de la Factura',
  `tax_date` date DEFAULT NULL COMMENT 'Fecha de Impuestos de la Factura',
  `security_level` tinyint(2) DEFAULT '0' COMMENT 'Nivel de seguridad de la Factura',
  `status` tinyint(2) DEFAULT '0' COMMENT 'Estado de la Factura',
  `type` tinyint(2) DEFAULT '0' COMMENT 'Tipo de Factura (Compra o Venta)',
  `surcharge` tinyint(1) DEFAULT '0' COMMENT 'Indica si la Factura tiene recargo de equivalencia',
  `withholding` tinyint(1) DEFAULT '0' COMMENT 'Indica si la Factura aplica retencion de impuestos',
  `withholding_farmer` tinyint(1) DEFAULT '0' COMMENT 'Indica si la Factura aplica retencion de Regimen Especial de Agricultura y Pesca',
  `vat_accrual_payment` tinyint(1) DEFAULT '0' COMMENT 'Indica si la Factura se incluye en el Regimen Especial de Criterio de Caja',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios de la Factura',
  `remarks` text COLLATE latin1_spanish_ci COMMENT 'Observaciones de la Factura',
  `investment` tinyint(1) DEFAULT '0' COMMENT 'Indica si la Factura es una inversion',
  `transaction` tinyint(2) DEFAULT '0' COMMENT 'Tipo de transaccion',
  `signed` tinyint(1) DEFAULT '0' COMMENT 'Indica si la Factura esta firmada electronicamente',
  `scope` int(4) NOT NULL DEFAULT '1' COMMENT 'Ambito de la Factura',
  `service` tinyint(1) DEFAULT '0' COMMENT 'Indica si es una Factura de servicios',
  `rectification_type` tinyint(2) DEFAULT '0' COMMENT 'Tipo de rectificacion (Normal o Especial)',
  `rectification_invoice` int(4) DEFAULT NULL COMMENT 'Relacion de rectificacion de Facturas',
  `advance` tinyint(1) DEFAULT '0' COMMENT 'Indica si la Factura es un anticipo',
  `pos_shift` int(4) DEFAULT NULL COMMENT 'Identificador del Turno de trabajo',
  `seller` int(4) DEFAULT NULL COMMENT 'Identificador de Agente Comercial',
  `taxable_base` double DEFAULT '0' COMMENT 'Base Imponible de la Factura',
  `vat_quota` double DEFAULT '0' COMMENT 'Cuota de IVA de la Factura',
  `retention_quota` double DEFAULT '0' COMMENT 'Cuota de IRPF de la Factura',
  `total` double DEFAULT '0' COMMENT 'Total Factura',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  UNIQUE KEY `IDX_UNQ_INVOICE_DOMAIN_SERIES_NUMBER_TYPE` (`domain`,`series`,`number`,`type`),
  KEY `IDX_INVOICE_SCOPE` (`scope`),
  KEY `IDX_INVOICE_INVOICE` (`rectification_invoice`),
  KEY `IDX_INVOICE_PROJECT` (`project`),
  KEY `IDX_INVOICE_ISSUE_DATE` (`issue_date`),
  KEY `IDX_INVOICE_TAX_DATE` (`tax_date`),
  KEY `IDX_INVOICE_REGISTRY` (`registry`),
  KEY `IDX_INVOICE_RADDRESS` (`raddress`),
  KEY `IDX_INVOICE_DOMAIN` (`domain`),
  KEY `IDX_INVOICE_SELLER` (`seller`),
  KEY `IDX_INVOICE_POS_SHIFT` (`pos_shift`),
  KEY `IDX_INVOICE_REFERENCE_CODE` (`reference_code`),
  KEY `IDX_INVOICE_ACTIVITY` (`activity`),
  KEY `IDX_INVOICE_INVEST_ASSET` (`invest_asset`),
  CONSTRAINT `FK_INVOICE_ACTIVITY` FOREIGN KEY (`activity`) REFERENCES `enterprise_activity` (`id`),
  CONSTRAINT `FK_INVOICE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_INVOICE_INVEST_ASSET` FOREIGN KEY (`invest_asset`) REFERENCES `invest_asset` (`id`),
  CONSTRAINT `FK_INVOICE_INVOICE` FOREIGN KEY (`rectification_invoice`) REFERENCES `invoice` (`id`),
  CONSTRAINT `FK_INVOICE_POS_SHIFT` FOREIGN KEY (`pos_shift`) REFERENCES `pos_shift` (`id`),
  CONSTRAINT `FK_INVOICE_PROJECT` FOREIGN KEY (`project`) REFERENCES `project` (`id`),
  CONSTRAINT `FK_INVOICE_RADDRESS` FOREIGN KEY (`raddress`) REFERENCES `raddress` (`id`),
  CONSTRAINT `FK_INVOICE_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`),
  CONSTRAINT `FK_INVOICE_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`),
  CONSTRAINT `FK_INVOICE_SELLER` FOREIGN KEY (`seller`) REFERENCES `seller` (`registry`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Facturas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invoice`
--

LOCK TABLES `invoice` WRITE;
/*!40000 ALTER TABLE `invoice` DISABLE KEYS */;
/*!40000 ALTER TABLE `invoice` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invoice_address`
--

DROP TABLE IF EXISTS `invoice_address`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invoice_address` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `invoice` int(4) NOT NULL COMMENT 'Identificador de la Factura',
  `street_type` varchar(2) COLLATE latin1_spanish_ci DEFAULT 'CL' COMMENT 'Tipo de via',
  `address` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Primera parte de la Direccion',
  `number` varchar(12) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero',
  `address2` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Segunda parte de la Direccion',
  `zip` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo Postal',
  `city` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Localidad',
  `province` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Provincia',
  `geozone` int(4) DEFAULT NULL COMMENT 'Identificador de la Zona Geografica',
  PRIMARY KEY (`id`),
  KEY `IDX_INVOICE_ADDRESS_INVOICE` (`invoice`),
  KEY `IDX_INVOICE_ADDRESS_GEOZONE` (`geozone`),
  KEY `IDX_INVOICE_ADDRESS_DOMAIN` (`domain`),
  CONSTRAINT `FK_INVOICE_ADDRESS_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_INVOICE_ADDRESS_GEOZONE` FOREIGN KEY (`geozone`) REFERENCES `geozone` (`id`),
  CONSTRAINT `FK_INVOICE_ADDRESS_INVOICE` FOREIGN KEY (`invoice`) REFERENCES `invoice` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Direcciones de la Factura';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invoice_address`
--

LOCK TABLES `invoice_address` WRITE;
/*!40000 ALTER TABLE `invoice_address` DISABLE KEYS */;
/*!40000 ALTER TABLE `invoice_address` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invoice_attach`
--

DROP TABLE IF EXISTS `invoice_attach`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invoice_attach` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `invoice` int(4) NOT NULL COMMENT 'Identificador de la Factura',
  `mimeType` tinyint(2) DEFAULT '0' COMMENT 'Mime Type del Archivo Adjunto',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion del Archivo Adjunto',
  `data` mediumblob COMMENT 'Archivo Adjunto en binario',
  `type` tinyint(2) DEFAULT '0' COMMENT 'Tipo de Archivo Adjunto',
  `attach_date` date DEFAULT NULL COMMENT 'Fecha del Archivo Adjunto',
  `driveId` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `IDX_INVOICE_ATTACH_INVOICE` (`invoice`),
  KEY `IDX_INVOICE_ATTACH_DOMAIN` (`domain`),
  CONSTRAINT `FK_INVOICE_ATTACH_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_INVOICE_ATTACH_INVOICE` FOREIGN KEY (`invoice`) REFERENCES `invoice` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Archivos Adjuntos de Facturas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invoice_attach`
--

LOCK TABLES `invoice_attach` WRITE;
/*!40000 ALTER TABLE `invoice_attach` DISABLE KEYS */;
/*!40000 ALTER TABLE `invoice_attach` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invoice_detail`
--

DROP TABLE IF EXISTS `invoice_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invoice_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Detalle de la Factura',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `invoice` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador de la Factura',
  `invest_asset` int(4) DEFAULT NULL COMMENT 'Identificador del Bien afecto',
  `project` int(4) DEFAULT NULL COMMENT 'Identificador del Proyecto',
  `line` smallint(2) DEFAULT '1' COMMENT 'Numero de linea del Detalle dentro de la Factura',
  `item` int(4) DEFAULT NULL COMMENT 'Identificador del Articulo del Detalle de Factura',
  `description` varchar(1024) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion del Detalle de Factura',
  `quantity` double(15,3) DEFAULT '0.000' COMMENT 'Cantidad del Detalle de Factura',
  `price` double DEFAULT '0' COMMENT 'Precio del Detalle de Factura',
  `discount_expr` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descuentos del Detalle de Factura',
  `source` tinyint(2) DEFAULT '0' COMMENT 'Origen del Detalle de la Factura',
  `source_id` int(4) DEFAULT NULL COMMENT 'Identificador del Origen del Detalle de la Factura',
  `taxable_base` double(15,4) DEFAULT '0.0000' COMMENT 'Base Imponible del Detalle de Factura',
  `taxes` double(15,3) DEFAULT '0.000' COMMENT 'Tasas del Detalle de Factura',
  `prepayment` tinyint(1) DEFAULT '0' COMMENT 'Indica si el Detalle de Factura es un Suplido',
  `seller` int(4) DEFAULT NULL COMMENT 'Identificador de Agente Comercial',
  `workplace` int(4) NOT NULL COMMENT 'Identificador del Centro de Trabajo',
  `warehouse` int(4) DEFAULT NULL COMMENT 'Identificador del Almacen',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_INVOICE_DETAIL_PROJECT` (`project`),
  KEY `IDX_INVOICE_DETAIL_WAREHOUSE` (`warehouse`),
  KEY `IDX_INVOICE_DETAIL_SOURCE_ID` (`source_id`),
  KEY `IDX_INVOICE_DETAIL_INVOICE` (`invoice`),
  KEY `IDX_INVOICE_DETAIL_ITEM` (`item`),
  KEY `IDX_INVOICE_DETAIL_WORKPLACE` (`workplace`),
  KEY `IDX_INVOICE_DETAIL_DOMAIN` (`domain`),
  KEY `IDX_INVOICE_DETAIL_SELLER` (`seller`),
  KEY `IDX_INVOICE_DETAIL_INVEST_ASSET` (`invest_asset`),
  CONSTRAINT `FK_INVOICE_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_INVOICE_DETAIL_INVEST_ASSET` FOREIGN KEY (`invest_asset`) REFERENCES `invest_asset` (`id`),
  CONSTRAINT `FK_INVOICE_DETAIL_INVOICE` FOREIGN KEY (`invoice`) REFERENCES `invoice` (`id`),
  CONSTRAINT `FK_INVOICE_DETAIL_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`),
  CONSTRAINT `FK_INVOICE_DETAIL_PROJECT` FOREIGN KEY (`project`) REFERENCES `project` (`id`),
  CONSTRAINT `FK_INVOICE_DETAIL_SELLER` FOREIGN KEY (`seller`) REFERENCES `seller` (`registry`),
  CONSTRAINT `FK_INVOICE_DETAIL_WAREHOUSE` FOREIGN KEY (`warehouse`) REFERENCES `warehouse` (`id`),
  CONSTRAINT `FK_INVOICE_DETAIL_WORKPLACE` FOREIGN KEY (`workplace`) REFERENCES `workplace` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalles de la Factura';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invoice_detail`
--

LOCK TABLES `invoice_detail` WRITE;
/*!40000 ALTER TABLE `invoice_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `invoice_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invoice_detail_account`
--

DROP TABLE IF EXISTS `invoice_detail_account`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invoice_detail_account` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `invoice_detail` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador de la Linea de Factura',
  `account` int(4) NOT NULL COMMENT 'Identificador de la Cuenta Contable',
  PRIMARY KEY (`id`),
  KEY `IDX_INVOICE_DETAIL_ACCOUNT_ACCOUNT` (`account`),
  KEY `IDX_INVOICE_DETAIL_ACCOUNT_INVOICE_DETAIL` (`invoice_detail`),
  KEY `IDX_INVOICE_DETAIL_ACCOUNT_DOMAIN` (`domain`),
  CONSTRAINT `FK_INVOICE_DETAIL_ACCOUNT_ACCOUNT` FOREIGN KEY (`account`) REFERENCES `account` (`id`),
  CONSTRAINT `FK_INVOICE_DETAIL_ACCOUNT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_INVOICE_DETAIL_ACCOUNT_INVOICE_DETAIL` FOREIGN KEY (`invoice_detail`) REFERENCES `invoice_detail` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Cuentas Contables asociadas a Lineas de Facturas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invoice_detail_account`
--

LOCK TABLES `invoice_detail_account` WRITE;
/*!40000 ALTER TABLE `invoice_detail_account` DISABLE KEYS */;
/*!40000 ALTER TABLE `invoice_detail_account` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invoice_tax`
--

DROP TABLE IF EXISTS `invoice_tax`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invoice_tax` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Impuesto de la Factura',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `invoice_detail` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador del Detalle de la Factura',
  `tax_type` tinyint(2) DEFAULT '0' COMMENT 'Tipo de Impuesto del Detalle de la Factura',
  `base` double(15,4) DEFAULT '0.0000' COMMENT 'Base Imponible de Impuesto del Detalle de la Factura',
  `percentage` double(15,3) DEFAULT '0.000' COMMENT 'Porcentaje de Impuesto del Detalle de la Factura',
  `surcharge` double(15,3) DEFAULT '0.000' COMMENT 'Porcentaje del recargo de equivalencia del Detalle de la Factura',
  `quota` double DEFAULT '0' COMMENT 'Cuota de Impuesto del Detalle de la Factura',
  `surcharge_quota` double DEFAULT '0' COMMENT 'Cuota de recargo de equivalencia del Detalle de la Factura',
  `vat_deduction_type` tinyint(2) DEFAULT '0' COMMENT 'Tipo de deduccion del IVA',
  `withholding_type` tinyint(2) DEFAULT '0' COMMENT 'Tipo de retencion',
  `deductible_percent` double DEFAULT '0' COMMENT 'Porcentaje de deducibilidad',
  `deductible_quota` double DEFAULT '0' COMMENT 'Cuota deducible',
  PRIMARY KEY (`id`),
  KEY `IDX_INVOICE_TAX_INVOICE_DETAIL` (`invoice_detail`),
  KEY `IDX_INVOICE_TAX_DOMAIN` (`domain`),
  CONSTRAINT `FK_INVOICE_TAX_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_INVOICE_TAX_INVOICE_DETAIL` FOREIGN KEY (`invoice_detail`) REFERENCES `invoice_detail` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Impuestos del Detalle de la Factura';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invoice_tax`
--

LOCK TABLES `invoice_tax` WRITE;
/*!40000 ALTER TABLE `invoice_tax` DISABLE KEYS */;
/*!40000 ALTER TABLE `invoice_tax` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invoice_tax_account`
--

DROP TABLE IF EXISTS `invoice_tax_account`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invoice_tax_account` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `invoice_tax` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador de la Linea de Impuesto',
  `account` int(4) NOT NULL COMMENT 'Identificador de la Cuenta Contable',
  PRIMARY KEY (`id`),
  KEY `IDX_INVOICE_TAX_ACCOUNT_ACCOUNT` (`account`),
  KEY `IDX_INVOICE_TAX_ACCOUNT_INVOICE_TAX` (`invoice_tax`),
  KEY `IDX_INVOICE_TAX_ACCOUNT_DOMAIN` (`domain`),
  CONSTRAINT `FK_INVOICE_TAX_ACCOUNT_ACCOUNT` FOREIGN KEY (`account`) REFERENCES `account` (`id`),
  CONSTRAINT `FK_INVOICE_TAX_ACCOUNT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_INVOICE_TAX_ACCOUNT_INVOICE_TAX` FOREIGN KEY (`invoice_tax`) REFERENCES `invoice_tax` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Cuentas Contables asociadas a Impuestos de Facturas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invoice_tax_account`
--

LOCK TABLES `invoice_tax_account` WRITE;
/*!40000 ALTER TABLE `invoice_tax_account` DISABLE KEYS */;
/*!40000 ALTER TABLE `invoice_tax_account` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `invoicing_group`
--

DROP TABLE IF EXISTS `invoicing_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `invoicing_group` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `customer` int(4) NOT NULL COMMENT 'Identificador del Cliente',
  `description` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion del Grupo de Facturacion',
  `customer_grouped` tinyint(1) DEFAULT '1' COMMENT 'Indica si el Grupo de Facturacion agrupa los Clientes en una sola Factura',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_INVOICING_GROUP_DOMAIN` (`domain`),
  KEY `IDX_INVOICING_GROUP_CUSTOMER` (`customer`),
  CONSTRAINT `FK_INVOICING_GROUP_CUSTOMER` FOREIGN KEY (`customer`) REFERENCES `customer` (`registry`),
  CONSTRAINT `FK_INVOICING_GROUP_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Grupos de Facturacion';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `invoicing_group`
--

LOCK TABLES `invoicing_group` WRITE;
/*!40000 ALTER TABLE `invoicing_group` DISABLE KEYS */;
/*!40000 ALTER TABLE `invoicing_group` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `irpf_data`
--

DROP TABLE IF EXISTS `irpf_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `irpf_data` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `contract` int(4) NOT NULL COMMENT 'Identificador del contrato',
  `family_situation` tinyint(2) DEFAULT '0' COMMENT 'Situacion familiar',
  `spouse_document` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de Documento del conyuge',
  `disability_level` tinyint(2) DEFAULT '0' COMMENT 'Grado de discapacidad',
  `dependence` tinyint(1) DEFAULT '0' COMMENT 'Dependencia de terceras personas',
  `moving_date` date DEFAULT NULL COMMENT 'Fecha de movilidad geografica',
  `labour_prolongation` tinyint(1) DEFAULT '0' COMMENT 'Prolongacion de la actividad laboral',
  `descendient_count` tinyint(2) DEFAULT NULL COMMENT 'Numero de hijos',
  `start_date` date DEFAULT NULL COMMENT 'Fecha inicio del modelo',
  `end_date` date DEFAULT NULL COMMENT 'Fecha fin del modelo',
  `fiscal_exclusion` tinyint(1) DEFAULT '0' COMMENT 'Exclusion a la obligacion de tributar',
  `issue_date` date NOT NULL COMMENT 'Fecha de emisión',
  `annual_remuneration` double(15,3) DEFAULT NULL COMMENT 'Retribuciones totales (dinerarias y en especie). Importe íntegro',
  `irregular_18_2_reduction` double(15,3) DEFAULT NULL COMMENT 'Reducciones por irregularidad ( Atr. 18.2 LIRPF)',
  `irregular_18_3_reduction` double(15,3) DEFAULT NULL COMMENT 'Reducciones por irregularidad ( Atr. 18.3: Disposiciones transitorias 11ª y 12 ª de la LIRPF)',
  `deduccibles_expenses` double(15,3) DEFAULT NULL COMMENT 'Gastos deducibles ( Atr 19.2, letras a, b y c de la LINRPF: Seguridad Social, Mutualidades ...)',
  `spousal_support` double(15,3) DEFAULT NULL COMMENT 'Pension compensatoria a favor del cónyuge. Importe fijado judicialmente',
  `food_annuity` double(15,3) DEFAULT NULL COMMENT 'Anualidades por alimentos en favor de los hijos. Importe fijado judicialmente',
  `deduct_home_loan` tinyint(2) DEFAULT NULL COMMENT 'Comunicación de pagos por la adquisión o rehabilitación de la vivienda habitual utilizando financiación ajena',
  `request_irpf` double(15,2) DEFAULT NULL COMMENT 'Tipo de retención solicitado',
  `contract_type` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Contrato o relación',
  `ceuta_melilla` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Los datos anteriores corresponden a rendimientos obtenidos en Ceuta o Melilla',
  PRIMARY KEY (`id`),
  KEY `IDX_IRPF_DATA_CONTRACT` (`contract`),
  KEY `IDX_IRPF_DATA_DOMAIN` (`domain`),
  CONSTRAINT `FK_IRPF_DATA_CONTRACT` FOREIGN KEY (`contract`) REFERENCES `contract` (`id`),
  CONSTRAINT `FK_IRPF_DATA_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Dator de irpf';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `irpf_data`
--

LOCK TABLES `irpf_data` WRITE;
/*!40000 ALTER TABLE `irpf_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `irpf_data` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `irpf_data_ascendants`
--

DROP TABLE IF EXISTS `irpf_data_ascendants`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `irpf_data_ascendants` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `irpf_data` int(4) NOT NULL COMMENT 'Identificador del irpf',
  `birth_year` int(4) DEFAULT NULL COMMENT 'Anio de nacimiento',
  `disability_level` tinyint(2) DEFAULT '0' COMMENT 'Grado de discapacidad',
  `dependence` tinyint(1) DEFAULT '0' COMMENT 'Dependencia de terceras personas',
  `another_descendient` tinyint(2) DEFAULT '0' COMMENT 'Convivencia con otros descendientes',
  PRIMARY KEY (`id`),
  KEY `IDX_IRPF_DATA_ASCENDANTS_IRPF_DATA` (`irpf_data`),
  KEY `IDX_IRPF_DATA_ASCENDANTS_DOMAIN` (`domain`),
  CONSTRAINT `FK_IRPF_DATA_ASCENDANTS_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_IRPF_DATA_ASCENDANTS_IRPF_DATA` FOREIGN KEY (`irpf_data`) REFERENCES `irpf_data` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Ascendientes del modelo 145';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `irpf_data_ascendants`
--

LOCK TABLES `irpf_data_ascendants` WRITE;
/*!40000 ALTER TABLE `irpf_data_ascendants` DISABLE KEYS */;
/*!40000 ALTER TABLE `irpf_data_ascendants` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `irpf_data_descendients`
--

DROP TABLE IF EXISTS `irpf_data_descendients`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `irpf_data_descendients` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `irpf_data` int(4) NOT NULL COMMENT 'Identificador del irpf',
  `birth_year` int(4) DEFAULT NULL COMMENT 'Anio de nacimiento',
  `adoption_year` int(4) DEFAULT NULL COMMENT 'Anio de adopcion',
  `disability_level` tinyint(2) DEFAULT '0' COMMENT 'Grado de discapacidad',
  `dependence` tinyint(1) DEFAULT '0' COMMENT 'Dependencia de terceras personas',
  `unique_parent` tinyint(1) DEFAULT '0' COMMENT 'Computo por entero de hijos o descendientes',
  PRIMARY KEY (`id`),
  KEY `IDX_IRPF_DATA_DESCENDIENTS_IRPF_DATA` (`irpf_data`),
  KEY `IDX_IRPF_DATA_DESCENDIENTS_DOMAIN` (`domain`),
  CONSTRAINT `FK_IRPF_DATA_DESCENDIENTS_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_IRPF_DATA_DESCENDIENTS_IRPF_DATA` FOREIGN KEY (`irpf_data`) REFERENCES `irpf_data` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Descendientes del modelo 145';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `irpf_data_descendients`
--

LOCK TABLES `irpf_data_descendients` WRITE;
/*!40000 ALTER TABLE `irpf_data_descendients` DISABLE KEYS */;
/*!40000 ALTER TABLE `irpf_data_descendients` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `irpf_regularization`
--

DROP TABLE IF EXISTS `irpf_regularization`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `irpf_regularization` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `contract` int(4) NOT NULL COMMENT 'Identificador del contrato',
  `reason` tinyint(2) DEFAULT NULL COMMENT 'Causa de regularización',
  `effective_date` date NOT NULL COMMENT 'Fecha de entrada en vigor',
  `paid_irpf` double(15,3) DEFAULT NULL COMMENT 'Retenciones practicadas con anterioridad a la regularización.',
  `paid_remuneration` double(15,3) DEFAULT NULL COMMENT 'Retribuciones ya satisfechas con anterioridad a la regularización.',
  `prior_annual_irpf` double(15,3) DEFAULT NULL COMMENT 'Retenciones anuales anteriores a la regularización.',
  `prior_annual_remuneration` double(15,3) DEFAULT NULL COMMENT 'Retribucines anulaes consideradas con anterioridad a la regularización.',
  `prior_base_irpf` double(15,3) DEFAULT NULL COMMENT 'Base para calcular el tipo de retención determinado antes de la regularización.',
  `prior_irpf` double(15,2) DEFAULT NULL COMMENT 'Tipo de retención aplicado antes de la regularización.',
  `prior_in_ceuta_melilla` tinyint(1) DEFAULT NULL COMMENT 'Los rendimientos anteriores a la regularización fueron obtenidos en Ceuta o Melilla',
  `prior_minimun_personal_family` double(15,3) DEFAULT NULL COMMENT 'Mínimo personal y familiar para calcular el tipo de retención determinado antes de la regularización.',
  `prior_deduct_home_loan` tinyint(2) DEFAULT NULL COMMENT 'En algún momento antes de la regularización se aplico la minoración por pagos por la adquisión o rehabilitación de la vivienda',
  `prior_deduct_home_loan_amount` double(15,3) DEFAULT NULL COMMENT 'Importe de la minoración por pagos por la adquisión o rehabilitación de la vivienda antes de la regularización',
  PRIMARY KEY (`id`),
  KEY `IDX_IRPF_REGULARIZATION_CONTRACT` (`contract`),
  KEY `IDX_IRPF_REGULARIZATION_DOMAIN` (`domain`),
  CONSTRAINT `FK_IRPF_REGULARIZATION_CONTRACT` FOREIGN KEY (`contract`) REFERENCES `contract` (`id`),
  CONSTRAINT `FK_IRPF_REGULARIZATION_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Datos regularizacion IRPF';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `irpf_regularization`
--

LOCK TABLES `irpf_regularization` WRITE;
/*!40000 ALTER TABLE `irpf_regularization` DISABLE KEYS */;
/*!40000 ALTER TABLE `irpf_regularization` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `irpf_result`
--

DROP TABLE IF EXISTS `irpf_result`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `irpf_result` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `contract` int(4) NOT NULL COMMENT 'Identificador del contrato',
  `effective_date` date NOT NULL COMMENT 'Fecha de entrada en vigor',
  `base_irpf` double(15,3) DEFAULT NULL COMMENT 'Base para calcular el tipo de retención',
  `minimun_personal_family` double(15,3) DEFAULT NULL COMMENT 'Mínimo personal y familiar para calcular el tipo de retención',
  `deduct_home_loan_amount` double(15,3) DEFAULT NULL COMMENT 'Minoración por pagos de préstamo para vivienda habitual',
  `deduct_80_bis` double(15,3) DEFAULT NULL COMMENT 'Deduccion Arttículo 80 bis LIRPF',
  `irpf` double(15,2) DEFAULT NULL COMMENT 'Tipo retención apliclabe ',
  `annual_irpf` double(15,3) DEFAULT NULL COMMENT 'Importe anual de las retenciones e ingresos a cuenta',
  `annual_remuneration` double(15,3) DEFAULT NULL COMMENT 'Retribuciones anuales. Importe íntegro',
  `irregular_18_2_reduction` double(15,3) DEFAULT NULL COMMENT 'Reducciones por irregularidad ( Art. 18.2 LIRPF). Importe',
  `irregular_18_3_reduction` double(15,3) DEFAULT NULL COMMENT 'Reducciones por irregularidad ( Art. 18.3: DD.TT 11ª y 12 ª de la LIRPF). Importe',
  `deduccibles_expenses` double(15,3) DEFAULT NULL COMMENT 'Gastos deducibles. Importe anual',
  `work_remuneration_reduction` double(15,3) DEFAULT NULL COMMENT 'Reducciones por rendimiento del trabajo ',
  `work_prolongation_reduction` double(15,3) DEFAULT NULL COMMENT 'Reducciones por prolongación de la actividad ',
  `work_moving_reduction` double(15,3) DEFAULT NULL COMMENT 'Reducciones por movilidad geografica ',
  `work_disability_reduction` double(15,3) DEFAULT NULL COMMENT 'Reducciones por discapacidad ',
  `social_security_pensioner` double(15,3) DEFAULT NULL COMMENT 'Por ser pensionista de la s. social/cl. Pasivas o desempleado',
  `two_or_more_descendents_min` double(15,3) DEFAULT NULL COMMENT 'Por tener más de dos descendientes con derecho a mínimo',
  `spousal_support` double(15,3) DEFAULT NULL COMMENT 'Pension compensatoria a favor del cónyuge. Importe anual',
  `food_annuity` double(15,3) DEFAULT NULL COMMENT 'Anualidades por alimentos en favor de los hijos. Importe anual',
  `minimun_personal` double(15,3) DEFAULT NULL COMMENT 'Mínimo personal',
  `minimun_ascendents` double(15,3) DEFAULT NULL COMMENT 'Mínimo por descendientes',
  `minimun_descendents` double(15,3) DEFAULT NULL COMMENT 'Mínimo por descendientes',
  `minimun_disability` double(15,3) DEFAULT NULL COMMENT 'Mínimo por discapacidad',
  `descendents_minor_3_total` tinyint(2) DEFAULT NULL COMMENT 'Descendientes computados menores de tres años. Total',
  `descendents_minor_3_entirely` tinyint(2) DEFAULT NULL COMMENT 'Descendientes computados menores de tres años. Por entero',
  `descendents_remainder_total` tinyint(2) DEFAULT NULL COMMENT 'Resto de descendientes computados . Total',
  `descendents_remainder_entirely` tinyint(2) DEFAULT NULL COMMENT 'Resto de descendientes computados . Por entero',
  `descendents_33_65_total` tinyint(2) DEFAULT NULL COMMENT 'Descendientes con discapacidad >= 33% y < 65%. Total',
  `descendents_33_65_entirely` tinyint(2) DEFAULT NULL COMMENT 'Descendientes con discapacidad >= 33% y < 65%. Por entero',
  `descendents_moving_total` tinyint(2) DEFAULT NULL COMMENT 'Descendientes con discapacidad, movilidad reducida. Total',
  `descendents_moving_entirely` tinyint(2) DEFAULT NULL COMMENT 'Descendientes con discapacidad, movilidad reducida. Por entero',
  `descendents_65_total` tinyint(2) DEFAULT NULL COMMENT 'Descendientes con discapacidad > 65%. Total',
  `descendents_65_entirely` tinyint(2) DEFAULT NULL COMMENT 'Descendientes con discapacidad > 65%. Por entero',
  `descendents_first` tinyint(2) DEFAULT NULL COMMENT 'Detalle del cómputo de descendientes. Hijo 1º',
  `descendents_second` tinyint(2) DEFAULT NULL COMMENT 'Detalle del cómputo de descendientes. Hijo 2º',
  `descendents_third` tinyint(2) DEFAULT NULL COMMENT 'Detalle del cómputo de descendientes. Hijo 3º',
  `descendents_fourth_subsequent_total` tinyint(2) DEFAULT NULL COMMENT 'Detalle del cómputo de descendientes. Hijo 4º y sucesivos. Total',
  `descendents_fourth_subsequent_entirely` tinyint(2) DEFAULT NULL COMMENT 'Detalle del cómputo de descendientes. Hijo 4º y sucesivos. Por entero',
  `ascendents_minor_75_total` tinyint(2) DEFAULT NULL COMMENT 'Ascendientes computados menores de 75 años. Total',
  `ascendents_minor_75_entirely` tinyint(2) DEFAULT NULL COMMENT 'Ascendientes computados menores de 75 años. Por entero',
  `ascendents_mayor_75_total` tinyint(2) DEFAULT NULL COMMENT 'Ascendientes computados mayores de 75 años. Total',
  `ascendents_mayor_75_entirely` tinyint(2) DEFAULT NULL COMMENT 'Ascendientes computados mayores de 75 años. Por entero',
  `ascendents_33_65_total` tinyint(2) DEFAULT NULL COMMENT 'Ascendientes con discapacidad >= 33% y < 65%. Total',
  `ascendents_33_65_entirely` tinyint(2) DEFAULT NULL COMMENT 'Ascendientes con discapacidad >= 33% y < 65%. Por entero',
  `ascendents_moving_total` tinyint(2) DEFAULT NULL COMMENT 'Ascendientes con discapacidad, movilidad reducida. Total',
  `ascendents_moving_entirely` tinyint(2) DEFAULT NULL COMMENT 'Ascendientes con discapacidad, movilidad reducida. Por entero',
  `ascendents_65_total` tinyint(2) DEFAULT NULL COMMENT 'Ascendientes con discapacidad > 65%. Total',
  `ascendents_65_entirely` tinyint(2) DEFAULT NULL COMMENT 'Ascendientes con discapacidad > 65%. Por entero',
  PRIMARY KEY (`id`),
  KEY `IDX_IRPF_RESULT_CONTRACT` (`contract`),
  KEY `IDX_IRPF_RESULT_DOMAIN` (`domain`),
  CONSTRAINT `FK_IRPF_RESULT_CONTRACT` FOREIGN KEY (`contract`) REFERENCES `contract` (`id`),
  CONSTRAINT `FK_IRPF_RESULT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Resultados IRPF';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `irpf_result`
--

LOCK TABLES `irpf_result` WRITE;
/*!40000 ALTER TABLE `irpf_result` DISABLE KEYS */;
/*!40000 ALTER TABLE `irpf_result` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `item`
--

DROP TABLE IF EXISTS `item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `item` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Articulo',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `product` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador del Producto',
  `detail` varchar(15) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Detalle del Articulo',
  `detail2` varchar(15) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Detalle 2 del Articulo',
  `detail3` varchar(15) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Detalle 3 del Articulo',
  `description` text COLLATE latin1_spanish_ci COMMENT 'Descripcion del Articulo',
  `serial_number` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de serie',
  `serial_date` date DEFAULT NULL COMMENT 'Fecha de serializacion',
  `price` double DEFAULT '0' COMMENT 'Precio del Articulo',
  `status` tinyint(2) DEFAULT '0' COMMENT 'Estado del Articulo',
  `expenses_percent` double DEFAULT '0' COMMENT 'Gastos porcentuales del Articulo',
  `expenses_fixed` double DEFAULT '0' COMMENT 'Gastos fijos del Articulo',
  `profit_percent` double DEFAULT '0' COMMENT 'Porcentaje de beneficio del Articulo',
  `purchase_price` double DEFAULT '0' COMMENT 'Precio de compra del Articulo',
  `internet` tinyint(1) DEFAULT '0' COMMENT 'Visible en internet',
  `barcode` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo de barras del Articulo',
  `pack_format_tag` int(4) DEFAULT NULL COMMENT 'Identificador de la Etiqueta de formato',
  `pack_units` int(4) DEFAULT '0' COMMENT 'Numero de unidades por formato',
  `pack_units_tag` int(4) DEFAULT NULL COMMENT 'Identificador de la Etiqueta de unidad de envase',
  `pack_measurement` double DEFAULT '0' COMMENT 'Medida envasada',
  `pack_measurement_tag` int(4) DEFAULT NULL COMMENT 'Identificador de la Etiqueta de unidad de medida',
  `stock_unit_tag` int(4) DEFAULT NULL COMMENT 'Identificador de la Etiqueta de unidad de Stock',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  UNIQUE KEY `IDX_ITEM_DOMAIN_BARCODE` (`domain`,`barcode`),
  KEY `IDX_ITEM_PRODUCT` (`product`),
  KEY `IDX_ITEM_DOMAIN` (`domain`),
  KEY `IDX_ITEM_TAG_PACK_FORMAT` (`pack_format_tag`),
  KEY `IDX_ITEM_TAG_PACK_UNITS` (`pack_units_tag`),
  KEY `IDX_ITEM_TAG_PACK_MEASUREMENT` (`pack_measurement_tag`),
  KEY `IDX_ITEM_TAG_STOCK_UNIT` (`stock_unit_tag`),
  CONSTRAINT `FK_ITEM_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_ITEM_PRODUCT` FOREIGN KEY (`product`) REFERENCES `product` (`id`),
  CONSTRAINT `FK_ITEM_TAG_PACK_FORMAT` FOREIGN KEY (`pack_format_tag`) REFERENCES `tag` (`id`),
  CONSTRAINT `FK_ITEM_TAG_PACK_MEASUREMENT` FOREIGN KEY (`pack_measurement_tag`) REFERENCES `tag` (`id`),
  CONSTRAINT `FK_ITEM_TAG_PACK_UNITS` FOREIGN KEY (`pack_units_tag`) REFERENCES `tag` (`id`),
  CONSTRAINT `FK_ITEM_TAG_STOCK_UNIT` FOREIGN KEY (`stock_unit_tag`) REFERENCES `tag` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Articulos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `item`
--

LOCK TABLES `item` WRITE;
/*!40000 ALTER TABLE `item` DISABLE KEYS */;
/*!40000 ALTER TABLE `item` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `item_addinfo`
--

DROP TABLE IF EXISTS `item_addinfo`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `item_addinfo` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `product` int(4) NOT NULL COMMENT 'Identificador del Producto',
  `item` int(4) NOT NULL COMMENT 'Identificador de Articulo',
  `attribute` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Atributo adicional',
  `value` varchar(128) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Valor del atributo adicional',
  `value_date` date NOT NULL COMMENT 'Fecha del valor del atributo',
  PRIMARY KEY (`id`),
  KEY `IDX_ITEM_ADDINFO_DOMAIN` (`domain`),
  KEY `IDX_ITEM_ADDINFO_ITEM` (`item`),
  KEY `IDX_ITEM_ADDINFO_PRODUCT` (`product`),
  CONSTRAINT `FK_ITEM_ADDINFO_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_ITEM_ADDINFO_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`),
  CONSTRAINT `FK_ITEM_ADDINFO_PRODUCT` FOREIGN KEY (`product`) REFERENCES `product` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Informacion adicional del Articulo';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `item_addinfo`
--

LOCK TABLES `item_addinfo` WRITE;
/*!40000 ALTER TABLE `item_addinfo` DISABLE KEYS */;
/*!40000 ALTER TABLE `item_addinfo` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `item_alternative`
--

DROP TABLE IF EXISTS `item_alternative`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `item_alternative` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `item` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador de Articulo',
  `alternative_item` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador de Articulo Alternativo',
  `priority` tinyint(2) DEFAULT '0' COMMENT 'Prioridad del Articulo Alternativo',
  PRIMARY KEY (`id`),
  UNIQUE KEY `IDX_UNQ_ITEM_ALTERNATIVE` (`item`,`alternative_item`),
  KEY `IDX_ITEM_ALTERNATIVE_ITEM` (`item`),
  KEY `IDX_ITEM_ALTERNATIVE_ALTERNATIVE` (`alternative_item`),
  KEY `IDX_ITEM_ALTERNATIVE_DOMAIN` (`domain`),
  CONSTRAINT `FK_ITEM_ALTERNATIVE_ALTERNATIVE` FOREIGN KEY (`alternative_item`) REFERENCES `item` (`id`),
  CONSTRAINT `FK_ITEM_ALTERNATIVE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_ITEM_ALTERNATIVE_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Articulo Alternativos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `item_alternative`
--

LOCK TABLES `item_alternative` WRITE;
/*!40000 ALTER TABLE `item_alternative` DISABLE KEYS */;
/*!40000 ALTER TABLE `item_alternative` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `item_composition`
--

DROP TABLE IF EXISTS `item_composition`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `item_composition` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `item` int(4) NOT NULL COMMENT 'Identificador del Articulo compuesto',
  `composition_item` int(4) NOT NULL COMMENT 'Identificador del Articulo componente',
  `sequence` smallint(2) DEFAULT '0' COMMENT 'Numero de secuencia dentro de la Composicion',
  `description` varchar(1024) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion del componente',
  `quantity` double(15,3) DEFAULT '0.000' COMMENT 'Cantidad del componente',
  `discount_expr` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descuentos del componente',
  PRIMARY KEY (`id`),
  KEY `IDX_ITEM_COMPOSITION_ITEM` (`item`),
  KEY `IDX_ITEM_COMPOSITION_COMPOSITION` (`composition_item`),
  KEY `IDX_ITEM_COMPOSITION_DOMAIN` (`domain`),
  CONSTRAINT `FK_ITEM_COMPOSITION_COMPOSITION` FOREIGN KEY (`composition_item`) REFERENCES `item` (`id`),
  CONSTRAINT `FK_ITEM_COMPOSITION_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_ITEM_COMPOSITION_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Composicion de Articulos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `item_composition`
--

LOCK TABLES `item_composition` WRITE;
/*!40000 ALTER TABLE `item_composition` DISABLE KEYS */;
/*!40000 ALTER TABLE `item_composition` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `item_tariff`
--

DROP TABLE IF EXISTS `item_tariff`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `item_tariff` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `item` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador de Articulo',
  `tariff` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador de Tarifa',
  `type` tinyint(2) DEFAULT '0' COMMENT 'Tipo de Tarifa',
  `profit_percent` double DEFAULT '0' COMMENT 'Porcentaje de beneficio',
  `price` double DEFAULT '0' COMMENT 'Precio de Venta',
  PRIMARY KEY (`id`),
  UNIQUE KEY `IDX_UNQ_ITEM_TARIFF` (`item`,`tariff`),
  KEY `IDX_ITEM_TARIFF_TARIFF` (`tariff`),
  KEY `IDX_ITEM_TARIFF_ITEM` (`item`),
  KEY `IDX_ITEM_TARIFF_DOMAIN` (`domain`),
  CONSTRAINT `FK_ITEM_TARIFF_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_ITEM_TARIFF_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`),
  CONSTRAINT `FK_ITEM_TARIFF_TARIFF` FOREIGN KEY (`tariff`) REFERENCES `tariff` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Tarifas de Articulos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `item_tariff`
--

LOCK TABLES `item_tariff` WRITE;
/*!40000 ALTER TABLE `item_tariff` DISABLE KEYS */;
/*!40000 ALTER TABLE `item_tariff` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `item_warehouse`
--

DROP TABLE IF EXISTS `item_warehouse`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `item_warehouse` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `item` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador de Articulo',
  `warehouse` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador de Almacen',
  `stock_max` double(15,3) DEFAULT '0.000' COMMENT 'Stock maximo del Articulo en el Almacen',
  `stock_min` double(15,3) DEFAULT '0.000' COMMENT 'Stock minimo del Articulo en el Almacen',
  `location` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Localizacion del Articulo en el Almacen',
  PRIMARY KEY (`id`),
  UNIQUE KEY `IDX_UNQ_ITEM_WAREHOUSE` (`item`,`warehouse`),
  KEY `IDX_ITEM_WAREHOUSE_ITEM` (`item`),
  KEY `IDX_ITEM_WAREHOUSE_WAREHOUSE` (`warehouse`),
  KEY `IDX_ITEM_WAREHOUSE_DOMAIN` (`domain`),
  CONSTRAINT `FK_ITEM_WAREHOUSE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_ITEM_WAREHOUSE_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`),
  CONSTRAINT `FK_ITEM_WAREHOUSE_WAREHOUSE` FOREIGN KEY (`warehouse`) REFERENCES `warehouse` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Datos del Articulo por Almacen';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `item_warehouse`
--

LOCK TABLES `item_warehouse` WRITE;
/*!40000 ALTER TABLE `item_warehouse` DISABLE KEYS */;
/*!40000 ALTER TABLE `item_warehouse` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `job_type`
--

DROP TABLE IF EXISTS `job_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `job_type` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Tipo de Trabajo',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `description` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion del Tipo de Trabajo',
  PRIMARY KEY (`id`),
  KEY `IDX_JOB_TYPE_DOMAIN` (`domain`),
  CONSTRAINT `FK_JOB_TYPE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Tipos de Trabajos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `job_type`
--

LOCK TABLES `job_type` WRITE;
/*!40000 ALTER TABLE `job_type` DISABLE KEYS */;
/*!40000 ALTER TABLE `job_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `leave_batch`
--

DROP TABLE IF EXISTS `leave_batch`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `leave_batch` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `date` datetime DEFAULT NULL COMMENT 'Fecha de la Remesa',
  `status` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Indica el estado de la remesa',
  `communication_id` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Identificador resultante de la comunicacion',
  `income_file` mediumblob COMMENT 'Archivo respuesta en binario',
  `income_file_date` datetime DEFAULT NULL COMMENT 'Fecha de respuesta',
  `outcome_file` mediumblob COMMENT 'Archivo Adjunto en binario',
  `outcome_file_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  PRIMARY KEY (`id`),
  KEY `IDX_LEAVE_BATCH_DOMAIN` (`domain`),
  CONSTRAINT `FK_LEAVE_BATCH_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Remesas de partes IT';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `leave_batch`
--

LOCK TABLES `leave_batch` WRITE;
/*!40000 ALTER TABLE `leave_batch` DISABLE KEYS */;
/*!40000 ALTER TABLE `leave_batch` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `leave_batch_detail`
--

DROP TABLE IF EXISTS `leave_batch_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `leave_batch_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `leave_batch` int(4) NOT NULL COMMENT 'Identificador unico de la remesa',
  `contract_leave_detail` int(4) NOT NULL COMMENT 'Identificador unico del parte',
  PRIMARY KEY (`id`),
  KEY `IDX_LEAVE_BATCH_DETAIL_LEAVE_BATCH` (`leave_batch`),
  KEY `IDX_LEAVE_BATCH_DETAIL_CONTRACT_LEAVE_DETAIL` (`contract_leave_detail`),
  KEY `IDX_LEAVE_BATCH_DETAIL_DOMAIN` (`domain`),
  CONSTRAINT `FK_LEAVE_BATCH_DETAIL_CONTRACT_LEAVE_DETAIL` FOREIGN KEY (`contract_leave_detail`) REFERENCES `contract_leave_detail` (`id`),
  CONSTRAINT `FK_LEAVE_BATCH_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_LEAVE_BATCH_DETAIL_LEAVE_BATCH` FOREIGN KEY (`leave_batch`) REFERENCES `leave_batch` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalle de remesas de partes IT';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `leave_batch_detail`
--

LOCK TABLES `leave_batch_detail` WRITE;
/*!40000 ALTER TABLE `leave_batch_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `leave_batch_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `loan`
--

DROP TABLE IF EXISTS `loan`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `loan` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador Unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion del Prestamo',
  `loan_date` date NOT NULL COMMENT 'Fecha de Concesion del Prestamo',
  `term` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Plazo',
  `interest` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Interes',
  `review` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Revision',
  `amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe',
  `expenses` double(15,3) DEFAULT '0.000' COMMENT 'Gastos asociados al Prestamo',
  `rbank` int(4) NOT NULL COMMENT 'Banco por el que se paga el Prestamo',
  `security_level` tinyint(2) DEFAULT '0' COMMENT 'Nivel de Seguridad',
  `fee_amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe de la cuota',
  `recurrence` int(4) DEFAULT '0' COMMENT 'Periodicidad',
  `pay_day` int(4) DEFAULT '1' COMMENT 'Dia de Pago',
  `status` tinyint(2) DEFAULT '0' COMMENT 'Estado',
  `account` int(4) DEFAULT NULL COMMENT 'Identificador de la Cuenta Contable',
  PRIMARY KEY (`id`),
  KEY `IDX_LOAN_RBANK` (`rbank`),
  KEY `IDX_LOAN_DOMAIN` (`domain`),
  KEY `IDX_LOAN_ACCOUNT` (`account`),
  CONSTRAINT `FK_LOAN_ACCOUNT` FOREIGN KEY (`account`) REFERENCES `account` (`id`),
  CONSTRAINT `FK_LOAN_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_LOAN_RBANK` FOREIGN KEY (`rbank`) REFERENCES `rbank` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Prestamos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `loan`
--

LOCK TABLES `loan` WRITE;
/*!40000 ALTER TABLE `loan` DISABLE KEYS */;
/*!40000 ALTER TABLE `loan` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mail_account`
--

DROP TABLE IF EXISTS `mail_account`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mail_account` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre de la Cuenta de Correo',
  `email` varchar(256) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Cuenta de correo',
  `replyto_mail` varchar(256) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Email de Respuesta',
  `incoming_host` varchar(256) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Host del correo entrante',
  `protocol` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Protocolo utilizado (IMAP)',
  `incoming_port` int(4) DEFAULT NULL COMMENT 'Puerto del correo entrante',
  `incoming_security` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Seguridad de conexin del correo entrante',
  `outgoing_verification` tinyint(1) DEFAULT '1' COMMENT 'Indica si hay autentificacion en el correo saliente',
  `outgoing_host` varchar(256) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Host del servidor de correo saliente',
  `outgoing_port` int(4) DEFAULT NULL COMMENT 'Puerto del servidor de correo saliente',
  `outgoing_security` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Seguridad de conexin del correo saliente',
  `mail_username` varchar(256) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre del usuario',
  `password` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Clave del usuario',
  `default_account` tinyint(1) DEFAULT '0' COMMENT 'Indica si es la cuenta de correo por defecto',
  `draft_folder` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Ruta de Borrador',
  `sent_folder` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Ruta de Enviados',
  `trash_folder` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Ruta de Papelera',
  `spam_folder` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Ruta de Spam',
  `display_name` varchar(256) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Mostrar como',
  `signature` int(4) DEFAULT NULL COMMENT 'Identificador de la Firma',
  `user_id` int(4) DEFAULT NULL COMMENT 'Identificador del Usuario',
  `type` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Tipo de la Cuenta de Correo',
  PRIMARY KEY (`id`),
  KEY `IDX_MAIL_ACCOUNT_SIGNATURE` (`signature`),
  KEY `IDX_MAIL_ACCOUNT_DOMAIN` (`domain`),
  KEY `IDX_MAIL_ACCOUNT_USER` (`user_id`),
  CONSTRAINT `FK_MAIL_ACCOUNT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_MAIL_ACCOUNT_SIGNATURE` FOREIGN KEY (`signature`) REFERENCES `signature` (`id`),
  CONSTRAINT `FK_MAIL_ACCOUNT_USER` FOREIGN KEY (`user_id`) REFERENCES `user` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Cuentas de Correo Electronico';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mail_account`
--

LOCK TABLES `mail_account` WRITE;
/*!40000 ALTER TABLE `mail_account` DISABLE KEYS */;
/*!40000 ALTER TABLE `mail_account` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `make`
--

DROP TABLE IF EXISTS `make`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `make` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Fabricante',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre del Fabricante',
  PRIMARY KEY (`id`),
  KEY `IDX_MAKE_DOMAIN` (`domain`),
  CONSTRAINT `FK_MAKE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Fabricantes';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `make`
--

LOCK TABLES `make` WRITE;
/*!40000 ALTER TABLE `make` DISABLE KEYS */;
/*!40000 ALTER TABLE `make` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mark`
--

DROP TABLE IF EXISTS `mark`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mark` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL DEFAULT '1' COMMENT 'Identificador del Dominio',
  `subject` int(4) NOT NULL COMMENT 'Identificador de Asignatura',
  `alumn` int(4) NOT NULL COMMENT 'Identificador de Alumno',
  `evaluation` tinyint(2) NOT NULL COMMENT 'Numero de evaluacion',
  `mark` double(15,3) DEFAULT '0.000' COMMENT 'Nota',
  PRIMARY KEY (`id`),
  UNIQUE KEY `IDX_MARK_SUBJECT_ALUMN_EVALUATION` (`subject`,`alumn`,`evaluation`),
  KEY `IDX_MARK_ALUMN` (`alumn`),
  KEY `IDX_MARK_SUBJECT` (`subject`),
  KEY `IDX_MARK_DOMAIN` (`domain`),
  CONSTRAINT `FK_MARK_ALUMN` FOREIGN KEY (`alumn`) REFERENCES `course_alumn` (`id`),
  CONSTRAINT `FK_MARK_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_MARK_SUBJECT` FOREIGN KEY (`subject`) REFERENCES `course_academicskill` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Notas de Alumnos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mark`
--

LOCK TABLES `mark` WRITE;
/*!40000 ALTER TABLE `mark` DISABLE KEYS */;
/*!40000 ALTER TABLE `mark` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mk_action`
--

DROP TABLE IF EXISTS `mk_action`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mk_action` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `campaign` int(11) NOT NULL COMMENT 'Identificador de la Campaña',
  `media_type` int(4) NOT NULL COMMENT 'Tipo de contacto de la Accion',
  `start_date` datetime NOT NULL COMMENT 'Fecha de inicio',
  `end_date` datetime DEFAULT NULL COMMENT 'Fecha de finalizacion',
  `survey` int(4) DEFAULT NULL COMMENT 'Identificador del Cuestionario',
  `newsletter` int(4) DEFAULT NULL COMMENT 'Identificador del Boletin',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion de la Accion',
  `news` int(4) DEFAULT NULL COMMENT 'Identificador de la Noticia',
  PRIMARY KEY (`id`),
  KEY `IDX_MK_ACTION_MK_CAMPAIGN` (`campaign`),
  KEY `IDX_MK_ACTION_SURVEY` (`survey`),
  KEY `IDX_MK_ACTION_DOMAIN` (`domain`),
  KEY `IDX_MK_ACTION_NEWSLETTER` (`newsletter`),
  KEY `IDX_MK_ACTION_NEWS` (`news`),
  CONSTRAINT `FK_MK_ACTION_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_MK_ACTION_MK_CAMPAIGN` FOREIGN KEY (`campaign`) REFERENCES `mk_campaign` (`id`),
  CONSTRAINT `FK_MK_ACTION_NEWS` FOREIGN KEY (`news`) REFERENCES `news` (`id`),
  CONSTRAINT `FK_MK_ACTION_NEWSLETTER` FOREIGN KEY (`newsletter`) REFERENCES `newsletter` (`id`),
  CONSTRAINT `FK_MK_ACTION_SURVEY` FOREIGN KEY (`survey`) REFERENCES `survey` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Acciones de Marketing';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mk_action`
--

LOCK TABLES `mk_action` WRITE;
/*!40000 ALTER TABLE `mk_action` DISABLE KEYS */;
/*!40000 ALTER TABLE `mk_action` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mk_action_target`
--

DROP TABLE IF EXISTS `mk_action_target`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mk_action_target` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `action` int(4) NOT NULL COMMENT 'Identificador de la Accion',
  `target` int(4) NOT NULL COMMENT 'Identificador del Cliente Potencial',
  `status` tinyint(2) NOT NULL COMMENT 'Estado del Cliente Potencial de la Accion de Campaña',
  `survey_response` int(4) DEFAULT NULL COMMENT 'Identificador de la Respuesta de Cuestionario',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios',
  `user` int(4) DEFAULT NULL COMMENT 'Identificador del Usuario',
  PRIMARY KEY (`id`),
  KEY `IDX_MK_ACTION_TARGET_USER` (`user`),
  KEY `IDX_MK_ACTION_TARGET_SURVEY_RESPONSE` (`survey_response`),
  KEY `IDX_MK_ACTION_TARGET_MK_ACTION` (`action`),
  KEY `IDX_MK_ACTION_TARGET_TARGET` (`target`),
  KEY `IDX_MK_ACTION_TARGET_DOMAIN` (`domain`),
  CONSTRAINT `FK_MK_ACTION_TARGET_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_MK_ACTION_TARGET_MK_ACTION` FOREIGN KEY (`action`) REFERENCES `mk_action` (`id`),
  CONSTRAINT `FK_MK_ACTION_TARGET_SURVEY_RESPONSE` FOREIGN KEY (`survey_response`) REFERENCES `survey_response` (`id`),
  CONSTRAINT `FK_MK_ACTION_TARGET_TARGET` FOREIGN KEY (`target`) REFERENCES `target` (`registry`),
  CONSTRAINT `FK_MK_ACTION_TARGET_USER` FOREIGN KEY (`user`) REFERENCES `user` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Clientes Potenciales de la Accion de Marketing';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mk_action_target`
--

LOCK TABLES `mk_action_target` WRITE;
/*!40000 ALTER TABLE `mk_action_target` DISABLE KEYS */;
/*!40000 ALTER TABLE `mk_action_target` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mk_campaign`
--

DROP TABLE IF EXISTS `mk_campaign`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mk_campaign` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `active` tinyint(1) NOT NULL COMMENT 'Indica si la Campaña esta activa o no',
  `description` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion de la Campaña',
  `scope` int(4) NOT NULL COMMENT 'Identificador del Ambito',
  PRIMARY KEY (`id`),
  KEY `IDX_MK_CAMPAIGN_DOMAIN` (`domain`),
  KEY `IDX_MK_CAMPAIGN_SCOPE` (`scope`),
  CONSTRAINT `FK_MK_CAMPAIGN_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_MK_CAMPAIGN_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Campañas de Marketing';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mk_campaign`
--

LOCK TABLES `mk_campaign` WRITE;
/*!40000 ALTER TABLE `mk_campaign` DISABLE KEYS */;
/*!40000 ALTER TABLE `mk_campaign` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `mk_template`
--

DROP TABLE IF EXISTS `mk_template`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `mk_template` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `scope` int(4) NOT NULL COMMENT 'Identificador del Ambito',
  `name` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre de la Plantilla',
  `active` tinyint(1) NOT NULL COMMENT 'Indica si la Plantilla esta activa o no',
  `creationDate` datetime NOT NULL COMMENT 'Fecha de la creacion en el sistema de la Plantilla',
  `subject` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Asunto de la Plantilla',
  `width` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Ancho de la Plantilla',
  `title_color` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Color del titulo de la Plantilla',
  `background_color` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Color de fondo de la Plantilla',
  `header_template` int(4) DEFAULT NULL COMMENT 'Identificador de la Plantilla de Cabecera',
  `footer_template` int(4) DEFAULT NULL COMMENT 'Identificador de la Plantilla de Pie de Pagina',
  PRIMARY KEY (`id`),
  KEY `IDX_MK_TEMPLATE_DOMAIN` (`domain`),
  KEY `IDX_MK_TEMPLATE_SCOPE` (`scope`),
  KEY `IDX_MK_TEMPLATE_HEADER_TEMPLATE` (`header_template`),
  KEY `IDX_MK_TEMPLATE_FOOTER_TEMPLATE` (`footer_template`),
  CONSTRAINT `FK_MK_TEMPLATE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_MK_TEMPLATE_FOOTER_TEMPLATE` FOREIGN KEY (`footer_template`) REFERENCES `rattach` (`id`),
  CONSTRAINT `FK_MK_TEMPLATE_HEADER_TEMPLATE` FOREIGN KEY (`header_template`) REFERENCES `rattach` (`id`),
  CONSTRAINT `FK_MK_TEMPLATE_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Plantilla de Marketing';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `mk_template`
--

LOCK TABLES `mk_template` WRITE;
/*!40000 ALTER TABLE `mk_template` DISABLE KEYS */;
/*!40000 ALTER TABLE `mk_template` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `model`
--

DROP TABLE IF EXISTS `model`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `model` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Modelo',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `make` int(4) NOT NULL COMMENT 'Identificador del Fabricante',
  `name` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre del Modelo',
  PRIMARY KEY (`id`),
  KEY `IDX_MODEL_MAKE` (`make`),
  KEY `IDX_MODEL_DOMAIN` (`domain`),
  CONSTRAINT `FK_MODEL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_MODEL_MAKE` FOREIGN KEY (`make`) REFERENCES `make` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Modelos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `model`
--

LOCK TABLES `model` WRITE;
/*!40000 ALTER TABLE `model` DISABLE KEYS */;
/*!40000 ALTER TABLE `model` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `news`
--

DROP TABLE IF EXISTS `news`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `news` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL DEFAULT '1' COMMENT 'Identificador del Dominio',
  `title` varchar(128) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Titulo de la Noticia',
  `description` varchar(1024) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion de la Noticia',
  `content` text COLLATE latin1_spanish_ci NOT NULL COMMENT 'Contenido de la Noticia',
  `url` varchar(256) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Url de la Noticia',
  `active` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'Indica si la Noticia esta activa o no',
  `rss` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indica si la Noticia se va a publicar en rss o no',
  `init_date` datetime DEFAULT NULL COMMENT 'Fecha Noticia',
  `end_date` datetime DEFAULT NULL COMMENT 'Fecha fin Noticia',
  `category` int(4) DEFAULT NULL COMMENT 'Categoria de la Noticia',
  `rattach` int(4) DEFAULT NULL COMMENT 'Identificador del Archivo Adjunto',
  `scope` int(4) NOT NULL COMMENT 'Identificador del Ambito',
  `type` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Tipo de Contenido',
  `template` int(4) DEFAULT NULL COMMENT 'Identificador de la Plantilla de Marketing',
  PRIMARY KEY (`id`),
  KEY `IDX_NEWS_DOMAIN` (`domain`),
  KEY `IDX_NEWS_CATEGORY` (`category`),
  KEY `IDX_NEWS_RATTACH` (`rattach`),
  KEY `IDX_NEWS_SCOPE` (`scope`),
  KEY `IDX_NEWS_MK_TEMPLATE` (`template`),
  CONSTRAINT `FK_NEWS_CATEGORY` FOREIGN KEY (`category`) REFERENCES `category` (`id`),
  CONSTRAINT `FK_NEWS_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_NEWS_MK_TEMPLATE` FOREIGN KEY (`template`) REFERENCES `mk_template` (`id`),
  CONSTRAINT `FK_NEWS_RATTACH` FOREIGN KEY (`rattach`) REFERENCES `rattach` (`id`),
  CONSTRAINT `FK_NEWS_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Noticias';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `news`
--

LOCK TABLES `news` WRITE;
/*!40000 ALTER TABLE `news` DISABLE KEYS */;
/*!40000 ALTER TABLE `news` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `newsletter`
--

DROP TABLE IF EXISTS `newsletter`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `newsletter` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL DEFAULT '1' COMMENT 'Identificador del Dominio',
  `name` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre del Boletin',
  `date` datetime NOT NULL COMMENT 'Fecha del Boletin',
  `layout` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Disposicion del Boletin',
  `active` tinyint(1) DEFAULT '1' COMMENT 'Indica si el Boletin esta activo o no',
  `subject` varchar(128) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Asunto del Boletin',
  `scope` int(4) NOT NULL COMMENT 'Identificador del Ambito',
  `highlightFirst` tinyint(1) DEFAULT '0' COMMENT 'Indica si el Boletin destaca la primera noticia o no',
  `template` int(4) DEFAULT NULL COMMENT 'Identificador de la Plantilla de Marketing',
  `newsSeparator` tinyint(1) DEFAULT '0' COMMENT 'Indica si el Boletin incluye un separador entre noticias',
  PRIMARY KEY (`id`),
  KEY `IDX_NEWSLETTER_DOMAIN` (`domain`),
  KEY `IDX_NEWSLETTER_SCOPE` (`scope`),
  KEY `IDX_NEWSLETTER_MK_TEMPLATE` (`template`),
  CONSTRAINT `FK_NEWSLETTER_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_NEWSLETTER_MK_TEMPLATE` FOREIGN KEY (`template`) REFERENCES `mk_template` (`id`),
  CONSTRAINT `FK_NEWSLETTER_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Boletin';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `newsletter`
--

LOCK TABLES `newsletter` WRITE;
/*!40000 ALTER TABLE `newsletter` DISABLE KEYS */;
/*!40000 ALTER TABLE `newsletter` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `newsletter_detail`
--

DROP TABLE IF EXISTS `newsletter_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `newsletter_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL DEFAULT '1' COMMENT 'Identificador del Dominio',
  `news` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador de la Noticia',
  `newsletter` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador del Boletin',
  `position` int(4) NOT NULL COMMENT 'Posicion dentro del Boletin',
  PRIMARY KEY (`id`),
  KEY `IDX_NEWSLETTER_DETAIL_DOMAIN` (`domain`),
  KEY `IDX_NEWSLETTER_DETAIL_NEWS` (`news`),
  KEY `IDX_NEWSLETTER_DETAIL_NEWSLETTER` (`newsletter`),
  CONSTRAINT `FK_NEWSLETTER_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_NEWSLETTER_DETAIL_NEWS` FOREIGN KEY (`news`) REFERENCES `news` (`id`),
  CONSTRAINT `FK_NEWSLETTER_DETAIL_NEWSLETTER` FOREIGN KEY (`newsletter`) REFERENCES `newsletter` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Noticias del Boletin';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `newsletter_detail`
--

LOCK TABLES `newsletter_detail` WRITE;
/*!40000 ALTER TABLE `newsletter_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `newsletter_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `note`
--

DROP TABLE IF EXISTS `note`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `note` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la Nota',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `subject` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion corta de la Nota',
  `date` datetime NOT NULL COMMENT 'Fecha de la Nota',
  `owner` int(4) DEFAULT NULL COMMENT 'Destinatario de la Nota',
  `note` text COLLATE latin1_spanish_ci COMMENT 'Texto de la Nota',
  PRIMARY KEY (`id`),
  KEY `IDX_NOTE_USER` (`owner`),
  KEY `IDX_NOTE_DOMAIN` (`domain`),
  CONSTRAINT `FK_NOTE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_NOTE_USER` FOREIGN KEY (`owner`) REFERENCES `user` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Notas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `note`
--

LOCK TABLES `note` WRITE;
/*!40000 ALTER TABLE `note` DISABLE KEYS */;
/*!40000 ALTER TABLE `note` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `notice`
--

DROP TABLE IF EXISTS `notice`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `notice` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Aviso',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `date` datetime NOT NULL COMMENT 'Fecha y hora en la que se produjo el Aviso',
  `sender` int(4) NOT NULL COMMENT 'Remitente del Aviso',
  `work_group` int(4) DEFAULT NULL COMMENT 'Grupo de Trabajo al que va dirigida el Aviso',
  `recipient` int(4) DEFAULT NULL COMMENT 'Destinatario del Aviso',
  `source` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Origen del Aviso',
  `company` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Empresa para la que trabaja el origen del Aviso',
  `phone` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Telefono para contactar con el origen del Aviso',
  `subject` text COLLATE latin1_spanish_ci COMMENT 'Asunto del Aviso',
  `status` tinyint(2) NOT NULL COMMENT 'Estado del Aviso',
  `type` tinyint(2) NOT NULL COMMENT 'Tipo de Aviso',
  `priority` tinyint(2) NOT NULL COMMENT 'Prioridad del Aviso',
  `notice` int(4) DEFAULT NULL COMMENT 'Aviso al que referencia',
  PRIMARY KEY (`id`),
  KEY `IDX_NOTICE_USER_SENDER` (`sender`),
  KEY `IDX_NOTICE_USER_RECIPIENT` (`recipient`),
  KEY `IDX_NOTICE_WORKGROUP` (`work_group`),
  KEY `IDX_NOTICE_DOMAIN` (`domain`),
  CONSTRAINT `FK_NOTICE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_NOTICE_USER_RECIPIENT` FOREIGN KEY (`recipient`) REFERENCES `user` (`id`),
  CONSTRAINT `FK_NOTICE_USER_SENDER` FOREIGN KEY (`sender`) REFERENCES `user` (`id`),
  CONSTRAINT `FK_NOTICE_WORKGROUP` FOREIGN KEY (`work_group`) REFERENCES `workgroup` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Avisos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `notice`
--

LOCK TABLES `notice` WRITE;
/*!40000 ALTER TABLE `notice` DISABLE KEYS */;
/*!40000 ALTER TABLE `notice` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `notice_tag`
--

DROP TABLE IF EXISTS `notice_tag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `notice_tag` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `notice` int(4) NOT NULL COMMENT 'Identificador del Aviso',
  `tag` int(4) NOT NULL COMMENT 'Identificador de la Etiqueta',
  `start_date` datetime NOT NULL COMMENT 'Fecha y hora de la apertura del Aviso',
  `end_date` datetime DEFAULT NULL COMMENT 'Fecha y hora de cierre del Aviso',
  `user` int(4) DEFAULT NULL COMMENT 'Identificador del Usuario',
  PRIMARY KEY (`id`),
  KEY `IDX_NOTICE_TAG_NOTICE` (`notice`),
  KEY `IDX_NOTICE_TAG_TAG` (`tag`),
  KEY `IDX_NOTICE_TAG_USER` (`user`),
  CONSTRAINT `FK_NOTICE_TAG_NOTICE` FOREIGN KEY (`notice`) REFERENCES `notice` (`id`),
  CONSTRAINT `FK_NOTICE_TAG_TAG` FOREIGN KEY (`tag`) REFERENCES `tag` (`id`),
  CONSTRAINT `FK_NOTICE_TAG_USER` FOREIGN KEY (`user`) REFERENCES `user` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Relacion entre Avisos y Etiquetas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `notice_tag`
--

LOCK TABLES `notice_tag` WRITE;
/*!40000 ALTER TABLE `notice_tag` DISABLE KEYS */;
/*!40000 ALTER TABLE `notice_tag` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `observation`
--

DROP TABLE IF EXISTS `observation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `observation` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la Observacion',
  `domain` int(4) NOT NULL DEFAULT '1' COMMENT 'Identificador del Dominio',
  `description` varchar(256) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion de la Observacion',
  PRIMARY KEY (`id`),
  KEY `IDX_OBSERVATION_DOMAIN` (`domain`),
  CONSTRAINT `FK_OBSERVATION_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Observaciones';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `observation`
--

LOCK TABLES `observation` WRITE;
/*!40000 ALTER TABLE `observation` DISABLE KEYS */;
/*!40000 ALTER TABLE `observation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `offer`
--

DROP TABLE IF EXISTS `offer`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `offer` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Presupuesto',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `project` int(4) DEFAULT NULL COMMENT 'Identificador del Proyecto',
  `target` int(4) NOT NULL COMMENT 'Identificador del Cliente Potencial',
  `series` char(5) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Serie del Presupuesto',
  `number` int(4) NOT NULL COMMENT 'Numero del Presupuesto',
  `version` smallint(2) NOT NULL DEFAULT '0' COMMENT 'Numero de version de Presupuesto',
  `address` int(4) DEFAULT NULL COMMENT 'Identificador de la Direccion de envio del Presupuesto',
  `seller` int(4) DEFAULT NULL COMMENT 'Agente Comercial del Presupuesto',
  `supplier` int(4) DEFAULT NULL COMMENT 'Identificador del Proveedor',
  `discount_expr` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descuentos del Presupuesto',
  `issue_date` date DEFAULT NULL COMMENT 'Fecha de emision del Presupuesto',
  `pay_method` int(4) DEFAULT NULL COMMENT 'Forma de Pago del Presupuesto',
  `security_level` tinyint(2) DEFAULT '0' COMMENT 'Nivel de seguridad del Presupuesto',
  `status` tinyint(2) DEFAULT '0' COMMENT 'Estado del Presupuesto',
  `type` tinyint(2) DEFAULT '0' COMMENT 'Tipo de Presupuesto',
  `workplace` int(4) NOT NULL COMMENT 'Identificador del Centro de Trabajo',
  `scope` int(4) NOT NULL DEFAULT '1' COMMENT 'Ambito del Presupuesto',
  `number_of_pymnts` smallint(2) DEFAULT '0' COMMENT 'Numero de Vencimientos',
  `days_to_first_pymnt` smallint(2) DEFAULT '0' COMMENT 'Dias al primer Vencimiento',
  `days_between_pymnts` smallint(2) DEFAULT '0' COMMENT 'Dias entre Vencimientos',
  `pymnt_days` varchar(8) COLLATE latin1_spanish_ci DEFAULT '0' COMMENT 'Dias de pago',
  `bank_account` varchar(34) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'IBAN - Numero de Cuenta Bancaria Internacional',
  `bank_alias` varchar(25) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Alias del Banco',
  `bic` varchar(11) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'BIC - Codigo Identificador del Banco',
  `signed` tinyint(1) DEFAULT '0' COMMENT 'Indica si el Presupuesto esta firmada electronicamente',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios del Presupuesto',
  `remarks` text COLLATE latin1_spanish_ci COMMENT 'Observaciones del Presupuesto',
  `external_reference` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Referencia externa',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  UNIQUE KEY `IDX_OFFER_DOMAIN_SERIES_NUMBER_VERSION` (`domain`,`series`,`number`,`version`),
  KEY `IDX_OFFER_SCOPE` (`scope`),
  KEY `IDX_OFFER_SUPPLIER` (`supplier`),
  KEY `IDX_OFFER_RADDRESS` (`address`),
  KEY `IDX_OFFER_PROJECT` (`project`),
  KEY `IDX_OFFER_ISSUE_DATE` (`issue_date`),
  KEY `IDX_OFFER_TARGET` (`target`),
  KEY `IDX_OFFER_SELLER` (`seller`),
  KEY `IDX_OFFER_PAY_METHOD` (`pay_method`),
  KEY `IDX_OFFER_WORKPLACE` (`workplace`),
  KEY `IDX_OFFER_DOMAIN` (`domain`),
  CONSTRAINT `FK_OFFER_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_OFFER_PAY_METHOD` FOREIGN KEY (`pay_method`) REFERENCES `pay_method` (`id`),
  CONSTRAINT `FK_OFFER_PROJECT` FOREIGN KEY (`project`) REFERENCES `project` (`id`),
  CONSTRAINT `FK_OFFER_RADDRESS` FOREIGN KEY (`address`) REFERENCES `raddress` (`id`),
  CONSTRAINT `FK_OFFER_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`),
  CONSTRAINT `FK_OFFER_SELLER` FOREIGN KEY (`seller`) REFERENCES `seller` (`registry`),
  CONSTRAINT `FK_OFFER_SUPPLIER` FOREIGN KEY (`supplier`) REFERENCES `supplier` (`registry`),
  CONSTRAINT `FK_OFFER_TARGET` FOREIGN KEY (`target`) REFERENCES `target` (`registry`),
  CONSTRAINT `FK_OFFER_WORKPLACE` FOREIGN KEY (`workplace`) REFERENCES `workplace` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Presupuestos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `offer`
--

LOCK TABLES `offer` WRITE;
/*!40000 ALTER TABLE `offer` DISABLE KEYS */;
/*!40000 ALTER TABLE `offer` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `offer_attach`
--

DROP TABLE IF EXISTS `offer_attach`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `offer_attach` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `offer` int(4) NOT NULL COMMENT 'Identificador del Presupuesto',
  `mimeType` tinyint(2) DEFAULT '0' COMMENT 'Mime Type del Archivo Adjunto',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion del Archivo Adjunto',
  `data` mediumblob COMMENT 'Archivo Adjunto en binario',
  `driveId` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `IDX_OFFER_ATTACH_OFFER` (`offer`),
  KEY `IDX_OFFER_ATTACH_DOMAIN` (`domain`),
  CONSTRAINT `FK_OFFER_ATTACH_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_OFFER_ATTACH_OFFER` FOREIGN KEY (`offer`) REFERENCES `offer` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Archivos Adjuntos de Presupuestos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `offer_attach`
--

LOCK TABLES `offer_attach` WRITE;
/*!40000 ALTER TABLE `offer_attach` DISABLE KEYS */;
/*!40000 ALTER TABLE `offer_attach` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `offer_detail`
--

DROP TABLE IF EXISTS `offer_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `offer_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Detalle de Presupuesto',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `offer` int(4) NOT NULL COMMENT 'Identificador del Presupuesto',
  `line` smallint(2) DEFAULT '1' COMMENT 'Numero de linea del Detalle dentro del Presupuesto',
  `item` int(4) DEFAULT NULL COMMENT 'Identificador del Articulo',
  `description` varchar(1024) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripción del Articulo',
  `quantity` double(15,3) DEFAULT '0.000' COMMENT 'Cantidad del Articulo',
  `price` double DEFAULT '0' COMMENT 'Precio del Articulo',
  `discount_expr` varchar(32) COLLATE latin1_spanish_ci DEFAULT '0' COMMENT 'Descuentos del Articulo',
  `status` tinyint(2) DEFAULT '0' COMMENT 'Estado del Detalle del Presupuesto',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_OFFER_DETAIL_OFFER` (`offer`),
  KEY `IDX_OFFER_DETAIL_ITEM` (`item`),
  KEY `IDX_OFFER_DETAIL_DOMAIN` (`domain`),
  CONSTRAINT `FK_OFFER_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_OFFER_DETAIL_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`),
  CONSTRAINT `FK_OFFER_DETAIL_OFFER` FOREIGN KEY (`offer`) REFERENCES `offer` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalles del Presupuesto';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `offer_detail`
--

LOCK TABLES `offer_detail` WRITE;
/*!40000 ALTER TABLE `offer_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `offer_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `offer_detail_commission`
--

DROP TABLE IF EXISTS `offer_detail_commission`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `offer_detail_commission` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `offer_detail` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador de la Linea de Presupuesto',
  `commission` double DEFAULT '0' COMMENT 'Porcentaje de Comision',
  `amount` double DEFAULT '0' COMMENT 'Importe de la Comision',
  `status` tinyint(2) DEFAULT '0' COMMENT 'Estado de la Comision',
  `pay_date` date DEFAULT NULL COMMENT 'Fecha de liquidacion',
  PRIMARY KEY (`id`),
  KEY `IDX_OFFER_DETAIL_COMMISSION_OFFER_DETAIL` (`offer_detail`),
  KEY `IDX_OFFER_DETAIL_COMMISSION_DOMAIN` (`domain`),
  CONSTRAINT `FK_OFFER_DETAIL_COMMISSION_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_OFFER_DETAIL_COMMISSION_OFFER_DETAIL` FOREIGN KEY (`offer_detail`) REFERENCES `offer_detail` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Comisiones asociadas a Lineas de Presupuestos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `offer_detail_commission`
--

LOCK TABLES `offer_detail_commission` WRITE;
/*!40000 ALTER TABLE `offer_detail_commission` DISABLE KEYS */;
/*!40000 ALTER TABLE `offer_detail_commission` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `offer_term`
--

DROP TABLE IF EXISTS `offer_term`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `offer_term` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `offer` int(4) NOT NULL COMMENT 'Identificador del Presupuesto',
  `line` smallint(2) DEFAULT '1' COMMENT 'Numero de linea de la Condicion del Presupuesto',
  `name` varchar(64) COLLATE latin1_spanish_ci NOT NULL DEFAULT '' COMMENT 'Nombre de la Condicion Comercial',
  `description` text COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion de la Condicion Comercial',
  `term_general` tinyint(1) DEFAULT '0' COMMENT 'Indica si la Condicion es particular o general',
  PRIMARY KEY (`id`),
  KEY `IDX_OFFER_TERM_OFFER` (`offer`),
  KEY `IDX_OFFER_TERM_DOMAIN` (`domain`),
  CONSTRAINT `FK_OFFER_TERM_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_OFFER_TERM_OFFER` FOREIGN KEY (`offer`) REFERENCES `offer` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Condiciones del Presupuesto';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `offer_term`
--

LOCK TABLES `offer_term` WRITE;
/*!40000 ALTER TABLE `offer_term` DISABLE KEYS */;
/*!40000 ALTER TABLE `offer_term` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pay_method`
--

DROP TABLE IF EXISTS `pay_method`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `pay_method` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la Forma de Pago',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre de Forma de Pago',
  `type` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Tipo de Forma de Pago',
  PRIMARY KEY (`id`),
  KEY `IDX_PAY_METHOD_DOMAIN` (`domain`),
  CONSTRAINT `FK_PAY_METHOD_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=17423 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Formas de Pago';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `pay_method`
--

LOCK TABLES `pay_method` WRITE;
/*!40000 ALTER TABLE `pay_method` DISABLE KEYS */;
INSERT INTO `pay_method` VALUES (17415,8776,'EFECTIVO',0),(17416,8776,'GIRO',1),(17417,8776,'CHEQUE',4),(17418,8776,'TRANSFERENCIA',5),(17419,8779,'EFECTIVO',0),(17420,8779,'GIRO',1),(17421,8779,'CHEQUE',4),(17422,8779,'TRANSFERENCIA',5);
/*!40000 ALTER TABLE `pay_method` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `payment_concept`
--

DROP TABLE IF EXISTS `payment_concept`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `payment_concept` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `code` varchar(25) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo',
  `description` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion',
  `type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de Percepcion Salarial',
  `description_decorable` tinyint(2) NOT NULL DEFAULT '0',
  `expression` varchar(1024) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Importe',
  `irpf_expression` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Importe tributable',
  `quote_expression` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Importe cotizable',
  PRIMARY KEY (`id`),
  KEY `IDX_PAYMENT_CONCEPT_DOMAIN` (`domain`),
  CONSTRAINT `FK_PAYMENT_CONCEPT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=6275 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Conceptos de devengos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `payment_concept`
--

LOCK TABLES `payment_concept` WRITE;
/*!40000 ALTER TABLE `payment_concept` DISABLE KEYS */;
INSERT INTO `payment_concept` VALUES (-6,0,'__67','1/2 DIETAS Y VIAJES',45,0,'MEDIA_DIETA * DIAS_MEDIA_DIETA','_P','_P'),(-5,0,'PAGA_BENEFICIOS','A CUENTA PAGA DE VENTAS O BENEFICIOS',4,0,'( SALARIO_BASE + ANTIGUEDAD ) / 14','_P','( SALARIO_BASE + ANTIGUEDAD ) / 12'),(-4,0,'__65','COMPLEMENTO POR MEJORA DE PRODUCTIVIDAD',1,0,'CHECK((DIAS_MES - DIAS_TRABAJADOS) <= 1.00, \"AUSENCIAS POR MÁS DE OCHO HORAS\");  SALARIO_BASE * 1/100','_P','_P'),(-3,8776,'__12','[7] DIETAS ( @{DIETA * 0.40} € X @{PERNOCTAS} PERNOCTAS )',43,0,'DIETA *0.40 * PERNOCTAS','_P','_P'),(-2,8778,'__9','[6] PLUS FORMACIÓN Y APRENDIZAJE',1,0,'0.00','_P','_P'),(6178,0,'SALARIO_BASE',' SALARIO BASE ANUAL',1,0,'/*user*/SALARIO_ANUAL/**/ / PAGAS * DIAS_TRABAJADOS / DIAS_MES ','_P','_P'),(6179,0,'SALARIO_BASE','SALARIO BASE MENSUAL',1,0,'/*user*/SALARIO_MENSUAL/**/ * DIAS_TRABAJADOS / DIAS_MES ','_P','_P'),(6180,0,'SALARIO_BASE','SALARIO BASE ( @{SALARIO_DIARIO} € X @{DIAS_TRABAJADOS} DÍAS )',1,0,'/*user*/SALARIO_DIARIO/**/ * DIAS_TRABAJADOS ','_P','_P'),(6181,0,'SALARIO_BASE','SALARIO BASE ( @{SALARIO_HORA} € X @{HORAS} HORAS )',1,0,'/*read-only*/SALARIO_HORA * HORAS/**/','_P','_P'),(6182,0,'ANTIGUEDAD','COMPLEMENTO PERSONAL DE ANTIGÜEDAD',1,0,'INPUT(\"/*user*//**/\",ANTIGUEDAD_HELP)','_P','_P'),(6183,0,'PLUS_EXTRA_SALARIAL','PLUS EXTRA SALARIAL',1,0,NULL,'_P','_P'),(6185,0,NULL,'GASTOS DE ESTANCIA',42,0,'GTOS_ESTANCIA','EXCESO(GTOS_JUSTIFICADOS)','EXCESO(GTOS_JUSTIFICADOS)'),(6186,0,NULL,'GASTOS LOCOMOCIÓN SIN JUSTIFICANTE ( @{IMPORTE_KM} € X @{KMS} KMS )',50,0,'/*read-only*/IMPORTE_KM * KMS/**/','EXCESO(0.19 * KMS)','EXCESO(0.19 * KMS)'),(6187,0,NULL,'GASTOS DE LOCOMOCIÓN TRANSPORTE PÚBLICO',49,0,NULL,NULL,NULL),(6188,0,NULL,'GASTOS PERNOCTA ( @{IMPORTE_PERNOCTA} € X @{DIAS_PERNOCTA} DÍAS )',43,0,'/*read-only*/IMPORTE_PERNOCTA * DIAS_PERNOCTA/**/','EXCESO(53.34 * DIAS_PERNOCTA)','EXCESO(53.34 * DIAS_PERNOCTA)'),(6189,0,NULL,'GASTOS MANUTENCIÓN ( @{IMPORTE_MANUTENCION} € X @{DIAS_MANUTENCION} DÍAS )',45,0,'/*read-only*/IMPORTE_MANUTENCION * DIAS_MANUTENCION/**/','EXCESO(26.67 * DIAS_MANUTENCION)','EXCESO(26.67 * DIAS_MANUTENCION)'),(6190,0,NULL,'GASTOS PERNOCTA EXTRANJERO ( @{IMPORTE_PERNOCTA_EXTRANJERO} € X @{DIAS_PERNOCTA_EXTRANJERO} DÍAS )',44,0,'/*read-only*/IMPORTE_PERNOCTA_EXTRANJERO * DIAS_PERNOCTA_EXTRANJERO/**/','EXCESO(91.35 * DIAS_PERNOCTA_EXTRANJERO)','EXCESO(91.35 * DIAS_PERNOCTA_EXTRANJERO)'),(6191,0,NULL,'GASTOS MANUTENCIÓN EXTRANJERO ( @{IMPORTE_MANUTENCION_EXTRANJERO} € X @{DIAS_MANUTENCION_EXTRANJERO} DÍAS )',46,0,'/*read-only*/IMPORTE_MANUTENCION_EXTRANJERO * DIAS_MANUTENCION_EXTRANJERO/**/','EXCESO(48.08 * DIAS_MANUTENCION_EXTRANJERO)','EXCESO(48.08 * DIAS_MANUTENCION_EXTRANJERO)'),(6192,0,'HORAS_EXTRAS','HORAS EXTRAORDINARIAS NO ESTRUCTURALES',2,0,'IMPORTE_HORA_EXTRA * HORAS_EXTRAS','_P','_P'),(6193,0,'HORAS_EXTRAS','HORAS EXTR. ESTRUCTURALES O FUERZA MAYOR',3,0,'IMPORTE_HORA_EXTRA_FZA * HORAS_EXTRAS_FZA','_P','_P'),(6194,0,'PAGA_EXTRA','PAGA EXTRAORDINARIA',4,0,'INPUT(\"/*user*//**/\",PAGA_EXTRA_HELP)','_P','_P'),(6195,0,NULL,'RETRIBUCIÓN EN ESPECIE',13,0,NULL,'_P','_P'),(6196,0,'INDEMNIZACION','INDEMNIZACIONES POR DESPIDO O CESE ( @{SALARIO_BRUTO_DIARIO} € X @{DIAS_INDEMNIZACION * AÑOS_TRABAJADOS} DÍAS )',54,0,'/*read-only*/DIAS_INDEMNIZACION * AÑOS_TRABAJADOS * SALARIO_BRUTO_DIARIO/**/',NULL,NULL),(6211,0,NULL,'RETRIBUCIÓN NO INCLUIDA OTROS APARTADOS',1,0,NULL,'_P','_P'),(6212,0,NULL,'RETR<>PAGA.EXTR.VENCIM.SUP.MES.PRORRATEO',5,0,NULL,'_P','_P'),(6213,0,NULL,'VACACIONES RETRIBUIDAS NO DISFRUTADAS',6,0,NULL,'_P','_P'),(6214,0,NULL,'SALARIOS DE TRAMITACIÓN',7,0,NULL,'_P','_P'),(6215,0,NULL,'RETR.POR ATRASOS NO INCLUIDA OTROS APART',8,0,NULL,'_P','_P'),(6216,0,NULL,'RETRIBUCIÓN POR ATRASOS.CONV.COLECTIVO',9,0,NULL,'_P','_P'),(6217,0,NULL,'RETRIBUCIÓN POR ATRASOS.SENTENCIA JUD.',10,0,NULL,'_P','_P'),(6218,0,NULL,'RETRIBUCIÓN POR ATRASOS.NORMATIVA',11,0,NULL,'_P','_P'),(6219,0,NULL,'RETRIBUCIÓN POR ATRASOS.ACTA CONCILIAC',12,0,NULL,'_P','_P'),(6220,0,NULL,'R.ESP.VIVIENDA.PROP.PAGAD.C/VALOR.CATAST.',14,0,NULL,'_P','_P'),(6221,0,NULL,'R.ESP.VIVIENDA.PROP.PAGAD.PTE.VALOR.CAT.',15,0,NULL,'_P','_P'),(6222,0,NULL,'R.ESP.VIVIENDA.NO PROPIEDAD PAGADOR',16,0,NULL,'_P','_P'),(6223,0,NULL,'R.ESP.VEHÍCULO.ENTREGA AL TRABAJADOR',17,0,NULL,'_P','_P'),(6224,0,NULL,'R.ESP.VEHÍCULO.USO.PROPIEDAD PAGADOR',18,0,NULL,'_P','_P'),(6225,0,NULL,'R.ESP.VEHÍCULO USO.NO PROPIEDAD PAGADOR',19,0,NULL,'_P','_P'),(6226,0,NULL,'R.ESP.VEHÍCULO USO Y POSTERIOR ENTREGA',20,0,NULL,'_P','_P'),(6227,0,NULL,'R.ESP.PRÉSTAMO.TIPO INTERÉS < LEGAL',21,0,NULL,'_P','_P'),(6228,0,NULL,'R.ESP. MANUTENCIÓN Y SIMILARES',22,0,NULL,'_P','_P'),(6229,0,NULL,'R.ESP. HOSPEDAJE Y SIMILARES',23,0,NULL,'_P','_P'),(6230,0,NULL,'R.ESP. VIAJES Y SIMILARES',24,0,NULL,'_P','_P'),(6231,0,NULL,'R.ESP.GASTOS DE ESTUDIOS Y MANUTENCIÓN',25,0,NULL,'_P','_P'),(6232,0,NULL,'R.ESP.DERECHOS FUNDADORES DE SOCIEDADES',26,0,NULL,'_P','_P'),(6233,0,NULL,'QUEBRANTO DE MONEDA',27,0,NULL,'_P','_P'),(6234,0,NULL,'DESGASTE ÚTILES Y HERRAMIENTAS',28,0,NULL,'_P','_P'),(6235,0,NULL,'ADQUISICIÓN Y MANTENIMIENTO ROPA TRABAJO',29,0,NULL,'_P','_P'),(6236,0,NULL,'PERCEPCIONES POR MATRIMONIO',30,0,NULL,'_P','_P'),(6237,0,NULL,'DONACIONES PROMOCIONALES',31,0,NULL,'_P','_P'),(6238,0,NULL,'PLUSES DE TRANSPORTE Y DE DISTANCIA',32,0,NULL,'_P','_P'),(6239,0,NULL,'PLANES PENSIONES Y SIST. ALTERNATIVOS',33,0,NULL,'_P','_P'),(6240,0,NULL,'ACCIONES O PARTICIPACIONES EMPRESA',34,0,NULL,'_P','_P'),(6241,0,NULL,'GASTOS ESTUDIO ACT. CAPACIT. O RECICLAJE',35,0,NULL,'_P','_P'),(6242,0,NULL,'PRODUCTOS.PREC.REB.CANTIN.COMED.ECONOM.',36,0,NULL,'_P','_P'),(6243,0,NULL,'BIENES DESTINADOS A SERV. SOC. Y CULT.',37,0,NULL,'_P','_P'),(6244,0,NULL,'PRIMAS SEGURO AT O RESPONS. CIVIL TRAB.',38,0,NULL,'_P','_P'),(6245,0,NULL,'PRIMAS SEGURO ENFERMEDAD COMÚN TRABAJ.',39,0,NULL,'_P','_P'),(6246,0,NULL,'PRIMAS SEGURO ENFERMEDAD COMÚN FAMILIAR.',40,0,NULL,'_P','_P'),(6247,0,NULL,'PREST. EDUC. POR CENTR.AUT. A HIJ. TRAB.',41,0,NULL,'_P','_P'),(6248,0,NULL,'INDEMNIZACIONES POR FALLECIMIENTO',51,0,NULL,'_P','_P'),(6249,0,NULL,'INDEMNIZACIONES POR SUSPENSIONES',53,0,NULL,'_P','_P'),(6250,0,'GARANTIZADO','MEJORAS PREST.SS.INCAPACIDAD TEMPORAL',55,0,NULL,'_P',NULL),(6251,0,NULL,'MEJORAS PREST.SS.<>INCAPACIDAD TEMPORAL',56,0,NULL,'_P',NULL),(6252,0,'SALARIO_BASE','SALARIO BASE ( @{SALARIO_HORA} € X @{HORAS_NOMINA} HRS. )',1,0,'/*read-only*/SALARIO_HORA * HORAS_NOMINA/**/','_P','_P'),(6253,0,'GARANTIZADO','MEJORAS PREST.SS.ENFERMEDAD COMÚN',55,0,'isdef DIAS_ENFERMEDAD_COMUN ?/*user*/GTZDO(SALARIO_BASE,1,3)/**/: REMOVE()','_P',NULL),(6254,0,'GARANTIZADO','MEJORAS PREST.SS.ENFERMEDAD PROFESIONAL',55,0,'isdef DIAS_ENFERMEDAD_PROFESIONAL ?/*user*/GTZDO(SALARIO_BASE,1,3)/**/: REMOVE()','_P',NULL),(6255,0,'PREST_IT',NULL,1,0,NULL,NULL,NULL),(6266,0,'PLUS_SALARIAL','PLUS SALARIAL',1,0,'/*user*/ 0.00 /**/ * DIAS_TRABAJADOS / DIAS_MES','_P','_P'),(6269,0,'MTNAD',NULL,1,0,NULL,NULL,NULL),(6270,0,'ERE',NULL,1,0,NULL,NULL,NULL),(6274,0,'PREAVISO','DIAS PREAVISO',1,0,NULL,'_P','_P');
/*!40000 ALTER TABLE `payment_concept` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `payroll_batch_attach`
--

DROP TABLE IF EXISTS `payroll_batch_attach`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `payroll_batch_attach` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `source_batch` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador de la Remesa',
  `source_type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de la Remesa',
  `mimeType` tinyint(2) DEFAULT '0' COMMENT 'Mime Type del Archivo Adjunto',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion del Archivo Adjunto',
  `data` mediumblob COMMENT 'Archivo Adjunto en binario',
  `type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de Archivo Adjunto',
  `scope` int(4) DEFAULT NULL COMMENT 'Ambito del Archivo Adjunto',
  `attach_date` date DEFAULT NULL COMMENT 'Fecha del Archivo Adjunto',
  `driveId` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `IDX_PAYROLL_BATCH_ATTACH_DOMAIN` (`domain`),
  KEY `IDX_PAYROLL_BATCH_ATTACH_SCOPE` (`scope`),
  CONSTRAINT `FK_PAYROLL_BATCH_ATTACH_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_PAYROLL_BATCH_ATTACH_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Archivos Adjuntos de Remesas de Laboral';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `payroll_batch_attach`
--

LOCK TABLES `payroll_batch_attach` WRITE;
/*!40000 ALTER TABLE `payroll_batch_attach` DISABLE KEYS */;
/*!40000 ALTER TABLE `payroll_batch_attach` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `payroll_workplace`
--

DROP TABLE IF EXISTS `payroll_workplace`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `payroll_workplace` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `workplace` int(4) NOT NULL COMMENT 'Identificador del Centro de Trabajo',
  `agreement` int(4) DEFAULT NULL COMMENT 'Identificador del Convenio',
  `enterprise_activity` int(4) DEFAULT NULL COMMENT 'Identificador de la Actividad',
  `calendar` int(4) DEFAULT NULL COMMENT 'Identificador del Calendario',
  PRIMARY KEY (`id`),
  KEY `IDX_PAYROLL_WORKPLACE_WORKPLACE` (`workplace`),
  KEY `IDX_PAYROLL_WORKPLACE_CALENDAR` (`calendar`),
  KEY `IDX_PAYROLL_WORKPLACE_ENTERPRISE_ACTIVITY` (`enterprise_activity`),
  KEY `IDX_PAYROLL_WORKPLACE_AGREEMENT` (`agreement`),
  KEY `IDX_PAYROLL_WORKPLACE_DOMAIN` (`domain`),
  CONSTRAINT `FK_PAYROLL_WORKPLACE_AGREEMENT` FOREIGN KEY (`agreement`) REFERENCES `agreement` (`id`),
  CONSTRAINT `FK_PAYROLL_WORKPLACE_CALENDAR` FOREIGN KEY (`calendar`) REFERENCES `calendar` (`id`),
  CONSTRAINT `FK_PAYROLL_WORKPLACE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_PAYROLL_WORKPLACE_ENTERPRISE_ACTIVITY` FOREIGN KEY (`enterprise_activity`) REFERENCES `enterprise_activity` (`id`),
  CONSTRAINT `FK_PAYROLL_WORKPLACE_WORKPLACE` FOREIGN KEY (`workplace`) REFERENCES `workplace` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3574 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Datos laborales del Centro de Trabajo';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `payroll_workplace`
--

LOCK TABLES `payroll_workplace` WRITE;
/*!40000 ALTER TABLE `payroll_workplace` DISABLE KEYS */;
INSERT INTO `payroll_workplace` VALUES (-3566,8783,8384,-1164,1452,NULL),(3534,8777,8352,1156,1447,NULL),(3535,8777,8353,1156,1447,NULL),(3536,8777,8354,1156,1447,NULL),(3537,8777,8355,1156,1447,NULL),(3538,8777,8356,1156,1447,NULL),(3539,8777,8357,NULL,1447,NULL),(3540,8778,8358,NULL,1448,NULL),(3541,8776,8351,NULL,NULL,NULL),(3542,8777,8359,NULL,1447,NULL),(3543,8777,8360,NULL,1447,NULL),(3544,8777,8361,NULL,1447,NULL),(3545,8777,8362,NULL,1447,NULL),(3546,8777,8364,NULL,1447,NULL),(3547,8777,8365,1164,1447,NULL),(3548,8777,8366,NULL,1447,NULL),(3549,8777,8368,1156,1447,NULL),(3550,8777,8369,1156,NULL,NULL),(3551,8780,8367,NULL,1449,NULL),(3552,8780,8370,NULL,1449,NULL),(3553,8777,8371,NULL,1447,NULL),(3554,8777,8372,NULL,NULL,NULL),(3555,8777,8373,NULL,NULL,NULL),(3556,8781,8374,NULL,1450,NULL),(3557,8782,8375,NULL,NULL,NULL),(3558,8783,8376,1159,NULL,NULL),(3559,8777,8377,NULL,1447,NULL),(3560,8784,8378,1161,1453,NULL),(3561,8777,8379,NULL,1447,NULL),(3563,8783,8381,1163,1452,NULL),(3564,8785,8382,NULL,NULL,2),(3565,8785,8383,NULL,1454,1),(3566,8777,8385,1156,1447,NULL),(3567,8777,8386,1156,1447,NULL),(3568,8777,8387,NULL,1447,NULL),(3569,8787,8389,1165,1455,NULL),(3570,8777,8390,1156,1447,NULL),(3571,8788,8391,1164,1456,NULL),(3572,8777,8392,1156,1447,NULL),(3573,8777,8393,1192,1447,NULL);
/*!40000 ALTER TABLE `payroll_workplace` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pcategory`
--

DROP TABLE IF EXISTS `pcategory`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `pcategory` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la Categoria',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre de la Categoria',
  `detail` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre del detalle de los Articulos',
  `detail2` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre del detalle 2 de los Articulos',
  `detail3` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre del detalle 3 de los Articulos',
  PRIMARY KEY (`id`),
  KEY `IDX_PCATEGORY_DOMAIN` (`domain`),
  CONSTRAINT `FK_PCATEGORY_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=10948 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Categorias de Productos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `pcategory`
--

LOCK TABLES `pcategory` WRITE;
/*!40000 ALTER TABLE `pcategory` DISABLE KEYS */;
INSERT INTO `pcategory` VALUES (10946,8776,'GENERICA',NULL,NULL,NULL),(10947,8779,'GENERICA',NULL,NULL,NULL);
/*!40000 ALTER TABLE `pcategory` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `person`
--

DROP TABLE IF EXISTS `person`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `person` (
  `registry` int(4) NOT NULL DEFAULT '0' COMMENT 'Registro de la Persona',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `birth_date` date DEFAULT NULL COMMENT 'Fecha de nacimiento de la Persona',
  `gender` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Sexo de la Persona',
  `marital_status` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Estado civil de la Persona',
  `social_security_num` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de Seguridad Social de la Persona',
  `name` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre',
  `first_surname` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Primer Apellido ',
  `second_surname` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Segundo Apellido',
  PRIMARY KEY (`registry`),
  KEY `IDX_PERSON_DOMAIN` (`domain`),
  CONSTRAINT `FK_PERSON_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_PERSON_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Personas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `person`
--

LOCK TABLES `person` WRITE;
/*!40000 ALTER TABLE `person` DISABLE KEYS */;
INSERT INTO `person` VALUES (8628389,8777,NULL,2,5,'','INDEFINIDO','2012 TIEMPO COMPLETO','ORDINARIO'),(8628390,8777,NULL,2,5,'','INDEFINIDO','1989 TIEMPO COMPLETO','ORDINARIO'),(8628391,8777,NULL,2,5,'','INDEFINIDO','1993 TIEMPO COMPLETO','ORDINARIO'),(8628393,8777,NULL,2,5,'','INDEFINIDO','1991 TIEMPO COMPLETO','ORDINARIO'),(8628394,8777,NULL,2,5,'','INDEFINIDO','EXTRAS TIEMPO COMPLETO','ORDINARIO'),(8628395,8777,NULL,2,5,'','INDEFINIDO','PRORR. TIEMPO COMPLETO','ORDINARIO'),(8628396,8777,NULL,2,5,'','MÁXIMA ( GRUPO 01 )','BASE',''),(8628398,8777,NULL,2,5,'','MÍNIMA ( GRUPO 01 )','BASE',''),(8628399,8778,NULL,2,5,'','APRENDIZAJE','FORMACIÓN','Y EL'),(8628400,8777,NULL,2,5,'','INDEFINIDO','BRUTO TIEMPO COMPLETO','ORDINARIO'),(8628401,8777,NULL,2,5,'','INDEFINIDO','I.R.P.F ARABA TIEMPO COMPLETO','ORDINARIO'),(8628402,8777,NULL,2,5,'','INDEFINIDO','I.R.P.F 1 TIEMPO COMPLETO','ORDINARIO'),(8628403,8777,NULL,2,5,'','INDEFINIDO','I.R.P.F 3 TIEMPO COMPLETO','ORDINARIO'),(8628404,8777,NULL,2,5,'','INDEFINIDO','NETO TIEMPO COMPLETO','ORDINARIO'),(8628406,8777,NULL,2,5,'','IMPROCEDENTE','DESPIDO',''),(8628407,8777,NULL,2,5,'','POR CAUSAS OBJETIVAS','DESPIDO',''),(8628408,8777,NULL,2,5,'','OBRA','FIN CONTRATO FIJO',''),(8628409,8777,NULL,2,5,'','DURACIÓN DETERMINADA','FIN CONTRATO',''),(8628410,8777,NULL,2,5,'','MODIFICACIÓN CONDICIONES','BAJA VOLUNTARIA',''),(8628411,8777,NULL,2,5,'','-','RETA',''),(8628413,8777,NULL,2,5,'','INDEFINIDO','ATRASOS TIEMPO COMPLETO','ORDINARIO'),(8628414,8778,NULL,2,5,'','EL','BECARIO',''),(8628415,8777,NULL,2,5,'','TARIFA PLANA','REDUCCIONES RD-L 3/2014',''),(8628416,8777,NULL,2,5,'','REDUCCIÓN RD-L 1/2015','TARIFA REDUCIDA ',''),(8628417,8777,NULL,2,5,'','COMÚN','ENFERMEDAD',''),(8628418,8777,NULL,2,5,'','PROFESIONAL','ENFERMEDAD',''),(8628419,8777,NULL,2,5,'','COMPLETA','MATERNIDAD',''),(8628420,8777,NULL,2,5,'','COMPLETA','PATERNIDAD',''),(8628421,8778,NULL,2,5,'','APRENDIZAJE','FINIQUITO ','FORMACIÓN'),(8628422,8777,NULL,2,5,'','CATEGORIA',' ',''),(8628423,8780,NULL,2,5,'','AGRARIO','MENSUAL TRABAJADOR','CUENTA AJENA'),(8628424,8777,NULL,2,5,'','NO DISFRUTADAS','VACACIONES',''),(8628425,8777,NULL,2,5,'','I.T','BASE MÍNIMA','MENSUAL'),(8628426,8777,NULL,2,5,'','I.T','BASE MÍNIMA','DIARIA'),(8628427,8777,NULL,2,5,'','JEFE DE PRIMERA','ANALISTA',''),(8628428,8777,NULL,2,5,'','REDEFINIDO','DEVENGO',''),(8628429,8777,NULL,2,5,'','REDEFINIDA','VARIABLE',''),(8628430,8777,NULL,2,5,'','A CUENTA DEL CONVENIO','PAGO',''),(8628431,8780,NULL,2,5,'','CONVENIO','VIGILANTE',''),(8628432,8777,NULL,2,5,'','DESCRIPCION','CONCEPTO','ANTIGUEDAD'),(8628433,8777,NULL,2,5,'','DESCRIPCIONES','ERROR',''),(8628434,8777,NULL,2,5,'','CATEGORIA','SIN',''),(8628435,8777,NULL,2,5,'','CHECKS','NOTIFICACIONES',''),(8628436,8777,NULL,2,5,'',' ','BORRAR',''),(8628437,8777,NULL,2,5,'','ANTIGUEDAD','CONCEPTO',''),(8628438,8777,NULL,2,5,'','PAGA EXTRA','CONCEPTO',''),(8628440,8781,NULL,2,5,'',' ','INACTIVO',''),(8628441,8777,NULL,2,5,'','RETENIDO IS NOT COMPLETE','I.R.P.F',''),(8628442,8777,NULL,2,5,'','REDEFINIDO','I.R.P.F',''),(8628444,8777,NULL,2,5,'','ENFERMEDAD COMÚN','GARANTIZADO',''),(8628445,8777,NULL,2,5,'','ENFERMEDAD PROFESIONAL','GARANTIZADO',''),(8628446,8777,NULL,2,5,'','DEVENGO FUERA','EXTRA',''),(8628447,8777,NULL,2,5,'','SIN I.Ts','GARANTIZADOS',''),(8628448,8777,NULL,2,5,'','Y PROFESIONAL','GARANTIZADO','ENFERMEDAD COMÚN'),(8628449,8777,NULL,2,5,'','ENFERMEDAD COMÚN','GARANTIZADOS',''),(8628450,8777,NULL,2,5,'','ENFERMEDAD PROFESIONAL','GARANTIZADOS',''),(8628452,8783,NULL,2,5,'','GARDO SUPERIOR','TITULADO',''),(8628453,8783,NULL,2,5,'','GRADO MEDIO','TITULADO',''),(8628454,8783,NULL,2,5,'','CALCULO EN DISEÑO','TÉCNICO',''),(8628455,8783,NULL,2,5,'','DE 2ª ( ENFERMEDAD COMÚN > 15 DIAS )','JEFE',''),(8628456,8783,NULL,2,5,'','ADMINISTRATIVO (ENFERMEDAD PROFESIONAL)','OFICIAL 1ª',''),(8628457,8783,NULL,2,5,'','ADMINISTRATIVO (MATERNIDAD)','OFICIAL 2ª',''),(8628458,8777,NULL,2,5,'','100%','GARANTIZADO',''),(8628459,8777,NULL,2,5,'','EXTRAS CON GARANTIZADO','GARANTIZADO',''),(8628460,8777,NULL,2,5,'','SALARIO BASE','NOMINA',''),(8628461,8777,NULL,2,5,'','EXTRAS','NOMINA',''),(8628462,8777,NULL,2,5,'','OFICINAS Y DESPACHOS MADRID','NOMINAS',''),(8628464,8784,NULL,2,5,'','DE RECEPCIÓN','JEFE',''),(8628465,8784,NULL,2,5,'','-','CAFETERO',''),(8628466,8777,NULL,2,5,'','EMBARGABLE','MAX',''),(8628467,8777,NULL,2,5,'','ENFERMEDAD COMÚN (BASES)','BRUTO',''),(8628468,8783,NULL,2,5,'','I','CATEGORIA',''),(8628469,8783,NULL,2,5,'','II','GATEGORIA',''),(8628470,8783,NULL,2,5,'','EMPLEADO','ANTIGUO',''),(8628471,8777,NULL,2,5,'','IT','EXTRAS',''),(8628472,8777,NULL,2,5,'','MÍNIMA IT ( GRUPO 01 )','BASE',''),(8628473,8777,NULL,2,5,'','MÍNIMA ( GRUPO 07 )','BASE',''),(8628475,8777,NULL,2,5,'','PENSIÓN ALIMENTICIA','IMPAGO',''),(8628476,8783,NULL,2,5,'','CATEGORIA 1','BORRAR',''),(8628477,8783,NULL,2,5,'','CATEGORIA 5','BORRAR',''),(8628478,8777,NULL,2,5,'','NO DISFRUTADAS (> 1 MES)','VACACIONES',''),(8628479,8777,NULL,2,5,'','INDEFINIDO','I.R.P.F BIZKAIA TIEMPO COMPLETO','ORDINARIO'),(8628480,8777,NULL,2,5,'','INDEFINIDO','I.R.P.F GIPUZKOA TIEMPO COMPLETO','ORDINARIO'),(8628481,8777,NULL,2,5,'','CERO','COTIZACIÓN',''),(8628482,8777,NULL,2,5,'','MÁX','COTIZACIÓN',''),(8628483,8777,NULL,2,5,'','REDEFINIDO','FINIQUITO',''),(8628484,8777,NULL,2,5,'','IT (REDEFINIDO)','EXTRAS',''),(8628485,8777,NULL,2,5,'','DIFERENCIAS','NOMINA',''),(8628486,8777,NULL,2,5,'','REDEFINIDA','BASE',''),(8628487,8777,NULL,2,5,'','VARIABLES','REDEFINIDAS',''),(8628488,8777,NULL,2,5,'','TRABAJADORES','ESTATUTO',''),(8628489,8777,NULL,2,5,'','(L M M J V ) 50%','INDEFINIDO','TIMEPO PARCIAL ORDINARIO'),(8628490,8777,NULL,2,5,'','( M M J V S D ) 50%','INDEFINIDO','TIEMPO PARCIAL ORDINARIO'),(8628491,8777,NULL,2,5,'','TRAMO I.T','COTIZACIÓN',''),(8628492,8777,NULL,2,5,'','NO ESTRUCTURALES','HORAS EXTRAS',''),(8628493,8777,NULL,2,5,'','ESTRUCTURALES','HORAS EXTRAS',''),(8628494,8777,NULL,2,5,'','FIJA','CONSTANTE',''),(8628495,8777,NULL,2,5,'','BRUTO','CONSTANTE',''),(8628496,8777,NULL,2,5,'','NETO','CONSTANTE',''),(8628497,8777,NULL,2,5,'','(L M ) NO LABORALES 25%','INDEFINIDO TIEMPO PARCIAL ORDINARIO',''),(8628498,8777,NULL,2,5,'','(J V) NO DEFINIDOS = NO LABORALES ','INDEFINIDO TIEMPO PARCIAL ORDINARIO',''),(8628501,8787,NULL,2,5,'','SISTEMAS','ANALISTA DE',''),(8628502,8787,NULL,2,5,'','ADMINISTRATIVO','JEFE 1ª',''),(8628503,8787,NULL,2,5,'','ADMINISTRATIVO','JEFE DE SECCIÓN',''),(8628504,8787,NULL,2,5,'','ORDENADOR','OPERADOR DE',''),(8628505,8787,NULL,2,5,'','2ª','OFICIAL',''),(8628506,8787,NULL,2,5,'','1º AÑO','CONTRATO PARA LA FORMACIÓN',''),(8628507,8787,NULL,2,5,'','2º AÑO','CONTRATO PARA LA FORMACIÓN',''),(8628508,8787,NULL,2,5,'','TIEMPO PARCIAL','PERSONAL DE LIMPIEZA',''),(8628509,8777,NULL,2,5,'','EMPLEADO','ANTIGUO',''),(8628510,8777,NULL,2,5,'','COEFICIENTE PARCIALIDAD','REDUCCIÓN','JORNADA'),(8628511,8777,NULL,2,5,'','HORAS','REDUCCIÓN','JORNADA'),(8628512,8777,NULL,2,5,'','INICIO ANTERIOR','REDUCCIONES RD-L 3/2014','TARIFA PLANA'),(8628513,8777,NULL,2,5,'','PARCIAL','MATERNIDAD',''),(8628514,8777,NULL,2,5,'','PARCIAL','PATERNIDAD',''),(8628515,8777,NULL,2,5,'','REDEFINIDAS','EXTRA',''),(8628516,8777,NULL,2,5,'','VACIO','DRAFT','COMPLETO'),(8628517,8777,NULL,2,5,'','CONVENIO','DRAFT','COMPLETO'),(8628518,8777,NULL,2,5,'','VACIO','DRAFT','PARCIAL'),(8628520,8788,NULL,2,5,'','SIN FRACCIONAR','TRAMO',''),(8628521,8788,NULL,2,5,'222222222222','SIN FRACCIONAR','TIEMPO COMPLETO',''),(8628522,8788,NULL,2,5,'111111111111','ALTAS y BAJAS','MÚLTIPLES',''),(8628523,8788,NULL,2,5,'33333333','15 PRIMEROS DIAS','INCAPACIDAD TEMPORAL',''),(8628524,8788,NULL,2,5,'444444444444','PAGO DELEGADO','INCAPACIDAD TEMPORAL',''),(8628525,8788,NULL,2,5,'555555555555','PAGO DELEGADO','INCAPACIDAD TEMPORAL','AT y EP'),(8628526,8777,NULL,2,5,'','SEMESTRALES Y TRIMESTREALES','EXTRAS ','ANUALES'),(8628527,8777,NULL,2,5,'','INCIDENCIA','COMPLEMENTO_I',''),(8628528,8777,NULL,2,5,'','TIEMPO_PARCIAL','COMPLEMENTO',''),(8628529,8777,NULL,2,5,'','CALENDARIO','TESTING','');
/*!40000 ALTER TABLE `person` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pm_type_detail`
--

DROP TABLE IF EXISTS `pm_type_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `pm_type_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `type` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Tipo de Forma de Pago',
  `description` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion del detalle',
  `account` int(4) DEFAULT NULL COMMENT 'Identificador de la Cuenta Contable',
  PRIMARY KEY (`id`),
  KEY `IDX_PM_TYPE_DETAIL_DOMAIN` (`domain`),
  KEY `IDX_PM_TYPE_DETAIL_ACCOUNT` (`account`),
  CONSTRAINT `FK_PM_TYPE_DETAIL_ACCOUNT` FOREIGN KEY (`account`) REFERENCES `account` (`id`),
  CONSTRAINT `FK_PM_TYPE_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalles por Tipo de Forma de Pago';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `pm_type_detail`
--

LOCK TABLES `pm_type_detail` WRITE;
/*!40000 ALTER TABLE `pm_type_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `pm_type_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pos`
--

DROP TABLE IF EXISTS `pos`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `pos` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `department` int(4) DEFAULT NULL COMMENT 'Identificador del Departamento',
  `workplace` int(4) NOT NULL COMMENT 'Identificador del Centro de Trabajo',
  `name` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre',
  `series` char(5) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Serie del POS',
  `customer` int(4) DEFAULT NULL COMMENT 'Identificador del Cliente',
  `price_editable` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indica si el precio es editable',
  `discount_editable` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indica si el descuento es editable',
  `invoiceable` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indica si el Punto de Venta es facturable',
  `item_invoice` int(4) DEFAULT NULL COMMENT 'Identificador del Articulo facturable',
  `display_mode` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Modo de visualizacion en pantalla',
  `num_rows` int(4) DEFAULT '0' COMMENT 'Numero de filas en la vista tipo Hosteleria',
  `num_cols` int(4) DEFAULT '0' COMMENT 'Numero de columnas en la vista tipo Hosteleria',
  `pin_pad` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indicador de si es un Pin Pad',
  `commerce` varchar(20) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Clave de firma del comercio',
  `signature_password` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Clave de firma del comercio',
  `terminal` varchar(4) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de terminal',
  `port_configuration` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Configuracion de puerto',
  `pos_version` varchar(8) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Version actual',
  `active` tinyint(1) DEFAULT '1' COMMENT 'Indica si el TPV esta activo o no',
  PRIMARY KEY (`id`),
  KEY `IDX_POS_WORKPLACE` (`workplace`),
  KEY `IDX_POS_DOMAIN` (`domain`),
  KEY `IDX_POS_DEPARTMENT` (`department`),
  KEY `IDX_POS_CUSTOMER` (`customer`),
  KEY `IDX_POS_ITEM_INVOICE` (`item_invoice`),
  CONSTRAINT `FK_POS_CUSTOMER` FOREIGN KEY (`customer`) REFERENCES `customer` (`registry`),
  CONSTRAINT `FK_POS_DEPARTMENT` FOREIGN KEY (`department`) REFERENCES `department` (`id`),
  CONSTRAINT `FK_POS_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_POS_ITEM_INVOICE` FOREIGN KEY (`item_invoice`) REFERENCES `item` (`id`),
  CONSTRAINT `FK_POS_WORKPLACE` FOREIGN KEY (`workplace`) REFERENCES `workplace` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='TPV';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `pos`
--

LOCK TABLES `pos` WRITE;
/*!40000 ALTER TABLE `pos` DISABLE KEYS */;
/*!40000 ALTER TABLE `pos` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pos_catalogue`
--

DROP TABLE IF EXISTS `pos_catalogue`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `pos_catalogue` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `pos` int(4) NOT NULL COMMENT 'Identificador del TPV',
  `catalogue` int(4) NOT NULL COMMENT 'Identificador del Catalogo',
  PRIMARY KEY (`id`),
  KEY `IDX_POS_CATALOGUE_CATALOGUE` (`catalogue`),
  KEY `IDX_POS_CATALOGUE_DOMAIN` (`domain`),
  KEY `IDX_POS_CATALOGUE_POS` (`pos`),
  CONSTRAINT `FK_POS_CATALOGUE_CATALOGUE` FOREIGN KEY (`catalogue`) REFERENCES `catalogue` (`id`),
  CONSTRAINT `FK_POS_CATALOGUE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_POS_CATALOGUE_POS` FOREIGN KEY (`pos`) REFERENCES `pos` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Catalogos asociados al TPV';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `pos_catalogue`
--

LOCK TABLES `pos_catalogue` WRITE;
/*!40000 ALTER TABLE `pos_catalogue` DISABLE KEYS */;
/*!40000 ALTER TABLE `pos_catalogue` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pos_shift`
--

DROP TABLE IF EXISTS `pos_shift`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `pos_shift` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `pos` int(4) NOT NULL COMMENT 'Identificador del TPV',
  `shift` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Turno de trabajo',
  `username` varchar(16) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Usuario del Turno',
  `start_time` datetime NOT NULL COMMENT 'Fecha-hora de apertura',
  `end_time` datetime DEFAULT NULL COMMENT 'Fecha-hora de cierre',
  `initial_amount` double(15,2) DEFAULT '0.00' COMMENT 'Efectivo inicial',
  `imbalance` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indica si existen descuadres en el Turno',
  `remarks` text COLLATE latin1_spanish_ci COMMENT 'Observaciones del turno',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_POS_SHIFT_POS` (`pos`),
  KEY `IDX_POS_SHIFT_DOMAIN` (`domain`),
  CONSTRAINT `FK_POS_SHIFT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_POS_SHIFT_POS` FOREIGN KEY (`pos`) REFERENCES `pos` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Turno de trabajo del TPV';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `pos_shift`
--

LOCK TABLES `pos_shift` WRITE;
/*!40000 ALTER TABLE `pos_shift` DISABLE KEYS */;
/*!40000 ALTER TABLE `pos_shift` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `pos_shift_count`
--

DROP TABLE IF EXISTS `pos_shift_count`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `pos_shift_count` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `pos_shift` int(4) NOT NULL COMMENT 'Identificador del Turno de trabajo',
  `pay_method` int(4) DEFAULT NULL COMMENT 'Identificador de la Forma de pago',
  `amount` double(15,2) DEFAULT '0.00' COMMENT 'Total efectivo',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_POS_SHIFT_COUNT_POS_SHIFT` (`pos_shift`),
  KEY `IDX_POS_SHIFT_COUNT_PAY_METHOD` (`pay_method`),
  KEY `IDX_POS_SHIFT_COUNT_DOMAIN` (`domain`),
  CONSTRAINT `FK_POS_SHIFT_COUNT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_POS_SHIFT_COUNT_PAY_METHOD` FOREIGN KEY (`pay_method`) REFERENCES `pay_method` (`id`),
  CONSTRAINT `FK_POS_SHIFT_COUNT_POS_SHIFT` FOREIGN KEY (`pos_shift`) REFERENCES `pos_shift` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Arqueo del TPV';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `pos_shift_count`
--

LOCK TABLES `pos_shift_count` WRITE;
/*!40000 ALTER TABLE `pos_shift_count` DISABLE KEYS */;
/*!40000 ALTER TABLE `pos_shift_count` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `prepayment`
--

DROP TABLE IF EXISTS `prepayment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `prepayment` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `creditor` int(4) NOT NULL COMMENT 'Identificador del Acreedor',
  `customer` int(4) NOT NULL COMMENT 'Identificador del Cliente',
  `finance` int(4) NOT NULL COMMENT 'Identificador del Vencimiento',
  `collect` tinyint(2) DEFAULT '0' COMMENT 'Localizacion del cobro del Suplido',
  `collect_id` int(4) DEFAULT NULL COMMENT 'Identificador del cobro del Suplido',
  PRIMARY KEY (`id`),
  KEY `IDX_PREPAYMENT_DOMAIN` (`domain`),
  KEY `IDX_PREPAYMENT_CREDITOR` (`creditor`),
  KEY `IDX_PREPAYMENT_CUSTOMER` (`customer`),
  KEY `IDX_PREPAYMENT_FINANCE` (`finance`),
  CONSTRAINT `FK_PREPAYMENT_CREDITOR` FOREIGN KEY (`creditor`) REFERENCES `creditor` (`registry`),
  CONSTRAINT `FK_PREPAYMENT_CUSTOMER` FOREIGN KEY (`customer`) REFERENCES `customer` (`registry`),
  CONSTRAINT `FK_PREPAYMENT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_PREPAYMENT_FINANCE` FOREIGN KEY (`finance`) REFERENCES `finance` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Suplidos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `prepayment`
--

LOCK TABLES `prepayment` WRITE;
/*!40000 ALTER TABLE `prepayment` DISABLE KEYS */;
/*!40000 ALTER TABLE `prepayment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `process`
--

DROP TABLE IF EXISTS `process`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `process` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Proceso',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `description` varchar(30) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion del Proceso.',
  `active` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'Activo si o no',
  PRIMARY KEY (`id`),
  KEY `IDX_PROCESS_DOMAIN` (`domain`),
  CONSTRAINT `FK_PROCESS_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Procesos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `process`
--

LOCK TABLES `process` WRITE;
/*!40000 ALTER TABLE `process` DISABLE KEYS */;
/*!40000 ALTER TABLE `process` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `process_detail`
--

DROP TABLE IF EXISTS `process_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `process_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Detalle de Proceso',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `process` int(4) NOT NULL COMMENT 'Identificador del Proceso',
  `description` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion del Detalle de Proceso',
  `position` int(4) NOT NULL COMMENT 'Orden de ejecucion del Detalle dentro del Proceso',
  `date_reference` tinyint(2) DEFAULT NULL COMMENT 'Referencia para el calculo de la fecha de vencimiento de la Tarea',
  `days` int(4) DEFAULT NULL COMMENT 'Numero de dias asociado a la referencia para el calculo de la fecha de vencimiento de la Tarea',
  `alert_days` int(4) DEFAULT NULL COMMENT 'Numero de dias, previos a la fecha de vencimiento de la Tarea, para el calculo de la fecha de generacion de la Alarma',
  `workgroup` int(4) DEFAULT NULL COMMENT 'Identificador del Grupo de Trabajo',
  `priority` tinyint(2) DEFAULT '0' COMMENT 'Prioridad de la Tarea',
  `active` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'Activo si o no',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios del Detalle de Proceso',
  PRIMARY KEY (`id`),
  KEY `IDX_PROCESS_DETAIL_PROCESS` (`process`),
  KEY `IDX_PROCESS_DETAIL_WORKGROUP` (`workgroup`),
  KEY `IDX_PROCESS_DETAIL_DOMAIN` (`domain`),
  CONSTRAINT `FK_PROCESS_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_PROCESS_DETAIL_PROCESS` FOREIGN KEY (`process`) REFERENCES `process` (`id`),
  CONSTRAINT `FK_PROCESS_DETAIL_WORKGROUP` FOREIGN KEY (`workgroup`) REFERENCES `workgroup` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalles de Procesos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `process_detail`
--

LOCK TABLES `process_detail` WRITE;
/*!40000 ALTER TABLE `process_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `process_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `process_detail_transition`
--

DROP TABLE IF EXISTS `process_detail_transition`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `process_detail_transition` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `process_detail` int(11) NOT NULL COMMENT 'Identificador del Detalle del Proceso.',
  `process_transition_type` int(11) NOT NULL COMMENT 'Identificador del Tipo de Transicion.',
  `next_process_detail` int(11) NOT NULL COMMENT 'Identificador del siguiente Detalle del Proceso.',
  PRIMARY KEY (`id`),
  KEY `IDX_PROCESS_DETAIL_TRANSITION_PROCESS_DETAIL` (`process_detail`),
  KEY `IDX_PROCESS_DETAIL_TRANSITION_NEXT_PROCESS_DETAIL` (`next_process_detail`),
  KEY `IDX_PROCESS_DETAIL_TRANSITION_PROCESS_TRANSITION_TYPE` (`process_transition_type`),
  KEY `IDX_PROCESS_DETAIL_TRANSITION_DOMAIN` (`domain`),
  CONSTRAINT `FK_PROCESS_DETAIL_TRANSITION_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_PROCESS_DETAIL_TRANSITION_NEXT_PROCESS_DETAIL` FOREIGN KEY (`next_process_detail`) REFERENCES `process_detail` (`id`),
  CONSTRAINT `FK_PROCESS_DETAIL_TRANSITION_PROCESS_DETAIL` FOREIGN KEY (`process_detail`) REFERENCES `process_detail` (`id`),
  CONSTRAINT `FK_PROCESS_DETAIL_TRANSITION_PROCESS_TRANSITION_TYPE` FOREIGN KEY (`process_transition_type`) REFERENCES `process_transition_type` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Tipos de Transiciones entre Detalles de Procesos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `process_detail_transition`
--

LOCK TABLES `process_detail_transition` WRITE;
/*!40000 ALTER TABLE `process_detail_transition` DISABLE KEYS */;
/*!40000 ALTER TABLE `process_detail_transition` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `process_task`
--

DROP TABLE IF EXISTS `process_task`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `process_task` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la Relacion entre Campañas, Actividades y Tareas',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `campaign` int(4) DEFAULT NULL COMMENT 'Identificador de la Campaña',
  `process_detail` int(4) NOT NULL COMMENT 'Identificador del Detalle de Proceso',
  `task` int(4) NOT NULL COMMENT 'Identificador de la Tarea',
  PRIMARY KEY (`id`),
  KEY `campaign` (`campaign`),
  KEY `IDX_PROCESS_TASK_CAMPAIGN` (`campaign`),
  KEY `IDX_PROCESS_TASK_TASK` (`task`),
  KEY `IDX_PROCESS_TASK_PROCESS_DETAIL` (`process_detail`),
  KEY `IDX_PROCESS_TASK_DOMAIN` (`domain`),
  CONSTRAINT `FK_PROCESS_TASK_CAMPAIGN` FOREIGN KEY (`campaign`) REFERENCES `campaign` (`id`),
  CONSTRAINT `FK_PROCESS_TASK_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_PROCESS_TASK_PROCESS_DETAIL` FOREIGN KEY (`process_detail`) REFERENCES `process_detail` (`id`),
  CONSTRAINT `FK_PROCESS_TASK_TASK` FOREIGN KEY (`task`) REFERENCES `task` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Relacion entre Campañas, Actividades y Tareas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `process_task`
--

LOCK TABLES `process_task` WRITE;
/*!40000 ALTER TABLE `process_task` DISABLE KEYS */;
/*!40000 ALTER TABLE `process_task` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `process_transition_type`
--

DROP TABLE IF EXISTS `process_transition_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `process_transition_type` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion del Tipo de Transicion',
  PRIMARY KEY (`id`),
  KEY `IDX_PROCESS_TRANSITION_TYPE_DOMAIN` (`domain`),
  CONSTRAINT `FK_PROCESS_TRANSITION_TYPE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Tipos de Transiciones entre Detalles de Procesos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `process_transition_type`
--

LOCK TABLES `process_transition_type` WRITE;
/*!40000 ALTER TABLE `process_transition_type` DISABLE KEYS */;
/*!40000 ALTER TABLE `process_transition_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product`
--

DROP TABLE IF EXISTS `product`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `product` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Producto',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre del Producto',
  `code` varchar(15) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Codigo del Producto',
  `kind` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Clase de Producto',
  `brand` int(4) DEFAULT NULL COMMENT 'Marca Comercial del Producto',
  `category` int(4) DEFAULT NULL COMMENT 'Categoria del Producto',
  `inventoriable` tinyint(1) DEFAULT NULL COMMENT 'Indica si el Producto es inventariable',
  `serializable` tinyint(1) DEFAULT '0' COMMENT 'Indica si el Producto es serializable',
  `lotable` tinyint(1) DEFAULT '0' COMMENT 'Indica si el Producto es loteable',
  `status` tinyint(2) DEFAULT '0' COMMENT 'Estado del Producto',
  `vat` int(4) DEFAULT NULL COMMENT 'IVA del Producto',
  `retention` int(4) DEFAULT NULL COMMENT 'Retencion del Producto',
  `type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de Producto',
  `manufactured` tinyint(1) DEFAULT '0' COMMENT 'Indica si el Producto es elaborado',
  `composition` tinyint(1) DEFAULT '0' COMMENT 'Indica si el Producto es una Composicion',
  `composition_price` tinyint(1) DEFAULT '0' COMMENT 'Indica si el Precio lo determina la Composicion',
  `packaged` tinyint(1) DEFAULT '0' COMMENT 'Indica si el Producto es envasado',
  `sales_account` int(4) DEFAULT NULL COMMENT 'Identificador de la Cuenta Contable de Ventas',
  `purchase_account` int(4) DEFAULT NULL COMMENT 'Identificador de la Cuenta Contable de Compras',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  UNIQUE KEY `IDX_PRODUCT_DOMAIN_CODE` (`domain`,`code`),
  KEY `IDX_PRODUCT_NAME` (`name`),
  KEY `IDX_PRODUCT_TAX_RETENTION` (`retention`),
  KEY `IDX_PRODUCT_PCATEGORY` (`category`),
  KEY `IDX_PRODUCT_BRAND` (`brand`),
  KEY `IDX_PRODUCT_TAX_VAT` (`vat`),
  KEY `IDX_PRODUCT_DOMAIN` (`domain`),
  KEY `IDX_PRODUCT_ACCOUNT_SALES` (`sales_account`),
  KEY `IDX_PRODUCT_ACCOUNT_PURCHASE` (`purchase_account`),
  CONSTRAINT `FK_PRODUCT_ACCOUNT_PURCHASE` FOREIGN KEY (`purchase_account`) REFERENCES `account` (`id`),
  CONSTRAINT `FK_PRODUCT_ACCOUNT_SALES` FOREIGN KEY (`sales_account`) REFERENCES `account` (`id`),
  CONSTRAINT `FK_PRODUCT_BRAND` FOREIGN KEY (`brand`) REFERENCES `brand` (`id`),
  CONSTRAINT `FK_PRODUCT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_PRODUCT_PCATEGORY` FOREIGN KEY (`category`) REFERENCES `pcategory` (`id`),
  CONSTRAINT `FK_PRODUCT_TAX_RETENTION` FOREIGN KEY (`retention`) REFERENCES `tax` (`id`),
  CONSTRAINT `FK_PRODUCT_TAX_VAT` FOREIGN KEY (`vat`) REFERENCES `tax` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Productos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `product`
--

LOCK TABLES `product` WRITE;
/*!40000 ALTER TABLE `product` DISABLE KEYS */;
/*!40000 ALTER TABLE `product` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `product_tag`
--

DROP TABLE IF EXISTS `product_tag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `product_tag` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `product` int(4) NOT NULL COMMENT 'Identificador del Producto',
  `tag` int(4) NOT NULL COMMENT 'Identificador de la Etiqueta',
  PRIMARY KEY (`id`),
  KEY `IDX_PRODUCT_TAG_DOMAIN` (`domain`),
  KEY `IDX_PRODUCT_TAG_PRODUCT` (`product`),
  KEY `IDX_PRODUCT_TAG_TAG` (`tag`),
  CONSTRAINT `FK_PRODUCT_TAG_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_PRODUCT_TAG_PRODUCT` FOREIGN KEY (`product`) REFERENCES `product` (`id`),
  CONSTRAINT `FK_PRODUCT_TAG_TAG` FOREIGN KEY (`tag`) REFERENCES `tag` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Relacion entre Productos y Etiquetas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `product_tag`
--

LOCK TABLES `product_tag` WRITE;
/*!40000 ALTER TABLE `product_tag` DISABLE KEYS */;
/*!40000 ALTER TABLE `product_tag` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `profile`
--

DROP TABLE IF EXISTS `profile`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `profile` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `name` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre del Perfil',
  `application` int(4) NOT NULL COMMENT 'Identificador de la Aplicacion',
  `domain` int(4) DEFAULT NULL COMMENT 'Identificador del Dominio',
  PRIMARY KEY (`id`),
  KEY `IDX_PROFILE_APPLICATION` (`application`),
  KEY `IDX_PROFILE_DOMAIN` (`domain`),
  CONSTRAINT `FK_PROFILE_APPLICATION` FOREIGN KEY (`application`) REFERENCES `application` (`id`),
  CONSTRAINT `FK_PROFILE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1264 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Perfiles';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `profile`
--

LOCK TABLES `profile` WRITE;
/*!40000 ALTER TABLE `profile` DISABLE KEYS */;
INSERT INTO `profile` VALUES (1,'AonAdmin',1,NULL),(2,'AonInvitado',1,NULL),(3,'Asesor',2,NULL),(4,'Invitado',2,NULL),(5,'Operador',2,NULL),(6,'AonAdmin',3,NULL),(7,'AonInvitado',3,NULL),(8,'AonInvitado',4,NULL),(9,'AonAdmin',5,NULL),(10,'Disenadores',5,NULL),(11,'Editores',5,NULL),(12,'Publicadores',5,NULL),(13,'Revisores',5,NULL),(14,'Administrador',6,NULL),(15,'Invitado',6,NULL),(16,'AonAdmin',7,NULL),(17,'AonInvitado',7,NULL),(18,'Administrador',8,NULL),(19,'Invitado',8,NULL),(20,'Administrador',9,NULL),(21,'Invitado',9,NULL),(22,'Administrador',10,NULL),(23,'User',10,NULL),(24,'Usuario',10,NULL),(25,'Administrador',11,NULL),(26,'Invitado',11,NULL),(27,'Administrador',12,NULL),(28,'Usuario',12,NULL),(29,'Administrador',13,NULL),(30,'Invitado',13,NULL),(31,'Administrador',14,NULL),(32,'Invitado',14,NULL),(33,'Administrador',15,NULL),(34,'Gestion',15,NULL),(35,'Invitado',15,NULL),(36,'Administrador',16,NULL),(37,'Gestion',16,NULL),(38,'Invitado',16,NULL),(39,'Administrador',17,NULL),(40,'Gestion',17,NULL),(41,'Invitado',17,NULL),(42,'Administrador',18,NULL),(43,'Gestion',18,NULL),(44,'Invitado',18,NULL),(45,'Operador',18,NULL),(46,'Administrador',19,NULL),(47,'Invitado',19,NULL),(48,'Administrador',20,NULL),(49,'Invitado',20,NULL),(50,'Programador',20,NULL),(51,'Administrador',21,NULL),(52,'Invitado',21,NULL),(53,'Operador',21,NULL),(54,'Administrador',22,NULL),(55,'Invitado',22,NULL),(56,'Monitor',22,NULL),(57,'Usuario',22,NULL),(58,'Administrador',23,NULL),(59,'Invitado',23,NULL),(60,'Administrador',24,NULL),(61,'Gestion',24,NULL),(62,'Invitado',24,NULL),(63,'Administrador',25,NULL),(64,'Invitado',25,NULL),(65,'Monitor',25,NULL),(66,'Usuario',25,NULL),(67,'Administrador',26,NULL),(68,'Administrador',27,NULL),(69,'Invitado',27,NULL),(70,'Usuario',27,NULL),(71,'Administrador',28,NULL),(72,'Gestion',28,NULL),(73,'Invitado',28,NULL),(1263,'Portal Laboral',28,NULL);
/*!40000 ALTER TABLE `profile` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `profile_action_denied`
--

DROP TABLE IF EXISTS `profile_action_denied`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `profile_action_denied` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `profile` int(4) NOT NULL COMMENT 'Identificador del Perfil',
  `action_id` int(4) NOT NULL COMMENT 'Identificador de la Accion',
  PRIMARY KEY (`id`),
  KEY `IDX_PROFILE_ACTION_DENIED_DOMAIN` (`domain`),
  KEY `IDX_PROFILE_ACTION_DENIED_PROFILE` (`profile`),
  KEY `IDX_PROFILE_ACTION_DENIED_ACTION` (`action_id`),
  CONSTRAINT `FK_PROFILE_ACTION_DENIED_ACTION` FOREIGN KEY (`action_id`) REFERENCES `action` (`id`),
  CONSTRAINT `FK_PROFILE_ACTION_DENIED_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_PROFILE_ACTION_DENIED_PROFILE` FOREIGN KEY (`profile`) REFERENCES `profile` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Acciones Inhabilitadas en el Perfil';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `profile_action_denied`
--

LOCK TABLES `profile_action_denied` WRITE;
/*!40000 ALTER TABLE `profile_action_denied` DISABLE KEYS */;
/*!40000 ALTER TABLE `profile_action_denied` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `profile_module_denied`
--

DROP TABLE IF EXISTS `profile_module_denied`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `profile_module_denied` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) DEFAULT NULL COMMENT 'Identificador del Dominio',
  `profile` int(4) NOT NULL COMMENT 'Identificador del Perfil',
  `module` tinyint(2) NOT NULL COMMENT 'Modulo Inhabilitado para el Perfil',
  PRIMARY KEY (`id`),
  KEY `IDX_PROFILE_MODULE_DENIED_PROFILE` (`profile`),
  KEY `IDX_PROFILE_MODULE_DENIED_DOMAIN` (`domain`),
  CONSTRAINT `FK_PROFILE_MODULE_DENIED_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_PROFILE_MODULE_DENIED_PROFILE` FOREIGN KEY (`profile`) REFERENCES `profile` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1611 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Modulos Inhabilitados en el Perfil';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `profile_module_denied`
--

LOCK TABLES `profile_module_denied` WRITE;
/*!40000 ALTER TABLE `profile_module_denied` DISABLE KEYS */;
INSERT INTO `profile_module_denied` VALUES (272,NULL,1263,18),(292,NULL,1270,18),(293,NULL,1270,6),(294,NULL,1270,9),(295,NULL,1270,7),(296,NULL,1270,15),(297,NULL,1272,18),(298,NULL,1272,7),(299,NULL,1272,2),(300,NULL,1272,3),(315,NULL,1280,3),(318,NULL,1284,18),(319,NULL,1284,6),(320,NULL,1284,3),(324,NULL,1304,7),(325,NULL,1304,15),(328,NULL,1308,18),(329,NULL,1308,6),(330,NULL,1308,7),(338,NULL,1307,18),(339,NULL,1326,5),(345,NULL,1458,3),(346,NULL,1459,5),(347,NULL,1459,9),(348,NULL,1461,18),(350,NULL,1462,6),(352,NULL,1462,7),(353,NULL,1462,8),(358,NULL,1463,18),(359,NULL,1463,2),(360,NULL,1463,8),(361,NULL,1463,3),(363,NULL,1465,9),(364,NULL,1465,5),(365,NULL,1467,9),(366,NULL,1467,5),(367,NULL,1468,9),(368,NULL,1468,5),(370,NULL,1473,9),(371,NULL,1473,5),(374,NULL,1478,5),(390,NULL,1489,17),(395,NULL,1278,7),(398,NULL,1528,5),(399,NULL,1536,5),(400,NULL,1537,18),(401,NULL,1537,6),(402,NULL,1537,9),(405,NULL,1537,3),(406,NULL,1537,0),(407,NULL,1538,8),(408,NULL,1539,6),(410,NULL,1550,18),(411,NULL,1549,18),(412,NULL,1297,18),(662,NULL,1537,5),(663,NULL,1537,2),(664,NULL,1635,4),(665,NULL,1635,18),(666,NULL,1635,9),(667,NULL,1635,5),(668,NULL,1635,2),(669,NULL,1635,0),(670,NULL,1635,3),(671,NULL,1099,18),(688,NULL,1656,5),(689,NULL,1663,4),(690,NULL,1663,18),(691,NULL,1663,6),(692,NULL,1663,3),(770,NULL,1723,18),(1001,NULL,1792,5),(1002,NULL,1793,5),(1003,NULL,1794,5),(1004,NULL,1799,6),(1006,NULL,1799,2),(1007,NULL,1799,7),(1008,NULL,1662,4),(1010,NULL,1662,18),(1011,NULL,1662,6),(1012,NULL,1662,9),(1013,NULL,1662,5),(1014,NULL,1662,2),(1015,NULL,1662,8),(1017,NULL,1662,16),(1018,NULL,1662,3),(1019,NULL,1484,14),(1020,NULL,1816,1),(1021,NULL,1816,6),(1022,NULL,1816,5),(1023,NULL,1816,0),(1024,NULL,1816,16),(1025,NULL,1829,5),(1026,NULL,1829,16),(1027,NULL,1832,5),(1028,NULL,1832,0),(1029,NULL,1832,16),(1030,NULL,1833,4),(1032,NULL,1833,18),(1033,NULL,1833,5),(1035,NULL,1833,0),(1036,NULL,1833,16),(1037,NULL,1834,1),(1038,NULL,1834,18),(1039,NULL,1834,6),(1040,NULL,1834,2),(1041,NULL,1834,0),(1042,NULL,1834,3),(1043,NULL,1836,18),(1044,NULL,1836,6),(1045,NULL,1836,7),(1046,NULL,1836,14),(1047,NULL,1836,3),(1048,NULL,1840,14),(1049,NULL,1852,18),(1050,NULL,1852,9),(1051,NULL,1852,5),(1052,NULL,1831,4),(1053,NULL,1831,1),(1054,NULL,1831,6),(1055,NULL,1831,5),(1056,NULL,1831,0),(1057,NULL,1831,16),(1058,NULL,1855,5),(1059,NULL,1874,5),(1061,NULL,1493,6),(1062,NULL,1492,6),(1063,NULL,1886,4),(1064,NULL,1886,1),(1067,NULL,1886,2),(1068,NULL,1886,0),(1069,NULL,1886,16),(1070,NULL,1886,3),(1071,NULL,1886,18),(1072,NULL,1889,4),(1073,NULL,1889,1),(1074,NULL,1889,18),(1075,NULL,1889,0),(1076,NULL,1889,16),(1077,NULL,1889,3),(1079,NULL,1890,0),(1080,NULL,1493,3),(1082,NULL,1891,18),(1083,NULL,1891,6),(1084,NULL,1891,9),(1085,NULL,1891,5),(1086,NULL,1891,0),(1087,NULL,1891,16),(1088,NULL,1891,3),(1091,NULL,1893,0),(1092,NULL,1893,16),(1093,NULL,1893,3),(1094,NULL,1449,4),(1096,NULL,1449,18),(1097,NULL,1449,6),(1099,NULL,1449,5),(1100,NULL,1449,7),(1101,NULL,1449,2),(1102,NULL,1449,8),(1104,NULL,1449,16),(1105,NULL,1449,3),(1195,NULL,1957,5),(1198,NULL,1960,18),(1199,NULL,1960,6),(1200,NULL,1960,7),(1201,NULL,1960,16),(1202,NULL,1960,3),(1203,NULL,1890,6),(1204,NULL,1890,9),(1205,NULL,1893,6),(1206,NULL,1893,9),(1207,NULL,1961,5),(1208,NULL,1449,1),(1209,NULL,1963,9),(1210,NULL,1963,5),(1211,NULL,1890,18),(1212,NULL,1893,18),(1224,NULL,1981,4),(1225,NULL,1981,18),(1226,NULL,1981,6),(1227,NULL,1981,9),(1228,NULL,1981,5),(1229,NULL,1981,2),(1230,NULL,1981,0),(1231,NULL,1981,16),(1232,NULL,1981,3),(1233,NULL,1982,5),(1235,NULL,1680,4),(1236,NULL,1680,18),(1237,NULL,1680,6),(1238,NULL,1680,9),(1239,NULL,1680,2),(1240,NULL,1680,8),(1241,NULL,1680,16),(1242,NULL,1680,3),(1244,NULL,1991,16),(1245,NULL,1992,18),(1246,NULL,1992,6),(1247,NULL,1992,5),(1248,NULL,1992,7),(1249,NULL,1992,2),(1250,NULL,1992,0),(1251,NULL,1993,4),(1252,NULL,1993,1),(1253,NULL,1993,18),(1254,NULL,1993,6),(1255,NULL,1993,5),(1256,NULL,1993,7),(1257,NULL,1993,2),(1258,NULL,1993,0),(1259,NULL,1993,3),(1261,NULL,1996,18),(1263,NULL,2007,1),(1264,NULL,2007,18),(1265,NULL,2007,6),(1266,NULL,2007,5),(1267,NULL,2007,0),(1268,NULL,2007,16),(1269,NULL,2007,3),(1270,NULL,2007,9),(1274,NULL,2007,4),(1288,NULL,2015,9),(1289,NULL,2015,5),(1290,NULL,2015,0),(1291,NULL,2015,16),(1293,NULL,2055,6),(1294,NULL,2055,3),(1295,NULL,2054,3),(1301,NULL,2056,6),(1304,NULL,2056,3),(1305,NULL,2054,6),(1306,NULL,2054,5),(1307,NULL,2054,2),(1326,NULL,2070,18),(1327,NULL,2070,2),(1328,NULL,2070,4),(1329,NULL,2071,4),(1330,NULL,2071,1),(1331,NULL,2071,18),(1332,NULL,2071,9),(1333,NULL,2071,5),(1334,NULL,2071,2),(1335,NULL,2071,0),(1336,NULL,2071,14),(1337,NULL,2071,3),(1344,NULL,2078,9),(1345,NULL,2081,4),(1346,NULL,2081,1),(1347,NULL,2081,5),(1348,NULL,2081,14),(1349,NULL,2081,16),(1359,NULL,2097,16),(1360,NULL,2092,16),(1361,NULL,2098,16),(1363,NULL,2100,18),(1366,NULL,2100,2),(1367,NULL,2100,0),(1368,NULL,2100,3),(1369,NULL,2100,16),(1370,NULL,2102,6),(1371,NULL,2102,7),(1372,NULL,2102,8),(1373,NULL,2114,6),(1374,NULL,2114,3),(1380,NULL,2115,16),(1381,NULL,2115,3),(1382,NULL,2122,4),(1383,NULL,2122,9),(1384,NULL,2122,5),(1385,NULL,2122,7),(1386,NULL,2122,8),(1387,NULL,2122,16),(1389,NULL,2011,3),(1390,NULL,2011,16),(1392,NULL,2127,4),(1393,NULL,2127,18),(1394,NULL,2127,16),(1395,NULL,2127,8),(1398,NULL,2150,4),(1399,NULL,2150,1),(1400,NULL,2150,18),(1401,NULL,2150,6),(1402,NULL,2150,7),(1403,NULL,2150,8),(1404,NULL,2150,0),(1405,NULL,2150,3),(1406,NULL,2153,4),(1407,NULL,2153,18),(1408,NULL,2153,2),(1409,NULL,2159,18),(1410,NULL,2159,2),(1425,NULL,2167,4),(1426,NULL,2167,18),(1427,NULL,2167,2),(1428,NULL,2169,5),(1429,NULL,2169,0),(1430,NULL,2172,4),(1431,NULL,2172,1),(1432,NULL,2172,5),(1433,NULL,2172,2),(1434,NULL,2172,0),(1435,NULL,2172,3),(1436,NULL,2172,16),(1452,NULL,2163,6),(1465,NULL,2192,18),(1466,NULL,2192,6),(1467,NULL,2192,7),(1468,NULL,2192,8),(1469,NULL,2192,4),(1470,NULL,2192,1),(1471,NULL,2192,5),(1472,NULL,2192,2),(1473,NULL,2192,0),(1474,NULL,2192,3),(1475,NULL,2192,16),(1480,NULL,2194,4),(1481,NULL,2194,6),(1482,NULL,2194,7),(1484,NULL,2194,8),(1485,NULL,2194,3),(1486,NULL,2194,16),(1489,NULL,2194,9),(1490,NULL,2197,4),(1491,NULL,2197,18),(1492,NULL,2197,6),(1493,NULL,2197,9),(1494,NULL,2197,2),(1495,NULL,2197,3),(1496,NULL,2197,16),(1505,NULL,1069,9),(1509,NULL,2210,14),(1510,NULL,1626,18),(1511,NULL,1663,5),(1513,NULL,1663,16),(1516,NULL,2214,18),(1522,NULL,2223,18),(1523,NULL,2223,6),(1525,NULL,2223,3),(1526,NULL,2223,16),(1527,NULL,2224,6),(1528,NULL,2129,4),(1529,NULL,2129,1),(1530,NULL,2129,18),(1531,NULL,2129,6),(1532,NULL,2129,5),(1533,NULL,2129,7),(1534,NULL,2129,2),(1535,NULL,2129,8),(1536,NULL,2129,0),(1537,NULL,2129,3),(1538,NULL,2129,16),(1542,NULL,1095,0),(1543,NULL,1095,16),(1544,NULL,2229,4),(1545,NULL,2229,1),(1546,NULL,2229,18),(1547,NULL,2229,5),(1548,NULL,2229,0),(1549,NULL,2229,16),(1568,NULL,2211,18),(1569,NULL,2241,4),(1570,NULL,2241,18),(1571,NULL,2241,6),(1572,NULL,2241,9),(1573,NULL,2241,2),(1574,NULL,2241,8),(1575,NULL,2241,0),(1576,NULL,2241,14),(1577,NULL,2241,3),(1578,NULL,2241,16),(1580,NULL,2253,2),(1582,NULL,2258,18),(1593,NULL,2268,0),(1595,NULL,2268,18),(1609,NULL,2268,5),(1610,NULL,2288,18);
/*!40000 ALTER TABLE `profile_module_denied` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `profile_role`
--

DROP TABLE IF EXISTS `profile_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `profile_role` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) DEFAULT NULL COMMENT 'Identificador del Dominio',
  `profile` int(4) NOT NULL COMMENT 'Identificador del Perfil',
  `application_role` int(4) NOT NULL COMMENT 'Identificador del Role de la Aplicacion',
  PRIMARY KEY (`id`),
  KEY `IDX_PROFILE_ROLE_PROFILE` (`profile`),
  KEY `IDX_PROFILE_ROLE_APPLICATION_ROLE` (`application_role`),
  KEY `IDX_PROFILE_ROLE_DOMAIN` (`domain`),
  CONSTRAINT `FK_PROFILE_ROLE_APPLICATION_ROLE` FOREIGN KEY (`application_role`) REFERENCES `application_role` (`id`),
  CONSTRAINT `FK_PROFILE_ROLE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_PROFILE_ROLE_PROFILE` FOREIGN KEY (`profile`) REFERENCES `profile` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4868 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Roles del Perfil';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `profile_role`
--

LOCK TABLES `profile_role` WRITE;
/*!40000 ALTER TABLE `profile_role` DISABLE KEYS */;
INSERT INTO `profile_role` VALUES (2,NULL,71,219),(4,NULL,72,220),(5,NULL,72,221),(6,NULL,72,223),(7,NULL,72,224),(8,NULL,72,225),(9,NULL,72,226),(10,NULL,72,227),(11,NULL,72,229),(12,NULL,72,230),(13,NULL,72,232),(15,NULL,73,218),(4613,NULL,71,219),(4614,NULL,72,220),(4615,NULL,72,221),(4616,NULL,72,223),(4617,NULL,72,224),(4618,NULL,72,225),(4619,NULL,72,226),(4620,NULL,72,227),(4621,NULL,72,229),(4622,NULL,72,230),(4623,NULL,72,232),(4624,NULL,73,218),(4866,NULL,1263,218),(4867,NULL,1263,234);
/*!40000 ALTER TABLE `profile_role` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `project`
--

DROP TABLE IF EXISTS `project`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `project` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre del Proyecto',
  `alias` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Alias del Proyecto',
  `registry` int(4) NOT NULL COMMENT 'Identificador del Cliente (Potencial) asociado',
  `date` date NOT NULL COMMENT 'Fecha del Proyecto',
  `project_type` int(4) DEFAULT NULL COMMENT 'Tipo de Proyecto',
  `tas` tinyint(1) DEFAULT '0' COMMENT 'Indica si se trata de una Orden de Reparacion o Fabricacion',
  `commercial` tinyint(1) DEFAULT '0' COMMENT 'Indica si se trata de una Operacion Comercial',
  `reservation` tinyint(1) DEFAULT '0' COMMENT 'Indica si se trata de una Reserva',
  `active` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'Indica si el Proyecto esta activo o no',
  PRIMARY KEY (`id`),
  KEY `IDX_PROJECT_REGISTRY` (`registry`),
  KEY `IDX_PROJECT_PROJECT_TYPE` (`project_type`),
  KEY `IDX_PROJECT_DOMAIN` (`domain`),
  CONSTRAINT `FK_PROJECT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_PROJECT_PROJECT_TYPE` FOREIGN KEY (`project_type`) REFERENCES `project_type` (`id`),
  CONSTRAINT `FK_PROJECT_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Proyectos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `project`
--

LOCK TABLES `project` WRITE;
/*!40000 ALTER TABLE `project` DISABLE KEYS */;
/*!40000 ALTER TABLE `project` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `project_activity`
--

DROP TABLE IF EXISTS `project_activity`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `project_activity` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la Actividad',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `project` int(4) NOT NULL COMMENT 'Identificador del Expendiente',
  `activity_type` int(4) NOT NULL COMMENT 'Tipo de Actividad',
  `active` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'Activo, si o no',
  PRIMARY KEY (`id`),
  KEY `IDX_PROJECT_ACTIVITY_ACTIVITY_TYPE` (`activity_type`),
  KEY `IDX_PROJECT_ACTIVITY_PROJECT` (`project`),
  KEY `IDX_PROJECT_ACTIVITY_DOMAIN` (`domain`),
  CONSTRAINT `FK_PROJECT_ACTIVITY_ACTIVITY_TYPE` FOREIGN KEY (`activity_type`) REFERENCES `activity_type` (`id`),
  CONSTRAINT `FK_PROJECT_ACTIVITY_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_PROJECT_ACTIVITY_PROJECT` FOREIGN KEY (`project`) REFERENCES `project` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Actividades';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `project_activity`
--

LOCK TABLES `project_activity` WRITE;
/*!40000 ALTER TABLE `project_activity` DISABLE KEYS */;
/*!40000 ALTER TABLE `project_activity` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `project_attach`
--

DROP TABLE IF EXISTS `project_attach`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `project_attach` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `project` int(4) NOT NULL COMMENT 'Identificador del Proyecto',
  `mimeType` tinyint(2) DEFAULT '0' COMMENT 'Mime Type del Archivo Adjunto',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion del Archivo Adjunto',
  `data` mediumblob COMMENT 'Archivo Adjunto en binario',
  `security_level` tinyint(2) DEFAULT '0' COMMENT 'Nivel de seguridad del Archivo Adjunto',
  `attach_date` date DEFAULT NULL COMMENT 'Fecha del Archivo Adjunto',
  `attach_type` tinyint(2) DEFAULT '0' COMMENT 'Tipo de Archivo Adjunto',
  `driveId` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL,
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_PROJECT_ATTACH_DOMAIN` (`domain`),
  KEY `IDX_PROJECT_ATTACH_PROJECT` (`project`),
  CONSTRAINT `FK_PROJECT_ATTACH_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_PROJECT_ATTACH_PROJECT` FOREIGN KEY (`project`) REFERENCES `project` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Archivos Adjuntos de Proyectos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `project_attach`
--

LOCK TABLES `project_attach` WRITE;
/*!40000 ALTER TABLE `project_attach` DISABLE KEYS */;
/*!40000 ALTER TABLE `project_attach` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `project_commercial`
--

DROP TABLE IF EXISTS `project_commercial`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `project_commercial` (
  `project` int(4) NOT NULL COMMENT 'Identificador del Proyecto',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `target` int(4) NOT NULL COMMENT 'Identificador del Cliente Potencial',
  `seller` int(4) DEFAULT NULL COMMENT 'Identificador del Comercial',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios',
  `source` tinyint(2) NOT NULL COMMENT 'Origen del Proyecto',
  `status` tinyint(2) NOT NULL COMMENT 'Estado del Proyecto',
  `status_date` date DEFAULT NULL COMMENT 'Fecha del Estado del Proyecto',
  `probability` int(4) DEFAULT NULL COMMENT 'Probabilidad del Proyecto',
  PRIMARY KEY (`project`),
  KEY `IDX_PROJECT_COMMERCIAL_TARGET` (`target`),
  KEY `IDX_PROJECT_COMMERCIAL_SELLER` (`seller`),
  KEY `IDX_PROJECT_COMMERCIAL_DOMAIN` (`domain`),
  CONSTRAINT `FK_PROJECT_COMMERCIAL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_PROJECT_COMMERCIAL_PROJECT` FOREIGN KEY (`project`) REFERENCES `project` (`id`),
  CONSTRAINT `FK_PROJECT_COMMERCIAL_SELLER` FOREIGN KEY (`seller`) REFERENCES `seller` (`registry`),
  CONSTRAINT `FK_PROJECT_COMMERCIAL_TARGET` FOREIGN KEY (`target`) REFERENCES `target` (`registry`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Operaciones Comerciales';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `project_commercial`
--

LOCK TABLES `project_commercial` WRITE;
/*!40000 ALTER TABLE `project_commercial` DISABLE KEYS */;
/*!40000 ALTER TABLE `project_commercial` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `project_reservation`
--

DROP TABLE IF EXISTS `project_reservation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `project_reservation` (
  `project` int(4) NOT NULL COMMENT 'Identificador del Proyecto',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `hotel` int(4) NOT NULL COMMENT 'Identificador del Hotel de Produccion',
  `hotel_reservation` int(4) NOT NULL COMMENT 'Identificador del Hotel de la Reserva',
  `code` varchar(48) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Localizador de la Reserva',
  `start_date` date NOT NULL COMMENT 'Fecha de entrada',
  `start_time` datetime NOT NULL COMMENT 'Hora de entrada',
  `end_date` date NOT NULL COMMENT 'Fecha de salida',
  `end_time` datetime NOT NULL COMMENT 'Hora de salida',
  `seller` int(4) DEFAULT NULL COMMENT 'Identificador del canal de venta',
  `agency` int(4) DEFAULT NULL COMMENT 'Identificador de la agencia de viajes',
  `agency_commission_percent` double(5,2) DEFAULT '0.00' COMMENT 'Porcentaje de comision de la agencia',
  `agency_commission_amount` double(15,2) DEFAULT '0.00' COMMENT 'Importe de comision de la agencia',
  `agency_rebate` tinyint(1) NOT NULL COMMENT 'Indica si la agencia trabaja en modo descuento o no',
  `company` int(4) DEFAULT NULL COMMENT 'Identificador de la empresa',
  `discount_percent` double(5,2) DEFAULT '0.00' COMMENT 'Porcentaje de descuento',
  `discount_amount` double(15,2) DEFAULT '0.00' COMMENT 'Importe de descuento',
  `booking_holder` tinyint(2) NOT NULL COMMENT 'Titular de la Reserva',
  `taxable_base` double(15,2) DEFAULT '0.00' COMMENT 'Base imponible',
  `vat_quota` double(15,2) DEFAULT '0.00' COMMENT 'Cuota de IVA',
  `other_tax_quota` double(15,2) DEFAULT '0.00' COMMENT 'Cuota de otros Impuestos',
  `total` double(15,2) DEFAULT '0.00' COMMENT 'Importe Total',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios',
  `remarks` text COLLATE latin1_spanish_ci COMMENT 'Observaciones',
  `source` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Origen de la Reserva',
  `crs_code` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo de la Reserva en el CRS',
  `advance` double(15,2) NOT NULL DEFAULT '0.00' COMMENT 'Anticipo',
  `advance_invoiced` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indica si el anticipo esta Facturado',
  `early_check_out` tinyint(1) DEFAULT '0' COMMENT 'Indica si se ha producido una salida anticipada',
  `prepay` tinyint(1) DEFAULT '0' COMMENT 'Indica si es un prepago',
  `bank_transaction` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo de transaccion bancaria',
  `credit_card_number` varchar(4) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Ultimos 4 numeros de la tarjeta de credito',
  `credit_card_expiration_month` varchar(2) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Mes de expiracion de la tarjeta de credito',
  `credit_card_expiration_year` varchar(2) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Año de expiracion de la tarjeta de credito',
  `credit_card_type` varchar(2) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Tipo de tarjeta de credito',
  `token` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Token de preautorizacion de cobro',
  `penalty_value` varchar(4) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Valor de penalizacion (patron)',
  `penalty_amount` double(15,2) DEFAULT '0.00' COMMENT 'Importe de penalizacion',
  `penalty_date` datetime DEFAULT NULL COMMENT 'Fecha de penalizacion',
  `tourist_tax_free` tinyint(2) DEFAULT NULL COMMENT 'Tipo de exencion de la Tasa turistica',
  `check_status` tinyint(2) NOT NULL COMMENT 'Estado de registro en el Hotel',
  `status` tinyint(2) NOT NULL COMMENT 'Estado de la Reserva',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  `cancellation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de cancelacion',
  `cancellation_date` datetime DEFAULT NULL COMMENT 'Fecha de cancelacion',
  PRIMARY KEY (`project`),
  KEY `IDX_PROJECT_RESERVATION_CODE` (`code`),
  KEY `IDX_PROJECT_RESERVATION_HOTEL` (`hotel`),
  KEY `IDX_PROJECT_RESERVATION_SELLER` (`seller`),
  KEY `IDX_PROJECT_RESERVATION_AGENCY` (`agency`),
  KEY `IDX_PROJECT_RESERVATION_COMPANY` (`company`),
  KEY `IDX_PROJECT_RESERVATION_DOMAIN` (`domain`),
  KEY `IDX_PROJECT_RESERVATION_HOTEL_RESERVATION` (`hotel_reservation`),
  KEY `IDX_PROJECT_RESERVATION_CRS_CODE` (`crs_code`),
  KEY `IDX_PROJECT_RESERVATION_START_DATE` (`start_date`),
  CONSTRAINT `FK_PROJECT_RESERVATION_AGENCY` FOREIGN KEY (`agency`) REFERENCES `customer` (`registry`),
  CONSTRAINT `FK_PROJECT_RESERVATION_COMPANY` FOREIGN KEY (`company`) REFERENCES `customer` (`registry`),
  CONSTRAINT `FK_PROJECT_RESERVATION_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_PROJECT_RESERVATION_HOTEL` FOREIGN KEY (`hotel`) REFERENCES `hotel` (`id`),
  CONSTRAINT `FK_PROJECT_RESERVATION_HOTEL_RESERVATION` FOREIGN KEY (`hotel_reservation`) REFERENCES `hotel` (`id`),
  CONSTRAINT `FK_PROJECT_RESERVATION_PROJECT` FOREIGN KEY (`project`) REFERENCES `project` (`id`),
  CONSTRAINT `FK_PROJECT_RESERVATION_SELLER` FOREIGN KEY (`seller`) REFERENCES `seller` (`registry`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Reservas de Hotel';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `project_reservation`
--

LOCK TABLES `project_reservation` WRITE;
/*!40000 ALTER TABLE `project_reservation` DISABLE KEYS */;
/*!40000 ALTER TABLE `project_reservation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `project_reservation_divert`
--

DROP TABLE IF EXISTS `project_reservation_divert`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `project_reservation_divert` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `project_reservation` int(4) NOT NULL COMMENT 'Identificador de la Reserva',
  `request_hotel` int(4) NOT NULL COMMENT 'Identificador del Hotel solicitante',
  `divert_hotel` int(4) NOT NULL COMMENT 'Identificador del Hotel destino',
  `divert_date` date NOT NULL COMMENT 'Fecha de Desvio',
  `status` tinyint(2) DEFAULT '0' COMMENT 'Estado del Desvio',
  `request_user` int(4) DEFAULT NULL COMMENT 'Identificador del Usuario solicitante',
  `response_user` int(4) DEFAULT NULL COMMENT 'Identificador del Usuario de respuesta',
  PRIMARY KEY (`id`),
  KEY `IDX_PROJECT_RESERVATION_DIVERT_DOMAIN` (`domain`),
  KEY `IDX_PROJECT_RESERVATION_DIVERT_PROJECT_RESERVATION` (`project_reservation`),
  KEY `IDX_PROJECT_RESERVATION_DIVERT_REQUEST_HOTEL` (`request_hotel`),
  KEY `IDX_PROJECT_RESERVATION_DIVERT_DIVERT_HOTEL` (`divert_hotel`),
  KEY `IDX_PROJECT_RESERVATION_DIVERT_REQUEST_USER` (`request_user`),
  KEY `IDX_PROJECT_RESERVATION_DIVERT_RESPONSE_USER` (`response_user`),
  CONSTRAINT `FK_PROJECT_RESERVATION_DIVERT_DIVERT_HOTEL` FOREIGN KEY (`divert_hotel`) REFERENCES `hotel` (`id`),
  CONSTRAINT `FK_PROJECT_RESERVATION_DIVERT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_PROJECT_RESERVATION_DIVERT_PROJECT_RESERVATION` FOREIGN KEY (`project_reservation`) REFERENCES `project_reservation` (`project`),
  CONSTRAINT `FK_PROJECT_RESERVATION_DIVERT_REQUEST_HOTEL` FOREIGN KEY (`request_hotel`) REFERENCES `hotel` (`id`),
  CONSTRAINT `FK_PROJECT_RESERVATION_DIVERT_REQUEST_USER` FOREIGN KEY (`request_user`) REFERENCES `user` (`id`),
  CONSTRAINT `FK_PROJECT_RESERVATION_DIVERT_RESPONSE_USER` FOREIGN KEY (`response_user`) REFERENCES `user` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Desvio de Reservas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `project_reservation_divert`
--

LOCK TABLES `project_reservation_divert` WRITE;
/*!40000 ALTER TABLE `project_reservation_divert` DISABLE KEYS */;
/*!40000 ALTER TABLE `project_reservation_divert` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `project_reservation_guest`
--

DROP TABLE IF EXISTS `project_reservation_guest`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `project_reservation_guest` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `project_reservation` int(4) NOT NULL COMMENT 'Identificador de la Reserva',
  `guest_index` tinyint(2) NOT NULL COMMENT 'Numero de Huesped',
  `name` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre',
  `surname` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Apellido 1',
  `surname2` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Apellido 2',
  `treatment` varchar(4) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Tratamiento',
  `document` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de documento de identificacion',
  `document_type` tinyint(2) DEFAULT '0' COMMENT 'Tipo de documento',
  `document_country` varchar(2) COLLATE latin1_spanish_ci DEFAULT 'ES' COMMENT 'Pais del documento',
  `document_exp_date` date DEFAULT NULL COMMENT 'Fecha de expiracion del documento',
  `birth_date` date DEFAULT NULL COMMENT 'Fecha de nacimiento',
  `email` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Email',
  `phone` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Telefono',
  `address` varchar(256) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Direccion',
  `number` varchar(12) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero',
  `address2` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Segunda parte de la Direccion',
  `zip` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo postal',
  `city` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Ciudad',
  `province` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Provincia',
  `country` varchar(3) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Pais',
  `barcode` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo de pulsera',
  `person` int(4) DEFAULT NULL COMMENT 'Identificador de la Persona',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_PROJECT_RESERVATION_GUEST_PROJECT_RESERVATION` (`project_reservation`),
  KEY `IDX_PROJECT_RESERVATION_GUEST_DOMAIN` (`domain`),
  KEY `IDX_PROJECT_RESERVATION_GUEST_PERSON` (`person`),
  CONSTRAINT `FK_PROJECT_RESERVATION_GUEST_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_PROJECT_RESERVATION_GUEST_PERSON` FOREIGN KEY (`person`) REFERENCES `person` (`registry`),
  CONSTRAINT `FK_PROJECT_RESERVATION_GUEST_PROJECT_RESERVATION` FOREIGN KEY (`project_reservation`) REFERENCES `project_reservation` (`project`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Huespedes por Reserva';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `project_reservation_guest`
--

LOCK TABLES `project_reservation_guest` WRITE;
/*!40000 ALTER TABLE `project_reservation_guest` DISABLE KEYS */;
/*!40000 ALTER TABLE `project_reservation_guest` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `project_reservation_room`
--

DROP TABLE IF EXISTS `project_reservation_room`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `project_reservation_room` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `project_reservation` int(4) NOT NULL COMMENT 'Identificador de la Reserva',
  `room_index` tinyint(2) NOT NULL COMMENT 'Numero de Habitacion',
  `room_code` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo de Habitacion en origen',
  `item` int(4) NOT NULL COMMENT 'Identificador del Tipo de Habitacion',
  `allotment_rate_code` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo de Cupo',
  `rate_plan` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo de Tarifa en origen',
  `tariff` int(4) NOT NULL COMMENT 'Identificador de la Tarifa',
  `adults` smallint(2) DEFAULT '0' COMMENT 'Numero de adultos',
  `children` smallint(2) DEFAULT '0' COMMENT 'Numero de nios',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_PROJECT_RESERVATION_ROOM_PROJECT_RESERVATION` (`project_reservation`),
  KEY `IDX_PROJECT_RESERVATION_ROOM_ITEM` (`item`),
  KEY `IDX_PROJECT_RESERVATION_ROOM_DOMAIN` (`domain`),
  KEY `IDX_PROJECT_RESERVATION_ROOM_TARIFF` (`tariff`),
  CONSTRAINT `FK_PROJECT_RESERVATION_ROOM_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_PROJECT_RESERVATION_ROOM_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`),
  CONSTRAINT `FK_PROJECT_RESERVATION_ROOM_PROJECT_RESERVATION` FOREIGN KEY (`project_reservation`) REFERENCES `project_reservation` (`project`),
  CONSTRAINT `FK_PROJECT_RESERVATION_ROOM_TARIFF` FOREIGN KEY (`tariff`) REFERENCES `tariff` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Habitaciones por Reserva';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `project_reservation_room`
--

LOCK TABLES `project_reservation_room` WRITE;
/*!40000 ALTER TABLE `project_reservation_room` DISABLE KEYS */;
/*!40000 ALTER TABLE `project_reservation_room` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `project_reservation_room_detail`
--

DROP TABLE IF EXISTS `project_reservation_room_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `project_reservation_room_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `project_reservation_room` int(4) NOT NULL COMMENT 'Identificador de la Habitacion de la Reserva',
  `asset_activity` int(4) NOT NULL COMMENT 'Identificador de la Actividad de la Habitacion',
  PRIMARY KEY (`id`),
  KEY `IDX_PROJECT_RESERVATION_ROOM_DETAIL_PROJECT_RESERVATION_ROOM` (`project_reservation_room`),
  KEY `IDX_PROJECT_RESERVATION_ROOM_DETAIL_ASSET_ACTIVITY` (`asset_activity`),
  KEY `IDX_PROJECT_RESERVATION_ROOM_DETAIL_DOMAIN` (`domain`),
  CONSTRAINT `FK_PROJECT_RESERVATION_ROOM_DETAIL_ASSET_ACTIVITY` FOREIGN KEY (`asset_activity`) REFERENCES `asset_activity` (`id`),
  CONSTRAINT `FK_PROJECT_RESERVATION_ROOM_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_PROJECT_RESERVATION_ROOM_DETAIL_PROJECT_RESERVATION_ROOM` FOREIGN KEY (`project_reservation_room`) REFERENCES `project_reservation_room` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalles de Habitacion por Reserva';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `project_reservation_room_detail`
--

LOCK TABLES `project_reservation_room_detail` WRITE;
/*!40000 ALTER TABLE `project_reservation_room_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `project_reservation_room_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `project_reservation_service`
--

DROP TABLE IF EXISTS `project_reservation_service`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `project_reservation_service` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `project_reservation` int(4) NOT NULL COMMENT 'Identificador de la Reserva',
  `service_index` tinyint(2) NOT NULL COMMENT 'Numero de Servicio',
  `service_code` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo del Servicio en origen',
  `item` int(4) NOT NULL COMMENT 'Identificador del Servicio',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion',
  `meal_plan` varchar(3) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Regimen',
  `project_reservation_room` int(4) DEFAULT NULL COMMENT 'Identificador de la Habitacion de la Reserva',
  `extra` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indica si se trata de un Servicio extra',
  `removed` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Servicio borrado',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_PROJECT_RESERVATION_SERVICE_PROJECT_RESERVATION` (`project_reservation`),
  KEY `IDX_PROJECT_RESERVATION_SERVICE_ITEM` (`item`),
  KEY `IDX_PROJECT_RESERVATION_SERVICE_DOMAIN` (`domain`),
  CONSTRAINT `FK_PROJECT_RESERVATION_SERVICE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_PROJECT_RESERVATION_SERVICE_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`),
  CONSTRAINT `FK_PROJECT_RESERVATION_SERVICE_PROJECT_RESERVATION` FOREIGN KEY (`project_reservation`) REFERENCES `project_reservation` (`project`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Servicios por Reserva';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `project_reservation_service`
--

LOCK TABLES `project_reservation_service` WRITE;
/*!40000 ALTER TABLE `project_reservation_service` DISABLE KEYS */;
/*!40000 ALTER TABLE `project_reservation_service` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `project_reservation_service_detail`
--

DROP TABLE IF EXISTS `project_reservation_service_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `project_reservation_service_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `project_reservation_service` int(4) NOT NULL COMMENT 'Identificador del Servicio de la Reserva',
  `project_reservation_room_detail` int(4) DEFAULT NULL COMMENT 'Identificador del Detalle de Habitacion de la Reserva',
  `effective_date` date NOT NULL COMMENT 'Fecha de efecto',
  `quantity` double(15,2) DEFAULT '0.00' COMMENT 'Cantidad',
  `price` double(15,4) DEFAULT '0.0000' COMMENT 'Precio',
  `taxable_base` double(15,4) DEFAULT '0.0000' COMMENT 'Base imponible',
  `taxable_base_production` double(15,4) DEFAULT '0.0000' COMMENT 'Base imponible de Produccion',
  `total_production` double(15,4) DEFAULT '0.0000' COMMENT 'Total Produccion acumulado',
  PRIMARY KEY (`id`),
  KEY `IDX_PROJECT_RESERVATION_SERVICE_DETAIL_DOMAIN` (`domain`),
  KEY `IDX_PRJ_RESERVATION_SERVICE_DETAIL_PRJ_RESERVATION_SERVICE` (`project_reservation_service`),
  KEY `IDX_PRJ_RESERVATION_SERVICE_DETAIL_PRJ_RESERVATION_ROOM_DETAIL` (`project_reservation_room_detail`),
  CONSTRAINT `FK_PRJ_RESERVATION_SERVICE_DETAIL_PRJ_RESERVATION_ROOM_DETAIL` FOREIGN KEY (`project_reservation_room_detail`) REFERENCES `project_reservation_room_detail` (`id`),
  CONSTRAINT `FK_PRJ_RESERVATION_SERVICE_DETAIL_PRJ_RESERVATION_SERVICE` FOREIGN KEY (`project_reservation_service`) REFERENCES `project_reservation_service` (`id`),
  CONSTRAINT `FK_PROJECT_RESERVATION_SERVICE_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalles de Servicio por Reserva';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `project_reservation_service_detail`
--

LOCK TABLES `project_reservation_service_detail` WRITE;
/*!40000 ALTER TABLE `project_reservation_service_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `project_reservation_service_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `project_tas`
--

DROP TABLE IF EXISTS `project_tas`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `project_tas` (
  `project` int(4) NOT NULL COMMENT 'Identificador del Proyecto',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `series` char(5) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Serie de la Orden de Reparacion',
  `number` int(4) NOT NULL DEFAULT '0' COMMENT 'Numero de la Orden de Reparacion',
  `target` int(4) NOT NULL COMMENT 'Identificador del Cliente Potencial',
  `tas_item` int(4) NOT NULL COMMENT 'Identificador del Articulo susceptible de Asistencia Tecnica',
  `counter` double(15,3) DEFAULT '0.000' COMMENT 'Contador del Articulo de la Orden de Reparacion (p.e. Kilometraje)',
  `task_holder` int(4) DEFAULT NULL COMMENT 'Identificador del Empleado que ejecuta la Orden',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios',
  `status` tinyint(2) NOT NULL COMMENT 'Estado de la Orden de Reparacion',
  `status_date` date DEFAULT NULL COMMENT 'Fecha del Estado de la Orden de Reparacion',
  `workplace` int(4) NOT NULL DEFAULT '1' COMMENT 'Identificador del Centro de Trabajo',
  PRIMARY KEY (`project`),
  KEY `IDX_PROJECT_TAS_TARGET` (`target`),
  KEY `IDX_PROJECT_TAS_TAS_ITEM` (`tas_item`),
  KEY `IDX_PROJECT_TAS_TASK_HOLDER` (`task_holder`),
  KEY `IDX_PROJECT_TAS_WORKPLACE` (`workplace`),
  KEY `IDX_PROJECT_TAS_DOMAIN` (`domain`),
  CONSTRAINT `FK_PROJECT_TAS_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_PROJECT_TAS_PROJECT` FOREIGN KEY (`project`) REFERENCES `project` (`id`),
  CONSTRAINT `FK_PROJECT_TAS_TARGET` FOREIGN KEY (`target`) REFERENCES `target` (`registry`),
  CONSTRAINT `FK_PROJECT_TAS_TASK_HOLDER` FOREIGN KEY (`task_holder`) REFERENCES `task_holder` (`registry`),
  CONSTRAINT `FK_PROJECT_TAS_TAS_ITEM` FOREIGN KEY (`tas_item`) REFERENCES `tas_item` (`id`),
  CONSTRAINT `FK_PROJECT_TAS_WORKPLACE` FOREIGN KEY (`workplace`) REFERENCES `workplace` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Ordenes de Reparacion o Fabricacion';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `project_tas`
--

LOCK TABLES `project_tas` WRITE;
/*!40000 ALTER TABLE `project_tas` DISABLE KEYS */;
/*!40000 ALTER TABLE `project_tas` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `project_type`
--

DROP TABLE IF EXISTS `project_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `project_type` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Tipo de Expediente',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `description` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion del Tipo de Expediente',
  `active` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'Activo si o no',
  PRIMARY KEY (`id`),
  KEY `IDX_PROJECT_TYPE_DOMAIN` (`domain`),
  CONSTRAINT `FK_PROJECT_TYPE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Tipos de Expedientes';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `project_type`
--

LOCK TABLES `project_type` WRITE;
/*!40000 ALTER TABLE `project_type` DISABLE KEYS */;
/*!40000 ALTER TABLE `project_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `proposal`
--

DROP TABLE IF EXISTS `proposal`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `proposal` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `issue_date` date DEFAULT NULL COMMENT 'Fecha de emision de la Propuesta',
  `department` int(4) DEFAULT NULL COMMENT 'Identificador del Departamento',
  `workplace` int(4) NOT NULL COMMENT 'Identificador del Centro de Trabajo',
  `warehouse` int(4) DEFAULT NULL COMMENT 'Identificador del Almacen',
  `scope` int(4) NOT NULL COMMENT 'Identificador del Ambito',
  `remarks` text COLLATE latin1_spanish_ci COMMENT 'Observaciones de la Propuesta',
  `item_return` tinyint(1) DEFAULT '0' COMMENT 'Indica si es una devolucion',
  `status` tinyint(2) DEFAULT '0' COMMENT 'Estado de la Propuesta',
  `transfer_status` tinyint(2) DEFAULT '0' COMMENT 'Indica si es un traspaso y su estado',
  `transfer_proposal` int(4) DEFAULT NULL COMMENT 'Identificador de la Solicitud de traspaso vinculada',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_PROPOSAL_DOMAIN` (`domain`),
  KEY `IDX_PROPOSAL_SCOPE` (`scope`),
  KEY `IDX_PROPOSAL_WORKPLACE` (`workplace`),
  KEY `IDX_PROPOSAL_DEPARTMENT` (`department`),
  KEY `IDX_PROPOSAL_TRANSFER_PROPOSAL` (`transfer_proposal`),
  KEY `IDX_PROPOSAL_WAREHOUSE` (`warehouse`),
  CONSTRAINT `FK_PROPOSAL_DEPARTMENT` FOREIGN KEY (`department`) REFERENCES `department` (`id`),
  CONSTRAINT `FK_PROPOSAL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_PROPOSAL_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`),
  CONSTRAINT `FK_PROPOSAL_TRANSFER_PROPOSAL` FOREIGN KEY (`transfer_proposal`) REFERENCES `proposal` (`id`),
  CONSTRAINT `FK_PROPOSAL_WAREHOUSE` FOREIGN KEY (`warehouse`) REFERENCES `warehouse` (`id`),
  CONSTRAINT `FK_PROPOSAL_WORKPLACE` FOREIGN KEY (`workplace`) REFERENCES `workplace` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Propuestas de Compra';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `proposal`
--

LOCK TABLES `proposal` WRITE;
/*!40000 ALTER TABLE `proposal` DISABLE KEYS */;
/*!40000 ALTER TABLE `proposal` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `proposal_detail`
--

DROP TABLE IF EXISTS `proposal_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `proposal_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `proposal` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador de la Propuesta de Compra',
  `item` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador del Articulo',
  `description` varchar(1024) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion',
  `quantity` double(15,3) DEFAULT '0.000' COMMENT 'Cantidad',
  `price` double DEFAULT '0' COMMENT 'Precio',
  `discount_expr` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descuentos',
  `status` tinyint(2) DEFAULT '0' COMMENT 'Estado del Detalle de la Propuesta',
  `supplier` int(4) DEFAULT NULL COMMENT 'Identificador de Proveedor',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_PROPOSAL_DETAIL_DOMAIN` (`domain`),
  KEY `IDX_PROPOSAL_DETAIL_PROPOSAL` (`proposal`),
  KEY `IDX_PROPOSAL_DETAIL_ITEM` (`item`),
  KEY `IDX_PROPOSAL_DETAIL_SUPPLIER` (`supplier`),
  CONSTRAINT `FK_PROPOSAL_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_PROPOSAL_DETAIL_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`),
  CONSTRAINT `FK_PROPOSAL_DETAIL_PROPOSAL` FOREIGN KEY (`proposal`) REFERENCES `proposal` (`id`),
  CONSTRAINT `FK_PROPOSAL_DETAIL_SUPPLIER` FOREIGN KEY (`supplier`) REFERENCES `supplier` (`registry`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalles de la Propuesta de Compra';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `proposal_detail`
--

LOCK TABLES `proposal_detail` WRITE;
/*!40000 ALTER TABLE `proposal_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `proposal_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `purchase`
--

DROP TABLE IF EXISTS `purchase`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `purchase` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Pedido de Compra',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `project` int(4) DEFAULT NULL COMMENT 'Identificador del Proyecto',
  `supplier` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador del Proveedor',
  `series` char(5) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Serie del Pedido',
  `number` int(4) NOT NULL DEFAULT '0' COMMENT 'Numero del Pedido',
  `purchase_reference` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo de referencia del Pedido de Compra',
  `address` int(4) DEFAULT NULL COMMENT 'Identificador de la Direccion del Proveedor',
  `discount_expr` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descuentos del Pedido',
  `issue_date` date DEFAULT NULL COMMENT 'Fecha de emision del Pedido',
  `pay_method` int(4) DEFAULT NULL COMMENT 'Identificador de la Forma de Pago',
  `document_type` tinyint(2) DEFAULT '1' COMMENT 'Tipo de Pedido',
  `security_level` tinyint(2) DEFAULT '0' COMMENT 'Nivel de seguridad del Pedido',
  `status` tinyint(2) DEFAULT '0' COMMENT 'Estado del Pedido',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios del Pedido',
  `remarks` text COLLATE latin1_spanish_ci COMMENT 'Observaciones del Pedido',
  `workplace` int(4) NOT NULL COMMENT 'Identificador del Centro de Trabajo',
  `warehouse` int(4) DEFAULT NULL COMMENT 'Identificador del Almacen',
  `scope` int(4) NOT NULL DEFAULT '1' COMMENT 'Ambito del Pedido',
  `number_of_pymnts` smallint(2) DEFAULT '0' COMMENT 'Numero de Vencimientos',
  `days_to_first_pymnt` smallint(2) DEFAULT '0' COMMENT 'Dias al primer Vencimiento',
  `days_between_pymnts` smallint(2) DEFAULT '0' COMMENT 'Dias entre Vencimientos',
  `pymnt_days` varchar(8) COLLATE latin1_spanish_ci DEFAULT '0' COMMENT 'Dias de pago',
  `bank_account` varchar(34) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'IBAN - Numero de Cuenta Bancaria Internacional',
  `bank_alias` varchar(25) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Alias del Banco',
  `bic` varchar(11) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'BIC - Codigo Identificador del Banco',
  `email_communication` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indica si se ha comunicado a traves de email',
  `delivery_date` date DEFAULT NULL COMMENT 'Fecha de entrega',
  `carrier` int(4) DEFAULT NULL COMMENT 'Identificador de la Agencia de Transporte',
  `carrier_packing` int(4) DEFAULT NULL COMMENT 'Identificador de la Hoja de ruta',
  `shipping_alternative_address` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Primera parte de la Direccion de entrega',
  `shipping_alternative_address2` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Segunda parte de la Direccion de entrega',
  `shipping_alternative_zip` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo Postal de entrega',
  `shipping_alternative_city` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Localidad de entrega',
  `shipping_alternative_phone` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Telefono de contacto de la entrega',
  `shipping_alternative_recipient` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Destinatario de la entrega',
  `shipping_contact` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre del contacto para la entrega',
  `shipping_period` tinyint(2) DEFAULT '0' COMMENT 'Tipo de periodo de entrega',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  UNIQUE KEY `IDX_UNQ_PURCHASE_DOMAIN_SUPPLIER_SERIES_NUMBER` (`domain`,`supplier`,`series`,`number`),
  KEY `IDX_PURCHASE_SCOPE` (`scope`),
  KEY `IDX_PURCHASE_PROJECT` (`project`),
  KEY `IDX_PURCHASE_SUPPLIER` (`supplier`),
  KEY `IDX_PURCHASE_PAY_METHOD` (`pay_method`),
  KEY `IDX_PURCHASE_WORKPLACE` (`workplace`),
  KEY `IDX_PURCHASE_DOMAIN` (`domain`),
  KEY `IDX_PURCHASE_RADDRESS` (`address`),
  KEY `IDX_PURCHASE_CARRIER` (`carrier`),
  KEY `IDX_PURCHASE_WAREHOUSE` (`warehouse`),
  CONSTRAINT `FK_PURCHASE_CARRIER` FOREIGN KEY (`carrier`) REFERENCES `carrier` (`registry`),
  CONSTRAINT `FK_PURCHASE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_PURCHASE_PAY_METHOD` FOREIGN KEY (`pay_method`) REFERENCES `pay_method` (`id`),
  CONSTRAINT `FK_PURCHASE_PROJECT` FOREIGN KEY (`project`) REFERENCES `project` (`id`),
  CONSTRAINT `FK_PURCHASE_RADDRESS` FOREIGN KEY (`address`) REFERENCES `raddress` (`id`),
  CONSTRAINT `FK_PURCHASE_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`),
  CONSTRAINT `FK_PURCHASE_SUPPLIER` FOREIGN KEY (`supplier`) REFERENCES `supplier` (`registry`),
  CONSTRAINT `FK_PURCHASE_WAREHOUSE` FOREIGN KEY (`warehouse`) REFERENCES `warehouse` (`id`),
  CONSTRAINT `FK_PURCHASE_WORKPLACE` FOREIGN KEY (`workplace`) REFERENCES `workplace` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Pedidos de Compra';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `purchase`
--

LOCK TABLES `purchase` WRITE;
/*!40000 ALTER TABLE `purchase` DISABLE KEYS */;
/*!40000 ALTER TABLE `purchase` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `purchase_detail`
--

DROP TABLE IF EXISTS `purchase_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `purchase_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Detalle del Pedido de Compra',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `purchase` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador del Pedido de Compra',
  `project` int(4) DEFAULT NULL COMMENT 'Identificador del Proyecto',
  `line` smallint(2) DEFAULT '1' COMMENT 'Numero de linea del Detalle dentro del Pedido',
  `item` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador del Articulo del Detalle de Pedido',
  `description` varchar(1024) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion del Detalle de Pedido',
  `quantity` double(15,3) DEFAULT '0.000' COMMENT 'Cantidad del Detalle de Pedido',
  `price` double DEFAULT '0' COMMENT 'Precio del Detalle de Pedido',
  `discount_expr` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descuentos del Detalle de Pedido',
  `taxes` double(15,3) DEFAULT '0.000' COMMENT 'Tasas del Detalle de Pedido',
  `status` tinyint(2) DEFAULT NULL COMMENT 'Estado del Detalle de Pedido',
  `source` tinyint(2) DEFAULT '0' COMMENT 'Origen del Detalle de la Compra',
  `source_id` int(4) DEFAULT NULL COMMENT 'Identificador del Origen del Detalle de la Compra',
  `proposal_detail` int(4) DEFAULT NULL COMMENT 'Identificador del Detalle de Solicitud',
  `delivered` double DEFAULT '0' COMMENT 'Cantidad entregada del Detalle de Pedido',
  `delivery_date` date DEFAULT NULL COMMENT 'Fecha de entrega',
  `carrier` int(4) DEFAULT NULL COMMENT 'Identificador de la Agencia de Transporte',
  `carrier_packing` int(4) DEFAULT NULL COMMENT 'Identificador de la Hoja de ruta',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_PURCHASE_DETAIL_PROJECT` (`project`),
  KEY `IDX_PURCHASE_DETAIL_PURCHASE` (`purchase`),
  KEY `IDX_PURCHASE_DETAIL_ITEM` (`item`),
  KEY `IDX_PURCHASE_DETAIL_DOMAIN` (`domain`),
  KEY `IDX_PURCHASE_DETAIL_PROPOSAL_DETAIL` (`proposal_detail`),
  KEY `IDX_PURCHASE_DETAIL_CARRIER` (`carrier`),
  KEY `IDX_PURCHASE_DETAIL_CARRIER_PACKING` (`carrier_packing`),
  CONSTRAINT `FK_PURCHASE_DETAIL_CARRIER` FOREIGN KEY (`carrier`) REFERENCES `carrier` (`registry`),
  CONSTRAINT `FK_PURCHASE_DETAIL_CARRIER_PACKING` FOREIGN KEY (`carrier_packing`) REFERENCES `carrier_packing` (`id`),
  CONSTRAINT `FK_PURCHASE_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_PURCHASE_DETAIL_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`),
  CONSTRAINT `FK_PURCHASE_DETAIL_PROJECT` FOREIGN KEY (`project`) REFERENCES `project` (`id`),
  CONSTRAINT `FK_PURCHASE_DETAIL_PROPOSAL_DETAIL` FOREIGN KEY (`proposal_detail`) REFERENCES `proposal_detail` (`id`),
  CONSTRAINT `FK_PURCHASE_DETAIL_PURCHASE` FOREIGN KEY (`purchase`) REFERENCES `purchase` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalles del Pedido de Compra';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `purchase_detail`
--

LOCK TABLES `purchase_detail` WRITE;
/*!40000 ALTER TABLE `purchase_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `purchase_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `qualification`
--

DROP TABLE IF EXISTS `qualification`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `qualification` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la Calificacion',
  `domain` int(4) NOT NULL DEFAULT '1' COMMENT 'Identificador del Dominio',
  `code` char(5) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Codigo de la Calificacion',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion de la Calificacion',
  `min_value` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Limite inferior de la Calificacion',
  `max_value` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Limite superior de la Calificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_QUALIFICATION_DOMAIN` (`domain`),
  CONSTRAINT `FK_QUALIFICATION_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Calificaciones';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `qualification`
--

LOCK TABLES `qualification` WRITE;
/*!40000 ALTER TABLE `qualification` DISABLE KEYS */;
/*!40000 ALTER TABLE `qualification` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `quality_skill`
--

DROP TABLE IF EXISTS `quality_skill`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `quality_skill` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la Aptitud Calidad',
  `domain` int(4) NOT NULL DEFAULT '1' COMMENT 'Identificador del Dominio',
  `code` char(5) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Codigo de la Aptitud Calidad',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion de la Aptitud Calidad',
  PRIMARY KEY (`id`),
  KEY `IDX_QUALITY_SKILL_DOMAIN` (`domain`),
  CONSTRAINT `FK_QUALITY_SKILL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Aptitudes Calidad';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `quality_skill`
--

LOCK TABLES `quality_skill` WRITE;
/*!40000 ALTER TABLE `quality_skill` DISABLE KEYS */;
/*!40000 ALTER TABLE `quality_skill` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `question`
--

DROP TABLE IF EXISTS `question`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `question` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `active` tinyint(1) NOT NULL COMMENT 'Indica si la Pregunta esta activa o no',
  `question_text` varchar(255) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Texto de la Pregunta',
  `type` tinyint(2) NOT NULL COMMENT 'Tipo de Pregunta',
  `argument` text COLLATE latin1_spanish_ci COMMENT 'Argumentacion de la Pregunta',
  `alias` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Alias de la Pregunta',
  PRIMARY KEY (`id`),
  KEY `IDX_QUESTION_DOMAIN` (`domain`),
  CONSTRAINT `FK_QUESTION_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Preguntas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `question`
--

LOCK TABLES `question` WRITE;
/*!40000 ALTER TABLE `question` DISABLE KEYS */;
/*!40000 ALTER TABLE `question` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `question_value`
--

DROP TABLE IF EXISTS `question_value`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `question_value` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `question` int(4) NOT NULL COMMENT 'Identificador de la Pregunta',
  `value_text` varchar(1024) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Valor de tipo texto',
  `value_number` double(15,3) DEFAULT NULL COMMENT 'Valor de tipo numerico',
  `value_date` datetime DEFAULT NULL COMMENT 'Valor de tipo fecha',
  PRIMARY KEY (`id`),
  KEY `IDX_QUESTION_VALUE_QUESTION` (`question`),
  KEY `IDX_QUESTION_VALUE_DOMAIN` (`domain`),
  CONSTRAINT `FK_QUESTION_VALUE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_QUESTION_VALUE_QUESTION` FOREIGN KEY (`question`) REFERENCES `question` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Valores de Preguntas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `question_value`
--

LOCK TABLES `question_value` WRITE;
/*!40000 ALTER TABLE `question_value` DISABLE KEYS */;
/*!40000 ALTER TABLE `question_value` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `raddinfo`
--

DROP TABLE IF EXISTS `raddinfo`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `raddinfo` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `registry` int(4) NOT NULL COMMENT 'Identificador de la Persona o Empresa',
  `attribute` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Atributo adicional',
  `value` varchar(128) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Valor del atributo adicional',
  `value_date` date NOT NULL COMMENT 'Fecha del valor del atributo',
  PRIMARY KEY (`id`),
  KEY `IDX_RADDINFO_REGISTRY` (`registry`),
  KEY `IDX_RADDINFO_DOMAIN` (`domain`),
  CONSTRAINT `FK_RADDINFO_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_RADDINFO_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Informacion adicional de la Persona o Empresa';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `raddinfo`
--

LOCK TABLES `raddinfo` WRITE;
/*!40000 ALTER TABLE `raddinfo` DISABLE KEYS */;
/*!40000 ALTER TABLE `raddinfo` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `raddress`
--

DROP TABLE IF EXISTS `raddress`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `raddress` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la Direccion de la Persona o Empresa',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `registry` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador del Registro de la Persona o Empresa',
  `type` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Tipo de Direccion',
  `recipient` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Destinatario',
  `street_type` varchar(2) COLLATE latin1_spanish_ci DEFAULT 'CL' COMMENT 'Tipo de via',
  `address` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Primera parte de la Direccion',
  `number` varchar(12) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero',
  `address2` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Segunda parte de la Direccion',
  `address3` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Tercera parte de la Direccion',
  `zip` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo Postal',
  `city` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Localidad',
  `geozone` int(4) DEFAULT NULL COMMENT 'Identificador de la Zona Geografica',
  `alias` varchar(15) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Alias',
  `municipality_code` varchar(5) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo del municipio',
  PRIMARY KEY (`id`),
  KEY `IDX_RADDRESS_REGISTRY` (`registry`),
  KEY `IDX_RADDRESS_GEOZONE` (`geozone`),
  KEY `IDX_RADDRESS_DOMAIN` (`domain`),
  CONSTRAINT `FK_RADDRESS_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_RADDRESS_GEOZONE` FOREIGN KEY (`geozone`) REFERENCES `geozone` (`id`),
  CONSTRAINT `FK_RADDRESS_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=7730513 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Direcciones de Personas o Empresas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `raddress`
--

LOCK TABLES `raddress` WRITE;
/*!40000 ALTER TABLE `raddress` DISABLE KEYS */;
INSERT INTO `raddress` VALUES (7730360,0,216081,0,NULL,'CL','','','','','','',NULL,NULL,''),(7730361,8776,8628387,0,NULL,'CL','','','','','','',NULL,NULL,''),(7730362,8777,8628388,0,NULL,'CL','','','','','','',133890,NULL,'01059'),(7730363,8777,8628389,0,NULL,'CL','-','-','','','','',NULL,NULL,''),(7730364,8777,8628390,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730365,8777,8628391,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730366,8777,8628392,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730367,8777,8628393,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730368,8777,8628394,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730369,8777,8628395,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730370,8777,8628396,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730371,8778,8628397,0,NULL,'CL','','','','','','',NULL,NULL,''),(7730372,8777,8628398,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730373,8778,8628399,0,NULL,'CL','-','-','','','','',NULL,NULL,''),(7730374,8778,8628397,1,NULL,'CL','-','','','','-','VITORIA-GASTEIZ',133890,'',''),(7730375,8777,8628400,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730376,8777,8628388,1,NULL,'CL','-','-','','','-','-',133909,'',''),(7730377,8777,8628388,1,NULL,'CL','-','-','','','-','-',133937,'',''),(7730378,8777,8628388,1,NULL,'CL','-','-','','','-','-',133917,'',''),(7730379,8777,8628401,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730380,8777,8628402,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730381,8777,8628403,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730382,8777,8628404,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730383,8779,8628405,0,NULL,'CL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7730384,8777,8628406,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730385,8777,8628407,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730386,8777,8628408,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730387,8777,8628409,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730388,8777,8628410,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730389,8777,8628411,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730390,8780,8628412,0,NULL,'CL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7730391,8777,8628413,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730392,8778,8628414,0,NULL,'CL','-','-','','','','',NULL,NULL,''),(7730393,8777,8628415,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730394,8777,8628416,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730395,8777,8628417,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730396,8777,8628418,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730397,8777,8628419,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730398,8777,8628420,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730399,8778,8628421,0,NULL,'CL','-','-','','','','',NULL,NULL,''),(7730400,8777,8628422,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730401,8780,8628412,1,NULL,'CL','-','','','','01000','VITORIA-GASTEIZ',133890,'','01059'),(7730402,8780,8628423,0,NULL,'CL','-','-','','','','',NULL,NULL,''),(7730403,8777,8628424,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730404,8777,8628425,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730405,8777,8628426,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730406,8777,8628427,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730407,8777,8628428,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730408,8777,8628429,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730409,8777,8628430,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730410,8780,8628431,0,NULL,'CL','-','-','','','','',NULL,NULL,''),(7730411,8777,8628432,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730412,8777,8628433,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730413,8777,8628434,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730414,8777,8628435,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730415,8777,8628436,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730416,8777,8628437,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730417,8777,8628438,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730418,8781,8628439,0,NULL,'CL','','','','','','',NULL,NULL,''),(7730419,8781,8628440,0,NULL,'CL','-','-','','','','',NULL,NULL,''),(7730420,8781,8628439,1,NULL,'CL','-','-','','','00000','MADRID',133917,'','28079'),(7730421,8777,8628441,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730422,8777,8628442,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730423,8782,8628443,0,NULL,'CL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7730424,8777,8628444,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730425,8777,8628445,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730426,8777,8628446,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730427,8777,8628447,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730428,8777,8628448,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730429,8777,8628449,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730430,8777,8628450,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730431,8783,8628451,0,NULL,'CL','','','','','','',NULL,NULL,''),(7730432,8783,8628451,1,NULL,'CL','-','-','','','-','EL MUNDO',133937,'','48020'),(7730433,8783,8628452,0,NULL,'CL','-','-','','','','',NULL,NULL,''),(7730434,8783,8628453,0,NULL,'CL','-','-','','','','',NULL,NULL,''),(7730435,8783,8628454,0,NULL,'CL','-','-','','','','',NULL,NULL,''),(7730436,8783,8628455,0,NULL,'CL','-','-','','','','',NULL,NULL,''),(7730437,8783,8628456,0,NULL,'CL','-','-','','','','',NULL,NULL,''),(7730438,8783,8628457,0,NULL,'CL','-','-','','','','',NULL,NULL,''),(7730439,8777,8628458,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730440,8777,8628459,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730441,8777,8628460,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730442,8777,8628461,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730443,8777,8628462,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730444,8784,8628463,0,NULL,'CL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7730445,8784,8628464,0,NULL,'CL','-','-','','','','',NULL,NULL,''),(7730446,8784,8628463,1,NULL,'CL','-','-','','','000000','MALLORCA',133896,'','07033'),(7730447,8784,8628465,0,NULL,'CL','-','-','','','','',NULL,NULL,''),(7730448,8777,8628466,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730449,8777,8628467,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730450,8783,8628468,0,NULL,'CL','-','-','','','','',NULL,NULL,''),(7730451,8783,8628469,0,NULL,'CL','-','-','','','','',NULL,NULL,''),(7730452,8783,8628470,0,NULL,'CL','-','-','','','','',NULL,NULL,''),(7730453,8777,8628471,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730454,8777,8628472,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730455,8777,8628473,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730456,8785,8628474,0,NULL,'CL',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),(7730457,8785,8628474,1,NULL,'CL','-','-','','','01002','VITORIA-GASTEIZ',133890,'','01059'),(7730458,8777,8628475,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730459,8783,8628476,0,NULL,'CL','-','-','','','','',NULL,NULL,''),(7730460,8783,8628477,0,NULL,'CL','-','-','','','','',NULL,NULL,''),(7730461,8777,8628478,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730462,8777,8628479,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730463,8777,8628480,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730464,8777,8628481,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730465,8777,8628482,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730466,8777,8628483,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730467,8777,8628484,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730468,8777,8628485,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730469,8777,8628486,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730470,8777,8628487,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730471,8777,8628488,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730472,8777,8628489,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730473,8777,8628490,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730474,8777,8628491,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730475,8777,8628492,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730476,8777,8628493,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730477,8777,8628494,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730478,8777,8628495,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730479,8777,8628496,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730480,8777,8628497,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730481,8777,8628498,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730483,8787,8628500,0,NULL,'CL','-','-','','','01000','MADRID',133917,'','28079'),(7730484,8787,8628501,0,NULL,'CL','-','-','','','','',133917,NULL,''),(7730485,8787,8628502,0,NULL,'CL','-','-','','','','',133917,NULL,''),(7730486,8787,8628503,0,NULL,'CL','-','-','','','','',133917,NULL,''),(7730487,8787,8628504,0,NULL,'CL','-','-','','','','',133917,NULL,''),(7730488,8787,8628505,0,NULL,'CL','-','-','','','','',133917,NULL,''),(7730489,8787,8628506,0,NULL,'CL','-','-','','','','',133917,NULL,''),(7730490,8787,8628507,0,NULL,'CL','-','-','','','','',133917,NULL,''),(7730491,8787,8628508,0,NULL,'CL','-','-','','','','',133917,NULL,''),(7730492,8777,8628509,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730493,8777,8628510,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730494,8777,8628511,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730495,8777,8628512,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730496,8777,8628513,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730497,8777,8628514,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730498,8777,8628515,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730499,8777,8628516,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730500,8777,8628517,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730501,8777,8628518,0,NULL,'CL','-','-','','','','',133890,NULL,''),(7730502,8788,8628519,0,NULL,'CL','','','','','','',133897,NULL,'08019'),(7730503,8788,8628520,0,NULL,'CL','-','-','','','','',NULL,NULL,''),(7730504,8788,8628521,0,NULL,'CL','-','-','','','','',133897,NULL,''),(7730505,8788,8628522,0,NULL,'CL','-','-','','','','',133897,NULL,''),(7730506,8788,8628523,0,NULL,'CL','-','-','','','','',133897,NULL,''),(7730507,8788,8628524,0,NULL,'CL','-','-','','','','',133897,NULL,''),(7730508,8788,8628525,0,NULL,'CL','-','-','','','','',133897,NULL,''),(7730509,8777,8628526,0,NULL,'CL','.','.','','','','',133890,NULL,''),(7730510,8777,8628527,0,NULL,'CL','.','.','','','','',133890,NULL,''),(7730511,8777,8628528,0,NULL,'CL','.','.','','','','',133890,NULL,''),(7730512,8777,8628529,0,NULL,'CL','.','.','','','','',133890,NULL,'');
/*!40000 ALTER TABLE `raddress` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rattach`
--

DROP TABLE IF EXISTS `rattach`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rattach` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Archivo Adjunto de la Persona o Empresa',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `registry` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador del Registro de la Persona o Empresa',
  `category` int(4) DEFAULT NULL COMMENT 'Categoria del Archivo Adjunto',
  `mimeType` tinyint(2) DEFAULT '0' COMMENT 'Mime Type del Archivo Adjunto',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion del Archivo Adjunto',
  `data` mediumblob COMMENT 'Archivo Adjunto en binario',
  `type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de Archivo Adjunto',
  `scope` int(4) DEFAULT NULL COMMENT 'Ambito del Archivo Adjunto',
  `security_level` tinyint(2) DEFAULT '0' COMMENT 'Nivel de seguridad del Archivo Adjunto',
  `attach_date` date DEFAULT NULL COMMENT 'Fecha del Archivo Adjunto',
  `drive_id` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL,
  `dparent_id` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL,
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_RATTACH_SCOPE` (`scope`),
  KEY `IDX_RATTACH_CATEGORY` (`category`),
  KEY `IDX_RATTACH_REGISTRY` (`registry`),
  KEY `IDX_RATTACH_DOMAIN` (`domain`),
  CONSTRAINT `FK_RATTACH_CATEGORY` FOREIGN KEY (`category`) REFERENCES `category` (`id`),
  CONSTRAINT `FK_RATTACH_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_RATTACH_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`),
  CONSTRAINT `FK_RATTACH_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=68217 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Archivos Adjuntos de Personas o Empresas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rattach`
--

LOCK TABLES `rattach` WRITE;
/*!40000 ALTER TABLE `rattach` DISABLE KEYS */;
INSERT INTO `rattach` VALUES (4346,0,216081,NULL,0,'aon-logo','\0JFIF\0\0\0\0\0\0\0\0	(!\Z%!1!%)+...383,7(-/+\n\n\n\r\r\Z,,,+77,++,,-.7,,,+7,,,+7./,7,,,+7+,+,.--,1,-,7.,8,,\0\0\0\"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0C\0	\0\0\0\0\0!1AQ\"aq2R#Bbr3C$%Ss\0\0\0\0\0\0\0\0\0\0\0\0\0\0 \0\0\0\0\0\0\0\0\0\01!\"Aa\0\0\0?\0\0\0\0\0\0\0\0\0VkuLz7Re\Z\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\04bljֶHCcT	nXDGXU!TS)P0\0\0\0\0\0\0\0\0\0\0\0\0\0\0aRJFm8^FoJr4*M2W@\0\0S5mrи9lS0u\rR	=`g`Jțg`LC}*fu\0NO,ɀ\0\0\0\0\0\0\0\0\0\0\0\0W瘧Nq{3P߳;N5dЫy)޲OY>]txtFeIX/K}&O=w2\Zj(HI~GjjЍH8N*Qj=؃fwj}|yjpYxiMo掓y]OfG3yIf[\\mV}_:Rtt}L4NF2̣n4mmI=S#m%îoreoXiqߋ$\0\0\0\0\0\0\0\0\0\0\0\0C(σtn}]j]Ox9~a]9F=;[	r}~e)zjKI-&HTG̰qJPeMƒQGF>\".!{c/\0ENa	Ej2fe\\*hӳ#JG]Ej8ʌ\'3ͳD`IXDU@&eA۝߳_943ʪF4.[S5\\Y|m)12Xn\n$>22v\0\0\0\0\0\0\0\0kF35&̀Fڃ[R>M|N.!ZP/ڋ+H8T^k9<nI[=s(kU.Sz.XVv#NK|kk[/&SaU$R1[ZO-lxʐMR)K6ٌmv:\\-&\'kVV=26qB^+\\>uk5Οmz-~]L<MxK}^We74ze[xeGUV./]ov\0ʜ(ӓ7\n[>$Ҋ/R\r Лս[w~ [<IBCLLep)jpyt_6_w[̍F7x]^RW_WIhdA^uoМ\0\0\0\0\0\0\0\0\0\0Jsӛь94ʼ6)quٕ;khմ/LgM&iiL,\'n:;Iɫ)v5˽L3KK>WLX,V7%J冒͵n*ƥX5~{ݭyᕻ1N;I]9gsڴҊnєjM+|Muw=I9>MjZӔh\0N_zяJt̥O*E;mFJI_vrl첮Xax?󠫆(lK}\0MskƌiƢQvRJ\'{~Hq8;鯉;3#	Ru)i8n_-[8חS.JO[hH\nj$gBHPFQ{͔0{]KL,VZ\\XlUTjmE4`\0\0\0\0\0\0\0\0\0\0\084٭$j.˚]_2-Ej9B7M5+{\\tЊoHpzޛ؂z\ZY$I]ܟ%<KڒZ-XRoznVm̷p\\Җ;pӑQ)Ȕ{uucv\0\0O:pΫ\\8lrjX%TMIb2KqmfT(Ol\\yb!/ZIs^VwÜKGKb*<kw[53lћJq\Zk^\'SLMߩ>P-Hʪ^hpl(/\0\0\0\0\0\0\0\0\0\0\0cR\nIjWiNOiߦΘ^a\'MPsQW]\ZگӣYkЋJ1m\ZkUL0Q*lKNxD2LF5SHEl+֦{zzf_N},l2\0m\0\0[k9įuRa/:OiFkU\"q9\0Ʊ)\0-ı[vU0#83_+.m8~2_$j=\ZG\0ШDJ}x5Z\ZV{\'6 *6ʹYTی*NQM.h&[ҌpT{/Nv]a4\Z,fE˧zkؔ\0\0\0\0\0\0\0\0\0\0\0\0\0Gޏ5fT:3Zjplp{5/$B@0->^kd)RWMwbK)~J^z\r;u/8?wNg2OMs#iixQHr#1*(Mn#/Ur\'Y75zqRTBgNγ[zOdE-4(Ӝ_^\0pXWz.e/X8\n-ߗԝZ`HG\0\0\0\0\0\0\0\0\0\0k]q_s]\03\0|	tu·\rS>>ZEscp4UN,(.ݨ|.\"5#x)J\0sjlqZk(Keo7KWOgz\ZT)\r\\[џ2OmǲmMKa:q|StoVKOz\0\0\0\0\0J02%j:mҷoEK3\\2/%QtIlj)KL7]\Zr\'8ŽSa0ZWdXajv◨\0\0\0\0\0\0\0\0\0\0\\N?] s{uGƢ{~\r0>]:r|	Hy)to}L:59.*Tu0:ݓCnqN51qqR\0MF)EY%efys͠2k=#_]z>ƽ8.2g(TבÅLDW.oNWlx=?&\nOo.vWK[G7\"ʭ}~clG#RL$yT}@\0\0\0\0\0\'4m%vMoRy㲶`2g+$;|_&jtW%(%!fX9UQ*M;TdtИx#k^7\0f~jd]9KjKV%yEyRyEU}2kĻ:)ѪW)ҽ4ww\0Kbc.{&Iy\Zu#hTwT7ddvYf\'=-{V,pIN;_>wZ;\"`{c;BT{fv={d)%/*͏Ű9ORONB0Vml\0\0\0_zKVȵs4~l*:t^݊SiZjn#\0fbݶBf\rwobVqkl&XJmKPw+2\0cac 62\0cac =\0yac\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0',0,NULL,0,NULL,NULL,'58567','admin','2016-02-18 10:38:24',NULL,NULL),(68194,0,216081,NULL,3,'payroll-test.aonsolutions.org','#\n#Thu Feb 18 10:42:32 CET 2016\nuser=admin\ndomainManagement=true\nname=payroll-test.aonsolutions.org\ntype=CONSULTANCY\nnumberOfUsers=0\nmaxTotalDocumentSize=100\n',13,NULL,0,'2016-02-18',NULL,NULL,'admin','2016-02-18 10:42:32',NULL,NULL),(68195,8776,8628387,NULL,0,'aon-logo','\0JFIF\0\0H\0H\0\0\0C\0	\Z!\Z\"$\"$\0C\0,,\"\0\0\0\0\0\0\0\0\0\0\0\0\0\0	\0B\0\0\0\0!1AQa\"q2B#3CRbr$cs\0\0\0\0\0\0\0\0\0\0\0\0\08\0\0\0\0\0\0\0\0!Q1Aa\"q#2Bb3R\0\0\0?\0ܴD@\0DDD@\0DDD@\0DDD@\0DDD@\0DDD@\0DDD@\0DDD@\0DDD@\0DDD@\0DDD@\0DDD@\0DDD@\0DDD@\0DDD@\0DDD@\0DDWݨv4,dK$\nGy?g\Z櫂<8h`5f\ZZ.s1Vqv;^ݵ{\nG\\G?ʻVjieq;<.?3ԩNI#]jrEKq_.fj>Ò#v&yg.X^$6_.hhk;r\0*R8)Wl07fğ2Q٫5nt^^wLz5?Z_^yDݫfu}e-VFbDEwD@\0DDD@\0DDD@\0DDD@5ۿkvfMsxfPKN{rH=]vWHV\r;m`|] 7!n]<,%JnyXř_,8y\'%zعr3xi\0W?ޞ\nu>oC?JG+c&~=TޕXjWl05}JRU`l05r[S\n(׷\\՗*W@9֞j#^GE,ncv-#le:-S9+	x-m^&R)G1.ݤt>`T>3ш×*\'=ca7\\yz=U-We2vl7%!YL\rn9Ms6\':eK0\"\"\0\" \"\"\0\" \"\"\0\"{y퍵;3Xwc;WM2pPÖ;H{{x퉘fM$Ael;䵆gY]$s\\8\\ORJ={$IY&Kwn<ϋa}0Rf7XS,$-ӆ.Bn\'n\Z}yj{.;̣{1.4UO|T^wɃy*(\n=8۫+ba`k_[|Y˄c2+f^os]=kLG݁H,0ĻĴsXlGg4>D|Փj0bS0،ߛOufڇl/ii;|Wy-\\JeYt{XC}m-pY*YH\"\"\0ދԗn<7߳4[2lb C(K1s<N@<=Km[-\'IN\0*^f͢jڑ[+fV;hO&l	kDE\0Xf\"%vsmչ	.Bq\nnZߔ4F <pU\0GZ3иq;/U[YW]y?4Hi/_7ǖdZIa!ëOPcH^{7	</o0P]6q#yEw\"\"\0SŴ6Wn?,̵~2g2Nd9Ӥ8Pq\ris\0s$=O=֊Q>*ߒ3)a̦	e;|_gg%ܜ|^vq[޻d2\Z_Hٜ~3͑\0\'eqyl\0/\0XS\r*(<ı*niޝ8`,?z/6Ech45l\0\\)2wy]Y]Ѻ\']Ǽ,/\'A<[#97d7#Nt\rcW({w8>;o#q5yj]7ig{Hh)l4l%~zre۴܌V_Cn2?	k\ZWy쥺Bf<=L6j<ϰd/B8~/wjQ`qOM]kzsTeqwyXA[m*$䞋!-\'s)7Ly6N&$Fv-^=?(lLslD^~{ni[F;\\-dfk$Ǚg} 9\r\n4Yr!T1ۿ9d\r\\in:^JZxr!{E[qeZnY\0.dYe&bJ#tSDױb:֭iE%L/}\\Wd76RRqhO%,s^摸 +MUؖGs3sNw~\n\\;y{\'d;GՍl\\fKvt;U`x氝L{W(vp݅Hag6*泔7ȦuIa6K\nRJ23P3jhZ{1SDչa\rjofziT#OWZUF7w@{)G%fyqT-\0rX<q@dal GE\'ixUcAh!kgF.{konɻ<Nմߣ=KHacG\"؅ku%|t3;$_:{Qbf!$Ff\0vEADO֭1ͻ\'岚vi?q\0wUr~O;I^k̲[\0DD^rJ7hTk{dZI_?EGOg!l4OV`xqqmDcvU^YtWLIX_,5F޶̔} 5sP+I=d#~jO\Z2ZodO3IĪ/\ZP\"&I{,I\n3iodU{Iܻ\\;[(}Mw|l{F\\^f4M_[ջVĖg|GqI^	]tr0lA!_V{[wXVfoWYEoOi eA\0Į;lȮbM+;{,YfA\nH2G1-sNi|⧑Zֹp{Zb\n6v3R{.<?5c;nݩ3{N[-e[Va[B\0B~BlcZh\0B?}VDUBP\0I\\$jx=?%vcT)j,M;m\n}crG4;o34{x &/5/^ҫ1ٗEd\'޳31|4Y\r\\lexZwrmnAY+C\'r?Vǲ>deydak,||ykchCF|޽(\" >8|%Y$q%l\n:\'xIݧBBqttf]nh	|VWi6\\u]۪\'bQܼe4QܽK\Z􉅱mDoWr!\\v{zmKG=th{@o^*;tl:ڳ֙Y,e:TԵ[г{7Y\0%hdwks8=-sN[ݞjn>\04y;̭z{{\08&7unܶ^&h%,\"\"_ƹ\'֩N	|;C59ʿ!>m)z1՛!^+gEߙq;xQ\0wSAEOE_/~S1GUZl,#ٌ~^,̴qpF7c,?.oLv}\"HGt|[)\'iokך_ɈWLU6ʬߏ=拆aaq\rTv^Ii|u`;PҘG\0kgFܩYkAhCFqx<	>햶gu`\rt<o[|?³hb:IU9֩\"\" Zk5{O!-#oi+\Z$tK|RjMj:3QH4#ib\'ډ \0Z5]\'ewm7z,;5B+&AI,*æu_gj;N+oi%?yљ%XO$L@>`Z\rEL\0}8;oPeHgԷYFyd2R+\0i\0ԲҍY5[1nީf\0cl?ea{K,U85y9ßepc(SeL}h`Yvlqw1½rѵ.;Ɵ0$ID@;ޙ9˃\Z#֎{\0ĸOS&G#K^\rÁ\nXHC\nAW$9{Ki=֥fso$>_A%kv @Ziv;&6JQuMB6f	̫@$oKq\\8J&Ѧ0ZWlXKF>yF}=o,ZkۉA(dX;GZށx5>kWǍ{}r2F7sךŨ[ؼ|<g̯)$f2ĖD0pdwI4	hslr	X\nI+O4Uh}`uzO47md E[bGou[52Uֺ\nip-fOW<\'\\\0q\'\0Ri2\'qv\re\0G uX9g-:E\n>jy\"y<fC?s5i<w.+xyH뎧Mi=OI\Zo<[\rdV:0KpwQwe,j9{&J0Kuimy(W\rēʚjͭyX.-FӝuR/gFKWdRn<;9ӴܴUG.9Ә˟Sr`qMf]_ j).G#;CɃx\0E286|\n)+K4䗯yc1Ļ=+;[X}<Jw_,hnzw 2k\0!@0hZ2j>ݜCGytu^\"l9sKW&jWy?6LtNp7`Fbni<e#익ka4mo})%X,Fgxh{]:Vk7y3[\Zg+jcsTi<Yd2YsC?{n[*ɌJz89|9+Lq;g8l=W!\0uP/f\ZrYFa-Om&yܝ\0v?b_.Ƽwpy\';~h+-1c]f6(\";w,B\0Q\nY^VvLIʢ\"\0\" \n?4^8ɓ֖S֎\0nĩ +1 ,rF%Ec,<tĎ|SD@uׂ\Zж\ZGL5hhJ}!Jpʹ~#q\nXIZnai;sip[vװ5_%i~AY\0Kә\'v6~1>پt:fk_aB;V-\nn?PN6>`t3r:}űekAn\n?xjmU+Udq\'6>B{9oWb)i볏!xZ]NWHZWtX|[ecA߈}۪^2T=\rjj4mc˃Xi:xxlj8O\0U#.vQ+Asl}kQS<o/sMVT7m Z5B|G;IbgM3%pZcZa63Ʊ/wdx-DE\"Ec:ZiLVK2?Nc>k6{ɓ(9B!/ˋ};*Ie}EFթݰy*pk)xeou,X嫂1{GiRgpҤț3XEj>N$˳wW䟝2<Nw zzt\rOiBDW\'yjev*~`\n(\ZUVgeWպ/c\0Q֭mulx.Q6<=m3x.,5X+G=;5Ō{p\rg]-!)J\\ٟ_OrG\r-O_-3KQ;ZT=}_&AUr(K]L4ȱaPp7y|9gڦFW^!\'^-=(mqE<3rcq;q\\~\"M-b=n Z\0QX8um^-u&3qbwYv{?i>X8iL`F\naՈGUJ{5G4rL߄g&|GOuT{^ީlp4Jóx	:.H%9GG8|W4D@\0DDmJڧq2t@9wokHrvӁ5%PxHh|*E<Miw9q[{@[{!]؅J#1]jG~7!5펳Y1i68kށ}6$|W5U<+svyڮKyKWiܾ6Yʎv^>-=AX㖨Uk44MCEz4_l\\>;1CHj8Fo%iEQ=Bkd)nH?/zRzV5C\'0ZsZ?\'DRDDh-(v~pu,cP]3},켺9wsI`A9<Y^.t~@X|eW벻MJZ|^%,bb6?Om^_N/R,v6,G\'+\0	tgN7!=#w2\Z<vqM-%8{s?\n׺#2}FOy7z&邗W7HnLw5-5J~ߒ6arӟ)fl}wV	\';u\rCL|VSgGĭDWҘ,o-ǆ@ַyIqޔ\'MKHRx|2ܔf}&T}!a7k,{܃VΌ	Gv\0q1F]\'d7\'{yG$6͢+h%+*L&DN).^:By2~>Roڌ<wRno^G|,u+d鬩xo֤- %E07ba&3cws=\0\"\"\0\" jթq0nI@/گN,2&\rOih*u\rVi\\lxwޥvZԗ5a^~IqZ 60\0=xed,W	iumTyc>@ <,62Lu.>଍/WCwByz,tV}v9@j鹸:Gc\0=N%ˢi49FGUڲb=W*>SrX[Ra%#fhS\0GxE:>G<{KhK6\nϥ)?dd\'+IZysE#vs:I[\\)#y4DZuU~f՞U^FkyUE5CKn.#\0>c[QHcl9!hn#\\KJ5롒cDdkK\0WS\")\" /s8;]j~ûH,1H]6>֑uOUs9Fxf>9>zGmLZal~r?*	]SWW[\0-wi(J2ͨڭ=AG*7\'c_?i̫	gwr߬Xc0B}|_*\r_9o4[EGH\r`yr\n`.BX.๎s Y_#\Zޮ\'8)lX17$om.A=rV[Oќ?5*@jދ8;Bñ06[U]\Z]-e;$\\aJt^QBjyxf-|,چb)؃ȩanA 2(؆x\0DDD@mj?18Z`NU1)#!<Af3apW\0y,l,ZRIZf	$c!\'`	w@bj[,Cj5m^S25zo\nQʔ+EZ}F݀PմوYVHǂ3_\\\"wkIow-I5g4<\nȇ6{7)?\\v\"(xhCn)\0܂\r)춮:@	{قjdf\'4N,75YzV)psP}&\ZZJhYkn7sH<Gliڤ4\0U#qMh|XIkgױ!-zũKK-eRap̴4F449FVݞjd<0J+%iĤfAaӸ>zDVc}j;TiO?_EcW[gĮ_7-ّgARA|Uƀ\0\0`d9e~- m{ց	\0nNq%ھ<Rm{0˿ ~*edӾ	v=\r<;n|:t^#Mn=W$i,c2p\"l2ftp\Z[0d\ZZxډcxzcsfL߂A=}Ѭvc31ZCէtYUt6\\CIT֢4>vYY=A@N;dFe\"`s0!\0\" yyc\0?bt3-׼#o%\\q1ΎwO4)͗J\Z$	8wM\n,Ro&\0bͩneR6Ny\Z{BRx,\\|rSG;Qi=]3=ZFX+IŜd><Xr*$M]!XY#99Vq\"sa46/L.o>hΛfXmwQ7|ԉc}&\'pK;#dl\n9*^=y*Z}7ң6\nӺIE3Xݻ~[+TTKoYӷ ={QaXoc7قK1\0o}+|ET5U.ч\nieRStDb,*sܠ\"/D[۵m߸x(lqc@\rkFUJ׭!115ھbu%ϸ.\roѭOEFUz;6SXę\\ʴ\"l$Vފɨt\"s.&},i{}1<VՖlA.@\r\'K1\Zn7{R{-?ރ̠0t*2NPQ3*ՎdI}GF瞍|pii6(\n0dY%sO>B: Plދ\ZkPMc\rFl*Glſ2ޤ0[ɲV2	d)ۨNYLِ%wo~k&\06`\0DD\\e-✽qJ+Rh6sReI>xfa,sۈ#LlwN$msQPl,|\ZQ\0o{~ٚяI\\Y63n yA6HӿY1do;zO1XU4GגA+ݾ߂;cع\" dq8̋+Ys>ˤ8WlMrڑЈ[Ȁ\"\"\0\" \"\"\0\" \"\"\0\" \"\"\0\" \"\"\0\" \"\"\0\" \"\"\0\" \"\"\0\" \"\"\0\" \"\"\0\" \"\"\0\" \"\"\0\" \"\"\0\" \"\"\0\" \"\"\0\" \"\"\0\" \"\"\0\" ',0,NULL,0,NULL,NULL,NULL,'admin','2016-02-18 10:51:23',NULL,NULL),(68196,8776,8628387,NULL,3,'20160218104645','#\n#Thu Feb 18 10:46:45 CET 2016\nautoUpdate=true\nuser=admin\ndomainManagement=true\nname=payroll-test.aonsolutions.org\ntype=CONSULTANCY\nnumberOfUsers=0\nmaxTotalDocumentSize=100\n',12,NULL,0,'2016-02-18',NULL,NULL,'admin','2016-02-18 10:46:45',NULL,NULL),(68197,8776,8628387,NULL,3,'20160218104657','#\n#Thu Feb 18 10:46:57 CET 2016\nuser=admin\ndomainManagement=true\nname=payroll-test.aonsolutions.org\ntype=CONSULTANCY\nnumberOfUsers=1\nmaxTotalDocumentSize=100\n',12,NULL,0,'2016-02-18',NULL,NULL,'admin','2016-02-18 10:46:57',NULL,NULL),(68198,8776,8628387,NULL,3,'20160218104709','#\n#Thu Feb 18 10:47:09 CET 2016\nuser=admin\ndomainManagement=true\nmodules=PAYROLL\nname=payroll-test.aonsolutions.org\ntype=CONSULTANCY\nnumberOfUsers=1\nmaxTotalDocumentSize=100\n',12,NULL,0,'2016-02-18',NULL,NULL,'admin','2016-02-18 10:47:09',NULL,NULL),(68199,0,216081,NULL,3,'general-payroll-test.aonsolutions.org','#\n#Thu Feb 18 10:56:49 CET 2016\nuser=admin\ndomainManagement=false\nmodules=AON_ONE\nname=general-payroll-test.aonsolutions.org\ntype=ENTERPRISE\nparent=payroll-test.aonsolutions.org\nnumberOfUsers=0\nmaxTotalDocumentSize=100\n',13,NULL,0,'2016-02-18',NULL,NULL,'admin','2016-02-18 10:56:49',NULL,NULL),(68200,0,216081,NULL,3,'trainning-payroll-test.aonsolutions.org','#\n#Sun Feb 21 23:49:20 CET 2016\nuser=admin\ndomainManagement=false\nmodules=AON_ONE\nname=trainning-payroll-test.aonsolutions.org\ntype=ENTERPRISE\nparent=payroll-test.aonsolutions.org\nnumberOfUsers=0\nmaxTotalDocumentSize=100\n',13,NULL,0,'2016-02-21',NULL,NULL,'admin','2016-02-21 23:49:20',NULL,NULL),(68201,0,216081,NULL,3,'doc-test.aonsolutions.org','#\n#Mon Feb 22 11:29:07 CET 2016\nuser=admin\ndomainManagement=true\nname=doc-test.aonsolutions.org\ntype=CONSULTANCY\nnumberOfUsers=0\nmaxTotalDocumentSize=100\n',13,NULL,0,'2016-02-22',NULL,NULL,'admin','2016-02-22 11:29:07',NULL,NULL),(68202,0,216081,NULL,3,'agrarian-payroll-test.aonsolutions.org','#\n#Tue Feb 23 11:32:45 CET 2016\nuser=admin\ndomainManagement=false\nmodules=AON_ONE\nname=agrarian-payroll-test.aonsolutions.org\ntype=ENTERPRISE\nparent=payroll-test.aonsolutions.org\nnumberOfUsers=0\nmaxTotalDocumentSize=100\n',13,NULL,0,'2016-02-23',NULL,NULL,'admin','2016-02-23 11:32:45',NULL,NULL),(68203,8778,8628397,NULL,0,'aon-logo','\0JFIF\0\0\0\0\0\0\0\0	( \Z%!1\"%)+...383-7(-.+\n\n\n\r.# %-///---+5+5-+-/-----/5-----------5/---------------\0\0\"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0F\0	\0\0\0\0!1A\"Qaq2#BRbrт3Cc$%5S\0\Z\0\0\0\0\0\0\0\0\0\0\0\0\0-\0\0\0\0\0\0\0\0\0!1\"AQaq23\0\0\0?\0a@B\0!\0!@B\0!\0!@B6vF+qrAIk#\0\0	mX@?iUoS\05eX$\\<I>&	#c<S[m:]/N\07-K#%0\0!\0!@Fir	H=V[k8$Ud7)\0/2^IgyrgvzD|ɥJPq\'Se{wKOS*&MR/1䓬@n9*e7,4֕om@8^s`b{>2S-ƕR\"ݗo*%`)\'왃<Őxw٦k}Y=S5:XbȱaLB!7,D\n=fs~&<R(y#lU):mR0Ks}0]C1ѻIh[_b8j!\'DN [7JCv?f^&wA*L殬:~<`>-Fu:\ro}2ĕHDɴ[W~&xruIEyǽE*XPr\\Sf/62i]ĒI&$ƟU>\ZL84=OlUUWJg_ԫӨUu?Gk+[8zfaI\nE]/bo!!Hw\\EFYEj	FVG݅WkjS\nCz#J=erztRhJSG1~^#j~z`m\0լWU(Q˭9o|Z\0?294ֵ8c^x/-TXҺb\\{\r*<n8fv4]pOǉr~~3F8Qv$5\r@3R=и+Nz\\[B;OIlF\Z	RA\\qc}5o~\0!w:=0:wxG>DMG\'{uFZiJF-٭?d~V4\Z+frDbo&	e>G\"a:J:ɶcu#\\uX.U:\'^Eyfd͠5ebA6pkQojP\rρ/P*2vNRU)rT[Xv:xN$,i,&k֧Bf\0i4H%k\";V*FՍ\ryZUiVAXESM\\tESYao>jLH٭ݣ^ݍԯSQPz-IY܃RM،U4LWV?,`-ڣd9ݭ{c;QβKB8bU}\\CUwI=ы@;FJEWu`xgq549O{r_~*fc|C! # Q$9*7eG<\"c霧[SfEAw7iJOVͩF<)[j-DzMCSMe`Pf\r H.]2s*ijok\'KBjQxr_(<͇cVѪt)\0֖\r\\MO$}Y2(Jpu[060,\0ORem<>R)GrFʸZetKrhxh٠+ɗ-Ł[fz͍٬ŬMGiun?1D3UV#8}*jslG>2ƥ$XgVyμ:I|M^\"Ea73jET51fIRUvB42bͩX=\'E,Cte]|v*g\n:X*$\0zalxZ+BOcŏy\"͖0E=lh=#jJRG~zJC+.<A/fFhb)rb!QدsΤ%ߑlm7$V4L7[E_Џo;j?[\0kaYY͹\"$f@s<2]VE0Gs @2bfbe~­E(\"fX=NEWv\r|9-H\Z:{;.biOQ.@Iknn!~\'~6pq?F*euP30ӉA<u5t6WnkmJ՘ԪR:C[[nqR27UM؜҉<}50֛[9[e6#OK><asх\'(O\'b#\'L}!\'2ʃz7Y_=:xɱ60(1uP]\0#^xwd\rب\0}RQI$cmݵU5G\'6!SQl5:ó/h0\ZA7\Z|θ<PKu(%:ՙ[澣9\ZR-7\0va\0\0FLShb/jy[Vh:	PӀMOR!*TNaaޤ|dzzkB\r#;dqw	vEz;R/bM7G\08F&\Zd%N*[^Vo:Egk~kb5|l|=\\,M[*3֥;Ԟ}$v2P0լP$]\0FwJ- ȃ[&=%=\\ۺ@YTL(qfL6i4ᶫ+)[~kZQ`o!LIw!|D1d\0XJnJh_čo,esz7\'[!@$xZT;;f\\SqKU\r3ˎeSe|e2lkdv\'Y歿kթV$Էkh-_}K8gԝԅ9q<KffӰoVMdiv<ʃh\r)C\"xv_87wUSEJ`\\M?g5HV\\6rA4Ѝ\rn\rܯڟ9!N&eXX3*-قu>\\\'@\08:tc6eJKuI<M(.ͩS6[uXccC	[\07	o>eTQ~cڔk[)\ZqHﵺSE{]ӌK-hOg?=?=msFlZ*#2r=}D/u#fQm_N񷦓;4p8jDXJHL37Ōfw/^!	`<\0m=O3vP/-\0$gvթPWSo8<a)tYe|ʹ\0qҋ2bm[Y1	W떙),\0ءT*~kFc)<|<m&m#5m$8\0:>s8y[!&p-K73RӤ3TZa!ñ̌>\0lzK@Kmg>3*##7UI~O)ۏO=+kTUߐ)nd\0h4O.rRtp;h.}|5<A 8*sS:jY<n=)=\Z:L6|-:ibj\ZuP2˗:؋5}$GztDR\r7g)4jd+Ӕ1GB?/*Fypn~\'딊/^݀RI8#RVL6,IUkۘܞ\0fx;Vz\"QA^IZm{۴	k$!\\Hح:ɔݪD%֦\\VEϏto>᪻WUERVڥ5ȧwV30 -\"HۉJ9$7_?g\Z]yP͉YϟT|c`ZFT6`};L呻xiM[$ڭQ:_pSM׵Xz#Vn\0{!\0%ybPPKB\'g0ЀNSc٨dWZKnx%Y{5\0A\'@TjU31$td^8?!5Q=Uy˛;d6/Frw\'K\'HR|o[%@+\\{O)e8+157d$\"o3\"E?Ud6\ZS+jnEU97 \"糌RYx\0JXPgJ牿sNlz-M?^vtrIdN(huRIZ3ڬ?H> 񛘦6fN*9\ZpGlVˣvfHw+\rMH\0*,n^g|N~~#tauWR(\"jZ8=C/fTBo$c,{[?ob)4mGKZXwH\'QAU`$W*b\Z\0\0`-FSs&jIQ7-@93Fi&wpIťK֪\'./!}/C$\',\rZ4קr&p/m/$Od6*\05RЎ<o+߭)ثu!3_KGil8كi!ɂO&\0Ic(hl\\ˢ²5W3SuNpm8mfFucM	Q*bA<4;DȭPHFrbR\0:lzt_E0 {)vhEThSDz1nNU;l%:85  e>-g]\\B|cDCvAKM8Mm*J.t	WUF[5tRDMCu#yEl18%/{v?Gi(jp,~(YÓwPZ\0,~x\nb)pjHGYxT\'0˕(Uȳ3ƺP\0`&sw	q	͈^G50*xA:O\Zu	m<:j\0#CKV\rZ~\0#u!}#}\0\0|Nd\0\0T\0,pQ|!	ZhZiSɚ\'1k@Կ-I	eb1;f8I~8XLAgsk|H4ڕ.lnPUv9Am%ˀ8uGtpKUjj+\0X]McF?fġ.OՅ)B|6Uk7b4W}ǟ˔bq\ZǍEyb4HC\0J\\3[[FOmLRgPE$`NckJ}Ap4\'S8.֢vtG\Z>}w\'n2XtoIHV	u76>TvqʤO;y{hp ;Qp.\Z`\0}Dݻ_~%otu q#kt\'HM*uM\0տ\r;#snN5Gw2%[j\n5iS([lSu\Zk_8b)!\Zm$JKd%UF_0M3kdrAulۍ\0ÁMn:o7U:!\"ĕqO^(rjyQka֮\"7f\ri=yzbIi\"fZM$[,Ji껵Je1VM\r^\Z٘ź$	T y-Eq$-N=K皞ѷթ.oeπ. -Oʗz\nx}萷g\'WVs?C%մ_nt\\|gvjTʈWeE\\y==>E9\ZE\0nft\09TD +K!VZת\0޲g#[vcbhSEKTH!A,Q 8؁*|r0s)RlH`AVjn)^u\0vV(d4U\rfrz*KQJaDN.\'1n9sqjQ9jSKzݮG6+ԘMpd c1SgaF{\'Nq7\0Ӭ6Ɠn-Rb=Aھα77j6썘J?Hf=l\n潭k_\rNoІXaFg?vz?SPlcɎ/oRL7Y\0,d5VlQΠ*$[6%D9a[\nM\',Y◱m&VӇ/	e;RXOڵX[e$$	Y* GO]%̶4}lek|2ΞuHjD>d9;Ɓr\"8\0m5E!TgISC{NݬcU9s)[o6o(r)O\"ܵͦ;3+hMqt#KQ;?Y^{51t^E\0|Wv-ׄk,*8FL.D\"ׁ2_Fv#Z3zd)VKq#؆Fcr~3xJ	|8$rOy&=MK,䩾\"#-<N7h͂Ba\"5e7\0\r	Ֆ`gw	QԡM۵I\"<eGgӦ2*\0A7Bn-Im1!\0O>ЎAG,K6c~q1V9x(s\"+[%L˞.4	\rRD`Sr͉+EIZeLIw~HeU/[8vBX!թTyFMdUѕV`Eؑk_^Y@.zS¹KXu\rΒCQDT\';/IgHUk?	ʦ16;\0,0xp)Py?iGZ(5T_Ec1AàeS84./MY2oš6]\'U<1Jl40{&\0TE8\rj`X`@d,P6c,ͦm3hm3h@1iLbдT -3B\0Y5>\'8{EˊYJbE\0kҺ?h{\'Je\0iN?İ7-6)oO,0\Z8$AM7 A\'LU<a7CO_~f5NqU*ʫbrzZ\\tܘY,s.H-Q\\l\rttYCe[^Xt\Zn\\<&Ydw#GAK;AБ;94\0ݤ¬ګ\0ab\0&mi@Um3hm3i@L\0Bf\0!\0!@Bu8c@p\"\0kBφ)`miC20^C	0c\r(B\n1B!\0PI0g,-@3iBfЄ\0!\0!@B\0!\0!@B',0,NULL,0,NULL,NULL,NULL,'admin','2016-04-04 14:44:20',NULL,NULL),(68204,0,216081,NULL,3,'inactiva-payroll-test.aonsolutions.org','#\n#Wed Apr 20 15:26:58 CEST 2016\nuser=admin\ndomainManagement=false\nmodules=AON_ONE\nname=inactiva-payroll-test.aonsolutions.org\ntype=ENTERPRISE\nparent=payroll-test.aonsolutions.org\nnumberOfUsers=0\nmaxTotalDocumentSize=100\n',13,NULL,0,'2016-04-20',NULL,NULL,'admin','2016-04-20 15:26:58',NULL,NULL),(68205,8781,8628439,NULL,3,'20160420152809','#\n#Wed Apr 20 15:28:09 CEST 2016\nname=inactiva-payroll-test.aonsolutions.org\nnumberOfUsers=0\nmodules=AON_ONE\nautoUpdate=true\nuser=admin\ndomainManagement=false\ntype=ENTERPRISE\nmaxTotalDocumentSize=100\nparent=payroll-test.aonsolutions.org\n',12,NULL,0,'2016-04-20',NULL,NULL,'admin','2016-04-20 15:28:09',NULL,NULL),(68206,0,216081,NULL,3,'artistas-payroll-test.aonsolutions.org','#\n#Thu Apr 21 10:38:46 CEST 2016\nuser=admin\ndomainManagement=false\nmodules=AON_ONE\nname=artistas-payroll-test.aonsolutions.org\ntype=ENTERPRISE\nparent=payroll-test.aonsolutions.org\nnumberOfUsers=0\nmaxTotalDocumentSize=100\n',13,NULL,0,'2016-04-21',NULL,NULL,'admin','2016-04-21 10:38:46',NULL,NULL),(68207,0,216081,NULL,3,'convenios-payroll-test.aonsolutions.org','#\n#Fri May 06 10:19:49 CEST 2016\nuser=admin\ndomainManagement=false\nmodules=AON_ONE\nname=convenios-payroll-test.aonsolutions.org\ntype=ENTERPRISE\nparent=payroll-test.aonsolutions.org\nnumberOfUsers=0\nmaxTotalDocumentSize=100\n',13,NULL,0,'2016-05-06',NULL,NULL,'admin','2016-05-06 10:19:49',NULL,NULL),(68208,0,216081,NULL,3,'hosteleria-baleares-payroll-test.aonsolutions.org','#\n#Wed May 18 15:06:04 CEST 2016\nuser=admin\ndomainManagement=false\nmodules=AON_ONE\nname=hosteleria-baleares-payroll-test.aonsolutions.org\ntype=ENTERPRISE\nparent=payroll-test.aonsolutions.org\nnumberOfUsers=0\nmaxTotalDocumentSize=100\n',13,NULL,0,'2016-05-18',NULL,NULL,'admin','2016-05-18 15:06:04',NULL,NULL),(68209,0,216081,NULL,3,'calendarios-payroll-test.aonsolutions.org','#\n#Mon Jun 06 17:41:19 CEST 2016\nuser=admin\ndomainManagement=false\nmodules=AON_ONE\nname=calendarios-payroll-test.aonsolutions.org\ntype=ENTERPRISE\nparent=payroll-test.aonsolutions.org\nnumberOfUsers=0\nmaxTotalDocumentSize=100\n',13,NULL,0,'2016-06-06',NULL,NULL,'admin','2016-06-06 17:41:19',NULL,NULL),(68210,8785,8628474,NULL,3,'20160621162649','#\n#Tue Jun 21 16:26:49 CEST 2016\nname=calendarios-payroll-test.aonsolutions.org\nnumberOfUsers=0\nmodules=AON_ONE\nautoUpdate=true\nuser=admin\ndomainManagement=false\ntype=ENTERPRISE\nmaxTotalDocumentSize=100\nparent=payroll-test.aonsolutions.org\n',12,NULL,0,'2016-06-21',NULL,NULL,'admin','2016-06-21 16:26:49',NULL,NULL),(68211,0,216081,NULL,3,'20160706105825','#\n#Wed Jul 06 10:58:25 CEST 2016\nautoUpdate=true\nuser=admin\ndomainManagement=false\nname=admin-test.aonsolutions.org\ntype=ADMIN\ndisplayModules=DOCUMENT\nnumberOfUsers=5\nmaxTotalDocumentSize=100\n',12,NULL,0,'2016-07-06',NULL,NULL,'admin','2016-07-06 10:58:25',NULL,NULL),(68212,0,216081,NULL,3,'20160706110432','#\n#Wed Jul 06 11:04:32 CEST 2016\nautoUpdate=true\nuser=admin\ndomainManagement=false\nname=admin-test.aonsolutions.org\ntype=ADMIN\nnumberOfUsers=5\nmaxTotalDocumentSize=100\n',12,NULL,0,'2016-07-06',NULL,NULL,'admin','2016-07-06 11:04:32',NULL,NULL),(68213,0,216081,NULL,3,'metal-payroll-test.aonsolutions.org','#\n#Thu Sep 29 18:37:20 CEST 2016\nuser=admin\ndomainManagement=false\nmodules=AON_ONE\nname=metal-payroll-test.aonsolutions.org\ntype=ENTERPRISE\nparent=payroll-test.aonsolutions.org\nnumberOfUsers=0\nmaxTotalDocumentSize=100\n',13,NULL,0,'2016-09-29',NULL,NULL,'admin','2016-09-29 18:37:20',NULL,NULL),(68214,0,216081,NULL,3,'metal-payroll-test.aonsolutions.org','#\n#Thu Sep 29 18:39:23 CEST 2016\nuser=admin\ndomainManagement=false\nmodules=AON_ONE\nname=metal-payroll-test.aonsolutions.org\ntype=ENTERPRISE\nparent=payroll-test.aonsolutions.org\nnumberOfUsers=0\nmaxTotalDocumentSize=100\n',14,NULL,0,'2016-09-29',NULL,NULL,'admin','2016-09-29 18:39:23',NULL,NULL),(68215,0,216081,NULL,3,'metal-payroll-test.aonsolutions.org','#\n#Thu Sep 29 18:41:07 CEST 2016\nuser=admin\ndomainManagement=false\nmodules=AON_ONE\nname=metal-payroll-test.aonsolutions.org\ntype=ENTERPRISE\nparent=payroll-test.aonsolutions.org\nnumberOfUsers=0\nmaxTotalDocumentSize=100\n',13,NULL,0,'2016-09-29',NULL,NULL,'admin','2016-09-29 18:41:07',NULL,NULL),(68216,0,216081,NULL,3,'creta-payroll-test.aonsolutions.org','#\n#Mon Dec 19 11:11:09 CET 2016\nuser=admin\ndomainManagement=false\nmodules=AON_ONE\nname=creta-payroll-test.aonsolutions.org\ntype=ENTERPRISE\nparent=payroll-test.aonsolutions.org\nnumberOfUsers=0\nmaxTotalDocumentSize=100\n',13,NULL,0,'2016-12-19',NULL,NULL,'admin','2016-12-19 11:11:09',NULL,NULL);
/*!40000 ALTER TABLE `rattach` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rattach_tag`
--

DROP TABLE IF EXISTS `rattach_tag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rattach_tag` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `rattach` int(4) NOT NULL COMMENT 'Identificador del Archivo Adjunto',
  `tag` int(4) NOT NULL COMMENT 'Identificador de la Etiqueta',
  PRIMARY KEY (`id`),
  KEY `IDX_RATTACH_TAG_DOMAIN` (`domain`),
  KEY `IDX_RATTACH_TAG_RATTACH` (`rattach`),
  KEY `IDX_RATTACH_TAG_TAG` (`tag`),
  CONSTRAINT `FK_RATTACH_TAG_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_RATTACH_TAG_RATTACH` FOREIGN KEY (`rattach`) REFERENCES `rattach` (`id`),
  CONSTRAINT `FK_RATTACH_TAG_TAG` FOREIGN KEY (`tag`) REFERENCES `tag` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Relacion entre Archivos Adjuntos y Etiquetas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rattach_tag`
--

LOCK TABLES `rattach_tag` WRITE;
/*!40000 ALTER TABLE `rattach_tag` DISABLE KEYS */;
INSERT INTO `rattach_tag` VALUES (-4666,0,-2000,-1003),(-4665,0,-2000,-1002),(-4664,0,-1885,-1031),(-4663,0,-1885,-1004),(-4662,0,-1882,-1011),(-4661,0,-1882,-1002),(-4660,0,-1881,-1006),(-4659,0,-1881,-1004),(-4658,0,-1879,-1032),(-4657,0,-1879,-1002),(-4656,0,-1878,-1012),(-4655,0,-1878,-1004),(-4654,0,-1876,-1058),(-4653,0,-1876,-1004),(-4652,0,-1875,-1036),(-4651,0,-1875,-1004),(-4650,0,-1874,-1039),(-4649,0,-1874,-1004),(-4648,0,-1873,-1038),(-4647,0,-1873,-1004),(-4646,0,-1872,-1036),(-4645,0,-1872,-1004),(-4644,0,-1871,-1027),(-4643,0,-1871,-1004),(-4642,0,-1870,-1001),(-4641,0,-1870,-1000),(-4640,0,-1869,-1056),(-4639,0,-1869,-1004),(-4638,0,-1867,-1032),(-4637,0,-1867,-1002),(-4636,0,-1866,-1063),(-4635,0,-1866,-1002),(-4634,0,-1865,-1052),(-4633,0,-1865,-1004),(-4632,0,-1864,-1055),(-4631,0,-1864,-1002),(-4630,0,-1863,-1055),(-4629,0,-1863,-1002),(-4628,0,-1862,-1012),(-4627,0,-1862,-1004),(-4626,0,-1861,-1012),(-4625,0,-1861,-1004),(-4624,0,-1860,-1013),(-4623,0,-1860,-1004),(-4622,0,-1859,-1057),(-4621,0,-1859,-1002),(-4620,0,-1858,-1020),(-4619,0,-1858,-1004),(-4618,0,-1857,-1020),(-4617,0,-1857,-1004),(-4616,0,-1856,-1020),(-4615,0,-1856,-1004),(-4614,0,-1855,-1058),(-4613,0,-1855,-1004),(-4612,0,-1854,-1058),(-4611,0,-1854,-1004),(-4610,0,-1853,-1018),(-4609,0,-1853,-1002),(-4608,0,-1852,-1018),(-4607,0,-1852,-1002),(-4606,0,-1851,-1018),(-4605,0,-1851,-1002),(-4604,0,-1850,-1062),(-4603,0,-1850,-1002),(-4602,0,-1849,-1062),(-4601,0,-1849,-1002),(-4600,0,-1848,-1062),(-4599,0,-1848,-1002),(-4598,0,-1847,-1062),(-4597,0,-1847,-1002),(-4596,0,-1846,-1060),(-4595,0,-1846,-1002),(-4594,0,-1845,-1009),(-4593,0,-1845,-1002),(-4592,0,-1844,-1009),(-4591,0,-1844,-1002),(-4590,0,-1843,-1009),(-4589,0,-1843,-1002),(-4588,0,-1842,-1009),(-4587,0,-1842,-1002),(-4586,0,-1841,-1009),(-4585,0,-1841,-1002),(-4584,0,-1840,-1024),(-4583,0,-1840,-1004),(-4582,0,-1839,-1029),(-4581,0,-1839,-1002),(-4580,0,-1838,-1029),(-4579,0,-1838,-1002),(-4578,0,-1837,-1029),(-4577,0,-1837,-1002),(-4576,0,-1836,-1029),(-4575,0,-1836,-1002),(-4574,0,-1835,-1011),(-4573,0,-1835,-1002),(-4572,0,-1834,-1011),(-4571,0,-1834,-1002),(-4570,0,-1833,-1011),(-4569,0,-1833,-1002),(-4568,0,-1832,-1011),(-4567,0,-1832,-1002),(-4566,0,-1831,-1011),(-4565,0,-1831,-1002),(-4564,0,-1830,-1050),(-4563,0,-1830,-1004),(-4562,0,-1829,-1050),(-4561,0,-1829,-1004),(-4560,0,-1828,-1022),(-4559,0,-1828,-1002),(-4558,0,-1827,-1022),(-4557,0,-1827,-1002),(-4556,0,-1826,-1022),(-4555,0,-1826,-1002),(-4554,0,-1825,-1022),(-4553,0,-1825,-1002),(-4552,0,-1824,-1046),(-4551,0,-1824,-1004),(-4550,0,-1823,-1028),(-4549,0,-1823,-1004),(-4548,0,-1822,-1028),(-4547,0,-1822,-1004),(-4546,0,-1821,-1028),(-4545,0,-1821,-1004),(-4544,0,-1820,-1028),(-4543,0,-1820,-1004),(-4542,0,-1819,-1013),(-4541,0,-1819,-1004),(-4540,0,-1818,-1046),(-4539,0,-1818,-1004),(-4538,0,-1817,-1046),(-4537,0,-1817,-1004),(-4536,0,-1816,-1046),(-4535,0,-1816,-1004),(-4534,0,-1815,-1046),(-4533,0,-1815,-1004),(-4532,0,-1814,-1046),(-4531,0,-1814,-1004),(-4530,0,-1813,-1010),(-4529,0,-1813,-1004),(-4528,0,-1812,-1010),(-4527,0,-1812,-1004),(-4526,0,-1811,-1010),(-4525,0,-1811,-1004),(-4524,0,-1810,-1027),(-4523,0,-1810,-1004),(-4522,0,-1809,-1027),(-4521,0,-1809,-1004),(-4520,0,-1808,-1040),(-4519,0,-1808,-1004),(-4518,0,-1807,-1040),(-4517,0,-1807,-1004),(-4516,0,-1806,-1022),(-4515,0,-1806,-1002),(-4514,0,-1805,-1022),(-4513,0,-1805,-1002),(-4512,0,-1804,-1022),(-4511,0,-1804,-1002),(-4510,0,-1803,-1022),(-4509,0,-1803,-1002),(-4508,0,-1802,-1022),(-4507,0,-1802,-1002),(-4506,0,-1801,-1022),(-4505,0,-1801,-1002),(-4504,0,-1800,-1022),(-4503,0,-1800,-1002),(-4502,0,-1799,-1022),(-4501,0,-1799,-1002),(-4500,0,-1798,-1022),(-4499,0,-1798,-1002),(-4498,0,-1797,-1038),(-4497,0,-1797,-1004),(-4496,0,-1796,-1063),(-4495,0,-1796,-1002),(-4494,0,-1795,-1042),(-4493,0,-1795,-1004),(-4492,0,-1794,-1011),(-4491,0,-1794,-1002),(-4490,0,-1793,-1011),(-4489,0,-1793,-1002),(-4488,0,-1792,-1011),(-4487,0,-1792,-1002),(-4486,0,-1791,-1065),(-4485,0,-1791,-1002),(-4484,0,-1790,-1046),(-4483,0,-1790,-1004),(-4482,0,-1789,-1011),(-4481,0,-1789,-1002),(-4480,0,-1788,-1011),(-4479,0,-1788,-1002),(-4478,0,-1787,-1040),(-4477,0,-1787,-1004),(-4476,0,-1786,-1034),(-4475,0,-1786,-1004),(-4474,0,-1785,-1009),(-4473,0,-1785,-1002),(-4472,0,-1784,-1009),(-4471,0,-1784,-1002),(-4470,0,-1783,-1030),(-4469,0,-1783,-1002),(-4468,0,-1782,-1003),(-4467,0,-1782,-1002),(-4466,0,-1781,-1030),(-4465,0,-1781,-1002),(-4464,0,-1780,-1030),(-4463,0,-1780,-1002),(-4462,0,-1779,-1021),(-4461,0,-1779,-1002),(-4460,0,-1778,-1021),(-4459,0,-1778,-1002),(-4458,0,-1777,-1021),(-4457,0,-1777,-1002),(-4456,0,-1776,-1021),(-4455,0,-1776,-1002),(-4454,0,-1775,-1021),(-4453,0,-1775,-1002),(-4452,0,-1774,-1021),(-4451,0,-1774,-1002),(-4450,0,-1773,-1021),(-4449,0,-1773,-1002),(-4448,0,-1772,-1021),(-4447,0,-1772,-1002),(-4446,0,-1771,-1021),(-4445,0,-1771,-1002),(-4444,0,-1770,-1021),(-4443,0,-1770,-1002),(-4442,0,-1769,-1021),(-4441,0,-1769,-1002),(-4440,0,-1768,-1021),(-4439,0,-1768,-1002),(-4438,0,-1767,-1021),(-4437,0,-1767,-1002),(-4436,0,-1766,-1021),(-4435,0,-1766,-1002),(-4434,0,-1765,-1021),(-4433,0,-1765,-1002),(-4432,0,-1764,-1032),(-4431,0,-1764,-1002),(-4430,0,-1763,-1021),(-4429,0,-1763,-1002),(-4428,0,-1762,-1021),(-4427,0,-1762,-1002),(-4426,0,-1761,-1021),(-4425,0,-1761,-1002),(-4424,0,-1760,-1021),(-4423,0,-1760,-1002),(-4422,0,-1759,-1009),(-4421,0,-1759,-1002),(-4420,0,-1758,-1022),(-4419,0,-1758,-1002),(-4418,0,-1757,-1034),(-4417,0,-1757,-1004),(-4416,0,-1756,-1055),(-4415,0,-1756,-1002),(-4414,0,-1755,-1055),(-4413,0,-1755,-1002),(-4412,0,-1754,-1063),(-4411,0,-1754,-1002),(-4410,0,-1753,-1010),(-4409,0,-1753,-1004),(-4408,0,-1752,-1029),(-4407,0,-1752,-1002),(-4406,0,-1751,-1021),(-4405,0,-1751,-1002),(-4404,0,-1750,-1030),(-4403,0,-1750,-1002),(-4402,0,-1749,-1048),(-4401,0,-1749,-1004),(-4400,0,-1748,-1055),(-4399,0,-1748,-1002),(-4398,0,-1747,-1055),(-4397,0,-1747,-1002),(-4396,0,-1746,-1034),(-4395,0,-1746,-1004),(-4394,0,-1745,-1053),(-4393,0,-1745,-1002),(-4392,0,-1744,-1014),(-4391,0,-1744,-1002),(-4390,0,-1743,-1013),(-4389,0,-1743,-1004),(-4388,0,-1742,-1040),(-4387,0,-1742,-1004),(-4386,0,-1741,-1040),(-4385,0,-1741,-1004),(-4384,0,-1740,-1040),(-4383,0,-1740,-1004),(-4382,0,-1739,-1029),(-4381,0,-1739,-1002),(-4380,0,-1738,-1054),(-4379,0,-1738,-1004),(-4378,0,-1737,-1009),(-4377,0,-1737,-1002),(-4376,0,-1736,-1046),(-4375,0,-1736,-1004),(-4374,0,-1735,-1013),(-4373,0,-1735,-1004),(-4372,0,-1734,-1028),(-4371,0,-1734,-1004),(-4370,0,-1733,-1028),(-4369,0,-1733,-1004),(-4368,0,-1732,-1010),(-4367,0,-1732,-1004),(-4366,0,-1731,-1046),(-4365,0,-1731,-1004),(-4364,0,-1730,-1013),(-4363,0,-1730,-1004),(-4362,0,-1729,-1012),(-4361,0,-1729,-1004),(-4360,0,-1728,-1057),(-4359,0,-1728,-1002),(-4358,0,-1727,-1057),(-4357,0,-1727,-1002),(-4356,0,-1726,-1057),(-4355,0,-1726,-1002),(-4354,0,-1725,-1010),(-4353,0,-1725,-1004),(-4352,0,-1724,-1028),(-4351,0,-1724,-1004),(-4350,0,-1723,-1028),(-4349,0,-1723,-1004),(-4348,0,-1722,-1009),(-4347,0,-1722,-1002),(-4346,0,-1721,-1009),(-4345,0,-1721,-1002),(-4344,0,-1720,-1055),(-4343,0,-1720,-1002),(-4342,0,-1719,-1054),(-4341,0,-1719,-1004),(-4340,0,-1718,-1054),(-4339,0,-1718,-1004),(-4338,0,-1717,-1011),(-4337,0,-1717,-1002),(-4336,0,-1716,-1011),(-4335,0,-1716,-1002),(-4334,0,-1715,-1022),(-4333,0,-1715,-1002),(-4332,0,-1714,-1022),(-4331,0,-1714,-1002),(-4330,0,-1713,-1022),(-4329,0,-1713,-1002),(-4328,0,-1711,-1022),(-4327,0,-1711,-1002),(-4326,0,-1710,-1022),(-4325,0,-1710,-1002),(-4324,0,-1709,-1012),(-4323,0,-1709,-1004),(-4322,0,-1708,-1012),(-4321,0,-1708,-1004),(-4320,0,-1707,-1001),(-4319,0,-1707,-1000),(-4318,0,-1706,-1022),(-4317,0,-1706,-1002),(-4316,0,-1705,-1022),(-4315,0,-1705,-1002),(-4314,0,-1704,-1022),(-4313,0,-1704,-1002),(-4312,0,-1703,-1021),(-4311,0,-1703,-1002),(-4310,0,-1702,-1022),(-4309,0,-1702,-1002),(-4308,0,-1701,-1021),(-4307,0,-1701,-1002),(-4306,0,-1700,-1010),(-4305,0,-1700,-1004),(-4304,0,-1699,-1010),(-4303,0,-1699,-1004),(-4302,0,-1698,-1010),(-4301,0,-1698,-1004),(-4300,0,-1697,-1010),(-4299,0,-1697,-1004),(-4298,0,-1696,-1010),(-4297,0,-1696,-1004),(-4296,0,-1695,-1028),(-4295,0,-1695,-1004),(-4294,0,-1694,-1046),(-4293,0,-1694,-1004),(-4292,0,-1693,-1046),(-4291,0,-1693,-1004),(-4290,0,-1692,-1046),(-4289,0,-1692,-1004),(-4288,0,-1691,-1046),(-4287,0,-1691,-1004),(-4286,0,-1690,-1046),(-4285,0,-1690,-1004),(-4284,0,-1689,-1046),(-4283,0,-1689,-1004),(-4282,0,-1688,-1031),(-4281,0,-1688,-1004),(-4280,0,-1687,-1050),(-4279,0,-1687,-1004),(-4278,0,-1686,-1054),(-4277,0,-1686,-1004),(-4276,0,-1685,-1051),(-4275,0,-1685,-1004),(-4274,0,-1684,-1009),(-4273,0,-1684,-1002),(-4272,0,-1683,-1009),(-4271,0,-1683,-1002),(-4270,0,-1682,-1009),(-4269,0,-1682,-1002),(-4268,0,-1681,-1009),(-4267,0,-1681,-1002),(-4266,0,-1680,-1009),(-4265,0,-1680,-1002),(-4264,0,-1679,-1009),(-4263,0,-1679,-1002),(-4262,0,-1678,-1009),(-4261,0,-1678,-1002),(-4260,0,-1677,-1009),(-4259,0,-1677,-1002),(-4258,0,-1676,-1009),(-4257,0,-1676,-1002),(-4256,0,-1675,-1029),(-4255,0,-1675,-1002),(-4254,0,-1674,-1029),(-4253,0,-1674,-1002),(-4252,0,-1673,-1029),(-4251,0,-1673,-1002),(-4250,0,-1672,-1029),(-4249,0,-1672,-1002),(-4248,0,-1671,-1029),(-4247,0,-1671,-1002),(-4246,0,-1670,-1027),(-4245,0,-1670,-1004),(-4244,0,-1669,-1027),(-4243,0,-1669,-1004),(-4242,0,-1668,-1027),(-4241,0,-1668,-1004),(-4240,0,-1667,-1027),(-4239,0,-1667,-1004),(-4238,0,-1666,-1027),(-4237,0,-1666,-1004),(-4236,0,-1665,-1027),(-4235,0,-1665,-1004),(-4234,0,-1664,-1027),(-4233,0,-1664,-1004),(-4232,0,-1663,-1027),(-4231,0,-1663,-1004),(-4230,0,-1662,-1027),(-4229,0,-1662,-1004),(-4228,0,-1661,-1029),(-4227,0,-1661,-1002),(-4226,0,-1660,-1029),(-4225,0,-1660,-1002),(-4224,0,-1659,-1029),(-4223,0,-1659,-1002),(-4222,0,-1658,-1029),(-4221,0,-1658,-1002),(-4220,0,-1657,-1029),(-4219,0,-1657,-1002),(-4218,0,-1656,-1029),(-4217,0,-1656,-1002),(-4216,0,-1655,-1013),(-4215,0,-1655,-1004),(-4214,0,-1654,-1018),(-4213,0,-1654,-1002),(-4212,0,-1653,-1013),(-4211,0,-1653,-1004),(-4210,0,-1652,-1001),(-4209,0,-1652,-1000),(-4208,0,-1651,-1001),(-4207,0,-1651,-1000),(-4206,0,-1650,-1001),(-4205,0,-1650,-1000),(-4204,0,-1649,-1018),(-4203,0,-1649,-1002),(-4202,0,-1648,-1001),(-4201,0,-1648,-1000),(-4200,0,-1647,-1032),(-4199,0,-1647,-1002),(-4198,0,-1646,-1029),(-4197,0,-1646,-1002),(-4196,0,-1645,-1029),(-4195,0,-1645,-1002),(-4194,0,-1644,-1001),(-4193,0,-1644,-1000),(-4192,0,-1643,-1032),(-4191,0,-1643,-1002),(-4190,0,-1642,-1001),(-4189,0,-1642,-1000),(-4188,0,-1641,-1061),(-4187,0,-1641,-1002),(-4186,0,-1640,-1061),(-4185,0,-1640,-1002),(-4184,0,-1639,-1061),(-4183,0,-1639,-1002),(-4182,0,-1638,-1023),(-4181,0,-1638,-1004),(-4180,0,-1637,-1020),(-4179,0,-1637,-1004),(-4178,0,-1636,-1036),(-4177,0,-1636,-1004),(-4176,0,-1635,-1012),(-4175,0,-1635,-1004),(-4174,0,-1634,-1006),(-4173,0,-1634,-1004),(-4172,0,-1632,-1001),(-4171,0,-1632,-1000),(-4170,0,-1631,-1001),(-4169,0,-1631,-1000),(-4168,0,-1630,-1034),(-4167,0,-1630,-1004),(-4166,0,-1629,-1050),(-4165,0,-1629,-1004),(-4164,0,-1628,-1028),(-4163,0,-1628,-1004),(-4162,0,-1627,-1060),(-4161,0,-1627,-1002),(-4160,0,-1626,-1005),(-4159,0,-1626,-1004),(-4158,0,-1625,-1009),(-4157,0,-1625,-1002),(-4156,0,-1624,-1055),(-4155,0,-1624,-1002),(-4154,0,-1623,-1001),(-4153,0,-1623,-1000),(-4152,0,-1622,-1001),(-4151,0,-1622,-1000),(-4150,0,-1621,-1018),(-4149,0,-1621,-1002),(-4148,0,-1620,-1001),(-4147,0,-1620,-1000),(-4146,0,-1619,-1044),(-4145,0,-1619,-1004),(-4144,0,-1618,-1020),(-4143,0,-1618,-1004),(-4142,0,-1617,-1001),(-4141,0,-1617,-1000),(-4140,0,-1616,-1032),(-4139,0,-1616,-1002),(-4138,0,-1615,-1001),(-4137,0,-1615,-1000),(-4136,0,-1614,-1011),(-4135,0,-1614,-1002),(-4134,0,-1613,-1031),(-4133,0,-1613,-1004),(-4132,0,-1612,-1053),(-4131,0,-1612,-1002),(-4130,0,-1611,-1021),(-4129,0,-1611,-1002),(-4128,0,-1610,-1027),(-4127,0,-1610,-1004),(-4126,0,-1609,-1001),(-4125,0,-1609,-1000),(-4124,0,-1608,-1009),(-4123,0,-1608,-1002),(-4122,0,-1607,-1010),(-4121,0,-1607,-1004),(-4120,0,-1606,-1054),(-4119,0,-1606,-1004),(-4118,0,-1605,-1046),(-4117,0,-1605,-1004),(-4116,0,-1604,-1027),(-4115,0,-1604,-1004),(-4114,0,-1603,-1011),(-4113,0,-1603,-1002),(-4112,0,-1602,-1028),(-4111,0,-1602,-1004),(-4110,0,-1601,-1021),(-4109,0,-1601,-1002),(-4108,0,-1600,-1012),(-4107,0,-1600,-1004),(-4106,0,-1599,-1016),(-4105,0,-1599,-1004),(-4104,0,-1598,-1021),(-4103,0,-1598,-1002),(-4102,0,-1597,-1020),(-4101,0,-1597,-1004),(-4100,0,-1596,-1039),(-4099,0,-1596,-1004),(-4098,0,-1595,-1030),(-4097,0,-1595,-1002),(-4096,0,-1594,-1030),(-4095,0,-1594,-1002),(-4094,0,-1593,-1061),(-4093,0,-1593,-1002),(-4092,0,-1589,-1007),(-4091,0,-1589,-1004),(-4090,0,-1588,-1007),(-4089,0,-1588,-1004),(-4088,0,-1587,-1012),(-4087,0,-1587,-1004),(-4086,0,-1586,-1001),(-4085,0,-1586,-1000),(-4084,0,-1585,-1007),(-4083,0,-1585,-1004),(-4082,0,-1584,-1040),(-4081,0,-1584,-1004),(-4080,0,-1583,-1061),(-4079,0,-1583,-1002),(-4078,0,-1582,-1032),(-4077,0,-1582,-1002),(-4076,0,-1581,-1009),(-4075,0,-1581,-1002),(-4074,0,-1580,-1032),(-4073,0,-1580,-1002),(-4072,0,-1579,-1059),(-4071,0,-1579,-1004),(-4070,0,-1578,-1014),(-4069,0,-1578,-1002),(-4068,0,-1577,-1032),(-4067,0,-1577,-1002),(-4066,0,-1576,-1032),(-4065,0,-1576,-1002),(-4064,0,-1575,-1057),(-4063,0,-1575,-1002),(-4062,0,-1574,-1011),(-4061,0,-1574,-1002),(-4060,0,-1573,-1054),(-4059,0,-1573,-1004),(-4058,0,-1572,-1010),(-4057,0,-1572,-1004),(-4056,0,-1571,-1011),(-4055,0,-1571,-1002),(-4054,0,-1570,-1009),(-4053,0,-1570,-1002),(-4052,0,-1569,-1050),(-4051,0,-1569,-1004),(-4050,0,-1568,-1021),(-4049,0,-1568,-1002),(-4048,0,-1567,-1028),(-4047,0,-1567,-1004),(-4046,0,-1566,-1021),(-4045,0,-1566,-1002),(-4044,0,-1564,-1008),(-4043,0,-1564,-1004),(-4042,0,-1563,-1032),(-4041,0,-1563,-1002),(-4040,0,-1562,-1021),(-4039,0,-1562,-1002),(-4038,0,-1561,-1055),(-4037,0,-1561,-1002),(-4036,0,-1560,-1057),(-4035,0,-1560,-1002),(-4034,0,-1559,-1020),(-4033,0,-1559,-1004),(-4032,0,-1558,-1032),(-4031,0,-1558,-1002),(-4030,0,-1557,-1003),(-4029,0,-1557,-1002),(-4028,0,-1556,-1037),(-4027,0,-1556,-1004),(-4026,0,-1555,-1001),(-4025,0,-1555,-1000),(-4024,0,-1554,-1001),(-4023,0,-1554,-1000),(-4022,0,-1553,-1003),(-4021,0,-1553,-1002),(-4020,0,-1551,-1001),(-4019,0,-1551,-1000),(-4018,0,-1550,-1020),(-4017,0,-1550,-1004),(-4016,0,-1549,-1020),(-4015,0,-1549,-1004),(-4014,0,-1548,-1021),(-4013,0,-1548,-1002),(-4012,0,-1547,-1021),(-4011,0,-1547,-1002),(-4010,0,-1546,-1021),(-4009,0,-1546,-1002),(-4008,0,-1545,-1020),(-4007,0,-1545,-1004),(-4006,0,-1544,-1020),(-4005,0,-1544,-1004),(-4004,0,-1543,-1021),(-4003,0,-1543,-1002),(-4002,0,-1542,-1032),(-4001,0,-1542,-1002),(-4000,0,-1541,-1021),(-3999,0,-1541,-1002),(-3998,0,-1540,-1021),(-3997,0,-1540,-1002),(-3996,0,-1539,-1021),(-3995,0,-1539,-1002),(-3994,0,-1538,-1032),(-3993,0,-1538,-1002),(-3992,0,-1537,-1021),(-3991,0,-1537,-1002),(-3990,0,-1536,-1012),(-3989,0,-1536,-1004),(-3988,0,-1535,-1001),(-3987,0,-1535,-1000),(-3986,0,-1534,-1062),(-3985,0,-1534,-1002),(-3984,0,-1533,-1030),(-3983,0,-1533,-1002),(-3982,0,-1532,-1020),(-3981,0,-1532,-1004),(-3980,0,-1531,-1023),(-3979,0,-1531,-1004),(-3978,0,-1530,-1001),(-3977,0,-1530,-1000),(-3976,0,-1529,-1060),(-3975,0,-1529,-1002),(-3974,0,-1528,-1024),(-3973,0,-1528,-1004),(-3972,0,-1527,-1024),(-3971,0,-1527,-1004),(-3970,0,-1526,-1024),(-3969,0,-1526,-1004),(-3968,0,-1525,-1026),(-3967,0,-1525,-1004),(-3966,0,-1524,-1026),(-3965,0,-1524,-1004),(-3964,0,-1523,-1036),(-3963,0,-1523,-1004),(-3962,0,-1522,-1036),(-3961,0,-1522,-1004),(-3960,0,-1521,-1024),(-3959,0,-1521,-1004),(-3958,0,-1520,-1024),(-3957,0,-1520,-1004),(-3956,0,-1518,-1063),(-3955,0,-1518,-1002),(-3954,0,-1517,-1064),(-3953,0,-1517,-1002),(-3952,0,-1516,-1064),(-3951,0,-1516,-1002),(-3950,0,-1515,-1064),(-3949,0,-1515,-1002),(-3948,0,-1514,-1038),(-3947,0,-1514,-1004),(-3946,0,-1513,-1060),(-3945,0,-1513,-1002),(-3944,0,-1512,-1064),(-3943,0,-1512,-1002),(-3942,0,-1511,-1064),(-3941,0,-1511,-1002),(-3940,0,-1510,-1064),(-3939,0,-1510,-1002),(-3938,0,-1509,-1064),(-3937,0,-1509,-1002),(-3936,0,-1508,-1024),(-3935,0,-1508,-1004),(-3934,0,-1507,-1063),(-3933,0,-1507,-1002),(-3932,0,-1506,-1063),(-3931,0,-1506,-1002),(-3930,0,-1505,-1063),(-3929,0,-1505,-1002),(-3928,0,-1504,-1036),(-3927,0,-1504,-1004),(-3926,0,-1503,-1036),(-3925,0,-1503,-1004),(-3924,0,-1502,-1036),(-3923,0,-1502,-1004),(-3922,0,-1501,-1036),(-3921,0,-1501,-1004),(-3920,0,-1500,-1026),(-3919,0,-1500,-1004),(-3918,0,-1499,-1026),(-3917,0,-1499,-1004),(-3916,0,-1498,-1026),(-3915,0,-1498,-1004),(-3914,0,-1497,-1026),(-3913,0,-1497,-1004),(-3912,0,-1496,-1026),(-3911,0,-1496,-1004),(-3910,0,-1495,-1026),(-3909,0,-1495,-1004),(-3908,0,-1494,-1026),(-3907,0,-1494,-1004),(-3906,0,-1493,-1026),(-3905,0,-1493,-1004),(-3904,0,-1492,-1026),(-3903,0,-1492,-1004),(-3902,0,-1491,-1026),(-3901,0,-1491,-1004),(-3900,0,-1490,-1026),(-3899,0,-1490,-1004),(-3898,0,-1489,-1026),(-3897,0,-1489,-1004),(-3896,0,-1488,-1026),(-3895,0,-1488,-1004),(-3894,0,-1487,-1026),(-3893,0,-1487,-1004),(-3892,0,-1486,-1026),(-3891,0,-1486,-1004),(-3890,0,-1485,-1026),(-3889,0,-1485,-1004),(-3888,0,-1484,-1026),(-3887,0,-1484,-1004),(-3886,0,-1483,-1026),(-3885,0,-1483,-1004),(-3884,0,-1482,-1026),(-3883,0,-1482,-1004),(-3882,0,-1481,-1026),(-3881,0,-1481,-1004),(-3880,0,-1480,-1026),(-3879,0,-1480,-1004),(-3878,0,-1479,-1026),(-3877,0,-1479,-1004),(-3876,0,-1478,-1026),(-3875,0,-1478,-1004),(-3874,0,-1477,-1026),(-3873,0,-1477,-1004),(-3872,0,-1476,-1026),(-3871,0,-1476,-1004),(-3870,0,-1475,-1026),(-3869,0,-1475,-1004),(-3868,0,-1474,-1026),(-3867,0,-1474,-1004),(-3866,0,-1473,-1026),(-3865,0,-1473,-1004),(-3864,0,-1472,-1026),(-3863,0,-1472,-1004),(-3862,0,-1471,-1036),(-3861,0,-1471,-1004),(-3860,0,-1470,-1036),(-3859,0,-1470,-1004),(-3858,0,-1469,-1036),(-3857,0,-1469,-1004),(-3856,0,-1468,-1036),(-3855,0,-1468,-1004),(-3854,0,-1467,-1036),(-3853,0,-1467,-1004),(-3852,0,-1466,-1036),(-3851,0,-1466,-1004),(-3850,0,-1465,-1036),(-3849,0,-1465,-1004),(-3848,0,-1464,-1036),(-3847,0,-1464,-1004),(-3846,0,-1463,-1036),(-3845,0,-1463,-1004),(-3844,0,-1462,-1036),(-3843,0,-1462,-1004),(-3842,0,-1461,-1036),(-3841,0,-1461,-1004),(-3840,0,-1460,-1036),(-3839,0,-1460,-1004),(-3838,0,-1459,-1036),(-3837,0,-1459,-1004),(-3836,0,-1458,-1036),(-3835,0,-1458,-1004),(-3834,0,-1457,-1036),(-3833,0,-1457,-1004),(-3832,0,-1456,-1036),(-3831,0,-1456,-1004),(-3830,0,-1455,-1036),(-3829,0,-1455,-1004),(-3828,0,-1454,-1036),(-3827,0,-1454,-1004),(-3826,0,-1453,-1036),(-3825,0,-1453,-1004),(-3824,0,-1452,-1036),(-3823,0,-1452,-1004),(-3822,0,-1451,-1036),(-3821,0,-1451,-1004),(-3820,0,-1450,-1036),(-3819,0,-1450,-1004),(-3818,0,-1449,-1036),(-3817,0,-1449,-1004),(-3816,0,-1448,-1036),(-3815,0,-1448,-1004),(-3814,0,-1447,-1036),(-3813,0,-1447,-1004),(-3812,0,-1446,-1036),(-3811,0,-1446,-1004),(-3810,0,-1445,-1036),(-3809,0,-1445,-1004),(-3808,0,-1444,-1036),(-3807,0,-1444,-1004),(-3806,0,-1443,-1038),(-3805,0,-1443,-1004),(-3804,0,-1442,-1038),(-3803,0,-1442,-1004),(-3802,0,-1441,-1038),(-3801,0,-1441,-1004),(-3800,0,-1440,-1038),(-3799,0,-1440,-1004),(-3798,0,-1439,-1038),(-3797,0,-1439,-1004),(-3796,0,-1438,-1038),(-3795,0,-1438,-1004),(-3794,0,-1437,-1038),(-3793,0,-1437,-1004),(-3792,0,-1436,-1038),(-3791,0,-1436,-1004),(-3790,0,-1435,-1038),(-3789,0,-1435,-1004),(-3788,0,-1434,-1038),(-3787,0,-1434,-1004),(-3786,0,-1433,-1038),(-3785,0,-1433,-1004),(-3784,0,-1432,-1038),(-3783,0,-1432,-1004),(-3782,0,-1431,-1042),(-3781,0,-1431,-1004),(-3780,0,-1430,-1042),(-3779,0,-1430,-1004),(-3778,0,-1429,-1042),(-3777,0,-1429,-1004),(-3776,0,-1428,-1042),(-3775,0,-1428,-1004),(-3774,0,-1427,-1042),(-3773,0,-1427,-1004),(-3772,0,-1426,-1042),(-3771,0,-1426,-1004),(-3770,0,-1425,-1042),(-3769,0,-1425,-1004),(-3768,0,-1424,-1042),(-3767,0,-1424,-1004),(-3766,0,-1423,-1042),(-3765,0,-1423,-1004),(-3764,0,-1422,-1042),(-3763,0,-1422,-1004),(-3762,0,-1421,-1042),(-3761,0,-1421,-1004),(-3760,0,-1420,-1024),(-3759,0,-1420,-1004),(-3758,0,-1419,-1024),(-3757,0,-1419,-1004),(-3756,0,-1418,-1024),(-3755,0,-1418,-1004),(-3754,0,-1417,-1024),(-3753,0,-1417,-1004),(-3752,0,-1416,-1024),(-3751,0,-1416,-1004),(-3750,0,-1415,-1024),(-3749,0,-1415,-1004),(-3748,0,-1414,-1041),(-3747,0,-1414,-1004),(-3746,0,-1413,-1041),(-3745,0,-1413,-1004),(-3744,0,-1412,-1041),(-3743,0,-1412,-1004),(-3742,0,-1411,-1041),(-3741,0,-1411,-1004),(-3740,0,-1410,-1024),(-3739,0,-1410,-1004),(-3738,0,-1409,-1024),(-3737,0,-1409,-1004),(-3736,0,-1408,-1024),(-3735,0,-1408,-1004),(-3734,0,-1407,-1024),(-3733,0,-1407,-1004),(-3732,0,-1406,-1024),(-3731,0,-1406,-1004),(-3730,0,-1405,-1024),(-3729,0,-1405,-1004),(-3728,0,-1404,-1024),(-3727,0,-1404,-1004),(-3726,0,-1403,-1024),(-3725,0,-1403,-1004),(-3724,0,-1402,-1024),(-3723,0,-1402,-1004),(-3722,0,-1401,-1024),(-3721,0,-1401,-1004),(-3720,0,-1400,-1024),(-3719,0,-1400,-1004),(-3718,0,-1399,-1024),(-3717,0,-1399,-1004),(-3716,0,-1398,-1024),(-3715,0,-1398,-1004),(-3714,0,-1397,-1024),(-3713,0,-1397,-1004),(-3712,0,-1396,-1024),(-3711,0,-1396,-1004),(-3710,0,-1395,-1024),(-3709,0,-1395,-1004),(-3708,0,-1394,-1024),(-3707,0,-1394,-1004),(-3706,0,-1393,-1024),(-3705,0,-1393,-1004),(-3704,0,-1392,-1020),(-3703,0,-1392,-1004),(-3702,0,-1391,-1022),(-3701,0,-1391,-1002),(-3700,0,-1390,-1032),(-3699,0,-1390,-1002),(-3698,0,-1389,-1020),(-3697,0,-1389,-1004),(-3696,0,-1388,-1036),(-3695,0,-1388,-1004),(-3694,0,-1387,-1030),(-3693,0,-1387,-1002),(-3692,0,-1386,-1013),(-3691,0,-1386,-1004),(-3690,0,-1385,-1032),(-3689,0,-1385,-1002),(-3688,0,-1384,-1034),(-3687,0,-1384,-1004),(-3686,0,-1382,-1034),(-3685,0,-1382,-1004),(-3684,0,-1381,-1034),(-3683,0,-1381,-1004),(-3682,0,-1380,-1034),(-3681,0,-1380,-1004),(-3680,0,-1379,-1034),(-3679,0,-1379,-1004),(-3678,0,-1378,-1030),(-3677,0,-1378,-1002),(-3676,0,-1377,-1030),(-3675,0,-1377,-1002),(-3674,0,-1376,-1030),(-3673,0,-1376,-1002),(-3672,0,-1375,-1030),(-3671,0,-1375,-1002),(-3670,0,-1374,-1040),(-3669,0,-1374,-1004),(-3668,0,-1373,-1034),(-3667,0,-1373,-1004),(-3666,0,-1372,-1034),(-3665,0,-1372,-1004),(-3664,0,-1370,-1034),(-3663,0,-1370,-1004),(-3662,0,-1369,-1034),(-3661,0,-1369,-1004),(-3660,0,-1368,-1034),(-3659,0,-1368,-1004),(-3658,0,-1367,-1030),(-3657,0,-1367,-1002),(-3656,0,-1366,-1012),(-3655,0,-1366,-1004),(-3654,0,-1365,-1005),(-3653,0,-1365,-1004),(-3652,0,-1364,-1032),(-3651,0,-1364,-1002),(-3650,0,-1363,-1001),(-3649,0,-1363,-1000),(-3648,0,-1362,-1039),(-3647,0,-1362,-1004),(-3646,0,-1361,-1026),(-3645,0,-1361,-1004),(-3644,0,-1360,-1011),(-3643,0,-1360,-1002),(-3642,0,-1359,-1046),(-3641,0,-1359,-1004),(-3640,0,-1358,-1015),(-3639,0,-1358,-1004),(-3638,0,-1357,-1001),(-3637,0,-1357,-1000),(-3636,0,-1356,-1018),(-3635,0,-1356,-1002),(-3634,0,-1355,-1061),(-3633,0,-1355,-1002),(-3632,0,-1354,-1001),(-3631,0,-1354,-1000),(-3630,0,-1353,-1032),(-3629,0,-1353,-1002),(-3628,0,-1352,-1032),(-3627,0,-1352,-1002),(-3626,0,-1351,-1063),(-3625,0,-1351,-1002),(-3624,0,-1350,-1021),(-3623,0,-1350,-1002),(-3622,0,-1349,-1021),(-3621,0,-1349,-1002),(-3620,0,-1348,-1031),(-3619,0,-1348,-1004),(-3618,0,-1347,-1003),(-3617,0,-1347,-1002),(-3616,0,-1346,-1044),(-3615,0,-1346,-1004),(-3614,0,-1345,-1032),(-3613,0,-1345,-1002),(-3612,0,-1344,-1001),(-3611,0,-1344,-1000),(-3610,0,-1343,-1012),(-3609,0,-1343,-1004),(-3608,0,-1342,-1003),(-3607,0,-1342,-1002),(-3606,0,-1341,-1015),(-3605,0,-1341,-1004),(-3604,0,-1340,-1032),(-3603,0,-1340,-1002),(-3602,0,-1339,-1035),(-3601,0,-1339,-1004),(-3600,0,-1338,-1055),(-3599,0,-1338,-1002),(-3598,0,-1337,-1029),(-3597,0,-1337,-1002),(-3596,0,-1336,-1041),(-3595,0,-1336,-1004),(-3594,0,-1335,-1060),(-3593,0,-1335,-1002),(-3592,0,-1334,-1062),(-3591,0,-1334,-1002),(-3590,0,-1333,-1058),(-3589,0,-1333,-1004),(-3588,0,-1332,-1032),(-3587,0,-1332,-1002),(-3586,0,-1331,-1034),(-3585,0,-1331,-1004),(-3584,0,-1330,-1026),(-3583,0,-1330,-1004),(-3582,0,-1328,-1059),(-3581,0,-1328,-1004),(-3580,0,-1327,-1042),(-3579,0,-1327,-1004),(-3578,0,-1326,-1032),(-3577,0,-1326,-1002),(-3576,0,-1325,-1020),(-3575,0,-1325,-1004),(-3574,0,-1324,-1050),(-3573,0,-1324,-1004),(-3572,0,-1323,-1028),(-3571,0,-1323,-1004),(-3570,0,-1322,-1063),(-3569,0,-1322,-1002),(-3568,0,-1321,-1046),(-3567,0,-1321,-1004),(-3566,0,-1320,-1032),(-3565,0,-1320,-1002),(-3564,0,-1319,-1038),(-3563,0,-1319,-1004),(-3562,0,-1318,-1027),(-3561,0,-1318,-1004),(-3560,0,-1317,-1027),(-3559,0,-1317,-1004),(-3558,0,-1315,-1001),(-3557,0,-1315,-1000),(-3556,0,-1314,-1026),(-3555,0,-1314,-1004),(-3554,0,-1313,-1001),(-3553,0,-1313,-1000),(-3552,0,-1312,-1013),(-3551,0,-1312,-1004),(-3550,0,-1311,-1003),(-3549,0,-1311,-1002),(-3548,0,-1310,-1001),(-3547,0,-1310,-1000),(-3546,0,-1309,-1034),(-3545,0,-1309,-1004),(-3544,0,-1308,-1005),(-3543,0,-1308,-1004),(-3542,0,-1307,-1034),(-3541,0,-1307,-1004),(-3540,0,-1306,-1035),(-3539,0,-1306,-1004),(-3538,0,-1305,-1009),(-3537,0,-1305,-1002),(-3536,0,-1304,-1032),(-3535,0,-1304,-1002),(-3534,0,-1303,-1027),(-3533,0,-1303,-1004),(-3532,0,-1302,-1003),(-3531,0,-1302,-1002),(-3530,0,-1301,-1001),(-3529,0,-1301,-1000),(-3528,0,-1300,-1032),(-3527,0,-1300,-1002),(-3526,0,-1299,-1024),(-3525,0,-1299,-1004),(-3524,0,-1298,-1011),(-3523,0,-1298,-1002),(-3522,0,-1297,-1021),(-3521,0,-1297,-1002),(-3520,0,-1296,-1013),(-3519,0,-1296,-1004),(-3518,0,-1295,-1010),(-3517,0,-1295,-1004),(-3516,0,-1294,-1046),(-3515,0,-1294,-1004),(-3514,0,-1293,-1034),(-3513,0,-1293,-1004),(-3512,0,-1292,-1041),(-3511,0,-1292,-1004),(-3510,0,-1291,-1018),(-3509,0,-1291,-1002),(-3508,0,-1290,-1042),(-3507,0,-1290,-1004),(-3506,0,-1289,-1047),(-3505,0,-1289,-1004),(-3504,0,-1288,-1015),(-3503,0,-1288,-1004),(-3502,0,-1287,-1057),(-3501,0,-1287,-1002),(-3500,0,-1286,-1049),(-3499,0,-1286,-1004),(-3498,0,-1285,-1021),(-3497,0,-1285,-1002),(-3496,0,-1284,-1006),(-3495,0,-1284,-1004),(-3494,0,-1283,-1012),(-3493,0,-1283,-1004),(-3492,0,-1282,-1011),(-3491,0,-1282,-1002),(-3490,0,-1281,-1040),(-3489,0,-1281,-1004),(-3488,0,-1280,-1057),(-3487,0,-1280,-1002),(-3486,0,-1279,-1045),(-3485,0,-1279,-1004),(-3484,0,-1278,-1001),(-3483,0,-1278,-1000),(-3482,0,-1277,-1048),(-3481,0,-1277,-1004),(-3480,0,-1276,-1053),(-3479,0,-1276,-1002),(-3478,0,-1275,-1042),(-3477,0,-1275,-1004),(-3476,0,-1274,-1063),(-3475,0,-1274,-1002),(-3474,0,-1273,-1048),(-3473,0,-1273,-1004),(-3472,0,-1272,-1048),(-3471,0,-1272,-1004),(-3470,0,-1271,-1048),(-3469,0,-1271,-1004),(-3468,0,-1270,-1048),(-3467,0,-1270,-1004),(-3466,0,-1268,-1048),(-3465,0,-1268,-1004),(-3464,0,-1267,-1047),(-3463,0,-1267,-1004),(-3462,0,-1266,-1047),(-3461,0,-1266,-1004),(-3460,0,-1265,-1048),(-3459,0,-1265,-1004),(-3458,0,-1264,-1047),(-3457,0,-1264,-1004),(-3456,0,-1263,-1047),(-3455,0,-1263,-1004),(-3454,0,-1262,-1048),(-3453,0,-1262,-1004),(-3452,0,-1261,-1021),(-3451,0,-1261,-1002),(-3450,0,-1260,-1024),(-3449,0,-1260,-1004),(-3448,0,-1259,-1036),(-3447,0,-1259,-1004),(-3446,0,-1258,-1049),(-3445,0,-1258,-1004),(-3444,0,-1257,-1034),(-3443,0,-1257,-1004),(-3442,0,-1256,-1035),(-3441,0,-1256,-1004),(-3440,0,-1255,-1009),(-3439,0,-1255,-1002),(-3438,0,-1254,-1037),(-3437,0,-1254,-1004),(-3436,0,-1253,-1027),(-3435,0,-1253,-1004),(-3434,0,-1252,-1040),(-3433,0,-1252,-1004),(-3432,0,-1251,-1055),(-3431,0,-1251,-1002),(-3430,0,-1250,-1030),(-3429,0,-1250,-1002),(-3428,0,-1249,-1005),(-3427,0,-1249,-1004),(-3426,0,-1248,-1041),(-3425,0,-1248,-1004),(-3424,0,-1247,-1020),(-3423,0,-1247,-1004),(-3422,0,-1246,-1032),(-3421,0,-1246,-1002),(-3420,0,-1245,-1032),(-3419,0,-1245,-1002),(-3418,0,-1244,-1032),(-3417,0,-1244,-1002),(-3416,0,-1243,-1032),(-3415,0,-1243,-1002),(-3414,0,-1241,-1032),(-3413,0,-1241,-1002),(-3412,0,-1240,-1032),(-3411,0,-1240,-1002),(-3410,0,-1239,-1032),(-3409,0,-1239,-1002),(-3408,0,-1238,-1032),(-3407,0,-1238,-1002),(-3406,0,-1237,-1032),(-3405,0,-1237,-1002),(-3404,0,-1236,-1032),(-3403,0,-1236,-1002),(-3402,0,-1235,-1032),(-3401,0,-1235,-1002),(-3400,0,-1234,-1037),(-3399,0,-1234,-1004),(-3398,0,-1233,-1037),(-3397,0,-1233,-1004),(-3396,0,-1232,-1037),(-3395,0,-1232,-1004),(-3394,0,-1231,-1037),(-3393,0,-1231,-1004),(-3392,0,-1230,-1037),(-3391,0,-1230,-1004),(-3390,0,-1229,-1037),(-3389,0,-1229,-1004),(-3388,0,-1228,-1037),(-3387,0,-1228,-1004),(-3386,0,-1227,-1037),(-3385,0,-1227,-1004),(-3384,0,-1226,-1037),(-3383,0,-1226,-1004),(-3382,0,-1225,-1037),(-3381,0,-1225,-1004),(-3380,0,-1224,-1052),(-3379,0,-1224,-1004),(-3378,0,-1223,-1052),(-3377,0,-1223,-1004),(-3376,0,-1222,-1052),(-3375,0,-1222,-1004),(-3374,0,-1221,-1052),(-3373,0,-1221,-1004),(-3372,0,-1220,-1052),(-3371,0,-1220,-1004),(-3370,0,-1219,-1052),(-3369,0,-1219,-1004),(-3368,0,-1218,-1052),(-3367,0,-1218,-1004),(-3366,0,-1217,-1052),(-3365,0,-1217,-1004),(-3364,0,-1216,-1039),(-3363,0,-1216,-1004),(-3362,0,-1215,-1039),(-3361,0,-1215,-1004),(-3360,0,-1214,-1026),(-3359,0,-1214,-1004),(-3358,0,-1213,-1023),(-3357,0,-1213,-1004),(-3356,0,-1212,-1030),(-3355,0,-1212,-1002),(-3354,0,-1211,-1029),(-3353,0,-1211,-1002),(-3352,0,-1210,-1018),(-3351,0,-1210,-1002),(-3350,0,-1209,-1001),(-3349,0,-1209,-1000),(-3348,0,-1208,-1032),(-3347,0,-1208,-1002),(-3346,0,-1207,-1045),(-3345,0,-1207,-1004),(-3344,0,-1206,-1044),(-3343,0,-1206,-1004),(-3342,0,-1205,-1048),(-3341,0,-1205,-1004),(-3340,0,-1204,-1048),(-3339,0,-1204,-1004),(-3338,0,-1203,-1047),(-3337,0,-1203,-1004),(-3336,0,-1202,-1032),(-3335,0,-1202,-1002),(-3334,0,-1201,-1029),(-3333,0,-1201,-1002),(-3332,0,-1200,-1023),(-3331,0,-1200,-1004),(-3330,0,-1199,-1047),(-3329,0,-1199,-1004),(-3328,0,-1198,-1047),(-3327,0,-1198,-1004),(-3326,0,-1197,-1022),(-3325,0,-1197,-1002),(-3324,0,-1196,-1012),(-3323,0,-1196,-1004),(-3322,0,-1195,-1027),(-3321,0,-1195,-1004),(-3320,0,-1194,-1040),(-3319,0,-1194,-1004),(-3318,0,-1193,-1005),(-3317,0,-1193,-1004),(-3316,0,-1192,-1047),(-3315,0,-1192,-1004),(-3314,0,-1191,-1047),(-3313,0,-1191,-1004),(-3312,0,-1190,-1001),(-3311,0,-1190,-1000),(-3310,0,-1189,-1001),(-3309,0,-1189,-1000),(-3308,0,-1188,-1005),(-3307,0,-1188,-1004),(-3306,0,-1187,-1032),(-3305,0,-1187,-1002),(-3304,0,-1186,-1047),(-3303,0,-1186,-1004),(-3302,0,-1185,-1024),(-3301,0,-1185,-1004),(-3300,0,-1184,-1065),(-3299,0,-1184,-1002),(-3298,0,-1183,-1061),(-3297,0,-1183,-1002),(-3296,0,-1182,-1007),(-3295,0,-1182,-1004),(-3294,0,-1181,-1001),(-3293,0,-1181,-1000),(-3292,0,-1180,-1059),(-3291,0,-1180,-1004),(-3290,0,-1179,-1059),(-3289,0,-1179,-1004),(-3288,0,-1178,-1032),(-3287,0,-1178,-1002),(-3286,0,-1177,-1032),(-3285,0,-1177,-1002),(-3284,0,-1176,-1024),(-3283,0,-1176,-1004),(-3282,0,-1175,-1064),(-3281,0,-1175,-1002),(-3280,0,-1174,-1038),(-3279,0,-1174,-1004),(-3278,0,-1173,-1012),(-3277,0,-1173,-1004),(-3276,0,-1172,-1046),(-3275,0,-1172,-1004),(-3274,0,-1171,-1026),(-3273,0,-1171,-1004),(-3272,0,-1170,-1011),(-3271,0,-1170,-1002),(-3270,0,-1169,-1063),(-3269,0,-1169,-1002),(-3268,0,-1168,-1009),(-3267,0,-1168,-1002),(-3266,0,-1167,-1049),(-3265,0,-1167,-1004),(-3264,0,-1166,-1054),(-3263,0,-1166,-1004),(-3262,0,-1165,-1059),(-3261,0,-1165,-1004),(-3260,0,-1164,-1028),(-3259,0,-1164,-1004),(-3258,0,-1163,-1012),(-3257,0,-1163,-1004),(-3256,0,-1162,-1024),(-3255,0,-1162,-1004),(-3254,0,-1161,-1032),(-3253,0,-1161,-1002),(-3252,0,-1160,-1034),(-3251,0,-1160,-1004),(-3250,0,-1159,-1029),(-3249,0,-1159,-1002),(-3248,0,-1158,-1029),(-3247,0,-1158,-1002),(-3246,0,-1157,-1062),(-3245,0,-1157,-1002),(-3244,0,-1156,-1044),(-3243,0,-1156,-1004),(-3242,0,-1155,-1015),(-3241,0,-1155,-1004),(-3240,0,-1154,-1015),(-3239,0,-1154,-1004),(-3238,0,-1153,-1015),(-3237,0,-1153,-1004),(-3236,0,-1152,-1015),(-3235,0,-1152,-1004),(-3234,0,-1151,-1015),(-3233,0,-1151,-1004),(-3232,0,-1150,-1015),(-3231,0,-1150,-1004),(-3230,0,-1149,-1015),(-3229,0,-1149,-1004),(-3228,0,-1148,-1015),(-3227,0,-1148,-1004),(-3226,0,-1147,-1015),(-3225,0,-1147,-1004),(-3224,0,-1146,-1015),(-3223,0,-1146,-1004),(-3222,0,-1145,-1015),(-3221,0,-1145,-1004),(-3220,0,-1144,-1015),(-3219,0,-1144,-1004),(-3218,0,-1143,-1007),(-3217,0,-1143,-1004),(-3216,0,-1142,-1030),(-3215,0,-1142,-1002),(-3214,0,-1141,-1037),(-3213,0,-1141,-1004),(-3212,0,-1140,-1048),(-3211,0,-1140,-1004),(-3210,0,-1139,-1044),(-3209,0,-1139,-1004),(-3208,0,-1138,-1029),(-3207,0,-1138,-1002),(-3206,0,-1137,-1029),(-3205,0,-1137,-1002),(-3204,0,-1136,-1056),(-3203,0,-1136,-1004),(-3202,0,-1135,-1029),(-3201,0,-1135,-1002),(-3200,0,-1134,-1018),(-3199,0,-1134,-1002),(-3198,0,-1133,-1056),(-3197,0,-1133,-1004),(-3196,0,-1132,-1059),(-3195,0,-1132,-1004),(-3194,0,-1131,-1046),(-3193,0,-1131,-1004),(-3192,0,-1130,-1009),(-3191,0,-1130,-1002),(-3190,0,-1129,-1003),(-3189,0,-1129,-1002),(-3188,0,-1128,-1018),(-3187,0,-1128,-1002),(-3186,0,-1127,-1036),(-3185,0,-1127,-1004),(-3184,0,-1126,-1016),(-3183,0,-1126,-1004),(-3182,0,-1125,-1016),(-3181,0,-1125,-1004),(-3180,0,-1124,-1058),(-3179,0,-1124,-1004),(-3178,0,-1123,-1019),(-3177,0,-1123,-1004),(-3176,0,-1122,-1016),(-3175,0,-1122,-1004),(-3174,0,-1121,-1007),(-3173,0,-1121,-1004),(-3172,0,-1120,-1058),(-3171,0,-1120,-1004),(-3170,0,-1119,-1058),(-3169,0,-1119,-1004),(-3168,0,-1118,-1058),(-3167,0,-1118,-1004),(-3166,0,-1117,-1058),(-3165,0,-1117,-1004),(-3164,0,-1116,-1038),(-3163,0,-1116,-1004),(-3162,0,-1115,-1062),(-3161,0,-1115,-1002),(-3160,0,-1114,-1046),(-3159,0,-1114,-1004),(-3158,0,-1113,-1013),(-3157,0,-1113,-1004),(-3156,0,-1112,-1028),(-3155,0,-1112,-1004),(-3154,0,-1111,-1060),(-3153,0,-1111,-1002),(-3152,0,-1110,-1036),(-3151,0,-1110,-1004),(-3150,0,-1109,-1042),(-3149,0,-1109,-1004),(-3148,0,-1108,-1001),(-3147,0,-1108,-1000),(-3146,0,-1107,-1016),(-3145,0,-1107,-1004),(-3144,0,-1106,-1058),(-3143,0,-1106,-1004),(-3142,0,-1105,-1019),(-3141,0,-1105,-1004),(-3140,0,-1104,-1008),(-3139,0,-1104,-1004),(-3138,0,-1103,-1052),(-3137,0,-1103,-1004),(-3136,0,-1102,-1032),(-3135,0,-1102,-1002),(-3134,0,-1101,-1039),(-3133,0,-1101,-1004),(-3132,0,-1100,-1039),(-3131,0,-1100,-1004),(-3130,0,-1099,-1032),(-3129,0,-1099,-1002),(-3128,0,-1098,-1037),(-3127,0,-1098,-1004),(-3126,0,-1097,-1037),(-3125,0,-1097,-1004),(-3124,0,-1096,-1037),(-3123,0,-1096,-1004),(-3122,0,-1095,-1032),(-3121,0,-1095,-1002),(-3120,0,-1094,-1039),(-3119,0,-1094,-1004),(-3118,0,-1093,-1032),(-3117,0,-1093,-1002),(-3116,0,-1092,-1037),(-3115,0,-1092,-1004),(-3114,0,-1091,-1032),(-3113,0,-1091,-1002),(-3112,0,-1090,-1032),(-3111,0,-1090,-1002),(-3110,0,-1089,-1037),(-3109,0,-1089,-1004),(-3108,0,-1088,-1052),(-3107,0,-1088,-1004),(-3106,0,-1087,-1039),(-3105,0,-1087,-1004),(-3104,0,-1086,-1039),(-3103,0,-1086,-1004),(-3102,0,-1085,-1039),(-3101,0,-1085,-1004),(-3100,0,-1084,-1052),(-3099,0,-1084,-1004),(-3098,0,-1083,-1026),(-3097,0,-1083,-1004),(-3096,0,-1082,-1037),(-3095,0,-1082,-1004),(-3094,0,-1081,-1032),(-3093,0,-1081,-1002),(-3092,0,-1080,-1037),(-3091,0,-1080,-1004),(-3090,0,-1079,-1036),(-3089,0,-1079,-1004),(-3088,0,-1078,-1039),(-3087,0,-1078,-1004),(-3086,0,-1077,-1037),(-3085,0,-1077,-1004),(-3084,0,-1076,-1032),(-3083,0,-1076,-1002),(-3082,0,-1075,-1037),(-3081,0,-1075,-1004),(-3080,0,-1074,-1037),(-3079,0,-1074,-1004),(-3078,0,-1073,-1052),(-3077,0,-1073,-1004),(-3076,0,-1072,-1037),(-3075,0,-1072,-1004),(-3074,0,-1071,-1032),(-3073,0,-1071,-1002),(-3072,0,-1070,-1040),(-3071,0,-1070,-1004),(-3070,0,-1069,-1024),(-3069,0,-1069,-1004),(-3068,0,-1068,-1048),(-3067,0,-1068,-1004),(-3066,0,-1067,-1009),(-3065,0,-1067,-1002),(-3064,0,-1066,-1029),(-3063,0,-1066,-1002),(-3062,0,-1065,-1026),(-3061,0,-1065,-1004),(-3060,0,-1064,-1020),(-3059,0,-1064,-1004),(-3058,0,-1063,-1028),(-3057,0,-1063,-1004),(-3056,0,-1062,-1015),(-3055,0,-1062,-1004),(-3054,0,-1061,-1030),(-3053,0,-1061,-1002),(-3052,0,-1060,-1021),(-3051,0,-1060,-1002),(-3050,0,-1059,-1026),(-3049,0,-1059,-1004),(-3048,0,-1058,-1031),(-3047,0,-1058,-1004),(-3046,0,-1057,-1001),(-3045,0,-1057,-1000),(-3044,0,-1056,-1040),(-3043,0,-1056,-1004),(-3042,0,-1055,-1061),(-3041,0,-1055,-1002),(-3040,0,-1054,-1061),(-3039,0,-1054,-1002),(-3038,0,-1053,-1057),(-3037,0,-1053,-1002),(-3036,0,-1052,-1061),(-3035,0,-1052,-1002),(-3034,0,-1051,-1022),(-3033,0,-1051,-1002),(-3032,0,-1050,-1022),(-3031,0,-1050,-1002),(-3030,0,-1049,-1022),(-3029,0,-1049,-1002),(-3028,0,-1048,-1022),(-3027,0,-1048,-1002),(-3026,0,-1047,-1022),(-3025,0,-1047,-1002),(-3024,0,-1046,-1022),(-3023,0,-1046,-1002),(-3022,0,-1045,-1056),(-3021,0,-1045,-1004),(-3020,0,-1044,-1056),(-3019,0,-1044,-1004),(-3018,0,-1043,-1056),(-3017,0,-1043,-1004),(-3016,0,-1042,-1056),(-3015,0,-1042,-1004),(-3014,0,-1041,-1056),(-3013,0,-1041,-1004),(-3012,0,-1040,-1056),(-3011,0,-1040,-1004),(-3010,0,-1039,-1056),(-3009,0,-1039,-1004),(-3008,0,-1038,-1056),(-3007,0,-1038,-1004),(-3006,0,-1037,-1056),(-3005,0,-1037,-1004),(-3004,0,-1036,-1056),(-3003,0,-1036,-1004),(-3002,0,-1035,-1056),(-3001,0,-1035,-1004),(-3000,0,-1034,-1056),(-2999,0,-1034,-1004),(-2998,0,-1033,-1056),(-2997,0,-1033,-1004),(-2996,0,-1032,-1056),(-2995,0,-1032,-1004),(-2994,0,-1031,-1056),(-2993,0,-1031,-1004),(-2992,0,-1030,-1056),(-2991,0,-1030,-1004),(-2990,0,-1029,-1056),(-2989,0,-1029,-1004),(-2988,0,-1028,-1056),(-2987,0,-1028,-1004),(-2986,0,-1027,-1056),(-2985,0,-1027,-1004),(-2984,0,-1026,-1056),(-2983,0,-1026,-1004),(-2982,0,-1025,-1056),(-2981,0,-1025,-1004),(-2980,0,-1024,-1056),(-2979,0,-1024,-1004),(-2978,0,-1023,-1056),(-2977,0,-1023,-1004),(-2976,0,-1022,-1056),(-2975,0,-1022,-1004),(-2974,0,-1021,-1056),(-2973,0,-1021,-1004),(-2972,0,-1020,-1056),(-2971,0,-1020,-1004),(-2970,0,-1019,-1056),(-2969,0,-1019,-1004),(-2968,0,-1018,-1056),(-2967,0,-1018,-1004),(-2966,0,-1017,-1056),(-2965,0,-1017,-1004),(-2964,0,-1016,-1056),(-2963,0,-1016,-1004),(-2962,0,-1015,-1043),(-2961,0,-1015,-1004),(-2960,0,-1014,-1027),(-2959,0,-1014,-1004),(-2958,0,-1013,-1027),(-2957,0,-1013,-1004),(-2956,0,-1012,-1005),(-2955,0,-1012,-1004),(-2954,0,-1011,-1005),(-2953,0,-1011,-1004),(-2952,0,-1010,-1005),(-2951,0,-1010,-1004),(-2950,0,-1009,-1005),(-2949,0,-1009,-1004),(-2948,0,-1008,-1009),(-2947,0,-1008,-1002),(-2946,0,-1007,-1005),(-2945,0,-1007,-1004),(-2944,0,-1006,-1005),(-2943,0,-1006,-1004),(-2942,0,-1005,-1005),(-2941,0,-1005,-1004),(-2940,0,-1004,-1013),(-2939,0,-1004,-1004),(-2938,0,-1003,-1005),(-2937,0,-1003,-1004),(-2936,0,-1002,-1021),(-2935,0,-1002,-1002),(-2934,0,-1001,-1005),(-2933,0,-1001,-1004),(-2932,0,-1000,-1032),(-2931,0,-1000,-1002),(-2930,0,-999,-1005),(-2929,0,-999,-1004),(-2928,0,-998,-1005),(-2927,0,-998,-1004),(-2926,0,-997,-1005),(-2925,0,-997,-1004),(-2924,0,-996,-1005),(-2923,0,-996,-1004),(-2922,0,-995,-1005),(-2921,0,-995,-1004),(-2920,0,-994,-1005),(-2919,0,-994,-1004),(-2918,0,-993,-1005),(-2917,0,-993,-1004),(-2916,0,-992,-1005),(-2915,0,-992,-1004),(-2914,0,-991,-1005),(-2913,0,-991,-1004),(-2912,0,-990,-1005),(-2911,0,-990,-1004),(-2910,0,-989,-1005),(-2909,0,-989,-1004),(-2908,0,-988,-1058),(-2907,0,-988,-1004),(-2906,0,-987,-1056),(-2905,0,-987,-1004),(-2904,0,-986,-1005),(-2903,0,-986,-1004),(-2902,0,-985,-1005),(-2901,0,-985,-1004),(-2900,0,-984,-1005),(-2899,0,-984,-1004),(-2898,0,-983,-1056),(-2897,0,-983,-1004),(-2896,0,-982,-1045),(-2895,0,-982,-1004),(-2894,0,-981,-1045),(-2893,0,-981,-1004),(-2892,0,-980,-1045),(-2891,0,-980,-1004),(-2890,0,-979,-1045),(-2889,0,-979,-1004),(-2888,0,-978,-1045),(-2887,0,-978,-1004),(-2886,0,-977,-1045),(-2885,0,-977,-1004),(-2884,0,-976,-1045),(-2883,0,-976,-1004),(-2882,0,-975,-1045),(-2881,0,-975,-1004),(-2880,0,-974,-1045),(-2879,0,-974,-1004),(-2878,0,-973,-1045),(-2877,0,-973,-1004),(-2876,0,-972,-1045),(-2875,0,-972,-1004),(-2874,0,-971,-1045),(-2873,0,-971,-1004),(-2872,0,-970,-1045),(-2871,0,-970,-1004),(-2870,0,-969,-1045),(-2869,0,-969,-1004),(-2868,0,-968,-1045),(-2867,0,-968,-1004),(-2866,0,-967,-1045),(-2865,0,-967,-1004),(-2864,0,-966,-1043),(-2863,0,-966,-1004),(-2862,0,-965,-1043),(-2861,0,-965,-1004),(-2860,0,-964,-1043),(-2859,0,-964,-1004),(-2858,0,-963,-1043),(-2857,0,-963,-1004),(-2856,0,-962,-1043),(-2855,0,-962,-1004),(-2854,0,-961,-1043),(-2853,0,-961,-1004),(-2852,0,-960,-1043),(-2851,0,-960,-1004),(-2850,0,-959,-1043),(-2849,0,-959,-1004),(-2848,0,-958,-1043),(-2847,0,-958,-1004),(-2846,0,-957,-1043),(-2845,0,-957,-1004),(-2844,0,-956,-1043),(-2843,0,-956,-1004),(-2842,0,-955,-1043),(-2841,0,-955,-1004),(-2840,0,-954,-1043),(-2839,0,-954,-1004),(-2838,0,-953,-1043),(-2837,0,-953,-1004),(-2836,0,-952,-1043),(-2835,0,-952,-1004),(-2834,0,-951,-1043),(-2833,0,-951,-1004),(-2832,0,-950,-1043),(-2831,0,-950,-1004),(-2830,0,-949,-1035),(-2829,0,-949,-1004),(-2828,0,-948,-1035),(-2827,0,-948,-1004),(-2826,0,-947,-1035),(-2825,0,-947,-1004),(-2824,0,-946,-1035),(-2823,0,-946,-1004),(-2822,0,-945,-1035),(-2821,0,-945,-1004),(-2820,0,-944,-1035),(-2819,0,-944,-1004),(-2818,0,-943,-1035),(-2817,0,-943,-1004),(-2816,0,-942,-1035),(-2815,0,-942,-1004),(-2814,0,-941,-1035),(-2813,0,-941,-1004),(-2812,0,-940,-1059),(-2811,0,-940,-1004),(-2810,0,-939,-1059),(-2809,0,-939,-1004),(-2808,0,-938,-1059),(-2807,0,-938,-1004),(-2806,0,-937,-1059),(-2805,0,-937,-1004),(-2804,0,-936,-1059),(-2803,0,-936,-1004),(-2802,0,-935,-1059),(-2801,0,-935,-1004),(-2800,0,-934,-1059),(-2799,0,-934,-1004),(-2798,0,-933,-1059),(-2797,0,-933,-1004),(-2796,0,-932,-1059),(-2795,0,-932,-1004),(-2794,0,-931,-1059),(-2793,0,-931,-1004),(-2792,0,-930,-1059),(-2791,0,-930,-1004),(-2790,0,-929,-1059),(-2789,0,-929,-1004),(-2788,0,-928,-1059),(-2787,0,-928,-1004),(-2786,0,-927,-1059),(-2785,0,-927,-1004),(-2784,0,-926,-1059),(-2783,0,-926,-1004),(-2782,0,-925,-1059),(-2781,0,-925,-1004),(-2780,0,-924,-1059),(-2779,0,-924,-1004),(-2778,0,-923,-1059),(-2777,0,-923,-1004),(-2776,0,-922,-1059),(-2775,0,-922,-1004),(-2774,0,-921,-1059),(-2773,0,-921,-1004),(-2772,0,-920,-1044),(-2771,0,-920,-1004),(-2770,0,-919,-1044),(-2769,0,-919,-1004),(-2768,0,-918,-1029),(-2767,0,-918,-1002),(-2766,0,-916,-1044),(-2765,0,-916,-1004),(-2764,0,-915,-1044),(-2763,0,-915,-1004),(-2762,0,-914,-1044),(-2761,0,-914,-1004),(-2760,0,-913,-1044),(-2759,0,-913,-1004),(-2758,0,-912,-1044),(-2757,0,-912,-1004),(-2756,0,-911,-1044),(-2755,0,-911,-1004),(-2754,0,-910,-1044),(-2753,0,-910,-1004),(-2752,0,-908,-1044),(-2751,0,-908,-1004),(-2750,0,-907,-1044),(-2749,0,-907,-1004),(-2748,0,-906,-1044),(-2747,0,-906,-1004),(-2746,0,-905,-1044),(-2745,0,-905,-1004),(-2744,0,-904,-1044),(-2743,0,-904,-1004),(-2742,0,-903,-1025),(-2741,0,-903,-1004),(-2740,0,-902,-1025),(-2739,0,-902,-1004),(-2738,0,-901,-1025),(-2737,0,-901,-1004),(-2736,0,-900,-1025),(-2735,0,-900,-1004),(-2734,0,-899,-1025),(-2733,0,-899,-1004),(-2732,0,-898,-1025),(-2731,0,-898,-1004),(-2730,0,-897,-1025),(-2729,0,-897,-1004),(-2728,0,-896,-1025),(-2727,0,-896,-1004),(-2726,0,-895,-1025),(-2725,0,-895,-1004),(-2724,0,-894,-1025),(-2723,0,-894,-1004),(-2722,0,-893,-1025),(-2721,0,-893,-1004),(-2720,0,-892,-1025),(-2719,0,-892,-1004),(-2718,0,-891,-1025),(-2717,0,-891,-1004),(-2716,0,-890,-1025),(-2715,0,-890,-1004),(-2714,0,-889,-1025),(-2713,0,-889,-1004),(-2712,0,-888,-1025),(-2711,0,-888,-1004),(-2710,0,-887,-1025),(-2709,0,-887,-1004),(-2708,0,-886,-1025),(-2707,0,-886,-1004),(-2706,0,-885,-1025),(-2705,0,-885,-1004),(-2704,0,-884,-1025),(-2703,0,-884,-1004),(-2702,0,-883,-1025),(-2701,0,-883,-1004),(-2700,0,-882,-1025),(-2699,0,-882,-1004),(-2698,0,-881,-1025),(-2697,0,-881,-1004),(-2696,0,-880,-1025),(-2695,0,-880,-1004),(-2694,0,-879,-1025),(-2693,0,-879,-1004),(-2692,0,-878,-1025),(-2691,0,-878,-1004),(-2690,0,-877,-1025),(-2689,0,-877,-1004),(-2688,0,-876,-1023),(-2687,0,-876,-1004),(-2686,0,-875,-1023),(-2685,0,-875,-1004),(-2684,0,-874,-1023),(-2683,0,-874,-1004),(-2682,0,-873,-1023),(-2681,0,-873,-1004),(-2680,0,-872,-1023),(-2679,0,-872,-1004),(-2678,0,-871,-1023),(-2677,0,-871,-1004),(-2676,0,-870,-1023),(-2675,0,-870,-1004),(-2674,0,-869,-1023),(-2673,0,-869,-1004),(-2672,0,-868,-1023),(-2671,0,-868,-1004),(-2670,0,-867,-1023),(-2669,0,-867,-1004),(-2668,0,-866,-1023),(-2667,0,-866,-1004),(-2666,0,-865,-1023),(-2665,0,-865,-1004),(-2664,0,-864,-1023),(-2663,0,-864,-1004),(-2662,0,-863,-1023),(-2661,0,-863,-1004),(-2660,0,-862,-1023),(-2659,0,-862,-1004),(-2658,0,-861,-1023),(-2657,0,-861,-1004),(-2656,0,-860,-1023),(-2655,0,-860,-1004),(-2654,0,-859,-1023),(-2653,0,-859,-1004),(-2652,0,-858,-1023),(-2651,0,-858,-1004),(-2650,0,-857,-1023),(-2649,0,-857,-1004),(-2648,0,-856,-1023),(-2647,0,-856,-1004),(-2646,0,-855,-1023),(-2645,0,-855,-1004),(-2644,0,-854,-1023),(-2643,0,-854,-1004),(-2642,0,-853,-1023),(-2641,0,-853,-1004),(-2640,0,-852,-1023),(-2639,0,-852,-1004),(-2638,0,-851,-1023),(-2637,0,-851,-1004),(-2636,0,-850,-1023),(-2635,0,-850,-1004),(-2634,0,-849,-1023),(-2633,0,-849,-1004),(-2632,0,-848,-1023),(-2631,0,-848,-1004),(-2630,0,-847,-1023),(-2629,0,-847,-1004),(-2628,0,-846,-1023),(-2627,0,-846,-1004),(-2626,0,-845,-1023),(-2625,0,-845,-1004),(-2624,0,-844,-1034),(-2623,0,-844,-1004),(-2622,0,-843,-1038),(-2621,0,-843,-1004),(-2620,0,-842,-1011),(-2619,0,-842,-1002),(-2618,0,-841,-1045),(-2617,0,-841,-1004),(-2616,0,-840,-1027),(-2615,0,-840,-1004),(-2614,0,-839,-1037),(-2613,0,-839,-1004),(-2612,0,-838,-1005),(-2611,0,-838,-1004),(-2610,0,-837,-1018),(-2609,0,-837,-1002),(-2608,0,-836,-1032),(-2607,0,-836,-1002),(-2606,0,-835,-1045),(-2605,0,-835,-1004),(-2604,0,-834,-1045),(-2603,0,-834,-1004),(-2602,0,-833,-1045),(-2601,0,-833,-1004),(-2600,0,-832,-1045),(-2599,0,-832,-1004),(-2598,0,-831,-1006),(-2597,0,-831,-1004),(-2596,0,-830,-1036),(-2595,0,-830,-1004),(-2594,0,-829,-1023),(-2593,0,-829,-1004),(-2592,0,-828,-1026),(-2591,0,-828,-1004),(-2590,0,-827,-1039),(-2589,0,-827,-1004),(-2588,0,-826,-1020),(-2587,0,-826,-1004),(-2586,0,-825,-1056),(-2585,0,-825,-1004),(-2584,0,-824,-1020),(-2583,0,-824,-1004),(-2582,0,-823,-1001),(-2581,0,-823,-1000),(-2580,0,-822,-1037),(-2579,0,-822,-1004),(-2578,0,-821,-1031),(-2577,0,-821,-1004),(-2576,0,-820,-1005),(-2575,0,-820,-1004),(-2574,0,-819,-1003),(-2573,0,-819,-1002),(-2572,0,-818,-1034),(-2571,0,-818,-1004),(-2570,0,-817,-1015),(-2569,0,-817,-1004),(-2568,0,-816,-1059),(-2567,0,-816,-1004),(-2566,0,-815,-1024),(-2565,0,-815,-1004),(-2564,0,-814,-1020),(-2563,0,-814,-1004),(-2562,0,-813,-1029),(-2561,0,-813,-1002),(-2560,0,-812,-1028),(-2559,0,-812,-1004),(-2558,0,-811,-1005),(-2557,0,-811,-1004),(-2556,0,-810,-1001),(-2555,0,-810,-1000),(-2554,0,-809,-1022),(-2553,0,-809,-1002),(-2552,0,-808,-1035),(-2551,0,-808,-1004),(-2550,0,-807,-1024),(-2549,0,-807,-1004),(-2548,0,-806,-1046),(-2547,0,-806,-1004),(-2546,0,-805,-1001),(-2545,0,-805,-1000),(-2544,0,-804,-1038),(-2543,0,-804,-1004),(-2542,0,-803,-1058),(-2541,0,-803,-1004),(-2540,0,-802,-1058),(-2539,0,-802,-1004),(-2538,0,-801,-1005),(-2537,0,-801,-1004),(-2536,0,-800,-1034),(-2535,0,-800,-1004),(-2534,0,-799,-1001),(-2533,0,-799,-1000),(-2532,0,-798,-1058),(-2531,0,-798,-1004),(-2530,0,-797,-1058),(-2529,0,-797,-1004),(-2528,0,-796,-1058),(-2527,0,-796,-1004),(-2526,0,-795,-1052),(-2525,0,-795,-1004),(-2524,0,-794,-1011),(-2523,0,-794,-1002),(-2522,0,-793,-1035),(-2521,0,-793,-1004),(-2520,0,-792,-1022),(-2519,0,-792,-1002),(-2518,0,-791,-1009),(-2517,0,-791,-1002),(-2516,0,-790,-1026),(-2515,0,-790,-1004),(-2514,0,-789,-1040),(-2513,0,-789,-1004),(-2512,0,-788,-1055),(-2511,0,-788,-1002),(-2510,0,-787,-1046),(-2509,0,-787,-1004),(-2508,0,-786,-1045),(-2507,0,-786,-1004),(-2506,0,-785,-1030),(-2505,0,-785,-1002),(-2504,0,-784,-1032),(-2503,0,-784,-1002),(-2502,0,-783,-1015),(-2501,0,-783,-1004),(-2500,0,-782,-1015),(-2499,0,-782,-1004),(-2498,0,-781,-1015),(-2497,0,-781,-1004),(-2496,0,-780,-1052),(-2495,0,-780,-1004),(-2494,0,-779,-1043),(-2493,0,-779,-1004),(-2492,0,-778,-1009),(-2491,0,-778,-1002),(-2490,0,-777,-1061),(-2489,0,-777,-1002),(-2488,0,-776,-1016),(-2487,0,-776,-1004),(-2486,0,-775,-1027),(-2485,0,-775,-1004),(-2484,0,-774,-1058),(-2483,0,-774,-1004),(-2482,0,-773,-1022),(-2481,0,-773,-1002),(-2480,0,-772,-1046),(-2479,0,-772,-1004),(-2478,0,-771,-1034),(-2477,0,-771,-1004),(-2476,0,-770,-1005),(-2475,0,-770,-1004),(-2474,0,-769,-1005),(-2473,0,-769,-1004),(-2472,0,-768,-1005),(-2471,0,-768,-1004),(-2470,0,-767,-1005),(-2469,0,-767,-1004),(-2468,0,-766,-1050),(-2467,0,-766,-1004),(-2466,0,-765,-1052),(-2465,0,-765,-1004),(-2464,0,-764,-1051),(-2463,0,-764,-1004),(-2462,0,-763,-1005),(-2461,0,-763,-1004),(-2460,0,-762,-1025),(-2459,0,-762,-1004),(-2458,0,-761,-1051),(-2457,0,-761,-1004),(-2456,0,-760,-1051),(-2455,0,-760,-1004),(-2454,0,-759,-1051),(-2453,0,-759,-1004),(-2452,0,-758,-1005),(-2451,0,-758,-1004),(-2450,0,-757,-1005),(-2449,0,-757,-1004),(-2448,0,-756,-1005),(-2447,0,-756,-1004),(-2446,0,-755,-1005),(-2445,0,-755,-1004),(-2444,0,-754,-1005),(-2443,0,-754,-1004),(-2442,0,-753,-1048),(-2441,0,-753,-1004),(-2440,0,-752,-1026),(-2439,0,-752,-1004),(-2438,0,-751,-1022),(-2437,0,-751,-1002),(-2436,0,-750,-1039),(-2435,0,-750,-1004),(-2434,0,-749,-1032),(-2433,0,-749,-1002),(-2432,0,-748,-1037),(-2431,0,-748,-1004),(-2430,0,-747,-1005),(-2429,0,-747,-1004),(-2428,0,-746,-1007),(-2427,0,-746,-1004),(-2426,0,-745,-1058),(-2425,0,-745,-1004),(-2424,0,-744,-1026),(-2423,0,-744,-1004),(-2422,0,-743,-1040),(-2421,0,-743,-1004),(-2420,0,-742,-1007),(-2419,0,-742,-1004),(-2418,0,-741,-1005),(-2417,0,-741,-1004),(-2416,0,-740,-1026),(-2415,0,-740,-1004),(-2414,0,-739,-1001),(-2413,0,-739,-1000),(-2412,0,-738,-1045),(-2411,0,-738,-1004),(-2410,0,-737,-1032),(-2409,0,-737,-1002),(-2408,0,-736,-1022),(-2407,0,-736,-1002),(-2406,0,-735,-1010),(-2405,0,-735,-1004),(-2404,0,-734,-1043),(-2403,0,-734,-1004),(-2402,0,-733,-1015),(-2401,0,-733,-1004),(-2400,0,-732,-1010),(-2399,0,-732,-1004),(-2398,0,-731,-1009),(-2397,0,-731,-1002),(-2396,0,-730,-1038),(-2395,0,-730,-1004),(-2394,0,-729,-1036),(-2393,0,-729,-1004),(-2392,0,-728,-1050),(-2391,0,-728,-1004),(-2390,0,-727,-1037),(-2389,0,-727,-1004),(-2388,0,-726,-1059),(-2387,0,-726,-1004),(-2386,0,-725,-1055),(-2385,0,-725,-1002),(-2384,0,-724,-1015),(-2383,0,-724,-1004),(-2382,0,-723,-1056),(-2381,0,-723,-1004),(-2380,0,-722,-1039),(-2379,0,-722,-1004),(-2378,0,-721,-1058),(-2377,0,-721,-1004),(-2376,0,-720,-1058),(-2375,0,-720,-1004),(-2374,0,-719,-1058),(-2373,0,-719,-1004),(-2372,0,-718,-1008),(-2371,0,-718,-1004),(-2370,0,-717,-1001),(-2369,0,-717,-1000),(-2368,0,-716,-1021),(-2367,0,-716,-1002),(-2366,0,-715,-1056),(-2365,0,-715,-1004),(-2364,0,-714,-1022),(-2363,0,-714,-1002),(-2362,0,-713,-1043),(-2361,0,-713,-1004),(-2360,0,-712,-1032),(-2359,0,-712,-1002),(-2358,0,-711,-1045),(-2357,0,-711,-1004),(-2356,0,-710,-1001),(-2355,0,-710,-1000),(-2354,0,-709,-1001),(-2353,0,-709,-1000),(-2352,0,-708,-1032),(-2351,0,-708,-1002),(-2350,0,-707,-1006),(-2349,0,-707,-1004),(-2348,0,-706,-1006),(-2347,0,-706,-1004),(-2346,0,-705,-1006),(-2345,0,-705,-1004),(-2344,0,-704,-1006),(-2343,0,-704,-1004),(-2342,0,-703,-1006),(-2341,0,-703,-1004),(-2340,0,-702,-1009),(-2339,0,-702,-1002),(-2338,0,-701,-1006),(-2337,0,-701,-1004),(-2336,0,-700,-1006),(-2335,0,-700,-1004),(-2334,0,-699,-1006),(-2333,0,-699,-1004),(-2332,0,-698,-1006),(-2331,0,-698,-1004),(-2330,0,-697,-1006),(-2329,0,-697,-1004),(-2328,0,-696,-1006),(-2327,0,-696,-1004),(-2326,0,-695,-1006),(-2325,0,-695,-1004),(-2324,0,-694,-1006),(-2323,0,-694,-1004),(-2322,0,-693,-1006),(-2321,0,-693,-1004),(-2320,0,-692,-1006),(-2319,0,-692,-1004),(-2318,0,-691,-1006),(-2317,0,-691,-1004),(-2316,0,-690,-1006),(-2315,0,-690,-1004),(-2314,0,-689,-1006),(-2313,0,-689,-1004),(-2312,0,-688,-1062),(-2311,0,-688,-1002),(-2310,0,-687,-1006),(-2309,0,-687,-1004),(-2308,0,-686,-1006),(-2307,0,-686,-1004),(-2306,0,-685,-1006),(-2305,0,-685,-1004),(-2304,0,-684,-1006),(-2303,0,-684,-1004),(-2302,0,-683,-1006),(-2301,0,-683,-1004),(-2300,0,-682,-1006),(-2299,0,-682,-1004),(-2298,0,-681,-1006),(-2297,0,-681,-1004),(-2296,0,-680,-1006),(-2295,0,-680,-1004),(-2294,0,-679,-1030),(-2293,0,-679,-1002),(-2292,0,-678,-1006),(-2291,0,-678,-1004),(-2290,0,-677,-1006),(-2289,0,-677,-1004),(-2288,0,-676,-1006),(-2287,0,-676,-1004),(-2286,0,-675,-1006),(-2285,0,-675,-1004),(-2284,0,-674,-1006),(-2283,0,-674,-1004),(-2282,0,-673,-1006),(-2281,0,-673,-1004),(-2280,0,-672,-1006),(-2279,0,-672,-1004),(-2278,0,-671,-1006),(-2277,0,-671,-1004),(-2276,0,-670,-1006),(-2275,0,-670,-1004),(-2274,0,-669,-1048),(-2273,0,-669,-1004),(-2272,0,-668,-1007),(-2271,0,-668,-1004),(-2270,0,-667,-1034),(-2269,0,-667,-1004),(-2268,0,-666,-1005),(-2267,0,-666,-1004),(-2266,0,-665,-1021),(-2265,0,-665,-1002),(-2264,0,-664,-1011),(-2263,0,-664,-1002),(-2262,0,-663,-1011),(-2261,0,-663,-1002),(-2260,0,-662,-1024),(-2259,0,-662,-1004),(-2258,0,-661,-1050),(-2257,0,-661,-1004),(-2256,0,-660,-1052),(-2255,0,-660,-1004),(-2254,0,-659,-1047),(-2253,0,-659,-1004),(-2252,0,-658,-1006),(-2251,0,-658,-1004),(-2250,0,-657,-1006),(-2249,0,-657,-1004),(-2248,0,-656,-1006),(-2247,0,-656,-1004),(-2246,0,-655,-1006),(-2245,0,-655,-1004),(-2244,0,-654,-1006),(-2243,0,-654,-1004),(-2242,0,-653,-1006),(-2241,0,-653,-1004),(-2240,0,-652,-1006),(-2239,0,-652,-1004),(-2238,0,-651,-1006),(-2237,0,-651,-1004),(-2236,0,-650,-1047),(-2235,0,-650,-1004),(-2234,0,-649,-1032),(-2233,0,-649,-1002),(-2232,0,-648,-1005),(-2231,0,-648,-1004),(-2230,0,-647,-1005),(-2229,0,-647,-1004),(-2228,0,-646,-1056),(-2227,0,-646,-1004),(-2226,0,-645,-1003),(-2225,0,-645,-1002),(-2224,0,-644,-1011),(-2223,0,-644,-1002),(-2222,0,-643,-1058),(-2221,0,-643,-1004),(-2220,0,-642,-1054),(-2219,0,-642,-1004),(-2218,0,-641,-1012),(-2217,0,-641,-1004),(-2216,0,-640,-1012),(-2215,0,-640,-1004),(-2214,0,-638,-1012),(-2213,0,-638,-1004),(-2212,0,-637,-1012),(-2211,0,-637,-1004),(-2210,0,-636,-1032),(-2209,0,-636,-1002),(-2208,0,-635,-1034),(-2207,0,-635,-1004),(-2206,0,-634,-1024),(-2205,0,-634,-1004),(-2204,0,-633,-1024),(-2203,0,-633,-1004),(-2202,0,-632,-1024),(-2201,0,-632,-1004),(-2200,0,-631,-1024),(-2199,0,-631,-1004),(-2198,0,-630,-1018),(-2197,0,-630,-1002),(-2196,0,-629,-1054),(-2195,0,-629,-1004),(-2194,0,-628,-1054),(-2193,0,-628,-1004),(-2192,0,-627,-1032),(-2191,0,-627,-1002),(-2190,0,-626,-1007),(-2189,0,-626,-1004),(-2188,0,-625,-1007),(-2187,0,-625,-1004),(-2186,0,-624,-1007),(-2185,0,-624,-1004),(-2184,0,-623,-1007),(-2183,0,-623,-1004),(-2182,0,-622,-1010),(-2181,0,-622,-1004),(-2180,0,-621,-1010),(-2179,0,-621,-1004),(-2178,0,-620,-1011),(-2177,0,-620,-1002),(-2176,0,-619,-1022),(-2175,0,-619,-1002),(-2174,0,-618,-1026),(-2173,0,-618,-1004),(-2172,0,-617,-1024),(-2171,0,-617,-1004),(-2170,0,-616,-1015),(-2169,0,-616,-1004),(-2168,0,-615,-1039),(-2167,0,-615,-1004),(-2166,0,-614,-1040),(-2165,0,-614,-1004),(-2164,0,-613,-1024),(-2163,0,-613,-1004),(-2162,0,-612,-1017),(-2161,0,-612,-1004),(-2160,0,-611,-1032),(-2159,0,-611,-1002),(-2158,0,-610,-1049),(-2157,0,-610,-1004),(-2156,0,-609,-1050),(-2155,0,-609,-1004),(-2154,0,-608,-1037),(-2153,0,-608,-1004),(-2152,0,-607,-1040),(-2151,0,-607,-1004),(-2150,0,-606,-1040),(-2149,0,-606,-1004),(-2148,0,-605,-1054),(-2147,0,-605,-1004),(-2146,0,-604,-1054),(-2145,0,-604,-1004),(-2144,0,-603,-1054),(-2143,0,-603,-1004),(-2142,0,-602,-1054),(-2141,0,-602,-1004),(-2140,0,-601,-1054),(-2139,0,-601,-1004),(-2138,0,-600,-1054),(-2137,0,-600,-1004),(-2136,0,-599,-1054),(-2135,0,-599,-1004),(-2134,0,-598,-1054),(-2133,0,-598,-1004),(-2132,0,-597,-1054),(-2131,0,-597,-1004),(-2130,0,-596,-1049),(-2129,0,-596,-1004),(-2128,0,-595,-1049),(-2127,0,-595,-1004),(-2126,0,-594,-1029),(-2125,0,-594,-1002),(-2124,0,-593,-1049),(-2123,0,-593,-1004),(-2122,0,-592,-1049),(-2121,0,-592,-1004),(-2120,0,-591,-1049),(-2119,0,-591,-1004),(-2118,0,-590,-1049),(-2117,0,-590,-1004),(-2116,0,-589,-1006),(-2115,0,-589,-1004),(-2114,0,-588,-1054),(-2113,0,-588,-1004),(-2112,0,-587,-1060),(-2111,0,-587,-1002),(-2110,0,-586,-1054),(-2109,0,-586,-1004),(-2108,0,-584,-1054),(-2107,0,-584,-1004),(-2106,0,-583,-1042),(-2105,0,-583,-1004),(-2104,0,-582,-1026),(-2103,0,-582,-1004),(-2102,0,-581,-1032),(-2101,0,-581,-1002),(-2100,0,-580,-1050),(-2099,0,-580,-1004),(-2098,0,-579,-1050),(-2097,0,-579,-1004),(-2096,0,-578,-1050),(-2095,0,-578,-1004),(-2094,0,-577,-1050),(-2093,0,-577,-1004),(-2092,0,-576,-1049),(-2091,0,-576,-1004),(-2090,0,-575,-1050),(-2089,0,-575,-1004),(-2088,0,-574,-1050),(-2087,0,-574,-1004),(-2086,0,-573,-1049),(-2085,0,-573,-1004),(-2084,0,-572,-1049),(-2083,0,-572,-1004),(-2082,0,-571,-1050),(-2081,0,-571,-1004),(-2080,0,-570,-1049),(-2079,0,-570,-1004),(-2078,0,-569,-1049),(-2077,0,-569,-1004),(-2076,0,-568,-1049),(-2075,0,-568,-1004),(-2074,0,-567,-1049),(-2073,0,-567,-1004),(-2072,0,-566,-1049),(-2071,0,-566,-1004),(-2070,0,-565,-1049),(-2069,0,-565,-1004),(-2068,0,-564,-1049),(-2067,0,-564,-1004),(-2066,0,-563,-1049),(-2065,0,-563,-1004),(-2064,0,-562,-1049),(-2063,0,-562,-1004),(-2062,0,-561,-1049),(-2061,0,-561,-1004),(-2060,0,-560,-1049),(-2059,0,-560,-1004),(-2058,0,-559,-1049),(-2057,0,-559,-1004),(-2056,0,-558,-1032),(-2055,0,-558,-1002),(-2054,0,-557,-1059),(-2053,0,-557,-1004),(-2052,0,-556,-1028),(-2051,0,-556,-1004),(-2050,0,-555,-1028),(-2049,0,-555,-1004),(-2048,0,-554,-1028),(-2047,0,-554,-1004),(-2046,0,-553,-1028),(-2045,0,-553,-1004),(-2044,0,-552,-1007),(-2043,0,-552,-1004),(-2042,0,-551,-1015),(-2041,0,-551,-1004),(-2040,0,-550,-1013),(-2039,0,-550,-1004),(-2038,0,-548,-1013),(-2037,0,-548,-1004),(-2036,0,-547,-1049),(-2035,0,-547,-1004),(-2034,0,-546,-1049),(-2033,0,-546,-1004),(-2032,0,-545,-1049),(-2031,0,-545,-1004),(-2030,0,-544,-1049),(-2029,0,-544,-1004),(-2028,0,-543,-1049),(-2027,0,-543,-1004),(-2026,0,-542,-1049),(-2025,0,-542,-1004),(-2024,0,-541,-1049),(-2023,0,-541,-1004),(-2022,0,-540,-1049),(-2021,0,-540,-1004),(-2020,0,-539,-1049),(-2019,0,-539,-1004),(-2018,0,-538,-1033),(-2017,0,-538,-1004),(-2016,0,-537,-1010),(-2015,0,-537,-1004),(-2014,0,-536,-1050),(-2013,0,-536,-1004),(-2012,0,-534,-1008),(-2011,0,-534,-1004),(-2010,0,-533,-1008),(-2009,0,-533,-1004),(-2008,0,-532,-1008),(-2007,0,-532,-1004),(-2006,0,-531,-1008),(-2005,0,-531,-1004),(-2004,0,-530,-1008),(-2003,0,-530,-1004),(-2002,0,-529,-1008),(-2001,0,-529,-1004),(-2000,0,-528,-1001),(-1999,0,-528,-1000),(-1998,0,-527,-1008),(-1997,0,-527,-1004),(-1996,0,-526,-1008),(-1995,0,-526,-1004),(-1994,0,-525,-1008),(-1993,0,-525,-1004),(-1992,0,-524,-1008),(-1991,0,-524,-1004),(-1990,0,-523,-1008),(-1989,0,-523,-1004),(-1988,0,-522,-1008),(-1987,0,-522,-1004),(-1986,0,-521,-1008),(-1985,0,-521,-1004),(-1984,0,-520,-1008),(-1983,0,-520,-1004),(-1982,0,-519,-1008),(-1981,0,-519,-1004),(-1980,0,-517,-1008),(-1979,0,-517,-1004),(-1978,0,-516,-1008),(-1977,0,-516,-1004),(-1976,0,-515,-1008),(-1975,0,-515,-1004),(-1974,0,-514,-1008),(-1973,0,-514,-1004),(-1972,0,-513,-1008),(-1971,0,-513,-1004),(-1970,0,-512,-1008),(-1969,0,-512,-1004),(-1968,0,-511,-1008),(-1967,0,-511,-1004),(-1966,0,-510,-1008),(-1965,0,-510,-1004),(-1964,0,-509,-1008),(-1963,0,-509,-1004),(-1962,0,-508,-1019),(-1961,0,-508,-1004),(-1960,0,-506,-1051),(-1959,0,-506,-1004),(-1958,0,-505,-1051),(-1957,0,-505,-1004),(-1956,0,-504,-1051),(-1955,0,-504,-1004),(-1954,0,-503,-1051),(-1953,0,-503,-1004),(-1952,0,-502,-1051),(-1951,0,-502,-1004),(-1950,0,-501,-1051),(-1949,0,-501,-1004),(-1948,0,-500,-1051),(-1947,0,-500,-1004),(-1946,0,-499,-1051),(-1945,0,-499,-1004),(-1944,0,-498,-1051),(-1943,0,-498,-1004),(-1942,0,-497,-1051),(-1941,0,-497,-1004),(-1940,0,-496,-1051),(-1939,0,-496,-1004),(-1938,0,-495,-1051),(-1937,0,-495,-1004),(-1936,0,-494,-1051),(-1935,0,-494,-1004),(-1934,0,-493,-1051),(-1933,0,-493,-1004),(-1932,0,-492,-1051),(-1931,0,-492,-1004),(-1930,0,-491,-1051),(-1929,0,-491,-1004),(-1928,0,-490,-1051),(-1927,0,-490,-1004),(-1926,0,-489,-1051),(-1925,0,-489,-1004),(-1924,0,-488,-1051),(-1923,0,-488,-1004),(-1922,0,-487,-1051),(-1921,0,-487,-1004),(-1920,0,-486,-1051),(-1919,0,-486,-1004),(-1918,0,-485,-1026),(-1917,0,-485,-1004),(-1916,0,-484,-1044),(-1915,0,-484,-1004),(-1914,0,-483,-1026),(-1913,0,-483,-1004),(-1912,0,-482,-1005),(-1911,0,-482,-1004),(-1910,0,-481,-1036),(-1909,0,-481,-1004),(-1908,0,-480,-1027),(-1907,0,-480,-1004),(-1906,0,-479,-1056),(-1905,0,-479,-1004),(-1904,0,-478,-1019),(-1903,0,-478,-1004),(-1902,0,-477,-1051),(-1901,0,-477,-1004),(-1900,0,-476,-1051),(-1899,0,-476,-1004),(-1898,0,-475,-1051),(-1897,0,-475,-1004),(-1896,0,-474,-1051),(-1895,0,-474,-1004),(-1894,0,-473,-1051),(-1893,0,-473,-1004),(-1892,0,-472,-1051),(-1891,0,-472,-1004),(-1890,0,-471,-1051),(-1889,0,-471,-1004),(-1888,0,-470,-1008),(-1887,0,-470,-1004),(-1886,0,-469,-1031),(-1885,0,-469,-1004),(-1884,0,-468,-1031),(-1883,0,-468,-1004),(-1882,0,-467,-1031),(-1881,0,-467,-1004),(-1880,0,-466,-1031),(-1879,0,-466,-1004),(-1878,0,-465,-1031),(-1877,0,-465,-1004),(-1876,0,-464,-1031),(-1875,0,-464,-1004),(-1874,0,-463,-1031),(-1873,0,-463,-1004),(-1872,0,-462,-1031),(-1871,0,-462,-1004),(-1870,0,-461,-1031),(-1869,0,-461,-1004),(-1868,0,-460,-1031),(-1867,0,-460,-1004),(-1866,0,-459,-1031),(-1865,0,-459,-1004),(-1864,0,-458,-1031),(-1863,0,-458,-1004),(-1862,0,-457,-1031),(-1861,0,-457,-1004),(-1860,0,-455,-1031),(-1859,0,-455,-1004),(-1858,0,-454,-1031),(-1857,0,-454,-1004),(-1856,0,-453,-1031),(-1855,0,-453,-1004),(-1854,0,-451,-1031),(-1853,0,-451,-1004),(-1852,0,-450,-1031),(-1851,0,-450,-1004),(-1850,0,-449,-1039),(-1849,0,-449,-1004),(-1848,0,-448,-1031),(-1847,0,-448,-1004),(-1846,0,-447,-1031),(-1845,0,-447,-1004),(-1844,0,-446,-1031),(-1843,0,-446,-1004),(-1842,0,-445,-1031),(-1841,0,-445,-1004),(-1840,0,-444,-1031),(-1839,0,-444,-1004),(-1838,0,-443,-1031),(-1837,0,-443,-1004),(-1836,0,-442,-1031),(-1835,0,-442,-1004),(-1834,0,-441,-1031),(-1833,0,-441,-1004),(-1832,0,-440,-1031),(-1831,0,-440,-1004),(-1830,0,-439,-1031),(-1829,0,-439,-1004),(-1828,0,-438,-1031),(-1827,0,-438,-1004),(-1826,0,-437,-1031),(-1825,0,-437,-1004),(-1824,0,-436,-1031),(-1823,0,-436,-1004),(-1822,0,-435,-1031),(-1821,0,-435,-1004),(-1820,0,-434,-1031),(-1819,0,-434,-1004),(-1818,0,-433,-1031),(-1817,0,-433,-1004),(-1816,0,-432,-1031),(-1815,0,-432,-1004),(-1814,0,-431,-1031),(-1813,0,-431,-1004),(-1812,0,-430,-1031),(-1811,0,-430,-1004),(-1810,0,-429,-1031),(-1809,0,-429,-1004),(-1808,0,-428,-1031),(-1807,0,-428,-1004),(-1806,0,-427,-1031),(-1805,0,-427,-1004),(-1804,0,-426,-1031),(-1803,0,-426,-1004),(-1802,0,-425,-1031),(-1801,0,-425,-1004),(-1800,0,-424,-1006),(-1799,0,-424,-1004),(-1798,0,-423,-1057),(-1797,0,-423,-1002),(-1796,0,-422,-1055),(-1795,0,-422,-1002),(-1794,0,-420,-1015),(-1793,0,-420,-1004),(-1792,0,-419,-1051),(-1791,0,-419,-1004),(-1790,0,-418,-1049),(-1789,0,-418,-1004),(-1788,0,-417,-1024),(-1787,0,-417,-1004),(-1786,0,-416,-1056),(-1785,0,-416,-1004),(-1784,0,-415,-1001),(-1783,0,-415,-1000),(-1782,0,-414,-1018),(-1781,0,-414,-1002),(-1780,0,-413,-1006),(-1779,0,-413,-1004),(-1778,0,-412,-1025),(-1777,0,-412,-1004),(-1776,0,-411,-1025),(-1775,0,-411,-1004),(-1774,0,-410,-1019),(-1773,0,-410,-1004),(-1772,0,-409,-1019),(-1771,0,-409,-1004),(-1770,0,-408,-1019),(-1769,0,-408,-1004),(-1768,0,-407,-1019),(-1767,0,-407,-1004),(-1766,0,-406,-1005),(-1765,0,-406,-1004),(-1764,0,-405,-1033),(-1763,0,-405,-1004),(-1762,0,-404,-1029),(-1761,0,-404,-1002),(-1760,0,-403,-1001),(-1759,0,-403,-1000),(-1758,0,-402,-1029),(-1757,0,-402,-1002),(-1756,0,-401,-1033),(-1755,0,-401,-1004),(-1754,0,-400,-1041),(-1753,0,-400,-1004),(-1752,0,-399,-1033),(-1751,0,-399,-1004),(-1750,0,-398,-1033),(-1749,0,-398,-1004),(-1748,0,-397,-1033),(-1747,0,-397,-1004),(-1746,0,-396,-1033),(-1745,0,-396,-1004),(-1744,0,-395,-1033),(-1743,0,-395,-1004),(-1742,0,-394,-1033),(-1741,0,-394,-1004),(-1740,0,-393,-1033),(-1739,0,-393,-1004),(-1738,0,-392,-1033),(-1737,0,-392,-1004),(-1736,0,-391,-1033),(-1735,0,-391,-1004),(-1734,0,-390,-1040),(-1733,0,-390,-1004),(-1732,0,-389,-1019),(-1731,0,-389,-1004),(-1730,0,-388,-1019),(-1729,0,-388,-1004),(-1728,0,-387,-1019),(-1727,0,-387,-1004),(-1726,0,-386,-1033),(-1725,0,-386,-1004),(-1724,0,-385,-1033),(-1723,0,-385,-1004),(-1722,0,-384,-1008),(-1721,0,-384,-1004),(-1720,0,-383,-1020),(-1719,0,-383,-1004),(-1718,0,-382,-1030),(-1717,0,-382,-1002),(-1716,0,-381,-1044),(-1715,0,-381,-1004),(-1714,0,-380,-1005),(-1713,0,-380,-1004),(-1712,0,-379,-1043),(-1711,0,-379,-1004),(-1710,0,-378,-1033),(-1709,0,-378,-1004),(-1708,0,-376,-1033),(-1707,0,-376,-1004),(-1706,0,-375,-1033),(-1705,0,-375,-1004),(-1704,0,-374,-1033),(-1703,0,-374,-1004),(-1702,0,-373,-1033),(-1701,0,-373,-1004),(-1700,0,-372,-1033),(-1699,0,-372,-1004),(-1698,0,-371,-1033),(-1697,0,-371,-1004),(-1696,0,-370,-1005),(-1695,0,-370,-1004),(-1694,0,-369,-1033),(-1693,0,-369,-1004),(-1692,0,-368,-1033),(-1691,0,-368,-1004),(-1690,0,-367,-1014),(-1689,0,-367,-1002),(-1688,0,-366,-1001),(-1687,0,-366,-1000),(-1686,0,-365,-1022),(-1685,0,-365,-1002),(-1684,0,-364,-1006),(-1683,0,-364,-1004),(-1682,0,-363,-1055),(-1681,0,-363,-1002),(-1680,0,-362,-1050),(-1679,0,-362,-1004),(-1678,0,-361,-1050),(-1677,0,-361,-1004),(-1676,0,-360,-1001),(-1675,0,-360,-1000),(-1674,0,-359,-1017),(-1673,0,-359,-1004),(-1672,0,-358,-1016),(-1671,0,-358,-1004),(-1670,0,-357,-1016),(-1669,0,-357,-1004),(-1668,0,-356,-1016),(-1667,0,-356,-1004),(-1666,0,-355,-1001),(-1665,0,-355,-1000),(-1664,0,-354,-1001),(-1663,0,-354,-1000),(-1662,0,-353,-1001),(-1661,0,-353,-1000),(-1660,0,-352,-1001),(-1659,0,-352,-1000),(-1658,0,-351,-1001),(-1657,0,-351,-1000),(-1656,0,-350,-1006),(-1655,0,-350,-1004),(-1654,0,-348,-1005),(-1653,0,-348,-1004),(-1652,0,-347,-1051),(-1651,0,-347,-1004),(-1650,0,-346,-1050),(-1649,0,-346,-1004),(-1648,0,-345,-1049),(-1647,0,-345,-1004),(-1646,0,-344,-1017),(-1645,0,-344,-1004),(-1644,0,-343,-1017),(-1643,0,-343,-1004),(-1642,0,-342,-1017),(-1641,0,-342,-1004),(-1640,0,-341,-1017),(-1639,0,-341,-1004),(-1638,0,-340,-1017),(-1637,0,-340,-1004),(-1636,0,-339,-1017),(-1635,0,-339,-1004),(-1634,0,-338,-1017),(-1633,0,-338,-1004),(-1632,0,-337,-1017),(-1631,0,-337,-1004),(-1630,0,-336,-1017),(-1629,0,-336,-1004),(-1628,0,-335,-1017),(-1627,0,-335,-1004),(-1626,0,-334,-1017),(-1625,0,-334,-1004),(-1624,0,-333,-1017),(-1623,0,-333,-1004),(-1622,0,-332,-1011),(-1621,0,-332,-1002),(-1620,0,-331,-1021),(-1619,0,-331,-1002),(-1618,0,-330,-1048),(-1617,0,-330,-1004),(-1616,0,-329,-1047),(-1615,0,-329,-1004),(-1614,0,-328,-1046),(-1613,0,-328,-1004),(-1612,0,-327,-1025),(-1611,0,-327,-1004),(-1610,0,-326,-1025),(-1609,0,-326,-1004),(-1608,0,-325,-1021),(-1607,0,-325,-1002),(-1606,0,-324,-1007),(-1605,0,-324,-1004),(-1604,0,-323,-1045),(-1603,0,-323,-1004),(-1602,0,-322,-1044),(-1601,0,-322,-1004),(-1600,0,-321,-1043),(-1599,0,-321,-1004),(-1598,0,-320,-1042),(-1597,0,-320,-1004),(-1596,0,-319,-1024),(-1595,0,-319,-1004),(-1594,0,-318,-1041),(-1593,0,-318,-1004),(-1592,0,-317,-1006),(-1591,0,-317,-1004),(-1590,0,-316,-1016),(-1589,0,-316,-1004),(-1588,0,-315,-1019),(-1587,0,-315,-1004),(-1586,0,-314,-1025),(-1585,0,-314,-1004),(-1584,0,-313,-1040),(-1583,0,-313,-1004),(-1582,0,-312,-1001),(-1581,0,-312,-1000),(-1580,0,-311,-1005),(-1579,0,-311,-1004),(-1578,0,-310,-1032),(-1577,0,-310,-1002),(-1576,0,-309,-1029),(-1575,0,-309,-1002),(-1574,0,-308,-1001),(-1573,0,-308,-1000),(-1572,0,-307,-1039),(-1571,0,-307,-1004),(-1570,0,-306,-1003),(-1569,0,-306,-1002),(-1568,0,-305,-1038),(-1567,0,-305,-1004),(-1566,0,-304,-1001),(-1565,0,-304,-1000),(-1564,0,-302,-1023),(-1563,0,-302,-1004),(-1562,0,-301,-1037),(-1561,0,-301,-1004),(-1560,0,-300,-1005),(-1559,0,-300,-1004),(-1558,0,-299,-1017),(-1557,0,-299,-1004),(-1556,0,-298,-1031),(-1555,0,-298,-1004),(-1554,0,-297,-1036),(-1553,0,-297,-1004),(-1552,0,-296,-1035),(-1551,0,-296,-1004),(-1550,0,-295,-1035),(-1549,0,-295,-1004),(-1548,0,-294,-1035),(-1547,0,-294,-1004),(-1546,0,-293,-1035),(-1545,0,-293,-1004),(-1544,0,-292,-1035),(-1543,0,-292,-1004),(-1542,0,-291,-1035),(-1541,0,-291,-1004),(-1540,0,-290,-1034),(-1539,0,-290,-1004),(-1538,0,-289,-1033),(-1537,0,-289,-1004),(-1536,0,-288,-1031),(-1535,0,-288,-1004),(-1534,0,-287,-1008),(-1533,0,-287,-1004),(-1532,0,-286,-1032),(-1531,0,-286,-1002),(-1530,0,-285,-1008),(-1529,0,-285,-1004),(-1528,0,-284,-1001),(-1527,0,-284,-1000),(-1526,0,-283,-1021),(-1525,0,-283,-1002),(-1524,0,-282,-1023),(-1523,0,-282,-1004),(-1522,0,-281,-1001),(-1521,0,-281,-1000),(-1520,0,-280,-1030),(-1519,0,-280,-1002),(-1518,0,-279,-1023),(-1517,0,-279,-1004),(-1516,0,-278,-1013),(-1515,0,-278,-1004),(-1514,0,-277,-1005),(-1513,0,-277,-1004),(-1512,0,-276,-1029),(-1511,0,-276,-1002),(-1510,0,-275,-1020),(-1509,0,-275,-1004),(-1508,0,-274,-1005),(-1507,0,-274,-1004),(-1506,0,-273,-1020),(-1505,0,-273,-1004),(-1504,0,-272,-1028),(-1503,0,-272,-1004),(-1502,0,-271,-1027),(-1501,0,-271,-1004),(-1500,0,-270,-1001),(-1499,0,-270,-1000),(-1498,0,-269,-1025),(-1497,0,-269,-1004),(-1496,0,-268,-1005),(-1495,0,-268,-1004),(-1494,0,-267,-1006),(-1493,0,-267,-1004),(-1492,0,-266,-1026),(-1491,0,-266,-1004),(-1490,0,-265,-1026),(-1489,0,-265,-1004),(-1488,0,-264,-1012),(-1487,0,-264,-1004),(-1486,0,-263,-1023),(-1485,0,-263,-1004),(-1484,0,-262,-1025),(-1483,0,-262,-1004),(-1482,0,-261,-1006),(-1481,0,-261,-1004),(-1480,0,-260,-1006),(-1479,0,-260,-1004),(-1478,0,-259,-1006),(-1477,0,-259,-1004),(-1476,0,-258,-1006),(-1475,0,-258,-1004),(-1474,0,-257,-1006),(-1473,0,-257,-1004),(-1472,0,-256,-1006),(-1471,0,-256,-1004),(-1470,0,-255,-1006),(-1469,0,-255,-1004),(-1468,0,-254,-1006),(-1467,0,-254,-1004),(-1466,0,-253,-1006),(-1465,0,-253,-1004),(-1464,0,-252,-1006),(-1463,0,-252,-1004),(-1462,0,-251,-1019),(-1461,0,-251,-1004),(-1460,0,-250,-1018),(-1459,0,-250,-1002),(-1458,0,-249,-1018),(-1457,0,-249,-1002),(-1456,0,-248,-1018),(-1455,0,-248,-1002),(-1454,0,-247,-1018),(-1453,0,-247,-1002),(-1452,0,-246,-1018),(-1451,0,-246,-1002),(-1450,0,-245,-1018),(-1449,0,-245,-1002),(-1448,0,-244,-1018),(-1447,0,-244,-1002),(-1446,0,-243,-1015),(-1445,0,-243,-1004),(-1444,0,-242,-1037),(-1443,0,-242,-1004),(-1442,0,-241,-1010),(-1441,0,-241,-1004),(-1440,0,-240,-1054),(-1439,0,-240,-1004),(-1438,0,-239,-1052),(-1437,0,-239,-1004),(-1436,0,-238,-1005),(-1435,0,-238,-1004),(-1434,0,-237,-1038),(-1433,0,-237,-1004),(-1432,0,-236,-1024),(-1431,0,-236,-1004),(-1430,0,-235,-1024),(-1429,0,-235,-1004),(-1428,0,-234,-1024),(-1427,0,-234,-1004),(-1426,0,-233,-1033),(-1425,0,-233,-1004),(-1424,0,-232,-1001),(-1423,0,-232,-1000),(-1422,0,-231,-1053),(-1421,0,-231,-1002),(-1420,0,-230,-1017),(-1419,0,-230,-1004),(-1418,0,-229,-1036),(-1417,0,-229,-1004),(-1416,0,-228,-1001),(-1415,0,-228,-1000),(-1414,0,-227,-1023),(-1413,0,-227,-1004),(-1412,0,-226,-1009),(-1411,0,-226,-1002),(-1410,0,-225,-1017),(-1409,0,-225,-1004),(-1408,0,-224,-1044),(-1407,0,-224,-1004),(-1406,0,-223,-1023),(-1405,0,-223,-1004),(-1404,0,-222,-1026),(-1403,0,-222,-1004),(-1402,0,-221,-1006),(-1401,0,-221,-1004),(-1400,0,-220,-1023),(-1399,0,-220,-1004),(-1398,0,-219,-1051),(-1397,0,-219,-1004),(-1396,0,-218,-1005),(-1395,0,-218,-1004),(-1394,0,-217,-1033),(-1393,0,-217,-1004),(-1392,0,-216,-1017),(-1391,0,-216,-1004),(-1390,0,-215,-1017),(-1389,0,-215,-1004),(-1388,0,-214,-1017),(-1387,0,-214,-1004),(-1386,0,-213,-1001),(-1385,0,-213,-1000),(-1384,0,-212,-1001),(-1383,0,-212,-1000),(-1382,0,-211,-1035),(-1381,0,-211,-1004),(-1380,0,-210,-1034),(-1379,0,-210,-1004),(-1378,0,-209,-1027),(-1377,0,-209,-1004),(-1376,0,-208,-1052),(-1375,0,-208,-1004),(-1374,0,-207,-1029),(-1373,0,-207,-1002),(-1372,0,-206,-1018),(-1371,0,-206,-1002),(-1370,0,-205,-1018),(-1369,0,-205,-1002),(-1368,0,-204,-1018),(-1367,0,-204,-1002),(-1366,0,-203,-1018),(-1365,0,-203,-1002),(-1364,0,-202,-1018),(-1363,0,-202,-1002),(-1362,0,-201,-1001),(-1361,0,-201,-1000),(-1360,0,-200,-1023),(-1359,0,-200,-1004),(-1358,0,-199,-1001),(-1357,0,-199,-1000),(-1356,0,-198,-1001),(-1355,0,-198,-1000),(-1354,0,-197,-1001),(-1353,0,-197,-1000),(-1352,0,-196,-1001),(-1351,0,-196,-1000),(-1350,0,-195,-1012),(-1349,0,-195,-1004),(-1348,0,-194,-1031),(-1347,0,-194,-1004),(-1346,0,-193,-1024),(-1345,0,-193,-1004),(-1344,0,-192,-1017),(-1343,0,-192,-1004),(-1342,0,-191,-1047),(-1341,0,-191,-1004),(-1340,0,-190,-1008),(-1339,0,-190,-1004),(-1338,0,-189,-1007),(-1337,0,-189,-1004),(-1336,0,-188,-1017),(-1335,0,-188,-1004),(-1334,0,-187,-1016),(-1333,0,-187,-1004),(-1332,0,-186,-1016),(-1331,0,-186,-1004),(-1330,0,-185,-1007),(-1329,0,-185,-1004),(-1328,0,-184,-1007),(-1327,0,-184,-1004),(-1326,0,-183,-1032),(-1325,0,-183,-1002),(-1324,0,-182,-1016),(-1323,0,-182,-1004),(-1322,0,-181,-1016),(-1321,0,-181,-1004),(-1320,0,-180,-1017),(-1319,0,-180,-1004),(-1318,0,-179,-1001),(-1317,0,-179,-1000),(-1316,0,-178,-1001),(-1315,0,-178,-1000),(-1314,0,-177,-1001),(-1313,0,-177,-1000),(-1312,0,-176,-1001),(-1311,0,-176,-1000),(-1310,0,-174,-1001),(-1309,0,-174,-1000),(-1308,0,-172,-1001),(-1307,0,-172,-1000),(-1306,0,-170,-1001),(-1305,0,-170,-1000),(-1304,0,-169,-1001),(-1303,0,-169,-1000),(-1302,0,-165,-1001),(-1301,0,-165,-1000),(-1300,0,-164,-1001),(-1299,0,-164,-1000),(-1298,0,-163,-1001),(-1297,0,-163,-1000),(-1296,0,-162,-1001),(-1295,0,-162,-1000),(-1294,0,-161,-1001),(-1293,0,-161,-1000),(-1292,0,-160,-1018),(-1291,0,-160,-1002),(-1290,0,-159,-1001),(-1289,0,-159,-1000),(-1288,0,-158,-1003),(-1287,0,-158,-1002),(-1286,0,-157,-1001),(-1285,0,-157,-1000),(-1284,0,-156,-1003),(-1283,0,-156,-1002),(-1282,0,-155,-1003),(-1281,0,-155,-1002),(-1280,0,-154,-1003),(-1279,0,-154,-1002),(-1278,0,-153,-1003),(-1277,0,-153,-1002),(-1276,0,-152,-1001),(-1275,0,-152,-1000),(-1274,0,-151,-1003),(-1273,0,-151,-1002),(-1272,0,-150,-1003),(-1271,0,-150,-1002),(-1270,0,-149,-1003),(-1269,0,-149,-1002),(-1268,0,-148,-1001),(-1267,0,-148,-1000),(-1266,0,-147,-1003),(-1265,0,-147,-1002),(-1264,0,-146,-1001),(-1263,0,-146,-1000),(-1262,0,-145,-1003),(-1261,0,-145,-1002),(-1260,0,-144,-1001),(-1259,0,-144,-1000),(-1258,0,-143,-1003),(-1257,0,-143,-1002),(-1256,0,-142,-1001),(-1255,0,-142,-1000),(-1254,0,-141,-1007),(-1253,0,-141,-1004),(-1252,0,-140,-1001),(-1251,0,-140,-1000),(-1250,0,-139,-1001),(-1249,0,-139,-1000),(-1248,0,-138,-1001),(-1247,0,-138,-1000),(-1246,0,-137,-1001),(-1245,0,-137,-1000),(-1244,0,-136,-1001),(-1243,0,-136,-1000),(-1242,0,-135,-1001),(-1241,0,-135,-1000),(-1240,0,-134,-1001),(-1239,0,-134,-1000),(-1238,0,-133,-1001),(-1237,0,-133,-1000),(-1236,0,-132,-1003),(-1235,0,-132,-1002),(-1234,0,-131,-1001),(-1233,0,-131,-1000),(-1232,0,-130,-1001),(-1231,0,-130,-1000),(-1230,0,-129,-1001),(-1229,0,-129,-1000),(-1228,0,-128,-1001),(-1227,0,-128,-1000),(-1226,0,-126,-1003),(-1225,0,-126,-1002),(-1224,0,-125,-1003),(-1223,0,-125,-1002),(-1222,0,-122,-1003),(-1221,0,-122,-1002),(-1220,0,-121,-1003),(-1219,0,-121,-1002),(-1218,0,-120,-1003),(-1217,0,-120,-1002),(-1216,0,-118,-1003),(-1215,0,-118,-1002),(-1214,0,-116,-1001),(-1213,0,-116,-1000),(-1212,0,-114,-1003),(-1211,0,-114,-1002),(-1210,0,-111,-1003),(-1209,0,-111,-1002),(-1208,0,-110,-1003),(-1207,0,-110,-1002),(-1206,0,-109,-1003),(-1205,0,-109,-1002),(-1204,0,-108,-1001),(-1203,0,-108,-1000),(-1202,0,-107,-1003),(-1201,0,-107,-1002),(-1200,0,-106,-1003),(-1199,0,-106,-1002),(-1198,0,-105,-1003),(-1197,0,-105,-1002),(-1196,0,-104,-1003),(-1195,0,-104,-1002),(-1194,0,-103,-1003),(-1193,0,-103,-1002),(-1192,0,-102,-1003),(-1191,0,-102,-1002),(-1190,0,-101,-1003),(-1189,0,-101,-1002),(-1188,0,-99,-1001),(-1187,0,-99,-1000),(-1186,0,-98,-1001),(-1185,0,-98,-1000),(-1184,0,-97,-1001),(-1183,0,-97,-1000),(-1182,0,-96,-1001),(-1181,0,-96,-1000),(-1180,0,-95,-1001),(-1179,0,-95,-1000),(-1178,0,-94,-1001),(-1177,0,-94,-1000),(-1176,0,-93,-1001),(-1175,0,-93,-1000),(-1174,0,-92,-1001),(-1173,0,-92,-1000),(-1172,0,-91,-1001),(-1171,0,-91,-1000),(-1170,0,-90,-1001),(-1169,0,-90,-1000),(-1168,0,-89,-1001),(-1167,0,-89,-1000),(-1166,0,-88,-1001),(-1165,0,-88,-1000),(-1164,0,-87,-1001),(-1163,0,-87,-1000),(-1162,0,-86,-1001),(-1161,0,-86,-1000),(-1160,0,-85,-1001),(-1159,0,-85,-1000),(-1158,0,-84,-1001),(-1157,0,-84,-1000),(-1156,0,-83,-1001),(-1155,0,-83,-1000),(-1154,0,-82,-1001),(-1153,0,-82,-1000),(-1152,0,-81,-1001),(-1151,0,-81,-1000),(-1150,0,-80,-1001),(-1149,0,-80,-1000),(-1148,0,-79,-1001),(-1147,0,-79,-1000),(-1146,0,-78,-1001),(-1145,0,-78,-1000),(-1144,0,-77,-1001),(-1143,0,-77,-1000),(-1142,0,-76,-1001),(-1141,0,-76,-1000),(-1140,0,-75,-1001),(-1139,0,-75,-1000),(-1138,0,-74,-1001),(-1137,0,-74,-1000),(-1136,0,-73,-1001),(-1135,0,-73,-1000),(-1134,0,-72,-1001),(-1133,0,-72,-1000),(-1132,0,-71,-1001),(-1131,0,-71,-1000),(-1130,0,-70,-1001),(-1129,0,-70,-1000),(-1128,0,-69,-1001),(-1127,0,-69,-1000),(-1126,0,-68,-1001),(-1125,0,-68,-1000),(-1124,0,-67,-1001),(-1123,0,-67,-1000),(-1122,0,-66,-1001),(-1121,0,-66,-1000),(-1120,0,-65,-1001),(-1119,0,-65,-1000),(-1118,0,-64,-1001),(-1117,0,-64,-1000),(-1116,0,-63,-1001),(-1115,0,-63,-1000),(-1114,0,-62,-1001),(-1113,0,-62,-1000),(-1112,0,-61,-1001),(-1111,0,-61,-1000),(-1110,0,-60,-1001),(-1109,0,-60,-1000),(-1108,0,-59,-1001),(-1107,0,-59,-1000),(-1106,0,-58,-1001),(-1105,0,-58,-1000),(-1104,0,-57,-1001),(-1103,0,-57,-1000),(-1102,0,-56,-1003),(-1101,0,-56,-1002),(-1100,0,-55,-1001),(-1099,0,-55,-1000),(-1098,0,-54,-1001),(-1097,0,-54,-1000),(-1096,0,-53,-1001),(-1095,0,-53,-1000),(-1094,0,-52,-1001),(-1093,0,-52,-1000),(-1092,0,-51,-1001),(-1091,0,-51,-1000),(-1090,0,-50,-1001),(-1089,0,-50,-1000),(-1088,0,-49,-1003),(-1087,0,-49,-1002),(-1086,0,-48,-1003),(-1085,0,-48,-1002),(-1084,0,-47,-1001),(-1083,0,-47,-1000),(-1082,0,-46,-1007),(-1081,0,-46,-1004),(-1080,0,-45,-1001),(-1079,0,-45,-1000),(-1078,0,-44,-1003),(-1077,0,-44,-1002),(-1076,0,-43,-1005),(-1075,0,-43,-1004),(-1074,0,-41,-1001),(-1073,0,-41,-1000),(-1072,0,-40,-1001),(-1071,0,-40,-1000),(-1070,0,-39,-1001),(-1069,0,-39,-1000),(-1068,0,-38,-1003),(-1067,0,-38,-1002),(-1066,0,-36,-1001),(-1065,0,-36,-1000),(-1064,0,-34,-1003),(-1063,0,-34,-1002),(-1062,0,-33,-1003),(-1061,0,-33,-1002),(-1060,0,-32,-1003),(-1059,0,-32,-1002),(-1058,0,-31,-1001),(-1057,0,-31,-1000),(-1056,0,-30,-1001),(-1055,0,-30,-1000),(-1054,0,-29,-1003),(-1053,0,-29,-1002),(-1052,0,-28,-1003),(-1051,0,-28,-1002),(-1050,0,-27,-1003),(-1049,0,-27,-1002),(-1048,0,-26,-1001),(-1047,0,-26,-1000),(-1046,0,-25,-1003),(-1045,0,-25,-1002),(-1044,0,-24,-1001),(-1043,0,-24,-1000),(-1042,0,-23,-1001),(-1041,0,-23,-1000),(-1040,0,-22,-1001),(-1039,0,-22,-1000),(-1038,0,-21,-1001),(-1037,0,-21,-1000),(-1036,0,-20,-1003),(-1035,0,-20,-1002),(-1034,0,-19,-1001),(-1033,0,-19,-1000),(-1032,0,-17,-1001),(-1031,0,-17,-1000),(-1030,0,-16,-1003),(-1029,0,-16,-1002),(-1028,0,-15,-1003),(-1027,0,-15,-1002),(-1026,0,-14,-1003),(-1025,0,-14,-1002),(-1024,0,-13,-1001),(-1023,0,-13,-1000),(-1022,0,-12,-1003),(-1021,0,-12,-1002),(-1020,0,-11,-1003),(-1019,0,-11,-1002),(-1018,0,-10,-1001),(-1017,0,-10,-1000),(-1016,0,-8,-1001),(-1015,0,-8,-1000),(-1014,0,-7,-1003),(-1013,0,-7,-1002),(-1012,0,-6,-1003),(-1011,0,-6,-1002),(-1010,0,-5,-1003),(-1009,0,-5,-1002),(-1008,0,-4,-1003),(-1007,0,-4,-1002),(-1006,0,-3,-1003),(-1005,0,-3,-1002),(-1004,0,-2,-1003),(-1003,0,-2,-1002),(-1002,0,-1,-1003),(-1001,0,-1,-1002);
/*!40000 ALTER TABLE `rattach_tag` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rbank`
--

DROP TABLE IF EXISTS `rbank`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rbank` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la Cuenta Bancaria de la Persona o Empresa',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `registry` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador del Registro de la Persona o Empresa',
  `bank_account` char(34) COLLATE latin1_spanish_ci NOT NULL COMMENT 'IBAN - Numero de Cuenta Bancaria Internacional',
  `bic` char(11) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'BIC - Codigo Identificador del Banco',
  `sufix` char(3) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Sufijo de Cuenta Bancaria para Remesas',
  `alias` varchar(25) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Alias de la Cuenta Bancaria',
  `active` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'Indica si la Cuenta Bancaria esta activa o no',
  `account` int(4) DEFAULT NULL COMMENT 'Identificador de la Cuenta Contable',
  PRIMARY KEY (`id`),
  KEY `IDX_RBANK_REGISTRY` (`registry`),
  KEY `IDX_RBANK_DOMAIN` (`domain`),
  KEY `IDX_RBANK_ACCOUNT` (`account`),
  CONSTRAINT `FK_RBANK_ACCOUNT` FOREIGN KEY (`account`) REFERENCES `account` (`id`),
  CONSTRAINT `FK_RBANK_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_RBANK_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Datos de Cuentas Bancarias de Personas o Empresas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rbank`
--

LOCK TABLES `rbank` WRITE;
/*!40000 ALTER TABLE `rbank` DISABLE KEYS */;
/*!40000 ALTER TABLE `rbank` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rdir_staff`
--

DROP TABLE IF EXISTS `rdir_staff`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rdir_staff` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la Relacion entre Empresas y sus Directivos',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `registry` int(4) NOT NULL COMMENT 'Identificador de la Empresa',
  `document` varchar(16) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Numero de Documento del Directivo',
  `name` varchar(128) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre del Directivo',
  `shareholder` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indica si el Directivo es socio',
  `representative` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indica si el Directivo es representante legal',
  `director` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indica si el Directivo es administrador',
  `percent_share` double DEFAULT '0' COMMENT 'Porcentaje de acciones (solo para socios)',
  `share_number` int(4) DEFAULT '0' COMMENT 'Numero de Acciones',
  `nominal_value` double(15,3) DEFAULT '0.000' COMMENT 'Valor Nominal',
  `due_date` date DEFAULT NULL COMMENT 'Fecha de vencimiento del cargo',
  `representative_labor` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indica si el Directivo es representante laboral',
  `charge_description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion del cargo de Directivo',
  PRIMARY KEY (`id`),
  KEY `IDX_RDIR_STAFF_REGISTRY` (`registry`),
  KEY `IDX_RDIR_STAFF_DOMAIN` (`domain`),
  CONSTRAINT `FK_RDIR_STAFF_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_RDIR_STAFF_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Relacion entre Empresas y sus Directivos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rdir_staff`
--

LOCK TABLES `rdir_staff` WRITE;
/*!40000 ALTER TABLE `rdir_staff` DISABLE KEYS */;
/*!40000 ALTER TABLE `rdir_staff` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `record_data`
--

DROP TABLE IF EXISTS `record_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `record_data` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Dato Registral',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `registry` int(4) NOT NULL COMMENT 'Registro de la Empresa',
  `creation_date` date DEFAULT NULL COMMENT 'Fecha de creacion del Dato Registral',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion del Dato Registral',
  `notary` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Notario del Dato Registral',
  `number` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero del Dato Registral',
  `record_date` date DEFAULT NULL COMMENT 'Fecha de registro del Dato Registral',
  `volume` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Tomo del Dato Registral',
  `section` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Seccion del Dato Registral',
  `page` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Folio del Dato Registral',
  `sheet` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Hoja del Dato Registral',
  `registration` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Inscripcion del Dato Registral',
  `attach` int(4) DEFAULT NULL COMMENT 'Archivo adjunto',
  PRIMARY KEY (`id`),
  KEY `IDX_RECORD_DATA_RATTACH` (`attach`),
  KEY `IDX_RECORD_DATA_REGISTRY` (`registry`),
  KEY `IDX_RECORD_DATA_DOMAIN` (`domain`),
  CONSTRAINT `FK_RECORD_DATA_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_RECORD_DATA_RATTACH` FOREIGN KEY (`attach`) REFERENCES `rattach` (`id`),
  CONSTRAINT `FK_RECORD_DATA_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Datos Registrales';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `record_data`
--

LOCK TABLES `record_data` WRITE;
/*!40000 ALTER TABLE `record_data` DISABLE KEYS */;
/*!40000 ALTER TABLE `record_data` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `registry`
--

DROP TABLE IF EXISTS `registry`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `registry` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la Persona o Empresa',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `document` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de Documento de la Persona o Empresa',
  `document_type` tinyint(2) DEFAULT '0' COMMENT 'Tipo de documento (NIF, CIF...)',
  `document_country` varchar(2) COLLATE latin1_spanish_ci DEFAULT 'ES' COMMENT 'Pais del documento',
  `name` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre de la Persona o Empresa',
  `alias` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Alias de la Persona o Empresa',
  `type` tinyint(2) DEFAULT NULL COMMENT 'Tipo (Persona o Empresa)',
  `nationality` varchar(2) COLLATE latin1_spanish_ci DEFAULT 'ES' COMMENT 'Nacionalidad',
  `security_level` tinyint(2) DEFAULT '0' COMMENT 'Nivel de seguridad',
  PRIMARY KEY (`id`),
  KEY `IDX_REGISTRY_NAME` (`name`),
  KEY `IDX_REGISTRY_DOCUMENT` (`document`),
  KEY `IDX_REGISTRY_DOMAIN` (`domain`),
  CONSTRAINT `FK_REGISTRY_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=8628530 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Registro de Personas o Empresas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `registry`
--

LOCK TABLES `registry` WRITE;
/*!40000 ALTER TABLE `registry` DISABLE KEYS */;
INSERT INTO `registry` VALUES (216081,0,'',0,'AF','TEST','TEST',NULL,NULL,0),(8628387,8776,'',1,'ES','PAYROLL TEST','PAYROLL-TEST',NULL,'ES',0),(8628388,8777,'',1,'ES','RÉGIMEN GENERAL','GENERAL-PAYROLL-TEST',NULL,'ES',0),(8628389,8777,'',0,'ES','2012 TIEMPO COMPLETO ORDINARIO, INDEFINIDO','',0,'ES',0),(8628390,8777,'',0,'ES','1989 TIEMPO COMPLETO ORDINARIO, INDEFINIDO','',0,'ES',0),(8628391,8777,'',0,'ES','1993 TIEMPO COMPLETO ORDINARIO, INDEFINIDO','',0,'ES',0),(8628392,8777,'33333333',0,'ES','TIEMPO COMPLETO ORDINARIO ( > 1996 ), INDEFINIDO','',0,'ES',0),(8628393,8777,'',0,'ES','1991 TIEMPO COMPLETO ORDINARIO, INDEFINIDO','',0,'ES',0),(8628394,8777,'',0,'ES','EXTRAS TIEMPO COMPLETO ORDINARIO, INDEFINIDO','',0,'ES',0),(8628395,8777,'',0,'ES','PRORR. TIEMPO COMPLETO ORDINARIO, INDEFINIDO','',0,'ES',0),(8628396,8777,'',0,'ES','BASE, MÁXIMA ( GRUPO 01 )','',0,'ES',0),(8628397,8778,'',1,'ES','FORMACIÓN Y APRENDIZAJE','TRAINNING-PAYROLL-TEST',NULL,'ES',0),(8628398,8777,'',0,'ES','BASE, MÍNIMA ( GRUPO 01 )','',0,'ES',0),(8628399,8778,'',0,'ES','FORMACIÓN Y EL, APRENDIZAJE','',0,'ES',0),(8628400,8777,'',0,'ES','BRUTO TIEMPO COMPLETO ORDINARIO, INDEFINIDO','',0,'ES',0),(8628401,8777,'',0,'ES','I.R.P.F ARABA TIEMPO COMPLETO ORDINARIO, INDEFINIDO','',0,'ES',0),(8628402,8777,'',0,'ES','I.R.P.F 1 TIEMPO COMPLETO ORDINARIO, INDEFINIDO','',0,'ES',0),(8628403,8777,'',0,'ES','I.R.P.F 3 TIEMPO COMPLETO ORDINARIO, INDEFINIDO','',0,'ES',0),(8628404,8777,'',0,'ES','NETO TIEMPO COMPLETO ORDINARIO, INDEFINIDO','',0,'ES',0),(8628405,8779,NULL,1,'ES','DOCUMENTAL TEST','DOC-TEST',NULL,'ES',0),(8628406,8777,'',0,'ES','DESPIDO, IMPROCEDENTE','',0,'ES',0),(8628407,8777,'',0,'ES','DESPIDO, POR CAUSAS OBJETIVAS','',0,'ES',0),(8628408,8777,'',0,'ES','FIN CONTRATO FIJO, OBRA','',0,'ES',0),(8628409,8777,'',0,'ES','FIN CONTRATO, DURACIÓN DETERMINADA','',0,'ES',0),(8628410,8777,'',0,'ES','BAJA VOLUNTARIA, MODIFICACIÓN CONDICIONES','',0,'ES',0),(8628411,8777,'',0,'ES','RETA, -','',0,'ES',0),(8628412,8780,NULL,1,'ES','RÉGIMEN ESPECIAL AGRARIO','AGRARIAN-PAYROLL-TEST',NULL,'ES',0),(8628413,8777,'',0,'ES','ATRASOS TIEMPO COMPLETO ORDINARIO, INDEFINIDO','',0,'ES',0),(8628414,8778,'',0,'ES','BECARIO, EL','',0,'ES',0),(8628415,8777,'',0,'ES','REDUCCIONES RD-L 3/2014, TARIFA PLANA','',0,'ES',0),(8628416,8777,'',0,'ES','TARIFA REDUCIDA , REDUCCIÓN RD-L 1/2015','',0,'ES',0),(8628417,8777,'',0,'ES','ENFERMEDAD, COMÚN','',0,'ES',0),(8628418,8777,'',0,'ES','ENFERMEDAD, PROFESIONAL','',0,'ES',0),(8628419,8777,'',0,'ES','MATERNIDAD, COMPLETA','',0,'ES',0),(8628420,8777,'',0,'ES','PATERNIDAD, COMPLETA','',0,'ES',0),(8628421,8778,'',0,'ES','FINIQUITO  FORMACIÓN, APRENDIZAJE','',0,'ES',0),(8628422,8777,'',0,'ES',' , CATEGORIA','',0,'ES',0),(8628423,8780,'',0,'ES','MENSUAL TRABAJADOR CUENTA AJENA, AGRARIO','',0,'ES',0),(8628424,8777,'',0,'ES','VACACIONES, NO DISFRUTADAS','',0,'ES',0),(8628425,8777,'',0,'ES','BASE MÍNIMA MENSUAL, I.T','',0,'ES',0),(8628426,8777,'',0,'ES','BASE MÍNIMA DIARIA, I.T','',0,'ES',0),(8628427,8777,'',0,'ES','ANALISTA, JEFE DE PRIMERA','',0,'ES',0),(8628428,8777,'',0,'ES','DEVENGO, REDEFINIDO','',0,'ES',0),(8628429,8777,'',0,'ES','VARIABLE, REDEFINIDA','',0,'ES',0),(8628430,8777,'',0,'ES','PAGO, A CUENTA DEL CONVENIO','',0,'ES',0),(8628431,8780,'',0,'ES','VIGILANTE, CONVENIO','',0,'ES',0),(8628432,8777,'',0,'ES','CONCEPTO ANTIGUEDAD, DESCRIPCION','',0,'ES',0),(8628433,8777,'',0,'ES','ERROR, DESCRIPCIONES','',0,'ES',0),(8628434,8777,'',0,'ES','SIN, CATEGORIA','',0,'ES',0),(8628435,8777,'',0,'ES','NOTIFICACIONES, CHECKS','',0,'ES',0),(8628436,8777,'',0,'ES','BORRAR,  ','',0,'ES',0),(8628437,8777,'',0,'ES','CONCEPTO, ANTIGUEDAD','',0,'ES',0),(8628438,8777,'',0,'ES','CONCEPTO, PAGA EXTRA','',0,'ES',0),(8628439,8781,'',1,'ES','INACTIVA','INACTIVA-PAYROLL-TEST',NULL,'ES',0),(8628440,8781,'',0,'ES','INACTIVO,  ','',0,'ES',0),(8628441,8777,'',0,'ES','I.R.P.F, RETENIDO IS NOT COMPLETE','',0,'ES',0),(8628442,8777,'',0,'ES','I.R.P.F, REDEFINIDO','',0,'ES',0),(8628443,8782,NULL,1,'ES','ARTISTAS','ARTISTAS-PAYROLL-TEST',NULL,'ES',0),(8628444,8777,'',0,'ES','GARANTIZADO, ENFERMEDAD COMÚN','',0,'ES',0),(8628445,8777,'',0,'ES','GARANTIZADO, ENFERMEDAD PROFESIONAL','',0,'ES',0),(8628446,8777,'',0,'ES','EXTRA, DEVENGO FUERA','',0,'ES',0),(8628447,8777,'',0,'ES','GARANTIZADOS, SIN I.Ts','',0,'ES',0),(8628448,8777,'',0,'ES','GARANTIZADO ENFERMEDAD COMÚN, Y PROFESIONAL','',0,'ES',0),(8628449,8777,'',0,'ES','GARANTIZADOS, ENFERMEDAD COMÚN','',0,'ES',0),(8628450,8777,'',0,'ES','GARANTIZADOS, ENFERMEDAD PROFESIONAL','',0,'ES',0),(8628451,8783,'',1,'ES','CONVENIOS COLECTIVOS','CONVENIOS-PAYROLL-TEST',NULL,'ES',0),(8628452,8783,'',0,'ES','TITULADO, GARDO SUPERIOR','',0,'ES',0),(8628453,8783,'',0,'ES','TITULADO, GRADO MEDIO','',0,'ES',0),(8628454,8783,'',0,'ES','TÉCNICO, CALCULO EN DISEÑO','',0,'ES',0),(8628455,8783,'',0,'ES','JEFE, DE 2ª ( ENFERMEDAD COMÚN > 15 DIAS )','',0,'ES',0),(8628456,8783,'',0,'ES','OFICIAL 1ª, ADMINISTRATIVO (ENFERMEDAD PROFESIONAL)','',0,'ES',0),(8628457,8783,'',0,'ES','OFICIAL 2ª, ADMINISTRATIVO (MATERNIDAD)','',0,'ES',0),(8628458,8777,'',0,'ES','GARANTIZADO, 100%','',0,'ES',0),(8628459,8777,'',0,'ES','GARANTIZADO, EXTRAS CON GARANTIZADO','',0,'ES',0),(8628460,8777,'',0,'ES','NOMINA, SALARIO BASE','',0,'ES',0),(8628461,8777,'',0,'ES','NOMINA, EXTRAS','',0,'ES',0),(8628462,8777,'',0,'ES','NOMINAS, OFICINAS Y DESPACHOS MADRID','',0,'ES',0),(8628463,8784,NULL,1,'ES','HOSTELERÍA ISLAS BALEARES','HOSTELERIA-BALEARES-PAYROLL-TEST',NULL,'ES',0),(8628464,8784,'',0,'ES','JEFE, DE RECEPCIÓN','',0,'ES',0),(8628465,8784,'',0,'ES','CAFETERO, -','',0,'ES',0),(8628466,8777,'',0,'ES','MAX, EMBARGABLE','',0,'ES',0),(8628467,8777,'',0,'ES','BRUTO, ENFERMEDAD COMÚN (BASES)','',0,'ES',0),(8628468,8783,'',0,'ES','CATEGORIA, I','',0,'ES',0),(8628469,8783,'',0,'ES','GATEGORIA, II','',0,'ES',0),(8628470,8783,'',0,'ES','ANTIGUO, EMPLEADO','',0,'ES',0),(8628471,8777,'',0,'ES','EXTRAS, IT','',0,'ES',0),(8628472,8777,'',0,'ES','BASE, MÍNIMA IT ( GRUPO 01 )','',0,'ES',0),(8628473,8777,'',0,'ES','BASE, MÍNIMA ( GRUPO 07 )','',0,'ES',0),(8628474,8785,NULL,1,'ES','CALENDARIOS DE EMPRESA','CALENDARIOS-PAYROLL-TEST',NULL,'ES',0),(8628475,8777,'',0,'ES','IMPAGO, PENSIÓN ALIMENTICIA','',0,'ES',0),(8628476,8783,'',0,'ES','BORRAR, CATEGORIA 1','',0,'ES',0),(8628477,8783,'',0,'ES','BORRAR, CATEGORIA 5','',0,'ES',0),(8628478,8777,'',0,'ES','VACACIONES, NO DISFRUTADAS (> 1 MES)','',0,'ES',0),(8628479,8777,'',0,'ES','I.R.P.F BIZKAIA TIEMPO COMPLETO ORDINARIO, INDEFINIDO','',0,'ES',0),(8628480,8777,'',0,'ES','I.R.P.F GIPUZKOA TIEMPO COMPLETO ORDINARIO, INDEFINIDO','',0,'ES',0),(8628481,8777,'',0,'ES','COTIZACIÓN, CERO','',0,'ES',0),(8628482,8777,'',0,'ES','COTIZACIÓN, MÁX','',0,'ES',0),(8628483,8777,'',0,'ES','FINIQUITO, REDEFINIDO','',0,'ES',0),(8628484,8777,'',0,'ES','EXTRAS, IT (REDEFINIDO)','',0,'ES',0),(8628485,8777,'',0,'ES','NOMINA, DIFERENCIAS','',0,'ES',0),(8628486,8777,'',0,'ES','BASE, REDEFINIDA','',0,'ES',0),(8628487,8777,'',0,'ES','REDEFINIDAS, VARIABLES','',0,'ES',0),(8628488,8777,'',0,'ES','ESTATUTO, TRABAJADORES','',0,'ES',0),(8628489,8777,'',0,'ES','INDEFINIDO TIMEPO PARCIAL ORDINARIO, (L M M J V ) 50%','',0,'ES',0),(8628490,8777,'',0,'ES','INDEFINIDO TIEMPO PARCIAL ORDINARIO, ( M M J V S D ) 50%','',0,'ES',0),(8628491,8777,'',0,'ES','COTIZACIÓN, TRAMO I.T','',0,'ES',0),(8628492,8777,'',0,'ES','HORAS EXTRAS, NO ESTRUCTURALES','',0,'ES',0),(8628493,8777,'',0,'ES','HORAS EXTRAS, ESTRUCTURALES','',0,'ES',0),(8628494,8777,'',0,'ES','CONSTANTE, FIJA','',0,'ES',0),(8628495,8777,'',0,'ES','CONSTANTE, BRUTO','',0,'ES',0),(8628496,8777,'',0,'ES','CONSTANTE, NETO','',0,'ES',0),(8628497,8777,'',0,'ES','INDEFINIDO TIEMPO PARCIAL ORDINARIO, (L M ) NO LABORALES 25%','',0,'ES',0),(8628498,8777,'',0,'ES','INDEFINIDO TIEMPO PARCIAL ORDINARIO, (J V) NO DEFINIDOS = NO LAB','',0,'ES',0),(8628500,8787,NULL,1,'ES','COMERCIO DEL METAL MADRID','METAL-PAYROLL-TEST',NULL,'ES',0),(8628501,8787,'',0,'ES','ANALISTA DE, SISTEMAS','',0,'ES',0),(8628502,8787,'',0,'ES','JEFE 1ª, ADMINISTRATIVO','',0,'ES',0),(8628503,8787,'',0,'ES','JEFE DE SECCIÓN, ADMINISTRATIVO','',0,'ES',0),(8628504,8787,'',0,'ES','OPERADOR DE, ORDENADOR','',0,'ES',0),(8628505,8787,'',0,'ES','OFICIAL, 2ª','',0,'ES',0),(8628506,8787,'',0,'ES','CONTRATO PARA LA FORMACIÓN, 1º AÑO','',0,'ES',0),(8628507,8787,'',0,'ES','CONTRATO PARA LA FORMACIÓN, 2º AÑO','',0,'ES',0),(8628508,8787,'',0,'ES','PERSONAL DE LIMPIEZA, TIEMPO PARCIAL','',0,'ES',0),(8628509,8777,'',0,'ES','ANTIGUO, EMPLEADO','',0,'ES',0),(8628510,8777,'',0,'ES','REDUCCIÓN JORNADA, COEFICIENTE PARCIALIDAD','',0,'ES',0),(8628511,8777,'',0,'ES','REDUCCIÓN JORNADA, HORAS','',0,'ES',0),(8628512,8777,'',0,'ES','REDUCCIONES RD-L 3/2014 TARIFA PLANA, INICIO ANTERIOR','',0,'ES',0),(8628513,8777,'',0,'ES','MATERNIDAD, PARCIAL','',0,'ES',0),(8628514,8777,'',0,'ES','PATERNIDAD, PARCIAL','',0,'ES',0),(8628515,8777,'',0,'ES','EXTRA, REDEFINIDAS','',0,'ES',0),(8628516,8777,'',0,'ES','DRAFT COMPLETO, VACIO','',0,'ES',0),(8628517,8777,'',0,'ES','DRAFT COMPLETO, CONVENIO','',0,'ES',0),(8628518,8777,'',0,'ES','DRAFT PARCIAL, VACIO','',0,'ES',0),(8628519,8788,'',1,'ES','SISTEMA DE LIQUIDACIÓN DIRECTA (CRET@)','CRETA-PAYROLL-TEST',NULL,'ES',0),(8628520,8788,'',0,'ES','TRAMO, SIN FRACCIONAR','',0,'ES',0),(8628521,8788,'22222222',0,'ES','TIEMPO COMPLETO, SIN FRACCIONAR','',0,'ES',0),(8628522,8788,'11111111',0,'ES','MÚLTIPLES, ALTAS y BAJAS','',0,'ES',0),(8628523,8788,'33333333',0,'ES','INCAPACIDAD TEMPORAL, 15 PRIMEROS DIAS','',0,'ES',0),(8628524,8788,'44444444',0,'ES','INCAPACIDAD TEMPORAL, PAGO DELEGADO','',0,'ES',0),(8628525,8788,'55555555',0,'ES','INCAPACIDAD TEMPORAL AT y EP, PAGO DELEGADO','',0,'ES',0),(8628526,8777,'',0,'ES','EXTRAS  ANUALES, SEMESTRALES Y TRIMESTREALES','',0,'ES',0),(8628527,8777,'',0,'ES','COMPLEMENTO_I, INCIDENCIA','',0,'ES',0),(8628528,8777,'',0,'ES','COMPLEMENTO, TIEMPO_PARCIAL','',0,'ES',0),(8628529,8777,'',0,'ES','TESTING, CALENDARIO','',0,'ES',0);
/*!40000 ALTER TABLE `registry` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `relationship`
--

DROP TABLE IF EXISTS `relationship`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `relationship` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Tipo de Relacion',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `description` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion del Tipo de Relacion',
  PRIMARY KEY (`id`),
  KEY `IDX_RELATIONSHIP_DOMAIN` (`domain`),
  CONSTRAINT `FK_RELATIONSHIP_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Tipos de Relaciones entre Personas y/o Empresas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `relationship`
--

LOCK TABLES `relationship` WRITE;
/*!40000 ALTER TABLE `relationship` DISABLE KEYS */;
/*!40000 ALTER TABLE `relationship` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `reservation_request`
--

DROP TABLE IF EXISTS `reservation_request`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `reservation_request` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `hotel` int(4) NOT NULL COMMENT 'Identificador del Hotel',
  `code` varchar(48) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Localizador',
  `start_date` date NOT NULL COMMENT 'Fecha de entrada',
  `end_date` date NOT NULL COMMENT 'Fecha de salida',
  `agency` int(4) DEFAULT NULL COMMENT 'Identificador de la agencia de viajes',
  `company` int(4) DEFAULT NULL COMMENT 'Identificador de la empresa',
  `booking_holder` tinyint(2) NOT NULL COMMENT 'Titular',
  `request_counter` smallint(6) NOT NULL COMMENT 'Numero de solicitudes enviadas',
  `remarks` varchar(166) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Observaciones',
  `active` tinyint(1) NOT NULL COMMENT 'Indica si la Solicitud esta activa o no',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_RESERVATION_REQUEST_DOMAIN` (`domain`),
  KEY `IDX_RESERVATION_REQUEST_HOTEL` (`hotel`),
  KEY `IDX_RESERVATION_REQUEST_AGENCY` (`agency`),
  KEY `IDX_RESERVATION_REQUEST_COMPANY` (`company`),
  CONSTRAINT `FK_RESERVATION_REQUEST_AGENCY` FOREIGN KEY (`agency`) REFERENCES `customer` (`registry`),
  CONSTRAINT `FK_RESERVATION_REQUEST_COMPANY` FOREIGN KEY (`company`) REFERENCES `customer` (`registry`),
  CONSTRAINT `FK_RESERVATION_REQUEST_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_RESERVATION_REQUEST_HOTEL` FOREIGN KEY (`hotel`) REFERENCES `hotel` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Solicitud de Reservas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `reservation_request`
--

LOCK TABLES `reservation_request` WRITE;
/*!40000 ALTER TABLE `reservation_request` DISABLE KEYS */;
/*!40000 ALTER TABLE `reservation_request` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `reservation_request_guest`
--

DROP TABLE IF EXISTS `reservation_request_guest`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `reservation_request_guest` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `reservation_request` int(4) NOT NULL COMMENT 'Identificador de la Solicitud de Reserva',
  `guest_index` tinyint(2) NOT NULL COMMENT 'Numero de Huesped',
  `name` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre',
  `surname` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Apellidos',
  `email` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Email',
  `phone` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Telefono',
  `address` varchar(256) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Direccion',
  `number` varchar(12) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero',
  `address2` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Segunda parte de la Direccion',
  `zip` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo postal',
  `city` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Ciudad',
  `province` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Provincia',
  `country` varchar(2) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Pais',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_RESERVATION_REQUEST_GUEST_DOMAIN` (`domain`),
  KEY `IDX_RESERVATION_REQUEST_GUEST_RESERVATION_REQUEST` (`reservation_request`),
  CONSTRAINT `FK_RESERVATION_REQUEST_GUEST_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_RESERVATION_REQUEST_GUEST_RESERVATION_REQUEST` FOREIGN KEY (`reservation_request`) REFERENCES `reservation_request` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Huespedes por Solicitud de Reserva';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `reservation_request_guest`
--

LOCK TABLES `reservation_request_guest` WRITE;
/*!40000 ALTER TABLE `reservation_request_guest` DISABLE KEYS */;
/*!40000 ALTER TABLE `reservation_request_guest` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `reservation_request_room`
--

DROP TABLE IF EXISTS `reservation_request_room`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `reservation_request_room` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `reservation_request` int(4) NOT NULL COMMENT 'Identificador de la Solicitud de Reserva',
  `room_index` tinyint(2) NOT NULL COMMENT 'Numero de Habitacion',
  `units` tinyint(2) NOT NULL COMMENT 'Numero de Habitaciones',
  `item` int(4) NOT NULL COMMENT 'Identificador del Tipo de Habitacion',
  `adults` smallint(2) DEFAULT '0' COMMENT 'Numero de adultos',
  `children` smallint(2) DEFAULT '0' COMMENT 'Numero de nios',
  `babies` smallint(2) DEFAULT '0' COMMENT 'Numero de bebes',
  `crs_code` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo de Reserva en CRS',
  `tariff_code` varchar(8) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo de Tarifa',
  `tariff_description` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion de Tarifa',
  `inventory_code` varchar(15) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo de Servicio',
  `room_code` varchar(15) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo de Habitacion',
  `room_description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion de Habitacion',
  `meal_plan` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Tipo de regimen',
  `daily_price` double(15,2) DEFAULT '0.00' COMMENT 'Importe Diario',
  `total_price` double(15,2) DEFAULT '0.00' COMMENT 'Importe Total',
  `agreed_price` double(15,2) DEFAULT '0.00' COMMENT 'Importe Pactado',
  `cancel_penalty` varchar(256) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Penalizaciones por cancelacion',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_RESERVATION_REQUEST_ROOM_DOMAIN` (`domain`),
  KEY `IDX_RESERVATION_REQUEST_ROOM_RESERVATION_REQUEST` (`reservation_request`),
  KEY `IDX_RESERVATION_REQUEST_ROOM_ITEM` (`item`),
  KEY `IDX_RESERVATION_REQUEST_ROOM_CRS_CODE` (`crs_code`),
  CONSTRAINT `FK_RESERVATION_REQUEST_ROOM_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_RESERVATION_REQUEST_ROOM_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`),
  CONSTRAINT `FK_RESERVATION_REQUEST_ROOM_RESERVATION_REQUEST` FOREIGN KEY (`reservation_request`) REFERENCES `reservation_request` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Habitaciones por Solicitud de Reserva';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `reservation_request_room`
--

LOCK TABLES `reservation_request_room` WRITE;
/*!40000 ALTER TABLE `reservation_request_room` DISABLE KEYS */;
/*!40000 ALTER TABLE `reservation_request_room` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ritem`
--

DROP TABLE IF EXISTS `ritem`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `ritem` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `registry` int(4) NOT NULL COMMENT 'Identificador de Persona o Empresa',
  `item` int(4) NOT NULL COMMENT 'Identificador del Articulo',
  `type` tinyint(2) DEFAULT '0' COMMENT 'Tipo de relacion',
  `code` varchar(15) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo del Producto',
  `price` double DEFAULT '0' COMMENT 'Precio del Producto',
  `discount_expr` varchar(32) COLLATE latin1_spanish_ci DEFAULT '0.0' COMMENT 'Descuentos del Producto',
  `priority` tinyint(2) DEFAULT '0' COMMENT 'Prioridad del Producto',
  `workplace` int(4) DEFAULT NULL COMMENT 'Identificador del Centro de Trabajo',
  `status` tinyint(2) NOT NULL COMMENT 'Estado',
  PRIMARY KEY (`id`),
  KEY `IDX_RITEM_DOMAIN` (`domain`),
  KEY `IDX_RITEM_ITEM` (`item`),
  KEY `IDX_RITEM_REGISTRY` (`registry`),
  KEY `IDX_RITEM_WORKPLACE` (`workplace`),
  CONSTRAINT `FK_RITEM_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_RITEM_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`),
  CONSTRAINT `FK_RITEM_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`),
  CONSTRAINT `FK_RITEM_WORKPLACE` FOREIGN KEY (`workplace`) REFERENCES `workplace` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Articulos interesados por Personas o Empresas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ritem`
--

LOCK TABLES `ritem` WRITE;
/*!40000 ALTER TABLE `ritem` DISABLE KEYS */;
/*!40000 ALTER TABLE `ritem` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rmedia`
--

DROP TABLE IF EXISTS `rmedia`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rmedia` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Medio de Contacto de la Persona o Empresa',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `registry` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador del Registro de la Persona o Empresa',
  `media` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Tipo de Medio de Contacto de la Persona o Empresa',
  `value` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Valor del Medio de Contacto de la Persona o Empresa',
  `comment` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Comentarios acerca del Medio de Contacto de la Persona o Empresa',
  `administrative` tinyint(1) DEFAULT '1' COMMENT 'Indica si el Contacto es de caracter administrativo',
  `commercial` tinyint(1) DEFAULT '1' COMMENT 'Indica si el Contacto es de caracter comercial',
  `technical` tinyint(1) DEFAULT '1' COMMENT 'Indica si el Contacto es de caracter tecnico',
  `raddress` int(4) DEFAULT NULL COMMENT 'Direccion del contacto',
  PRIMARY KEY (`id`),
  KEY `IDX_RMEDIA_RADDRESS` (`raddress`),
  KEY `IDX_RMEDIA_REGISTRY` (`registry`),
  KEY `IDX_RMEDIA_DOMAIN` (`domain`),
  CONSTRAINT `FK_RMEDIA_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_RMEDIA_RADDRESS` FOREIGN KEY (`raddress`) REFERENCES `raddress` (`id`),
  CONSTRAINT `FK_RMEDIA_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=9235488 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Medios de Contacto de Personas o Empresas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rmedia`
--

LOCK TABLES `rmedia` WRITE;
/*!40000 ALTER TABLE `rmedia` DISABLE KEYS */;
INSERT INTO `rmedia` VALUES (9235460,0,216081,1,'',NULL,0,0,0,NULL),(9235461,0,216081,3,'',NULL,0,0,0,NULL),(9235462,0,216081,4,'',NULL,0,0,0,NULL),(9235463,0,216081,5,'',NULL,0,0,0,NULL),(9235464,8776,8628387,1,'',NULL,0,0,0,NULL),(9235465,8776,8628387,3,'',NULL,0,0,0,NULL),(9235466,8776,8628387,4,'',NULL,0,0,0,NULL),(9235467,8776,8628387,5,'',NULL,0,0,0,NULL),(9235468,8777,8628388,1,'',NULL,0,0,0,NULL),(9235469,8777,8628388,3,'',NULL,0,0,0,NULL),(9235470,8777,8628388,4,'',NULL,0,0,0,NULL),(9235471,8777,8628388,5,'',NULL,0,0,0,NULL),(9235472,8778,8628397,1,'',NULL,0,0,0,NULL),(9235473,8778,8628397,3,'',NULL,0,0,0,NULL),(9235474,8778,8628397,4,'',NULL,0,0,0,NULL),(9235475,8778,8628397,5,'',NULL,0,0,0,NULL),(9235476,8781,8628439,1,'',NULL,0,0,0,NULL),(9235477,8781,8628439,3,'',NULL,0,0,0,NULL),(9235478,8781,8628439,4,'',NULL,0,0,0,NULL),(9235479,8781,8628439,5,'',NULL,0,0,0,NULL),(9235480,8783,8628451,1,'',NULL,0,0,0,NULL),(9235481,8783,8628451,3,'',NULL,0,0,0,NULL),(9235482,8783,8628451,4,'',NULL,0,0,0,NULL),(9235483,8783,8628451,5,'',NULL,0,0,0,NULL),(9235484,8788,8628519,1,'',NULL,0,0,0,NULL),(9235485,8788,8628519,3,'',NULL,0,0,0,NULL),(9235486,8788,8628519,4,'',NULL,0,0,0,NULL),(9235487,8788,8628519,5,'',NULL,0,0,0,NULL);
/*!40000 ALTER TABLE `rmedia` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rnote`
--

DROP TABLE IF EXISTS `rnote`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rnote` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la Nota de la Persona o Empresa',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `registry` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador del Registro de la Persona o Empresa',
  `description` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion de la Nota',
  `note_date` date DEFAULT NULL COMMENT 'Fecha de la Nota',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios de la Nota',
  `note_type` tinyint(2) DEFAULT NULL,
  `security_level` tinyint(2) DEFAULT '0' COMMENT 'Nivel de seguridad de la Nota',
  PRIMARY KEY (`id`),
  KEY `IDX_RNOTE_REGISTRY` (`registry`),
  KEY `IDX_RNOTE_DOMAIN` (`domain`),
  CONSTRAINT `FK_RNOTE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_RNOTE_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Notas de Personas o Empresas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rnote`
--

LOCK TABLES `rnote` WRITE;
/*!40000 ALTER TABLE `rnote` DISABLE KEYS */;
/*!40000 ALTER TABLE `rnote` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `role`
--

DROP TABLE IF EXISTS `role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `role` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `name` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre del Role',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=1059 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Roles';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `role`
--

LOCK TABLES `role` WRITE;
/*!40000 ALTER TABLE `role` DISABLE KEYS */;
INSERT INTO `role` VALUES (2,'Guest'),(3,'Admin'),(4,'Config'),(5,'Auditor'),(6,'Confidentiality'),(7,'Product'),(8,'Commercial'),(9,'Sale'),(10,'Purchase'),(11,'Warehouse'),(12,'Accounting'),(13,'Finance'),(14,'Statistics'),(15,'TaskMonitoring'),(16,'eSignature'),(17,'SisAdmin'),(18,'Tgc'),(19,'DocumentManager'),(20,'Payroll'),(21,'Fiscal'),(22,'AccountingManager'),(23,'CallCenter'),(24,'CallCenterManager'),(101,'Administrador'),(102,'Invitado'),(103,'Manager'),(104,'Designer'),(105,'Editor'),(106,'Revisor'),(107,'Publisher'),(108,'SMSSender'),(109,'FAXSender'),(110,'DocumentsVisible'),(111,'PredefinedDocumentsExecutable'),(112,'CorporativeDocumentsManager'),(113,'Administrator'),(114,'ContentManagement'),(115,'Consultant'),(116,'Anonymous'),(1001,'Alumnos'),(1002,'AlumnosAusencias'),(1003,'AlumnosDatosAlumno'),(1004,'AlumnosDatosEconomicos'),(1005,'AlumnosDatosPersonales'),(1006,'AlumnosHistorial'),(1007,'AlumnosRelaciones'),(1008,'AlumnosSeguimiento'),(1009,'AuxiliaresAnyosAcademicos'),(1010,'AuxiliaresAptitudesCalidad'),(1011,'AuxiliaresBancos'),(1012,'AuxiliaresCalificaciones'),(1013,'AuxiliaresCategorias'),(1014,'AuxiliaresFormasDePago'),(1015,'AuxiliaresHabilidades'),(1016,'AuxiliaresMaterias'),(1017,'AuxiliaresNiveles'),(1018,'AuxiliaresObservaciones'),(1019,'AuxiliaresProductos'),(1020,'AuxiliaresTiposAlumno'),(1021,'AuxiliaresTiposRelaciones'),(1022,'BorradoFacturas'),(1023,'CentrosFormacion'),(1024,'ChecksTesoreria'),(1025,'CierreGrupos'),(1026,'ConfiguracionEjercicios'),(1027,'ConfiguracionImpuestos'),(1028,'ConfiguracionProvincias'),(1029,'ConfiguracionSeries'),(1030,'ConsultaNotas'),(1031,'ContabilizacionFacturas'),(1032,'CuotasAGrupos'),(1033,'DatosEmpresa'),(1034,'DevolucionVencimientos'),(1035,'DuplicarGrupos'),(1036,'FacturacionCuotas'),(1037,'FacturasVenta'),(1038,'GestionCartera'),(1039,'Grupos'),(1040,'GruposAlumnos'),(1041,'GruposAusencias'),(1042,'GruposCalificaciones'),(1043,'GruposFacturacion'),(1044,'GruposGrupo'),(1045,'GruposHabilidades'),(1046,'GruposObservaciones'),(1047,'GruposVCalidad'),(1048,'HabilidadesAGrupos'),(1049,'ImpresionFacturas'),(1050,'ListadoCuotas'),(1051,'MenuContabilidad'),(1052,'Prefacturacion'),(1053,'Prestamos'),(1054,'Profesores'),(1055,'ReclasificacionAlumnos'),(1056,'Remesas'),(1057,'Vencimientos'),(1058,'Invitado');
/*!40000 ALTER TABLE `role` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `room`
--

DROP TABLE IF EXISTS `room`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `room` (
  `asset` int(4) NOT NULL COMMENT 'Identificador del Activo',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `hotel` int(4) NOT NULL COMMENT 'Identificador del Hotel',
  `item` int(4) NOT NULL COMMENT 'Identificador del Producto',
  `status` tinyint(2) NOT NULL DEFAULT '1' COMMENT 'Estado de la Habitacion',
  `last_cleaning_date` datetime DEFAULT NULL COMMENT 'Ultima fecha de limpieza',
  `active` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'Indica si la Habitacion esta activa o no',
  PRIMARY KEY (`asset`),
  KEY `IDX_ROOM_DOMAIN` (`domain`),
  KEY `IDX_ROOM_HOTEL` (`hotel`),
  KEY `IDX_ROOM_ITEM` (`item`),
  CONSTRAINT `FK_ROOM_ASSET` FOREIGN KEY (`asset`) REFERENCES `asset` (`id`),
  CONSTRAINT `FK_ROOM_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_ROOM_HOTEL` FOREIGN KEY (`hotel`) REFERENCES `hotel` (`id`),
  CONSTRAINT `FK_ROOM_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Habitaciones de Hotel';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `room`
--

LOCK TABLES `room` WRITE;
/*!40000 ALTER TABLE `room` DISABLE KEYS */;
/*!40000 ALTER TABLE `room` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rpaymethod`
--

DROP TABLE IF EXISTS `rpaymethod`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rpaymethod` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la Forma de Pago de la Persona o Empresa',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `registry` int(4) NOT NULL COMMENT 'Identificador del Registro de la Persona o Empresa',
  `pay_method` int(4) NOT NULL COMMENT 'Identificador de la Forma de Pago',
  `rbank` int(4) DEFAULT NULL COMMENT 'Identificador de la Entidad Bancaria',
  `number_of_pymnts` smallint(2) DEFAULT '0' COMMENT 'Numero de Vencimientos',
  `days_to_first_pymnt` smallint(2) DEFAULT '0' COMMENT 'Dias al primer Vencimiento',
  `days_between_pymnts` smallint(2) DEFAULT '0' COMMENT 'Dias entre Vencimientos',
  `pymnt_days` varchar(8) COLLATE latin1_spanish_ci DEFAULT '0' COMMENT 'Dias de pago',
  PRIMARY KEY (`id`),
  KEY `IDX_RPAYMETHOD_PAY_METHOD` (`pay_method`),
  KEY `IDX_RPAYMETHOD_RBANK` (`rbank`),
  KEY `IDX_RPAYMETHOD_REGISTRY` (`registry`),
  KEY `IDX_RPAYMETHOD_DOMAIN` (`domain`),
  CONSTRAINT `FK_RPAYMETHOD_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_RPAYMETHOD_PAY_METHOD` FOREIGN KEY (`pay_method`) REFERENCES `pay_method` (`id`),
  CONSTRAINT `FK_RPAYMETHOD_RBANK` FOREIGN KEY (`rbank`) REFERENCES `rbank` (`id`),
  CONSTRAINT `FK_RPAYMETHOD_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Datos de la Forma de Pago de la Persona o Empresa';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rpaymethod`
--

LOCK TABLES `rpaymethod` WRITE;
/*!40000 ALTER TABLE `rpaymethod` DISABLE KEYS */;
/*!40000 ALTER TABLE `rpaymethod` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rprofile`
--

DROP TABLE IF EXISTS `rprofile`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rprofile` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `registry` int(4) NOT NULL COMMENT 'Identificador de Persona o Empresa',
  `last_update` datetime NOT NULL COMMENT 'Fecha de la ultima modificacion del Perfil del Cliente Potencial',
  `question` int(4) NOT NULL COMMENT 'Identificador de la Pregunta',
  `value_text` varchar(1024) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Valor de tipo texto',
  `value_number` double(15,3) DEFAULT NULL COMMENT 'Valor de tipo numerico',
  `value_date` datetime DEFAULT NULL COMMENT 'Valor de tipo fecha',
  PRIMARY KEY (`id`),
  KEY `IDX_RPROFILE_DOMAIN` (`domain`),
  KEY `IDX_RPROFILE_QUESTION` (`question`),
  KEY `IDX_RPROFILE_REGISTRY` (`registry`),
  CONSTRAINT `FK_RPROFILE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_RPROFILE_QUESTION` FOREIGN KEY (`question`) REFERENCES `question` (`id`),
  CONSTRAINT `FK_RPROFILE_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Perfiles de Personas o Empresas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rprofile`
--

LOCK TABLES `rprofile` WRITE;
/*!40000 ALTER TABLE `rprofile` DISABLE KEYS */;
/*!40000 ALTER TABLE `rprofile` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rrelationship`
--

DROP TABLE IF EXISTS `rrelationship`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rrelationship` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la Relacion',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `registry` int(4) NOT NULL COMMENT 'Identificador de la Persona o Empresa que tiene la Relacion',
  `related_registry` int(4) NOT NULL COMMENT 'Identificador de la Persona o Empresa relacionada',
  `relationship` int(4) NOT NULL COMMENT 'Identificador del Tipo de Relación',
  `comments` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Comentarios de la Relacion',
  PRIMARY KEY (`id`),
  KEY `IDX_RRELATIONSHIP_REGISTRY` (`registry`),
  KEY `IDX_RRELATIONSHIP_RELATED_REGISTRY` (`related_registry`),
  KEY `IDX_RRELATIONSHIP_RELATIONSHIP` (`relationship`),
  KEY `IDX_RRELATIONSHIP_DOMAIN` (`domain`),
  CONSTRAINT `FK_RRELATIONSHIP_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_RRELATIONSHIP_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`),
  CONSTRAINT `FK_RRELATIONSHIP_RELATED_REGISTRY` FOREIGN KEY (`related_registry`) REFERENCES `registry` (`id`),
  CONSTRAINT `FK_RRELATIONSHIP_RELATIONSHIP` FOREIGN KEY (`relationship`) REFERENCES `relationship` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Relaciones entre Personas y/o Empresas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rrelationship`
--

LOCK TABLES `rrelationship` WRITE;
/*!40000 ALTER TABLE `rrelationship` DISABLE KEYS */;
/*!40000 ALTER TABLE `rrelationship` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rsegment`
--

DROP TABLE IF EXISTS `rsegment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rsegment` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `registry` int(4) NOT NULL COMMENT 'Identificador de Persona o Empresa',
  `segment` int(4) NOT NULL COMMENT 'Identificador del Segmento',
  PRIMARY KEY (`id`),
  KEY `IDX_RSEGMENT_REGISTRY` (`registry`),
  KEY `IDX_RSEGMENT_SEGMENT` (`segment`),
  KEY `IDX_RSEGMENT_DOMAIN` (`domain`),
  CONSTRAINT `FK_RSEGMENT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_RSEGMENT_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`),
  CONSTRAINT `FK_RSEGMENT_SEGMENT` FOREIGN KEY (`segment`) REFERENCES `segment` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Segmentos de Personas o Empresas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rsegment`
--

LOCK TABLES `rsegment` WRITE;
/*!40000 ALTER TABLE `rsegment` DISABLE KEYS */;
/*!40000 ALTER TABLE `rsegment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rseller`
--

DROP TABLE IF EXISTS `rseller`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rseller` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `registry` int(4) NOT NULL COMMENT 'Identificador de Persona o Empresa',
  `seller` int(4) NOT NULL COMMENT 'Identificador del Comercial',
  `start_date` date NOT NULL COMMENT 'Fecha de Inicio',
  `end_date` date DEFAULT NULL COMMENT 'Fecha de Fin',
  `status` tinyint(2) NOT NULL COMMENT 'Estado',
  PRIMARY KEY (`id`),
  KEY `IDX_RSELLER_DOMAIN` (`domain`),
  KEY `IDX_RSELLER_SELLER` (`seller`),
  KEY `IDX_RSELLER_REGISTRY` (`registry`),
  CONSTRAINT `FK_RSELLER_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_RSELLER_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`),
  CONSTRAINT `FK_RSELLER_SELLER` FOREIGN KEY (`seller`) REFERENCES `seller` (`registry`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Comerciales relacionados con Personas o Empresas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rseller`
--

LOCK TABLES `rseller` WRITE;
/*!40000 ALTER TABLE `rseller` DISABLE KEYS */;
/*!40000 ALTER TABLE `rseller` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rsupplier`
--

DROP TABLE IF EXISTS `rsupplier`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rsupplier` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `registry` int(4) NOT NULL COMMENT 'Identificador de Persona o Empresa',
  `supplier` int(4) NOT NULL COMMENT 'Identificador del Proveedor',
  `target_external_code` varchar(15) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo del Cliente Potencial para el Proveedor',
  `tariff` int(4) DEFAULT NULL COMMENT 'Identificador de Tarifa',
  `pay_method` int(4) DEFAULT NULL COMMENT 'Identificador de la Forma de Pago',
  `number_of_pymnts` smallint(2) DEFAULT '0' COMMENT 'Numero de Vencimientos',
  `days_to_first_pymnt` smallint(2) DEFAULT '0' COMMENT 'Dias al primer Vencimiento',
  `days_between_pymnts` smallint(2) DEFAULT '0' COMMENT 'Dias entre Vencimientos',
  `pymnt_days` varchar(8) COLLATE latin1_spanish_ci DEFAULT '0' COMMENT 'Dias de pago',
  `bank_account` varchar(34) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'IBAN - Numero de Cuenta Bancaria Internacional',
  `bank_alias` varchar(25) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Alias del Banco',
  `bic` varchar(11) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'BIC - Codigo Identificador del Banco',
  PRIMARY KEY (`id`),
  KEY `IDX_RSUPPLIER_DOMAIN` (`domain`),
  KEY `IDX_RSUPPLIER_PAY_METHOD` (`pay_method`),
  KEY `IDX_RSUPPLIER_REGISTRY` (`registry`),
  KEY `IDX_RSUPPLIER_SUPPLIER` (`supplier`),
  KEY `IDX_RSUPPLIER_TARIFF` (`tariff`),
  CONSTRAINT `FK_RSUPPLIER_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_RSUPPLIER_PAY_METHOD` FOREIGN KEY (`pay_method`) REFERENCES `pay_method` (`id`),
  CONSTRAINT `FK_RSUPPLIER_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`),
  CONSTRAINT `FK_RSUPPLIER_SUPPLIER` FOREIGN KEY (`supplier`) REFERENCES `supplier` (`registry`),
  CONSTRAINT `FK_RSUPPLIER_TARIFF` FOREIGN KEY (`tariff`) REFERENCES `tariff` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Proveedores relacionados con Personas o Empresas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rsupplier`
--

LOCK TABLES `rsupplier` WRITE;
/*!40000 ALTER TABLE `rsupplier` DISABLE KEYS */;
/*!40000 ALTER TABLE `rsupplier` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `rtax`
--

DROP TABLE IF EXISTS `rtax`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `rtax` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `registry` int(4) NOT NULL COMMENT 'Identificador de Persona o Empresa',
  `tax` int(4) NOT NULL COMMENT 'Identificador del Impuesto',
  `percentage` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Porcentaje de recargo actual',
  `surcharge` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Porcentaje de recargo de equivalencia actual',
  `start_date` date NOT NULL COMMENT 'Fecha de inicio de vigencia',
  `end_date` date DEFAULT NULL COMMENT 'Fecha de fin de vigencia',
  PRIMARY KEY (`id`),
  KEY `IDX_RTAX_DOMAIN` (`domain`),
  KEY `IDX_RTAX_REGISTRY` (`registry`),
  KEY `IDX_RTAX_TAX` (`tax`),
  CONSTRAINT `FK_RTAX_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_RTAX_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`),
  CONSTRAINT `FK_RTAX_TAX` FOREIGN KEY (`tax`) REFERENCES `tax` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Impuestos redefinidos para Personas o Empresas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `rtax`
--

LOCK TABLES `rtax` WRITE;
/*!40000 ALTER TABLE `rtax` DISABLE KEYS */;
/*!40000 ALTER TABLE `rtax` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salary`
--

DROP TABLE IF EXISTS `salary`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `salary` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de Nomina',
  `contract` int(4) NOT NULL COMMENT 'Contrato',
  `start_date` date NOT NULL COMMENT 'Fecha de inicio liquidación',
  `end_date` date NOT NULL COMMENT 'Fecha de finalizacion liquidación',
  `enterprise_name` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre de la empresa',
  `enterprise_address` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Domicilio de la empresa',
  `enterprise_document` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de Documento de la Empresa',
  `ccc` char(11) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Valor del Codigo Cuenta Cotizacion',
  `ss_regime` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Regimen de la Seguridad Social',
  `employee_name` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre del trabajador',
  `social_security_number` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de la seguridad social',
  `employee_document` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Numero de Documento de la Persona',
  `seniority_date` date DEFAULT NULL COMMENT 'Fecha de antiguedad',
  `quote_group` varchar(2) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Grupo de Cotización',
  `category` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Categoria o grupo profesional',
  `registration` int(4) NOT NULL COMMENT 'Número libro de matricula',
  `time_units` int(4) NOT NULL COMMENT 'total dias/horas',
  `total_payment` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Total devengado',
  `total_deduction` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Total a deducir',
  `total_liquid` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Liquido total a percibir',
  `total_enterprise` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Cuota total de la empresa',
  `issue_date` date NOT NULL COMMENT 'Fecha de emisión',
  `remuneration` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Remuneración mensual',
  `pro_ext_base` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Base prorraterreada de pagas extras',
  `it_base` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Base de IT',
  `raw_cgc_base` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Base efectiva de cotizacion por contingencias comunes ',
  `cgc_base` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Base de cotizacion por contingencias comunes',
  `hextra_base` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Base de cotizacion adicional por horas extraordinarias estructurales',
  `non_hextra_base` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Base de cotizacion adicional por horas extraordinarias no estructurales',
  `cgp_base` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Base de cotizacion por contingencias profesionales',
  `money_irpf_base` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Salario en dinero sujeto a retención I.R.P.F',
  `inkind_irpf_base` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Salario en especie sujeto a retención I.R.P.F',
  `irpf_base` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Base sujeta a retención I.R.P.F',
  `social_security_contributions` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Aportaciones a la Seguridad Social',
  `total_irpf` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Total retención aplicada ',
  `charge_date` date NOT NULL COMMENT 'Fecha de cobro',
  PRIMARY KEY (`id`),
  KEY `IDX_SALARY_CONTRACT` (`contract`),
  KEY `IDX_SALARY_DOMAIN` (`domain`),
  CONSTRAINT `FK_SALARY_CONTRACT` FOREIGN KEY (`contract`) REFERENCES `contract` (`id`),
  CONSTRAINT `FK_SALARY_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=136 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Recibo del pago de salarios';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salary`
--

LOCK TABLES `salary` WRITE;
/*!40000 ALTER TABLE `salary` DISABLE KEYS */;
INSERT INTO `salary` VALUES (15,8777,2,5784,'2016-02-09','2016-04-05','RÉGIMEN GENERAL ','CL. ','','00000000000',0,'VACACIONES, NO DISFRUTADAS','','','2016-02-09','04','OCIFIAL DE PRIMERA',0,49,265.882,12.762,253.120,83.088,'2016-03-28',265.882,0.000,0.000,265.882,265.882,0.000,0.000,265.882,265.882,0.000,265.882,12.762,0.000,'2016-03-28'),(18,8777,0,-5800,'2016-04-19','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'SIN, CATEGORIA','','','2016-04-19',NULL,NULL,0,12,0.000,0.000,0.000,0.000,'2016-04-30',0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,'2016-04-30'),(19,8777,0,-5799,'2016-04-15','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'NOTIFICACIONES, CHECKS','','','2016-04-15','01',NULL,0,16,0.000,0.000,0.000,0.000,'2016-04-30',0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,'2016-04-30'),(20,8777,0,-5798,'2016-04-15','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'NOTIFICACIONES, CHECKS','','','2016-04-15','02','JEFE DE PRIMERA',0,16,548.078,45.679,502.399,224.798,'2016-04-30',548.078,171.274,0.000,719.352,719.352,0.000,0.000,719.352,548.078,0.000,548.078,45.679,0.000,'2016-04-30'),(21,8777,0,-5797,'2016-04-14','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'NOTIFICACIONES, CHECKS','','','2016-04-14','01',NULL,0,17,0.000,0.000,0.000,0.000,'2016-04-30',0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,'2016-04-30'),(22,8777,0,-5795,'2016-04-14','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'SIN, CATEGORIA','','','2016-04-14','01',NULL,0,17,0.000,0.000,0.000,0.000,'2016-04-30',0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,'2016-04-30'),(23,8777,0,5747,'2016-04-01','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'2012 TIEMPO COMPLETO ORDINARIO , INDEFINIDO','','','2012-08-18','03','PERSONAL TITULADO DE GRADO SUPERIOR',0,30,1148.046,108.012,1040.034,418.558,'2016-04-30',1148.046,191.341,0.000,1339.387,1339.387,0.000,0.000,1339.387,1148.046,0.000,1148.046,85.051,22.961,'2016-04-30'),(24,8777,0,5748,'2016-04-01','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'1993 TIEMPO COMPLETO ORDINARIO , INDEFINIDO','','','1993-02-18','03','PERSONAL TITULADO DE GRADO SUPERIOR',0,30,1368.824,183.069,1185.754,496.750,'2016-04-30',1368.824,220.778,0.000,1589.602,1589.602,0.000,0.000,1589.602,1368.824,0.000,1368.824,100.940,82.129,'2016-04-30'),(25,8777,0,5749,'2016-04-01','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'1989 TIEMPO COMPLETO ORDINARIO, INDEFINIDO','','','1989-02-18','03','PERSONAL TITULADO DE GRADO SUPERIOR',0,30,1424.018,204.126,1219.892,513.999,'2016-04-30',1424.018,220.778,0.000,1644.796,1644.796,0.000,0.000,1644.796,1424.018,0.000,1424.018,104.445,99.681,'2016-04-30'),(26,8777,0,5750,'2016-04-01','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'1991 TIEMPO COMPLETO ORDINARIO, INDEFINIDO','','','1991-02-19','03','PERSONAL TITULADO DE GRADO SUPERIOR',0,30,1368.824,183.069,1185.754,496.750,'2016-04-30',1368.824,220.778,0.000,1589.602,1589.602,0.000,0.000,1589.602,1368.824,0.000,1368.824,100.940,82.129,'2016-04-30'),(27,8777,0,5792,'2016-04-07','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'CONCEPTO ANTIGUEDAD, DESCRIPCION','','','2016-04-07','05',NULL,0,24,611.520,38.832,572.688,191.100,'2016-04-30',611.520,0.000,0.000,611.520,611.520,0.000,0.000,611.520,611.520,0.000,611.520,38.832,0.000,'2016-04-30'),(29,8777,0,5778,'2016-04-01','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'ENFERMEDAD, PROFESIONAL','','','2016-03-01','09','DIBUJANTE',0,30,835.413,61.890,773.523,304.578,'2016-04-30',835.413,139.235,0.000,974.648,974.648,0.000,0.000,974.648,835.413,0.000,835.413,61.890,0.000,'2016-04-30'),(30,8777,0,5779,'2016-04-01','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'MATERNIDAD,  ','','','2016-03-01','09','ENTREVISTADOR-ENCUESTADOR',0,30,835.413,61.890,773.523,304.578,'2016-04-30',835.413,139.235,0.000,974.648,974.648,0.000,0.000,974.648,835.413,0.000,835.413,61.890,0.000,'2016-04-30'),(31,8777,0,5780,'2016-04-01','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'PATERNIDAD,  ','','','2016-03-01','08','OPERADOR DE SEGUNDA',0,30,439.238,37.189,402.049,183.016,'2016-04-30',439.238,146.413,0.000,585.650,585.650,0.000,0.000,585.650,439.238,0.000,439.238,37.189,0.000,'2016-04-30'),(32,8777,0,5785,'2016-04-01','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'BASE MÍNIMA MENSUAL, I.T','','','2016-04-03','05',NULL,0,30,655.200,48.539,606.661,238.875,'2016-04-30',655.200,0.000,0.000,655.200,764.400,0.000,0.000,764.400,655.200,0.000,655.200,48.539,0.000,'2016-04-30'),(33,8777,0,5786,'2016-04-01','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'BASE MÍNIMA DIARIA, I.T','','','2016-04-03','09',NULL,0,30,611.520,45.303,566.217,222.950,'2016-04-30',611.520,0.000,0.000,611.520,713.440,0.000,0.000,713.440,611.520,0.000,611.520,45.303,0.000,'2016-04-30'),(34,8777,0,5806,'2016-04-25','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'GARANTIZADO, ENFERMEDAD COMÚN','','','2016-04-25','01',NULL,0,6,213.480,13.556,199.924,66.713,'2016-04-30',213.480,0.000,0.000,213.480,213.480,0.000,0.000,213.480,213.480,0.000,213.480,13.556,0.000,'2016-04-30'),(35,8777,0,5807,'2016-04-25','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'GARANTIZADO, ENFERMEDAD PROFESIONAL','','','2016-04-25','01',NULL,0,6,213.480,13.556,199.924,-40.028,'2016-04-30',213.480,0.000,0.000,213.480,213.480,0.000,0.000,213.480,213.480,0.000,213.480,13.556,0.000,'2016-04-30'),(36,8777,0,5758,'2016-04-01','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'I.R.P.F TIEMPO COMPLETO ORDINARIO, INDEFINIDO','','','2015-02-22','01',NULL,0,30,1013.334,66.888,946.446,329.426,'2016-04-30',1013.334,0.000,0.000,1013.334,1067.400,0.000,0.000,1013.334,1013.334,0.000,1013.334,66.888,0.000,'2016-04-30'),(37,8777,0,5763,'2016-04-01','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'I.R.P.F 1 TIEMPO COMPLETO ORDINARIO, INDEFINIDO','','','2016-02-22','09',NULL,0,30,0.000,0.000,0.000,0.000,'2016-04-30',0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,'2016-04-30'),(38,8777,0,5751,'2016-04-01','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'EXTRAS TIEMPO COMPLETO ORDINARIO, INDEFINIDO','','','2016-02-22','03','ANALISTA',0,30,1027.646,76.131,951.515,374.663,'2016-04-30',1027.646,171.274,0.000,1198.921,1198.921,0.000,0.000,1198.921,1027.646,0.000,1027.646,76.131,0.000,'2016-04-30'),(39,8777,0,5752,'2016-04-01','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'PRORR. TIEMPO COMPLETO ORDINARIO, INDEFINIDO','','','2016-02-22','05','ANALISTA',0,30,1198.921,76.131,1122.789,374.663,'2016-04-30',1198.921,0.000,0.000,1198.921,1198.921,0.000,0.000,1198.921,1198.921,0.000,1198.921,76.131,0.000,'2016-04-30'),(40,8777,0,5753,'2016-04-01','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'01 MAX TIEMPO COMPLETO ORDINARIO, INDEFINIDO','','','2016-02-21','01',NULL,0,30,10000.000,3398.267,6601.733,1138.125,'2016-04-30',10000.000,0.000,0.000,10000.000,3642.000,0.000,0.000,3642.000,10000.000,0.000,10000.000,231.267,3167.000,'2016-04-30'),(41,8777,0,5754,'2016-04-01','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'01 MIN TIEMPO COMPLETO ORDINARIO, INDEFINIDO','','','2016-02-21','01',NULL,0,30,10.000,62.780,-52.780,310.383,'2016-04-30',10.000,0.000,0.000,10.000,1067.400,0.000,0.000,764.400,10.000,0.000,10.000,62.780,0.000,'2016-04-30'),(42,8777,0,5756,'2016-04-01','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'BRUTO TIEMPO COMPLETO ORDINARIO, INDEFINIDO','','','2016-02-22','04',NULL,0,30,1500.000,155.250,1344.750,468.750,'2016-04-30',1500.000,0.000,0.000,1500.000,1500.000,0.000,0.000,1500.000,1500.000,0.000,1500.000,95.250,60.000,'2016-04-30'),(43,8777,0,5762,'2016-04-01','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'NETO TIEMPO COMPLETO ORDINARIO, INDEFINIDO','','','2016-02-22','05',NULL,0,30,2634.842,509.842,2125.000,823.388,'2016-04-30',2634.842,0.000,0.000,2634.842,2634.842,0.000,0.000,2634.842,2634.842,0.000,2634.842,167.312,342.529,'2016-04-30'),(44,8777,0,5759,'2016-04-01','2016-04-30','RÉGIMEN GENERAL','CL. - - (-) -','','00000000000',0,'I.R.P.F TIEMPO COMPLETO ORDINARIO, INDEFINIDO','','','2015-02-22','01',NULL,0,30,16964.167,6508.009,10456.158,1138.125,'2016-04-30',16964.167,0.000,0.000,16964.167,3642.000,0.000,0.000,3642.000,16964.167,0.000,16964.167,231.267,6276.742,'2016-04-30'),(45,8777,0,5764,'2016-04-01','2016-04-30','RÉGIMEN GENERAL','CL. - - (-) -','','00000000000',0,'I.R.P.F 1 TIEMPO COMPLETO ORDINARIO, INDEFINIDO','','','2016-02-22','03',NULL,0,30,0.000,0.000,0.000,0.000,'2016-04-30',0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,'2016-04-30'),(46,8777,0,5760,'2016-04-01','2016-04-30','RÉGIMEN GENERAL','CL. - - (-) -','','00000000000',0,'I.R.P.F TIEMPO COMPLETO ORDINARIO, INDEFINIDO','','','2015-02-22','05',NULL,0,30,974.167,61.860,912.307,304.427,'2016-04-30',974.167,0.000,0.000,974.167,974.167,0.000,0.000,974.167,974.167,0.000,974.167,61.860,0.000,'2016-04-30'),(47,8777,0,5765,'2016-04-01','2016-04-30','RÉGIMEN GENERAL','CL. - - (-) -','','00000000000',0,'I.R.P.F 1 TIEMPO COMPLETO ORDINARIO, INDEFINIDO','','','2016-02-22','07',NULL,0,30,0.000,0.000,0.000,0.000,'2016-04-30',0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,'2016-04-30'),(48,8777,0,5761,'2016-04-01','2016-04-30','RÉGIMEN GENERAL','CL. - - (-) -','','00000000000',0,'I.R.P.F TIEMPO COMPLETO ORDINARIO, INDEFINIDO','','','2016-02-22','01',NULL,0,30,0.000,0.000,0.000,0.000,'2016-04-30',0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,'2016-04-30'),(49,8777,0,5804,'2016-04-20','2016-04-30','RÉGIMEN GENERAL','CL. - - (-) -','','00000000000',0,'I.R.P.F, RETENIDO IS NOT COMPLETE','','','2016-04-20','04',NULL,0,11,0.000,0.000,0.000,0.000,'2016-04-30',0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,'2016-04-30'),(50,8777,0,5805,'2016-04-20','2016-04-30','RÉGIMEN GENERAL','CL. - - (-) -','','00000000000',0,'I.R.P.F, REDEFINIDO','','','2016-04-20','05',NULL,0,11,0.000,0.000,0.000,0.000,'2016-04-30',0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,'2016-04-30'),(51,8777,0,5767,'2016-04-01','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'DESPIDO, POR CAUSAS OBJETIVAS','','','2016-02-22','08',NULL,0,30,0.000,0.000,0.000,0.000,'2016-04-30',0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,'2016-04-30'),(53,8777,0,5771,'2016-04-01','2016-04-30','RÉGIMEN GENERAL','CL. ','',NULL,3,'RETA, -','','','2016-02-22',NULL,NULL,0,30,0.000,0.000,0.000,0.000,'2016-04-30',0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,'2016-04-30'),(54,8777,0,5775,'2016-04-01','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'TARIFA REDUCIDA , REDUCCIÓN RD-L 1/2015','','','2016-03-01','08','OCIFIAL DE PRIMERA',0,30,365.969,32.922,333.047,162.017,'2016-04-30',365.969,152.487,0.000,518.456,518.456,0.000,0.000,518.456,365.969,0.000,365.969,32.922,0.000,'2016-04-30'),(55,8777,0,5776,'2016-04-01','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'REDUCCIONES RD-L 3/2014, TARIFA PLANA','','','2016-03-01','09','DIBUJANTE',0,30,835.413,61.890,773.523,174.561,'2016-04-30',835.413,139.235,0.000,974.648,974.648,0.000,0.000,974.648,835.413,0.000,835.413,61.890,0.000,'2016-04-30'),(56,8777,0,5782,'2016-04-01','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,' , CATEGORIA','','','2016-03-09','06','OBSOLETO',0,30,1027.646,76.131,951.515,374.663,'2016-04-30',1027.646,171.274,0.000,1198.921,1198.921,0.000,0.000,1198.921,1027.646,0.000,1027.646,76.131,0.000,'2016-04-30'),(57,8777,0,5788,'2016-04-05','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'DEVENGO, REDEFINIDO','','','2016-04-05','02','PROGRAMADOR',0,26,1013.020,76.290,936.729,375.444,'2016-04-30',1013.020,188.402,0.000,1201.421,1201.421,0.000,0.000,1201.421,1013.020,0.000,1013.020,76.290,0.000,'2016-04-30'),(58,8777,0,5789,'2016-04-05','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'VARIABLE, REDEFINIDA','','','2016-04-05','02','ANALISTA',0,26,489.845,43.069,446.776,211.952,'2016-04-30',489.845,188.402,0.000,678.247,678.247,0.000,0.000,678.247,489.845,0.000,489.845,43.069,0.000,'2016-04-30'),(59,8777,0,5790,'2016-04-05','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'PAGO, A CUENTA DEL CONVENIO','','','2016-04-05','07','DELINEANTE',0,26,761.346,57.643,703.703,283.674,'2016-04-30',761.346,146.413,0.000,907.758,907.758,0.000,0.000,907.758,761.346,0.000,761.346,57.643,0.000,'2016-04-30'),(60,8777,0,5787,'2016-04-03','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'ANALISTA, JEFE DE PRIMERA','','','2016-04-03','02','ANALISTA',0,28,959.137,71.781,887.356,353.253,'2016-04-30',959.137,171.274,0.000,1130.411,1130.411,0.000,0.000,1130.411,959.137,0.000,959.137,71.781,0.000,'2016-04-30'),(61,8777,0,5794,'2016-04-14','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'SIN, CATEGORIA','','','2016-04-14','06',NULL,0,17,0.000,0.000,0.000,0.000,'2016-04-30',0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,'2016-04-30'),(62,8777,0,5793,'2016-04-07','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'ERROR, DESCRIPCIONES','','','2016-04-07','04',NULL,0,24,140.000,38.832,101.168,191.100,'2016-04-30',140.000,0.000,0.000,140.000,611.520,0.000,0.000,611.520,140.000,0.000,140.000,38.832,0.000,'2016-04-30'),(63,8777,0,5796,'2016-04-14','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'NOTIFICACIONES, CHECKS','','','2016-04-14','04',NULL,0,17,0.000,0.000,0.000,0.000,'2016-04-30',0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,'2016-04-30'),(64,8777,0,5801,'2016-04-19','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'CONCEPTO, ANTIGUEDAD','','','2016-04-19','06',NULL,0,12,327.600,20.803,306.797,102.375,'2016-04-30',327.600,0.000,0.000,327.600,327.600,0.000,0.000,327.600,327.600,0.000,327.600,20.803,0.000,'2016-04-30'),(65,8777,0,5802,'2016-04-19','2016-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'CONCEPTO, PAGA EXTRA','','','2016-04-19','02',NULL,0,12,131.040,11.751,119.289,57.952,'2016-04-30',131.040,0.000,0.000,131.040,191.880,0.000,0.000,165.600,131.040,0.000,131.040,11.751,0.000,'2016-04-30'),(69,8777,1,5823,'2016-07-01','2016-12-31','RÉGIMEN GENERAL','CL. ','','00000000000',0,'NOMINAS, OFICINAS Y DESPACHOS MADRID','','','2016-05-18','03','JEFE DE PRIMERA',0,180,1027.646,0.000,1027.646,0.000,'2016-12-15',1027.646,0.000,0.000,0.000,0.000,0.000,0.000,0.000,1027.646,0.000,1027.646,0.000,0.000,'2016-12-15'),(70,8777,0,5821,'2016-05-18','2016-05-31','RÉGIMEN GENERAL','CL. ','','00000000000',0,'NOMINA, SALARIO BASE','','','2016-05-18','05',NULL,0,14,356.720,22.652,334.068,111.475,'2016-05-31',356.720,0.000,0.000,356.720,356.720,0.000,0.000,356.720,356.720,0.000,356.720,22.652,0.000,'2016-05-31'),(71,8777,0,5822,'2016-05-18','2016-05-31','RÉGIMEN GENERAL','CL. ','','00000000000',0,'NOMINA, EXTRAS','','','2016-05-18','09',NULL,0,14,345.213,22.652,322.561,111.475,'2016-05-31',345.213,0.000,0.000,345.213,356.720,0.000,0.000,356.720,345.213,0.000,345.213,22.652,0.000,'2016-05-31'),(72,8777,0,5823,'2016-05-18','2016-05-31','RÉGIMEN GENERAL','CL. ','','00000000000',0,'NOMINAS, OFICINAS Y DESPACHOS MADRID','','','2016-05-18','03','JEFE DE PRIMERA',0,14,479.568,41.329,438.240,203.388,'2016-05-31',479.568,171.274,0.000,650.843,650.843,0.000,0.000,650.843,479.568,0.000,479.568,41.329,0.000,'2016-05-31'),(73,8784,0,5824,'2016-06-01','2016-06-30','HOSTELERÍA ISLAS BALEARES','CL. - - (000000) MALLORCA',NULL,'00000000000',0,'JEFE, DE RECEPCIÓN','','','2016-05-18','03','Jefe/a de recepción',0,30,1614.590,120.556,1494.034,609.373,'2016-06-30',1614.590,269.098,0.000,1883.688,1883.688,0.000,0.000,1883.688,1614.590,0.000,1614.590,120.556,0.000,'2016-06-30'),(74,8784,0,5825,'2016-05-18','2016-05-31','HOSTELERÍA ISLAS BALEARES','CL. - - (000000) MALLORCA',NULL,'00000000000',0,'CAFETERO, -','','','2016-05-18','08','Cafetero/a',0,14,584.803,43.324,541.479,212.527,'2016-05-31',584.803,97.467,0.000,682.270,682.270,0.000,0.000,682.270,584.803,0.000,584.803,43.324,0.000,'2016-05-31'),(75,8777,0,5826,'2016-06-01','2016-06-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'MAX, EMBARGABLE','','','2016-05-23','04',NULL,0,30,1925.486,603.746,1321.739,601.714,'2016-06-30',1925.486,0.000,0.000,1925.486,1925.486,0.000,0.000,1925.486,1925.486,0.000,1925.486,122.268,77.019,'2016-06-30'),(77,8777,0,5772,'2015-02-01','2015-02-28','RÉGIMEN GENERAL','CL. ','','00000000000',0,'ATRASOS TIEMPO COMPLETO ORDINARIO, INDEFINIDO','','','2012-02-29','03','CATEGORIA III',0,30,1935.900,433.803,1502.097,705.797,'2015-02-28',1935.900,322.650,0.000,2258.550,2258.550,0.000,0.000,2258.550,1935.900,0.000,1935.900,143.418,290.385,'2015-02-28'),(78,8777,0,5772,'2015-03-01','2015-03-31','RÉGIMEN GENERAL','CL. ','','00000000000',0,'ATRASOS TIEMPO COMPLETO ORDINARIO, INDEFINIDO','','','2012-02-29','03','CATEGORIA III',0,30,2013.336,451.155,1562.181,734.029,'2015-03-31',2013.336,335.556,0.000,2348.892,2348.892,0.000,0.000,2348.892,2013.336,0.000,2013.336,149.155,302.000,'2015-03-31'),(79,8777,0,5772,'2015-04-01','2015-04-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'ATRASOS TIEMPO COMPLETO ORDINARIO, INDEFINIDO','','','2012-02-29','03','CATEGORIA III',0,30,2013.336,451.155,1562.181,734.029,'2015-04-30',2013.336,335.556,0.000,2348.892,2348.892,0.000,0.000,2348.892,2013.336,0.000,2013.336,149.155,302.000,'2015-04-30'),(80,8777,0,5772,'2015-05-01','2015-05-31','RÉGIMEN GENERAL','CL. ','','00000000000',0,'ATRASOS TIEMPO COMPLETO ORDINARIO, INDEFINIDO','','','2012-02-29','03','CATEGORIA III',0,30,2013.336,451.155,1562.181,734.029,'2015-05-31',2013.336,335.556,0.000,2348.892,2348.892,0.000,0.000,2348.892,2013.336,0.000,2013.336,149.155,302.000,'2015-05-31'),(81,8777,0,5772,'2015-06-01','2015-06-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'ATRASOS TIEMPO COMPLETO ORDINARIO, INDEFINIDO','','','2012-02-29','03','CATEGORIA III',0,30,2013.336,451.155,1562.181,734.029,'2015-06-30',2013.336,335.556,0.000,2348.892,2348.892,0.000,0.000,2348.892,2013.336,0.000,2013.336,149.155,302.000,'2015-06-30'),(82,8777,0,5772,'2015-07-01','2015-07-31','RÉGIMEN GENERAL','CL. ','','00000000000',0,'ATRASOS TIEMPO COMPLETO ORDINARIO, INDEFINIDO','','','2012-02-29','03','CATEGORIA III',0,30,2013.336,451.155,1562.181,734.029,'2015-07-31',2013.336,335.556,0.000,2348.892,2348.892,0.000,0.000,2348.892,2013.336,0.000,2013.336,149.155,302.000,'2015-07-31'),(83,8777,0,5772,'2015-08-01','2015-08-31','RÉGIMEN GENERAL','CL. ','','00000000000',0,'ATRASOS TIEMPO COMPLETO ORDINARIO, INDEFINIDO','','','2012-02-29','03','CATEGORIA III',0,30,2013.336,451.155,1562.181,734.029,'2015-08-31',2013.336,335.556,0.000,2348.892,2348.892,0.000,0.000,2348.892,2013.336,0.000,2013.336,149.155,302.000,'2015-08-31'),(84,8777,0,5772,'2015-09-01','2015-09-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'ATRASOS TIEMPO COMPLETO ORDINARIO, INDEFINIDO','','','2012-02-29','03','CATEGORIA III',0,30,2013.336,451.155,1562.181,734.029,'2015-09-30',2013.336,335.556,0.000,2348.892,2348.892,0.000,0.000,2348.892,2013.336,0.000,2013.336,149.155,302.000,'2015-09-30'),(85,8777,0,5772,'2015-10-01','2015-10-31','RÉGIMEN GENERAL','CL. ','','00000000000',0,'ATRASOS TIEMPO COMPLETO ORDINARIO, INDEFINIDO','','','2012-02-29','03','CATEGORIA III',0,30,2013.336,451.155,1562.181,734.029,'2015-10-31',2013.336,335.556,0.000,2348.892,2348.892,0.000,0.000,2348.892,2013.336,0.000,2013.336,149.155,302.000,'2015-10-31'),(86,8777,0,5772,'2015-11-01','2015-11-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'ATRASOS TIEMPO COMPLETO ORDINARIO, INDEFINIDO','','','2012-02-29','03','CATEGORIA III',0,30,2013.336,451.155,1562.181,734.029,'2015-11-30',2013.336,335.556,0.000,2348.892,2348.892,0.000,0.000,2348.892,2013.336,0.000,2013.336,149.155,302.000,'2015-11-30'),(87,8777,0,5772,'2015-12-01','2015-12-31','RÉGIMEN GENERAL','CL. ','','00000000000',0,'ATRASOS TIEMPO COMPLETO ORDINARIO, INDEFINIDO','','','2012-02-29','03','CATEGORIA III',0,30,2013.336,451.155,1562.181,734.029,'2015-12-31',2013.336,335.556,0.000,2348.892,2348.892,0.000,0.000,2348.892,2013.336,0.000,2013.336,149.155,302.000,'2015-12-31'),(88,8777,0,5772,'2015-01-01','2015-01-31','RÉGIMEN GENERAL','CL. ','','00000000000',0,'ATRASOS TIEMPO COMPLETO ORDINARIO, INDEFINIDO','','','2012-02-29','03','CATEGORIA III',0,30,1935.900,433.803,1502.097,705.797,'2015-01-31',1935.900,322.650,0.000,2258.550,2258.550,0.000,0.000,2258.550,1935.900,0.000,1935.900,143.418,290.385,'2015-01-31'),(89,8777,3,5772,'2015-01-01','2015-12-31','RÉGIMEN GENERAL','CL. ','','00000000000',0,'ATRASOS TIEMPO COMPLETO ORDINARIO, INDEFINIDO','','','2012-02-29','03','CATEGORIA III',0,360,800.170,179.305,620.865,291.728,'2015-12-31',800.170,0.000,0.000,933.530,933.530,0.000,0.000,933.530,800.170,0.000,800.170,59.279,120.026,'2015-12-31'),(90,8783,1,5816,'2016-05-06','2016-12-31','CONVENIOS COLECTIVOS','CL. - - (-) EL MUNDO',NULL,'00000000000',0,'JEFE, DE 2ª ( ENFERMEDAD COMÚN > 15 DIAS )','','','2016-05-06','04','Jefe/a de 2',0,239,311.676,0.000,311.676,0.000,'2016-12-15',311.676,0.000,0.000,0.000,0.000,0.000,0.000,0.000,311.676,0.000,311.676,0.000,0.000,'2016-12-15'),(93,8783,0,5828,'2016-05-01','2016-05-31','CONVENIOS COLECTIVOS','CL. - - (-) EL MUNDO',NULL,'00000000000',0,'CATEGORIA, I','','','2016-02-01','05','CATEGORIA I',0,30,0.000,0.000,0.000,0.000,'2016-05-31',0.000,0.000,0.000,1528.800,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,'2016-05-31'),(94,8783,0,5829,'2016-05-01','2016-05-31','CONVENIOS COLECTIVOS','CL. - - (-) EL MUNDO',NULL,'00000000000',0,'GATEGORIA, II','','','2010-05-27','04','CATEGORIA II',0,30,0.000,0.000,0.000,0.000,'2016-05-31',0.000,0.000,0.000,764.400,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,'2016-05-31'),(96,8783,1,5829,'2016-01-01','2016-12-31','CONVENIOS COLECTIVOS','CL. - - (-) EL MUNDO',NULL,'00000000000',0,'GATEGORIA, II','','','2010-05-27','04','CATEGORIA II',0,360,655.200,0.000,655.200,0.000,'2016-12-15',655.200,0.000,0.000,0.000,0.000,0.000,0.000,0.000,655.200,0.000,655.200,0.000,0.000,'2016-12-15'),(97,8783,0,5828,'2016-06-01','2016-06-30','CONVENIOS COLECTIVOS','CL. - - (-) EL MUNDO',NULL,'00000000000',0,'CATEGORIA, I','','','2016-02-01','05','CATEGORIA I',0,30,1310.400,97.079,1213.321,488.452,'2016-06-30',1310.400,218.400,0.000,1528.800,1528.800,0.000,0.000,1528.800,1310.400,0.000,1310.400,97.079,0.000,'2016-06-30'),(98,8777,0,5832,'2016-07-01','2016-07-31','RÉGIMEN GENERAL','CL. ','','00000000000',0,'BASE, MÍNIMA IT ( GRUPO 01 )','','','2016-05-31','01',NULL,0,30,606.108,64.947,541.161,320.427,'2016-07-31',606.108,0.000,0.000,833.820,1067.400,0.000,0.000,1067.400,606.108,0.000,606.108,64.947,0.000,'2016-07-31'),(99,8777,0,5786,'2016-05-01','2016-05-31','RÉGIMEN GENERAL','CL. ','','00000000000',0,'BASE MÍNIMA DIARIA, I.T','','','2016-04-03','09',NULL,0,31,557.460,50.157,507.303,246.838,'2016-05-31',557.460,0.000,0.000,676.367,789.880,0.000,0.000,789.880,557.460,0.000,557.460,50.157,0.000,'2016-05-31'),(100,8777,2,5837,'2016-06-07','2016-07-27','RÉGIMEN GENERAL','CL. ','','00000000000',0,'VACACIONES, NO DISFRUTADAS (> 1 MES)','','','2016-06-07','06','OPERADOR DE SEGUNDA',0,21,1144.253,68.655,1075.598,348.103,'2016-06-27',1072.737,0.000,0.000,1072.737,1072.737,0.000,0.000,1072.737,1072.737,0.000,1072.737,68.655,0.000,'2016-06-27'),(101,8777,0,5842,'2016-06-20','2016-06-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'NOMINA, DIFERENCIAS','','','2016-06-20','04','JEFE DE SEGUNDA',0,11,362.203,33.718,328.485,170.960,'2016-06-30',362.203,164.638,0.000,526.840,526.840,0.000,0.000,526.840,362.203,0.000,362.203,33.718,0.000,'2016-06-30'),(102,8777,0,5842,'2016-07-01','2016-07-31','RÉGIMEN GENERAL','CL. ','','00000000000',0,'NOMINA, DIFERENCIAS','','','2016-06-20','04','JEFE DE SEGUNDA',0,30,987.825,73.758,914.067,373.974,'2016-07-31',987.825,164.638,0.000,1152.462,1152.462,0.000,0.000,1152.462,987.825,0.000,987.825,73.758,0.000,'2016-07-31'),(103,8777,0,5842,'2016-08-01','2016-08-31','RÉGIMEN GENERAL','CL. ','','00000000000',0,'NOMINA, DIFERENCIAS','','','2016-06-20','04','JEFE DE SEGUNDA',0,30,987.825,73.758,914.067,373.974,'2016-08-31',987.825,164.638,0.000,1152.462,1152.462,0.000,0.000,1152.462,987.825,0.000,987.825,73.758,0.000,'2016-08-31'),(104,8777,0,5842,'2016-09-01','2016-09-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'NOMINA, DIFERENCIAS','','','2016-06-20','04','JEFE DE SEGUNDA',0,30,987.825,73.758,914.067,373.974,'2016-09-30',987.825,164.638,0.000,1152.462,1152.462,0.000,0.000,1152.462,987.825,0.000,987.825,73.758,0.000,'2016-09-30'),(105,8777,0,5842,'2016-10-01','2016-10-31','RÉGIMEN GENERAL','CL. ','','00000000000',0,'NOMINA, DIFERENCIAS','','','2016-06-20','04','JEFE DE SEGUNDA',0,30,987.825,73.758,914.067,373.974,'2016-10-31',987.825,164.638,0.000,1152.462,1152.462,0.000,0.000,1152.462,987.825,0.000,987.825,73.758,0.000,'2016-10-31'),(106,8777,0,5842,'2016-11-01','2016-11-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'NOMINA, DIFERENCIAS','','','2016-06-20','04','JEFE DE SEGUNDA',0,30,987.825,73.758,914.067,373.974,'2016-11-30',987.825,164.638,0.000,1152.462,1152.462,0.000,0.000,1152.462,987.825,0.000,987.825,73.758,0.000,'2016-11-30'),(107,8777,0,5850,'2016-08-19','2016-08-31','RÉGIMEN GENERAL','CL. ','','00000000000',0,'HORAS EXTRAS, ESTRUCTURALES','','','2016-08-19','02','PROGRAMADOR',0,12,430.955,54.851,376.104,271.621,'2016-08-31',430.955,342.549,0.000,806.307,806.307,100.000,0.000,806.307,430.955,0.000,430.955,54.851,0.000,'2016-08-31'),(108,8777,0,5868,'2016-11-01','2016-11-30','RÉGIMEN GENERAL','CL. ','','00000000000',0,'MATERNIDAD, PARCIAL','','','2016-07-16','05','OPERADOR DE PRIMERA',0,30,914.922,67.780,847.142,333.565,'2016-11-30',914.922,152.487,0.000,1067.409,1067.409,0.000,0.000,1067.409,914.922,0.000,914.922,67.780,0.000,'2016-11-30'),(119,8788,0,5874,'2016-12-01','2016-12-31','SISTEMA DE LIQUIDACIÓN DIRECTA (CRET@)','CL. ','','66666666666',0,'TIEMPO COMPLETO, SIN FRACCIONAR','222222222222','22222222','2012-12-19','05','ADMINISTRATIVO',0,30,1146.600,218.427,928.173,1128.254,'2016-12-31',1146.600,2293.200,0.000,3439.800,3439.800,0.000,0.000,3439.800,1146.600,0.000,1146.600,218.427,0.000,'2016-12-31'),(120,8788,0,5875,'2016-12-02','2016-12-09','SISTEMA DE LIQUIDACIÓN DIRECTA (CRET@)','CL. ','','66666666666',0,'MÚLTIPLES, ALTAS y BAJAS','111111111111','11111111','2016-12-02','04','I',0,8,174.720,37.041,137.679,178.214,'2016-12-31',174.720,349.440,0.000,524.160,524.160,0.000,0.000,524.160,174.720,0.000,174.720,33.546,3.494,'2016-12-09'),(121,8788,0,5876,'2016-12-12','2016-12-16','SISTEMA DE LIQUIDACIÓN DIRECTA (CRET@)','CL. ','','66666666666',0,'MÚLTIPLES, ALTAS y BAJAS','111111111111','11111111','2016-12-12','04','I',0,5,109.200,23.150,86.050,139.217,'2016-12-31',109.200,218.400,0.000,327.600,327.600,0.000,0.000,327.600,109.200,0.000,109.200,20.966,2.184,'2016-12-16'),(122,8788,0,5877,'2016-12-19','2016-12-23','SISTEMA DE LIQUIDACIÓN DIRECTA (CRET@)','CL. ','','66666666666',0,'MÚLTIPLES, ALTAS y BAJAS','111111111111','11111111','2016-12-19','07','I',0,5,109.200,23.150,86.050,139.217,'2016-12-31',109.200,218.400,0.000,327.600,327.600,0.000,0.000,327.600,109.200,0.000,109.200,20.966,2.184,'2016-12-23'),(123,8788,0,5878,'2016-12-26','2016-12-31','SISTEMA DE LIQUIDACIÓN DIRECTA (CRET@)','CL. ','','66666666666',0,'MÚLTIPLES, ALTAS y BAJAS','111111111111','11111111','2016-12-26','07','I',0,6,131.040,27.780,103.260,167.060,'2016-12-31',131.040,262.080,0.000,393.120,393.120,0.000,0.000,393.120,131.040,0.000,131.040,25.160,2.621,'2016-12-31'),(125,8788,0,5874,'2016-11-01','2016-11-30','SISTEMA DE LIQUIDACIÓN DIRECTA (CRET@)','CL. ','','66666666666',0,'TIEMPO COMPLETO, SIN FRACCIONAR','222222222222','22222222','2012-11-19','05','ADMINISTRATIVO',0,30,655.200,124.816,530.384,644.717,'2016-11-30',655.200,1310.400,0.000,1965.600,1965.600,0.000,0.000,1965.600,655.200,0.000,655.200,124.816,0.000,'2016-11-30'),(126,8788,0,5875,'2016-11-02','2016-11-09','SISTEMA DE LIQUIDACIÓN DIRECTA (CRET@)','CL. ','','66666666666',0,'MÚLTIPLES, ALTAS y BAJAS','111111111111','11111111','2016-11-02','04','I',0,8,174.720,37.041,137.679,178.214,'2016-11-30',174.720,349.440,0.000,524.160,524.160,0.000,0.000,524.160,174.720,0.000,174.720,33.546,3.494,'2016-11-09'),(127,8788,0,5876,'2016-11-12','2016-11-16','SISTEMA DE LIQUIDACIÓN DIRECTA (CRET@)','CL. ','','66666666666',0,'MÚLTIPLES, ALTAS y BAJAS','111111111111','11111111','2016-11-12','04','I',0,5,109.200,23.150,86.050,139.217,'2016-11-30',109.200,218.400,0.000,327.600,327.600,0.000,0.000,327.600,109.200,0.000,109.200,20.966,2.184,'2016-11-16'),(128,8788,0,5877,'2016-11-19','2016-11-23','SISTEMA DE LIQUIDACIÓN DIRECTA (CRET@)','CL. ','','66666666666',0,'MÚLTIPLES, ALTAS y BAJAS','111111111111','11111111','2016-11-19','07','I',0,5,109.200,23.150,86.050,139.217,'2016-11-30',109.200,218.400,0.000,327.600,327.600,0.000,0.000,327.600,109.200,0.000,109.200,20.966,2.184,'2016-11-23'),(129,8788,0,5878,'2016-11-26','2016-11-30','SISTEMA DE LIQUIDACIÓN DIRECTA (CRET@)','CL. ','','66666666666',0,'MÚLTIPLES, ALTAS y BAJAS','111111111111','11111111','2016-11-26','07','I',0,5,109.200,23.150,86.050,139.217,'2016-11-30',109.200,218.400,0.000,327.600,327.600,0.000,0.000,327.600,109.200,0.000,109.200,20.966,2.184,'2016-11-30'),(133,8788,0,5880,'2016-11-01','2016-11-30','SISTEMA DE LIQUIDACIÓN DIRECTA (CRET@)','CL. ','','66666666666',0,'INCAPACIDAD TEMPORAL, PAGO DELEGADO','444444444444','44444444','2016-01-04','04','I',0,30,1474.200,124.816,1349.384,-829.483,'2016-11-30',1474.200,0.000,0.000,1965.600,1965.600,0.000,0.000,1965.600,1474.200,0.000,1474.200,124.816,0.000,'2016-11-30'),(134,8788,0,5881,'2016-11-01','2016-11-30','SISTEMA DE LIQUIDACIÓN DIRECTA (CRET@)','CL. ','','66666666666',0,'INCAPACIDAD TEMPORAL AT y EP, PAGO DELEGADO','555555555555','55555555','2016-01-04','03','I',0,30,1474.200,124.816,1349.384,-829.483,'2016-11-30',1474.200,0.000,0.000,1965.600,1965.600,0.000,0.000,1965.600,1474.200,0.000,1474.200,124.816,0.000,'2016-11-30'),(135,8788,0,5879,'2016-11-01','2016-11-30','SISTEMA DE LIQUIDACIÓN DIRECTA (CRET@)','CL. ','','66666666666',0,'INCAPACIDAD TEMPORAL, 15 PRIMEROS DIAS','33333333','33333333','2016-01-04','05','OFICIAL Y CABALLERO',0,30,711.984,124.816,587.168,644.717,'2016-11-30',711.984,873.600,0.000,1965.600,1965.600,0.000,0.000,1965.600,711.984,0.000,711.984,124.816,0.000,'2016-11-30');
/*!40000 ALTER TABLE `salary` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salary_bonus`
--

DROP TABLE IF EXISTS `salary_bonus`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `salary_bonus` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `salary` int(4) NOT NULL COMMENT 'Recibo del pago de salarios',
  `bonus_concept` varchar(5) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo del concepto',
  `amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion',
  PRIMARY KEY (`id`),
  KEY `IDX_SALARY_BONUS_SALARY` (`salary`),
  KEY `IDX_SALARY_BONUS_DOMAIN` (`domain`),
  CONSTRAINT `FK_SALARY_BONUS_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_SALARY_BONUS_SALARY` FOREIGN KEY (`salary`) REFERENCES `salary` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Bonificaciones';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salary_bonus`
--

LOCK TABLES `salary_bonus` WRITE;
/*!40000 ALTER TABLE `salary_bonus` DISABLE KEYS */;
INSERT INTO `salary_bonus` VALUES (1,8777,55,'3262',130.017,'REDUCCIONES RD-L 3/2014 TARIFA PLANA (PRIMEROS DOS AÑOS)');
/*!40000 ALTER TABLE `salary_bonus` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salary_cost`
--

DROP TABLE IF EXISTS `salary_cost`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `salary_cost` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `salary` int(4) NOT NULL COMMENT 'Recibo del pago de salarios',
  `amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion',
  `type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de deduccion Salarial',
  `cost_concept` varchar(10) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo del concepto',
  PRIMARY KEY (`id`),
  KEY `IDX_SALARY_COST_SALARY` (`salary`),
  KEY `IDX_SALARY_COST_DOMAIN` (`domain`),
  CONSTRAINT `FK_SALARY_COST_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_SALARY_COST_SALARY` FOREIGN KEY (`salary`) REFERENCES `salary` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=783703 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Costos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salary_cost`
--

LOCK TABLES `salary_cost` WRITE;
/*!40000 ALTER TABLE `salary_cost` DISABLE KEYS */;
INSERT INTO `salary_cost` VALUES (782804,8777,15,62.748,NULL,0,'CGC_E'),(782805,8777,15,0.000,NULL,4,'EXTR_E'),(782806,8777,15,0.000,NULL,5,'NEXTR_E'),(782807,8777,15,1.728,NULL,1,'IT_E'),(782808,8777,15,1.861,NULL,1,'IMS_E'),(782809,8777,15,0.532,NULL,10,'FOGASA_E'),(782810,8777,15,1.595,NULL,3,'FP_E'),(782811,8777,15,14.624,NULL,2,'DESMPL_E'),(782820,8777,18,0.000,NULL,0,'CGC_E'),(782821,8777,18,0.000,NULL,4,'EXTR_E'),(782822,8777,18,0.000,NULL,5,'NEXTR_E'),(782823,8777,18,0.000,NULL,1,'IT_E'),(782824,8777,18,0.000,NULL,1,'IMS_E'),(782825,8777,18,0.000,NULL,10,'FOGASA_E'),(782826,8777,18,0.000,NULL,3,'FP_E'),(782827,8777,18,0.000,NULL,2,'DESMPL_E'),(782828,8777,19,0.000,NULL,0,'CGC_E'),(782829,8777,19,0.000,NULL,4,'EXTR_E'),(782830,8777,19,0.000,NULL,5,'NEXTR_E'),(782831,8777,19,0.000,NULL,1,'IT_E'),(782832,8777,19,0.000,NULL,1,'IMS_E'),(782833,8777,19,0.000,NULL,10,'FOGASA_E'),(782834,8777,19,0.000,NULL,3,'FP_E'),(782835,8777,19,0.000,NULL,2,'DESMPL_E'),(782836,8777,20,169.767,NULL,0,'CGC_E'),(782837,8777,20,0.000,NULL,4,'EXTR_E'),(782838,8777,20,0.000,NULL,5,'NEXTR_E'),(782839,8777,20,4.676,NULL,1,'IT_E'),(782840,8777,20,5.035,NULL,1,'IMS_E'),(782841,8777,20,1.439,NULL,10,'FOGASA_E'),(782842,8777,20,4.316,NULL,3,'FP_E'),(782843,8777,20,39.564,NULL,2,'DESMPL_E'),(782844,8777,21,0.000,NULL,0,'CGC_E'),(782845,8777,21,0.000,NULL,4,'EXTR_E'),(782846,8777,21,0.000,NULL,5,'NEXTR_E'),(782847,8777,21,0.000,NULL,1,'IT_E'),(782848,8777,21,0.000,NULL,1,'IMS_E'),(782849,8777,21,0.000,NULL,10,'FOGASA_E'),(782850,8777,21,0.000,NULL,3,'FP_E'),(782851,8777,21,0.000,NULL,2,'DESMPL_E'),(782852,8777,22,0.000,NULL,0,'CGC_E'),(782853,8777,22,0.000,NULL,4,'EXTR_E'),(782854,8777,22,0.000,NULL,5,'NEXTR_E'),(782855,8777,22,0.000,NULL,1,'IT_E'),(782856,8777,22,0.000,NULL,1,'IMS_E'),(782857,8777,22,0.000,NULL,10,'FOGASA_E'),(782858,8777,22,0.000,NULL,3,'FP_E'),(782859,8777,22,0.000,NULL,2,'DESMPL_E'),(782860,8777,23,316.095,NULL,0,'CGC_E'),(782861,8777,23,0.000,NULL,4,'EXTR_E'),(782862,8777,23,0.000,NULL,5,'NEXTR_E'),(782863,8777,23,8.706,NULL,1,'IT_E'),(782864,8777,23,9.376,NULL,1,'IMS_E'),(782865,8777,23,2.679,NULL,10,'FOGASA_E'),(782866,8777,23,8.036,NULL,3,'FP_E'),(782867,8777,23,73.666,NULL,2,'DESMPL_E'),(782868,8777,24,375.146,NULL,0,'CGC_E'),(782869,8777,24,0.000,NULL,4,'EXTR_E'),(782870,8777,24,0.000,NULL,5,'NEXTR_E'),(782871,8777,24,10.332,NULL,1,'IT_E'),(782872,8777,24,11.127,NULL,1,'IMS_E'),(782873,8777,24,3.179,NULL,10,'FOGASA_E'),(782874,8777,24,9.538,NULL,3,'FP_E'),(782875,8777,24,87.428,NULL,2,'DESMPL_E'),(782876,8777,25,388.172,NULL,0,'CGC_E'),(782877,8777,25,0.000,NULL,4,'EXTR_E'),(782878,8777,25,0.000,NULL,5,'NEXTR_E'),(782879,8777,25,10.691,NULL,1,'IT_E'),(782880,8777,25,11.514,NULL,1,'IMS_E'),(782881,8777,25,3.290,NULL,10,'FOGASA_E'),(782882,8777,25,9.869,NULL,3,'FP_E'),(782883,8777,25,90.464,NULL,2,'DESMPL_E'),(782884,8777,26,375.146,NULL,0,'CGC_E'),(782885,8777,26,0.000,NULL,4,'EXTR_E'),(782886,8777,26,0.000,NULL,5,'NEXTR_E'),(782887,8777,26,10.332,NULL,1,'IT_E'),(782888,8777,26,11.127,NULL,1,'IMS_E'),(782889,8777,26,3.179,NULL,10,'FOGASA_E'),(782890,8777,26,9.538,NULL,3,'FP_E'),(782891,8777,26,87.428,NULL,2,'DESMPL_E'),(782892,8777,27,144.319,NULL,0,'CGC_E'),(782893,8777,27,0.000,NULL,4,'EXTR_E'),(782894,8777,27,0.000,NULL,5,'NEXTR_E'),(782895,8777,27,3.975,NULL,1,'IT_E'),(782896,8777,27,4.281,NULL,1,'IMS_E'),(782897,8777,27,1.223,NULL,10,'FOGASA_E'),(782898,8777,27,3.669,NULL,3,'FP_E'),(782899,8777,27,33.634,NULL,2,'DESMPL_E'),(782908,8777,29,230.017,NULL,0,'CGC_E'),(782909,8777,29,0.000,NULL,4,'EXTR_E'),(782910,8777,29,0.000,NULL,5,'NEXTR_E'),(782911,8777,29,6.335,NULL,1,'IT_E'),(782912,8777,29,6.823,NULL,1,'IMS_E'),(782913,8777,29,1.949,NULL,10,'FOGASA_E'),(782914,8777,29,5.848,NULL,3,'FP_E'),(782915,8777,29,53.606,NULL,2,'DESMPL_E'),(782916,8777,30,230.017,NULL,0,'CGC_E'),(782917,8777,30,0.000,NULL,4,'EXTR_E'),(782918,8777,30,0.000,NULL,5,'NEXTR_E'),(782919,8777,30,6.335,NULL,1,'IT_E'),(782920,8777,30,6.823,NULL,1,'IMS_E'),(782921,8777,30,1.949,NULL,10,'FOGASA_E'),(782922,8777,30,5.848,NULL,3,'FP_E'),(782923,8777,30,53.606,NULL,2,'DESMPL_E'),(782924,8777,31,138.214,NULL,0,'CGC_E'),(782925,8777,31,0.000,NULL,4,'EXTR_E'),(782926,8777,31,0.000,NULL,5,'NEXTR_E'),(782927,8777,31,3.807,NULL,1,'IT_E'),(782928,8777,31,4.100,NULL,1,'IMS_E'),(782929,8777,31,1.171,NULL,10,'FOGASA_E'),(782930,8777,31,3.514,NULL,3,'FP_E'),(782931,8777,31,32.211,NULL,2,'DESMPL_E'),(782932,8777,32,180.398,NULL,0,'CGC_E'),(782933,8777,32,0.000,NULL,4,'EXTR_E'),(782934,8777,32,0.000,NULL,5,'NEXTR_E'),(782935,8777,32,4.969,NULL,1,'IT_E'),(782936,8777,32,5.351,NULL,1,'IMS_E'),(782937,8777,32,1.529,NULL,10,'FOGASA_E'),(782938,8777,32,4.586,NULL,3,'FP_E'),(782939,8777,32,42.042,NULL,2,'DESMPL_E'),(782940,8777,33,168.372,NULL,0,'CGC_E'),(782941,8777,33,0.000,NULL,4,'EXTR_E'),(782942,8777,33,0.000,NULL,5,'NEXTR_E'),(782943,8777,33,4.637,NULL,1,'IT_E'),(782944,8777,33,4.994,NULL,1,'IMS_E'),(782945,8777,33,1.427,NULL,10,'FOGASA_E'),(782946,8777,33,4.281,NULL,3,'FP_E'),(782947,8777,33,39.239,NULL,2,'DESMPL_E'),(782948,8777,34,50.381,NULL,0,'CGC_E'),(782949,8777,34,0.000,NULL,4,'EXTR_E'),(782950,8777,34,0.000,NULL,5,'NEXTR_E'),(782951,8777,34,1.388,NULL,1,'IT_E'),(782952,8777,34,1.494,NULL,1,'IMS_E'),(782953,8777,34,0.427,NULL,10,'FOGASA_E'),(782954,8777,34,1.281,NULL,3,'FP_E'),(782955,8777,34,11.741,NULL,2,'DESMPL_E'),(782956,8777,35,50.381,NULL,0,'CGC_E'),(782957,8777,35,0.000,NULL,4,'EXTR_E'),(782958,8777,35,0.000,NULL,5,'NEXTR_E'),(782959,8777,35,1.388,NULL,1,'IT_E'),(782960,8777,35,1.494,NULL,1,'IMS_E'),(782961,8777,35,0.427,NULL,10,'FOGASA_E'),(782962,8777,35,1.281,NULL,3,'FP_E'),(782963,8777,35,-106.740,NULL,8,'ATEP_E'),(782964,8777,35,11.741,NULL,2,'DESMPL_E'),(782965,8777,36,251.906,NULL,0,'CGC_E'),(782966,8777,36,0.000,NULL,4,'EXTR_E'),(782967,8777,36,0.000,NULL,5,'NEXTR_E'),(782968,8777,36,6.587,NULL,1,'IT_E'),(782969,8777,36,7.093,NULL,1,'IMS_E'),(782970,8777,36,2.027,NULL,10,'FOGASA_E'),(782971,8777,36,6.080,NULL,3,'FP_E'),(782972,8777,36,55.733,NULL,2,'DESMPL_E'),(782973,8777,37,0.000,NULL,0,'CGC_E'),(782974,8777,37,0.000,NULL,4,'EXTR_E'),(782975,8777,37,0.000,NULL,5,'NEXTR_E'),(782976,8777,37,0.000,NULL,1,'IT_E'),(782977,8777,37,0.000,NULL,1,'IMS_E'),(782978,8777,37,0.000,NULL,10,'FOGASA_E'),(782979,8777,37,0.000,NULL,3,'FP_E'),(782980,8777,37,0.000,NULL,2,'DESMPL_E'),(782981,8777,38,282.945,NULL,0,'CGC_E'),(782982,8777,38,0.000,NULL,4,'EXTR_E'),(782983,8777,38,0.000,NULL,5,'NEXTR_E'),(782984,8777,38,7.793,NULL,1,'IT_E'),(782985,8777,38,8.392,NULL,1,'IMS_E'),(782986,8777,38,2.398,NULL,10,'FOGASA_E'),(782987,8777,38,7.194,NULL,3,'FP_E'),(782988,8777,38,65.941,NULL,2,'DESMPL_E'),(782989,8777,39,282.945,NULL,0,'CGC_E'),(782990,8777,39,0.000,NULL,4,'EXTR_E'),(782991,8777,39,0.000,NULL,5,'NEXTR_E'),(782992,8777,39,7.793,NULL,1,'IT_E'),(782993,8777,39,8.392,NULL,1,'IMS_E'),(782994,8777,39,2.398,NULL,10,'FOGASA_E'),(782995,8777,39,7.194,NULL,3,'FP_E'),(782996,8777,39,65.941,NULL,2,'DESMPL_E'),(782997,8777,40,859.512,NULL,0,'CGC_E'),(782998,8777,40,0.000,NULL,4,'EXTR_E'),(782999,8777,40,0.000,NULL,5,'NEXTR_E'),(783000,8777,40,23.673,NULL,1,'IT_E'),(783001,8777,40,25.494,NULL,1,'IMS_E'),(783002,8777,40,7.284,NULL,10,'FOGASA_E'),(783003,8777,40,21.852,NULL,3,'FP_E'),(783004,8777,40,200.310,NULL,2,'DESMPL_E'),(783005,8777,41,251.906,NULL,0,'CGC_E'),(783006,8777,41,0.000,NULL,4,'EXTR_E'),(783007,8777,41,0.000,NULL,5,'NEXTR_E'),(783008,8777,41,4.969,NULL,1,'IT_E'),(783009,8777,41,5.351,NULL,1,'IMS_E'),(783010,8777,41,1.529,NULL,10,'FOGASA_E'),(783011,8777,41,4.586,NULL,3,'FP_E'),(783012,8777,41,42.042,NULL,2,'DESMPL_E'),(783013,8777,42,354.000,NULL,0,'CGC_E'),(783014,8777,42,0.000,NULL,4,'EXTR_E'),(783015,8777,42,0.000,NULL,5,'NEXTR_E'),(783016,8777,42,9.750,NULL,1,'IT_E'),(783017,8777,42,10.500,NULL,1,'IMS_E'),(783018,8777,42,3.000,NULL,10,'FOGASA_E'),(783019,8777,42,9.000,NULL,3,'FP_E'),(783020,8777,42,82.500,NULL,2,'DESMPL_E'),(783021,8777,43,621.823,NULL,0,'CGC_E'),(783022,8777,43,0.000,NULL,4,'EXTR_E'),(783023,8777,43,0.000,NULL,5,'NEXTR_E'),(783024,8777,43,17.126,NULL,1,'IT_E'),(783025,8777,43,18.444,NULL,1,'IMS_E'),(783026,8777,43,5.270,NULL,10,'FOGASA_E'),(783027,8777,43,15.809,NULL,3,'FP_E'),(783028,8777,43,144.916,NULL,2,'DESMPL_E'),(783029,8777,44,859.512,NULL,0,'CGC_E'),(783030,8777,44,0.000,NULL,4,'EXTR_E'),(783031,8777,44,0.000,NULL,5,'NEXTR_E'),(783032,8777,44,23.673,NULL,1,'IT_E'),(783033,8777,44,25.494,NULL,1,'IMS_E'),(783034,8777,44,7.284,NULL,10,'FOGASA_E'),(783035,8777,44,21.852,NULL,3,'FP_E'),(783036,8777,44,200.310,NULL,2,'DESMPL_E'),(783037,8777,45,0.000,NULL,0,'CGC_E'),(783038,8777,45,0.000,NULL,4,'EXTR_E'),(783039,8777,45,0.000,NULL,5,'NEXTR_E'),(783040,8777,45,0.000,NULL,1,'IT_E'),(783041,8777,45,0.000,NULL,1,'IMS_E'),(783042,8777,45,0.000,NULL,10,'FOGASA_E'),(783043,8777,45,0.000,NULL,3,'FP_E'),(783044,8777,45,0.000,NULL,2,'DESMPL_E'),(783045,8777,46,229.903,NULL,0,'CGC_E'),(783046,8777,46,0.000,NULL,4,'EXTR_E'),(783047,8777,46,0.000,NULL,5,'NEXTR_E'),(783048,8777,46,6.332,NULL,1,'IT_E'),(783049,8777,46,6.819,NULL,1,'IMS_E'),(783050,8777,46,1.948,NULL,10,'FOGASA_E'),(783051,8777,46,5.845,NULL,3,'FP_E'),(783052,8777,46,53.579,NULL,2,'DESMPL_E'),(783053,8777,47,0.000,NULL,0,'CGC_E'),(783054,8777,47,0.000,NULL,4,'EXTR_E'),(783055,8777,47,0.000,NULL,5,'NEXTR_E'),(783056,8777,47,0.000,NULL,1,'IT_E'),(783057,8777,47,0.000,NULL,1,'IMS_E'),(783058,8777,47,0.000,NULL,10,'FOGASA_E'),(783059,8777,47,0.000,NULL,3,'FP_E'),(783060,8777,47,0.000,NULL,2,'DESMPL_E'),(783061,8777,48,0.000,NULL,0,'CGC_E'),(783062,8777,48,0.000,NULL,4,'EXTR_E'),(783063,8777,48,0.000,NULL,5,'NEXTR_E'),(783064,8777,48,0.000,NULL,1,'IT_E'),(783065,8777,48,0.000,NULL,1,'IMS_E'),(783066,8777,48,0.000,NULL,10,'FOGASA_E'),(783067,8777,48,0.000,NULL,3,'FP_E'),(783068,8777,48,0.000,NULL,2,'DESMPL_E'),(783069,8777,49,0.000,NULL,0,'CGC_E'),(783070,8777,49,0.000,NULL,4,'EXTR_E'),(783071,8777,49,0.000,NULL,5,'NEXTR_E'),(783072,8777,49,0.000,NULL,1,'IT_E'),(783073,8777,49,0.000,NULL,1,'IMS_E'),(783074,8777,49,0.000,NULL,10,'FOGASA_E'),(783075,8777,49,0.000,NULL,3,'FP_E'),(783076,8777,49,0.000,NULL,2,'DESMPL_E'),(783077,8777,50,0.000,NULL,0,'CGC_E'),(783078,8777,50,0.000,NULL,4,'EXTR_E'),(783079,8777,50,0.000,NULL,5,'NEXTR_E'),(783080,8777,50,0.000,NULL,1,'IT_E'),(783081,8777,50,0.000,NULL,1,'IMS_E'),(783082,8777,50,0.000,NULL,10,'FOGASA_E'),(783083,8777,50,0.000,NULL,3,'FP_E'),(783084,8777,50,0.000,NULL,2,'DESMPL_E'),(783085,8777,51,0.000,NULL,0,'CGC_E'),(783086,8777,51,0.000,NULL,4,'EXTR_E'),(783087,8777,51,0.000,NULL,5,'NEXTR_E'),(783088,8777,51,0.000,NULL,1,'IT_E'),(783089,8777,51,0.000,NULL,1,'IMS_E'),(783090,8777,51,0.000,NULL,10,'FOGASA_E'),(783091,8777,51,0.000,NULL,3,'FP_E'),(783092,8777,51,0.000,NULL,2,'DESMPL_E'),(783101,8777,54,122.356,NULL,0,'CGC_E'),(783102,8777,54,0.000,NULL,4,'EXTR_E'),(783103,8777,54,0.000,NULL,5,'NEXTR_E'),(783104,8777,54,3.370,NULL,1,'IT_E'),(783105,8777,54,3.629,NULL,1,'IMS_E'),(783106,8777,54,1.037,NULL,10,'FOGASA_E'),(783107,8777,54,3.111,NULL,3,'FP_E'),(783108,8777,54,28.515,NULL,2,'DESMPL_E'),(783109,8777,55,230.017,NULL,0,'CGC_E'),(783110,8777,55,0.000,NULL,4,'EXTR_E'),(783111,8777,55,0.000,NULL,5,'NEXTR_E'),(783112,8777,55,6.335,NULL,1,'IT_E'),(783113,8777,55,6.823,NULL,1,'IMS_E'),(783114,8777,55,1.949,NULL,10,'FOGASA_E'),(783115,8777,55,5.848,NULL,3,'FP_E'),(783116,8777,55,53.606,NULL,2,'DESMPL_E'),(783117,8777,56,282.945,NULL,0,'CGC_E'),(783118,8777,56,0.000,NULL,4,'EXTR_E'),(783119,8777,56,0.000,NULL,5,'NEXTR_E'),(783120,8777,56,7.793,NULL,1,'IT_E'),(783121,8777,56,8.392,NULL,1,'IMS_E'),(783122,8777,56,2.398,NULL,10,'FOGASA_E'),(783123,8777,56,7.194,NULL,3,'FP_E'),(783124,8777,56,65.941,NULL,2,'DESMPL_E'),(783125,8777,57,283.535,NULL,0,'CGC_E'),(783126,8777,57,0.000,NULL,4,'EXTR_E'),(783127,8777,57,0.000,NULL,5,'NEXTR_E'),(783128,8777,57,7.809,NULL,1,'IT_E'),(783129,8777,57,8.410,NULL,1,'IMS_E'),(783130,8777,57,2.403,NULL,10,'FOGASA_E'),(783131,8777,57,7.209,NULL,3,'FP_E'),(783132,8777,57,66.078,NULL,2,'DESMPL_E'),(783133,8777,58,160.066,NULL,0,'CGC_E'),(783134,8777,58,0.000,NULL,4,'EXTR_E'),(783135,8777,58,0.000,NULL,5,'NEXTR_E'),(783136,8777,58,4.409,NULL,1,'IT_E'),(783137,8777,58,4.748,NULL,1,'IMS_E'),(783138,8777,58,1.356,NULL,10,'FOGASA_E'),(783139,8777,58,4.069,NULL,3,'FP_E'),(783140,8777,58,37.304,NULL,2,'DESMPL_E'),(783141,8777,59,214.231,NULL,0,'CGC_E'),(783142,8777,59,0.000,NULL,4,'EXTR_E'),(783143,8777,59,0.000,NULL,5,'NEXTR_E'),(783144,8777,59,5.900,NULL,1,'IT_E'),(783145,8777,59,6.354,NULL,1,'IMS_E'),(783146,8777,59,1.816,NULL,10,'FOGASA_E'),(783147,8777,59,5.447,NULL,3,'FP_E'),(783148,8777,59,49.927,NULL,2,'DESMPL_E'),(783149,8777,60,266.777,NULL,0,'CGC_E'),(783150,8777,60,0.000,NULL,4,'EXTR_E'),(783151,8777,60,0.000,NULL,5,'NEXTR_E'),(783152,8777,60,7.348,NULL,1,'IT_E'),(783153,8777,60,7.913,NULL,1,'IMS_E'),(783154,8777,60,2.261,NULL,10,'FOGASA_E'),(783155,8777,60,6.782,NULL,3,'FP_E'),(783156,8777,60,62.173,NULL,2,'DESMPL_E'),(783157,8777,61,0.000,NULL,0,'CGC_E'),(783158,8777,61,0.000,NULL,4,'EXTR_E'),(783159,8777,61,0.000,NULL,5,'NEXTR_E'),(783160,8777,61,0.000,NULL,1,'IT_E'),(783161,8777,61,0.000,NULL,1,'IMS_E'),(783162,8777,61,0.000,NULL,10,'FOGASA_E'),(783163,8777,61,0.000,NULL,3,'FP_E'),(783164,8777,61,0.000,NULL,2,'DESMPL_E'),(783165,8777,62,144.319,NULL,0,'CGC_E'),(783166,8777,62,0.000,NULL,4,'EXTR_E'),(783167,8777,62,0.000,NULL,5,'NEXTR_E'),(783168,8777,62,3.975,NULL,1,'IT_E'),(783169,8777,62,4.281,NULL,1,'IMS_E'),(783170,8777,62,1.223,NULL,10,'FOGASA_E'),(783171,8777,62,3.669,NULL,3,'FP_E'),(783172,8777,62,33.634,NULL,2,'DESMPL_E'),(783173,8777,63,0.000,NULL,0,'CGC_E'),(783174,8777,63,0.000,NULL,4,'EXTR_E'),(783175,8777,63,0.000,NULL,5,'NEXTR_E'),(783176,8777,63,0.000,NULL,1,'IT_E'),(783177,8777,63,0.000,NULL,1,'IMS_E'),(783178,8777,63,0.000,NULL,10,'FOGASA_E'),(783179,8777,63,0.000,NULL,3,'FP_E'),(783180,8777,63,0.000,NULL,2,'DESMPL_E'),(783181,8777,64,77.314,NULL,0,'CGC_E'),(783182,8777,64,0.000,NULL,4,'EXTR_E'),(783183,8777,64,0.000,NULL,5,'NEXTR_E'),(783184,8777,64,2.129,NULL,1,'IT_E'),(783185,8777,64,2.293,NULL,1,'IMS_E'),(783186,8777,64,0.655,NULL,10,'FOGASA_E'),(783187,8777,64,1.966,NULL,3,'FP_E'),(783188,8777,64,18.018,NULL,2,'DESMPL_E'),(783189,8777,65,45.284,NULL,0,'CGC_E'),(783190,8777,65,0.000,NULL,4,'EXTR_E'),(783191,8777,65,0.000,NULL,5,'NEXTR_E'),(783192,8777,65,1.076,NULL,1,'IT_E'),(783193,8777,65,1.159,NULL,1,'IMS_E'),(783194,8777,65,0.331,NULL,10,'FOGASA_E'),(783195,8777,65,0.994,NULL,3,'FP_E'),(783196,8777,65,9.108,NULL,2,'DESMPL_E'),(783221,8777,70,84.186,NULL,0,'CGC_E'),(783222,8777,70,0.000,NULL,4,'EXTR_E'),(783223,8777,70,0.000,NULL,5,'NEXTR_E'),(783224,8777,70,2.319,NULL,1,'IT_E'),(783225,8777,70,2.497,NULL,1,'IMS_E'),(783226,8777,70,0.713,NULL,10,'FOGASA_E'),(783227,8777,70,2.140,NULL,3,'FP_E'),(783228,8777,70,19.620,NULL,2,'DESMPL_E'),(783229,8777,71,84.186,NULL,0,'CGC_E'),(783230,8777,71,0.000,NULL,4,'EXTR_E'),(783231,8777,71,0.000,NULL,5,'NEXTR_E'),(783232,8777,71,2.319,NULL,1,'IT_E'),(783233,8777,71,2.497,NULL,1,'IMS_E'),(783234,8777,71,0.713,NULL,10,'FOGASA_E'),(783235,8777,71,2.140,NULL,3,'FP_E'),(783236,8777,71,19.620,NULL,2,'DESMPL_E'),(783237,8777,72,153.599,NULL,0,'CGC_E'),(783238,8777,72,0.000,NULL,4,'EXTR_E'),(783239,8777,72,0.000,NULL,5,'NEXTR_E'),(783240,8777,72,4.230,NULL,1,'IT_E'),(783241,8777,72,4.556,NULL,1,'IMS_E'),(783242,8777,72,1.302,NULL,10,'FOGASA_E'),(783243,8777,72,3.905,NULL,3,'FP_E'),(783244,8777,72,35.796,NULL,2,'DESMPL_E'),(783245,8784,73,444.550,NULL,0,'CGC_E'),(783246,8784,73,0.000,NULL,4,'EXTR_E'),(783247,8784,73,0.000,NULL,5,'NEXTR_E'),(783248,8784,73,14.128,NULL,1,'IT_E'),(783249,8784,73,9.418,NULL,1,'IMS_E'),(783250,8784,73,3.767,NULL,10,'FOGASA_E'),(783251,8784,73,11.302,NULL,3,'FP_E'),(783252,8784,73,126.207,NULL,2,'DESMPL_E'),(783253,8784,74,161.016,NULL,0,'CGC_E'),(783254,8784,74,0.000,NULL,4,'EXTR_E'),(783255,8784,74,0.000,NULL,5,'NEXTR_E'),(783256,8784,74,5.117,NULL,1,'IT_E'),(783257,8784,74,3.411,NULL,1,'IMS_E'),(783258,8784,74,1.365,NULL,10,'FOGASA_E'),(783259,8784,74,4.094,NULL,3,'FP_E'),(783260,8784,74,37.525,NULL,2,'DESMPL_E'),(783261,8777,75,454.415,NULL,0,'CGC_E'),(783262,8777,75,0.000,NULL,4,'EXTR_E'),(783263,8777,75,0.000,NULL,5,'NEXTR_E'),(783264,8777,75,12.516,NULL,1,'IT_E'),(783265,8777,75,13.478,NULL,1,'IMS_E'),(783266,8777,75,3.851,NULL,10,'FOGASA_E'),(783267,8777,75,11.553,NULL,3,'FP_E'),(783268,8777,75,105.902,NULL,2,'DESMPL_E'),(783277,8777,77,533.018,NULL,0,'CGC_E'),(783278,8777,77,0.000,NULL,4,'EXTR_E'),(783279,8777,77,0.000,NULL,5,'NEXTR_E'),(783280,8777,77,14.681,NULL,1,'IT_E'),(783281,8777,77,15.810,NULL,1,'IMS_E'),(783282,8777,77,4.517,NULL,10,'FOGASA_E'),(783283,8777,77,13.551,NULL,3,'FP_E'),(783284,8777,77,124.220,NULL,2,'DESMPL_E'),(783285,8777,78,554.339,NULL,0,'CGC_E'),(783286,8777,78,0.000,NULL,4,'EXTR_E'),(783287,8777,78,0.000,NULL,5,'NEXTR_E'),(783288,8777,78,15.268,NULL,1,'IT_E'),(783289,8777,78,16.442,NULL,1,'IMS_E'),(783290,8777,78,4.698,NULL,10,'FOGASA_E'),(783291,8777,78,14.093,NULL,3,'FP_E'),(783292,8777,78,129.189,NULL,2,'DESMPL_E'),(783293,8777,79,554.339,NULL,0,'CGC_E'),(783294,8777,79,0.000,NULL,4,'EXTR_E'),(783295,8777,79,0.000,NULL,5,'NEXTR_E'),(783296,8777,79,15.268,NULL,1,'IT_E'),(783297,8777,79,16.442,NULL,1,'IMS_E'),(783298,8777,79,4.698,NULL,10,'FOGASA_E'),(783299,8777,79,14.093,NULL,3,'FP_E'),(783300,8777,79,129.189,NULL,2,'DESMPL_E'),(783301,8777,80,554.339,NULL,0,'CGC_E'),(783302,8777,80,0.000,NULL,4,'EXTR_E'),(783303,8777,80,0.000,NULL,5,'NEXTR_E'),(783304,8777,80,15.268,NULL,1,'IT_E'),(783305,8777,80,16.442,NULL,1,'IMS_E'),(783306,8777,80,4.698,NULL,10,'FOGASA_E'),(783307,8777,80,14.093,NULL,3,'FP_E'),(783308,8777,80,129.189,NULL,2,'DESMPL_E'),(783309,8777,81,554.339,NULL,0,'CGC_E'),(783310,8777,81,0.000,NULL,4,'EXTR_E'),(783311,8777,81,0.000,NULL,5,'NEXTR_E'),(783312,8777,81,15.268,NULL,1,'IT_E'),(783313,8777,81,16.442,NULL,1,'IMS_E'),(783314,8777,81,4.698,NULL,10,'FOGASA_E'),(783315,8777,81,14.093,NULL,3,'FP_E'),(783316,8777,81,129.189,NULL,2,'DESMPL_E'),(783317,8777,82,554.339,NULL,0,'CGC_E'),(783318,8777,82,0.000,NULL,4,'EXTR_E'),(783319,8777,82,0.000,NULL,5,'NEXTR_E'),(783320,8777,82,15.268,NULL,1,'IT_E'),(783321,8777,82,16.442,NULL,1,'IMS_E'),(783322,8777,82,4.698,NULL,10,'FOGASA_E'),(783323,8777,82,14.093,NULL,3,'FP_E'),(783324,8777,82,129.189,NULL,2,'DESMPL_E'),(783325,8777,83,554.339,NULL,0,'CGC_E'),(783326,8777,83,0.000,NULL,4,'EXTR_E'),(783327,8777,83,0.000,NULL,5,'NEXTR_E'),(783328,8777,83,15.268,NULL,1,'IT_E'),(783329,8777,83,16.442,NULL,1,'IMS_E'),(783330,8777,83,4.698,NULL,10,'FOGASA_E'),(783331,8777,83,14.093,NULL,3,'FP_E'),(783332,8777,83,129.189,NULL,2,'DESMPL_E'),(783333,8777,84,554.339,NULL,0,'CGC_E'),(783334,8777,84,0.000,NULL,4,'EXTR_E'),(783335,8777,84,0.000,NULL,5,'NEXTR_E'),(783336,8777,84,15.268,NULL,1,'IT_E'),(783337,8777,84,16.442,NULL,1,'IMS_E'),(783338,8777,84,4.698,NULL,10,'FOGASA_E'),(783339,8777,84,14.093,NULL,3,'FP_E'),(783340,8777,84,129.189,NULL,2,'DESMPL_E'),(783341,8777,85,554.339,NULL,0,'CGC_E'),(783342,8777,85,0.000,NULL,4,'EXTR_E'),(783343,8777,85,0.000,NULL,5,'NEXTR_E'),(783344,8777,85,15.268,NULL,1,'IT_E'),(783345,8777,85,16.442,NULL,1,'IMS_E'),(783346,8777,85,4.698,NULL,10,'FOGASA_E'),(783347,8777,85,14.093,NULL,3,'FP_E'),(783348,8777,85,129.189,NULL,2,'DESMPL_E'),(783349,8777,86,554.339,NULL,0,'CGC_E'),(783350,8777,86,0.000,NULL,4,'EXTR_E'),(783351,8777,86,0.000,NULL,5,'NEXTR_E'),(783352,8777,86,15.268,NULL,1,'IT_E'),(783353,8777,86,16.442,NULL,1,'IMS_E'),(783354,8777,86,4.698,NULL,10,'FOGASA_E'),(783355,8777,86,14.093,NULL,3,'FP_E'),(783356,8777,86,129.189,NULL,2,'DESMPL_E'),(783357,8777,87,554.339,NULL,0,'CGC_E'),(783358,8777,87,0.000,NULL,4,'EXTR_E'),(783359,8777,87,0.000,NULL,5,'NEXTR_E'),(783360,8777,87,15.268,NULL,1,'IT_E'),(783361,8777,87,16.442,NULL,1,'IMS_E'),(783362,8777,87,4.698,NULL,10,'FOGASA_E'),(783363,8777,87,14.093,NULL,3,'FP_E'),(783364,8777,87,129.189,NULL,2,'DESMPL_E'),(783365,8777,88,533.018,NULL,0,'CGC_E'),(783366,8777,88,0.000,NULL,4,'EXTR_E'),(783367,8777,88,0.000,NULL,5,'NEXTR_E'),(783368,8777,88,14.681,NULL,1,'IT_E'),(783369,8777,88,15.810,NULL,1,'IMS_E'),(783370,8777,88,4.517,NULL,10,'FOGASA_E'),(783371,8777,88,13.551,NULL,3,'FP_E'),(783372,8777,88,124.220,NULL,2,'DESMPL_E'),(783373,8777,89,220.313,NULL,0,'CGC_E'),(783374,8777,89,0.000,NULL,4,'EXTR_E'),(783375,8777,89,0.000,NULL,5,'NEXTR_E'),(783376,8777,89,6.068,NULL,1,'IT_E'),(783377,8777,89,6.535,NULL,1,'IMS_E'),(783378,8777,89,1.867,NULL,10,'FOGASA_E'),(783379,8777,89,5.601,NULL,3,'FP_E'),(783380,8777,89,51.344,NULL,2,'DESMPL_E'),(783381,8783,93,360.797,NULL,0,'CGC_E'),(783382,8783,93,0.000,NULL,4,'EXTR_E'),(783383,8783,93,0.000,NULL,5,'NEXTR_E'),(783384,8783,93,15.288,NULL,1,'IT_E'),(783385,8783,93,16.052,NULL,1,'IMS_E'),(783386,8783,93,3.058,NULL,10,'FOGASA_E'),(783387,8783,93,9.173,NULL,3,'FP_E'),(783388,8783,93,84.084,NULL,2,'DESMPL_E'),(783389,8783,94,180.398,NULL,0,'CGC_E'),(783390,8783,94,0.000,NULL,4,'EXTR_E'),(783391,8783,94,0.000,NULL,5,'NEXTR_E'),(783392,8783,94,7.644,NULL,1,'IT_E'),(783393,8783,94,8.026,NULL,1,'IMS_E'),(783394,8783,94,1.529,NULL,10,'FOGASA_E'),(783395,8783,94,4.586,NULL,3,'FP_E'),(783396,8783,94,42.042,NULL,2,'DESMPL_E'),(783397,8783,97,360.797,NULL,0,'CGC_E'),(783398,8783,97,0.000,NULL,4,'EXTR_E'),(783399,8783,97,0.000,NULL,5,'NEXTR_E'),(783400,8783,97,15.288,NULL,1,'IT_E'),(783401,8783,97,16.052,NULL,1,'IMS_E'),(783402,8783,97,3.058,NULL,10,'FOGASA_E'),(783403,8783,97,9.173,NULL,3,'FP_E'),(783404,8783,97,84.084,NULL,2,'DESMPL_E'),(783414,8777,98,251.906,NULL,0,'CGC_E'),(783415,8777,98,0.000,NULL,4,'EXTR_E'),(783416,8777,98,0.000,NULL,5,'NEXTR_E'),(783417,8777,98,5.822,NULL,1,'IT_E'),(783418,8777,98,6.270,NULL,1,'IMS_E'),(783419,8777,98,1.791,NULL,10,'FOGASA_E'),(783420,8777,98,5.374,NULL,3,'FP_E'),(783421,8777,98,49.264,NULL,2,'DESMPL_E'),(783438,8777,99,186.412,NULL,0,'CGC_E'),(783439,8777,99,0.000,NULL,4,'EXTR_E'),(783440,8777,99,0.000,NULL,5,'NEXTR_E'),(783441,8777,99,5.134,NULL,1,'IT_E'),(783442,8777,99,5.529,NULL,1,'IMS_E'),(783443,8777,99,1.580,NULL,10,'FOGASA_E'),(783444,8777,99,4.739,NULL,3,'FP_E'),(783445,8777,99,43.443,NULL,2,'DESMPL_E'),(783454,8777,100,253.166,NULL,0,'CGC_E'),(783455,8777,100,0.000,NULL,4,'EXTR_E'),(783456,8777,100,0.000,NULL,5,'NEXTR_E'),(783457,8777,100,6.973,NULL,1,'IT_E'),(783458,8777,100,7.509,NULL,1,'IMS_E'),(783459,8777,100,2.145,NULL,10,'FOGASA_E'),(783460,8777,100,6.436,NULL,3,'FP_E'),(783461,8777,100,71.873,NULL,2,'DESMPL_E'),(783462,8777,101,124.334,NULL,0,'CGC_E'),(783463,8777,101,0.000,NULL,4,'EXTR_E'),(783464,8777,101,0.000,NULL,5,'NEXTR_E'),(783465,8777,101,3.424,NULL,1,'IT_E'),(783466,8777,101,3.688,NULL,1,'IMS_E'),(783467,8777,101,1.054,NULL,10,'FOGASA_E'),(783468,8777,101,3.161,NULL,3,'FP_E'),(783469,8777,101,35.298,NULL,2,'DESMPL_E'),(783470,8777,102,271.981,NULL,0,'CGC_E'),(783471,8777,102,0.000,NULL,4,'EXTR_E'),(783472,8777,102,0.000,NULL,5,'NEXTR_E'),(783473,8777,102,7.491,NULL,1,'IT_E'),(783474,8777,102,8.067,NULL,1,'IMS_E'),(783475,8777,102,2.305,NULL,10,'FOGASA_E'),(783476,8777,102,6.915,NULL,3,'FP_E'),(783477,8777,102,77.215,NULL,2,'DESMPL_E'),(783478,8777,103,271.981,NULL,0,'CGC_E'),(783479,8777,103,0.000,NULL,4,'EXTR_E'),(783480,8777,103,0.000,NULL,5,'NEXTR_E'),(783481,8777,103,7.491,NULL,1,'IT_E'),(783482,8777,103,8.067,NULL,1,'IMS_E'),(783483,8777,103,2.305,NULL,10,'FOGASA_E'),(783484,8777,103,6.915,NULL,3,'FP_E'),(783485,8777,103,77.215,NULL,2,'DESMPL_E'),(783486,8777,104,271.981,NULL,0,'CGC_E'),(783487,8777,104,0.000,NULL,4,'EXTR_E'),(783488,8777,104,0.000,NULL,5,'NEXTR_E'),(783489,8777,104,7.491,NULL,1,'IT_E'),(783490,8777,104,8.067,NULL,1,'IMS_E'),(783491,8777,104,2.305,NULL,10,'FOGASA_E'),(783492,8777,104,6.915,NULL,3,'FP_E'),(783493,8777,104,77.215,NULL,2,'DESMPL_E'),(783494,8777,105,271.981,NULL,0,'CGC_E'),(783495,8777,105,0.000,NULL,4,'EXTR_E'),(783496,8777,105,0.000,NULL,5,'NEXTR_E'),(783497,8777,105,7.491,NULL,1,'IT_E'),(783498,8777,105,8.067,NULL,1,'IMS_E'),(783499,8777,105,2.305,NULL,10,'FOGASA_E'),(783500,8777,105,6.915,NULL,3,'FP_E'),(783501,8777,105,77.215,NULL,2,'DESMPL_E'),(783502,8777,106,271.981,NULL,0,'CGC_E'),(783503,8777,106,0.000,NULL,4,'EXTR_E'),(783504,8777,106,0.000,NULL,5,'NEXTR_E'),(783505,8777,106,7.491,NULL,1,'IT_E'),(783506,8777,106,8.067,NULL,1,'IMS_E'),(783507,8777,106,2.305,NULL,10,'FOGASA_E'),(783508,8777,106,6.915,NULL,3,'FP_E'),(783509,8777,106,77.215,NULL,2,'DESMPL_E'),(783510,8777,107,190.288,NULL,0,'CGC_E'),(783511,8777,107,4.000,NULL,4,'EXTR_E'),(783512,8777,107,8.000,NULL,4,'EXTR_E'),(783513,8777,107,5.891,NULL,1,'IT_E'),(783514,8777,107,6.344,NULL,1,'IMS_E'),(783515,8777,107,1.813,NULL,10,'FOGASA_E'),(783516,8777,107,5.438,NULL,3,'FP_E'),(783517,8777,107,49.847,NULL,2,'DESMPL_E'),(783518,8777,108,251.909,NULL,0,'CGC_E'),(783519,8777,108,6.938,NULL,1,'IT_E'),(783520,8777,108,7.472,NULL,1,'IMS_E'),(783521,8777,108,2.135,NULL,10,'FOGASA_E'),(783522,8777,108,6.404,NULL,3,'FP_E'),(783523,8777,108,58.708,NULL,2,'DESMPL_E'),(783590,8788,119,811.793,NULL,0,'CGC_E'),(783591,8788,119,58.477,NULL,1,'IT_E'),(783592,8788,119,41.278,NULL,1,'IMS_E'),(783593,8788,119,6.880,NULL,10,'FOGASA_E'),(783594,8788,119,20.639,NULL,3,'FP_E'),(783595,8788,119,189.189,NULL,2,'DESMPL_E'),(783596,8788,120,123.702,NULL,0,'CGC_E'),(783597,8788,120,8.911,NULL,1,'IT_E'),(783598,8788,120,6.290,NULL,1,'IMS_E'),(783599,8788,120,1.048,NULL,10,'FOGASA_E'),(783600,8788,120,3.145,NULL,3,'FP_E'),(783601,8788,120,35.119,NULL,2,'DESMPL_E'),(783602,8788,121,77.314,NULL,0,'CGC_E'),(783603,8788,121,5.569,NULL,1,'IT_E'),(783604,8788,121,3.931,NULL,1,'IMS_E'),(783605,8788,121,0.655,NULL,10,'FOGASA_E'),(783606,8788,121,1.966,NULL,3,'FP_E'),(783607,8788,121,27.833,NULL,0,'CGC_E_TEMP'),(783608,8788,121,21.949,NULL,2,'DESMPL_E'),(783609,8788,122,77.314,NULL,0,'CGC_E'),(783610,8788,122,5.569,NULL,1,'IT_E'),(783611,8788,122,3.931,NULL,1,'IMS_E'),(783612,8788,122,0.655,NULL,10,'FOGASA_E'),(783613,8788,122,1.966,NULL,3,'FP_E'),(783614,8788,122,27.833,NULL,0,'CGC_E_TEMP'),(783615,8788,122,21.949,NULL,2,'DESMPL_E'),(783616,8788,123,92.776,NULL,0,'CGC_E'),(783617,8788,123,6.683,NULL,1,'IT_E'),(783618,8788,123,4.717,NULL,1,'IMS_E'),(783619,8788,123,0.786,NULL,10,'FOGASA_E'),(783620,8788,123,2.359,NULL,3,'FP_E'),(783621,8788,123,33.399,NULL,0,'CGC_E_TEMP'),(783622,8788,123,26.339,NULL,2,'DESMPL_E'),(783630,8788,125,463.882,NULL,0,'CGC_E'),(783631,8788,125,33.415,NULL,1,'IT_E'),(783632,8788,125,23.587,NULL,1,'IMS_E'),(783633,8788,125,3.931,NULL,10,'FOGASA_E'),(783634,8788,125,11.794,NULL,3,'FP_E'),(783635,8788,125,108.108,NULL,2,'DESMPL_E'),(783636,8788,126,123.702,NULL,0,'CGC_E'),(783637,8788,126,8.911,NULL,1,'IT_E'),(783638,8788,126,6.290,NULL,1,'IMS_E'),(783639,8788,126,1.048,NULL,10,'FOGASA_E'),(783640,8788,126,3.145,NULL,3,'FP_E'),(783641,8788,126,35.119,NULL,2,'DESMPL_E'),(783642,8788,127,77.314,NULL,0,'CGC_E'),(783643,8788,127,5.569,NULL,1,'IT_E'),(783644,8788,127,3.931,NULL,1,'IMS_E'),(783645,8788,127,0.655,NULL,10,'FOGASA_E'),(783646,8788,127,1.966,NULL,3,'FP_E'),(783647,8788,127,27.833,NULL,0,'CGC_E_TEMP'),(783648,8788,127,21.949,NULL,2,'DESMPL_E'),(783649,8788,128,77.314,NULL,0,'CGC_E'),(783650,8788,128,5.569,NULL,1,'IT_E'),(783651,8788,128,3.931,NULL,1,'IMS_E'),(783652,8788,128,0.655,NULL,10,'FOGASA_E'),(783653,8788,128,1.966,NULL,3,'FP_E'),(783654,8788,128,27.833,NULL,0,'CGC_E_TEMP'),(783655,8788,128,21.949,NULL,2,'DESMPL_E'),(783656,8788,129,77.314,NULL,0,'CGC_E'),(783657,8788,129,5.569,NULL,1,'IT_E'),(783658,8788,129,3.931,NULL,1,'IMS_E'),(783659,8788,129,0.655,NULL,10,'FOGASA_E'),(783660,8788,129,1.966,NULL,3,'FP_E'),(783661,8788,129,27.833,NULL,0,'CGC_E_TEMP'),(783662,8788,129,21.949,NULL,2,'DESMPL_E'),(783683,8788,133,463.882,NULL,0,'CGC_E'),(783684,8788,133,33.415,NULL,1,'IT_E'),(783685,8788,133,23.587,NULL,1,'IMS_E'),(783686,8788,133,3.931,NULL,10,'FOGASA_E'),(783687,8788,133,11.794,NULL,3,'FP_E'),(783688,8788,133,108.108,NULL,2,'DESMPL_E'),(783689,8788,133,-1474.200,NULL,8,'ECSS_E'),(783690,8788,134,463.882,NULL,0,'CGC_E'),(783691,8788,134,33.415,NULL,1,'IT_E'),(783692,8788,134,23.587,NULL,1,'IMS_E'),(783693,8788,134,3.931,NULL,10,'FOGASA_E'),(783694,8788,134,11.794,NULL,3,'FP_E'),(783695,8788,134,-1474.200,NULL,8,'ATEP_E'),(783696,8788,134,108.108,NULL,2,'DESMPL_E'),(783697,8788,135,463.882,NULL,0,'CGC_E'),(783698,8788,135,33.415,NULL,1,'IT_E'),(783699,8788,135,23.587,NULL,1,'IMS_E'),(783700,8788,135,3.931,NULL,10,'FOGASA_E'),(783701,8788,135,11.794,NULL,3,'FP_E'),(783702,8788,135,108.108,NULL,2,'DESMPL_E');
/*!40000 ALTER TABLE `salary_cost` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salary_data`
--

DROP TABLE IF EXISTS `salary_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `salary_data` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre',
  `expression` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Importe',
  `start_date` date NOT NULL COMMENT 'Fecha de inicio ',
  `end_date` date DEFAULT NULL COMMENT 'Fecha de finalizacion',
  `salary` int(4) NOT NULL COMMENT 'Recibo del pago de salarios',
  PRIMARY KEY (`id`),
  KEY `IDX_SALARY_DATA_DOMAIN` (`domain`),
  KEY `IDX_SALARY_DATA_SALARY` (`salary`),
  CONSTRAINT `FK_SALARY_DATA_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_SALARY_DATA_SALARY` FOREIGN KEY (`salary`) REFERENCES `salary` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=989408 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Datos de la nomina';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salary_data`
--

LOCK TABLES `salary_data` WRITE;
/*!40000 ALTER TABLE `salary_data` DISABLE KEYS */;
INSERT INTO `salary_data` VALUES (985229,8777,'SALARIO_VARIABLE_DIA','0.0','2016-02-09','2016-04-05',15),(985230,8777,'DIAS_VACACIONES_NO_DISFRUTADOS','3.0','2016-03-29','2016-03-31',15),(985231,8777,'SALARIO_DIA','35.45099496785016','2016-02-09','2016-04-05',15),(985232,8777,'DIAS_VACACIONES_NO_DISFRUTADOS','4.5','2016-04-01','2016-04-05',15),(985233,8777,'BASE_CGC','106.35298490355046','2016-03-29','2016-03-31',15),(985234,8777,'PORCENTAJE_CGC','4.7','2016-02-09','2016-04-05',15),(985235,8777,'BASE_CGC','159.5294773553257','2016-04-01','2016-04-05',15),(985236,8777,'PORCENTAJE_FP','0.1','2016-02-09','2016-04-05',15),(985237,8777,'BASE_CGP','106.35298490355046','2016-03-29','2016-03-31',15),(985238,8777,'BASE_CGP','159.5294773553257','2016-04-01','2016-04-05',15),(985239,8777,'BASE_CGC_E','265.88246225887616','2016-02-09','2016-04-05',15),(985240,8777,'PORCENTAJE_CGC_E','23.6','2016-02-09','2016-04-05',15),(985241,8777,'PORCENTAJE_EXTR_E','12.0','2016-02-09','2016-04-05',15),(985242,8777,'PORCENTAJE_NEXTR_E','23.6','2016-02-09','2016-04-05',15),(985243,8777,'BASE_CGP_E','265.88246225887616','2016-02-09','2016-04-05',15),(985244,8777,'TARIFA_IT','0.65','2016-02-09','2016-04-05',15),(985245,8777,'TARIFA_IMS','0.7','2016-02-09','2016-04-05',15),(985246,8777,'PORCENTAJE_FOGASA','0.2','2016-02-09','2016-04-05',15),(985247,8777,'PORCENTAJE_FP_E','0.6','2016-02-09','2016-04-05',15),(985248,8777,'TC2','100','2016-02-09','2016-03-28',15),(985249,8777,'INDEFINIDO','true','2016-02-09','2016-04-05',15),(985250,8777,'DIAS_COTIZADOS','21.0','2016-02-09','2016-02-29',15),(985251,8777,'DIAS_COTIZADOS','28.0','2016-03-01','2016-03-28',15),(985252,8777,'HORAS_TRABAJADAS','0.0','2016-02-09','2016-02-29',15),(985253,8777,'HORAS_TRABAJADAS','0.0','2016-03-01','2016-03-28',15),(985325,8777,'BASE_CGC_E','0.0','2016-04-19','2016-04-30',18),(985326,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',18),(985327,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',18),(985328,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',18),(985329,8777,'BASE_CGP_E','0.0','2016-04-19','2016-04-30',18),(985330,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',18),(985331,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',18),(985332,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',18),(985333,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',18),(985334,8777,'TC2','401','2016-04-19','2016-04-30',18),(985335,8777,'INDEFINIDO','false','2016-04-01','2016-04-30',18),(985336,8777,'HORAS_TRABAJADAS','0.0','2016-04-19','2016-04-30',18),(985337,8777,'BASE_CGC_E','0.0','2016-04-15','2016-04-30',19),(985338,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',19),(985339,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',19),(985340,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',19),(985341,8777,'BASE_CGP_E','0.0','2016-04-15','2016-04-30',19),(985342,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',19),(985343,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',19),(985344,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',19),(985345,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',19),(985346,8777,'TC2','100','2016-04-15','2016-04-30',19),(985347,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',19),(985348,8777,'DIAS_COTIZADOS','16.0','2016-04-15','2016-04-30',19),(985349,8777,'HORAS_TRABAJADAS','0.0','2016-04-15','2016-04-30',19),(985350,8777,'BASE_CGC_MIN','472.15999999999997','2016-04-15','2016-04-30',20),(985351,8777,'TC2','100','2016-04-15','2016-04-30',20),(985352,8777,'DIAS_COTIZADOS','16.0','2016-04-15','2016-04-30',20),(985353,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',20),(985354,8777,'TIEMPO_COMPLETO','true','2016-04-01','2016-04-30',20),(985355,8777,'GRUPO_COTIZACION','02','2016-04-15','2016-04-30',20),(985356,8777,'DIAS_MES','30.0','2016-04-15','2016-04-30',20),(985357,8777,'BASE_CGP_MIN','407.68','2016-04-15','2016-04-30',20),(985358,8777,'PLUS_EXTRA_SALARIAL','0.0','2016-04-01','2016-04-30',20),(985359,8777,'DIAS_NOMINA','16.0','2016-04-15','2016-04-30',20),(985360,8777,'BASE_CGC_MAX','1942.3999999999999','2016-04-15','2016-04-30',20),(985361,8777,'BASE_CGP_MAX','1942.3999999999999','2016-04-15','2016-04-30',20),(985362,8777,'COEFICIENTE_ERE','0.0','2016-04-15','2016-04-30',20),(985363,8777,'SALARIO_ANUAL','14387.05','2016-04-01','2016-04-30',20),(985364,8777,'DIAS_HUELGA','0.0','2016-04-15','2016-04-30',20),(985365,8777,'DIAS_TRABAJADOS','16.0','2016-04-15','2016-04-30',20),(985366,8777,'PAGAS','14','2016-04-01','2016-04-30',20),(985367,8777,'SALARIO_BASE','548.0780952380952','2016-04-15','2016-04-30',20),(985368,8777,'DIAS_PAGA','30.0','2016-04-15','2016-04-30',20),(985369,8777,'ANTIGUEDAD','0.0','2016-04-15','2016-04-30',20),(985370,8777,'BASE_CGC','719.3525','2016-04-15','2016-04-30',20),(985371,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',20),(985372,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',20),(985373,8777,'BASE_CGP','719.3525','2016-04-15','2016-04-30',20),(985374,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',20),(985375,8777,'BASE_CGC_E','719.3525','2016-04-15','2016-04-30',20),(985376,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',20),(985377,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',20),(985378,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',20),(985379,8777,'BASE_CGP_E','719.3525','2016-04-15','2016-04-30',20),(985380,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',20),(985381,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',20),(985382,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',20),(985383,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',20),(985384,8777,'HORAS_TRABAJADAS','0.0','2016-04-15','2016-04-30',20),(985385,8777,'BASE_CGC_E','0.0','2016-04-14','2016-04-30',21),(985386,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',21),(985387,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',21),(985388,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',21),(985389,8777,'BASE_CGP_E','0.0','2016-04-14','2016-04-30',21),(985390,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',21),(985391,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',21),(985392,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',21),(985393,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',21),(985394,8777,'TC2','100','2016-04-14','2016-04-30',21),(985395,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',21),(985396,8777,'DIAS_COTIZADOS','17.0','2016-04-14','2016-04-30',21),(985397,8777,'HORAS_TRABAJADAS','0.0','2016-04-14','2016-04-30',21),(985398,8777,'BASE_CGC_E','0.0','2016-04-14','2016-04-30',22),(985399,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',22),(985400,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',22),(985401,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',22),(985402,8777,'BASE_CGP_E','0.0','2016-04-14','2016-04-30',22),(985403,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',22),(985404,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',22),(985405,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',22),(985406,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',22),(985407,8777,'TC2','100','2016-04-14','2016-04-30',22),(985408,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',22),(985409,8777,'DIAS_COTIZADOS','17.0','2016-04-14','2016-04-30',22),(985410,8777,'HORAS_TRABAJADAS','0.0','2016-04-14','2016-04-30',22),(985411,8777,'BASE_CGC_MIN','770.1','2016-04-01','2016-04-30',23),(985412,8777,'TC2','100','2016-04-01','2016-04-30',23),(985413,8777,'DIAS_COTIZADOS','30.0','2016-04-01','2016-04-30',23),(985414,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',23),(985415,8777,'TIEMPO_COMPLETO','true','2016-04-01','2016-04-30',23),(985416,8777,'GRUPO_COTIZACION','03','2016-04-01','2016-04-30',23),(985417,8777,'DIAS_MES','30.0','2016-04-01','2016-04-30',23),(985418,8777,'BASE_CGP_MIN','764.4','2016-04-01','2016-04-30',23),(985419,8777,'PLUS_EXTRA_SALARIAL','0.0','2016-04-01','2016-04-30',23),(985420,8777,'DIAS_NOMINA','30.0','2016-04-01','2016-04-30',23),(985421,8777,'BASE_CGC_MAX','3642.0','2016-04-01','2016-04-30',23),(985422,8777,'BASE_CGP_MAX','3642.0','2016-04-01','2016-04-30',23),(985423,8777,'COEFICIENTE_ERE','0.0','2016-04-01','2016-04-30',23),(985424,8777,'SALARIO_ANUAL','15454.46','2016-04-01','2016-04-30',23),(985425,8777,'DIAS_HUELGA','0.0','2016-04-01','2016-04-30',23),(985426,8777,'DIAS_TRABAJADOS','30.0','2016-04-01','2016-04-30',23),(985427,8777,'PAGAS','14','2016-04-01','2016-04-30',23),(985428,8777,'SALARIO_BASE','1103.8899999999999','2016-04-01','2016-04-30',23),(985429,8777,'DIAS_PAGA','30.0','2016-04-01','2016-04-30',23),(985430,8777,'ANTIGUEDAD','44.15559999999999','2016-04-01','2016-04-30',23),(985431,8777,'BASE_CGC','1339.3865333333333','2016-04-01','2016-04-30',23),(985432,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',23),(985433,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',23),(985434,8777,'BASE_CGP','1339.3865333333333','2016-04-01','2016-04-30',23),(985435,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',23),(985436,8777,'BASE_CGC_E','1339.3865333333333','2016-04-01','2016-04-30',23),(985437,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',23),(985438,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',23),(985439,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',23),(985440,8777,'BASE_CGP_E','1339.3865333333333','2016-04-01','2016-04-30',23),(985441,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',23),(985442,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',23),(985443,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',23),(985444,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',23),(985445,8777,'HORAS_TRABAJADAS','0.0','2016-04-01','2016-04-30',23),(985446,8777,'BASE_CGC_MIN','770.1','2016-04-01','2016-04-30',24),(985447,8777,'TC2','100','2016-04-01','2016-04-30',24),(985448,8777,'DIAS_COTIZADOS','30.0','2016-04-01','2016-04-30',24),(985449,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',24),(985450,8777,'TIEMPO_COMPLETO','true','2016-04-01','2016-04-30',24),(985451,8777,'GRUPO_COTIZACION','03','2016-04-01','2016-04-30',24),(985452,8777,'DIAS_MES','30.0','2016-04-01','2016-04-30',24),(985453,8777,'BASE_CGP_MIN','764.4','2016-04-01','2016-04-30',24),(985454,8777,'PLUS_EXTRA_SALARIAL','0.0','2016-04-01','2016-04-30',24),(985455,8777,'DIAS_NOMINA','30.0','2016-04-01','2016-04-30',24),(985456,8777,'BASE_CGC_MAX','3642.0','2016-04-01','2016-04-30',24),(985457,8777,'BASE_CGP_MAX','3642.0','2016-04-01','2016-04-30',24),(985458,8777,'COEFICIENTE_ERE','0.0','2016-04-01','2016-04-30',24),(985459,8777,'SALARIO_ANUAL','15454.46','2016-04-01','2016-04-30',24),(985460,8777,'DIAS_HUELGA','0.0','2016-04-01','2016-04-30',24),(985461,8777,'DIAS_TRABAJADOS','30.0','2016-04-01','2016-04-30',24),(985462,8777,'PAGAS','14','2016-04-01','2016-04-30',24),(985463,8777,'SALARIO_BASE','1103.8899999999999','2016-04-01','2016-04-30',24),(985464,8777,'DIAS_PAGA','30.0','2016-04-01','2016-04-30',24),(985465,8777,'ANTIGUEDAD','220.77799999999996','2016-04-01','2016-04-30',24),(985466,8777,'BASE_CGC','1589.6015999999997','2016-04-01','2016-04-30',24),(985467,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',24),(985468,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',24),(985469,8777,'BASE_CGP','1589.6015999999997','2016-04-01','2016-04-30',24),(985470,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',24),(985471,8777,'BASE_CGC_E','1589.6015999999997','2016-04-01','2016-04-30',24),(985472,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',24),(985473,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',24),(985474,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',24),(985475,8777,'BASE_CGP_E','1589.6015999999997','2016-04-01','2016-04-30',24),(985476,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',24),(985477,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',24),(985478,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',24),(985479,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',24),(985480,8777,'HORAS_TRABAJADAS','0.0','2016-04-01','2016-04-30',24),(985481,8777,'BASE_CGC_MIN','770.1','2016-04-01','2016-04-30',25),(985482,8777,'TC2','100','2016-04-01','2016-04-30',25),(985483,8777,'DIAS_COTIZADOS','30.0','2016-04-01','2016-04-30',25),(985484,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',25),(985485,8777,'TIEMPO_COMPLETO','true','2016-04-01','2016-04-30',25),(985486,8777,'GRUPO_COTIZACION','03','2016-04-01','2016-04-30',25),(985487,8777,'DIAS_MES','30.0','2016-04-01','2016-04-30',25),(985488,8777,'BASE_CGP_MIN','764.4','2016-04-01','2016-04-30',25),(985489,8777,'PLUS_EXTRA_SALARIAL','0.0','2016-04-01','2016-04-30',25),(985490,8777,'DIAS_NOMINA','30.0','2016-04-01','2016-04-30',25),(985491,8777,'BASE_CGC_MAX','3642.0','2016-04-01','2016-04-30',25),(985492,8777,'BASE_CGP_MAX','3642.0','2016-04-01','2016-04-30',25),(985493,8777,'COEFICIENTE_ERE','0.0','2016-04-01','2016-04-30',25),(985494,8777,'SALARIO_ANUAL','15454.46','2016-04-01','2016-04-30',25),(985495,8777,'DIAS_HUELGA','0.0','2016-04-01','2016-04-30',25),(985496,8777,'DIAS_TRABAJADOS','30.0','2016-04-01','2016-04-30',25),(985497,8777,'PAGAS','14','2016-04-01','2016-04-30',25),(985498,8777,'SALARIO_BASE','1103.8899999999999','2016-04-01','2016-04-30',25),(985499,8777,'DIAS_PAGA','30.0','2016-04-01','2016-04-30',25),(985500,8777,'ANTIGUEDAD','220.77799999999996','2016-04-01','2016-04-30',25),(985501,8777,'BASE_CGC','1644.7960999999998','2016-04-01','2016-04-30',25),(985502,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',25),(985503,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',25),(985504,8777,'BASE_CGP','1644.7960999999998','2016-04-01','2016-04-30',25),(985505,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',25),(985506,8777,'BASE_CGC_E','1644.7960999999998','2016-04-01','2016-04-30',25),(985507,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',25),(985508,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',25),(985509,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',25),(985510,8777,'BASE_CGP_E','1644.7960999999998','2016-04-01','2016-04-30',25),(985511,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',25),(985512,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',25),(985513,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',25),(985514,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',25),(985515,8777,'HORAS_TRABAJADAS','0.0','2016-04-01','2016-04-30',25),(985516,8777,'BASE_CGC_MIN','770.1','2016-04-01','2016-04-30',26),(985517,8777,'TC2','100','2016-04-01','2016-04-30',26),(985518,8777,'DIAS_COTIZADOS','30.0','2016-04-01','2016-04-30',26),(985519,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',26),(985520,8777,'TIEMPO_COMPLETO','true','2016-04-01','2016-04-30',26),(985521,8777,'GRUPO_COTIZACION','03','2016-04-01','2016-04-30',26),(985522,8777,'DIAS_MES','30.0','2016-04-01','2016-04-30',26),(985523,8777,'BASE_CGP_MIN','764.4','2016-04-01','2016-04-30',26),(985524,8777,'PLUS_EXTRA_SALARIAL','0.0','2016-04-01','2016-04-30',26),(985525,8777,'DIAS_NOMINA','30.0','2016-04-01','2016-04-30',26),(985526,8777,'BASE_CGC_MAX','3642.0','2016-04-01','2016-04-30',26),(985527,8777,'BASE_CGP_MAX','3642.0','2016-04-01','2016-04-30',26),(985528,8777,'COEFICIENTE_ERE','0.0','2016-04-01','2016-04-30',26),(985529,8777,'SALARIO_ANUAL','15454.46','2016-04-01','2016-04-30',26),(985530,8777,'DIAS_HUELGA','0.0','2016-04-01','2016-04-30',26),(985531,8777,'DIAS_TRABAJADOS','30.0','2016-04-01','2016-04-30',26),(985532,8777,'PAGAS','14','2016-04-01','2016-04-30',26),(985533,8777,'SALARIO_BASE','1103.8899999999999','2016-04-01','2016-04-30',26),(985534,8777,'DIAS_PAGA','30.0','2016-04-01','2016-04-30',26),(985535,8777,'ANTIGUEDAD','220.77799999999996','2016-04-01','2016-04-30',26),(985536,8777,'BASE_CGC','1589.6015999999997','2016-04-01','2016-04-30',26),(985537,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',26),(985538,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',26),(985539,8777,'BASE_CGP','1589.6015999999997','2016-04-01','2016-04-30',26),(985540,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',26),(985541,8777,'BASE_CGC_E','1589.6015999999997','2016-04-01','2016-04-30',26),(985542,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',26),(985543,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',26),(985544,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',26),(985545,8777,'BASE_CGP_E','1589.6015999999997','2016-04-01','2016-04-30',26),(985546,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',26),(985547,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',26),(985548,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',26),(985549,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',26),(985550,8777,'HORAS_TRABAJADAS','0.0','2016-04-01','2016-04-30',26),(985551,8777,'BASE_CGC_MIN','611.52','2016-04-07','2016-04-30',27),(985552,8777,'TC2','100','2016-04-07','2016-04-30',27),(985553,8777,'DIAS_COTIZADOS','24.0','2016-04-07','2016-04-30',27),(985554,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',27),(985555,8777,'TIEMPO_COMPLETO','true','2016-04-01','2016-04-30',27),(985556,8777,'GRUPO_COTIZACION','05','2016-04-07','2016-04-30',27),(985557,8777,'DIAS_MES','30.0','2016-04-07','2016-04-30',27),(985558,8777,'DIAS_NOMINA','24.0','2016-04-07','2016-04-30',27),(985559,8777,'BASE_CGC_MAX','2913.6000000000004','2016-04-07','2016-04-30',27),(985560,8777,'BASE_CGP_MIN','611.52','2016-04-07','2016-04-30',27),(985561,8777,'BASE_CGP_MAX','2913.6000000000004','2016-04-07','2016-04-30',27),(985562,8777,'COEFICIENTE_ERE','0.0','2016-04-07','2016-04-30',27),(985563,8777,'DIAS_HUELGA','0.0','2016-04-07','2016-04-30',27),(985564,8777,'SALARIO_MENSUAL','764.4000000000001','2016-04-07','2016-04-30',27),(985565,8777,'SMI','655.2','2016-04-01','2016-04-30',27),(985566,8777,'DIAS_TRABAJADOS','24.0','2016-04-07','2016-04-30',27),(985567,8777,'AÑOS_ANTIGUEDAD','0','2016-04-07','2016-04-30',27),(985568,8777,'TRIENIO','THREE','2016-04-01','2016-04-30',27),(985569,8777,'SALARIO_BASE','611.5200000000001','2016-04-07','2016-04-30',27),(985570,8777,'BASE_CGC','611.5200000000001','2016-04-07','2016-04-30',27),(985571,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',27),(985572,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',27),(985573,8777,'BASE_CGP','611.5200000000001','2016-04-07','2016-04-30',27),(985574,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',27),(985575,8777,'BASE_CGC_E','611.5200000000001','2016-04-07','2016-04-30',27),(985576,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',27),(985577,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',27),(985578,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',27),(985579,8777,'BASE_CGP_E','611.5200000000001','2016-04-07','2016-04-30',27),(985580,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',27),(985581,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',27),(985582,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',27),(985583,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',27),(985584,8777,'HORAS_TRABAJADAS','0.0','2016-04-07','2016-04-30',27),(985620,8777,'BASE_CGC_MIN','764.4','2016-04-01','2016-04-30',29),(985621,8777,'TC2','100','2016-04-01','2016-04-30',29),(985622,8777,'DIAS_COTIZADOS','30.0','2016-04-01','2016-04-30',29),(985623,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',29),(985624,8777,'TIEMPO_COMPLETO','true','2016-04-01','2016-04-30',29),(985625,8777,'GRUPO_COTIZACION','09','2016-04-01','2016-04-30',29),(985626,8777,'DIAS_MES','30.0','2016-04-01','2016-04-30',29),(985627,8777,'BASE_CGP_MIN','764.4','2016-04-01','2016-04-30',29),(985628,8777,'PLUS_EXTRA_SALARIAL','0.0','2016-04-01','2016-04-30',29),(985629,8777,'DIAS_NOMINA','30.0','2016-04-01','2016-04-30',29),(985630,8777,'BASE_CGC_MAX','3642.0','2016-04-01','2016-04-30',29),(985631,8777,'BASE_CGP_MAX','3642.0','2016-04-01','2016-04-30',29),(985632,8777,'COEFICIENTE_ERE','0.0','2016-04-01','2016-04-30',29),(985633,8777,'SALARIO_ANUAL','11695.78','2016-04-01','2016-04-30',29),(985634,8777,'DIAS_HUELGA','0.0','2016-04-01','2016-04-30',29),(985635,8777,'DIAS_TRABAJADOS','30.0','2016-04-01','2016-04-30',29),(985636,8777,'PAGAS','14','2016-04-01','2016-04-30',29),(985637,8777,'SALARIO_BASE','835.4128571428572','2016-04-01','2016-04-30',29),(985638,8777,'DIAS_PAGA','30.0','2016-04-01','2016-04-30',29),(985639,8777,'ANTIGUEDAD','0.0','2016-04-01','2016-04-30',29),(985640,8777,'BASE_CGC','974.6483333333334','2016-04-01','2016-04-30',29),(985641,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',29),(985642,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',29),(985643,8777,'BASE_CGP','974.6483333333334','2016-04-01','2016-04-30',29),(985644,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',29),(985645,8777,'BASE_CGC_E','974.6483333333334','2016-04-01','2016-04-30',29),(985646,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',29),(985647,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',29),(985648,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',29),(985649,8777,'BASE_CGP_E','974.6483333333334','2016-04-01','2016-04-30',29),(985650,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',29),(985651,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',29),(985652,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',29),(985653,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',29),(985654,8777,'HORAS_TRABAJADAS','0.0','2016-04-01','2016-04-30',29),(985655,8777,'BASE_CGC_MIN','764.4','2016-04-01','2016-04-30',30),(985656,8777,'TC2','100','2016-04-01','2016-04-30',30),(985657,8777,'DIAS_COTIZADOS','30.0','2016-04-01','2016-04-30',30),(985658,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',30),(985659,8777,'TIEMPO_COMPLETO','true','2016-04-01','2016-04-30',30),(985660,8777,'GRUPO_COTIZACION','09','2016-04-01','2016-04-30',30),(985661,8777,'DIAS_MES','30.0','2016-04-01','2016-04-30',30),(985662,8777,'BASE_CGP_MIN','764.4','2016-04-01','2016-04-30',30),(985663,8777,'PLUS_EXTRA_SALARIAL','0.0','2016-04-01','2016-04-30',30),(985664,8777,'DIAS_NOMINA','30.0','2016-04-01','2016-04-30',30),(985665,8777,'BASE_CGC_MAX','3642.0','2016-04-01','2016-04-30',30),(985666,8777,'BASE_CGP_MAX','3642.0','2016-04-01','2016-04-30',30),(985667,8777,'COEFICIENTE_ERE','0.0','2016-04-01','2016-04-30',30),(985668,8777,'SALARIO_ANUAL','11695.78','2016-04-01','2016-04-30',30),(985669,8777,'DIAS_HUELGA','0.0','2016-04-01','2016-04-30',30),(985670,8777,'DIAS_TRABAJADOS','30.0','2016-04-01','2016-04-30',30),(985671,8777,'PAGAS','14','2016-04-01','2016-04-30',30),(985672,8777,'SALARIO_BASE','835.4128571428572','2016-04-01','2016-04-30',30),(985673,8777,'DIAS_PAGA','30.0','2016-04-01','2016-04-30',30),(985674,8777,'ANTIGUEDAD','0.0','2016-04-01','2016-04-30',30),(985675,8777,'BASE_CGC','974.6483333333334','2016-04-01','2016-04-30',30),(985676,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',30),(985677,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',30),(985678,8777,'BASE_CGP','974.6483333333334','2016-04-01','2016-04-30',30),(985679,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',30),(985680,8777,'BASE_CGC_E','974.6483333333334','2016-04-01','2016-04-30',30),(985681,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',30),(985682,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',30),(985683,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',30),(985684,8777,'BASE_CGP_E','974.6483333333334','2016-04-01','2016-04-30',30),(985685,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',30),(985686,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',30),(985687,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',30),(985688,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',30),(985689,8777,'HORAS_TRABAJADAS','0.0','2016-04-01','2016-04-30',30),(985690,8777,'BASE_CGC_MIN','386.4','2016-04-01','2016-04-30',31),(985691,8777,'TC2','200','2016-04-01','2016-04-30',31),(985692,8777,'HORAS_VIERNES','4.0','2016-04-01','2016-04-30',31),(985693,8777,'HORAS_MARTES','2.5','2016-04-01','2016-04-30',31),(985694,8777,'TIEMPO_COMPLETO','false','2016-04-01','2016-04-30',31),(985695,8777,'GRUPO_COTIZACION','08','2016-04-01','2016-04-30',31),(985696,8777,'HORAS_NOMINA','84.0','2016-04-01','2016-04-30',31),(985697,8777,'HORAS_JUEVES','5.5','2016-04-01','2016-04-30',31),(985698,8777,'HORAS_LUNES','2.5','2016-04-01','2016-04-30',31),(985699,8777,'HORAS_MIERCOLES','5.5','2016-04-01','2016-04-30',31),(985700,8777,'BASE_CGP_MIN','386.4','2016-04-01','2016-04-30',31),(985701,8777,'PLUS_EXTRA_SALARIAL','0.0','2016-04-01','2016-04-30',31),(985702,8777,'DIAS_NOMINA','30.0','2016-04-01','2016-04-30',31),(985703,8777,'BASE_CGC_MAX','3642.0','2016-04-01','2016-04-30',31),(985704,8777,'DIAS_MES','30.0','2016-04-01','2016-04-30',31),(985705,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',31),(985706,8777,'BASE_CGP_MAX','3642.0','2016-04-01','2016-04-30',31),(985707,8777,'COEFICIENTE_ERE','0.0','2016-04-01','2016-04-30',31),(985708,8777,'SALARIO_ANUAL','12298.66','2016-04-01','2016-04-30',31),(985709,8777,'DIAS_HUELGA','0.0','2016-04-01','2016-04-30',31),(985710,8777,'DIAS_TRABAJADOS','15.0','2016-04-01','2016-04-30',31),(985711,8777,'PAGAS','14','2016-04-01','2016-04-30',31),(985712,8777,'SALARIO_BASE','439.23785714285714','2016-04-01','2016-04-30',31),(985713,8777,'HORAS_DOMINGO','0.0','2016-04-01','2016-04-30',31),(985714,8777,'DIAS_PAGA','30.0','2016-04-01','2016-04-30',31),(985715,8777,'HORAS_CONVENIO','40.0','2016-04-01','2016-04-30',31),(985716,8777,'HORAS_SABADO','0.0','2016-04-01','2016-04-30',31),(985717,8777,'ANTIGUEDAD','0.0','2016-04-01','2016-04-30',31),(985718,8777,'HORAS_SEMANA','20.0','2016-04-01','2016-04-30',31),(985719,8777,'COEFICIENTE_PARCIALIDAD','0.5','2016-04-01','2016-04-30',31),(985720,8777,'BASE_CGC','585.6504761904762','2016-04-01','2016-04-30',31),(985721,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',31),(985722,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',31),(985723,8777,'BASE_CGP','585.6504761904762','2016-04-01','2016-04-30',31),(985724,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',31),(985725,8777,'BASE_CGC_E','585.6504761904762','2016-04-01','2016-04-30',31),(985726,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',31),(985727,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',31),(985728,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',31),(985729,8777,'BASE_CGP_E','585.6504761904762','2016-04-01','2016-04-30',31),(985730,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',31),(985731,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',31),(985732,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',31),(985733,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',31),(985734,8777,'DIAS_COTIZADOS','30.0','2016-04-01','2016-04-30',31),(985735,8777,'HORAS_TRABAJADAS','84.0','2016-04-01','2016-04-30',31),(985736,8777,'BASE_CGC_MIN','764.4','2016-04-01','2016-04-30',32),(985737,8777,'TC2','100','2016-04-01','2016-04-30',32),(985738,8777,'DIAS_COTIZADOS','30.0','2016-04-01','2016-04-30',32),(985739,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',32),(985740,8777,'TIEMPO_COMPLETO','true','2016-04-01','2016-04-30',32),(985741,8777,'GRUPO_COTIZACION','05','2016-04-01','2016-04-30',32),(985742,8777,'DIAS_MES','30.0','2016-04-01','2016-04-30',32),(985743,8777,'BASE_CGP_MIN','764.4','2016-04-01','2016-04-30',32),(985744,8777,'COEFICIENTE_ERE','0.0','2016-04-01','2016-04-30',32),(985745,8777,'DIAS_HUELGA','0.0','2016-04-01','2016-04-30',32),(985746,8777,'SALARIO_MENSUAL','655.2','2016-04-01','2016-04-30',32),(985747,8777,'SMI','655.2','2016-04-01','2016-04-30',32),(985748,8777,'DIAS_TRABAJADOS','30.0','2016-04-01','2016-04-30',32),(985749,8777,'BASE_CGC','764.4','2016-04-01','2016-04-30',32),(985750,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',32),(985751,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',32),(985752,8777,'BASE_CGP','764.4','2016-04-01','2016-04-30',32),(985753,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',32),(985754,8777,'BASE_CGC_E','764.4','2016-04-01','2016-04-30',32),(985755,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',32),(985756,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',32),(985757,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',32),(985758,8777,'BASE_CGP_E','764.4','2016-04-01','2016-04-30',32),(985759,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',32),(985760,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',32),(985761,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',32),(985762,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',32),(985763,8777,'HORAS_TRABAJADAS','0.0','2016-04-01','2016-04-30',32),(985764,8777,'BASE_CGC_MIN','713.44','2016-04-03','2016-04-30',33),(985765,8777,'TC2','100','2016-04-01','2016-04-30',33),(985766,8777,'DIAS_COTIZADOS','28.0','2016-04-03','2016-04-30',33),(985767,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',33),(985768,8777,'TIEMPO_COMPLETO','true','2016-04-01','2016-04-30',33),(985769,8777,'GRUPO_COTIZACION','09','2016-04-01','2016-04-30',33),(985770,8777,'DIAS_MES','30.0','2016-04-03','2016-04-30',33),(985771,8777,'BASE_CGP_MIN','713.4399999999999','2016-04-03','2016-04-30',33),(985772,8777,'COEFICIENTE_ERE','0.0','2016-04-03','2016-04-30',33),(985773,8777,'DIAS_HUELGA','0.0','2016-04-03','2016-04-30',33),(985774,8777,'SALARIO_MENSUAL','655.2','2016-04-03','2016-04-30',33),(985775,8777,'SMI','655.2','2016-04-01','2016-04-30',33),(985776,8777,'DIAS_TRABAJADOS','28.0','2016-04-03','2016-04-30',33),(985777,8777,'BASE_CGC','713.44','2016-04-03','2016-04-30',33),(985778,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',33),(985779,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',33),(985780,8777,'BASE_CGP','713.4399999999999','2016-04-03','2016-04-30',33),(985781,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',33),(985782,8777,'BASE_CGC_E','713.44','2016-04-01','2016-04-30',33),(985783,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',33),(985784,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',33),(985785,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',33),(985786,8777,'BASE_CGP_E','713.4399999999999','2016-04-01','2016-04-30',33),(985787,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',33),(985788,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',33),(985789,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',33),(985790,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',33),(985791,8777,'DIAS_COTIZADOS','2.0','2016-04-01','2016-04-02',33),(985792,8777,'HORAS_TRABAJADAS','0.0','2016-04-01','2016-04-30',33),(985793,8777,'BASE_CGC_MIN','71.16000000000001','2016-04-25','2016-04-26',34),(985794,8777,'TC2','100','2016-04-25','2016-04-30',34),(985795,8777,'DIAS_COTIZADOS','2.0','2016-04-25','2016-04-26',34),(985796,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',34),(985797,8777,'TIEMPO_COMPLETO','true','2016-04-01','2016-04-30',34),(985798,8777,'GRUPO_COTIZACION','01','2016-04-25','2016-04-30',34),(985799,8777,'DIAS_MES','30.0','2016-04-25','2016-04-26',34),(985800,8777,'BASE_CGP_MIN','50.96','2016-04-25','2016-04-26',34),(985801,8777,'DIAS_NOMINA','2.0','2016-04-25','2016-04-26',34),(985802,8777,'BASE_CGP_MAX','242.79999999999998','2016-04-25','2016-04-26',34),(985803,8777,'COEFICIENTE_ERE','0.0','2016-04-25','2016-04-26',34),(985804,8777,'DIAS_HUELGA','0.0','2016-04-25','2016-04-26',34),(985805,8777,'SALARIO_MENSUAL','1067.4','2016-04-25','2016-04-30',34),(985806,8777,'DIAS_TRABAJADOS','2.0','2016-04-25','2016-04-26',34),(985807,8777,'BASE_REGULADORA','35.580000000000005','2016-04-27','2016-04-30',34),(985808,8777,'DIAS_COTIZADOS','3.0','2016-04-27','2016-04-29',34),(985809,8777,'BASE_CGC_MIN','106.74000000000001','2016-04-27','2016-04-29',34),(985810,8777,'DIAS_MES','30.0','2016-04-27','2016-04-29',34),(985811,8777,'BASE_CGP_MIN','76.44','2016-04-27','2016-04-29',34),(985812,8777,'DIAS_NOMINA','3.0','2016-04-27','2016-04-29',34),(985813,8777,'BASE_CGP_MAX','364.20000000000005','2016-04-27','2016-04-29',34),(985814,8777,'DIAS_ENFERMEDAD_COMUN_1_3','3','2016-04-27','2016-04-29',34),(985815,8777,'DIAS_COTIZADOS','1.0','2016-04-30','2016-04-30',34),(985816,8777,'BASE_CGC_MIN','35.580000000000005','2016-04-30','2016-04-30',34),(985817,8777,'DIAS_MES','30','2016-04-30','2016-04-30',34),(985818,8777,'BASE_CGP_MIN','25.48','2016-04-30','2016-04-30',34),(985819,8777,'DIAS_NOMINA','1.0','2016-04-30','2016-04-30',34),(985820,8777,'BASE_CGP_MAX','121.39999999999999','2016-04-30','2016-04-30',34),(985821,8777,'DIAS_ENFERMEDAD_COMUN_4_15','1','2016-04-30','2016-04-30',34),(985822,8777,'BASE_CGC','71.16000000000001','2016-04-25','2016-04-26',34),(985823,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',34),(985824,8777,'BASE_CGC','106.74000000000001','2016-04-27','2016-04-29',34),(985825,8777,'BASE_CGC','35.580000000000005','2016-04-30','2016-04-30',34),(985826,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',34),(985827,8777,'BASE_CGP','71.16000000000001','2016-04-25','2016-04-26',34),(985828,8777,'BASE_CGP','106.74000000000001','2016-04-27','2016-04-29',34),(985829,8777,'BASE_CGP','35.580000000000005','2016-04-30','2016-04-30',34),(985830,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',34),(985831,8777,'BASE_CGC_E','213.48000000000005','2016-04-25','2016-04-30',34),(985832,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',34),(985833,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',34),(985834,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',34),(985835,8777,'BASE_CGP_E','213.48000000000005','2016-04-25','2016-04-30',34),(985836,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',34),(985837,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',34),(985838,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',34),(985839,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',34),(985840,8777,'HORAS_TRABAJADAS','0.0','2016-04-25','2016-04-26',34),(985841,8777,'BASE_CGC_MIN','71.16000000000001','2016-04-25','2016-04-26',35),(985842,8777,'TC2','100','2016-04-25','2016-04-30',35),(985843,8777,'DIAS_COTIZADOS','2.0','2016-04-25','2016-04-26',35),(985844,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',35),(985845,8777,'TIEMPO_COMPLETO','true','2016-04-01','2016-04-30',35),(985846,8777,'GRUPO_COTIZACION','01','2016-04-25','2016-04-30',35),(985847,8777,'DIAS_MES','30.0','2016-04-25','2016-04-26',35),(985848,8777,'BASE_CGP_MIN','50.96','2016-04-25','2016-04-26',35),(985849,8777,'DIAS_NOMINA','2.0','2016-04-25','2016-04-26',35),(985850,8777,'BASE_CGP_MAX','242.79999999999998','2016-04-25','2016-04-26',35),(985851,8777,'COEFICIENTE_ERE','0.0','2016-04-25','2016-04-26',35),(985852,8777,'DIAS_HUELGA','0.0','2016-04-25','2016-04-26',35),(985853,8777,'SALARIO_MENSUAL','1067.4','2016-04-25','2016-04-30',35),(985854,8777,'DIAS_TRABAJADOS','2.0','2016-04-25','2016-04-26',35),(985855,8777,'BASE_REGULADORA','35.580000000000005','2016-04-27','2016-04-30',35),(985856,8777,'DIAS_COTIZADOS','4.0','2016-04-27','2016-04-30',35),(985857,8777,'BASE_CGC_MIN','142.32000000000002','2016-04-27','2016-04-30',35),(985858,8777,'DIAS_MES','30','2016-04-27','2016-04-30',35),(985859,8777,'BASE_CGP_MIN','101.92','2016-04-27','2016-04-30',35),(985860,8777,'DIAS_NOMINA','4.0','2016-04-27','2016-04-30',35),(985861,8777,'BASE_CGP_MAX','485.59999999999997','2016-04-27','2016-04-30',35),(985862,8777,'DIAS_ENFERMEDAD_PROFESIONAL','4','2016-04-27','2016-04-30',35),(985863,8777,'BASE_CGC','71.16000000000001','2016-04-25','2016-04-26',35),(985864,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',35),(985865,8777,'BASE_CGC','142.32000000000002','2016-04-27','2016-04-30',35),(985866,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',35),(985867,8777,'BASE_CGP','71.16000000000001','2016-04-25','2016-04-26',35),(985868,8777,'BASE_CGP','142.32000000000002','2016-04-27','2016-04-30',35),(985869,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',35),(985870,8777,'BASE_CGC_E','213.48000000000002','2016-04-25','2016-04-30',35),(985871,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',35),(985872,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',35),(985873,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',35),(985874,8777,'BASE_CGP_E','213.48000000000002','2016-04-25','2016-04-30',35),(985875,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',35),(985876,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',35),(985877,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',35),(985878,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',35),(985879,8777,'NOMINA','true','2016-04-01','2016-04-30',35),(985880,8777,'HORAS_TRABAJADAS','0.0','2016-04-25','2016-04-26',35),(985881,8777,'BASE_CGC_MIN','1067.4','2016-04-01','2016-04-30',36),(985882,8777,'TC2','100','2016-04-01','2016-04-30',36),(985883,8777,'DIAS_COTIZADOS','30.0','2016-04-01','2016-04-30',36),(985884,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',36),(985885,8777,'TIEMPO_COMPLETO','true','2016-04-01','2016-04-30',36),(985886,8777,'GRUPO_COTIZACION','01','2016-04-01','2016-04-30',36),(985887,8777,'DIAS_MES','30.0','2016-04-01','2016-04-30',36),(985888,8777,'BASE_CGP_MIN','764.4','2016-04-01','2016-04-30',36),(985889,8777,'DIAS_NOMINA','30.0','2016-04-01','2016-04-30',36),(985890,8777,'BASE_CGP_MAX','3642.0','2016-04-01','2016-04-30',36),(985891,8777,'BASE_CGC','1067.4','2016-04-01','2016-04-30',36),(985892,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',36),(985893,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',36),(985894,8777,'BASE_CGP','1013.3341666666665','2016-04-01','2016-04-30',36),(985895,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',36),(985896,8777,'BASE_CGC_E','1067.4','2016-04-01','2016-04-30',36),(985897,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',36),(985898,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',36),(985899,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',36),(985900,8777,'BASE_CGP_E','1013.3341666666665','2016-04-01','2016-04-30',36),(985901,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',36),(985902,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',36),(985903,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',36),(985904,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',36),(985905,8777,'HORAS_TRABAJADAS','0.0','2016-04-01','2016-04-30',36),(985906,8777,'BASE_CGC_E','0.0','2016-04-01','2016-04-30',37),(985907,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',37),(985908,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',37),(985909,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',37),(985910,8777,'BASE_CGP_E','0.0','2016-04-01','2016-04-30',37),(985911,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',37),(985912,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',37),(985913,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',37),(985914,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',37),(985915,8777,'TC2','100','2016-04-01','2016-04-30',37),(985916,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',37),(985917,8777,'DIAS_COTIZADOS','30.0','2016-04-01','2016-04-30',37),(985918,8777,'HORAS_TRABAJADAS','0.0','2016-04-01','2016-04-30',37),(985919,8777,'BASE_CGC_MIN','770.1','2016-04-01','2016-04-30',38),(985920,8777,'TC2','100','2016-04-01','2016-04-30',38),(985921,8777,'DIAS_COTIZADOS','30.0','2016-04-01','2016-04-30',38),(985922,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',38),(985923,8777,'TIEMPO_COMPLETO','true','2016-04-01','2016-04-30',38),(985924,8777,'GRUPO_COTIZACION','03','2016-04-01','2016-04-30',38),(985925,8777,'DIAS_MES','30.0','2016-04-01','2016-04-30',38),(985926,8777,'BASE_CGP_MIN','764.4','2016-04-01','2016-04-30',38),(985927,8777,'PLUS_EXTRA_SALARIAL','0.0','2016-04-01','2016-04-30',38),(985928,8777,'DIAS_NOMINA','30.0','2016-04-01','2016-04-30',38),(985929,8777,'BASE_CGC_MAX','3642.0','2016-04-01','2016-04-30',38),(985930,8777,'BASE_CGP_MAX','3642.0','2016-04-01','2016-04-30',38),(985931,8777,'COEFICIENTE_ERE','0.0','2016-04-01','2016-04-30',38),(985932,8777,'SALARIO_ANUAL','14387.05','2016-04-01','2016-04-30',38),(985933,8777,'DIAS_HUELGA','0.0','2016-04-01','2016-04-30',38),(985934,8777,'DIAS_TRABAJADOS','30.0','2016-04-01','2016-04-30',38),(985935,8777,'PAGAS','14','2016-04-01','2016-04-30',38),(985936,8777,'SALARIO_BASE','1027.6464285714285','2016-04-01','2016-04-30',38),(985937,8777,'DIAS_PAGA','30.0','2016-04-01','2016-04-30',38),(985938,8777,'ANTIGUEDAD','0.0','2016-04-01','2016-04-30',38),(985939,8777,'BASE_CGC','1198.9208333333333','2016-04-01','2016-04-30',38),(985940,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',38),(985941,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',38),(985942,8777,'BASE_CGP','1198.9208333333333','2016-04-01','2016-04-30',38),(985943,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',38),(985944,8777,'BASE_CGC_E','1198.9208333333333','2016-04-01','2016-04-30',38),(985945,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',38),(985946,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',38),(985947,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',38),(985948,8777,'BASE_CGP_E','1198.9208333333333','2016-04-01','2016-04-30',38),(985949,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',38),(985950,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',38),(985951,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',38),(985952,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',38),(985953,8777,'HORAS_TRABAJADAS','0.0','2016-04-01','2016-04-30',38),(985954,8777,'BASE_CGC_MIN','764.4','2016-04-01','2016-04-30',39),(985955,8777,'TC2','100','2016-04-01','2016-04-30',39),(985956,8777,'DIAS_COTIZADOS','30.0','2016-04-01','2016-04-30',39),(985957,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',39),(985958,8777,'TIEMPO_COMPLETO','true','2016-04-01','2016-04-30',39),(985959,8777,'GRUPO_COTIZACION','05','2016-04-01','2016-04-30',39),(985960,8777,'DIAS_MES','30.0','2016-04-01','2016-04-30',39),(985961,8777,'BASE_CGP_MIN','764.4','2016-04-01','2016-04-30',39),(985962,8777,'PLUS_EXTRA_SALARIAL','0.0','2016-04-01','2016-04-30',39),(985963,8777,'DIAS_NOMINA','30.0','2016-04-01','2016-04-30',39),(985964,8777,'BASE_CGC_MAX','3642.0','2016-04-01','2016-04-30',39),(985965,8777,'BASE_CGP_MAX','3642.0','2016-04-01','2016-04-30',39),(985966,8777,'COEFICIENTE_ERE','0.0','2016-04-01','2016-04-30',39),(985967,8777,'SALARIO_ANUAL','14387.05','2016-04-01','2016-04-30',39),(985968,8777,'DIAS_HUELGA','0.0','2016-04-01','2016-04-30',39),(985969,8777,'DIAS_TRABAJADOS','30.0','2016-04-01','2016-04-30',39),(985970,8777,'PAGAS','14','2016-04-01','2016-04-30',39),(985971,8777,'SALARIO_BASE','1027.6464285714285','2016-04-01','2016-04-30',39),(985972,8777,'DIAS_PAGA','30.0','2016-04-01','2016-04-30',39),(985973,8777,'ANTIGUEDAD','0.0','2016-04-01','2016-04-30',39),(985974,8777,'BASE_CGC','1198.9208333333333','2016-04-01','2016-04-30',39),(985975,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',39),(985976,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',39),(985977,8777,'BASE_CGP','1198.9208333333333','2016-04-01','2016-04-30',39),(985978,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',39),(985979,8777,'BASE_CGC_E','1198.9208333333333','2016-04-01','2016-04-30',39),(985980,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',39),(985981,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',39),(985982,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',39),(985983,8777,'BASE_CGP_E','1198.9208333333333','2016-04-01','2016-04-30',39),(985984,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',39),(985985,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',39),(985986,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',39),(985987,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',39),(985988,8777,'HORAS_TRABAJADAS','0.0','2016-04-01','2016-04-30',39),(985989,8777,'BASE_CGC_MIN','1067.4','2016-04-01','2016-04-30',40),(985990,8777,'TC2','100','2016-04-01','2016-04-30',40),(985991,8777,'DIAS_COTIZADOS','30.0','2016-04-01','2016-04-30',40),(985992,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',40),(985993,8777,'TIEMPO_COMPLETO','true','2016-04-01','2016-04-30',40),(985994,8777,'GRUPO_COTIZACION','01','2016-04-01','2016-04-30',40),(985995,8777,'DIAS_MES','30.0','2016-04-01','2016-04-30',40),(985996,8777,'DIAS_NOMINA','30.0','2016-04-01','2016-04-30',40),(985997,8777,'BASE_CGC_MAX','3642.0','2016-04-01','2016-04-30',40),(985998,8777,'BASE_CGP_MIN','764.4','2016-04-01','2016-04-30',40),(985999,8777,'BASE_CGP_MAX','3642.0','2016-04-01','2016-04-30',40),(986000,8777,'COEFICIENTE_ERE','0.0','2016-04-01','2016-04-30',40),(986001,8777,'DIAS_HUELGA','0.0','2016-04-01','2016-04-30',40),(986002,8777,'SALARIO_MENSUAL','10000','2016-04-01','2016-04-30',40),(986003,8777,'DIAS_TRABAJADOS','30.0','2016-04-01','2016-04-30',40),(986004,8777,'BASE_CGC','3642.0','2016-04-01','2016-04-30',40),(986005,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',40),(986006,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',40),(986007,8777,'BASE_CGP','3642.0','2016-04-01','2016-04-30',40),(986008,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',40),(986009,8777,'BASE_CGC_E','3642.0','2016-04-01','2016-04-30',40),(986010,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',40),(986011,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',40),(986012,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',40),(986013,8777,'BASE_CGP_E','3642.0','2016-04-01','2016-04-30',40),(986014,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',40),(986015,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',40),(986016,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',40),(986017,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',40),(986018,8777,'HORAS_TRABAJADAS','0.0','2016-04-01','2016-04-30',40),(986019,8777,'BASE_CGC_MIN','1067.4','2016-04-01','2016-04-30',41),(986020,8777,'TC2','100','2016-04-01','2016-04-30',41),(986021,8777,'DIAS_COTIZADOS','30.0','2016-04-01','2016-04-30',41),(986022,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',41),(986023,8777,'TIEMPO_COMPLETO','true','2016-04-01','2016-04-30',41),(986024,8777,'GRUPO_COTIZACION','01','2016-04-01','2016-04-30',41),(986025,8777,'DIAS_MES','30.0','2016-04-01','2016-04-30',41),(986026,8777,'BASE_CGP_MIN','764.4','2016-04-01','2016-04-30',41),(986027,8777,'COEFICIENTE_ERE','0.0','2016-04-01','2016-04-30',41),(986028,8777,'DIAS_HUELGA','0.0','2016-04-01','2016-04-30',41),(986029,8777,'SALARIO_MENSUAL','10','2016-04-01','2016-04-30',41),(986030,8777,'DIAS_TRABAJADOS','30.0','2016-04-01','2016-04-30',41),(986031,8777,'BASE_CGC','1067.4','2016-04-01','2016-04-30',41),(986032,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',41),(986033,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',41),(986034,8777,'BASE_CGP','764.4','2016-04-01','2016-04-30',41),(986035,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',41),(986036,8777,'BASE_CGC_E','1067.4','2016-04-01','2016-04-30',41),(986037,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',41),(986038,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',41),(986039,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',41),(986040,8777,'BASE_CGP_E','764.4','2016-04-01','2016-04-30',41),(986041,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',41),(986042,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',41),(986043,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',41),(986044,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',41),(986045,8777,'HORAS_TRABAJADAS','0.0','2016-04-01','2016-04-30',41),(986046,8777,'BASE_CGC_MIN','764.4','2016-04-01','2016-04-30',42),(986047,8777,'TC2','100','2016-04-01','2016-04-30',42),(986048,8777,'DIAS_COTIZADOS','30.0','2016-04-01','2016-04-30',42),(986049,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',42),(986050,8777,'TIEMPO_COMPLETO','true','2016-04-01','2016-04-30',42),(986051,8777,'GRUPO_COTIZACION','04','2016-04-01','2016-04-30',42),(986052,8777,'DIAS_MES','30.0','2016-04-01','2016-04-30',42),(986053,8777,'DIAS_NOMINA','30.0','2016-04-01','2016-04-30',42),(986054,8777,'BASE_CGC_MAX','3642.0','2016-04-01','2016-04-30',42),(986055,8777,'BASE_CGP_MIN','764.4','2016-04-01','2016-04-30',42),(986056,8777,'BASE_CGP_MAX','3642.0','2016-04-01','2016-04-30',42),(986057,8777,'COEFICIENTE_ERE','0.0','2016-04-01','2016-04-30',42),(986058,8777,'DIAS_HUELGA','0.0','2016-04-01','2016-04-30',42),(986059,8777,'DIAS_TRABAJADOS','30.0','2016-04-01','2016-04-30',42),(986060,8777,'BASE_CGC','1500.0','2016-04-01','2016-04-30',42),(986061,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',42),(986062,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',42),(986063,8777,'BASE_CGP','1500.0','2016-04-01','2016-04-30',42),(986064,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',42),(986065,8777,'BASE_CGC_E','1500.0','2016-04-01','2016-04-30',42),(986066,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',42),(986067,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',42),(986068,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',42),(986069,8777,'BASE_CGP_E','1500.0','2016-04-01','2016-04-30',42),(986070,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',42),(986071,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',42),(986072,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',42),(986073,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',42),(986074,8777,'HORAS_TRABAJADAS','0.0','2016-04-01','2016-04-30',42),(986075,8777,'BASE_CGC_MIN','764.4','2016-04-01','2016-04-30',43),(986076,8777,'TC2','100','2016-04-01','2016-04-30',43),(986077,8777,'DIAS_COTIZADOS','30.0','2016-04-01','2016-04-30',43),(986078,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',43),(986079,8777,'TIEMPO_COMPLETO','true','2016-04-01','2016-04-30',43),(986080,8777,'GRUPO_COTIZACION','05','2016-04-01','2016-04-30',43),(986081,8777,'DIAS_MES','30.0','2016-04-01','2016-04-30',43),(986082,8777,'BASE_CGP_MIN','764.4','2016-04-01','2016-04-30',43),(986083,8777,'COEFICIENTE_ERE','0.0','2016-04-01','2016-04-30',43),(986084,8777,'DIAS_PAGA','30.0','2016-04-01','2016-04-30',43),(986085,8777,'DIAS_HUELGA','0.0','2016-04-01','2016-04-30',43),(986086,8777,'DIAS_TRABAJADOS','30.0','2016-04-01','2016-04-30',43),(986087,8777,'DIAS_NOMINA','30.0','2016-04-01','2016-04-30',43),(986088,8777,'BASE_CGC_MAX','3642.0','2016-04-01','2016-04-30',43),(986089,8777,'BASE_CGP_MAX','3642.0','2016-04-01','2016-04-30',43),(986090,8777,'BASE_CGC','2634.8419094854307','2016-04-01','2016-04-30',43),(986091,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',43),(986092,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',43),(986093,8777,'BASE_CGP','2634.8419094854307','2016-04-01','2016-04-30',43),(986094,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',43),(986095,8777,'BASE_CGC_E','2634.8419094854307','2016-04-01','2016-04-30',43),(986096,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',43),(986097,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',43),(986098,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',43),(986099,8777,'BASE_CGP_E','2634.8419094854307','2016-04-01','2016-04-30',43),(986100,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',43),(986101,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',43),(986102,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',43),(986103,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',43),(986104,8777,'HORAS_TRABAJADAS','0.0','2016-04-01','2016-04-30',43),(986105,8777,'BASE_CGC_MIN','1067.4','2016-04-01','2016-04-30',44),(986106,8777,'TC2','100','2016-04-01','2016-04-30',44),(986107,8777,'DIAS_COTIZADOS','30.0','2016-04-01','2016-04-30',44),(986108,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',44),(986109,8777,'TIEMPO_COMPLETO','true','2016-04-01','2016-04-30',44),(986110,8777,'GRUPO_COTIZACION','01','2016-04-01','2016-04-30',44),(986111,8777,'DIAS_MES','30.0','2016-04-01','2016-04-30',44),(986112,8777,'DIAS_NOMINA','30.0','2016-04-01','2016-04-30',44),(986113,8777,'BASE_CGC_MAX','3642.0','2016-04-01','2016-04-30',44),(986114,8777,'BASE_CGP_MIN','764.4','2016-04-01','2016-04-30',44),(986115,8777,'BASE_CGP_MAX','3642.0','2016-04-01','2016-04-30',44),(986116,8777,'BASE_CGC','3642.0','2016-04-01','2016-04-30',44),(986117,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',44),(986118,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',44),(986119,8777,'BASE_CGP','3642.0','2016-04-01','2016-04-30',44),(986120,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',44),(986121,8777,'BASE_CGC_E','3642.0','2016-04-01','2016-04-30',44),(986122,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',44),(986123,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',44),(986124,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',44),(986125,8777,'BASE_CGP_E','3642.0','2016-04-01','2016-04-30',44),(986126,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',44),(986127,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',44),(986128,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',44),(986129,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',44),(986130,8777,'HORAS_TRABAJADAS','0.0','2016-04-01','2016-04-30',44),(986131,8777,'BASE_CGC_E','0.0','2016-04-01','2016-04-30',45),(986132,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',45),(986133,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',45),(986134,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',45),(986135,8777,'BASE_CGP_E','0.0','2016-04-01','2016-04-30',45),(986136,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',45),(986137,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',45),(986138,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',45),(986139,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',45),(986140,8777,'TC2','100','2016-04-01','2016-04-30',45),(986141,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',45),(986142,8777,'DIAS_COTIZADOS','30.0','2016-04-01','2016-04-30',45),(986143,8777,'HORAS_TRABAJADAS','0.0','2016-04-01','2016-04-30',45),(986144,8777,'BASE_CGC_MIN','764.4','2016-04-01','2016-04-30',46),(986145,8777,'TC2','100','2016-04-01','2016-04-30',46),(986146,8777,'DIAS_COTIZADOS','30.0','2016-04-01','2016-04-30',46),(986147,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',46),(986148,8777,'TIEMPO_COMPLETO','true','2016-04-01','2016-04-30',46),(986149,8777,'GRUPO_COTIZACION','05','2016-04-01','2016-04-30',46),(986150,8777,'DIAS_MES','30.0','2016-04-01','2016-04-30',46),(986151,8777,'DIAS_NOMINA','30.0','2016-04-01','2016-04-30',46),(986152,8777,'BASE_CGC_MAX','3642.0','2016-04-01','2016-04-30',46),(986153,8777,'BASE_CGP_MIN','764.4','2016-04-01','2016-04-30',46),(986154,8777,'BASE_CGP_MAX','3642.0','2016-04-01','2016-04-30',46),(986155,8777,'BASE_CGC','974.1666666666666','2016-04-01','2016-04-30',46),(986156,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',46),(986157,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',46),(986158,8777,'BASE_CGP','974.1666666666666','2016-04-01','2016-04-30',46),(986159,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',46),(986160,8777,'BASE_CGC_E','974.1666666666666','2016-04-01','2016-04-30',46),(986161,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',46),(986162,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',46),(986163,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',46),(986164,8777,'BASE_CGP_E','974.1666666666666','2016-04-01','2016-04-30',46),(986165,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',46),(986166,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',46),(986167,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',46),(986168,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',46),(986169,8777,'HORAS_TRABAJADAS','0.0','2016-04-01','2016-04-30',46),(986170,8777,'BASE_CGC_E','0.0','2016-04-01','2016-04-30',47),(986171,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',47),(986172,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',47),(986173,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',47),(986174,8777,'BASE_CGP_E','0.0','2016-04-01','2016-04-30',47),(986175,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',47),(986176,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',47),(986177,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',47),(986178,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',47),(986179,8777,'TC2','100','2016-04-01','2016-04-30',47),(986180,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',47),(986181,8777,'DIAS_COTIZADOS','30.0','2016-04-01','2016-04-30',47),(986182,8777,'HORAS_TRABAJADAS','0.0','2016-04-01','2016-04-30',47),(986183,8777,'BASE_CGC_E','0.0','2016-04-01','2016-04-30',48),(986184,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',48),(986185,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',48),(986186,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',48),(986187,8777,'BASE_CGP_E','0.0','2016-04-01','2016-04-30',48),(986188,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',48),(986189,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',48),(986190,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',48),(986191,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',48),(986192,8777,'TC2','100','2016-04-01','2016-04-30',48),(986193,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',48),(986194,8777,'DIAS_COTIZADOS','30.0','2016-04-01','2016-04-30',48),(986195,8777,'HORAS_TRABAJADAS','0.0','2016-04-01','2016-04-30',48),(986196,8777,'BASE_CGC_E','0.0','2016-04-20','2016-04-30',49),(986197,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',49),(986198,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',49),(986199,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',49),(986200,8777,'BASE_CGP_E','0.0','2016-04-20','2016-04-30',49),(986201,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',49),(986202,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',49),(986203,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',49),(986204,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',49),(986205,8777,'TC2','100','2016-04-20','2016-04-30',49),(986206,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',49),(986207,8777,'DIAS_COTIZADOS','11.0','2016-04-20','2016-04-30',49),(986208,8777,'HORAS_TRABAJADAS','0.0','2016-04-20','2016-04-30',49),(986209,8777,'BASE_CGC_E','0.0','2016-04-20','2016-04-30',50),(986210,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',50),(986211,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',50),(986212,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',50),(986213,8777,'BASE_CGP_E','0.0','2016-04-20','2016-04-30',50),(986214,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',50),(986215,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',50),(986216,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',50),(986217,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',50),(986218,8777,'TC2','100','2016-04-20','2016-04-30',50),(986219,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',50),(986220,8777,'DIAS_COTIZADOS','11.0','2016-04-20','2016-04-30',50),(986221,8777,'HORAS_TRABAJADAS','0.0','2016-04-20','2016-04-30',50),(986222,8777,'BASE_CGC_E','0.0','2016-04-01','2016-04-30',51),(986223,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',51),(986224,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',51),(986225,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',51),(986226,8777,'BASE_CGP_E','0.0','2016-04-01','2016-04-30',51),(986227,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',51),(986228,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',51),(986229,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',51),(986230,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',51),(986231,8777,'TC2','100','2016-04-01','2016-04-30',51),(986232,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',51),(986233,8777,'DIAS_COTIZADOS','30.0','2016-04-01','2016-04-30',51),(986234,8777,'HORAS_TRABAJADAS','0.0','2016-04-01','2016-04-30',51),(986270,8777,'HORAS_TRABAJADAS','0.0','2016-04-01','2016-04-30',53),(986271,8777,'BASE_CGC_MIN','303.59999999999997','2016-04-01','2016-04-30',54),(986272,8777,'TC2','200','2016-04-01','2016-04-30',54),(986273,8777,'HORAS_VIERNES','2.0','2016-04-01','2016-04-30',54),(986274,8777,'HORAS_MARTES','4.0','2016-04-01','2016-04-30',54),(986275,8777,'TIEMPO_COMPLETO','false','2016-04-01','2016-04-30',54),(986276,8777,'GRUPO_COTIZACION','08','2016-04-01','2016-04-30',54),(986277,8777,'HORAS_NOMINA','66.0','2016-04-01','2016-04-30',54),(986278,8777,'HORAS_JUEVES','2.0','2016-04-01','2016-04-30',54),(986279,8777,'HORAS_LUNES','4.0','2016-04-01','2016-04-30',54),(986280,8777,'HORAS_MIERCOLES','4.0','2016-04-01','2016-04-30',54),(986281,8777,'BASE_CGP_MIN','303.59999999999997','2016-04-01','2016-04-30',54),(986282,8777,'PLUS_EXTRA_SALARIAL','0.0','2016-04-01','2016-04-30',54),(986283,8777,'DIAS_NOMINA','30.0','2016-04-01','2016-04-30',54),(986284,8777,'BASE_CGC_MAX','3642.0','2016-04-01','2016-04-30',54),(986285,8777,'DIAS_MES','30.0','2016-04-01','2016-04-30',54),(986286,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',54),(986287,8777,'BASE_CGP_MAX','3642.0','2016-04-01','2016-04-30',54),(986288,8777,'COEFICIENTE_ERE','0.0','2016-04-01','2016-04-30',54),(986289,8777,'SALARIO_ANUAL','12808.91','2016-04-01','2016-04-30',54),(986290,8777,'DIAS_HUELGA','0.0','2016-04-01','2016-04-30',54),(986291,8777,'DIAS_TRABAJADOS','12.0','2016-04-01','2016-04-30',54),(986292,8777,'PAGAS','14','2016-04-01','2016-04-30',54),(986293,8777,'SALARIO_BASE','365.96885714285713','2016-04-01','2016-04-30',54),(986294,8777,'HORAS_DOMINGO','0.0','2016-04-01','2016-04-30',54),(986295,8777,'DIAS_PAGA','30.0','2016-04-01','2016-04-30',54),(986296,8777,'HORAS_CONVENIO','40.0','2016-04-01','2016-04-30',54),(986297,8777,'HORAS_SABADO','0.0','2016-04-01','2016-04-30',54),(986298,8777,'ANTIGUEDAD','0.0','2016-04-01','2016-04-30',54),(986299,8777,'HORAS_SEMANA','16.0','2016-04-01','2016-04-30',54),(986300,8777,'COEFICIENTE_PARCIALIDAD','0.4','2016-04-01','2016-04-30',54),(986301,8777,'BASE_CGC','518.455880952381','2016-04-01','2016-04-30',54),(986302,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',54),(986303,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',54),(986304,8777,'BASE_CGP','518.455880952381','2016-04-01','2016-04-30',54),(986305,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',54),(986306,8777,'BASE_CGC_E','518.455880952381','2016-04-01','2016-04-30',54),(986307,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',54),(986308,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',54),(986309,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',54),(986310,8777,'BASE_CGP_E','518.455880952381','2016-04-01','2016-04-30',54),(986311,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',54),(986312,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',54),(986313,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',54),(986314,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',54),(986315,8777,'DIAS_COTIZADOS','30.0','2016-04-01','2016-04-30',54),(986316,8777,'HORAS_TRABAJADAS','66.0','2016-04-01','2016-04-30',54),(986317,8777,'BASE_CGC_MIN','764.4','2016-04-01','2016-04-30',55),(986318,8777,'TC2','100','2016-04-01','2016-04-30',55),(986319,8777,'DIAS_COTIZADOS','30.0','2016-04-01','2016-04-30',55),(986320,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',55),(986321,8777,'TIEMPO_COMPLETO','true','2016-04-01','2016-04-30',55),(986322,8777,'GRUPO_COTIZACION','09','2016-04-01','2016-04-30',55),(986323,8777,'DIAS_MES','30.0','2016-04-01','2016-04-30',55),(986324,8777,'BASE_CGP_MIN','764.4','2016-04-01','2016-04-30',55),(986325,8777,'PLUS_EXTRA_SALARIAL','0.0','2016-04-01','2016-04-30',55),(986326,8777,'DIAS_NOMINA','30.0','2016-04-01','2016-04-30',55),(986327,8777,'BASE_CGC_MAX','3642.0','2016-04-01','2016-04-30',55),(986328,8777,'BASE_CGP_MAX','3642.0','2016-04-01','2016-04-30',55),(986329,8777,'COEFICIENTE_ERE','0.0','2016-04-01','2016-04-30',55),(986330,8777,'SALARIO_ANUAL','11695.78','2016-04-01','2016-04-30',55),(986331,8777,'DIAS_HUELGA','0.0','2016-04-01','2016-04-30',55),(986332,8777,'DIAS_TRABAJADOS','30.0','2016-04-01','2016-04-30',55),(986333,8777,'PAGAS','14','2016-04-01','2016-04-30',55),(986334,8777,'SALARIO_BASE','835.4128571428572','2016-04-01','2016-04-30',55),(986335,8777,'DIAS_PAGA','30.0','2016-04-01','2016-04-30',55),(986336,8777,'ANTIGUEDAD','0.0','2016-04-01','2016-04-30',55),(986337,8777,'BASE_CGC','974.6483333333334','2016-04-01','2016-04-30',55),(986338,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',55),(986339,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',55),(986340,8777,'BASE_CGP','974.6483333333334','2016-04-01','2016-04-30',55),(986341,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',55),(986342,8777,'BASE_CGC_E','974.6483333333334','2016-04-01','2016-04-30',55),(986343,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',55),(986344,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',55),(986345,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',55),(986346,8777,'BASE_CGP_E','974.6483333333334','2016-04-01','2016-04-30',55),(986347,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',55),(986348,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',55),(986349,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',55),(986350,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',55),(986351,8777,'COEFICIENTE_PARCIALIDAD','1.0','2016-04-01','2016-04-30',55),(986352,8777,'HORAS_TRABAJADAS','0.0','2016-04-01','2016-04-30',55),(986353,8777,'BASE_CGC_MIN','764.4','2016-04-01','2016-04-30',56),(986354,8777,'TC2','100','2016-04-01','2016-04-30',56),(986355,8777,'DIAS_COTIZADOS','30.0','2016-04-01','2016-04-30',56),(986356,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',56),(986357,8777,'TIEMPO_COMPLETO','true','2016-04-01','2016-04-30',56),(986358,8777,'GRUPO_COTIZACION','06','2016-04-01','2016-04-30',56),(986359,8777,'DIAS_MES','30.0','2016-04-01','2016-04-30',56),(986360,8777,'BASE_CGP_MIN','764.4','2016-04-01','2016-04-30',56),(986361,8777,'PLUS_EXTRA_SALARIAL','0.0','2016-04-01','2016-04-30',56),(986362,8777,'DIAS_NOMINA','30.0','2016-04-01','2016-04-30',56),(986363,8777,'BASE_CGC_MAX','3642.0','2016-04-01','2016-04-30',56),(986364,8777,'BASE_CGP_MAX','3642.0','2016-04-01','2016-04-30',56),(986365,8777,'COEFICIENTE_ERE','0.0','2016-04-01','2016-04-30',56),(986366,8777,'SALARIO_ANUAL','14387.05','2016-04-01','2016-04-30',56),(986367,8777,'DIAS_HUELGA','0.0','2016-04-01','2016-04-30',56),(986368,8777,'DIAS_TRABAJADOS','30.0','2016-04-01','2016-04-30',56),(986369,8777,'PAGAS','14','2016-04-01','2016-04-30',56),(986370,8777,'SALARIO_BASE','1027.6464285714285','2016-04-01','2016-04-30',56),(986371,8777,'DIAS_PAGA','30.0','2016-04-01','2016-04-30',56),(986372,8777,'ANTIGUEDAD','0.0','2016-04-01','2016-04-30',56),(986373,8777,'BASE_CGC','1198.9208333333333','2016-04-01','2016-04-30',56),(986374,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',56),(986375,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',56),(986376,8777,'BASE_CGP','1198.9208333333333','2016-04-01','2016-04-30',56),(986377,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',56),(986378,8777,'BASE_CGC_E','1198.9208333333333','2016-04-01','2016-04-30',56),(986379,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',56),(986380,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',56),(986381,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',56),(986382,8777,'BASE_CGP_E','1198.9208333333333','2016-04-01','2016-04-30',56),(986383,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',56),(986384,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',56),(986385,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',56),(986386,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',56),(986387,8777,'HORAS_TRABAJADAS','0.0','2016-04-01','2016-04-30',56),(986388,8777,'BASE_CGC_MIN','767.26','2016-04-05','2016-04-30',57),(986389,8777,'TC2','100','2016-04-05','2016-04-30',57),(986390,8777,'DIAS_COTIZADOS','26.0','2016-04-05','2016-04-30',57),(986391,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',57),(986392,8777,'TIEMPO_COMPLETO','true','2016-04-01','2016-04-30',57),(986393,8777,'GRUPO_COTIZACION','02','2016-04-05','2016-04-30',57),(986394,8777,'DIAS_MES','30.0','2016-04-05','2016-04-30',57),(986395,8777,'BASE_CGP_MIN','662.48','2016-04-05','2016-04-30',57),(986396,8777,'DIAS_NOMINA','26.0','2016-04-05','2016-04-30',57),(986397,8777,'BASE_CGC_MAX','3156.4','2016-04-05','2016-04-30',57),(986398,8777,'BASE_CGP_MAX','3156.4','2016-04-05','2016-04-30',57),(986399,8777,'COEFICIENTE_ERE','0.0','2016-04-05','2016-04-30',57),(986400,8777,'SALARIO_ANUAL','14387.05','2016-04-01','2016-04-30',57),(986401,8777,'DIAS_HUELGA','0.0','2016-04-05','2016-04-30',57),(986402,8777,'DIAS_TRABAJADOS','26.0','2016-04-05','2016-04-30',57),(986403,8777,'PAGAS','14','2016-04-01','2016-04-30',57),(986404,8777,'PLUS_EXTRA_SALARIAL','0.0','2016-04-01','2016-04-30',57),(986405,8777,'SALARIO_BASE','979.6895952380952','2016-04-05','2016-04-30',57),(986406,8777,'DIAS_PAGA','30.0','2016-04-05','2016-04-30',57),(986407,8777,'ANTIGUEDAD','0.0','2016-04-05','2016-04-30',57),(986408,8777,'BASE_CGC','1201.4214404761904','2016-04-05','2016-04-30',57),(986409,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',57),(986410,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',57),(986411,8777,'BASE_CGP','1201.4214404761904','2016-04-05','2016-04-30',57),(986412,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',57),(986413,8777,'BASE_CGC_E','1201.4214404761904','2016-04-05','2016-04-30',57),(986414,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',57),(986415,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',57),(986416,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',57),(986417,8777,'BASE_CGP_E','1201.4214404761904','2016-04-05','2016-04-30',57),(986418,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',57),(986419,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',57),(986420,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',57),(986421,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',57),(986422,8777,'HORAS_TRABAJADAS','0.0','2016-04-05','2016-04-30',57),(986423,8777,'BASE_CGC_MIN','405.08','2016-04-05','2016-04-30',58),(986424,8777,'TC2','200','2016-04-05','2016-04-30',58),(986425,8777,'HORAS_VIERNES','4.0','2016-04-05','2016-04-30',58),(986426,8777,'HORAS_MARTES','4.0','2016-04-05','2016-04-30',58),(986427,8777,'TIEMPO_COMPLETO','false','2016-04-01','2016-04-30',58),(986428,8777,'GRUPO_COTIZACION','02','2016-04-05','2016-04-30',58),(986429,8777,'HORAS_NOMINA','76.0','2016-04-05','2016-04-30',58),(986430,8777,'HORAS_JUEVES','6.0','2016-04-05','2016-04-30',58),(986431,8777,'HORAS_LUNES','4.0','2016-04-05','2016-04-30',58),(986432,8777,'HORAS_MIERCOLES','2.0','2016-04-05','2016-04-30',58),(986433,8777,'BASE_CGP_MIN','349.59999999999997','2016-04-05','2016-04-30',58),(986434,8777,'PLUS_EXTRA_SALARIAL','0.0','2016-04-01','2016-04-30',58),(986435,8777,'DIAS_NOMINA','26.0','2016-04-05','2016-04-30',58),(986436,8777,'BASE_CGC_MAX','3156.4','2016-04-05','2016-04-30',58),(986437,8777,'DIAS_MES','30.0','2016-04-05','2016-04-30',58),(986438,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',58),(986439,8777,'BASE_CGP_MAX','3156.4','2016-04-05','2016-04-30',58),(986440,8777,'COEFICIENTE_ERE','0.0','2016-04-05','2016-04-30',58),(986441,8777,'SALARIO_ANUAL','15825.755000000001','2016-04-05','2016-04-30',58),(986442,8777,'DIAS_HUELGA','0.0','2016-04-05','2016-04-30',58),(986443,8777,'DIAS_TRABAJADOS','13.0','2016-04-05','2016-04-30',58),(986444,8777,'PAGAS','14','2016-04-01','2016-04-30',58),(986445,8777,'SALARIO_BASE','489.8447976190476','2016-04-05','2016-04-30',58),(986446,8777,'HORAS_DOMINGO','0.0','2016-04-05','2016-04-30',58),(986447,8777,'DIAS_PAGA','30.0','2016-04-05','2016-04-30',58),(986448,8777,'HORAS_CONVENIO','40.0','2016-04-01','2016-04-30',58),(986449,8777,'HORAS_SABADO','0.0','2016-04-05','2016-04-30',58),(986450,8777,'ANTIGUEDAD','0.0','2016-04-05','2016-04-30',58),(986451,8777,'HORAS_SEMANA','20.0','2016-04-05','2016-04-30',58),(986452,8777,'COEFICIENTE_PARCIALIDAD','0.5','2016-04-05','2016-04-30',58),(986453,8777,'BASE_CGC','678.2466428571429','2016-04-05','2016-04-30',58),(986454,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',58),(986455,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',58),(986456,8777,'BASE_CGP','678.2466428571429','2016-04-05','2016-04-30',58),(986457,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',58),(986458,8777,'BASE_CGC_E','678.2466428571429','2016-04-05','2016-04-30',58),(986459,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',58),(986460,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',58),(986461,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',58),(986462,8777,'BASE_CGP_E','678.2466428571429','2016-04-05','2016-04-30',58),(986463,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',58),(986464,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',58),(986465,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',58),(986466,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',58),(986467,8777,'DIAS_COTIZADOS','26.0','2016-04-05','2016-04-30',58),(986468,8777,'HORAS_TRABAJADAS','76.0','2016-04-05','2016-04-30',58),(986469,8777,'BASE_CGC_MIN','662.48','2016-04-05','2016-04-30',59),(986470,8777,'TC2','100','2016-04-05','2016-04-30',59),(986471,8777,'DIAS_COTIZADOS','26.0','2016-04-05','2016-04-30',59),(986472,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',59),(986473,8777,'TIEMPO_COMPLETO','true','2016-04-01','2016-04-30',59),(986474,8777,'GRUPO_COTIZACION','07','2016-04-05','2016-04-30',59),(986475,8777,'DIAS_MES','30.0','2016-04-05','2016-04-30',59),(986476,8777,'BASE_CGP_MIN','662.48','2016-04-05','2016-04-30',59),(986477,8777,'PLUS_EXTRA_SALARIAL','0.0','2016-04-01','2016-04-30',59),(986478,8777,'DIAS_NOMINA','26.0','2016-04-05','2016-04-30',59),(986479,8777,'BASE_CGC_MAX','3156.4','2016-04-05','2016-04-30',59),(986480,8777,'BASE_CGP_MAX','3156.4','2016-04-05','2016-04-30',59),(986481,8777,'COEFICIENTE_ERE','0.0','2016-04-05','2016-04-30',59),(986482,8777,'SALARIO_ANUAL','12298.66','2016-04-01','2016-04-30',59),(986483,8777,'DIAS_HUELGA','0.0','2016-04-05','2016-04-30',59),(986484,8777,'DIAS_TRABAJADOS','26.0','2016-04-05','2016-04-30',59),(986485,8777,'PAGAS','14','2016-04-01','2016-04-30',59),(986486,8777,'SALARIO_BASE','761.345619047619','2016-04-05','2016-04-30',59),(986487,8777,'DIAS_PAGA','30.0','2016-04-05','2016-04-30',59),(986488,8777,'ANTIGUEDAD','0.0','2016-04-05','2016-04-30',59),(986489,8777,'BASE_CGC','907.7582380952381','2016-04-05','2016-04-30',59),(986490,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',59),(986491,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',59),(986492,8777,'BASE_CGP','907.7582380952381','2016-04-05','2016-04-30',59),(986493,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',59),(986494,8777,'BASE_CGC_E','907.7582380952381','2016-04-05','2016-04-30',59),(986495,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',59),(986496,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',59),(986497,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',59),(986498,8777,'BASE_CGP_E','907.7582380952381','2016-04-05','2016-04-30',59),(986499,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',59),(986500,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',59),(986501,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',59),(986502,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',59),(986503,8777,'HORAS_TRABAJADAS','0.0','2016-04-05','2016-04-30',59),(986504,8777,'BASE_CGC_MIN','826.28','2016-04-03','2016-04-30',60),(986505,8777,'TC2','100','2016-04-03','2016-04-30',60),(986506,8777,'DIAS_COTIZADOS','28.0','2016-04-03','2016-04-30',60),(986507,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',60),(986508,8777,'TIEMPO_COMPLETO','true','2016-04-01','2016-04-30',60),(986509,8777,'GRUPO_COTIZACION','02','2016-04-03','2016-04-30',60),(986510,8777,'DIAS_MES','30.0','2016-04-03','2016-04-30',60),(986511,8777,'BASE_CGP_MIN','713.4399999999999','2016-04-03','2016-04-30',60),(986512,8777,'PLUS_EXTRA_SALARIAL','0.0','2016-04-01','2016-04-30',60),(986513,8777,'DIAS_NOMINA','28.0','2016-04-03','2016-04-30',60),(986514,8777,'BASE_CGC_MAX','3399.2000000000003','2016-04-03','2016-04-30',60),(986515,8777,'BASE_CGP_MAX','3399.2000000000003','2016-04-03','2016-04-30',60),(986516,8777,'COEFICIENTE_ERE','0.0','2016-04-03','2016-04-30',60),(986517,8777,'SALARIO_ANUAL','14387.05','2016-04-01','2016-04-30',60),(986518,8777,'DIAS_HUELGA','0.0','2016-04-03','2016-04-30',60),(986519,8777,'DIAS_TRABAJADOS','28.0','2016-04-03','2016-04-30',60),(986520,8777,'PAGAS','14','2016-04-01','2016-04-30',60),(986521,8777,'SALARIO_BASE','959.1366666666667','2016-04-03','2016-04-30',60),(986522,8777,'DIAS_PAGA','30.0','2016-04-03','2016-04-30',60),(986523,8777,'ANTIGUEDAD','0.0','2016-04-03','2016-04-30',60),(986524,8777,'BASE_CGC','1130.4110714285714','2016-04-03','2016-04-30',60),(986525,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',60),(986526,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',60),(986527,8777,'BASE_CGP','1130.4110714285714','2016-04-03','2016-04-30',60),(986528,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',60),(986529,8777,'BASE_CGC_E','1130.4110714285714','2016-04-03','2016-04-30',60),(986530,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',60),(986531,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',60),(986532,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',60),(986533,8777,'BASE_CGP_E','1130.4110714285714','2016-04-03','2016-04-30',60),(986534,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',60),(986535,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',60),(986536,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',60),(986537,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',60),(986538,8777,'HORAS_TRABAJADAS','0.0','2016-04-03','2016-04-30',60),(986539,8777,'BASE_CGC_E','0.0','2016-04-14','2016-04-30',61),(986540,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',61),(986541,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',61),(986542,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',61),(986543,8777,'BASE_CGP_E','0.0','2016-04-14','2016-04-30',61),(986544,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',61),(986545,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',61),(986546,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',61),(986547,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',61),(986548,8777,'TC2','100','2016-04-14','2016-04-30',61),(986549,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',61),(986550,8777,'DIAS_COTIZADOS','17.0','2016-04-14','2016-04-30',61),(986551,8777,'HORAS_TRABAJADAS','0.0','2016-04-14','2016-04-30',61),(986552,8777,'BASE_CGC_MIN','611.52','2016-04-07','2016-04-30',62),(986553,8777,'TC2','100','2016-04-07','2016-04-30',62),(986554,8777,'DIAS_COTIZADOS','24.0','2016-04-07','2016-04-30',62),(986555,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',62),(986556,8777,'TIEMPO_COMPLETO','true','2016-04-01','2016-04-30',62),(986557,8777,'GRUPO_COTIZACION','04','2016-04-07','2016-04-30',62),(986558,8777,'DIAS_MES','30.0','2016-04-07','2016-04-30',62),(986559,8777,'BASE_CGP_MIN','611.52','2016-04-07','2016-04-30',62),(986560,8777,'COEFICIENTE_ERE','0.0','2016-04-07','2016-04-30',62),(986561,8777,'DIAS_HUELGA','0.0','2016-04-07','2016-04-30',62),(986562,8777,'DIAS_TRABAJADOS','24.0','2016-04-07','2016-04-30',62),(986563,8777,'BASE_CGC','611.52','2016-04-07','2016-04-30',62),(986564,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',62),(986565,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',62),(986566,8777,'BASE_CGP','611.52','2016-04-07','2016-04-30',62),(986567,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',62),(986568,8777,'BASE_CGC_E','611.52','2016-04-07','2016-04-30',62),(986569,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',62),(986570,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',62),(986571,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',62),(986572,8777,'BASE_CGP_E','611.52','2016-04-07','2016-04-30',62),(986573,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',62),(986574,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',62),(986575,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',62),(986576,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',62),(986577,8777,'HORAS_TRABAJADAS','0.0','2016-04-07','2016-04-30',62),(986578,8777,'BASE_CGC_E','0.0','2016-04-14','2016-04-30',63),(986579,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',63),(986580,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',63),(986581,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',63),(986582,8777,'BASE_CGP_E','0.0','2016-04-14','2016-04-30',63),(986583,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',63),(986584,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',63),(986585,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',63),(986586,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',63),(986587,8777,'TC2','100','2016-04-14','2016-04-30',63),(986588,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',63),(986589,8777,'DIAS_COTIZADOS','17.0','2016-04-14','2016-04-30',63),(986590,8777,'HORAS_TRABAJADAS','0.0','2016-04-14','2016-04-30',63),(986591,8777,'BASE_CGC_MIN','305.76','2016-04-19','2016-04-30',64),(986592,8777,'TC2','100','2016-04-19','2016-04-30',64),(986593,8777,'DIAS_COTIZADOS','12.0','2016-04-19','2016-04-30',64),(986594,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',64),(986595,8777,'TIEMPO_COMPLETO','true','2016-04-01','2016-04-30',64),(986596,8777,'GRUPO_COTIZACION','06','2016-04-19','2016-04-30',64),(986597,8777,'DIAS_MES','30.0','2016-04-19','2016-04-30',64),(986598,8777,'DIAS_NOMINA','12.0','2016-04-19','2016-04-30',64),(986599,8777,'BASE_CGC_MAX','1456.8000000000002','2016-04-19','2016-04-30',64),(986600,8777,'BASE_CGP_MIN','305.76','2016-04-19','2016-04-30',64),(986601,8777,'BASE_CGP_MAX','1456.8000000000002','2016-04-19','2016-04-30',64),(986602,8777,'COEFICIENTE_ERE','0.0','2016-04-19','2016-04-30',64),(986603,8777,'DIAS_HUELGA','0.0','2016-04-19','2016-04-30',64),(986604,8777,'SALARIO_MENSUAL','819.0','2016-04-19','2016-04-30',64),(986605,8777,'SMI','655.2','2016-04-01','2016-04-30',64),(986606,8777,'DIAS_TRABAJADOS','12.0','2016-04-19','2016-04-30',64),(986607,8777,'BASE_CGC','327.6','2016-04-19','2016-04-30',64),(986608,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',64),(986609,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',64),(986610,8777,'BASE_CGP','327.6','2016-04-19','2016-04-30',64),(986611,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',64),(986612,8777,'BASE_CGC_E','327.6','2016-04-19','2016-04-30',64),(986613,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',64),(986614,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',64),(986615,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',64),(986616,8777,'BASE_CGP_E','327.6','2016-04-19','2016-04-30',64),(986617,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',64),(986618,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',64),(986619,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',64),(986620,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',64),(986621,8777,'HORAS_TRABAJADAS','0.0','2016-04-19','2016-04-30',64),(986622,8777,'BASE_CGC_MIN','191.88','2016-04-19','2016-04-30',65),(986623,8777,'TC2','300','2016-04-19','2016-04-30',65),(986624,8777,'HORAS_MARTES','4.0','2016-04-19','2016-04-30',65),(986625,8777,'TIEMPO_COMPLETO','false','2016-04-01','2016-04-30',65),(986626,8777,'GRUPO_COTIZACION','02','2016-04-19','2016-04-30',65),(986627,8777,'HORAS_NOMINA','36.0','2016-04-19','2016-04-30',65),(986628,8777,'HORAS_JUEVES','8.0','2016-04-19','2016-04-30',65),(986629,8777,'HORAS_LUNES','4.0','2016-04-19','2016-04-30',65),(986630,8777,'HORAS_MIERCOLES','4.0','2016-04-19','2016-04-30',65),(986631,8777,'BASE_CGP_MIN','165.6','2016-04-19','2016-04-30',65),(986632,8777,'DIAS_NATURALES_MES','30','2016-04-01','2016-04-30',65),(986633,8777,'COEFICIENTE_ERE','0.0','2016-04-19','2016-04-30',65),(986634,8777,'DIAS_HUELGA','0.0','2016-04-19','2016-04-30',65),(986635,8777,'SALARIO_MENSUAL','655.2','2016-04-19','2016-04-30',65),(986636,8777,'SMI','655.2','2016-04-01','2016-04-30',65),(986637,8777,'DIAS_TRABAJADOS','6.0','2016-04-19','2016-04-30',65),(986638,8777,'DIAS_MES','30.0','2016-04-19','2016-04-30',65),(986639,8777,'BASE_CGC','191.88','2016-04-19','2016-04-30',65),(986640,8777,'PORCENTAJE_CGC','4.7','2016-04-01','2016-04-30',65),(986641,8777,'INDEFINIDO','true','2016-04-01','2016-04-30',65),(986642,8777,'BASE_CGP','165.6','2016-04-19','2016-04-30',65),(986643,8777,'PORCENTAJE_FP','0.1','2016-04-01','2016-04-30',65),(986644,8777,'BASE_CGC_E','191.88','2016-04-19','2016-04-30',65),(986645,8777,'PORCENTAJE_CGC_E','23.6','2016-04-01','2016-04-30',65),(986646,8777,'PORCENTAJE_EXTR_E','12.0','2016-04-01','2016-04-30',65),(986647,8777,'PORCENTAJE_NEXTR_E','23.6','2016-04-01','2016-04-30',65),(986648,8777,'BASE_CGP_E','165.6','2016-04-19','2016-04-30',65),(986649,8777,'TARIFA_IT','0.65','2016-04-01','2016-04-30',65),(986650,8777,'TARIFA_IMS','0.7','2016-04-01','2016-04-30',65),(986651,8777,'PORCENTAJE_FOGASA','0.2','2016-04-01','2016-04-30',65),(986652,8777,'PORCENTAJE_FP_E','0.6','2016-04-01','2016-04-30',65),(986653,8777,'DIAS_COTIZADOS','12.0','2016-04-19','2016-04-30',65),(986654,8777,'HORAS_TRABAJADAS','36.0','2016-04-19','2016-04-30',65),(986752,8777,'DIAS_NATURALES_MES','31','2016-07-01','2016-07-31',69),(986753,8777,'GRUPO_COTIZACION','03','2016-07-01','2016-12-31',69),(986754,8777,'DIAS_PAGA','30.0','2016-07-01','2016-07-31',69),(986755,8777,'SALARIO_BASE','171.27440476190475','2016-07-01','2016-07-31',69),(986756,8777,'DIAS_TRABAJADOS','5.0','2016-07-01','2016-07-31',69),(986757,8777,'ANTIGUEDAD','0.0','2016-07-01','2016-07-31',69),(986758,8777,'DIAS_NATURALES_MES','31','2016-08-01','2016-08-31',69),(986759,8777,'DIAS_PAGA','30.0','2016-08-01','2016-08-31',69),(986760,8777,'SALARIO_BASE','171.27440476190475','2016-08-01','2016-08-31',69),(986761,8777,'DIAS_TRABAJADOS','5.0','2016-08-01','2016-08-31',69),(986762,8777,'ANTIGUEDAD','0.0','2016-08-01','2016-08-31',69),(986763,8777,'DIAS_NATURALES_MES','30','2016-09-01','2016-09-30',69),(986764,8777,'DIAS_PAGA','30.0','2016-09-01','2016-09-30',69),(986765,8777,'SALARIO_BASE','171.27440476190475','2016-09-01','2016-09-30',69),(986766,8777,'DIAS_TRABAJADOS','5.0','2016-09-01','2016-09-30',69),(986767,8777,'ANTIGUEDAD','0.0','2016-09-01','2016-09-30',69),(986768,8777,'DIAS_NATURALES_MES','31','2016-10-01','2016-10-31',69),(986769,8777,'DIAS_PAGA','30.0','2016-10-01','2016-10-31',69),(986770,8777,'SALARIO_BASE','171.27440476190475','2016-10-01','2016-10-31',69),(986771,8777,'DIAS_TRABAJADOS','5.0','2016-10-01','2016-10-31',69),(986772,8777,'ANTIGUEDAD','0.0','2016-10-01','2016-10-31',69),(986773,8777,'DIAS_NATURALES_MES','30','2016-11-01','2016-11-30',69),(986774,8777,'DIAS_PAGA','30.0','2016-11-01','2016-11-30',69),(986775,8777,'SALARIO_BASE','171.27440476190475','2016-11-01','2016-11-30',69),(986776,8777,'DIAS_TRABAJADOS','5.0','2016-11-01','2016-11-30',69),(986777,8777,'ANTIGUEDAD','0.0','2016-11-01','2016-11-30',69),(986778,8777,'DIAS_NATURALES_MES','31','2016-12-01','2016-12-31',69),(986779,8777,'DIAS_PAGA','30.0','2016-12-01','2016-12-31',69),(986780,8777,'SALARIO_BASE','171.27440476190475','2016-12-01','2016-12-31',69),(986781,8777,'DIAS_TRABAJADOS','5.0','2016-12-01','2016-12-31',69),(986782,8777,'ANTIGUEDAD','0.0','2016-12-01','2016-12-31',69),(986783,8777,'TC2','100','2016-07-01','2016-12-31',69),(986784,8777,'DIAS_COTIZADOS','30.0','2016-07-01','2016-07-31',69),(986785,8777,'DIAS_COTIZADOS','30.0','2016-08-01','2016-08-31',69),(986786,8777,'DIAS_COTIZADOS','30.0','2016-09-01','2016-09-30',69),(986787,8777,'DIAS_COTIZADOS','30.0','2016-10-01','2016-10-31',69),(986788,8777,'DIAS_COTIZADOS','30.0','2016-11-01','2016-11-30',69),(986789,8777,'DIAS_COTIZADOS','30.0','2016-12-01','2016-12-31',69),(986790,8777,'HORAS_TRABAJADAS','0.0','2016-07-01','2016-07-31',69),(986791,8777,'HORAS_TRABAJADAS','0.0','2016-08-01','2016-08-31',69),(986792,8777,'HORAS_TRABAJADAS','0.0','2016-09-01','2016-09-30',69),(986793,8777,'HORAS_TRABAJADAS','0.0','2016-10-01','2016-10-31',69),(986794,8777,'HORAS_TRABAJADAS','0.0','2016-11-01','2016-11-30',69),(986795,8777,'HORAS_TRABAJADAS','0.0','2016-12-01','2016-12-31',69),(986796,8777,'BASE_CGC_MIN','356.71999999999997','2016-05-18','2016-05-31',70),(986797,8777,'TC2','100','2016-05-18','2016-05-31',70),(986798,8777,'DIAS_COTIZADOS','14.0','2016-05-18','2016-05-31',70),(986799,8777,'DIAS_NATURALES_MES','31','2016-05-01','2016-05-31',70),(986800,8777,'TIEMPO_COMPLETO','true','2016-05-01','2016-05-31',70),(986801,8777,'GRUPO_COTIZACION','05','2016-05-18','2016-05-31',70),(986802,8777,'DIAS_MES','30.0','2016-05-18','2016-05-31',70),(986803,8777,'DIAS_NOMINA','14.0','2016-05-18','2016-05-31',70),(986804,8777,'BASE_CGC_MAX','1699.6000000000001','2016-05-18','2016-05-31',70),(986805,8777,'BASE_CGP_MIN','356.71999999999997','2016-05-18','2016-05-31',70),(986806,8777,'BASE_CGP_MAX','1699.6000000000001','2016-05-18','2016-05-31',70),(986807,8777,'COEFICIENTE_ERE','0.0','2016-05-18','2016-05-31',70),(986808,8777,'SALARIO_ANUAL','9172.800000000001','2016-05-18','2016-05-31',70),(986809,8777,'SMI','655.2','2016-05-01','2016-05-31',70),(986810,8777,'DIAS_HUELGA','0.0','2016-05-18','2016-05-31',70),(986811,8777,'DIAS_TRABAJADOS','14.0','2016-05-18','2016-05-31',70),(986812,8777,'PAGAS','12','2016-05-18','2016-05-31',70),(986813,8777,'BASE_CGC','356.7200000000001','2016-05-18','2016-05-31',70),(986814,8777,'PORCENTAJE_CGC','4.7','2016-05-01','2016-05-31',70),(986815,8777,'INDEFINIDO','true','2016-05-01','2016-05-31',70),(986816,8777,'BASE_CGP','356.7200000000001','2016-05-18','2016-05-31',70),(986817,8777,'PORCENTAJE_FP','0.1','2016-05-01','2016-05-31',70),(986818,8777,'BASE_CGC_E','356.7200000000001','2016-05-18','2016-05-31',70),(986819,8777,'PORCENTAJE_CGC_E','23.6','2016-05-01','2016-05-31',70),(986820,8777,'PORCENTAJE_EXTR_E','12.0','2016-05-01','2016-05-31',70),(986821,8777,'PORCENTAJE_NEXTR_E','23.6','2016-05-01','2016-05-31',70),(986822,8777,'BASE_CGP_E','356.7200000000001','2016-05-18','2016-05-31',70),(986823,8777,'TARIFA_IT','0.65','2016-05-01','2016-05-31',70),(986824,8777,'TARIFA_IMS','0.7','2016-05-01','2016-05-31',70),(986825,8777,'PORCENTAJE_FOGASA','0.2','2016-05-01','2016-05-31',70),(986826,8777,'PORCENTAJE_FP_E','0.6','2016-05-01','2016-05-31',70),(986827,8777,'HORAS_TRABAJADAS','0.0','2016-05-18','2016-05-31',70),(986828,8777,'BASE_CGC_MIN','356.72','2016-05-18','2016-05-31',71),(986829,8777,'TC2','100','2016-05-18','2016-05-31',71),(986830,8777,'DIAS_COTIZADOS','14.0','2016-05-18','2016-05-31',71),(986831,8777,'DIAS_NATURALES_MES','31','2016-05-01','2016-05-31',71),(986832,8777,'TIEMPO_COMPLETO','true','2016-05-01','2016-05-31',71),(986833,8777,'GRUPO_COTIZACION','09','2016-05-18','2016-05-31',71),(986834,8777,'DIAS_MES','31.0','2016-05-18','2016-05-31',71),(986835,8777,'BASE_CGP_MIN','356.71999999999997','2016-05-18','2016-05-31',71),(986836,8777,'COEFICIENTE_ERE','0.0','2016-05-18','2016-05-31',71),(986837,8777,'SALARIO_ANUAL','9172.800000000001','2016-05-18','2016-05-31',71),(986838,8777,'SMI','655.2','2016-05-01','2016-05-31',71),(986839,8777,'DIAS_HUELGA','0.0','2016-05-18','2016-05-31',71),(986840,8777,'DIAS_TRABAJADOS','14.0','2016-05-18','2016-05-31',71),(986841,8777,'PAGAS','14','2016-05-18','2016-05-31',71),(986842,8777,'SALARIO_BASE','295.8967741935484','2016-05-18','2016-05-31',71),(986843,8777,'BASE_CGC','356.72','2016-05-18','2016-05-31',71),(986844,8777,'PORCENTAJE_CGC','4.7','2016-05-01','2016-05-31',71),(986845,8777,'INDEFINIDO','true','2016-05-01','2016-05-31',71),(986846,8777,'BASE_CGP','356.71999999999997','2016-05-18','2016-05-31',71),(986847,8777,'PORCENTAJE_FP','0.1','2016-05-01','2016-05-31',71),(986848,8777,'BASE_CGC_E','356.72','2016-05-18','2016-05-31',71),(986849,8777,'PORCENTAJE_CGC_E','23.6','2016-05-01','2016-05-31',71),(986850,8777,'PORCENTAJE_EXTR_E','12.0','2016-05-01','2016-05-31',71),(986851,8777,'PORCENTAJE_NEXTR_E','23.6','2016-05-01','2016-05-31',71),(986852,8777,'BASE_CGP_E','356.71999999999997','2016-05-18','2016-05-31',71),(986853,8777,'TARIFA_IT','0.65','2016-05-01','2016-05-31',71),(986854,8777,'TARIFA_IMS','0.7','2016-05-01','2016-05-31',71),(986855,8777,'PORCENTAJE_FOGASA','0.2','2016-05-01','2016-05-31',71),(986856,8777,'PORCENTAJE_FP_E','0.6','2016-05-01','2016-05-31',71),(986857,8777,'HORAS_TRABAJADAS','0.0','2016-05-18','2016-05-31',71),(986858,8777,'BASE_CGC_MIN','359.38','2016-05-18','2016-05-31',72),(986859,8777,'TC2','100','2016-05-18','2016-05-31',72),(986860,8777,'DIAS_COTIZADOS','14.0','2016-05-18','2016-05-31',72),(986861,8777,'DIAS_NATURALES_MES','31','2016-05-01','2016-05-31',72),(986862,8777,'TIEMPO_COMPLETO','true','2016-05-01','2016-05-31',72),(986863,8777,'GRUPO_COTIZACION','03','2016-05-18','2016-05-31',72),(986864,8777,'DIAS_MES','30.0','2016-05-18','2016-05-31',72),(986865,8777,'BASE_CGP_MIN','356.71999999999997','2016-05-18','2016-05-31',72),(986866,8777,'PLUS_EXTRA_SALARIAL','0.0','2016-05-01','2016-05-31',72),(986867,8777,'DIAS_NOMINA','14.0','2016-05-18','2016-05-31',72),(986868,8777,'BASE_CGC_MAX','1699.6000000000001','2016-05-18','2016-05-31',72),(986869,8777,'BASE_CGP_MAX','1699.6000000000001','2016-05-18','2016-05-31',72),(986870,8777,'COEFICIENTE_ERE','0.0','2016-05-18','2016-05-31',72),(986871,8777,'SALARIO_ANUAL','14387.05','2016-05-01','2016-05-31',72),(986872,8777,'DIAS_HUELGA','0.0','2016-05-18','2016-05-31',72),(986873,8777,'DIAS_TRABAJADOS','14.0','2016-05-18','2016-05-31',72),(986874,8777,'PAGAS','14','2016-05-01','2016-05-31',72),(986875,8777,'SALARIO_BASE','479.5683333333333','2016-05-18','2016-05-31',72),(986876,8777,'DIAS_PAGA','30.0','2016-05-18','2016-05-31',72),(986877,8777,'ANTIGUEDAD','0.0','2016-05-18','2016-05-31',72),(986878,8777,'BASE_CGC','650.842738095238','2016-05-18','2016-05-31',72),(986879,8777,'PORCENTAJE_CGC','4.7','2016-05-01','2016-05-31',72),(986880,8777,'INDEFINIDO','true','2016-05-01','2016-05-31',72),(986881,8777,'BASE_CGP','650.842738095238','2016-05-18','2016-05-31',72),(986882,8777,'PORCENTAJE_FP','0.1','2016-05-01','2016-05-31',72),(986883,8777,'BASE_CGC_E','650.842738095238','2016-05-18','2016-05-31',72),(986884,8777,'PORCENTAJE_CGC_E','23.6','2016-05-01','2016-05-31',72),(986885,8777,'PORCENTAJE_EXTR_E','12.0','2016-05-01','2016-05-31',72),(986886,8777,'PORCENTAJE_NEXTR_E','23.6','2016-05-01','2016-05-31',72),(986887,8777,'BASE_CGP_E','650.842738095238','2016-05-18','2016-05-31',72),(986888,8777,'TARIFA_IT','0.65','2016-05-01','2016-05-31',72),(986889,8777,'TARIFA_IMS','0.7','2016-05-01','2016-05-31',72),(986890,8777,'PORCENTAJE_FOGASA','0.2','2016-05-01','2016-05-31',72),(986891,8777,'PORCENTAJE_FP_E','0.6','2016-05-01','2016-05-31',72),(986892,8777,'HORAS_TRABAJADAS','0.0','2016-05-18','2016-05-31',72),(986893,8784,'BASE_CGC_MIN','770.1','2016-06-01','2016-06-30',73),(986894,8784,'TC2','401','2016-06-01','2016-06-30',73),(986895,8784,'DIAS_COTIZADOS','30.0','2016-06-01','2016-06-30',73),(986896,8784,'DIAS_NATURALES_MES','30','2016-06-01','2016-06-30',73),(986897,8784,'TIEMPO_COMPLETO','true','2016-06-01','2016-06-30',73),(986898,8784,'GRUPO_COTIZACION','03','2016-06-01','2016-06-30',73),(986899,8784,'DIAS_MES','30.0','2016-06-01','2016-06-30',73),(986900,8784,'DIAS_NOMINA','30.0','2016-06-01','2016-06-30',73),(986901,8784,'BASE_CGC_MAX','3642.0','2016-06-01','2016-06-30',73),(986902,8784,'BASE_CGP_MIN','764.4','2016-06-01','2016-06-30',73),(986903,8784,'BASE_CGP_MAX','3642.0','2016-06-01','2016-06-30',73),(986904,8784,'COEFICIENTE_ERE','0.0','2016-06-01','2016-06-30',73),(986905,8784,'DIAS_HUELGA','0.0','2016-06-01','2016-06-30',73),(986906,8784,'SALARIO_MENSUAL','1614.59','2016-06-01','2016-06-30',73),(986907,8784,'DIAS_TRABAJADOS','30.0','2016-06-01','2016-06-30',73),(986908,8784,'SALARIO_BASE','1614.59','2016-06-01','2016-06-30',73),(986909,8784,'ANTIGUEDAD','0.0','2016-06-01','2016-06-30',73),(986910,8784,'GARANTIZADO','0.0','2016-06-01','2016-06-30',73),(986911,8784,'BASE_CGC','1883.6883333333333','2016-06-01','2016-06-30',73),(986912,8784,'PORCENTAJE_CGC','4.7','2016-06-01','2016-06-30',73),(986913,8784,'INDEFINIDO','false','2016-06-01','2016-06-30',73),(986914,8784,'BASE_CGP','1883.6883333333333','2016-06-01','2016-06-30',73),(986915,8784,'PORCENTAJE_FP','0.1','2016-06-01','2016-06-30',73),(986916,8784,'BASE_CGC_E','1883.6883333333333','2016-06-01','2016-06-30',73),(986917,8784,'PORCENTAJE_CGC_E','23.6','2016-06-01','2016-06-30',73),(986918,8784,'PORCENTAJE_EXTR_E','12.0','2016-06-01','2016-06-30',73),(986919,8784,'PORCENTAJE_NEXTR_E','23.6','2016-06-01','2016-06-30',73),(986920,8784,'BASE_CGP_E','1883.6883333333333','2016-06-01','2016-06-30',73),(986921,8784,'TARIFA_IT','0.75','2016-06-01','2016-06-30',73),(986922,8784,'TARIFA_IMS','0.5','2016-06-01','2016-06-30',73),(986923,8784,'PORCENTAJE_FOGASA','0.2','2016-06-01','2016-06-30',73),(986924,8784,'PORCENTAJE_FP_E','0.6','2016-06-01','2016-06-30',73),(986925,8784,'HORAS_TRABAJADAS','0.0','2016-06-01','2016-06-30',73),(986926,8784,'BASE_CGC_MIN','356.72','2016-05-18','2016-05-31',74),(986927,8784,'TC2','100','2016-05-18','2016-05-31',74),(986928,8784,'DIAS_COTIZADOS','14.0','2016-05-18','2016-05-31',74),(986929,8784,'DIAS_NATURALES_MES','31','2016-05-01','2016-05-31',74),(986930,8784,'TIEMPO_COMPLETO','true','2016-05-18','2016-05-31',74),(986931,8784,'GRUPO_COTIZACION','08','2016-05-18','2016-05-31',74),(986932,8784,'DIAS_MES','31.0','2016-05-18','2016-05-31',74),(986933,8784,'DIAS_NOMINA','14.0','2016-05-18','2016-05-31',74),(986934,8784,'BASE_CGC_MAX','1699.6000000000001','2016-05-18','2016-05-31',74),(986935,8784,'BASE_CGP_MIN','356.71999999999997','2016-05-18','2016-05-31',74),(986936,8784,'BASE_CGP_MAX','1699.6000000000001','2016-05-18','2016-05-31',74),(986937,8784,'COEFICIENTE_ERE','0.0','2016-05-18','2016-05-31',74),(986938,8784,'DIAS_HUELGA','0.0','2016-05-18','2016-05-31',74),(986939,8784,'SALARIO_MENSUAL','1294.92','2016-05-18','2016-05-31',74),(986940,8784,'DIAS_TRABAJADOS','14.0','2016-05-18','2016-05-31',74),(986941,8784,'SALARIO_BASE','584.8025806451614','2016-05-18','2016-05-31',74),(986942,8784,'ANTIGUEDAD','0.0','2016-05-18','2016-05-31',74),(986943,8784,'GARANTIZADO','0.0','2016-05-18','2016-05-31',74),(986944,8784,'BASE_CGC','682.2696774193549','2016-05-18','2016-05-31',74),(986945,8784,'PORCENTAJE_CGC','4.7','2016-05-18','2016-05-31',74),(986946,8784,'INDEFINIDO','true','2016-05-18','2016-05-31',74),(986947,8784,'BASE_CGP','682.2696774193549','2016-05-18','2016-05-31',74),(986948,8784,'PORCENTAJE_FP','0.1','2016-05-18','2016-05-31',74),(986949,8784,'BASE_CGC_E','682.2696774193549','2016-05-18','2016-05-31',74),(986950,8784,'PORCENTAJE_CGC_E','23.6','2016-05-18','2016-05-31',74),(986951,8784,'PORCENTAJE_EXTR_E','12.0','2016-05-18','2016-05-31',74),(986952,8784,'PORCENTAJE_NEXTR_E','23.6','2016-05-18','2016-05-31',74),(986953,8784,'BASE_CGP_E','682.2696774193549','2016-05-18','2016-05-31',74),(986954,8784,'TARIFA_IT','0.75','2016-05-18','2016-05-31',74),(986955,8784,'TARIFA_IMS','0.5','2016-05-18','2016-05-31',74),(986956,8784,'PORCENTAJE_FOGASA','0.2','2016-05-18','2016-05-31',74),(986957,8784,'PORCENTAJE_FP_E','0.6','2016-05-18','2016-05-31',74),(986958,8784,'HORAS_TRABAJADAS','0.0','2016-05-18','2016-05-31',74),(986959,8777,'BASE_CGC_MIN','764.4','2016-06-01','2016-06-30',75),(986960,8777,'TC2','100','2016-06-01','2016-06-30',75),(986961,8777,'DIAS_COTIZADOS','30.0','2016-06-01','2016-06-30',75),(986962,8777,'DIAS_NATURALES_MES','30','2016-06-01','2016-06-30',75),(986963,8777,'TIEMPO_COMPLETO','true','2016-06-01','2016-06-30',75),(986964,8777,'GRUPO_COTIZACION','04','2016-06-01','2016-06-30',75),(986965,8777,'DIAS_MES','30.0','2016-06-01','2016-06-30',75),(986966,8777,'DIAS_NOMINA','30.0','2016-06-01','2016-06-30',75),(986967,8777,'BASE_CGC_MAX','3642.0','2016-06-01','2016-06-30',75),(986968,8777,'BASE_CGP_MIN','764.4','2016-06-01','2016-06-30',75),(986969,8777,'BASE_CGP_MAX','3642.0','2016-06-01','2016-06-30',75),(986970,8777,'COEFICIENTE_ERE','0.0','2016-06-01','2016-06-30',75),(986971,8777,'DIAS_HUELGA','0.0','2016-06-01','2016-06-30',75),(986972,8777,'SALARIO_MENSUAL','1684.8','2016-06-01','2016-06-30',75),(986973,8777,'SMI','655.2','2016-06-01','2016-06-30',75),(986974,8777,'DIAS_TRABAJADOS','30.0','2016-06-01','2016-06-30',75),(986975,8777,'SALARIO_BASE','1684.8','2016-06-01','2016-06-30',75),(986976,8777,'BASE_CGC','1925.4857142857143','2016-06-01','2016-06-30',75),(986977,8777,'PORCENTAJE_CGC','4.7','2016-06-01','2016-06-30',75),(986978,8777,'INDEFINIDO','true','2016-06-01','2016-06-30',75),(986979,8777,'BASE_CGP','1925.4857142857143','2016-06-01','2016-06-30',75),(986980,8777,'PORCENTAJE_FP','0.1','2016-06-01','2016-06-30',75),(986981,8777,'NOMINA','true','2016-06-01','2016-06-30',75),(986982,8777,'EMBARGADO','0.0','2016-06-01','2016-06-30',75),(986983,8777,'BASE_CGC_E','1925.4857142857143','2016-06-01','2016-06-30',75),(986984,8777,'PORCENTAJE_CGC_E','23.6','2016-06-01','2016-06-30',75),(986985,8777,'PORCENTAJE_EXTR_E','12.0','2016-06-01','2016-06-30',75),(986986,8777,'PORCENTAJE_NEXTR_E','23.6','2016-06-01','2016-06-30',75),(986987,8777,'BASE_CGP_E','1925.4857142857143','2016-06-01','2016-06-30',75),(986988,8777,'TARIFA_IT','0.65','2016-06-01','2016-06-30',75),(986989,8777,'TARIFA_IMS','0.7','2016-06-01','2016-06-30',75),(986990,8777,'PORCENTAJE_FOGASA','0.2','2016-06-01','2016-06-30',75),(986991,8777,'PORCENTAJE_FP_E','0.6','2016-06-01','2016-06-30',75),(986992,8777,'HORAS_TRABAJADAS','0.0','2016-06-01','2016-06-30',75),(987029,8777,'BASE_CGC_MIN','758.7','2015-02-01','2015-02-28',77),(987030,8777,'DIAS_NOMINA','30.0','2015-02-01','2015-02-28',77),(987031,8777,'TC2','100','2015-02-01','2015-02-28',77),(987032,8777,'DIAS_NATURALES_MES','28','2015-02-01','2015-02-28',77),(987033,8777,'TIEMPO_COMPLETO','true','2015-02-01','2015-02-28',77),(987034,8777,'GRUPO_COTIZACION','03','2015-02-01','2015-02-28',77),(987035,8777,'DIAS_MES','30.0','2015-02-01','2015-02-28',77),(987036,8777,'BASE_CGC_MAX','3597.0','2015-02-01','2015-02-28',77),(987037,8777,'BASE_CGP_MIN','753.0','2015-02-01','2015-02-28',77),(987038,8777,'BASE_CGP_MAX','3597.0','2015-02-01','2015-02-28',77),(987039,8777,'COEFICIENTE_ERE','0.0','2015-02-01','2015-02-28',77),(987040,8777,'SALARIO_ANUAL','27102.6','2015-02-01','2015-02-28',77),(987041,8777,'PAGAS','14','2015-02-01','2015-02-28',77),(987042,8777,'SMI','645.3','2015-02-01','2015-02-28',77),(987043,8777,'DIAS_HUELGA','0.0','2015-02-01','2015-02-28',77),(987044,8777,'DIAS_TRABAJADOS','30.0','2015-02-01','2015-02-28',77),(987045,8777,'AÑOS_ANTIGUEDAD','2','2015-02-01','2015-02-28',77),(987046,8777,'TRIENIO','THREE','2015-02-01','2015-02-28',77),(987047,8777,'SALARIO_BASE','1935.8999999999999','2015-02-01','2015-02-28',77),(987048,8777,'ANTIGUEDAD','0.0','2015-02-01','2015-02-28',77),(987049,8777,'BASE_CGC','2258.5499999999993','2015-02-01','2015-02-28',77),(987050,8777,'PORCENTAJE_CGC','4.7','2015-02-01','2015-02-28',77),(987051,8777,'INDEFINIDO','true','2015-02-01','2015-02-28',77),(987052,8777,'BASE_CGP','2258.5499999999993','2015-02-01','2015-02-28',77),(987053,8777,'PORCENTAJE_FP','0.1','2015-02-01','2015-02-28',77),(987054,8777,'BASE_CGC_E','2258.5499999999993','2015-02-01','2015-02-28',77),(987055,8777,'PORCENTAJE_CGC_E','23.6','2015-02-01','2015-02-28',77),(987056,8777,'PORCENTAJE_EXTR_E','12.0','2015-02-01','2015-02-28',77),(987057,8777,'PORCENTAJE_NEXTR_E','23.6','2015-02-01','2015-02-28',77),(987058,8777,'BASE_CGP_E','2258.5499999999993','2015-02-01','2015-02-28',77),(987059,8777,'TARIFA_IT','0.65','2015-02-01','2015-02-28',77),(987060,8777,'TARIFA_IMS','0.7','2015-02-01','2015-02-28',77),(987061,8777,'PORCENTAJE_FOGASA','0.2','2015-02-01','2015-02-28',77),(987062,8777,'PORCENTAJE_FP_E','0.6','2015-02-01','2015-02-28',77),(987063,8777,'DIAS_COTIZADOS','30.0','2015-02-01','2015-02-28',77),(987064,8777,'HORAS_TRABAJADAS','0.0','2015-02-01','2015-02-28',77),(987065,8777,'BASE_CGC_MIN','758.7','2015-03-01','2015-03-31',78),(987066,8777,'DIAS_NOMINA','30.0','2015-03-01','2015-03-31',78),(987067,8777,'TC2','100','2015-03-01','2015-03-31',78),(987068,8777,'DIAS_NATURALES_MES','31','2015-03-01','2015-03-31',78),(987069,8777,'TIEMPO_COMPLETO','true','2015-03-01','2015-03-31',78),(987070,8777,'GRUPO_COTIZACION','03','2015-03-01','2015-03-31',78),(987071,8777,'DIAS_MES','30.0','2015-03-01','2015-03-31',78),(987072,8777,'BASE_CGC_MAX','3597.0','2015-03-01','2015-03-31',78),(987073,8777,'BASE_CGP_MIN','753.0','2015-03-01','2015-03-31',78),(987074,8777,'BASE_CGP_MAX','3597.0','2015-03-01','2015-03-31',78),(987075,8777,'COEFICIENTE_ERE','0.0','2015-03-01','2015-03-31',78),(987076,8777,'SALARIO_ANUAL','27102.6','2015-03-01','2015-03-31',78),(987077,8777,'PAGAS','14','2015-03-01','2015-03-31',78),(987078,8777,'SMI','645.3','2015-03-01','2015-03-31',78),(987079,8777,'DIAS_HUELGA','0.0','2015-03-01','2015-03-31',78),(987080,8777,'DIAS_TRABAJADOS','30.0','2015-03-01','2015-03-31',78),(987081,8777,'AÑOS_ANTIGUEDAD','3','2015-03-01','2015-03-31',78),(987082,8777,'TRIENIO','THREE','2015-03-01','2015-03-31',78),(987083,8777,'SALARIO_BASE','1935.8999999999999','2015-03-01','2015-03-31',78),(987084,8777,'ANTIGUEDAD','77.43599999999999','2015-03-01','2015-03-31',78),(987085,8777,'BASE_CGC','2348.8919999999994','2015-03-01','2015-03-31',78),(987086,8777,'PORCENTAJE_CGC','4.7','2015-03-01','2015-03-31',78),(987087,8777,'INDEFINIDO','true','2015-03-01','2015-03-31',78),(987088,8777,'BASE_CGP','2348.8919999999994','2015-03-01','2015-03-31',78),(987089,8777,'PORCENTAJE_FP','0.1','2015-03-01','2015-03-31',78),(987090,8777,'BASE_CGC_E','2348.8919999999994','2015-03-01','2015-03-31',78),(987091,8777,'PORCENTAJE_CGC_E','23.6','2015-03-01','2015-03-31',78),(987092,8777,'PORCENTAJE_EXTR_E','12.0','2015-03-01','2015-03-31',78),(987093,8777,'PORCENTAJE_NEXTR_E','23.6','2015-03-01','2015-03-31',78),(987094,8777,'BASE_CGP_E','2348.8919999999994','2015-03-01','2015-03-31',78),(987095,8777,'TARIFA_IT','0.65','2015-03-01','2015-03-31',78),(987096,8777,'TARIFA_IMS','0.7','2015-03-01','2015-03-31',78),(987097,8777,'PORCENTAJE_FOGASA','0.2','2015-03-01','2015-03-31',78),(987098,8777,'PORCENTAJE_FP_E','0.6','2015-03-01','2015-03-31',78),(987099,8777,'DIAS_COTIZADOS','30.0','2015-03-01','2015-03-31',78),(987100,8777,'HORAS_TRABAJADAS','0.0','2015-03-01','2015-03-31',78),(987101,8777,'BASE_CGC_MIN','758.7','2015-04-01','2015-04-30',79),(987102,8777,'DIAS_NOMINA','30.0','2015-04-01','2015-04-30',79),(987103,8777,'TC2','100','2015-04-01','2015-04-30',79),(987104,8777,'DIAS_NATURALES_MES','30','2015-04-01','2015-04-30',79),(987105,8777,'TIEMPO_COMPLETO','true','2015-04-01','2015-04-30',79),(987106,8777,'GRUPO_COTIZACION','03','2015-04-01','2015-04-30',79),(987107,8777,'DIAS_MES','30.0','2015-04-01','2015-04-30',79),(987108,8777,'BASE_CGC_MAX','3597.0','2015-04-01','2015-04-30',79),(987109,8777,'BASE_CGP_MIN','753.0','2015-04-01','2015-04-30',79),(987110,8777,'BASE_CGP_MAX','3597.0','2015-04-01','2015-04-30',79),(987111,8777,'COEFICIENTE_ERE','0.0','2015-04-01','2015-04-30',79),(987112,8777,'SALARIO_ANUAL','27102.6','2015-04-01','2015-04-30',79),(987113,8777,'PAGAS','14','2015-04-01','2015-04-30',79),(987114,8777,'SMI','645.3','2015-04-01','2015-04-30',79),(987115,8777,'DIAS_HUELGA','0.0','2015-04-01','2015-04-30',79),(987116,8777,'DIAS_TRABAJADOS','30.0','2015-04-01','2015-04-30',79),(987117,8777,'AÑOS_ANTIGUEDAD','3','2015-04-01','2015-04-30',79),(987118,8777,'TRIENIO','THREE','2015-04-01','2015-04-30',79),(987119,8777,'SALARIO_BASE','1935.8999999999999','2015-04-01','2015-04-30',79),(987120,8777,'ANTIGUEDAD','77.43599999999999','2015-04-01','2015-04-30',79),(987121,8777,'BASE_CGC','2348.892','2015-04-01','2015-04-30',79),(987122,8777,'PORCENTAJE_CGC','4.7','2015-04-01','2015-04-30',79),(987123,8777,'INDEFINIDO','true','2015-04-01','2015-04-30',79),(987124,8777,'BASE_CGP','2348.892','2015-04-01','2015-04-30',79),(987125,8777,'PORCENTAJE_FP','0.1','2015-04-01','2015-04-30',79),(987126,8777,'BASE_CGC_E','2348.892','2015-04-01','2015-04-30',79),(987127,8777,'PORCENTAJE_CGC_E','23.6','2015-04-01','2015-04-30',79),(987128,8777,'PORCENTAJE_EXTR_E','12.0','2015-04-01','2015-04-30',79),(987129,8777,'PORCENTAJE_NEXTR_E','23.6','2015-04-01','2015-04-30',79),(987130,8777,'BASE_CGP_E','2348.892','2015-04-01','2015-04-30',79),(987131,8777,'TARIFA_IT','0.65','2015-04-01','2015-04-30',79),(987132,8777,'TARIFA_IMS','0.7','2015-04-01','2015-04-30',79),(987133,8777,'PORCENTAJE_FOGASA','0.2','2015-04-01','2015-04-30',79),(987134,8777,'PORCENTAJE_FP_E','0.6','2015-04-01','2015-04-30',79),(987135,8777,'DIAS_COTIZADOS','30.0','2015-04-01','2015-04-30',79),(987136,8777,'HORAS_TRABAJADAS','0.0','2015-04-01','2015-04-30',79),(987137,8777,'BASE_CGC_MIN','758.7','2015-05-01','2015-05-31',80),(987138,8777,'DIAS_NOMINA','30.0','2015-05-01','2015-05-31',80),(987139,8777,'TC2','100','2015-05-01','2015-05-31',80),(987140,8777,'DIAS_NATURALES_MES','31','2015-05-01','2015-05-31',80),(987141,8777,'TIEMPO_COMPLETO','true','2015-05-01','2015-05-31',80),(987142,8777,'GRUPO_COTIZACION','03','2015-05-01','2015-05-31',80),(987143,8777,'DIAS_MES','30.0','2015-05-01','2015-05-31',80),(987144,8777,'BASE_CGC_MAX','3597.0','2015-05-01','2015-05-31',80),(987145,8777,'BASE_CGP_MIN','753.0','2015-05-01','2015-05-31',80),(987146,8777,'BASE_CGP_MAX','3597.0','2015-05-01','2015-05-31',80),(987147,8777,'COEFICIENTE_ERE','0.0','2015-05-01','2015-05-31',80),(987148,8777,'SALARIO_ANUAL','27102.6','2015-05-01','2015-05-31',80),(987149,8777,'PAGAS','14','2015-05-01','2015-05-31',80),(987150,8777,'SMI','645.3','2015-05-01','2015-05-31',80),(987151,8777,'DIAS_HUELGA','0.0','2015-05-01','2015-05-31',80),(987152,8777,'DIAS_TRABAJADOS','30.0','2015-05-01','2015-05-31',80),(987153,8777,'AÑOS_ANTIGUEDAD','3','2015-05-01','2015-05-31',80),(987154,8777,'TRIENIO','THREE','2015-05-01','2015-05-31',80),(987155,8777,'SALARIO_BASE','1935.8999999999999','2015-05-01','2015-05-31',80),(987156,8777,'ANTIGUEDAD','77.43599999999999','2015-05-01','2015-05-31',80),(987157,8777,'BASE_CGC','2348.8919999999994','2015-05-01','2015-05-31',80),(987158,8777,'PORCENTAJE_CGC','4.7','2015-05-01','2015-05-31',80),(987159,8777,'INDEFINIDO','true','2015-05-01','2015-05-31',80),(987160,8777,'BASE_CGP','2348.8919999999994','2015-05-01','2015-05-31',80),(987161,8777,'PORCENTAJE_FP','0.1','2015-05-01','2015-05-31',80),(987162,8777,'BASE_CGC_E','2348.8919999999994','2015-05-01','2015-05-31',80),(987163,8777,'PORCENTAJE_CGC_E','23.6','2015-05-01','2015-05-31',80),(987164,8777,'PORCENTAJE_EXTR_E','12.0','2015-05-01','2015-05-31',80),(987165,8777,'PORCENTAJE_NEXTR_E','23.6','2015-05-01','2015-05-31',80),(987166,8777,'BASE_CGP_E','2348.8919999999994','2015-05-01','2015-05-31',80),(987167,8777,'TARIFA_IT','0.65','2015-05-01','2015-05-31',80),(987168,8777,'TARIFA_IMS','0.7','2015-05-01','2015-05-31',80),(987169,8777,'PORCENTAJE_FOGASA','0.2','2015-05-01','2015-05-31',80),(987170,8777,'PORCENTAJE_FP_E','0.6','2015-05-01','2015-05-31',80),(987171,8777,'DIAS_COTIZADOS','30.0','2015-05-01','2015-05-31',80),(987172,8777,'HORAS_TRABAJADAS','0.0','2015-05-01','2015-05-31',80),(987173,8777,'BASE_CGC_MIN','758.7','2015-06-01','2015-06-30',81),(987174,8777,'DIAS_NOMINA','30.0','2015-06-01','2015-06-30',81),(987175,8777,'TC2','100','2015-06-01','2015-06-30',81),(987176,8777,'DIAS_NATURALES_MES','30','2015-06-01','2015-06-30',81),(987177,8777,'TIEMPO_COMPLETO','true','2015-06-01','2015-06-30',81),(987178,8777,'GRUPO_COTIZACION','03','2015-06-01','2015-06-30',81),(987179,8777,'DIAS_MES','30.0','2015-06-01','2015-06-30',81),(987180,8777,'BASE_CGC_MAX','3597.0','2015-06-01','2015-06-30',81),(987181,8777,'BASE_CGP_MIN','753.0','2015-06-01','2015-06-30',81),(987182,8777,'BASE_CGP_MAX','3597.0','2015-06-01','2015-06-30',81),(987183,8777,'COEFICIENTE_ERE','0.0','2015-06-01','2015-06-30',81),(987184,8777,'SALARIO_ANUAL','27102.6','2015-06-01','2015-06-30',81),(987185,8777,'PAGAS','14','2015-06-01','2015-06-30',81),(987186,8777,'SMI','645.3','2015-06-01','2015-06-30',81),(987187,8777,'DIAS_HUELGA','0.0','2015-06-01','2015-06-30',81),(987188,8777,'DIAS_TRABAJADOS','30.0','2015-06-01','2015-06-30',81),(987189,8777,'AÑOS_ANTIGUEDAD','3','2015-06-01','2015-06-30',81),(987190,8777,'TRIENIO','THREE','2015-06-01','2015-06-30',81),(987191,8777,'SALARIO_BASE','1935.8999999999999','2015-06-01','2015-06-30',81),(987192,8777,'ANTIGUEDAD','77.43599999999999','2015-06-01','2015-06-30',81),(987193,8777,'BASE_CGC','2348.892','2015-06-01','2015-06-30',81),(987194,8777,'PORCENTAJE_CGC','4.7','2015-06-01','2015-06-30',81),(987195,8777,'INDEFINIDO','true','2015-06-01','2015-06-30',81),(987196,8777,'BASE_CGP','2348.892','2015-06-01','2015-06-30',81),(987197,8777,'PORCENTAJE_FP','0.1','2015-06-01','2015-06-30',81),(987198,8777,'BASE_CGC_E','2348.892','2015-06-01','2015-06-30',81),(987199,8777,'PORCENTAJE_CGC_E','23.6','2015-06-01','2015-06-30',81),(987200,8777,'PORCENTAJE_EXTR_E','12.0','2015-06-01','2015-06-30',81),(987201,8777,'PORCENTAJE_NEXTR_E','23.6','2015-06-01','2015-06-30',81),(987202,8777,'BASE_CGP_E','2348.892','2015-06-01','2015-06-30',81),(987203,8777,'TARIFA_IT','0.65','2015-06-01','2015-06-30',81),(987204,8777,'TARIFA_IMS','0.7','2015-06-01','2015-06-30',81),(987205,8777,'PORCENTAJE_FOGASA','0.2','2015-06-01','2015-06-30',81),(987206,8777,'PORCENTAJE_FP_E','0.6','2015-06-01','2015-06-30',81),(987207,8777,'DIAS_COTIZADOS','30.0','2015-06-01','2015-06-30',81),(987208,8777,'HORAS_TRABAJADAS','0.0','2015-06-01','2015-06-30',81),(987209,8777,'BASE_CGC_MIN','758.7','2015-07-01','2015-07-31',82),(987210,8777,'DIAS_NOMINA','30.0','2015-07-01','2015-07-31',82),(987211,8777,'TC2','100','2015-07-01','2015-07-31',82),(987212,8777,'DIAS_NATURALES_MES','31','2015-07-01','2015-07-31',82),(987213,8777,'TIEMPO_COMPLETO','true','2015-07-01','2015-07-31',82),(987214,8777,'GRUPO_COTIZACION','03','2015-07-01','2015-07-31',82),(987215,8777,'DIAS_MES','30.0','2015-07-01','2015-07-31',82),(987216,8777,'BASE_CGC_MAX','3597.0','2015-07-01','2015-07-31',82),(987217,8777,'BASE_CGP_MIN','753.0','2015-07-01','2015-07-31',82),(987218,8777,'BASE_CGP_MAX','3597.0','2015-07-01','2015-07-31',82),(987219,8777,'COEFICIENTE_ERE','0.0','2015-07-01','2015-07-31',82),(987220,8777,'SALARIO_ANUAL','27102.6','2015-07-01','2015-07-31',82),(987221,8777,'PAGAS','14','2015-07-01','2015-07-31',82),(987222,8777,'SMI','645.3','2015-07-01','2015-07-31',82),(987223,8777,'DIAS_HUELGA','0.0','2015-07-01','2015-07-31',82),(987224,8777,'DIAS_TRABAJADOS','30.0','2015-07-01','2015-07-31',82),(987225,8777,'AÑOS_ANTIGUEDAD','3','2015-07-01','2015-07-31',82),(987226,8777,'TRIENIO','THREE','2015-07-01','2015-07-31',82),(987227,8777,'SALARIO_BASE','1935.8999999999999','2015-07-01','2015-07-31',82),(987228,8777,'ANTIGUEDAD','77.43599999999999','2015-07-01','2015-07-31',82),(987229,8777,'BASE_CGC','2348.8919999999994','2015-07-01','2015-07-31',82),(987230,8777,'PORCENTAJE_CGC','4.7','2015-07-01','2015-07-31',82),(987231,8777,'INDEFINIDO','true','2015-07-01','2015-07-31',82),(987232,8777,'BASE_CGP','2348.8919999999994','2015-07-01','2015-07-31',82),(987233,8777,'PORCENTAJE_FP','0.1','2015-07-01','2015-07-31',82),(987234,8777,'BASE_CGC_E','2348.8919999999994','2015-07-01','2015-07-31',82),(987235,8777,'PORCENTAJE_CGC_E','23.6','2015-07-01','2015-07-31',82),(987236,8777,'PORCENTAJE_EXTR_E','12.0','2015-07-01','2015-07-31',82),(987237,8777,'PORCENTAJE_NEXTR_E','23.6','2015-07-01','2015-07-31',82),(987238,8777,'BASE_CGP_E','2348.8919999999994','2015-07-01','2015-07-31',82),(987239,8777,'TARIFA_IT','0.65','2015-07-01','2015-07-31',82),(987240,8777,'TARIFA_IMS','0.7','2015-07-01','2015-07-31',82),(987241,8777,'PORCENTAJE_FOGASA','0.2','2015-07-01','2015-07-31',82),(987242,8777,'PORCENTAJE_FP_E','0.6','2015-07-01','2015-07-31',82),(987243,8777,'DIAS_COTIZADOS','30.0','2015-07-01','2015-07-31',82),(987244,8777,'HORAS_TRABAJADAS','0.0','2015-07-01','2015-07-31',82),(987245,8777,'BASE_CGC_MIN','758.7','2015-08-01','2015-08-31',83),(987246,8777,'DIAS_NOMINA','30.0','2015-08-01','2015-08-31',83),(987247,8777,'TC2','100','2015-08-01','2015-08-31',83),(987248,8777,'DIAS_NATURALES_MES','31','2015-08-01','2015-08-31',83),(987249,8777,'TIEMPO_COMPLETO','true','2015-08-01','2015-08-31',83),(987250,8777,'GRUPO_COTIZACION','03','2015-08-01','2015-08-31',83),(987251,8777,'DIAS_MES','30.0','2015-08-01','2015-08-31',83),(987252,8777,'BASE_CGC_MAX','3597.0','2015-08-01','2015-08-31',83),(987253,8777,'BASE_CGP_MIN','753.0','2015-08-01','2015-08-31',83),(987254,8777,'BASE_CGP_MAX','3597.0','2015-08-01','2015-08-31',83),(987255,8777,'COEFICIENTE_ERE','0.0','2015-08-01','2015-08-31',83),(987256,8777,'SALARIO_ANUAL','27102.6','2015-08-01','2015-08-31',83),(987257,8777,'PAGAS','14','2015-08-01','2015-08-31',83),(987258,8777,'SMI','645.3','2015-08-01','2015-08-31',83),(987259,8777,'DIAS_HUELGA','0.0','2015-08-01','2015-08-31',83),(987260,8777,'DIAS_TRABAJADOS','30.0','2015-08-01','2015-08-31',83),(987261,8777,'AÑOS_ANTIGUEDAD','3','2015-08-01','2015-08-31',83),(987262,8777,'TRIENIO','THREE','2015-08-01','2015-08-31',83),(987263,8777,'SALARIO_BASE','1935.8999999999999','2015-08-01','2015-08-31',83),(987264,8777,'ANTIGUEDAD','77.43599999999999','2015-08-01','2015-08-31',83),(987265,8777,'BASE_CGC','2348.8919999999994','2015-08-01','2015-08-31',83),(987266,8777,'PORCENTAJE_CGC','4.7','2015-08-01','2015-08-31',83),(987267,8777,'INDEFINIDO','true','2015-08-01','2015-08-31',83),(987268,8777,'BASE_CGP','2348.8919999999994','2015-08-01','2015-08-31',83),(987269,8777,'PORCENTAJE_FP','0.1','2015-08-01','2015-08-31',83),(987270,8777,'BASE_CGC_E','2348.8919999999994','2015-08-01','2015-08-31',83),(987271,8777,'PORCENTAJE_CGC_E','23.6','2015-08-01','2015-08-31',83),(987272,8777,'PORCENTAJE_EXTR_E','12.0','2015-08-01','2015-08-31',83),(987273,8777,'PORCENTAJE_NEXTR_E','23.6','2015-08-01','2015-08-31',83),(987274,8777,'BASE_CGP_E','2348.8919999999994','2015-08-01','2015-08-31',83),(987275,8777,'TARIFA_IT','0.65','2015-08-01','2015-08-31',83),(987276,8777,'TARIFA_IMS','0.7','2015-08-01','2015-08-31',83),(987277,8777,'PORCENTAJE_FOGASA','0.2','2015-08-01','2015-08-31',83),(987278,8777,'PORCENTAJE_FP_E','0.6','2015-08-01','2015-08-31',83),(987279,8777,'DIAS_COTIZADOS','30.0','2015-08-01','2015-08-31',83),(987280,8777,'HORAS_TRABAJADAS','0.0','2015-08-01','2015-08-31',83),(987281,8777,'BASE_CGC_MIN','758.7','2015-09-01','2015-09-30',84),(987282,8777,'DIAS_NOMINA','30.0','2015-09-01','2015-09-30',84),(987283,8777,'TC2','100','2015-09-01','2015-09-30',84),(987284,8777,'DIAS_NATURALES_MES','30','2015-09-01','2015-09-30',84),(987285,8777,'TIEMPO_COMPLETO','true','2015-09-01','2015-09-30',84),(987286,8777,'GRUPO_COTIZACION','03','2015-09-01','2015-09-30',84),(987287,8777,'DIAS_MES','30.0','2015-09-01','2015-09-30',84),(987288,8777,'BASE_CGC_MAX','3597.0','2015-09-01','2015-09-30',84),(987289,8777,'BASE_CGP_MIN','753.0','2015-09-01','2015-09-30',84),(987290,8777,'BASE_CGP_MAX','3597.0','2015-09-01','2015-09-30',84),(987291,8777,'COEFICIENTE_ERE','0.0','2015-09-01','2015-09-30',84),(987292,8777,'SALARIO_ANUAL','27102.6','2015-09-01','2015-09-30',84),(987293,8777,'PAGAS','14','2015-09-01','2015-09-30',84),(987294,8777,'SMI','645.3','2015-09-01','2015-09-30',84),(987295,8777,'DIAS_HUELGA','0.0','2015-09-01','2015-09-30',84),(987296,8777,'DIAS_TRABAJADOS','30.0','2015-09-01','2015-09-30',84),(987297,8777,'AÑOS_ANTIGUEDAD','3','2015-09-01','2015-09-30',84),(987298,8777,'TRIENIO','THREE','2015-09-01','2015-09-30',84),(987299,8777,'SALARIO_BASE','1935.8999999999999','2015-09-01','2015-09-30',84),(987300,8777,'ANTIGUEDAD','77.43599999999999','2015-09-01','2015-09-30',84),(987301,8777,'BASE_CGC','2348.892','2015-09-01','2015-09-30',84),(987302,8777,'PORCENTAJE_CGC','4.7','2015-09-01','2015-09-30',84),(987303,8777,'INDEFINIDO','true','2015-09-01','2015-09-30',84),(987304,8777,'BASE_CGP','2348.892','2015-09-01','2015-09-30',84),(987305,8777,'PORCENTAJE_FP','0.1','2015-09-01','2015-09-30',84),(987306,8777,'BASE_CGC_E','2348.892','2015-09-01','2015-09-30',84),(987307,8777,'PORCENTAJE_CGC_E','23.6','2015-09-01','2015-09-30',84),(987308,8777,'PORCENTAJE_EXTR_E','12.0','2015-09-01','2015-09-30',84),(987309,8777,'PORCENTAJE_NEXTR_E','23.6','2015-09-01','2015-09-30',84),(987310,8777,'BASE_CGP_E','2348.892','2015-09-01','2015-09-30',84),(987311,8777,'TARIFA_IT','0.65','2015-09-01','2015-09-30',84),(987312,8777,'TARIFA_IMS','0.7','2015-09-01','2015-09-30',84),(987313,8777,'PORCENTAJE_FOGASA','0.2','2015-09-01','2015-09-30',84),(987314,8777,'PORCENTAJE_FP_E','0.6','2015-09-01','2015-09-30',84),(987315,8777,'DIAS_COTIZADOS','30.0','2015-09-01','2015-09-30',84),(987316,8777,'HORAS_TRABAJADAS','0.0','2015-09-01','2015-09-30',84),(987317,8777,'BASE_CGC_MIN','758.7','2015-10-01','2015-10-31',85),(987318,8777,'DIAS_NOMINA','30.0','2015-10-01','2015-10-31',85),(987319,8777,'TC2','100','2015-10-01','2015-10-31',85),(987320,8777,'DIAS_NATURALES_MES','31','2015-10-01','2015-10-31',85),(987321,8777,'TIEMPO_COMPLETO','true','2015-10-01','2015-10-31',85),(987322,8777,'GRUPO_COTIZACION','03','2015-10-01','2015-10-31',85),(987323,8777,'DIAS_MES','30.0','2015-10-01','2015-10-31',85),(987324,8777,'BASE_CGC_MAX','3597.0','2015-10-01','2015-10-31',85),(987325,8777,'BASE_CGP_MIN','753.0','2015-10-01','2015-10-31',85),(987326,8777,'BASE_CGP_MAX','3597.0','2015-10-01','2015-10-31',85),(987327,8777,'COEFICIENTE_ERE','0.0','2015-10-01','2015-10-31',85),(987328,8777,'SALARIO_ANUAL','27102.6','2015-10-01','2015-10-31',85),(987329,8777,'PAGAS','14','2015-10-01','2015-10-31',85),(987330,8777,'SMI','645.3','2015-10-01','2015-10-31',85),(987331,8777,'DIAS_HUELGA','0.0','2015-10-01','2015-10-31',85),(987332,8777,'DIAS_TRABAJADOS','30.0','2015-10-01','2015-10-31',85),(987333,8777,'AÑOS_ANTIGUEDAD','3','2015-10-01','2015-10-31',85),(987334,8777,'TRIENIO','THREE','2015-10-01','2015-10-31',85),(987335,8777,'SALARIO_BASE','1935.8999999999999','2015-10-01','2015-10-31',85),(987336,8777,'ANTIGUEDAD','77.43599999999999','2015-10-01','2015-10-31',85),(987337,8777,'BASE_CGC','2348.8919999999994','2015-10-01','2015-10-31',85),(987338,8777,'PORCENTAJE_CGC','4.7','2015-10-01','2015-10-31',85),(987339,8777,'INDEFINIDO','true','2015-10-01','2015-10-31',85),(987340,8777,'BASE_CGP','2348.8919999999994','2015-10-01','2015-10-31',85),(987341,8777,'PORCENTAJE_FP','0.1','2015-10-01','2015-10-31',85),(987342,8777,'BASE_CGC_E','2348.8919999999994','2015-10-01','2015-10-31',85),(987343,8777,'PORCENTAJE_CGC_E','23.6','2015-10-01','2015-10-31',85),(987344,8777,'PORCENTAJE_EXTR_E','12.0','2015-10-01','2015-10-31',85),(987345,8777,'PORCENTAJE_NEXTR_E','23.6','2015-10-01','2015-10-31',85),(987346,8777,'BASE_CGP_E','2348.8919999999994','2015-10-01','2015-10-31',85),(987347,8777,'TARIFA_IT','0.65','2015-10-01','2015-10-31',85),(987348,8777,'TARIFA_IMS','0.7','2015-10-01','2015-10-31',85),(987349,8777,'PORCENTAJE_FOGASA','0.2','2015-10-01','2015-10-31',85),(987350,8777,'PORCENTAJE_FP_E','0.6','2015-10-01','2015-10-31',85),(987351,8777,'DIAS_COTIZADOS','30.0','2015-10-01','2015-10-31',85),(987352,8777,'HORAS_TRABAJADAS','0.0','2015-10-01','2015-10-31',85),(987353,8777,'BASE_CGC_MIN','758.7','2015-11-01','2015-11-30',86),(987354,8777,'DIAS_NOMINA','30.0','2015-11-01','2015-11-30',86),(987355,8777,'TC2','100','2015-11-01','2015-11-30',86),(987356,8777,'DIAS_NATURALES_MES','30','2015-11-01','2015-11-30',86),(987357,8777,'TIEMPO_COMPLETO','true','2015-11-01','2015-11-30',86),(987358,8777,'GRUPO_COTIZACION','03','2015-11-01','2015-11-30',86),(987359,8777,'DIAS_MES','30.0','2015-11-01','2015-11-30',86),(987360,8777,'BASE_CGC_MAX','3597.0','2015-11-01','2015-11-30',86),(987361,8777,'BASE_CGP_MIN','753.0','2015-11-01','2015-11-30',86),(987362,8777,'BASE_CGP_MAX','3597.0','2015-11-01','2015-11-30',86),(987363,8777,'COEFICIENTE_ERE','0.0','2015-11-01','2015-11-30',86),(987364,8777,'SALARIO_ANUAL','27102.6','2015-11-01','2015-11-30',86),(987365,8777,'PAGAS','14','2015-11-01','2015-11-30',86),(987366,8777,'SMI','645.3','2015-11-01','2015-11-30',86),(987367,8777,'DIAS_HUELGA','0.0','2015-11-01','2015-11-30',86),(987368,8777,'DIAS_TRABAJADOS','30.0','2015-11-01','2015-11-30',86),(987369,8777,'AÑOS_ANTIGUEDAD','3','2015-11-01','2015-11-30',86),(987370,8777,'TRIENIO','THREE','2015-11-01','2015-11-30',86),(987371,8777,'SALARIO_BASE','1935.8999999999999','2015-11-01','2015-11-30',86),(987372,8777,'ANTIGUEDAD','77.43599999999999','2015-11-01','2015-11-30',86),(987373,8777,'BASE_CGC','2348.892','2015-11-01','2015-11-30',86),(987374,8777,'PORCENTAJE_CGC','4.7','2015-11-01','2015-11-30',86),(987375,8777,'INDEFINIDO','true','2015-11-01','2015-11-30',86),(987376,8777,'BASE_CGP','2348.892','2015-11-01','2015-11-30',86),(987377,8777,'PORCENTAJE_FP','0.1','2015-11-01','2015-11-30',86),(987378,8777,'BASE_CGC_E','2348.892','2015-11-01','2015-11-30',86),(987379,8777,'PORCENTAJE_CGC_E','23.6','2015-11-01','2015-11-30',86),(987380,8777,'PORCENTAJE_EXTR_E','12.0','2015-11-01','2015-11-30',86),(987381,8777,'PORCENTAJE_NEXTR_E','23.6','2015-11-01','2015-11-30',86),(987382,8777,'BASE_CGP_E','2348.892','2015-11-01','2015-11-30',86),(987383,8777,'TARIFA_IT','0.65','2015-11-01','2015-11-30',86),(987384,8777,'TARIFA_IMS','0.7','2015-11-01','2015-11-30',86),(987385,8777,'PORCENTAJE_FOGASA','0.2','2015-11-01','2015-11-30',86),(987386,8777,'PORCENTAJE_FP_E','0.6','2015-11-01','2015-11-30',86),(987387,8777,'DIAS_COTIZADOS','30.0','2015-11-01','2015-11-30',86),(987388,8777,'HORAS_TRABAJADAS','0.0','2015-11-01','2015-11-30',86),(987389,8777,'BASE_CGC_MIN','758.7','2015-12-01','2015-12-31',87),(987390,8777,'DIAS_NOMINA','30.0','2015-12-01','2015-12-31',87),(987391,8777,'TC2','100','2015-12-01','2015-12-31',87),(987392,8777,'DIAS_NATURALES_MES','31','2015-12-01','2015-12-31',87),(987393,8777,'TIEMPO_COMPLETO','true','2015-12-01','2015-12-31',87),(987394,8777,'GRUPO_COTIZACION','03','2015-12-01','2015-12-31',87),(987395,8777,'DIAS_MES','30.0','2015-12-01','2015-12-31',87),(987396,8777,'BASE_CGC_MAX','3597.0','2015-12-01','2015-12-31',87),(987397,8777,'BASE_CGP_MIN','753.0','2015-12-01','2015-12-31',87),(987398,8777,'BASE_CGP_MAX','3597.0','2015-12-01','2015-12-31',87),(987399,8777,'COEFICIENTE_ERE','0.0','2015-12-01','2015-12-31',87),(987400,8777,'SALARIO_ANUAL','27102.6','2015-12-01','2015-12-31',87),(987401,8777,'PAGAS','14','2015-12-01','2015-12-31',87),(987402,8777,'SMI','645.3','2015-12-01','2015-12-31',87),(987403,8777,'DIAS_HUELGA','0.0','2015-12-01','2015-12-31',87),(987404,8777,'DIAS_TRABAJADOS','30.0','2015-12-01','2015-12-31',87),(987405,8777,'AÑOS_ANTIGUEDAD','3','2015-12-01','2015-12-31',87),(987406,8777,'TRIENIO','THREE','2015-12-01','2015-12-31',87),(987407,8777,'SALARIO_BASE','1935.8999999999999','2015-12-01','2015-12-31',87),(987408,8777,'ANTIGUEDAD','77.43599999999999','2015-12-01','2015-12-31',87),(987409,8777,'BASE_CGC','2348.8919999999994','2015-12-01','2015-12-31',87),(987410,8777,'PORCENTAJE_CGC','4.7','2015-12-01','2015-12-31',87),(987411,8777,'INDEFINIDO','true','2015-12-01','2015-12-31',87),(987412,8777,'BASE_CGP','2348.8919999999994','2015-12-01','2015-12-31',87),(987413,8777,'PORCENTAJE_FP','0.1','2015-12-01','2015-12-31',87),(987414,8777,'BASE_CGC_E','2348.8919999999994','2015-12-01','2015-12-31',87),(987415,8777,'PORCENTAJE_CGC_E','23.6','2015-12-01','2015-12-31',87),(987416,8777,'PORCENTAJE_EXTR_E','12.0','2015-12-01','2015-12-31',87),(987417,8777,'PORCENTAJE_NEXTR_E','23.6','2015-12-01','2015-12-31',87),(987418,8777,'BASE_CGP_E','2348.8919999999994','2015-12-01','2015-12-31',87),(987419,8777,'TARIFA_IT','0.65','2015-12-01','2015-12-31',87),(987420,8777,'TARIFA_IMS','0.7','2015-12-01','2015-12-31',87),(987421,8777,'PORCENTAJE_FOGASA','0.2','2015-12-01','2015-12-31',87),(987422,8777,'PORCENTAJE_FP_E','0.6','2015-12-01','2015-12-31',87),(987423,8777,'DIAS_COTIZADOS','30.0','2015-12-01','2015-12-31',87),(987424,8777,'HORAS_TRABAJADAS','0.0','2015-12-01','2015-12-31',87),(987425,8777,'BASE_CGC_MIN','758.7','2015-01-01','2015-01-31',88),(987426,8777,'DIAS_NOMINA','30.0','2015-01-01','2015-01-31',88),(987427,8777,'TC2','100','2015-01-01','2015-01-31',88),(987428,8777,'DIAS_NATURALES_MES','31','2015-01-01','2015-01-31',88),(987429,8777,'TIEMPO_COMPLETO','true','2015-01-01','2015-01-31',88),(987430,8777,'GRUPO_COTIZACION','03','2015-01-01','2015-01-31',88),(987431,8777,'DIAS_MES','30.0','2015-01-01','2015-01-31',88),(987432,8777,'BASE_CGC_MAX','3597.0','2015-01-01','2015-01-31',88),(987433,8777,'BASE_CGP_MIN','753.0','2015-01-01','2015-01-31',88),(987434,8777,'BASE_CGP_MAX','3597.0','2015-01-01','2015-01-31',88),(987435,8777,'COEFICIENTE_ERE','0.0','2015-01-01','2015-01-31',88),(987436,8777,'SALARIO_ANUAL','27102.6','2015-01-01','2015-01-31',88),(987437,8777,'PAGAS','14','2015-01-01','2015-01-31',88),(987438,8777,'SMI','645.3','2015-01-01','2015-01-31',88),(987439,8777,'DIAS_HUELGA','0.0','2015-01-01','2015-01-31',88),(987440,8777,'DIAS_TRABAJADOS','30.0','2015-01-01','2015-01-31',88),(987441,8777,'AÑOS_ANTIGUEDAD','2','2015-01-01','2015-01-31',88),(987442,8777,'TRIENIO','THREE','2015-01-01','2015-01-31',88),(987443,8777,'SALARIO_BASE','1935.8999999999999','2015-01-01','2015-01-31',88),(987444,8777,'ANTIGUEDAD','0.0','2015-01-01','2015-01-31',88),(987445,8777,'BASE_CGC','2258.5499999999997','2015-01-01','2015-01-31',88),(987446,8777,'PORCENTAJE_CGC','4.7','2015-01-01','2015-01-31',88),(987447,8777,'INDEFINIDO','true','2015-01-01','2015-01-31',88),(987448,8777,'BASE_CGP','2258.5499999999997','2015-01-01','2015-01-31',88),(987449,8777,'PORCENTAJE_FP','0.1','2015-01-01','2015-01-31',88),(987450,8777,'BASE_CGC_E','2258.5499999999997','2015-01-01','2015-01-31',88),(987451,8777,'PORCENTAJE_CGC_E','23.6','2015-01-01','2015-01-31',88),(987452,8777,'PORCENTAJE_EXTR_E','12.0','2015-01-01','2015-01-31',88),(987453,8777,'PORCENTAJE_NEXTR_E','23.6','2015-01-01','2015-01-31',88),(987454,8777,'BASE_CGP_E','2258.5499999999997','2015-01-01','2015-01-31',88),(987455,8777,'TARIFA_IT','0.65','2015-01-01','2015-01-31',88),(987456,8777,'TARIFA_IMS','0.7','2015-01-01','2015-01-31',88),(987457,8777,'PORCENTAJE_FOGASA','0.2','2015-01-01','2015-01-31',88),(987458,8777,'PORCENTAJE_FP_E','0.6','2015-01-01','2015-01-31',88),(987459,8777,'DIAS_COTIZADOS','30.0','2015-01-01','2015-01-31',88),(987460,8777,'HORAS_TRABAJADAS','0.0','2015-01-01','2015-01-31',88),(987461,8777,'BASE_CGC','75.285','2015-01-01','2015-01-31',89),(987462,8777,'PORCENTAJE_CGC','4.7','2015-01-01','2015-12-31',89),(987463,8777,'BASE_CGC','75.285','2015-02-01','2015-02-28',89),(987464,8777,'BASE_CGC','78.296','2015-03-01','2015-03-31',89),(987465,8777,'BASE_CGC','78.296','2015-04-01','2015-04-30',89),(987466,8777,'BASE_CGC','78.296','2015-05-01','2015-05-31',89),(987467,8777,'BASE_CGC','78.296','2015-06-01','2015-06-30',89),(987468,8777,'BASE_CGC','78.296','2015-07-01','2015-07-31',89),(987469,8777,'BASE_CGC','78.296','2015-08-01','2015-08-31',89),(987470,8777,'BASE_CGC','78.296','2015-09-01','2015-09-30',89),(987471,8777,'BASE_CGC','78.296','2015-10-01','2015-10-31',89),(987472,8777,'BASE_CGC','78.296','2015-11-01','2015-11-30',89),(987473,8777,'BASE_CGC','78.296','2015-12-01','2015-12-31',89),(987474,8777,'TC2','100','2015-01-01','2015-12-31',89),(987475,8777,'INDEFINIDO','true','2015-01-01','2015-12-31',89),(987476,8777,'BASE_CGP','75.285','2015-01-01','2015-01-31',89),(987477,8777,'BASE_CGP','75.285','2015-02-01','2015-02-28',89),(987478,8777,'BASE_CGP','78.296','2015-03-01','2015-03-31',89),(987479,8777,'BASE_CGP','78.296','2015-04-01','2015-04-30',89),(987480,8777,'BASE_CGP','78.296','2015-05-01','2015-05-31',89),(987481,8777,'BASE_CGP','78.296','2015-06-01','2015-06-30',89),(987482,8777,'BASE_CGP','78.296','2015-07-01','2015-07-31',89),(987483,8777,'BASE_CGP','78.296','2015-08-01','2015-08-31',89),(987484,8777,'BASE_CGP','78.296','2015-09-01','2015-09-30',89),(987485,8777,'BASE_CGP','78.296','2015-10-01','2015-10-31',89),(987486,8777,'BASE_CGP','78.296','2015-11-01','2015-11-30',89),(987487,8777,'BASE_CGP','78.296','2015-12-01','2015-12-31',89),(987488,8777,'PORCENTAJE_FP','0.1','2015-01-01','2015-12-31',89),(987489,8777,'BASE_CGC_E','933.5300000000002','2015-01-01','2015-12-31',89),(987490,8777,'PORCENTAJE_CGC_E','23.6','2015-01-01','2015-12-31',89),(987491,8777,'PORCENTAJE_EXTR_E','12.0','2015-01-01','2015-12-31',89),(987492,8777,'PORCENTAJE_NEXTR_E','23.6','2015-01-01','2015-12-31',89),(987493,8777,'BASE_CGP_E','933.5300000000002','2015-01-01','2015-12-31',89),(987494,8777,'TARIFA_IT','0.65','2015-01-01','2015-12-31',89),(987495,8777,'TARIFA_IMS','0.7','2015-01-01','2015-12-31',89),(987496,8777,'PORCENTAJE_FOGASA','0.2','2015-01-01','2015-12-31',89),(987497,8777,'PORCENTAJE_FP_E','0.6','2015-01-01','2015-12-31',89),(987498,8777,'DIAS_COTIZADOS','30.0','2015-01-01','2015-01-31',89),(987499,8777,'DIAS_COTIZADOS','30.0','2015-02-01','2015-02-28',89),(987500,8777,'DIAS_COTIZADOS','30.0','2015-03-01','2015-03-31',89),(987501,8777,'DIAS_COTIZADOS','30.0','2015-04-01','2015-04-30',89),(987502,8777,'DIAS_COTIZADOS','30.0','2015-05-01','2015-05-31',89),(987503,8777,'DIAS_COTIZADOS','30.0','2015-06-01','2015-06-30',89),(987504,8777,'DIAS_COTIZADOS','30.0','2015-07-01','2015-07-31',89),(987505,8777,'DIAS_COTIZADOS','30.0','2015-08-01','2015-08-31',89),(987506,8777,'DIAS_COTIZADOS','30.0','2015-09-01','2015-09-30',89),(987507,8777,'DIAS_COTIZADOS','30.0','2015-10-01','2015-10-31',89),(987508,8777,'DIAS_COTIZADOS','30.0','2015-11-01','2015-11-30',89),(987509,8777,'DIAS_COTIZADOS','30.0','2015-12-01','2015-12-31',89),(987510,8777,'HORAS_TRABAJADAS','0.0','2015-01-01','2015-01-31',89),(987511,8777,'HORAS_TRABAJADAS','0.0','2015-02-01','2015-02-28',89),(987512,8777,'HORAS_TRABAJADAS','0.0','2015-03-01','2015-03-31',89),(987513,8777,'HORAS_TRABAJADAS','0.0','2015-04-01','2015-04-30',89),(987514,8777,'HORAS_TRABAJADAS','0.0','2015-05-01','2015-05-31',89),(987515,8777,'HORAS_TRABAJADAS','0.0','2015-06-01','2015-06-30',89),(987516,8777,'HORAS_TRABAJADAS','0.0','2015-07-01','2015-07-31',89),(987517,8777,'HORAS_TRABAJADAS','0.0','2015-08-01','2015-08-31',89),(987518,8777,'HORAS_TRABAJADAS','0.0','2015-09-01','2015-09-30',89),(987519,8777,'HORAS_TRABAJADAS','0.0','2015-10-01','2015-10-31',89),(987520,8777,'HORAS_TRABAJADAS','0.0','2015-11-01','2015-11-30',89),(987521,8777,'HORAS_TRABAJADAS','0.0','2015-12-01','2015-12-31',89),(987746,8783,'SALARIO_BASE','111.00777037037035','2016-05-06','2016-05-31',90),(987747,8783,'ANTIGUEDAD','0.0','2016-05-06','2016-05-31',90),(987748,8783,'SALARIO_BASE','128.0858888888889','2016-06-01','2016-06-30',90),(987749,8783,'ANTIGUEDAD','0.0','2016-06-01','2016-06-30',90),(987750,8783,'SALARIO_BASE','72.5820037037037','2016-07-01','2016-07-17',90),(987751,8783,'ANTIGUEDAD','0.0','2016-07-01','2016-07-17',90),(987752,8783,'SALARIO_BASE','0.0','2016-07-18','2016-12-31',90),(987753,8783,'ANTIGUEDAD','0.0','2016-07-18','2016-12-31',90),(987754,8783,'TC2','100','2016-05-06','2016-12-31',90),(987755,8783,'DIAS_COTIZADOS','26.0','2016-05-06','2016-05-31',90),(987756,8783,'DIAS_COTIZADOS','30.0','2016-06-01','2016-06-30',90),(987757,8783,'DIAS_COTIZADOS','17.0','2016-07-01','2016-07-17',90),(987758,8783,'DIAS_COTIZADOS','166.0','2016-07-18','2016-12-31',90),(987759,8783,'HORAS_TRABAJADAS','0.0','2016-05-06','2016-05-31',90),(987760,8783,'HORAS_TRABAJADAS','0.0','2016-06-01','2016-06-30',90),(987761,8783,'HORAS_TRABAJADAS','0.0','2016-07-01','2016-07-17',90),(987884,8783,'BASE_CGC_MIN','764.4','2016-05-01','2016-05-31',93),(987885,8783,'TC2','100','2016-05-01','2016-05-31',93),(987886,8783,'DIAS_COTIZADOS','30.0','2016-05-01','2016-05-31',93),(987887,8783,'DIAS_NATURALES_MES','31','2016-05-01','2016-05-31',93),(987888,8783,'TIEMPO_COMPLETO','true','2016-05-01','2016-05-31',93),(987889,8783,'GRUPO_COTIZACION','05','2016-05-01','2016-05-31',93),(987890,8783,'DIAS_MES','30.0','2016-05-01','2016-05-31',93),(987891,8783,'DIAS_NOMINA','30.0','2016-05-01','2016-05-31',93),(987892,8783,'BASE_CGC_MAX','3642.0','2016-05-01','2016-05-31',93),(987893,8783,'BASE_CGP_MIN','764.4','2016-05-01','2016-05-31',93),(987894,8783,'BASE_CGP_MAX','3642.0','2016-05-01','2016-05-31',93),(987895,8783,'COEFICIENTE_ERE','0.0','2016-05-01','2016-05-31',93),(987896,8783,'DIAS_HUELGA','0.0','2016-05-01','2016-05-31',93),(987897,8783,'SALARIO_MENSUAL','1310.4','2016-05-01','2016-05-31',93),(987898,8783,'SMI','655.2','2016-05-01','2016-05-31',93),(987899,8783,'DIAS_TRABAJADOS','30.0','2016-05-01','2016-05-31',93),(987900,8783,'SALARIO_BASE','1310.4','2016-05-01','2016-05-31',93),(987901,8783,'BASE_CGC','1528.8000000000002','2016-05-01','2016-05-31',93),(987902,8783,'PORCENTAJE_CGC','4.7','2016-05-01','2016-05-31',93),(987903,8783,'INDEFINIDO','true','2016-05-01','2016-05-31',93),(987904,8783,'BASE_CGP','1528.8000000000002','2016-05-01','2016-05-31',93),(987905,8783,'PORCENTAJE_FP','0.1','2016-05-01','2016-05-31',93),(987906,8783,'BASE_CGC_E','1528.8000000000002','2016-05-01','2016-05-31',93),(987907,8783,'PORCENTAJE_CGC_E','23.6','2016-05-01','2016-05-31',93),(987908,8783,'PORCENTAJE_EXTR_E','12.0','2016-05-01','2016-05-31',93),(987909,8783,'PORCENTAJE_NEXTR_E','23.6','2016-05-01','2016-05-31',93),(987910,8783,'BASE_CGP_E','1528.8000000000002','2016-05-01','2016-05-31',93),(987911,8783,'TARIFA_IT','1.0','2016-05-01','2016-05-31',93),(987912,8783,'TARIFA_IMS','1.05','2016-05-01','2016-05-31',93),(987913,8783,'PORCENTAJE_FOGASA','0.2','2016-05-01','2016-05-31',93),(987914,8783,'PORCENTAJE_FP_E','0.6','2016-05-01','2016-05-31',93),(987915,8783,'HORAS_TRABAJADAS','0.0','2016-05-01','2016-05-31',93),(987916,8783,'BASE_CGC_MIN','764.4','2016-05-01','2016-05-31',94),(987917,8783,'TC2','100','2016-05-01','2016-05-31',94),(987918,8783,'DIAS_COTIZADOS','30.0','2016-05-01','2016-05-31',94),(987919,8783,'DIAS_NATURALES_MES','31','2016-05-01','2016-05-31',94),(987920,8783,'TIEMPO_COMPLETO','true','2016-05-01','2016-05-31',94),(987921,8783,'GRUPO_COTIZACION','04','2016-05-01','2016-05-31',94),(987922,8783,'DIAS_MES','30.0','2016-05-01','2016-05-31',94),(987923,8783,'BASE_CGP_MIN','764.4','2016-05-01','2016-05-31',94),(987924,8783,'COEFICIENTE_ERE','0.0','2016-05-01','2016-05-31',94),(987925,8783,'DIAS_HUELGA','0.0','2016-05-01','2016-05-31',94),(987926,8783,'SALARIO_MENSUAL','655.2','2016-05-01','2016-05-31',94),(987927,8783,'SMI','655.2','2016-05-01','2016-05-31',94),(987928,8783,'DIAS_TRABAJADOS','30.0','2016-05-01','2016-05-31',94),(987929,8783,'SALARIO_BASE','655.2','2016-05-01','2016-05-31',94),(987930,8783,'DIAS_NOMINA','30.0','2016-05-01','2016-05-31',94),(987931,8783,'BASE_CGC_MAX','3642.0','2016-05-01','2016-05-31',94),(987932,8783,'BASE_CGP_MAX','3642.0','2016-05-01','2016-05-31',94),(987933,8783,'BASE_CGC','764.4000000000001','2016-05-01','2016-05-31',94),(987934,8783,'PORCENTAJE_CGC','4.7','2016-05-01','2016-05-31',94),(987935,8783,'INDEFINIDO','true','2016-05-01','2016-05-31',94),(987936,8783,'BASE_CGP','764.4000000000001','2016-05-01','2016-05-31',94),(987937,8783,'PORCENTAJE_FP','0.1','2016-05-01','2016-05-31',94),(987938,8783,'BASE_CGC_E','764.4000000000001','2016-05-01','2016-05-31',94),(987939,8783,'PORCENTAJE_CGC_E','23.6','2016-05-01','2016-05-31',94),(987940,8783,'PORCENTAJE_EXTR_E','12.0','2016-05-01','2016-05-31',94),(987941,8783,'PORCENTAJE_NEXTR_E','23.6','2016-05-01','2016-05-31',94),(987942,8783,'BASE_CGP_E','764.4000000000001','2016-05-01','2016-05-31',94),(987943,8783,'TARIFA_IT','1.0','2016-05-01','2016-05-31',94),(987944,8783,'TARIFA_IMS','1.05','2016-05-01','2016-05-31',94),(987945,8783,'PORCENTAJE_FOGASA','0.2','2016-05-01','2016-05-31',94),(987946,8783,'PORCENTAJE_FP_E','0.6','2016-05-01','2016-05-31',94),(987947,8783,'HORAS_TRABAJADAS','0.0','2016-05-01','2016-05-31',94),(987982,8783,'SALARIO_BASE','54.6','2016-01-01','2016-01-31',96),(987983,8783,'SALARIO_BASE','54.6','2016-02-01','2016-02-29',96),(987984,8783,'SALARIO_BASE','54.6','2016-03-01','2016-03-31',96),(987985,8783,'SALARIO_BASE','54.6','2016-04-01','2016-04-30',96),(987986,8783,'SALARIO_BASE','54.6','2016-05-01','2016-05-31',96),(987987,8783,'SALARIO_BASE','54.6','2016-06-01','2016-06-30',96),(987988,8783,'SALARIO_BASE','54.6','2016-07-01','2016-07-31',96),(987989,8783,'SALARIO_BASE','54.6','2016-08-01','2016-08-31',96),(987990,8783,'SALARIO_BASE','54.6','2016-09-01','2016-09-30',96),(987991,8783,'SALARIO_BASE','54.6','2016-10-01','2016-10-31',96),(987992,8783,'SALARIO_BASE','54.6','2016-11-01','2016-11-30',96),(987993,8783,'SALARIO_BASE','54.6','2016-12-01','2016-12-31',96),(987994,8783,'TC2','100','2016-01-01','2016-12-31',96),(987995,8783,'DIAS_COTIZADOS','30.0','2016-01-01','2016-01-31',96),(987996,8783,'DIAS_COTIZADOS','30.0','2016-02-01','2016-02-29',96),(987997,8783,'DIAS_COTIZADOS','30.0','2016-03-01','2016-03-31',96),(987998,8783,'DIAS_COTIZADOS','30.0','2016-04-01','2016-04-30',96),(987999,8783,'DIAS_COTIZADOS','30.0','2016-05-01','2016-05-31',96),(988000,8783,'DIAS_COTIZADOS','30.0','2016-06-01','2016-06-30',96),(988001,8783,'DIAS_COTIZADOS','30.0','2016-07-01','2016-07-31',96),(988002,8783,'DIAS_COTIZADOS','30.0','2016-08-01','2016-08-31',96),(988003,8783,'DIAS_COTIZADOS','30.0','2016-09-01','2016-09-30',96),(988004,8783,'DIAS_COTIZADOS','30.0','2016-10-01','2016-10-31',96),(988005,8783,'DIAS_COTIZADOS','30.0','2016-11-01','2016-11-30',96),(988006,8783,'DIAS_COTIZADOS','30.0','2016-12-01','2016-12-31',96),(988007,8783,'HORAS_TRABAJADAS','0.0','2016-01-01','2016-01-31',96),(988008,8783,'HORAS_TRABAJADAS','0.0','2016-02-01','2016-02-29',96),(988009,8783,'HORAS_TRABAJADAS','0.0','2016-03-01','2016-03-31',96),(988010,8783,'HORAS_TRABAJADAS','0.0','2016-04-01','2016-04-30',96),(988011,8783,'HORAS_TRABAJADAS','0.0','2016-05-01','2016-05-31',96),(988012,8783,'HORAS_TRABAJADAS','0.0','2016-06-01','2016-06-30',96),(988013,8783,'HORAS_TRABAJADAS','0.0','2016-07-01','2016-07-31',96),(988014,8783,'HORAS_TRABAJADAS','0.0','2016-08-01','2016-08-31',96),(988015,8783,'HORAS_TRABAJADAS','0.0','2016-09-01','2016-09-30',96),(988016,8783,'HORAS_TRABAJADAS','0.0','2016-10-01','2016-10-31',96),(988017,8783,'HORAS_TRABAJADAS','0.0','2016-11-01','2016-11-30',96),(988018,8783,'HORAS_TRABAJADAS','0.0','2016-12-01','2016-12-31',96),(988019,8783,'BASE_CGC_MIN','764.4','2016-06-01','2016-06-30',97),(988020,8783,'TC2','100','2016-06-01','2016-06-30',97),(988021,8783,'DIAS_COTIZADOS','30.0','2016-06-01','2016-06-30',97),(988022,8783,'DIAS_NATURALES_MES','30','2016-06-01','2016-06-30',97),(988023,8783,'TIEMPO_COMPLETO','true','2016-06-01','2016-06-30',97),(988024,8783,'GRUPO_COTIZACION','05','2016-06-01','2016-06-30',97),(988025,8783,'DIAS_MES','30.0','2016-06-01','2016-06-30',97),(988026,8783,'DIAS_NOMINA','30.0','2016-06-01','2016-06-30',97),(988027,8783,'BASE_CGC_MAX','3642.0','2016-06-01','2016-06-30',97),(988028,8783,'BASE_CGP_MIN','764.4','2016-06-01','2016-06-30',97),(988029,8783,'BASE_CGP_MAX','3642.0','2016-06-01','2016-06-30',97),(988030,8783,'COEFICIENTE_ERE','0.0','2016-06-01','2016-06-30',97),(988031,8783,'DIAS_HUELGA','0.0','2016-06-01','2016-06-30',97),(988032,8783,'SALARIO_MENSUAL','1310.4','2016-06-01','2016-06-30',97),(988033,8783,'SMI','655.2','2016-06-01','2016-06-30',97),(988034,8783,'DIAS_TRABAJADOS','30.0','2016-06-01','2016-06-30',97),(988035,8783,'SALARIO_BASE','1310.4','2016-06-01','2016-06-30',97),(988036,8783,'BASE_CGC','1528.8000000000002','2016-06-01','2016-06-30',97),(988037,8783,'PORCENTAJE_CGC','4.7','2016-06-01','2016-06-30',97),(988038,8783,'INDEFINIDO','true','2016-06-01','2016-06-30',97),(988039,8783,'BASE_CGP','1528.8000000000002','2016-06-01','2016-06-30',97),(988040,8783,'PORCENTAJE_FP','0.1','2016-06-01','2016-06-30',97),(988041,8783,'BASE_CGC_E','1528.8000000000002','2016-06-01','2016-06-30',97),(988042,8783,'PORCENTAJE_CGC_E','23.6','2016-06-01','2016-06-30',97),(988043,8783,'PORCENTAJE_EXTR_E','12.0','2016-06-01','2016-06-30',97),(988044,8783,'PORCENTAJE_NEXTR_E','23.6','2016-06-01','2016-06-30',97),(988045,8783,'BASE_CGP_E','1528.8000000000002','2016-06-01','2016-06-30',97),(988046,8783,'TARIFA_IT','1.0','2016-06-01','2016-06-30',97),(988047,8783,'TARIFA_IMS','1.05','2016-06-01','2016-06-30',97),(988048,8783,'PORCENTAJE_FOGASA','0.2','2016-06-01','2016-06-30',97),(988049,8783,'PORCENTAJE_FP_E','0.6','2016-06-01','2016-06-30',97),(988050,8783,'HORAS_TRABAJADAS','0.0','2016-06-01','2016-06-30',97),(988102,8777,'TC2','100','2016-07-01','2016-07-31',98),(988103,8777,'DIAS_COTIZADOS','13.0','2016-07-01','2016-07-13',98),(988104,8777,'DIAS_NATURALES_MES','31','2016-07-01','2016-07-31',98),(988105,8777,'TIEMPO_COMPLETO','true','2016-07-01','2016-07-31',98),(988106,8777,'GRUPO_COTIZACION','01','2016-07-01','2016-07-31',98),(988107,8777,'DIAS_MES','30.0','2016-07-01','2016-07-13',98),(988108,8777,'COEFICIENTE_ERE','0.0','2016-07-01','2016-07-13',98),(988109,8777,'DIAS_HUELGA','0.0','2016-07-01','2016-07-13',98),(988110,8777,'SALARIO_MENSUAL','655.2','2016-07-01','2016-07-31',98),(988111,8777,'SMI','655.2','2016-07-01','2016-07-31',98),(988112,8777,'DIAS_TRABAJADOS','13.0','2016-07-01','2016-07-13',98),(988113,8777,'DIAS_MES','30.0','2016-07-28','2016-07-31',98),(988114,8777,'DIAS_COTIZADOS','4.0','2016-07-28','2016-07-31',98),(988115,8777,'COEFICIENTE_ERE','0.0','2016-07-28','2016-07-31',98),(988116,8777,'DIAS_HUELGA','0.0','2016-07-28','2016-07-31',98),(988117,8777,'DIAS_TRABAJADOS','4.0','2016-07-28','2016-07-31',98),(988118,8777,'BASE_REGULADORA','35.580000000000005','2016-07-14','2016-07-27',98),(988119,8777,'DIAS_COTIZADOS','3.0','2016-07-14','2016-07-16',98),(988120,8777,'DIAS_MES','30.0','2016-07-14','2016-07-16',98),(988121,8777,'DIAS_NOMINA','3.0','2016-07-14','2016-07-16',98),(988122,8777,'DIAS_ENFERMEDAD_COMUN_1_3','3','2016-07-14','2016-07-16',98),(988123,8777,'DIAS_COTIZADOS','10.0','2016-07-17','2016-07-27',98),(988124,8777,'DIAS_MES','30','2016-07-17','2016-07-27',98),(988125,8777,'DIAS_NOMINA','11.0','2016-07-17','2016-07-27',98),(988126,8777,'DIAS_ENFERMEDAD_COMUN_4_15','11','2016-07-17','2016-07-27',98),(988127,8777,'BASE_CGC','462.5400000000001','2016-07-01','2016-07-13',98),(988128,8777,'PORCENTAJE_CGC','4.7','2016-07-01','2016-07-31',98),(988129,8777,'BASE_CGC','106.74000000000001','2016-07-14','2016-07-16',98),(988130,8777,'BASE_CGC','355.80000000000007','2016-07-17','2016-07-27',98),(988131,8777,'BASE_CGC','142.32000000000002','2016-07-28','2016-07-31',98),(988132,8777,'INDEFINIDO','true','2016-07-01','2016-07-31',98),(988133,8777,'BASE_CGP','331.24','2016-07-01','2016-07-13',98),(988134,8777,'BASE_CGP','106.74000000000001','2016-07-14','2016-07-16',98),(988135,8777,'BASE_CGP','355.80000000000007','2016-07-17','2016-07-27',98),(988136,8777,'BASE_CGP','101.92','2016-07-28','2016-07-31',98),(988137,8777,'PORCENTAJE_FP','0.1','2016-07-01','2016-07-31',98),(988138,8777,'BASE_CGC_E','1067.4','2016-07-01','2016-07-31',98),(988139,8777,'PORCENTAJE_CGC_E','23.6','2016-07-01','2016-07-31',98),(988140,8777,'PORCENTAJE_EXTR_E','12.0','2016-07-01','2016-07-31',98),(988141,8777,'PORCENTAJE_NEXTR_E','23.6','2016-07-01','2016-07-31',98),(988142,8777,'BASE_CGP_E','895.7','2016-07-01','2016-07-31',98),(988143,8777,'TARIFA_IT','0.65','2016-07-01','2016-07-31',98),(988144,8777,'TARIFA_IMS','0.7','2016-07-01','2016-07-31',98),(988145,8777,'PORCENTAJE_FOGASA','0.2','2016-07-01','2016-07-31',98),(988146,8777,'PORCENTAJE_FP_E','0.6','2016-07-01','2016-07-31',98),(988147,8777,'HORAS_TRABAJADAS','0.0','2016-07-01','2016-07-13',98),(988148,8777,'HORAS_TRABAJADAS','0.0','2016-07-28','2016-07-31',98),(988235,8777,'TC2','100','2016-05-01','2016-05-31',99),(988236,8777,'DIAS_COTIZADOS','11.0','2016-05-01','2016-05-11',99),(988237,8777,'DIAS_NATURALES_MES','31','2016-05-01','2016-05-31',99),(988238,8777,'TIEMPO_COMPLETO','true','2016-05-01','2016-05-31',99),(988239,8777,'GRUPO_COTIZACION','09','2016-05-01','2016-05-31',99),(988240,8777,'DIAS_MES','31.0','2016-05-01','2016-05-11',99),(988241,8777,'COEFICIENTE_ERE','0.0','2016-05-01','2016-05-11',99),(988242,8777,'DIAS_HUELGA','0.0','2016-05-01','2016-05-11',99),(988243,8777,'SALARIO_MENSUAL','655.2','2016-05-01','2016-05-31',99),(988244,8777,'SMI','655.2','2016-05-01','2016-05-31',99),(988245,8777,'DIAS_TRABAJADOS','11.0','2016-05-01','2016-05-11',99),(988246,8777,'DIAS_MES','31.0','2016-05-20','2016-05-31',99),(988247,8777,'DIAS_COTIZADOS','12.0','2016-05-20','2016-05-31',99),(988248,8777,'COEFICIENTE_ERE','0.0','2016-05-20','2016-05-31',99),(988249,8777,'DIAS_HUELGA','0.0','2016-05-20','2016-05-31',99),(988250,8777,'DIAS_TRABAJADOS','12.0','2016-05-20','2016-05-31',99),(988251,8777,'BASE_REGULADORA','23.781333333333336','2016-05-12','2016-05-19',99),(988252,8777,'DIAS_COTIZADOS','3.0','2016-05-12','2016-05-14',99),(988253,8777,'DIAS_MES','31.0','2016-05-12','2016-05-14',99),(988254,8777,'DIAS_ENFERMEDAD_COMUN_1_3','3','2016-05-12','2016-05-14',99),(988255,8777,'DIAS_COTIZADOS','5.0','2016-05-15','2016-05-19',99),(988256,8777,'DIAS_MES','31','2016-05-15','2016-05-19',99),(988257,8777,'DIAS_ENFERMEDAD_COMUN_4_15','5','2016-05-15','2016-05-19',99),(988258,8777,'BASE_CGC','280.28000000000003','2016-05-01','2016-05-11',99),(988259,8777,'PORCENTAJE_CGC','4.7','2016-05-01','2016-05-31',99),(988260,8777,'BASE_CGC','76.44','2016-05-12','2016-05-14',99),(988261,8777,'BASE_CGC','127.4','2016-05-15','2016-05-19',99),(988262,8777,'BASE_CGC','305.76','2016-05-20','2016-05-31',99),(988263,8777,'INDEFINIDO','true','2016-05-01','2016-05-31',99),(988264,8777,'BASE_CGP','280.28','2016-05-01','2016-05-11',99),(988265,8777,'BASE_CGP','76.44','2016-05-12','2016-05-14',99),(988266,8777,'BASE_CGP','127.39999999999998','2016-05-15','2016-05-19',99),(988267,8777,'BASE_CGP','305.76','2016-05-20','2016-05-31',99),(988268,8777,'PORCENTAJE_FP','0.1','2016-05-01','2016-05-31',99),(988269,8777,'BASE_CGC_E','789.88','2016-05-01','2016-05-31',99),(988270,8777,'PORCENTAJE_CGC_E','23.6','2016-05-01','2016-05-31',99),(988271,8777,'PORCENTAJE_EXTR_E','12.0','2016-05-01','2016-05-31',99),(988272,8777,'PORCENTAJE_NEXTR_E','23.6','2016-05-01','2016-05-31',99),(988273,8777,'BASE_CGP_E','789.8799999999999','2016-05-01','2016-05-31',99),(988274,8777,'TARIFA_IT','0.65','2016-05-01','2016-05-31',99),(988275,8777,'TARIFA_IMS','0.7','2016-05-01','2016-05-31',99),(988276,8777,'PORCENTAJE_FOGASA','0.2','2016-05-01','2016-05-31',99),(988277,8777,'PORCENTAJE_FP_E','0.6','2016-05-01','2016-05-31',99),(988278,8777,'HORAS_TRABAJADAS','0.0','2016-05-01','2016-05-11',99),(988279,8777,'HORAS_TRABAJADAS','0.0','2016-05-20','2016-05-31',99),(988305,8777,'SALARIO_VARIABLE_DIA','0.0','2016-06-07','2016-07-27',100),(988306,8777,'DIAS_VACACIONES_NO_DISFRUTADOS','3.0','2016-06-28','2016-06-30',100),(988307,8777,'SALARIO_DIA','35.757915571708125','2016-06-07','2016-07-27',100),(988308,8777,'DIAS_VACACIONES_NO_DISFRUTADOS','27.0','2016-07-01','2016-07-27',100),(988309,8777,'FIN_TEMPORAL','TEMP_END','2016-06-07','2016-07-27',100),(988310,8777,'CAUSA_INDEMNIZACION','TEMP_END','2016-06-07','2016-07-27',100),(988311,8777,'AÑOS_TRABAJADOS','0.16666666666666666','2016-06-07','2016-07-27',100),(988312,8777,'BASE_CGC','107.27374671512437','2016-06-28','2016-06-30',100),(988313,8777,'PORCENTAJE_CGC','4.7','2016-06-07','2016-07-27',100),(988314,8777,'BASE_CGC','965.4637204361194','2016-07-01','2016-07-27',100),(988315,8777,'TC2','401','2016-06-07','2016-07-27',100),(988316,8777,'INDEFINIDO','false','2016-06-07','2016-07-27',100),(988317,8777,'BASE_CGP','107.27374671512437','2016-06-28','2016-06-30',100),(988318,8777,'BASE_CGP','965.4637204361194','2016-07-01','2016-07-27',100),(988319,8777,'PORCENTAJE_FP','0.1','2016-06-07','2016-07-27',100),(988320,8777,'BASE_CGC_E','1072.7374671512437','2016-06-07','2016-07-27',100),(988321,8777,'PORCENTAJE_CGC_E','23.6','2016-06-07','2016-07-27',100),(988322,8777,'PORCENTAJE_EXTR_E','12.0','2016-06-07','2016-07-27',100),(988323,8777,'PORCENTAJE_NEXTR_E','23.6','2016-06-07','2016-07-27',100),(988324,8777,'BASE_CGP_E','1072.7374671512437','2016-06-07','2016-07-27',100),(988325,8777,'TARIFA_IT','0.65','2016-06-07','2016-07-27',100),(988326,8777,'TARIFA_IMS','0.7','2016-06-07','2016-07-27',100),(988327,8777,'PORCENTAJE_FOGASA','0.2','2016-06-07','2016-07-27',100),(988328,8777,'PORCENTAJE_FP_E','0.6','2016-06-07','2016-07-27',100),(988329,8777,'HORAS_TRABAJADAS','0.0','2016-06-07','2016-06-27',100),(988330,8777,'TC2','401','2016-06-20','2016-06-30',101),(988331,8777,'DIAS_COTIZADOS','11.0','2016-06-20','2016-06-30',101),(988332,8777,'DIAS_NATURALES_MES','30','2016-06-01','2016-06-30',101),(988333,8777,'TIEMPO_COMPLETO','true','2016-06-01','2016-06-30',101),(988334,8777,'GRUPO_COTIZACION','04','2016-06-20','2016-06-30',101),(988335,8777,'DIAS_MES','30.0','2016-06-20','2016-06-30',101),(988336,8777,'PLUS_EXTRA_SALARIAL','0.0','2016-06-01','2016-06-30',101),(988337,8777,'DIAS_NOMINA','11.0','2016-06-20','2016-06-30',101),(988338,8777,'COEFICIENTE_ERE','0.0','2016-06-20','2016-06-30',101),(988339,8777,'SALARIO_ANUAL','13829.55','2016-06-01','2016-06-30',101),(988340,8777,'DIAS_HUELGA','0.0','2016-06-20','2016-06-30',101),(988341,8777,'DIAS_TRABAJADOS','11.0','2016-06-20','2016-06-30',101),(988342,8777,'PAGAS','14','2016-06-01','2016-06-30',101),(988343,8777,'SALARIO_BASE','362.2025','2016-06-20','2016-06-30',101),(988344,8777,'DIAS_PAGA','30.0','2016-06-20','2016-06-30',101),(988345,8777,'ANTIGUEDAD','0.0','2016-06-20','2016-06-30',101),(988346,8777,'BASE_CGC','526.84','2016-06-20','2016-06-30',101),(988347,8777,'PORCENTAJE_CGC','4.7','2016-06-01','2016-06-30',101),(988348,8777,'INDEFINIDO','false','2016-06-01','2016-06-30',101),(988349,8777,'BASE_CGP','526.84','2016-06-20','2016-06-30',101),(988350,8777,'PORCENTAJE_FP','0.1','2016-06-01','2016-06-30',101),(988351,8777,'BASE_CGC_E','526.84','2016-06-20','2016-06-30',101),(988352,8777,'PORCENTAJE_CGC_E','23.6','2016-06-01','2016-06-30',101),(988353,8777,'PORCENTAJE_EXTR_E','12.0','2016-06-01','2016-06-30',101),(988354,8777,'PORCENTAJE_NEXTR_E','23.6','2016-06-01','2016-06-30',101),(988355,8777,'BASE_CGP_E','526.84','2016-06-20','2016-06-30',101),(988356,8777,'TARIFA_IT','0.65','2016-06-01','2016-06-30',101),(988357,8777,'TARIFA_IMS','0.7','2016-06-01','2016-06-30',101),(988358,8777,'PORCENTAJE_FOGASA','0.2','2016-06-01','2016-06-30',101),(988359,8777,'PORCENTAJE_FP_E','0.6','2016-06-01','2016-06-30',101),(988360,8777,'HORAS_TRABAJADAS','0.0','2016-06-20','2016-06-30',101),(988361,8777,'PREST_IT','0.0','2016-06-20','2016-06-30',101),(988362,8777,'TC2','401','2016-07-01','2016-07-31',102),(988363,8777,'DIAS_COTIZADOS','30.0','2016-07-01','2016-07-31',102),(988364,8777,'DIAS_NATURALES_MES','31','2016-07-01','2016-07-31',102),(988365,8777,'TIEMPO_COMPLETO','true','2016-07-01','2016-07-31',102),(988366,8777,'GRUPO_COTIZACION','04','2016-07-01','2016-07-31',102),(988367,8777,'DIAS_MES','30.0','2016-07-01','2016-07-31',102),(988368,8777,'PLUS_EXTRA_SALARIAL','0.0','2016-07-01','2016-07-31',102),(988369,8777,'DIAS_NOMINA','30.0','2016-07-01','2016-07-31',102),(988370,8777,'COEFICIENTE_ERE','0.0','2016-07-01','2016-07-31',102),(988371,8777,'SALARIO_ANUAL','13829.55','2016-07-01','2016-07-31',102),(988372,8777,'DIAS_HUELGA','0.0','2016-07-01','2016-07-31',102),(988373,8777,'DIAS_TRABAJADOS','30.0','2016-07-01','2016-07-31',102),(988374,8777,'PAGAS','14','2016-07-01','2016-07-31',102),(988375,8777,'SALARIO_BASE','987.8249999999999','2016-07-01','2016-07-31',102),(988376,8777,'DIAS_PAGA','30.0','2016-07-01','2016-07-31',102),(988377,8777,'ANTIGUEDAD','0.0','2016-07-01','2016-07-31',102),(988378,8777,'BASE_CGC','1152.4624999999999','2016-07-01','2016-07-31',102),(988379,8777,'PORCENTAJE_CGC','4.7','2016-07-01','2016-07-31',102),(988380,8777,'INDEFINIDO','false','2016-07-01','2016-07-31',102),(988381,8777,'BASE_CGP','1152.4624999999999','2016-07-01','2016-07-31',102),(988382,8777,'PORCENTAJE_FP','0.1','2016-07-01','2016-07-31',102),(988383,8777,'BASE_CGC_E','1152.4624999999999','2016-07-01','2016-07-31',102),(988384,8777,'PORCENTAJE_CGC_E','23.6','2016-07-01','2016-07-31',102),(988385,8777,'PORCENTAJE_EXTR_E','12.0','2016-07-01','2016-07-31',102),(988386,8777,'PORCENTAJE_NEXTR_E','23.6','2016-07-01','2016-07-31',102),(988387,8777,'BASE_CGP_E','1152.4624999999999','2016-07-01','2016-07-31',102),(988388,8777,'TARIFA_IT','0.65','2016-07-01','2016-07-31',102),(988389,8777,'TARIFA_IMS','0.7','2016-07-01','2016-07-31',102),(988390,8777,'PORCENTAJE_FOGASA','0.2','2016-07-01','2016-07-31',102),(988391,8777,'PORCENTAJE_FP_E','0.6','2016-07-01','2016-07-31',102),(988392,8777,'HORAS_TRABAJADAS','0.0','2016-07-01','2016-07-31',102),(988393,8777,'PREST_IT','0.0','2016-07-01','2016-07-31',102),(988394,8777,'TC2','401','2016-08-01','2016-08-31',103),(988395,8777,'DIAS_COTIZADOS','30.0','2016-08-01','2016-08-31',103),(988396,8777,'DIAS_NATURALES_MES','31','2016-08-01','2016-08-31',103),(988397,8777,'TIEMPO_COMPLETO','true','2016-08-01','2016-08-31',103),(988398,8777,'GRUPO_COTIZACION','04','2016-08-01','2016-08-31',103),(988399,8777,'DIAS_MES','30.0','2016-08-01','2016-08-31',103),(988400,8777,'PLUS_EXTRA_SALARIAL','0.0','2016-08-01','2016-08-31',103),(988401,8777,'DIAS_NOMINA','30.0','2016-08-01','2016-08-31',103),(988402,8777,'COEFICIENTE_ERE','0.0','2016-08-01','2016-08-31',103),(988403,8777,'SALARIO_ANUAL','13829.55','2016-08-01','2016-08-31',103),(988404,8777,'DIAS_HUELGA','0.0','2016-08-01','2016-08-31',103),(988405,8777,'DIAS_TRABAJADOS','30.0','2016-08-01','2016-08-31',103),(988406,8777,'PAGAS','14','2016-08-01','2016-08-31',103),(988407,8777,'SALARIO_BASE','987.8249999999999','2016-08-01','2016-08-31',103),(988408,8777,'DIAS_PAGA','30.0','2016-08-01','2016-08-31',103),(988409,8777,'ANTIGUEDAD','0.0','2016-08-01','2016-08-31',103),(988410,8777,'BASE_CGC','1152.4624999999999','2016-08-01','2016-08-31',103),(988411,8777,'PORCENTAJE_CGC','4.7','2016-08-01','2016-08-31',103),(988412,8777,'INDEFINIDO','false','2016-08-01','2016-08-31',103),(988413,8777,'BASE_CGP','1152.4624999999999','2016-08-01','2016-08-31',103),(988414,8777,'PORCENTAJE_FP','0.1','2016-08-01','2016-08-31',103),(988415,8777,'BASE_CGC_E','1152.4624999999999','2016-08-01','2016-08-31',103),(988416,8777,'PORCENTAJE_CGC_E','23.6','2016-08-01','2016-08-31',103),(988417,8777,'PORCENTAJE_EXTR_E','12.0','2016-08-01','2016-08-31',103),(988418,8777,'PORCENTAJE_NEXTR_E','23.6','2016-08-01','2016-08-31',103),(988419,8777,'BASE_CGP_E','1152.4624999999999','2016-08-01','2016-08-31',103),(988420,8777,'TARIFA_IT','0.65','2016-08-01','2016-08-31',103),(988421,8777,'TARIFA_IMS','0.7','2016-08-01','2016-08-31',103),(988422,8777,'PORCENTAJE_FOGASA','0.2','2016-08-01','2016-08-31',103),(988423,8777,'PORCENTAJE_FP_E','0.6','2016-08-01','2016-08-31',103),(988424,8777,'HORAS_TRABAJADAS','0.0','2016-08-01','2016-08-31',103),(988425,8777,'PREST_IT','0.0','2016-08-01','2016-08-31',103),(988426,8777,'TC2','401','2016-09-01','2016-09-30',104),(988427,8777,'DIAS_COTIZADOS','30.0','2016-09-01','2016-09-30',104),(988428,8777,'DIAS_NATURALES_MES','30','2016-09-01','2016-09-30',104),(988429,8777,'TIEMPO_COMPLETO','true','2016-09-01','2016-09-30',104),(988430,8777,'GRUPO_COTIZACION','04','2016-09-01','2016-09-30',104),(988431,8777,'DIAS_MES','30.0','2016-09-01','2016-09-30',104),(988432,8777,'PLUS_EXTRA_SALARIAL','0.0','2016-09-01','2016-09-30',104),(988433,8777,'DIAS_NOMINA','30.0','2016-09-01','2016-09-30',104),(988434,8777,'COEFICIENTE_ERE','0.0','2016-09-01','2016-09-30',104),(988435,8777,'SALARIO_ANUAL','13829.55','2016-09-01','2016-09-30',104),(988436,8777,'DIAS_HUELGA','0.0','2016-09-01','2016-09-30',104),(988437,8777,'DIAS_TRABAJADOS','30.0','2016-09-01','2016-09-30',104),(988438,8777,'PAGAS','14','2016-09-01','2016-09-30',104),(988439,8777,'SALARIO_BASE','987.8249999999999','2016-09-01','2016-09-30',104),(988440,8777,'DIAS_PAGA','30.0','2016-09-01','2016-09-30',104),(988441,8777,'ANTIGUEDAD','0.0','2016-09-01','2016-09-30',104),(988442,8777,'BASE_CGC','1152.4624999999996','2016-09-01','2016-09-30',104),(988443,8777,'PORCENTAJE_CGC','4.7','2016-09-01','2016-09-30',104),(988444,8777,'INDEFINIDO','false','2016-09-01','2016-09-30',104),(988445,8777,'BASE_CGP','1152.4624999999996','2016-09-01','2016-09-30',104),(988446,8777,'PORCENTAJE_FP','0.1','2016-09-01','2016-09-30',104),(988447,8777,'BASE_CGC_E','1152.4624999999996','2016-09-01','2016-09-30',104),(988448,8777,'PORCENTAJE_CGC_E','23.6','2016-09-01','2016-09-30',104),(988449,8777,'PORCENTAJE_EXTR_E','12.0','2016-09-01','2016-09-30',104),(988450,8777,'PORCENTAJE_NEXTR_E','23.6','2016-09-01','2016-09-30',104),(988451,8777,'BASE_CGP_E','1152.4624999999996','2016-09-01','2016-09-30',104),(988452,8777,'TARIFA_IT','0.65','2016-09-01','2016-09-30',104),(988453,8777,'TARIFA_IMS','0.7','2016-09-01','2016-09-30',104),(988454,8777,'PORCENTAJE_FOGASA','0.2','2016-09-01','2016-09-30',104),(988455,8777,'PORCENTAJE_FP_E','0.6','2016-09-01','2016-09-30',104),(988456,8777,'HORAS_TRABAJADAS','0.0','2016-09-01','2016-09-30',104),(988457,8777,'PREST_IT','0.0','2016-09-01','2016-09-30',104),(988458,8777,'TC2','401','2016-10-01','2016-10-31',105),(988459,8777,'DIAS_COTIZADOS','30.0','2016-10-01','2016-10-31',105),(988460,8777,'DIAS_NATURALES_MES','31','2016-10-01','2016-10-31',105),(988461,8777,'TIEMPO_COMPLETO','true','2016-10-01','2016-10-31',105),(988462,8777,'GRUPO_COTIZACION','04','2016-10-01','2016-10-31',105),(988463,8777,'DIAS_MES','30.0','2016-10-01','2016-10-31',105),(988464,8777,'PLUS_EXTRA_SALARIAL','0.0','2016-10-01','2016-10-31',105),(988465,8777,'DIAS_NOMINA','30.0','2016-10-01','2016-10-31',105),(988466,8777,'COEFICIENTE_ERE','0.0','2016-10-01','2016-10-31',105),(988467,8777,'SALARIO_ANUAL','13829.55','2016-10-01','2016-10-31',105),(988468,8777,'DIAS_HUELGA','0.0','2016-10-01','2016-10-31',105),(988469,8777,'DIAS_TRABAJADOS','30.0','2016-10-01','2016-10-31',105),(988470,8777,'PAGAS','14','2016-10-01','2016-10-31',105),(988471,8777,'SALARIO_BASE','987.8249999999999','2016-10-01','2016-10-31',105),(988472,8777,'DIAS_PAGA','30.0','2016-10-01','2016-10-31',105),(988473,8777,'ANTIGUEDAD','0.0','2016-10-01','2016-10-31',105),(988474,8777,'BASE_CGC','1152.4624999999999','2016-10-01','2016-10-31',105),(988475,8777,'PORCENTAJE_CGC','4.7','2016-10-01','2016-10-31',105),(988476,8777,'INDEFINIDO','false','2016-10-01','2016-10-31',105),(988477,8777,'BASE_CGP','1152.4624999999999','2016-10-01','2016-10-31',105),(988478,8777,'PORCENTAJE_FP','0.1','2016-10-01','2016-10-31',105),(988479,8777,'BASE_CGC_E','1152.4624999999999','2016-10-01','2016-10-31',105),(988480,8777,'PORCENTAJE_CGC_E','23.6','2016-10-01','2016-10-31',105),(988481,8777,'PORCENTAJE_EXTR_E','12.0','2016-10-01','2016-10-31',105),(988482,8777,'PORCENTAJE_NEXTR_E','23.6','2016-10-01','2016-10-31',105),(988483,8777,'BASE_CGP_E','1152.4624999999999','2016-10-01','2016-10-31',105),(988484,8777,'TARIFA_IT','0.65','2016-10-01','2016-10-31',105),(988485,8777,'TARIFA_IMS','0.7','2016-10-01','2016-10-31',105),(988486,8777,'PORCENTAJE_FOGASA','0.2','2016-10-01','2016-10-31',105),(988487,8777,'PORCENTAJE_FP_E','0.6','2016-10-01','2016-10-31',105),(988488,8777,'HORAS_TRABAJADAS','0.0','2016-10-01','2016-10-31',105),(988489,8777,'PREST_IT','0.0','2016-10-01','2016-10-31',105),(988490,8777,'TC2','401','2016-11-01','2016-11-30',106),(988491,8777,'DIAS_COTIZADOS','30.0','2016-11-01','2016-11-30',106),(988492,8777,'DIAS_NATURALES_MES','30','2016-11-01','2016-11-30',106),(988493,8777,'TIEMPO_COMPLETO','true','2016-11-01','2016-11-30',106),(988494,8777,'GRUPO_COTIZACION','04','2016-11-01','2016-11-30',106),(988495,8777,'DIAS_MES','30.0','2016-11-01','2016-11-30',106),(988496,8777,'PLUS_EXTRA_SALARIAL','0.0','2016-11-01','2016-11-30',106),(988497,8777,'DIAS_NOMINA','30.0','2016-11-01','2016-11-30',106),(988498,8777,'COEFICIENTE_ERE','0.0','2016-11-01','2016-11-30',106),(988499,8777,'SALARIO_ANUAL','13829.55','2016-11-01','2016-11-30',106),(988500,8777,'DIAS_HUELGA','0.0','2016-11-01','2016-11-30',106),(988501,8777,'DIAS_TRABAJADOS','30.0','2016-11-01','2016-11-30',106),(988502,8777,'PAGAS','14','2016-11-01','2016-11-30',106),(988503,8777,'SALARIO_BASE','987.8249999999999','2016-11-01','2016-11-30',106),(988504,8777,'DIAS_PAGA','30.0','2016-11-01','2016-11-30',106),(988505,8777,'ANTIGUEDAD','0.0','2016-11-01','2016-11-30',106),(988506,8777,'BASE_CGC','1152.4624999999996','2016-11-01','2016-11-30',106),(988507,8777,'PORCENTAJE_CGC','4.7','2016-11-01','2016-11-30',106),(988508,8777,'INDEFINIDO','false','2016-11-01','2016-11-30',106),(988509,8777,'BASE_CGP','1152.4624999999996','2016-11-01','2016-11-30',106),(988510,8777,'PORCENTAJE_FP','0.1','2016-11-01','2016-11-30',106),(988511,8777,'BASE_CGC_E','1152.4624999999996','2016-11-01','2016-11-30',106),(988512,8777,'PORCENTAJE_CGC_E','23.6','2016-11-01','2016-11-30',106),(988513,8777,'PORCENTAJE_EXTR_E','12.0','2016-11-01','2016-11-30',106),(988514,8777,'PORCENTAJE_NEXTR_E','23.6','2016-11-01','2016-11-30',106),(988515,8777,'BASE_CGP_E','1152.4624999999996','2016-11-01','2016-11-30',106),(988516,8777,'TARIFA_IT','0.65','2016-11-01','2016-11-30',106),(988517,8777,'TARIFA_IMS','0.7','2016-11-01','2016-11-30',106),(988518,8777,'PORCENTAJE_FOGASA','0.2','2016-11-01','2016-11-30',106),(988519,8777,'PORCENTAJE_FP_E','0.6','2016-11-01','2016-11-30',106),(988520,8777,'HORAS_TRABAJADAS','0.0','2016-11-01','2016-11-30',106),(988521,8777,'PREST_IT','0.0','2016-11-01','2016-11-30',106),(988522,8777,'PORCENTAJE_EXTR_E','12.0','2016-08-01','2016-08-31',107),(988523,8777,'DIAS_NOMINA','3.0','2016-08-19','2016-08-21',107),(988524,8777,'DIAS_NOMINA','3.0','2016-08-22','2016-08-24',107),(988525,8777,'DIAS_NOMINA','2.0','2016-08-25','2016-08-26',107),(988526,8777,'DIAS_NOMINA','5.0','2016-08-27','2016-08-31',107),(988527,8777,'DIAS_COTIZADOS','3.0','2016-08-19','2016-08-21',107),(988528,8777,'DIAS_COTIZADOS','4.0','2016-08-22','2016-08-26',107),(988529,8777,'DIAS_COTIZADOS','5.0','2016-08-27','2016-08-31',107),(988530,8777,'BASE_CGP_E','906.3071978021976','2016-08-19','2016-08-31',107),(988531,8777,'COEFICIENTE_ERE','0.0','2016-08-19','2016-08-21',107),(988532,8777,'COEFICIENTE_ERE','0.0','2016-08-27','2016-08-31',107),(988533,8777,'DIAS_PAGA','30.0','2016-08-19','2016-08-21',107),(988534,8777,'DIAS_PAGA','30.0','2016-08-27','2016-08-31',107),(988535,8777,'PORCENTAJE_FOGASA','0.2','2016-08-01','2016-08-31',107),(988536,8777,'PORCENTAJE_FP_E','0.6','2016-08-01','2016-08-31',107),(988537,8777,'DIAS_ENFERMEDAD_COMUN_1_3','3.0','2016-08-22','2016-08-24',107),(988538,8777,'HORAS_TRABAJADAS','0.0','2016-08-19','2016-08-21',107),(988539,8777,'HORAS_TRABAJADAS','0.0','2016-08-27','2016-08-31',107),(988540,8777,'BASE_ESTR','33.333333333333336','2016-08-19','2016-08-21',107),(988541,8777,'BASE_ESTR','66.66666666666667','2016-08-27','2016-08-31',107),(988542,8777,'PORCENTAJE_CGC_E','23.6','2016-08-01','2016-08-31',107),(988543,8777,'PORCENTAJE_CGC','4.7','2016-08-01','2016-08-31',107),(988544,8777,'BASE_REGULADORA','47.429835164835154','2016-08-22','2016-08-26',107),(988545,8777,'DIAS_ENFERMEDAD_COMUN_4_15','2.0','2016-08-25','2016-08-26',107),(988546,8777,'TARIFA_IT','0.65','2016-08-01','2016-08-31',107),(988547,8777,'TC2','100','2016-08-19','2016-08-31',107),(988548,8777,'BASE_CGP','307.3723809523809','2016-08-19','2016-08-21',107),(988549,8777,'BASE_CGP','142.28950549450548','2016-08-22','2016-08-24',107),(988550,8777,'BASE_CGP','47.429835164835154','2016-08-25','2016-08-26',107),(988551,8777,'BASE_CGP','409.2154761904761','2016-08-27','2016-08-31',107),(988552,8777,'DIAS_NATURALES_MES','31','2016-08-01','2016-08-31',107),(988553,8777,'TIEMPO_COMPLETO','true','2016-08-01','2016-08-31',107),(988554,8777,'GRUPO_COTIZACION','02','2016-08-19','2016-08-31',107),(988555,8777,'SALARIO_ANUAL','14387.05','2016-08-01','2016-08-31',107),(988556,8777,'INDEFINIDO','true','2016-08-01','2016-08-31',107),(988557,8777,'PORCENTAJE_EXTR','2.0','2016-08-01','2016-08-31',107),(988558,8777,'DIAS_MES','30.0','2016-08-19','2016-08-21',107),(988559,8777,'DIAS_MES','30','2016-08-22','2016-08-26',107),(988560,8777,'DIAS_MES','30.0','2016-08-27','2016-08-31',107),(988561,8777,'PLUS_EXTRA_SALARIAL','0.0','2016-08-01','2016-08-31',107),(988562,8777,'BASE_CGC','274.0390476190476','2016-08-19','2016-08-21',107),(988563,8777,'BASE_CGC','142.28950549450548','2016-08-22','2016-08-24',107),(988564,8777,'BASE_CGC','47.429835164835154','2016-08-25','2016-08-26',107),(988565,8777,'BASE_CGC','342.5488095238095','2016-08-27','2016-08-31',107),(988566,8777,'PAGAS','14','2016-08-01','2016-08-31',107),(988567,8777,'ANTIGUEDAD','0.0','2016-08-19','2016-08-21',107),(988568,8777,'ANTIGUEDAD','0.0','2016-08-27','2016-08-31',107),(988569,8777,'PREST_IT','0.0','2016-08-19','2016-08-21',107),(988570,8777,'PREST_IT','0.0','2016-08-22','2016-08-24',107),(988571,8777,'PREST_IT','56.915802197802186','2016-08-25','2016-08-26',107),(988572,8777,'PREST_IT','0.0','2016-08-27','2016-08-31',107),(988573,8777,'DIAS_HUELGA','0.0','2016-08-19','2016-08-21',107),(988574,8777,'DIAS_HUELGA','0.0','2016-08-27','2016-08-31',107),(988575,8777,'BASE_CGC_E','806.3071978021977','2016-08-19','2016-08-31',107),(988576,8777,'TARIFA_IMS','0.7','2016-08-01','2016-08-31',107),(988577,8777,'DIAS_TRABAJADOS','3.0','2016-08-19','2016-08-21',107),(988578,8777,'DIAS_TRABAJADOS','5.0','2016-08-27','2016-08-31',107),(988579,8777,'SALARIO_BASE','102.76464285714286','2016-08-19','2016-08-21',107),(988580,8777,'SALARIO_BASE','0.0','2016-08-22','2016-08-26',107),(988581,8777,'SALARIO_BASE','171.27440476190475','2016-08-27','2016-08-31',107),(988582,8777,'PORCENTAJE_FP','0.1','2016-08-01','2016-08-31',107),(988583,8777,'DIAS_NOMINA','30.0','2016-11-01','2016-11-30',108),(988584,8777,'DIAS_COTIZADOS','30.0','2016-11-01','2016-11-30',108),(988585,8777,'BASE_CGP_E','1067.4091666666666','2016-11-01','2016-11-30',108),(988586,8777,'COEFICIENTE_ERE','0.0','2016-11-01','2016-11-30',108),(988587,8777,'DIAS_PAGA','30.0','2016-11-01','2016-11-30',108),(988588,8777,'PORCENTAJE_FOGASA','0.2','2016-11-01','2016-11-30',108),(988589,8777,'PORCENTAJE_FP_E','0.6','2016-11-01','2016-11-30',108),(988590,8777,'HORAS_TRABAJADAS','0.0','2016-11-01','2016-11-30',108),(988591,8777,'PORCENTAJE_CGC_E','23.6','2016-11-01','2016-11-30',108),(988592,8777,'PORCENTAJE_CGC','4.7','2016-11-01','2016-11-30',108),(988593,8777,'TARIFA_IT','0.65','2016-11-01','2016-11-30',108),(988594,8777,'TC2','100','2016-11-01','2016-11-30',108),(988595,8777,'BASE_CGP','1067.4091666666666','2016-11-01','2016-11-30',108),(988596,8777,'DIAS_NATURALES_MES','30','2016-11-01','2016-11-30',108),(988597,8777,'TIEMPO_COMPLETO','true','2016-11-01','2016-11-30',108),(988598,8777,'GRUPO_COTIZACION','05','2016-11-01','2016-11-30',108),(988599,8777,'SALARIO_ANUAL','12808.91','2016-11-01','2016-11-30',108),(988600,8777,'INDEFINIDO','true','2016-11-01','2016-11-30',108),(988601,8777,'DIAS_MES','30.0','2016-11-01','2016-11-30',108),(988602,8777,'PLUS_EXTRA_SALARIAL','0.0','2016-11-01','2016-11-30',108),(988603,8777,'BASE_CGC','1067.4091666666666','2016-11-01','2016-11-30',108),(988604,8777,'PAGAS','14','2016-11-01','2016-11-30',108),(988605,8777,'ANTIGUEDAD','0.0','2016-11-01','2016-11-30',108),(988606,8777,'PREST_IT','0.0','2016-11-01','2016-11-30',108),(988607,8777,'DIAS_HUELGA','0.0','2016-11-01','2016-11-30',108),(988608,8777,'BASE_CGC_E','1067.4091666666666','2016-11-01','2016-11-30',108),(988609,8777,'TARIFA_IMS','0.7','2016-11-01','2016-11-30',108),(988610,8777,'DIAS_TRABAJADOS','30.0','2016-11-01','2016-11-30',108),(988611,8777,'SALARIO_BASE','914.9221428571428','2016-11-01','2016-11-30',108),(988612,8777,'PORCENTAJE_FP','0.1','2016-11-01','2016-11-30',108),(988895,8788,'DIAS_NOMINA','30.0','2016-12-01','2016-12-31',119),(988896,8788,'DIAS_COTIZADOS','30.0','2016-12-01','2016-12-31',119),(988897,8788,'BASE_CGP_E','3439.8','2016-12-01','2016-12-31',119),(988898,8788,'COEFICIENTE_ERE','0.0','2016-12-01','2016-12-31',119),(988899,8788,'PORCENTAJE_FOGASA','0.2','2016-12-01','2016-12-31',119),(988900,8788,'PORCENTAJE_FP_E','0.6','2016-12-01','2016-12-31',119),(988901,8788,'HORAS_TRABAJADAS','0.0','2016-12-01','2016-12-31',119),(988902,8788,'PORCENTAJE_CGC_E','23.6','2016-12-01','2016-12-31',119),(988903,8788,'SALARIO_MENSUAL','1146.6000000000001','2016-12-01','2016-12-31',119),(988904,8788,'PORCENTAJE_CGC','4.7','2016-12-01','2016-12-31',119),(988905,8788,'TARIFA_IT','1.7','2016-12-01','2016-12-31',119),(988906,8788,'TC2','100','2016-12-01','2016-12-31',119),(988907,8788,'BASE_CGP','3439.8','2016-12-01','2016-12-31',119),(988908,8788,'DIAS_NATURALES_MES','31','2016-12-01','2016-12-31',119),(988909,8788,'TIEMPO_COMPLETO','true','2016-12-01','2016-12-31',119),(988910,8788,'GRUPO_COTIZACION','05','2016-12-01','2016-12-31',119),(988911,8788,'INDEFINIDO','true','2016-12-01','2016-12-31',119),(988912,8788,'DIAS_MES','30.0','2016-12-01','2016-12-31',119),(988913,8788,'BASE_CGC','3439.8','2016-12-01','2016-12-31',119),(988914,8788,'SMI','655.2','2016-12-01','2016-12-31',119),(988915,8788,'PREST_IT','0.0','2016-12-01','2016-12-31',119),(988916,8788,'DIAS_HUELGA','0.0','2016-12-01','2016-12-31',119),(988917,8788,'BASE_CGC_E','3439.8','2016-12-01','2016-12-31',119),(988918,8788,'TARIFA_IMS','1.2','2016-12-01','2016-12-31',119),(988919,8788,'DIAS_TRABAJADOS','30.0','2016-12-01','2016-12-31',119),(988920,8788,'SALARIO_BASE','1146.6000000000001','2016-12-01','2016-12-31',119),(988921,8788,'PORCENTAJE_FP','0.1','2016-12-01','2016-12-31',119),(988922,8788,'DIAS_NOMINA','8.0','2016-12-02','2016-12-09',120),(988923,8788,'DIAS_COTIZADOS','8.0','2016-12-02','2016-12-09',120),(988924,8788,'BASE_CGP_E','524.16','2016-12-02','2016-12-09',120),(988925,8788,'COEFICIENTE_ERE','0.0','2016-12-02','2016-12-09',120),(988926,8788,'PORCENTAJE_FOGASA','0.2','2016-12-02','2016-12-09',120),(988927,8788,'PORCENTAJE_FP_E','0.6','2016-12-02','2016-12-09',120),(988928,8788,'HORAS_TRABAJADAS','0.0','2016-12-02','2016-12-09',120),(988929,8788,'PORCENTAJE_CGC_E','23.6','2016-12-02','2016-12-09',120),(988930,8788,'SALARIO_MENSUAL','655.2','2016-12-02','2016-12-09',120),(988931,8788,'PORCENTAJE_CGC','4.7','2016-12-02','2016-12-09',120),(988932,8788,'TARIFA_IT','1.7','2016-12-02','2016-12-09',120),(988933,8788,'TC2','401','2016-12-02','2016-12-09',120),(988934,8788,'BASE_CGP','524.16','2016-12-02','2016-12-09',120),(988935,8788,'DIAS_NATURALES_MES','31','2016-12-02','2016-12-09',120),(988936,8788,'TIEMPO_COMPLETO','true','2016-12-02','2016-12-09',120),(988937,8788,'GRUPO_COTIZACION','04','2016-12-02','2016-12-09',120),(988938,8788,'INDEFINIDO','false','2016-12-02','2016-12-09',120),(988939,8788,'DIAS_MES','30.0','2016-12-02','2016-12-09',120),(988940,8788,'BASE_CGC','524.16','2016-12-02','2016-12-09',120),(988941,8788,'SMI','655.2','2016-12-01','2016-12-31',120),(988942,8788,'PREST_IT','0.0','2016-12-02','2016-12-09',120),(988943,8788,'DIAS_HUELGA','0.0','2016-12-02','2016-12-09',120),(988944,8788,'BASE_CGC_E','524.16','2016-12-02','2016-12-09',120),(988945,8788,'TARIFA_IMS','1.2','2016-12-02','2016-12-09',120),(988946,8788,'DIAS_TRABAJADOS','8.0','2016-12-02','2016-12-09',120),(988947,8788,'SALARIO_BASE','174.72','2016-12-02','2016-12-09',120),(988948,8788,'PORCENTAJE_FP','0.1','2016-12-02','2016-12-09',120),(988949,8788,'DIAS_NOMINA','5.0','2016-12-12','2016-12-16',121),(988950,8788,'DIAS_COTIZADOS','5.0','2016-12-12','2016-12-16',121),(988951,8788,'BASE_CGP_E','327.6','2016-12-12','2016-12-16',121),(988952,8788,'COEFICIENTE_ERE','0.0','2016-12-12','2016-12-16',121),(988953,8788,'PORCENTAJE_FOGASA','0.2','2016-12-12','2016-12-16',121),(988954,8788,'PORCENTAJE_FP_E','0.6','2016-12-12','2016-12-16',121),(988955,8788,'PORCENTAJE_CORTA_DURACION','36.0','2016-12-12','2016-12-16',121),(988956,8788,'HORAS_TRABAJADAS','0.0','2016-12-12','2016-12-16',121),(988957,8788,'PORCENTAJE_CGC_E','23.6','2016-12-12','2016-12-16',121),(988958,8788,'SALARIO_MENSUAL','655.2','2016-12-12','2016-12-16',121),(988959,8788,'PORCENTAJE_CGC','4.7','2016-12-12','2016-12-16',121),(988960,8788,'TARIFA_IT','1.7','2016-12-12','2016-12-16',121),(988961,8788,'TC2','401','2016-12-12','2016-12-16',121),(988962,8788,'BASE_CGP','327.6','2016-12-12','2016-12-16',121),(988963,8788,'DIAS_NATURALES_MES','31','2016-12-12','2016-12-16',121),(988964,8788,'TIEMPO_COMPLETO','true','2016-12-12','2016-12-16',121),(988965,8788,'GRUPO_COTIZACION','04','2016-12-12','2016-12-16',121),(988966,8788,'INDEFINIDO','false','2016-12-12','2016-12-16',121),(988967,8788,'DIAS_MES','30.0','2016-12-12','2016-12-16',121),(988968,8788,'BASE_CGC','327.6','2016-12-12','2016-12-16',121),(988969,8788,'CONTRATO_CORTA_DURACION','true','2016-12-12','2016-12-16',121),(988970,8788,'SMI','655.2','2016-12-01','2016-12-31',121),(988971,8788,'PREST_IT','0.0','2016-12-12','2016-12-16',121),(988972,8788,'DIAS_HUELGA','0.0','2016-12-12','2016-12-16',121),(988973,8788,'BASE_CGC_E','327.6','2016-12-12','2016-12-16',121),(988974,8788,'TARIFA_IMS','1.2','2016-12-12','2016-12-16',121),(988975,8788,'DIAS_TRABAJADOS','5.0','2016-12-12','2016-12-16',121),(988976,8788,'SALARIO_BASE','109.2','2016-12-12','2016-12-16',121),(988977,8788,'PORCENTAJE_FP','0.1','2016-12-12','2016-12-16',121),(988978,8788,'DIAS_NOMINA','5.0','2016-12-19','2016-12-23',122),(988979,8788,'DIAS_COTIZADOS','5.0','2016-12-19','2016-12-23',122),(988980,8788,'BASE_CGP_E','327.6','2016-12-19','2016-12-23',122),(988981,8788,'COEFICIENTE_ERE','0.0','2016-12-19','2016-12-23',122),(988982,8788,'PORCENTAJE_FOGASA','0.2','2016-12-19','2016-12-23',122),(988983,8788,'PORCENTAJE_FP_E','0.6','2016-12-19','2016-12-23',122),(988984,8788,'PORCENTAJE_CORTA_DURACION','36.0','2016-12-19','2016-12-23',122),(988985,8788,'HORAS_TRABAJADAS','0.0','2016-12-19','2016-12-23',122),(988986,8788,'PORCENTAJE_CGC_E','23.6','2016-12-19','2016-12-23',122),(988987,8788,'SALARIO_MENSUAL','655.2','2016-12-19','2016-12-23',122),(988988,8788,'PORCENTAJE_CGC','4.7','2016-12-19','2016-12-23',122),(988989,8788,'TARIFA_IT','1.7','2016-12-19','2016-12-23',122),(988990,8788,'TC2','401','2016-12-19','2016-12-23',122),(988991,8788,'BASE_CGP','327.6','2016-12-19','2016-12-23',122),(988992,8788,'DIAS_NATURALES_MES','31','2016-12-19','2016-12-23',122),(988993,8788,'TIEMPO_COMPLETO','true','2016-12-19','2016-12-23',122),(988994,8788,'GRUPO_COTIZACION','07','2016-12-19','2016-12-23',122),(988995,8788,'INDEFINIDO','false','2016-12-19','2016-12-23',122),(988996,8788,'DIAS_MES','30.0','2016-12-19','2016-12-23',122),(988997,8788,'BASE_CGC','327.6','2016-12-19','2016-12-23',122),(988998,8788,'CONTRATO_CORTA_DURACION','true','2016-12-19','2016-12-23',122),(988999,8788,'SMI','655.2','2016-12-01','2016-12-31',122),(989000,8788,'PREST_IT','0.0','2016-12-19','2016-12-23',122),(989001,8788,'DIAS_HUELGA','0.0','2016-12-19','2016-12-23',122),(989002,8788,'BASE_CGC_E','327.6','2016-12-19','2016-12-23',122),(989003,8788,'TARIFA_IMS','1.2','2016-12-19','2016-12-23',122),(989004,8788,'DIAS_TRABAJADOS','5.0','2016-12-19','2016-12-23',122),(989005,8788,'SALARIO_BASE','109.2','2016-12-19','2016-12-23',122),(989006,8788,'PORCENTAJE_FP','0.1','2016-12-19','2016-12-23',122),(989007,8788,'DIAS_NOMINA','6.0','2016-12-26','2016-12-31',123),(989008,8788,'DIAS_COTIZADOS','6.0','2016-12-26','2016-12-31',123),(989009,8788,'BASE_CGP_E','393.12000000000006','2016-12-26','2016-12-31',123),(989010,8788,'COEFICIENTE_ERE','0.0','2016-12-26','2016-12-31',123),(989011,8788,'PORCENTAJE_FOGASA','0.2','2016-12-26','2016-12-31',123),(989012,8788,'PORCENTAJE_FP_E','0.6','2016-12-26','2016-12-31',123),(989013,8788,'PORCENTAJE_CORTA_DURACION','36.0','2016-12-26','2016-12-31',123),(989014,8788,'HORAS_TRABAJADAS','0.0','2016-12-26','2016-12-31',123),(989015,8788,'PORCENTAJE_CGC_E','23.6','2016-12-26','2016-12-31',123),(989016,8788,'SALARIO_MENSUAL','655.2','2016-12-26','2016-12-31',123),(989017,8788,'PORCENTAJE_CGC','4.7','2016-12-26','2016-12-31',123),(989018,8788,'TARIFA_IT','1.7','2016-12-26','2016-12-31',123),(989019,8788,'TC2','401','2016-12-26','2016-12-31',123),(989020,8788,'BASE_CGP','393.12000000000006','2016-12-26','2016-12-31',123),(989021,8788,'DIAS_NATURALES_MES','31','2016-12-26','2016-12-31',123),(989022,8788,'TIEMPO_COMPLETO','true','2016-12-26','2016-12-31',123),(989023,8788,'GRUPO_COTIZACION','07','2016-12-26','2016-12-31',123),(989024,8788,'INDEFINIDO','false','2016-12-26','2016-12-31',123),(989025,8788,'DIAS_MES','30.0','2016-12-26','2016-12-31',123),(989026,8788,'BASE_CGC','393.12000000000006','2016-12-26','2016-12-31',123),(989027,8788,'CONTRATO_CORTA_DURACION','true','2016-12-26','2016-12-31',123),(989028,8788,'SMI','655.2','2016-12-01','2016-12-31',123),(989029,8788,'PREST_IT','0.0','2016-12-26','2016-12-31',123),(989030,8788,'DIAS_HUELGA','0.0','2016-12-26','2016-12-31',123),(989031,8788,'BASE_CGC_E','393.12000000000006','2016-12-26','2016-12-31',123),(989032,8788,'TARIFA_IMS','1.2','2016-12-26','2016-12-31',123),(989033,8788,'DIAS_TRABAJADOS','6.0','2016-12-26','2016-12-31',123),(989034,8788,'SALARIO_BASE','131.04000000000002','2016-12-26','2016-12-31',123),(989035,8788,'PORCENTAJE_FP','0.1','2016-12-26','2016-12-31',123),(989065,8788,'DIAS_NOMINA','30.0','2016-11-01','2016-11-30',125),(989066,8788,'DIAS_COTIZADOS','30.0','2016-11-01','2016-11-30',125),(989067,8788,'BASE_CGP_E','1965.6000000000004','2016-11-01','2016-11-30',125),(989068,8788,'COEFICIENTE_ERE','0.0','2016-11-01','2016-11-30',125),(989069,8788,'PORCENTAJE_FOGASA','0.2','2016-11-01','2016-11-30',125),(989070,8788,'PORCENTAJE_FP_E','0.6','2016-11-01','2016-11-30',125),(989071,8788,'HORAS_TRABAJADAS','0.0','2016-11-01','2016-11-30',125),(989072,8788,'PORCENTAJE_CGC_E','23.6','2016-11-01','2016-11-30',125),(989073,8788,'SALARIO_MENSUAL','655.2','2016-11-01','2016-11-30',125),(989074,8788,'PORCENTAJE_CGC','4.7','2016-11-01','2016-11-30',125),(989075,8788,'TARIFA_IT','1.7','2016-11-01','2016-11-30',125),(989076,8788,'TC2','100','2016-11-01','2016-11-30',125),(989077,8788,'BASE_CGP','1965.6000000000004','2016-11-01','2016-11-30',125),(989078,8788,'DIAS_NATURALES_MES','30','2016-11-01','2016-11-30',125),(989079,8788,'TIEMPO_COMPLETO','true','2016-11-01','2016-11-30',125),(989080,8788,'GRUPO_COTIZACION','05','2016-11-01','2016-11-30',125),(989081,8788,'INDEFINIDO','true','2016-11-01','2016-11-30',125),(989082,8788,'DIAS_MES','30.0','2016-11-01','2016-11-30',125),(989083,8788,'BASE_CGC','1965.6000000000004','2016-11-01','2016-11-30',125),(989084,8788,'SMI','655.2','2016-11-01','2016-11-30',125),(989085,8788,'PREST_IT','0.0','2016-11-01','2016-11-30',125),(989086,8788,'DIAS_HUELGA','0.0','2016-11-01','2016-11-30',125),(989087,8788,'BASE_CGC_E','1965.6000000000004','2016-11-01','2016-11-30',125),(989088,8788,'TARIFA_IMS','1.2','2016-11-01','2016-11-30',125),(989089,8788,'DIAS_TRABAJADOS','30.0','2016-11-01','2016-11-30',125),(989090,8788,'SALARIO_BASE','655.2','2016-11-01','2016-11-30',125),(989091,8788,'PORCENTAJE_FP','0.1','2016-11-01','2016-11-30',125),(989092,8788,'DIAS_NOMINA','8.0','2016-11-02','2016-11-09',126),(989093,8788,'DIAS_COTIZADOS','8.0','2016-11-02','2016-11-09',126),(989094,8788,'BASE_CGP_E','524.16','2016-11-02','2016-11-09',126),(989095,8788,'COEFICIENTE_ERE','0.0','2016-11-02','2016-11-09',126),(989096,8788,'PORCENTAJE_FOGASA','0.2','2016-11-02','2016-11-09',126),(989097,8788,'PORCENTAJE_FP_E','0.6','2016-11-02','2016-11-09',126),(989098,8788,'HORAS_TRABAJADAS','0.0','2016-11-02','2016-11-09',126),(989099,8788,'PORCENTAJE_CGC_E','23.6','2016-11-02','2016-11-09',126),(989100,8788,'SALARIO_MENSUAL','655.2','2016-11-02','2016-11-09',126),(989101,8788,'PORCENTAJE_CGC','4.7','2016-11-02','2016-11-09',126),(989102,8788,'TARIFA_IT','1.7','2016-11-02','2016-11-09',126),(989103,8788,'TC2','401','2016-11-02','2016-11-09',126),(989104,8788,'BASE_CGP','524.16','2016-11-02','2016-11-09',126),(989105,8788,'DIAS_NATURALES_MES','30','2016-11-02','2016-11-09',126),(989106,8788,'TIEMPO_COMPLETO','true','2016-11-02','2016-11-09',126),(989107,8788,'GRUPO_COTIZACION','04','2016-11-02','2016-11-09',126),(989108,8788,'INDEFINIDO','false','2016-11-02','2016-11-09',126),(989109,8788,'DIAS_MES','30.0','2016-11-02','2016-11-09',126),(989110,8788,'BASE_CGC','524.16','2016-11-02','2016-11-09',126),(989111,8788,'SMI','655.2','2016-11-01','2016-11-30',126),(989112,8788,'PREST_IT','0.0','2016-11-02','2016-11-09',126),(989113,8788,'DIAS_HUELGA','0.0','2016-11-02','2016-11-09',126),(989114,8788,'BASE_CGC_E','524.16','2016-11-02','2016-11-09',126),(989115,8788,'TARIFA_IMS','1.2','2016-11-02','2016-11-09',126),(989116,8788,'DIAS_TRABAJADOS','8.0','2016-11-02','2016-11-09',126),(989117,8788,'SALARIO_BASE','174.72','2016-11-02','2016-11-09',126),(989118,8788,'PORCENTAJE_FP','0.1','2016-11-02','2016-11-09',126),(989119,8788,'DIAS_NOMINA','5.0','2016-11-12','2016-11-16',127),(989120,8788,'DIAS_COTIZADOS','5.0','2016-11-12','2016-11-16',127),(989121,8788,'BASE_CGP_E','327.6','2016-11-12','2016-11-16',127),(989122,8788,'COEFICIENTE_ERE','0.0','2016-11-12','2016-11-16',127),(989123,8788,'PORCENTAJE_FOGASA','0.2','2016-11-12','2016-11-16',127),(989124,8788,'PORCENTAJE_FP_E','0.6','2016-11-12','2016-11-16',127),(989125,8788,'PORCENTAJE_CORTA_DURACION','36.0','2016-11-12','2016-11-16',127),(989126,8788,'HORAS_TRABAJADAS','0.0','2016-11-12','2016-11-16',127),(989127,8788,'PORCENTAJE_CGC_E','23.6','2016-11-12','2016-11-16',127),(989128,8788,'SALARIO_MENSUAL','655.2','2016-11-12','2016-11-16',127),(989129,8788,'PORCENTAJE_CGC','4.7','2016-11-12','2016-11-16',127),(989130,8788,'TARIFA_IT','1.7','2016-11-12','2016-11-16',127),(989131,8788,'TC2','401','2016-11-12','2016-11-16',127),(989132,8788,'BASE_CGP','327.6','2016-11-12','2016-11-16',127),(989133,8788,'DIAS_NATURALES_MES','30','2016-11-12','2016-11-16',127),(989134,8788,'TIEMPO_COMPLETO','true','2016-11-12','2016-11-16',127),(989135,8788,'GRUPO_COTIZACION','04','2016-11-12','2016-11-16',127),(989136,8788,'INDEFINIDO','false','2016-11-12','2016-11-16',127),(989137,8788,'DIAS_MES','30.0','2016-11-12','2016-11-16',127),(989138,8788,'BASE_CGC','327.6','2016-11-12','2016-11-16',127),(989139,8788,'CONTRATO_CORTA_DURACION','true','2016-11-12','2016-11-16',127),(989140,8788,'SMI','655.2','2016-11-01','2016-11-30',127),(989141,8788,'PREST_IT','0.0','2016-11-12','2016-11-16',127),(989142,8788,'DIAS_HUELGA','0.0','2016-11-12','2016-11-16',127),(989143,8788,'BASE_CGC_E','327.6','2016-11-12','2016-11-16',127),(989144,8788,'TARIFA_IMS','1.2','2016-11-12','2016-11-16',127),(989145,8788,'DIAS_TRABAJADOS','5.0','2016-11-12','2016-11-16',127),(989146,8788,'SALARIO_BASE','109.2','2016-11-12','2016-11-16',127),(989147,8788,'PORCENTAJE_FP','0.1','2016-11-12','2016-11-16',127),(989148,8788,'DIAS_NOMINA','5.0','2016-11-19','2016-11-23',128),(989149,8788,'DIAS_COTIZADOS','5.0','2016-11-19','2016-11-23',128),(989150,8788,'BASE_CGP_E','327.6','2016-11-19','2016-11-23',128),(989151,8788,'COEFICIENTE_ERE','0.0','2016-11-19','2016-11-23',128),(989152,8788,'PORCENTAJE_FOGASA','0.2','2016-11-19','2016-11-23',128),(989153,8788,'PORCENTAJE_FP_E','0.6','2016-11-19','2016-11-23',128),(989154,8788,'PORCENTAJE_CORTA_DURACION','36.0','2016-11-19','2016-11-23',128),(989155,8788,'HORAS_TRABAJADAS','0.0','2016-11-19','2016-11-23',128),(989156,8788,'PORCENTAJE_CGC_E','23.6','2016-11-19','2016-11-23',128),(989157,8788,'SALARIO_MENSUAL','655.2','2016-11-19','2016-11-23',128),(989158,8788,'PORCENTAJE_CGC','4.7','2016-11-19','2016-11-23',128),(989159,8788,'TARIFA_IT','1.7','2016-11-19','2016-11-23',128),(989160,8788,'TC2','401','2016-11-19','2016-11-23',128),(989161,8788,'BASE_CGP','327.6','2016-11-19','2016-11-23',128),(989162,8788,'DIAS_NATURALES_MES','30','2016-11-19','2016-11-23',128),(989163,8788,'TIEMPO_COMPLETO','true','2016-11-19','2016-11-23',128),(989164,8788,'GRUPO_COTIZACION','07','2016-11-19','2016-11-23',128),(989165,8788,'INDEFINIDO','false','2016-11-19','2016-11-23',128),(989166,8788,'DIAS_MES','30.0','2016-11-19','2016-11-23',128),(989167,8788,'BASE_CGC','327.6','2016-11-19','2016-11-23',128),(989168,8788,'CONTRATO_CORTA_DURACION','true','2016-11-19','2016-11-23',128),(989169,8788,'SMI','655.2','2016-11-01','2016-11-30',128),(989170,8788,'PREST_IT','0.0','2016-11-19','2016-11-23',128),(989171,8788,'DIAS_HUELGA','0.0','2016-11-19','2016-11-23',128),(989172,8788,'BASE_CGC_E','327.6','2016-11-19','2016-11-23',128),(989173,8788,'TARIFA_IMS','1.2','2016-11-19','2016-11-23',128),(989174,8788,'DIAS_TRABAJADOS','5.0','2016-11-19','2016-11-23',128),(989175,8788,'SALARIO_BASE','109.2','2016-11-19','2016-11-23',128),(989176,8788,'PORCENTAJE_FP','0.1','2016-11-19','2016-11-23',128),(989177,8788,'DIAS_NOMINA','5.0','2016-11-26','2016-11-30',129),(989178,8788,'DIAS_COTIZADOS','5.0','2016-11-26','2016-11-30',129),(989179,8788,'BASE_CGP_E','327.6','2016-11-26','2016-11-30',129),(989180,8788,'COEFICIENTE_ERE','0.0','2016-11-26','2016-11-30',129),(989181,8788,'PORCENTAJE_FOGASA','0.2','2016-11-26','2016-11-30',129),(989182,8788,'PORCENTAJE_FP_E','0.6','2016-11-26','2016-11-30',129),(989183,8788,'PORCENTAJE_CORTA_DURACION','36.0','2016-11-26','2016-11-30',129),(989184,8788,'HORAS_TRABAJADAS','0.0','2016-11-26','2016-11-30',129),(989185,8788,'PORCENTAJE_CGC_E','23.6','2016-11-26','2016-11-30',129),(989186,8788,'SALARIO_MENSUAL','655.2','2016-11-26','2016-11-30',129),(989187,8788,'PORCENTAJE_CGC','4.7','2016-11-26','2016-11-30',129),(989188,8788,'TARIFA_IT','1.7','2016-11-26','2016-11-30',129),(989189,8788,'TC2','401','2016-11-26','2016-11-30',129),(989190,8788,'BASE_CGP','327.6','2016-11-26','2016-11-30',129),(989191,8788,'DIAS_NATURALES_MES','30','2016-11-26','2016-11-30',129),(989192,8788,'TIEMPO_COMPLETO','true','2016-11-26','2016-11-30',129),(989193,8788,'GRUPO_COTIZACION','07','2016-11-26','2016-11-30',129),(989194,8788,'INDEFINIDO','false','2016-11-26','2016-11-30',129),(989195,8788,'DIAS_MES','30.0','2016-11-26','2016-11-30',129),(989196,8788,'BASE_CGC','327.6','2016-11-26','2016-11-30',129),(989197,8788,'CONTRATO_CORTA_DURACION','true','2016-11-26','2016-11-30',129),(989198,8788,'SMI','655.2','2016-11-01','2016-11-30',129),(989199,8788,'PREST_IT','0.0','2016-11-26','2016-11-30',129),(989200,8788,'DIAS_HUELGA','0.0','2016-11-26','2016-11-30',129),(989201,8788,'BASE_CGC_E','327.6','2016-11-26','2016-11-30',129),(989202,8788,'TARIFA_IMS','1.2','2016-11-26','2016-11-30',129),(989203,8788,'DIAS_TRABAJADOS','5.0','2016-11-26','2016-11-30',129),(989204,8788,'SALARIO_BASE','109.2','2016-11-26','2016-11-30',129),(989205,8788,'PORCENTAJE_FP','0.1','2016-11-26','2016-11-30',129),(989307,8788,'BASE_REGULADORA','65.52000000000001','2016-11-01','2016-11-30',133),(989308,8788,'DIAS_NOMINA','30.0','2016-11-01','2016-11-30',133),(989309,8788,'TARIFA_IT','1.7','2016-11-01','2016-11-30',133),(989310,8788,'TC2','100','2016-11-01','2016-11-30',133),(989311,8788,'DIAS_ENFERMEDAD_COMUN_21','30','2016-11-01','2016-11-30',133),(989312,8788,'BASE_CGP','1965.6000000000004','2016-11-01','2016-11-30',133),(989313,8788,'DIAS_COTIZADOS','30.0','2016-11-01','2016-11-30',133),(989314,8788,'DIAS_NATURALES_MES','30','2016-11-01','2016-11-30',133),(989315,8788,'NOMINA','true','2016-11-01','2016-11-30',133),(989316,8788,'TIEMPO_COMPLETO','true','2016-11-01','2016-11-30',133),(989317,8788,'GRUPO_COTIZACION','04','2016-11-01','2016-11-30',133),(989318,8788,'BASE_CGP_E','1965.6000000000004','2016-11-01','2016-11-30',133),(989319,8788,'INDEFINIDO','true','2016-11-01','2016-11-30',133),(989320,8788,'PORCENTAJE_FOGASA','0.2','2016-11-01','2016-11-30',133),(989321,8788,'PORCENTAJE_FP_E','0.6','2016-11-01','2016-11-30',133),(989322,8788,'DIAS_MES','30','2016-11-01','2016-11-30',133),(989323,8788,'BASE_CGC','1965.6000000000004','2016-11-01','2016-11-30',133),(989324,8788,'PREST_IT','1474.2000000000003','2016-11-01','2016-11-30',133),(989325,8788,'BASE_CGC_E','1965.6000000000004','2016-11-01','2016-11-30',133),(989326,8788,'PORCENTAJE_CGC_E','23.6','2016-11-01','2016-11-30',133),(989327,8788,'TARIFA_IMS','1.2','2016-11-01','2016-11-30',133),(989328,8788,'SALARIO_BASE','0.0','2016-11-01','2016-11-30',133),(989329,8788,'PORCENTAJE_CGC','4.7','2016-11-01','2016-11-30',133),(989330,8788,'PORCENTAJE_FP','0.1','2016-11-01','2016-11-30',133),(989331,8788,'BASE_REGULADORA','65.52000000000001','2016-11-01','2016-11-30',134),(989332,8788,'DIAS_NOMINA','30.0','2016-11-01','2016-11-30',134),(989333,8788,'TARIFA_IT','1.7','2016-11-01','2016-11-30',134),(989334,8788,'TC2','100','2016-11-01','2016-11-30',134),(989335,8788,'BASE_CGP','1965.6000000000004','2016-11-01','2016-11-30',134),(989336,8788,'DIAS_ENFERMEDAD_PROFESIONAL','30','2016-11-01','2016-11-30',134),(989337,8788,'DIAS_COTIZADOS','30.0','2016-11-01','2016-11-30',134),(989338,8788,'DIAS_NATURALES_MES','30','2016-11-01','2016-11-30',134),(989339,8788,'NOMINA','true','2016-11-01','2016-11-30',134),(989340,8788,'TIEMPO_COMPLETO','true','2016-11-01','2016-11-30',134),(989341,8788,'GRUPO_COTIZACION','03','2016-11-01','2016-11-30',134),(989342,8788,'BASE_CGP_E','1965.6000000000004','2016-11-01','2016-11-30',134),(989343,8788,'INDEFINIDO','true','2016-11-01','2016-11-30',134),(989344,8788,'PORCENTAJE_FOGASA','0.2','2016-11-01','2016-11-30',134),(989345,8788,'PORCENTAJE_FP_E','0.6','2016-11-01','2016-11-30',134),(989346,8788,'DIAS_MES','30','2016-11-01','2016-11-30',134),(989347,8788,'BASE_CGC','1965.6000000000004','2016-11-01','2016-11-30',134),(989348,8788,'PREST_IT','1474.2000000000003','2016-11-01','2016-11-30',134),(989349,8788,'BASE_CGC_E','1965.6000000000004','2016-11-01','2016-11-30',134),(989350,8788,'PORCENTAJE_CGC_E','23.6','2016-11-01','2016-11-30',134),(989351,8788,'TARIFA_IMS','1.2','2016-11-01','2016-11-30',134),(989352,8788,'SALARIO_BASE','0.0','2016-11-01','2016-11-30',134),(989353,8788,'PORCENTAJE_CGC','4.7','2016-11-01','2016-11-30',134),(989354,8788,'PORCENTAJE_FP','0.1','2016-11-01','2016-11-30',134),(989355,8788,'DIAS_NOMINA','20.0','2016-11-01','2016-11-20',135),(989356,8788,'DIAS_NOMINA','3.0','2016-11-21','2016-11-23',135),(989357,8788,'DIAS_NOMINA','7.0','2016-11-24','2016-11-30',135),(989358,8788,'DIAS_COTIZADOS','20.0','2016-11-01','2016-11-20',135),(989359,8788,'DIAS_COTIZADOS','10.0','2016-11-21','2016-11-30',135),(989360,8788,'BASE_CGP_E','1965.6000000000001','2016-11-01','2016-11-30',135),(989361,8788,'COEFICIENTE_ERE','0.0','2016-11-01','2016-11-20',135),(989362,8788,'PORCENTAJE_FOGASA','0.2','2016-11-01','2016-11-30',135),(989363,8788,'PORCENTAJE_FP_E','0.6','2016-11-01','2016-11-30',135),(989364,8788,'DIAS_ENFERMEDAD_COMUN_1_3','3','2016-11-21','2016-11-23',135),(989365,8788,'HORAS_TRABAJADAS','0.0','2016-11-01','2016-11-20',135),(989366,8788,'PORCENTAJE_CGC_E','23.6','2016-11-01','2016-11-30',135),(989367,8788,'SALARIO_MENSUAL','655.2','2016-11-01','2016-11-20',135),(989368,8788,'PORCENTAJE_CGC','4.7','2016-11-01','2016-11-20',135),(989369,8788,'PORCENTAJE_CGC','4.7','2016-11-21','2016-11-23',135),(989370,8788,'PORCENTAJE_CGC','4.7','2016-11-24','2016-11-30',135),(989371,8788,'BASE_REGULADORA','65.52000000000001','2016-11-21','2016-11-23',135),(989372,8788,'BASE_REGULADORA','65.52000000000001','2016-11-24','2016-11-30',135),(989373,8788,'DIAS_ENFERMEDAD_COMUN_4_15','7','2016-11-24','2016-11-30',135),(989374,8788,'TARIFA_IT','1.7','2016-11-01','2016-11-30',135),(989375,8788,'TC2','100','2016-11-01','2016-11-30',135),(989376,8788,'BASE_CGP','1310.4','2016-11-01','2016-11-20',135),(989377,8788,'BASE_CGP','196.56000000000003','2016-11-21','2016-11-23',135),(989378,8788,'BASE_CGP','458.6400000000001','2016-11-24','2016-11-30',135),(989379,8788,'DIAS_NATURALES_MES','30','2016-11-01','2016-11-20',135),(989380,8788,'DIAS_NATURALES_MES','30','2016-11-21','2016-11-23',135),(989381,8788,'DIAS_NATURALES_MES','30','2016-11-24','2016-11-30',135),(989382,8788,'TIEMPO_COMPLETO','true','2016-11-01','2016-11-20',135),(989383,8788,'TIEMPO_COMPLETO','true','2016-11-21','2016-11-23',135),(989384,8788,'TIEMPO_COMPLETO','true','2016-11-24','2016-11-30',135),(989385,8788,'GRUPO_COTIZACION','05','2016-11-01','2016-11-20',135),(989386,8788,'GRUPO_COTIZACION','05','2016-11-21','2016-11-23',135),(989387,8788,'GRUPO_COTIZACION','05','2016-11-24','2016-11-30',135),(989388,8788,'INDEFINIDO','true','2016-11-01','2016-11-30',135),(989389,8788,'DIAS_MES','30.0','2016-11-01','2016-11-20',135),(989390,8788,'DIAS_MES','30','2016-11-21','2016-11-23',135),(989391,8788,'DIAS_MES','30','2016-11-24','2016-11-30',135),(989392,8788,'BASE_CGC','1310.4','2016-11-01','2016-11-20',135),(989393,8788,'BASE_CGC','196.56000000000003','2016-11-21','2016-11-23',135),(989394,8788,'BASE_CGC','458.6400000000001','2016-11-24','2016-11-30',135),(989395,8788,'SMI','655.2','2016-11-01','2016-11-30',135),(989396,8788,'PREST_IT','0.0','2016-11-01','2016-11-20',135),(989397,8788,'PREST_IT','0.0','2016-11-21','2016-11-23',135),(989398,8788,'PREST_IT','275.184','2016-11-24','2016-11-30',135),(989399,8788,'DIAS_HUELGA','0.0','2016-11-01','2016-11-20',135),(989400,8788,'BASE_CGC_E','1965.6000000000001','2016-11-01','2016-11-30',135),(989401,8788,'TARIFA_IMS','1.2','2016-11-01','2016-11-30',135),(989402,8788,'DIAS_TRABAJADOS','20.0','2016-11-01','2016-11-20',135),(989403,8788,'SALARIO_BASE','436.8','2016-11-01','2016-11-20',135),(989404,8788,'SALARIO_BASE','0.0','2016-11-21','2016-11-30',135),(989405,8788,'PORCENTAJE_FP','0.1','2016-11-01','2016-11-20',135),(989406,8788,'PORCENTAJE_FP','0.1','2016-11-21','2016-11-23',135),(989407,8788,'PORCENTAJE_FP','0.1','2016-11-24','2016-11-30',135);
/*!40000 ALTER TABLE `salary_data` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salary_deduction`
--

DROP TABLE IF EXISTS `salary_deduction`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `salary_deduction` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `salary` int(4) NOT NULL COMMENT 'Recibo del pago de salarios',
  `type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de deducción Salarial',
  `deduction_concept` varchar(15) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo del concepto',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion',
  `expression` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Fórmula',
  `amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe',
  PRIMARY KEY (`id`),
  KEY `IDX_SALARY_DEDUCTION_SALARY` (`salary`),
  KEY `IDX_SALARY_DEDUCTION_DOMAIN` (`domain`),
  CONSTRAINT `FK_SALARY_DEDUCTION_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_SALARY_DEDUCTION_SALARY` FOREIGN KEY (`salary`) REFERENCES `salary` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=207850 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Deducciones';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salary_deduction`
--

LOCK TABLES `salary_deduction` WRITE;
/*!40000 ALTER TABLE `salary_deduction` DISABLE KEYS */;
INSERT INTO `salary_deduction` VALUES (207413,8777,15,0,'CGC',NULL,NULL,4.999),(207414,8777,15,0,'CGC',NULL,NULL,7.498),(207415,8777,15,3,'FP',NULL,NULL,0.106),(207416,8777,15,3,'FP',NULL,NULL,0.160),(207425,8777,20,0,'CGC',NULL,NULL,33.810),(207426,8777,20,2,'DESMPL',NULL,NULL,11.150),(207427,8777,20,3,'FP',NULL,NULL,0.719),(207428,8777,23,0,'CGC',NULL,NULL,62.951),(207429,8777,23,2,'DESMPL',NULL,NULL,20.760),(207430,8777,23,3,'FP',NULL,NULL,1.339),(207431,8777,23,6,'IRPF',NULL,NULL,22.961),(207432,8777,24,0,'CGC',NULL,NULL,74.711),(207433,8777,24,2,'DESMPL',NULL,NULL,24.639),(207434,8777,24,3,'FP',NULL,NULL,1.590),(207435,8777,24,6,'IRPF',NULL,NULL,82.129),(207436,8777,25,0,'CGC',NULL,NULL,77.305),(207437,8777,25,2,'DESMPL',NULL,NULL,25.494),(207438,8777,25,3,'FP',NULL,NULL,1.645),(207439,8777,25,6,'IRPF',NULL,NULL,99.681),(207440,8777,26,0,'CGC',NULL,NULL,74.711),(207441,8777,26,2,'DESMPL',NULL,NULL,24.639),(207442,8777,26,3,'FP',NULL,NULL,1.590),(207443,8777,26,6,'IRPF',NULL,NULL,82.129),(207444,8777,27,0,'CGC',NULL,NULL,28.741),(207445,8777,27,2,'DESMPL',NULL,NULL,9.479),(207446,8777,27,3,'FP',NULL,NULL,0.612),(207450,8777,29,0,'CGC',NULL,NULL,45.808),(207451,8777,29,2,'DESMPL',NULL,NULL,15.107),(207452,8777,29,3,'FP',NULL,NULL,0.975),(207453,8777,30,0,'CGC',NULL,NULL,45.808),(207454,8777,30,2,'DESMPL',NULL,NULL,15.107),(207455,8777,30,3,'FP',NULL,NULL,0.975),(207456,8777,31,0,'CGC',NULL,NULL,27.526),(207457,8777,31,2,'DESMPL',NULL,NULL,9.078),(207458,8777,31,3,'FP',NULL,NULL,0.586),(207459,8777,32,0,'CGC',NULL,NULL,35.927),(207460,8777,32,2,'DESMPL',NULL,NULL,11.848),(207461,8777,32,3,'FP',NULL,NULL,0.764),(207462,8777,33,0,'CGC',NULL,NULL,33.532),(207463,8777,33,2,'DESMPL',NULL,NULL,11.058),(207464,8777,33,3,'FP',NULL,NULL,0.713),(207465,8777,34,0,'CGC',NULL,NULL,3.345),(207466,8777,34,0,'CGC',NULL,NULL,5.017),(207467,8777,34,0,'CGC',NULL,NULL,1.672),(207468,8777,34,2,'DESMPL',NULL,NULL,1.103),(207469,8777,34,2,'DESMPL',NULL,NULL,1.654),(207470,8777,34,2,'DESMPL',NULL,NULL,0.551),(207471,8777,34,3,'FP',NULL,NULL,0.071),(207472,8777,34,3,'FP',NULL,NULL,0.107),(207473,8777,34,3,'FP',NULL,NULL,0.036),(207474,8777,35,0,'CGC',NULL,NULL,3.345),(207475,8777,35,0,'CGC',NULL,NULL,6.689),(207476,8777,35,2,'DESMPL',NULL,NULL,1.103),(207477,8777,35,2,'DESMPL',NULL,NULL,2.206),(207478,8777,35,3,'FP',NULL,NULL,0.071),(207479,8777,35,3,'FP',NULL,NULL,0.142),(207480,8777,36,0,'CGC',NULL,NULL,50.168),(207481,8777,36,2,'DESMPL',NULL,NULL,15.707),(207482,8777,36,3,'FP',NULL,NULL,1.013),(207483,8777,38,0,'CGC',NULL,NULL,56.349),(207484,8777,38,2,'DESMPL',NULL,NULL,18.583),(207485,8777,38,3,'FP',NULL,NULL,1.199),(207486,8777,39,0,'CGC',NULL,NULL,56.349),(207487,8777,39,2,'DESMPL',NULL,NULL,18.583),(207488,8777,39,3,'FP',NULL,NULL,1.199),(207489,8777,40,0,'CGC',NULL,NULL,171.174),(207490,8777,40,2,'DESMPL',NULL,NULL,56.451),(207491,8777,40,3,'FP',NULL,NULL,3.642),(207492,8777,40,6,'IRPF',NULL,NULL,3167.000),(207493,8777,41,0,'CGC',NULL,NULL,50.168),(207494,8777,41,2,'DESMPL',NULL,NULL,11.848),(207495,8777,41,3,'FP',NULL,NULL,0.764),(207496,8777,42,0,'CGC',NULL,NULL,70.500),(207497,8777,42,2,'DESMPL',NULL,NULL,23.250),(207498,8777,42,3,'FP',NULL,NULL,1.500),(207499,8777,42,6,'IRPF',NULL,NULL,60.000),(207500,8777,43,0,'CGC',NULL,NULL,123.838),(207501,8777,43,2,'DESMPL',NULL,NULL,40.840),(207502,8777,43,3,'FP',NULL,NULL,2.635),(207503,8777,43,6,'IRPF',NULL,NULL,342.529),(207504,8777,44,0,'CGC',NULL,NULL,171.174),(207505,8777,44,2,'DESMPL',NULL,NULL,56.451),(207506,8777,44,3,'FP',NULL,NULL,3.642),(207507,8777,44,6,'IRPF',NULL,NULL,6276.742),(207508,8777,46,0,'CGC',NULL,NULL,45.786),(207509,8777,46,2,'DESMPL',NULL,NULL,15.100),(207510,8777,46,3,'FP',NULL,NULL,0.974),(207515,8777,54,0,'CGC',NULL,NULL,24.367),(207516,8777,54,2,'DESMPL',NULL,NULL,8.036),(207517,8777,54,3,'FP',NULL,NULL,0.518),(207518,8777,55,0,'CGC',NULL,NULL,45.808),(207519,8777,55,2,'DESMPL',NULL,NULL,15.107),(207520,8777,55,3,'FP',NULL,NULL,0.975),(207521,8777,56,0,'CGC',NULL,NULL,56.349),(207522,8777,56,2,'DESMPL',NULL,NULL,18.583),(207523,8777,56,3,'FP',NULL,NULL,1.199),(207524,8777,57,0,'CGC',NULL,NULL,56.467),(207525,8777,57,2,'DESMPL',NULL,NULL,18.622),(207526,8777,57,3,'FP',NULL,NULL,1.201),(207527,8777,58,0,'CGC',NULL,NULL,31.878),(207528,8777,58,2,'DESMPL',NULL,NULL,10.513),(207529,8777,58,3,'FP',NULL,NULL,0.678),(207530,8777,59,0,'CGC',NULL,NULL,42.665),(207531,8777,59,2,'DESMPL',NULL,NULL,14.070),(207532,8777,59,3,'FP',NULL,NULL,0.908),(207533,8777,60,0,'CGC',NULL,NULL,53.129),(207534,8777,60,2,'DESMPL',NULL,NULL,17.521),(207535,8777,60,3,'FP',NULL,NULL,1.130),(207536,8777,62,0,'CGC',NULL,NULL,28.741),(207537,8777,62,2,'DESMPL',NULL,NULL,9.479),(207538,8777,62,3,'FP',NULL,NULL,0.612),(207539,8777,64,0,'CGC',NULL,NULL,15.397),(207540,8777,64,2,'DESMPL',NULL,NULL,5.078),(207541,8777,64,3,'FP',NULL,NULL,0.328),(207542,8777,65,0,'CGC',NULL,NULL,9.018),(207543,8777,65,2,'DESMPL',NULL,NULL,2.567),(207544,8777,65,3,'FP',NULL,NULL,0.166),(207554,8777,70,0,'CGC',NULL,NULL,16.766),(207555,8777,70,2,'DESMPL',NULL,NULL,5.529),(207556,8777,70,3,'FP',NULL,NULL,0.357),(207557,8777,71,0,'CGC',NULL,NULL,16.766),(207558,8777,71,2,'DESMPL',NULL,NULL,5.529),(207559,8777,71,3,'FP',NULL,NULL,0.357),(207560,8777,72,0,'CGC',NULL,NULL,30.590),(207561,8777,72,2,'DESMPL',NULL,NULL,10.088),(207562,8777,72,3,'FP',NULL,NULL,0.651),(207563,8784,73,0,'CGC',NULL,NULL,88.533),(207564,8784,73,2,'DESMPL',NULL,NULL,30.139),(207565,8784,73,3,'FP',NULL,NULL,1.884),(207566,8784,74,0,'CGC',NULL,NULL,32.067),(207567,8784,74,2,'DESMPL',NULL,NULL,10.575),(207568,8784,74,3,'FP',NULL,NULL,0.682),(207569,8777,75,0,'CGC',NULL,NULL,90.498),(207570,8777,75,2,'DESMPL',NULL,NULL,29.845),(207571,8777,75,3,'FP',NULL,NULL,1.925),(207572,8777,75,6,'IRPF',NULL,NULL,77.019),(207577,8777,77,0,'CGC',NULL,NULL,106.152),(207578,8777,77,2,'DESMPL',NULL,NULL,35.008),(207579,8777,77,3,'FP',NULL,NULL,2.259),(207580,8777,77,6,'IRPF',NULL,NULL,290.385),(207581,8777,78,0,'CGC',NULL,NULL,110.398),(207582,8777,78,2,'DESMPL',NULL,NULL,36.408),(207583,8777,78,3,'FP',NULL,NULL,2.349),(207584,8777,78,6,'IRPF',NULL,NULL,302.000),(207585,8777,79,0,'CGC',NULL,NULL,110.398),(207586,8777,79,2,'DESMPL',NULL,NULL,36.408),(207587,8777,79,3,'FP',NULL,NULL,2.349),(207588,8777,79,6,'IRPF',NULL,NULL,302.000),(207589,8777,80,0,'CGC',NULL,NULL,110.398),(207590,8777,80,2,'DESMPL',NULL,NULL,36.408),(207591,8777,80,3,'FP',NULL,NULL,2.349),(207592,8777,80,6,'IRPF',NULL,NULL,302.000),(207593,8777,81,0,'CGC',NULL,NULL,110.398),(207594,8777,81,2,'DESMPL',NULL,NULL,36.408),(207595,8777,81,3,'FP',NULL,NULL,2.349),(207596,8777,81,6,'IRPF',NULL,NULL,302.000),(207597,8777,82,0,'CGC',NULL,NULL,110.398),(207598,8777,82,2,'DESMPL',NULL,NULL,36.408),(207599,8777,82,3,'FP',NULL,NULL,2.349),(207600,8777,82,6,'IRPF',NULL,NULL,302.000),(207601,8777,83,0,'CGC',NULL,NULL,110.398),(207602,8777,83,2,'DESMPL',NULL,NULL,36.408),(207603,8777,83,3,'FP',NULL,NULL,2.349),(207604,8777,83,6,'IRPF',NULL,NULL,302.000),(207605,8777,84,0,'CGC',NULL,NULL,110.398),(207606,8777,84,2,'DESMPL',NULL,NULL,36.408),(207607,8777,84,3,'FP',NULL,NULL,2.349),(207608,8777,84,6,'IRPF',NULL,NULL,302.000),(207609,8777,85,0,'CGC',NULL,NULL,110.398),(207610,8777,85,2,'DESMPL',NULL,NULL,36.408),(207611,8777,85,3,'FP',NULL,NULL,2.349),(207612,8777,85,6,'IRPF',NULL,NULL,302.000),(207613,8777,86,0,'CGC',NULL,NULL,110.398),(207614,8777,86,2,'DESMPL',NULL,NULL,36.408),(207615,8777,86,3,'FP',NULL,NULL,2.349),(207616,8777,86,6,'IRPF',NULL,NULL,302.000),(207617,8777,87,0,'CGC',NULL,NULL,110.398),(207618,8777,87,2,'DESMPL',NULL,NULL,36.408),(207619,8777,87,3,'FP',NULL,NULL,2.349),(207620,8777,87,6,'IRPF',NULL,NULL,302.000),(207621,8777,88,0,'CGC',NULL,NULL,106.152),(207622,8777,88,2,'DESMPL',NULL,NULL,35.008),(207623,8777,88,3,'FP',NULL,NULL,2.259),(207624,8777,88,6,'IRPF',NULL,NULL,290.385),(207625,8777,89,0,'CGC',NULL,NULL,3.538),(207626,8777,89,0,'CGC',NULL,NULL,3.538),(207627,8777,89,0,'CGC',NULL,NULL,3.680),(207628,8777,89,0,'CGC',NULL,NULL,3.680),(207629,8777,89,0,'CGC',NULL,NULL,3.680),(207630,8777,89,0,'CGC',NULL,NULL,3.680),(207631,8777,89,0,'CGC',NULL,NULL,3.680),(207632,8777,89,0,'CGC',NULL,NULL,3.680),(207633,8777,89,0,'CGC',NULL,NULL,3.680),(207634,8777,89,0,'CGC',NULL,NULL,3.680),(207635,8777,89,0,'CGC',NULL,NULL,3.680),(207636,8777,89,0,'CGC',NULL,NULL,3.680),(207637,8777,89,2,'DESMPL',NULL,NULL,1.167),(207638,8777,89,2,'DESMPL',NULL,NULL,1.167),(207639,8777,89,2,'DESMPL',NULL,NULL,1.214),(207640,8777,89,2,'DESMPL',NULL,NULL,1.214),(207641,8777,89,2,'DESMPL',NULL,NULL,1.214),(207642,8777,89,2,'DESMPL',NULL,NULL,1.214),(207643,8777,89,2,'DESMPL',NULL,NULL,1.214),(207644,8777,89,2,'DESMPL',NULL,NULL,1.214),(207645,8777,89,2,'DESMPL',NULL,NULL,1.214),(207646,8777,89,2,'DESMPL',NULL,NULL,1.214),(207647,8777,89,2,'DESMPL',NULL,NULL,1.214),(207648,8777,89,2,'DESMPL',NULL,NULL,1.214),(207649,8777,89,3,'FP',NULL,NULL,0.075),(207650,8777,89,3,'FP',NULL,NULL,0.075),(207651,8777,89,3,'FP',NULL,NULL,0.078),(207652,8777,89,3,'FP',NULL,NULL,0.078),(207653,8777,89,3,'FP',NULL,NULL,0.078),(207654,8777,89,3,'FP',NULL,NULL,0.078),(207655,8777,89,3,'FP',NULL,NULL,0.078),(207656,8777,89,3,'FP',NULL,NULL,0.078),(207657,8777,89,3,'FP',NULL,NULL,0.078),(207658,8777,89,3,'FP',NULL,NULL,0.078),(207659,8777,89,3,'FP',NULL,NULL,0.078),(207660,8777,89,3,'FP',NULL,NULL,0.078),(207661,8777,89,6,'IRPF',NULL,NULL,120.025),(207668,8783,93,0,'CGC',NULL,NULL,71.854),(207669,8783,93,2,'DESMPL',NULL,NULL,23.696),(207670,8783,93,3,'FP',NULL,NULL,1.529),(207671,8783,93,6,'IRPF',NULL,NULL,26.208),(207672,8783,94,0,'CGC',NULL,NULL,35.927),(207673,8783,94,2,'DESMPL',NULL,NULL,11.848),(207674,8783,94,3,'FP',NULL,NULL,0.764),(207676,8783,97,0,'CGC',NULL,NULL,71.854),(207677,8783,97,2,'DESMPL',NULL,NULL,23.696),(207678,8783,97,3,'FP',NULL,NULL,1.529),(207691,8777,98,0,'CGC',NULL,NULL,21.739),(207692,8777,98,0,'CGC',NULL,NULL,5.017),(207693,8777,98,0,'CGC',NULL,NULL,16.723),(207694,8777,98,0,'CGC',NULL,NULL,6.689),(207695,8777,98,2,'DESMPL',NULL,NULL,5.134),(207696,8777,98,2,'DESMPL',NULL,NULL,1.654),(207697,8777,98,2,'DESMPL',NULL,NULL,5.515),(207698,8777,98,2,'DESMPL',NULL,NULL,1.580),(207699,8777,98,3,'FP',NULL,NULL,0.331),(207700,8777,98,3,'FP',NULL,NULL,0.107),(207701,8777,98,3,'FP',NULL,NULL,0.356),(207702,8777,98,3,'FP',NULL,NULL,0.102),(207718,8777,99,0,'CGC',NULL,NULL,37.124),(207719,8777,99,2,'DESMPL',NULL,NULL,12.243),(207720,8777,99,3,'FP',NULL,NULL,0.790),(207724,8777,100,0,'CGC',NULL,NULL,50.419),(207725,8777,100,2,'DESMPL',NULL,NULL,17.164),(207726,8777,100,3,'FP',NULL,NULL,1.073),(207727,8777,101,0,'CGC',NULL,NULL,24.761),(207728,8777,101,2,'DESMPL',NULL,NULL,8.429),(207729,8777,101,3,'FP',NULL,NULL,0.527),(207730,8777,102,0,'CGC',NULL,NULL,54.166),(207731,8777,102,2,'DESMPL',NULL,NULL,18.439),(207732,8777,102,3,'FP',NULL,NULL,1.152),(207733,8777,103,0,'CGC',NULL,NULL,54.166),(207734,8777,103,2,'DESMPL',NULL,NULL,18.439),(207735,8777,103,3,'FP',NULL,NULL,1.152),(207736,8777,104,0,'CGC',NULL,NULL,54.166),(207737,8777,104,2,'DESMPL',NULL,NULL,18.439),(207738,8777,104,3,'FP',NULL,NULL,1.152),(207739,8777,105,0,'CGC',NULL,NULL,54.166),(207740,8777,105,2,'DESMPL',NULL,NULL,18.439),(207741,8777,105,3,'FP',NULL,NULL,1.152),(207742,8777,106,0,'CGC',NULL,NULL,54.166),(207743,8777,106,2,'DESMPL',NULL,NULL,18.439),(207744,8777,106,3,'FP',NULL,NULL,1.152),(207745,8777,107,0,'CGC',NULL,NULL,37.896),(207746,8777,107,2,'DESMPL',NULL,NULL,14.048),(207747,8777,107,3,'FP',NULL,NULL,0.906),(207748,8777,107,4,'ESTR',NULL,NULL,2.000),(207749,8777,108,0,'CGC',NULL,NULL,50.168),(207750,8777,108,2,'DESMPL',NULL,NULL,16.545),(207751,8777,108,3,'FP',NULL,NULL,1.067),(207790,8788,119,0,'CGC',NULL,NULL,161.671),(207791,8788,119,2,'DESMPL',NULL,NULL,53.317),(207792,8788,119,3,'FP',NULL,NULL,3.440),(207793,8788,120,0,'CGC',NULL,NULL,24.636),(207794,8788,120,2,'DESMPL',NULL,NULL,8.387),(207795,8788,120,3,'FP',NULL,NULL,0.524),(207796,8788,120,6,'IRPF',NULL,NULL,3.494),(207797,8788,121,0,'CGC',NULL,NULL,15.397),(207798,8788,121,2,'DESMPL',NULL,NULL,5.242),(207799,8788,121,3,'FP',NULL,NULL,0.328),(207800,8788,121,6,'IRPF',NULL,NULL,2.184),(207801,8788,122,0,'CGC',NULL,NULL,15.397),(207802,8788,122,2,'DESMPL',NULL,NULL,5.242),(207803,8788,122,3,'FP',NULL,NULL,0.328),(207804,8788,122,6,'IRPF',NULL,NULL,2.184),(207805,8788,123,0,'CGC',NULL,NULL,18.477),(207806,8788,123,2,'DESMPL',NULL,NULL,6.290),(207807,8788,123,3,'FP',NULL,NULL,0.393),(207808,8788,123,6,'IRPF',NULL,NULL,2.621),(207813,8788,125,0,'CGC',NULL,NULL,92.383),(207814,8788,125,2,'DESMPL',NULL,NULL,30.467),(207815,8788,125,3,'FP',NULL,NULL,1.966),(207816,8788,126,0,'CGC',NULL,NULL,24.636),(207817,8788,126,2,'DESMPL',NULL,NULL,8.387),(207818,8788,126,3,'FP',NULL,NULL,0.524),(207819,8788,126,6,'IRPF',NULL,NULL,3.494),(207820,8788,127,0,'CGC',NULL,NULL,15.397),(207821,8788,127,2,'DESMPL',NULL,NULL,5.242),(207822,8788,127,3,'FP',NULL,NULL,0.328),(207823,8788,127,6,'IRPF',NULL,NULL,2.184),(207824,8788,128,0,'CGC',NULL,NULL,15.397),(207825,8788,128,2,'DESMPL',NULL,NULL,5.242),(207826,8788,128,3,'FP',NULL,NULL,0.328),(207827,8788,128,6,'IRPF',NULL,NULL,2.184),(207828,8788,129,0,'CGC',NULL,NULL,15.397),(207829,8788,129,2,'DESMPL',NULL,NULL,5.242),(207830,8788,129,3,'FP',NULL,NULL,0.328),(207831,8788,129,6,'IRPF',NULL,NULL,2.184),(207841,8788,133,0,'CGC',NULL,NULL,92.383),(207842,8788,133,2,'DESMPL',NULL,NULL,30.467),(207843,8788,133,3,'FP',NULL,NULL,1.966),(207844,8788,134,0,'CGC',NULL,NULL,92.383),(207845,8788,134,2,'DESMPL',NULL,NULL,30.467),(207846,8788,134,3,'FP',NULL,NULL,1.966),(207847,8788,135,0,'CGC',NULL,NULL,92.383),(207848,8788,135,2,'DESMPL',NULL,NULL,30.467),(207849,8788,135,3,'FP',NULL,NULL,1.966);
/*!40000 ALTER TABLE `salary_deduction` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salary_embargo`
--

DROP TABLE IF EXISTS `salary_embargo`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `salary_embargo` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `salary` int(4) NOT NULL COMMENT 'Recibo del pago de salarios',
  `contract_embargo` int(4) NOT NULL COMMENT 'Embargo',
  `amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion',
  PRIMARY KEY (`id`),
  KEY `IDX_SALARY_EMBARGO_CONTRACT_EMBARGO` (`contract_embargo`),
  KEY `IDX_SALARY_EMBARGO_SALARY` (`salary`),
  KEY `IDX_SALARY_EMBARGO_DOMAIN` (`domain`),
  CONSTRAINT `FK_SALARY_EMBARGO_CONTRACT_EMBARGO` FOREIGN KEY (`contract_embargo`) REFERENCES `contract_embargo` (`id`),
  CONSTRAINT `FK_SALARY_EMBARGO_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_SALARY_EMBARGO_SALARY` FOREIGN KEY (`salary`) REFERENCES `salary` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Embargos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salary_embargo`
--

LOCK TABLES `salary_embargo` WRITE;
/*!40000 ALTER TABLE `salary_embargo` DISABLE KEYS */;
INSERT INTO `salary_embargo` VALUES (1,8777,75,-666,404.459,'EMBARGO');
/*!40000 ALTER TABLE `salary_embargo` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salary_payment`
--

DROP TABLE IF EXISTS `salary_payment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `salary_payment` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `salary` int(4) NOT NULL COMMENT 'Recibo del pago de salarios',
  `type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de Percepción Salarial',
  `payment_concept` varchar(25) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo',
  `description` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion',
  `expression` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Fórmula',
  `amount` double(15,3) DEFAULT '0.000' COMMENT 'Importe',
  `irpf` double(15,3) DEFAULT '0.000' COMMENT 'Importe I.R.P.F',
  `quote` double(15,3) DEFAULT '0.000' COMMENT 'Importe Cotizable',
  PRIMARY KEY (`id`),
  KEY `IDX_SALARY_PAYMENT_SALARY` (`salary`),
  KEY `IDX_SALARY_PAYMENT_DOMAIN` (`domain`),
  CONSTRAINT `FK_SALARY_PAYMENT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_SALARY_PAYMENT_SALARY` FOREIGN KEY (`salary`) REFERENCES `salary` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=224410 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Percepciones salariales';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salary_payment`
--

LOCK TABLES `salary_payment` WRITE;
/*!40000 ALTER TABLE `salary_payment` DISABLE KEYS */;
INSERT INTO `salary_payment` VALUES (224000,8777,15,6,'__6213','VACACIONES RETRIBUIDAS NO DISFRUTADAS',NULL,265.882,265.882,265.882),(224011,8777,20,1,'PLUS_EXTRA_SALARIAL','PLUS REGIMEN GENERAL ( VARIABLE == DEVENGO )',NULL,0.000,0.000,0.000),(224012,8777,20,1,'SALARIO_BASE','[1]SALARIO BASE',NULL,548.078,548.078,548.078),(224013,8777,20,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( > 1996 )',NULL,0.000,0.000,0.000),(224014,8777,20,4,'PAGA_EXTRA','[4]PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,85.637),(224015,8777,20,4,'PAGA_EXTRA','[3]PAGA EXTRAORDINARIA JULIO',NULL,0.000,0.000,85.637),(224016,8777,23,1,'PLUS_EXTRA_SALARIAL','PLUS REGIMEN GENERAL ( VARIABLE == DEVENGO )',NULL,0.000,0.000,0.000),(224017,8777,23,1,'SALARIO_BASE','[1]SALARIO BASE',NULL,1103.890,1103.890,1103.890),(224018,8777,23,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( > 1996 )',NULL,44.156,44.156,44.156),(224019,8777,23,4,'PAGA_EXTRA','[4]PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,95.670),(224020,8777,23,4,'PAGA_EXTRA','[3]PAGA EXTRAORDINARIA JULIO',NULL,0.000,0.000,95.670),(224021,8777,23,1,NULL,'TEST COMPLEMENTO DE ANTIGÜEDAD (2012-2016)',NULL,0.000,0.000,0.000),(224022,8777,24,1,'PLUS_EXTRA_SALARIAL','PLUS REGIMEN GENERAL ( VARIABLE == DEVENGO )',NULL,0.000,0.000,0.000),(224023,8777,24,1,'SALARIO_BASE','[1]SALARIO BASE',NULL,1103.890,1103.890,1103.890),(224024,8777,24,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( > 1996 )',NULL,220.778,220.778,220.778),(224025,8777,24,4,'PAGA_EXTRA','[4]PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,110.389),(224026,8777,24,4,'PAGA_EXTRA','[3]PAGA EXTRAORDINARIA JULIO',NULL,0.000,0.000,110.389),(224027,8777,24,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( 1993-1996 )',NULL,44.156,44.156,44.156),(224028,8777,24,1,NULL,'TEST COMPLEMENTO ANTIGUEDAD (2016)',NULL,0.000,0.000,0.000),(224029,8777,25,1,'PLUS_EXTRA_SALARIAL','PLUS REGIMEN GENERAL ( VARIABLE == DEVENGO )',NULL,0.000,0.000,0.000),(224030,8777,25,1,'SALARIO_BASE','[1]SALARIO BASE',NULL,1103.890,1103.890,1103.890),(224031,8777,25,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( > 1996 )',NULL,220.778,220.778,220.778),(224032,8777,25,4,'PAGA_EXTRA','[4]PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,110.389),(224033,8777,25,4,'PAGA_EXTRA','[3]PAGA EXTRAORDINARIA JULIO',NULL,0.000,0.000,110.389),(224034,8777,25,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( 1993-1996 )',NULL,44.156,44.156,44.156),(224035,8777,25,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( < 1993 )',NULL,55.194,55.194,55.194),(224036,8777,25,1,NULL,'TEST COMPLEMENTO ANTIGUEDAD (2016)',NULL,0.000,0.000,0.000),(224037,8777,26,1,'PLUS_EXTRA_SALARIAL','PLUS REGIMEN GENERAL ( VARIABLE == DEVENGO )',NULL,0.000,0.000,0.000),(224038,8777,26,1,'SALARIO_BASE','[1]SALARIO BASE',NULL,1103.890,1103.890,1103.890),(224039,8777,26,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( > 1996 )',NULL,220.778,220.778,220.778),(224040,8777,26,4,'PAGA_EXTRA','[4]PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,110.389),(224041,8777,26,4,'PAGA_EXTRA','[3]PAGA EXTRAORDINARIA JULIO',NULL,0.000,0.000,110.389),(224042,8777,26,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( 1993-1996 )',NULL,44.156,44.156,44.156),(224043,8777,26,1,NULL,'TEST COMPLEMENTO ANTIGUEDAD (2016)',NULL,0.000,0.000,0.000),(224044,8777,27,1,'SALARIO_BASE','[1]SALARIO BASE',NULL,611.520,611.520,611.520),(224045,8777,27,1,'ANTIGUEDAD','COMPLEMENTO PERSONAL DE ANTIGÜEDAD',NULL,0.000,0.000,0.000),(224051,8777,29,1,'PLUS_EXTRA_SALARIAL','PLUS REGIMEN GENERAL ( VARIABLE == DEVENGO )',NULL,0.000,0.000,0.000),(224052,8777,29,1,'SALARIO_BASE','[1]SALARIO BASE',NULL,835.413,835.413,835.413),(224053,8777,29,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( > 1996 )',NULL,0.000,0.000,0.000),(224054,8777,29,4,'PAGA_EXTRA','[4]PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,69.618),(224055,8777,29,4,'PAGA_EXTRA','[3]PAGA EXTRAORDINARIA JULIO',NULL,0.000,0.000,69.618),(224056,8777,30,1,'PLUS_EXTRA_SALARIAL','PLUS REGIMEN GENERAL ( VARIABLE == DEVENGO )',NULL,0.000,0.000,0.000),(224057,8777,30,1,'SALARIO_BASE','[1]SALARIO BASE',NULL,835.413,835.413,835.413),(224058,8777,30,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( > 1996 )',NULL,0.000,0.000,0.000),(224059,8777,30,4,'PAGA_EXTRA','[4]PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,69.618),(224060,8777,30,4,'PAGA_EXTRA','[3]PAGA EXTRAORDINARIA JULIO',NULL,0.000,0.000,69.618),(224061,8777,31,1,'PLUS_EXTRA_SALARIAL','PLUS REGIMEN GENERAL ( VARIABLE == DEVENGO )',NULL,0.000,0.000,0.000),(224062,8777,31,1,'SALARIO_BASE','[1]SALARIO BASE',NULL,439.238,439.238,439.238),(224063,8777,31,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( > 1996 )',NULL,0.000,0.000,0.000),(224064,8777,31,4,'PAGA_EXTRA','[4]PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,73.206),(224065,8777,31,4,'PAGA_EXTRA','[3]PAGA EXTRAORDINARIA JULIO',NULL,0.000,0.000,73.206),(224066,8777,32,1,'SALARIO_BASE','SALARIO BASE',NULL,655.200,655.200,655.200),(224067,8777,33,1,'SALARIO_BASE','SALARIO BASE',NULL,611.520,611.520,611.520),(224068,8777,34,1,'SALARIO_BASE','SALARIO BASE MENSUAL',NULL,71.160,71.160,71.160),(224069,8777,34,1,'PREST_IT','PREST. POR ENFERMEDAD COMÚN',NULL,0.000,0.000,106.740),(224070,8777,34,1,'PREST_IT','PREST. POR ENFERMEDAD COMÚN A CARGO DE LA EMPRESA',NULL,21.348,21.348,35.580),(224071,8777,34,55,'__6253','MEJORAS PREST.SS.ENFERMEDAD COMÚM',NULL,120.972,120.972,0.000),(224072,8777,35,1,'SALARIO_BASE','SALARIO BASE MENSUAL',NULL,71.160,71.160,71.160),(224073,8777,35,1,'PREST_IT','PREST. POR ACCIDENTE DE TRABAJO Y/O ENFERMEDAD PROFESIONAL',NULL,106.740,106.740,142.320),(224074,8777,35,55,'__6254','MEJORAS PREST.SS.ENFERMEDAD PROFESIONAL',NULL,35.580,35.580,0.000),(224075,8777,36,1,NULL,'SALARIO BASE',NULL,1013.334,1013.334,1013.334),(224076,8777,38,1,'PLUS_EXTRA_SALARIAL','PLUS REGIMEN GENERAL ( VARIABLE == DEVENGO )',NULL,0.000,0.000,0.000),(224077,8777,38,1,'SALARIO_BASE','[1]SALARIO BASE',NULL,1027.646,1027.646,1027.646),(224078,8777,38,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( > 1996 )',NULL,0.000,0.000,0.000),(224079,8777,38,4,'PAGA_EXTRA','[4]PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,85.637),(224080,8777,38,4,'PAGA_EXTRA','[3]PAGA EXTRAORDINARIA JULIO',NULL,0.000,0.000,85.637),(224081,8777,39,1,'PLUS_EXTRA_SALARIAL','PLUS REGIMEN GENERAL ( VARIABLE == DEVENGO )',NULL,0.000,0.000,0.000),(224082,8777,39,1,'SALARIO_BASE','[1]SALARIO BASE',NULL,1027.646,1027.646,1027.646),(224083,8777,39,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( > 1996 )',NULL,0.000,0.000,0.000),(224084,8777,39,4,'PAGA_EXTRA','[3]PAGA EXTRAORDINARIA JULIO',NULL,85.637,85.637,85.637),(224085,8777,39,4,'PAGA_EXTRA','[4]PAGA EXTRAORDINARIA DICIEMBRE',NULL,85.637,85.637,85.637),(224086,8777,40,1,'SALARIO_BASE','SALARIO BASE',NULL,10000.000,10000.000,10000.000),(224087,8777,41,1,'SALARIO_BASE','SALARIO BASE ',NULL,10.000,10.000,10.000),(224088,8777,42,1,NULL,'SALARIO BASE',NULL,1400.000,1400.000,1400.000),(224089,8777,42,32,'__6238','PLUSES DE TRANSPORTE Y DE DISTANCIA',NULL,100.000,100.000,100.000),(224090,8777,43,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA',NULL,150.000,150.000,150.000),(224091,8777,43,1,'PLUS_EXTRA_SALARIAL','PLUS EXTRA SALARIAL',NULL,33.000,33.000,33.000),(224092,8777,43,1,NULL,'SALARIO BASE',NULL,2451.842,2451.842,2451.842),(224093,8777,44,1,NULL,'SALARIO BASE',NULL,16964.167,16964.167,16964.167),(224094,8777,46,1,NULL,'SALARIO BASE',NULL,974.167,974.167,974.167),(224100,8777,54,1,'PLUS_EXTRA_SALARIAL','PLUS REGIMEN GENERAL ( VARIABLE == DEVENGO )',NULL,0.000,0.000,0.000),(224101,8777,54,1,'SALARIO_BASE','[1]SALARIO BASE',NULL,365.969,365.969,365.969),(224102,8777,54,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( > 1996 )',NULL,0.000,0.000,0.000),(224103,8777,54,4,'PAGA_EXTRA','[4]PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,76.244),(224104,8777,54,4,'PAGA_EXTRA','[3]PAGA EXTRAORDINARIA JULIO',NULL,0.000,0.000,76.244),(224105,8777,55,1,'PLUS_EXTRA_SALARIAL','PLUS REGIMEN GENERAL ( VARIABLE == DEVENGO )',NULL,0.000,0.000,0.000),(224106,8777,55,1,'SALARIO_BASE','[1]SALARIO BASE',NULL,835.413,835.413,835.413),(224107,8777,55,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( > 1996 )',NULL,0.000,0.000,0.000),(224108,8777,55,4,'PAGA_EXTRA','[4]PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,69.618),(224109,8777,55,4,'PAGA_EXTRA','[3]PAGA EXTRAORDINARIA JULIO',NULL,0.000,0.000,69.618),(224110,8777,56,1,'PLUS_EXTRA_SALARIAL','PLUS REGIMEN GENERAL ( VARIABLE == DEVENGO )',NULL,0.000,0.000,0.000),(224111,8777,56,1,'SALARIO_BASE','[1]SALARIO BASE',NULL,1027.646,1027.646,1027.646),(224112,8777,56,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( > 1996 )',NULL,0.000,0.000,0.000),(224113,8777,56,4,'PAGA_EXTRA','[4]PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,85.637),(224114,8777,56,4,'PAGA_EXTRA','[3]PAGA EXTRAORDINARIA JULIO',NULL,0.000,0.000,85.637),(224115,8777,57,1,NULL,'[6] PLUS REGIMÉN GENERAL ( REDEFINIDO )',NULL,33.330,33.330,33.330),(224116,8777,57,1,'SALARIO_BASE','[1]SALARIO BASE ( REDEFINIDO )',NULL,979.690,979.690,979.690),(224117,8777,57,1,'PLUS_EXTRA_SALARIAL','PLUS REGIMEN GENERAL ( VARIABLE == DEVENGO )',NULL,0.000,0.000,0.000),(224118,8777,57,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( > 1996 )',NULL,0.000,0.000,0.000),(224119,8777,57,4,'PAGA_EXTRA','[4]PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,94.201),(224120,8777,57,4,'PAGA_EXTRA','[3]PAGA EXTRAORDINARIA JULIO',NULL,0.000,0.000,94.201),(224121,8777,58,1,'PLUS_EXTRA_SALARIAL','PLUS REGIMEN GENERAL ( VARIABLE == DEVENGO )',NULL,0.000,0.000,0.000),(224122,8777,58,1,'SALARIO_BASE','[1]SALARIO BASE',NULL,489.845,489.845,489.845),(224123,8777,58,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( > 1996 )',NULL,0.000,0.000,0.000),(224124,8777,58,4,'PAGA_EXTRA','[4]PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,94.201),(224125,8777,58,4,'PAGA_EXTRA','[3]PAGA EXTRAORDINARIA JULIO',NULL,0.000,0.000,94.201),(224126,8777,59,1,'PLUS_EXTRA_SALARIAL','PLUS REGIMEN GENERAL ( VARIABLE == DEVENGO )',NULL,0.000,0.000,0.000),(224127,8777,59,1,'SALARIO_BASE','[1]SALARIO BASE',NULL,761.346,761.346,761.346),(224128,8777,59,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( > 1996 )',NULL,0.000,0.000,0.000),(224129,8777,59,4,'PAGA_EXTRA','[4]PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,73.206),(224130,8777,59,4,'PAGA_EXTRA','[3]PAGA EXTRAORDINARIA JULIO',NULL,0.000,0.000,73.206),(224131,8777,60,1,'PLUS_EXTRA_SALARIAL','PLUS REGIMEN GENERAL ( VARIABLE == DEVENGO )',NULL,0.000,0.000,0.000),(224132,8777,60,1,'SALARIO_BASE','[1]SALARIO BASE',NULL,959.137,959.137,959.137),(224133,8777,60,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( > 1996 )',NULL,0.000,0.000,0.000),(224134,8777,60,4,'PAGA_EXTRA','[4]PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,85.637),(224135,8777,60,4,'PAGA_EXTRA','[3]PAGA EXTRAORDINARIA JULIO',NULL,0.000,0.000,85.637),(224136,8777,62,1,NULL,NULL,NULL,100.000,100.000,100.000),(224137,8777,62,1,'PLUS_SALARIAL',NULL,NULL,40.000,40.000,40.000),(224138,8777,64,1,'SALARIO_BASE','SALARIO BASE MENSUAL',NULL,327.600,327.600,327.600),(224139,8777,65,1,'SALARIO_BASE','SALARIO BASE MENSUAL',NULL,131.040,131.040,131.040),(224149,8777,69,4,'PAGA_EXTRA','[4]PAGA EXTRAORDINARIA DICIEMBRE',NULL,1027.646,1027.646,0.000),(224150,8777,70,1,'SALARIO_BASE',' SALARIO BASE ANUAL',NULL,356.720,356.720,356.720),(224151,8777,71,1,'SALARIO_BASE',' SALARIO BASE ANUAL',NULL,295.897,295.897,295.897),(224152,8777,71,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA JUNIO',NULL,24.658,24.658,24.658),(224153,8777,71,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA NAVIDAD',NULL,24.658,24.658,24.658),(224154,8777,72,1,'PLUS_EXTRA_SALARIAL','PLUS REGIMEN GENERAL ( VARIABLE == DEVENGO )',NULL,0.000,0.000,0.000),(224155,8777,72,1,'SALARIO_BASE','[1]SALARIO BASE',NULL,479.568,479.568,479.568),(224156,8777,72,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( > 1996 )',NULL,0.000,0.000,0.000),(224157,8777,72,4,'PAGA_EXTRA','[4]PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,85.637),(224158,8777,72,4,'PAGA_EXTRA','[3]PAGA EXTRAORDINARIA JULIO',NULL,0.000,0.000,85.637),(224159,8784,73,1,'SALARIO_BASE','SALARIO BASE MENSUAL',NULL,1614.590,1614.590,1614.590),(224160,8784,73,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA JULIO',NULL,0.000,0.000,134.549),(224161,8784,73,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,134.549),(224162,8784,74,1,'SALARIO_BASE','SALARIO BASE MENSUAL',NULL,584.803,584.803,584.803),(224163,8784,74,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA JULIO',NULL,0.000,0.000,48.734),(224164,8784,74,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,48.734),(224165,8777,75,1,'SALARIO_BASE','SALARIO BASE MENSUAL',NULL,1684.800,1684.800,1684.800),(224166,8777,75,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA',NULL,120.343,120.343,120.343),(224167,8777,75,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA',NULL,120.343,120.343,120.343),(224172,8777,77,1,'SALARIO_BASE','[1] SALARIO BASE ANUAL',NULL,1935.900,1935.900,1935.900),(224173,8777,77,1,'ANTIGUEDAD','[2] COMPLEMENTO PERSONAL DE ANTIGÜEDAD',NULL,0.000,0.000,0.000),(224174,8777,77,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA VERANO',NULL,0.000,0.000,161.325),(224175,8777,77,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA NAVIDAD',NULL,0.000,0.000,161.325),(224176,8777,78,1,'SALARIO_BASE','[1] SALARIO BASE ANUAL',NULL,1935.900,1935.900,1935.900),(224177,8777,78,1,'ANTIGUEDAD','[2] COMPLEMENTO PERSONAL DE ANTIGÜEDAD',NULL,77.436,77.436,77.436),(224178,8777,78,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA VERANO',NULL,0.000,0.000,167.778),(224179,8777,78,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA NAVIDAD',NULL,0.000,0.000,167.778),(224180,8777,79,1,'SALARIO_BASE','[1] SALARIO BASE ANUAL',NULL,1935.900,1935.900,1935.900),(224181,8777,79,1,'ANTIGUEDAD','[2] COMPLEMENTO PERSONAL DE ANTIGÜEDAD',NULL,77.436,77.436,77.436),(224182,8777,79,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA VERANO',NULL,0.000,0.000,167.778),(224183,8777,79,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA NAVIDAD',NULL,0.000,0.000,167.778),(224184,8777,80,1,'SALARIO_BASE','[1] SALARIO BASE ANUAL',NULL,1935.900,1935.900,1935.900),(224185,8777,80,1,'ANTIGUEDAD','[2] COMPLEMENTO PERSONAL DE ANTIGÜEDAD',NULL,77.436,77.436,77.436),(224186,8777,80,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA VERANO',NULL,0.000,0.000,167.778),(224187,8777,80,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA NAVIDAD',NULL,0.000,0.000,167.778),(224188,8777,81,1,'SALARIO_BASE','[1] SALARIO BASE ANUAL',NULL,1935.900,1935.900,1935.900),(224189,8777,81,1,'ANTIGUEDAD','[2] COMPLEMENTO PERSONAL DE ANTIGÜEDAD',NULL,77.436,77.436,77.436),(224190,8777,81,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA VERANO',NULL,0.000,0.000,167.778),(224191,8777,81,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA NAVIDAD',NULL,0.000,0.000,167.778),(224192,8777,82,1,'SALARIO_BASE','[1] SALARIO BASE ANUAL',NULL,1935.900,1935.900,1935.900),(224193,8777,82,1,'ANTIGUEDAD','[2] COMPLEMENTO PERSONAL DE ANTIGÜEDAD',NULL,77.436,77.436,77.436),(224194,8777,82,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA VERANO',NULL,0.000,0.000,167.778),(224195,8777,82,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA NAVIDAD',NULL,0.000,0.000,167.778),(224196,8777,83,1,'SALARIO_BASE','[1] SALARIO BASE ANUAL',NULL,1935.900,1935.900,1935.900),(224197,8777,83,1,'ANTIGUEDAD','[2] COMPLEMENTO PERSONAL DE ANTIGÜEDAD',NULL,77.436,77.436,77.436),(224198,8777,83,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA VERANO',NULL,0.000,0.000,167.778),(224199,8777,83,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA NAVIDAD',NULL,0.000,0.000,167.778),(224200,8777,84,1,'SALARIO_BASE','[1] SALARIO BASE ANUAL',NULL,1935.900,1935.900,1935.900),(224201,8777,84,1,'ANTIGUEDAD','[2] COMPLEMENTO PERSONAL DE ANTIGÜEDAD',NULL,77.436,77.436,77.436),(224202,8777,84,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA VERANO',NULL,0.000,0.000,167.778),(224203,8777,84,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA NAVIDAD',NULL,0.000,0.000,167.778),(224204,8777,85,1,'SALARIO_BASE','[1] SALARIO BASE ANUAL',NULL,1935.900,1935.900,1935.900),(224205,8777,85,1,'ANTIGUEDAD','[2] COMPLEMENTO PERSONAL DE ANTIGÜEDAD',NULL,77.436,77.436,77.436),(224206,8777,85,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA VERANO',NULL,0.000,0.000,167.778),(224207,8777,85,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA NAVIDAD',NULL,0.000,0.000,167.778),(224208,8777,86,1,'SALARIO_BASE','[1] SALARIO BASE ANUAL',NULL,1935.900,1935.900,1935.900),(224209,8777,86,1,'ANTIGUEDAD','[2] COMPLEMENTO PERSONAL DE ANTIGÜEDAD',NULL,77.436,77.436,77.436),(224210,8777,86,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA VERANO',NULL,0.000,0.000,167.778),(224211,8777,86,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA NAVIDAD',NULL,0.000,0.000,167.778),(224212,8777,87,1,'SALARIO_BASE','[1] SALARIO BASE ANUAL',NULL,1935.900,1935.900,1935.900),(224213,8777,87,1,'ANTIGUEDAD','[2] COMPLEMENTO PERSONAL DE ANTIGÜEDAD',NULL,77.436,77.436,77.436),(224214,8777,87,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA VERANO',NULL,0.000,0.000,167.778),(224215,8777,87,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA NAVIDAD',NULL,0.000,0.000,167.778),(224216,8777,88,1,'SALARIO_BASE','[1] SALARIO BASE ANUAL',NULL,1935.900,1935.900,1935.900),(224217,8777,88,1,'ANTIGUEDAD','[2] COMPLEMENTO PERSONAL DE ANTIGÜEDAD',NULL,0.000,0.000,0.000),(224218,8777,88,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA VERANO',NULL,0.000,0.000,161.325),(224219,8777,88,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA NAVIDAD',NULL,0.000,0.000,161.325),(224220,8777,89,8,'__I','Atrasos en la Nómina',NULL,64.530,64.530,75.285),(224221,8777,89,8,'__II','Atrasos en la Nómina',NULL,64.530,64.530,75.285),(224222,8777,89,8,'__III','Atrasos en la Nómina',NULL,67.111,67.111,78.296),(224223,8777,89,8,'__IV','Atrasos en la Nómina',NULL,67.111,67.111,78.296),(224224,8777,89,8,'__V','Atrasos en la Nómina',NULL,67.111,67.111,78.296),(224225,8777,89,8,'__VI','Atrasos en la Nómina',NULL,67.111,67.111,78.296),(224226,8777,89,8,'__VII','Atrasos en la Nómina',NULL,67.111,67.111,78.296),(224227,8777,89,8,'__VIII','Atrasos en la Nómina',NULL,67.111,67.111,78.296),(224228,8777,89,8,'__IX','Atrasos en la Nómina',NULL,67.111,67.111,78.296),(224229,8777,89,8,'__X','Atrasos en la Nómina',NULL,67.111,67.111,78.296),(224230,8777,89,8,'__XI','Atrasos en la Nómina',NULL,67.111,67.111,78.296),(224231,8777,89,8,'__XII','Atrasos en la Nómina',NULL,67.111,67.111,78.296),(224239,8783,90,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA DE JULIO',NULL,311.676,311.676,0.000),(224243,8783,93,1,'SALARIO_BASE','SALARIO BASE MENSUAL',NULL,1310.400,1310.400,1310.400),(224244,8783,93,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,109.200),(224245,8783,93,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA VERANO',NULL,0.000,0.000,109.200),(224246,8783,94,1,'SALARIO_BASE','SALARIO BASE MENSUAL',NULL,655.200,655.200,655.200),(224247,8783,94,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,54.600),(224248,8783,94,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA VERANO',NULL,0.000,0.000,54.600),(224250,8783,96,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA DICIEMBRE',NULL,655.200,655.200,0.000),(224251,8783,97,1,'SALARIO_BASE','SALARIO BASE MENSUAL',NULL,1310.400,1310.400,1310.400),(224252,8783,97,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,109.200),(224253,8783,97,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA VERANO',NULL,0.000,0.000,109.200),(224260,8777,98,1,'SALARIO_BASE','SALARIO BASE MENSUAL',NULL,371.280,371.280,371.280),(224261,8777,98,1,'PREST_IT','PREST. POR ENFERMEDAD COMÚN',NULL,0.000,0.000,106.740),(224262,8777,98,1,'PREST_IT','PREST. POR ENFERMEDAD COMÚN A CARGO DE LA EMPRESA',NULL,234.828,234.828,355.800),(224275,8777,99,1,'SALARIO_BASE','SALARIO BASE',NULL,486.116,486.116,486.116),(224276,8777,99,1,'PREST_IT','PREST. POR ENFERMEDAD COMÚN',NULL,0.000,0.000,71.344),(224277,8777,99,1,'PREST_IT','PREST. POR ENFERMEDAD COMÚN A CARGO DE LA EMPRESA',NULL,71.344,71.344,118.907),(224280,8777,100,6,'__6213','VACACIONES RETRIBUIDAS NO DISFRUTADAS',NULL,1072.737,1072.737,1072.737),(224281,8777,100,54,'INDEMNIZACION','INDEMNIZACION POR FIN DE CONTRATO TEMPORAL',NULL,71.516,0.000,0.000),(224282,8777,101,1,'PLUS_EXTRA_SALARIAL','PLUS REGIMEN GENERAL ( VARIABLE == DEVENGO )',NULL,0.000,0.000,0.000),(224283,8777,101,1,'SALARIO_BASE','[1]SALARIO BASE',NULL,362.202,362.202,362.202),(224284,8777,101,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( > 1996 )',NULL,0.000,0.000,0.000),(224285,8777,101,4,'PAGA_EXTRA','[4]PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,82.319),(224286,8777,101,4,'PAGA_EXTRA','[3]PAGA EXTRAORDINARIA JULIO',NULL,0.000,0.000,82.319),(224287,8777,102,1,'PLUS_EXTRA_SALARIAL','PLUS REGIMEN GENERAL ( VARIABLE == DEVENGO )',NULL,0.000,0.000,0.000),(224288,8777,102,1,'SALARIO_BASE','[1]SALARIO BASE',NULL,987.825,987.825,987.825),(224289,8777,102,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( > 1996 )',NULL,0.000,0.000,0.000),(224290,8777,102,4,'PAGA_EXTRA','[4]PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,82.319),(224291,8777,102,4,'PAGA_EXTRA','[3]PAGA EXTRAORDINARIA JULIO',NULL,0.000,0.000,82.319),(224292,8777,103,1,'PLUS_EXTRA_SALARIAL','PLUS REGIMEN GENERAL ( VARIABLE == DEVENGO )',NULL,0.000,0.000,0.000),(224293,8777,103,1,'SALARIO_BASE','[1]SALARIO BASE',NULL,987.825,987.825,987.825),(224294,8777,103,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( > 1996 )',NULL,0.000,0.000,0.000),(224295,8777,103,4,'PAGA_EXTRA','[4]PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,82.319),(224296,8777,103,4,'PAGA_EXTRA','[3]PAGA EXTRAORDINARIA JULIO',NULL,0.000,0.000,82.319),(224297,8777,104,1,'PLUS_EXTRA_SALARIAL','PLUS REGIMEN GENERAL ( VARIABLE == DEVENGO )',NULL,0.000,0.000,0.000),(224298,8777,104,1,'SALARIO_BASE','[1]SALARIO BASE',NULL,987.825,987.825,987.825),(224299,8777,104,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( > 1996 )',NULL,0.000,0.000,0.000),(224300,8777,104,4,'PAGA_EXTRA','[4]PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,82.319),(224301,8777,104,4,'PAGA_EXTRA','[3]PAGA EXTRAORDINARIA JULIO',NULL,0.000,0.000,82.319),(224302,8777,105,1,'PLUS_EXTRA_SALARIAL','PLUS REGIMEN GENERAL ( VARIABLE == DEVENGO )',NULL,0.000,0.000,0.000),(224303,8777,105,1,'SALARIO_BASE','[1]SALARIO BASE',NULL,987.825,987.825,987.825),(224304,8777,105,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( > 1996 )',NULL,0.000,0.000,0.000),(224305,8777,105,4,'PAGA_EXTRA','[4]PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,82.319),(224306,8777,105,4,'PAGA_EXTRA','[3]PAGA EXTRAORDINARIA JULIO',NULL,0.000,0.000,82.319),(224307,8777,106,1,'PLUS_EXTRA_SALARIAL','PLUS REGIMEN GENERAL ( VARIABLE == DEVENGO )',NULL,0.000,0.000,0.000),(224308,8777,106,1,'SALARIO_BASE','[1]SALARIO BASE',NULL,987.825,987.825,987.825),(224309,8777,106,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( > 1996 )',NULL,0.000,0.000,0.000),(224310,8777,106,4,'PAGA_EXTRA','[4]PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,82.319),(224311,8777,106,4,'PAGA_EXTRA','[3]PAGA EXTRAORDINARIA JULIO',NULL,0.000,0.000,82.319),(224312,8777,107,3,'HORAS_EXTRAS','HORAS EXTR. ESTRUCTURALES O FUERZA MAYOR',NULL,100.000,100.000,100.000),(224313,8777,107,1,'PLUS_EXTRA_SALARIAL','PLUS REGIMEN GENERAL ( VARIABLE == DEVENGO )',NULL,0.000,0.000,0.000),(224314,8777,107,1,'SALARIO_BASE','[1]SALARIO BASE',NULL,274.039,274.039,274.039),(224315,8777,107,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( > 1996 )',NULL,0.000,0.000,0.000),(224316,8777,107,4,'PAGA_EXTRA','[4]PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,171.274),(224317,8777,107,4,'PAGA_EXTRA','[3]PAGA EXTRAORDINARIA JULIO',NULL,0.000,0.000,171.274),(224318,8777,107,1,'PREST_IT','PREST. POR ENFERMEDAD COMÚN',NULL,0.000,0.000,142.290),(224319,8777,107,1,'PREST_IT','PREST. POR ENFERMEDAD COMÚN A CARGO DE LA EMPRESA',NULL,56.916,56.916,47.430),(224320,8777,108,1,'PLUS_EXTRA_SALARIAL','PLUS REGIMEN GENERAL ( VARIABLE == DEVENGO )',NULL,0.000,0.000,0.000),(224321,8777,108,1,'SALARIO_BASE','[1]SALARIO BASE',NULL,914.922,914.922,914.922),(224322,8777,108,1,'ANTIGUEDAD','[2]COMPLEMENTO DE ANTIGÜEDAD ( > 1996 )',NULL,0.000,0.000,0.000),(224323,8777,108,4,'PAGA_EXTRA','[4]PAGA EXTRAORDINARIA DICIEMBRE',NULL,0.000,0.000,76.244),(224324,8777,108,4,'PAGA_EXTRA','[3]PAGA EXTRAORDINARIA JULIO',NULL,0.000,0.000,76.244),(224355,8788,119,1,'SALARIO_BASE','SALARIO BASE MENSUAL',NULL,1146.600,1146.600,1146.600),(224356,8788,119,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA NAVIDAD',NULL,0.000,0.000,1146.600),(224357,8788,119,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA VERANO',NULL,0.000,0.000,1146.600),(224358,8788,120,1,'SALARIO_BASE','SALARIO BASE MENSUAL',NULL,174.720,174.720,174.720),(224359,8788,120,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA NAVIDAD',NULL,0.000,0.000,174.720),(224360,8788,120,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA VERANO',NULL,0.000,0.000,174.720),(224361,8788,121,1,'SALARIO_BASE','SALARIO BASE MENSUAL',NULL,109.200,109.200,109.200),(224362,8788,121,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA NAVIDAD',NULL,0.000,0.000,109.200),(224363,8788,121,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA VERANO',NULL,0.000,0.000,109.200),(224364,8788,122,1,'SALARIO_BASE','SALARIO BASE MENSUAL',NULL,109.200,109.200,109.200),(224365,8788,122,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA NAVIDAD',NULL,0.000,0.000,109.200),(224366,8788,122,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA VERANO',NULL,0.000,0.000,109.200),(224367,8788,123,1,'SALARIO_BASE','SALARIO BASE MENSUAL',NULL,131.040,131.040,131.040),(224368,8788,123,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA NAVIDAD',NULL,0.000,0.000,131.040),(224369,8788,123,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA VERANO',NULL,0.000,0.000,131.040),(224373,8788,125,1,'SALARIO_BASE','SALARIO BASE MENSUAL',NULL,655.200,655.200,655.200),(224374,8788,125,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA NAVIDAD',NULL,0.000,0.000,655.200),(224375,8788,125,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA VERANO',NULL,0.000,0.000,655.200),(224376,8788,126,1,'SALARIO_BASE','SALARIO BASE MENSUAL',NULL,174.720,174.720,174.720),(224377,8788,126,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA NAVIDAD',NULL,0.000,0.000,174.720),(224378,8788,126,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA VERANO',NULL,0.000,0.000,174.720),(224379,8788,127,1,'SALARIO_BASE','SALARIO BASE MENSUAL',NULL,109.200,109.200,109.200),(224380,8788,127,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA NAVIDAD',NULL,0.000,0.000,109.200),(224381,8788,127,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA VERANO',NULL,0.000,0.000,109.200),(224382,8788,128,1,'SALARIO_BASE','SALARIO BASE MENSUAL',NULL,109.200,109.200,109.200),(224383,8788,128,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA NAVIDAD',NULL,0.000,0.000,109.200),(224384,8788,128,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA VERANO',NULL,0.000,0.000,109.200),(224385,8788,129,1,'SALARIO_BASE','SALARIO BASE MENSUAL',NULL,109.200,109.200,109.200),(224386,8788,129,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA NAVIDAD',NULL,0.000,0.000,109.200),(224387,8788,129,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA VERANO',NULL,0.000,0.000,109.200),(224399,8788,133,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA NAVIDAD',NULL,0.000,0.000,0.000),(224400,8788,133,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA VERANO',NULL,0.000,0.000,0.000),(224401,8788,133,1,'PREST_IT','PREST. POR ENFERMEDAD COMÚN A CARGO DEL INSS',NULL,1474.200,1474.200,1965.600),(224402,8788,134,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA NAVIDAD',NULL,0.000,0.000,0.000),(224403,8788,134,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA VERANO',NULL,0.000,0.000,0.000),(224404,8788,134,1,'PREST_IT','PREST. POR ACCIDENTE DE TRABAJO Y/O ENFERMEDAD PROFESIONAL',NULL,1474.200,1474.200,1965.600),(224405,8788,135,1,'SALARIO_BASE','SALARIO BASE MENSUAL',NULL,436.800,436.800,436.800),(224406,8788,135,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA NAVIDAD',NULL,0.000,0.000,436.800),(224407,8788,135,4,'PAGA_EXTRA','PAGA EXTRAORDINARIA VERANO',NULL,0.000,0.000,436.800),(224408,8788,135,1,'PREST_IT','PREST. POR ENFERMEDAD COMÚN',NULL,0.000,0.000,196.560),(224409,8788,135,1,'PREST_IT','PREST. POR ENFERMEDAD COMÚN A CARGO DE LA EMPRESA',NULL,275.184,275.184,458.640);
/*!40000 ALTER TABLE `salary_payment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales`
--

DROP TABLE IF EXISTS `sales`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sales` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Pedido de Venta',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `project` int(4) DEFAULT NULL COMMENT 'Identificador del Proyecto',
  `customer` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador del Cliente',
  `series` char(5) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Serie del Pedido',
  `number` int(4) NOT NULL DEFAULT '0' COMMENT 'Numero del Pedido',
  `purchase_reference` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo de referencia del Pedido de Compra',
  `shipping_address` int(4) DEFAULT NULL COMMENT 'Identificador de la Direccion de envio del Pedido',
  `seller` int(4) DEFAULT NULL COMMENT 'Identificador del Agente Comercial',
  `discount_expr` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descuentos del Pedido',
  `issue_date` date DEFAULT NULL COMMENT 'Fecha de emision del Pedido',
  `pay_method` int(4) DEFAULT NULL COMMENT 'Identificador de la Forma de Pago',
  `document_type` tinyint(2) DEFAULT '0' COMMENT 'Tipo de Pedido',
  `security_level` tinyint(2) DEFAULT '0' COMMENT 'Nivel de seguridad del Pedido',
  `status` tinyint(2) DEFAULT '0' COMMENT 'Estado del Pedido',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios del Pedido',
  `remarks` text COLLATE latin1_spanish_ci COMMENT 'Observaciones del Pedido',
  `workplace` int(4) NOT NULL COMMENT 'Identificador del Centro de Trabajo',
  `scope` int(4) NOT NULL DEFAULT '1' COMMENT 'Ambito del Pedido',
  `number_of_pymnts` smallint(2) DEFAULT '0' COMMENT 'Numero de Vencimientos',
  `days_to_first_pymnt` smallint(2) DEFAULT '0' COMMENT 'Dias al primer Vencimiento',
  `days_between_pymnts` smallint(2) DEFAULT '0' COMMENT 'Dias entre Vencimientos',
  `pymnt_days` varchar(8) COLLATE latin1_spanish_ci DEFAULT '0' COMMENT 'Dias de pago',
  `bank_account` varchar(34) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'IBAN - Numero de Cuenta Bancaria Internacional',
  `bank_alias` varchar(25) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Alias del Banco',
  `bic` varchar(11) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'BIC - Codigo Identificador del Banco',
  `purchase_generated` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indica si se han generado los Pedidos de Compra derivados',
  `delivery_date` date DEFAULT NULL COMMENT 'Fecha de entrega',
  `carrier` int(4) DEFAULT NULL COMMENT 'Identificador de la Agencia de Transporte',
  `carrier_packing` int(4) DEFAULT NULL COMMENT 'Identificador de la Hoja de ruta',
  `shipping_alternative_address` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Primera parte de la Direccion de entrega',
  `shipping_alternative_address2` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Segunda parte de la Direccion de entrega',
  `shipping_alternative_zip` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo Postal de entrega',
  `shipping_alternative_city` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Localidad de entrega',
  `shipping_alternative_phone` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Telefono de contacto de la entrega',
  `shipping_alternative_recipient` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Destinatario de la entrega',
  `shipping_contact` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre del contacto para la entrega',
  `shipping_period` tinyint(2) DEFAULT '0' COMMENT 'Tipo de periodo de entrega',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  UNIQUE KEY `IDX_UNQ_SALES_DOMAIN_SERIES_NUMBER` (`domain`,`series`,`number`),
  KEY `IDX_SALES_SCOPE` (`scope`),
  KEY `IDX_SALES_PROJECT` (`project`),
  KEY `IDX_SALES_ISSUE_DATE` (`issue_date`),
  KEY `IDX_SALES_SELLER` (`seller`),
  KEY `IDX_SALES_CUSTOMER` (`customer`),
  KEY `IDX_SALES_RADDRESS` (`shipping_address`),
  KEY `IDX_SALES_PAY_METHOD` (`pay_method`),
  KEY `IDX_SALES_WORKPLACE` (`workplace`),
  KEY `IDX_SALES_DOMAIN` (`domain`),
  KEY `IDX_SALES_CARRIER` (`carrier`),
  CONSTRAINT `FK_SALES_CARRIER` FOREIGN KEY (`carrier`) REFERENCES `carrier` (`registry`),
  CONSTRAINT `FK_SALES_CUSTOMER` FOREIGN KEY (`customer`) REFERENCES `customer` (`registry`),
  CONSTRAINT `FK_SALES_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_SALES_PAY_METHOD` FOREIGN KEY (`pay_method`) REFERENCES `pay_method` (`id`),
  CONSTRAINT `FK_SALES_PROJECT` FOREIGN KEY (`project`) REFERENCES `project` (`id`),
  CONSTRAINT `FK_SALES_RADDRESS` FOREIGN KEY (`shipping_address`) REFERENCES `raddress` (`id`),
  CONSTRAINT `FK_SALES_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`),
  CONSTRAINT `FK_SALES_SELLER` FOREIGN KEY (`seller`) REFERENCES `seller` (`registry`),
  CONSTRAINT `FK_SALES_WORKPLACE` FOREIGN KEY (`workplace`) REFERENCES `workplace` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Pedidos de Venta';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales`
--

LOCK TABLES `sales` WRITE;
/*!40000 ALTER TABLE `sales` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sales_detail`
--

DROP TABLE IF EXISTS `sales_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sales_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Detalle del Pedido de Venta',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `sales` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador del Pedido de Venta',
  `line` smallint(2) DEFAULT '1' COMMENT 'Numero de linea del Detalle dentro del Pedido',
  `item` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador del Articulo del Detalle de Pedido',
  `description` varchar(1024) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion del Detalle de Pedido',
  `quantity` double(15,3) DEFAULT '0.000' COMMENT 'Cantidad del Detalle de Pedido',
  `price` double DEFAULT '0' COMMENT 'Precio del Detalle de Pedido',
  `discount_expr` varchar(32) COLLATE latin1_spanish_ci DEFAULT '0' COMMENT 'Descuentos del Detalle de Pedido',
  `taxes` double(15,3) DEFAULT '0.000' COMMENT 'Tasas del Detalle de Pedido',
  `status` tinyint(2) DEFAULT '0' COMMENT 'Estado del Detalle de Pedido',
  `offer_detail` int(4) DEFAULT NULL COMMENT 'Identificador del Detalle del Presupuesto Origen',
  `delivered` double DEFAULT '0' COMMENT 'Cantidad entregada del Detalle de Pedido',
  `delivery_date` date DEFAULT NULL COMMENT 'Fecha de entrega',
  `carrier` int(4) DEFAULT NULL COMMENT 'Identificador de la Agencia de Transporte',
  `carrier_packing` int(4) DEFAULT NULL COMMENT 'Identificador de la Hoja de ruta',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_SALES_DETAIL_OFFER_DETAIL` (`offer_detail`),
  KEY `IDX_SALES_DETAIL_SALES` (`sales`),
  KEY `IDX_SALES_DETAIL_ITEM` (`item`),
  KEY `IDX_SALES_DETAIL_DOMAIN` (`domain`),
  KEY `IDX_SALES_DETAIL_CARRIER` (`carrier`),
  KEY `IDX_SALES_DETAIL_CARRIER_PACKING` (`carrier_packing`),
  CONSTRAINT `FK_SALES_DETAIL_CARRIER` FOREIGN KEY (`carrier`) REFERENCES `carrier` (`registry`),
  CONSTRAINT `FK_SALES_DETAIL_CARRIER_PACKING` FOREIGN KEY (`carrier_packing`) REFERENCES `carrier_packing` (`id`),
  CONSTRAINT `FK_SALES_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_SALES_DETAIL_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`),
  CONSTRAINT `FK_SALES_DETAIL_OFFER_DETAIL` FOREIGN KEY (`offer_detail`) REFERENCES `offer_detail` (`id`),
  CONSTRAINT `FK_SALES_DETAIL_SALES` FOREIGN KEY (`sales`) REFERENCES `sales` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalles del Pedido de Venta';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sales_detail`
--

LOCK TABLES `sales_detail` WRITE;
/*!40000 ALTER TABLE `sales_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `sales_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `scope`
--

DROP TABLE IF EXISTS `scope`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `scope` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `description` varchar(16) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion del Ambito',
  PRIMARY KEY (`id`),
  KEY `IDX_SCOPE_DOMAIN` (`domain`),
  CONSTRAINT `FK_SCOPE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3539 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Ambitos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `scope`
--

LOCK TABLES `scope` WRITE;
/*!40000 ALTER TABLE `scope` DISABLE KEYS */;
INSERT INTO `scope` VALUES (2559,0,'CONSOLE'),(3535,8776,'GENERAL'),(3536,8776,'TRAINNING'),(3537,8776,'AGRARIAN'),(3538,8779,'GENERAL');
/*!40000 ALTER TABLE `scope` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `segment`
--

DROP TABLE IF EXISTS `segment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `segment` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre del Segmento',
  PRIMARY KEY (`id`),
  KEY `IDX_SEGMENT_DOMAIN` (`domain`),
  CONSTRAINT `FK_SEGMENT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Segmentos Comerciales';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `segment`
--

LOCK TABLES `segment` WRITE;
/*!40000 ALTER TABLE `segment` DISABLE KEYS */;
/*!40000 ALTER TABLE `segment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `seller`
--

DROP TABLE IF EXISTS `seller`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `seller` (
  `registry` int(4) NOT NULL DEFAULT '0' COMMENT 'Registro del Agente Comercial',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `commission_type` int(4) DEFAULT NULL COMMENT 'Identificador del Tipo de Comision',
  `status` tinyint(2) DEFAULT '0' COMMENT 'Estado del Agente Comercial',
  `scope` int(4) NOT NULL COMMENT 'Identificador del Ambito',
  PRIMARY KEY (`registry`),
  KEY `IDX_SELLER_COMMISSION_TYPE` (`commission_type`),
  KEY `IDX_SELLER_DOMAIN` (`domain`),
  KEY `IDX_SELLER_SCOPE` (`scope`),
  CONSTRAINT `FK_SELLER_COMMISSION_TYPE` FOREIGN KEY (`commission_type`) REFERENCES `commission_type` (`id`),
  CONSTRAINT `FK_SELLER_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_SELLER_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`),
  CONSTRAINT `FK_SELLER_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Agentes Comerciales';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `seller`
--

LOCK TABLES `seller` WRITE;
/*!40000 ALTER TABLE `seller` DISABLE KEYS */;
/*!40000 ALTER TABLE `seller` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sepe_batch_attach`
--

DROP TABLE IF EXISTS `sepe_batch_attach`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sepe_batch_attach` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Archivo Adjunto',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `source_batch` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador de la remesa',
  `source_type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de la remesa',
  `mimeType` tinyint(2) DEFAULT '0' COMMENT 'Mime Type del Archivo Adjunto',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion del Archivo Adjunto',
  `data` mediumblob COMMENT 'Archivo Adjunto en binario',
  `type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de Archivo Adjunto',
  `scope` int(4) DEFAULT NULL COMMENT 'Ambito del Archivo Adjunto',
  `attach_date` date DEFAULT NULL COMMENT 'Fecha del Archivo Adjunto',
  `driveId` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `IDX_SEPE_BATCH_ATTACH_SCOPE` (`scope`),
  KEY `IDX_SEPE_BATCH_ATTACH_DOMAIN` (`domain`),
  CONSTRAINT `FK_SEPE_BATCH_ATTACH_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_SEPE_BATCH_ATTACH_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Archivos Adjuntos de remesas de SEPE';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sepe_batch_attach`
--

LOCK TABLES `sepe_batch_attach` WRITE;
/*!40000 ALTER TABLE `sepe_batch_attach` DISABLE KEYS */;
/*!40000 ALTER TABLE `sepe_batch_attach` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `series`
--

DROP TABLE IF EXISTS `series`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `series` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `code` varchar(5) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Serie',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `scope` int(4) NOT NULL COMMENT 'Identificador del Ambito',
  `description` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion de la Serie',
  `tas` tinyint(1) DEFAULT '0' COMMENT 'Indica si es una Serie para Ordenes de Reparacion',
  `offer` tinyint(1) DEFAULT '0' COMMENT 'Indica si es una Serie para Presupuestos',
  `sales` tinyint(1) DEFAULT '0' COMMENT 'Indica si es una Serie para Pedidos',
  `delivery` tinyint(1) DEFAULT '0' COMMENT 'Indica si es una Serie para Albaranes',
  `invoice` tinyint(1) DEFAULT '0' COMMENT 'Indica si es una Serie para Facturas',
  `rectification` tinyint(1) DEFAULT '0' COMMENT 'Indica si es una Serie para Facturas rectificativas',
  `pos` tinyint(1) DEFAULT '0' COMMENT 'Indica si es una Serie para TPV',
  `security_level` tinyint(2) NOT NULL COMMENT 'Nivel de seguridad de la Serie',
  `active` tinyint(1) NOT NULL COMMENT 'Indica si la Serie esta activa o no',
  PRIMARY KEY (`id`),
  KEY `IDX_SERIES_DOMAIN` (`domain`),
  KEY `IDX_SERIES_SCOPE` (`scope`),
  CONSTRAINT `FK_SERIES_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_SERIES_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Series';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `series`
--

LOCK TABLES `series` WRITE;
/*!40000 ALTER TABLE `series` DISABLE KEYS */;
/*!40000 ALTER TABLE `series` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `session`
--

DROP TABLE IF EXISTS `session`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `session` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `endDate` datetime DEFAULT NULL COMMENT 'Fecha de finalizacion',
  `remote_address` varchar(15) COLLATE latin1_spanish_ci NOT NULL DEFAULT '' COMMENT 'IP remota',
  `remote_host` varchar(64) COLLATE latin1_spanish_ci NOT NULL DEFAULT '' COMMENT 'Equipo remoto',
  `session_id` varchar(128) COLLATE latin1_spanish_ci NOT NULL DEFAULT '' COMMENT 'Identificador web de la sesión',
  `startDate` datetime NOT NULL COMMENT 'Fecha de inicio',
  `application` int(4) NOT NULL COMMENT 'Identificador de la Aplicacion',
  `user_id` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador del Usuario',
  PRIMARY KEY (`id`),
  KEY `IDX_SESSION_APPLICATION` (`application`),
  KEY `IDX_SESSION_USER` (`user_id`),
  KEY `IDX_SESSION_DOMAIN` (`domain`),
  CONSTRAINT `FK_SESSION_APPLICATION` FOREIGN KEY (`application`) REFERENCES `application` (`id`),
  CONSTRAINT `FK_SESSION_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_SESSION_USER` FOREIGN KEY (`user_id`) REFERENCES `user` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Sesion web';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `session`
--

LOCK TABLES `session` WRITE;
/*!40000 ALTER TABLE `session` DISABLE KEYS */;
/*!40000 ALTER TABLE `session` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `signature`
--

DROP TABLE IF EXISTS `signature`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `signature` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre de la Firma',
  `signature` text COLLATE latin1_spanish_ci NOT NULL COMMENT 'Texto de la Firma de la Cuenta de Correo',
  `user_id` int(4) DEFAULT NULL COMMENT 'Identificador del Usuario',
  PRIMARY KEY (`id`),
  KEY `IDX_SIGNATURE_DOMAIN` (`domain`),
  KEY `IDX_SIGNATURE_USER` (`user_id`),
  CONSTRAINT `FK_SIGNATURE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_SIGNATURE_USER` FOREIGN KEY (`user_id`) REFERENCES `user` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Firmas de Cuentas de Correo Electronico';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `signature`
--

LOCK TABLES `signature` WRITE;
/*!40000 ALTER TABLE `signature` DISABLE KEYS */;
/*!40000 ALTER TABLE `signature` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `stock`
--

DROP TABLE IF EXISTS `stock`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `stock` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Stock',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `warehouse` int(4) DEFAULT NULL COMMENT 'Identificador del Almacen',
  `item` int(4) DEFAULT NULL COMMENT 'Identificador del Articulo',
  `quantity` double(15,3) DEFAULT '0.000' COMMENT 'Cantidad del Articulo en el Almacen',
  PRIMARY KEY (`id`),
  UNIQUE KEY `IDX_UNQ_STOCK_WAREHOUSE_ITEM` (`warehouse`,`item`),
  KEY `IDX_STOCK_WAREHOUSE` (`warehouse`),
  KEY `IDX_STOCK_ITEM` (`item`),
  KEY `IDX_STOCK_DOMAIN` (`domain`),
  CONSTRAINT `FK_STOCK_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_STOCK_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`),
  CONSTRAINT `FK_STOCK_WAREHOUSE` FOREIGN KEY (`warehouse`) REFERENCES `warehouse` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Stocks de Almacenes';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `stock`
--

LOCK TABLES `stock` WRITE;
/*!40000 ALTER TABLE `stock` DISABLE KEYS */;
/*!40000 ALTER TABLE `stock` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `stop_sales`
--

DROP TABLE IF EXISTS `stop_sales`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `stop_sales` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `hotel` int(4) NOT NULL COMMENT 'Identificador del Hotel',
  `start_date` date NOT NULL COMMENT 'Fecha de inicio del Paro',
  `end_date` date NOT NULL COMMENT 'Fecha de fin del Paro',
  `remarks` text COLLATE latin1_spanish_ci COMMENT 'Comentarios',
  `active` tinyint(1) NOT NULL COMMENT 'Indica si el Paro esta activo o no',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_STOP_SALES_DOMAIN` (`domain`),
  KEY `IDX_STOP_SALES_HOTEL` (`hotel`),
  CONSTRAINT `FK_STOP_SALES_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_STOP_SALES_HOTEL` FOREIGN KEY (`hotel`) REFERENCES `hotel` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Paros de venta';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `stop_sales`
--

LOCK TABLES `stop_sales` WRITE;
/*!40000 ALTER TABLE `stop_sales` DISABLE KEYS */;
/*!40000 ALTER TABLE `stop_sales` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `stop_sales_item`
--

DROP TABLE IF EXISTS `stop_sales_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `stop_sales_item` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `stop_sales` int(4) NOT NULL COMMENT 'Identificador del Paro de ventas',
  `item` int(4) NOT NULL COMMENT 'Identificador del Tipo de Habitacion',
  PRIMARY KEY (`id`),
  KEY `IDX_STOP_SALES_ITEM_DOMAIN` (`domain`),
  KEY `IDX_STOP_SALES_ITEM_STOP_SALES` (`stop_sales`),
  KEY `IDX_STOP_SALES_ITEM_ITEM` (`item`),
  CONSTRAINT `FK_STOP_SALES_ITEM_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_STOP_SALES_ITEM_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`),
  CONSTRAINT `FK_STOP_SALES_ITEM_STOP_SALES` FOREIGN KEY (`stop_sales`) REFERENCES `stop_sales` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Tipos de Habitacion por Paro';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `stop_sales_item`
--

LOCK TABLES `stop_sales_item` WRITE;
/*!40000 ALTER TABLE `stop_sales_item` DISABLE KEYS */;
/*!40000 ALTER TABLE `stop_sales_item` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `stop_sales_tariff`
--

DROP TABLE IF EXISTS `stop_sales_tariff`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `stop_sales_tariff` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `stop_sales` int(4) NOT NULL COMMENT 'Identificador del Paro de ventas',
  `tariff` int(4) NOT NULL COMMENT 'Identificador de la Tarifa',
  PRIMARY KEY (`id`),
  KEY `IDX_STOP_SALES_TARIFF_DOMAIN` (`domain`),
  KEY `IDX_STOP_SALES_TARIFF_STOP_SALES` (`stop_sales`),
  KEY `IDX_STOP_SALES_TARIFF_TARIFF` (`tariff`),
  CONSTRAINT `FK_STOP_SALES_TARIFF_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_STOP_SALES_TARIFF_STOP_SALES` FOREIGN KEY (`stop_sales`) REFERENCES `stop_sales` (`id`),
  CONSTRAINT `FK_STOP_SALES_TARIFF_TARIFF` FOREIGN KEY (`tariff`) REFERENCES `tariff` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Tarifas por Paro';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `stop_sales_tariff`
--

LOCK TABLES `stop_sales_tariff` WRITE;
/*!40000 ALTER TABLE `stop_sales_tariff` DISABLE KEYS */;
/*!40000 ALTER TABLE `stop_sales_tariff` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `supplier`
--

DROP TABLE IF EXISTS `supplier`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `supplier` (
  `registry` int(4) NOT NULL DEFAULT '0' COMMENT 'Registro del Proveedor',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `tariff` int(4) DEFAULT NULL COMMENT 'Tarifa asociada al Proveedor',
  `withholding` tinyint(1) DEFAULT '0' COMMENT 'Indica si el Proveedor aplica retencion de impuestos',
  `withholding_farmer` tinyint(1) DEFAULT '0' COMMENT 'Indica si el Proveedor pertenece al Regimen Especial de Agricultura y Pesca',
  `vat_accrual_payment` tinyint(1) DEFAULT '0' COMMENT 'Indica si el Proveedor esta acogido al Regimen Especial de Criterio de Caja',
  `transaction` tinyint(2) DEFAULT '0' COMMENT 'Tipo de transacciones del Proveedor',
  `status` tinyint(2) DEFAULT NULL COMMENT 'Estado del Proveedor',
  `scope` int(4) NOT NULL COMMENT 'Identificador del Ambito',
  `purchase_valuated` tinyint(1) DEFAULT '1' COMMENT 'Indica si el Pedido se imprime valorado segun el Proveedor',
  `account` int(4) DEFAULT NULL COMMENT 'Identificador de la Cuenta Contable',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`registry`),
  KEY `IDX_SUPPLIER_SCOPE` (`scope`),
  KEY `IDX_SUPPLIER_DOMAIN` (`domain`),
  KEY `IDX_SUPPLIER_ACCOUNT` (`account`),
  KEY `IDX_SUPPLIER_TARIFF` (`tariff`),
  CONSTRAINT `FK_SUPPLIER_ACCOUNT` FOREIGN KEY (`account`) REFERENCES `account` (`id`),
  CONSTRAINT `FK_SUPPLIER_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_SUPPLIER_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`),
  CONSTRAINT `FK_SUPPLIER_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`),
  CONSTRAINT `FK_SUPPLIER_TARIFF` FOREIGN KEY (`tariff`) REFERENCES `tariff` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Proveedores';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `supplier`
--

LOCK TABLES `supplier` WRITE;
/*!40000 ALTER TABLE `supplier` DISABLE KEYS */;
/*!40000 ALTER TABLE `supplier` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `survey`
--

DROP TABLE IF EXISTS `survey`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `survey` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `scope` int(4) NOT NULL COMMENT 'Identificador del Ambito',
  `active` tinyint(1) NOT NULL COMMENT 'Indica si el Cuestionario esta activa o no',
  `creationDate` datetime NOT NULL COMMENT 'Fecha de creacion del Cuestionario',
  `description` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion del Cuestionario',
  PRIMARY KEY (`id`),
  KEY `IDX_SURVEY_DOMAIN` (`domain`),
  KEY `IDX_SURVEY_SCOPE` (`scope`),
  CONSTRAINT `FK_SURVEY_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_SURVEY_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Cuestionarios';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `survey`
--

LOCK TABLES `survey` WRITE;
/*!40000 ALTER TABLE `survey` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `survey_question`
--

DROP TABLE IF EXISTS `survey_question`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `survey_question` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `survey` int(4) NOT NULL COMMENT 'Identificador del Cuestionario',
  `question` int(4) NOT NULL COMMENT 'Identificador de la Pregunta',
  `position` int(11) DEFAULT NULL COMMENT 'Posicion de la Pregunta dentro del Cuestionario',
  PRIMARY KEY (`id`),
  KEY `IDX_SURVEY_QUESTION_QUESTION` (`question`),
  KEY `IDX_SURVEY_QUESTION_SURVEY` (`survey`),
  KEY `IDX_SURVEY_QUESTION_DOMAIN` (`domain`),
  CONSTRAINT `FK_SURVEY_QUESTION_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_SURVEY_QUESTION_QUESTION` FOREIGN KEY (`question`) REFERENCES `question` (`id`),
  CONSTRAINT `FK_SURVEY_QUESTION_SURVEY` FOREIGN KEY (`survey`) REFERENCES `survey` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Preguntas de Cuestionarios';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `survey_question`
--

LOCK TABLES `survey_question` WRITE;
/*!40000 ALTER TABLE `survey_question` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey_question` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `survey_response`
--

DROP TABLE IF EXISTS `survey_response`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `survey_response` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `creationDate` datetime NOT NULL COMMENT 'Fecha de la creacion en el sistema de la Respuesta del Cuestionario',
  `response_date` datetime NOT NULL COMMENT 'Fecha de la Respuesta del Cuestionario',
  `survey` int(4) NOT NULL COMMENT 'Identificador del Cuestionario',
  `registry` int(4) NOT NULL COMMENT 'Identificador del Registro que responde al Cuestionario',
  `user` int(4) DEFAULT NULL COMMENT 'Identificador del Usuario',
  `campaign_action` int(4) DEFAULT NULL COMMENT 'Identificador de la Accion de la Campaña',
  PRIMARY KEY (`id`),
  KEY `IDX_SURVEY_RESPONSE_MK_ACTION` (`campaign_action`),
  KEY `IDX_SURVEY_RESPONSE_SURVEY` (`survey`),
  KEY `IDX_SURVEY_RESPONSE_USER` (`user`),
  KEY `IDX_SURVEY_RESPONSE_DOMAIN` (`domain`),
  KEY `IDX_SURVEY_RESPONSE_REGISTRY` (`registry`),
  CONSTRAINT `FK_SURVEY_RESPONSE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_SURVEY_RESPONSE_MK_ACTION` FOREIGN KEY (`campaign_action`) REFERENCES `mk_action` (`id`),
  CONSTRAINT `FK_SURVEY_RESPONSE_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`),
  CONSTRAINT `FK_SURVEY_RESPONSE_SURVEY` FOREIGN KEY (`survey`) REFERENCES `survey` (`id`),
  CONSTRAINT `FK_SURVEY_RESPONSE_USER` FOREIGN KEY (`user`) REFERENCES `user` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Respuestas de Cuestionarios';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `survey_response`
--

LOCK TABLES `survey_response` WRITE;
/*!40000 ALTER TABLE `survey_response` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey_response` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `survey_response_detail`
--

DROP TABLE IF EXISTS `survey_response_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `survey_response_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `value_text` varchar(1024) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Valor de tipo texto',
  `value_number` double(15,3) DEFAULT NULL COMMENT 'Valor de tipo numerico',
  `value_date` datetime DEFAULT NULL COMMENT 'Valor de tipo fecha',
  `question` int(4) NOT NULL COMMENT 'Identificador de la Pregunta',
  `surveyResponse` int(4) NOT NULL COMMENT 'Identificador de la Respuesta del Cuestionario',
  PRIMARY KEY (`id`),
  KEY `IDX_SURVEY_RESPONSE_DETAIL_QUESTION` (`question`),
  KEY `IDX_SURVEY_RESPONSE_DETAIL_SURVEY_RESPONSE` (`surveyResponse`),
  KEY `IDX_SURVEY_RESPONSE_DETAIL_DOMAIN` (`domain`),
  CONSTRAINT `FK_SURVEY_RESPONSE_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_SURVEY_RESPONSE_DETAIL_QUESTION` FOREIGN KEY (`question`) REFERENCES `question` (`id`),
  CONSTRAINT `FK_SURVEY_RESPONSE_DETAIL_SURVEY_RESPONSE` FOREIGN KEY (`surveyResponse`) REFERENCES `survey_response` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalles de Respuestas de Cuestionarios';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `survey_response_detail`
--

LOCK TABLES `survey_response_detail` WRITE;
/*!40000 ALTER TABLE `survey_response_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey_response_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `survey_workflow`
--

DROP TABLE IF EXISTS `survey_workflow`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `survey_workflow` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `questionValue` int(4) DEFAULT NULL COMMENT 'Identificador del Valor de la Pregunta',
  `surveyQuestion` int(4) NOT NULL COMMENT 'Identificador de la Pregunta del Cuestionario',
  `nextSurveyQuestion` int(4) NOT NULL COMMENT 'Identificador de la siguiente Pregunta del Cuestionario',
  `operator` tinyint(2) DEFAULT NULL COMMENT 'Operador a utilizar con el Valor',
  `value_text` varchar(1024) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Valor de tipo texto',
  `value_number` double(15,3) DEFAULT NULL COMMENT 'Valor de tipo numerico',
  `value_date` datetime DEFAULT NULL COMMENT 'Valor de tipo fecha',
  PRIMARY KEY (`id`),
  KEY `IDX_SURVEY_WORKFLOW_NEXT_SURVEY_QUESTION` (`nextSurveyQuestion`),
  KEY `IDX_SURVEY_WORKFLOW_QUESTION_VALUE` (`questionValue`),
  KEY `IDX_SURVEY_WORKFLOW_SURVEY_QUESTION` (`surveyQuestion`),
  KEY `IDX_SURVEY_WORKFLOW_DOMAIN` (`domain`),
  CONSTRAINT `FK_SURVEY_WORKFLOW_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_SURVEY_WORKFLOW_NEXT_SURVEY_QUESTION` FOREIGN KEY (`nextSurveyQuestion`) REFERENCES `survey_question` (`id`),
  CONSTRAINT `FK_SURVEY_WORKFLOW_QUESTION_VALUE` FOREIGN KEY (`questionValue`) REFERENCES `question_value` (`id`),
  CONSTRAINT `FK_SURVEY_WORKFLOW_SURVEY_QUESTION` FOREIGN KEY (`surveyQuestion`) REFERENCES `survey_question` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Secuencias de Cuestionarios';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `survey_workflow`
--

LOCK TABLES `survey_workflow` WRITE;
/*!40000 ALTER TABLE `survey_workflow` DISABLE KEYS */;
/*!40000 ALTER TABLE `survey_workflow` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `system_cost`
--

DROP TABLE IF EXISTS `system_cost`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `system_cost` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `start_date` date NOT NULL COMMENT 'Fecha de inicio ',
  `end_date` date DEFAULT NULL COMMENT 'Fecha de finalizacion',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion',
  `expression` text COLLATE latin1_spanish_ci COMMENT 'Expresion',
  `type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de Costo',
  `code` varchar(10) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Código',
  PRIMARY KEY (`id`),
  KEY `IDX_SYSTEM_COST_DOMAIN` (`domain`),
  CONSTRAINT `FK_SYSTEM_COST_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=9744 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Costos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `system_cost`
--

LOCK TABLES `system_cost` WRITE;
/*!40000 ALTER TABLE `system_cost` DISABLE KEYS */;
INSERT INTO `system_cost` VALUES (9599,0,'2010-01-01',NULL,'23.60 %','BASE_CGC_E * PORCENTAJE_CGC_E/100',0,'CGC_E'),(9600,0,'2010-01-01',NULL,'12.00 %','BASE_ESTR * PORCENTAJE_EXTR_E/100',4,'EXTR_E'),(9601,0,'2010-01-01',NULL,'23.60 %','BASE_NESTR * PORCENTAJE_NEXTR_E/100',5,'NEXTR_E'),(9602,0,'2010-01-01',NULL,'@{PORCENTAJE_IT} %','BASE_CGP_E * (isdef PORCENTAJE_IT ? PORCENTAJE_IT : (PORCENTAJE_IT=( isdef OCUPACION ? OCUPACION_IT[OCUPACION] : TARIFA_IT)))/100',1,'IT_E'),(9603,0,'2010-01-01',NULL,'@{PORCENTAJE_IMS} %','BASE_CGP_E * (isdef PORCENTAJE_IMS ? PORCENTAJE_IMS : (PORCENTAJE_IMS=( isdef OCUPACION ? OCUPACION_IMS[OCUPACION] : TARIFA_IMS)))/100',1,'IMS_E'),(9604,0,'2010-01-01','2013-12-31','@{PORCENTAJE_DESMPL_E} %','(PORCENTAJE_DESMPL == 0) ? 0.00 : ( BASE_CGP_E * ( isdef PORCENTAJE_DESMPL_E ? PORCENTAJE_DESMPL_E : PORCENTAJE_DESMPL_E=(INDEFINIDO ? 5.50 : (TIEMPO_COMPLETO ? 6.70 : 7.70)))/100)',2,'DESMPL_E'),(9605,0,'2010-01-01',NULL,'@ {PORCENTAJE_FOGASA} %','BASE_CGP_E * PORCENTAJE_FOGASA / 100',10,'FOGASA_E'),(9606,0,'2010-01-01',NULL,'0.60 %','BASE_CGP_E * PORCENTAJE_FP_E/100',3,'FP_E'),(9607,0,'2010-01-01',NULL,'36.00 %','CONTRATO_CORTA_DURACION ? ( CGC_E * PORCENTAJE_CORTA_DURACION / 100 ) : null',0,'CGC_E_TEMP'),(9609,0,'1970-01-01',NULL,'PREST. A.T y E.P',' NOMINA ? ( -1 * DIAS_ENFERMEDAD_PROFESIONAL * BASE_REGULADORA * 0.75 ) : REMOVE()',8,'ATEP_E'),(9676,0,'2014-01-01',NULL,'@{PORCENTAJE_DESMPL_E} %','( BASE_CGP_E * ( isdef PORCENTAJE_DESMPL_E ? PORCENTAJE_DESMPL_E : PORCENTAJE_DESMPL_E=(INDEFINIDO ? 5.50 : 6.70 ))/100)',2,'DESMPL_E'),(9677,-101,'2014-01-01','2014-12-31','Contingencias Comunes','BASE_CGC_E * PORCENTAJE_CGC_E/100',0,'CGC_E'),(9678,-101,'2014-01-01','2014-12-31','IT ','BASE_CGP_E * (isdef PORCENTAJE_IT ? PORCENTAJE_IT : (PORCENTAJE_IT=( isdef OCUPACION ? OCUPACION_IT[OCUPACION] : TARIFA_IT)))/100',1,'IT_E'),(9679,-101,'2014-01-01','2014-12-31','IMS ','SI(BASE_CGP > 0.00, 1.85,0.00)',1,'IMS_E'),(9681,-101,'2014-01-01','2014-12-31','Formación Profesional','SI(BASE_CGP > 0.00, 1.12,0.00)',3,'FP_E'),(9682,-101,'2014-01-01','2014-12-31','FOGASA ','SI(BASE_CGP > 0.00, 2.32,0.00)',10,'FOGASA_E'),(9683,-107,'2014-01-01',NULL,'Contingencias Comunes','BASE_CGC_E * PORCENTAJE_CGC_E/100',0,'CGC_E'),(9684,-107,'2014-01-01',NULL,'I.T, R.E y R.L, MATERNIDAD y PATERNIDAD','-1 * DIAS_ENFERMEDAD_PROFESIONAL * BASE_REGULADORA * 0.75',8,'ATEP_E'),(9685,-107,'2014-01-01',NULL,'Accidentes de Trabajo y Enfermedades Profesionales','-1 * DIAS_ENFERMEDAD_PROFESIONAL * BASE_REGULADORA * 0.75',8,'ATEP_E'),(9686,-101,'2015-01-01','2015-12-31','Contingencias Comunes','SI(BASE_CGC > 0.00, 30.67,0.00)',0,'CGC_E'),(9687,-101,'2015-01-01','2015-12-31','IT ','SI(BASE_CGP > 0.00, 2.36,0.00)',1,'IT_E'),(9688,-101,'2015-01-01','2015-12-31','IMS ','SI(BASE_CGP > 0.00, 1.86,0.00)',1,'IMS_E'),(9689,-101,'2015-01-01','2015-12-31','FOGASA ','SI(BASE_CGP > 0.00, 2.33,0.00)',10,'FOGASA_E'),(9691,-101,'2015-01-01','2015-12-31','Formación Profesional','SI(BASE_CGP > 0.00, 1.13,0.00)',3,'FP_E'),(9692,0,'2010-01-01',NULL,'PREST. IT A CARGO DEL INSS',' NOMINA ? ( -1 * DIAS_ENFERMEDAD_COMUN_16_20 * BASE_REGULADORA * 0.60  ) : REMOVE()',8,'ECSS_E'),(9693,0,'2010-01-01',NULL,'PREST. IT A CARGO DEL INSS',' NOMINA ? ( -1 * DIAS_ENFERMEDAD_COMUN_21 * BASE_REGULADORA * 0.75  ) : REMOVE()',8,'ECSS_E'),(9694,-105,'2015-01-01','2015-12-31','Contingencias Comunes','SI(BASE_CGC > 0.00, 30.67,0.00)',0,'CGC_E'),(9695,-105,'2015-01-01','2015-12-31','IT ','2.36',1,'IT_E'),(9696,-105,'2015-01-01','2015-12-31','IMS ','1.86',1,'IMS_E'),(9697,-105,'2015-01-01',NULL,'CGC _TEMP','REMOVE()',0,'CGC_E_TEMP'),(9698,-105,'2015-01-01',NULL,'Desempleo','REMOVE()',2,'DESMPL_E'),(9699,-105,'2015-01-01',NULL,'Formación Profesional','REMOVE()',3,'FP_E'),(9700,-105,'2015-01-01',NULL,'FOGASA ','REMOVE()',3,'FOGASA_E'),(9710,-101,'2016-01-01','2016-12-31','Contingencias Comunes','SI(BASE_CGC > 0.00, 30.98,0.00)',0,'CGC_E'),(9711,-101,'2016-01-01',NULL,'IT ','SI(BASE_CGP > 0.00, 2.38,0.00)',1,'IT_E'),(9712,-101,'2016-01-01',NULL,'IMS ','SI(BASE_CGP > 0.00, 1.88,0.00)',1,'IMS_E'),(9714,-101,'2016-01-01','2016-12-31','FOGASA ','SI(BASE_CGP > 0.00, 2.35,0.00)',10,'FOGASA_E'),(9715,-101,'2016-01-01','2016-12-31','Formación Profesional','SI(BASE_CGP > 0.00, 1.14,0.00)',3,'FP_E'),(9716,-105,'2016-01-01','2016-12-31','Contingencias Comunes','SI(BASE_CGC > 0.00, 30.98,0.00)',0,'CGC_E'),(9717,-105,'2016-01-01',NULL,'IT ','2.38',1,'IT_E'),(9718,-105,'2016-01-01',NULL,'IMS ','1.88',1,'IMS_E'),(9740,-101,'2017-01-01',NULL,'Contingencias Comunes','SI(BASE_CGC > 0.00, 33.46,0.00)',0,'CGC_E'),(9741,-101,'2017-01-01',NULL,'FOGASA','SI(BASE_CGP > 0.00, 2.54,0.00)',10,'FOGASA_E'),(9742,-101,'2017-01-01',NULL,'Formación Profesional','SI(BASE_CGP > 0.00, 1.23,0.00)',3,'FP_E'),(9743,-105,'2017-01-01',NULL,'Contingencias Comunes','SI(BASE_CGC > 0.00, 33.46,0.00)',0,'CGC_E');
/*!40000 ALTER TABLE `system_cost` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `system_data`
--

DROP TABLE IF EXISTS `system_data`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `system_data` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(32) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre',
  `expression` text COLLATE latin1_spanish_ci COMMENT 'Expresion',
  `start_date` date NOT NULL COMMENT 'Fecha de inicio ',
  `end_date` date DEFAULT NULL COMMENT 'Fecha de finalizacion',
  `read_only` tinyint(1) DEFAULT NULL COMMENT 'Modificable',
  `comments` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Comentario de ayuda',
  PRIMARY KEY (`id`),
  KEY `IDX_SYSTEM_DATA_DOMAIN` (`domain`),
  CONSTRAINT `FK_SYSTEM_DATA_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=24817 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Contexto de las funciones';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `system_data`
--

LOCK TABLES `system_data` WRITE;
/*!40000 ALTER TABLE `system_data` DISABLE KEYS */;
INSERT INTO `system_data` VALUES (527,0,'BASE_CGC_MIN','[	\"01\":\"TIEMPO_COMPLETO ? 1031.70 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 6.22 * HORAS_NOMINA), \"02\":\"TIEMPO_COMPLETO ? 855.90 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 5.16 * HORAS_NOMINA), \"03\":\"TIEMPO_COMPLETO ? 744.60 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 4.49 * HORAS_NOMINA), \"04\":\"TIEMPO_COMPLETO ? 738.90 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 4.45 * HORAS_NOMINA), \"05\":\"TIEMPO_COMPLETO ? 738.90 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 4.45 * HORAS_NOMINA), \"06\":\"TIEMPO_COMPLETO ? 738.90 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 4.45 * HORAS_NOMINA), \"07\":\"TIEMPO_COMPLETO ? 738.90 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 4.45 * HORAS_NOMINA), \"08\":\"TIEMPO_COMPLETO ? 24.63 * DIAS_NOMINA : 4.45 * HORAS_NOMINA), \"09\":\"TIEMPO_COMPLETO ? 24.63 * DIAS_NOMINA : 4.45 * HORAS_NOMINA), \"10\":\"TIEMPO_COMPLETO ? 24.63 * DIAS_NOMINA : 4.45 * HORAS_NOMINA), \"11\":\"TIEMPO_COMPLETO ? 24.63 * DIAS_NOMINA : 4.45 * HORAS_NOMINA)][GRUPO_COTIZACION]','2010-01-01','2010-12-31',1,'Bases minimas'),(529,0,'BASE_CGC_MAX','[	\"01\":(3198.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) ), \"02\":(3198.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"03\":(3198.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"04\":(3198.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"05\":(3198.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"06\":(3198.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"07\":(3198.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"08\":(106.60 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA)), \"09\":(106.60 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA)), \"10\":(106.60 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA)), \"11\":(106.60 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA))][GRUPO_COTIZACION]','2010-01-01','2010-12-31',1,'Bases Máximas'),(531,0,'IPREM','516.90','2008-01-01',NULL,1,'Indicador Público de Renta de Efectos Múltiples (IPREM) '),(533,0,'IPREM','527.24','2009-01-01',NULL,1,'Indicador Público de Renta de Efectos Múltiples (IPREM) '),(535,0,'IPREM','531.51','2010-01-01',NULL,1,'Indicador Público de Renta de Efectos Múltiples (IPREM) '),(537,0,'IPREM','531.51','2011-01-01',NULL,1,'Indicador Público de Renta de Efectos Múltiples (IPREM) '),(539,0,'COTIZACION_IT','\"MENSUAL\"','2010-01-01',NULL,0,'Prorrateo de la cotización por incapacidad temporal'),(541,0,'BASE_CGC_MIN','[\"01\":(TIEMPO_COMPLETO ? 1045.20 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 6.30 * HORAS_NOMINA), \"02\":(TIEMPO_COMPLETO ? 867.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 5.22 * HORAS_NOMINA), \"03\":(TIEMPO_COMPLETO ? 754.20 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 4.55 * HORAS_NOMINA), \"04\":(TIEMPO_COMPLETO ? 748.20 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 4.51 * HORAS_NOMINA), \"05\":(TIEMPO_COMPLETO ? 748.20 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 4.51 * HORAS_NOMINA), \"06\":(TIEMPO_COMPLETO ? 748.20 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 4.51 * HORAS_NOMINA ), \"07\":(TIEMPO_COMPLETO ? 748.20 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 4.51 * HORAS_NOMINA), \"08\":(TIEMPO_COMPLETO ? 24.94 * DIAS_NOMINA : 4.51 * HORAS_NOMINA), \"09\":(TIEMPO_COMPLETO ? 24.94 * DIAS_NOMINA : 4.51 * HORAS_NOMINA), \"10\":(TIEMPO_COMPLETO ? 24.94 * DIAS_NOMINA : 4.51 * HORAS_NOMINA), \"11\":(TIEMPO_COMPLETO ? 24.94 * DIAS_NOMINA : 4.51 * HORAS_NOMINA)][GRUPO_COTIZACION]','2011-01-01','2012-12-31',1,'Bases mínimas'),(543,0,'BASE_CGC_MAX','[\"01\":(3230.10 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"02\":(3230.10 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"03\":(3230.10 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"04\":(3230.10 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"05\":(3230.10 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"06\":(3230.10 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"07\":(3230.10 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"08\":(107.67 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA)), \"09\":(107.67 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA)), \"10\":(107.67 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA)), \"11\":(107.67 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA))][GRUPO_COTIZACION]','2011-01-01','2011-12-31',1,'Bases Máximas'),(545,0,'BASE_CGP_MAX','3198.10 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)','2010-01-01','2010-12-31',0,'Tope Mínimo de cotización para Accidentes de Trabajo y Enfermedades Profesionales'),(547,0,'BASE_CGP_MIN','TIEMPO_COMPLETO ? 738.90 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 4.45 * HORAS_NOMINA','2010-01-01','2010-12-31',0,'Tope Máximo de cotización para Accidentes de Trabajo y Enfermedades Profesionales'),(549,0,'BASE_CGP_MAX','3230.10 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)','2011-01-01','2011-12-31',0,'Tope Mínimo de cotización para Accidentes de Trabajo y Enfermedades Profesionales'),(551,0,'BASE_CGP_MIN','TIEMPO_COMPLETO ? 748.20 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 4.51 * HORAS_NOMINA ','2011-01-01','2012-12-31',0,'Tope Máximo de cotización para Accidentes de Trabajo y Enfermedades Profesionales'),(553,0,'INGRESO_AC_EMPRESA','false','1979-01-01',NULL,0,'Ingreso a cuenta a cargo de la empresa'),(555,0,'SMI','633.30','2010-01-01',NULL,0,'Salario mínimo interprofesional'),(557,0,'SMI','641.40','2011-01-01',NULL,0,'Salario mínimo interprofesional'),(559,0,'MAX_EMBARGABLE','def(total_liquido){ MAX(((total_liquido - SMI) * 0.30),0)+MAX(((total_liquido - 2 * SMI ) * 0.20),0) + MAX((( total_liquido - 3 * SMI ) * 0.10),0) +MAX((( total_liquido - 4 * SMI ) * 0.15),0) + MAX((( total_liquido - 5 * SMI ) * 0.15),0)}','2000-01-01',NULL,0,'Máximo embargable'),(561,0,'BASE_IPREM','0.00','2000-01-01',NULL,1,'Base para los conceptos exentos de cotizacion (IPREM) '),(563,0,'BIPREM','0.00','2000-01-01',NULL,1,'Base para los conceptos exentos de cotizacion (IPREM) '),(565,0,'OCUPACION_IT',' [\"a\": 0.65, \"b\": 1.00, \"d\": 3.35, \"e\": 1.80, \"f\": 3.35, \"g\": 2.10, \"h\": 1.40]','2010-01-01',NULL,1,'Tarifas de primas para I.T'),(567,0,'OCUPACION_IMS',' [\"a\": 0.35, \"b\": 1.00, \"d\": 3.35, \"e\": 1.50, \"f\": 3.35, \"g\": 1.50, \"h\": 2.20]','2010-01-01',NULL,1,'Tarifas de primas para I.M.S'),(569,0,'IPREM','532.51','2012-01-01',NULL,1,'Indicador Público de Renta de Efectos Múltiples (IPREM)'),(571,0,'BASE_CGC_MAX','[\"01\":(3262.50 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"02\":(3262.50 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"03\":(3262.50 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"04\":(3262.50 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"05\":(3262.50 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"06\":(3262.50 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"07\":(3262.50 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"08\":(108.75 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA)), \"09\":(108.75 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA)), \"10\":(108.75 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA)), \"11\":(108.75 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA))][GRUPO_COTIZACION]','2012-01-01','2012-12-31',1,'Bases Máximas'),(573,0,'BASE_CGP_MAX','3262.50 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)','2012-01-01','2012-12-31',1,'Tope Mínimo de cotización para Accidentes de Trabajo y Enfermedades Profesionales'),(14534,0,'SMI','645.30','2013-01-01',NULL,0,'Salario minimo interprofesional'),(15045,0,'BASE_CGC_MAX','[\"01\":(3425.70 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"02\":(3425.70 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"03\":(3425.70 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"04\":(3425.70 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"05\":(3425.70 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"06\":(3425.70 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"07\":(3425.70 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"08\":(114.19 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA)), \"09\":(114.19 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA)), \"10\":(114.19 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA)), \"11\":(114.19 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA))][GRUPO_COTIZACION]','2013-01-01','2013-12-31',1,'Bases Máximas'),(24056,0,'KMS','UNDEFINED(\"KMS\")','2000-01-01',NULL,NULL,NULL),(24057,0,'DIES_PERNOCTA','UNDEFINED(\"DIAS_PERNOCTA\")','2000-01-01',NULL,NULL,NULL),(24058,0,'DIES_MANUTENCIO','UNDEFINED(\"DIAS_MANUTENCION\")','2000-01-01',NULL,NULL,NULL),(24061,0,'DIES_TREBALLATS','DIAS_TRABAJADOS','2000-01-01',NULL,NULL,NULL),(24118,0,'BASE_CGC_MIN','[\"01\":(TIEMPO_COMPLETO ? 1051.50 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 6.33 * HORAS_NOMINA), \"02\":(TIEMPO_COMPLETO ? 872.10 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 5.25 * HORAS_NOMINA), \"03\":(TIEMPO_COMPLETO ? 758.70 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 4.57 * HORAS_NOMINA), \"04\":(TIEMPO_COMPLETO ? 753.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 4.54 * HORAS_NOMINA), \"05\":(TIEMPO_COMPLETO ? 753.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 4.54 * HORAS_NOMINA), \"06\":(TIEMPO_COMPLETO ? 753.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 4.54 * HORAS_NOMINA), \"07\":(TIEMPO_COMPLETO ? 753.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 4.54 * HORAS_NOMINA), \"08\":(TIEMPO_COMPLETO ? 25.10 * DIAS_NOMINA : 4.54 * HORAS_NOMINA), \"09\":(TIEMPO_COMPLETO ? 25.10 * DIAS_NOMINA : 4.54 * HORAS_NOMINA), \"10\":(TIEMPO_COMPLETO ? 25.10 * DIAS_NOMINA : 4.54 * HORAS_NOMINA), \"11\":(TIEMPO_COMPLETO ? 25.10 * DIAS_NOMINA : 4.54 * HORAS_NOMINA)][GRUPO_COTIZACION]','2013-01-01',NULL,1,'Bases mínimas'),(24119,0,'HORAS_CONVENIO','40.00','2000-01-01',NULL,0,'Horas Semanales estándar'),(24121,0,'PORCENTAJE_FOGASA','0.20','2010-01-01',NULL,0,'Porcentaje FOGASA'),(24122,0,'DIAS_INDEMNIZACION_FIN','8','2011-01-01','2011-12-31',NULL,NULL),(24123,0,'DIAS_INDEMNIZACION_FIN','9','2012-01-01','2012-12-31',NULL,NULL),(24124,0,'DIAS_INDEMNIZACION_FIN','10','2013-01-01','2013-12-31',NULL,NULL),(24125,0,'DIAS_INDEMNIZACION_FIN','11','2014-01-01','2014-12-31',NULL,NULL),(24126,0,'DIAS_INDEMNIZACION_FIN','12','2015-01-01',NULL,NULL,NULL),(24133,0,'BONIFICACION_TARIFA_PLANA','CGC_E - ( ( COEFICIENTE_PARCIALIDAD == 1 ? 100 : (COEFICIENTE_PARCIALIDAD >= 0.75 ? 75 : (COEFICIENTE_PARCIALIDAD >= 0.5 ? 50 : 0) ) ) * DIAS_NOMINA / DIAS_MES)','2014-02-28',NULL,0,'Importe a Reducir en Contingencias Comunes de Empresa'),(24353,0,'EMBARGAR','def (embargo){ ( PENDIENTE = ( embargo - EMBARGADO ) ) > 0 ? MIN(MAX_EMBARGABLE(TOTAL_LIQUIDO), PENDIENTE ) : REMOVE()  }','2000-01-01',NULL,NULL,NULL),(24355,0,'BASE_CGC_MAX','[\"01\":(3597.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"02\":(3597.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"03\":(3597.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"04\":(3597.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"05\":(3597.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"06\":(3597.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"07\":(3597.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"08\":(119.90 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA)), \"09\":(119.90 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA)), \"10\":(119.90 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA)), \"11\":(119.90 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA))][GRUPO_COTIZACION]','2014-01-01',NULL,1,'Bases Máximas'),(24357,0,'BASE_CGP_MAX','3597.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)','2014-01-01',NULL,0,'Tope Máximo de cotización para Accidentes de Trabajo y Enfermedades Profesionales'),(24358,0,'BASE_CGP_MIN','TIEMPO_COMPLETO ? 753.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 4.54 * HORAS_NOMINA ','2013-01-01',NULL,0,'Tope Máximo de cotización para Accidentes de Trabajo y Enfermedades Profesionales'),(24359,0,'BASE_CGP_MAX','3425.70 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)','2013-01-01','2013-12-31',0,'Tope Máximo de cotización para Accidentes de Trabajo y Enfermedades Profesionales'),(24360,0,'PORCENTAJE_CGC','4.70','2010-01-01',NULL,0,'Porcentaje de contingencias comunes'),(24361,0,'PORCENTAJE_FP','0.10','2010-01-01',NULL,0,'Porcentaje de formacion profesional'),(24362,0,'PORCENTAJE_EXTR','2.00','2010-01-01',NULL,0,'Porcentaje horas extra'),(24363,0,'PORCENTAJE_NEXTR','4.70','2010-01-01',NULL,0,'Porcentaje horas extra no estructurales'),(24364,0,'PORCENTAJE_CGC_E','23.60','2010-01-01',NULL,0,'Porcentaje de contingencias comunes (Empresa)'),(24365,0,'PORCENTAJE_EXTR_E','12.00','2010-01-01',NULL,0,'Porcentaje horas extra (Empresa)'),(24366,0,'PORCENTAJE_NEXTR_E','23.60','2010-01-01',NULL,0,'Porcentaje horas extra no estructurales (Empresa)'),(24367,0,'PORCENTAJE_FP_E','0.60','2010-01-01',NULL,0,'Porcentaje de formacion profesional (Empresa)'),(24368,0,'PORCENTAJE_CORTA_DURACION','36.00','2010-01-01',NULL,0,'Porcentaje (Empresa)'),(24372,-106,'PORCENTAJE_CGC','3.95','2014-01-01','2014-12-31',1,NULL),(24373,-106,'PORCENTAJE_DESMPL','REMOVE()','2014-01-01',NULL,1,NULL),(24374,-106,'PORCENTAJE_FP','REMOVE()','2014-01-01',NULL,1,NULL),(24375,-106,'PORCENTAJE_EXTR','REMOVE()','2014-01-01',NULL,1,NULL),(24376,-106,'PORCENTAJE_NEXTR','REMOVE()','2014-01-01',NULL,1,NULL),(24377,-106,'PORCENTAJE_CGC_E','19.85','2014-01-01','2014-12-31',1,NULL),(24378,-106,'PORCENTAJE_IT','TARIFA_IT','2014-01-01',NULL,1,NULL),(24379,-106,'PORCENTAJE_IMS','TARIFA_IMS','2014-01-01',NULL,1,NULL),(24380,-106,'PORCENTAJE_FOGASA','REMOVE()','2014-01-01',NULL,1,NULL),(24381,-106,'PORCENTAJE_DESMPL_E','REMOVE()','2014-01-01',NULL,1,NULL),(24382,-106,'PORCENTAJE_FP_E','REMOVE()','2014-01-01',NULL,1,NULL),(24383,-106,'PORCENTAJE_EXTR_E','REMOVE()','2014-01-01',NULL,1,NULL),(24384,-106,'PORCENTAJE_NEXTR_E','REMOVE()','2014-01-01',NULL,1,NULL),(24385,-106,'BASE_CGC_MIN','($ in [[172.05,147.86],[268.80,244.62],[365.60,341.40],[462.40,438.17],[559.10,534.95],[655.90,631.73],[753.00,753.00],[Double.MAX_VALUE,790.65]] if $[0] >= BASE_CGC )[0][1]','2014-01-01','2014-12-31',1,NULL),(24386,-106,'BASE_CGC_MAX','BASE_CGC_MIN','2014-01-01',NULL,1,NULL),(24387,-106,'BASE_CGP_MIN','BASE_CGC_MIN','2014-01-01',NULL,1,NULL),(24388,-106,'BASE_CGP_MAX','BASE_CGC_MIN','2014-01-01',NULL,1,NULL),(24389,0,'SMI','648.60','2015-01-01','2015-12-31',0,'Salario mínimo interprofesional'),(24390,-107,'PORCENTAJE_EXTR','REMOVE()','2014-01-01',NULL,1,NULL),(24391,-107,'PORCENTAJE_NEXTR','REMOVE()','2014-01-01',NULL,1,NULL),(24392,-107,'PORCENTAJE_EXTR_E','REMOVE()','2014-01-01',NULL,1,NULL),(24393,-107,'PORCENTAJE_NEXTR_E','REMOVE()','2014-01-01',NULL,1,NULL),(24394,-107,'PORCENTAJE_CORTA_DURACION','REMOVE()','2014-01-01',NULL,1,NULL),(24395,-107,'COTIZACION_MENSUAL','true','2014-01-01',NULL,1,NULL),(24396,-107,'BASE_CGC_MIN_MES',' [\"01\":1051.50, \"02\":872.10, \"03\":758.70, \"04\":753.00, \"05\":753.00, \"06\":753.00, \"07\":753.00, \"08\":753.00, \"09\":753.00, \"10\":753.00, \"11\":753.00][GRUPO_COTIZACION] * ( DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30 )','2014-01-01','2015-12-31',1,NULL),(24397,-107,'BASE_CGC_MIN_DIA',' [\"01\":45.72, \"02\":37.92, \"03\":32.99, \"04\":32.74, \"05\":32.74, \"06\":32.74, \"07\":32.74, \"08\":32.74, \"09\":32.74, \"10\":32.74, \"11\":32.74][GRUPO_COTIZACION]  * JORNADAS_REALES','2014-01-01','2015-12-31',1,NULL),(24398,-107,'BASE_CGC_MIN','( COTIZACION_MENSUAL ) ? BASE_CGC_MIN_MES : BASE_CGC_MIN_DIA','2014-01-01',NULL,1,NULL),(24399,-107,'BASE_CGC_MAX_MES','2595.60 * ( DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30 )','2014-01-01','2015-12-31',1,NULL),(24400,-107,'BASE_CGC_MAX_DIA','112.85 * JORNADAS_REALES','2014-01-01','2015-12-31',1,NULL),(24401,-107,'BASE_CGC_MAX','( COTIZACION_MENSUAL || JORNADAS_REALES >= 23 ) ? BASE_CGC_MAX_MES : BASE_CGC_MAX_DIA','2014-01-01',NULL,1,NULL),(24402,-107,'REDUCCION_CGC_E_01','8.10','2014-01-01','2015-12-31',1,NULL),(24403,-107,'REDUCCION_CGC_E_02','COTIZACION_MENSUAL ? ((BASE_CGC_E <= 986.70) ? 6.50 : ((BASE_CGC_E <= 2595.60) ? (6.50 * ( 1 + (BASE_CGC_E - 986.70)/ BASE_CGC_E * 2.52 * 6.15 / 6.50)) : 0.00)) : ((BASE_CGC_E / JORNADAS_REALES <= 42.90) ? 6.50 : ((BASE_CGC_E / JORNADAS_REALES <= 112.85 )? (6.50 * ( 1 + (BASE_CGC_E / JORNADAS_REALES - 42.90) / ( BASE_CGC_E / JORNADAS_REALES ) * 2.52 * 6.15 / 6.50)) : 0.00))','2014-01-01','2014-12-31',1,NULL),(24404,-107,'PORCENTAJE_CGC_E','(GRUPO_COTIZACION == \"01\") ? (23.260 - REDUCCION_CGC_E_01) : (16.85 - REDUCCION_CGC_E_02)','2014-01-01','2014-12-31',1,NULL),(24405,-107,'PORCENTAJE_FOGASA','0.10','2014-01-01',NULL,1,NULL),(24406,-107,'PORCENTAJE_FP','0.03','2014-01-01',NULL,1,NULL),(24407,-107,'PORCENTAJE_FP_E','0.15','2014-01-01',NULL,1,NULL),(24408,0,'BASE_CGC_MIN','[ \"01\":(TIEMPO_COMPLETO ? 1056.90 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 6.37 * HORAS_NOMINA), \"02\":(TIEMPO_COMPLETO ? 876.60 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 5.28 * HORAS_NOMINA), \"03\":(TIEMPO_COMPLETO ? 762.60 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 4.59 * HORAS_NOMINA), \"04\":(TIEMPO_COMPLETO ? 756.60 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 4.56 * HORAS_NOMINA), \"05\":(TIEMPO_COMPLETO ? 756.60 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 4.56 * HORAS_NOMINA), \"06\":(TIEMPO_COMPLETO ? 756.60 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 4.56 * HORAS_NOMINA), \"07\":(TIEMPO_COMPLETO ? 756.60 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 4.56 * HORAS_NOMINA), \"08\":(TIEMPO_COMPLETO ? 25.22 * DIAS_NOMINA : 4.56 * HORAS_NOMINA), \"09\":(TIEMPO_COMPLETO ? 25.22 * DIAS_NOMINA : 4.56 * HORAS_NOMINA), \"10\":(TIEMPO_COMPLETO ? 25.22* DIAS_NOMINA : 4.56 * HORAS_NOMINA), \"11\":(TIEMPO_COMPLETO ? 25.22 * DIAS_NOMINA : 4.56 * HORAS_NOMINA) ] [GRUPO_COTIZACION]','2015-01-01','2015-12-31',1,'Bases mínimas'),(24409,0,'BASE_CGC_MAX','[ \"01\":(3606.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"02\":(3606.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"03\":(3606.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"04\":(3606.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"05\":(3606.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"06\":(3606.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"07\":(3606.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)), \"08\":(120.20 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA)), \"09\":(120.20 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA)), \"10\":(120.20 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA)), \"11\":(120.20 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA)) ] [GRUPO_COTIZACION]','2015-01-01','2015-12-31',1,'Bases MÃ¡ximas'),(24410,0,'BASE_CGP_MAX','3606.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)','2015-01-01','2015-12-31',0,'Tope MÃ¡ximo de cotizaciÃ³n para Accidentes de Trabajo y Enfermedades Profesionales'),(24411,0,'BASE_CGP_MIN','TIEMPO_COMPLETO ? 756.6000 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 4.56 * HORAS_NOMINA ','2015-01-01','2015-12-31',0,'Tope Má­nimo de cotización para Accidentes de Trabajo y Enfermedades Profesionales'),(24412,-106,'PORCENTAJE_CGC','4.10','2015-01-01','2015-12-31',1,NULL),(24413,-106,'PORCENTAJE_CGC_E','20.60','2015-01-01','2015-12-31',1,NULL),(24414,-106,'BASE_CGC_MIN','($ in [ [172.91,148.60], [270.10,245.84], [367.40,343.10], [464.70,440.36], [561.90,537.63], [658.40,634.89], [756.60,756.60], [Double.MAX_VALUE,794.60] ] if $[0] >= BASE_CGC )[0][1]','2015-01-01','2015-12-31',1,NULL),(24415,-107,'BASE_CGC_MIN_MES','[ \"01\":1056.90, \"02\":876.60, \"03\":762.60, \"04\":756.60, \"05\":756.60, \"06\":756.60, \"07\":756.60, \"08\":756.60, \"09\":756.60, \"10\":756.60, \"11\":756.60 ][GRUPO_COTIZACION] * ( DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30 )','2015-01-01',NULL,1,NULL),(24416,-107,'BASE_CGC_MAX_MES','3063.30 * ( DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30 )','2015-01-01',NULL,1,NULL),(24417,-107,'BASE_CGC_MIN_DIA','[ \"01\":45.95, \"02\":38.11, \"03\":33.16, \"04\":32.90, \"05\":32.90, \"06\":32.90, \"07\":32.90, \"08\":32.90, \"09\":32.90, \"10\":32.90, \"11\":32.90 ][GRUPO_COTIZACION]  * JORNADAS_REALES','2015-01-01',NULL,1,NULL),(24418,-107,'BASE_CGC_MAX_DIA','133.19 * JORNADAS_REALES','2015-01-01',NULL,1,NULL),(24494,-107,'REDUCCION_CGC_E_02','COTIZACION_MENSUAL ? ((BASE_CGC_E <= 986.70) ? 6.68 : ((BASE_CGC_E <= 3063.30) ? (6.68 * ( 1 + (BASE_CGC_E - 986.70)/ BASE_CGC_E * 2.52 * 6.15 / 6.68)) : 0.00)) : ((BASE_CGC_E / JORNADAS_REALES <= 42.90) ? 6.68 : ((BASE_CGC_E / JORNADAS_REALES <= 133.19 )? (6.68 * ( 1 + (BASE_CGC_E / JORNADAS_REALES - 42.90) / ( BASE_CGC_E / JORNADAS_REALES ) * 2.52 * 6.15 / 6.68)) : 0.00))','2015-01-01','2015-12-31',1,NULL),(24495,-107,'PORCENTAJE_CGC_E','(GRUPO_COTIZACION == \"01\") ? (23.60 - REDUCCION_CGC_E_01) : (17.30 -REDUCCION_CGC_E_02)','2015-01-01','2015-12-31',1,NULL),(24496,-8,'PORCENTAJE_ISFAS','1.69','2015-01-01',NULL,1,NULL),(24497,-8,'PORCENTAJE_DCHOS','3.86','2015-01-01',NULL,1,NULL),(24498,-9,'PORCENTAJE_MUFACE','1.69','2015-01-01',NULL,1,NULL),(24499,-9,'PORCENTAJE_DCHOS','3.86','2015-01-01',NULL,1,NULL),(24500,-8,'BASE_CGC_MIN','[ \"01\":2839.07, \"02\":2234.42, \"03\":1956.60, \"04\":1716.07, \"05\":1357.70, \"06\":1157.55 ][GRUPO_COTIZACION]','2015-01-01',NULL,1,NULL),(24501,-8,'BASE_CGC_MAX','BASE_CGC_MIN','2015-01-01',NULL,1,NULL),(24502,-8,'BASE_CGP_MIN','BASE_CGC_MIN','2015-01-01',NULL,1,NULL),(24503,-8,'BASE_CGP_MAX','BASE_CGC_MIN','2015-01-01',NULL,1,NULL),(24504,-9,'BASE_CGC_MIN','[ \"01\":2839.07, \"02\":2234.42, \"03\":1956.60, \"04\":1716.07, \"05\":1357.70, \"06\":1157.55 ][GRUPO_COTIZACION]','2015-01-01',NULL,1,NULL),(24505,-9,'BASE_CGC_MAX','BASE_CGC_MIN','2015-01-01',NULL,1,NULL),(24506,-9,'BASE_CGP_MIN','BASE_CGC_MIN','2015-01-01',NULL,1,NULL),(24507,-9,'BASE_CGP_MAX','BASE_CGC_MIN','2015-01-01',NULL,1,NULL),(24686,0,'DIAS_MES','[ \"01\":30, \"02\":30, \"03\":30, \"04\":30, \"05\":30, \"06\":30, \"07\":30, \"08\": DIAS_NATURALES_MES, \"09\": DIAS_NATURALES_MES, \"10\": DIAS_NATURALES_MES, \"11\": DIAS_NATURALES_MES][GRUPO_COTIZACION]','2015-01-01',NULL,0,NULL),(24687,0,'DIAS_PAGA','[ \"01\":30, \"02\":30, \"03\":30, \"04\":30, \"05\":30, \"06\":30, \"07\":30, \"08\": DIAS_NATURALES_MES, \"09\": DIAS_NATURALES_MES, \"10\": DIAS_NATURALES_MES, \"11\": DIAS_NATURALES_MES][GRUPO_COTIZACION]','2015-01-01',NULL,0,NULL),(24688,-3,'DIAS_PAGA','DIAS_NATURALES_MES','2015-01-01',NULL,NULL,NULL),(24689,-3,'DIAS_MES','DIAS_NATURALES_MES','2015-01-01',NULL,NULL,NULL),(24698,-106,'PORCENTAJE_CGC','4.25','2016-01-01','2016-12-31',1,NULL),(24701,-107,'BASE_CGC_MIN_MES',' [\n \"01\":1067.40\n,\"02\":885.30\n,\"03\":770.10\n,\"04\":764.40\n,\"05\":764.40\n,\"06\":764.40\n,\"07\":764.40\n,\"08\":764.40\n,\"09\":764.40\n,\"10\":764.40\n,\"11\":764.40][GRUPO_COTIZACION] * ( DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30 )','2016-01-01',NULL,1,NULL),(24708,0,'SMI','655.20','2016-01-01','2016-12-31',0,'SMI'),(24710,0,'BASE_CGC_MAX','[ \"01\":(3642.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)) ,\"02\":(3642.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)) ,\"03\":(3642.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)) ,\"04\":(3642.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)) ,\"05\":(3642.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)) ,\"06\":(3642.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)) ,\"07\":(3642.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)) ,\"08\":(121.40 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA)) ,\"09\":(121.40 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA)) ,\"10\":(121.40 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA)) ,\"11\":(121.40 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA))] [GRUPO_COTIZACION] ','2016-01-01','2016-12-31',1,'Bases MÃ¡ximas'),(24711,0,'BASE_CGP_MAX','3642.00 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)','2016-01-01','2016-12-31',0,'Tope MÃ¡ximo de cotizaciÃ³n para Accidentes de Trabajo y Enfermedades Profesionales'),(24713,-106,'PORCENTAJE_CGC','4.25','2016-01-01','2016-12-31',1,NULL),(24714,-106,'PORCENTAJE_CGC_E','21.35','2016-01-01','2016-12-31',1,NULL),(24716,-107,'BASE_CGC_MIN_MES',' [ \"01\":1067.40 ,\"02\":885.30 ,\"03\":770.10 ,\"04\":764.40 ,\"05\":764.40 ,\"06\":764.40 ,\"07\":764.40 ,\"08\":764.40 ,\"09\":764.40 ,\"10\":764.40 ,\"11\":764.40][GRUPO_COTIZACION] * ( DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30 )','2016-01-01',NULL,1,NULL),(24717,-107,'BASE_CGC_MAX_MES','3642.00 * ( DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30 )','2016-01-01',NULL,1,NULL),(24718,-107,'BASE_CGC_MIN_DIA','[ \"01\":46.41, \"02\":38.49, \"03\":33.48, \"04\":33.23, \"05\":33.23, \"06\":33.23, \"07\":33.23, \"08\":33.23, \"09\":33.23, \"10\":33.23, \"11\":33.23][GRUPO_COTIZACION]  * JORNADAS_REALES','2016-01-01',NULL,1,NULL),(24719,-107,'BASE_CGC_MAX_DIA','158.35 * JORNADAS_REALES','2016-01-01',NULL,1,NULL),(24720,-107,'REDUCCION_CGC_E_01','8.10','2016-01-01',NULL,1,NULL),(24721,-107,'REDUCCION_CGC_E_02','COTIZACION_MENSUAL ? ((BASE_CGC_E <= 986.70) ? 6.83 : ((BASE_CGC_E <= 3642.00) ? (6.83 * ( 1 + (BASE_CGC_E - 986.70)/ BASE_CGC_E * 2.52 * 6.15 / 6.83)) : 0.00)) : ((BASE_CGC_E / JORNADAS_REALES <= 42.90) ? 6.83 : ((BASE_CGC_E / JORNADAS_REALES <= 158.35)? (6.83 * ( 1 + (BASE_CGC_E / JORNADAS_REALES - 42.90) / ( BASE_CGC_E / JORNADAS_REALES ) * 2.52 * 6.15 / 6.83)) : 0.00))','2016-01-01','2016-12-31',1,NULL),(24722,-107,'PORCENTAJE_CGC_E','(GRUPO_COTIZACION == \"01\") ? (23.60 - REDUCCION_CGC_E_01) : (17.75 - REDUCCION_CGC_E_02)','2016-01-01','2016-12-31',1,NULL),(24725,-101,'DIAS_MES','30','2010-01-01',NULL,NULL,NULL),(24726,-105,'DIAS_MES','30','2010-01-01',NULL,NULL,NULL),(24736,-101,'PORCENTAJE_DESMPL','1.55','2014-01-01',NULL,NULL,NULL),(24737,-101,'PORCENTAJE_DESMPL_E','5.50','2014-01-01',NULL,NULL,NULL),(24738,-101,'BASE_CGP_MIN','753.00','2014-01-01','2014-12-31',NULL,NULL),(24739,-105,'BASE_CGP_MIN','753.00','2014-01-01','2014-12-31',NULL,NULL),(24740,-101,'BASE_CGP_MIN','756.60','2015-01-01','2015-12-31',NULL,NULL),(24741,-105,'BASE_CGP_MIN','756.60','2015-01-01','2015-12-31',NULL,NULL),(24744,-101,'BASE_CGC_MIN','BASE_CGP_MIN','2014-01-01',NULL,NULL,NULL),(24745,-105,'BASE_CGC_MIN','BASE_CGP_MIN','2014-01-01',NULL,NULL,NULL),(24746,-101,'BASE_CGP_MAX','BASE_CGP_MIN','2014-01-01',NULL,NULL,NULL),(24747,-105,'BASE_CGP_MAX','BASE_CGP_MIN','2014-01-01',NULL,NULL,NULL),(24748,-101,'BASE_CGC_MAX','BASE_CGP_MIN','2014-01-01',NULL,NULL,NULL),(24749,-105,'BASE_CGC_MAX','BASE_CGP_MIN','2014-01-01',NULL,NULL,NULL),(24750,0,'BASE_CGC_MIN','[ \"01\":(TIEMPO_COMPLETO ? 1067.40 * (DIAS_COTIZADOS == DIAS_MES ? 1 : DIAS_COTIZADOS/30) : 6.37 * HORAS_NOMINA) ,\"02\":(TIEMPO_COMPLETO ? 885.30 * (DIAS_COTIZADOS == DIAS_MES ? 1 : DIAS_COTIZADOS/30) : 5.33 * HORAS_NOMINA) ,\"03\":(TIEMPO_COMPLETO ? 770.10 * (DIAS_COTIZADOS == DIAS_MES ? 1 : DIAS_COTIZADOS/30) : 4.64 * HORAS_NOMINA) ,\"04\":(TIEMPO_COMPLETO ? 764.40 * (DIAS_COTIZADOS == DIAS_MES ? 1 : DIAS_COTIZADOS/30) : 4.60 * HORAS_NOMINA) ,\"05\":(TIEMPO_COMPLETO ? 764.40 * (DIAS_COTIZADOS == DIAS_MES ? 1 : DIAS_COTIZADOS/30) : 4.60 * HORAS_NOMINA) ,\"06\":(TIEMPO_COMPLETO ? 764.40 * (DIAS_COTIZADOS == DIAS_MES ? 1 : DIAS_COTIZADOS/30) : 4.60 * HORAS_NOMINA) ,\"07\":(TIEMPO_COMPLETO ? 764.40 * (DIAS_COTIZADOS == DIAS_MES ? 1 : DIAS_COTIZADOS/30) : 4.60 * HORAS_NOMINA) ,\"08\":(TIEMPO_COMPLETO ? 25.48 * DIAS_COTIZADOS : 4.60 * HORAS_NOMINA) ,\"09\":(TIEMPO_COMPLETO ? 25.48 * DIAS_COTIZADOS : 4.60 * HORAS_NOMINA) ,\"10\":(TIEMPO_COMPLETO ? 25.48 * DIAS_COTIZADOS : 4.60 * HORAS_NOMINA) ,\"11\":(TIEMPO_COMPLETO ? 25.48 * DIAS_COTIZADOS : 4.60 * HORAS_NOMINA)] [GRUPO_COTIZACION] ','2016-01-01','2016-12-31',1,'Bases mÃ­nimas'),(24751,0,'BASE_CGP_MIN','TIEMPO_COMPLETO ? 764.40 * (DIAS_COTIZADOS == DIAS_MES ? 1 : DIAS_COTIZADOS/30) : 4.60 * HORAS_NOMINA ','2016-01-01','2016-12-31',0,'Tope MÃ­nimo de cotizaciÃ³n para Accidentes de Trabajo y Enfermedades Profesionales'),(24754,-101,'BASE_CGP_MIN','764.40','2016-01-01',NULL,NULL,NULL),(24755,-105,'BASE_CGP_MIN','764.40','2016-01-01',NULL,NULL,NULL),(24756,0,'PAGA_EXTRA_HELP','\"Por favor, introduzca la cuant&iacute;a de la paga (bono), ejemplos:\n<ul style=\'margin-left:1em;\'>\n<li>\n	<a style=\'color:orange;\'>SALARIO_BASE + ANTIGUEDAD + PLUS_SALARIAL</a>&nbsp;\n	<span style=\'font-weight: lighter;\'>una mensualidad de salario base, plus convenio y antig&uuml;edad</span>\n</li>\n<li>\n	<a style=\'color:orange;\'>(SALARIO_BASE + ANTIGUEDAD + PLUS_SALARIAL)/12</a>&nbsp;\n	<span style=\'font-weight: lighter;\'>la paga arriba indicada pero en este caso prorrateada</span>\n</li>\n<li>\n	<a style=\'color:orange;\'>2000.00 * DIAS_TRABAJADOS / DIAS_MES</a>&nbsp;\n	<span style=\'font-weight: lighter;\'>2000&euro;</sppan>\n</li>\n</ul>\"','2010-01-01',NULL,NULL,NULL),(24757,0,'ANTIGUEDAD_HELP','\"Por favor, introduzca la cuant&iacute;a del complemento personal de antig&uuml;edad, ejemplos:\n<ul style=\'margin-left:1em;\'>\n<li>	\n	<a style=\'color:orange;\' >ANTIGÜEDAD(SALARIO_BASE * 0.04, CUATRIENIO)</a>&nbsp;\n	<span style=\'font-weight: lighter;\'>4 por 100 del salario base por cuatrienio</span>\n</li>\n<li>\n	<a style=\'color:orange;\'>ANTIGÜEDAD(SALARIO_BASE * 0.03, 6, 4, 4, 4)</a>\n	<span style=\'font-weight: lighter;\'>primer sexenio el 3% del salario y tres cuatrienios del 3% cada uno</span>\n</li>\n<li>	\n	<a style=\'color:orange;\'>MAX(ANTIGÜEDAD(SALARIO_BASE * 0.05, TRIENIO), SALARIO_BASE * 0.40)</a>&nbsp;\n	<span style=\'font-weight: lighter;\'>5% del salario por trienio, no podr&aacute; en ning&uacute;n caso, suponer\nm&aacute;s del 40%</span>\n</li>\n</ul>\"','2010-01-01',NULL,NULL,NULL),(24758,-107,'BASE_CGP_MIN_DIA','764.40 * JORNADAS_REALES / 30','2016-01-01',NULL,1,NULL),(24759,-107,'BASE_CGP_MIN_MES','( TIEMPO_COMPLETO ) ? 764.40 * ((DIAS_COTIZADOS == DIAS_MES) ? 1 : DIAS_COTIZADOS/30) : 4.60 * HORAS_NOMINA','2016-01-01',NULL,1,NULL),(24760,-107,'BASE_CGP_MIN','( COTIZACION_MENSUAL ) ? BASE_CGP_MIN_MES : BASE_CGP_MIN_DIA','2016-01-01',NULL,1,NULL),(24800,0,'SMI','707.70','2017-01-01',NULL,0,'SMI'),(24801,0,'BASE_CGC_MIN','[\n \"01\":(TIEMPO_COMPLETO ? 1152.90 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 6.95 * HORAS_NOMINA)\n,\"02\":(TIEMPO_COMPLETO ?  956.10 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 5.76 * HORAS_NOMINA)\n,\"03\":(TIEMPO_COMPLETO ?  831.60 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 5.01 * HORAS_NOMINA)\n,\"04\":(TIEMPO_COMPLETO ?  825.60 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 4.97 * HORAS_NOMINA)\n,\"05\":(TIEMPO_COMPLETO ?  825.60 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 4.97 * HORAS_NOMINA)\n,\"06\":(TIEMPO_COMPLETO ?  825.60 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 4.97 * HORAS_NOMINA)\n,\"07\":(TIEMPO_COMPLETO ?  825.60 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 4.97 * HORAS_NOMINA)\n,\"08\":(TIEMPO_COMPLETO ?   27.52 * DIAS_NOMINA : 4.97 * HORAS_NOMINA)\n,\"09\":(TIEMPO_COMPLETO ?   27.52 * DIAS_NOMINA : 4.97 * HORAS_NOMINA)\n,\"10\":(TIEMPO_COMPLETO ?   27.52 * DIAS_NOMINA : 4.97 * HORAS_NOMINA)\n,\"11\":(TIEMPO_COMPLETO ?   27.52 * DIAS_NOMINA : 4.97 * HORAS_NOMINA)]\n[GRUPO_COTIZACION]\n','2017-01-01',NULL,1,'Bases mínimas'),(24802,0,'BASE_CGC_MAX','[\n \"01\":(3751.20 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30))\n,\"02\":(3751.20 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30))\n,\"03\":(3751.20 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30))\n,\"04\":(3751.20 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30))\n,\"05\":(3751.20 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30))\n,\"06\":(3751.20 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30))\n,\"07\":(3751.20 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30))\n,\"08\":(125.04 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA))\n,\"09\":(125.04 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA))\n,\"10\":(125.04 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA))\n,\"11\":(125.04 * (DIAS_NOMINA > 30 ? 30 : DIAS_NOMINA))]\n[GRUPO_COTIZACION]\n','2017-01-01',NULL,1,'Bases Máximas'),(24803,0,'BASE_CGP_MAX','3751.20 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30)','2017-01-01',NULL,0,'Tope Máximo de cotización para Accidentes de Trabajo y Enfermedades Profesionales'),(24804,0,'BASE_CGP_MIN','TIEMPO_COMPLETO ? 825.60 * (DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30) : 4.97 * HORAS_NOMINA ','2017-01-01',NULL,0,'Tope Mínimo de cotización para Accidentes de Trabajo y Enfermedades Profesionales'),(24805,-106,'PORCENTAJE_CGC','4.40','2017-01-01',NULL,1,NULL),(24806,-106,'PORCENTAJE_CGC_E','22.10','2017-01-01',NULL,1,NULL),(24807,-106,'BASE_CGC_MIN','($ in [\n [188.61,161.29],\n [294.60,266.84],\n [400.80,372.39],\n [506.80,477.96],\n [612.90,583.52],\n [718.20,689.09],\n [825.65,825.60], [Double.MAX_VALUE,862.44] ] if $[0] >= BASE_CGC )[0][1]','2017-01-01',NULL,1,NULL),(24808,-107,'BASE_CGC_MIN_MES',' [\n \"01\":1152.90\n,\"02\":956.10\n,\"03\":831.60\n,\"04\":825.60\n,\"05\":825.60\n,\"06\":825.60\n,\"07\":825.60\n,\"08\":825.60\n,\"09\":825.60\n,\"10\":825.60\n,\"11\":825.60][GRUPO_COTIZACION] * ( DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30 )','2017-01-01',NULL,1,NULL),(24809,-107,'BASE_CGC_MAX_MES','3751.20 * ( DIAS_NOMINA == DIAS_MES ? 1 : DIAS_NOMINA/30 )','2017-01-01',NULL,1,NULL),(24810,-107,'BASE_CGC_MIN_DIA','[\n \"01\":50.13,\n \"02\":41.57,\n \"03\":36.16,\n \"04\":35.90,\n \"05\":35.90,\n \"06\":35.90,\n \"07\":35.90,\n \"08\":35.90,\n \"09\":35.90,\n \"10\":35.90,\n \"11\":35.90][GRUPO_COTIZACION]  * JORNADAS_REALES','2017-01-01',NULL,1,NULL),(24811,-107,'BASE_CGC_MAX_DIA','163.10 * JORNADAS_REALES','2017-01-01',NULL,1,NULL),(24812,-107,'REDUCCION_CGC_E_01','8.10','2017-01-01',NULL,1,NULL),(24813,-107,'REDUCCION_CGC_E_02','COTIZACION_MENSUAL ? ((BASE_CGC <= 986.70) ? 6.97 : ((BASE_CGC <= 3751.20) ? (6.97 * ( 1 + (BASE_CGC - 986.70)/ BASE_CGC * 2.52 * 6.15 / 6.97)) : 0.00)) : ((BASE_CGC / JORNADAS_REALES <= 42.90) ? 6.97 : ((BASE_CGC / JORNADAS_REALES <= 163.10)? (6.97 * ( 1 + (BASE_CGC / JORNADAS_REALES - 42.90) / ( BASE_CGC / JORNADAS_REALES ) * 2.52 * 6.15 / 6.97)) : 0.00))','2017-01-01',NULL,1,NULL),(24814,-107,'PORCENTAJE_CGC_E','(GRUPO_COTIZACION == \"01\") ? (23.60 - REDUCCION_CGC_E_01) : (17.30 - REDUCCION_CGC_E_02)','2017-01-01',NULL,1,NULL),(24815,-101,'BASE_CGP_MIN','825.60','2017-01-01',NULL,NULL,NULL),(24816,-105,'BASE_CGP_MIN','825.60','2017-01-01',NULL,NULL,NULL);
/*!40000 ALTER TABLE `system_data` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `system_deduction`
--

DROP TABLE IF EXISTS `system_deduction`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `system_deduction` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de Deducción',
  `deduction_concept` int(4) DEFAULT NULL COMMENT 'Identificador unico del concepto',
  `description` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion',
  `description_decorable` tinyint(2) NOT NULL DEFAULT '0',
  `expression` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Fórmula',
  `start_date` date NOT NULL COMMENT 'Fecha de inicio ',
  `end_date` date DEFAULT NULL COMMENT 'Fecha de finalizacion',
  `month` tinyint(2) DEFAULT NULL COMMENT 'Mes de la deducción',
  PRIMARY KEY (`id`),
  KEY `IDX_SYSTEM_DEDUCTION_DEDUCTION_CONCEPT` (`deduction_concept`),
  KEY `IDX_SYSTEM_DEDUCTION_DOMAIN` (`domain`),
  CONSTRAINT `FK_SYSTEM_DEDUCTION_DEDUCTION_CONCEPT` FOREIGN KEY (`deduction_concept`) REFERENCES `deduction_concept` (`id`),
  CONSTRAINT `FK_SYSTEM_DEDUCTION_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5343 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Deducciones';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `system_deduction`
--

LOCK TABLES `system_deduction` WRITE;
/*!40000 ALTER TABLE `system_deduction` DISABLE KEYS */;
INSERT INTO `system_deduction` VALUES (139,0,NULL,6299,'4.70 %',1,'BASE_CGC * PORCENTAJE_CGC/100','2010-01-01',NULL,NULL),(141,0,NULL,6301,'@{PORCENTAJE_DESMPL} %',1,'BASE_CGP * ( isdef PORCENTAJE_DESMPL ? PORCENTAJE_DESMPL : PORCENTAJE_DESMPL=(INDEFINIDO ? 1.55 : 1.60 ))/100','2010-01-01',NULL,NULL),(143,0,NULL,6302,'0.10 %',1,'BASE_CGP * PORCENTAJE_FP/100','2010-01-01',NULL,NULL),(145,0,NULL,6303,'2.00 %',1,'BASE_ESTR * PORCENTAJE_EXTR/100','2010-01-01',NULL,NULL),(147,0,NULL,6304,'4.70 %',1,'BASE_NESTR * PORCENTAJE_NEXTR/100','2010-01-01',NULL,NULL),(149,0,NULL,6305,'@{PORCENTAJE_IRPF} %',1,'BASE_IRPF * PORCENTAJE_IRPF/100','2010-01-01',NULL,NULL),(5299,-101,NULL,6299,NULL,0,'SI(BASE_CGC > 0.00, 6.09,0.00)','2014-01-01','2014-12-31',NULL),(5301,-101,NULL,6302,NULL,0,'SI(BASE_CGP > 0.00, 0.15,0.00)','2014-01-01','2016-12-31',NULL),(5302,-3,NULL,6305,'@{PORCENTAJE_IRPF} %',0,'BASE_IRPF * PORCENTAJE_IRPF/100','2010-01-01',NULL,NULL),(5303,-101,NULL,6299,NULL,0,'SI(BASE_CGC > 0.00, 6.12,0.00)','2015-01-01','2015-12-31',NULL),(5305,-8,10,NULL,'Instituto Social de las Fuerzas Armadas (ISFAS)',0,'BASE_CGC * PORCENTAJE_ISFAS / 100.00','2015-01-01',NULL,NULL),(5306,-9,10,NULL,'Administración Civil del Estado (MUFACE)',0,'BASE_CGC * PORCENTAJE_MUFACE / 100.00','2015-01-01',NULL,NULL),(5307,-8,10,NULL,'Cuota de Derechos Pasivos',0,'BASE_CGC * PORCENTAJE_DCHOS / 100.00','2015-01-01',NULL,NULL),(5308,-9,10,NULL,'Cuota de Derechos Pasivos',0,'BASE_CGC * PORCENTAJE_DCHOS / 100.00','2015-01-01',NULL,NULL),(5309,-8,NULL,6305,'@{PORCENTAJE_IRPF} %',0,'BASE_IRPF * PORCENTAJE_IRPF/100','2010-01-01',NULL,NULL),(5310,-9,NULL,6305,'@{PORCENTAJE_IRPF} %',0,'BASE_IRPF * PORCENTAJE_IRPF/100','2010-01-01',NULL,NULL),(5312,-105,NULL,6299,NULL,0,'SI(BASE_CGC > 0.00, 6.12,0.00)','2015-01-01','2015-12-31',NULL),(5313,-105,NULL,6301,NULL,0,'REMOVE()','2015-01-01',NULL,NULL),(5314,-105,NULL,6302,NULL,0,'REMOVE()','2015-01-01',NULL,NULL),(5315,-101,NULL,6299,NULL,0,'SI(BASE_CGC > 0.00, 6.18,0.00)','2016-01-01','2016-12-31',NULL),(5316,-105,NULL,6299,NULL,0,'SI(BASE_CGC > 0.00, 6.18,0.00)','2016-01-01','2016-12-31',NULL),(5322,-101,NULL,6302,NULL,0,'SI(BASE_CGP > 0.00, 0.15,0.00)','2014-01-01','2016-12-31',NULL),(5340,-101,NULL,6299,NULL,0,'SI(BASE_CGC > 0.00, 6.67,0.00)','2017-01-01',NULL,NULL),(5341,-105,NULL,6299,NULL,0,'SI(BASE_CGC > 0.00, 6.67,0.00)','2017-01-01',NULL,NULL),(5342,-101,NULL,6302,NULL,0,'SI(BASE_CGP > 0.00, 0.16,0.00)','2017-01-01',NULL,NULL);
/*!40000 ALTER TABLE `system_deduction` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `system_payment`
--

DROP TABLE IF EXISTS `system_payment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `system_payment` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de Percepción Salarial',
  `payment_concept` int(4) DEFAULT NULL COMMENT 'Identificador unico del concepto',
  `description` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion',
  `description_decorable` tinyint(2) NOT NULL DEFAULT '0',
  `expression` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Importe',
  `irpf_expression` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Importe tributable',
  `quote_expression` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Importe cotizable',
  `start_date` date NOT NULL COMMENT 'Fecha de inicio',
  `month` tinyint(2) DEFAULT NULL COMMENT 'Mes de la percepcion',
  `end_date` date DEFAULT NULL COMMENT 'Fecha de finalizacion',
  `salary_type` tinyint(2) DEFAULT NULL COMMENT 'Tipo de Nomina/Recibo',
  PRIMARY KEY (`id`),
  KEY `IDX_SYSTEM_PAYMENT_PAYMENT_CONCEPT` (`payment_concept`),
  KEY `IDX_SYSTEM_PAYMENT_DOMAIN` (`domain`),
  CONSTRAINT `FK_SYSTEM_PAYMENT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_SYSTEM_PAYMENT_PAYMENT_CONCEPT` FOREIGN KEY (`payment_concept`) REFERENCES `payment_concept` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5899 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Percepciones Salariales';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `system_payment`
--

LOCK TABLES `system_payment` WRITE;
/*!40000 ALTER TABLE `system_payment` DISABLE KEYS */;
INSERT INTO `system_payment` VALUES (5876,0,NULL,6196,'INDEMNIZACION POR CESE',0,'(CAUSA_INDEMNIZACION == FIN) ? DIAS_INDEMNIZACION_FIN(FIN_CONTRATO) * AÑOS_TRABAJADOS * SALARIO_DIA : REMOVE()',NULL,NULL,'2011-01-01',NULL,NULL,2),(5877,0,NULL,6196,'INDEMNIZACION POR DESPIDO IMPROCEDENTE (< 13 DE FEBRERO DE 2012)',0,'(CAUSA_INDEMNIZACION == IMPROCEDENTE) ? MIN(45 * AÑOS_TRABAJADOS * SALARIO_DIA,SALARIO_DIA * 365 / 12 * 42 ): REMOVE()',NULL,NULL,'2010-01-01',NULL,'2012-03-12',2),(5878,0,NULL,6196,'INDEMNIZACION POR DESPIDO IMPROCEDENTE (>= 13 DE FEBRERO DE 2012)',0,'(CAUSA_INDEMNIZACION==IMPROCEDENTE)?MIN(33*AÑOS_TRABAJADOS*SALARIO_DIA,ABS(SALARIO_DIA*365/12*24-INDEMNIZACION)):REMOVE()',NULL,NULL,'2012-02-13',NULL,NULL,2),(5879,0,NULL,6196,'INDEMNIZACION POR DESPIDO POR CAUSAS OBJETIVAS',0,'(CAUSA_INDEMNIZACION == PROCEDENTE ) ? MIN(20 * AÑOS_TRABAJADOS * SALARIO_DIA, SALARIO_DIA * 365 / 12 * 12 ) : REMOVE()',NULL,NULL,'2010-01-01',NULL,NULL,2),(5880,0,NULL,6213,NULL,0,'DIAS_VACACIONES_NO_DISFRUTADOS * ( SALARIO_DIA + SALARIO_VARIABLE_DIA )',NULL,NULL,'2010-01-01',NULL,NULL,2),(5881,0,NULL,6274,NULL,0,'MAX((15 - DIAS_PREAVISO),0) * ( SALARIO_DIA + SALARIO_VARIABLE_DIA )',NULL,NULL,'2010-01-01',NULL,NULL,2),(5882,0,NULL,6196,'INDEMNIZACION POR FIN DE OBRA',0,'(CAUSA_INDEMNIZACION == FIN_OBRA) ? DIAS_INDEMNIZACION_FIN(INICIO_CONTRATO) * AÑOS_TRABAJADOS * SALARIO_DIA : REMOVE()',NULL,NULL,'2011-01-01',NULL,NULL,2),(5883,0,NULL,6196,'INDEMNIZACION POR FIN DE CONTRATO TEMPORAL',0,'(CAUSA_INDEMNIZACION == FIN_TEMPORAL) ? DIAS_INDEMNIZACION_FIN(INICIO_CONTRATO) * AÑOS_TRABAJADOS * SALARIO_DIA : REMOVE()',NULL,NULL,'2011-01-01',NULL,NULL,2),(5884,0,NULL,6196,'INDEMNIZACION POR BAJA VOLUNTARIA',0,'(CAUSA_INDEMNIZACION == CAMBIO_CONDICIONES ) ? MIN(20 * AÑOS_TRABAJADOS * SALARIO_DIA, SALARIO_DIA * 365 / 12 * 12 ) : REMOVE()',NULL,NULL,'2010-01-01',NULL,NULL,2),(5886,-107,NULL,114,'',0,'REMOVE()',NULL,NULL,'2014-01-01',NULL,NULL,0),(5887,0,NULL,6255,'PREST. POR ENFERMEDAD COMÚN',0,'DIAS_ENFERMEDAD_COMUN_1_3 * 0.00 * BASE_REGULADORA',NULL,'DIAS_COTIZADOS * BASE_REGULADORA','2010-01-01',NULL,NULL,0),(5888,0,NULL,6255,'PREST. POR ENFERMEDAD COMÚN A CARGO DE LA EMPRESA',0,'DIAS_ENFERMEDAD_COMUN_4_15 * BASE_REGULADORA * 0.60','_P','DIAS_COTIZADOS * BASE_REGULADORA','2010-01-01',NULL,NULL,0),(5889,0,NULL,6255,'PREST. POR ENFERMEDAD COMÚN A CARGO DEL INSS',0,'DIAS_ENFERMEDAD_COMUN_16_20 * BASE_REGULADORA * 0.60','_P','DIAS_COTIZADOS * BASE_REGULADORA','2010-01-01',NULL,NULL,0),(5890,0,NULL,6255,'PREST. POR ENFERMEDAD COMÚN A CARGO DEL INSS',0,'DIAS_ENFERMEDAD_COMUN_21 * BASE_REGULADORA * 0.75','_P','DIAS_COTIZADOS * BASE_REGULADORA','2010-01-01',NULL,NULL,0),(5891,0,NULL,6255,'PREST. POR ACCIDENTE DE TRABAJO Y/O ENFERMEDAD PROFESIONAL',0,'DIAS_ENFERMEDAD_PROFESIONAL * BASE_REGULADORA * 0.75','_P','DIAS_COTIZADOS * BASE_REGULADORA','2010-01-01',NULL,NULL,0),(5892,0,NULL,6269,'PREST. POR PATERNIDAD',0,'DIAS_PATERNIDAD * 0.00',NULL,'DIAS_COTIZADOS * (isdef COEFICIENTE_PATERNIDAD ? COEFICIENTE_PATERNIDAD : 1.00) * BASE_REGULADORA','2010-01-01',NULL,NULL,0),(5893,0,NULL,6269,'PREST. POR MATERNIDAD Y/O RIESGO DURANTE EL EMBARAZO',0,'DIAS_MATERNIDAD * 0.00',NULL,'DIAS_COTIZADOS * (isdef COEFICIENTE_MATERNIDAD ? COEFICIENTE_MATERNIDAD : 1.00) * BASE_REGULADORA','2010-01-01',NULL,NULL,0),(5894,0,1,6270,'EXPDTE. REGULARIZACIÓN DE EMPLEO',0,NULL,NULL,'DIAS_ERE * BASE_REGULADORA','2010-01-01',NULL,NULL,1),(5895,0,NULL,NULL,'PREST. POR ENFERMEDAD COMÃ?N PAGO DIRECTO',0,'DIAS_ENFERMEDAD_COMUN_366 * 0.00',NULL,'DIAS_COTIZADOS * BASE_REGULADORA','2010-01-01',NULL,NULL,0),(5896,0,NULL,NULL,'PREST. POR A.T Y/O E.P PAGO DIRECTO',0,'DIAS_ENFERMEDAD_PROFESIONAL_366 * 0.00',NULL,'DIAS_COTIZADOS * BASE_REGULADORA','2010-01-01',NULL,NULL,0),(5897,-101,NULL,6213,NULL,0,'DIAS_VACACIONES_NO_DISFRUTADOS * ( SALARIO_DIA + SALARIO_VARIABLE_DIA )',NULL,'0.00','2010-01-01',NULL,NULL,2),(5898,-105,NULL,6213,NULL,0,'DIAS_VACACIONES_NO_DISFRUTADOS * ( SALARIO_DIA + SALARIO_VARIABLE_DIA )',NULL,'0.00','2010-01-01',NULL,NULL,2);
/*!40000 ALTER TABLE `system_payment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tag`
--

DROP TABLE IF EXISTS `tag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tag` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre de la Etiqueta',
  `type` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Tipo de Etiqueta',
  `color` varchar(24) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Color de la Etiqueta',
  PRIMARY KEY (`id`),
  KEY `IDX_TAG_DOMAIN` (`domain`),
  CONSTRAINT `FK_TAG_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2403 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Etiquetas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tag`
--

LOCK TABLES `tag` WRITE;
/*!40000 ALTER TABLE `tag` DISABLE KEYS */;
INSERT INTO `tag` VALUES (-1065,0,'C. AUTÓNOMA DE LAS CANARIAS',0,NULL),(-1064,0,'EUSKADI',0,NULL),(-1063,0,'C. AUTÓNOMA DE ARAGÓN',0,NULL),(-1062,0,'C. AUTÓNOMA DE CEUTA',0,NULL),(-1061,0,'C. AUTÓNOMA DE ANDALUCÍA',0,NULL),(-1060,0,'C. AUTÓNOMA DE MELILLA',0,NULL),(-1059,0,'HUELVA',0,NULL),(-1058,0,'SANTA CRUZ DE TENERIFE',0,NULL),(-1057,0,'C. AUTÓNOMA DE CASTILLA-LEÓN',0,NULL),(-1056,0,'CÁDIZ',0,NULL),(-1055,0,'GALICIA',0,NULL),(-1054,0,'LUGO',0,NULL),(-1053,0,'C. AUTÓNOMA DE EXTREMADURA',0,NULL),(-1052,0,'LLEIDA',0,NULL),(-1051,0,'PONTEVEDRA',0,NULL),(-1050,0,'ORENSE',0,NULL),(-1049,0,'LA CORUÑA',0,NULL),(-1048,0,'BADAJOZ',0,NULL),(-1047,0,'CÁCERES',0,NULL),(-1046,0,'ZAMORA',0,NULL),(-1045,0,'JAÉN',0,NULL),(-1044,0,'ALMERÍA',0,NULL),(-1043,0,'GRANADA',0,NULL),(-1042,0,'HUESCA',0,NULL),(-1041,0,'TERUEL',0,NULL),(-1040,0,'ALBACETE',0,NULL),(-1039,0,'GIRONA',0,NULL),(-1038,0,'ÁLAVA',0,NULL),(-1037,0,'TARRAGONA',0,NULL),(-1036,0,'GUIPUZCOA',0,NULL),(-1035,0,'CÓRDOBA',0,NULL),(-1034,0,'CASTELLÓN',0,NULL),(-1033,0,'CIUDAD REAL',0,NULL),(-1032,0,'CATALUÑA',0,NULL),(-1031,0,'ALICANTE',0,NULL),(-1030,0,'C. AUTONOMA DE VALENCIA',0,NULL),(-1029,0,'C. AUTÓNOMA DE ASTURIAS',0,NULL),(-1028,0,'SALAMANCA',0,NULL),(-1027,0,'LEÓN',0,NULL),(-1026,0,'VIZCAYA',0,NULL),(-1025,0,'MÁLAGA',0,NULL),(-1024,0,'ZARAGOZA',0,NULL),(-1023,0,'SEVILLA',0,NULL),(-1022,0,'C. AUTÓNOMA DE NAVARRA',0,NULL),(-1021,0,'C. AUTÓNOMA DE MURCIA',0,NULL),(-1020,0,'LAS PALMAS',0,NULL),(-1019,0,'CUENCA',0,NULL),(-1018,0,'C. AUTÓNOMA DE BALEARES',0,NULL),(-1017,0,'TOLEDO',0,NULL),(-1016,0,'GUADALAJARA',0,NULL),(-1015,0,'VALLADOLID',0,NULL),(-1014,0,'C. AUTÓNOMA DE CASTILLA-LA MANCHA',0,NULL),(-1013,0,'SORIA',0,NULL),(-1012,0,'SEGOVIA',0,NULL),(-1011,0,'C. AUTÓNOMA DE LA RIOJA',0,NULL),(-1010,0,'PALENCIA',0,NULL),(-1009,0,'C. AUTÓNOMA CÁNTABRA',0,NULL),(-1008,0,'BURGOS',0,NULL),(-1007,0,'ÁVILA',0,NULL),(-1006,0,'VALENCIA',0,NULL),(-1005,0,'BARCELONA',0,NULL),(-1004,0,'INTERPROVINCIALES Y PROVINCIALES',0,NULL),(-1003,0,'C. AUTÓNOMA DE MADRID',0,NULL),(-1002,0,'AUTONÓMICOS',0,NULL),(-1001,0,'ESPAÑA',0,NULL),(-1000,0,'NACIONALES',0,NULL),(1972,0,'OPEN',6,NULL),(1973,0,'REOPEN',6,NULL),(1974,0,'CLOSED',6,NULL),(1975,0,'DUPLICATED',6,NULL),(2401,0,'MODIFIED',6,NULL),(2402,0,'FAQ',6,NULL);
/*!40000 ALTER TABLE `tag` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `target`
--

DROP TABLE IF EXISTS `target`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `target` (
  `registry` int(4) NOT NULL DEFAULT '0' COMMENT 'Registro del Cliente Potencial',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `tariff` int(4) DEFAULT NULL COMMENT 'Tarifa asociada al Cliente Potencial',
  `advertising` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Admision de Publicidad',
  `surcharge` tinyint(1) DEFAULT '0' COMMENT 'Indica si el Cliente Potencial tiene recargo de equivalencia',
  `withholding` tinyint(1) DEFAULT '0' COMMENT 'Indica si el Cliente Potencial aplica retencion de impuestos',
  `transaction` tinyint(2) DEFAULT '0' COMMENT 'Tipo de transacciones del Cliente Potencial',
  `status` tinyint(2) DEFAULT '0' COMMENT 'Estado del Cliente Potencial',
  `scope` int(4) NOT NULL DEFAULT '1' COMMENT 'Identificador del Ambito',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`registry`),
  KEY `IDX_TARGET_TARIFF` (`tariff`),
  KEY `IDX_TARGET_SCOPE` (`scope`),
  KEY `IDX_TARGET_DOMAIN` (`domain`),
  CONSTRAINT `FK_TARGET_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_TARGET_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`),
  CONSTRAINT `FK_TARGET_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`),
  CONSTRAINT `FK_TARGET_TARIFF` FOREIGN KEY (`tariff`) REFERENCES `tariff` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Clientes Potenciales';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `target`
--

LOCK TABLES `target` WRITE;
/*!40000 ALTER TABLE `target` DISABLE KEYS */;
/*!40000 ALTER TABLE `target` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tariff`
--

DROP TABLE IF EXISTS `tariff`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tariff` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la Tarifa',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `code` varchar(8) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo de la Tarifa',
  `name` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre de la Tarifa',
  `purchase` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Indica si se trata de una Tarifa de Compras o Ventas',
  `discount` double(6,2) DEFAULT '0.00' COMMENT 'Descuento general de la Tarifa',
  `active` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'Indica si la Tarifa esta activa o no',
  PRIMARY KEY (`id`),
  KEY `IDX_TARIFF_DOMAIN` (`domain`),
  CONSTRAINT `FK_TARIFF_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Tarifas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tariff`
--

LOCK TABLES `tariff` WRITE;
/*!40000 ALTER TABLE `tariff` DISABLE KEYS */;
/*!40000 ALTER TABLE `tariff` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tariff_addinfo`
--

DROP TABLE IF EXISTS `tariff_addinfo`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tariff_addinfo` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `tariff` int(4) NOT NULL COMMENT 'Identificador de la Tarifa',
  `attribute` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Atributo adicional',
  `value` varchar(128) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Valor del atributo adicional',
  `value_date` date NOT NULL COMMENT 'Fecha del valor del atributo',
  PRIMARY KEY (`id`),
  KEY `IDX_TARIFF_ADDINFO_DOMAIN` (`domain`),
  KEY `IDX_TARIFF_ADDINFO_TARIFF` (`tariff`),
  CONSTRAINT `FK_TARIFF_ADDINFO_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_TARIFF_ADDINFO_TARIFF` FOREIGN KEY (`tariff`) REFERENCES `tariff` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Informacion adicional de la Tarifa';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tariff_addinfo`
--

LOCK TABLES `tariff_addinfo` WRITE;
/*!40000 ALTER TABLE `tariff_addinfo` DISABLE KEYS */;
/*!40000 ALTER TABLE `tariff_addinfo` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tariff_catalogue`
--

DROP TABLE IF EXISTS `tariff_catalogue`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tariff_catalogue` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `tariff` int(4) NOT NULL COMMENT 'Identificador de la Tarifa',
  `catalogue` int(4) NOT NULL COMMENT 'Identificador del Catalogo',
  PRIMARY KEY (`id`),
  KEY `IDX_TARIFF_CATALOGUE_TARIFF` (`tariff`),
  KEY `IDX_TARIFF_CATALOGUE_CATALOGUE` (`catalogue`),
  KEY `IDX_TARIFF_CATALOGUE_DOMAIN` (`domain`),
  CONSTRAINT `FK_TARIFF_CATALOGUE_CATALOGUE` FOREIGN KEY (`catalogue`) REFERENCES `catalogue` (`id`),
  CONSTRAINT `FK_TARIFF_CATALOGUE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_TARIFF_CATALOGUE_TARIFF` FOREIGN KEY (`tariff`) REFERENCES `tariff` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Tarifas por Catalogo';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tariff_catalogue`
--

LOCK TABLES `tariff_catalogue` WRITE;
/*!40000 ALTER TABLE `tariff_catalogue` DISABLE KEYS */;
/*!40000 ALTER TABLE `tariff_catalogue` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tas_item`
--

DROP TABLE IF EXISTS `tas_item`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tas_item` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Articulo',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `model` int(4) NOT NULL COMMENT 'Identificador del Modelo',
  `publicCode` varchar(25) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Codigo publico del Articulo',
  `privateCode` varchar(25) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo privado del Articulo',
  `description` varchar(255) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Descripcion del Articulo',
  `add_info` varchar(255) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Informacion adicional del Articulo',
  PRIMARY KEY (`id`),
  UNIQUE KEY `IDX_UNQ_TAS_ITEM_DOMAIN_PUBLIC_CODE` (`domain`,`publicCode`),
  UNIQUE KEY `IDX_UNQ_TAS_ITEM_DOMAIN_PRIVATE_CODE` (`domain`,`privateCode`),
  KEY `IDX_TAS_ITEM_MODEL` (`model`),
  KEY `IDX_TAS_ITEM_DOMAIN` (`domain`),
  CONSTRAINT `FK_TAS_ITEM_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_TAS_ITEM_MODEL` FOREIGN KEY (`model`) REFERENCES `model` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Articulo susceptible de Asistencia Tecnica';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tas_item`
--

LOCK TABLES `tas_item` WRITE;
/*!40000 ALTER TABLE `tas_item` DISABLE KEYS */;
/*!40000 ALTER TABLE `tas_item` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `task`
--

DROP TABLE IF EXISTS `task`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `task` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico de la Tarea',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `number` int(4) DEFAULT NULL COMMENT 'Numero de la Tarea',
  `description` varchar(128) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion de la Tarea',
  `start_date` datetime NOT NULL COMMENT 'Fecha de inicio de la Tarea',
  `end_date` datetime DEFAULT NULL COMMENT 'Fecha de finalizacion de la Tarea',
  `due_date` datetime DEFAULT NULL COMMENT 'Fecha de vencimiento de la Tarea',
  `priority` tinyint(2) DEFAULT '0' COMMENT 'Prioridad de la Tarea',
  `status` tinyint(2) DEFAULT '0' COMMENT 'Estado de la Tarea',
  `percent` tinyint(2) DEFAULT '0' COMMENT 'Porcentaje de realizacion de la Tarea',
  `task_holder` int(4) DEFAULT NULL COMMENT 'Identificador del Usuario asociado a la Tarea',
  `workgroup` int(4) DEFAULT NULL COMMENT 'Identificador del Grupo de Trabajo asociado a la Tarea',
  `source` tinyint(2) DEFAULT NULL COMMENT 'Origen de la Tarea',
  `source_id` int(4) DEFAULT NULL COMMENT 'Identificador del source',
  `project` int(4) DEFAULT NULL COMMENT 'Identificador del Expediente',
  `registry` int(4) DEFAULT NULL,
  `activity_type` int(4) DEFAULT NULL COMMENT 'Identificador de la Actividad',
  `sender` int(4) DEFAULT NULL COMMENT 'Remitente de la Tarea',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios de la Tarea',
  `repeat_period` tinyint(2) DEFAULT '0' COMMENT 'Periodo de repeticion de la Tarea',
  `gtask_id` varchar(100) COLLATE latin1_spanish_ci DEFAULT NULL,
  `gtasklist_id` varchar(100) COLLATE latin1_spanish_ci DEFAULT NULL,
  `parent` int(4) DEFAULT NULL COMMENT 'Task parent',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion de la Tarea',
  PRIMARY KEY (`id`),
  KEY `IDX_TASK_ACTIVITY_TYPE` (`activity_type`),
  KEY `IDX_TASK_PROJECT` (`project`),
  KEY `IDX_TASK_REGISTRY` (`registry`),
  KEY `IDX_TASK_SENDER` (`sender`),
  KEY `IDX_TASK_TASK_HOLDER` (`task_holder`),
  KEY `IDX_TASK_WORKGROUP` (`workgroup`),
  KEY `IDX_TASK_DOMAIN` (`domain`),
  CONSTRAINT `FK_TASK_ACTIVITY_TYPE` FOREIGN KEY (`activity_type`) REFERENCES `activity_type` (`id`),
  CONSTRAINT `FK_TASK_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_TASK_PROJECT` FOREIGN KEY (`project`) REFERENCES `project` (`id`),
  CONSTRAINT `FK_TASK_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`),
  CONSTRAINT `FK_TASK_SENDER` FOREIGN KEY (`sender`) REFERENCES `task_holder` (`registry`),
  CONSTRAINT `FK_TASK_TASK_HOLDER` FOREIGN KEY (`task_holder`) REFERENCES `task_holder` (`registry`),
  CONSTRAINT `FK_TASK_WORKGROUP` FOREIGN KEY (`workgroup`) REFERENCES `workgroup` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Tareas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `task`
--

LOCK TABLES `task` WRITE;
/*!40000 ALTER TABLE `task` DISABLE KEYS */;
/*!40000 ALTER TABLE `task` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `task_comment`
--

DROP TABLE IF EXISTS `task_comment`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `task_comment` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `task` int(4) NOT NULL COMMENT 'Identificador de la tarea',
  `comment` text COLLATE latin1_spanish_ci COMMENT 'Comentario de la Tarea',
  `source` int(4) DEFAULT NULL COMMENT 'Origen del comentario',
  `source_id` int(4) DEFAULT NULL COMMENT 'Identificador del origen',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_TASK_COMMENT_DOMAIN` (`domain`),
  KEY `IDX_TASK_COMMENT_TASK` (`task`),
  CONSTRAINT `FK_TASK_COMMENT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_TASK_COMMENT_TASK` FOREIGN KEY (`task`) REFERENCES `task` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Relacion entre Tareas y Comentarios';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `task_comment`
--

LOCK TABLES `task_comment` WRITE;
/*!40000 ALTER TABLE `task_comment` DISABLE KEYS */;
/*!40000 ALTER TABLE `task_comment` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `task_event`
--

DROP TABLE IF EXISTS `task_event`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `task_event` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `task` int(4) NOT NULL COMMENT 'Identificador de la tarea',
  `event` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Evento de la Tarea',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_TASK_EVENT_DOMAIN` (`domain`),
  KEY `IDX_TASK_EVENT_TASK` (`task`),
  CONSTRAINT `FK_TASK_EVENT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_TASK_EVENT_TASK` FOREIGN KEY (`task`) REFERENCES `task` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Relacion entre Tareas y Eventos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `task_event`
--

LOCK TABLES `task_event` WRITE;
/*!40000 ALTER TABLE `task_event` DISABLE KEYS */;
/*!40000 ALTER TABLE `task_event` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `task_holder`
--

DROP TABLE IF EXISTS `task_holder`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `task_holder` (
  `registry` int(4) NOT NULL DEFAULT '0' COMMENT 'Registro de la Entidad susceptible de Recibir Tareas',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `type` tinyint(2) DEFAULT '0' COMMENT 'Tipo de Entidad susceptible de Recibir Tareas',
  `active` tinyint(1) DEFAULT '1' COMMENT 'Indica si dicha Entidad esta activa o no',
  `user_id` int(4) DEFAULT NULL COMMENT 'Identificador del Usuario',
  `cost_profile` int(4) DEFAULT NULL COMMENT 'Identificador del Perfil de Costos',
  PRIMARY KEY (`registry`),
  KEY `IDX_TASK_HOLDER_COST_PROFILE` (`cost_profile`),
  KEY `IDX_TASK_HOLDER_USER` (`user_id`),
  KEY `IDX_TASK_HOLDER_DOMAIN` (`domain`),
  CONSTRAINT `FK_TASK_HOLDER_COST_PROFILE` FOREIGN KEY (`cost_profile`) REFERENCES `cost_profile` (`id`),
  CONSTRAINT `FK_TASK_HOLDER_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_TASK_HOLDER_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`),
  CONSTRAINT `FK_TASK_HOLDER_USER` FOREIGN KEY (`user_id`) REFERENCES `user` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Titulares de Tareas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `task_holder`
--

LOCK TABLES `task_holder` WRITE;
/*!40000 ALTER TABLE `task_holder` DISABLE KEYS */;
/*!40000 ALTER TABLE `task_holder` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `task_holder_workgroup`
--

DROP TABLE IF EXISTS `task_holder_workgroup`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `task_holder_workgroup` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `task_holder` int(4) NOT NULL COMMENT 'Identificador del Responsable de la Tarea',
  `workgroup` int(4) NOT NULL COMMENT 'Identificador del Grupo de Trabajo',
  PRIMARY KEY (`id`),
  KEY `IDX_TASK_HOLDER_WORKGROUP_TASK_HOLDER` (`task_holder`),
  KEY `IDX_TASK_HOLDER_WORKGROUP_WORKGROUP` (`workgroup`),
  KEY `IDX_TASK_HOLDER_WORKGROUP_DOMAIN` (`domain`),
  CONSTRAINT `FK_TASK_HOLDER_WORKGROUP_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_TASK_HOLDER_WORKGROUP_TASK_HOLDER` FOREIGN KEY (`task_holder`) REFERENCES `task_holder` (`registry`),
  CONSTRAINT `FK_TASK_HOLDER_WORKGROUP_WORKGROUP` FOREIGN KEY (`workgroup`) REFERENCES `workgroup` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Relacion entre Usuarios y Grupos de Trabajo';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `task_holder_workgroup`
--

LOCK TABLES `task_holder_workgroup` WRITE;
/*!40000 ALTER TABLE `task_holder_workgroup` DISABLE KEYS */;
/*!40000 ALTER TABLE `task_holder_workgroup` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `task_tag`
--

DROP TABLE IF EXISTS `task_tag`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `task_tag` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `task` int(4) NOT NULL COMMENT 'Identificador de la tarea',
  `tag` int(4) NOT NULL COMMENT 'Identificador de la Etiqueta',
  PRIMARY KEY (`id`),
  KEY `IDX_TASK_TAG_DOMAIN` (`domain`),
  KEY `IDX_TASK_TAG_TASK` (`task`),
  KEY `IDX_TASK_TAG_TAG` (`tag`),
  CONSTRAINT `FK_TASK_TAG_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_TASK_TAG_TAG` FOREIGN KEY (`tag`) REFERENCES `tag` (`id`),
  CONSTRAINT `FK_TASK_TAG_TASK` FOREIGN KEY (`task`) REFERENCES `task` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Relacion entre Tareas y Etiquetas';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `task_tag`
--

LOCK TABLES `task_tag` WRITE;
/*!40000 ALTER TABLE `task_tag` DISABLE KEYS */;
/*!40000 ALTER TABLE `task_tag` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tax`
--

DROP TABLE IF EXISTS `tax`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tax` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Impuesto',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(30) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre del Impuesto',
  `tax_type` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Tipo de Impuesto',
  `percentage` double(15,3) NOT NULL DEFAULT '0.000' COMMENT 'Porcentaje de recargo actual',
  `surcharge` double(15,3) DEFAULT '0.000' COMMENT 'Porcentaje de recargo de equivalencia actual',
  `start_date` date DEFAULT NULL COMMENT 'Fecha de inicio de vigencia',
  `vat_deduction_type` tinyint(2) DEFAULT '0' COMMENT 'Tipo de deduccion del IVA',
  `withholding_type` tinyint(2) DEFAULT '0' COMMENT 'Tipo de retencion',
  `sales_account` int(4) DEFAULT NULL COMMENT 'Identificador de la Cuenta Contable de Ventas',
  `purchase_account` int(4) DEFAULT NULL COMMENT 'Identificador de la Cuenta Contable de Compras',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_TAX_DOMAIN` (`domain`),
  KEY `IDX_TAX_ACCOUNT_SALES` (`sales_account`),
  KEY `IDX_TAX_ACCOUNT_PURCHASE` (`purchase_account`),
  CONSTRAINT `FK_TAX_ACCOUNT_PURCHASE` FOREIGN KEY (`purchase_account`) REFERENCES `account` (`id`),
  CONSTRAINT `FK_TAX_ACCOUNT_SALES` FOREIGN KEY (`sales_account`) REFERENCES `account` (`id`),
  CONSTRAINT `FK_TAX_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=15351 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Impuestos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tax`
--

LOCK TABLES `tax` WRITE;
/*!40000 ALTER TABLE `tax` DISABLE KEYS */;
INSERT INTO `tax` VALUES (15341,8776,'GENERAL',1,21.000,5.200,'2012-09-01',0,0,NULL,NULL,NULL,NULL,NULL,NULL),(15342,8776,'REDUCIDO',1,10.000,1.400,'2012-09-01',0,0,NULL,NULL,NULL,NULL,NULL,NULL),(15343,8776,'SUPERREDUCIDO',1,4.000,0.500,'2000-01-01',0,0,NULL,NULL,NULL,NULL,NULL,NULL),(15344,8776,'SIN IVA',1,0.000,0.000,'2000-01-01',0,0,NULL,NULL,NULL,NULL,NULL,NULL),(15345,8776,'IRPF',2,19.000,0.000,'2015-01-01',0,0,NULL,NULL,NULL,NULL,NULL,NULL),(15346,8779,'GENERAL',1,21.000,5.200,'2012-09-01',0,0,NULL,NULL,NULL,NULL,NULL,NULL),(15347,8779,'REDUCIDO',1,10.000,1.400,'2012-09-01',0,0,NULL,NULL,NULL,NULL,NULL,NULL),(15348,8779,'SUPERREDUCIDO',1,4.000,0.500,'2000-01-01',0,0,NULL,NULL,NULL,NULL,NULL,NULL),(15349,8779,'SIN IVA',1,0.000,0.000,'2000-01-01',0,0,NULL,NULL,NULL,NULL,NULL,NULL),(15350,8779,'IRPF',2,19.000,0.000,'2015-01-01',0,0,NULL,NULL,NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `tax` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tax_detail`
--

DROP TABLE IF EXISTS `tax_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `tax_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Historico de Impuestos',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `tax` int(4) NOT NULL DEFAULT '0' COMMENT 'Identificador del Impuesto',
  `start_date` date DEFAULT NULL COMMENT 'Fecha de inicio de vigencia',
  `end_date` date DEFAULT NULL COMMENT 'Fecha de fin de vigencia',
  `value` double(15,3) DEFAULT NULL COMMENT 'Porcentaje de recargo',
  `surcharge` double(15,3) DEFAULT NULL COMMENT 'Porcentaje de recargo de equivalencia',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_TAX_DETAIL_TAX` (`tax`),
  KEY `IDX_TAX_DETAIL_DOMAIN` (`domain`),
  CONSTRAINT `FK_TAX_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_TAX_DETAIL_TAX` FOREIGN KEY (`tax`) REFERENCES `tax` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=15146 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Historico de Impuestos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tax_detail`
--

LOCK TABLES `tax_detail` WRITE;
/*!40000 ALTER TABLE `tax_detail` DISABLE KEYS */;
INSERT INTO `tax_detail` VALUES (15136,8776,15341,'2000-01-01','2010-06-30',16.000,4.000,NULL,NULL,NULL,NULL),(15137,8776,15342,'2000-01-01','2010-06-30',7.000,1.000,NULL,NULL,NULL,NULL),(15138,8776,15341,'2010-07-01','2012-08-31',18.000,4.000,NULL,NULL,NULL,NULL),(15139,8776,15342,'2010-07-01','2012-08-31',8.000,1.000,NULL,NULL,NULL,NULL),(15140,8776,15345,'2010-01-01','2014-12-31',21.000,0.000,NULL,NULL,NULL,NULL),(15141,8779,15346,'2000-01-01','2010-06-30',16.000,4.000,NULL,NULL,NULL,NULL),(15142,8779,15347,'2000-01-01','2010-06-30',7.000,1.000,NULL,NULL,NULL,NULL),(15143,8779,15346,'2010-07-01','2012-08-31',18.000,4.000,NULL,NULL,NULL,NULL),(15144,8779,15347,'2010-07-01','2012-08-31',8.000,1.000,NULL,NULL,NULL,NULL),(15145,8779,15350,'2010-01-01','2014-12-31',21.000,0.000,NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `tax_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `training_center`
--

DROP TABLE IF EXISTS `training_center`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `training_center` (
  `registry` int(4) NOT NULL COMMENT 'Registro del Centro Formativo',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `code` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo del centro formativo',
  PRIMARY KEY (`registry`),
  KEY `IDX_TRAINING_CENTER_DOMAIN` (`domain`),
  CONSTRAINT `FK_TRAINING_CENTER_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_TRAINING_CENTER_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Centros Formativos acreditados';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `training_center`
--

LOCK TABLES `training_center` WRITE;
/*!40000 ALTER TABLE `training_center` DISABLE KEYS */;
/*!40000 ALTER TABLE `training_center` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `training_course`
--

DROP TABLE IF EXISTS `training_course`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `training_course` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `training_center` int(4) NOT NULL COMMENT 'Identificador del Centro Formativo',
  `code` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Codigo del Curso Formativo',
  `certification_name` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Denominacion de la certificacion',
  `cno` int(4) DEFAULT NULL COMMENT 'CNO',
  `modality` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Modalidad del Curso Formativo',
  `fp_title_name` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Titulo de formacion profesional',
  `occupation_name` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre de la ocupacion',
  `professional_certificate` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Certificado de profesionalidad',
  `fp_title` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Titulo de formacion profesional',
  `center_available` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'Centro disponible',
  PRIMARY KEY (`id`),
  KEY `IDX_TRAINING_COURSE_CNO` (`cno`),
  KEY `IDX_TRAINING_COURSE_DOMAIN` (`domain`),
  KEY `IDX_TRAINING_COURSE_TRAINING_CENTER` (`training_center`),
  CONSTRAINT `FK_TRAINING_COURSE_CNO` FOREIGN KEY (`cno`) REFERENCES `cno` (`id`),
  CONSTRAINT `FK_TRAINING_COURSE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_TRAINING_COURSE_TRAINING_CENTER` FOREIGN KEY (`training_center`) REFERENCES `training_center` (`registry`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Cursos de los Centros Formativos';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `training_course`
--

LOCK TABLES `training_course` WRITE;
/*!40000 ALTER TABLE `training_course` DISABLE KEYS */;
/*!40000 ALTER TABLE `training_course` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `user`
--

DROP TABLE IF EXISTS `user`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `user` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre del Usuario',
  `login` varchar(16) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Login del Usuario',
  `enterprise` int(4) DEFAULT NULL COMMENT 'Identificador de la Empresa',
  `registry` int(4) DEFAULT NULL COMMENT 'Identificador del Registry',
  `active` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'Indica si el Usuario esta activo o no',
  `allowConcurrent` tinyint(1) DEFAULT '0' COMMENT 'Indica si el Usuario admite Sesiones concurrentes',
  `password` varchar(128) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Contraseña del Usuario',
  `passwordExpiration` date DEFAULT NULL COMMENT 'Fecha de Expiracion de la Contrasea',
  `toolbar` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Tipo de Barra de Herramientas del Usuario',
  `locale` varchar(8) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Locale del Usuario',
  `pageLimit` int(4) DEFAULT NULL COMMENT 'Limite de filas en pantalla del Usuario',
  `linesPageLimit` int(4) DEFAULT NULL COMMENT 'Limite de filas en pantalla en lineas del Usuario',
  `initAction` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre la acicn de inicio del Usuario',
  `lastAccess` datetime DEFAULT NULL COMMENT 'Fecha del ultimo acceso del Usuario',
  PRIMARY KEY (`id`),
  UNIQUE KEY `IDX_UNQ_USER_DOMAIN_LOGIN` (`domain`,`login`),
  KEY `IDX_USER_ENTERPRISE` (`enterprise`),
  KEY `IDX_USER_REGISTRY` (`registry`),
  KEY `IDX_USER_DOMAIN` (`domain`),
  CONSTRAINT `FK_USER_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_USER_ENTERPRISE` FOREIGN KEY (`enterprise`) REFERENCES `enterprise` (`registry`),
  CONSTRAINT `FK_USER_REGISTRY` FOREIGN KEY (`registry`) REFERENCES `registry` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=10249 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Usuarios';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `user`
--

LOCK TABLES `user` WRITE;
/*!40000 ALTER TABLE `user` DISABLE KEYS */;
INSERT INTO `user` VALUES (2862,0,'Administrador','admin',NULL,NULL,1,0,'0jtZh1BMGz3khL8uR8dvdau3lNM=',NULL,6,'es',NULL,NULL,NULL,'2015-04-08 19:01:09'),(10248,8776,'ADMIN','admin',NULL,NULL,1,0,'0jtZh1BMGz3khL8uR8dvdau3lNM=',NULL,0,'es',NULL,NULL,'','2017-09-11 11:16:12');
/*!40000 ALTER TABLE `user` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `user_scope`
--

DROP TABLE IF EXISTS `user_scope`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `user_scope` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `user_id` int(4) NOT NULL COMMENT 'Identificador del Usuario',
  `scope` int(4) NOT NULL COMMENT 'Identificador del Ambito',
  PRIMARY KEY (`id`),
  KEY `IDX_USER_SCOPE_SCOPE` (`scope`),
  KEY `IDX_USER_SCOPE_USER` (`user_id`),
  KEY `IDX_USER_SCOPE_DOMAIN` (`domain`),
  CONSTRAINT `FK_USER_SCOPE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_USER_SCOPE_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`),
  CONSTRAINT `FK_USER_SCOPE_USER` FOREIGN KEY (`user_id`) REFERENCES `user` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=12186 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Ambitos de Usuario';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `user_scope`
--

LOCK TABLES `user_scope` WRITE;
/*!40000 ALTER TABLE `user_scope` DISABLE KEYS */;
INSERT INTO `user_scope` VALUES (12184,8776,10248,3535),(12185,0,2862,2559);
/*!40000 ALTER TABLE `user_scope` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `user_workgroup`
--

DROP TABLE IF EXISTS `user_workgroup`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `user_workgroup` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `user_id` int(4) NOT NULL COMMENT 'Identificador del Usuario',
  `workgroup` int(4) NOT NULL COMMENT 'Identificador del Grupo de Trabajo',
  PRIMARY KEY (`id`),
  KEY `IDX_USER_WORKGROUP_USER` (`user_id`),
  KEY `IDX_USER_WORKGROUP_WORKGROUP` (`workgroup`),
  KEY `IDX_USER_WORKGROUP_DOMAIN` (`domain`),
  CONSTRAINT `FK_USER_WORKGROUP_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_USER_WORKGROUP_USER` FOREIGN KEY (`user_id`) REFERENCES `user` (`id`),
  CONSTRAINT `FK_USER_WORKGROUP_WORKGROUP` FOREIGN KEY (`workgroup`) REFERENCES `workgroup` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5251 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Relacion entre Usuarios y Grupos de Trabajo';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `user_workgroup`
--

LOCK TABLES `user_workgroup` WRITE;
/*!40000 ALTER TABLE `user_workgroup` DISABLE KEYS */;
INSERT INTO `user_workgroup` VALUES (2835,0,2862,1258),(5250,8776,10248,3205);
/*!40000 ALTER TABLE `user_workgroup` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `warehouse`
--

DROP TABLE IF EXISTS `warehouse`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `warehouse` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Almacen',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(32) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre del Almacen',
  `workplace` int(4) DEFAULT NULL COMMENT 'Identificador del Centro de Trabajo',
  `department` int(4) DEFAULT NULL COMMENT 'Identificador del Departamento',
  `active` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'Indica si el Almacen esta activo o no',
  PRIMARY KEY (`id`),
  KEY `IDX_WAREHOUSE_WORKPLACE` (`workplace`),
  KEY `IDX_WAREHOUSE_DOMAIN` (`domain`),
  KEY `IDX_WAREHOUSE_DEPARTMENT` (`department`),
  CONSTRAINT `FK_WAREHOUSE_DEPARTMENT` FOREIGN KEY (`department`) REFERENCES `department` (`id`),
  CONSTRAINT `FK_WAREHOUSE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_WAREHOUSE_WORKPLACE` FOREIGN KEY (`workplace`) REFERENCES `workplace` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2364 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Almacenes';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `warehouse`
--

LOCK TABLES `warehouse` WRITE;
/*!40000 ALTER TABLE `warehouse` DISABLE KEYS */;
INSERT INTO `warehouse` VALUES (2362,8776,'PRINCIPAL',NULL,NULL,1),(2363,8779,'PRINCIPAL',NULL,NULL,1);
/*!40000 ALTER TABLE `warehouse` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `warehouse_transfer`
--

DROP TABLE IF EXISTS `warehouse_transfer`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `warehouse_transfer` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `series` char(5) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Serie del Traspaso',
  `number` int(4) NOT NULL DEFAULT '0' COMMENT 'Numero del Traspaso',
  `issue_time` datetime NOT NULL COMMENT 'Fecha de emision del Traspaso',
  `comments` text COLLATE latin1_spanish_ci COMMENT 'Comentarios del Traspaso',
  `source_warehouse` int(4) DEFAULT NULL COMMENT 'Identificador del Almacen Origen',
  `target_warehouse` int(4) DEFAULT NULL COMMENT 'Identificador del Almacen Destino',
  `inventory` int(4) DEFAULT NULL COMMENT 'Identificador del Inventario',
  `source` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Origen',
  `source_id` int(4) DEFAULT NULL COMMENT 'Identificador del origen',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  UNIQUE KEY `IDX_UNQ_WAREHOUSE_TRANSFER_DOMAIN_SERIES_NUMBER` (`domain`,`series`,`number`),
  KEY `IDX_WAREHOUSE_TRANSFER_ISSUE_TIME` (`issue_time`),
  KEY `IDX_WAREHOUSE_TRANSFER_SOURCE_WAREHOUSE` (`source_warehouse`),
  KEY `IDX_WAREHOUSE_TRANSFER_TARGET_WAREHOUSE` (`target_warehouse`),
  KEY `IDX_WAREHOUSE_TRANSFER_DOMAIN` (`domain`),
  KEY `IDX_WAREHOUSE_TRANSFER_INVENTORY` (`inventory`),
  CONSTRAINT `FK_WAREHOUSE_TRANSFER_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_WAREHOUSE_TRANSFER_INVENTORY` FOREIGN KEY (`inventory`) REFERENCES `inventory` (`id`),
  CONSTRAINT `FK_WAREHOUSE_TRANSFER_SOURCE_WAREHOUSE` FOREIGN KEY (`source_warehouse`) REFERENCES `warehouse` (`id`),
  CONSTRAINT `FK_WAREHOUSE_TRANSFER_TARGET_WAREHOUSE` FOREIGN KEY (`target_warehouse`) REFERENCES `warehouse` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Traspasos entre Almacenes';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `warehouse_transfer`
--

LOCK TABLES `warehouse_transfer` WRITE;
/*!40000 ALTER TABLE `warehouse_transfer` DISABLE KEYS */;
/*!40000 ALTER TABLE `warehouse_transfer` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `warehouse_transfer_detail`
--

DROP TABLE IF EXISTS `warehouse_transfer_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `warehouse_transfer_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `warehouse_transfer` int(4) NOT NULL COMMENT 'Identificador del Traspaso',
  `item` int(4) NOT NULL COMMENT 'Identificador del Articulo del Detalle de Traspaso',
  `quantity` double(15,3) DEFAULT NULL COMMENT 'Cantidad del Detalle de Traspaso',
  `creation_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de creacion',
  `creation_date` datetime DEFAULT NULL COMMENT 'Fecha de creacion',
  `modification_user` varchar(16) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Usuario de modificacion',
  `modification_date` datetime DEFAULT NULL COMMENT 'Fecha de modificacion',
  PRIMARY KEY (`id`),
  KEY `IDX_WAREHOUSE_TRANSFER_DETAIL_ITEM` (`item`),
  KEY `IDX_WAREHOUSE_TRANSFER_DETAIL_WAREHOUSE_TRANSFER` (`warehouse_transfer`),
  KEY `IDX_WAREHOUSE_TRANSFER_DETAIL_DOMAIN` (`domain`),
  CONSTRAINT `FK_WAREHOUSE_TRANSFER_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_WAREHOUSE_TRANSFER_DETAIL_ITEM` FOREIGN KEY (`item`) REFERENCES `item` (`id`),
  CONSTRAINT `FK_WAREHOUSE_TRANSFER_DETAIL_WAREHOUSE_TRANSFER` FOREIGN KEY (`warehouse_transfer`) REFERENCES `warehouse_transfer` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Detalles de Traspasos entre Almacenes';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `warehouse_transfer_detail`
--

LOCK TABLES `warehouse_transfer_detail` WRITE;
/*!40000 ALTER TABLE `warehouse_transfer_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `warehouse_transfer_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `web_info`
--

DROP TABLE IF EXISTS `web_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `web_info` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador Unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `company` int(4) NOT NULL COMMENT 'Empresa',
  `commercial_description` text COLLATE latin1_spanish_ci COMMENT 'Descripcion comercial',
  `schedule` text COLLATE latin1_spanish_ci COMMENT 'Horario',
  `slogan` varchar(64) COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Slogan',
  PRIMARY KEY (`id`),
  KEY `IDX_WEB_INFO_COMPANY` (`company`),
  KEY `IDX_WEB_INFO_DOMAIN` (`domain`),
  CONSTRAINT `FK_WEB_INFO_COMPANY` FOREIGN KEY (`company`) REFERENCES `company` (`registry`),
  CONSTRAINT `FK_WEB_INFO_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Informacion de la empresa que se mostrara en la ficha web';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `web_info`
--

LOCK TABLES `web_info` WRITE;
/*!40000 ALTER TABLE `web_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `web_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `web_info_page`
--

DROP TABLE IF EXISTS `web_info_page`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `web_info_page` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Codigo de la Pagina',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `name` varchar(64) CHARACTER SET latin1 COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Nombre de la Pagina.',
  `type` tinyint(2) NOT NULL DEFAULT '0' COMMENT 'Tipo de Pagina',
  `position` tinyint(2) DEFAULT NULL COMMENT 'Posicion de la Pagina en el menu',
  `active` tinyint(1) NOT NULL DEFAULT '1' COMMENT 'Indica si la Pagina esta activa o no',
  PRIMARY KEY (`id`),
  KEY `IDX_WEB_INFO_PAGE_DOMAIN` (`domain`),
  CONSTRAINT `FK_WEB_INFO_PAGE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Paginas pertenecientes a la ficha web';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `web_info_page`
--

LOCK TABLES `web_info_page` WRITE;
/*!40000 ALTER TABLE `web_info_page` DISABLE KEYS */;
/*!40000 ALTER TABLE `web_info_page` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `web_info_page_detail`
--

DROP TABLE IF EXISTS `web_info_page_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `web_info_page_detail` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Codigo del Detalle de la Pagina',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `web_info_page` int(4) NOT NULL COMMENT 'Identificador de la Pagina a la que corresponde el detalle',
  `title` varchar(255) CHARACTER SET latin1 COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Titulo del contenido de la Pagina',
  `layout` int(2) DEFAULT NULL COMMENT 'Tipo de plantilla',
  `content` text CHARACTER SET latin1 COLLATE latin1_spanish_ci COMMENT 'Texto del contenido de la Pagina',
  `extra` varchar(255) CHARACTER SET latin1 COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Campo reservado a otros datos de la Pagina',
  PRIMARY KEY (`id`),
  KEY `IDX_WEB_INFO_PAGE_DETAIL_WEB_INFO_PAGE` (`web_info_page`),
  KEY `IDX_WEB_INFO_PAGE_DETAIL_DOMAIN` (`domain`),
  CONSTRAINT `FK_WEB_INFO_PAGE_DETAIL_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_WEB_INFO_PAGE_DETAIL_WEB_INFO_PAGE` FOREIGN KEY (`web_info_page`) REFERENCES `web_info_page` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Detalles de la pagina perteneciente a la ficha web';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `web_info_page_detail`
--

LOCK TABLES `web_info_page_detail` WRITE;
/*!40000 ALTER TABLE `web_info_page_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `web_info_page_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `web_info_page_resource`
--

DROP TABLE IF EXISTS `web_info_page_resource`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `web_info_page_resource` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Codigo del Recurso de la Pagina',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `web_info_page` int(4) NOT NULL COMMENT 'Codigo de la Pagina',
  `rattach` int(4) NOT NULL COMMENT 'Identificador del Archivo Adjunto calificado como Recurso',
  `content` varchar(255) CHARACTER SET latin1 COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Texto del Recurso',
  PRIMARY KEY (`id`),
  KEY `IDX_WEB_INFO_PAGE_RESOURCE_WEB_INFO_PAGE` (`web_info_page`),
  KEY `IDX_WEB_INFO_PAGE_RESOURCE_RATTACH` (`rattach`),
  KEY `IDX_WEB_INFO_PAGE_RESOURCE_DOMAIN` (`domain`),
  CONSTRAINT `FK_WEB_INFO_PAGE_RESOURCE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_WEB_INFO_PAGE_RESOURCE_RATTACH` FOREIGN KEY (`rattach`) REFERENCES `rattach` (`id`),
  CONSTRAINT `FK_WEB_INFO_PAGE_RESOURCE_WEB_INFO_PAGE` FOREIGN KEY (`web_info_page`) REFERENCES `web_info_page` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Recursos de la pagina perteneciente a la ficha web';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `web_info_page_resource`
--

LOCK TABLES `web_info_page_resource` WRITE;
/*!40000 ALTER TABLE `web_info_page_resource` DISABLE KEYS */;
/*!40000 ALTER TABLE `web_info_page_resource` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `web_info_style`
--

DROP TABLE IF EXISTS `web_info_style`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `web_info_style` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Codigo del Estilo de la Pagina',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `variable` varchar(128) CHARACTER SET latin1 COLLATE latin1_spanish_ci NOT NULL COMMENT 'Nombre de la variable del Estilo',
  `value` varchar(255) CHARACTER SET latin1 COLLATE latin1_spanish_ci DEFAULT NULL COMMENT 'Valor de la variable del Estilo',
  PRIMARY KEY (`id`),
  KEY `IDX_WEB_INFO_STYLE_DOMAIN` (`domain`),
  CONSTRAINT `FK_WEB_INFO_STYLE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COMMENT='Estilos a utilizar en las plantillas para generar ficha web';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `web_info_style`
--

LOCK TABLES `web_info_style` WRITE;
/*!40000 ALTER TABLE `web_info_style` DISABLE KEYS */;
/*!40000 ALTER TABLE `web_info_style` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `workgroup`
--

DROP TABLE IF EXISTS `workgroup`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `workgroup` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Grupo de Trabajo',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `description` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion del Grupo de Trabajo',
  `status` tinyint(2) DEFAULT NULL COMMENT 'Estado del grupo de Trabajo',
  PRIMARY KEY (`id`),
  KEY `IDX_WORKGROUP_DOMAIN` (`domain`),
  CONSTRAINT `FK_WORKGROUP_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3206 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Grupos de Trabajo';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `workgroup`
--

LOCK TABLES `workgroup` WRITE;
/*!40000 ALTER TABLE `workgroup` DISABLE KEYS */;
INSERT INTO `workgroup` VALUES (1258,0,'GENERAL',0),(3205,8776,'GENERAL',0);
/*!40000 ALTER TABLE `workgroup` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `workplace`
--

DROP TABLE IF EXISTS `workplace`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `workplace` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico del Centro de Trabajo',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `enterprise` int(4) NOT NULL DEFAULT '1' COMMENT 'Empresa asociada al Centro de Trabajo',
  `description` varchar(64) COLLATE latin1_spanish_ci NOT NULL COMMENT 'Descripcion del Centro de Trabajo',
  `address` int(4) NOT NULL COMMENT 'Identificador de la Direccion',
  `customer` int(4) DEFAULT NULL COMMENT 'Identificador del Cliente',
  `scope` int(4) NOT NULL COMMENT 'Identificador del Ambito',
  `economicAgreement` tinyint(2) DEFAULT '0' COMMENT 'Concierto Economico del Centro de Trabajo',
  `active` tinyint(1) DEFAULT '1' COMMENT 'Indica si el Centro de Trabajo esta activo o no',
  PRIMARY KEY (`id`),
  KEY `IDX_WORKPLACE_ENTERPRISE` (`enterprise`),
  KEY `IDX_WORKPLACE_RADDRESS` (`address`),
  KEY `IDX_WORKPLACE_SCOPE` (`scope`),
  KEY `IDX_WORKPLACE_DOMAIN` (`domain`),
  KEY `IDX_WORKPLACE_CUSTOMER` (`customer`),
  CONSTRAINT `FK_WORKPLACE_CUSTOMER` FOREIGN KEY (`customer`) REFERENCES `customer` (`registry`),
  CONSTRAINT `FK_WORKPLACE_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_WORKPLACE_ENTERPRISE` FOREIGN KEY (`enterprise`) REFERENCES `enterprise` (`registry`),
  CONSTRAINT `FK_WORKPLACE_RADDRESS` FOREIGN KEY (`address`) REFERENCES `raddress` (`id`),
  CONSTRAINT `FK_WORKPLACE_SCOPE` FOREIGN KEY (`scope`) REFERENCES `scope` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=8394 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Centros de Trabajo';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `workplace`
--

LOCK TABLES `workplace` WRITE;
/*!40000 ALTER TABLE `workplace` DISABLE KEYS */;
INSERT INTO `workplace` VALUES (8351,8776,8628387,'PRINCIPAL',7730361,NULL,3535,NULL,1),(8352,8777,8628388,'ANTIGÜEDAD',7730362,NULL,3535,0,1),(8353,8777,8628388,'CRET@',7730362,NULL,3535,0,1),(8354,8777,8628388,'I.T',7730362,NULL,3535,0,1),(8355,8777,8628388,'I.R.P.F - ÁLAVA/ARABA',7730362,NULL,3535,0,1),(8356,8777,8628388,'EXTRAS',7730362,NULL,3535,0,1),(8357,8777,8628388,'BASES MÁXIMAS Y MÍNIMAS',7730362,NULL,3535,NULL,1),(8358,8778,8628397,'COTIZACIÓN FORMACIÓN Y EL APRENDIZAJE',7730374,NULL,3535,NULL,1),(8359,8777,8628388,'BRUTO Y NETO',7730362,NULL,3535,0,1),(8360,8777,8628388,'I.R.P.F - BIZKAIA',7730377,NULL,3535,1,1),(8361,8777,8628388,'I.R.P.F - GIPUZKOA',7730376,NULL,3535,2,1),(8362,8777,8628388,'I.R.P.F - ESTATAL',7730378,NULL,3535,4,1),(8363,8779,8628405,'PRINCIPAL',7730383,NULL,3538,NULL,1),(8364,8777,8628388,'FINIQUITOS',7730362,NULL,3535,0,1),(8365,8777,8628388,'ATRASOS',7730362,NULL,3535,0,1),(8366,8777,8628388,'RETA',7730362,NULL,3535,0,1),(8367,8780,8628412,'PRINCIPAL',7730401,NULL,3535,4,1),(8368,8777,8628388,'BONIFICACIONES',7730362,NULL,3535,0,1),(8369,8777,8628388,'CONVENIO',7730362,NULL,3535,4,1),(8370,8780,8628412,'I.T',7730401,NULL,3535,4,1),(8371,8777,8628388,'SIN CONVENIO',7730362,NULL,3535,NULL,1),(8372,8777,8628388,'CALCULADOR',7730362,NULL,3535,0,1),(8373,8777,8628388,'CONCEPTOS',7730362,NULL,3535,4,1),(8374,8781,8628439,'PRINCIPAL',7730420,NULL,3535,4,1),(8375,8782,8628443,'PRINCIPAL',7730423,NULL,3535,NULL,1),(8376,8783,8628451,'OFICINAS Y DESPACHOS PARA BIZKAIA',7730432,NULL,3535,1,1),(8377,8777,8628388,'NOMINAS',7730362,NULL,3535,0,1),(8378,8784,8628463,'CATEGORIA \"A\"',7730446,NULL,3535,4,1),(8379,8777,8628388,'EMBARGOS',7730362,NULL,3535,0,1),(8381,8783,8628451,'CONVENIO DE EMPRESA',7730432,NULL,3535,1,1),(8382,8785,8628474,'PRINCIPAL',7730456,NULL,3535,NULL,1),(8383,8785,8628474,'VITORIA-GASTEIZ',7730457,NULL,3535,0,1),(8384,8783,8628451,'BORRAR ( PAPELERA ) Y RESTAURAR',7730432,NULL,3535,1,1),(8385,8777,8628388,'TIEMPO PARCIAL',7730378,NULL,3535,4,1),(8386,8777,8628388,'HORAS EXTRAS',7730362,NULL,3535,4,1),(8387,8777,8628388,'4DUMMIES',7730362,NULL,3535,4,1),(8389,8787,8628500,'PRINCIPAL',7730483,NULL,3535,4,1),(8390,8777,8628388,'DRAFT',7730362,NULL,3535,4,1),(8391,8788,8628519,'PRINCIPAL',7730502,NULL,3535,4,1),(8392,8777,8628388,'INCIDENCIAS',7730378,NULL,3535,4,1),(8393,8777,8628388,'CALENDARIO',7730362,NULL,3535,0,1);
/*!40000 ALTER TABLE `workplace` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `workplace_department`
--

DROP TABLE IF EXISTS `workplace_department`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `workplace_department` (
  `id` int(4) NOT NULL AUTO_INCREMENT COMMENT 'Identificador unico',
  `domain` int(4) NOT NULL COMMENT 'Identificador del Dominio',
  `workplace` int(4) NOT NULL COMMENT 'Identificador del Centro de Trabajo',
  `department` int(4) NOT NULL COMMENT 'Identificador del Departamento',
  `warehouse` int(4) DEFAULT NULL COMMENT 'Identificador del Almacen',
  `catalogue` int(4) DEFAULT NULL COMMENT 'Identificador del Catalogo',
  `active` tinyint(1) DEFAULT '1' COMMENT 'Indica si el Departamento esta activo o no',
  PRIMARY KEY (`id`),
  KEY `IDX_WORKPLACE_DEPARTMENT_DOMAIN` (`domain`),
  KEY `IDX_WORKPLACE_DEPARTMENT_WORKPLACE` (`workplace`),
  KEY `IDX_WORKPLACE_DEPARTMENT_DEPARTMENT` (`department`),
  KEY `IDX_WORKPLACE_DEPARTMENT_CATALOGUE` (`catalogue`),
  KEY `IDX_WORKPLACE_DEPARTMENT_WAREHOUSE` (`warehouse`),
  CONSTRAINT `FK_WORKPLACE_DEPARTMENT_CATALOGUE` FOREIGN KEY (`catalogue`) REFERENCES `catalogue` (`id`),
  CONSTRAINT `FK_WORKPLACE_DEPARTMENT_DEPARTMENT` FOREIGN KEY (`department`) REFERENCES `department` (`id`),
  CONSTRAINT `FK_WORKPLACE_DEPARTMENT_DOMAIN` FOREIGN KEY (`domain`) REFERENCES `domain` (`id`),
  CONSTRAINT `FK_WORKPLACE_DEPARTMENT_WAREHOUSE` FOREIGN KEY (`warehouse`) REFERENCES `warehouse` (`id`),
  CONSTRAINT `FK_WORKPLACE_DEPARTMENT_WORKPLACE` FOREIGN KEY (`workplace`) REFERENCES `workplace` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci COMMENT='Departamentos del Centro de Trabajo';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `workplace_department`
--

LOCK TABLES `workplace_department` WRITE;
/*!40000 ALTER TABLE `workplace_department` DISABLE KEYS */;
/*!40000 ALTER TABLE `workplace_department` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2017-09-15 12:02:33
